# Copyright 2017 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# AUTOMATICALLY GENERATED; DO NOT EDIT.
# generated with: gcloud meta list-gcloud --format=json | python -c "import json; import sys; data = json.load(sys.stdin); print 'gcloud_tree =', data" >> gcloud_tree.py

gcloud_tree = {u'capsule': u'Manage Google Cloud Platform resources and developer workflow.',
 u'commands': {u'alpha': {u'capsule': u'*(ALPHA)* Alpha versions of gcloud commands.',
                          u'commands': {u'billing': {u'capsule': u'*(ALPHA)* Manage billing accounts and associate them with projects.',
                                                     u'commands': {u'accounts': {u'capsule': u'*(ALPHA)* List or describe billing accounts.',
                                                                                 u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Show metadata for a billing account.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'billing',
                                                                                                                       u'accounts',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Specify a billing account id. Billing account ids look like: 0X0X0X-0X0X0X-0X0X0X, and can be listed with, gcloud alpha billing accounts list.',
                                                                                                                               u'name': u'id',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'ACCOUNT_ID'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u"This command shows info for a billing account, given it's ID.\n\nThis call can fail for the following reasons:\n* The account specified does not exist.\n* The active user does not have permission to access the given\naccount.\n",
                                                                                                                           u'EXAMPLES': u'*describe* 0X0X0X-0X0X0X-0X0X0X will print the info for billing\naccount 0X0X0X-0X0X0X-0X0X0X.\n'}},
                                                                                               u'list': {u'capsule': u'*(ALPHA)* List all active billing accounts.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'billing',
                                                                                                                   u'accounts',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* *list* lists all billing accounts owned by the currently\nauthenticated user.'}},
                                                                                               u'projects': {u'capsule': u'*(ALPHA)* Manage the billing account configuration of your projects.',
                                                                                                             u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Show detailed billing information for a project.',
                                                                                                                                         u'commands': {},
                                                                                                                                         u'flags': {},
                                                                                                                                         u'group': False,
                                                                                                                                         u'groups': {},
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'describe',
                                                                                                                                         u'path': [u'gcloud',
                                                                                                                                                   u'alpha',
                                                                                                                                                   u'billing',
                                                                                                                                                   u'accounts',
                                                                                                                                                   u'projects',
                                                                                                                                                   u'describe'],
                                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Specify a project id.',
                                                                                                                                                           u'name': u'project-id',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'value': u'PROJECT_ID'}],
                                                                                                                                         u'release': u'ALPHA',
                                                                                                                                         u'sections': {u'DESCRIPTION': u"\nThis command shows billing info for a project, given it's ID.\n\nThis call can fail for the following reasons:\n* The project specified does not exist.\n* The active user does not have permission to access the given\nproject.\n",
                                                                                                                                                       u'EXAMPLES': u'\n*describe* 0X0X0X-0X0X0X-0X0X0X will print the info for\nbilling account 0X0X0X-0X0X0X-0X0X0X.\n'}},
                                                                                                                           u'link': {u'capsule': u'*(ALPHA)* Link a project with a billing account.',
                                                                                                                                     u'commands': {},
                                                                                                                                     u'flags': {u'--account-id': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'Specify a billing account id. Billing account ids look like: 0X0X0X-0X0X0X-0X0X0X, and can be listed with, gcloud alpha billing accounts list.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--account-id',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': True,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'ACCOUNT_ID'}},
                                                                                                                                     u'group': False,
                                                                                                                                     u'groups': {},
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'link',
                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                               u'alpha',
                                                                                                                                               u'billing',
                                                                                                                                               u'accounts',
                                                                                                                                               u'projects',
                                                                                                                                               u'link'],
                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Specify a project id.',
                                                                                                                                                       u'name': u'projectId',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'value': u'PROJECT_ID'}],
                                                                                                                                     u'release': u'ALPHA',
                                                                                                                                     u'sections': {u'DESCRIPTION': u'This command links a billing account to a project.\nIf the specified billing account is open, this has\nthe effect of enabling billing on the project.\n'}},
                                                                                                                           u'list': {u'capsule': u'*(ALPHA)* List all active projects associated with the specified billing account.',
                                                                                                                                     u'commands': {},
                                                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--filter',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                                                u'--limit': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--limit',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'LIMIT'},
                                                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--page-size',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--sort-by',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'list',
                                                                                                                                                               u'value': u'FIELD'}},
                                                                                                                                     u'group': False,
                                                                                                                                     u'groups': {},
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'list',
                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                               u'alpha',
                                                                                                                                               u'billing',
                                                                                                                                               u'accounts',
                                                                                                                                               u'projects',
                                                                                                                                               u'list'],
                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Specify a billing account id. Billing account ids look like: 0X0X0X-0X0X0X-0X0X0X, and can be listed with, gcloud alpha billing accounts list.',
                                                                                                                                                       u'name': u'id',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'value': u'ACCOUNT_ID'}],
                                                                                                                                     u'release': u'ALPHA',
                                                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* *list* ACCOUNT_ID -- lists all active projects, for the specified\nbilling account id.'}},
                                                                                                                           u'unlink': {u'capsule': u'*(ALPHA)* Unlink the account (if any) linked with a project.',
                                                                                                                                       u'commands': {},
                                                                                                                                       u'flags': {},
                                                                                                                                       u'group': False,
                                                                                                                                       u'groups': {},
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'unlink',
                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                 u'alpha',
                                                                                                                                                 u'billing',
                                                                                                                                                 u'accounts',
                                                                                                                                                 u'projects',
                                                                                                                                                 u'unlink'],
                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Specify a project id.',
                                                                                                                                                         u'name': u'project-id',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'value': u'PROJECT_ID'}],
                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                       u'sections': {u'DESCRIPTION': u"\nThis command unlinks a project from it's linked billing\naccount. This disables billing on the project.\n"}}},
                                                                                                             u'flags': {},
                                                                                                             u'group': True,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'projects',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'billing',
                                                                                                                       u'accounts',
                                                                                                                       u'projects'],
                                                                                                             u'positionals': [],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage the billing account configuration of your projects.'}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'accounts',
                                                                                 u'path': [u'gcloud',
                                                                                           u'alpha',
                                                                                           u'billing',
                                                                                           u'accounts'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'ALPHA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* List or describe billing accounts.'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'billing',
                                                     u'path': [u'gcloud',
                                                               u'alpha',
                                                               u'billing'],
                                                     u'positionals': [],
                                                     u'release': u'ALPHA',
                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage billing accounts and associate them with projects.'}},
                                        u'bio': {u'capsule': u'*(ALPHA)* Bio command groups.',
                                                 u'commands': {u'operations': {u'capsule': u'*(ALPHA)* Bio operations commands.',
                                                                               u'commands': {u'cancel': {u'capsule': u'*(ALPHA)* Cancel a bio operation.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'cancel',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'bio',
                                                                                                                   u'operations',
                                                                                                                   u'cancel'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Name for the operation you want to cancel.',
                                                                                                                           u'name': u'name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'OPERATION_NAME'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u"*(ALPHA)* Cancels the operation with the given operation name.\n\nThis command can fail for the following reasons:\n* The operation specified does not exist.\n* The active account does not have Writer permissions for the operation's\nproject.\n\n## EXAMPLES\n\nThe following command cancels the operation with the name\n`OP-NAMES-ARE-A-UNIQUE-HASH`:\n\n  $ cancel OP-NAMES-ARE-A-UNIQUE-HASH"}},
                                                                                             u'describe': {u'capsule': u'*(ALPHA)* Show metadata about a bio operation.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'describe',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'bio',
                                                                                                                     u'operations',
                                                                                                                     u'describe'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Name for the operation you want to describe.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'OPERATION_NAME'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* Shows metadata for a bio operation given a valid operation name.\n\nThis command can fail for the following reasons:\n* The operation specified does not exist.\n* The active account does not have permission to access the given operation.\n\n## EXAMPLES\n\nThe following command prints metadata for an operation with the name\n`OP-NAMES-ARE-A-UNIQUE-HASH`:\n\n  $ describe OP-NAMES-ARE-A-UNIQUE-HASH'}},
                                                                                             u'list': {u'capsule': u'*(ALPHA)* List bio operations associated with a project.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_URI'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'},
                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'URI'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'list',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'bio',
                                                                                                                 u'operations',
                                                                                                                 u'list'],
                                                                                                       u'positionals': [],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* You can specify the maximum number of operations to list using the `--limit`\nflag.\n\n## EXAMPLES\n\nThe following command lists a maximum of five operations:\n\n  $ list --limit=5'}}},
                                                                               u'flags': {},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'operations',
                                                                               u'path': [u'gcloud',
                                                                                         u'alpha',
                                                                                         u'bio',
                                                                                         u'operations'],
                                                                               u'positionals': [],
                                                                               u'release': u'ALPHA',
                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Bio operations commands.'}},
                                                               u'pipelines': {u'capsule': u'*(ALPHA)* Bio pipelines commands.',
                                                                              u'commands': {u'run': {u'capsule': u'*(ALPHA)* Bio pipelines run commands.',
                                                                                                     u'commands': {u'deepvariant-alpha1': {u'capsule': u'*(ALPHA)* Runs DeepVariant Alpha1.',
                                                                                                                                           u'commands': {},
                                                                                                                                           u'flags': {u'--input-pair': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'A comma-separated pair of Google Cloud Storage paths of the\n        forward and reverse strand FASTQ files used as input.',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--input-pair',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': True,
                                                                                                                                                                        u'type': u'list',
                                                                                                                                                                        u'value': u'FASTQ_PATH'},
                                                                                                                                                      u'--labels': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--labels',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'dict',
                                                                                                                                                                    u'value': u'KEY=VALUE'},
                                                                                                                                                      u'--logging': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The location in Google Cloud Storage to which the\n        pipeline logs will be copied. Can be specified as a fully qualified\n        directory path, in which case logs will be output with a unique id\n        as the filename in that directory, or as a fully specified path,\n        which must end in `.log`, in which case that path will be\n        used. Stdout and stderr logs from the run are also generated and\n        output as `-stdout.log` and `-stderr.log`. For example,\n        `gs://<user_bucket>/<log_path>`.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--logging',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': True,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'LOGGING_PATH'},
                                                                                                                                                      u'--output-path': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The Google Cloud Storage path for copying the final output files.\n        For example, `gs://<user_bucket>/<sample_name>/`.',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--output-path',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': True,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'OUTPUT_PATH'},
                                                                                                                                                      u'--sample-name': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The sample name.',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--sample-name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': True,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'SAMPLE_NAME'},
                                                                                                                                                      u'--zones': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'A list of Google Compute Engine zones which may\n        be used to run the pipeline. A zone with available quota will be\n        randomly selected at the time of execution. If empty, any zone may\n        be selected.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--zones',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'list',
                                                                                                                                                                   u'value': u'ZONE'}},
                                                                                                                                           u'group': False,
                                                                                                                                           u'groups': {},
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'deepvariant-alpha1',
                                                                                                                                           u'path': [u'gcloud',
                                                                                                                                                     u'alpha',
                                                                                                                                                     u'bio',
                                                                                                                                                     u'pipelines',
                                                                                                                                                     u'run',
                                                                                                                                                     u'deepvariant-alpha1'],
                                                                                                                                           u'positionals': [],
                                                                                                                                           u'release': u'ALPHA',
                                                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* See https://cloud.google.com/genomics/v1alpha2/deepvariant for more\ninformation.'}}},
                                                                                                     u'flags': {},
                                                                                                     u'group': True,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'run',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'alpha',
                                                                                                               u'bio',
                                                                                                               u'pipelines',
                                                                                                               u'run'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'ALPHA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Bio pipelines run commands.'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'pipelines',
                                                                              u'path': [u'gcloud',
                                                                                        u'alpha',
                                                                                        u'bio',
                                                                                        u'pipelines'],
                                                                              u'positionals': [],
                                                                              u'release': u'ALPHA',
                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Bio pipelines commands.'}}},
                                                 u'flags': {},
                                                 u'group': True,
                                                 u'groups': {},
                                                 u'hidden': False,
                                                 u'name': u'bio',
                                                 u'path': [u'gcloud',
                                                           u'alpha',
                                                           u'bio'],
                                                 u'positionals': [],
                                                 u'release': u'ALPHA',
                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Bio command groups.'}},
                                        u'compute': {u'capsule': u'*(ALPHA)* Create and manipulate Google Compute Engine resources.',
                                                     u'commands': {u'accelerator-types': {u'capsule': u'*(ALPHA)* Read Google Compute Engine accelerator types.',
                                                                                          u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Describe Google Compute Engine accelerator types.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The zone of the accelerator type to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--zone',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'describe',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'accelerator-types',
                                                                                                                                u'describe'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the accelerator type.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine accelerator type.\n'}},
                                                                                                        u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine accelerator types.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--filter',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'EXPRESSION'},
                                                                                                                             u'--limit': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--limit',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'LIMIT'},
                                                                                                                             u'--no-uri': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-uri',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_URI'},
                                                                                                                             u'--page-size': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--page-size',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                                                             u'--sort-by': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--sort-by',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'FIELD'},
                                                                                                                             u'--uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'URI'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'list',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'compute',
                                                                                                                            u'accelerator-types',
                                                                                                                            u'list'],
                                                                                                                  u'positionals': [],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine accelerator types in a project.\n\nBy default, accelerator types from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                                u'EXAMPLES': u"To list all accelerator types in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all accelerator types in a project, run:\n\n  $ list --uri\n\nTo list all accelerator types in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                                          u'flags': {},
                                                                                          u'group': True,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'accelerator-types',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'alpha',
                                                                                                    u'compute',
                                                                                                    u'accelerator-types'],
                                                                                          u'positionals': [],
                                                                                          u'release': u'ALPHA',
                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read Google Compute Engine accelerator types.'}},
                                                                   u'addresses': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine addresses.',
                                                                                  u'commands': {u'create': {u'capsule': u'*(ALPHA)* Reserve IP addresses.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--addresses': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"Ephemeral IP addresses to promote to reserved status. Only addresses\nthat are being used by resources in the project can be promoted. When\nproviding this flag, a parallel list of names for the addresses can\nbe provided. For example,\n+\n  $ {command} ADDRESS-1 ADDRESS-2 --addresses 162.222.181.197,162.222.181.198 --region us-central1\n+\nwill result in 162.222.181.197 being reserved as\n'ADDRESS-1' and 162.222.181.198 as 'ADDRESS-2'. If\nno names are given, randomly-generated names will be assigned\nto the IP addresses.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--addresses',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'ADDRESS'},
                                                                                                                       u'--description': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'An optional textual description for the addresses.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--description',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                                       u'--global': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'If provided, it is assumed the address name is global.',
                                                                                                                                     u'group': u'create.1',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--global',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'GLOBAL'},
                                                                                                                       u'--network-tier': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [u'PREMIUM',
                                                                                                                                                        u'SELECT'],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The network tier to assign to the reserved IP addresses. If left empty, `PREMIUM` is used. Supported network tiers are: `PREMIUM`, `SELECT`. _NETWORK_TIER_ must be one of: *PREMIUM*, *SELECT*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--network-tier',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'NETWORK_TIER'},
                                                                                                                       u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"The region of the address name to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                     u'group': u'create.1',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--region',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'REGION'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False}},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'create',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'compute',
                                                                                                                      u'addresses',
                                                                                                                      u'create'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The address names to operate on.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'*',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u"*create* is used to reserve one or more IP addresses. Once\nan IP address is reserved, it will be associated with the\nproject until it is released using 'gcloud compute addresses\ndelete'. Ephemeral IP addresses that are in use by resources\nin the project, can be reserved using the ``--addresses''\nflag.\n",
                                                                                                                          u'EXAMPLES': u"To reserve three IP addresses in the ``us-central1'' region,\nrun:\n\n  $ create ADDRESS-1 ADDRESS-2 ADDRESS-3 --region us-central1\n\nTo reserve ephemeral IP addresses 162.222.181.198 and\n23.251.146.189 which are being used by virtual machine\ninstances in the ``us-central1'' region, run:\n\n  $ create --addresses 162.222.181.198,23.251.146.189 --region us-central1\n\nIn the above invocation, the two addresses will be assigned\nrandom names.\n"}},
                                                                                                u'delete': {u'capsule': u'*(ALPHA)* Release reserved IP addresses.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--global': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'If provided, it is assumed the address name is global.',
                                                                                                                                     u'group': u'delete.1',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--global',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'GLOBAL'},
                                                                                                                       u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"The region of the address name to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                     u'group': u'delete.1',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--region',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'REGION'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False}},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'delete',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'compute',
                                                                                                                      u'addresses',
                                                                                                                      u'delete'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The address names to operate on.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'+',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*delete* releases one or more Google Compute Engine IP addresses.\n'}},
                                                                                                u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about an address.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--global': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'If provided, it is assumed that the requested resource is global.',
                                                                                                                                       u'group': u'describe.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--global',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'GLOBAL'},
                                                                                                                         u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                       u'group': u'describe.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--region',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'REGION'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                          u'is_mutex': True,
                                                                                                                                          u'is_required': False}},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'compute',
                                                                                                                        u'addresses',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the resource to fetch.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with an address in a project.\n',
                                                                                                                            u'EXAMPLES': u'To get details about a global address, run:\n\n  $ describe ADDRESS --global\n\nTo get details about a regional address, run:\n\n  $ describe ADDRESS --region us-central1\n'}},
                                                                                                u'list': {u'capsule': u'*(ALPHA)* List addresses.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--global': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'If provided, only global resources are shown.',
                                                                                                                                   u'group': u'list.1',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--global',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'GLOBAL'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--regexp': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--regexp',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'REGEXP'},
                                                                                                                     u'--regions': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                    u'group': u'list.1',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--regions',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'REGION'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                  u'is_mutex': True,
                                                                                                                                  u'is_required': False}},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'addresses',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': [],
                                                                                                                            u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'*',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*list* lists summary information of addresses in a project. The\n*--uri* option can be used to display URIs instead. Users who want to\nsee more data should use `gcloud compute addresses describe`.\n\nBy default, global addresses and addresses from all regions are listed.\nThe results can be narrowed down by providing the *--regions* or\n*--global* flag.\n',
                                                                                                                        u'EXAMPLES': u"To list all addresses in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all addresses in a project, run:\n\n  $ list --uri\n\nTo list all of the global addresses in a project, run:\n\n  $ list --global\n\nTo list all of the regional addresses in a project, run:\n\n  $ list --regions\n\nTo list all of the addresses from the ``us-central1'' and the\n``europe-west1'' regions, run:\n\n  $ list --regions us-central1,europe-west1\n"}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'addresses',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'compute',
                                                                                            u'addresses'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine addresses.'}},
                                                                   u'backend-buckets': {u'capsule': u'*(ALPHA)* Read and manipulate backend buckets.',
                                                                                        u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a backend bucket.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--description': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'An optional, textual description for the backend bucket.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--description',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'DESCRIPTION'},
                                                                                                                             u'--enable-cdn': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'Enable Cloud CDN for the backend bucket. Cloud CDN can cache HTTP\nresponses from a backend bucket at the edge of the network, close to\nusers.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--enable-cdn',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'ENABLE_CDN'},
                                                                                                                             u'--gcs-bucket-name': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The name of the Google Cloud Storage bucket to serve from. The storage\n        bucket must be owned by the project's owner.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--gcs-bucket-name',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': True,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'GCS_BUCKET_NAME'},
                                                                                                                             u'--no-enable-cdn': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--no-enable-cdn',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_ENABLE_CDN'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'create',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'compute',
                                                                                                                            u'backend-buckets',
                                                                                                                            u'create'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the backend bucket.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'\n*create* is used to create backend buckets. Backend buckets\ndefine a Google Cloud Storage bucket that can serve content. URL\nmaps define which requests are sent to which backend buckets.\n'}},
                                                                                                      u'delete': {u'capsule': u'*(ALPHA)* Delete backend buckets.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'delete',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'compute',
                                                                                                                            u'backend-buckets',
                                                                                                                            u'delete'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The resources to delete.',
                                                                                                                                    u'name': u'names',
                                                                                                                                    u'nargs': u'+',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* *delete* deletes one or more backend buckets.'}},
                                                                                                      u'describe': {u'capsule': u'*(ALPHA)* Describe a backend bucket.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'describe',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'compute',
                                                                                                                              u'backend-buckets',
                                                                                                                              u'describe'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the resource to fetch.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a backend bucket in a\nproject.\n'}},
                                                                                                      u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine backend buckets.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--filter',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--limit',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--page-size',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                           u'--regexp': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--regexp',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGEXP'},
                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'FIELD'},
                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'URI'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'list',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'backend-buckets',
                                                                                                                          u'list'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': [],
                                                                                                                                  u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                  u'name': u'names',
                                                                                                                                  u'nargs': u'*',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine backend buckets in a project.\n',
                                                                                                                              u'EXAMPLES': u'To list all backend buckets in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all backend buckets in a project, run:\n\n  $ list --uri\n'}},
                                                                                                      u'update': {u'capsule': u'*(ALPHA)* Update a backend bucket.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--description': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'An optional, textual description for the backend bucket.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--description',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'DESCRIPTION'},
                                                                                                                             u'--enable-cdn': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'Enable Cloud CDN for the backend bucket. Cloud CDN can cache HTTP\nresponses from a backend bucket at the edge of the network, close to\nusers.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--enable-cdn',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'ENABLE_CDN'},
                                                                                                                             u'--gcs-bucket-name': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The name of the Google Cloud Storage bucket to serve from. The storage\n        bucket must be owned by the project's owner.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--gcs-bucket-name',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'GCS_BUCKET_NAME'},
                                                                                                                             u'--no-enable-cdn': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--no-enable-cdn',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_ENABLE_CDN'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'update',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'compute',
                                                                                                                            u'backend-buckets',
                                                                                                                            u'update'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the backend bucket.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'\n*update* is used to update backend buckets.\n'}}},
                                                                                        u'flags': {},
                                                                                        u'group': True,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'backend-buckets',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'alpha',
                                                                                                  u'compute',
                                                                                                  u'backend-buckets'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'ALPHA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate backend buckets.'}},
                                                                   u'backend-services': {u'capsule': u'*(ALPHA)* List, create, and delete backend services.',
                                                                                         u'commands': {u'add-backend': {u'capsule': u'*(ALPHA)* Add a backend to a backend service.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--balancing-mode': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [u'CONNECTION',
                                                                                                                                                                      u'RATE',
                                                                                                                                                                      u'UTILIZATION'],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Defines the strategy for balancing load.\n+\n*RATE* and the max rate arguments are available only\nin backend services with HTTP based protocols.\n+\nFor backend services with TCP/SSL protocol either *UTILIZATION* or\n*CONNECTION* are available.\n+\n_BALANCING_MODE_ must be one of:\n+\n*CONNECTION*:::           Spreads load based on how many concurrent connections the group\n          can handle. There are two ways to specify max connections:\n          *--max-connections* which defines the max number of connections\n          for the whole group or *--max-connections-per-instance*, which\n          defines the max number of connections on a per-instance basis.\n\n*RATE*:::           Spreads load based on how many requests per second (RPS) the group\n          can handle. There are two ways to specify max RPS: *--max-rate* which\n          defines the max RPS for the whole group or *--max-rate-per-instance*,\n          which defines the max RPS on a per-instance basis.\n\n*UTILIZATION*:::           Relies on the CPU utilization of the instances in the group when\n          balancing load. Use *--max-utilization* to set a maximum target CPU\n          utilization for each instance. Use *--max-rate-per-instance* or\n          *--max-rate* to optionally limit based on RPS in addition to CPU.\n          You can optionally also limit based on connections (for TCP/SSL) in\n          addition to CPU by setting *--max-connections* or\n          *--max-connections-per-instance*.\n\n+',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--balancing-mode',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'BALANCING_MODE'},
                                                                                                                                   u'--capacity-scaler': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u"A float in the range [0.0, 1.0] that scales the maximum\nparameters for the group (e.g., max rate). A value of 0.0 will\ncause no requests to be sent to the group (i.e., it adds the\ngroup in a ``drained'' state).",
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--capacity-scaler',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'CAPACITY_SCALER'},
                                                                                                                                   u'--description': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'An optional, textual description for the backend.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--description',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                                   u'--global': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                 u'group': u'add-backend.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--global',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'GLOBAL'},
                                                                                                                                   u'--instance-group': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name of the instance group.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--instance-group',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': True,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'INSTANCE_GROUP'},
                                                                                                                                   u'--instance-group-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u"The region of the instance group to add. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                                u'group': u'add-backend.2',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--instance-group-region',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'INSTANCE_GROUP_REGION'},
                                                                                                                                   u'--instance-group-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u"The zone of the instance group to add. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                              u'group': u'add-backend.2',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--instance-group-zone',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'INSTANCE_GROUP_ZONE'},
                                                                                                                                   u'--max-connections': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'Maximum concurrent connections that the group can handle.',
                                                                                                                                                          u'group': u'add-backend.3',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--max-connections',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'MAX_CONNECTIONS'},
                                                                                                                                   u'--max-connections-per-instance': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The maximum concurrent connections per-instance.',
                                                                                                                                                                       u'group': u'add-backend.3',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--max-connections-per-instance',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'MAX_CONNECTIONS_PER_INSTANCE'},
                                                                                                                                   u'--max-rate': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Maximum requests per second (RPS) that the group can handle.',
                                                                                                                                                   u'group': u'add-backend.3',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--max-rate',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'MAX_RATE'},
                                                                                                                                   u'--max-rate-per-instance': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The maximum per-instance requests per second (RPS).',
                                                                                                                                                                u'group': u'add-backend.3',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--max-rate-per-instance',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'MAX_RATE_PER_INSTANCE'},
                                                                                                                                   u'--max-utilization': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The target CPU utilization for the group as a float in the range\n[0.0, 1.0]. This flag can only be provided when the balancing\nmode is *UTILIZATION*.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--max-utilization',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'MAX_UTILIZATION'},
                                                                                                                                   u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                 u'group': u'add-backend.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--region',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'REGION'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {u'add-backend.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                       u'is_required': False},
                                                                                                                                    u'add-backend.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                       u'is_required': False},
                                                                                                                                    u'add-backend.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                       u'is_required': False}},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'add-backend',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'alpha',
                                                                                                                                  u'compute',
                                                                                                                                  u'backend-services',
                                                                                                                                  u'add-backend'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the backend service.',
                                                                                                                                          u'name': u'name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'NAME'}],
                                                                                                                        u'release': u'ALPHA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'\n*add-backend* is used to add a backend to a backend service. A\nbackend is a group of tasks that can handle requests sent to a\nbackend service. Currently, the group of tasks can be one or\nmore Google Compute Engine virtual machine instances grouped\ntogether using an instance group.\n\nTraffic is first spread evenly across all virtual machines in\nthe group. When the group is full, traffic is sent to the next\nnearest group(s) that still have remaining capacity.\n\nTo modify the parameters of a backend after it has been added\nto the backend service, use\n`gcloud compute backend-services update-backend` or\n`gcloud compute backend-services edit`.\n'}},
                                                                                                       u'create': {u'capsule': u'*(ALPHA)* Create a backend service.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--affinity-cookie-ttl': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'If session-affinity is set to "generated_cookie", this flag sets\nthe TTL, in seconds, of the resulting cookie.  A setting of 0\nindicates that the cookie should be transient.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--affinity-cookie-ttl',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'AFFINITY_COOKIE_TTL'},
                                                                                                                              u'--cache-key-include-host': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': True,
                                                                                                                                                            u'description': u'Enable including host in cache key. If enabled, requests to different\nhosts will be cached separately. Can only be applied for global resources. Enabled by default, use *--no-cache-key-include-host* to disable.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--cache-key-include-host',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'CACHE_KEY_INCLUDE_HOST'},
                                                                                                                              u'--cache-key-include-protocol': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': True,
                                                                                                                                                                u'description': u'Enable including protocol in cache key. If enabled, http and https\nrequests will be cached separately. Can only be applied for global\nresources. Enabled by default, use *--no-cache-key-include-protocol* to disable.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--cache-key-include-protocol',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                u'value': u'CACHE_KEY_INCLUDE_PROTOCOL'},
                                                                                                                              u'--cache-key-include-query-string': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': True,
                                                                                                                                                                    u'description': u'Enable including query string in cache key. If enabled, the query string\nparameters will be included according to\n--cache-key-query-string-whitelist and\n--cache-key-query-string-blacklist. If neither is set, the entire query\nstring will be included. If disabled, then the entire query string will\nbe excluded. Can only be applied for global resources. Enabled by default, use *--no-cache-key-include-query-string* to disable.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--cache-key-include-query-string',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'bool',
                                                                                                                                                                    u'value': u'CACHE_KEY_INCLUDE_QUERY_STRING'},
                                                                                                                              u'--cache-key-query-string-blacklist': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u"Specifies a comma separated list of query string parameters to exclude\nin cache keys. All other parameters will be included. Either specify\n--cache-key-query-string-whitelist or --cache-key-query-string-blacklist,\nnot both. '&' and '=' will be percent encoded and not treated as\ndelimiters. Can only be applied for global resources.",
                                                                                                                                                                      u'group': u'create.1',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--cache-key-query-string-blacklist',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'list',
                                                                                                                                                                      u'value': u'QUERY_STRING'},
                                                                                                                              u'--cache-key-query-string-whitelist': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u"Specifies a comma separated list of query string parameters to include\nin cache keys. All other parameters will be excluded. Either specify\n--cache-key-query-string-whitelist or --cache-key-query-string-blacklist,\nnot both. '&' and '=' will be percent encoded and not treated as\ndelimiters. Can only be applied for global resources.",
                                                                                                                                                                      u'group': u'create.1',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--cache-key-query-string-whitelist',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'list',
                                                                                                                                                                      u'value': u'QUERY_STRING'},
                                                                                                                              u'--connection-draining-timeout': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Connection draining timeout to be used during removal of VMs from\ninstance groups. This guarantees that for the specified time all existing\nconnections to a VM will remain untouched, but no new connections will be\naccepted. Set timeout to zero to disable connection draining. Enable\nfeature by specifying a timeout of up to one hour.\nIf the flag is omitted API default value (0s) will be used.\nValid units for this flag are `s` for seconds, `m` for minutes, and\n`h` for hours.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--connection-draining-timeout',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'CONNECTION_DRAINING_TIMEOUT'},
                                                                                                                              u'--description': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'An optional, textual description for the backend service.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--description',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'DESCRIPTION'},
                                                                                                                              u'--enable-cdn': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Enable Cloud CDN for the backend service. Cloud CDN can cache HTTP\nresponses from a backend service at the edge of the network, close to\nusers. Cloud CDN is disabled by default.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--enable-cdn',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'ENABLE_CDN'},
                                                                                                                              u'--global': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                            u'group': u'create.2',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--global',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'GLOBAL'},
                                                                                                                              u'--health-checks': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Specifies a list of health check objects for checking the health of\nthe backend service. Health checks need not be for the same protocol\nas that of the backend service.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--health-checks',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'list',
                                                                                                                                                   u'value': u'HEALTH_CHECK'},
                                                                                                                              u'--http-health-checks': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Specifies a list of HTTP health check objects for checking the health\nof the backend service.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--http-health-checks',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                              u'--https-health-checks': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Specifies a list of HTTPS health check objects for checking the health\nof the backend service.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--https-health-checks',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'HTTPS_HEALTH_CHECK'},
                                                                                                                              u'--iap': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"Configure Identity Aware Proxy (IAP) service. You can configure IAP to be\n'enabled' or 'disabled' (default). If it is enabled you can provide values\nfor 'oauth2-client-id' and 'oauth2-client-secret'. For example,\n'--iap=enabled,oauth2-client-id=foo,oauth2-client-secret=bar' will\nturn IAP on, and '--iap=disabled' will turn it off. See\nhttps://cloud.google.com/iap/ for more information about this feature.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--iap',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'disabled|enabled,[oauth2-client-id=OAUTH2-CLIENT-ID,oauth2-client-secret=OAUTH2-CLIENT-SECRET]'},
                                                                                                                              u'--load-balancing-scheme': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [u'INTERNAL',
                                                                                                                                                                        u'EXTERNAL'],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': u'EXTERNAL',
                                                                                                                                                           u'description': u'Specifies if this is internal or external load balancer. _LOAD_BALANCING_SCHEME_ must be one of: *INTERNAL*, *EXTERNAL*.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--load-balancing-scheme',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'LOAD_BALANCING_SCHEME'},
                                                                                                                              u'--no-cache-key-include-host': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': True,
                                                                                                                                                               u'description': u'',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': True,
                                                                                                                                                               u'name': u'--no-cache-key-include-host',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'bool',
                                                                                                                                                               u'value': u'NO_CACHE_KEY_INCLUDE_HOST'},
                                                                                                                              u'--no-cache-key-include-protocol': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': True,
                                                                                                                                                                   u'description': u'',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': True,
                                                                                                                                                                   u'name': u'--no-cache-key-include-protocol',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'bool',
                                                                                                                                                                   u'value': u'NO_CACHE_KEY_INCLUDE_PROTOCOL'},
                                                                                                                              u'--no-cache-key-include-query-string': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': True,
                                                                                                                                                                       u'description': u'',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': True,
                                                                                                                                                                       u'name': u'--no-cache-key-include-query-string',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'bool',
                                                                                                                                                                       u'value': u'NO_CACHE_KEY_INCLUDE_QUERY_STRING'},
                                                                                                                              u'--no-enable-cdn': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-enable-cdn',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_ENABLE_CDN'},
                                                                                                                              u'--port': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The TCP port to use when connecting to the backend. --port is being deprecated in favor of --port-name.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--port',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PORT'},
                                                                                                                              u'--port-name': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"The name of a service that has been added to an instance group\nin this backend. Instance group services map a name to a port\nnumber which is used by the load balancing service.\nOnly one ``port-name'' may be added to a backend service, and that\nname must exist as a service on all instance groups that are a\npart of this backend service. The port number associated with the\nname may differ between instances. If you do not specify\nthis flag, your instance groups must have a service named ``http''\nconfigured. See also\n`gcloud compute instance-groups set-named-ports --help`.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--port-name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PORT_NAME'},
                                                                                                                              u'--protocol': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [u'HTTP',
                                                                                                                                                           u'HTTPS',
                                                                                                                                                           u'SSL',
                                                                                                                                                           u'TCP',
                                                                                                                                                           u'UDP'],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The protocol for incoming requests. _PROTOCOL_ must be one of: *HTTP*, *HTTPS*, *SSL*, *TCP*, *UDP*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--protocol',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PROTOCOL'},
                                                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                            u'group': u'create.2',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'},
                                                                                                                              u'--session-affinity': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [u'CLIENT_IP',
                                                                                                                                                                   u'CLIENT_IP_PORT_PROTO',
                                                                                                                                                                   u'CLIENT_IP_PROTO',
                                                                                                                                                                   u'GENERATED_COOKIE',
                                                                                                                                                                   u'NONE'],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The type of session affinity to use for this backend service. _SESSION_AFFINITY_ must be one of:\n+\n*CLIENT_IP*::: Route requests to instances based on the hash of the client\'s IP address.\n*CLIENT_IP_PORT_PROTO*::: Connections from the same client IP with the same IP protocol and port will go to the same VM in the backend while that VM remains healthy. This option cannot be used for HTTP(S) load balancing.\n*CLIENT_IP_PROTO*::: Connections from the same client IP with the same IP protocol willgo to the same VM in the pool while that VM remains healthy. This option cannot be used for HTTP(s) load balancing.\n*GENERATED_COOKIE*::: Route requests to instances based on the contents of the "GCLB" cookie set by the load balancer.\n*NONE*::: Session affinity is disabled.\n+',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--session-affinity',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'SESSION_AFFINITY'},
                                                                                                                              u'--timeout': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': u'30s',
                                                                                                                                             u'description': u"The amount of time to wait for a backend to respond to a request\nbefore considering the request failed. For example, specifying\n``10s'' will give backends 10 seconds to respond to\nrequests. Valid units for this flag are ``s'' for seconds, ``m''\nfor minutes, and ``h'' for hours.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--timeout',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'TIMEOUT'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False},
                                                                                                                               u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False}},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'create',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'backend-services',
                                                                                                                             u'create'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the backend service.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u"\n*create* is used to create backend services. Backend\nservices define groups of backends that can receive\ntraffic. Each backend group has parameters that define the\ngroup's capacity (e.g., max CPU utilization, max queries per\nsecond, ...). URL maps define which requests are sent to which\nbackend services.\n\nBackend services created through this command will start out\nwithout any backend groups. To add backend groups, use 'gcloud\ncompute backend-services add-backend' or 'gcloud compute\nbackend-services edit'.\n"}},
                                                                                                       u'delete': {u'capsule': u'*(ALPHA)* Delete backend services.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--global': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                            u'group': u'delete.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--global',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'GLOBAL'},
                                                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                            u'group': u'delete.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False}},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'delete',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'backend-services',
                                                                                                                             u'delete'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The names of the backend services.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'+',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* *delete* deletes one or more backend services.'}},
                                                                                                       u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about a backend service.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--global': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'If provided, it is assumed that the requested resource is global.',
                                                                                                                                              u'group': u'describe.1',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--global',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'GLOBAL'},
                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                              u'group': u'describe.1',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--region',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'REGION'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                 u'is_mutex': True,
                                                                                                                                                 u'is_required': False}},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'describe',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'backend-services',
                                                                                                                               u'describe'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the resource to fetch.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a backend service in a project.\n',
                                                                                                                                   u'EXAMPLES': u"\nTo get details about a global backend service, run:\n\n  $ describe --global\n\nTo get details about a regional backend service in the ``us-central1'' regions,\nrun:\n\n  $ describe --region us-central1\n"}},
                                                                                                       u'edit': {u'capsule': u'*(ALPHA)* Modify backend services.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--global': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                          u'group': u'edit.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--global',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'GLOBAL'},
                                                                                                                            u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                          u'group': u'edit.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--region',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'REGION'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {u'edit.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                         u'is_mutex': True,
                                                                                                                                         u'is_required': False}},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'edit',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'backend-services',
                                                                                                                           u'edit'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the backend service.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*edit* can be used to modify a backend service. The backend\nservice resource is fetched from the server and presented in a text\neditor. After the file is saved and closed, this command will\nupdate the resource. Only fields that can be modified are\ndisplayed in the editor.\n\nBackends are named by their associated instances groups, and one\nof the ``--group\'\' or ``--instance-group\'\' flags is required to\nidentify the backend that you are modifying.  You cannot "change"\nthe instance group associated with a backend, but you can accomplish\nsomething similar with ``backend-services remove-backend\'\' and\n``backend-services add-backend\'\'.\n\nThe editor used to modify the resource is chosen by inspecting\nthe ``EDITOR\'\' environment variable.\n'}},
                                                                                                       u'get-health': {u'capsule': u'*(ALPHA)* Get backend health statuses from a backend service.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--filter',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                                  u'--global': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                u'group': u'get-health.1',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--global',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'GLOBAL'},
                                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--limit',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'LIMIT'},
                                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-uri',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_URI'},
                                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--page-size',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                                  u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                u'group': u'get-health.1',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--region',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'REGION'},
                                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'list',
                                                                                                                                                 u'value': u'FIELD'},
                                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'URI'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {u'get-health.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                     u'is_mutex': True,
                                                                                                                                                     u'is_required': False}},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'get-health',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'backend-services',
                                                                                                                                 u'get-health'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the backend service.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u"\n*get-health* is used to request the current health status of\ninstances in a backend service. Every group in the service\nis checked and the health status of each configured instance\nis printed.\n\nIf a group contains names of instances that don't exist or\ninstances that haven't yet been pushed to the load-balancing\nsystem, they will not show up. Those that are listed as\n``HEALTHY'' are able to receive load-balanced traffic. Those that\nare marked as ``UNHEALTHY'' are either failing the configured\nhealth-check or not responding to it.\n\nSince the health checks are performed continuously and in\na distributed manner, the state returned by this command is\nthe most recent result of a vote of several redundant health\nchecks. Backend services that do not have a valid global\nforwarding rule referencing it will not be health checked and\nso will have no health status.\n"}},
                                                                                                       u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine backend services.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--filter',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                                            u'--global': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'If provided, only global resources are shown.',
                                                                                                                                          u'group': u'list.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--global',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'GLOBAL'},
                                                                                                                            u'--limit': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--limit',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'LIMIT'},
                                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_URI'},
                                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--page-size',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                                            u'--regexp': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--regexp',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'REGEXP'},
                                                                                                                            u'--regions': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                           u'group': u'list.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--regions',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'REGION'},
                                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--sort-by',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'FIELD'},
                                                                                                                            u'--uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'URI'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                         u'is_mutex': True,
                                                                                                                                         u'is_required': False}},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'list',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'backend-services',
                                                                                                                           u'list'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': [],
                                                                                                                                   u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                   u'name': u'names',
                                                                                                                                   u'nargs': u'*',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine backend services in a project.\n\nBy default, global backend services and backend services from all regions are listed. The results can be narrowed down by\nproviding the ``--global'' or ``--regions'' flag.\n",
                                                                                                                               u'EXAMPLES': u"To list all backend services in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all backend services in a project, run:\n\n  $ list --uri\n\nTo list all global backend services in a project, run:\n\n  $ list --global\n\nTo list all backend services in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n"}},
                                                                                                       u'remove-backend': {u'capsule': u'*(ALPHA)* Remove a backend from a backend service.',
                                                                                                                           u'commands': {},
                                                                                                                           u'flags': {u'--global': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                    u'group': u'remove-backend.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--global',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'GLOBAL'},
                                                                                                                                      u'--instance-group': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The name of the instance group.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--instance-group',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': True,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'INSTANCE_GROUP'},
                                                                                                                                      u'--instance-group-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u"The region of the instance group to remove. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                                   u'group': u'remove-backend.2',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--instance-group-region',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'INSTANCE_GROUP_REGION'},
                                                                                                                                      u'--instance-group-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u"The zone of the instance group to remove. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                 u'group': u'remove-backend.2',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--instance-group-zone',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'INSTANCE_GROUP_ZONE'},
                                                                                                                                      u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                    u'group': u'remove-backend.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--region',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'REGION'}},
                                                                                                                           u'group': False,
                                                                                                                           u'groups': {u'remove-backend.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                             u'is_required': False},
                                                                                                                                       u'remove-backend.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                             u'is_required': False}},
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'remove-backend',
                                                                                                                           u'path': [u'gcloud',
                                                                                                                                     u'alpha',
                                                                                                                                     u'compute',
                                                                                                                                     u'backend-services',
                                                                                                                                     u'remove-backend'],
                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The name of the backend service.',
                                                                                                                                             u'name': u'name',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'NAME'}],
                                                                                                                           u'release': u'ALPHA',
                                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* *remove-backend* is used to remove a backend from a backend\nservice.\n\nBefore removing a backend, it is a good idea to "drain" the\nbackend first. A backend can be drained by setting its\ncapacity scaler to zero through \'gcloud compute\nbackend-services edit\'.'}},
                                                                                                       u'update': {u'capsule': u'*(ALPHA)* Update a backend service.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--affinity-cookie-ttl': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'If session-affinity is set to "generated_cookie", this flag sets\nthe TTL, in seconds, of the resulting cookie.  A setting of 0\nindicates that the cookie should be transient.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--affinity-cookie-ttl',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'AFFINITY_COOKIE_TTL'},
                                                                                                                              u'--cache-key-include-host': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': False,
                                                                                                                                                            u'description': u'Enable including host in cache key. If enabled, requests to different\nhosts will be cached separately. Can only be applied for global resources.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--cache-key-include-host',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'CACHE_KEY_INCLUDE_HOST'},
                                                                                                                              u'--cache-key-include-protocol': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': False,
                                                                                                                                                                u'description': u'Enable including protocol in cache key. If enabled, http and https\nrequests will be cached separately. Can only be applied for global\nresources.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--cache-key-include-protocol',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                u'value': u'CACHE_KEY_INCLUDE_PROTOCOL'},
                                                                                                                              u'--cache-key-include-query-string': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': False,
                                                                                                                                                                    u'description': u'Enable including query string in cache key. If enabled, the query string\nparameters will be included according to\n--cache-key-query-string-whitelist and\n--cache-key-query-string-blacklist. If disabled, the entire query string\nwill be excluded. Use "--cache-key-query-string-blacklist=" (sets the\nblacklist to the empty list) to include the entire query string. Can\nonly be applied for global resources.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--cache-key-include-query-string',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'bool',
                                                                                                                                                                    u'value': u'CACHE_KEY_INCLUDE_QUERY_STRING'},
                                                                                                                              u'--cache-key-query-string-blacklist': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u"Specifies a comma separated list of query string parameters to exclude\nin cache keys. All other parameters will be included. Either specify\n--cache-key-query-string-whitelist or --cache-key-query-string-blacklist,\nnot both. '&' and '=' will be percent encoded and not treated as\ndelimiters. Can only be applied for global resources.",
                                                                                                                                                                      u'group': u'update.1',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--cache-key-query-string-blacklist',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'list',
                                                                                                                                                                      u'value': u'QUERY_STRING'},
                                                                                                                              u'--cache-key-query-string-whitelist': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u"Specifies a comma separated list of query string parameters to include\nin cache keys. All other parameters will be excluded. Either specify\n--cache-key-query-string-whitelist or --cache-key-query-string-blacklist,\nnot both. '&' and '=' will be percent encoded and not treated as\ndelimiters. Can only be applied for global resources.",
                                                                                                                                                                      u'group': u'update.1',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--cache-key-query-string-whitelist',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'list',
                                                                                                                                                                      u'value': u'QUERY_STRING'},
                                                                                                                              u'--connection-draining-timeout': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Connection draining timeout to be used during removal of VMs from\ninstance groups. This guarantees that for the specified time all existing\nconnections to a VM will remain untouched, but no new connections will be\naccepted. Set timeout to zero to disable connection draining. Enable\nfeature by specifying a timeout of up to one hour.\nIf the flag is omitted API default value (0s) will be used.\nValid units for this flag are `s` for seconds, `m` for minutes, and\n`h` for hours.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--connection-draining-timeout',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'CONNECTION_DRAINING_TIMEOUT'},
                                                                                                                              u'--description': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'An optional, textual description for the backend service.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--description',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'DESCRIPTION'},
                                                                                                                              u'--enable-cdn': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Enable Cloud CDN for the backend service. Cloud CDN can cache HTTP\nresponses from a backend service at the edge of the network, close to\nusers. Cloud CDN is disabled by default.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--enable-cdn',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'ENABLE_CDN'},
                                                                                                                              u'--global': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                            u'group': u'update.2',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--global',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'GLOBAL'},
                                                                                                                              u'--health-checks': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Specifies a list of health check objects for checking the health of\nthe backend service. Health checks need not be for the same protocol\nas that of the backend service.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--health-checks',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'list',
                                                                                                                                                   u'value': u'HEALTH_CHECK'},
                                                                                                                              u'--http-health-checks': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Specifies a list of HTTP health check objects for checking the health\nof the backend service.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--http-health-checks',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                              u'--https-health-checks': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Specifies a list of HTTPS health check objects for checking the health\nof the backend service.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--https-health-checks',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'HTTPS_HEALTH_CHECK'},
                                                                                                                              u'--iap': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"Change the Identity Aware Proxy (IAP) service configuration for the\nbackend service. You can set IAP to 'enabled' or 'disabled', or modify\nthe OAuth2 client configuration (oauth2-client-id and\noauth2-client-secret) used by IAP. If any fields are unspecified, their\nvalues will not be modified. For instance, if IAP is enabled,\n'--iap=disabled' will disable IAP, and a subsequent '--iap=enabled' will\nthen enable it with the same OAuth2 client configuration as the first\ntime it was enabled. See\nhttps://cloud.google.com/iap/ for more information about this feature.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--iap',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'disabled|enabled,[oauth2-client-id=OAUTH2-CLIENT-ID,oauth2-client-secret=OAUTH2-CLIENT-SECRET]'},
                                                                                                                              u'--no-cache-key-include-host': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': False,
                                                                                                                                                               u'description': u'',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': True,
                                                                                                                                                               u'name': u'--no-cache-key-include-host',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'bool',
                                                                                                                                                               u'value': u'NO_CACHE_KEY_INCLUDE_HOST'},
                                                                                                                              u'--no-cache-key-include-protocol': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': False,
                                                                                                                                                                   u'description': u'',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': True,
                                                                                                                                                                   u'name': u'--no-cache-key-include-protocol',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'bool',
                                                                                                                                                                   u'value': u'NO_CACHE_KEY_INCLUDE_PROTOCOL'},
                                                                                                                              u'--no-cache-key-include-query-string': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': False,
                                                                                                                                                                       u'description': u'',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': True,
                                                                                                                                                                       u'name': u'--no-cache-key-include-query-string',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'bool',
                                                                                                                                                                       u'value': u'NO_CACHE_KEY_INCLUDE_QUERY_STRING'},
                                                                                                                              u'--no-enable-cdn': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-enable-cdn',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_ENABLE_CDN'},
                                                                                                                              u'--port': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The TCP port to use when connecting to the backend. --port is being deprecated in favor of --port-name.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--port',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PORT'},
                                                                                                                              u'--port-name': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"The name of a service that has been added to an instance group\nin this backend. Instance group services map a name to a port\nnumber which is used by the load balancing service.\nOnly one ``port-name'' may be added to a backend service, and that\nname must exist as a service on all instance groups that are a\npart of this backend service. The port number associated with the\nname may differ between instances. If you do not specify\nthis flag, your instance groups must have a service named ``http''\nconfigured. See also\n`gcloud compute instance-groups set-named-ports --help`.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--port-name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PORT_NAME'},
                                                                                                                              u'--protocol': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [u'HTTP',
                                                                                                                                                           u'HTTPS',
                                                                                                                                                           u'SSL',
                                                                                                                                                           u'TCP',
                                                                                                                                                           u'UDP'],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The protocol for incoming requests. _PROTOCOL_ must be one of: *HTTP*, *HTTPS*, *SSL*, *TCP*, *UDP*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--protocol',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PROTOCOL'},
                                                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                            u'group': u'update.2',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'},
                                                                                                                              u'--session-affinity': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [u'CLIENT_IP',
                                                                                                                                                                   u'CLIENT_IP_PORT_PROTO',
                                                                                                                                                                   u'CLIENT_IP_PROTO',
                                                                                                                                                                   u'GENERATED_COOKIE',
                                                                                                                                                                   u'NONE'],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The type of session affinity to use for this backend service. _SESSION_AFFINITY_ must be one of:\n+\n*CLIENT_IP*::: Route requests to instances based on the hash of the client\'s IP address.\n*CLIENT_IP_PORT_PROTO*::: Connections from the same client IP with the same IP protocol and port will go to the same VM in the backend while that VM remains healthy. This option cannot be used for HTTP(S) load balancing.\n*CLIENT_IP_PROTO*::: Connections from the same client IP with the same IP protocol willgo to the same VM in the pool while that VM remains healthy. This option cannot be used for HTTP(s) load balancing.\n*GENERATED_COOKIE*::: Route requests to instances based on the contents of the "GCLB" cookie set by the load balancer.\n*NONE*::: Session affinity is disabled.\n+',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--session-affinity',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'SESSION_AFFINITY'},
                                                                                                                              u'--timeout': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"The amount of time to wait for a backend to respond to a request\nbefore considering the request failed. For example, specifying\n``10s'' will give backends 10 seconds to respond to\nrequests. Valid units for this flag are ``s'' for seconds, ``m''\nfor minutes, and ``h'' for hours.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--timeout',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'TIMEOUT'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {u'update.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False},
                                                                                                                               u'update.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False}},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'update',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'backend-services',
                                                                                                                             u'update'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the backend service.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'\n*update* is used to update backend services.\n'}},
                                                                                                       u'update-backend': {u'capsule': u'*(ALPHA)* Update an existing backend in a backend service.',
                                                                                                                           u'commands': {},
                                                                                                                           u'flags': {u'--balancing-mode': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [u'CONNECTION',
                                                                                                                                                                         u'RATE',
                                                                                                                                                                         u'UTILIZATION'],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Defines the strategy for balancing load.\n+\n*RATE* and the max rate arguments are available only\nin backend services with HTTP based protocols.\n+\nFor backend services with TCP/SSL protocol either *UTILIZATION* or\n*CONNECTION* are available.\n+\n_BALANCING_MODE_ must be one of:\n+\n*CONNECTION*:::           Spreads load based on how many concurrent connections the group\n          can handle. There are two ways to specify max connections:\n          *--max-connections* which defines the max number of connections\n          for the whole group or *--max-connections-per-instance*, which\n          defines the max number of connections on a per-instance basis.\n\n*RATE*:::           Spreads load based on how many requests per second (RPS) the group\n          can handle. There are two ways to specify max RPS: *--max-rate* which\n          defines the max RPS for the whole group or *--max-rate-per-instance*,\n          which defines the max RPS on a per-instance basis.\n\n*UTILIZATION*:::           Relies on the CPU utilization of the instances in the group when\n          balancing load. Use *--max-utilization* to set a maximum target CPU\n          utilization for each instance. Use *--max-rate-per-instance* or\n          *--max-rate* to optionally limit based on RPS in addition to CPU.\n          You can optionally also limit based on connections (for TCP/SSL) in\n          addition to CPU by setting *--max-connections* or\n          *--max-connections-per-instance*.\n\n+',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--balancing-mode',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'BALANCING_MODE'},
                                                                                                                                      u'--capacity-scaler': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u"A float in the range [0.0, 1.0] that scales the maximum\nparameters for the group (e.g., max rate). A value of 0.0 will\ncause no requests to be sent to the group (i.e., it adds the\ngroup in a ``drained'' state).",
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--capacity-scaler',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'CAPACITY_SCALER'},
                                                                                                                                      u'--description': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'An optional, textual description for the backend.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--description',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'DESCRIPTION'},
                                                                                                                                      u'--global': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                    u'group': u'update-backend.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--global',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'GLOBAL'},
                                                                                                                                      u'--instance-group': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The name of the instance group.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--instance-group',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': True,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'INSTANCE_GROUP'},
                                                                                                                                      u'--instance-group-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u"The region of the instance group to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                                   u'group': u'update-backend.2',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--instance-group-region',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'INSTANCE_GROUP_REGION'},
                                                                                                                                      u'--instance-group-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u"The zone of the instance group to update. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                 u'group': u'update-backend.2',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--instance-group-zone',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'INSTANCE_GROUP_ZONE'},
                                                                                                                                      u'--max-connections': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Maximum concurrent connections that the group can handle.',
                                                                                                                                                             u'group': u'update-backend.3',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--max-connections',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'MAX_CONNECTIONS'},
                                                                                                                                      u'--max-connections-per-instance': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The maximum concurrent connections per-instance.',
                                                                                                                                                                          u'group': u'update-backend.3',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--max-connections-per-instance',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'MAX_CONNECTIONS_PER_INSTANCE'},
                                                                                                                                      u'--max-rate': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Maximum requests per second (RPS) that the group can handle.',
                                                                                                                                                      u'group': u'update-backend.3',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--max-rate',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'MAX_RATE'},
                                                                                                                                      u'--max-rate-per-instance': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The maximum per-instance requests per second (RPS).',
                                                                                                                                                                   u'group': u'update-backend.3',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--max-rate-per-instance',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'MAX_RATE_PER_INSTANCE'},
                                                                                                                                      u'--max-utilization': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The target CPU utilization for the group as a float in the range\n[0.0, 1.0]. This flag can only be provided when the balancing\nmode is *UTILIZATION*.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--max-utilization',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'MAX_UTILIZATION'},
                                                                                                                                      u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                    u'group': u'update-backend.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--region',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'REGION'}},
                                                                                                                           u'group': False,
                                                                                                                           u'groups': {u'update-backend.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                             u'is_required': False},
                                                                                                                                       u'update-backend.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                             u'is_required': False},
                                                                                                                                       u'update-backend.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                             u'is_required': False}},
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'update-backend',
                                                                                                                           u'path': [u'gcloud',
                                                                                                                                     u'alpha',
                                                                                                                                     u'compute',
                                                                                                                                     u'backend-services',
                                                                                                                                     u'update-backend'],
                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The name of the backend service.',
                                                                                                                                             u'name': u'name',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'NAME'}],
                                                                                                                           u'release': u'ALPHA',
                                                                                                                           u'sections': {u'DESCRIPTION': u'\n*update-backend* updates a backend that is part of a backend\nservice. This is useful for changing the way a backend\nbehaves. Example changes that can be made include changing the\nload balancing policy and ``draining\'\' a backend by setting\nits capacity scaler to zero.\n\nBackends are named by their associated instances groups, and one\nof the ``--group\'\' or ``--instance-group\'\' flags is required to\nidentify the backend that you are modifying.  You cannot "change"\nthe instance group associated with a backend, but you can accomplish\nsomething similar with ``backend-services remove-backend\'\' and\n``backend-services add-backend\'\'.\n\n`gcloud compute backend-services edit` can also be used to\nupdate a backend if the use of a text editor is desired.\n'}}},
                                                                                         u'flags': {},
                                                                                         u'group': True,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'backend-services',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'alpha',
                                                                                                   u'compute',
                                                                                                   u'backend-services'],
                                                                                         u'positionals': [],
                                                                                         u'release': u'ALPHA',
                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, and delete backend services.'}},
                                                                   u'config-ssh': {u'capsule': u'*(ALPHA)* Populate SSH config files with Host entries from each instance.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--dry-run': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': False,
                                                                                                             u'description': u'If provided, the proposed changes to the SSH config file are printed to standard output and no actual changes are made.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--dry-run',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'DRY_RUN'},
                                                                                              u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--force-key-file-overwrite',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                              u'--no-dry-run': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': True,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--no-dry-run',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_DRY_RUN'},
                                                                                              u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-force-key-file-overwrite',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                              u'--no-remove': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': True,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-remove',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_REMOVE'},
                                                                                              u'--remove': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u'If provided, any changes made to the SSH config file by this tool are reverted.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--remove',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'REMOVE'},
                                                                                              u'--ssh-config-file': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"Specifies an alternative per-user SSH configuration file. By\ndefault, this is ``~/.ssh/config''.",
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--ssh-config-file',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'SSH_CONFIG_FILE'},
                                                                                              u'--ssh-key-file': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--ssh-key-file',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'SSH_KEY_FILE'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'config-ssh',
                                                                                   u'path': [u'gcloud',
                                                                                             u'alpha',
                                                                                             u'compute',
                                                                                             u'config-ssh'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'ALPHA',
                                                                                   u'sections': {u'DESCRIPTION': u"*config-ssh* makes SSHing to virtual machine instances easier\nby adding an alias for each instance to the user SSH configuration\n(``~/.ssh/config'') file.\n\nIn most cases, it is sufficient to run:\n\n  $ config-ssh\n\nEach instance will be given an alias of the form\n``NAME.ZONE.PROJECT''. For example, if ``example-instance'' resides in\n``us-central1-a'', you can SSH to it by running:\n\n  $ ssh example-instance.us-central1-a.MY-PROJECT\n\nOn some platforms, the host alias can be tab-completed, making\nthe long alias less daunting to type.\n\nThe aliases created interface with SSH-based programs like\n*scp(1)*, so it is possible to use the aliases elsewhere:\n\n  $ scp ~/MY-FILE example-instance.us-central1-a.MY-PROJECT:~\n\nWhenever instances are added, removed, or their external IP\naddresses are changed, this command should be re-executed to\nupdate the configuration.\n\nThis command ensures that the user's public SSH key is present\nin the project's metadata. If the user does not have a public\nSSH key, one is generated using *ssh-keygen(1)* (if the `--quiet`\nflag is given, the generated key will have an empty passphrase).\n"}},
                                                                   u'connect-to-serial-port': {u'capsule': u'*(ALPHA)* Connect to the serial port of an instance.',
                                                                                               u'commands': {},
                                                                                               u'flags': {u'--dry-run': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'If provided, the ssh command is printed to standard out rather than being executed.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--dry-run',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'DRY_RUN'},
                                                                                                          u'--extra-args': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': {},
                                                                                                                            u'description': u'Optional arguments can be passed to the serial port connection by\npassing key-value pairs to this flag, such as max-connections=N or\nreplay-lines=N. See https://cloud.google.com/compute/docs/instances/interacting-with-serial-console for additional options.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--extra-args',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'dict',
                                                                                                                            u'value': u'KEY=VALUE'},
                                                                                                          u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--force-key-file-overwrite',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                                          u'--no-dry-run': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': True,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--no-dry-run',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_DRY_RUN'},
                                                                                                          u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-force-key-file-overwrite',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                                          u'--no-plain': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': True,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-plain',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_PLAIN'},
                                                                                                          u'--plain': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--plain',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'PLAIN'},
                                                                                                          u'--port': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The number of the requested serial port. Can be 1-4, default is 1.\n+\nInstances can support up to four serial ports. By default, this\ncommand will connect to the first serial port. Setting this flag\nwill connect to the requested serial port.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--port',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'PORT'},
                                                                                                          u'--serial-port-gateway': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': u'ssh-serialport.googleapis.com',
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--serial-port-gateway',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'SERIAL_PORT_GATEWAY'},
                                                                                                          u'--ssh-key-file': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--ssh-key-file',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'SSH_KEY_FILE'},
                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"The zone of the instance to connect to. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--zone',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'ZONE'}},
                                                                                               u'group': False,
                                                                                               u'groups': {},
                                                                                               u'hidden': False,
                                                                                               u'name': u'connect-to-serial-port',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'alpha',
                                                                                                         u'compute',
                                                                                                         u'connect-to-serial-port'],
                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"Specifies the user/instance for the serial port connection.\n+\n``USER'' specifies the username to authenticate as. If omitted,\nthe current OS user is selected.",
                                                                                                                 u'name': u'user-host',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'value': u'[USER@]INSTANCE'}],
                                                                                               u'release': u'ALPHA',
                                                                                               u'sections': {u'DESCRIPTION': u"*connect-to-serial-port* allows users to connect to, and interact with, a VM's\nvirtual serial port using ssh as the secure, authenticated transport\nprotocol.\n\nThe user must first enable serial port access to a given VM by setting\nthe 'serial-port-enable=true' metadata key-value pair. Setting\n'serial-port-enable' on the project-level metadata enables serial port\naccess to all VMs in the project.\n\nThis command uses the same SSH key pair as the `gcloud compute ssh`\ncommand and also ensures that the user's public SSH key is present in\nthe project's metadata. If the user does not have a public SSH key,\none is generated using ssh-keygen.\n"}},
                                                                   u'copy-files': {u'capsule': u'*(ALPHA)* Copy files to and from Google Compute Engine virtual machines.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--dry-run': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': False,
                                                                                                             u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--dry-run',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'DRY_RUN'},
                                                                                              u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--force-key-file-overwrite',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                              u'--no-dry-run': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': True,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--no-dry-run',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_DRY_RUN'},
                                                                                              u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-force-key-file-overwrite',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                              u'--no-plain': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-plain',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_PLAIN'},
                                                                                              u'--plain': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'Suppresses the automatic addition of *ssh(1)*/*scp(1)* flags. This flag\nis useful if you want to take care of authentication yourself or\nuse specific ssh/scp features.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--plain',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'PLAIN'},
                                                                                              u'--ssh-key-file': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--ssh-key-file',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'SSH_KEY_FILE'},
                                                                                              u'--strict-host-key-checking': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [u'yes',
                                                                                                                                           u'no',
                                                                                                                                           u'ask'],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"Override the default behavior of StrictHostKeyChecking. By default,\nStrictHostKeyChecking is set to 'no' the first time you connect to an\ninstance and will be set to 'yes' for all subsequent connections. Use\nthis flag to specify a value for the connection. _STRICT_HOST_KEY_CHECKING_ must be one of: *yes*, *no*, *ask*.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--strict-host-key-checking',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'STRICT_HOST_KEY_CHECKING'},
                                                                                              u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"The zone of the instance to copy files to/from. If omitted,\nyou will be prompted to select a zone.\n+\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--zone',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'ZONE'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'copy-files',
                                                                                   u'path': [u'gcloud',
                                                                                             u'alpha',
                                                                                             u'compute',
                                                                                             u'copy-files'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Specifies a source file.',
                                                                                                     u'name': u'sources',
                                                                                                     u'nargs': u'+',
                                                                                                     u'required': False,
                                                                                                     u'value': u'[[USER@]INSTANCE:]SRC'},
                                                                                                    {u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Specifies a destination for the source files.',
                                                                                                     u'name': u'destination',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'value': u'[[USER@]INSTANCE:]DEST'}],
                                                                                   u'release': u'ALPHA',
                                                                                   u'sections': {u'DESCRIPTION': u"*copy-files* copies files between a virtual machine instance\nand your local machine.\n\nTo denote a remote file, prefix the file name with the virtual\nmachine instance name (e.g., _example-instance_:~/_FILE_). To\ndenote a local file, do not add a prefix to the file name\n(e.g., ~/_FILE_). For example, to copy a remote directory\nto your local host, run:\n\n  $ copy-files example-instance:~/REMOTE-DIR ~/LOCAL-DIR --zone us-central1-a\n\nIn the above example, ``~/REMOTE-DIR'' from ``example-instance'' is\ncopied into the ~/_LOCAL-DIR_ directory.\n\nConversely, files from your local computer can be copied to a\nvirtual machine:\n\n  $ copy-files ~/LOCAL-FILE-1 ~/LOCAL-FILE-2 example-instance:~/REMOTE-DIR --zone us-central1-a\n\nIf a file contains a colon (``:''), you must specify it by\neither using an absolute path or a path that begins with\n``./''.\n\nUnder the covers, *scp(1)* is used to facilitate the transfer.\n\nWhen the destination is local, all sources must be the same\nvirtual machine instance. When the destination is remote, all\nsource must be local.\n\nThis command ensures that the user's public SSH key is present\nin the project's metadata. If the user does not have a public\nSSH key, one is generated using *ssh-keygen(1)* (if the the `--quiet`\nflag is given, the generated key will have an empty passphrase).\n"}},
                                                                   u'disk-types': {u'capsule': u'*(ALPHA)* Read Google Compute Engine virtual disk types.',
                                                                                   u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine disk type.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--zone',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ZONE'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'describe',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'compute',
                                                                                                                         u'disk-types',
                                                                                                                         u'describe'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the resource to fetch.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine disk type.\n'}},
                                                                                                 u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine disk types.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--filter',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--limit',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-uri',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_URI'},
                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--page-size',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                      u'--regexp': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--regexp',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'REGEXP'},
                                                                                                                      u'--regions': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                     u'group': u'list.1',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--regions',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'REGION'},
                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'FIELD'},
                                                                                                                      u'--uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'URI'},
                                                                                                                      u'--zones': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'If provided, only zonal resources are shown. If arguments are provided, only resources from the given zones are shown.',
                                                                                                                                   u'group': u'list.1',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--zones',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'ZONE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                   u'is_mutex': True,
                                                                                                                                   u'is_required': False}},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'list',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'disk-types',
                                                                                                                     u'list'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': [],
                                                                                                                             u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'*',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine disk types in a project.\n\nBy default, disk types from all regions and disk types from all zones are listed. The results can be narrowed down by\nproviding the ``--regions'' or ``--zones'' flag.\n",
                                                                                                                         u'EXAMPLES': u"To list all disk types in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all disk types in a project, run:\n\n  $ list --uri\n\nTo list all disk types in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n\nTo list all disk types in zones ``us-central1-b'' and ``europe-west1-d'',\nrun:\n\n  $ list --zones us-central1,europe-west1\n"}}},
                                                                                   u'flags': {},
                                                                                   u'group': True,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'disk-types',
                                                                                   u'path': [u'gcloud',
                                                                                             u'alpha',
                                                                                             u'compute',
                                                                                             u'disk-types'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'ALPHA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read Google Compute Engine virtual disk types.'}},
                                                                   u'disks': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine disks.',
                                                                              u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create Google Compute Engine persistent disks.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--csek-key-file',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'FILE'},
                                                                                                                   u'--description': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'An optional, textual description for the disks being created.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--description',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                   u'--image': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"An image to apply to the disks being created. When using\nthis option, the size of the disks must be at least as large as\nthe image size. Use ``--size'' to adjust the size of the disks.\n+\nThis flag is mutually exclusive with ``--source-snapshot'' and\n``--image-family''.",
                                                                                                                                u'group': u'create.1',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--image',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'IMAGE'},
                                                                                                                   u'--image-family': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The family of the image that the boot disk will be initialized with. When a family is used instead of an image, the latest non-deprecated image associated with that family is used.',
                                                                                                                                       u'group': u'create.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--image-family',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'IMAGE_FAMILY'},
                                                                                                                   u'--image-project': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The project against which all image and image family references will be\nresolved. See ``--image'' for more details.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--image-project',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'IMAGE_PROJECT'},
                                                                                                                   u'--no-require-csek-key-create': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': True,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-require-csek-key-create',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                   u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'create.2',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--region',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'REGION'},
                                                                                                                   u'--replica-zones': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--replica-zones',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'ZONE1, ZONE2'},
                                                                                                                   u'--require-csek-key-create': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': True,
                                                                                                                                                  u'description': u'Refuse to create resources not protected by a user managed key in\nthe key file when --csek-key-file is given. This behavior is enabled\nby default to prevent incorrect gcloud invocations from accidentally\ncreating resources with no user managed key. Disabling the check\nallows creation of some resources without a matching\nCustomer-Supplied Encryption Key in the supplied --csek-key-file.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details. Enabled by default, use *--no-require-csek-key-create* to disable.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--require-csek-key-create',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                   u'--size': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"Indicates the size of the disks. The value must be a whole\nnumber followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For\nexample, ``10GB'' will produce 10 gigabyte disks.  Disk size\nmust be a multiple of 10 GB.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--size',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'SIZE'},
                                                                                                                   u'--source-snapshot': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'A source snapshot used to create the disks. It is safe to\ndelete a snapshot after a disk has been created from the\nsnapshot. In such cases, the disks will no longer reference\nthe deleted snapshot. To get a list of snapshots in your\ncurrent project, run `gcloud compute snapshots list`. A\nsnapshot from an existing disk can be created using the\n`gcloud compute disks snapshot` command. This flag is mutually\nexclusive with *--image*.\n+\nWhen using this option, the size of the disks must be at least\nas large as the snapshot size. Use *--size* to adjust the\nsize of the disks.',
                                                                                                                                          u'group': u'create.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--source-snapshot',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'SOURCE_SNAPSHOT'},
                                                                                                                   u'--type': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Specifies the type of disk to create. To get a\nlist of available disk types, run `gcloud compute disk-types list`.\nThe default disk type is pd-standard.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--type',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'TYPE'},
                                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                               u'group': u'create.2',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--zone',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'ZONE'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                  u'is_mutex': True,
                                                                                                                                  u'is_required': False},
                                                                                                                    u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                  u'is_mutex': True,
                                                                                                                                  u'is_required': False}},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'create',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'compute',
                                                                                                                  u'disks',
                                                                                                                  u'create'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The names of the disks.',
                                                                                                                          u'name': u'DISK-NAME',
                                                                                                                          u'nargs': u'+',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'DISK_NAME'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*create* creates one or more Google Compute Engine\npersistent disks. When creating virtual machine instances,\ndisks can be attached to the instances through the\n`gcloud compute instances create` command. Disks can also be\nattached to instances that are already running using\n`gcloud compute instances attach-disk`.\n\nDisks are zonal resources, so they reside in a particular zone\nfor their entire lifetime. The contents of a disk can be moved\nto a different zone by snapshotting the disk (using\n`gcloud compute disks snapshot`) and creating a new disk using\n`--source-snapshot` in the desired zone. The contents of a\ndisk can also be moved across project or zone by creating an\nimage (using `gcloud compute images create`) and creating a\nnew disk using `--image` in the desired project and/or\nzone.\n\nWhen creating disks, be sure to include the `--zone` option:\n\n  $ create my-disk-1 my-disk-2 --zone us-east1-a\n'}},
                                                                                            u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine persistent disks.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'delete.1',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--region',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'REGION'},
                                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"The zone of the disk to delete. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                               u'group': u'delete.1',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--zone',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'ZONE'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                  u'is_mutex': True,
                                                                                                                                  u'is_required': False}},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'delete',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'compute',
                                                                                                                  u'disks',
                                                                                                                  u'delete'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The names of the disks.',
                                                                                                                          u'name': u'DISK-NAME',
                                                                                                                          u'nargs': u'+',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'DISK_NAME'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* *delete* deletes one or more Google Compute Engine\npersistent disks. Disks can be deleted only if they are not\nbeing used by any virtual machine instances.'}},
                                                                                            u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine disk.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'describe.1',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--region',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'REGION'},
                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                 u'group': u'describe.1',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--zone',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False}},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'describe',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'disks',
                                                                                                                    u'describe'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the disk.',
                                                                                                                            u'name': u'DISK-NAME',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'DISK_NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine disk in a project.\n'}},
                                                                                            u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine disks.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--regexp': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--regexp',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'REGEXP'},
                                                                                                                 u'--regions': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                u'group': u'list.1',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--regions',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'REGION'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'},
                                                                                                                 u'--zones': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'If provided, only zonal resources are shown. If arguments are provided, only resources from the given zones are shown.',
                                                                                                                              u'group': u'list.1',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--zones',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'ZONE'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                              u'is_mutex': True,
                                                                                                                              u'is_required': False}},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'compute',
                                                                                                                u'disks',
                                                                                                                u'list'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': [],
                                                                                                                        u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                        u'name': u'names',
                                                                                                                        u'nargs': u'*',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'NAME'}],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine disks in a project.\n\nBy default, disks from all regions and disks from all zones are listed. The results can be narrowed down by\nproviding the ``--regions'' or ``--zones'' flag.\n",
                                                                                                                    u'EXAMPLES': u"To list all disks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all disks in a project, run:\n\n  $ list --uri\n\nTo list all disks in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n\nTo list all disks in zones ``us-central1-b'' and ``europe-west1-d'',\nrun:\n\n  $ list --zones us-central1,europe-west1\n"}},
                                                                                            u'move': {u'capsule': u'*(ALPHA)* Move a disk between zones.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--async': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--async',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'ASYNC'},
                                                                                                                 u'--destination-zone': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The zone to move the disk to.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--destination-zone',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': True,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'DESTINATION_ZONE'},
                                                                                                                 u'--no-async': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-async',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_ASYNC'},
                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--zone',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'ZONE'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'move',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'compute',
                                                                                                                u'disks',
                                                                                                                u'move'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The name of the disk.',
                                                                                                                        u'name': u'DISK-NAME',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'DISK_NAME'}],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*move* facilitates moving a Google Compute Engine disk volume from\none zone to another. You cannot move a disk if it is attached to a\nrunning or stopped instance; use the gcloud compute instances move\ncommand instead.\n\nFor example, running:\n\n   $ gcloud compute disks move example-disk-1 --zone us-central1-b --destination-zone us-central1-f\n\nwill move the disk called example-disk-1, currently running in\nus-central1-b, to us-central1-f.\n'}},
                                                                                            u'resize': {u'capsule': u'*(ALPHA)* Resize a disk or disks.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'resize.1',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--region',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'REGION'},
                                                                                                                   u'--size': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"Indicates the new size of the disks. The value must be a whole\nnumber followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For\nexample, ``10GB'' will produce 10 gigabyte disks.  Disk size\nmust be a multiple of 10 GB.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--size',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': True,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'SIZE'},
                                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                               u'group': u'resize.1',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--zone',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'ZONE'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {u'resize.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                  u'is_mutex': True,
                                                                                                                                  u'is_required': False}},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'resize',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'compute',
                                                                                                                  u'disks',
                                                                                                                  u'resize'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The names of the disks.',
                                                                                                                          u'name': u'DISK-NAME',
                                                                                                                          u'nargs': u'+',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'DISK_NAME'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*resize* resizes a Google Compute Engine disk(s).\n\nOnly increasing disk size is supported. Disks can be resized\nregardless of whether they are attached.\n\n',
                                                                                                                      u'EXAMPLES': u'To resize a disk called example-disk-1 to new size 6TB, run:\n\n   $ resize example-disk-1 --size=6TB\n\nTo resize two disks called example-disk-2 and example-disk-3 to\nnew size 6TB, run:\n\n   $ resize example-disk-2 example-disk-3 --size=6TB\n\nThis assumes that original size of each of these disks is 6TB or less.\n'}},
                                                                                            u'snapshot': {u'capsule': u'*(ALPHA)* Create snapshots of Google Compute Engine persistent disks.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--async': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--async',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'ASYNC'},
                                                                                                                     u'--csek-key-file': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--csek-key-file',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'FILE'},
                                                                                                                     u'--description': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'An optional, textual description for the snapshots being created.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--description',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DESCRIPTION'},
                                                                                                                     u'--guest-flush': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Create an application consistent snapshot by informing the OS to prepare for the snapshot process. Currently only supported on Windows instances using the Volume Shadow Copy Service (VSS).',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--guest-flush',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'GUEST_FLUSH'},
                                                                                                                     u'--no-async': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-async',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_ASYNC'},
                                                                                                                     u'--no-guest-flush': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-guest-flush',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_GUEST_FLUSH'},
                                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'snapshot.1',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--region',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'REGION'},
                                                                                                                     u'--snapshot-names': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"Names to assign to the snapshots. Without this option, the\nname of each snapshot will be a random, 16-character\nhexadecimal number that starts with a letter. The values of\nthis option run parallel to the disks specified. For example,\n+\n  $ {command} my-disk-1 my-disk-2 my-disk-3 --snapshot-names snapshot-1,snapshot-2,snapshot-3\n+\nwill result in ``my-disk-1'' being snapshotted as\n``snapshot-1'', ``my-disk-2'' as ``snapshot-2'', and so on.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--snapshot-names',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'SNAPSHOT_NAME'},
                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                 u'group': u'snapshot.1',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--zone',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {u'snapshot.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False}},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'snapshot',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'disks',
                                                                                                                    u'snapshot'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The names of the disks.',
                                                                                                                            u'name': u'DISK-NAME',
                                                                                                                            u'nargs': u'+',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'DISK_NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u"Create snapshots of Google Compute Engine persistent disks.\n\n*snapshot* creates snapshots of persistent disks. Snapshots are useful\nfor backing up data or copying a persistent disk. Once created,\nsnapshots may be managed (listed, deleted, etc.) via\n``gcloud compute snapshots''.\n"}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'disks',
                                                                              u'path': [u'gcloud',
                                                                                        u'alpha',
                                                                                        u'compute',
                                                                                        u'disks'],
                                                                              u'positionals': [],
                                                                              u'release': u'ALPHA',
                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine disks.'}},
                                                                   u'firewall-rules': {u'capsule': u'*(ALPHA)* List, create, update, and delete Google Compute Engine firewall rules.',
                                                                                       u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a Google Compute Engine firewall rule.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--action': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [u'ALLOW',
                                                                                                                                                       u'DENY'],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The action for the firewall rule: whether to allow or deny matching\ntraffic. If specified, the flag `--rules` must also be specified. _ACTION_ must be one of: *ALLOW*, *DENY*.',
                                                                                                                                          u'group': u'create.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--action',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'ACTION'},
                                                                                                                            u'--allow': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A list of protocols and ports whose traffic will be allowed.\n+\nPROTOCOL is the IP protocol whose traffic will be allowed.\nPROTOCOL can be either the name of a well-known protocol\n(e.g., tcp or icmp) or the IP protocol number.\nA list of IP protocols can be found at\nlink:http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml[].\n+\nA port or port range can be specified after PROTOCOL to\nallow traffic through specific ports. If no port or port range\nis specified, connections through all ranges are allowed. For\nexample, the following will create a rule that allows TCP traffic\nthrough port 80 and allows ICMP traffic:\n+\n  $ {command} MY-RULE --allow tcp:80,icmp\n+\nTCP and UDP rules must include a port or port range.',
                                                                                                                                         u'group': u'create.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--allow',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'PROTOCOL[:PORT[-PORT]]'},
                                                                                                                            u'--description': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'A textual description for the firewall rule.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--description',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'DESCRIPTION'},
                                                                                                                            u'--destination-ranges': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': [],
                                                                                                                                                      u'description': u'The firewall rule will apply to traffic that has destination IP address\nin these IP address block list. The IP address blocks must be specified\nin CIDR format:\nlink:http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing[].\n+\nIf --destination-ranges is NOT provided, then this\nflag will default to 0.0.0.0/0, allowing all destinations. Multiple IP\naddress blocks can be specified if they are separated by commas.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--destination-ranges',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'list',
                                                                                                                                                      u'value': u'CIDR_RANGE'},
                                                                                                                            u'--direction': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [u'INGRESS',
                                                                                                                                                          u'EGRESS',
                                                                                                                                                          u'IN',
                                                                                                                                                          u'OUT'],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'If direction is NOT specified, then default is to apply on incoming\ntraffic. For incoming traffic, it is NOT supported to specify\ndestination-ranges; For outbound traffic, it is NOT supported to specify\nsource-ranges or source-tags. _DIRECTION_ must be one of: *INGRESS*, *EGRESS*, *IN*, *OUT*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--direction',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DIRECTION'},
                                                                                                                            u'--network': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': u'default',
                                                                                                                                           u'description': u"The network to which this rule is attached. If omitted, the\nrule is attached to the ``default'' network.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--network',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'NETWORK'},
                                                                                                                            u'--priority': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'This is an integer between 0 and 65535, both inclusive. When NOT\nspecified, the value assumed is 1000. Relative priority determines\nprecedence of conflicting rules: lower priority values imply higher\nprecedence. DENY rules take precedence over ALLOW rules having equal\npriority.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--priority',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PRIORITY'},
                                                                                                                            u'--rules': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A list of protocols and ports to which the firewall rule will apply.\n+\nPROTOCOL is the IP protocol whose traffic will be checked.\nPROTOCOL can be either the name of a well-known protocol\n(e.g., tcp or icmp) or the IP protocol number.\nA list of IP protocols can be found at\nlink:http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml[].\n+\nA port or port range can be specified after PROTOCOL to which the\nfirewall rule apply on traffic through specific ports. If no port\nor port range is specified, connections through all ranges are applied.\nFor example, the following will create a rule that denys TCP\ntraffic through port 80 and ICMP traffic:\n+\n  $ {command} MY-RULE --action deny --rules tcp:80,icmp\n+\nTCP and UDP rules must include a port or port range.\n+\nIf specified, the flag --action must also be specified.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--rules',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'PROTOCOL[:PORT[-PORT]]'},
                                                                                                                            u'--source-ranges': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': [],
                                                                                                                                                 u'description': u'A list of IP address blocks that are allowed to make inbound\nconnections that match the firewall rule to the instances on\nthe network. The IP address blocks must be specified in CIDR\nformat:\nlink:http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing[].\n+\nIf neither --source-ranges nor --source-tags is provided, then this\nflag will default to 0.0.0.0/0, allowing all sources. Multiple IP\naddress blocks can be specified if they are separated by commas.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--source-ranges',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'list',
                                                                                                                                                 u'value': u'CIDR_RANGE'},
                                                                                                                            u'--source-tags': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': [],
                                                                                                                                               u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may make network connections that match the\nfirewall rule. If omitted, all instances on the network can\nmake connections that match the rule.\n+\nTags can be assigned to instances during instance creation.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--source-tags',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'TAG'},
                                                                                                                            u'--target-tags': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': [],
                                                                                                                                               u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may accept inbound connections that match the\nfirewall rule. If omitted, all instances on the network can\nreceive inbound connections that match the rule.\n+\nTags can be assigned to instances during instance creation.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--target-tags',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'TAG'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {u'create.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                           u'is_mutex': True,
                                                                                                                                           u'is_required': True}},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'create',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'firewall-rules',
                                                                                                                           u'create'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the firewall rule to create.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* *create* is used to create firewall rules to allow/deny\nincoming/outgoing traffic.'}},
                                                                                                     u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine firewall rules.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'delete',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'firewall-rules',
                                                                                                                           u'delete'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The resources to delete.',
                                                                                                                                   u'name': u'names',
                                                                                                                                   u'nargs': u'+',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine firewall\n rules.\n'}},
                                                                                                     u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine firewall rule.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'describe',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'firewall-rules',
                                                                                                                             u'describe'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the resource to fetch.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* *describe* displays all data associated with a Google Compute\nEngine firewall rule in a project.'}},
                                                                                                     u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine firewall rules.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--filter',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'EXPRESSION'},
                                                                                                                          u'--limit': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--limit',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'LIMIT'},
                                                                                                                          u'--no-uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_URI'},
                                                                                                                          u'--page-size': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--page-size',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                                                          u'--regexp': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--regexp',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REGEXP'},
                                                                                                                          u'--sort-by': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--sort-by',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'FIELD'},
                                                                                                                          u'--uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'URI'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'list',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'compute',
                                                                                                                         u'firewall-rules',
                                                                                                                         u'list'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': [],
                                                                                                                                 u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                 u'name': u'names',
                                                                                                                                 u'nargs': u'*',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine firewall rules in a project.\n',
                                                                                                                             u'EXAMPLES': u'To list all firewall rules in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all firewall rules in a project, run:\n\n  $ list --uri\n'}},
                                                                                                     u'update': {u'capsule': u'*(ALPHA)* Update a firewall rule.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--allow': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A list of protocols and ports whose traffic will be allowed.\n+\nPROTOCOL is the IP protocol whose traffic will be allowed.\nPROTOCOL can be either the name of a well-known protocol\n(e.g., tcp or icmp) or the IP protocol number.\nA list of IP protocols can be found at\nlink:http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml[].\n+\nA port or port range can be specified after PROTOCOL to\nallow traffic through specific ports. If no port or port range\nis specified, connections through all ranges are allowed. For\nexample, the following will create a rule that allows TCP traffic\nthrough port 80 and allows ICMP traffic:\n+\n  $ {command} MY-RULE --allow tcp:80,icmp\n+\nTCP and UDP rules must include a port or port range.\n+\nSetting this will override the current values.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--allow',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'PROTOCOL[:PORT[-PORT]]'},
                                                                                                                            u'--description': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'A textual description for the firewall rule. Set to an empty string to clear existing.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--description',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'DESCRIPTION'},
                                                                                                                            u'--destination-ranges': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The firewall rule will apply to traffic that has destination IP address\nin these IP address block list. The IP address blocks must be specified\nin CIDR format:\nlink:http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing[].\n+\nSetting this will override the existing destination ranges for the\nfirewall. The following will clear the existing destination ranges:\n+\n  $ {command} MY-RULE --destination-ranges',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--destination-ranges',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'list',
                                                                                                                                                      u'value': u'CIDR_RANGE'},
                                                                                                                            u'--priority': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'This is an integer between 0 and 65535, both inclusive. When NOT\nspecified, the value assumed is 1000. Relative priority determines\nprecedence of conflicting rules: lower priority values imply higher\nprecedence. DENY rules take precedence over ALLOW rules having equal\npriority.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--priority',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PRIORITY'},
                                                                                                                            u'--rules': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A list of protocols and ports to which the firewall rule will apply.\n+\nPROTOCOL is the IP protocol whose traffic will be checked.\nPROTOCOL can be either the name of a well-known protocol\n(e.g., tcp or icmp) or the IP protocol number.\nA list of IP protocols can be found at\nlink:http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml[].\n+\nA port or port range can be specified after PROTOCOL to which the\nfirewall rule apply on traffic through specific ports. If no port\nor port range is specified, connections through all ranges are applied.\nFor example, the following will create a rule that denys TCP\ntraffic through port 80 and ICMP traffic:\n+\n  $ {command} MY-RULE --action deny --rules tcp:80,icmp\n+\nTCP and UDP rules must include a port or port range.\n+\nSetting this will override the current values.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--rules',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'PROTOCOL[:PORT[-PORT]]'},
                                                                                                                            u'--source-ranges': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'A list of IP address blocks that are allowed to make inbound\nconnections that match the firewall rule to the instances on\nthe network. The IP address blocks must be specified in CIDR\nformat:\nlink:http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing[].\n+\nSetting this will override the existing source ranges for the firewall.\nThe following will clear the existing source ranges:\n+\n  $ {command} MY-RULE --source-ranges',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--source-ranges',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'list',
                                                                                                                                                 u'value': u'CIDR_RANGE'},
                                                                                                                            u'--source-tags': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may make network connections that match the\nfirewall rule. If omitted, all instances on the network can\nmake connections that match the rule.\n+\nTags can be assigned to instances during instance creation.\n+\nSetting this will override the existing source tags for the firewall.\nThe following will clear the existing source tags:\n+\n  $ {command} MY-RULE --source-tags',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--source-tags',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'TAG'},
                                                                                                                            u'--target-tags': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may accept inbound connections that match the\nfirewall rule. If omitted, all instances on the network can\nreceive inbound connections that match the rule.\n+\nTags can be assigned to instances during instance creation.\n+\nSetting this will override the existing target tags for the firewall.\nThe following will clear the existing target tags:\n+\n  $ {command} MY-RULE --target-tags',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--target-tags',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'TAG'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'update',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'firewall-rules',
                                                                                                                           u'update'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the firewall rule to update.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*update* is used to update firewall rules that allow/deny\nincoming/outgoing traffic. Only arguments passed in will be updated on\nthe firewall rule.  Other attributes will remain unaffected.\n'}}},
                                                                                       u'flags': {},
                                                                                       u'group': True,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'firewall-rules',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'alpha',
                                                                                                 u'compute',
                                                                                                 u'firewall-rules'],
                                                                                       u'positionals': [],
                                                                                       u'release': u'ALPHA',
                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, update, and delete Google Compute Engine firewall rules.'}},
                                                                   u'forwarding-rules': {u'capsule': u'*(ALPHA)* Read and manipulate forwarding rules to send traffic to load balancers.',
                                                                                         u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a forwarding rule to direct network traffic to a load balancer.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--address': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The external IP address that the forwarding rule will\nserve. All traffic sent to this IP address is directed to the\ntarget pointed to by the forwarding rule. If the address is\nreserved, it must either (1) reside in the global scope if the\nforwarding rule is being configured to point to a target HTTP\nproxy or (2) reside in the same region as the forwarding rule\nif the forwarding rule is being configured to point to a\ntarget pool or target instance. If this flag is omitted, an\nephemeral IP address is assigned.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--address',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ADDRESS'},
                                                                                                                              u'--address-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The region of the address to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                    u'group': u'create.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--address-region',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'ADDRESS_REGION'},
                                                                                                                              u'--backend-service': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The target backend service that will receive the traffic.',
                                                                                                                                                     u'group': u'create.2',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--backend-service',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'BACKEND_SERVICE'},
                                                                                                                              u'--backend-service-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The region of the backend service to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                            u'group': u'create.3',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--backend-service-region',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'BACKEND_SERVICE_REGION'},
                                                                                                                              u'--description': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'An optional textual description for the forwarding rule.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--description',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'DESCRIPTION'},
                                                                                                                              u'--global': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'If provided, it is assumed the forwarding rule is global.',
                                                                                                                                            u'group': u'create.4',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--global',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'GLOBAL'},
                                                                                                                              u'--global-address': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'If provided, it is assumed the address is global.',
                                                                                                                                                    u'group': u'create.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--global-address',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'GLOBAL_ADDRESS'},
                                                                                                                              u'--global-backend-service': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': False,
                                                                                                                                                            u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                            u'group': u'create.3',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--global-backend-service',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'GLOBAL_BACKEND_SERVICE'},
                                                                                                                              u'--ip-protocol': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [u'AH',
                                                                                                                                                              u'ESP',
                                                                                                                                                              u'ICMP',
                                                                                                                                                              u'SCTP',
                                                                                                                                                              u'TCP',
                                                                                                                                                              u'UDP'],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The IP protocol that the rule will serve. The default is TCP. _IP_PROTOCOL_ must be one of: *AH*, *ESP*, *ICMP*, *SCTP*, *TCP*, *UDP*.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--ip-protocol',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'IP_PROTOCOL'},
                                                                                                                              u'--load-balancing-scheme': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [u'EXTERNAL',
                                                                                                                                                                        u'INTERNAL'],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': u'EXTERNAL',
                                                                                                                                                           u'description': u'This signifies what the forwarding rule will be used for. _LOAD_BALANCING_SCHEME_ must be one of:\n+\n*EXTERNAL*::: Used for HTTP or HTTPS for External Load Balancing.\n*INTERNAL*::: Used for Internal Network Load Balancing.\n+',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--load-balancing-scheme',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'LOAD_BALANCING_SCHEME'},
                                                                                                                              u'--network': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'(Only for Internal Load Balancing) The network that this forwarding\nrule applies to. If this field is not specified, the default network\nwill be used. In the absence of the default network, this field must\nbe specified.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--network',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'NETWORK'},
                                                                                                                              u'--network-tier': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [u'PREMIUM',
                                                                                                                                                               u'SELECT'],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The network tier to assign to the forwarding rules. If left empty, `PREMIUM` is used. Supported network tiers are: `PREMIUM`, `SELECT`. _NETWORK_TIER_ must be one of: *PREMIUM*, *SELECT*.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--network-tier',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'NETWORK_TIER'},
                                                                                                                              u'--port-range': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'DEPRECATED, use --ports. If specified, only packets addressed to ports in\nthe specified range will be forwarded. If not specified for regional\nforwarding rules, all ports are matched. This flag is required for global\nforwarding rules.\n+\nEither an individual port (`--port-range 80`) or a range of ports\n(`--port-range 3000-3100`) may be specified.',
                                                                                                                                                u'group': u'create.5',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--port-range',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'[PORT | PORT-PORT]'},
                                                                                                                              u'--ports': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': [],
                                                                                                                                           u'description': u'If specified, only packets addressed to ports in the specified\nlist will be forwarded. If not specified for regional forwarding\nrules, all ports are matched. This flag is required for global\nforwarding rules and accepts a single continuous set of ports.\n+\nIndividual ports and ranges can be specified,\nfor example (`--ports 8000-8004` or `--ports 80`).',
                                                                                                                                           u'group': u'create.5',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--ports',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'[PORT | PORT-PORT]'},
                                                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The region of the forwarding rule to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                            u'group': u'create.4',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'},
                                                                                                                              u'--service-label': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'(Only for Internal Load Balancing): https://cloud.google.com/compute/docs/load-balancing/internal/\nThe DNS label to use as the prefix of the fully qualified domain name for this forwarding rule. The full name will be internally generated and output as dnsName. If this field is not specified, no DNS record will be generated and no DNS name will be output.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--service-label',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'SERVICE_LABEL'},
                                                                                                                              u'--subnet': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'(Only for Internal Load Balancing) The subnetwork that this forwarding\nrule applies to. If the network configured for this forwarding rule is\nin auto subnet mode, the subnetwork is optional. However, if the\nnetwork is in custom subnet mode, a subnetwork must be specified.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--subnet',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'SUBNET'},
                                                                                                                              u'--subnet-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The region of the subnetwork to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--subnet-region',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'SUBNET_REGION'},
                                                                                                                              u'--target-http-proxy': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The target HTTP proxy that will receive the traffic.',
                                                                                                                                                       u'group': u'create.2',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--target-http-proxy',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'TARGET_HTTP_PROXY'},
                                                                                                                              u'--target-https-proxy': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The target HTTPS proxy that will receive the traffic.',
                                                                                                                                                        u'group': u'create.2',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--target-https-proxy',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'TARGET_HTTPS_PROXY'},
                                                                                                                              u'--target-instance': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"The name of the target instance that will receive the traffic. The\ntarget instance must be in a zone that's in the forwarding rule's\nregion. Global forwarding rules may not direct traffic to target\ninstances.\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                     u'group': u'create.2',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--target-instance',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'TARGET_INSTANCE'},
                                                                                                                              u'--target-instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The zone of the target instance to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--target-instance-zone',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'TARGET_INSTANCE_ZONE'},
                                                                                                                              u'--target-pool': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The target pool that will receive the traffic. The target pool\nmust be in the same region as the forwarding rule. Global\nforwarding rules may not direct traffic to target pools.',
                                                                                                                                                 u'group': u'create.2',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--target-pool',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'TARGET_POOL'},
                                                                                                                              u'--target-pool-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--target-pool-region',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'TARGET_POOL_REGION'},
                                                                                                                              u'--target-ssl-proxy': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The target SSL proxy that will receive the traffic.',
                                                                                                                                                      u'group': u'create.2',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--target-ssl-proxy',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'TARGET_SSL_PROXY'},
                                                                                                                              u'--target-tcp-proxy': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The target TCP proxy that will receive the traffic.',
                                                                                                                                                      u'group': u'create.2',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--target-tcp-proxy',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'TARGET_TCP_PROXY'},
                                                                                                                              u'--target-vpn-gateway': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The target VPN gateway that will receive forwarded traffic.',
                                                                                                                                                        u'group': u'create.2',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--target-vpn-gateway',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'TARGET_VPN_GATEWAY'},
                                                                                                                              u'--target-vpn-gateway-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The region of the VPN gateway to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--target-vpn-gateway-region',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'TARGET_VPN_GATEWAY_REGION'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False},
                                                                                                                               u'create.2': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': True},
                                                                                                                               u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False},
                                                                                                                               u'create.4': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False},
                                                                                                                               u'create.5': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False}},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'create',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'forwarding-rules',
                                                                                                                             u'create'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the forwarding rule.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u"*create* is used to create a forwarding rule.         Forwarding rules match and direct certain types of traffic to a load\nbalancer which is controlled by a target pool, a target instance,\nor a target HTTP proxy. Target pools and target instances perform load\nbalancing at the layer 3 of the OSI networking model\n(http://en.wikipedia.org/wiki/Network_layer). Target\nHTTP proxies perform load balancing at layer 7.\n\nForwarding rules can be either regional or global. They are\nregional if they point to a target pool or a target instance\nand global if they point to a target HTTP proxy.\n\nFor more information on load balancing, see\nhttps://cloud.google.com/compute/docs/load-balancing-and-autoscaling/.\n\n\nWhen creating a forwarding rule, exactly one of  ``--target-instance'',\n``--target-pool'', ``--target-http-proxy'', ``--target-https-proxy'',\n``--target-ssl-proxy'', ``--target-tcp-proxy'', or\n``--target-vpn-gateway'' must be specified."}},
                                                                                                       u'delete': {u'capsule': u'*(ALPHA)* Delete forwarding rules.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--global': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'If provided, it is assumed the forwarding rule is global.',
                                                                                                                                            u'group': u'delete.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--global',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'GLOBAL'},
                                                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The region of the forwarding rule to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                            u'group': u'delete.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False}},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'delete',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'forwarding-rules',
                                                                                                                             u'delete'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The names of the forwarding rules.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'+',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* *delete* deletes one or more Google Compute Engine forwarding rules.'}},
                                                                                                       u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about a forwarding rule.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--global': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'If provided, it is assumed that the requested resource is global.',
                                                                                                                                              u'group': u'describe.1',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--global',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'GLOBAL'},
                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                              u'group': u'describe.1',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--region',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'REGION'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                 u'is_mutex': True,
                                                                                                                                                 u'is_required': False}},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'describe',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'forwarding-rules',
                                                                                                                               u'describe'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the resource to fetch.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a forwarding rule\nin a project.\n',
                                                                                                                                   u'EXAMPLES': u'To get details about a global forwarding rule, run:\n\n  $ describe FORWARDING-RULE --global\n\nTo get details about a regional forwarding rule, run:\n\n  $ describe FORWARDING-RULE --region us-central1\n'}},
                                                                                                       u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine forwarding rules.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--filter',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                                            u'--global': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'If provided, only global resources are shown.',
                                                                                                                                          u'group': u'list.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--global',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'GLOBAL'},
                                                                                                                            u'--limit': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--limit',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'LIMIT'},
                                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_URI'},
                                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--page-size',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                                            u'--regexp': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--regexp',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'REGEXP'},
                                                                                                                            u'--regions': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                           u'group': u'list.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--regions',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'REGION'},
                                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--sort-by',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'FIELD'},
                                                                                                                            u'--uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'URI'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                         u'is_mutex': True,
                                                                                                                                         u'is_required': False}},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'list',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'forwarding-rules',
                                                                                                                           u'list'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': [],
                                                                                                                                   u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                   u'name': u'names',
                                                                                                                                   u'nargs': u'*',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine forwarding rules in a project.\n\nBy default, global forwarding rules and forwarding rules from all regions are listed. The results can be narrowed down by\nproviding the ``--global'' or ``--regions'' flag.\n",
                                                                                                                               u'EXAMPLES': u"To list all forwarding rules in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all forwarding rules in a project, run:\n\n  $ list --uri\n\nTo list all global forwarding rules in a project, run:\n\n  $ list --global\n\nTo list all forwarding rules in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n"}},
                                                                                                       u'set-target': {u'capsule': u'*(ALPHA)* Modify a forwarding rule to direct network traffic to a new target.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The target backend service that will receive the traffic.',
                                                                                                                                                         u'group': u'set-target.1',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--backend-service',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'BACKEND_SERVICE'},
                                                                                                                                  u'--backend-service-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The region of the backend service to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                u'group': u'set-target.2',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--backend-service-region',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'BACKEND_SERVICE_REGION'},
                                                                                                                                  u'--global': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'If provided, it is assumed the forwarding rule is global.',
                                                                                                                                                u'group': u'set-target.3',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--global',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'GLOBAL'},
                                                                                                                                  u'--global-backend-service': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': False,
                                                                                                                                                                u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                                u'group': u'set-target.2',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--global-backend-service',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                u'value': u'GLOBAL_BACKEND_SERVICE'},
                                                                                                                                  u'--load-balancing-scheme': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [u'EXTERNAL',
                                                                                                                                                                            u'INTERNAL'],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': u'EXTERNAL',
                                                                                                                                                               u'description': u'This signifies what the forwarding rule will be used for. _LOAD_BALANCING_SCHEME_ must be one of:\n+\n*EXTERNAL*::: Used for HTTP or HTTPS for External Load Balancing.\n*INTERNAL*::: Used for Internal Network Load Balancing.\n+',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--load-balancing-scheme',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'LOAD_BALANCING_SCHEME'},
                                                                                                                                  u'--network': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'(Only for Internal Load Balancing) The network that this forwarding\nrule applies to. If this field is not specified, the default network\nwill be used. In the absence of the default network, this field must\nbe specified.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--network',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'NETWORK'},
                                                                                                                                  u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"The region of the forwarding rule to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                u'group': u'set-target.3',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--region',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'REGION'},
                                                                                                                                  u'--subnet': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'(Only for Internal Load Balancing) The subnetwork that this forwarding\nrule applies to. If the network configured for this forwarding rule is\nin auto subnet mode, the subnetwork is optional. However, if the\nnetwork is in custom subnet mode, a subnetwork must be specified.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--subnet',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'SUBNET'},
                                                                                                                                  u'--subnet-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The region of the subnetwork to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--subnet-region',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'SUBNET_REGION'},
                                                                                                                                  u'--target-http-proxy': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The target HTTP proxy that will receive the traffic.',
                                                                                                                                                           u'group': u'set-target.1',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--target-http-proxy',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'TARGET_HTTP_PROXY'},
                                                                                                                                  u'--target-https-proxy': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The target HTTPS proxy that will receive the traffic.',
                                                                                                                                                            u'group': u'set-target.1',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--target-https-proxy',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'TARGET_HTTPS_PROXY'},
                                                                                                                                  u'--target-instance': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u"The name of the target instance that will receive the traffic. The\ntarget instance must be in a zone that's in the forwarding rule's\nregion. Global forwarding rules may not direct traffic to target\ninstances.\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                         u'group': u'set-target.1',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--target-instance',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'TARGET_INSTANCE'},
                                                                                                                                  u'--target-instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The zone of the target instance to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--target-instance-zone',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'TARGET_INSTANCE_ZONE'},
                                                                                                                                  u'--target-pool': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The target pool that will receive the traffic. The target pool\nmust be in the same region as the forwarding rule. Global\nforwarding rules may not direct traffic to target pools.',
                                                                                                                                                     u'group': u'set-target.1',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--target-pool',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'TARGET_POOL'},
                                                                                                                                  u'--target-pool-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--target-pool-region',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'TARGET_POOL_REGION'},
                                                                                                                                  u'--target-ssl-proxy': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The target SSL proxy that will receive the traffic.',
                                                                                                                                                          u'group': u'set-target.1',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--target-ssl-proxy',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'TARGET_SSL_PROXY'},
                                                                                                                                  u'--target-tcp-proxy': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The target TCP proxy that will receive the traffic.',
                                                                                                                                                          u'group': u'set-target.1',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--target-tcp-proxy',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'TARGET_TCP_PROXY'},
                                                                                                                                  u'--target-vpn-gateway': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The target VPN gateway that will receive forwarded traffic.',
                                                                                                                                                            u'group': u'set-target.1',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--target-vpn-gateway',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'TARGET_VPN_GATEWAY'},
                                                                                                                                  u'--target-vpn-gateway-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The region of the VPN gateway to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--target-vpn-gateway-region',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'TARGET_VPN_GATEWAY_REGION'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {u'set-target.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                     u'is_mutex': True,
                                                                                                                                                     u'is_required': True},
                                                                                                                                   u'set-target.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                     u'is_mutex': True,
                                                                                                                                                     u'is_required': False},
                                                                                                                                   u'set-target.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                                     u'is_mutex': True,
                                                                                                                                                     u'is_required': False}},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'set-target',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'forwarding-rules',
                                                                                                                                 u'set-target'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the forwarding rule.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u"*set-target* is used to set a new target for a forwarding\nrule.         Forwarding rules match and direct certain types of traffic to a load\nbalancer which is controlled by a target pool, a target instance,\nor a target HTTP proxy. Target pools and target instances perform load\nbalancing at the layer 3 of the OSI networking model\n(http://en.wikipedia.org/wiki/Network_layer). Target\nHTTP proxies perform load balancing at layer 7.\n\nForwarding rules can be either regional or global. They are\nregional if they point to a target pool or a target instance\nand global if they point to a target HTTP proxy.\n\nFor more information on load balancing, see\nhttps://cloud.google.com/compute/docs/load-balancing-and-autoscaling/.\n\n\nWhen creating a forwarding rule, exactly one of  ``--target-instance'',\n``--target-pool'', ``--target-http-proxy'', ``--target-https-proxy'',\n``--target-ssl-proxy'', ``--target-tcp-proxy'' or\n``--target-vpn-gateway'' must be specified."}}},
                                                                                         u'flags': {},
                                                                                         u'group': True,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'forwarding-rules',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'alpha',
                                                                                                   u'compute',
                                                                                                   u'forwarding-rules'],
                                                                                         u'positionals': [],
                                                                                         u'release': u'ALPHA',
                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate forwarding rules to send traffic to load balancers.'}},
                                                                   u'groups': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine groups.',
                                                                               u'commands': {u'add-members': {u'capsule': u'*(ALPHA)* Add a user to a Google Compute Engine group.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--members': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The names or fully-qualified URLs of the users to add.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--members',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': True,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'USERNAME'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'add-members',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'compute',
                                                                                                                        u'groups',
                                                                                                                        u'add-members'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The names of the groups to add members to.',
                                                                                                                                u'name': u'names',
                                                                                                                                u'nargs': u'+',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* *add-members* adds a users to a Google Compute Engine group.',
                                                                                                                            u'EXAMPLES': u'To add a user to a group, run:\n\n  $ add-members example-group --members example-user\n\nTo add multiple users to multiple groups, run:\n\n  $ add-members example-group-1 example-group-2 --members example-user-1,example-user-2\n'}},
                                                                                             u'create': {u'capsule': u'*(ALPHA)* Create Google Compute Engine groups.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--description': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'An optional, textual description for the group being created.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--description',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DESCRIPTION'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'create',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'compute',
                                                                                                                   u'groups',
                                                                                                                   u'create'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the group to create.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'+',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*create* creates Google Compute Engine groups.\n',
                                                                                                                       u'EXAMPLES': u'To create a group, run:\n\n  $ create example-group\n'}},
                                                                                             u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine groups.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'delete',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'compute',
                                                                                                                   u'groups',
                                                                                                                   u'delete'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The names of the groups to delete.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'+',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine groups.\n',
                                                                                                                       u'EXAMPLES': u'To delete a group, run:\n\n  $ delete example-group\n\nTo delete multiple groups, run:\n\n  $ delete example-group-1 example-group-2\n'}},
                                                                                             u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine group.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'describe',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'groups',
                                                                                                                     u'describe'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the group to describe.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* *describe* displays all data associated with a Google Compute\nEngine group in a project.',
                                                                                                                         u'EXAMPLES': u'To describe a user, run:\n\n  $ describe example-user\n'}},
                                                                                             u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine groups.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_URI'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--regexp': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--regexp',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'REGEXP'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'},
                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'URI'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'list',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'compute',
                                                                                                                 u'groups',
                                                                                                                 u'list'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': [],
                                                                                                                         u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                         u'name': u'names',
                                                                                                                         u'nargs': u'*',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'NAME'}],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine groups in a project.\n',
                                                                                                                     u'EXAMPLES': u'To list all groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all groups in a project, run:\n\n  $ list --uri\n'}},
                                                                                             u'remove-members': {u'capsule': u'*(ALPHA)* Remove a user from a Google Compute Engine group.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--members': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The names or fully-qualified URLs of the users to remove.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--members',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'USERNAME'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'remove-members',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'groups',
                                                                                                                           u'remove-members'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The names of the groups to remove members from.',
                                                                                                                                   u'name': u'names',
                                                                                                                                   u'nargs': u'+',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* *remove-members* removes a user from a Google Compute Engine group.',
                                                                                                                               u'EXAMPLES': u'To remove a user from a group, run:\n\n  $ remove-members example-group --members example-user\n\nTo remove multiple users from multiple groups with\none command, run\n\n  $ remove-members example-group-1 example-group-2 --members example-user-1,example-user-2\n'}}},
                                                                               u'flags': {},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'groups',
                                                                               u'path': [u'gcloud',
                                                                                         u'alpha',
                                                                                         u'compute',
                                                                                         u'groups'],
                                                                               u'positionals': [],
                                                                               u'release': u'ALPHA',
                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine groups.'}},
                                                                   u'health-checks': {u'capsule': u'*(ALPHA)* Read and manipulate health checks for load balanced instances.',
                                                                                      u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create health checks for load balanced instances.',
                                                                                                                u'commands': {u'http': {u'capsule': u'*(ALPHA)* Create a HTTP health check to monitor load balanced instances.',
                                                                                                                                        u'commands': {},
                                                                                                                                        u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': u'5s',
                                                                                                                                                                         u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--check-interval',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'CHECK_INTERVAL'},
                                                                                                                                                   u'--description': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'An optional, textual description for the HTTP health check.',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--description',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                                                   u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': 2,
                                                                                                                                                                            u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--healthy-threshold',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'int',
                                                                                                                                                                            u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                   u'--host': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--host',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'HOST'},
                                                                                                                                                   u'--port': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': 80,
                                                                                                                                                               u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--port',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'int',
                                                                                                                                                               u'value': u'PORT'},
                                                                                                                                                   u'--port-name': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--port-name',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'PORT_NAME'},
                                                                                                                                                   u'--proxy-header': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [u'NONE',
                                                                                                                                                                                    u'PROXY_V1'],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': u'NONE',
                                                                                                                                                                       u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--proxy-header',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'PROXY_HEADER'},
                                                                                                                                                   u'--request-path': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': u'/',
                                                                                                                                                                       u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--request-path',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'REQUEST_PATH'},
                                                                                                                                                   u'--response': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'When empty, status code of the response determines health. When not empty,\npresence of specified string in first 1024 characters of response body\ndetermines health. Only ASCII characters allowed.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--response',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'RESPONSE'},
                                                                                                                                                   u'--timeout': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': u'5s',
                                                                                                                                                                  u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--timeout',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'TIMEOUT'},
                                                                                                                                                   u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': 2,
                                                                                                                                                                              u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--unhealthy-threshold',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'int',
                                                                                                                                                                              u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                        u'group': False,
                                                                                                                                        u'groups': {},
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'http',
                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                  u'alpha',
                                                                                                                                                  u'compute',
                                                                                                                                                  u'health-checks',
                                                                                                                                                  u'create',
                                                                                                                                                  u'http'],
                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The name of the HTTP health check.',
                                                                                                                                                          u'name': u'name',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                        u'release': u'ALPHA',
                                                                                                                                        u'sections': {u'DESCRIPTION': u'*http* is used to create a HTTP health check. HTTP health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                                              u'http2': {u'capsule': u'*(ALPHA)* Create a HTTP2 health check to monitor load balanced instances.',
                                                                                                                                         u'commands': {},
                                                                                                                                         u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': u'5s',
                                                                                                                                                                          u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--check-interval',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'CHECK_INTERVAL'},
                                                                                                                                                    u'--description': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'An optional, textual description for the HTTP2 health check.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--description',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                                                    u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': 2,
                                                                                                                                                                             u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--healthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'int',
                                                                                                                                                                             u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                    u'--host': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--host',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'HOST'},
                                                                                                                                                    u'--port': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': 80,
                                                                                                                                                                u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--port',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'int',
                                                                                                                                                                u'value': u'PORT'},
                                                                                                                                                    u'--port-name': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--port-name',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'PORT_NAME'},
                                                                                                                                                    u'--proxy-header': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [u'NONE',
                                                                                                                                                                                     u'PROXY_V1'],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': u'NONE',
                                                                                                                                                                        u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--proxy-header',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'PROXY_HEADER'},
                                                                                                                                                    u'--request-path': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': u'/',
                                                                                                                                                                        u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--request-path',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'REQUEST_PATH'},
                                                                                                                                                    u'--response': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'When empty, status code of the response determines health. When not empty,\npresence of specified string in first 1024 characters of response body\ndetermines health. Only ASCII characters allowed.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--response',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'RESPONSE'},
                                                                                                                                                    u'--timeout': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': u'5s',
                                                                                                                                                                   u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--timeout',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'TIMEOUT'},
                                                                                                                                                    u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': 2,
                                                                                                                                                                               u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--unhealthy-threshold',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'int',
                                                                                                                                                                               u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                         u'group': False,
                                                                                                                                         u'groups': {},
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'http2',
                                                                                                                                         u'path': [u'gcloud',
                                                                                                                                                   u'alpha',
                                                                                                                                                   u'compute',
                                                                                                                                                   u'health-checks',
                                                                                                                                                   u'create',
                                                                                                                                                   u'http2'],
                                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The name of the HTTP2 health check.',
                                                                                                                                                           u'name': u'name',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'value': u'NAME'}],
                                                                                                                                         u'release': u'ALPHA',
                                                                                                                                         u'sections': {u'DESCRIPTION': u'*http2* is used to create a HTTP2 health check. HTTP2 health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                                              u'https': {u'capsule': u'*(ALPHA)* Create a HTTPS health check to monitor load balanced instances.',
                                                                                                                                         u'commands': {},
                                                                                                                                         u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': u'5s',
                                                                                                                                                                          u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--check-interval',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'CHECK_INTERVAL'},
                                                                                                                                                    u'--description': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'An optional, textual description for the HTTPS health check.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--description',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                                                    u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': 2,
                                                                                                                                                                             u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--healthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'int',
                                                                                                                                                                             u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                    u'--host': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--host',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'HOST'},
                                                                                                                                                    u'--port': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': 80,
                                                                                                                                                                u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--port',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'int',
                                                                                                                                                                u'value': u'PORT'},
                                                                                                                                                    u'--port-name': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--port-name',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'PORT_NAME'},
                                                                                                                                                    u'--proxy-header': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [u'NONE',
                                                                                                                                                                                     u'PROXY_V1'],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': u'NONE',
                                                                                                                                                                        u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--proxy-header',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'PROXY_HEADER'},
                                                                                                                                                    u'--request-path': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': u'/',
                                                                                                                                                                        u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--request-path',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'REQUEST_PATH'},
                                                                                                                                                    u'--response': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'When empty, status code of the response determines health. When not empty,\npresence of specified string in first 1024 characters of response body\ndetermines health. Only ASCII characters allowed.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--response',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'RESPONSE'},
                                                                                                                                                    u'--timeout': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': u'5s',
                                                                                                                                                                   u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--timeout',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'TIMEOUT'},
                                                                                                                                                    u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': 2,
                                                                                                                                                                               u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--unhealthy-threshold',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'int',
                                                                                                                                                                               u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                         u'group': False,
                                                                                                                                         u'groups': {},
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'https',
                                                                                                                                         u'path': [u'gcloud',
                                                                                                                                                   u'alpha',
                                                                                                                                                   u'compute',
                                                                                                                                                   u'health-checks',
                                                                                                                                                   u'create',
                                                                                                                                                   u'https'],
                                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The name of the HTTPS health check.',
                                                                                                                                                           u'name': u'name',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'value': u'NAME'}],
                                                                                                                                         u'release': u'ALPHA',
                                                                                                                                         u'sections': {u'DESCRIPTION': u'*https* is used to create a HTTPS health check. HTTPS health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                                              u'ssl': {u'capsule': u'*(ALPHA)* Create a SSL health check to monitor load balanced instances.',
                                                                                                                                       u'commands': {},
                                                                                                                                       u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': u'5s',
                                                                                                                                                                        u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--check-interval',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'CHECK_INTERVAL'},
                                                                                                                                                  u'--description': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'An optional, textual description for the SSL health check.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--description',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                                                  u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': 2,
                                                                                                                                                                           u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--healthy-threshold',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'int',
                                                                                                                                                                           u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                  u'--port': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': 80,
                                                                                                                                                              u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--port',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'int',
                                                                                                                                                              u'value': u'PORT'},
                                                                                                                                                  u'--port-name': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--port-name',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'PORT_NAME'},
                                                                                                                                                  u'--proxy-header': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [u'NONE',
                                                                                                                                                                                   u'PROXY_V1'],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': u'NONE',
                                                                                                                                                                      u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--proxy-header',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'PROXY_HEADER'},
                                                                                                                                                  u'--request': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--request',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'REQUEST'},
                                                                                                                                                  u'--response': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--response',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'RESPONSE'},
                                                                                                                                                  u'--timeout': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': u'5s',
                                                                                                                                                                 u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--timeout',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'TIMEOUT'},
                                                                                                                                                  u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': 2,
                                                                                                                                                                             u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--unhealthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'int',
                                                                                                                                                                             u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                       u'group': False,
                                                                                                                                       u'groups': {},
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'ssl',
                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                 u'alpha',
                                                                                                                                                 u'compute',
                                                                                                                                                 u'health-checks',
                                                                                                                                                 u'create',
                                                                                                                                                 u'ssl'],
                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name of the SSL health check.',
                                                                                                                                                         u'name': u'name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                       u'sections': {u'DESCRIPTION': u'*ssl* is used to create a SSL health check. SSL health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                                              u'tcp': {u'capsule': u'*(ALPHA)* Create a TCP health check to monitor load balanced instances.',
                                                                                                                                       u'commands': {},
                                                                                                                                       u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': u'5s',
                                                                                                                                                                        u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--check-interval',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'CHECK_INTERVAL'},
                                                                                                                                                  u'--description': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'An optional, textual description for the TCP health check.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--description',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                                                  u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': 2,
                                                                                                                                                                           u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--healthy-threshold',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'int',
                                                                                                                                                                           u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                  u'--port': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': 80,
                                                                                                                                                              u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--port',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'int',
                                                                                                                                                              u'value': u'PORT'},
                                                                                                                                                  u'--port-name': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--port-name',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'PORT_NAME'},
                                                                                                                                                  u'--proxy-header': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [u'NONE',
                                                                                                                                                                                   u'PROXY_V1'],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': u'NONE',
                                                                                                                                                                      u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--proxy-header',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'PROXY_HEADER'},
                                                                                                                                                  u'--request': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--request',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'REQUEST'},
                                                                                                                                                  u'--response': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--response',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'RESPONSE'},
                                                                                                                                                  u'--timeout': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': u'5s',
                                                                                                                                                                 u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--timeout',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'TIMEOUT'},
                                                                                                                                                  u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': 2,
                                                                                                                                                                             u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--unhealthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'int',
                                                                                                                                                                             u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                       u'group': False,
                                                                                                                                       u'groups': {},
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'tcp',
                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                 u'alpha',
                                                                                                                                                 u'compute',
                                                                                                                                                 u'health-checks',
                                                                                                                                                 u'create',
                                                                                                                                                 u'tcp'],
                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name of the TCP health check.',
                                                                                                                                                         u'name': u'name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                       u'sections': {u'DESCRIPTION': u'*tcp* is used to create a TCP health check. TCP health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                                              u'udp': {u'capsule': u'*(ALPHA)* Create a UDP health check to monitor load balanced instances.',
                                                                                                                                       u'commands': {},
                                                                                                                                       u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': u'5s',
                                                                                                                                                                        u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--check-interval',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'CHECK_INTERVAL'},
                                                                                                                                                  u'--description': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'An optional, textual description for the UDP health check.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--description',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                                                  u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': 2,
                                                                                                                                                                           u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--healthy-threshold',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'int',
                                                                                                                                                                           u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                  u'--port': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The UDP port number that this health check monitors. The default is not\nset.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--port',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'PORT'},
                                                                                                                                                  u'--port-name': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--port-name',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'PORT_NAME'},
                                                                                                                                                  u'--request': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Application data to send in payload of an UDP packet. It is an error if\nthis is empty.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--request',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': True,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'REQUEST'},
                                                                                                                                                  u'--response': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The bytes to match against the beginning of the response data.\nIt is an error if this is empty.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--response',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': True,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'RESPONSE'},
                                                                                                                                                  u'--timeout': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': u'5s',
                                                                                                                                                                 u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--timeout',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'TIMEOUT'},
                                                                                                                                                  u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': 2,
                                                                                                                                                                             u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--unhealthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'int',
                                                                                                                                                                             u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                       u'group': False,
                                                                                                                                       u'groups': {},
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'udp',
                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                 u'alpha',
                                                                                                                                                 u'compute',
                                                                                                                                                 u'health-checks',
                                                                                                                                                 u'create',
                                                                                                                                                 u'udp'],
                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name of the UDP health check.',
                                                                                                                                                         u'name': u'name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                       u'sections': {u'DESCRIPTION': u'*udp* is used to create a UDP health check. UDP health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck, request and response. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}}},
                                                                                                                u'flags': {},
                                                                                                                u'group': True,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'create',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'health-checks',
                                                                                                                          u'create'],
                                                                                                                u'positionals': [],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Create health checks for load balanced instances.'}},
                                                                                                    u'delete': {u'capsule': u'*(ALPHA)* Delete health checks.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'delete',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'health-checks',
                                                                                                                          u'delete'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The resources to delete.',
                                                                                                                                  u'name': u'names',
                                                                                                                                  u'nargs': u'+',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nhealth checks.\n'}},
                                                                                                    u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about a health check.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'describe',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'compute',
                                                                                                                            u'health-checks',
                                                                                                                            u'describe'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the resource to fetch.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine health check in a project.\n'}},
                                                                                                    u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine health checks.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--filter',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'EXPRESSION'},
                                                                                                                         u'--limit': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--limit',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'LIMIT'},
                                                                                                                         u'--no-uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_URI'},
                                                                                                                         u'--page-size': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--page-size',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                                                         u'--protocol': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'If protocol is specified, only health checks for that protocol are\nlisted, and protocol-specific columns are added to the output. By\ndefault, health checks for all protocols are listed.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--protocol',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PROTOCOL'},
                                                                                                                         u'--regexp': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--regexp',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'REGEXP'},
                                                                                                                         u'--sort-by': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--sort-by',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'FIELD'},
                                                                                                                         u'--uri': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--uri',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'URI'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'list',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'compute',
                                                                                                                        u'health-checks',
                                                                                                                        u'list'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': [],
                                                                                                                                u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                u'name': u'names',
                                                                                                                                u'nargs': u'*',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine health checks in a project.\n',
                                                                                                                            u'EXAMPLES': u'To list all health checks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all health checks in a project, run:\n\n  $ list --uri\n'}},
                                                                                                    u'update': {u'capsule': u'*(ALPHA)* Update health checks for load balanced instances.',
                                                                                                                u'commands': {u'http': {u'capsule': u'*(ALPHA)* Update a HTTP health check.',
                                                                                                                                        u'commands': {},
                                                                                                                                        u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--check-interval',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'CHECK_INTERVAL'},
                                                                                                                                                   u'--description': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'A textual description for the HTTP health check. Pass in an empty string to unset.',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--description',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                                                   u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--healthy-threshold',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                   u'--host': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--host',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'HOST'},
                                                                                                                                                   u'--port': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--port',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'PORT'},
                                                                                                                                                   u'--port-name': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--port-name',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'PORT_NAME'},
                                                                                                                                                   u'--proxy-header': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [u'NONE',
                                                                                                                                                                                    u'PROXY_V1'],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--proxy-header',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'PROXY_HEADER'},
                                                                                                                                                   u'--request-path': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--request-path',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'REQUEST_PATH'},
                                                                                                                                                   u'--response': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'When empty, status code of the response determines health. When not empty,\npresence of specified string in first 1024 characters of response body\ndetermines health. Only ASCII characters allowed.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--response',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'RESPONSE'},
                                                                                                                                                   u'--timeout': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--timeout',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'TIMEOUT'},
                                                                                                                                                   u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--unhealthy-threshold',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                        u'group': False,
                                                                                                                                        u'groups': {},
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'http',
                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                  u'alpha',
                                                                                                                                                  u'compute',
                                                                                                                                                  u'health-checks',
                                                                                                                                                  u'update',
                                                                                                                                                  u'http'],
                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The name of the HTTP health check.',
                                                                                                                                                          u'name': u'name',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                        u'release': u'ALPHA',
                                                                                                                                        u'sections': {u'DESCRIPTION': u'*http* is used to update an existing HTTP health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                                              u'http2': {u'capsule': u'*(ALPHA)* Update a HTTP2 health check.',
                                                                                                                                         u'commands': {},
                                                                                                                                         u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--check-interval',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'CHECK_INTERVAL'},
                                                                                                                                                    u'--description': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'A textual description for the HTTP2 health check. Pass in an empty string to unset.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--description',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                                                    u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--healthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                    u'--host': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--host',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'HOST'},
                                                                                                                                                    u'--port': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--port',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'PORT'},
                                                                                                                                                    u'--port-name': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--port-name',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'PORT_NAME'},
                                                                                                                                                    u'--proxy-header': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [u'NONE',
                                                                                                                                                                                     u'PROXY_V1'],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--proxy-header',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'PROXY_HEADER'},
                                                                                                                                                    u'--request-path': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--request-path',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'REQUEST_PATH'},
                                                                                                                                                    u'--response': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'When empty, status code of the response determines health. When not empty,\npresence of specified string in first 1024 characters of response body\ndetermines health. Only ASCII characters allowed.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--response',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'RESPONSE'},
                                                                                                                                                    u'--timeout': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--timeout',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'TIMEOUT'},
                                                                                                                                                    u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--unhealthy-threshold',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                         u'group': False,
                                                                                                                                         u'groups': {},
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'http2',
                                                                                                                                         u'path': [u'gcloud',
                                                                                                                                                   u'alpha',
                                                                                                                                                   u'compute',
                                                                                                                                                   u'health-checks',
                                                                                                                                                   u'update',
                                                                                                                                                   u'http2'],
                                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The name of the HTTP2 health check.',
                                                                                                                                                           u'name': u'name',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'value': u'NAME'}],
                                                                                                                                         u'release': u'ALPHA',
                                                                                                                                         u'sections': {u'DESCRIPTION': u'*http2* is used to update an existing HTTP2 health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                                              u'https': {u'capsule': u'*(ALPHA)* Update a HTTPS health check.',
                                                                                                                                         u'commands': {},
                                                                                                                                         u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--check-interval',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'CHECK_INTERVAL'},
                                                                                                                                                    u'--description': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'A textual description for the HTTPS health check. Pass in an empty string to unset.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--description',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                                                    u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--healthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                    u'--host': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--host',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'HOST'},
                                                                                                                                                    u'--port': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--port',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'PORT'},
                                                                                                                                                    u'--port-name': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--port-name',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'PORT_NAME'},
                                                                                                                                                    u'--proxy-header': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [u'NONE',
                                                                                                                                                                                     u'PROXY_V1'],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--proxy-header',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'PROXY_HEADER'},
                                                                                                                                                    u'--request-path': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--request-path',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'REQUEST_PATH'},
                                                                                                                                                    u'--response': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'When empty, status code of the response determines health. When not empty,\npresence of specified string in first 1024 characters of response body\ndetermines health. Only ASCII characters allowed.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--response',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'RESPONSE'},
                                                                                                                                                    u'--timeout': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--timeout',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'TIMEOUT'},
                                                                                                                                                    u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--unhealthy-threshold',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                         u'group': False,
                                                                                                                                         u'groups': {},
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'https',
                                                                                                                                         u'path': [u'gcloud',
                                                                                                                                                   u'alpha',
                                                                                                                                                   u'compute',
                                                                                                                                                   u'health-checks',
                                                                                                                                                   u'update',
                                                                                                                                                   u'https'],
                                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The name of the HTTPS health check.',
                                                                                                                                                           u'name': u'name',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'value': u'NAME'}],
                                                                                                                                         u'release': u'ALPHA',
                                                                                                                                         u'sections': {u'DESCRIPTION': u'*https* is used to update an existing HTTPS health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                                              u'ssl': {u'capsule': u'*(ALPHA)* Update a SSL health check.',
                                                                                                                                       u'commands': {},
                                                                                                                                       u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--check-interval',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'CHECK_INTERVAL'},
                                                                                                                                                  u'--description': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'A textual description for the SSL health check. Pass in an empty string to unset.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--description',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                                                  u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--healthy-threshold',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'string',
                                                                                                                                                                           u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                  u'--port': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--port',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'PORT'},
                                                                                                                                                  u'--port-name': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--port-name',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'PORT_NAME'},
                                                                                                                                                  u'--proxy-header': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [u'NONE',
                                                                                                                                                                                   u'PROXY_V1'],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--proxy-header',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'PROXY_HEADER'},
                                                                                                                                                  u'--request': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.\n+\nSetting this to an empty string will clear any existing request value.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--request',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'REQUEST'},
                                                                                                                                                  u'--response': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.\n      Setting this to an empty string will clear any existing\nresponse value.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--response',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'RESPONSE'},
                                                                                                                                                  u'--timeout': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--timeout',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'TIMEOUT'},
                                                                                                                                                  u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--unhealthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                       u'group': False,
                                                                                                                                       u'groups': {},
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'ssl',
                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                 u'alpha',
                                                                                                                                                 u'compute',
                                                                                                                                                 u'health-checks',
                                                                                                                                                 u'update',
                                                                                                                                                 u'ssl'],
                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name of the SSL health check.',
                                                                                                                                                         u'name': u'name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                       u'sections': {u'DESCRIPTION': u'*ssl* is used to update an existing SSL health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                                              u'tcp': {u'capsule': u'*(ALPHA)* Update a TCP health check.',
                                                                                                                                       u'commands': {},
                                                                                                                                       u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--check-interval',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'CHECK_INTERVAL'},
                                                                                                                                                  u'--description': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'A textual description for the TCP health check. Pass in an empty string to unset.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--description',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                                                  u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--healthy-threshold',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'string',
                                                                                                                                                                           u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                  u'--port': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--port',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'PORT'},
                                                                                                                                                  u'--port-name': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--port-name',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'PORT_NAME'},
                                                                                                                                                  u'--proxy-header': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [u'NONE',
                                                                                                                                                                                   u'PROXY_V1'],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--proxy-header',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'PROXY_HEADER'},
                                                                                                                                                  u'--request': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.\n+\nSetting this to an empty string will clear any existing request value.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--request',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'REQUEST'},
                                                                                                                                                  u'--response': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.\n      Setting this to an empty string will clear any existing\nresponse value.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--response',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'RESPONSE'},
                                                                                                                                                  u'--timeout': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--timeout',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'TIMEOUT'},
                                                                                                                                                  u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--unhealthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                       u'group': False,
                                                                                                                                       u'groups': {},
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'tcp',
                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                 u'alpha',
                                                                                                                                                 u'compute',
                                                                                                                                                 u'health-checks',
                                                                                                                                                 u'update',
                                                                                                                                                 u'tcp'],
                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name of the TCP health check.',
                                                                                                                                                         u'name': u'name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                       u'sections': {u'DESCRIPTION': u'*tcp* is used to update an existing TCP health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                                              u'udp': {u'capsule': u'*(ALPHA)* Update a UDP health check.',
                                                                                                                                       u'commands': {},
                                                                                                                                       u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--check-interval',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'CHECK_INTERVAL'},
                                                                                                                                                  u'--description': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'A textual description for the UDP health check. Pass in an empty string to unset.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--description',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                                                  u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--healthy-threshold',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'string',
                                                                                                                                                                           u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                  u'--port': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The UDP port number that this health check monitors. The default is not\nset.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--port',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'PORT'},
                                                                                                                                                  u'--port-name': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--port-name',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'PORT_NAME'},
                                                                                                                                                  u'--request': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Application data to send in payload of an UDP packet. It is an error if\nthis is empty.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--request',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'REQUEST'},
                                                                                                                                                  u'--response': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The bytes to match against the beginning of the response data.\nIt is an error if this is empty.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--response',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'RESPONSE'},
                                                                                                                                                  u'--timeout': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--timeout',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'TIMEOUT'},
                                                                                                                                                  u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--unhealthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                       u'group': False,
                                                                                                                                       u'groups': {},
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'udp',
                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                 u'alpha',
                                                                                                                                                 u'compute',
                                                                                                                                                 u'health-checks',
                                                                                                                                                 u'update',
                                                                                                                                                 u'udp'],
                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name of the UDP health check.',
                                                                                                                                                         u'name': u'name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                       u'sections': {u'DESCRIPTION': u'*udp* is used to update an existing UDP health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}}},
                                                                                                                u'flags': {},
                                                                                                                u'group': True,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'update',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'health-checks',
                                                                                                                          u'update'],
                                                                                                                u'positionals': [],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Update health checks for load balanced instances.'}}},
                                                                                      u'flags': {},
                                                                                      u'group': True,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'health-checks',
                                                                                      u'path': [u'gcloud',
                                                                                                u'alpha',
                                                                                                u'compute',
                                                                                                u'health-checks'],
                                                                                      u'positionals': [],
                                                                                      u'release': u'ALPHA',
                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate health checks for load balanced instances.'}},
                                                                   u'http-health-checks': {u'capsule': u'*(ALPHA)* Read and manipulate HTTP health checks for load balanced instances.',
                                                                                           u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create an HTTP health check to monitor load balanced instances.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': u'5s',
                                                                                                                                                      u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--check-interval',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'CHECK_INTERVAL'},
                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'An optional, textual description for the HTTP health check.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--healthy-threshold': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': 2,
                                                                                                                                                         u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--healthy-threshold',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'int',
                                                                                                                                                         u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                u'--host': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--host',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'HOST'},
                                                                                                                                u'--port': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': 80,
                                                                                                                                            u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--port',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'int',
                                                                                                                                            u'value': u'PORT'},
                                                                                                                                u'--request-path': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': u'/',
                                                                                                                                                    u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--request-path',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'REQUEST_PATH'},
                                                                                                                                u'--timeout': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': u'5s',
                                                                                                                                               u'description': u"If Google Compute Engine doesn't receive an HTTP 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--timeout',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'TIMEOUT'},
                                                                                                                                u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': 2,
                                                                                                                                                           u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--unhealthy-threshold',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'int',
                                                                                                                                                           u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'create',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'http-health-checks',
                                                                                                                               u'create'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the HTTP health check.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*create* is used to create an HTTP health check. HTTP health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                         u'delete': {u'capsule': u'*(ALPHA)* Delete HTTP health checks.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'delete',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'http-health-checks',
                                                                                                                               u'delete'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The resources to delete.',
                                                                                                                                       u'name': u'names',
                                                                                                                                       u'nargs': u'+',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nHTTP health checks.\n'}},
                                                                                                         u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about an HTTP health check.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'describe',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'http-health-checks',
                                                                                                                                 u'describe'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the resource to fetch.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine HTTP health check in a project.\n'}},
                                                                                                         u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine health checks.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--filter',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--limit',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--page-size',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                              u'--regexp': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--regexp',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGEXP'},
                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'FIELD'},
                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'URI'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'list',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'http-health-checks',
                                                                                                                             u'list'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                     u'name': u'names',
                                                                                                                                     u'nargs': u'*',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine health checks in a project.\n',
                                                                                                                                 u'EXAMPLES': u'To list all health checks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all health checks in a project, run:\n\n  $ list --uri\n'}},
                                                                                                         u'update': {u'capsule': u'*(ALPHA)* Update an HTTP health check.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--check-interval',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'CHECK_INTERVAL'},
                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'A textual description for the HTTP health check. Pass in an empty string to unset.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--healthy-threshold': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--healthy-threshold',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                u'--host': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--host',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'HOST'},
                                                                                                                                u'--port': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--port',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PORT'},
                                                                                                                                u'--request-path': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--request-path',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'REQUEST_PATH'},
                                                                                                                                u'--timeout': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"If Google Compute Engine doesn't receive an HTTP 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--timeout',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'TIMEOUT'},
                                                                                                                                u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--unhealthy-threshold',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'update',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'http-health-checks',
                                                                                                                               u'update'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the HTTP health check.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*update* is used to update an existing HTTP health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}}},
                                                                                           u'flags': {},
                                                                                           u'group': True,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'http-health-checks',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'alpha',
                                                                                                     u'compute',
                                                                                                     u'http-health-checks'],
                                                                                           u'positionals': [],
                                                                                           u'release': u'ALPHA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate HTTP health checks for load balanced instances.'}},
                                                                   u'https-health-checks': {u'capsule': u'*(ALPHA)* Read and manipulate HTTPS health checks for load balanced instances.',
                                                                                            u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create an HTTPS health check to monitor load balanced instances.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': u'5s',
                                                                                                                                                       u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--check-interval',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'CHECK_INTERVAL'},
                                                                                                                                 u'--description': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'An optional, textual description for the HTTPS health check.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--description',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                 u'--healthy-threshold': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': 2,
                                                                                                                                                          u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--healthy-threshold',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'int',
                                                                                                                                                          u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                 u'--host': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The value of the host header used in this HTTPS health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--host',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'HOST'},
                                                                                                                                 u'--port': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': 443,
                                                                                                                                             u'description': u'The TCP port number that this health check monitors. The default value\nis 443.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--port',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'int',
                                                                                                                                             u'value': u'PORT'},
                                                                                                                                 u'--request-path': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': u'/',
                                                                                                                                                     u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--request-path',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'REQUEST_PATH'},
                                                                                                                                 u'--timeout': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': u'5s',
                                                                                                                                                u'description': u"If Google Compute Engine doesn't receive an HTTPS 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--timeout',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'TIMEOUT'},
                                                                                                                                 u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': 2,
                                                                                                                                                            u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--unhealthy-threshold',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'int',
                                                                                                                                                            u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'create',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'https-health-checks',
                                                                                                                                u'create'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the HTTPS health check.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*create* is used to create an HTTPS health check. HTTPS health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                          u'delete': {u'capsule': u'*(ALPHA)* Delete HTTPS health checks.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'delete',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'https-health-checks',
                                                                                                                                u'delete'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The resources to delete.',
                                                                                                                                        u'name': u'names',
                                                                                                                                        u'nargs': u'+',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nHTTPS health checks.\n'}},
                                                                                                          u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about an HTTPS health check.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'describe',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'alpha',
                                                                                                                                  u'compute',
                                                                                                                                  u'https-health-checks',
                                                                                                                                  u'describe'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the resource to fetch.',
                                                                                                                                          u'name': u'name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'NAME'}],
                                                                                                                        u'release': u'ALPHA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine HTTPS health check in a project.\n'}},
                                                                                                          u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine HTTPS health checks.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--filter',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--limit',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                               u'--regexp': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--regexp',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGEXP'},
                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'FIELD'},
                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'URI'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'list',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'compute',
                                                                                                                              u'https-health-checks',
                                                                                                                              u'list'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': [],
                                                                                                                                      u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                      u'name': u'names',
                                                                                                                                      u'nargs': u'*',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine HTTPS health checks in a project.\n',
                                                                                                                                  u'EXAMPLES': u'To list all HTTPS health checks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all HTTPS health checks in a project, run:\n\n  $ list --uri\n'}},
                                                                                                          u'update': {u'capsule': u'*(ALPHA)* Update an HTTPS health check.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--check-interval',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'CHECK_INTERVAL'},
                                                                                                                                 u'--description': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'A textual description for the HTTPS health check. Pass in an empty string to unset.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--description',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                 u'--healthy-threshold': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--healthy-threshold',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                 u'--host': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The value of the host header used in this HTTPS health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--host',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'HOST'},
                                                                                                                                 u'--port': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--port',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PORT'},
                                                                                                                                 u'--request-path': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--request-path',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'REQUEST_PATH'},
                                                                                                                                 u'--timeout': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"If Google Compute Engine doesn't receive an HTTPS 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--timeout',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'TIMEOUT'},
                                                                                                                                 u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--unhealthy-threshold',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'update',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'https-health-checks',
                                                                                                                                u'update'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the HTTPS health check.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*update* is used to update an existing HTTPS health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}}},
                                                                                            u'flags': {},
                                                                                            u'group': True,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'https-health-checks',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'alpha',
                                                                                                      u'compute',
                                                                                                      u'https-health-checks'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'ALPHA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate HTTPS health checks for load balanced instances.'}},
                                                                   u'images': {u'capsule': u'*(ALPHA)* List, create, and delete Google Compute Engine images.',
                                                                               u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create Google Compute Engine images.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine images to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--csek-key-file',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'FILE'},
                                                                                                                    u'--description': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'An optional, textual description for the image being created.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--description',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                    u'--family': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The family of the image. When creating an instance or disk, specifying a family will cause the latest non-deprecated image in the family to be used.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--family',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'FAMILY'},
                                                                                                                    u'--guest-os-features': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'One or more features supported by the OS in the image. _GUEST_OS_FEATURE_ must be one of: *MULTI_IP_SUBNET*, *VIRTIO_SCSI_MULTIQUEUE*, *WINDOWS*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--guest-os-features',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'GUEST_OS_FEATURE'},
                                                                                                                    u'--licenses': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Comma-separated list of URIs to license resources.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--licenses',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'LICENSES'},
                                                                                                                    u'--no-require-csek-key-create': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': True,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-require-csek-key-create',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                    u'--require-csek-key-create': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': True,
                                                                                                                                                   u'description': u'Refuse to create images not protected by a user managed key in\nthe key file when --csek-key-file is given. This behavior is enabled\nby default to prevent incorrect gcloud invocations from accidentally\ncreating images with no user managed key. Disabling the check\nallows creation of some images without a matching\nCustomer-Supplied Encryption Key in the supplied --csek-key-file.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details. Enabled by default, use *--no-require-csek-key-create* to disable.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--require-csek-key-create',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                    u'--source-disk': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A source disk to create the image from. The value for this option can be\nthe name of a disk with the zone specified via ``--source-disk-zone''\nflag.\n+\nThis flag is mutually exclusive with ``--source-uri''.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--source-disk',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'SOURCE_DISK'},
                                                                                                                    u'--source-disk-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The zone of the source disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--source-disk-zone',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'SOURCE_DISK_ZONE'},
                                                                                                                    u'--source-uri': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The full Google Cloud Storage URI where the disk image is stored.\nThis file must be a gzip-compressed tarball whose name ends in\n``.tar.gz''.\n+\nThis flag is mutually exclusive with ``--source-disk''.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--source-uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'SOURCE_URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'create',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'compute',
                                                                                                                   u'images',
                                                                                                                   u'create'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the disk image.',
                                                                                                                           u'name': u'name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*create* is used to create custom disk images.\nThe resulting image can be provided during instance or disk creation\nso that the instance attached to the resulting disks has access\nto a known set of software or files from the image.\n\nImages can be created from gzipped compressed tarball containing raw\ndisk data or from existing disks in any zone.\n\nImages are global resources, so they can be used across zones and\nprojects.\n\nTo learn more about creating image tarballs, visit\n[](https://cloud.google.com/compute/docs/creating-custom-image)\n'}},
                                                                                             u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine images.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'delete',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'compute',
                                                                                                                   u'images',
                                                                                                                   u'delete'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The resources to delete.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'+',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine images.\n'}},
                                                                                             u'deprecate': {u'capsule': u'*(ALPHA)* Manage deprecation status of Google Compute Engine images.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--delete-in': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"Specifies the amount of time until the image will be marked as DELETED.\nNote: The image will not actually be deleted - this field is only for\ninformational purposes (see below). For instance, specifying ``30d'' will\nmark as DELETED in 30 days from the current system time. Valid units for\nthis flag are ``s'' for seconds, ``m'' for minutes, ``h'' for hours and\n``d'' for days. If no unit is specified, seconds is assumed.\n+\nNote that the image will not be deleted automatically. The image will\nonly be marked as deleted. An explicit request to delete the image must\nbe made in order to remove it from the image list.\nThis flag is mutually exclusive with *--delete-on*.",
                                                                                                                                        u'group': u'deprecate.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--delete-in',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DELETE_IN'},
                                                                                                                       u'--delete-on': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"Similar to *--delete-in*, but specifies an absolute time when the image\nwill be marked as DELETED. Note: The image will not actually be\ndeleted - this field is for informational purposes (see the description\nof --delete-in for more details). The date and time specified must be\nvalid RFC 3339 full-date or date-time. For times in UTC, this looks\nlike ``YYYY-MM-DDTHH:MM:SSZ''. For example: 2020-01-02T00:00:00Z for\nmidnight on January 2, 2020 in UTC.\nThis flag is mutually exclusive with *--delete-in*.",
                                                                                                                                        u'group': u'deprecate.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--delete-on',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DELETE_ON'},
                                                                                                                       u'--obsolete-in': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Specifies time (in the same format as *--delete-in*) until the image\nwill be marked OBSOLETE. State will not be changed - it is only for\ninformational purposes.\nThis flag is mutually exclusive with *--obsolete-on*.',
                                                                                                                                          u'group': u'deprecate.2',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--obsolete-in',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'OBSOLETE_IN'},
                                                                                                                       u'--obsolete-on': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Specifies time (in the same format as *--delete-on*) when this image will\nbe marked as OBSOLETE. State will not be changed - it has only\ninformational purpose.\nThis flag is mutually exclusive with *--obsolete-in*.',
                                                                                                                                          u'group': u'deprecate.2',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--obsolete-on',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'OBSOLETE_ON'},
                                                                                                                       u'--replacement': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Specifies a Compute Engine image as a replacement for the image\nbeing phased out. Users of the deprecated image will be advised to switch\nto this replacement. For example, *--replacement example-image* or\n*--replacement projects/google/global/images/example-image*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--replacement',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'REPLACEMENT'},
                                                                                                                       u'--state': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [u'ACTIVE',
                                                                                                                                                 u'DELETED',
                                                                                                                                                 u'DEPRECATED',
                                                                                                                                                 u'OBSOLETE'],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': u'ACTIVE',
                                                                                                                                    u'description': u'The deprecation state to set on the image. _STATE_ must be one of:\n+\n*ACTIVE*::: The image is currently supported.\n*DELETED*::: New uses result in an error. Setting this state will not automatically delete the image. You must still make a request to delete the image to remove it from the image list.\n*DEPRECATED*::: Operations which create a new *DEPRECATED* resource return successfully, but with a warning indicating that the image is deprecated and recommending its replacement.\n*OBSOLETE*::: New uses result in an error.\n+',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--state',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'STATE'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {u'deprecate.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                         u'is_mutex': True,
                                                                                                                                         u'is_required': False},
                                                                                                                        u'deprecate.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                         u'is_mutex': True,
                                                                                                                                         u'is_required': False}},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'deprecate',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'compute',
                                                                                                                      u'images',
                                                                                                                      u'deprecate'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The name of the disk image.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* *deprecate* is used to deprecate images.',
                                                                                                                          u'EXAMPLES': u"To deprecate an image called 'IMAGE' immediately, mark it as\nobsolete in one day, and mark it as deleted in two days, use:\n\n  $ deprecate IMAGE --state DEPRECATED --obsolete-in 1d --delete-in 2d\n\nTo un-deprecate an image called 'IMAGE', use:\n\n  $ deprecate IMAGE --state ACTIVE\n"}},
                                                                                             u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine image.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'describe',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'images',
                                                                                                                     u'describe'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the resource to fetch.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine image in a project.\n'}},
                                                                                             u'describe-from-family': {u'capsule': u'*(ALPHA)* Describe the latest image from an image family.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'describe-from-family',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'images',
                                                                                                                                 u'describe-from-family'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the resource to fetch.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* *describe-from-family* looks up the latest image from an image family and runs a describe\non it.'}},
                                                                                             u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine images.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--no-preview-images': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-preview-images',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_PREVIEW_IMAGES'},
                                                                                                                  u'--no-show-deprecated': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-show-deprecated',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_SHOW_DEPRECATED'},
                                                                                                                  u'--no-show-preview-images': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-show-preview-images',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_SHOW_PREVIEW_IMAGES'},
                                                                                                                  u'--no-standard-images': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-standard-images',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_STANDARD_IMAGES'},
                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_URI'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--preview-images': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Show images that are in limited preview. The preview image projects\nare: (none)',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--preview-images',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'PREVIEW_IMAGES'},
                                                                                                                  u'--regexp': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--regexp',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'REGEXP'},
                                                                                                                  u'--show-deprecated': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'If provided, deprecated images are shown.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--show-deprecated',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'SHOW_DEPRECATED'},
                                                                                                                  u'--show-preview-images': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--show-preview-images',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'SHOW_PREVIEW_IMAGES'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'},
                                                                                                                  u'--standard-images': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'Show images from well-known image projects.  The well known image\nprojects are: centos-cloud, coreos-cloud, debian-cloud, cos-cloud, rhel-cloud, suse-cloud, ubuntu-os-cloud, windows-cloud, windows-sql-cloud. Enabled by default, use *--no-standard-images* to disable.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--standard-images',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'STANDARD_IMAGES'},
                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'URI'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'list',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'compute',
                                                                                                                 u'images',
                                                                                                                 u'list'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': [],
                                                                                                                         u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                         u'name': u'names',
                                                                                                                         u'nargs': u'*',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'NAME'}],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine images in a project.\n',
                                                                                                                     u'EXAMPLES': u'To list all images in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all images in a project, run:\n\n  $ list --uri\n'}}},
                                                                               u'flags': {},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'images',
                                                                               u'path': [u'gcloud',
                                                                                         u'alpha',
                                                                                         u'compute',
                                                                                         u'images'],
                                                                               u'positionals': [],
                                                                               u'release': u'ALPHA',
                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, and delete Google Compute Engine images.'}},
                                                                   u'instance-groups': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine instance groups.',
                                                                                        u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about an instance group.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                             u'group': u'describe.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--region',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGION'},
                                                                                                                               u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The zone of the resource to fetch. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                           u'group': u'describe.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--zone',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'ZONE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                u'is_mutex': True,
                                                                                                                                                u'is_required': False}},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'describe',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'compute',
                                                                                                                              u'instance-groups',
                                                                                                                              u'describe'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the resource to fetch.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with an instance group in a project.\n',
                                                                                                                                  u'EXAMPLES': u"\nTo get details about a regional instance group in the ``us-central1'' regions,\nrun:\n\n  $ describe --region us-central1\n\nTo get details about a zonal instance group in the ``us-central1-b'' zone, run:\n\n  $ describe --zone us-central1-b\n"}},
                                                                                                      u'get-named-ports': {u'capsule': u'*(ALPHA)* Lists the named ports for an instance group resource.',
                                                                                                                           u'commands': {},
                                                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--filter',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--limit',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': True,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-uri',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_URI'},
                                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--page-size',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                                      u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                    u'group': u'get-named-ports.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--region',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'REGION'},
                                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'list',
                                                                                                                                                     u'value': u'FIELD'},
                                                                                                                                      u'--uri': {u'attr': {},
                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--uri',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'URI'},
                                                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                  u'group': u'get-named-ports.1',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--zone',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'ZONE'}},
                                                                                                                           u'group': False,
                                                                                                                           u'groups': {u'get-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                              u'is_mutex': True,
                                                                                                                                                              u'is_required': False}},
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'get-named-ports',
                                                                                                                           u'path': [u'gcloud',
                                                                                                                                     u'alpha',
                                                                                                                                     u'compute',
                                                                                                                                     u'instance-groups',
                                                                                                                                     u'get-named-ports'],
                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The name of the instance group.',
                                                                                                                                             u'name': u'name',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'NAME'}],
                                                                                                                           u'release': u'ALPHA',
                                                                                                                           u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which indicates that the service\nis available on all instances in the group. This information is used\nby the HTTP Load Balancing service.\n\n*get-named-ports* lists the named ports (name and port tuples)\nfor an instance group.\n",
                                                                                                                                         u'EXAMPLES': u"For example, to list named ports for an instance group:\n\n  $ get-named-ports example-instance-group --zone us-central1-a\n\nThe above example lists named ports assigned to an instance\ngroup named 'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                      u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine instance groups.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--filter',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--limit',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--page-size',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                           u'--regexp': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--regexp',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGEXP'},
                                                                                                                           u'--regions': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                          u'group': u'list.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--regions',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'REGION'},
                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'FIELD'},
                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'URI'},
                                                                                                                           u'--zones': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'If provided, only zonal resources are shown. If arguments are provided, only resources from the given zones are shown.',
                                                                                                                                        u'group': u'list.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--zones',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'ZONE'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                        u'is_mutex': True,
                                                                                                                                        u'is_required': False}},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'list',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'instance-groups',
                                                                                                                          u'list'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': [],
                                                                                                                                  u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                  u'name': u'names',
                                                                                                                                  u'nargs': u'*',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine instance groups in a project.\n\nBy default, instance groups from all regions and instance groups from all zones are listed. The results can be narrowed down by\nproviding the ``--regions'' or ``--zones'' flag.\n",
                                                                                                                              u'EXAMPLES': u"To list all instance groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all instance groups in a project, run:\n\n  $ list --uri\n\nTo list all instance groups in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n\nTo list all instance groups in zones ``us-central1-b'' and ``europe-west1-d'',\nrun:\n\n  $ list --zones us-central1,europe-west1\n"}},
                                                                                                      u'list-instances': {u'capsule': u'*(ALPHA)* List instances present in the instance group.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--filter',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--limit',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': True,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--page-size',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                                     u'--regexp': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--regexp',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'REGEXP'},
                                                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                   u'group': u'list-instances.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--region',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'REGION'},
                                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'list',
                                                                                                                                                    u'value': u'FIELD'},
                                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--uri',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'URI'},
                                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                 u'group': u'list-instances.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--zone',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'ZONE'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {u'list-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                            u'is_required': False}},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'list-instances',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'alpha',
                                                                                                                                    u'compute',
                                                                                                                                    u'instance-groups',
                                                                                                                                    u'list-instances'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the instance group.',
                                                                                                                                            u'name': u'name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'NAME'}],
                                                                                                                          u'release': u'ALPHA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'*list-instances* list instances in an instance group.\n'}},
                                                                                                      u'managed': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine managed instance groups.',
                                                                                                                   u'commands': {u'abandon-instances': {u'capsule': u'*(ALPHA)* Abandon instances owned by a managed instance group.',
                                                                                                                                                        u'commands': {},
                                                                                                                                                        u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                                                    u'category': u'',
                                                                                                                                                                                    u'choices': [],
                                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                                    u'default': None,
                                                                                                                                                                                    u'description': u'Names of instances to abandon.',
                                                                                                                                                                                    u'group': u'',
                                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                                    u'name': u'--instances',
                                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                                    u'required': True,
                                                                                                                                                                                    u'type': u'list',
                                                                                                                                                                                    u'value': u'INSTANCE'},
                                                                                                                                                                   u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                 u'group': u'abandon-instances.1',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--region',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'REGION'},
                                                                                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                               u'group': u'abandon-instances.1',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--zone',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'ZONE'}},
                                                                                                                                                        u'group': False,
                                                                                                                                                        u'groups': {u'abandon-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                                                             u'is_required': False}},
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'abandon-instances',
                                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                                  u'alpha',
                                                                                                                                                                  u'compute',
                                                                                                                                                                  u'instance-groups',
                                                                                                                                                                  u'managed',
                                                                                                                                                                  u'abandon-instances'],
                                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The name of the managed instance group.',
                                                                                                                                                                          u'name': u'name',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                                        u'release': u'ALPHA',
                                                                                                                                                        u'sections': {u'DESCRIPTION': u'\n        *abandon-instances* abandons one or more instances from a managed instance\ngroup, thereby reducing the targetSize of the group. Once instances have been\nabandoned, the currentSize of the group is automatically reduced as well to\nreflect the change.\n\nAbandoning an instance does not delete the underlying virtual machine instances,\nbut just removes the instances from the instance group. If you would like the\ndelete the underlying instances, use the delete-instances command instead.\n'}},
                                                                                                                                 u'create': {u'capsule': u'*(ALPHA)* Create a Compute Engine managed instance group.',
                                                                                                                                             u'commands': {},
                                                                                                                                             u'flags': {u'--base-instance-name': {u'attr': {},
                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                  u'description': u'The base name to use for the Compute Engine instances that will be created with the managed instance group. If not provided base instance name will be the prefix of instance group name.',
                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                  u'name': u'--base-instance-name',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                                  u'value': u'BASE_INSTANCE_NAME'},
                                                                                                                                                        u'--description': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'An optional description for this group.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--description',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'string',
                                                                                                                                                                           u'value': u'DESCRIPTION'},
                                                                                                                                                        u'--http-health-check': {u'attr': {},
                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'Specifies the HTTP health check object used for autohealing instances in this group.',
                                                                                                                                                                                 u'group': u'create.1',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--http-health-check',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                                                        u'--https-health-check': {u'attr': {},
                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                  u'description': u'Specifies the HTTPS health check object used for autohealing instances in this group.',
                                                                                                                                                                                  u'group': u'create.1',
                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                  u'name': u'--https-health-check',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                                  u'value': u'HTTPS_HEALTH_CHECK'},
                                                                                                                                                        u'--initial-delay': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u"Specifies the length of the period during which the instance is known to\nbe initializing and should not be autohealed even if unhealthy.\nValid units for this flag are ``s'' for seconds, ``m'' for minutes and\n``h'' for hours. If no unit is specified, seconds is assumed. This value\ncannot be greater than 1 hour.",
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--initial-delay',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'INITIAL_DELAY'},
                                                                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                      u'group': u'create.2',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--region',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'REGION'},
                                                                                                                                                        u'--size': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The initial number of instances you want in this group.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--size',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': True,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'SIZE'},
                                                                                                                                                        u'--target-pool': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'Specifies any target pools you want the instances of this managed instance group to be part of.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--target-pool',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'list',
                                                                                                                                                                           u'value': u'TARGET_POOL'},
                                                                                                                                                        u'--template': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'Specifies the instance template to use when creating new instances.',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--template',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': True,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'TEMPLATE'},
                                                                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                    u'group': u'create.2',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--zone',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'ZONE'}},
                                                                                                                                             u'group': False,
                                                                                                                                             u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                                       u'is_required': False},
                                                                                                                                                         u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                                       u'is_required': False}},
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'create',
                                                                                                                                             u'path': [u'gcloud',
                                                                                                                                                       u'alpha',
                                                                                                                                                       u'compute',
                                                                                                                                                       u'instance-groups',
                                                                                                                                                       u'managed',
                                                                                                                                                       u'create'],
                                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The name of the managed instance group.',
                                                                                                                                                               u'name': u'name',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'value': u'NAME'}],
                                                                                                                                             u'release': u'ALPHA',
                                                                                                                                             u'sections': {u'DESCRIPTION': u"        *create* creates a Google Compute Engine managed instance group.\n\nFor example, running:\n\n        $ create example-managed-instance-group --zone us-central1-a --template example-instance-template --size 1\n\nwill create one managed instance group called 'example-managed-instance-group'\nin the ``us-central1-a'' zone.\n"}},
                                                                                                                                 u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine managed instance groups.',
                                                                                                                                             u'commands': {},
                                                                                                                                             u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                      u'group': u'delete.1',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--region',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'REGION'},
                                                                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                    u'group': u'delete.1',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--zone',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'ZONE'}},
                                                                                                                                             u'group': False,
                                                                                                                                             u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                                       u'is_required': False}},
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'delete',
                                                                                                                                             u'path': [u'gcloud',
                                                                                                                                                       u'alpha',
                                                                                                                                                       u'compute',
                                                                                                                                                       u'instance-groups',
                                                                                                                                                       u'managed',
                                                                                                                                                       u'delete'],
                                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The names of the managed instance groups.',
                                                                                                                                                               u'name': u'names',
                                                                                                                                                               u'nargs': u'+',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'value': u'NAMES'}],
                                                                                                                                             u'release': u'ALPHA',
                                                                                                                                             u'sections': {u'DESCRIPTION': u'        *delete* deletes one or more Google Compute Engine managed instance\ngroups.\n'}},
                                                                                                                                 u'delete-instances': {u'capsule': u'*(ALPHA)* Delete instances managed by managed instance group.',
                                                                                                                                                       u'commands': {},
                                                                                                                                                       u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                                                   u'category': u'',
                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                   u'description': u'Names of instances to delete.',
                                                                                                                                                                                   u'group': u'',
                                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                                   u'name': u'--instances',
                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                   u'required': True,
                                                                                                                                                                                   u'type': u'list',
                                                                                                                                                                                   u'value': u'INSTANCE'},
                                                                                                                                                                  u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                u'group': u'delete-instances.1',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--region',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'REGION'},
                                                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                              u'group': u'delete-instances.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--zone',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                                                       u'group': False,
                                                                                                                                                       u'groups': {u'delete-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                           u'is_mutex': True,
                                                                                                                                                                                           u'is_required': False}},
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'delete-instances',
                                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                                 u'alpha',
                                                                                                                                                                 u'compute',
                                                                                                                                                                 u'instance-groups',
                                                                                                                                                                 u'managed',
                                                                                                                                                                 u'delete-instances'],
                                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the managed instance group.',
                                                                                                                                                                         u'name': u'name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                                       u'sections': {u'DESCRIPTION': u'\n        *delete-instances* is used to deletes one or more instances from a managed\ninstance group. Once the instances are deleted, the size of the group is\nautomatically reduced to reflect the changes.\n\nIf you would like to keep the underlying virtual machines but still remove them\nfrom the managed instance group, use the abandon-instances command instead.\n'}},
                                                                                                                                 u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about a managed instance group.',
                                                                                                                                               u'commands': {},
                                                                                                                                               u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                        u'group': u'describe.1',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--region',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'REGION'},
                                                                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'The zone of the resource to fetch. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                      u'group': u'describe.1',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--zone',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'ZONE'}},
                                                                                                                                               u'group': False,
                                                                                                                                               u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                           u'is_mutex': True,
                                                                                                                                                                           u'is_required': False}},
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'describe',
                                                                                                                                               u'path': [u'gcloud',
                                                                                                                                                         u'alpha',
                                                                                                                                                         u'compute',
                                                                                                                                                         u'instance-groups',
                                                                                                                                                         u'managed',
                                                                                                                                                         u'describe'],
                                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The name of the resource to fetch.',
                                                                                                                                                                 u'name': u'name',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'value': u'NAME'}],
                                                                                                                                               u'release': u'ALPHA',
                                                                                                                                               u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a managed instance group in a project.\n',
                                                                                                                                                             u'EXAMPLES': u"\nTo get details about a regional managed instance group in the ``us-central1'' regions,\nrun:\n\n  $ describe --region us-central1\n\nTo get details about a zonal managed instance group in the ``us-central1-b'' zone, run:\n\n  $ describe --zone us-central1-b\n"}},
                                                                                                                                 u'get-named-ports': {u'capsule': u'*(ALPHA)* Lists the named ports for an instance group resource.',
                                                                                                                                                      u'commands': {},
                                                                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--filter',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--limit',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'LIMIT'},
                                                                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': True,
                                                                                                                                                                               u'description': u'',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': True,
                                                                                                                                                                               u'name': u'--no-uri',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'bool',
                                                                                                                                                                               u'value': u'NO_URI'},
                                                                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                  u'name': u'--page-size',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                               u'group': u'get-named-ports.1',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--region',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'REGION'},
                                                                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--sort-by',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'list',
                                                                                                                                                                                u'value': u'FIELD'},
                                                                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': False,
                                                                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--uri',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'bool',
                                                                                                                                                                            u'value': u'URI'},
                                                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                             u'group': u'get-named-ports.1',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--zone',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                                                      u'group': False,
                                                                                                                                                      u'groups': {u'get-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                         u'is_mutex': True,
                                                                                                                                                                                         u'is_required': False}},
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'get-named-ports',
                                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                                u'alpha',
                                                                                                                                                                u'compute',
                                                                                                                                                                u'instance-groups',
                                                                                                                                                                u'managed',
                                                                                                                                                                u'get-named-ports'],
                                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The name of the instance group.',
                                                                                                                                                                        u'name': u'name',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                                      u'release': u'ALPHA',
                                                                                                                                                      u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which indicates that the service\nis available on all instances in the group. This information is used\nby the HTTP Load Balancing service.\n\n*get-named-ports* lists the named ports (name and port tuples)\nfor an instance group.\n",
                                                                                                                                                                    u'EXAMPLES': u"For example, to list named ports for an instance group:\n\n  $ get-named-ports example-instance-group --zone us-central1-a\n\nThe above example lists named ports assigned to an instance\ngroup named 'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                                                 u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine managed instance groups.',
                                                                                                                                           u'commands': {},
                                                                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--filter',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--limit',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': True,
                                                                                                                                                                    u'description': u'',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': True,
                                                                                                                                                                    u'name': u'--no-uri',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'bool',
                                                                                                                                                                    u'value': u'NO_URI'},
                                                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--page-size',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                                                      u'--regexp': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--regexp',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'REGEXP'},
                                                                                                                                                      u'--regions': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                                                     u'group': u'list.1',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--regions',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'list',
                                                                                                                                                                     u'value': u'REGION'},
                                                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'list',
                                                                                                                                                                     u'value': u'FIELD'},
                                                                                                                                                      u'--uri': {u'attr': {},
                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': False,
                                                                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--uri',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'bool',
                                                                                                                                                                 u'value': u'URI'},
                                                                                                                                                      u'--zones': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'If provided, only zonal resources are shown. If arguments are provided, only resources from the given zones are shown.',
                                                                                                                                                                   u'group': u'list.1',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--zones',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'list',
                                                                                                                                                                   u'value': u'ZONE'}},
                                                                                                                                           u'group': False,
                                                                                                                                           u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                   u'is_mutex': True,
                                                                                                                                                                   u'is_required': False}},
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'list',
                                                                                                                                           u'path': [u'gcloud',
                                                                                                                                                     u'alpha',
                                                                                                                                                     u'compute',
                                                                                                                                                     u'instance-groups',
                                                                                                                                                     u'managed',
                                                                                                                                                     u'list'],
                                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                                             u'default': [],
                                                                                                                                                             u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                                             u'name': u'names',
                                                                                                                                                             u'nargs': u'*',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'value': u'NAME'}],
                                                                                                                                           u'release': u'ALPHA',
                                                                                                                                           u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine managed instance groups in a project.\n\nBy default, managed instance groups from all regions and managed instance groups from all zones are listed. The results can be narrowed down by\nproviding the ``--regions'' or ``--zones'' flag.\n",
                                                                                                                                                         u'EXAMPLES': u"To list all managed instance groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all managed instance groups in a project, run:\n\n  $ list --uri\n\nTo list all managed instance groups in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n\nTo list all managed instance groups in zones ``us-central1-b'' and ``europe-west1-d'',\nrun:\n\n  $ list --zones us-central1,europe-west1\n"}},
                                                                                                                                 u'list-instances': {u'capsule': u'*(ALPHA)* List instances present in the managed instance group.',
                                                                                                                                                     u'commands': {},
                                                                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--filter',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                                                                u'--limit': {u'attr': {},
                                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--limit',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'LIMIT'},
                                                                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': True,
                                                                                                                                                                              u'description': u'',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': True,
                                                                                                                                                                              u'name': u'--no-uri',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'bool',
                                                                                                                                                                              u'value': u'NO_URI'},
                                                                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--page-size',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The region of the instance group to list instances in. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                              u'group': u'list-instances.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--region',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'REGION'},
                                                                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--sort-by',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'list',
                                                                                                                                                                               u'value': u'FIELD'},
                                                                                                                                                                u'--uri': {u'attr': {},
                                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': False,
                                                                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--uri',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'bool',
                                                                                                                                                                           u'value': u'URI'},
                                                                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The zone of the instance group to list instances in. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                            u'group': u'list-instances.1',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--zone',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                                                     u'group': False,
                                                                                                                                                     u'groups': {u'list-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                                                       u'is_required': False}},
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'list-instances',
                                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                                               u'alpha',
                                                                                                                                                               u'compute',
                                                                                                                                                               u'instance-groups',
                                                                                                                                                               u'managed',
                                                                                                                                                               u'list-instances'],
                                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The name of the instance group.',
                                                                                                                                                                       u'name': u'name',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'value': u'NAME'}],
                                                                                                                                                     u'release': u'ALPHA',
                                                                                                                                                     u'sections': {u'DESCRIPTION': u'*list-instances* list instances in a managed instance group.\n'}},
                                                                                                                                 u'recreate-instances': {u'capsule': u'*(ALPHA)* Recreate instances managed by a managed instance group.',
                                                                                                                                                         u'commands': {},
                                                                                                                                                         u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                                                     u'category': u'',
                                                                                                                                                                                     u'choices': [],
                                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                                     u'default': None,
                                                                                                                                                                                     u'description': u'Names of instances to recreate.',
                                                                                                                                                                                     u'group': u'',
                                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                                     u'name': u'--instances',
                                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                                     u'required': True,
                                                                                                                                                                                     u'type': u'list',
                                                                                                                                                                                     u'value': u'INSTANCE'},
                                                                                                                                                                    u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                  u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                  u'group': u'recreate-instances.1',
                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                  u'name': u'--region',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                                  u'value': u'REGION'},
                                                                                                                                                                    u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                                u'group': u'recreate-instances.1',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--zone',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'ZONE'}},
                                                                                                                                                         u'group': False,
                                                                                                                                                         u'groups': {u'recreate-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                               u'is_mutex': True,
                                                                                                                                                                                               u'is_required': False}},
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'recreate-instances',
                                                                                                                                                         u'path': [u'gcloud',
                                                                                                                                                                   u'alpha',
                                                                                                                                                                   u'compute',
                                                                                                                                                                   u'instance-groups',
                                                                                                                                                                   u'managed',
                                                                                                                                                                   u'recreate-instances'],
                                                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'The name of the managed instance group.',
                                                                                                                                                                           u'name': u'name',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'value': u'NAME'}],
                                                                                                                                                         u'release': u'ALPHA',
                                                                                                                                                         u'sections': {u'DESCRIPTION': u'\n        *recreate-instances* is used to recreate one or more instances in a managed\ninstance group. The underlying virtual machine instances are deleted and\nrecreated based on the latest instance template configured for the managed\ninstance group.\n'}},
                                                                                                                                 u'resize': {u'capsule': u'*(ALPHA)* Set managed instance group size.',
                                                                                                                                             u'commands': {},
                                                                                                                                             u'flags': {u'--creation-retries': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': True,
                                                                                                                                                                                u'description': u'When instance creation fails retry it. Enabled by default, use *--no-creation-retries* to disable.',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--creation-retries',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                                u'value': u'CREATION_RETRIES'},
                                                                                                                                                        u'--no-creation-retries': {u'attr': {},
                                                                                                                                                                                   u'category': u'',
                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                   u'default': True,
                                                                                                                                                                                   u'description': u'',
                                                                                                                                                                                   u'group': u'',
                                                                                                                                                                                   u'hidden': True,
                                                                                                                                                                                   u'name': u'--no-creation-retries',
                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                   u'required': False,
                                                                                                                                                                                   u'type': u'bool',
                                                                                                                                                                                   u'value': u'NO_CREATION_RETRIES'},
                                                                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                      u'group': u'resize.1',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--region',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'REGION'},
                                                                                                                                                        u'--size': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'Target number of instances in managed instance group.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--size',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': True,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'SIZE'},
                                                                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                    u'group': u'resize.1',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--zone',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'ZONE'}},
                                                                                                                                             u'group': False,
                                                                                                                                             u'groups': {u'resize.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                                       u'is_required': False}},
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'resize',
                                                                                                                                             u'path': [u'gcloud',
                                                                                                                                                       u'alpha',
                                                                                                                                                       u'compute',
                                                                                                                                                       u'instance-groups',
                                                                                                                                                       u'managed',
                                                                                                                                                       u'resize'],
                                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The name of the managed instance group.',
                                                                                                                                                               u'name': u'name',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'value': u'NAME'}],
                                                                                                                                             u'release': u'ALPHA',
                                                                                                                                             u'sections': {u'DESCRIPTION': u'\n        *resize* resize a managed instance group to a provided size.\n\nIf you resize down, the Instance Group Manager service deletes instances from\nthe group until the group reaches the desired size. To understand in what order\ninstances will be deleted, see the API documentation.\n\nIf you resize up, the service adds instances to the group using the current\ninstance template until the group reaches the desired size.\n'}},
                                                                                                                                 u'rolling-action': {u'capsule': u'*(ALPHA)* Manipulate rolling actions on Google Compute Engine managed instance groups.',
                                                                                                                                                     u'commands': {u'recreate': {u'capsule': u'*(ALPHA)* Recreates instances in a managed instance group.',
                                                                                                                                                                                 u'commands': {},
                                                                                                                                                                                 u'flags': {u'--max-surge': {u'attr': {},
                                                                                                                                                                                                             u'category': u'',
                                                                                                                                                                                                             u'choices': [],
                                                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                                                             u'default': None,
                                                                                                                                                                                                             u'description': u'Maximum additional number of instances that can be created during the update process. This can be a fixed number (e.g. 5) or a percentage of size to the managed instance group (e.g. 10%)',
                                                                                                                                                                                                             u'group': u'',
                                                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                                                             u'name': u'--max-surge',
                                                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                                                             u'required': False,
                                                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                                                             u'value': u'MAX_SURGE'},
                                                                                                                                                                                            u'--max-unavailable': {u'attr': {},
                                                                                                                                                                                                                   u'category': u'',
                                                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                                                   u'description': u'Maximum number of instances that can be unavailable during the update process. This can be a fixed number (e.g. 5) or a percentage of size to the managed instance group (e.g. 10%)',
                                                                                                                                                                                                                   u'group': u'',
                                                                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                                                                   u'name': u'--max-unavailable',
                                                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                                                   u'required': False,
                                                                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                                                                   u'value': u'MAX_UNAVAILABLE'},
                                                                                                                                                                                            u'--min-ready': {u'attr': {},
                                                                                                                                                                                                             u'category': u'',
                                                                                                                                                                                                             u'choices': [],
                                                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                                                             u'default': None,
                                                                                                                                                                                                             u'description': u'Minimum time for which a newly created instance should be ready to be considered available.',
                                                                                                                                                                                                             u'group': u'',
                                                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                                                             u'name': u'--min-ready',
                                                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                                                             u'required': False,
                                                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                                                             u'value': u'MIN_READY'},
                                                                                                                                                                                            u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                                          u'category': u'',
                                                                                                                                                                                                          u'choices': [],
                                                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                                                          u'default': None,
                                                                                                                                                                                                          u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                                          u'group': u'recreate.1',
                                                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                                                          u'name': u'--region',
                                                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                                                          u'required': False,
                                                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                                                          u'value': u'REGION'},
                                                                                                                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                                                        u'category': u'',
                                                                                                                                                                                                        u'choices': [],
                                                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                                                        u'default': None,
                                                                                                                                                                                                        u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                                                        u'group': u'recreate.1',
                                                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                                                        u'name': u'--zone',
                                                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                                                        u'required': False,
                                                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                                                        u'value': u'ZONE'}},
                                                                                                                                                                                 u'group': False,
                                                                                                                                                                                 u'groups': {u'recreate.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                                                                             u'is_required': False}},
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'recreate',
                                                                                                                                                                                 u'path': [u'gcloud',
                                                                                                                                                                                           u'alpha',
                                                                                                                                                                                           u'compute',
                                                                                                                                                                                           u'instance-groups',
                                                                                                                                                                                           u'managed',
                                                                                                                                                                                           u'rolling-action',
                                                                                                                                                                                           u'recreate'],
                                                                                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                                   u'description': u'The name of the managed instance group.',
                                                                                                                                                                                                   u'name': u'name',
                                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                                   u'required': False,
                                                                                                                                                                                                   u'value': u'NAME'}],
                                                                                                                                                                                 u'release': u'ALPHA',
                                                                                                                                                                                 u'sections': {u'DESCRIPTION': u'*recreate* recreates instances in a managed instance group.'}},
                                                                                                                                                                   u'restart': {u'capsule': u'*(ALPHA)* Restarts instances in a managed instance group.',
                                                                                                                                                                                u'commands': {},
                                                                                                                                                                                u'flags': {u'--max-unavailable': {u'attr': {},
                                                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                                                  u'description': u'Maximum number of instances that can be unavailable during the update process. This can be a fixed number (e.g. 5) or a percentage of size to the managed instance group (e.g. 10%)',
                                                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                                                  u'name': u'--max-unavailable',
                                                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                                                                  u'value': u'MAX_UNAVAILABLE'},
                                                                                                                                                                                           u'--min-ready': {u'attr': {},
                                                                                                                                                                                                            u'category': u'',
                                                                                                                                                                                                            u'choices': [],
                                                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                                                            u'default': None,
                                                                                                                                                                                                            u'description': u'Minimum time for which a newly created instance should be ready to be considered available.',
                                                                                                                                                                                                            u'group': u'',
                                                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                                                            u'name': u'--min-ready',
                                                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                                                            u'required': False,
                                                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                                                            u'value': u'MIN_READY'},
                                                                                                                                                                                           u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                                         u'category': u'',
                                                                                                                                                                                                         u'choices': [],
                                                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                                                         u'default': None,
                                                                                                                                                                                                         u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                                         u'group': u'restart.1',
                                                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                                                         u'name': u'--region',
                                                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                                                         u'required': False,
                                                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                                                         u'value': u'REGION'},
                                                                                                                                                                                           u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                                                       u'category': u'',
                                                                                                                                                                                                       u'choices': [],
                                                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                                                       u'default': None,
                                                                                                                                                                                                       u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                                                       u'group': u'restart.1',
                                                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                                                       u'name': u'--zone',
                                                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                                                       u'required': False,
                                                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                                                       u'value': u'ZONE'}},
                                                                                                                                                                                u'group': False,
                                                                                                                                                                                u'groups': {u'restart.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                                           u'is_mutex': True,
                                                                                                                                                                                                           u'is_required': False}},
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'restart',
                                                                                                                                                                                u'path': [u'gcloud',
                                                                                                                                                                                          u'alpha',
                                                                                                                                                                                          u'compute',
                                                                                                                                                                                          u'instance-groups',
                                                                                                                                                                                          u'managed',
                                                                                                                                                                                          u'rolling-action',
                                                                                                                                                                                          u'restart'],
                                                                                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                                  u'description': u'The name of the managed instance group.',
                                                                                                                                                                                                  u'name': u'name',
                                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                                  u'value': u'NAME'}],
                                                                                                                                                                                u'release': u'ALPHA',
                                                                                                                                                                                u'sections': {u'DESCRIPTION': u'*restart* restarts instances in a managed instance group.'}},
                                                                                                                                                                   u'start-update': {u'capsule': u'*(ALPHA)* Updates instances in a managed instance group.',
                                                                                                                                                                                     u'commands': {},
                                                                                                                                                                                     u'flags': {u'--canary-version': {u'attr': {},
                                                                                                                                                                                                                      u'category': u'COMMONLY USED',
                                                                                                                                                                                                                      u'choices': [],
                                                                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                                                                      u'default': None,
                                                                                                                                                                                                                      u'description': u'New instance template resource to be used. Each version has the following format: template=TEMPLATE,target-size=FIXED_OR_PERCENT,[name=NAME]',
                                                                                                                                                                                                                      u'group': u'',
                                                                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                                                                      u'name': u'--canary-version',
                                                                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                                                                      u'required': False,
                                                                                                                                                                                                                      u'type': u'dict',
                                                                                                                                                                                                                      u'value': u'template=TEMPLATE,target-size=FIXED_OR_PERCENT,[name=NAME]'},
                                                                                                                                                                                                u'--force': {u'attr': {},
                                                                                                                                                                                                             u'category': u'',
                                                                                                                                                                                                             u'choices': [],
                                                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                                                             u'default': False,
                                                                                                                                                                                                             u'description': u'If set, accepts any original or new version configurations without validation.',
                                                                                                                                                                                                             u'group': u'',
                                                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                                                             u'name': u'--force',
                                                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                                                             u'required': False,
                                                                                                                                                                                                             u'type': u'bool',
                                                                                                                                                                                                             u'value': u'FORCE'},
                                                                                                                                                                                                u'--max-surge': {u'attr': {},
                                                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                                                 u'description': u'Maximum additional number of instances that can be created during the update process. This can be a fixed number (e.g. 5) or a percentage of size to the managed instance group (e.g. 10%)',
                                                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                                                 u'name': u'--max-surge',
                                                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                                                 u'value': u'MAX_SURGE'},
                                                                                                                                                                                                u'--max-unavailable': {u'attr': {},
                                                                                                                                                                                                                       u'category': u'',
                                                                                                                                                                                                                       u'choices': [],
                                                                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                                                                       u'default': None,
                                                                                                                                                                                                                       u'description': u'Maximum number of instances that can be unavailable during the update process. This can be a fixed number (e.g. 5) or a percentage of size to the managed instance group (e.g. 10%)',
                                                                                                                                                                                                                       u'group': u'',
                                                                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                                                                       u'name': u'--max-unavailable',
                                                                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                                                                       u'required': False,
                                                                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                                                                       u'value': u'MAX_UNAVAILABLE'},
                                                                                                                                                                                                u'--min-ready': {u'attr': {},
                                                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                                                 u'description': u'Minimum time for which a newly created instance should be ready to be considered available.',
                                                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                                                 u'name': u'--min-ready',
                                                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                                                 u'value': u'MIN_READY'},
                                                                                                                                                                                                u'--no-force': {u'attr': {},
                                                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                                                u'default': True,
                                                                                                                                                                                                                u'description': u'',
                                                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                                                u'hidden': True,
                                                                                                                                                                                                                u'name': u'--no-force',
                                                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                                                u'required': False,
                                                                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                                                                u'value': u'NO_FORCE'},
                                                                                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                                              u'category': u'',
                                                                                                                                                                                                              u'choices': [],
                                                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                                                              u'default': None,
                                                                                                                                                                                                              u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                                              u'group': u'start-update.1',
                                                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                                                              u'name': u'--region',
                                                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                                                              u'required': False,
                                                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                                                              u'value': u'REGION'},
                                                                                                                                                                                                u'--type': {u'attr': {},
                                                                                                                                                                                                            u'category': u'COMMONLY USED',
                                                                                                                                                                                                            u'choices': [u'opportunistic',
                                                                                                                                                                                                                         u'proactive'],
                                                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                                                            u'default': u'proactive',
                                                                                                                                                                                                            u'description': u'Desired update type. _TYPE_ must be one of:\n+\n*opportunistic*::: Replace instances when needed.\n*proactive*::: Replace instances proactively.\n+',
                                                                                                                                                                                                            u'group': u'',
                                                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                                                            u'name': u'--type',
                                                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                                                            u'required': False,
                                                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                                                            u'value': u'TYPE'},
                                                                                                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                                                            u'category': u'',
                                                                                                                                                                                                            u'choices': [],
                                                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                                                            u'default': None,
                                                                                                                                                                                                            u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                                                            u'group': u'start-update.1',
                                                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                                                            u'name': u'--zone',
                                                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                                                            u'required': False,
                                                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                                                                                     u'group': False,
                                                                                                                                                                                     u'groups': {u'start-update.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                                                     u'is_mutex': True,
                                                                                                                                                                                                                     u'is_required': False}},
                                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                                     u'name': u'start-update',
                                                                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                                                                               u'alpha',
                                                                                                                                                                                               u'compute',
                                                                                                                                                                                               u'instance-groups',
                                                                                                                                                                                               u'managed',
                                                                                                                                                                                               u'rolling-action',
                                                                                                                                                                                               u'start-update'],
                                                                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                                                                       u'default': None,
                                                                                                                                                                                                       u'description': u'The name of the managed instance group.',
                                                                                                                                                                                                       u'name': u'name',
                                                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                                                       u'required': False,
                                                                                                                                                                                                       u'value': u'NAME'}],
                                                                                                                                                                                     u'release': u'ALPHA',
                                                                                                                                                                                     u'sections': {u'DESCRIPTION': u'*start-update* updates instances in a managed instance group,\naccording to the given versions and the given update policy.'}},
                                                                                                                                                                   u'stop-proactive-update': {u'capsule': u'*(ALPHA)* Stop the proactive update process of managed instance group.',
                                                                                                                                                                                              u'commands': {},
                                                                                                                                                                                              u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                                                       u'category': u'',
                                                                                                                                                                                                                       u'choices': [],
                                                                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                                                                       u'default': None,
                                                                                                                                                                                                                       u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                                                       u'group': u'stop-proactive-update.1',
                                                                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                                                                       u'name': u'--region',
                                                                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                                                                       u'required': False,
                                                                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                                                                       u'value': u'REGION'},
                                                                                                                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                                                                     u'category': u'',
                                                                                                                                                                                                                     u'choices': [],
                                                                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                                                                     u'default': None,
                                                                                                                                                                                                                     u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                                                                     u'group': u'stop-proactive-update.1',
                                                                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                                                                     u'name': u'--zone',
                                                                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                                                                     u'required': False,
                                                                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                                                                     u'value': u'ZONE'}},
                                                                                                                                                                                              u'group': False,
                                                                                                                                                                                              u'groups': {u'stop-proactive-update.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                                                                                                       u'is_required': False}},
                                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                                              u'name': u'stop-proactive-update',
                                                                                                                                                                                              u'path': [u'gcloud',
                                                                                                                                                                                                        u'alpha',
                                                                                                                                                                                                        u'compute',
                                                                                                                                                                                                        u'instance-groups',
                                                                                                                                                                                                        u'managed',
                                                                                                                                                                                                        u'rolling-action',
                                                                                                                                                                                                        u'stop-proactive-update'],
                                                                                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                                                                                u'default': None,
                                                                                                                                                                                                                u'description': u'The name of the managed instance group.',
                                                                                                                                                                                                                u'name': u'name',
                                                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                                                u'required': False,
                                                                                                                                                                                                                u'value': u'NAME'}],
                                                                                                                                                                                              u'release': u'ALPHA',
                                                                                                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Stop the proactive update process of managed instance group.'}}},
                                                                                                                                                     u'flags': {},
                                                                                                                                                     u'group': True,
                                                                                                                                                     u'groups': {},
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'rolling-action',
                                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                                               u'alpha',
                                                                                                                                                               u'compute',
                                                                                                                                                               u'instance-groups',
                                                                                                                                                               u'managed',
                                                                                                                                                               u'rolling-action'],
                                                                                                                                                     u'positionals': [],
                                                                                                                                                     u'release': u'ALPHA',
                                                                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine managed instance groups.'}},
                                                                                                                                 u'set-autohealing': {u'capsule': u'*(ALPHA)* Set autohealing policy for managed instance group.',
                                                                                                                                                      u'commands': {},
                                                                                                                                                      u'flags': {u'--http-health-check': {u'attr': {},
                                                                                                                                                                                          u'category': u'',
                                                                                                                                                                                          u'choices': [],
                                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                                          u'default': None,
                                                                                                                                                                                          u'description': u'Specifies the HTTP health check object used for autohealing instances in this group.',
                                                                                                                                                                                          u'group': u'set-autohealing.1',
                                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                                          u'name': u'--http-health-check',
                                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                                          u'required': False,
                                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                                          u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                                                                 u'--https-health-check': {u'attr': {},
                                                                                                                                                                                           u'category': u'',
                                                                                                                                                                                           u'choices': [],
                                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                                           u'default': None,
                                                                                                                                                                                           u'description': u'Specifies the HTTPS health check object used for autohealing instances in this group.',
                                                                                                                                                                                           u'group': u'set-autohealing.1',
                                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                                           u'name': u'--https-health-check',
                                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                                           u'required': False,
                                                                                                                                                                                           u'type': u'string',
                                                                                                                                                                                           u'value': u'HTTPS_HEALTH_CHECK'},
                                                                                                                                                                 u'--initial-delay': {u'attr': {},
                                                                                                                                                                                      u'category': u'',
                                                                                                                                                                                      u'choices': [],
                                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                                      u'default': None,
                                                                                                                                                                                      u'description': u"Specifies the length of the period during which the instance is known to\nbe initializing and should not be autohealed even if unhealthy.\nValid units for this flag are ``s'' for seconds, ``m'' for minutes and\n``h'' for hours. If no unit is specified, seconds is assumed. This value\ncannot be greater than 1 hour.",
                                                                                                                                                                                      u'group': u'',
                                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                                      u'name': u'--initial-delay',
                                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                                      u'required': False,
                                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                                      u'value': u'INITIAL_DELAY'},
                                                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                               u'group': u'set-autohealing.2',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--region',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'REGION'},
                                                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                             u'group': u'set-autohealing.2',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--zone',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                                                      u'group': False,
                                                                                                                                                      u'groups': {u'set-autohealing.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                         u'is_mutex': True,
                                                                                                                                                                                         u'is_required': False},
                                                                                                                                                                  u'set-autohealing.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                         u'is_mutex': True,
                                                                                                                                                                                         u'is_required': False}},
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'set-autohealing',
                                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                                u'alpha',
                                                                                                                                                                u'compute',
                                                                                                                                                                u'instance-groups',
                                                                                                                                                                u'managed',
                                                                                                                                                                u'set-autohealing'],
                                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The name of the managed instance group.',
                                                                                                                                                                        u'name': u'name',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                                      u'release': u'ALPHA',
                                                                                                                                                      u'sections': {u'DESCRIPTION': u"\n        *set-autohealing* updates the autohealing policy for an existing managed\ninstance group.\n\nIf --http-health-check or --https-health-check is specified, the resulting\nautohealing policy will be triggered by the health-check i.e. the autohealing\naction (RECREATE) on an instance will be performed if the health-check signals\nthat the instance is UNHEALTHY. If neither --http-health-check nor\n--https-health-check is specified, the resulting autohealing policy will be\ntriggered by instance's status i.e. the autohealing action (RECREATE) on an\ninstance will be performed if the instance.status is not RUNNING.\n--initial-delay specifies the length of the period during which IGM will\nrefrain from autohealing the instance even if the instance is reported as not\nRUNNING or UNHEALTHY. This value must be from range [0, 3600].\n"}},
                                                                                                                                 u'set-autoscaling': {u'capsule': u'*(ALPHA)* Set autoscaling parameters of a managed instance group.',
                                                                                                                                                      u'commands': {},
                                                                                                                                                      u'flags': {u'--cool-down-period': {u'attr': {},
                                                                                                                                                                                         u'category': u'',
                                                                                                                                                                                         u'choices': [],
                                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                                         u'default': None,
                                                                                                                                                                                         u'description': u'Number of seconds Autoscaler will wait between resizing collection. Note: The Autoscaler waits 10 minutes before scaling down, the value entered here is in addition to the initial 10 minute period.',
                                                                                                                                                                                         u'group': u'',
                                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                                         u'name': u'--cool-down-period',
                                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                                         u'required': False,
                                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                                         u'value': u'COOL_DOWN_PERIOD'},
                                                                                                                                                                 u'--custom-metric-utilization': {u'attr': {},
                                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                                  u'description': u'Adds a target metric value for the to the Autoscaler.\n+\n*metric*::: Protocol-free URL of a Google Cloud Monitoring metric.\n+\n*utilization-target*::: Value of the metric Autoscaler will aim to\nmaintain (greater than 0.0).\n+\n*utilization-target-type*::: How target is expressed. Valid values: DELTA_PER_MINUTE, DELTA_PER_SECOND, GAUGE.',
                                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                                  u'name': u'--custom-metric-utilization',
                                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                                  u'type': u'dict',
                                                                                                                                                                                                  u'value': u'CUSTOM_METRIC_UTILIZATION'},
                                                                                                                                                                 u'--description': {u'attr': {},
                                                                                                                                                                                    u'category': u'',
                                                                                                                                                                                    u'choices': [],
                                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                                    u'default': None,
                                                                                                                                                                                    u'description': u'Notes about Autoscaler.',
                                                                                                                                                                                    u'group': u'',
                                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                                    u'name': u'--description',
                                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                                    u'required': False,
                                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                                                 u'--max-num-replicas': {u'attr': {},
                                                                                                                                                                                         u'category': u'',
                                                                                                                                                                                         u'choices': [],
                                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                                         u'default': None,
                                                                                                                                                                                         u'description': u'Maximum number of replicas Autoscaler will set.',
                                                                                                                                                                                         u'group': u'',
                                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                                         u'name': u'--max-num-replicas',
                                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                                         u'required': True,
                                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                                         u'value': u'MAX_NUM_REPLICAS'},
                                                                                                                                                                 u'--min-num-replicas': {u'attr': {},
                                                                                                                                                                                         u'category': u'',
                                                                                                                                                                                         u'choices': [],
                                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                                         u'default': None,
                                                                                                                                                                                         u'description': u'Minimum number of replicas Autoscaler will set.',
                                                                                                                                                                                         u'group': u'',
                                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                                         u'name': u'--min-num-replicas',
                                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                                         u'required': False,
                                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                                         u'value': u'MIN_NUM_REPLICAS'},
                                                                                                                                                                 u'--no-scale-based-on-cpu': {u'attr': {},
                                                                                                                                                                                              u'category': u'',
                                                                                                                                                                                              u'choices': [],
                                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                                              u'default': True,
                                                                                                                                                                                              u'description': u'',
                                                                                                                                                                                              u'group': u'',
                                                                                                                                                                                              u'hidden': True,
                                                                                                                                                                                              u'name': u'--no-scale-based-on-cpu',
                                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                                              u'required': False,
                                                                                                                                                                                              u'type': u'bool',
                                                                                                                                                                                              u'value': u'NO_SCALE_BASED_ON_CPU'},
                                                                                                                                                                 u'--no-scale-based-on-load-balancing': {u'attr': {},
                                                                                                                                                                                                         u'category': u'',
                                                                                                                                                                                                         u'choices': [],
                                                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                                                         u'default': True,
                                                                                                                                                                                                         u'description': u'',
                                                                                                                                                                                                         u'group': u'',
                                                                                                                                                                                                         u'hidden': True,
                                                                                                                                                                                                         u'name': u'--no-scale-based-on-load-balancing',
                                                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                                                         u'required': False,
                                                                                                                                                                                                         u'type': u'bool',
                                                                                                                                                                                                         u'value': u'NO_SCALE_BASED_ON_LOAD_BALANCING'},
                                                                                                                                                                 u'--queue-scaling-acceptable-backlog-per-instance': {u'attr': {},
                                                                                                                                                                                                                      u'category': u'',
                                                                                                                                                                                                                      u'choices': [],
                                                                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                                                                      u'default': None,
                                                                                                                                                                                                                      u'description': u'Queue-based scaling target: autoscaler will aim to assure that average number of tasks in the queue is no greater than this value.',
                                                                                                                                                                                                                      u'group': u'',
                                                                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                                                                      u'name': u'--queue-scaling-acceptable-backlog-per-instance',
                                                                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                                                                      u'required': False,
                                                                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                                                                      u'value': u'QUEUE_SCALING_ACCEPTABLE_BACKLOG_PER_INSTANCE'},
                                                                                                                                                                 u'--queue-scaling-cloud-pub-sub': {u'attr': {},
                                                                                                                                                                                                    u'category': u'',
                                                                                                                                                                                                    u'choices': [],
                                                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                                                    u'default': None,
                                                                                                                                                                                                    u'description': u'Specifies queue-based scaling based on a Cloud Pub/Sub queuing system.\nBoth topic and subscription are required.\n+\n*topic*::: Topic specification. Can be just a name or a partial URL\n(starting with "projects/..."). Topic must belong to the same project as\nAutoscaler.\n+\n*subscription*::: Subscription specification. Can be just a name or a\npartial URL (starting with "projects/..."). Subscription must belong to\nthe same project as Autoscaler and must be connected to the specified\ntopic.',
                                                                                                                                                                                                    u'group': u'',
                                                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                                                    u'name': u'--queue-scaling-cloud-pub-sub',
                                                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                                                    u'required': False,
                                                                                                                                                                                                    u'type': u'dict',
                                                                                                                                                                                                    u'value': u'QUEUE_SCALING_CLOUD_PUB_SUB'},
                                                                                                                                                                 u'--queue-scaling-single-worker-throughput': {u'attr': {},
                                                                                                                                                                                                               u'category': u'',
                                                                                                                                                                                                               u'choices': [],
                                                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                                                               u'default': None,
                                                                                                                                                                                                               u'description': u'Hint the autoscaler for queue-based scaling on how much throughput a single worker instance is able to consume.',
                                                                                                                                                                                                               u'group': u'',
                                                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                                                               u'name': u'--queue-scaling-single-worker-throughput',
                                                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                                                               u'required': False,
                                                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                                                               u'value': u'QUEUE_SCALING_SINGLE_WORKER_THROUGHPUT'},
                                                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                               u'group': u'set-autoscaling.1',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--region',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'REGION'},
                                                                                                                                                                 u'--scale-based-on-cpu': {u'attr': {},
                                                                                                                                                                                           u'category': u'',
                                                                                                                                                                                           u'choices': [],
                                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                                           u'default': False,
                                                                                                                                                                                           u'description': u'Autoscaler will be based on CPU utilization.',
                                                                                                                                                                                           u'group': u'',
                                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                                           u'name': u'--scale-based-on-cpu',
                                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                                           u'required': False,
                                                                                                                                                                                           u'type': u'bool',
                                                                                                                                                                                           u'value': u'SCALE_BASED_ON_CPU'},
                                                                                                                                                                 u'--scale-based-on-load-balancing': {u'attr': {},
                                                                                                                                                                                                      u'category': u'',
                                                                                                                                                                                                      u'choices': [],
                                                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                                                      u'default': False,
                                                                                                                                                                                                      u'description': u'Use autoscaling based on load balancing utilization.',
                                                                                                                                                                                                      u'group': u'',
                                                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                                                      u'name': u'--scale-based-on-load-balancing',
                                                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                                                      u'required': False,
                                                                                                                                                                                                      u'type': u'bool',
                                                                                                                                                                                                      u'value': u'SCALE_BASED_ON_LOAD_BALANCING'},
                                                                                                                                                                 u'--target-cpu-utilization': {u'attr': {},
                                                                                                                                                                                               u'category': u'',
                                                                                                                                                                                               u'choices': [],
                                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                                               u'default': None,
                                                                                                                                                                                               u'description': u'Autoscaler will aim to maintain CPU utilization at target level (0.0 to 1.0).',
                                                                                                                                                                                               u'group': u'',
                                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                                               u'name': u'--target-cpu-utilization',
                                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                                               u'required': False,
                                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                                               u'value': u'TARGET_CPU_UTILIZATION'},
                                                                                                                                                                 u'--target-load-balancing-utilization': {u'attr': {},
                                                                                                                                                                                                          u'category': u'',
                                                                                                                                                                                                          u'choices': [],
                                                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                                                          u'default': None,
                                                                                                                                                                                                          u'description': u'Autoscaler will aim to maintain the load balancing utilization level (greater than 0.0).',
                                                                                                                                                                                                          u'group': u'',
                                                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                                                          u'name': u'--target-load-balancing-utilization',
                                                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                                                          u'required': False,
                                                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                                                          u'value': u'TARGET_LOAD_BALANCING_UTILIZATION'},
                                                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                             u'group': u'set-autoscaling.1',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--zone',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                                                      u'group': False,
                                                                                                                                                      u'groups': {u'set-autoscaling.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                         u'is_mutex': True,
                                                                                                                                                                                         u'is_required': False}},
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'set-autoscaling',
                                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                                u'alpha',
                                                                                                                                                                u'compute',
                                                                                                                                                                u'instance-groups',
                                                                                                                                                                u'managed',
                                                                                                                                                                u'set-autoscaling'],
                                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The name of the managed instance group.',
                                                                                                                                                                        u'name': u'name',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                                      u'release': u'ALPHA',
                                                                                                                                                      u'sections': {u'DESCRIPTION': u'        *set-autoscaling* sets autoscaling parameters of specified managed instance\ngroup.\n\nAutoscalers can use one or more policies listed below. Information on using\nmultiple policies can be found here: [](https://cloud.google.com/compute/docs/autoscaler/multiple-policies)\n'}},
                                                                                                                                 u'set-instance-template': {u'capsule': u'*(ALPHA)* Set instance template for managed instance group.',
                                                                                                                                                            u'commands': {},
                                                                                                                                                            u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                     u'category': u'',
                                                                                                                                                                                     u'choices': [],
                                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                                     u'default': None,
                                                                                                                                                                                     u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                     u'group': u'set-instance-template.1',
                                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                                     u'name': u'--region',
                                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                                     u'required': False,
                                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                                     u'value': u'REGION'},
                                                                                                                                                                       u'--template': {u'attr': {},
                                                                                                                                                                                       u'category': u'',
                                                                                                                                                                                       u'choices': [],
                                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                                       u'default': None,
                                                                                                                                                                                       u'description': u'Compute Engine instance template resource to be used.',
                                                                                                                                                                                       u'group': u'',
                                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                                       u'name': u'--template',
                                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                                       u'required': True,
                                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                                       u'value': u'TEMPLATE'},
                                                                                                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                                   u'category': u'',
                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                   u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                                   u'group': u'set-instance-template.1',
                                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                                   u'name': u'--zone',
                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                   u'required': False,
                                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                                   u'value': u'ZONE'}},
                                                                                                                                                            u'group': False,
                                                                                                                                                            u'groups': {u'set-instance-template.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                                     u'is_mutex': True,
                                                                                                                                                                                                     u'is_required': False}},
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'set-instance-template',
                                                                                                                                                            u'path': [u'gcloud',
                                                                                                                                                                      u'alpha',
                                                                                                                                                                      u'compute',
                                                                                                                                                                      u'instance-groups',
                                                                                                                                                                      u'managed',
                                                                                                                                                                      u'set-instance-template'],
                                                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The name of the managed instance group.',
                                                                                                                                                                              u'name': u'name',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'value': u'NAME'}],
                                                                                                                                                            u'release': u'ALPHA',
                                                                                                                                                            u'sections': {u'DESCRIPTION': u"\n        *set-instance-template* updates the instance template for an existing managed instance group.\n\nThe new template won't apply to existing instances in the group unless they are\nrecreated using the recreate-instances command. But the new template does apply\nto all new instances added to the managed instance group.\n"}},
                                                                                                                                 u'set-named-ports': {u'capsule': u'*(ALPHA)* Sets the list of named ports for an instance group.',
                                                                                                                                                      u'commands': {},
                                                                                                                                                      u'flags': {u'--named-ports': {u'attr': {},
                                                                                                                                                                                    u'category': u'',
                                                                                                                                                                                    u'choices': [],
                                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                                    u'default': None,
                                                                                                                                                                                    u'description': u'The comma-separated list of key:value pairs representing\nthe service name and the port that it is running on.\n+\nTo clear the list of named ports pass empty list as flag value.\nFor example:\n+\n  $ {command} example-instance-group --named-ports ""',
                                                                                                                                                                                    u'group': u'',
                                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                                    u'name': u'--named-ports',
                                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                                    u'required': True,
                                                                                                                                                                                    u'type': u'list',
                                                                                                                                                                                    u'value': u'NAME:PORT'},
                                                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                               u'group': u'set-named-ports.1',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--region',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'REGION'},
                                                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                             u'group': u'set-named-ports.1',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--zone',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                                                      u'group': False,
                                                                                                                                                      u'groups': {u'set-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                         u'is_mutex': True,
                                                                                                                                                                                         u'is_required': False}},
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'set-named-ports',
                                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                                u'alpha',
                                                                                                                                                                u'compute',
                                                                                                                                                                u'instance-groups',
                                                                                                                                                                u'managed',
                                                                                                                                                                u'set-named-ports'],
                                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The name of the instance group.',
                                                                                                                                                                        u'name': u'name',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                                      u'release': u'ALPHA',
                                                                                                                                                      u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which\nindicates that the service is available on all instances in the\ngroup. This information is used by the HTTP Load Balancing\nservice.\n\n*set-named-ports* sets the list of named ports for all instances\nin an instance group.\n\nNote: Running this command will clear all existing named ports.\n",
                                                                                                                                                                    u'EXAMPLES': u'For example, to apply the named ports to an entire instance group:\n\n  $ set-named-ports example-instance-group --named-ports example-service:1111 --zone us-central1-a\n\nThe above example will assign a name \'example-service\' for port 1111\nto the instance group called \'example-instance-group\' in the\n``us-central1-a\'\' zone. The command removes any named ports that are\nalready set for this instance group.\n\nTo clear named ports from instance group provide empty named ports\nlist as parameter:\n\n  $ set-named-ports example-instance-group --named-ports "" --zone us-central1-a\n'}},
                                                                                                                                 u'set-target-pools': {u'capsule': u'*(ALPHA)* Set target pools of managed instance group.',
                                                                                                                                                       u'commands': {},
                                                                                                                                                       u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                u'group': u'set-target-pools.1',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--region',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'REGION'},
                                                                                                                                                                  u'--target-pools': {u'attr': {},
                                                                                                                                                                                      u'category': u'',
                                                                                                                                                                                      u'choices': [],
                                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                                      u'default': None,
                                                                                                                                                                                      u'description': u'Compute Engine Target Pools to add the instances to. Target Pools must be specified by name or by URL. Example: --target-pool target-pool-1,target-pool-2.',
                                                                                                                                                                                      u'group': u'',
                                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                                      u'name': u'--target-pools',
                                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                                      u'required': True,
                                                                                                                                                                                      u'type': u'list',
                                                                                                                                                                                      u'value': u'TARGET_POOL'},
                                                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                              u'group': u'set-target-pools.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--zone',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                                                       u'group': False,
                                                                                                                                                       u'groups': {u'set-target-pools.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                           u'is_mutex': True,
                                                                                                                                                                                           u'is_required': False}},
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'set-target-pools',
                                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                                 u'alpha',
                                                                                                                                                                 u'compute',
                                                                                                                                                                 u'instance-groups',
                                                                                                                                                                 u'managed',
                                                                                                                                                                 u'set-target-pools'],
                                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the managed instance group.',
                                                                                                                                                                         u'name': u'name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                                       u'sections': {u'DESCRIPTION': u"\n        *set-target-pools* sets the target pools for an existing managed instance group.\nInstances that are part of the managed instance group will be added to the\ntarget pool automatically.\n\nSetting a new target pool won't apply to existing instances in the group unless\nthey are recreated using the recreate-instances command. But any new instances\ncreated in the managed instance group will be added to all of the provided\ntarget pools for load balancing purposes.\n"}},
                                                                                                                                 u'stop-autoscaling': {u'capsule': u'*(ALPHA)* Stop autoscaling a managed instance group.',
                                                                                                                                                       u'commands': {},
                                                                                                                                                       u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                u'group': u'stop-autoscaling.1',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--region',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'REGION'},
                                                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                              u'group': u'stop-autoscaling.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--zone',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                                                       u'group': False,
                                                                                                                                                       u'groups': {u'stop-autoscaling.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                           u'is_mutex': True,
                                                                                                                                                                                           u'is_required': False}},
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'stop-autoscaling',
                                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                                 u'alpha',
                                                                                                                                                                 u'compute',
                                                                                                                                                                 u'instance-groups',
                                                                                                                                                                 u'managed',
                                                                                                                                                                 u'stop-autoscaling'],
                                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the managed instance group.',
                                                                                                                                                                         u'name': u'name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                                       u'sections': {u'DESCRIPTION': u'        *stop-autoscaling* stops autoscaling a managed instance group. If autoscaling\nis not enabled for the managed instance group, this command does nothing and\nwill report an error.\n'}},
                                                                                                                                 u'stop-proactive-update-instances': {u'capsule': u'*(ALPHA)*  *(DEPRECATED)* Stop current proactive update instances of managed instance group.',
                                                                                                                                                                      u'commands': {},
                                                                                                                                                                      u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                               u'category': u'',
                                                                                                                                                                                               u'choices': [],
                                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                                               u'default': None,
                                                                                                                                                                                               u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                               u'group': u'stop-proactive-update-instances.1',
                                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                                               u'name': u'--region',
                                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                                               u'required': False,
                                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                                               u'value': u'REGION'},
                                                                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                                             u'category': u'',
                                                                                                                                                                                             u'choices': [],
                                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                                             u'default': None,
                                                                                                                                                                                             u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                                             u'group': u'stop-proactive-update-instances.1',
                                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                                             u'name': u'--zone',
                                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                                             u'required': False,
                                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                                                                      u'group': False,
                                                                                                                                                                      u'groups': {u'stop-proactive-update-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                                                         u'is_mutex': True,
                                                                                                                                                                                                                         u'is_required': False}},
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'stop-proactive-update-instances',
                                                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                                                u'alpha',
                                                                                                                                                                                u'compute',
                                                                                                                                                                                u'instance-groups',
                                                                                                                                                                                u'managed',
                                                                                                                                                                                u'stop-proactive-update-instances'],
                                                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                                                        u'default': None,
                                                                                                                                                                                        u'description': u'The name of the managed instance group.',
                                                                                                                                                                                        u'name': u'name',
                                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                                        u'required': False,
                                                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                                                      u'release': u'ALPHA',
                                                                                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)*  *(DEPRECATED)* Stop current proactive update instances of managed instance group.\n\nThis command is deprecated. Use gcloud alpha compute instance-groups managed rolling-action stop-proactive-update instead.\n\n'}},
                                                                                                                                 u'update-instances': {u'capsule': u'*(ALPHA)*  *(DEPRECATED)* Updates instances in a managed instance group.',
                                                                                                                                                       u'commands': {},
                                                                                                                                                       u'flags': {u'--action': {u'attr': {},
                                                                                                                                                                                u'category': u'COMMONLY USED',
                                                                                                                                                                                u'choices': [u'replace',
                                                                                                                                                                                             u'restart'],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': u'replace',
                                                                                                                                                                                u'description': u'Desired action. _ACTION_ must be one of:\n+\n*replace*::: Replace instances by new ones\n*restart*::: Restart existing instances.\n+',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--action',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'ACTION'},
                                                                                                                                                                  u'--force': {u'attr': {},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': False,
                                                                                                                                                                               u'description': u'If set, accepts any original or new version configurations without validation.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--force',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'bool',
                                                                                                                                                                               u'value': u'FORCE'},
                                                                                                                                                                  u'--max-surge': {u'attr': {},
                                                                                                                                                                                   u'category': u'',
                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                   u'description': u'Maximum additional number of instances that can be created during the update process. This can be a fixed number (e.g. 5) or a percentage of size to the managed instance group (e.g. 10%)',
                                                                                                                                                                                   u'group': u'',
                                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                                   u'name': u'--max-surge',
                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                   u'required': False,
                                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                                   u'value': u'MAX_SURGE'},
                                                                                                                                                                  u'--max-unavailable': {u'attr': {},
                                                                                                                                                                                         u'category': u'',
                                                                                                                                                                                         u'choices': [],
                                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                                         u'default': None,
                                                                                                                                                                                         u'description': u'Maximum number of instances that can be unavailable during the update process. This can be a fixed number (e.g. 5) or a percentage of size to the managed instance group (e.g. 10%)',
                                                                                                                                                                                         u'group': u'',
                                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                                         u'name': u'--max-unavailable',
                                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                                         u'required': False,
                                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                                         u'value': u'MAX_UNAVAILABLE'},
                                                                                                                                                                  u'--min-ready': {u'attr': {},
                                                                                                                                                                                   u'category': u'',
                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                   u'description': u'Minimum time for which a newly created instance should be ready to be considered available.',
                                                                                                                                                                                   u'group': u'',
                                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                                   u'name': u'--min-ready',
                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                   u'required': False,
                                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                                   u'value': u'MIN_READY'},
                                                                                                                                                                  u'--no-force': {u'attr': {},
                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': True,
                                                                                                                                                                                  u'description': u'',
                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                  u'hidden': True,
                                                                                                                                                                                  u'name': u'--no-force',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                  u'type': u'bool',
                                                                                                                                                                                  u'value': u'NO_FORCE'},
                                                                                                                                                                  u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                u'group': u'update-instances.1',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--region',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'REGION'},
                                                                                                                                                                  u'--type': {u'attr': {},
                                                                                                                                                                              u'category': u'COMMONLY USED',
                                                                                                                                                                              u'choices': [u'opportunistic',
                                                                                                                                                                                           u'proactive'],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': u'proactive',
                                                                                                                                                                              u'description': u'Desired update type. _TYPE_ must be one of:\n+\n*opportunistic*::: Replace instances when needed.\n*proactive*::: Replace instances proactively.\n+',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--type',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'TYPE'},
                                                                                                                                                                  u'--version-new': {u'attr': {},
                                                                                                                                                                                     u'category': u'COMMONLY USED',
                                                                                                                                                                                     u'choices': [],
                                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                                     u'default': None,
                                                                                                                                                                                     u'description': u'New instance template resource to be used. Each version has the following format: template=TEMPLATE,[target-size=FIXED_OR_PERCENT]',
                                                                                                                                                                                     u'group': u'',
                                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                                     u'name': u'--version-new',
                                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                                     u'required': False,
                                                                                                                                                                                     u'type': u'dict',
                                                                                                                                                                                     u'value': u'VERSION_NEW'},
                                                                                                                                                                  u'--version-original': {u'attr': {},
                                                                                                                                                                                          u'category': u'COMMONLY USED',
                                                                                                                                                                                          u'choices': [],
                                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                                          u'default': None,
                                                                                                                                                                                          u'description': u'Original instance template resource to be used. Each version has the following format: template=TEMPLATE,[target-size=FIXED_OR_PERCENT]',
                                                                                                                                                                                          u'group': u'',
                                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                                          u'name': u'--version-original',
                                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                                          u'required': False,
                                                                                                                                                                                          u'type': u'dict',
                                                                                                                                                                                          u'value': u'VERSION_ORIGINAL'},
                                                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                              u'group': u'update-instances.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--zone',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                                                       u'group': False,
                                                                                                                                                       u'groups': {u'update-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                           u'is_mutex': True,
                                                                                                                                                                                           u'is_required': False}},
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'update-instances',
                                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                                 u'alpha',
                                                                                                                                                                 u'compute',
                                                                                                                                                                 u'instance-groups',
                                                                                                                                                                 u'managed',
                                                                                                                                                                 u'update-instances'],
                                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the managed instance group.',
                                                                                                                                                                         u'name': u'name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)*  *(DEPRECATED)* Updates instances in a managed instance group.\n\nThis command is deprecated. Use gcloud alpha compute instance-groups managed rolling-action command group instead.\n\n        *update-instances* updates instances in a managed instance group,\n        according to the given versions and the given update policy.'}},
                                                                                                                                 u'wait-until-stable': {u'capsule': u'*(ALPHA)* Waits until state of managed instance group is stable.',
                                                                                                                                                        u'commands': {},
                                                                                                                                                        u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                 u'group': u'wait-until-stable.1',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--region',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'REGION'},
                                                                                                                                                                   u'--timeout': {u'attr': {},
                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                  u'description': u'Timeout in seconds for waiting for group becoming stable.',
                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                  u'name': u'--timeout',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                                  u'value': u'TIMEOUT'},
                                                                                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                               u'group': u'wait-until-stable.1',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--zone',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'ZONE'}},
                                                                                                                                                        u'group': False,
                                                                                                                                                        u'groups': {u'wait-until-stable.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                                                             u'is_required': False}},
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'wait-until-stable',
                                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                                  u'alpha',
                                                                                                                                                                  u'compute',
                                                                                                                                                                  u'instance-groups',
                                                                                                                                                                  u'managed',
                                                                                                                                                                  u'wait-until-stable'],
                                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The name of the managed instance group.',
                                                                                                                                                                          u'name': u'name',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                                        u'release': u'ALPHA',
                                                                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Waits until state of managed instance group is stable.'}}},
                                                                                                                   u'flags': {},
                                                                                                                   u'group': True,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'managed',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'instance-groups',
                                                                                                                             u'managed'],
                                                                                                                   u'positionals': [],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine managed instance groups.'}},
                                                                                                      u'set-named-ports': {u'capsule': u'*(ALPHA)* Sets the list of named ports for an instance group.',
                                                                                                                           u'commands': {},
                                                                                                                           u'flags': {u'--named-ports': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The comma-separated list of key:value pairs representing\nthe service name and the port that it is running on.\n+\nTo clear the list of named ports pass empty list as flag value.\nFor example:\n+\n  $ {command} example-instance-group --named-ports ""',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--named-ports',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': True,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'NAME:PORT'},
                                                                                                                                      u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                    u'group': u'set-named-ports.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--region',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'REGION'},
                                                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                  u'group': u'set-named-ports.1',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--zone',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'ZONE'}},
                                                                                                                           u'group': False,
                                                                                                                           u'groups': {u'set-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                              u'is_mutex': True,
                                                                                                                                                              u'is_required': False}},
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'set-named-ports',
                                                                                                                           u'path': [u'gcloud',
                                                                                                                                     u'alpha',
                                                                                                                                     u'compute',
                                                                                                                                     u'instance-groups',
                                                                                                                                     u'set-named-ports'],
                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The name of the instance group.',
                                                                                                                                             u'name': u'name',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'NAME'}],
                                                                                                                           u'release': u'ALPHA',
                                                                                                                           u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which\nindicates that the service is available on all instances in the\ngroup. This information is used by the HTTP Load Balancing\nservice.\n\n*set-named-ports* sets the list of named ports for all instances\nin an instance group.\n\nNote: Running this command will clear all existing named ports.\n",
                                                                                                                                         u'EXAMPLES': u'For example, to apply the named ports to an entire instance group:\n\n  $ set-named-ports example-instance-group --named-ports example-service:1111 --zone us-central1-a\n\nThe above example will assign a name \'example-service\' for port 1111\nto the instance group called \'example-instance-group\' in the\n``us-central1-a\'\' zone. The command removes any named ports that are\nalready set for this instance group.\n\nTo clear named ports from instance group provide empty named ports\nlist as parameter:\n\n  $ set-named-ports example-instance-group --named-ports "" --zone us-central1-a\n'}},
                                                                                                      u'unmanaged': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine unmanaged instance group.',
                                                                                                                     u'commands': {u'add-instances': {u'capsule': u'*(ALPHA)* Adds instances to an unmanaged instance group by name.',
                                                                                                                                                      u'commands': {},
                                                                                                                                                      u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                  u'description': u'A list of names of instances to add to the instance group. These must exist beforehand and must live in the same zone as the instance group.',
                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                  u'name': u'--instances',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': True,
                                                                                                                                                                                  u'type': u'list',
                                                                                                                                                                                  u'value': u'INSTANCE'},
                                                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--zone',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                                                      u'group': False,
                                                                                                                                                      u'groups': {},
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'add-instances',
                                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                                u'alpha',
                                                                                                                                                                u'compute',
                                                                                                                                                                u'instance-groups',
                                                                                                                                                                u'unmanaged',
                                                                                                                                                                u'add-instances'],
                                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The name of the instance group.',
                                                                                                                                                                        u'name': u'name',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                                      u'release': u'ALPHA',
                                                                                                                                                      u'sections': {u'DESCRIPTION': u'*add-instances* adds existing instances to an unmanaged instance group\nby name.\nFor example:\n\n  $ add-instances example-instance-group --instances example-instance-1 example-instance-2 --zone us-central1-a\n'}},
                                                                                                                                   u'create': {u'capsule': u'*(ALPHA)* Create a Compute Engine unmanaged instance group.',
                                                                                                                                               u'commands': {},
                                                                                                                                               u'flags': {u'--description': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'Specifies a textual description for the unmanaged instance group.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--description',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'DESCRIPTION'},
                                                                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--zone',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'ZONE'}},
                                                                                                                                               u'group': False,
                                                                                                                                               u'groups': {},
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'create',
                                                                                                                                               u'path': [u'gcloud',
                                                                                                                                                         u'alpha',
                                                                                                                                                         u'compute',
                                                                                                                                                         u'instance-groups',
                                                                                                                                                         u'unmanaged',
                                                                                                                                                         u'create'],
                                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The name of the instance group.',
                                                                                                                                                                 u'name': u'name',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'value': u'NAME'}],
                                                                                                                                               u'release': u'ALPHA',
                                                                                                                                               u'sections': {u'DESCRIPTION': u"*create* creates a new Google Compute Engine unmanaged\ninstance group.\nFor example:\n\n  $ create example-instance-group --zone us-central1-a\n\nThe above example creates one unmanaged instance group called\n'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                                                   u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine unmanaged instance groups.',
                                                                                                                                               u'commands': {},
                                                                                                                                               u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u"The zone of the resources to delete. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--zone',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'ZONE'}},
                                                                                                                                               u'group': False,
                                                                                                                                               u'groups': {},
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'delete',
                                                                                                                                               u'path': [u'gcloud',
                                                                                                                                                         u'alpha',
                                                                                                                                                         u'compute',
                                                                                                                                                         u'instance-groups',
                                                                                                                                                         u'unmanaged',
                                                                                                                                                         u'delete'],
                                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The resources to delete.',
                                                                                                                                                                 u'name': u'names',
                                                                                                                                                                 u'nargs': u'+',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'value': u'NAME'}],
                                                                                                                                               u'release': u'ALPHA',
                                                                                                                                               u'sections': {u'DESCRIPTION': u"*delete* deletes one or more Google Compute Engine unmanaged\ninstance groups. This command just deletes the instance group and does\nnot delete the individual virtual machine instances\nin the instance group.\nFor example:\n\n  $ delete example-instance-group-1 example-instance-group-2 --zone us-central1-a\n\nThe above example deletes two instance groups, example-instance-group-1\nand example-instance-group-2, in the ``us-central1-a'' zone.\n"}},
                                                                                                                                   u'describe': {u'capsule': u'*(ALPHA)* Describe an instance group.',
                                                                                                                                                 u'commands': {},
                                                                                                                                                 u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--zone',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'ZONE'}},
                                                                                                                                                 u'group': False,
                                                                                                                                                 u'groups': {},
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'describe',
                                                                                                                                                 u'path': [u'gcloud',
                                                                                                                                                           u'alpha',
                                                                                                                                                           u'compute',
                                                                                                                                                           u'instance-groups',
                                                                                                                                                           u'unmanaged',
                                                                                                                                                           u'describe'],
                                                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The name of the resource to fetch.',
                                                                                                                                                                   u'name': u'name',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'value': u'NAME'}],
                                                                                                                                                 u'release': u'ALPHA',
                                                                                                                                                 u'sections': {u'DESCRIPTION': u'*describe* displays detailed information about a Google Compute\nEngine instance group.\n'}},
                                                                                                                                   u'get-named-ports': {u'capsule': u'*(ALPHA)* Lists the named ports for an instance group resource.',
                                                                                                                                                        u'commands': {},
                                                                                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--filter',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                                                                                   u'--limit': {u'attr': {},
                                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--limit',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'LIMIT'},
                                                                                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': True,
                                                                                                                                                                                 u'description': u'',
                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                 u'hidden': True,
                                                                                                                                                                                 u'name': u'--no-uri',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'bool',
                                                                                                                                                                                 u'value': u'NO_URI'},
                                                                                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                                    u'choices': [],
                                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                                    u'default': None,
                                                                                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                                    u'group': u'',
                                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                                    u'name': u'--page-size',
                                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                                    u'required': False,
                                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                                                                                   u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                 u'group': u'get-named-ports.1',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--region',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'REGION'},
                                                                                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                  u'name': u'--sort-by',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                  u'type': u'list',
                                                                                                                                                                                  u'value': u'FIELD'},
                                                                                                                                                                   u'--uri': {u'attr': {},
                                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': False,
                                                                                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--uri',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'bool',
                                                                                                                                                                              u'value': u'URI'},
                                                                                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                               u'group': u'get-named-ports.1',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--zone',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'ZONE'}},
                                                                                                                                                        u'group': False,
                                                                                                                                                        u'groups': {u'get-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                           u'is_mutex': True,
                                                                                                                                                                                           u'is_required': False}},
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'get-named-ports',
                                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                                  u'alpha',
                                                                                                                                                                  u'compute',
                                                                                                                                                                  u'instance-groups',
                                                                                                                                                                  u'unmanaged',
                                                                                                                                                                  u'get-named-ports'],
                                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The name of the instance group.',
                                                                                                                                                                          u'name': u'name',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                                        u'release': u'ALPHA',
                                                                                                                                                        u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which indicates that the service\nis available on all instances in the group. This information is used\nby the HTTP Load Balancing service.\n\n*get-named-ports* lists the named ports (name and port tuples)\nfor an instance group.\n",
                                                                                                                                                                      u'EXAMPLES': u"For example, to list named ports for an instance group:\n\n  $ get-named-ports example-instance-group --zone us-central1-a\n\nThe above example lists named ports assigned to an instance\ngroup named 'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                                                   u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine unmanaged instance groups.',
                                                                                                                                             u'commands': {},
                                                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--filter',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--limit',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': True,
                                                                                                                                                                      u'description': u'',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': True,
                                                                                                                                                                      u'name': u'--no-uri',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'bool',
                                                                                                                                                                      u'value': u'NO_URI'},
                                                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--page-size',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                                                        u'--regexp': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--regexp',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'REGEXP'},
                                                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'list',
                                                                                                                                                                       u'value': u'FIELD'},
                                                                                                                                                        u'--uri': {u'attr': {},
                                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': False,
                                                                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--uri',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'bool',
                                                                                                                                                                   u'value': u'URI'},
                                                                                                                                                        u'--zones': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': [],
                                                                                                                                                                     u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--zones',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'list',
                                                                                                                                                                     u'value': u'ZONE'}},
                                                                                                                                             u'group': False,
                                                                                                                                             u'groups': {},
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'list',
                                                                                                                                             u'path': [u'gcloud',
                                                                                                                                                       u'alpha',
                                                                                                                                                       u'compute',
                                                                                                                                                       u'instance-groups',
                                                                                                                                                       u'unmanaged',
                                                                                                                                                       u'list'],
                                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                                               u'default': [],
                                                                                                                                                               u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                                               u'name': u'names',
                                                                                                                                                               u'nargs': u'*',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'value': u'NAME'}],
                                                                                                                                             u'release': u'ALPHA',
                                                                                                                                             u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine unmanaged instance groups in a project.\n\nBy default, unmanaged instance groups from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                                                           u'EXAMPLES': u"To list all unmanaged instance groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all unmanaged instance groups in a project, run:\n\n  $ list --uri\n\nTo list all unmanaged instance groups in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}},
                                                                                                                                   u'list-instances': {u'capsule': u'*(ALPHA)* List instances present in the instance group.',
                                                                                                                                                       u'commands': {},
                                                                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--filter',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--limit',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'LIMIT'},
                                                                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': True,
                                                                                                                                                                                u'description': u'',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': True,
                                                                                                                                                                                u'name': u'--no-uri',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                                u'value': u'NO_URI'},
                                                                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                                   u'group': u'',
                                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                                   u'name': u'--page-size',
                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                   u'required': False,
                                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                                                                  u'--regexp': {u'attr': {},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--regexp',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'REGEXP'},
                                                                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'list',
                                                                                                                                                                                 u'value': u'FIELD'},
                                                                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': False,
                                                                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--uri',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'bool',
                                                                                                                                                                             u'value': u'URI'},
                                                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--zone',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                                                       u'group': False,
                                                                                                                                                       u'groups': {},
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'list-instances',
                                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                                 u'alpha',
                                                                                                                                                                 u'compute',
                                                                                                                                                                 u'instance-groups',
                                                                                                                                                                 u'unmanaged',
                                                                                                                                                                 u'list-instances'],
                                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the instance group.',
                                                                                                                                                                         u'name': u'name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                                       u'release': u'ALPHA',
                                                                                                                                                       u'sections': {u'DESCRIPTION': u'*list-instances* list instances in an instance group.\n'}},
                                                                                                                                   u'remove-instances': {u'capsule': u'*(ALPHA)* Removes resources from an unmanaged instance group by instance name.',
                                                                                                                                                         u'commands': {},
                                                                                                                                                         u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                                                     u'category': u'',
                                                                                                                                                                                     u'choices': [],
                                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                                     u'default': None,
                                                                                                                                                                                     u'description': u'The names of the instances to remove from the instance group.',
                                                                                                                                                                                     u'group': u'',
                                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                                     u'name': u'--instances',
                                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                                     u'required': True,
                                                                                                                                                                                     u'type': u'list',
                                                                                                                                                                                     u'value': u'INSTANCE'},
                                                                                                                                                                    u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--zone',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'ZONE'}},
                                                                                                                                                         u'group': False,
                                                                                                                                                         u'groups': {},
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'remove-instances',
                                                                                                                                                         u'path': [u'gcloud',
                                                                                                                                                                   u'alpha',
                                                                                                                                                                   u'compute',
                                                                                                                                                                   u'instance-groups',
                                                                                                                                                                   u'unmanaged',
                                                                                                                                                                   u'remove-instances'],
                                                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'The name of the instance group.',
                                                                                                                                                                           u'name': u'name',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'value': u'NAME'}],
                                                                                                                                                         u'release': u'ALPHA',
                                                                                                                                                         u'sections': {u'DESCRIPTION': u'*remove-instances* removes instances from an unmanaged instance group using\nthe instance name.\n\nThis does not delete the actual instance resources but removes\nit from the instance group.\n'}},
                                                                                                                                   u'set-named-ports': {u'capsule': u'*(ALPHA)* Sets the list of named ports for an instance group.',
                                                                                                                                                        u'commands': {},
                                                                                                                                                        u'flags': {u'--named-ports': {u'attr': {},
                                                                                                                                                                                      u'category': u'',
                                                                                                                                                                                      u'choices': [],
                                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                                      u'default': None,
                                                                                                                                                                                      u'description': u'The comma-separated list of key:value pairs representing\nthe service name and the port that it is running on.\n+\nTo clear the list of named ports pass empty list as flag value.\nFor example:\n+\n  $ {command} example-instance-group --named-ports ""',
                                                                                                                                                                                      u'group': u'',
                                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                                      u'name': u'--named-ports',
                                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                                      u'required': True,
                                                                                                                                                                                      u'type': u'list',
                                                                                                                                                                                      u'value': u'NAME:PORT'},
                                                                                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--zone',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'ZONE'}},
                                                                                                                                                        u'group': False,
                                                                                                                                                        u'groups': {},
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'set-named-ports',
                                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                                  u'alpha',
                                                                                                                                                                  u'compute',
                                                                                                                                                                  u'instance-groups',
                                                                                                                                                                  u'unmanaged',
                                                                                                                                                                  u'set-named-ports'],
                                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The name of the instance group.',
                                                                                                                                                                          u'name': u'name',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                                        u'release': u'ALPHA',
                                                                                                                                                        u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which\nindicates that the service is available on all instances in the\ngroup. This information is used by the HTTP Load Balancing\nservice.\n\n*set-named-ports* sets the list of named ports for all instances\nin an instance group.\n\nNote: Running this command will clear all existing named ports.\n",
                                                                                                                                                                      u'EXAMPLES': u'For example, to apply the named ports to an entire instance group:\n\n  $ set-named-ports example-instance-group --named-ports example-service:1111 --zone us-central1-a\n\nThe above example will assign a name \'example-service\' for port 1111\nto the instance group called \'example-instance-group\' in the\n``us-central1-a\'\' zone. The command removes any named ports that are\nalready set for this instance group.\n\nTo clear named ports from instance group provide empty named ports\nlist as parameter:\n\n  $ set-named-ports example-instance-group --named-ports "" --zone us-central1-a\n'}}},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': True,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'unmanaged',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'instance-groups',
                                                                                                                               u'unmanaged'],
                                                                                                                     u'positionals': [],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine unmanaged instance groups.'}}},
                                                                                        u'flags': {},
                                                                                        u'group': True,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'instance-groups',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'alpha',
                                                                                                  u'compute',
                                                                                                  u'instance-groups'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'ALPHA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine instance groups. To accommodate the\ndifferences between managed and unmanaged instances, some commands (such as\n`delete`) are in the managed or unmanaged subgroups.'}},
                                                                   u'instance-templates': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine instances templates.',
                                                                                           u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a Compute Engine virtual machine instance template.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--address': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Assigns the given external IP address to the instance that is created.\nThis option can only be used when creating a single instance.',
                                                                                                                                               u'group': u'create.1',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--address',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'ADDRESS'},
                                                                                                                                u'--boot-disk-auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': True,
                                                                                                                                                             u'description': u'Automatically delete boot disks when their instances are deleted. Enabled by default, use *--no-boot-disk-auto-delete* to disable.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--boot-disk-auto-delete',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'bool',
                                                                                                                                                             u'value': u'BOOT_DISK_AUTO_DELETE'},
                                                                                                                                u'--boot-disk-device-name': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The name the guest operating system will see for the boot disk as.  This\noption can only be specified if a new boot disk is being created (as\nopposed to mounting an existing persistent disk).',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--boot-disk-device-name',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'BOOT_DISK_DEVICE_NAME'},
                                                                                                                                u'--boot-disk-size': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"The size of the boot disk. This option can only be specified if a new\nboot disk is being created (as opposed to mounting an existing\npersistent disk). The value must be a whole number followed by a size\nunit of ``KB'' for kilobyte, ``MB'' for megabyte, ``GB'' for gigabyte,\nor ``TB'' for terabyte. For example, ``10GB'' will produce a 10 gigabyte\ndisk. The minimum size a boot disk can have is 10 GB. Disk size must be a\nmultiple of 1 GB.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--boot-disk-size',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'BOOT_DISK_SIZE'},
                                                                                                                                u'--boot-disk-type': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The type of the boot disk. This option can only be specified if a new boot\ndisk is being created (as opposed to mounting an existing persistent\ndisk). To get a list of available disk types, run\n`$ gcloud compute disk-types list`.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--boot-disk-type',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'BOOT_DISK_TYPE'},
                                                                                                                                u'--can-ip-forward': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'If provided, allows the instances to send and receive packets with non-matching destination or source IP addresses.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--can-ip-forward',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'CAN_IP_FORWARD'},
                                                                                                                                u'--create-disk': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"Creates and attaches persistent disks to the instances.\n+\n*name*::: Specifies the name of the disk. This option cannot be\nspecified if more than one instance is being created.\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default.\n+\n*image*::: Specifies the name of the image that the disk will be\ninitialized with. A new disk will be created based on the given\nimage. To view a list of public images and projects, run\n`$ gcloud compute images list`. If omitted image-family must be\nspecified to identify the image.\n+\n*image-family*::: The family of the image that the disk will be\ninitialized with. When a family is specified instead of an image,\nthe latest non-deprecated image associated with that family is\nused.\n+\n*image-project*::: The project that the image or image family\nbelongs to. If not specified and either an image or image family\nis provided, the project of the instance is assumed.\n+\n*size*::: The size of the disk. The value must be a whole number\nfollowed by a size unit of ``KB'' for kilobyte, ``MB'' for\nmegabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For\nexample, ``10GB'' will produce a 10 gigabyte disk. Disk size must\nbe a multiple of 1 GB. If not specified, the default image size\nwill be used for the new disk.\n+\n*type*::: The type of the disk. To get a list of available disk\ntypes, run $ gcloud compute disk-types list. The default disk type\nis ``pd-standard''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--create-disk',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'dict',
                                                                                                                                                   u'value': u'PROPERTY=VALUE'},
                                                                                                                                u'--custom-cpu': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--custom-cpu',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'CUSTOM_CPU'},
                                                                                                                                u'--custom-extensions': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': False,
                                                                                                                                                         u'description': u'If provided, uses extended custom machine type. Both --custom-cpu and --custom-memory must be specified if --custom-extensions is provided.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--custom-extensions',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'CUSTOM_EXTENSIONS'},
                                                                                                                                u'--custom-memory': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--custom-memory',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'CUSTOM_MEMORY'},
                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Specifies a textual description for the instance template.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--disk': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"Attaches persistent disks to the instances. The disks\nspecified must already exist.\n+\n*name*::: The disk to attach to the instances. When creating\nmore than one instance and using this property, the only valid\nmode for attaching the disk is read-only (see *mode* below).\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default. It is an error for mode\nto be ``rw'' when creating more than one instance because\nread-write disks can only be attached to a single instance.\n+\n*boot*::: If ``yes'', indicates that this is a boot disk. The\nvirtual machines will use the first partition of the disk for\ntheir root file systems. The default value for this is ``no''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--disk',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'dict',
                                                                                                                                            u'value': u'DISK'},
                                                                                                                                u'--image': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"Specifies the boot image for the instances. For each\ninstance, a new boot disk will be created from the given\nimage. Each boot disk will have the same name as the\ninstance. To view a list of public images and projects, run\n`$ gcloud compute images list`.\n+\nWhen using this option, ``--boot-disk-device-name'' and\n``--boot-disk-size'' can be used to override the boot disk's\ndevice name and size, respectively.",
                                                                                                                                             u'group': u'create.2',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--image',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'IMAGE'},
                                                                                                                                u'--image-family': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The family of the image that the boot disk will be initialized\nwith. When a family is specified instead of an image, the latest\nnon-deprecated image associated with that family is used.\n+\nBy default, ``debian-8'' is assumed for this flag.",
                                                                                                                                                    u'group': u'create.2',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--image-family',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'IMAGE_FAMILY'},
                                                                                                                                u'--image-project': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"The project against which all image and image family references will be\nresolved. See ``--image'' for more details.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--image-project',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'IMAGE_PROJECT'},
                                                                                                                                u'--local-ssd': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"Attaches a local SSD to the instances.\n+\nThis flag is currently in BETA and may change without notice.\n+\n*device-name*::: Optional. A name that indicates the disk name\nthe guest operating system will see.  If omitted, a device name\nof the form ``local-ssd-N'' will be used.\n+\n*interface*::: Optional. The kind of disk interface exposed to the VM\nfor this SSD.  Valid values are ``SCSI'' and ``NVME''.  SCSI is\nthe default and is supported by more guest operating systems.  NVME\nmay provide higher performance.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--local-ssd',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'dict',
                                                                                                                                                 u'value': u'LOCAL_SSD'},
                                                                                                                                u'--machine-type': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--machine-type',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'MACHINE_TYPE'},
                                                                                                                                u'--maintenance-policy': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [u'MIGRATE',
                                                                                                                                                                       u'TERMINATE'],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--maintenance-policy',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'MAINTENANCE_POLICY'},
                                                                                                                                u'--metadata': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': {},
                                                                                                                                                u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--metadata',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'dict',
                                                                                                                                                u'value': u'KEY=VALUE'},
                                                                                                                                u'--metadata-from-file': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': {},
                                                                                                                                                          u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.",
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--metadata-from-file',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'dict',
                                                                                                                                                          u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                                                                u'--network': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Specifies the network that the instances will be part of. If --subnet is\nalso specified subnet must be a subnetwork of network specified by\n--network. If neither is specified, this defaults to the "default"\nnetwork.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--network',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'NETWORK'},
                                                                                                                                u'--network-interface': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Adds a network interface to the instance. Mutually exclusive with\n--address, --network, --network-tier, --subnet, and --private-network-ip\nflags.\n+\nThe following keys are allowed:\n*address*::: Assigns the given external address to the instance that is\ncreated. Specifying an empty string will assign an ephemeral IP.\nMutually exclusive with no-address. If neither key is present the\ninstance will get an ephemeral IP.\n+\n*network*::: Specifies the network that the interface will be part of.\nIf subnet is also specified it must be subnetwork of this network. If\nneither is specified, this defaults to the "default" network.\n+\n*no-address*::: If specified the interface will have no external IP.\nMutually exclusive with address. If neither key is present the\ninstance will get an ephemeral IP.\n+\n*subnet*::: Specifies the subnet that the interface will be part of.\nIf network key is also specified this must be a subnetwork of the\nspecified network.\n+\n*aliases*::: Specifies the IP aliase ranges to allocate for this\ninterface.  If there are multiple IP aliase ranges, they are seperated\nby semicolons. Currently, only one IP alias range is supported.\n  Each IP alias range consists of a range name and an CIDR net mask\n  (e.g. /24) separated by a colon, or just the net mask.\n  The range name is the name of the range within the network\n  interface\'s subnet from which to allocate an IP alias range. If\n  unspecified, it defaults to the primary IP range of the subnet.\n  IP allocator will pick an available range with the specified netmask\n  and allocate it to this network interface.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--network-interface',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'dict',
                                                                                                                                                         u'value': u'PROPERTY=VALUE'},
                                                                                                                                u'--no-address': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'If provided, the instances will not be assigned external IP addresses.',
                                                                                                                                                  u'group': u'create.1',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--no-address',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_ADDRESS'},
                                                                                                                                u'--no-boot-disk-auto-delete': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': True,
                                                                                                                                                                u'description': u'',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': True,
                                                                                                                                                                u'name': u'--no-boot-disk-auto-delete',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                u'value': u'NO_BOOT_DISK_AUTO_DELETE'},
                                                                                                                                u'--no-can-ip-forward': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': True,
                                                                                                                                                         u'description': u'',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': True,
                                                                                                                                                         u'name': u'--no-can-ip-forward',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'NO_CAN_IP_FORWARD'},
                                                                                                                                u'--no-custom-extensions': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': True,
                                                                                                                                                            u'description': u'',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': True,
                                                                                                                                                            u'name': u'--no-custom-extensions',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'NO_CUSTOM_EXTENSIONS'},
                                                                                                                                u'--no-preemptible': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-preemptible',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_PREEMPTIBLE'},
                                                                                                                                u'--no-restart-on-failure': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': True,
                                                                                                                                                             u'description': u'',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': True,
                                                                                                                                                             u'name': u'--no-restart-on-failure',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'bool',
                                                                                                                                                             u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                                                                u'--no-scopes': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'Create instance without scopes',
                                                                                                                                                 u'group': u'create.3',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--no-scopes',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'NO_SCOPES'},
                                                                                                                                u'--no-service-account': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'Create instance without service account',
                                                                                                                                                          u'group': u'create.4',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--no-service-account',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                                                                u'--preemptible': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'If provided, instances will be preemptible and time-limited.\nInstances may be preempted to free up resources for standard VM instances,\nand will only be able to run for a limited amount of time. Preemptible\ninstances can not be restarted and will not migrate.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--preemptible',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'PREEMPTIBLE'},
                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"The region of the subnetwork to attach. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--region',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'REGION'},
                                                                                                                                u'--restart-on-failure': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': True,
                                                                                                                                                          u'description': u'The instances will be restarted if they are terminated by Compute Engine.\nThis does not affect terminations performed by the user. Enabled by default, use *--no-restart-on-failure* to disable.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--restart-on-failure',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'RESTART_ON_FAILURE'},
                                                                                                                                u'--scopes': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'If not provided, the instance will be assigned the default scopes, described below.\n+\nSCOPE can be either the full URI of the scope or an alias. Available\naliases are:\n+\n  default\n    Scopes assigned to instances by default:\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n    - https://www.googleapis.com/auth/devstorage.read_only\n    - https://www.googleapis.com/auth/logging.write\n    - https://www.googleapis.com/auth/monitoring.write\n    - https://www.googleapis.com/auth/service.management.readonly\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  bigquery\n    - https://www.googleapis.com/auth/bigquery\n+\n  cloud-platform\n    - https://www.googleapis.com/auth/cloud-platform\n+\n  compute-ro\n    - https://www.googleapis.com/auth/compute.readonly\n+\n  compute-rw\n    - https://www.googleapis.com/auth/compute\n+\n  datastore\n    - https://www.googleapis.com/auth/datastore\n+\n  logging-write\n    - https://www.googleapis.com/auth/logging.write\n+\n  monitoring\n    - https://www.googleapis.com/auth/monitoring\n+\n  monitoring-write\n    - https://www.googleapis.com/auth/monitoring.write\n+\n  service-control\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  service-management\n    - https://www.googleapis.com/auth/service.management.readonly\n+\n  sql\n    - https://www.googleapis.com/auth/sqlservice\n+\n  sql-admin\n    - https://www.googleapis.com/auth/sqlservice.admin\n+\n  storage-full\n    - https://www.googleapis.com/auth/devstorage.full_control\n+\n  storage-ro\n    - https://www.googleapis.com/auth/devstorage.read_only\n+\n  storage-rw\n    - https://www.googleapis.com/auth/devstorage.read_write\n+\n  taskqueue\n    - https://www.googleapis.com/auth/taskqueue\n+\n  useraccounts-ro\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n+\n  useraccounts-rw\n    - https://www.googleapis.com/auth/cloud.useraccounts\n+\n  userinfo-email\n    - https://www.googleapis.com/auth/userinfo.email',
                                                                                                                                              u'group': u'create.3',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--scopes',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'SCOPE'},
                                                                                                                                u'--service-account': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u"A service account is an identity attached to the instance. Its access tokens\ncan be accessed through the instance metadata server and are used to\nauthenticate applications on the instance. The account can be either an email\naddress or an alias corresponding to a service account. You can explicitly\nspecify the Compute Engine default service account using the 'default' alias.\n+\nIf not provided, the instance will get project's default service account.",
                                                                                                                                                       u'group': u'create.4',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--service-account',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'SERVICE_ACCOUNT'},
                                                                                                                                u'--subnet': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Specifies the subnet that the instances will be part of. If --network is\nalso specified subnet must be a subnetwork of network specified by\n--network.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--subnet',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'SUBNET'},
                                                                                                                                u'--tags': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Specifies a list of tags to apply to the instances for\nidentifying the instances to which network firewall rules will\napply. See gcloud_compute_firewall-rules_create(1) for more\ndetails.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--tags',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'TAG'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                               u'is_mutex': True,
                                                                                                                                               u'is_required': False},
                                                                                                                                 u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                               u'is_mutex': True,
                                                                                                                                               u'is_required': False},
                                                                                                                                 u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                               u'is_mutex': True,
                                                                                                                                               u'is_required': False},
                                                                                                                                 u'create.4': {u'description': u'At most one of these may be specified:',
                                                                                                                                               u'is_mutex': True,
                                                                                                                                               u'is_required': False}},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'create',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'instance-templates',
                                                                                                                               u'create'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the instance template.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u"*(ALPHA)* *create* facilitates the creation of Google Compute Engine\nvirtual machine instance templates. For example, running:\n\n    $ create INSTANCE-TEMPLATE\n\nwill create one instance templates called 'INSTANCE-TEMPLATE'.\n\nInstance templates are global resources, and can be used to create\ninstances in any zone."}},
                                                                                                         u'create-from-container': {u'capsule': u'*(ALPHA)* Command for creating Google Compute engine virtual machine instance templates for running Docker images.',
                                                                                                                                    u'commands': {},
                                                                                                                                    u'flags': {u'--address': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Assigns the given external IP address to the instance that is created.\nThis option can only be used when creating a single instance.',
                                                                                                                                                              u'group': u'create-from-container.1',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--address',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'ADDRESS'},
                                                                                                                                               u'--boot-disk-auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': True,
                                                                                                                                                                            u'description': u'Automatically delete boot disks when their instances are deleted. Enabled by default, use *--no-boot-disk-auto-delete* to disable.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--boot-disk-auto-delete',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'bool',
                                                                                                                                                                            u'value': u'BOOT_DISK_AUTO_DELETE'},
                                                                                                                                               u'--boot-disk-device-name': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The name the guest operating system will see for the boot disk as.  This\noption can only be specified if a new boot disk is being created (as\nopposed to mounting an existing persistent disk).',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--boot-disk-device-name',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'BOOT_DISK_DEVICE_NAME'},
                                                                                                                                               u'--boot-disk-size': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u"The size of the boot disk. This option can only be specified if a new\nboot disk is being created (as opposed to mounting an existing\npersistent disk). The value must be a whole number followed by a size\nunit of ``KB'' for kilobyte, ``MB'' for megabyte, ``GB'' for gigabyte,\nor ``TB'' for terabyte. For example, ``10GB'' will produce a 10 gigabyte\ndisk. The minimum size a boot disk can have is 10 GB. Disk size must be a\nmultiple of 1 GB.",
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--boot-disk-size',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'BOOT_DISK_SIZE'},
                                                                                                                                               u'--boot-disk-type': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The type of the boot disk. This option can only be specified if a new boot\ndisk is being created (as opposed to mounting an existing persistent\ndisk). To get a list of available disk types, run\n`$ gcloud compute disk-types list`.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--boot-disk-type',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'BOOT_DISK_TYPE'},
                                                                                                                                               u'--can-ip-forward': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': False,
                                                                                                                                                                     u'description': u'If provided, allows the instances to send and receive packets with non-matching destination or source IP addresses.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--can-ip-forward',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'bool',
                                                                                                                                                                     u'value': u'CAN_IP_FORWARD'},
                                                                                                                                               u'--container-manifest': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': True,
                                                                                                                                                                         u'name': u'--container-manifest',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'CONTAINER_MANIFEST'},
                                                                                                                                               u'--create-disk': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u"Creates and attaches persistent disks to the instances.\n+\n*name*::: Specifies the name of the disk. This option cannot be\nspecified if more than one instance is being created.\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default.\n+\n*image*::: Specifies the name of the image that the disk will be\ninitialized with. A new disk will be created based on the given\nimage. To view a list of public images and projects, run\n`$ gcloud compute images list`. If omitted image-family must be\nspecified to identify the image.\n+\n*image-family*::: The family of the image that the disk will be\ninitialized with. When a family is specified instead of an image,\nthe latest non-deprecated image associated with that family is\nused.\n+\n*image-project*::: The project that the image or image family\nbelongs to. If not specified and either an image or image family\nis provided, the project of the instance is assumed.\n+\n*size*::: The size of the disk. The value must be a whole number\nfollowed by a size unit of ``KB'' for kilobyte, ``MB'' for\nmegabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For\nexample, ``10GB'' will produce a 10 gigabyte disk. Disk size must\nbe a multiple of 1 GB. If not specified, the default image size\nwill be used for the new disk.\n+\n*type*::: The type of the disk. To get a list of available disk\ntypes, run $ gcloud compute disk-types list. The default disk type\nis ``pd-standard''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.",
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--create-disk',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'dict',
                                                                                                                                                                  u'value': u'PROPERTY=VALUE'},
                                                                                                                                               u'--custom-cpu': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--custom-cpu',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'CUSTOM_CPU'},
                                                                                                                                               u'--custom-extensions': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': False,
                                                                                                                                                                        u'description': u'If provided, uses extended custom machine type. Both --custom-cpu and --custom-memory must be specified if --custom-extensions is provided.',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--custom-extensions',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'bool',
                                                                                                                                                                        u'value': u'CUSTOM_EXTENSIONS'},
                                                                                                                                               u'--custom-memory': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--custom-memory',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'CUSTOM_MEMORY'},
                                                                                                                                               u'--description': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'Specifies a textual description for the instance template.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--description',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'DESCRIPTION'},
                                                                                                                                               u'--disk': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u"Attaches persistent disks to the instances. The disks\nspecified must already exist.\n+\n*name*::: The disk to attach to the instances. When creating\nmore than one instance and using this property, the only valid\nmode for attaching the disk is read-only (see *mode* below).\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default. It is an error for mode\nto be ``rw'' when creating more than one instance because\nread-write disks can only be attached to a single instance.\n+\n*boot*::: If ``yes'', indicates that this is a boot disk. The\nvirtual machines will use the first partition of the disk for\ntheir root file systems. The default value for this is ``no''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.",
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--disk',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'dict',
                                                                                                                                                           u'value': u'DISK'},
                                                                                                                                               u'--docker-image': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The URL to a Docker image to run on this instance. For example:\n    gcr.io/google-containers/busybox',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--docker-image',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'DOCKER_IMAGE'},
                                                                                                                                               u'--local-ssd': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u"Attaches a local SSD to the instances.\n+\nThis flag is currently in BETA and may change without notice.\n+\n*device-name*::: Optional. A name that indicates the disk name\nthe guest operating system will see.  If omitted, a device name\nof the form ``local-ssd-N'' will be used.\n+\n*interface*::: Optional. The kind of disk interface exposed to the VM\nfor this SSD.  Valid values are ``SCSI'' and ``NVME''.  SCSI is\nthe default and is supported by more guest operating systems.  NVME\nmay provide higher performance.",
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--local-ssd',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'dict',
                                                                                                                                                                u'value': u'LOCAL_SSD'},
                                                                                                                                               u'--machine-type': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--machine-type',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'MACHINE_TYPE'},
                                                                                                                                               u'--maintenance-policy': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [u'MIGRATE',
                                                                                                                                                                                      u'TERMINATE'],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--maintenance-policy',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'MAINTENANCE_POLICY'},
                                                                                                                                               u'--metadata': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': {},
                                                                                                                                                               u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.",
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--metadata',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'dict',
                                                                                                                                                               u'value': u'KEY=VALUE'},
                                                                                                                                               u'--metadata-from-file': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': {},
                                                                                                                                                                         u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.",
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--metadata-from-file',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'dict',
                                                                                                                                                                         u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                                                                               u'--network': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Specifies the network that the instances will be part of. If --subnet is\nalso specified subnet must be a subnetwork of network specified by\n--network. If neither is specified, this defaults to the "default"\nnetwork.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--network',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'NETWORK'},
                                                                                                                                               u'--no-address': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': False,
                                                                                                                                                                 u'description': u'If provided, the instances will not be assigned external IP addresses.',
                                                                                                                                                                 u'group': u'create-from-container.1',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--no-address',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'bool',
                                                                                                                                                                 u'value': u'NO_ADDRESS'},
                                                                                                                                               u'--no-boot-disk-auto-delete': {u'attr': {},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': True,
                                                                                                                                                                               u'description': u'',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': True,
                                                                                                                                                                               u'name': u'--no-boot-disk-auto-delete',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'bool',
                                                                                                                                                                               u'value': u'NO_BOOT_DISK_AUTO_DELETE'},
                                                                                                                                               u'--no-can-ip-forward': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': True,
                                                                                                                                                                        u'description': u'',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': True,
                                                                                                                                                                        u'name': u'--no-can-ip-forward',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'bool',
                                                                                                                                                                        u'value': u'NO_CAN_IP_FORWARD'},
                                                                                                                                               u'--no-custom-extensions': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': True,
                                                                                                                                                                           u'description': u'',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': True,
                                                                                                                                                                           u'name': u'--no-custom-extensions',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'bool',
                                                                                                                                                                           u'value': u'NO_CUSTOM_EXTENSIONS'},
                                                                                                                                               u'--no-preemptible': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': False,
                                                                                                                                                                     u'description': u'',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': True,
                                                                                                                                                                     u'name': u'--no-preemptible',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'bool',
                                                                                                                                                                     u'value': u'NO_PREEMPTIBLE'},
                                                                                                                                               u'--no-restart-on-failure': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': True,
                                                                                                                                                                            u'description': u'',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': True,
                                                                                                                                                                            u'name': u'--no-restart-on-failure',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'bool',
                                                                                                                                                                            u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                                                                               u'--no-run-as-privileged': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': True,
                                                                                                                                                                           u'description': u'',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': True,
                                                                                                                                                                           u'name': u'--no-run-as-privileged',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'bool',
                                                                                                                                                                           u'value': u'NO_RUN_AS_PRIVILEGED'},
                                                                                                                                               u'--no-scopes': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': False,
                                                                                                                                                                u'description': u'Create instance without scopes',
                                                                                                                                                                u'group': u'create-from-container.2',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--no-scopes',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                u'value': u'NO_SCOPES'},
                                                                                                                                               u'--no-service-account': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': False,
                                                                                                                                                                         u'description': u'Create instance without service account',
                                                                                                                                                                         u'group': u'create-from-container.3',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--no-service-account',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'bool',
                                                                                                                                                                         u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                                                                               u'--port-mappings': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'Configure bindings of container ports to the host ports.\nValue of this parameter should be comma-separated list of\nport1:port2:protocol triads representing host port, container port and\nprotocol. Protocol could be: TCP, UDP.\n+\nFor example following command:\n+\n  $ {command} --port-mappings=80:8888:TCP\n+\nwill expose container port 8888 on port 80 of VM. This binding will serve TCP\ntraffic.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--port-mappings',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'list',
                                                                                                                                                                    u'value': u'PORT:TARGET_PORT:PROTOCOL'},
                                                                                                                                               u'--preemptible': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': False,
                                                                                                                                                                  u'description': u'If provided, instances will be preemptible and time-limited.\nInstances may be preempted to free up resources for standard VM instances,\nand will only be able to run for a limited amount of time. Preemptible\ninstances can not be restarted and will not migrate.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--preemptible',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'bool',
                                                                                                                                                                  u'value': u'PREEMPTIBLE'},
                                                                                                                                               u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u"The region of the instance template to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--region',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'REGION'},
                                                                                                                                               u'--restart-on-failure': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': True,
                                                                                                                                                                         u'description': u'The instances will be restarted if they are terminated by Compute Engine.\nThis does not affect terminations performed by the user. Enabled by default, use *--no-restart-on-failure* to disable.',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--restart-on-failure',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'bool',
                                                                                                                                                                         u'value': u'RESTART_ON_FAILURE'},
                                                                                                                                               u'--run-as-privileged': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': False,
                                                                                                                                                                        u'description': u'Privileged mode is useful for containers that want to use linux capabilities\nlike manipulating the network stack and accessing devices.\nWith this argument specified Docker will enable to access to all devices on\nthe host as well as set some configuration in AppArmor or SELinux\nto allow the container nearly all the same access to the host as processes\nrunning outside containers on the host.',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--run-as-privileged',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'bool',
                                                                                                                                                                        u'value': u'RUN_AS_PRIVILEGED'},
                                                                                                                                               u'--run-command': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'Command to be executed when running the Docker image. The command is\nspecified in shell form:\n+\n  command param1 param2 ...\n+\nIt is possible to quote and escape params, for example:\n+\n  $ {command} --run-command=\'echo "Hello world"\'\n+\nCommand will result in error on wrong syntax for this parameter.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--run-command',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'RUN_COMMAND'},
                                                                                                                                               u'--scopes': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'If not provided, the instance will be assigned the default scopes, described below.\n+\nSCOPE can be either the full URI of the scope or an alias. Available\naliases are:\n+\n  default\n    Scopes assigned to instances by default:\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n    - https://www.googleapis.com/auth/devstorage.read_only\n    - https://www.googleapis.com/auth/logging.write\n    - https://www.googleapis.com/auth/monitoring.write\n    - https://www.googleapis.com/auth/service.management.readonly\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  bigquery\n    - https://www.googleapis.com/auth/bigquery\n+\n  cloud-platform\n    - https://www.googleapis.com/auth/cloud-platform\n+\n  compute-ro\n    - https://www.googleapis.com/auth/compute.readonly\n+\n  compute-rw\n    - https://www.googleapis.com/auth/compute\n+\n  datastore\n    - https://www.googleapis.com/auth/datastore\n+\n  logging-write\n    - https://www.googleapis.com/auth/logging.write\n+\n  monitoring\n    - https://www.googleapis.com/auth/monitoring\n+\n  monitoring-write\n    - https://www.googleapis.com/auth/monitoring.write\n+\n  service-control\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  service-management\n    - https://www.googleapis.com/auth/service.management.readonly\n+\n  sql\n    - https://www.googleapis.com/auth/sqlservice\n+\n  sql-admin\n    - https://www.googleapis.com/auth/sqlservice.admin\n+\n  storage-full\n    - https://www.googleapis.com/auth/devstorage.full_control\n+\n  storage-ro\n    - https://www.googleapis.com/auth/devstorage.read_only\n+\n  storage-rw\n    - https://www.googleapis.com/auth/devstorage.read_write\n+\n  taskqueue\n    - https://www.googleapis.com/auth/taskqueue\n+\n  useraccounts-ro\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n+\n  useraccounts-rw\n    - https://www.googleapis.com/auth/cloud.useraccounts\n+\n  userinfo-email\n    - https://www.googleapis.com/auth/userinfo.email',
                                                                                                                                                             u'group': u'create-from-container.2',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--scopes',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'list',
                                                                                                                                                             u'value': u'SCOPE'},
                                                                                                                                               u'--service-account': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u"A service account is an identity attached to the instance. Its access tokens\ncan be accessed through the instance metadata server and are used to\nauthenticate applications on the instance. The account can be either an email\naddress or an alias corresponding to a service account. You can explicitly\nspecify the Compute Engine default service account using the 'default' alias.\n+\nIf not provided, the instance will get project's default service account.",
                                                                                                                                                                      u'group': u'create-from-container.3',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--service-account',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'SERVICE_ACCOUNT'},
                                                                                                                                               u'--subnet': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Specifies the subnet that the instances will be part of. If --network is\nalso specified subnet must be a subnetwork of network specified by\n--network.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--subnet',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'SUBNET'},
                                                                                                                                               u'--tags': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Specifies a list of tags to apply to the instances for\nidentifying the instances to which network firewall rules will\napply. See gcloud_compute_firewall-rules_create(1) for more\ndetails.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--tags',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'list',
                                                                                                                                                           u'value': u'TAG'}},
                                                                                                                                    u'group': False,
                                                                                                                                    u'groups': {u'create-from-container.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                                             u'is_required': False},
                                                                                                                                                u'create-from-container.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                                             u'is_required': False},
                                                                                                                                                u'create-from-container.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                                             u'is_required': False}},
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'create-from-container',
                                                                                                                                    u'path': [u'gcloud',
                                                                                                                                              u'alpha',
                                                                                                                                              u'compute',
                                                                                                                                              u'instance-templates',
                                                                                                                                              u'create-from-container'],
                                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The name of the instance template.',
                                                                                                                                                      u'name': u'name',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'value': u'NAME'}],
                                                                                                                                    u'release': u'ALPHA',
                                                                                                                                    u'sections': {u'DESCRIPTION': u"*create-from-container* facilitates the creation of a Google Compute Engine virtual\nmachine instance template that runs a Docker image. For example, running:\n\n  $ create-from-container instance-template-1 --docker-image=gcr.io/google-containers/busybox\n\nwill create an instance template that runs the 'busybox' image.\nIn this example, the instance template will have the name\n'instance-template-1'\n\nFor more examples, refer to the *EXAMPLES* section below.\n",
                                                                                                                                                  u'EXAMPLES': u'To create a template named \'instance-template-1\' that runs the\ngcr.io/google-containers/busybox image and exposes port 80, run:\n\n  $ create-from-container instance-template-1 --docker-image=gcr.io/google-containers/busybox --port-mappings=80:80:TCP\n\nTo create a template named \'instance-template-1\' that runs the\ngcr.io/google-containers/busybox image and executes \'echo "Hello world"\'\nas a command, run:\n\n  $ create-from-container instance-template-1 --docker-image=gcr.io/google-containers/busybox --run-command=\'echo "Hello world"\'\n\nTo create a template running gcr.io/google-containers/busybox in\nprivileged mode, run:\n\n  $ create-from-container instance-template-1 --docker-image=gcr.io/google-containers/busybox --run-as-privileged\n'}},
                                                                                                         u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine virtual machine instance templates.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'delete',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'instance-templates',
                                                                                                                               u'delete'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The resources to delete.',
                                                                                                                                       u'name': u'names',
                                                                                                                                       u'nargs': u'+',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine virtual machine\ninstance templates.\n'}},
                                                                                                         u'describe': {u'capsule': u'*(ALPHA)* Describe a virtual machine instance template.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'describe',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'instance-templates',
                                                                                                                                 u'describe'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the resource to fetch.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine virtual machine instance template.\n'}},
                                                                                                         u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine instance templates.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--filter',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--limit',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--page-size',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                              u'--regexp': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--regexp',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGEXP'},
                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'FIELD'},
                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'URI'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'list',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'instance-templates',
                                                                                                                             u'list'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                     u'name': u'names',
                                                                                                                                     u'nargs': u'*',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine instance templates in a project.\n\nBy default, instance templates from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                                 u'EXAMPLES': u"To list all instance templates in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all instance templates in a project, run:\n\n  $ list --uri\n\nTo list all instance templates in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                                           u'flags': {},
                                                                                           u'group': True,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'instance-templates',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'alpha',
                                                                                                     u'compute',
                                                                                                     u'instance-templates'],
                                                                                           u'positionals': [],
                                                                                           u'release': u'ALPHA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists, creates, deletes, and modifies Compute Engine instance templates.\n\nMore information on Compute Engine instance templates can be found here:\n[](https://cloud.google.com/compute/docs/instance-templates)'}},
                                                                   u'instances': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine virtual machine instances.',
                                                                                  u'commands': {u'add-access-config': {u'capsule': u'*(ALPHA)* Create a Google Compute Engine virtual machine access configuration.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--access-config-name': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': u'external-nat',
                                                                                                                                                            u'description': u"Specifies the name of the new access configuration. ``external-nat''\nis used as the default if this flag is not provided.",
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--access-config-name',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'ACCESS_CONFIG_NAME'},
                                                                                                                                  u'--address': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Specifies the external IP address of the new access\nconfiguration. If this is not specified, then the service will\nchoose an available ephemeral IP address. If an explicit IP\naddress is given, then that IP address must be reserved by the\nproject and not be in use by another resource.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--address',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'ADDRESS'},
                                                                                                                                  u'--network-interface': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': u'nic0',
                                                                                                                                                           u'description': u'Specifies the name of the network interface which contains the access\nconfiguration. If this is not provided, then "nic0" is used\nas the default.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--network-interface',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'NETWORK_INTERFACE'},
                                                                                                                                  u'--network-tier': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [u'PREMIUM',
                                                                                                                                                                   u'SELECT'],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': u'PREMIUM',
                                                                                                                                                      u'description': u'Specifies the network tier of the access configuration. It can only take\nthe following values: PREMIUM, SELECT. The default network tier is\nPREMIUM. _NETWORK_TIER_ must be one of: *PREMIUM*, *SELECT*.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--network-tier',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'NETWORK_TIER'},
                                                                                                                                  u'--no-public-dns': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'If provided, the external IP in the access configuration will not be\nassigned a public DNS name.',
                                                                                                                                                       u'group': u'add-access-config.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--no-public-dns',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_PUBLIC_DNS'},
                                                                                                                                  u'--no-public-ptr': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'If provided, no DNS PTR record is created for the external IP in the\naccess configuration. Mutually exclusive with public-ptr-domain.',
                                                                                                                                                       u'group': u'add-access-config.2',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--no-public-ptr',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_PUBLIC_PTR'},
                                                                                                                                  u'--no-public-ptr-domain': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': False,
                                                                                                                                                              u'description': u'If both this flag and --public-ptr are specified, creates a DNS PTR\nrecord for the external IP in the access configuration with the PTR\ndomain name being the DNS name of the instance.',
                                                                                                                                                              u'group': u'add-access-config.3',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--no-public-ptr-domain',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'bool',
                                                                                                                                                              u'value': u'NO_PUBLIC_PTR_DOMAIN'},
                                                                                                                                  u'--public-dns': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Assigns a public DNS name to the external IP in the access\nconfiguration. This option can only be specified for the default\nnetwork-interface, "nic0".',
                                                                                                                                                    u'group': u'add-access-config.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--public-dns',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'PUBLIC_DNS'},
                                                                                                                                  u'--public-ptr': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Creates a DNS PTR record for the external IP in the access\nconfiguration. This option can only be specified for the default\nnetwork-interface, "nic0".',
                                                                                                                                                    u'group': u'add-access-config.2',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--public-ptr',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'PUBLIC_PTR'},
                                                                                                                                  u'--public-ptr-domain': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Assigns a custom PTR domain for the external IP in the access\nconfiguration. Mutually exclusive with no-public-ptr. This option can\nonly be specified for the default network-interface, "nic0".',
                                                                                                                                                           u'group': u'add-access-config.3',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--public-ptr-domain',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'PUBLIC_PTR_DOMAIN'},
                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--zone',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {u'add-access-config.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                            u'is_required': False},
                                                                                                                                   u'add-access-config.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                            u'is_required': False},
                                                                                                                                   u'add-access-config.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                            u'is_required': False}},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'add-access-config',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'instances',
                                                                                                                                 u'add-access-config'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the instance.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*add-access-config* is used to create access configurations for network\ninterfaces of Google Compute Engine virtual machines.\n'}},
                                                                                                u'add-metadata': {u'capsule': u'*(ALPHA)* Add or update instance metadata.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--metadata': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': {},
                                                                                                                                             u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--metadata',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'dict',
                                                                                                                                             u'value': u'KEY=VALUE'},
                                                                                                                             u'--metadata-from-file': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': {},
                                                                                                                                                       u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--metadata-from-file',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'dict',
                                                                                                                                                       u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                                                             u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"The zone of the instance to set metadata on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--zone',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'ZONE'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'add-metadata',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'compute',
                                                                                                                            u'instances',
                                                                                                                            u'add-metadata'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the instance whose metadata should be modified.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'add-metadata can be used to add or update the metadata of a\nvirtual machine instance. Every instance has access to a\nmetadata server that can be used to query metadata that has\nbeen set through this tool. For information on metadata, see\n[](https://cloud.google.com/compute/docs/metadata)\n\nOnly metadata keys that are provided are mutated. Existing\nmetadata entries will remain unaffected.\n'}},
                                                                                                u'add-tags': {u'capsule': u'*(ALPHA)* Add tags to Google Compute Engine virtual machine instances.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--tags': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Specifies strings to be attached to the instance for later\nidentifying the instance when adding network firewall rules.\nMultiple tags can be attached by repeating this flag.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--tags',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': True,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'TAG'},
                                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"The zone of the instance to set tags on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--zone',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'ZONE'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'add-tags',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'compute',
                                                                                                                        u'instances',
                                                                                                                        u'add-tags'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the instance whose tags should be modified.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u"*add-tags* is used to add tags to Google Compute Engine virtual\nmachine instances. For example, running:\n\n  $ add-tags example-instance --tags tag-1,tag-2\n\nwill add tags ``tag-1'' and ``tag-2'' to 'example-instance'.\n\nTags can be used to identify the instances when adding network\nfirewall rules. Tags can also be used to get firewall rules that\nalready exist to be applied to the instance. See\ngcloud_compute_firewall-rules_create(1) for more details.\n"}},
                                                                                                u'attach-disk': {u'capsule': u'*(ALPHA)* Attach a disk to an instance.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--csek-key-file',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'FILE'},
                                                                                                                            u'--device-name': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'An optional name that indicates the disk name the guest operating system will see. (Note: Device name does not correspond to mounted volume name)',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--device-name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'DEVICE_NAME'},
                                                                                                                            u'--disk': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the disk to attach to the instance.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--disk',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': True,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DISK'},
                                                                                                                            u'--disk-scope': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [u'regional',
                                                                                                                                                           u'zonal'],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': u'zonal',
                                                                                                                                              u'description': u'',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': True,
                                                                                                                                              u'name': u'--disk-scope',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'DISK_SCOPE'},
                                                                                                                            u'--force-attach': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--force-attach',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'FORCE_ATTACH'},
                                                                                                                            u'--mode': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [u'ro',
                                                                                                                                                     u'rw'],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': u'rw',
                                                                                                                                        u'description': u'Specifies the mode of the disk. _MODE_ must be one of:\n+\n*ro*::: Read-only.\n*rw*::: Read-write. It is an error to attach a disk in read-write mode to more than one instance.\n+',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--mode',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'MODE'},
                                                                                                                            u'--no-force-attach': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-force-attach',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_FORCE_ATTACH'},
                                                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--zone',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'ZONE'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'attach-disk',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'instances',
                                                                                                                           u'attach-disk'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the instance.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u"*attach-disk* is used to attach a disk to an instance. For example,\n\n  $ gcloud compute instances attach-disk example-instance --disk DISK --zone us-central1-a\n\nattaches the disk named 'DISK' to the instance named\n'example-instance' in zone ``us-central1-a''.\n"}},
                                                                                                u'create': {u'capsule': u'*(ALPHA)* Create Google Compute Engine virtual machine instances.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--accelerator': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"Attaches accelerators (e.g. GPUs) to the instances.\n+\n*type*::: The specific type (e.g. nvidia-tesla-k80 for nVidia Tesla K80)\nof accelerator to attach to the instances. Use 'gcloud compute\naccelerator-types list' to learn about all available accelerator types.\n+\n*count*::: The number of pieces of the accelerator to attach to the\ninstances. The default value is 1.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--accelerator',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'dict',
                                                                                                                                          u'value': u'type=TYPE,[count=COUNT]'},
                                                                                                                       u'--address': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Assigns the given external address to the instance that is created.\nThe address may be an IP address or the name or URI of an address\nresource. This option can only be used when creating a single instance.',
                                                                                                                                      u'group': u'create.1',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--address',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ADDRESS'},
                                                                                                                       u'--boot-disk-auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': True,
                                                                                                                                                    u'description': u'Automatically delete boot disks when their instances are deleted. Enabled by default, use *--no-boot-disk-auto-delete* to disable.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--boot-disk-auto-delete',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'BOOT_DISK_AUTO_DELETE'},
                                                                                                                       u'--boot-disk-device-name': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The name the guest operating system will see for the boot disk as.  This\noption can only be specified if a new boot disk is being created (as\nopposed to mounting an existing persistent disk).',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--boot-disk-device-name',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'BOOT_DISK_DEVICE_NAME'},
                                                                                                                       u'--boot-disk-size': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"The size of the boot disk. This option can only be specified if a new\nboot disk is being created (as opposed to mounting an existing\npersistent disk). The value must be a whole number followed by a size\nunit of ``KB'' for kilobyte, ``MB'' for megabyte, ``GB'' for gigabyte,\nor ``TB'' for terabyte. For example, ``10GB'' will produce a 10 gigabyte\ndisk. The minimum size a boot disk can have is 10 GB. Disk size must be a\nmultiple of 1 GB.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--boot-disk-size',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'BOOT_DISK_SIZE'},
                                                                                                                       u'--boot-disk-type': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The type of the boot disk. This option can only be specified if a new boot\ndisk is being created (as opposed to mounting an existing persistent\ndisk). To get a list of available disk types, run\n`$ gcloud compute disk-types list`.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--boot-disk-type',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'BOOT_DISK_TYPE'},
                                                                                                                       u'--can-ip-forward': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'If provided, allows the instances to send and receive packets with non-matching destination or source IP addresses.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--can-ip-forward',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'CAN_IP_FORWARD'},
                                                                                                                       u'--create-disk': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"Creates and attaches persistent disks to the instances.\n+\n*name*::: Specifies the name of the disk. This option cannot be\nspecified if more than one instance is being created.\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default.\n+\n*image*::: Specifies the name of the image that the disk will be\ninitialized with. A new disk will be created based on the given\nimage. To view a list of public images and projects, run\n`$ gcloud compute images list`. If omitted image-family must be\nspecified to identify the image.\n+\n*image-family*::: The family of the image that the disk will be\ninitialized with. When a family is specified instead of an image,\nthe latest non-deprecated image associated with that family is\nused.\n+\n*image-project*::: The project that the image or image family\nbelongs to. If not specified and either an image or image family\nis provided, the project of the instance is assumed.\n+\n*size*::: The size of the disk. The value must be a whole number\nfollowed by a size unit of ``KB'' for kilobyte, ``MB'' for\nmegabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For\nexample, ``10GB'' will produce a 10 gigabyte disk. Disk size must\nbe a multiple of 1 GB. If not specified, the default image size\nwill be used for the new disk.\n+\n*type*::: The type of the disk. To get a list of available disk\ntypes, run $ gcloud compute disk-types list. The default disk type\nis ``pd-standard''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--create-disk',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'dict',
                                                                                                                                          u'value': u'PROPERTY=VALUE'},
                                                                                                                       u'--csek-key-file': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--csek-key-file',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'FILE'},
                                                                                                                       u'--custom-cpu': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--custom-cpu',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'CUSTOM_CPU'},
                                                                                                                       u'--custom-extensions': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'If provided, uses extended custom machine type. Both --custom-cpu and --custom-memory must be specified if --custom-extensions is provided.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--custom-extensions',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'CUSTOM_EXTENSIONS'},
                                                                                                                       u'--custom-memory': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--custom-memory',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'CUSTOM_MEMORY'},
                                                                                                                       u'--description': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Specifies a textual description of the instances.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--description',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                                       u'--disk': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"Attaches persistent disks to the instances. The disks\nspecified must already exist.\n+\n*name*::: The disk to attach to the instances. When creating\nmore than one instance and using this property, the only valid\nmode for attaching the disk is read-only (see *mode* below).\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default. It is an error for mode\nto be ``rw'' when creating more than one instance because\nread-write disks can only be attached to a single instance.\n+\n*boot*::: If ``yes'', indicates that this is a boot disk. The\nvirtual machines will use the first partition of the disk for\ntheir root file systems. The default value for this is ``no''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.\n+\n*scope*::: Can be `zonal` or `regional`. If ``zonal'', the disk is\ninterpreted as a zonal disk in the same zone as the instance (default).\nIf ``regional'', the disk is interpreted as a regional disk in the same\nregion as the instance. The default value for this is ``zonal''.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--disk',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'dict',
                                                                                                                                   u'value': u'DISK'},
                                                                                                                       u'--image': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"Specifies the boot image for the instances. For each\ninstance, a new boot disk will be created from the given\nimage. Each boot disk will have the same name as the\ninstance. To view a list of public images and projects, run\n`$ gcloud compute images list`.\n+\nWhen using this option, ``--boot-disk-device-name'' and\n``--boot-disk-size'' can be used to override the boot disk's\ndevice name and size, respectively.",
                                                                                                                                    u'group': u'create.2',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--image',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'IMAGE'},
                                                                                                                       u'--image-family': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The family of the image that the boot disk will be initialized\nwith. When a family is specified instead of an image, the latest\nnon-deprecated image associated with that family is used.\n+\nBy default, ``debian-8'' is assumed for this flag.",
                                                                                                                                           u'group': u'create.2',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--image-family',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'IMAGE_FAMILY'},
                                                                                                                       u'--image-project': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The project against which all image and image family references will be\nresolved. See ``--image'' for more details.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--image-project',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'IMAGE_PROJECT'},
                                                                                                                       u'--local-ssd': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"Attaches a local SSD to the instances.\n+\nThis flag is currently in BETA and may change without notice.\n+\n*device-name*::: Optional. A name that indicates the disk name\nthe guest operating system will see.  If omitted, a device name\nof the form ``local-ssd-N'' will be used.\n+\n*interface*::: Optional. The kind of disk interface exposed to the VM\nfor this SSD.  Valid values are ``SCSI'' and ``NVME''.  SCSI is\nthe default and is supported by more guest operating systems.  NVME\nmay provide higher performance.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--local-ssd',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'dict',
                                                                                                                                        u'value': u'LOCAL_SSD'},
                                                                                                                       u'--machine-type': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--machine-type',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'MACHINE_TYPE'},
                                                                                                                       u'--maintenance-policy': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [u'MIGRATE',
                                                                                                                                                              u'TERMINATE'],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--maintenance-policy',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'MAINTENANCE_POLICY'},
                                                                                                                       u'--metadata': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': {},
                                                                                                                                       u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--metadata',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'dict',
                                                                                                                                       u'value': u'KEY=VALUE'},
                                                                                                                       u'--metadata-from-file': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': {},
                                                                                                                                                 u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--metadata-from-file',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'dict',
                                                                                                                                                 u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                                                       u'--min-cpu-platform': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'When specified the VM will be scheduled on host with specified CPU\narchitecture or a newer one. To list available CPU platforms in given\nzone run\n+\n    $ gcloud compute zones describe ZONE --format="value(availableCpuPlatforms)"\n+\nCPU platform selection is available only in selected zones.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--min-cpu-platform',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PLATFORM'},
                                                                                                                       u'--network': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Specifies the network that the instances will be part of. If --subnet is\nalso specified subnet must be a subnetwork of network specified by\n--network. If neither is specified, this defaults to the "default"\nnetwork.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--network',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'NETWORK'},
                                                                                                                       u'--network-interface': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Adds a network interface to the instance. Mutually exclusive with\n--address, --network, --network-tier, --subnet, and --private-network-ip\nflags.\n+\nThe following keys are allowed:\n*address*::: Assigns the given external address to the instance that is\ncreated. Specifying an empty string will assign an ephemeral IP.\nMutually exclusive with no-address. If neither key is present the\ninstance will get an ephemeral IP.\n+\n*network*::: Specifies the network that the interface will be part of.\nIf subnet is also specified it must be subnetwork of this network. If\nneither is specified, this defaults to the "default" network.\n+\n*no-address*::: If specified the interface will have no external IP.\nMutually exclusive with address. If neither key is present the\ninstance will get an ephemeral IP.\n+\n*network-tier*::: Specifies the network tier of the interface. It can\nonly take the following values: PREMIUM, SELECT. The default network\ntier is PREMIUM.\n+\n*private-network-ip*::: Assigns the given RFC1918 IP address to the\ninterface.\n+\n*subnet*::: Specifies the subnet that the interface will be part of.\nIf network key is also specified this must be a subnetwork of the\nspecified network.\n+\n*aliases*::: Specifies the IP aliase ranges to allocate for this\ninterface.  If there are multiple IP aliase ranges, they are seperated\nby semicolons. Currently, only one IP alias range is supported.\n  Each IP alias range consists of a range name and an IP range\n  separated by a colon, or just the IP range.\n  The range name is the name of the range within the network\n  interface\'s subnet from which to allocate an IP alias range. If\n  unspecified, it defaults to the primary IP range of the subnet.\n  The IP range can be a CIDR range (e.g. 192.168.100.0/24), a single\n  IP address (e.g. 192.168.100.1), or a net mask in CIDR format (e.g.\n  /24). If the IP range is specified by CIDR range or single IP\n  address, it must belong to the CIDR range specified by the range\n  name on the subnet. If the IP range is specified by net mask, the\n  IP allocator will pick an available range with the specified netmask\n  and allocate it to this network interface.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--network-interface',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'dict',
                                                                                                                                                u'value': u'PROPERTY=VALUE'},
                                                                                                                       u'--network-tier': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [u'PREMIUM',
                                                                                                                                                        u'SELECT'],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': u'PREMIUM',
                                                                                                                                           u'description': u'Specifies the network tier that will be used to configure the instance.\nIt can only take the following values: PREMIUM, SELECT. The default\nnetwork tier is PREMIUM. _NETWORK_TIER_ must be one of: *PREMIUM*, *SELECT*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--network-tier',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'NETWORK_TIER'},
                                                                                                                       u'--no-address': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'If provided, the instances will not be assigned external IP addresses.',
                                                                                                                                         u'group': u'create.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--no-address',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_ADDRESS'},
                                                                                                                       u'--no-boot-disk-auto-delete': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': True,
                                                                                                                                                       u'description': u'',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': True,
                                                                                                                                                       u'name': u'--no-boot-disk-auto-delete',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_BOOT_DISK_AUTO_DELETE'},
                                                                                                                       u'--no-can-ip-forward': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-can-ip-forward',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_CAN_IP_FORWARD'},
                                                                                                                       u'--no-custom-extensions': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': True,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-custom-extensions',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_CUSTOM_EXTENSIONS'},
                                                                                                                       u'--no-preemptible': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-preemptible',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_PREEMPTIBLE'},
                                                                                                                       u'--no-public-dns': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'If provided, the instance will not be assigned a public DNS name.',
                                                                                                                                            u'group': u'create.3',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--no-public-dns',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_PUBLIC_DNS'},
                                                                                                                       u'--no-public-ptr': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'If provided, no DNS PTR record is created for the external IP of the\ninstance. Mutually exclusive with public-ptr-domain.',
                                                                                                                                            u'group': u'create.4',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--no-public-ptr',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_PUBLIC_PTR'},
                                                                                                                       u'--no-public-ptr-domain': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'If both this flag and --public-ptr are specified, creates a DNS PTR\nrecord for the external IP of the instance with the PTR domain name\nbeing the DNS name of the instance.',
                                                                                                                                                   u'group': u'create.5',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--no-public-ptr-domain',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_PUBLIC_PTR_DOMAIN'},
                                                                                                                       u'--no-require-csek-key-create': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': True,
                                                                                                                                                         u'description': u'',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': True,
                                                                                                                                                         u'name': u'--no-require-csek-key-create',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'NO_REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                       u'--no-restart-on-failure': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': True,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-restart-on-failure',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                                                       u'--no-scopes': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Create instance without scopes',
                                                                                                                                        u'group': u'create.6',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--no-scopes',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_SCOPES'},
                                                                                                                       u'--no-service-account': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'Create instance without service account',
                                                                                                                                                 u'group': u'create.7',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--no-service-account',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                                                       u'--preemptible': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'If provided, instances will be preemptible and time-limited.\nInstances may be preempted to free up resources for standard VM instances,\nand will only be able to run for a limited amount of time. Preemptible\ninstances can not be restarted and will not migrate.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--preemptible',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'PREEMPTIBLE'},
                                                                                                                       u'--private-network-ip': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Specifies the RFC1918 IP to assign to the instance. The IP should be in\nthe subnet or legacy network IP range.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--private-network-ip',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'PRIVATE_NETWORK_IP'},
                                                                                                                       u'--public-dns': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Assigns a public DNS name to the instance.',
                                                                                                                                         u'group': u'create.3',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--public-dns',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'PUBLIC_DNS'},
                                                                                                                       u'--public-ptr': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Creates a DNS PTR record for the external IP of the instance.',
                                                                                                                                         u'group': u'create.4',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--public-ptr',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'PUBLIC_PTR'},
                                                                                                                       u'--public-ptr-domain': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Assigns a custom PTR domain for the external IP of the instance.\nMutually exclusive with no-public-ptr.',
                                                                                                                                                u'group': u'create.5',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--public-ptr-domain',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PUBLIC_PTR_DOMAIN'},
                                                                                                                       u'--require-csek-key-create': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': True,
                                                                                                                                                      u'description': u'Refuse to create resources not protected by a user managed key in\nthe key file when --csek-key-file is given. This behavior is enabled\nby default to prevent incorrect gcloud invocations from accidentally\ncreating resources with no user managed key. Disabling the check\nallows creation of some resources without a matching\nCustomer-Supplied Encryption Key in the supplied --csek-key-file.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details. Enabled by default, use *--no-require-csek-key-create* to disable.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--require-csek-key-create',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                       u'--restart-on-failure': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': True,
                                                                                                                                                 u'description': u'The instances will be restarted if they are terminated by Compute Engine.\nThis does not affect terminations performed by the user. Enabled by default, use *--no-restart-on-failure* to disable.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--restart-on-failure',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'RESTART_ON_FAILURE'},
                                                                                                                       u'--scopes': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'If not provided, the instance will be assigned the default scopes, described below.\n+\nSCOPE can be either the full URI of the scope or an alias. Available\naliases are:\n+\n  default\n    Scopes assigned to instances by default:\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n    - https://www.googleapis.com/auth/devstorage.read_only\n    - https://www.googleapis.com/auth/logging.write\n    - https://www.googleapis.com/auth/monitoring.write\n    - https://www.googleapis.com/auth/service.management.readonly\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  bigquery\n    - https://www.googleapis.com/auth/bigquery\n+\n  cloud-platform\n    - https://www.googleapis.com/auth/cloud-platform\n+\n  compute-ro\n    - https://www.googleapis.com/auth/compute.readonly\n+\n  compute-rw\n    - https://www.googleapis.com/auth/compute\n+\n  datastore\n    - https://www.googleapis.com/auth/datastore\n+\n  logging-write\n    - https://www.googleapis.com/auth/logging.write\n+\n  monitoring\n    - https://www.googleapis.com/auth/monitoring\n+\n  monitoring-write\n    - https://www.googleapis.com/auth/monitoring.write\n+\n  service-control\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  service-management\n    - https://www.googleapis.com/auth/service.management.readonly\n+\n  sql\n    - https://www.googleapis.com/auth/sqlservice\n+\n  sql-admin\n    - https://www.googleapis.com/auth/sqlservice.admin\n+\n  storage-full\n    - https://www.googleapis.com/auth/devstorage.full_control\n+\n  storage-ro\n    - https://www.googleapis.com/auth/devstorage.read_only\n+\n  storage-rw\n    - https://www.googleapis.com/auth/devstorage.read_write\n+\n  taskqueue\n    - https://www.googleapis.com/auth/taskqueue\n+\n  useraccounts-ro\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n+\n  useraccounts-rw\n    - https://www.googleapis.com/auth/cloud.useraccounts\n+\n  userinfo-email\n    - https://www.googleapis.com/auth/userinfo.email',
                                                                                                                                     u'group': u'create.6',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--scopes',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'SCOPE'},
                                                                                                                       u'--service-account': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A service account is an identity attached to the instance. Its access tokens\ncan be accessed through the instance metadata server and are used to\nauthenticate applications on the instance. The account can be either an email\naddress or an alias corresponding to a service account. You can explicitly\nspecify the Compute Engine default service account using the 'default' alias.\n+\nIf not provided, the instance will get project's default service account.",
                                                                                                                                              u'group': u'create.7',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--service-account',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'SERVICE_ACCOUNT'},
                                                                                                                       u'--sole-tenancy-host': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--sole-tenancy-host',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'SOLE_TENANCY_HOST'},
                                                                                                                       u'--subnet': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Specifies the subnet that the instances will be part of. If --network is\nalso specified subnet must be a subnetwork of network specified by\n--network.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--subnet',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'SUBNET'},
                                                                                                                       u'--tags': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Specifies a list of tags to apply to the instances for\nidentifying the instances to which network firewall rules will\napply. See gcloud_compute_firewall-rules_create(1) for more\ndetails.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--tags',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'TAG'},
                                                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--zone',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'ZONE'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False},
                                                                                                                        u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False},
                                                                                                                        u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False},
                                                                                                                        u'create.4': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False},
                                                                                                                        u'create.5': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False},
                                                                                                                        u'create.6': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False},
                                                                                                                        u'create.7': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False}},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'create',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'compute',
                                                                                                                      u'instances',
                                                                                                                      u'create'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The names of the instances.',
                                                                                                                              u'name': u'names',
                                                                                                                              u'nargs': u'+',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAMES'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*create* facilitates the creation of Google Compute Engine\nvirtual machines. For example, running:\n\n  $ create example-instance-1 example-instance-2 example-instance-3 --zone us-central1-a\n\nwill create three instances called `example-instance-1`,\n`example-instance-2`, and `example-instance-3` in the\n`us-central1-a` zone.\n\nWhen an instance is in RUNNING state and the system begins to boot,\nthe instance creation is considered finished, and the command returns\nwith a list of new virtual machines.  Note that you usually cannot log\ninto a new instance until it finishes booting. Check the progress of an\ninstance using `gcloud compute instances get-serial-port-output`.\n\nFor more examples, refer to the *EXAMPLES* section below.\n',
                                                                                                                          u'EXAMPLES': u"To create an instance with the latest ``Red Hat Enterprise Linux\n7'' image available, run:\n\n  $ create example-instance --image-family rhel-7 --image-project rhel-cloud --zone us-central1-a\n"}},
                                                                                                u'create-from-container': {u'capsule': u'*(ALPHA)* Command for creating Google Compute engine virtual machine instances running Docker images.',
                                                                                                                           u'commands': {},
                                                                                                                           u'flags': {u'--address': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Assigns the given external address to the instance that is created.\nThe address may be an IP address or the name or URI of an address\nresource. This option can only be used when creating a single instance.',
                                                                                                                                                     u'group': u'create-from-container.1',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--address',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'ADDRESS'},
                                                                                                                                      u'--boot-disk-auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': True,
                                                                                                                                                                   u'description': u'Automatically delete boot disks when their instances are deleted. Enabled by default, use *--no-boot-disk-auto-delete* to disable.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--boot-disk-auto-delete',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'bool',
                                                                                                                                                                   u'value': u'BOOT_DISK_AUTO_DELETE'},
                                                                                                                                      u'--boot-disk-device-name': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The name the guest operating system will see for the boot disk as.  This\noption can only be specified if a new boot disk is being created (as\nopposed to mounting an existing persistent disk).',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--boot-disk-device-name',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'BOOT_DISK_DEVICE_NAME'},
                                                                                                                                      u'--boot-disk-size': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u"The size of the boot disk. This option can only be specified if a new\nboot disk is being created (as opposed to mounting an existing\npersistent disk). The value must be a whole number followed by a size\nunit of ``KB'' for kilobyte, ``MB'' for megabyte, ``GB'' for gigabyte,\nor ``TB'' for terabyte. For example, ``10GB'' will produce a 10 gigabyte\ndisk. The minimum size a boot disk can have is 10 GB. Disk size must be a\nmultiple of 1 GB.",
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--boot-disk-size',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'BOOT_DISK_SIZE'},
                                                                                                                                      u'--boot-disk-type': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The type of the boot disk. This option can only be specified if a new boot\ndisk is being created (as opposed to mounting an existing persistent\ndisk). To get a list of available disk types, run\n`$ gcloud compute disk-types list`.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--boot-disk-type',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'BOOT_DISK_TYPE'},
                                                                                                                                      u'--can-ip-forward': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': False,
                                                                                                                                                            u'description': u'If provided, allows the instances to send and receive packets with non-matching destination or source IP addresses.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--can-ip-forward',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'CAN_IP_FORWARD'},
                                                                                                                                      u'--container-manifest': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': True,
                                                                                                                                                                u'name': u'--container-manifest',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'CONTAINER_MANIFEST'},
                                                                                                                                      u'--create-disk': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u"Creates and attaches persistent disks to the instances.\n+\n*name*::: Specifies the name of the disk. This option cannot be\nspecified if more than one instance is being created.\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default.\n+\n*image*::: Specifies the name of the image that the disk will be\ninitialized with. A new disk will be created based on the given\nimage. To view a list of public images and projects, run\n`$ gcloud compute images list`. If omitted image-family must be\nspecified to identify the image.\n+\n*image-family*::: The family of the image that the disk will be\ninitialized with. When a family is specified instead of an image,\nthe latest non-deprecated image associated with that family is\nused.\n+\n*image-project*::: The project that the image or image family\nbelongs to. If not specified and either an image or image family\nis provided, the project of the instance is assumed.\n+\n*size*::: The size of the disk. The value must be a whole number\nfollowed by a size unit of ``KB'' for kilobyte, ``MB'' for\nmegabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For\nexample, ``10GB'' will produce a 10 gigabyte disk. Disk size must\nbe a multiple of 1 GB. If not specified, the default image size\nwill be used for the new disk.\n+\n*type*::: The type of the disk. To get a list of available disk\ntypes, run $ gcloud compute disk-types list. The default disk type\nis ``pd-standard''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.",
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--create-disk',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'dict',
                                                                                                                                                         u'value': u'PROPERTY=VALUE'},
                                                                                                                                      u'--custom-cpu': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--custom-cpu',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'CUSTOM_CPU'},
                                                                                                                                      u'--custom-extensions': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': False,
                                                                                                                                                               u'description': u'If provided, uses extended custom machine type. Both --custom-cpu and --custom-memory must be specified if --custom-extensions is provided.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--custom-extensions',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'bool',
                                                                                                                                                               u'value': u'CUSTOM_EXTENSIONS'},
                                                                                                                                      u'--custom-memory': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--custom-memory',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'CUSTOM_MEMORY'},
                                                                                                                                      u'--description': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Specifies a textual description of the instances.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--description',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'DESCRIPTION'},
                                                                                                                                      u'--disk': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u"Attaches persistent disks to the instances. The disks\nspecified must already exist.\n+\n*name*::: The disk to attach to the instances. When creating\nmore than one instance and using this property, the only valid\nmode for attaching the disk is read-only (see *mode* below).\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default. It is an error for mode\nto be ``rw'' when creating more than one instance because\nread-write disks can only be attached to a single instance.\n+\n*boot*::: If ``yes'', indicates that this is a boot disk. The\nvirtual machines will use the first partition of the disk for\ntheir root file systems. The default value for this is ``no''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.\n+\n*scope*::: Can be `zonal` or `regional`. If ``zonal'', the disk is\ninterpreted as a zonal disk in the same zone as the instance (default).\nIf ``regional'', the disk is interpreted as a regional disk in the same\nregion as the instance. The default value for this is ``zonal''.",
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--disk',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'dict',
                                                                                                                                                  u'value': u'DISK'},
                                                                                                                                      u'--docker-image': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The URL to a Docker image to run on this instance. For example:\n    gcr.io/google-containers/busybox',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--docker-image',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'DOCKER_IMAGE'},
                                                                                                                                      u'--local-ssd': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u"Attaches a local SSD to the instances.\n+\nThis flag is currently in BETA and may change without notice.\n+\n*device-name*::: Optional. A name that indicates the disk name\nthe guest operating system will see.  If omitted, a device name\nof the form ``local-ssd-N'' will be used.\n+\n*interface*::: Optional. The kind of disk interface exposed to the VM\nfor this SSD.  Valid values are ``SCSI'' and ``NVME''.  SCSI is\nthe default and is supported by more guest operating systems.  NVME\nmay provide higher performance.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--local-ssd',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'dict',
                                                                                                                                                       u'value': u'LOCAL_SSD'},
                                                                                                                                      u'--machine-type': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--machine-type',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'MACHINE_TYPE'},
                                                                                                                                      u'--maintenance-policy': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [u'MIGRATE',
                                                                                                                                                                             u'TERMINATE'],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--maintenance-policy',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'MAINTENANCE_POLICY'},
                                                                                                                                      u'--metadata': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': {},
                                                                                                                                                      u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--metadata',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'dict',
                                                                                                                                                      u'value': u'KEY=VALUE'},
                                                                                                                                      u'--metadata-from-file': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': {},
                                                                                                                                                                u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.",
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--metadata-from-file',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'dict',
                                                                                                                                                                u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                                                                      u'--min-cpu-platform': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'When specified the VM will be scheduled on host with specified CPU\narchitecture or a newer one. To list available CPU platforms in given\nzone run\n+\n    $ gcloud compute zones describe ZONE --format="value(availableCpuPlatforms)"\n+\nCPU platform selection is available only in selected zones.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--min-cpu-platform',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'PLATFORM'},
                                                                                                                                      u'--network': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Specifies the network that the instances will be part of. If --subnet is\nalso specified subnet must be a subnetwork of network specified by\n--network. If neither is specified, this defaults to the "default"\nnetwork.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--network',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'NETWORK'},
                                                                                                                                      u'--network-tier': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [u'PREMIUM',
                                                                                                                                                                       u'SELECT'],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': u'PREMIUM',
                                                                                                                                                          u'description': u'Specifies the network tier that will be used to configure the instance.\nIt can only take the following values: PREMIUM, SELECT. The default\nnetwork tier is PREMIUM. _NETWORK_TIER_ must be one of: *PREMIUM*, *SELECT*.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--network-tier',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'NETWORK_TIER'},
                                                                                                                                      u'--no-address': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': False,
                                                                                                                                                        u'description': u'If provided, the instances will not be assigned external IP addresses.',
                                                                                                                                                        u'group': u'create-from-container.1',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--no-address',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'NO_ADDRESS'},
                                                                                                                                      u'--no-boot-disk-auto-delete': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': True,
                                                                                                                                                                      u'description': u'',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': True,
                                                                                                                                                                      u'name': u'--no-boot-disk-auto-delete',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'bool',
                                                                                                                                                                      u'value': u'NO_BOOT_DISK_AUTO_DELETE'},
                                                                                                                                      u'--no-can-ip-forward': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': True,
                                                                                                                                                               u'description': u'',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': True,
                                                                                                                                                               u'name': u'--no-can-ip-forward',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'bool',
                                                                                                                                                               u'value': u'NO_CAN_IP_FORWARD'},
                                                                                                                                      u'--no-custom-extensions': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': True,
                                                                                                                                                                  u'description': u'',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': True,
                                                                                                                                                                  u'name': u'--no-custom-extensions',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'bool',
                                                                                                                                                                  u'value': u'NO_CUSTOM_EXTENSIONS'},
                                                                                                                                      u'--no-preemptible': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': False,
                                                                                                                                                            u'description': u'',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': True,
                                                                                                                                                            u'name': u'--no-preemptible',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'NO_PREEMPTIBLE'},
                                                                                                                                      u'--no-public-dns': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': False,
                                                                                                                                                           u'description': u'If provided, the instance will not be assigned a public DNS name.',
                                                                                                                                                           u'group': u'create-from-container.2',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--no-public-dns',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'NO_PUBLIC_DNS'},
                                                                                                                                      u'--no-public-ptr': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': False,
                                                                                                                                                           u'description': u'If provided, no DNS PTR record is created for the external IP of the\ninstance. Mutually exclusive with public-ptr-domain.',
                                                                                                                                                           u'group': u'create-from-container.3',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--no-public-ptr',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'NO_PUBLIC_PTR'},
                                                                                                                                      u'--no-public-ptr-domain': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': False,
                                                                                                                                                                  u'description': u'If both this flag and --public-ptr are specified, creates a DNS PTR\nrecord for the external IP of the instance with the PTR domain name\nbeing the DNS name of the instance.',
                                                                                                                                                                  u'group': u'create-from-container.4',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--no-public-ptr-domain',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'bool',
                                                                                                                                                                  u'value': u'NO_PUBLIC_PTR_DOMAIN'},
                                                                                                                                      u'--no-restart-on-failure': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': True,
                                                                                                                                                                   u'description': u'',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': True,
                                                                                                                                                                   u'name': u'--no-restart-on-failure',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'bool',
                                                                                                                                                                   u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                                                                      u'--no-run-as-privileged': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': True,
                                                                                                                                                                  u'description': u'',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': True,
                                                                                                                                                                  u'name': u'--no-run-as-privileged',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'bool',
                                                                                                                                                                  u'value': u'NO_RUN_AS_PRIVILEGED'},
                                                                                                                                      u'--no-scopes': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'Create instance without scopes',
                                                                                                                                                       u'group': u'create-from-container.5',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--no-scopes',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_SCOPES'},
                                                                                                                                      u'--no-service-account': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': False,
                                                                                                                                                                u'description': u'Create instance without service account',
                                                                                                                                                                u'group': u'create-from-container.6',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--no-service-account',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                                                                      u'--port-mappings': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Configure bindings of container ports to the host ports.\nValue of this parameter should be comma-separated list of\nport1:port2:protocol triads representing host port, container port and\nprotocol. Protocol could be: TCP, UDP.\n+\nFor example following command:\n+\n  $ {command} --port-mappings=80:8888:TCP\n+\nwill expose container port 8888 on port 80 of VM. This binding will serve TCP\ntraffic.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--port-mappings',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'list',
                                                                                                                                                           u'value': u'PORT:TARGET_PORT:PROTOCOL'},
                                                                                                                                      u'--preemptible': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': False,
                                                                                                                                                         u'description': u'If provided, instances will be preemptible and time-limited.\nInstances may be preempted to free up resources for standard VM instances,\nand will only be able to run for a limited amount of time. Preemptible\ninstances can not be restarted and will not migrate.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--preemptible',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'PREEMPTIBLE'},
                                                                                                                                      u'--private-network-ip': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Specifies the RFC1918 IP to assign to the instance. The IP should be in\nthe subnet or legacy network IP range.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--private-network-ip',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'PRIVATE_NETWORK_IP'},
                                                                                                                                      u'--public-dns': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': False,
                                                                                                                                                        u'description': u'Assigns a public DNS name to the instance.',
                                                                                                                                                        u'group': u'create-from-container.2',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--public-dns',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'PUBLIC_DNS'},
                                                                                                                                      u'--public-ptr': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': False,
                                                                                                                                                        u'description': u'Creates a DNS PTR record for the external IP of the instance.',
                                                                                                                                                        u'group': u'create-from-container.3',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--public-ptr',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'PUBLIC_PTR'},
                                                                                                                                      u'--public-ptr-domain': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'Assigns a custom PTR domain for the external IP of the instance.\nMutually exclusive with no-public-ptr.',
                                                                                                                                                               u'group': u'create-from-container.4',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--public-ptr-domain',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'PUBLIC_PTR_DOMAIN'},
                                                                                                                                      u'--restart-on-failure': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': True,
                                                                                                                                                                u'description': u'The instances will be restarted if they are terminated by Compute Engine.\nThis does not affect terminations performed by the user. Enabled by default, use *--no-restart-on-failure* to disable.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--restart-on-failure',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                u'value': u'RESTART_ON_FAILURE'},
                                                                                                                                      u'--run-as-privileged': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': False,
                                                                                                                                                               u'description': u'Privileged mode is useful for containers that want to use linux capabilities\nlike manipulating the network stack and accessing devices.\nWith this argument specified Docker will enable to access to all devices on\nthe host as well as set some configuration in AppArmor or SELinux\nto allow the container nearly all the same access to the host as processes\nrunning outside containers on the host.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--run-as-privileged',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'bool',
                                                                                                                                                               u'value': u'RUN_AS_PRIVILEGED'},
                                                                                                                                      u'--run-command': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Command to be executed when running the Docker image. The command is\nspecified in shell form:\n+\n  command param1 param2 ...\n+\nIt is possible to quote and escape params, for example:\n+\n  $ {command} --run-command=\'echo "Hello world"\'\n+\nCommand will result in error on wrong syntax for this parameter.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--run-command',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'RUN_COMMAND'},
                                                                                                                                      u'--scopes': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'If not provided, the instance will be assigned the default scopes, described below.\n+\nSCOPE can be either the full URI of the scope or an alias. Available\naliases are:\n+\n  default\n    Scopes assigned to instances by default:\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n    - https://www.googleapis.com/auth/devstorage.read_only\n    - https://www.googleapis.com/auth/logging.write\n    - https://www.googleapis.com/auth/monitoring.write\n    - https://www.googleapis.com/auth/service.management.readonly\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  bigquery\n    - https://www.googleapis.com/auth/bigquery\n+\n  cloud-platform\n    - https://www.googleapis.com/auth/cloud-platform\n+\n  compute-ro\n    - https://www.googleapis.com/auth/compute.readonly\n+\n  compute-rw\n    - https://www.googleapis.com/auth/compute\n+\n  datastore\n    - https://www.googleapis.com/auth/datastore\n+\n  logging-write\n    - https://www.googleapis.com/auth/logging.write\n+\n  monitoring\n    - https://www.googleapis.com/auth/monitoring\n+\n  monitoring-write\n    - https://www.googleapis.com/auth/monitoring.write\n+\n  service-control\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  service-management\n    - https://www.googleapis.com/auth/service.management.readonly\n+\n  sql\n    - https://www.googleapis.com/auth/sqlservice\n+\n  sql-admin\n    - https://www.googleapis.com/auth/sqlservice.admin\n+\n  storage-full\n    - https://www.googleapis.com/auth/devstorage.full_control\n+\n  storage-ro\n    - https://www.googleapis.com/auth/devstorage.read_only\n+\n  storage-rw\n    - https://www.googleapis.com/auth/devstorage.read_write\n+\n  taskqueue\n    - https://www.googleapis.com/auth/taskqueue\n+\n  useraccounts-ro\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n+\n  useraccounts-rw\n    - https://www.googleapis.com/auth/cloud.useraccounts\n+\n  userinfo-email\n    - https://www.googleapis.com/auth/userinfo.email',
                                                                                                                                                    u'group': u'create-from-container.5',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--scopes',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'list',
                                                                                                                                                    u'value': u'SCOPE'},
                                                                                                                                      u'--service-account': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u"A service account is an identity attached to the instance. Its access tokens\ncan be accessed through the instance metadata server and are used to\nauthenticate applications on the instance. The account can be either an email\naddress or an alias corresponding to a service account. You can explicitly\nspecify the Compute Engine default service account using the 'default' alias.\n+\nIf not provided, the instance will get project's default service account.",
                                                                                                                                                             u'group': u'create-from-container.6',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--service-account',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'SERVICE_ACCOUNT'},
                                                                                                                                      u'--subnet': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'Specifies the subnet that the instances will be part of. If --network is\nalso specified subnet must be a subnetwork of network specified by\n--network.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--subnet',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'SUBNET'},
                                                                                                                                      u'--tags': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Specifies a list of tags to apply to the instances for\nidentifying the instances to which network firewall rules will\napply. See gcloud_compute_firewall-rules_create(1) for more\ndetails.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--tags',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'list',
                                                                                                                                                  u'value': u'TAG'},
                                                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--zone',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'ZONE'}},
                                                                                                                           u'group': False,
                                                                                                                           u'groups': {u'create-from-container.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                                    u'is_required': False},
                                                                                                                                       u'create-from-container.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                                    u'is_required': False},
                                                                                                                                       u'create-from-container.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                                    u'is_required': False},
                                                                                                                                       u'create-from-container.4': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                                    u'is_required': False},
                                                                                                                                       u'create-from-container.5': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                                    u'is_required': False},
                                                                                                                                       u'create-from-container.6': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                                    u'is_required': False}},
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'create-from-container',
                                                                                                                           u'path': [u'gcloud',
                                                                                                                                     u'alpha',
                                                                                                                                     u'compute',
                                                                                                                                     u'instances',
                                                                                                                                     u'create-from-container'],
                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The names of the instances.',
                                                                                                                                             u'name': u'names',
                                                                                                                                             u'nargs': u'+',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'NAMES'}],
                                                                                                                           u'release': u'ALPHA',
                                                                                                                           u'sections': {u'DESCRIPTION': u"*create-from-container* facilitates the creation of Google Compute Engine virtual\nmachines that runs a Docker image. For example, running:\n\n  $ create-from-container instance-1 --zone us-central1-a --docker-image=gcr.io/google-containers/busybox\n\nwill create an instance called instance-1, in the us-central1-a zone,\nrunning the 'busybox' image.\n\nFor more examples, refer to the *EXAMPLES* section below.\n",
                                                                                                                                         u'EXAMPLES': u'To run the gcr.io/google-containers/busybox image on an instance named\n\'instance-1\' that exposes port 80, run:\n\n  $ create-from-container instance-1 --docker-image=gcr.io/google-containers/busybox --port-mappings=80:80:TCP\n\nTo run the gcr.io/google-containers/busybox image on an instance named\n\'instance-1\' that executes \'echo "Hello world"\' as a run command, run:\n\n  $ create-from-container instance-1 --docker-image=gcr.io/google-containers/busybox --run-command=\'echo "Hello world"\'\n\nTo run the gcr.io/google-containers/busybox image in privileged mode, run:\n\n  $ create-from-container instance-1 --docker-image=gcr.io/google-containers/busybox --run-as-privileged\n'}},
                                                                                                u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine virtual machine instances.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--delete-disks': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [u'all',
                                                                                                                                                        u'boot',
                                                                                                                                                        u'data'],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The types of disks to delete with instance deletion regardless\nof the disks' auto-delete configuration. When this flag is\nprovided, the auto-delete bits on the attached disks are\nmodified accordingly before the instance deletion requests are\nissued. For more information on disk auto-deletion, see\n[](https://cloud.google.com/compute/docs/disks/persistent-disks#updateautodelete). _DISK-TYPE_ must be one of:\n+\n*all*::: All disk types.\n*boot*::: The first partition is reserved for the root filesystem.\n*data*::: A non-boot disk.\n+",
                                                                                                                                           u'group': u'delete.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--delete-disks',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'DISK-TYPE'},
                                                                                                                       u'--keep-disks': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [u'all',
                                                                                                                                                      u'boot',
                                                                                                                                                      u'data'],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"The types of disks to not delete with instance deletion regardless\nof the disks' auto-delete configuration. When this flag is\nprovided, the auto-delete bits on the attached disks are\nmodified accordingly before the instance deletion requests are\nissued. For more information on disk auto-deletion, see\n[](https://cloud.google.com/compute/docs/disks/persistent-disks#updateautodelete). _DISK-TYPE_ must be one of:\n+\n*all*::: All disk types.\n*boot*::: The first partition is reserved for the root filesystem.\n*data*::: A non-boot disk.\n+",
                                                                                                                                         u'group': u'delete.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--keep-disks',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'DISK-TYPE'},
                                                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--zone',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'ZONE'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': False}},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'delete',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'compute',
                                                                                                                      u'instances',
                                                                                                                      u'delete'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The names of the instances.',
                                                                                                                              u'name': u'names',
                                                                                                                              u'nargs': u'+',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAMES'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine virtual machine\ninstances.\n'}},
                                                                                                u'delete-access-config': {u'capsule': u'*(ALPHA)* Delete an access configuration from a virtual machine network interface.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--access-config-name': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': u'external-nat',
                                                                                                                                                               u'description': u"Specifies the name of the access configuration to delete.\n``external-nat'' is used as the default if this flag is not provided.",
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--access-config-name',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'ACCESS_CONFIG_NAME'},
                                                                                                                                     u'--network-interface': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': u'nic0',
                                                                                                                                                              u'description': u"Specifies the name of the network interface from which to delete the\naccess configuration. If this is not provided, then ``nic0'' is used\nas the default.",
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--network-interface',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'NETWORK_INTERFACE'},
                                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--zone',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'ZONE'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'delete-access-config',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'alpha',
                                                                                                                                    u'compute',
                                                                                                                                    u'instances',
                                                                                                                                    u'delete-access-config'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the instance.',
                                                                                                                                            u'name': u'name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'NAME'}],
                                                                                                                          u'release': u'ALPHA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* *delete-access-config* is used to delete access configurations from network\ninterfaces of Google Compute Engine virtual machines.'}},
                                                                                                u'describe': {u'capsule': u'*(ALPHA)* Describe a virtual machine instance.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--zone',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'ZONE'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'compute',
                                                                                                                        u'instances',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the resource to fetch.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine virtual machine instance.\n'}},
                                                                                                u'detach-disk': {u'capsule': u'*(ALPHA)* Detach disks from Compute Engine virtual machine instances.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--device-name': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"Specifies a disk to detach by its device name, which is the name\nthat the guest operating system sees. The device name is set\nat the time that the disk is attached to the instance, and needs not be\nthe same as the persistent disk name. If the disk's device name is\nspecified, then its persistent disk name must not be specified\nusing the ``--disk'' flag.",
                                                                                                                                               u'group': u'detach-disk.1',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--device-name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'DEVICE_NAME'},
                                                                                                                            u'--disk': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"Specifies a disk to detach by its resource name. If you specify a\ndisk to remove by persistent disk name, then you must not specify its\ndevice name using the ``--device-name'' flag.",
                                                                                                                                        u'group': u'detach-disk.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--disk',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DISK'},
                                                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--zone',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'ZONE'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {u'detach-disk.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                u'is_mutex': True,
                                                                                                                                                u'is_required': True}},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'detach-disk',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'instances',
                                                                                                                           u'detach-disk'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the instance.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* *detach-disk* is used to detach disks from virtual machines.\n\nDetaching a disk without first unmounting it may result in\nincomplete I/O operations and data corruption.\nTo unmount a persistent disk on a Linux-based image,\nssh into the instance and run:\n\n    $ sudo umount /dev/disk/by-id/google-DEVICE_NAME'}},
                                                                                                u'get-serial-port-output': {u'capsule': u"*(ALPHA)* Read output from a virtual machine instance's serial port.",
                                                                                                                            u'commands': {},
                                                                                                                            u'flags': {u'--port': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Instances can support up to four serial port outputs, numbered 1 through\n4. By default, this command will return the output of the first serial\nport. Setting this flag will return the output of the requested serial\nport.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--port',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'PORT'},
                                                                                                                                       u'--start': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'Specifies the byte index (zero-based) of the first byte you want\nreturned.  Use this flag if you want to continue getting the output from\na previous request that was too long to return in one attempt.  The last\nbyte returned in a request will be reported on STDERR.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--start',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'START'},
                                                                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--zone',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'ZONE'}},
                                                                                                                            u'group': False,
                                                                                                                            u'groups': {},
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'get-serial-port-output',
                                                                                                                            u'path': [u'gcloud',
                                                                                                                                      u'alpha',
                                                                                                                                      u'compute',
                                                                                                                                      u'instances',
                                                                                                                                      u'get-serial-port-output'],
                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The name of the instance.',
                                                                                                                                              u'name': u'name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'value': u'NAME'}],
                                                                                                                            u'release': u'ALPHA',
                                                                                                                            u'sections': {u'DESCRIPTION': u"get-serial-port-output is used to get the output from a Google Compute\nEngine virtual machine's serial port. The serial port output\nfrom the virtual machine will be printed to standard output. This\ninformation can be useful for diagnostic purposes.\n"}},
                                                                                                u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine instances.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--regexp': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--regexp',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'REGEXP'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'},
                                                                                                                     u'--zones': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': [],
                                                                                                                                  u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--zones',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'instances',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': [],
                                                                                                                            u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'*',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine instances in a project.\n\nBy default, instances from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                        u'EXAMPLES': u"To list all instances in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all instances in a project, run:\n\n  $ list --uri\n\nTo list all instances in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}},
                                                                                                u'move': {u'capsule': u'*(ALPHA)* Move an instance between zones.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--async': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--async',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'ASYNC'},
                                                                                                                     u'--destination-zone': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The zone to move the instance to.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--destination-zone',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': True,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DESTINATION_ZONE'},
                                                                                                                     u'--no-async': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-async',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_ASYNC'},
                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--zone',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'move',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'instances',
                                                                                                                    u'move'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the instance.',
                                                                                                                            u'name': u'name',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*move* facilitates moving a Google Compute Engine virtual machine\nfrom one zone to another. Moving a virtual machine may incur downtime\nif the guest OS must be shutdown in order to quiesce disk volumes\nprior to snapshotting.\n\nFor example, running:\n\n   $ gcloud compute instances move example-instance-1 --zone us-central1-b --destination-zone us-central1-f\n\nwill move the instance called example-instance-1, currently running in\nus-central1-b, to us-central1-f.\n'}},
                                                                                                u'remove-metadata': {u'capsule': u'*(ALPHA)* Remove instance metadata.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--all': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'If provided, all metadata entries are removed.',
                                                                                                                                           u'group': u'remove-metadata.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--all',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'ALL'},
                                                                                                                                u'--keys': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The keys of the entries to remove.',
                                                                                                                                            u'group': u'remove-metadata.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--keys',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'KEY'},
                                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The zone of the instance to set metadata on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--zone',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {u'remove-metadata.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                        u'is_mutex': True,
                                                                                                                                                        u'is_required': False}},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'remove-metadata',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'instances',
                                                                                                                               u'remove-metadata'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the instance whose metadata should be modified.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'remove-metadata can be used to remove instance metadata entries.\n'}},
                                                                                                u'remove-tags': {u'capsule': u'*(ALPHA)* Remove tags from Google Compute Engine virtual machine instances.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--all': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Remove all tags from the instance.',
                                                                                                                                       u'group': u'remove-tags.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--all',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'ALL'},
                                                                                                                            u'--tags': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Specifies strings to be removed from the instance tags.\nMultiple tags can be removed by repeating this flag.',
                                                                                                                                        u'group': u'remove-tags.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--tags',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'TAG'},
                                                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The zone of the instance to set tags on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--zone',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'ZONE'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {u'remove-tags.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                u'is_mutex': True,
                                                                                                                                                u'is_required': True}},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'remove-tags',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'instances',
                                                                                                                           u'remove-tags'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the instance whose tags should be modified.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u"*remove-tags* is used to remove tags to Google Compute Engine virtual\nmachine instances.  For example:\n\n  $ remove-tags example-instance --tags tag-1,tag-2\n\nwill remove tags ``tag-1'' and ``tag-2'' from the existing tags of\n'example-instance'.\n\nTags can be used to identify instances when adding network\nfirewall rules. Tags can also be used to get firewall rules that already\nexist to be applied to the instance. See\ngcloud_compute_firewall-rules_create(1) for more details.\n"}},
                                                                                                u'reset': {u'capsule': u'*(ALPHA)* Reset a virtual machine instance.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--zone',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'ZONE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'reset',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'instances',
                                                                                                                     u'reset'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The names of the instances.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAMES'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*reset* is used to perform a hard reset on a Google\nCompute Engine virtual machine.\n'}},
                                                                                                u'set-disk-auto-delete': {u'capsule': u'*(ALPHA)* Set auto-delete behavior for disks.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': True,
                                                                                                                                                        u'description': u'Enables auto-delete for the given disk. Enabled by default, use *--no-auto-delete* to disable.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--auto-delete',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'AUTO_DELETE'},
                                                                                                                                     u'--device-name': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u"Specifies a disk to set auto-delete for by its device name,\nwhich is the name that the guest operating system sees. The\ndevice name is set at the time that the disk is attached to the\ninstance, and need not be the same as the persistent disk name.\nIf the disk's device name is specified, then its persistent disk\nname must not be specified using the ``--disk'' flag.",
                                                                                                                                                        u'group': u'set-disk-auto-delete.1',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--device-name',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'DEVICE_NAME'},
                                                                                                                                     u'--disk': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"Specifies a disk to set auto-delete for by its resource name. If\nyou specify a disk to set auto-delete for by persistent disk name,\nthen you must not specify its device name using the\n``--device-name'' flag.",
                                                                                                                                                 u'group': u'set-disk-auto-delete.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--disk',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'DISK'},
                                                                                                                                     u'--no-auto-delete': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': True,
                                                                                                                                                           u'description': u'',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': True,
                                                                                                                                                           u'name': u'--no-auto-delete',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'NO_AUTO_DELETE'},
                                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--zone',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'ZONE'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {u'set-disk-auto-delete.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                                  u'is_mutex': True,
                                                                                                                                                                  u'is_required': True}},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'set-disk-auto-delete',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'alpha',
                                                                                                                                    u'compute',
                                                                                                                                    u'instances',
                                                                                                                                    u'set-disk-auto-delete'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the instance.',
                                                                                                                                            u'name': u'name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'NAME'}],
                                                                                                                          u'release': u'ALPHA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'*$set-disk-auto-delete* is used to configure the auto-delete behavior for disks\nattached to Google Compute Engine virtual machines. When\nauto-delete is on, the persistent disk is deleted when the\ninstance it is attached to is deleted.\n'}},
                                                                                                u'set-machine-type': {u'capsule': u'*(ALPHA)* Set machine type for Google Compute Engine virtual machines.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--custom-cpu': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--custom-cpu',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'CUSTOM_CPU'},
                                                                                                                                 u'--custom-extensions': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'If provided, uses extended custom machine type. Both --custom-cpu and --custom-memory must be specified if --custom-extensions is provided.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--custom-extensions',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'CUSTOM_EXTENSIONS'},
                                                                                                                                 u'--custom-memory': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--custom-memory',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'CUSTOM_MEMORY'},
                                                                                                                                 u'--machine-type': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--machine-type',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'MACHINE_TYPE'},
                                                                                                                                 u'--no-custom-extensions': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': True,
                                                                                                                                                             u'description': u'',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': True,
                                                                                                                                                             u'name': u'--no-custom-extensions',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'bool',
                                                                                                                                                             u'value': u'NO_CUSTOM_EXTENSIONS'},
                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--zone',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'set-machine-type',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'instances',
                                                                                                                                u'set-machine-type'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the instance.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u"``set-machine-type'' allows you to change the machine type of a virtual machine\nin the *TERMINATED* state (that is, a virtual machine instance that\nhas been stopped).\n\nFor example, if ``example-instance'' is a ``g1-small'' virtual machine\ncurrently in the *TERMINATED* state, running:\n\n  $ set-machine-type example-instance --zone us-central1-b --machine-type n1-standard-4\n\nwill change the machine type to ``n1-standard-4'', so that when you\nnext start ``example-instance'', it will be provisioned as an\n``n1-standard-4'' instead of a ``g1-small''.\n\nSee [](https://cloud.google.com/compute/docs/machine-types) for more\ninformation on machine types.\n"}},
                                                                                                u'set-scheduling': {u'capsule': u'*(ALPHA)* Set scheduling options for Google Compute Engine virtual machines.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--maintenance-policy': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [u'MIGRATE',
                                                                                                                                                                      u'TERMINATE'],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--maintenance-policy',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'MAINTENANCE_POLICY'},
                                                                                                                               u'--no-restart-on-failure': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': False,
                                                                                                                                                            u'description': u'',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': True,
                                                                                                                                                            u'name': u'--no-restart-on-failure',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                                                               u'--restart-on-failure': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': False,
                                                                                                                                                         u'description': u'The instances will be restarted if they are terminated by Compute\nEngine.  This does not affect terminations performed by the user.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--restart-on-failure',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'RESTART_ON_FAILURE'},
                                                                                                                               u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--zone',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'ZONE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'set-scheduling',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'compute',
                                                                                                                              u'instances',
                                                                                                                              u'set-scheduling'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the instance.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*$set-scheduling* is used to configure scheduling options for Google Compute\nEngine virtual machines.\n'}},
                                                                                                u'set-scopes': {u'capsule': u'*(ALPHA)* Set scopes and service account for a Google Compute Engine instance.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--no-scopes': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'Remove all scopes from the instance',
                                                                                                                                            u'group': u'set-scopes.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--no-scopes',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_SCOPES'},
                                                                                                                           u'--no-service-account': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'Remove service account from the instance',
                                                                                                                                                     u'group': u'set-scopes.2',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--no-service-account',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                                                           u'--scopes': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'If not provided, the instance will keep the scopes it currently has.\n+\nSCOPE can be either the full URI of the scope or an alias. Available\naliases are:\n+\n  default\n    Scopes assigned to instances by default:\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n    - https://www.googleapis.com/auth/devstorage.read_only\n    - https://www.googleapis.com/auth/logging.write\n    - https://www.googleapis.com/auth/monitoring.write\n    - https://www.googleapis.com/auth/service.management.readonly\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  bigquery\n    - https://www.googleapis.com/auth/bigquery\n+\n  cloud-platform\n    - https://www.googleapis.com/auth/cloud-platform\n+\n  compute-ro\n    - https://www.googleapis.com/auth/compute.readonly\n+\n  compute-rw\n    - https://www.googleapis.com/auth/compute\n+\n  datastore\n    - https://www.googleapis.com/auth/datastore\n+\n  logging-write\n    - https://www.googleapis.com/auth/logging.write\n+\n  monitoring\n    - https://www.googleapis.com/auth/monitoring\n+\n  monitoring-write\n    - https://www.googleapis.com/auth/monitoring.write\n+\n  service-control\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  service-management\n    - https://www.googleapis.com/auth/service.management.readonly\n+\n  sql\n    - https://www.googleapis.com/auth/sqlservice\n+\n  sql-admin\n    - https://www.googleapis.com/auth/sqlservice.admin\n+\n  storage-full\n    - https://www.googleapis.com/auth/devstorage.full_control\n+\n  storage-ro\n    - https://www.googleapis.com/auth/devstorage.read_only\n+\n  storage-rw\n    - https://www.googleapis.com/auth/devstorage.read_write\n+\n  taskqueue\n    - https://www.googleapis.com/auth/taskqueue\n+\n  useraccounts-ro\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n+\n  useraccounts-rw\n    - https://www.googleapis.com/auth/cloud.useraccounts\n+\n  userinfo-email\n    - https://www.googleapis.com/auth/userinfo.email',
                                                                                                                                         u'group': u'set-scopes.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--scopes',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'SCOPE'},
                                                                                                                           u'--service-account': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u"A service account is an identity attached to the instance. Its access tokens\ncan be accessed through the instance metadata server and are used to\nauthenticate applications on the instance. The account can be either an email\naddress or an alias corresponding to a service account. You can explicitly\nspecify the Compute Engine default service account using the 'default' alias.\n+\nIf not provided, the instance will keep the service account it currently has.",
                                                                                                                                                  u'group': u'set-scopes.2',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--service-account',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'SERVICE_ACCOUNT'},
                                                                                                                           u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--zone',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'ZONE'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {u'set-scopes.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                              u'is_mutex': True,
                                                                                                                                              u'is_required': False},
                                                                                                                            u'set-scopes.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                              u'is_mutex': True,
                                                                                                                                              u'is_required': False}},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'set-scopes',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'instances',
                                                                                                                          u'set-scopes'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the instance.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Set scopes and service account for a Google Compute Engine instance.'}},
                                                                                                u'start': {u'capsule': u'*(ALPHA)* Start a stopped virtual machine instance.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--csek-key-file',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'FILE'},
                                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--zone',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'ZONE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'start',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'instances',
                                                                                                                     u'start'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The names of the instances.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAMES'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'Start a stopped virtual machine instance.\n\n*start* is used to start a stopped Google Compute Engine virtual\nmachine. Only a stopped virtual machine can be started.\n'}},
                                                                                                u'stop': {u'capsule': u'*(ALPHA)* Stop a virtual machine instance.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--discard-local-ssd': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'If provided, local SSD data is discarded.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--discard-local-ssd',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'DISCARD_LOCAL_SSD'},
                                                                                                                     u'--no-discard-local-ssd': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': True,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--no-discard-local-ssd',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'NO_DISCARD_LOCAL_SSD'},
                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--zone',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'stop',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'instances',
                                                                                                                    u'stop'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The names of the instances.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'+',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAMES'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*stop* is used stop a Google Compute Engine virtual machine.\nStopping a VM performs a clean shutdown, much like invoking the shutdown\nfunctionality of a workstation or laptop. Stopping a VM with a local SSD\nis not supported and will result in an API error.\n'}},
                                                                                                u'suspend': {u'capsule': u'*(ALPHA)* Suspend a virtual machine instance.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--discard-local-ssd': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'If provided, local SSD data is discarded.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--discard-local-ssd',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'DISCARD_LOCAL_SSD'},
                                                                                                                        u'--no-discard-local-ssd': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': True,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-discard-local-ssd',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_DISCARD_LOCAL_SSD'},
                                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--zone',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'ZONE'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'suspend',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'compute',
                                                                                                                       u'instances',
                                                                                                                       u'suspend'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The names of the instances.',
                                                                                                                               u'name': u'names',
                                                                                                                               u'nargs': u'+',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAMES'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*suspend* is used to suspend a Google Compute Engine virtual machine.\nSuspending a VM is the equivalent of sleep or standby mode:\nthe guest receives an ACPI S3 suspend signal, after which all VM state\nis saved to temporary storage.  An instance can only be suspended while\nit is in the RUNNING state.  A suspended instance will be put in\nSUSPENDED state.\n\nAlpha restrictions: Suspending a Preemptible VM is not supported and\nwill result in an API error. Suspending a VM that is using CSEK or GPUs\nis not supported and will result in an API error.\n'}},
                                                                                                u'tail-serial-port-output': {u'capsule': u"*(ALPHA)* Periodically fetch new output from a virtual machine instance's     serial port and display it as it becomes available.",
                                                                                                                             u'commands': {},
                                                                                                                             u'flags': {u'--port': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'Instances can support up to four serial port outputs, numbered 1 through\n4. By default, this command will return the output of the first serial\nport. Setting this flag will return the output of the requested serial\nport.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--port',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'PORT'},
                                                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--zone',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'ZONE'}},
                                                                                                                             u'group': False,
                                                                                                                             u'groups': {},
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'tail-serial-port-output',
                                                                                                                             u'path': [u'gcloud',
                                                                                                                                       u'alpha',
                                                                                                                                       u'compute',
                                                                                                                                       u'instances',
                                                                                                                                       u'tail-serial-port-output'],
                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The name of the instance.',
                                                                                                                                               u'name': u'name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'value': u'NAME'}],
                                                                                                                             u'release': u'ALPHA',
                                                                                                                             u'sections': {u'DESCRIPTION': u"tail-serial-port-output is used to tail the output from a Google Compute\nEngine virtual machine instance's serial port. The serial port output\nfrom the instance will be printed to standard output. This\ninformation can be useful for diagnostic purposes.\n"}},
                                                                                                u'update-access-config': {u'capsule': u'*(ALPHA)* Update a Google Compute Engine virtual machine access configuration.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--network-interface': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': u'nic0',
                                                                                                                                                              u'description': u'Specifies the name of the network interface which contains the access\nconfiguration. If this is not provided, then "nic0" is used\nas the default.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--network-interface',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'NETWORK_INTERFACE'},
                                                                                                                                     u'--network-tier': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [u'PREMIUM',
                                                                                                                                                                      u'SELECT'],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': u'PREMIUM',
                                                                                                                                                         u'description': u'Specifies the network tier of the access configuration. It can only take\nthe following values: PREMIUM, SELECT. The default network tier is\nPREMIUM. _NETWORK_TIER_ must be one of: *PREMIUM*, *SELECT*.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--network-tier',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'NETWORK_TIER'},
                                                                                                                                     u'--no-public-dns': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'If provided, the external IP in the access configuration will not be\nassigned a public DNS name.',
                                                                                                                                                          u'group': u'update-access-config.1',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--no-public-dns',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_PUBLIC_DNS'},
                                                                                                                                     u'--no-public-ptr': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'If provided, no DNS PTR record is created for the external IP in the\naccess configuration. Mutually exclusive with public-ptr-domain.',
                                                                                                                                                          u'group': u'update-access-config.2',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--no-public-ptr',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_PUBLIC_PTR'},
                                                                                                                                     u'--no-public-ptr-domain': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': False,
                                                                                                                                                                 u'description': u'If both this flag and --public-ptr are specified, creates a DNS PTR\nrecord for the external IP in the access configuration with the PTR\ndomain name being the DNS name of the instance.',
                                                                                                                                                                 u'group': u'update-access-config.3',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--no-public-ptr-domain',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'bool',
                                                                                                                                                                 u'value': u'NO_PUBLIC_PTR_DOMAIN'},
                                                                                                                                     u'--public-dns': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'Assigns a public DNS name to the external IP in the access\nconfiguration. This option can only be specified for the default\nnetwork-interface, "nic0".',
                                                                                                                                                       u'group': u'update-access-config.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--public-dns',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'PUBLIC_DNS'},
                                                                                                                                     u'--public-ptr': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'Creates a DNS PTR record for the external IP in the access\nconfiguration. This option can only be specified for the default\nnetwork-interface, "nic0".',
                                                                                                                                                       u'group': u'update-access-config.2',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--public-ptr',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'PUBLIC_PTR'},
                                                                                                                                     u'--public-ptr-domain': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Assigns a custom PTR domain for the external IP in the access\nconfiguration. Mutually exclusive with no-public-ptr. This option can\nonly be specified for the default network-interface, "nic0".',
                                                                                                                                                              u'group': u'update-access-config.3',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--public-ptr-domain',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'PUBLIC_PTR_DOMAIN'},
                                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--zone',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'ZONE'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {u'update-access-config.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                  u'is_mutex': True,
                                                                                                                                                                  u'is_required': False},
                                                                                                                                      u'update-access-config.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                  u'is_mutex': True,
                                                                                                                                                                  u'is_required': False},
                                                                                                                                      u'update-access-config.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                  u'is_mutex': True,
                                                                                                                                                                  u'is_required': False}},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'update-access-config',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'alpha',
                                                                                                                                    u'compute',
                                                                                                                                    u'instances',
                                                                                                                                    u'update-access-config'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the instance.',
                                                                                                                                            u'name': u'name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'NAME'}],
                                                                                                                          u'release': u'ALPHA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* *update-access-config* is used to update access configurations for network\ninterfaces of Google Compute Engine virtual machines.'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'instances',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'compute',
                                                                                            u'instances'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine virtual machine instances.'}},
                                                                   u'machine-types': {u'capsule': u'*(ALPHA)* Read Google Compute Engine virtual machine types.',
                                                                                      u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine machine type.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--zone',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'ZONE'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'describe',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'compute',
                                                                                                                            u'machine-types',
                                                                                                                            u'describe'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the resource to fetch.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine machine type.\n'}},
                                                                                                    u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine machine types.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--filter',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'EXPRESSION'},
                                                                                                                         u'--limit': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--limit',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'LIMIT'},
                                                                                                                         u'--no-uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_URI'},
                                                                                                                         u'--page-size': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--page-size',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                                                         u'--regexp': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--regexp',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'REGEXP'},
                                                                                                                         u'--sort-by': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--sort-by',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'FIELD'},
                                                                                                                         u'--uri': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--uri',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'URI'},
                                                                                                                         u'--zones': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': [],
                                                                                                                                      u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--zones',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'ZONE'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'list',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'compute',
                                                                                                                        u'machine-types',
                                                                                                                        u'list'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': [],
                                                                                                                                u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                u'name': u'names',
                                                                                                                                u'nargs': u'*',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine machine types in a project.\n\nBy default, machine types from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                            u'EXAMPLES': u"To list all machine types in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all machine types in a project, run:\n\n  $ list --uri\n\nTo list all machine types in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                                      u'flags': {},
                                                                                      u'group': True,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'machine-types',
                                                                                      u'path': [u'gcloud',
                                                                                                u'alpha',
                                                                                                u'compute',
                                                                                                u'machine-types'],
                                                                                      u'positionals': [],
                                                                                      u'release': u'ALPHA',
                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read Google Compute Engine virtual machine types.'}},
                                                                   u'networks': {u'capsule': u'*(ALPHA)* List, create, and delete Google Compute Engine networks.',
                                                                                 u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a Google Compute Engine network.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--description': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'An optional, textual description for the network.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--description',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'DESCRIPTION'},
                                                                                                                      u'--mode': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [u'auto',
                                                                                                                                               u'custom',
                                                                                                                                               u'legacy'],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The network type. _NETWORK_TYPE_ must be one of:\n+\n*auto*::: Subnets are created automatically. This is the recommended selection.\n*custom*::: Create subnets manually.\n*legacy*::: Create an old style network that has a range and cannot have subnets.\n+',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--mode',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'NETWORK_TYPE'},
                                                                                                                      u'--range': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Specifies the IPv4 address range of legacy mode networks. The range\nmust be specified in CIDR format:\n[](http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing)\n+\nThis flag only works if mode is legacy.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--range',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'RANGE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'create',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'networks',
                                                                                                                     u'create'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the network.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* *create* is used to create virtual networks. A network\nperforms the same function that a router does in a home\nnetwork: it describes the network range and gateway IP\naddress, handles communication between instances, and serves\nas a gateway between instances and callers outside the\nnetwork.'}},
                                                                                               u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine networks.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'delete',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'networks',
                                                                                                                     u'delete'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The resources to delete.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nnetworks. Networks can only be deleted when no other resources\n(e.g., virtual machine instances) refer to them.\n'}},
                                                                                               u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine network.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'compute',
                                                                                                                       u'networks',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the resource to fetch.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with Google Compute\nEngine network in a project.\n'}},
                                                                                               u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine networks.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--regexp': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--regexp',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'REGEXP'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'compute',
                                                                                                                   u'networks',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': [],
                                                                                                                           u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'*',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine networks in a project.\n',
                                                                                                                       u'EXAMPLES': u'To list all networks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all networks in a project, run:\n\n  $ list --uri\n'}},
                                                                                               u'subnets': {u'capsule': u'*(ALPHA)* List, describe, and delete Google Compute Engine subnetworks.',
                                                                                                            u'commands': {u'create': {u'capsule': u'*(ALPHA)* Define a subnet for a network in custom subnet mode.',
                                                                                                                                      u'commands': {},
                                                                                                                                      u'flags': {u'--description': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'An optional description of this subnetwork.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--description',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                                 u'--enable-private-ip-google-access': {u'attr': {},
                                                                                                                                                                                        u'category': u'',
                                                                                                                                                                                        u'choices': [],
                                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                                        u'default': False,
                                                                                                                                                                                        u'description': u'Enable/disable access to Google Cloud APIs from this subnet for instances without a public ip address.',
                                                                                                                                                                                        u'group': u'',
                                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                                        u'name': u'--enable-private-ip-google-access',
                                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                                        u'required': False,
                                                                                                                                                                                        u'type': u'bool',
                                                                                                                                                                                        u'value': u'ENABLE_PRIVATE_IP_GOOGLE_ACCESS'},
                                                                                                                                                 u'--network': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The network to which the subnetwork belongs.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--network',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': True,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'NETWORK'},
                                                                                                                                                 u'--no-enable-private-ip-google-access': {u'attr': {},
                                                                                                                                                                                           u'category': u'',
                                                                                                                                                                                           u'choices': [],
                                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                                           u'default': False,
                                                                                                                                                                                           u'description': u'',
                                                                                                                                                                                           u'group': u'',
                                                                                                                                                                                           u'hidden': True,
                                                                                                                                                                                           u'name': u'--no-enable-private-ip-google-access',
                                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                                           u'required': False,
                                                                                                                                                                                           u'type': u'bool',
                                                                                                                                                                                           u'value': u'NO_ENABLE_PRIVATE_IP_GOOGLE_ACCESS'},
                                                                                                                                                 u'--range': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The IP space allocated to this subnetwork in CIDR format.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--range',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': True,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'RANGE'},
                                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u"The region of the subnetwork to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--region',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'REGION'},
                                                                                                                                                 u'--secondary-range': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'Adds a secondary IP range to the Subnetwork for use in IP aliasing.\n+\nFor example, `--secondary-range name=range1,range=192.168.64.0/24` adds\na secondary range 192.168.64.0/24 with name range1.\n+\n*name*::: Name of the secondary range.\n*range*::: IP range in CIDR format.',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--secondary-range',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'dict',
                                                                                                                                                                        u'value': u'PROPERTY=VALUE'}},
                                                                                                                                      u'group': False,
                                                                                                                                      u'groups': {},
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'create',
                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                u'alpha',
                                                                                                                                                u'compute',
                                                                                                                                                u'networks',
                                                                                                                                                u'subnets',
                                                                                                                                                u'create'],
                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The name of the subnetwork.',
                                                                                                                                                        u'name': u'name',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                      u'release': u'ALPHA',
                                                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Define a subnet for a network in custom subnet mode.'}},
                                                                                                                          u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine subnetworks.',
                                                                                                                                      u'commands': {},
                                                                                                                                      u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--region',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'REGION'}},
                                                                                                                                      u'group': False,
                                                                                                                                      u'groups': {},
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'delete',
                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                u'alpha',
                                                                                                                                                u'compute',
                                                                                                                                                u'networks',
                                                                                                                                                u'subnets',
                                                                                                                                                u'delete'],
                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The resources to delete.',
                                                                                                                                                        u'name': u'names',
                                                                                                                                                        u'nargs': u'+',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                      u'release': u'ALPHA',
                                                                                                                                      u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nsubnetworks. Subnetworks can only be deleted when no other resources\n(e.g., virtual machine instances) refer to them.\n'}},
                                                                                                                          u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine subnetwork.',
                                                                                                                                        u'commands': {},
                                                                                                                                        u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--region',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'REGION'}},
                                                                                                                                        u'group': False,
                                                                                                                                        u'groups': {},
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'describe',
                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                  u'alpha',
                                                                                                                                                  u'compute',
                                                                                                                                                  u'networks',
                                                                                                                                                  u'subnets',
                                                                                                                                                  u'describe'],
                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The name of the resource to fetch.',
                                                                                                                                                          u'name': u'name',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                        u'release': u'ALPHA',
                                                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* *describe* displays all data associated with a Google Compute\nEngine subnetwork.'}},
                                                                                                                          u'expand-ip-range': {u'capsule': u'*(ALPHA)* Expand the IP range of a Google Compute Engine subnetwork.',
                                                                                                                                               u'commands': {},
                                                                                                                                               u'flags': {u'--prefix-length': {u'attr': {},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The new prefix length of the subnet. It must be smaller than the original and in the private address space 10.0.0.0/8, 172.16.0.0/12 or 192.168.0.0/16 defined in RFC 1918.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--prefix-length',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': True,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'PREFIX_LENGTH'},
                                                                                                                                                          u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u"The region of the subnetwork to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--region',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'REGION'}},
                                                                                                                                               u'group': False,
                                                                                                                                               u'groups': {},
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'expand-ip-range',
                                                                                                                                               u'path': [u'gcloud',
                                                                                                                                                         u'alpha',
                                                                                                                                                         u'compute',
                                                                                                                                                         u'networks',
                                                                                                                                                         u'subnets',
                                                                                                                                                         u'expand-ip-range'],
                                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The name of the subnetwork.',
                                                                                                                                                                 u'name': u'name',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'value': u'NAME'}],
                                                                                                                                               u'release': u'ALPHA',
                                                                                                                                               u'sections': {u'DESCRIPTION': u'*expand-ip-range* is used to expand the IP range of a subnetwork in a custom\nmode network.\n',
                                                                                                                                                             u'EXAMPLES': u"To expand the IP range of ``SUBNET'' to /16, run:\n\n  $ expand-ip-range SUBNET --region us-central1 --prefix-length 16\n"}},
                                                                                                                          u'get-iam-policy': {u'capsule': u'*(ALPHA)* Get the IAM Policy for a Google Compute Engine subnetwork.',
                                                                                                                                              u'commands': {},
                                                                                                                                              u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--region',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'REGION'}},
                                                                                                                                              u'group': False,
                                                                                                                                              u'groups': {},
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'get-iam-policy',
                                                                                                                                              u'path': [u'gcloud',
                                                                                                                                                        u'alpha',
                                                                                                                                                        u'compute',
                                                                                                                                                        u'networks',
                                                                                                                                                        u'subnets',
                                                                                                                                                        u'get-iam-policy'],
                                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The resources whose IAM policy to fetch.',
                                                                                                                                                                u'name': u'name',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'value': u'NAME'}],
                                                                                                                                              u'release': u'ALPHA',
                                                                                                                                              u'sections': {u'DESCRIPTION': u'*get-iam-policy* displays the Iam Policy associated with a Google Compute\nEngine subnetwork in a project.\n'}},
                                                                                                                          u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine subnetworks.',
                                                                                                                                    u'commands': {},
                                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--filter',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--limit',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                                               u'--network': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Only show subnetworks of a specific network.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--network',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'NETWORK'},
                                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': True,
                                                                                                                                                             u'description': u'',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': True,
                                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'bool',
                                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                                               u'--regexp': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--regexp',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'REGEXP'},
                                                                                                                                               u'--regions': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': [],
                                                                                                                                                              u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--regions',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'list',
                                                                                                                                                              u'value': u'REGION'},
                                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'list',
                                                                                                                                                              u'value': u'FIELD'},
                                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--uri',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'URI'}},
                                                                                                                                    u'group': False,
                                                                                                                                    u'groups': {},
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'list',
                                                                                                                                    u'path': [u'gcloud',
                                                                                                                                              u'alpha',
                                                                                                                                              u'compute',
                                                                                                                                              u'networks',
                                                                                                                                              u'subnets',
                                                                                                                                              u'list'],
                                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                                      u'default': [],
                                                                                                                                                      u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                                      u'name': u'names',
                                                                                                                                                      u'nargs': u'*',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'value': u'NAME'}],
                                                                                                                                    u'release': u'ALPHA',
                                                                                                                                    u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine subnetworks in a project.\n\nBy default, subnetworks from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                                                  u'EXAMPLES': u"To list all subnetworks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all subnetworks in a project, run:\n\n  $ list --uri\n\nTo list all subnetworks in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}},
                                                                                                                          u'list-usable': {u'capsule': u'*(ALPHA)* List subnetworks which the current user has permission to use.',
                                                                                                                                           u'commands': {},
                                                                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--filter',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--limit',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': True,
                                                                                                                                                                    u'description': u'',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': True,
                                                                                                                                                                    u'name': u'--no-uri',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'bool',
                                                                                                                                                                    u'value': u'NO_URI'},
                                                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--page-size',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'list',
                                                                                                                                                                     u'value': u'FIELD'},
                                                                                                                                                      u'--uri': {u'attr': {},
                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': False,
                                                                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--uri',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'bool',
                                                                                                                                                                 u'value': u'URI'}},
                                                                                                                                           u'group': False,
                                                                                                                                           u'groups': {},
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'list-usable',
                                                                                                                                           u'path': [u'gcloud',
                                                                                                                                                     u'alpha',
                                                                                                                                                     u'compute',
                                                                                                                                                     u'networks',
                                                                                                                                                     u'subnets',
                                                                                                                                                     u'list-usable'],
                                                                                                                                           u'positionals': [],
                                                                                                                                           u'release': u'ALPHA',
                                                                                                                                           u'sections': {u'DESCRIPTION': u'*list-usable* is used to list subnetworks which the current user has permission to use.\n',
                                                                                                                                                         u'EXAMPLES': u'$ list-usable\n'}},
                                                                                                                          u'set-iam-policy': {u'capsule': u'*(ALPHA)* Set the IAM Policy for a Google Compute Engine subnetwork.',
                                                                                                                                              u'commands': {},
                                                                                                                                              u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--region',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'REGION'}},
                                                                                                                                              u'group': False,
                                                                                                                                              u'groups': {},
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'set-iam-policy',
                                                                                                                                              u'path': [u'gcloud',
                                                                                                                                                        u'alpha',
                                                                                                                                                        u'compute',
                                                                                                                                                        u'networks',
                                                                                                                                                        u'subnets',
                                                                                                                                                        u'set-iam-policy'],
                                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The resources whose IAM policy to set.',
                                                                                                                                                                u'name': u'name',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'value': u'NAME'},
                                                                                                                                                               {u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Path to a local JSON or YAML formatted file containing a valid policy.',
                                                                                                                                                                u'name': u'policy-file',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'value': u'POLICY_FILE'}],
                                                                                                                                              u'release': u'ALPHA',
                                                                                                                                              u'sections': {u'DESCRIPTION': u'*set-iam-policy* sets the Iam Policy associated with a Google Compute\nEngine subnetwork in a project.\n'}},
                                                                                                                          u'update': {u'capsule': u'*(ALPHA)* Updates properties of an existing Google Compute Engine subnetwork.',
                                                                                                                                      u'commands': {},
                                                                                                                                      u'flags': {u'--enable-private-ip-google-access': {u'attr': {},
                                                                                                                                                                                        u'category': u'',
                                                                                                                                                                                        u'choices': [],
                                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                                        u'default': False,
                                                                                                                                                                                        u'description': u'Enable/disable access to Google Cloud APIs from this subnet for instances without a public ip address.',
                                                                                                                                                                                        u'group': u'',
                                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                                        u'name': u'--enable-private-ip-google-access',
                                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                                        u'required': False,
                                                                                                                                                                                        u'type': u'bool',
                                                                                                                                                                                        u'value': u'ENABLE_PRIVATE_IP_GOOGLE_ACCESS'},
                                                                                                                                                 u'--no-enable-private-ip-google-access': {u'attr': {},
                                                                                                                                                                                           u'category': u'',
                                                                                                                                                                                           u'choices': [],
                                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                                           u'default': False,
                                                                                                                                                                                           u'description': u'',
                                                                                                                                                                                           u'group': u'',
                                                                                                                                                                                           u'hidden': True,
                                                                                                                                                                                           u'name': u'--no-enable-private-ip-google-access',
                                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                                           u'required': False,
                                                                                                                                                                                           u'type': u'bool',
                                                                                                                                                                                           u'value': u'NO_ENABLE_PRIVATE_IP_GOOGLE_ACCESS'},
                                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u"The region of the subnetwork to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--region',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'REGION'}},
                                                                                                                                      u'group': False,
                                                                                                                                      u'groups': {},
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'update',
                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                u'alpha',
                                                                                                                                                u'compute',
                                                                                                                                                u'networks',
                                                                                                                                                u'subnets',
                                                                                                                                                u'update'],
                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The name of the subnetwork.',
                                                                                                                                                        u'name': u'name',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                      u'release': u'ALPHA',
                                                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Updates properties of an existing Google Compute Engine subnetwork.'}}},
                                                                                                            u'flags': {},
                                                                                                            u'group': True,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'subnets',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'compute',
                                                                                                                      u'networks',
                                                                                                                      u'subnets'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, describe, and delete Google Compute Engine subnetworks.'}},
                                                                                               u'switch-mode': {u'capsule': u'*(ALPHA)* Switch the mode of a Google Compute Engine network.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--mode': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The target mode of the network. Only support "custom" now.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--mode',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'MODE'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'switch-mode',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'networks',
                                                                                                                          u'switch-mode'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the network for which to switch mode.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*switch-mode* is used to change the mode of a network. Currently, only\nchanging from auto to custom mode is supported.\n',
                                                                                                                              u'EXAMPLES': u"To switch ``NETWORK'' to custom subnet mode, run:\n\n  $ switch-mode NETWORK --mode custom\n"}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'networks',
                                                                                 u'path': [u'gcloud',
                                                                                           u'alpha',
                                                                                           u'compute',
                                                                                           u'networks'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'ALPHA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, and delete Google Compute Engine networks.'}},
                                                                   u'operations': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine operations.',
                                                                                   u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine operation.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--global': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'If provided, it is assumed the operation is global.',
                                                                                                                                        u'group': u'describe.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--global',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'GLOBAL'},
                                                                                                                          u'--no-user-accounts': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': True,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--no-user-accounts',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_USER_ACCOUNTS'},
                                                                                                                          u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The region of the operation to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                        u'group': u'describe.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--region',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REGION'},
                                                                                                                          u'--user-accounts': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'If provided, it is assumed that the requested operation is a Compute User Accounts operation. Mutually exclusive with --global, --region, and --zone flags.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--user-accounts',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'USER_ACCOUNTS'},
                                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The zone of the operation to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                      u'group': u'describe.1',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--zone',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ZONE'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                           u'is_mutex': True,
                                                                                                                                           u'is_required': False}},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'describe',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'compute',
                                                                                                                         u'operations',
                                                                                                                         u'describe'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the operation.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine operation in a project.\n',
                                                                                                                             u'EXAMPLES': u'To get details about a global operation, run:\n\n  $ describe OPERATION --global\n\nTo get details about a regional operation, run:\n\n  $ describe OPERATION --region us-central1\n\nTo get details about a zonal operation, run:\n\n  $ describe OPERATION --zone us-central1-a\n\nTo get details about a Compute User Accounts operation, run:\n\n  $ describe OPERATION --user-accounts\n'}},
                                                                                                 u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine operations.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--accounts': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'If provided, all accounts resources are shown.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--accounts',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'ACCOUNTS'},
                                                                                                                      u'--filter': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--filter',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                      u'--global': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'If provided, all global resources are shown.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--global',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'GLOBAL'},
                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--limit',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                      u'--no-accounts': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-accounts',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_ACCOUNTS'},
                                                                                                                      u'--no-global': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-global',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_GLOBAL'},
                                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-uri',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_URI'},
                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--page-size',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                      u'--regexp': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--regexp',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'REGEXP'},
                                                                                                                      u'--regions': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'If arguments are provided, only resources from the given regions are shown. If no arguments are provided all regional operations are shown.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--regions',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'REGION'},
                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'FIELD'},
                                                                                                                      u'--uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'URI'},
                                                                                                                      u'--zones': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'If arguments are provided, only resources from the given zones are shown. If no arguments are provided all zonal operations are shown.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--zones',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'ZONE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'list',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'operations',
                                                                                                                     u'list'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': [],
                                                                                                                             u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'*',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine operations in a\nproject.\n\nBy default, all global, regional, zonal and Compute Accounts operations\nare listed. The results can be narrowed by providing combinations of\nthe --zones, --regions, --global and --accounts flags.\n\nNote: *list* displays operations fewer than 14 days old, up to a\nmaximum of 5000.\n',
                                                                                                                         u'EXAMPLES': u'To list all operations in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all operations in a project, run:\n\n  $ list --uri\n\nTo list all operations in zones us-central1-b and\neurope-west1-d, run:\n\n   $ list --zones us-central1-b,europe-west1-d\n\nTo list all global operations in a project, run:\n\n   $ list --global\n\nTo list all regional operations in a project, run:\n\n   $ list --regions ""\n\nTo list all operations in the us-central1 and europe-west1\nregions and all operations in the us-central1-a zone, run:\n\n   $ list --zones us-central1-a --regions us-central1,europe-west1\n\nTo list all Compute Accounts operations, run:\n\n   $ list --accounts\n'}}},
                                                                                   u'flags': {},
                                                                                   u'group': True,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'operations',
                                                                                   u'path': [u'gcloud',
                                                                                             u'alpha',
                                                                                             u'compute',
                                                                                             u'operations'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'ALPHA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine operations.'}},
                                                                   u'project-info': {u'capsule': u'*(ALPHA)* Read and manipulate project-level data like quotas and metadata.',
                                                                                     u'commands': {u'add-metadata': {u'capsule': u'*(ALPHA)* Add or update project-wide metadata.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--metadata': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': {},
                                                                                                                                                u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--metadata',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'dict',
                                                                                                                                                u'value': u'KEY=VALUE'},
                                                                                                                                u'--metadata-from-file': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': {},
                                                                                                                                                          u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--metadata-from-file',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'dict',
                                                                                                                                                          u'value': u'KEY=LOCAL_FILE_PATH'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'add-metadata',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'project-info',
                                                                                                                               u'add-metadata'],
                                                                                                                     u'positionals': [],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*add-metadata* can be used to add or update project-wide\nmetadata. Every instance has access to a metadata server that\ncan be used to query metadata that has been set through this\ntool. Project-wide metadata entries are visible to all\ninstances. To set metadata for individual instances, use\n`gcloud compute instances add-metadata`. For information on\nmetadata, see\n[](https://cloud.google.com/compute/docs/metadata)\n\nOnly metadata keys that are provided are mutated. Existing\nmetadata entries will remain unaffected.\n'}},
                                                                                                   u'describe': {u'capsule': u'*(ALPHA)* Describe the Google Compute Engine project resource.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'describe',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'project-info',
                                                                                                                           u'describe'],
                                                                                                                 u'positionals': [],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u"*describe* displays all data associated with the Google\nCompute Engine project resource. The project resource contains\ndata such as global quotas, common instance metadata, and the\nproject's creation time.\n"}},
                                                                                                   u'remove-metadata': {u'capsule': u'*(ALPHA)* Remove project-wide metadata entries.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--all': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'If provided, all metadata entries are removed.',
                                                                                                                                              u'group': u'remove-metadata.1',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--all',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'ALL'},
                                                                                                                                   u'--keys': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The keys of the entries to remove.',
                                                                                                                                               u'group': u'remove-metadata.1',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--keys',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'KEY'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {u'remove-metadata.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                           u'is_mutex': True,
                                                                                                                                                           u'is_required': False}},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'remove-metadata',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'alpha',
                                                                                                                                  u'compute',
                                                                                                                                  u'project-info',
                                                                                                                                  u'remove-metadata'],
                                                                                                                        u'positionals': [],
                                                                                                                        u'release': u'ALPHA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*remove-metadata* can be used to remove project-wide metadata entries.\n'}},
                                                                                                   u'set-default-service-account': {u'capsule': u'*(ALPHA)* Set the default service account on the project.',
                                                                                                                                    u'commands': {},
                                                                                                                                    u'flags': {u'--no-service-account': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': False,
                                                                                                                                                                         u'description': u'Sets the default service account on the project as no service account.\nThis causes newly created instances to not run as a service account\nby default.\n+\nTo set the default service account as no service account, specify this\nflag:\n+\n  $ {command} --no-service-account',
                                                                                                                                                                         u'group': u'set-default-service-account.1',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--no-service-account',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'bool',
                                                                                                                                                                         u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                                                                               u'--service-account': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'The email address of the service account that will be set as the default\nservice account for all newly created instances in the project.\n+\nTo set the default service account to\nexample@project.iam.gserviceaccount.com:\n+\n  $ {command} --service-account example@project.iam.gserviceaccount.com',
                                                                                                                                                                      u'group': u'set-default-service-account.1',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--service-account',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'SERVICE_ACCOUNT'}},
                                                                                                                                    u'group': False,
                                                                                                                                    u'groups': {u'set-default-service-account.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                   u'is_mutex': True,
                                                                                                                                                                                   u'is_required': False}},
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'set-default-service-account',
                                                                                                                                    u'path': [u'gcloud',
                                                                                                                                              u'alpha',
                                                                                                                                              u'compute',
                                                                                                                                              u'project-info',
                                                                                                                                              u'set-default-service-account'],
                                                                                                                                    u'positionals': [],
                                                                                                                                    u'release': u'ALPHA',
                                                                                                                                    u'sections': {u'DESCRIPTION': u'*set-default-service-account* is used to configure the default service account on project.\n\nThe project\'s default service account is used when a new instance is\ncreated unless a custom service account is set via --scopes or\n--no-scopes. Existing existances are not effected.\n\nFor example,\n\n  $ set-default-service-account --email=example@developers.gserviceaccount.com\n  $ gcloud compute instances create instance-name\n\nwill set the project\'s default service account as\nexample@developers.gserviceaccount.com. The instance created will have\nexample@developers.gserviceaccount.com as the service account associated\nwith because no service account email was specified in the\n"instances create" command.\n\nTo remove the default service account from the project, issue the command:\n\n  $ gcloud compute project-info set-default-service-account --no-service-account\n'}},
                                                                                                   u'set-usage-bucket': {u'capsule': u'*(ALPHA)* Set the usage reporting bucket for a project.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--bucket': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The URI of a Google Cloud Storage bucket where the usage\nreport object should be stored. The Google Service Account for\nperforming usage reporting is granted write access to this bucket.\nThe user running this command must be an owner of the bucket.\n+\nTo clear the usage bucket, use --no-bucket.',
                                                                                                                                                  u'group': u'set-usage-bucket.1',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--bucket',
                                                                                                                                                  u'nargs': u'?',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'BUCKET'},
                                                                                                                                    u'--no-bucket': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'Unsets the bucket. This disables usage report storage.',
                                                                                                                                                     u'group': u'set-usage-bucket.1',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--no-bucket',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_BUCKET'},
                                                                                                                                    u'--prefix': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u"An optional prefix for the name of the usage report object stored in\nthe bucket. If not supplied, then this defaults to ``usage''. The\nreport is stored as a CSV file named PREFIX_gce_YYYYMMDD.csv where\nYYYYMMDD is the day of the usage according to Pacific Time. The prefix\nshould conform to Google Cloud Storage object naming conventions.\nThis flag must not be provided when clearing the usage bucket.",
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--prefix',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'PREFIX'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {u'set-usage-bucket.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                             u'is_required': False}},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'set-usage-bucket',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'alpha',
                                                                                                                                   u'compute',
                                                                                                                                   u'project-info',
                                                                                                                                   u'set-usage-bucket'],
                                                                                                                         u'positionals': [],
                                                                                                                         u'release': u'ALPHA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*set-usage-bucket* is used to configure usage reporting for projects.\n\nSetting usage reporting will cause a log of usage per resource to be\nwritten to a specified Google Cloud Storage bucket daily. For example,\n\n  $ gcloud compute project-info set-usage-bucket --bucket gs://my-bucket\n\nwill cause logs of the form usage_gce_YYYYMMDD.csv to be written daily\nto the bucket `my-bucket`. To disable this feature, issue the command:\n\n  $ gcloud compute project-info set-usage-bucket --no-bucket\n'}}},
                                                                                     u'flags': {},
                                                                                     u'group': True,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'project-info',
                                                                                     u'path': [u'gcloud',
                                                                                               u'alpha',
                                                                                               u'compute',
                                                                                               u'project-info'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'ALPHA',
                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate project-level data like quotas and metadata.'}},
                                                                   u'regions': {u'capsule': u'*(ALPHA)* List Google Compute Engine regions.',
                                                                                u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine region.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'describe',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'compute',
                                                                                                                      u'regions',
                                                                                                                      u'describe'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The name of the resource to fetch.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine region.\n'}},
                                                                                              u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine regions.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--filter',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                                   u'--limit': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--limit',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'LIMIT'},
                                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_URI'},
                                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--page-size',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                                   u'--regexp': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--regexp',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'REGEXP'},
                                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--sort-by',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'FIELD'},
                                                                                                                   u'--uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'URI'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'list',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'compute',
                                                                                                                  u'regions',
                                                                                                                  u'list'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': [],
                                                                                                                          u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                          u'name': u'names',
                                                                                                                          u'nargs': u'*',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine regions in a project.\n',
                                                                                                                      u'EXAMPLES': u'To list all regions in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all regions in a project, run:\n\n  $ list --uri\n'}}},
                                                                                u'flags': {},
                                                                                u'group': True,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'regions',
                                                                                u'path': [u'gcloud',
                                                                                          u'alpha',
                                                                                          u'compute',
                                                                                          u'regions'],
                                                                                u'positionals': [],
                                                                                u'release': u'ALPHA',
                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* List Google Compute Engine regions.'}},
                                                                   u'reset-windows-password': {u'capsule': u'*(ALPHA)* Reset and return a password for a Windows machine instance.',
                                                                                               u'commands': {},
                                                                                               u'flags': {u'--user': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"``USER'' specifies the username to get the password for.\nIf omitted, the username is derived from your authenticated\naccount email address.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--user',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'USER'},
                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--zone',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'ZONE'}},
                                                                                               u'group': False,
                                                                                               u'groups': {},
                                                                                               u'hidden': False,
                                                                                               u'name': u'reset-windows-password',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'alpha',
                                                                                                         u'compute',
                                                                                                         u'reset-windows-password'],
                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The name of the instance.',
                                                                                                                 u'name': u'name',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'value': u'NAME'}],
                                                                                               u'release': u'ALPHA',
                                                                                               u'sections': {u'DESCRIPTION': u'*reset-windows-password* allows a user to reset and retrieve a password for\na Windows virtual machine instance. If the Windows account does not\nexist, this command will cause the account to be created and the\npassword for that new account will be returned.\n\nFor Windows instances that are running a domain controller, running\nthis command creates a new domain user if the user does not exist,\nor resets the password if the user does exist. It is not possible to\nuse this command to create a local user on a domain-controller\ninstance.\n\nFor all other instances, including domain-joined instances, running\nthis command creates a local user or resets the password for a local\nuser.\n\nWARNING: Resetting a password for an existing user can cause the\nloss of data encrypted with the current Windows password, such as\nencrypted files or stored passwords.\n\nThe user running this command must have write permission for the\nGoogle Compute Engine project containing the Windows instance.\n'}},
                                                                   u'rolling-updates': {u'capsule': u'*(ALPHA)* Manage updates in a managed instance group.',
                                                                                        u'commands': {u'cancel': {u'capsule': u'*(ALPHA)* Cancels an existing update.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'cancel',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'compute',
                                                                                                                            u'rolling-updates',
                                                                                                                            u'cancel'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Update id.',
                                                                                                                                    u'name': u'update',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'UPDATE'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'Cancels the update in state PAUSED or CANCELLED (fails if the update         is in any other state).\nNo-op if invoked in state CANCELLED.\n'}},
                                                                                                      u'describe': {u'capsule': u'*(ALPHA)* Gets information about a single update.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'describe',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'compute',
                                                                                                                              u'rolling-updates',
                                                                                                                              u'describe'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Update id.',
                                                                                                                                      u'name': u'update',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'UPDATE'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'This command gets information about a single update.\n\nBy default, this information is displayed in yaml format.\nYou can also specify json or text formats.\n'}},
                                                                                                      u'list': {u'capsule': u'*(ALPHA)* Lists all updates for a given group.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--filter',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                           u'--group': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Managed instance group name.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--group',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'GROUP'},
                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--limit',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--page-size',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'FIELD'},
                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'URI'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'list',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'rolling-updates',
                                                                                                                          u'list'],
                                                                                                                u'positionals': [],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists all updates for a given group.'}},
                                                                                                      u'list-instance-updates': {u'capsule': u'*(ALPHA)* Lists all instance updates for a given update.',
                                                                                                                                 u'commands': {},
                                                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--filter',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                                                            u'--limit': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--limit',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'LIMIT'},
                                                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': True,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-uri',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_URI'},
                                                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--page-size',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--sort-by',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'list',
                                                                                                                                                           u'value': u'FIELD'},
                                                                                                                                            u'--uri': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--uri',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'URI'}},
                                                                                                                                 u'group': False,
                                                                                                                                 u'groups': {},
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'list-instance-updates',
                                                                                                                                 u'path': [u'gcloud',
                                                                                                                                           u'alpha',
                                                                                                                                           u'compute',
                                                                                                                                           u'rolling-updates',
                                                                                                                                           u'list-instance-updates'],
                                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Update id.',
                                                                                                                                                   u'name': u'update',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'value': u'UPDATE'}],
                                                                                                                                 u'release': u'ALPHA',
                                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists all instance updates for a given update.'}},
                                                                                                      u'pause': {u'capsule': u'*(ALPHA)* Pauses an existing update.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'pause',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'rolling-updates',
                                                                                                                           u'pause'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Update id.',
                                                                                                                                   u'name': u'update',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'UPDATE'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'Pauses the update in state ROLLING_FORWARD, ROLLING_BACK or PAUSED         (fails if the update is in any other state).\nNo-op if invoked in state PAUSED.\n'}},
                                                                                                      u'resume': {u'capsule': u'*(ALPHA)* Resume an existing update.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'resume',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'compute',
                                                                                                                            u'rolling-updates',
                                                                                                                            u'resume'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Update id.',
                                                                                                                                    u'name': u'update',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'UPDATE'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Resumes the update in state ROLLING_FORWARD or PAUSED\n(fails if the update is in any other state).\nNo-op if invoked in state ROLLED_OUT.\n\nResume continues applying the new template and should be used\nwhen rollback was started, but the user decided to proceed with\nthe update.'}},
                                                                                                      u'rollback': {u'capsule': u'*(ALPHA)* Rolls back an existing update.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'rollback',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'compute',
                                                                                                                              u'rolling-updates',
                                                                                                                              u'rollback'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Update id.',
                                                                                                                                      u'name': u'update',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'UPDATE'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'Rolls back the update in state ROLLING_FORWARD, ROLLING_BACK or PAUSED         (fails if the update is in any other state).\nNo-op if invoked in state ROLLED_BACK.\n\nRollback sets the template that the Managed Instance Group         used before the update was started and gradually restarts back to the         old template all instances that are running in the new template.\n'}},
                                                                                                      u'start': {u'capsule': u'*(ALPHA)* Starts a new rolling update.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--action': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [u'RECREATE'],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': u'RECREATE',
                                                                                                                                          u'description': u"Action to be performed on each instance. Currently only 'RECREATE' is\nsupported. _ACTION_ must be (currenly only one value is supported): *RECREATE*.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--action',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'ACTION'},
                                                                                                                            u'--auto-pause-after-instances': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Number of instances after which the update will be automatically paused.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--auto-pause-after-instances',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'AUTO_PAUSE_AFTER_INSTANCES'},
                                                                                                                            u'--group': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Instance group name.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--group',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': True,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'GROUP'},
                                                                                                                            u'--instance-startup-timeout': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u"Maximum amount of time we will wait after finishing all steps until\ninstance is in *RUNNING* state. If this deadline is exceeded instance\nupdate is considered as failed. Valid units for this flag are ``s'' for\nseconds, ``m'' for minutes, ``h'' for hours and ``d'' for days. If no\nunit is specified, seconds is assumed.",
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--instance-startup-timeout',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'INSTANCE_STARTUP_TIMEOUT'},
                                                                                                                            u'--max-num-concurrent-instances': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Maximum number of instances that can be updated simultaneously.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--max-num-concurrent-instances',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'MAX_NUM_CONCURRENT_INSTANCES'},
                                                                                                                            u'--max-num-failed-instances': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u"Maximum number of instance updates that can fail without failing the\ngroup update. Instance update is considered failed if any of its\nupdate actions (currently only 'RECREATE' call) failed with permanent\nfailure, or if after finishing all update actions this instance is not\nrunning.",
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--max-num-failed-instances',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'MAX_NUM_FAILED_INSTANCES'},
                                                                                                                            u'--min-instance-update-time': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u"Specifies minimum amount of time we will spend on updating single\ninstance, measuring at the start of the first update action (currently\nonly 'RECREATE' call). If actual instance update takes less time we will\nsimply sleep before proceeding with next instance. Valid units for this\nflag are ``s'' for seconds, ``m'' for minutes, ``h'' for hours and\n``d'' for days. If no unit is specified, seconds is assumed.",
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--min-instance-update-time',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'MIN_INSTANCE_UPDATE_TIME'},
                                                                                                                            u'--template': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Name of the Compute Engine instance template resource.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--template',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'TEMPLATE'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'start',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'rolling-updates',
                                                                                                                           u'start'],
                                                                                                                 u'positionals': [],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'A rolling update causes the service to gradually update your         existing instances.\n\nYou can increase the number of instances updated simultaneously with         the --max-num-concurrent-instances flag.\n\nIf you are not sure you want to apply an update to all existing         instances, you can use the --auto-pause-after-instances flag and the         update will automatically be paused after updating the number of         instances specified. Afterwards, you can decide whether to cancel or         continue the update.\n\nIn case you notice your managed instance group misbehaving due to the         new template, you can roll back the update. This will stop the update         from being applied to more instances, and instances already created         with the new template will be recreated with the last template applied         before the current update.\n'}}},
                                                                                        u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Rolling update zone name. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--zone',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'ZONE'}},
                                                                                        u'group': True,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'rolling-updates',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'alpha',
                                                                                                  u'compute',
                                                                                                  u'rolling-updates'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'ALPHA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage updates in a managed instance group.'}},
                                                                   u'routers': {u'capsule': u'*(ALPHA)* List, create, and delete Google Compute Engine routers.',
                                                                                u'commands': {u'add-bgp-peer': {u'capsule': u'*(ALPHA)* Add a BGP peer to a router.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--advertised-route-priority': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The priority of routes advertised to this BGP peer. In the case where there is more than one matching route of maximum length, the routes with lowest priority value win. 0 <= priority <= 65535.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--advertised-route-priority',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'ADVERTISED_ROUTE_PRIORITY'},
                                                                                                                           u'--interface': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The interface of the peer being added.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--interface',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'INTERFACE'},
                                                                                                                           u'--peer-asn': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The asn of the peer being added.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--peer-asn',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'PEER_ASN'},
                                                                                                                           u'--peer-ip-address': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The link local address of the peer.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--peer-ip-address',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'PEER_IP_ADDRESS'},
                                                                                                                           u'--peer-name': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the peer being added.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--peer-name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PEER_NAME'},
                                                                                                                           u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--region',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGION'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'add-bgp-peer',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'routers',
                                                                                                                          u'add-bgp-peer'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the router.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'\n*add-bgp-peer* is used to add a BGP peer to a router.\n'}},
                                                                                              u'add-interface': {u'capsule': u'*(ALPHA)* Add an interface to a router.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--interface-name': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The name of the interface being added.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--interface-name',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': True,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'INTERFACE_NAME'},
                                                                                                                            u'--ip-address': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The link local address of the router for this interface.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--ip-address',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'IP_ADDRESS'},
                                                                                                                            u'--mask-length': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The mask for network used for the server IP address.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--mask-length',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'MASK_LENGTH'},
                                                                                                                            u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--region',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'REGION'},
                                                                                                                            u'--vpn-tunnel': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The tunnel of the interface being added.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--vpn-tunnel',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'VPN_TUNNEL'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'add-interface',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'routers',
                                                                                                                           u'add-interface'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the router.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'\n*add-interface* is used to add an interface to a router.\n'}},
                                                                                              u'create': {u'capsule': u'*(ALPHA)* Create a router.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--asn': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The BGP asn for this router',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--asn',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'ASN'},
                                                                                                                     u'--description': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'An optional description of this router.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--description',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DESCRIPTION'},
                                                                                                                     u'--network': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The network for this router',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--network',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'NETWORK'},
                                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"The region of the router to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--region',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'REGION'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'create',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'routers',
                                                                                                                    u'create'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the router.',
                                                                                                                            u'name': u'name',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'\n*create* is used to create a router for use in dynamic\nrouting with vpn tunnels.\n'}},
                                                                                              u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine routers.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--region',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'REGION'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'delete',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'routers',
                                                                                                                    u'delete'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The resources to delete.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'+',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nrouters. Routers can only be deleted when no other resources\n(e.g., virtual machine instances) refer to them.\n'}},
                                                                                              u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine router.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--region',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'REGION'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'describe',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'compute',
                                                                                                                      u'routers',
                                                                                                                      u'describe'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The name of the resource to fetch.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* *describe* displays all data associated with a Google Compute\nEngine router.'}},
                                                                                              u'get-status': {u'capsule': u'*(ALPHA)* Get status of a Google Compute Engine router.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--region',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'REGION'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'get-status',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'compute',
                                                                                                                        u'routers',
                                                                                                                        u'get-status'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the resource to fetch.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* *get-status* displays all runtime data associated with a Google Compute\nEngine router.'}},
                                                                                              u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine routers.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--filter',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                                   u'--limit': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--limit',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'LIMIT'},
                                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_URI'},
                                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--page-size',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                                   u'--regexp': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--regexp',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'REGEXP'},
                                                                                                                   u'--regions': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': [],
                                                                                                                                  u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--regions',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'REGION'},
                                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--sort-by',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'FIELD'},
                                                                                                                   u'--uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'URI'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'list',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'compute',
                                                                                                                  u'routers',
                                                                                                                  u'list'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': [],
                                                                                                                          u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                          u'name': u'names',
                                                                                                                          u'nargs': u'*',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine routers in a project.\n\nBy default, routers from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                      u'EXAMPLES': u"To list all routers in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all routers in a project, run:\n\n  $ list --uri\n\nTo list all routers in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}},
                                                                                              u'remove-bgp-peer': {u'capsule': u'*(ALPHA)* Remove a BGP peer from a router.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--peer-name': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The name of the peer being removed.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--peer-name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PEER_NAME'},
                                                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'remove-bgp-peer',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'routers',
                                                                                                                             u'remove-bgp-peer'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the router.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'\n*remove-bgp-peer* removes a BGP peer from a router.\n'}},
                                                                                              u'remove-interface': {u'capsule': u'*(ALPHA)* Remove an interface from a router.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--interface-name': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The name of the interface being removed.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--interface-name',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': True,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'INTERFACE_NAME'},
                                                                                                                               u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--region',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGION'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'remove-interface',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'compute',
                                                                                                                              u'routers',
                                                                                                                              u'remove-interface'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the router.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'\n*remove-interface* removes an interface from a router.\n'}},
                                                                                              u'update-bgp-peer': {u'capsule': u'*(ALPHA)* Update a BGP peer on a router.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--advertised-route-priority': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The priority of routes advertised to this BGP peer. In the case where there is more than one matching route of maximum length, the routes with lowest priority value win. 0 <= priority <= 65535.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--advertised-route-priority',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'ADVERTISED_ROUTE_PRIORITY'},
                                                                                                                              u'--interface': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The new interface of the peer being modified.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--interface',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'INTERFACE'},
                                                                                                                              u'--ip-address': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The new link local address of the router for this peer.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--ip-address',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'IP_ADDRESS'},
                                                                                                                              u'--peer-asn': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The new asn of the peer being modified.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--peer-asn',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PEER_ASN'},
                                                                                                                              u'--peer-ip-address': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The new link local address of the peer.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--peer-ip-address',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'PEER_IP_ADDRESS'},
                                                                                                                              u'--peer-name': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The name of the peer being modified.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--peer-name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PEER_NAME'},
                                                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'update-bgp-peer',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'routers',
                                                                                                                             u'update-bgp-peer'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the router.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'\n*update-bgp-peer* is used to update a BGP peer on a router.\n'}},
                                                                                              u'update-interface': {u'capsule': u'*(ALPHA)* Update an interface on a router.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--interface-name': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The name of the interface being updated.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--interface-name',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': True,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'INTERFACE_NAME'},
                                                                                                                               u'--ip-address': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The link local address of the router for this interface.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--ip-address',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'IP_ADDRESS'},
                                                                                                                               u'--mask-length': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The mask for network used for the server IP address.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--mask-length',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'MASK_LENGTH'},
                                                                                                                               u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--region',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGION'},
                                                                                                                               u'--vpn-tunnel': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The tunnel of the interface being updated.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--vpn-tunnel',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'VPN_TUNNEL'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'update-interface',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'compute',
                                                                                                                              u'routers',
                                                                                                                              u'update-interface'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the router.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'\n*update-interface* is used to update an interface on a router.\n'}}},
                                                                                u'flags': {},
                                                                                u'group': True,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'routers',
                                                                                u'path': [u'gcloud',
                                                                                          u'alpha',
                                                                                          u'compute',
                                                                                          u'routers'],
                                                                                u'positionals': [],
                                                                                u'release': u'ALPHA',
                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, and delete Google Compute Engine routers.'}},
                                                                   u'routes': {u'capsule': u'*(ALPHA)* Read and manipulate routes.',
                                                                               u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a new route.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--description': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'An optional, textual description for the route.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--description',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                    u'--destination-range': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"The destination range of outgoing packets that the route will\napply to. To match all traffic, use ``0.0.0.0/0''.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--destination-range',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': True,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DESTINATION_RANGE'},
                                                                                                                    u'--network': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': u'default',
                                                                                                                                   u'description': u'Specifies the network to which the route will be applied.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--network',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'NETWORK'},
                                                                                                                    u'--next-hop-address': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"Specifies the IP address of an instance that should handle\nmatching packets. The instance must have IP forwarding enabled\n(i.e., include ``--can-ip-forward'' when creating the instance\nusing `gcloud compute instances create`)",
                                                                                                                                            u'group': u'create.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--next-hop-address',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'NEXT_HOP_ADDRESS'},
                                                                                                                    u'--next-hop-gateway': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"Specifies the gateway that should handle matching\npackets. Currently, the only acceptable value is\n``default-internet-gateway'' which is a gateway operated by\nGoogle Compute Engine.",
                                                                                                                                            u'group': u'create.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--next-hop-gateway',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'NEXT_HOP_GATEWAY'},
                                                                                                                    u'--next-hop-instance': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"Specifies the name of an instance that should handle traffic\nmatching this route. When this flag is specified, the zone of\nthe instance must be specified using\n``--next-hop-instance-zone''.",
                                                                                                                                             u'group': u'create.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--next-hop-instance',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'NEXT_HOP_INSTANCE'},
                                                                                                                    u'--next-hop-instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u"The zone of the next hop instance. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--next-hop-instance-zone',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'NEXT_HOP_INSTANCE_ZONE'},
                                                                                                                    u'--next-hop-vpn-tunnel': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The target VPN tunnel that will receive forwarded traffic.',
                                                                                                                                               u'group': u'create.1',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--next-hop-vpn-tunnel',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'NEXT_HOP_VPN_TUNNEL'},
                                                                                                                    u'--next-hop-vpn-tunnel-region': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"The region of the next hop vpn tunnel. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--next-hop-vpn-tunnel-region',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'NEXT_HOP_VPN_TUNNEL_REGION'},
                                                                                                                    u'--priority': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': 1000,
                                                                                                                                    u'description': u'Specifies the priority of this route relative to other routes\nwith the same specificity. The lower the value, the higher the\npriority.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--priority',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'int',
                                                                                                                                    u'value': u'PRIORITY'},
                                                                                                                    u'--tags': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': [],
                                                                                                                                u'description': u'Identifies the set of instances that this route will apply to. If no\ntags are provided, the route will apply to all instances in the network.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--tags',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'TAG'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {u'create.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                   u'is_mutex': True,
                                                                                                                                   u'is_required': True}},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'create',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'compute',
                                                                                                                   u'routes',
                                                                                                                   u'create'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name to assign to the route.',
                                                                                                                           u'name': u'name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u"*create* is used to create routes. A route is a rule that\nspecifies how certain packets should be handled by the virtual\nnetwork. Routes are associated with virtual machine instances\nby tag, and the set of routes for a particular VM is called\nits routing table. For each packet leaving a virtual machine,\nthe system searches that machine's routing table for a single\nbest matching route.\n\nRoutes match packets by destination IP address, preferring\nsmaller or more specific ranges over larger ones (see\n``--destination-range''). If there is a tie, the system selects\nthe route with the smallest priority value. If there is still\na tie, it uses the layer three and four packet headers to\nselect just one of the remaining matching routes. The packet\nis then forwarded as specified by ``--next-hop-address'',\n``--next-hop-instance'', ``--next-hop-vpn-tunnel'', or\n``--next-hop-gateway'' of the winning route. Packets that do\nnot match any route in the sending virtual machine routing\ntable will be dropped.\n\nExactly one of ``--next-hop-address'', ``--next-hop-gateway'',\n``--next-hop-vpn-tunnel'', or ``--next-hop-instance'' must be\nprovided with this command.\n"}},
                                                                                             u'delete': {u'capsule': u'*(ALPHA)* Delete routes.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'delete',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'compute',
                                                                                                                   u'routes',
                                                                                                                   u'delete'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The resources to delete.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'+',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine routes.\n'}},
                                                                                             u'describe': {u'capsule': u'*(ALPHA)* Describe a route.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'describe',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'routes',
                                                                                                                     u'describe'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the resource to fetch.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine route in a project.\n'}},
                                                                                             u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine routes.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_URI'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--regexp': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--regexp',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'REGEXP'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'},
                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'URI'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'list',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'compute',
                                                                                                                 u'routes',
                                                                                                                 u'list'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': [],
                                                                                                                         u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                         u'name': u'names',
                                                                                                                         u'nargs': u'*',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'NAME'}],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine routes in a project.\n',
                                                                                                                     u'EXAMPLES': u'To list all routes in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all routes in a project, run:\n\n  $ list --uri\n'}}},
                                                                               u'flags': {},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'routes',
                                                                               u'path': [u'gcloud',
                                                                                         u'alpha',
                                                                                         u'compute',
                                                                                         u'routes'],
                                                                               u'positionals': [],
                                                                               u'release': u'ALPHA',
                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate routes.'}},
                                                                   u'scp': {u'capsule': u'*(ALPHA)* Copy files to and from Google Compute Engine virtual machines via scp.',
                                                                            u'commands': {},
                                                                            u'flags': {u'--compress': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u'Enable compression.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--compress',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'COMPRESS'},
                                                                                       u'--dry-run': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': False,
                                                                                                      u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--dry-run',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'DRY_RUN'},
                                                                                       u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--force-key-file-overwrite',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                       u'--no-compress': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-compress',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_COMPRESS'},
                                                                                       u'--no-dry-run': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': True,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--no-dry-run',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'NO_DRY_RUN'},
                                                                                       u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-force-key-file-overwrite',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                       u'--no-plain': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': True,
                                                                                                       u'description': u'',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': True,
                                                                                                       u'name': u'--no-plain',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'NO_PLAIN'},
                                                                                       u'--no-recurse': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': True,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--no-recurse',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'NO_RECURSE'},
                                                                                       u'--plain': {u'attr': {},
                                                                                                    u'category': u'',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': False,
                                                                                                    u'description': u'Suppresses the automatic addition of *ssh(1)*/*scp(1)* flags. This flag\nis useful if you want to take care of authentication yourself or\nuse specific ssh/scp features.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--plain',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'PLAIN'},
                                                                                       u'--port': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The port to connect to.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--port',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'PORT'},
                                                                                       u'--recurse': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': False,
                                                                                                      u'description': u'Upload directories recursively.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--recurse',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'RECURSE'},
                                                                                       u'--scp-flag': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Extra flag to be sent to scp. This flag may be repeated.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--scp-flag',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'SCP_FLAG'},
                                                                                       u'--ssh-key-file': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--ssh-key-file',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'SSH_KEY_FILE'},
                                                                                       u'--strict-host-key-checking': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [u'yes',
                                                                                                                                    u'no',
                                                                                                                                    u'ask'],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u"Override the default behavior of StrictHostKeyChecking. By default,\nStrictHostKeyChecking is set to 'no' the first time you connect to an\ninstance and will be set to 'yes' for all subsequent connections. Use\nthis flag to specify a value for the connection. _STRICT_HOST_KEY_CHECKING_ must be one of: *yes*, *no*, *ask*.",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--strict-host-key-checking',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'STRICT_HOST_KEY_CHECKING'},
                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u"The zone of the instance to copy files to/from.\n+\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--zone',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'ZONE'}},
                                                                            u'group': False,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'scp',
                                                                            u'path': [u'gcloud',
                                                                                      u'alpha',
                                                                                      u'compute',
                                                                                      u'scp'],
                                                                            u'positionals': [{u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u'Specifies the files to copy.',
                                                                                              u'name': u'sources',
                                                                                              u'nargs': u'+',
                                                                                              u'required': False,
                                                                                              u'value': u'[[USER@]INSTANCE:]SRC'},
                                                                                             {u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u'Specifies a destination for the source files.',
                                                                                              u'name': u'destination',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'value': u'[[USER@]INSTANCE:]DEST'}],
                                                                            u'release': u'ALPHA',
                                                                            u'sections': {u'DESCRIPTION': u"*scp* copies files between a virtual machine instance\nand your local machine using the scp command.\n\nTo denote a remote file, prefix the file name with the virtual\nmachine instance name (e.g., _example-instance_:~/_FILE_). To\ndenote a local file, do not add a prefix to the file name\n(e.g., ~/_FILE_). For example, to copy a remote directory\nto your local host, run:\n\n  $ scp example-instance:~/REMOTE-DIR ~/LOCAL-DIR --zone us-central1-a\n\nIn the above example, ``~/REMOTE-DIR'' from ``example-instance'' is\ncopied into the ~/_LOCAL-DIR_ directory.\n\nConversely, files from your local computer can be copied to a\nvirtual machine:\n\n  $ scp ~/LOCAL-FILE-1 ~/LOCAL-FILE-2 example-instance:~/REMOTE-DIR --zone us-central1-a\n\nIf a file contains a colon (``:''), you must specify it by\neither using an absolute path or a path that begins with\n``./''.\n\nUnder the covers, *scp(1)* or pscp (on Windows) is used to facilitate the transfer.\n\nWhen the destination is local, all sources must be the same\nvirtual machine instance. When the destination is remote, all\nsource must be local.\n"}},
                                                                   u'snapshots': {u'capsule': u'*(ALPHA)* List, describe, and delete Google Compute Engine snapshots.',
                                                                                  u'commands': {u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine snapshots.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'delete',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'compute',
                                                                                                                      u'snapshots',
                                                                                                                      u'delete'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The resources to delete.',
                                                                                                                              u'name': u'names',
                                                                                                                              u'nargs': u'+',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine snapshots.\n'}},
                                                                                                u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine snapshot.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'compute',
                                                                                                                        u'snapshots',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the resource to fetch.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine snapshot in a project.\n'}},
                                                                                                u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine snapshots.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--regexp': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--regexp',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'REGEXP'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'snapshots',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': [],
                                                                                                                            u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'*',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine snapshots in a project.\n',
                                                                                                                        u'EXAMPLES': u'To list all snapshots in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all snapshots in a project, run:\n\n  $ list --uri\n'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'snapshots',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'compute',
                                                                                            u'snapshots'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, describe, and delete Google Compute Engine snapshots.'}},
                                                                   u'ssh': {u'capsule': u'*(ALPHA)* SSH into a virtual machine instance.',
                                                                            u'commands': {},
                                                                            u'flags': {u'--command': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'A command to run on the virtual machine.\n+\nRuns the command on the target instance and then exits.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--command',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'COMMAND'},
                                                                                       u'--container': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The name of a container inside of the virtual machine instance to\nconnect to. This only applies to virtual machines that are using\na Google container virtual machine image. For more information,\nsee [](https://cloud.google.com/compute/docs/containers)',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--container',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'CONTAINER'},
                                                                                       u'--dry-run': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': False,
                                                                                                      u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--dry-run',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'DRY_RUN'},
                                                                                       u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--force-key-file-overwrite',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                       u'--no-dry-run': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': True,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--no-dry-run',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'NO_DRY_RUN'},
                                                                                       u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-force-key-file-overwrite',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                       u'--no-plain': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': True,
                                                                                                       u'description': u'',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': True,
                                                                                                       u'name': u'--no-plain',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'NO_PLAIN'},
                                                                                       u'--plain': {u'attr': {},
                                                                                                    u'category': u'',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': False,
                                                                                                    u'description': u'Suppresses the automatic addition of *ssh(1)*/*scp(1)* flags. This flag\nis useful if you want to take care of authentication yourself or\nuse specific ssh/scp features.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--plain',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'PLAIN'},
                                                                                       u'--ssh-flag': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Additional flags to be passed to *ssh(1)*. It is recommended that flags\nbe passed using an assignment operator and quotes. This flag will\nreplace occurences of ``%USER%\'\' and ``%INSTANCE%\'\' with their\ndereferenced values. Example:\n+\n  $ {command} example-instance --zone us-central1-a --ssh-flag="-vvv" --ssh-flag="-L 80:%INSTANCE%:80"\n+\nis equivalent to passing the flags ``--vvv\'\' and ``-L\n80:162.222.181.197:80\'\' to *ssh(1)* if the external IP address of\n\'example-instance\' is 162.222.181.197.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--ssh-flag',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'SSH_FLAG'},
                                                                                       u'--ssh-key-file': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--ssh-key-file',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'SSH_KEY_FILE'},
                                                                                       u'--strict-host-key-checking': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [u'yes',
                                                                                                                                    u'no',
                                                                                                                                    u'ask'],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u"Override the default behavior of StrictHostKeyChecking. By default,\nStrictHostKeyChecking is set to 'no' the first time you connect to an\ninstance and will be set to 'yes' for all subsequent connections. Use\nthis flag to specify a value for the connection. _STRICT_HOST_KEY_CHECKING_ must be one of: *yes*, *no*, *ask*.",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--strict-host-key-checking',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'STRICT_HOST_KEY_CHECKING'},
                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u"The zone of the instance to connect to. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--zone',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'ZONE'}},
                                                                            u'group': False,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'ssh',
                                                                            u'path': [u'gcloud',
                                                                                      u'alpha',
                                                                                      u'compute',
                                                                                      u'ssh'],
                                                                            u'positionals': [{u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u"Specifies the instance to SSH into.\n+\n``USER'' specifies the username with which to SSH. If omitted,\n$USER from the environment is selected.",
                                                                                              u'name': u'user-host',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'value': u'[USER@]INSTANCE'},
                                                                                             {u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u"Flags and positionals passed to the underlying ssh implementation.\n+\n\nThe '--' argument must be specified between gcloud specific args on the left and SSH_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017. Example:\n+\n        $ {command} example-instance --zone us-central1-a -- -vvv -L 80:%INSTANCE%:80",
                                                                                              u'name': u'ssh-args',
                                                                                              u'nargs': u'...',
                                                                                              u'required': False,
                                                                                              u'value': u'SSH_ARGS'}],
                                                                            u'release': u'ALPHA',
                                                                            u'sections': {u'DESCRIPTION': u"*ssh* is a thin wrapper around the *ssh(1)* command that\ntakes care of authentication and the translation of the\ninstance name into an IP address.\n\nThis command uses the Compute Accounts API to ensure that the user's\npublic SSH key is availibe to the VM. This form of key management\nwill only work with VMs configured to work with the Compute Accounts\nAPI. If the user does not have a public SSH key, one is generated using\n*ssh-keygen(1)* (if `the --quiet` flag is given, the generated key will\nhave an empty passphrase).\n\n",
                                                                                          u'EXAMPLES': u'To SSH into \'example-instance\' in zone ``us-central1-a\'\', run:\n\n  $ ssh example-instance --zone us-central1-a\n\nYou can also run a command on the virtual machine. For\nexample, to get a snapshot of the guest\'s process tree, run:\n\n  $ ssh example-instance --zone us-central1-a --command "ps -ejH"\n\nIf you are using the Google container virtual machine image, you\ncan SSH into one of your containers with:\n\n  $ ssh example-instance --zone us-central1-a --container CONTAINER\n'}},
                                                                   u'ssl-certificates': {u'capsule': u'*(ALPHA)* List, create, and delete Google Compute Engine SSL certificates.',
                                                                                         u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a Google Compute Engine SSL certificate.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--certificate': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The path to a local certificate file. The certificate must be in PEM\nformat.  The certificate chain must be no greater than 5 certs long. The\nchain must include at least one intermediate cert.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--certificate',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': True,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'LOCAL_FILE_PATH'},
                                                                                                                              u'--description': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'An optional, textual description for the SSL certificate.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--description',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'DESCRIPTION'},
                                                                                                                              u'--private-key': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The path to a local private key file. The private key must be in PEM\nformat and must use RSA or ECDSA encryption.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--private-key',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': True,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'LOCAL_FILE_PATH'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'create',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'ssl-certificates',
                                                                                                                             u'create'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the SSL certificate.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* *create* is used to create SSL certificates which can be used to\nconfigure a target HTTPS proxy. An SSL certificate consists of a\ncertificate and private key. The private key is encrypted before it is\nstored.'}},
                                                                                                       u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine SSL certificates.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'delete',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'ssl-certificates',
                                                                                                                             u'delete'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The resources to delete.',
                                                                                                                                     u'name': u'names',
                                                                                                                                     u'nargs': u'+',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine SSL certificates.\nSSL certificates can only be deleted when no other resources (e.g.,\ntarget HTTPS proxies) refer to them.\n'}},
                                                                                                       u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine SSL certificate.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'describe',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'ssl-certificates',
                                                                                                                               u'describe'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the resource to fetch.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with Google Compute\nEngine SSL certificate in a project.\n'}},
                                                                                                       u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine SSL certificates.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--filter',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                                            u'--limit': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--limit',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'LIMIT'},
                                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_URI'},
                                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--page-size',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                                            u'--regexp': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--regexp',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'REGEXP'},
                                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--sort-by',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'FIELD'},
                                                                                                                            u'--uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'URI'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'list',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'ssl-certificates',
                                                                                                                           u'list'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': [],
                                                                                                                                   u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                   u'name': u'names',
                                                                                                                                   u'nargs': u'*',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine SSL certificates in a project.\n',
                                                                                                                               u'EXAMPLES': u'To list all SSL certificates in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all SSL certificates in a project, run:\n\n  $ list --uri\n'}}},
                                                                                         u'flags': {},
                                                                                         u'group': True,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'ssl-certificates',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'alpha',
                                                                                                   u'compute',
                                                                                                   u'ssl-certificates'],
                                                                                         u'positionals': [],
                                                                                         u'release': u'ALPHA',
                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, and delete Google Compute Engine SSL certificates.'}},
                                                                   u'target-http-proxies': {u'capsule': u'*(ALPHA)* List, create, and delete target HTTP proxies.',
                                                                                            u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a target HTTP proxy.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--description': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'An optional, textual description for the target HTTP proxy.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--description',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                 u'--url-map': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'A reference to a URL map resource that defines the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTP proxy.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--url-map',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': True,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'URL_MAP'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'create',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'target-http-proxies',
                                                                                                                                u'create'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the target HTTP proxy.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u"\n*create* is used to create target HTTP proxies. A target\nHTTP proxy is referenced by one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTP proxy points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests.\n"}},
                                                                                                          u'delete': {u'capsule': u'*(ALPHA)* Delete target HTTP proxies.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'delete',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'target-http-proxies',
                                                                                                                                u'delete'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The resources to delete.',
                                                                                                                                        u'name': u'names',
                                                                                                                                        u'nargs': u'+',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*delete* deletes one or more target HTTP proxies.\n'}},
                                                                                                          u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about a target HTTP proxy.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'describe',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'alpha',
                                                                                                                                  u'compute',
                                                                                                                                  u'target-http-proxies',
                                                                                                                                  u'describe'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the resource to fetch.',
                                                                                                                                          u'name': u'name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'NAME'}],
                                                                                                                        u'release': u'ALPHA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a target HTTP proxy\nin a project.\n'}},
                                                                                                          u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine target HTTP proxies.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--filter',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--limit',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                               u'--regexp': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--regexp',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGEXP'},
                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'FIELD'},
                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'URI'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'list',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'compute',
                                                                                                                              u'target-http-proxies',
                                                                                                                              u'list'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': [],
                                                                                                                                      u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                      u'name': u'names',
                                                                                                                                      u'nargs': u'*',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine target HTTP proxies in a project.\n',
                                                                                                                                  u'EXAMPLES': u'To list all target HTTP proxies in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target HTTP proxies in a project, run:\n\n  $ list --uri\n'}},
                                                                                                          u'update': {u'capsule': u'*(ALPHA)* Update a target HTTP proxy.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--url-map': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'A reference to a URL map resource that will define the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTP proxy.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--url-map',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': True,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'URL_MAP'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'update',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'target-http-proxies',
                                                                                                                                u'update'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the target HTTP proxy.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u"*update* is used to change the URL map of existing\ntarget HTTP proxies. A target HTTP proxy is referenced\nby one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTP proxy in turn points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests.\n"}}},
                                                                                            u'flags': {},
                                                                                            u'group': True,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'target-http-proxies',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'alpha',
                                                                                                      u'compute',
                                                                                                      u'target-http-proxies'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'ALPHA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, and delete target HTTP proxies.'}},
                                                                   u'target-https-proxies': {u'capsule': u'*(ALPHA)* List, create, and delete target HTTPS proxies.',
                                                                                             u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a target HTTPS proxy.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--description': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'An optional, textual description for the target HTTPS proxy.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--description',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                                  u'--ssl-certificate': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target HTTPS proxy.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--ssl-certificate',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': True,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'SSL_CERTIFICATE'},
                                                                                                                                  u'--url-map': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'A reference to a URL map resource that defines the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTPS proxy.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--url-map',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': True,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'URL_MAP'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'create',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'target-https-proxies',
                                                                                                                                 u'create'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the target HTTPS proxy.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u"\n*create* is used to create target HTTPS proxies. A target\nHTTPS proxy is referenced by one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTPS proxy points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests. The target\nHTTPS proxy also points to an SSL certificate used for\nserver-side authentication.\n"}},
                                                                                                           u'delete': {u'capsule': u'*(ALPHA)* Delete target HTTPS proxies.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'delete',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'target-https-proxies',
                                                                                                                                 u'delete'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The resources to delete.',
                                                                                                                                         u'name': u'names',
                                                                                                                                         u'nargs': u'+',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*delete* deletes one or more target HTTPS proxies.\n'}},
                                                                                                           u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about a target HTTPS proxy.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'describe',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'alpha',
                                                                                                                                   u'compute',
                                                                                                                                   u'target-https-proxies',
                                                                                                                                   u'describe'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The name of the resource to fetch.',
                                                                                                                                           u'name': u'name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'NAME'}],
                                                                                                                         u'release': u'ALPHA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a target HTTPS proxy\nin a project.\n'}},
                                                                                                           u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine target HTTPS proxies.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--filter',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                                u'--limit': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--limit',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'LIMIT'},
                                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': True,
                                                                                                                                              u'description': u'',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': True,
                                                                                                                                              u'name': u'--no-uri',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'NO_URI'},
                                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--page-size',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                                u'--regexp': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--regexp',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'REGEXP'},
                                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--sort-by',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'FIELD'},
                                                                                                                                u'--uri': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--uri',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'URI'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'list',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'target-https-proxies',
                                                                                                                               u'list'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': [],
                                                                                                                                       u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                       u'name': u'names',
                                                                                                                                       u'nargs': u'*',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine target HTTPS proxies in a project.\n',
                                                                                                                                   u'EXAMPLES': u'To list all target HTTPS proxies in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target HTTPS proxies in a project, run:\n\n  $ list --uri\n'}},
                                                                                                           u'update': {u'capsule': u'*(ALPHA)* Update a target HTTPS proxy.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--ssl-certificate': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target HTTPS proxy.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--ssl-certificate',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'SSL_CERTIFICATE'},
                                                                                                                                  u'--url-map': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'A reference to a URL map resource that defines the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTPS proxy.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--url-map',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'URL_MAP'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'update',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'target-https-proxies',
                                                                                                                                 u'update'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the target HTTPS proxy.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u"*update* is used to change the SSL certificate and/or URL map of\nexisting target HTTPS proxies. A target HTTPS proxy is referenced\nby one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTPS proxy in turn points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests. The target\nHTTPS proxy also points to an SSL certificate used for\nserver-side authentication.\n"}}},
                                                                                             u'flags': {},
                                                                                             u'group': True,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'target-https-proxies',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'alpha',
                                                                                                       u'compute',
                                                                                                       u'target-https-proxies'],
                                                                                             u'positionals': [],
                                                                                             u'release': u'ALPHA',
                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, and delete target HTTPS proxies.'}},
                                                                   u'target-instances': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine virtual target instances.',
                                                                                         u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a target instance for handling traffic from a forwarding rule.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--description': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'An optional, textual description of the target instance.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--description',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'DESCRIPTION'},
                                                                                                                              u'--instance': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The name of the virtual machine instance that will handle the traffic.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--instance',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'INSTANCE'},
                                                                                                                              u'--instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The zone of the instance to operate on. If not specified, it will be set to the same as zone. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--instance-zone',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'INSTANCE_ZONE'},
                                                                                                                              u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"The zone of the target instance to create the target instance in. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--zone',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'ZONE'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'create',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'target-instances',
                                                                                                                             u'create'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the target instance.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*create* is used to create a target instance for handling\ntraffic from one or more forwarding rules. Target instances\nare ideal for traffic that should be managed by a single\nsource. For more information on target instances, see\n[](https://cloud.google.com/compute/docs/protocol-forwarding/#targetinstances)\n'}},
                                                                                                       u'delete': {u'capsule': u'*(ALPHA)* Delete target instances.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"The zone of the resources to delete. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--zone',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'ZONE'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'delete',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'target-instances',
                                                                                                                             u'delete'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The resources to delete.',
                                                                                                                                     u'name': u'names',
                                                                                                                                     u'nargs': u'+',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine target\ninstances. Target instances can be deleted only if they are\nnot being used by any other resources like forwarding rules.\n'}},
                                                                                                       u'describe': {u'capsule': u'*(ALPHA)* Describe a target instance.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--zone',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'describe',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'target-instances',
                                                                                                                               u'describe'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the resource to fetch.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine target instance in a project.\n'}},
                                                                                                       u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine target instances.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--filter',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                                            u'--limit': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--limit',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'LIMIT'},
                                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_URI'},
                                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--page-size',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                                            u'--regexp': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--regexp',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'REGEXP'},
                                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--sort-by',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'FIELD'},
                                                                                                                            u'--uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'URI'},
                                                                                                                            u'--zones': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': [],
                                                                                                                                         u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--zones',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'ZONE'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'list',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'target-instances',
                                                                                                                           u'list'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': [],
                                                                                                                                   u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                   u'name': u'names',
                                                                                                                                   u'nargs': u'*',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine target instances in a project.\n\nBy default, target instances from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                               u'EXAMPLES': u"To list all target instances in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target instances in a project, run:\n\n  $ list --uri\n\nTo list all target instances in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                                         u'flags': {},
                                                                                         u'group': True,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'target-instances',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'alpha',
                                                                                                   u'compute',
                                                                                                   u'target-instances'],
                                                                                         u'positionals': [],
                                                                                         u'release': u'ALPHA',
                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine virtual target instances.'}},
                                                                   u'target-pools': {u'capsule': u'*(ALPHA)* Control Compute Engine target pools for network load balancing.',
                                                                                     u'commands': {u'add-health-checks': {u'capsule': u'*(ALPHA)* Add an HTTP health check to a target pool.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--http-health-check': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Specifies an HTTP health check object to add to the target pool.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--http-health-check',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': True,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The region of the target pool to add health checks to. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--region',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'REGION'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'add-health-checks',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'alpha',
                                                                                                                                    u'compute',
                                                                                                                                    u'target-pools',
                                                                                                                                    u'add-health-checks'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the target pool to which to add the health check.',
                                                                                                                                            u'name': u'name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'NAME'}],
                                                                                                                          u'release': u'ALPHA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* *add-health-checks* is used to add an HTTP health check\nto a target pool. Health checks are used to determine\nthe health status of instances in the target pool. Only one\nhealth check can be attached to a target pool, so this command\nwill fail if there as already a health check attached to the target\npool. For more information on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)'}},
                                                                                                   u'add-instances': {u'capsule': u'*(ALPHA)* Add instances to a target pool.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Specifies a list of instances to add to the target pool.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--instances',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': True,
                                                                                                                                                  u'type': u'list',
                                                                                                                                                  u'value': u'INSTANCE'},
                                                                                                                                 u'--instances-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u"The zone of the instances to add to the target pool. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--instances-zone',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'INSTANCES_ZONE'},
                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the instances. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--region',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'REGION'},
                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The zone of the instances to add to the target pool. DEPRECATED, use --instances-zone. If not specified, you will be prompted to select a zone. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--zone',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'add-instances',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'target-pools',
                                                                                                                                u'add-instances'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the target pool to which to add the instances.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*add-instances* is used to add one or more instances to a target pool.\nFor more information on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                   u'create': {u'capsule': u'*(ALPHA)* Define a load-balanced pool of virtual machine instances.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--backup-pool': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"Together with ``--failover-ratio'', this flag defines the fallback\nbehavior of the target pool (primary pool) to be created by this\ncommand. If the ratio of the healthy instances in the primary pool\nis at or below the specified ``--failover-ratio value'', then traffic\narriving at the load-balanced IP address will be directed to the\nbackup pool. If this flag is provided, then ``--failover-ratio'' is\nrequired.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--backup-pool',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'BACKUP_POOL'},
                                                                                                                          u'--description': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'An optional description of this target pool.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--description',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DESCRIPTION'},
                                                                                                                          u'--failover-ratio': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"Together with ``--backup-pool'', defines the fallback behavior of the\ntarget pool (primary pool) to be created by this command. If the\nratio of the healthy instances in the primary pool is at or below this\nnumber, traffic arriving at the load-balanced IP address will be\ndirected to the backup pool. For example, if 0.4 is chosen as the\nfailover ratio, then traffic will fail over to the backup pool if\nmore than 40% of the instances become unhealthy.\nIf not set, the traffic will be directed the\ninstances in this pool in the ``force'' mode, where traffic will be\nspread to the healthy instances with the best effort, or to all\ninstances when no instance is healthy.\nIf this flag is provided, then ``--backup-pool'' is required.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--failover-ratio',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'FAILOVER_RATIO'},
                                                                                                                          u'--health-check': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'DEPRECATED, use --http-health-check.\nSpecifies an HTTP health check resource to use to determine the health\nof instances in this pool. If no health check is specified, traffic will\nbe sent to all instances in this target pool as if the instances\nwere healthy, but the health status of this pool will appear as\nunhealthy as a warning that this target pool does not have a health\ncheck.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--health-check',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'HEALTH_CHECK'},
                                                                                                                          u'--http-health-check': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Specifies an HTTP health check resource to use to determine the health\nof instances in this pool. If no health check is specified, traffic will\nbe sent to all instances in this target pool as if the instances\nwere healthy, but the health status of this pool will appear as\nunhealthy as a warning that this target pool does not have a health\ncheck.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--http-health-check',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                          u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The region of the target pool to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--region',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REGION'},
                                                                                                                          u'--session-affinity': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [u'CLIENT_IP',
                                                                                                                                                               u'CLIENT_IP_PROTO',
                                                                                                                                                               u'GENERATED_COOKIE',
                                                                                                                                                               u'NONE'],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': u'NONE',
                                                                                                                                                  u'description': u'The type of session affinity to use for this backend service. _SESSION_AFFINITY_ must be one of:\n+\n*CLIENT_IP*::: Route requests to instances based on the hash of the client\'s IP address.\n*CLIENT_IP_PROTO*::: Connections from the same client IP with the same IP protocol willgo to the same VM in the pool while that VM remains healthy. This option cannot be used for HTTP(s) load balancing.\n*GENERATED_COOKIE*::: Route requests to instances based on the contents of the "GCLB" cookie set by the load balancer.\n*NONE*::: Session affinity is disabled.\n+',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--session-affinity',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'SESSION_AFFINITY'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'create',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'compute',
                                                                                                                         u'target-pools',
                                                                                                                         u'create'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the target pool.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u"*(ALPHA)* *create* is used to create a target pool. A target pool resource\ndefines a group of instances that can receive incoming traffic\nfrom forwarding rules. When a forwarding rule directs traffic to a\ntarget pool, Google Compute Engine picks an instance from the\ntarget pool based on a hash of the source and\ndestination IP addresses and ports. For more\ninformation on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n\nTo add instances to a target pool, use 'gcloud compute\ntarget-pools add-instances'."}},
                                                                                                   u'delete': {u'capsule': u'*(ALPHA)* Delete target pools.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--region',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REGION'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'delete',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'compute',
                                                                                                                         u'target-pools',
                                                                                                                         u'delete'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The resources to delete.',
                                                                                                                                 u'name': u'names',
                                                                                                                                 u'nargs': u'+',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine target pools.\n'}},
                                                                                                   u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine target pool.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--region',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'REGION'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'describe',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'compute',
                                                                                                                           u'target-pools',
                                                                                                                           u'describe'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the resource to fetch.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* *describe* displays all data associated with a Google Compute\nEngine target pool in a project.'}},
                                                                                                   u'get-health': {u'capsule': u'*(ALPHA)* Get the health of instances in a target pool.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The region of the target pool to get health information for. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'get-health',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'target-pools',
                                                                                                                             u'get-health'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the target pool.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*get-health* displays the health of instances in a target pool.\n'}},
                                                                                                   u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine target pools.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--limit',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_URI'},
                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--page-size',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                        u'--regexp': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--regexp',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REGEXP'},
                                                                                                                        u'--regions': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': [],
                                                                                                                                       u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--regions',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'REGION'},
                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'FIELD'},
                                                                                                                        u'--uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'URI'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'list',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'compute',
                                                                                                                       u'target-pools',
                                                                                                                       u'list'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': [],
                                                                                                                               u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                               u'name': u'names',
                                                                                                                               u'nargs': u'*',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine target pools in a project.\n\nBy default, target pools from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                           u'EXAMPLES': u"To list all target pools in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target pools in a project, run:\n\n  $ list --uri\n\nTo list all target pools in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}},
                                                                                                   u'remove-health-checks': {u'capsule': u'*(ALPHA)* Remove an HTTP health check from a target pool.',
                                                                                                                             u'commands': {},
                                                                                                                             u'flags': {u'--http-health-check': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Specifies an HTTP health check object to remove from the target pool.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--http-health-check',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': True,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"The region of the target pool to remove health checks from. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--region',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'REGION'}},
                                                                                                                             u'group': False,
                                                                                                                             u'groups': {},
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'remove-health-checks',
                                                                                                                             u'path': [u'gcloud',
                                                                                                                                       u'alpha',
                                                                                                                                       u'compute',
                                                                                                                                       u'target-pools',
                                                                                                                                       u'remove-health-checks'],
                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The name of the target pool from which to remove the health check.',
                                                                                                                                               u'name': u'name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'value': u'NAME'}],
                                                                                                                             u'release': u'ALPHA',
                                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* *remove-health-checks* is used to remove an HTTP health check\nfrom a target pool. Health checks are used to determine\nthe health status of instances in the target pool. For more\ninformation on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)'}},
                                                                                                   u'remove-instances': {u'capsule': u'*(ALPHA)* Remove instances from a target pool.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Specifies a list of instances to remove from the target pool.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--instances',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': True,
                                                                                                                                                     u'type': u'list',
                                                                                                                                                     u'value': u'INSTANCE'},
                                                                                                                                    u'--instances-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u"The zone of the instances to remove from the target pool. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--instances-zone',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'INSTANCES_ZONE'},
                                                                                                                                    u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the instances. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--region',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'REGION'},
                                                                                                                                    u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The zone of the instances to remove from the target pool. DEPRECATED, use --instances-zone. If not specified, you will be prompted to select a zone. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--zone',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'ZONE'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'remove-instances',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'alpha',
                                                                                                                                   u'compute',
                                                                                                                                   u'target-pools',
                                                                                                                                   u'remove-instances'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The name of the target pool from which to remove the instances.',
                                                                                                                                           u'name': u'name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'NAME'}],
                                                                                                                         u'release': u'ALPHA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*remove-instances* is used to remove one or more instances from a\ntarget pool.\nFor more information on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                   u'set-backup': {u'capsule': u'*(ALPHA)* Set a backup pool for a target pool.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--backup-pool': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Name of the target pool that will serve as backup.',
                                                                                                                                                 u'group': u'set-backup.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--backup-pool',
                                                                                                                                                 u'nargs': u'?',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'BACKUP_POOL'},
                                                                                                                              u'--failover-ratio': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The new failover ratio value for the target pool. This must be a float in the range of [0, 1].',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--failover-ratio',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'FAILOVER_RATIO'},
                                                                                                                              u'--no-backup-pool': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Unsets the backup pool. This disables failover.',
                                                                                                                                                    u'group': u'set-backup.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--no-backup-pool',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_BACKUP_POOL'},
                                                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The region of the target pool to set a backup pool for. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {u'set-backup.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                 u'is_mutex': True,
                                                                                                                                                 u'is_required': False}},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'set-backup',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'target-pools',
                                                                                                                             u'set-backup'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the target pool for which to set the backup pool.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u"*set-backup* is used to set a backup target pool for a primary\ntarget pool, which defines the fallback behavior of the primary\npool. If the ratio of the healthy instances in the primary pool\nis at or below the specified ``--failover-ratio value'', then traffic\narriving at the load-balanced IP address will be directed to the\nbackup pool.\n",
                                                                                                                                 u'EXAMPLES': u"To cause `TARGET-POOL` (in region `us-central1`) to fail over\nto `BACKUP-POOL` when more than half of the `TARGET-POOL`\ninstances are unhealthy, run:\n\n  $ set-backup TARGET-POOL --backup-pool BACKUP-POOL --failover-ratio 0.5 --region us-central1\n\nTo remove `BACKUP-POOL` as a backup to `TARGET-POOL`, run:\n\n  $ set-backup TARGET-POOL --backup-pool '' --region us-central1\n"}}},
                                                                                     u'flags': {},
                                                                                     u'group': True,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'target-pools',
                                                                                     u'path': [u'gcloud',
                                                                                               u'alpha',
                                                                                               u'compute',
                                                                                               u'target-pools'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'ALPHA',
                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Control Compute Engine target pools for network load balancing.'}},
                                                                   u'target-ssl-proxies': {u'capsule': u'*(ALPHA)* List, create, and delete target SSL proxies.',
                                                                                           u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a target SSL proxy.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A backend service that will be used for connections to the target SSL\nproxy.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--backend-service',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': True,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'BACKEND_SERVICE'},
                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'An optional, textual description for the target SSL proxy.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--proxy-header': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [u'NONE',
                                                                                                                                                                 u'PROXY_V1'],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': u'NONE',
                                                                                                                                                    u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Enables PROXY protocol (version 1) for passing client connection information.\n+',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--proxy-header',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'PROXY_HEADER'},
                                                                                                                                u'--ssl-certificate': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target SSL proxy.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--ssl-certificate',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': True,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'SSL_CERTIFICATE'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'create',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'target-ssl-proxies',
                                                                                                                               u'create'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the target SSL proxy.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'\n*create* is used to create target SSL proxies. A target\nSSL proxy is referenced by one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget SSL proxy points to a backend service which handle the\nactual requests. The target SSL proxy also points to an SSL\ncertificate used for server-side authentication.\n'}},
                                                                                                         u'delete': {u'capsule': u'*(ALPHA)* Delete target SSL proxies.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'delete',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'target-ssl-proxies',
                                                                                                                               u'delete'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The names of the target SSL proxies.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'+',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*delete* deletes one or more target SSL proxies.\n'}},
                                                                                                         u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about a target SSL proxy.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'describe',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'target-ssl-proxies',
                                                                                                                                 u'describe'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the target SSL proxy.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a target SSL proxy\nin a project.\n'}},
                                                                                                         u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine target SSL proxies.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--filter',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--limit',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--page-size',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                              u'--regexp': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--regexp',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGEXP'},
                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'FIELD'},
                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'URI'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'list',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'target-ssl-proxies',
                                                                                                                             u'list'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                     u'name': u'names',
                                                                                                                                     u'nargs': u'*',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine target SSL proxies in a project.\n',
                                                                                                                                 u'EXAMPLES': u'To list all target SSL proxies in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target SSL proxies in a project, run:\n\n  $ list --uri\n'}},
                                                                                                         u'update': {u'capsule': u'*(ALPHA)* Update a target SSL proxy.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A backend service that will be used for connections to the target SSL\nproxy.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--backend-service',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'BACKEND_SERVICE'},
                                                                                                                                u'--proxy-header': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [u'NONE',
                                                                                                                                                                 u'PROXY_V1'],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Enables PROXY protocol (version 1) for passing client connection information.\n+',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--proxy-header',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'PROXY_HEADER'},
                                                                                                                                u'--ssl-certificate': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target SSL proxy.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--ssl-certificate',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'SSL_CERTIFICATE'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'update',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'target-ssl-proxies',
                                                                                                                               u'update'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the target SSL proxy.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'\n*update* is used to change the SSL certificate, backend\nservice or proxy header of existing target SSL proxies. A\ntarget SSL proxy is referenced by one or more forwarding rules\nwhich define which packets the proxy is responsible for\nrouting. The target SSL proxy in turn points to a backend\nservice which will handle the requests. The target SSL proxy\nalso points to an SSL certificate used for server-side\nauthentication.  '}}},
                                                                                           u'flags': {},
                                                                                           u'group': True,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'target-ssl-proxies',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'alpha',
                                                                                                     u'compute',
                                                                                                     u'target-ssl-proxies'],
                                                                                           u'positionals': [],
                                                                                           u'release': u'ALPHA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, and delete target SSL proxies.'}},
                                                                   u'target-tcp-proxies': {u'capsule': u'*(ALPHA)* List, create, and delete target TCP proxies.',
                                                                                           u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a target TCP proxy.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A backend service that will be used for connections to the target TCP\nproxy.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--backend-service',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': True,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'BACKEND_SERVICE'},
                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'An optional, textual description for the target TCP proxy.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--proxy-header': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [u'NONE',
                                                                                                                                                                 u'PROXY_V1'],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': u'NONE',
                                                                                                                                                    u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Enables PROXY protocol (version 1) for passing client connection information.\n+',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--proxy-header',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'PROXY_HEADER'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'create',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'target-tcp-proxies',
                                                                                                                               u'create'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the target TCP proxy.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'\n*create* is used to create target TCP proxies. A target\nTCP proxy is referenced by one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget TCP proxy points to a backend service which handle the\nactual requests.\n'}},
                                                                                                         u'delete': {u'capsule': u'*(ALPHA)* Delete target TCP proxies.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'delete',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'target-tcp-proxies',
                                                                                                                               u'delete'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The names of the target TCP proxies.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'+',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*delete* deletes one or more target TCP proxies.\n'}},
                                                                                                         u'describe': {u'capsule': u'*(ALPHA)* Display detailed information about a target TCP proxy.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'describe',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'compute',
                                                                                                                                 u'target-tcp-proxies',
                                                                                                                                 u'describe'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the target TCP proxy.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a target TCP proxy\nin a project.\n'}},
                                                                                                         u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine target TCP proxies.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--filter',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--limit',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--page-size',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                              u'--regexp': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--regexp',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGEXP'},
                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'FIELD'},
                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'URI'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'list',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'target-tcp-proxies',
                                                                                                                             u'list'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                     u'name': u'names',
                                                                                                                                     u'nargs': u'*',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine target TCP proxies in a project.\n',
                                                                                                                                 u'EXAMPLES': u'To list all target TCP proxies in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target TCP proxies in a project, run:\n\n  $ list --uri\n'}},
                                                                                                         u'update': {u'capsule': u'*(ALPHA)* Update a target TCP proxy.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A backend service that will be used for connections to the target TCP\nproxy.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--backend-service',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'BACKEND_SERVICE'},
                                                                                                                                u'--proxy-header': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [u'NONE',
                                                                                                                                                                 u'PROXY_V1'],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Enables PROXY protocol (version 1) for passing client connection information.\n+',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--proxy-header',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'PROXY_HEADER'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'update',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'target-tcp-proxies',
                                                                                                                               u'update'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the target TCP proxy.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'\n*update* is used to change the backend service or proxy header\nof existing target TCP proxies. A target TCP proxy is referenced\nby one or more forwarding rules which define which packets the\nproxy is responsible for routing. The target TCP proxy in turn\npoints to a backend service which will handle the requests.  '}}},
                                                                                           u'flags': {},
                                                                                           u'group': True,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'target-tcp-proxies',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'alpha',
                                                                                                     u'compute',
                                                                                                     u'target-tcp-proxies'],
                                                                                           u'positionals': [],
                                                                                           u'release': u'ALPHA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, and delete target TCP proxies.'}},
                                                                   u'target-vpn-gateways': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine VPN Gateways.',
                                                                                            u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a target VPN Gateway.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--description': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'An optional, textual description for the target VPN Gateway.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--description',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                 u'--network': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'A reference to a network in this project to\ncontain the VPN Gateway.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--network',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': True,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'NETWORK'},
                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"The region of the Target VPN Gateway to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--region',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'REGION'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'create',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'target-vpn-gateways',
                                                                                                                                u'create'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the target VPN Gateway.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'\n*create* is used to create a target VPN Gateway. A target VPN\nGateway can reference one or more VPN tunnels that connect it to\nexternal VPN gateways. A VPN Gateway may also be referenced by\none or more forwarding rules that define which packets the\ngateway is responsible for routing.\n'}},
                                                                                                          u'delete': {u'capsule': u'*(ALPHA)* Delete target vpn gateways.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--region',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'REGION'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'delete',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'compute',
                                                                                                                                u'target-vpn-gateways',
                                                                                                                                u'delete'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The resources to delete.',
                                                                                                                                        u'name': u'names',
                                                                                                                                        u'nargs': u'+',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine target vpn\ngateways.\n'}},
                                                                                                          u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine target vpn gateway.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--region',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'REGION'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'describe',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'alpha',
                                                                                                                                  u'compute',
                                                                                                                                  u'target-vpn-gateways',
                                                                                                                                  u'describe'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the resource to fetch.',
                                                                                                                                          u'name': u'name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'NAME'}],
                                                                                                                        u'release': u'ALPHA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine target vpn gateway in a project.\n'}},
                                                                                                          u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine target VPN gateways.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--filter',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--limit',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                               u'--regexp': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--regexp',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGEXP'},
                                                                                                                               u'--regions': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': [],
                                                                                                                                              u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--regions',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'REGION'},
                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'FIELD'},
                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'URI'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'list',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'compute',
                                                                                                                              u'target-vpn-gateways',
                                                                                                                              u'list'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': [],
                                                                                                                                      u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                      u'name': u'names',
                                                                                                                                      u'nargs': u'*',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine target VPN gateways in a project.\n\nBy default, target VPN gateways from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                                  u'EXAMPLES': u"To list all target VPN gateways in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target VPN gateways in a project, run:\n\n  $ list --uri\n\nTo list all target VPN gateways in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}}},
                                                                                            u'flags': {},
                                                                                            u'group': True,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'target-vpn-gateways',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'alpha',
                                                                                                      u'compute',
                                                                                                      u'target-vpn-gateways'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'ALPHA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine VPN Gateways.'}},
                                                                   u'url-maps': {u'capsule': u'*(ALPHA)* List, create, and delete URL maps.',
                                                                                 u'commands': {u'add-host-rule': {u'capsule': u'*(ALPHA)* Add a rule to a URL map to map hosts to a path matcher.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--description': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'An optional, textual description for the host rule.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--description',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'DESCRIPTION'},
                                                                                                                             u'--hosts': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"The set of hosts to match requests against. Each host must be\na fully qualified domain name (FQDN) with the exception that\nthe host can begin with a ``*'' or ``*-''. ``*'' acts as a\nglob and will match any string of atoms to the left where an\natom is separated by dots (``.'') or dashes (``-'').",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--hosts',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'HOST'},
                                                                                                                             u'--path-matcher-name': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The name of the patch matcher to use if a request matches this\nhost rule. The patch matcher must already exist in the URL map\n(see `gcloud compute url-maps add-path-matcher`).',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--path-matcher-name',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': True,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'PATH_MATCHER_NAME'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'add-host-rule',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'compute',
                                                                                                                            u'url-maps',
                                                                                                                            u'add-host-rule'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the URL map.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*add-host-rule* is used to add a mapping of hosts to a patch\nmatcher in a URL map. The mapping will match the host\ncomponent of HTTP requests to path matchers which in turn map\nthe request to a backend service. Before adding a host rule,\nat least one path matcher must exist in the URL map to take\ncare of the path component of the requests.\n`gcloud compute url-maps add-path-matcher` or\n`gcloud compute url-maps edit` can be used to add path matchers.\n',
                                                                                                                                u'EXAMPLES': u"To create a host rule mapping the ```*-foo.google.com``` and\n```google.com``` hosts to the ```www``` path matcher, run:\n\n  $ add-host-rule MY-URL-MAP --hosts '*-foo.google.com,google.com' --path-matcher-name www\n"}},
                                                                                               u'add-path-matcher': {u'capsule': u'*(ALPHA)* Add a path matcher to a URL map.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--backend-bucket-path-rules': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': {},
                                                                                                                                                                 u'description': u'Rules for mapping request paths to backend buckets.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--backend-bucket-path-rules',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'dict',
                                                                                                                                                                 u'value': u'PATH=BUCKET'},
                                                                                                                                u'--backend-service-path-rules': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': {},
                                                                                                                                                                  u'description': u'Rules for mapping request paths to services.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--backend-service-path-rules',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'dict',
                                                                                                                                                                  u'value': u'PATH=SERVICE'},
                                                                                                                                u'--default-backend-bucket': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'A backend bucket that will be used for requests that the path matcher cannot match. Exactly one of --default-service or --default-backend-bucket is required.',
                                                                                                                                                              u'group': u'add-path-matcher.1',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--default-backend-bucket',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'DEFAULT_BACKEND_BUCKET'},
                                                                                                                                u'--default-service': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A backend service that will be used for requests that the path matcher cannot match. Exactly one of --default-service or --default-backend-bucket is required.',
                                                                                                                                                       u'group': u'add-path-matcher.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--default-service',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'DEFAULT_SERVICE'},
                                                                                                                                u'--delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': False,
                                                                                                                                                                    u'description': u'If provided and a path matcher is orphaned as a result of this command, the command removes the orphaned path matcher instead of failing.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--delete-orphaned-path-matcher',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'bool',
                                                                                                                                                                    u'value': u'DELETE_ORPHANED_PATH_MATCHER'},
                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'An optional, textual description for the path matcher.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--existing-host': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'An existing host rule to tie the new path matcher to. Although\nhost rules can contain more than one host, only a single host\nis needed to uniquely identify the host rule.',
                                                                                                                                                     u'group': u'add-path-matcher.2',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--existing-host',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'EXISTING_HOST'},
                                                                                                                                u'--new-hosts': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'If specified, a new host rule with the given hosts is created and the path matcher is tied to the new host rule.',
                                                                                                                                                 u'group': u'add-path-matcher.2',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--new-hosts',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'list',
                                                                                                                                                 u'value': u'NEW_HOST'},
                                                                                                                                u'--no-delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': False,
                                                                                                                                                                       u'description': u'',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': True,
                                                                                                                                                                       u'name': u'--no-delete-orphaned-path-matcher',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'bool',
                                                                                                                                                                       u'value': u'NO_DELETE_ORPHANED_PATH_MATCHER'},
                                                                                                                                u'--path-matcher-name': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name to assign to the path matcher.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--path-matcher-name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': True,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'PATH_MATCHER_NAME'},
                                                                                                                                u'--path-rules': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': {},
                                                                                                                                                  u'description': u'Rules for mapping request paths to services.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--path-rules',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'dict',
                                                                                                                                                  u'value': u'PATH=SERVICE'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {u'add-path-matcher.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                         u'is_mutex': True,
                                                                                                                                                         u'is_required': True},
                                                                                                                                 u'add-path-matcher.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                         u'is_mutex': True,
                                                                                                                                                         u'is_required': False}},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'add-path-matcher',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'url-maps',
                                                                                                                               u'add-path-matcher'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the URL map.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u"*add-path-matcher* is used to add a path matcher to a URL map. A path\nmatcher maps HTTP request paths to backend services or backend\nbuckets. Each path matcher must be referenced by at least one\nhost rule. This command can create a new host rule through the\n``--new-hosts'' flag or it can reconfigure an existing host rule\nto point to the newly added path matcher using ``--existing-host''.\nIn the latter case, if a path matcher is orphaned as a result\nof the operation, this command will fail unless\n``--delete-orphaned-path-matcher'' is provided.\n",
                                                                                                                                   u'EXAMPLES': u"To create a rule for mapping the path ```/search/*``` to the\nhypothetical ```search-service```, ```/static/*``` to the\n```static-bucket``` backend bucket and ```/images/*``` to the\n```images-service``` under the hosts ```google.com``` and\n```*.google.com```, run:\n\n  $ add-path-matcher MY-URL-MAP --path-matcher-name MY-MATCHER --default-service MY-DEFAULT-SERVICE --backend-service-path-rules '/search/*=search_service,/images/*=images-service' --backend-bucket-path-rules '/static/*=static-bucket' --new-hosts google.com '*.google.com'\n\nNote that a default service or default backend bucket must be\nprovided to handle paths for which there is no mapping.\n"}},
                                                                                               u'create': {u'capsule': u'*(ALPHA)* Create a URL map.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--default-backend-bucket': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'A backend bucket that will be used for requests for which this URL map has no mappings. Exactly one of --default-service or --default-backend-bucket is required.',
                                                                                                                                                    u'group': u'create.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--default-backend-bucket',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'DEFAULT_BACKEND_BUCKET'},
                                                                                                                      u'--default-service': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A backend service that will be used for requests for which this URL map has no mappings. Exactly one of --default-service or --default-backend-bucket is required.',
                                                                                                                                             u'group': u'create.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--default-service',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DEFAULT_SERVICE'},
                                                                                                                      u'--description': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'An optional, textual description for the URL map.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--description',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'DESCRIPTION'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {u'create.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': True}},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'create',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'url-maps',
                                                                                                                     u'create'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the URL map.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u"\n*create* is used to create URL maps which map HTTP and\nHTTPS request URLs to backend services and backend buckets.\nMappings are done using a longest-match strategy.\n\nThere are two components to a mapping: a host rule and a path\nmatcher. A host rule maps one or more hosts to a path\nmatcher. A path matcher maps request paths to backend\nservices or backend buckets. For example, a host rule can map\nthe hosts ``*.google.com'' and ``google.com'' to a path\nmatcher called ``www''. The ``www'' path matcher in turn can\nmap the path ``/search/*'' to the search backend service, the\npath ``/static/*'' to the static backend bucket  and everything\nelse to a default backend service or default backend bucket.\n\nHost rules and patch matchers can be added to the URL map\nafter the map is created by using `gcloud compute url-maps edit`\nor by using `gcloud compute url-maps add-path-matcher`\nand `gcloud compute url-maps add-host-rule`.\n"}},
                                                                                               u'delete': {u'capsule': u'*(ALPHA)* Delete URL maps.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'delete',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'compute',
                                                                                                                     u'url-maps',
                                                                                                                     u'delete'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The resources to delete.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* *delete* deletes one or more URL maps.'}},
                                                                                               u'describe': {u'capsule': u'*(ALPHA)* Describe a URL map.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--region',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REGION'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'compute',
                                                                                                                       u'url-maps',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the resource to fetch.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a URL map in a\nproject.\n'}},
                                                                                               u'edit': {u'capsule': u'*(ALPHA)* Modify URL maps.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'edit',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'compute',
                                                                                                                   u'url-maps',
                                                                                                                   u'edit'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the URL map.',
                                                                                                                           u'name': u'name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u"*edit* can be used to modify a URL map. The URL map\nresource is fetched from the server and presented in a text\neditor. After the file is saved and closed, this command will\nupdate the resource. Only fields that can be modified are\ndisplayed in the editor.\n\nThe editor used to modify the resource is chosen by inspecting\nthe ``EDITOR'' environment variable.\n"}},
                                                                                               u'invalidate-cdn-cache': {u'capsule': u'*(ALPHA)* Invalidate specified objects for a URL map in Cloud CDN caches.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'Do not wait for the operation to complete.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--async',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'ASYNC'},
                                                                                                                                    u'--host': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'If set, this invalidation will apply only to requests to the\nspecified host.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--host',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'HOST'},
                                                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': True,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-async',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_ASYNC'},
                                                                                                                                    u'--path': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"A path specifying which objects to invalidate. PATH must start with\n``/'' and the only place a ``*'' is allowed is at the end following a\n``/''. It will be matched against URL paths, which do not include\nscheme, host, or any text after the first ``?'' or ``#'' (and those\ncharacters are not allowed here). For example, for the URL\n``https://example.com/whatever/x.html?a=b'', the path is\n``/whatever/x.html''.\n+\nIf PATH ends with ``*'', the preceding string is a prefix, and all URLs\nwhose paths begin with it will be invalidated. If PATH doesn't end with\n``*'', then only URLs with exactly that path will be invalidated.\n+\nExamples:\n- ``'', ``*'', anything that doesn't start with ``/'': error\n- ``/'': just the root URL\n- ``/*'': everything\n- ``/x/y'': ``/x/y'' only (and not ``/x/y/'')\n- ``/x/y/'': ``/x/y/'' only (and not ``/x/y'')\n- ``/x/y/*'': ``/x/y/'' and everything under it",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--path',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': True,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PATH'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'invalidate-cdn-cache',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'alpha',
                                                                                                                                   u'compute',
                                                                                                                                   u'url-maps',
                                                                                                                                   u'invalidate-cdn-cache'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The name of the URL map.',
                                                                                                                                           u'name': u'name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'URLMAP'}],
                                                                                                                         u'release': u'ALPHA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'\n*invalidate-cdn-cache* requests that Cloud CDN stop using cached content for\nresources at a particular URL path or set of URL paths.\n\n*invalidate-cdn-cache* may succeed even if no content is cached for some or all\nURLs with the given path.\n'}},
                                                                                               u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine URL maps.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--regexp': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--regexp',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'REGEXP'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'compute',
                                                                                                                   u'url-maps',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': [],
                                                                                                                           u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'*',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine URL maps in a project.\n',
                                                                                                                       u'EXAMPLES': u'To list all URL maps in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all URL maps in a project, run:\n\n  $ list --uri\n'}},
                                                                                               u'list-cdn-cache-invalidations': {u'capsule': u'*(ALPHA)* List Cloud CDN cache invalidations for a URL map.',
                                                                                                                                 u'commands': {},
                                                                                                                                 u'flags': {u'--limit': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The maximum number of invalidations to list.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--limit',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'LIMIT'}},
                                                                                                                                 u'group': False,
                                                                                                                                 u'groups': {},
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'list-cdn-cache-invalidations',
                                                                                                                                 u'path': [u'gcloud',
                                                                                                                                           u'alpha',
                                                                                                                                           u'compute',
                                                                                                                                           u'url-maps',
                                                                                                                                           u'list-cdn-cache-invalidations'],
                                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The name of the URL map.',
                                                                                                                                                   u'name': u'urlmap',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'value': u'URLMAP'}],
                                                                                                                                 u'release': u'ALPHA',
                                                                                                                                 u'sections': {u'DESCRIPTION': u'List Cloud CDN cache invalidations for a URL map. A cache invalidation instructs\nCloud CDN to stop using cached content. You can list invalidations to check\nwhich have completed.\n'}},
                                                                                               u'remove-host-rule': {u'capsule': u'*(ALPHA)* Remove a host rule from a URL map.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': False,
                                                                                                                                                                    u'description': u'If provided and a path matcher is orphaned as a result of this command, the command removes the orphaned path matcher instead of failing.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--delete-orphaned-path-matcher',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'bool',
                                                                                                                                                                    u'value': u'DELETE_ORPHANED_PATH_MATCHER'},
                                                                                                                                u'--host': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'One of the hosts in the host rule to remove.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--host',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'HOST'},
                                                                                                                                u'--no-delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': False,
                                                                                                                                                                       u'description': u'',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': True,
                                                                                                                                                                       u'name': u'--no-delete-orphaned-path-matcher',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'bool',
                                                                                                                                                                       u'value': u'NO_DELETE_ORPHANED_PATH_MATCHER'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'remove-host-rule',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'compute',
                                                                                                                               u'url-maps',
                                                                                                                               u'remove-host-rule'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the URL map.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u"*remove-host-rule* is used to remove a host rule from a URL map. When\na host rule is removed, its path matcher is only removed if\nit is not referenced by any other host rules and\n``--delete-orphaned-path-matcher'' is provided.\n",
                                                                                                                                   u'EXAMPLES': u"To remove a host rule that contains the host ``google.com''\nfrom the URL map named ``MY-URL-MAP'', you can use this\ncommand:\n\n  $ remove-host-rule MY-URL-MAP --host google.com\n"}},
                                                                                               u'remove-path-matcher': {u'capsule': u'*(ALPHA)* Remove a path matcher from a URL map.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--path-matcher-name': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The name of the path matcher to remove.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--path-matcher-name',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': True,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'PATH_MATCHER_NAME'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'remove-path-matcher',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'alpha',
                                                                                                                                  u'compute',
                                                                                                                                  u'url-maps',
                                                                                                                                  u'remove-path-matcher'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the URL map.',
                                                                                                                                          u'name': u'name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'NAME'}],
                                                                                                                        u'release': u'ALPHA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*remove-path-matcher* is used to remove a path matcher from a URL\n map. When a path matcher is removed, all host rules that\n refer to the path matcher are also removed.\n',
                                                                                                                                      u'EXAMPLES': u"To remove the path matcher named ``MY-MATCHER'' from the URL map named\n``MY-URL-MAP'', you can use this command:\n\n  $ remove-path-matcher MY-URL-MAP --path-matcher MY-MATCHER\n"}},
                                                                                               u'set-default-service': {u'capsule': u'*(ALPHA)* Change the default service or default bucket of a URL map.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--default-backend-bucket': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'A backend bucket that will be used for requests for which this URL map has no mappings.',
                                                                                                                                                                 u'group': u'set-default-service.1',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--default-backend-bucket',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'DEFAULT_BACKEND_BUCKET'},
                                                                                                                                   u'--default-service': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'A backend service that will be used for requests for which this URL map has no mappings.',
                                                                                                                                                          u'group': u'set-default-service.1',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--default-service',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'DEFAULT_SERVICE'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {u'set-default-service.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                               u'is_mutex': True,
                                                                                                                                                               u'is_required': True}},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'set-default-service',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'alpha',
                                                                                                                                  u'compute',
                                                                                                                                  u'url-maps',
                                                                                                                                  u'set-default-service'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the URL map.',
                                                                                                                                          u'name': u'name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'NAME'}],
                                                                                                                        u'release': u'ALPHA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*set-default-service* is used to change the default service or default\nbucket of a URL map. The default service or default bucket is\nused for any requests for which there is no mapping in the\nURL map.\n'}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'url-maps',
                                                                                 u'path': [u'gcloud',
                                                                                           u'alpha',
                                                                                           u'compute',
                                                                                           u'url-maps'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'ALPHA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* List, create, and delete URL maps.'}},
                                                                   u'users': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine users.',
                                                                              u'commands': {u'add-keys': {u'capsule': u'*(ALPHA)* Add public keys to a Google Compute Engine user.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--description': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'A description of the public keys',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--description',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DESCRIPTION'},
                                                                                                                     u'--expire': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"Public keys can be configured to expire after a specified amount\nof time. For example, specifying ``12h'' will cause the key to expire\nafter 12 hours. Valid units for this flag are ``s'' for seconds, ``m''\nfor minutes, ``h'' for hours, and ''d'' for days.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--expire',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPIRE'},
                                                                                                                     u'--public-key-files': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The path to a public-key file.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--public-key-files',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': True,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'LOCAL_FILE_PATH'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'add-keys',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'users',
                                                                                                                    u'add-keys'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'If provided, the name of the user to add a public key to. Else, the default user will be used. The default username is mapped from the email address of the\nauthenticated account.\nPlease run:\n+\n  $ gcloud config set account ACCOUNT\n+\nto change the authenticated account.',
                                                                                                                            u'name': u'name',
                                                                                                                            u'nargs': u'?',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* *add-keys* adds public keys to a Google Compute Engine user.',
                                                                                                                        u'EXAMPLES': u'To add a public key to a user, run:\n\n  $ add-keys example-user --public-key-files ~/.ssh/pubkey.pub\n\nMultiple public keys can be specified by providing multiple paths\nto key files on the local machine.\n'}},
                                                                                            u'create': {u'capsule': u'*(ALPHA)* Create Google Compute Engine users.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--description': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'An optional, textual description for the user being created.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--description',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                   u'--owner': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The owner of the user to be created. The owner must be an email address associated with a Google account',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--owner',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'OWNER'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'create',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'compute',
                                                                                                                  u'users',
                                                                                                                  u'create'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'If provided, the name of the user to create. Else, the default user will be created. The default username is mapped from the email address of the\nauthenticated account.\nPlease run:\n+\n  $ gcloud config set account ACCOUNT\n+\nto change the authenticated account.',
                                                                                                                          u'name': u'name',
                                                                                                                          u'nargs': u'?',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*create* creates a Google Compute Engine user.\n',
                                                                                                                      u'EXAMPLES': u"To create a user with the specified name and owner, run:\n\n  $ create example-user --owner example-owner@google.com\n\nTo create a user with the currently authenticated Google account as\nowner and a default username mapped from that account's email, run:\n\n  $ create\n\nTo create a user with the specified name and the currently\nauthenticated Google account as owner, run:\n\n  $ create example-user\n\nTo create a user with the specified owner and a default username\nmapped from the owner email, run:\n\n  $ create --owner example-owner@google.com\n\n"}},
                                                                                            u'delete': {u'capsule': u'*(ALPHA)* Delete Google Compute Engine users.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--no-owners': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-owners',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_OWNERS'},
                                                                                                                   u'--owners': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u'The owner of the user to be created. The owner must be an email address associated with a Google account',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--owners',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'OWNERS'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'delete',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'compute',
                                                                                                                  u'users',
                                                                                                                  u'delete'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The names of the users to delete.',
                                                                                                                          u'name': u'names',
                                                                                                                          u'nargs': u'+',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine users.\n',
                                                                                                                      u'EXAMPLES': u'To delete one or more users by name, run:\n\n  $ delete example-user-1 example-user-2\n\nTo delete all users for one or more owners, run:\n\n  $ delete example-owner-1@gmail.com example-owner-2@gmail.com --owners\n'}},
                                                                                            u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine user.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'describe',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'users',
                                                                                                                    u'describe'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'If provided, the name of the user to describe. Else, the default user will be described. The default username is mapped from the email address of the\nauthenticated account.\nPlease run:\n+\n  $ gcloud config set account ACCOUNT\n+\nto change the authenticated account.',
                                                                                                                            u'name': u'name',
                                                                                                                            u'nargs': u'?',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* *describe* displays all data associated with a Google Compute\nEngine user in a project.',
                                                                                                                        u'EXAMPLES': u'To describe a user, run:\n\n  $ describe example-user\n\nTo describe the default user mapped from the currently authenticated\nGoogle account email, run:\n\n  $ describe\n'}},
                                                                                            u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine users.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--regexp': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--regexp',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'REGEXP'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'compute',
                                                                                                                u'users',
                                                                                                                u'list'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': [],
                                                                                                                        u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                        u'name': u'names',
                                                                                                                        u'nargs': u'*',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'NAME'}],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine users in a project.\n',
                                                                                                                    u'EXAMPLES': u'To list all users in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all users in a project, run:\n\n  $ list --uri\n'}},
                                                                                            u'remove-keys': {u'capsule': u'*(ALPHA)* Remove a public key from a Google Compute Engine user.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--fingerprints': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The fingerprints of the public keys to remove from the user.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--fingerprints',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'FINGERPRINT'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'remove-keys',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'compute',
                                                                                                                       u'users',
                                                                                                                       u'remove-keys'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'If provided, the name of the user to remove public keys from. Else, the default user will be used. The default username is mapped from the email address of the\nauthenticated account.\nPlease run:\n+\n  $ gcloud config set account ACCOUNT\n+\nto change the authenticated account.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'?',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* *remove-keys* removes public keys from a Google Compute Engine user.',
                                                                                                                           u'EXAMPLES': u'To remove all public keys for a user, run:\n\n  $ remove-keys example-user\n\nTo remove a specific public key, first describe the user\n(using `gcloud compute users describe example-user`) to determine the\nfingerprints of the public keys you wish\nto remove. Then run:\n\n  $ remove-keys example-user --fingerprints b3ca856958b524f3f12c3e43f6c9065d\n'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'users',
                                                                              u'path': [u'gcloud',
                                                                                        u'alpha',
                                                                                        u'compute',
                                                                                        u'users'],
                                                                              u'positionals': [],
                                                                              u'release': u'ALPHA',
                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine users.'}},
                                                                   u'vpn-tunnels': {u'capsule': u'*(ALPHA)* Read and manipulate Google Compute Engine VPN Tunnels.',
                                                                                    u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a VPN tunnel.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--description': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'An optional, textual description for the target VPN tunnel.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--description',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'DESCRIPTION'},
                                                                                                                         u'--ike-networks': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--ike-networks',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'IKE_NETWORKS'},
                                                                                                                         u'--ike-version': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [1,
                                                                                                                                                         2],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Internet Key Exchange protocol version number. Default is 2. _IKE_VERSION_ must be one of: *1*, *2*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--ike-version',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'IKE_VERSION'},
                                                                                                                         u'--local-traffic-selector': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Traffic selector is an agreement between IKE peers to permit traffic through a tunnel if the traffic matches a specified pair of local and remote addresses.\n+\nlocal_traffic_selector allows to configure the local addresses that are permitted. The value should be a comma separated list of CIDR formatted strings. Example: 192.168.0.0/16,10.0.0.0/24.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--local-traffic-selector',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'list',
                                                                                                                                                       u'value': u'CIDR'},
                                                                                                                         u'--peer-address': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A valid IP-v4 address representing the remote tunnel endpoint',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--peer-address',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': True,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PEER_ADDRESS'},
                                                                                                                         u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The region of the VPN Tunnel to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--region',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'REGION'},
                                                                                                                         u'--remote-traffic-selector': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Traffic selector is an agreement between IKE peers to permit traffic through a tunnel if the traffic matches a specified pair of local and remote addresses.\n+\nremote_traffic_selector allows to configure the remote addresses that are permitted. The value should be a comma separated list of CIDR formatted strings. Example: 192.168.0.0/16,10.0.0.0/24.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--remote-traffic-selector',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'CIDR'},
                                                                                                                         u'--router': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The Router to use for dynamic routing.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--router',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'ROUTER'},
                                                                                                                         u'--shared-secret': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A shared secret consisting of printable characters.  Valid\narguments match the regular expression [ -~]+',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--shared-secret',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'SHARED_SECRET'},
                                                                                                                         u'--target-vpn-gateway': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'A reference to a target vpn gateway',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--target-vpn-gateway',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': True,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'TARGET_VPN_GATEWAY'},
                                                                                                                         u'--target-vpn-gateway-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The region of the Target VPN Gateway to operate on. Should be the same as region, if not specified, it will be automatically set. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--target-vpn-gateway-region',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'TARGET_VPN_GATEWAY_REGION'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'create',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'compute',
                                                                                                                        u'vpn-tunnels',
                                                                                                                        u'create'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the VPN tunnel.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'\n*create* is used to create a VPN tunnel between a VPN Gateway\nin Google Cloud Platform and an external gateway that is\nidentified by --peer-address.\n'}},
                                                                                                  u'delete': {u'capsule': u'*(ALPHA)* Delete vpn tunnels.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--region',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'REGION'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'delete',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'compute',
                                                                                                                        u'vpn-tunnels',
                                                                                                                        u'delete'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The resources to delete.',
                                                                                                                                u'name': u'names',
                                                                                                                                u'nargs': u'+',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine vpn tunnels.\n'}},
                                                                                                  u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine vpn tunnel.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--region',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGION'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'describe',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'vpn-tunnels',
                                                                                                                          u'describe'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the resource to fetch.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine vpn tunnel in a project.\n'}},
                                                                                                  u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine VPN tunnels.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--filter',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--limit',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_URI'},
                                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--page-size',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                                       u'--regexp': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--regexp',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'REGEXP'},
                                                                                                                       u'--regions': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': [],
                                                                                                                                      u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--regions',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'REGION'},
                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'FIELD'},
                                                                                                                       u'--uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'URI'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'list',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'compute',
                                                                                                                      u'vpn-tunnels',
                                                                                                                      u'list'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': [],
                                                                                                                              u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                              u'name': u'names',
                                                                                                                              u'nargs': u'*',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine VPN tunnels in a project.\n\nBy default, VPN tunnels from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                          u'EXAMPLES': u"To list all VPN tunnels in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all VPN tunnels in a project, run:\n\n  $ list --uri\n\nTo list all VPN tunnels in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}}},
                                                                                    u'flags': {},
                                                                                    u'group': True,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'vpn-tunnels',
                                                                                    u'path': [u'gcloud',
                                                                                              u'alpha',
                                                                                              u'compute',
                                                                                              u'vpn-tunnels'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'ALPHA',
                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Compute Engine VPN Tunnels.'}},
                                                                   u'xpn': {u'capsule': u'*(ALPHA)* Configure cross-project networking (XPN).',
                                                                            u'commands': {u'associated-projects': {u'capsule': u'*(ALPHA)* Configure associated projects for cross-project networking (XPN).',
                                                                                                                   u'commands': {u'add': {u'capsule': u'*(ALPHA)* Associate the given project with a given host project via XPN.',
                                                                                                                                          u'commands': {},
                                                                                                                                          u'flags': {u'--host-project': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The XPN host to add an associated project to',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--host-project',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': True,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'HOST_PROJECT'}},
                                                                                                                                          u'group': False,
                                                                                                                                          u'groups': {},
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'add',
                                                                                                                                          u'path': [u'gcloud',
                                                                                                                                                    u'alpha',
                                                                                                                                                    u'compute',
                                                                                                                                                    u'xpn',
                                                                                                                                                    u'associated-projects',
                                                                                                                                                    u'add'],
                                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'ID for the project to add to the host project',
                                                                                                                                                            u'name': u'project',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'value': u'PROJECT_ID'}],
                                                                                                                                          u'release': u'ALPHA',
                                                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* Associate the given project with a given host project via XPN.',
                                                                                                                                                        u'EXAMPLES': u'\nTo enable the project `xpn-user` to use the project `xpn-host` via\nXPN, run:\n\n  $ add --host-project=xpn-host xpn-user\n'}},
                                                                                                                                 u'list': {u'capsule': u'*(ALPHA)* List the projects that can use the given project via XPN.',
                                                                                                                                           u'commands': {},
                                                                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--filter',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--limit',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': True,
                                                                                                                                                                    u'description': u'',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': True,
                                                                                                                                                                    u'name': u'--no-uri',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'bool',
                                                                                                                                                                    u'value': u'NO_URI'},
                                                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--page-size',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'list',
                                                                                                                                                                     u'value': u'FIELD'},
                                                                                                                                                      u'--uri': {u'attr': {},
                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': False,
                                                                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--uri',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'bool',
                                                                                                                                                                 u'value': u'URI'}},
                                                                                                                                           u'group': False,
                                                                                                                                           u'groups': {},
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'list',
                                                                                                                                           u'path': [u'gcloud',
                                                                                                                                                     u'alpha',
                                                                                                                                                     u'compute',
                                                                                                                                                     u'xpn',
                                                                                                                                                     u'associated-projects',
                                                                                                                                                     u'list'],
                                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'ID for the project to get associated projects for',
                                                                                                                                                             u'name': u'project',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'value': u'PROJECT_ID'}],
                                                                                                                                           u'release': u'ALPHA',
                                                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* List the projects that can use the given project via XPN.',
                                                                                                                                                         u'EXAMPLES': u'\nIf the project `xpn-user` can use the project `xpn-host` via XPN, the\ncommand\n\n  $ list xpn-host\n\nyields the output\n\n  RESOURCE_ID  RESOURCE_TYPE\n  xpn-user     PROJECT\n'}},
                                                                                                                                 u'remove': {u'capsule': u'*(ALPHA)* Disassociate the given project from the given host project via XPN.',
                                                                                                                                             u'commands': {},
                                                                                                                                             u'flags': {u'--host-project': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The XPN host to remove the associated project from',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--host-project',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': True,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'HOST_PROJECT'}},
                                                                                                                                             u'group': False,
                                                                                                                                             u'groups': {},
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'remove',
                                                                                                                                             u'path': [u'gcloud',
                                                                                                                                                       u'alpha',
                                                                                                                                                       u'compute',
                                                                                                                                                       u'xpn',
                                                                                                                                                       u'associated-projects',
                                                                                                                                                       u'remove'],
                                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'ID for the project to remove from the host project',
                                                                                                                                                               u'name': u'project',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'value': u'PROJECT_ID'}],
                                                                                                                                             u'release': u'ALPHA',
                                                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Disassociate the given project from the given host project via XPN.',
                                                                                                                                                           u'EXAMPLES': u'\nTo disable the project `xpn-user` from using the project `xpn-host`\nvia XPN, run:\n\n  $ remove --host-project=xpn-host xpn-user\n'}}},
                                                                                                                   u'flags': {},
                                                                                                                   u'group': True,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'associated-projects',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'compute',
                                                                                                                             u'xpn',
                                                                                                                             u'associated-projects'],
                                                                                                                   u'positionals': [],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Configure associated projects for cross-project networking (XPN).'}},
                                                                                          u'disable': {u'capsule': u'*(ALPHA)* Disable the given project as an XPN host.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'disable',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'compute',
                                                                                                                 u'xpn',
                                                                                                                 u'disable'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'ID for the project to disable as an XPN host',
                                                                                                                         u'name': u'project',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'PROJECT_ID'}],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* That is, after running this command, one *cannot* enable another project to\nuse this project via XPN.',
                                                                                                                     u'EXAMPLES': u'\nTo disable the project `myproject` as an XPN host, run:\n\n  $ disable myproject\n'}},
                                                                                          u'enable': {u'capsule': u'*(ALPHA)* Enable the given project as an XPN host.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'enable',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'compute',
                                                                                                                u'xpn',
                                                                                                                u'enable'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'ID for the project to enable as an XPN host',
                                                                                                                        u'name': u'project',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'PROJECT_ID'}],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* That is, after running this command, one *can* enable another project to use\nthis project via XPN.',
                                                                                                                    u'EXAMPLES': u'\nTo enable the project `myproject` as an XPN host, run:\n\n  $ enable myproject\n'}},
                                                                                          u'get-host-project': {u'capsule': u'*(ALPHA)* Get the XPN host project that the given project is linked to.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'get-host-project',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'compute',
                                                                                                                          u'xpn',
                                                                                                                          u'get-host-project'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'ID for the project to get the host project for',
                                                                                                                                  u'name': u'project',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'PROJECT_ID'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Get the cross-project networking (XPN) host project of this project, whose\nnetworks can be accessed from this one via XPN.',
                                                                                                                              u'EXAMPLES': u'\nIf the project `xpn-user` can use the project `xpn-host` via XPN,\n\n  $ get-host-project xpn-user\n\nwill show the `xpn-host` project.\n'}},
                                                                                          u'list-associated-resources': {u'capsule': u'*(ALPHA)* List the resources that can use the given project via XPN.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--filter',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--limit',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': True,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--page-size',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'list',
                                                                                                                                                   u'value': u'FIELD'},
                                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--uri',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'URI'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'list-associated-resources',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'alpha',
                                                                                                                                   u'compute',
                                                                                                                                   u'xpn',
                                                                                                                                   u'list-associated-resources'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'ID for the project to get associated resources for',
                                                                                                                                           u'name': u'project',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'PROJECT_ID'}],
                                                                                                                         u'release': u'ALPHA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* Currently, "resources" only includes projects.',
                                                                                                                                       u'EXAMPLES': u'\nIf the project `xpn-user` can use the project `xpn-host` via XPN, the\ncommand\n\n  $ list-associated-resources xpn-host\n\nyields the output\n\n  RESOURCE_ID  RESOURCE_TYPE\n  xpn-user     PROJECT\n'}},
                                                                                          u'organizations': {u'capsule': u'*(ALPHA)* Configure organizations for cross-project networking (XPN).',
                                                                                                             u'commands': {u'list-host-projects': {u'capsule': u'*(ALPHA)* List projects in a given organization that are enabled as XPN hosts.',
                                                                                                                                                   u'commands': {},
                                                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--filter',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--limit',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'string',
                                                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': True,
                                                                                                                                                                            u'description': u'',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': True,
                                                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'bool',
                                                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--page-size',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'list',
                                                                                                                                                                             u'value': u'FIELD'},
                                                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': False,
                                                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--uri',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'bool',
                                                                                                                                                                         u'value': u'URI'}},
                                                                                                                                                   u'group': False,
                                                                                                                                                   u'groups': {},
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'list-host-projects',
                                                                                                                                                   u'path': [u'gcloud',
                                                                                                                                                             u'alpha',
                                                                                                                                                             u'compute',
                                                                                                                                                             u'xpn',
                                                                                                                                                             u'organizations',
                                                                                                                                                             u'list-host-projects'],
                                                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'ID for the organization whose XPN host projects to list.',
                                                                                                                                                                     u'name': u'id',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'value': u'ORGANIZATION_ID'}],
                                                                                                                                                   u'release': u'ALPHA',
                                                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* List projects in a given organization that are enabled as XPN hosts.',
                                                                                                                                                                 u'EXAMPLES': u'\nTo list the XPN host projects in the organization with ID 12345, run:\n\n  $ list-host-projects 12345\n  NAME       CREATION_TIMESTAMP            XPN_PROJECT_STATUS\n  xpn-host1  2000-01-01T12:00:00.00-00:00  HOST\n  xpn-host2  2000-01-02T12:00:00.00-00:00  HOST\n'}}},
                                                                                                             u'flags': {},
                                                                                                             u'group': True,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'organizations',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'compute',
                                                                                                                       u'xpn',
                                                                                                                       u'organizations'],
                                                                                                             u'positionals': [],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Configure organizations for cross-project networking (XPN).'}}},
                                                                            u'flags': {},
                                                                            u'group': True,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'xpn',
                                                                            u'path': [u'gcloud',
                                                                                      u'alpha',
                                                                                      u'compute',
                                                                                      u'xpn'],
                                                                            u'positionals': [],
                                                                            u'release': u'ALPHA',
                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Configure cross-project networking (XPN).'}},
                                                                   u'zones': {u'capsule': u'*(ALPHA)* List Google Compute Engine zones.',
                                                                              u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Describe a Google Compute Engine zone.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'describe',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'compute',
                                                                                                                    u'zones',
                                                                                                                    u'describe'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the resource to fetch.',
                                                                                                                            u'name': u'name',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine zone.\n'}},
                                                                                            u'list': {u'capsule': u'*(ALPHA)* List Google Compute Engine zones.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--regexp': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--regexp',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'REGEXP'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'compute',
                                                                                                                u'zones',
                                                                                                                u'list'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': [],
                                                                                                                        u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                        u'name': u'names',
                                                                                                                        u'nargs': u'*',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'NAME'}],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine zones in a project.\n',
                                                                                                                    u'EXAMPLES': u'To list all zones in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all zones in a project, run:\n\n  $ list --uri\n'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'zones',
                                                                              u'path': [u'gcloud',
                                                                                        u'alpha',
                                                                                        u'compute',
                                                                                        u'zones'],
                                                                              u'positionals': [],
                                                                              u'release': u'ALPHA',
                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* List Google Compute Engine zones.'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'compute',
                                                     u'path': [u'gcloud',
                                                               u'alpha',
                                                               u'compute'],
                                                     u'positionals': [],
                                                     u'release': u'ALPHA',
                                                     u'sections': {u'DESCRIPTION': u"The gcloud compute command group lets you create, configure and\nmanipulate Google Compute Engine virtual machines.\n\nWith Compute Engine you can create and run virtual machines\non Google infrastructure. Compute Engine offers scale, performance, and\nvalue that allows you to easily launch large compute clusters on\nGoogle's infrastructure.\n\nMore information on Compute Engine can be found here:\nhttps://cloud.google.com/compute/ and detailed documentation can be\nfound here: https://cloud.google.com/compute/docs/\n"}},
                                        u'config': {u'capsule': u'*(ALPHA)* View and edit Cloud SDK properties.',
                                                    u'commands': {u'configurations': {u'capsule': u'*(ALPHA)* Manage the set of gcloud named configurations.',
                                                                                      u'commands': {u'activate': {u'capsule': u'*(ALPHA)* Activates an existing named configuration.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'activate',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'config',
                                                                                                                            u'configurations',
                                                                                                                            u'activate'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Name of the configuration to activate',
                                                                                                                                    u'name': u'configuration-name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'CONFIGURATION_NAME'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Activates an existing named configuration.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                                                u'EXAMPLES': u'To activate an existing named configuration, run:\n\n  $ activate my_config\n\nTo list all properties in the activated configuration, run:\n\n  $ gcloud config list --all\n'}},
                                                                                                    u'create': {u'capsule': u'*(ALPHA)* Creates a new named configuration.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--activate': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'If true, activate this configuration upon create. Enabled by default, use *--no-activate* to disable.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--activate',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'ACTIVATE'},
                                                                                                                           u'--no-activate': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': True,
                                                                                                                                              u'description': u'',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': True,
                                                                                                                                              u'name': u'--no-activate',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'NO_ACTIVATE'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'create',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'config',
                                                                                                                          u'configurations',
                                                                                                                          u'create'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Name of the configuration to create',
                                                                                                                                  u'name': u'configuration-name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'CONFIGURATION_NAME'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u"*(ALPHA)* Creates a new named configuration.\n\nExcept for special cases (NONE), configuration names start with a\nlower case letter and contain only lower case letters a-z, digits 0-9,\nand hyphens '-'.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n",
                                                                                                                              u'EXAMPLES': u'To create a new named configuration, run:\n\n  $ create my-config\n'}},
                                                                                                    u'delete': {u'capsule': u'*(ALPHA)* Deletes a named configuration.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'delete',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'config',
                                                                                                                          u'configurations',
                                                                                                                          u'delete'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Name of the configuration to delete. Cannot be currently active configuration.',
                                                                                                                                  u'name': u'configuration-names',
                                                                                                                                  u'nargs': u'+',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'CONFIGURATION_NAMES'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes a named configuration. You cannot delete a configuration that is active, even\nwhen overridden with the --configuration flag.  To delete the current\nactive configuration, first `gcloud config configurations activate`\nanother one.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                                              u'EXAMPLES': u'To delete a named configuration, run:\n\n  $ delete my_config\n\nTo delete more than one configuration, run:\n\n  $ delete my_config1 my_config2\n\nTo list existing configurations, run:\n\n  $ gcloud config configurations list\n'}},
                                                                                                    u'describe': {u'capsule': u'*(ALPHA)* Describes a named configuration by listing its properties.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--all': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Include unset properties in output.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--all',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'ALL'},
                                                                                                                             u'--no-all': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-all',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_ALL'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'describe',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'alpha',
                                                                                                                            u'config',
                                                                                                                            u'configurations',
                                                                                                                            u'describe'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Name of the configuration to describe',
                                                                                                                                    u'name': u'configuration-name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'CONFIGURATION_NAME'}],
                                                                                                                  u'release': u'ALPHA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Describes a named configuration by listing its properties.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                                                u'EXAMPLES': u'To describe existing named configuration, run:\n\n  $ describe my_config\n\nThis is similar to:\n\n  $ gcloud config configurations activate my_config\n\n  $ gcloud config list\n'}},
                                                                                                    u'list': {u'capsule': u'*(ALPHA)* Lists existing named configurations.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--filter',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'EXPRESSION'},
                                                                                                                         u'--limit': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--limit',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'LIMIT'},
                                                                                                                         u'--sort-by': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--sort-by',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'FIELD'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'list',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'config',
                                                                                                                        u'configurations',
                                                                                                                        u'list'],
                                                                                                              u'positionals': [],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists existing named configurations.\n\nRun `$ gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                                            u'EXAMPLES': u'To list all available configurations, run:\n\n  $ list\n'}}},
                                                                                      u'flags': {},
                                                                                      u'group': True,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'configurations',
                                                                                      u'path': [u'gcloud',
                                                                                                u'alpha',
                                                                                                u'config',
                                                                                                u'configurations'],
                                                                                      u'positionals': [],
                                                                                      u'release': u'ALPHA',
                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage the set of gcloud named configurations.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n'}},
                                                                  u'list': {u'capsule': u'*(ALPHA)* View Cloud SDK properties.',
                                                                            u'commands': {},
                                                                            u'flags': {u'--all': {u'attr': {},
                                                                                                  u'category': u'',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': False,
                                                                                                  u'description': u'List all set and unset properties that match the arguments.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--all',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'bool',
                                                                                                  u'value': u'ALL'},
                                                                                       u'--filter': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--filter',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'EXPRESSION'},
                                                                                       u'--limit': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--limit',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'LIMIT'},
                                                                                       u'--no-all': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': True,
                                                                                                     u'description': u'',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': True,
                                                                                                     u'name': u'--no-all',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'NO_ALL'},
                                                                                       u'--sort-by': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--sort-by',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'list',
                                                                                                      u'value': u'FIELD'}},
                                                                            u'group': False,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'list',
                                                                            u'path': [u'gcloud',
                                                                                      u'alpha',
                                                                                      u'config',
                                                                                      u'list'],
                                                                            u'positionals': [{u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u'The property to be listed. Note that SECTION/ is optional while referring to properties in the core section.',
                                                                                              u'name': u'property',
                                                                                              u'nargs': u'?',
                                                                                              u'required': False,
                                                                                              u'value': u'SECTION/PROPERTY'}],
                                                                            u'release': u'ALPHA',
                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists all properties in your active configuration. These include the\naccount used to authorize access to the Cloud Platform, the current Cloud\nPlatform project, and the default Compute Engine region and zone, if set. See\n`gcloud topic configurations` for more information.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo list the project property in the core section, run:\n\n  $ list project\n\nTo list the zone property in the compute section, run:\n\n  $ list compute/zone\n\nTo list all the properties, run:\n\n  $ list --all\n\nNote you cannot specify both --all and a property name.'}},
                                                                  u'set': {u'capsule': u'*(ALPHA)* Set a Cloud SDK property.',
                                                                           u'commands': {},
                                                                           u'flags': {u'--installation': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u'Typically properties are updated only in the currently active\nconfiguration, but when `--installation` is given the property is\nupdated for the entire gcloud installation.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--installation',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'INSTALLATION'},
                                                                                      u'--no-installation': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': True,
                                                                                                             u'description': u'',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': True,
                                                                                                             u'name': u'--no-installation',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'NO_INSTALLATION'}},
                                                                           u'group': False,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'set',
                                                                           u'path': [u'gcloud',
                                                                                     u'alpha',
                                                                                     u'config',
                                                                                     u'set'],
                                                                           u'positionals': [{u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u'The property to be set. Note that SECTION/ is optional while referring to properties in the core section.',
                                                                                             u'name': u'property',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'value': u'SECTION/PROPERTY'},
                                                                                            {u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u'The value to be set.',
                                                                                             u'name': u'value',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'value': u'VALUE'}],
                                                                           u'release': u'ALPHA',
                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* By default, sets the property in your active configuration only. Use the\n`--installation` flag to set the property across all configurations. See\n`gcloud topic configurations` for more information.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo set the project property in the core section, run:\n\n  $ set project myProject\n\nTo set the zone property in the compute section, run:\n\n  $ set compute/zone zone3'}},
                                                                  u'unset': {u'capsule': u'*(ALPHA)* Unset a Cloud SDK property.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--installation': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u'Typically properties are updated only in the currently active\nconfiguration, but when `--installation` is given the property is\nupdated for the entire gcloud installation.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--installation',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'INSTALLATION'},
                                                                                        u'--no-installation': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': True,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-installation',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_INSTALLATION'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'unset',
                                                                             u'path': [u'gcloud',
                                                                                       u'alpha',
                                                                                       u'config',
                                                                                       u'unset'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'The property to be unset. Note that SECTION/ is optional while referring to properties in the core section.',
                                                                                               u'name': u'property',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'value': u'SECTION/PROPERTY'}],
                                                                             u'release': u'ALPHA',
                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* By default, unsets the property in your active configuration only. Use the\n`--installation` flag to unset the property across all configurations. See\n`gcloud topic configurations` for more information.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo unset the project property in the core section, run:\n\n  $ unset project\n\nTo unset the zone property in the compute section, run:\n\n  $ unset compute/zone'}}},
                                                    u'flags': {},
                                                    u'group': True,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'config',
                                                    u'path': [u'gcloud',
                                                              u'alpha',
                                                              u'config'],
                                                    u'positionals': [],
                                                    u'release': u'ALPHA',
                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* The config command group lets you set, view and unset properties used by\nCloud SDK.\n\nA configuration is a set of properties that govern the behavior of gcloud\nand other Cloud SDK tools. The initial `default` configuration is set when\n`gcloud init` is run. You can create additional named configurations using\n`gcloud init` or `config configurations create`.\n\nTo switch between configurations, use `config configurations activate`.\n\ngcloud supports several flags that have the same effect as properties in\na configuration (for example, gcloud supports both the `--project` flag and\n`project` property). Properties differ from flags in that flags affect command\nbehavior on a per-invocation basis. Properties allow you to maintain the same\nsettings across command executions.\n\nFor more information on configurations, see `gcloud topic configurations`.\n\n## AVAILABLE PROPERTIES\n\n{properties}'}},
                                        u'container': {u'capsule': u'*(ALPHA)* Deploy and manage clusters of machines for running containers.',
                                                       u'commands': {u'builds': {u'capsule': u'*(ALPHA)* Create and manage container builds.',
                                                                                 u'commands': {u'cancel': {u'capsule': u'*(ALPHA)* Cancel an ongoing build.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'cancel',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'container',
                                                                                                                     u'builds',
                                                                                                                     u'cancel'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The build to cancel. The ID of the build is printed at the end of the build submission process, or in the ID column when listing builds.',
                                                                                                                             u'name': u'build',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'BUILD'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cancel an ongoing build.'}},
                                                                                               u'describe': {u'capsule': u'*(ALPHA)* Get information about a particular build.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'container',
                                                                                                                       u'builds',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The build to describe. The ID of the build is printed at the end of the build submission process, or in the ID column when listing builds.',
                                                                                                                               u'name': u'build',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'BUILD'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Get information about a particular build.'}},
                                                                                               u'list': {u'capsule': u'*(ALPHA)* List builds.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': 50,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'int',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-ongoing': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-ongoing',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ONGOING'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--ongoing': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Only list builds that are currently QUEUED or WORKING.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--ongoing',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ONGOING'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'container',
                                                                                                                   u'builds',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* List builds.'}},
                                                                                               u'stream-logs': {u'capsule': u'*(ALPHA)* Stream the logs for a build.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'stream-logs',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'container',
                                                                                                                          u'builds',
                                                                                                                          u'stream-logs'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The build whose logs shall be streamed. The ID of the build is printed at the end of the build submission process, or in the ID column when listing builds.',
                                                                                                                                  u'name': u'build',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'BUILD'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Stream the logs for a build.'}},
                                                                                               u'submit': {u'capsule': u'*(ALPHA)* Submit a build using the Google Container Builder service.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--async',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ASYNC'},
                                                                                                                      u'--config': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The .yaml or .json file to use for build configuration.',
                                                                                                                                    u'group': u'submit.1',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--config',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'CONFIG'},
                                                                                                                      u'--gcs-log-dir': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Directory in Google Cloud Storage to hold build logs. If the bucket does not exist, it will be created. If not set, ```gs://<project id>_cloudbuild/logs``` is used.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--gcs-log-dir',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'GCS_LOG_DIR'},
                                                                                                                      u'--gcs-source-staging-dir': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'Directory in Google Cloud Storage to stage a copy of the source used for the build. If the bucket does not exist, it will be created. If not set, ```gs://<project id>_cloudbuild/source``` is used.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--gcs-source-staging-dir',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'GCS_SOURCE_STAGING_DIR'},
                                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-async',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ASYNC'},
                                                                                                                      u'--substitutions': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Parameters to be substituted in the build specification.\n+\nFor example (using some nonsensical substitution keys; all keys must begin with\nan underscore):\n+\n    $ gcloud container builds submit . \\\n        --config config.yaml \\\n        --substitutions _FAVORITE_COLOR=blue,_NUM_CANDIES=10\n+\nThis will result in a build where every occurrence of ```${_FAVORITE_COLOR}```\nin certain fields is replaced by "blue", and similarly for ```${_NUM_CANDIES}```\nand "10".\n+\nFor more details, see:\nhttps://cloud.google.com/container-builder/docs/api/build-requests#substitutions',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--substitutions',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'dict',
                                                                                                                                           u'value': u'```_```KEY=VALUE'},
                                                                                                                      u'--tag': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The tag to use with a "docker build" image creation. The Container Builder service will run a remote "docker build -t $TAG .", where $TAG is the tag provided by this flag. The tag must be in the gcr.io/* or *.gcr.io/* namespaces.',
                                                                                                                                 u'group': u'submit.1',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--tag',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'TAG'},
                                                                                                                      u'--timeout': {u'attr': {u'property': {u'name': u'container/build_timeout'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Maximum time a build can last before it is failed as "TIMEOUT", written as a duration (eg "2h15m5s" is two hours, fifteen minutes, and five seconds). If no unit is specified, seconds is assumed (eg "10" is 10 seconds). Overrides the default *container/build_timeout* property value for this command invocation.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--timeout',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'TIMEOUT'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {u'submit.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': True}},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'submit',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'container',
                                                                                                                     u'builds',
                                                                                                                     u'submit'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The source directory on local disk or tarball in Google Cloud Storage or disk to use for this build.',
                                                                                                                             u'name': u'source',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'SOURCE'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* Submit a build using the Google Container Builder service.'}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'builds',
                                                                                 u'path': [u'gcloud',
                                                                                           u'alpha',
                                                                                           u'container',
                                                                                           u'builds'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'ALPHA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Create and manage container builds.'}},
                                                                     u'clusters': {u'capsule': u'*(ALPHA)* Deploy and teardown Google Container Engine clusters.',
                                                                                   u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a cluster for running containers.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--additional-zones': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"The set of additional zones in which the specified node footprint should be\nreplicated. All zones must be in the same region as the cluster's primary zone.\nIf additional-zones is not specified, all nodes will be in the cluster's primary\nzone.\n+\nNote that `NUM_NODES` nodes will be created in each zone, such that if you\nspecify `--num-nodes=4` and choose one additional zone, 8 nodes will be created.\n+\nMultiple locations can be specified, separated by commas. For example:\n+\n  $ {command} example-cluster --zone us-central1-a --additional-zones us-central1-b,us-central1-c",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--additional-zones',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'list',
                                                                                                                                                u'value': u'ZONE'},
                                                                                                                        u'--async': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u"Don't wait for the operation to complete.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--async',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'ASYNC'},
                                                                                                                        u'--cluster-ipv4-cidr': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The IP address range for the pods in this cluster in CIDR notation (e.g. 10.0.0.0/14). Due to kube-proxy limitations, this range must be a subset of the 10.0.0.0/8 space. Defaults to server-specified.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--cluster-ipv4-cidr',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'CLUSTER_IPV4_CIDR'},
                                                                                                                        u'--cluster-version': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The Kubernetes version to use for the master and nodes. Defaults to\nserver-specified.\n+\nThe default Kubernetes version are available using the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--cluster-version',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'CLUSTER_VERSION'},
                                                                                                                        u'--disable-addons': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'List of cluster addons to disable. Options are HttpLoadBalancing, HorizontalPodAutoscaling. _DISABLE_ADDONS_ must be one of: *HttpLoadBalancing*, *HorizontalPodAutoscaling*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--disable-addons',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'DISABLE_ADDONS'},
                                                                                                                        u'--disk-size': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Size in GB for node VM boot disks. Defaults to 100GB.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--disk-size',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'DISK_SIZE'},
                                                                                                                        u'--enable-autorepair': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--enable-autorepair',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'ENABLE_AUTOREPAIR'},
                                                                                                                        u'--enable-autoscaling': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'Enables autoscaling for a node pool.\n+\nEnables autoscaling in the node pool specified by --node-pool or\nthe default node pool if --node-pool is not provided.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--enable-autoscaling',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'ENABLE_AUTOSCALING'},
                                                                                                                        u'--enable-autoupgrade': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u"Sets autoupgrade feature for a cluster's default node-pool(s).\n+\n  $ {command} example-cluster --enable-autoupgrade\n+\nSee https://cloud.google.com/container-engine/docs/node-managament for more info.",
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--enable-autoupgrade',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'ENABLE_AUTOUPGRADE'},
                                                                                                                        u'--enable-cloud-endpoints': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': True,
                                                                                                                                                      u'description': u'Automatically enable Google Cloud Endpoints to take advantage of API management features. Enabled by default, use *--no-enable-cloud-endpoints* to disable.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--enable-cloud-endpoints',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'ENABLE_CLOUD_ENDPOINTS'},
                                                                                                                        u'--enable-cloud-logging': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': True,
                                                                                                                                                    u'description': u'Automatically send logs from the cluster to the Google Cloud Logging API. Enabled by default, use *--no-enable-cloud-logging* to disable.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--enable-cloud-logging',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'ENABLE_CLOUD_LOGGING'},
                                                                                                                        u'--enable-cloud-monitoring': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': True,
                                                                                                                                                       u'description': u'Automatically send metrics from pods in the cluster to the Google Cloud Monitoring API. VM metrics will be collected by Google Compute Engine regardless of this setting. Enabled by default, use *--no-enable-cloud-monitoring* to disable.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--enable-cloud-monitoring',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'ENABLE_CLOUD_MONITORING'},
                                                                                                                        u'--enable-kubernetes-alpha': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'Enable Kubernetes alpha features on this cluster. Selecting this\noption will result in the cluster having all Kubernetes alpha API groups and\nfeatures turned on. Cluster upgrades (both manual and automatic) will be\ndisabled and the cluster will be automatically deleted after 30 days.\n+\nAlpha clusters are not covered by the Container Engine SLA and should not be\nused for production workloads.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--enable-kubernetes-alpha',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'ENABLE_KUBERNETES_ALPHA'},
                                                                                                                        u'--image-type': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The image type to use for the cluster. Defaults to server-specified.\n+\nImage Type specifies the base OS that the nodes in the cluster will run on.\nIf an image type is specified, that will be assigned to the cluster and all\nfuture upgrades will use the specified image type. If it is not specified the\nserver will pick the default image type.\n+\nThe default image type and the list of valid image types are available\nusing the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--image-type',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'IMAGE_TYPE'},
                                                                                                                        u'--local-ssd-count': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': 0,
                                                                                                                                               u'description': u'The number of local SSD disks to provision on each node.\n+\nLocal SSDs have a fixed 375 GB capacity per device. The number of disks that\ncan be attached to an instance is limited by the maximum number of disks\navailable on a machine, which differs by compute zone. See\nhttps://cloud.google.com/compute/docs/disks/local-ssd for more information.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--local-ssd-count',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'int',
                                                                                                                                               u'value': u'LOCAL_SSD_COUNT'},
                                                                                                                        u'--machine-type': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The type of machine to use for nodes. Defaults to server-specified.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--machine-type',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'MACHINE_TYPE'},
                                                                                                                        u'--max-nodes': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Maximum number of nodes in the node pool.\n+\nMaximum number of nodes to which the node pool specified by --node-pool\n(or default node pool if unspecified) can scale. Ignored unless\n--enable-autoscaling is also specified.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--max-nodes',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'MAX_NODES'},
                                                                                                                        u'--max-nodes-per-pool': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The maximum number of nodes to allocate per default initial node pool. Container engine will automatically create enough nodes pools such that each node pool contains less than --max-nodes-per-pool nodes. Defaults to 1000 nodes, but can be set as low as 100 nodes per pool on initial create.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--max-nodes-per-pool',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'MAX_NODES_PER_POOL'},
                                                                                                                        u'--min-nodes': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Minimum number of nodes in the node pool.\n+\nMinimum number of nodes to which the node pool specified by --node-pool\n(or default node pool if unspecified) can scale. Ignored unless\n--enable-autoscaling is also specified.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--min-nodes',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'MIN_NODES'},
                                                                                                                        u'--network': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The Compute Engine Network that the cluster will connect to. Google Container Engine will use this network when creating routes and firewalls for the clusters. Defaults to the 'default' network.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--network',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'NETWORK'},
                                                                                                                        u'--no-async': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-async',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ASYNC'},
                                                                                                                        u'--no-enable-autorepair': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-enable-autorepair',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_ENABLE_AUTOREPAIR'},
                                                                                                                        u'--no-enable-autoscaling': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-enable-autoscaling',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_ENABLE_AUTOSCALING'},
                                                                                                                        u'--no-enable-autoupgrade': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-enable-autoupgrade',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_ENABLE_AUTOUPGRADE'},
                                                                                                                        u'--no-enable-cloud-endpoints': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': True,
                                                                                                                                                         u'description': u'',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': True,
                                                                                                                                                         u'name': u'--no-enable-cloud-endpoints',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'NO_ENABLE_CLOUD_ENDPOINTS'},
                                                                                                                        u'--no-enable-cloud-logging': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': True,
                                                                                                                                                       u'description': u'',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': True,
                                                                                                                                                       u'name': u'--no-enable-cloud-logging',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_ENABLE_CLOUD_LOGGING'},
                                                                                                                        u'--no-enable-cloud-monitoring': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': True,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-enable-cloud-monitoring',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_ENABLE_CLOUD_MONITORING'},
                                                                                                                        u'--no-enable-kubernetes-alpha': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': True,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-enable-kubernetes-alpha',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_ENABLE_KUBERNETES_ALPHA'},
                                                                                                                        u'--no-preemptible': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': True,
                                                                                                                                              u'description': u'',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': True,
                                                                                                                                              u'name': u'--no-preemptible',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'NO_PREEMPTIBLE'},
                                                                                                                        u'--no-wait': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-wait',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_WAIT'},
                                                                                                                        u'--node-labels': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Applies the given kubernetes labels on all nodes in the new node-pool. Example:\n+\n  $ {command} example-cluster --node-labels=label-a=value1,label-2=value2\n+\nNew nodes, including ones created by resize or recreate, will have these labels\non the kubernetes API node object and can be used in nodeSelectors.\nSee http://kubernetes.io/docs/user-guide/node-selection/ for examples.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--node-labels',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'dict',
                                                                                                                                           u'value': u'NODE_LABELS'},
                                                                                                                        u'--num-nodes': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': 3,
                                                                                                                                         u'description': u"The number of nodes to be created in each of the cluster's zones.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--num-nodes',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'int',
                                                                                                                                         u'value': u'NUM_NODES'},
                                                                                                                        u'--password': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The password to use for cluster auth. Defaults to a server-specified randomly-generated string.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--password',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'PASSWORD'},
                                                                                                                        u'--preemptible': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'Create nodes using preemptible VM instances in the new cluster.\n+\n  $ {command} example-cluster --preemptible\n+\nNew nodes, including ones created by resize or recreate, will use preemptible\nVM instances. See https://cloud.google.com/container-engine/docs/preemptible-vm\nfor more information on how to use Preemptible VMs with Container Engine.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--preemptible',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'PREEMPTIBLE'},
                                                                                                                        u'--scopes': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Specifies scopes for the node instances. The project\'s default\nservice account is used. Examples:\n+\n  $ {command} example-cluster --scopes https://www.googleapis.com/auth/devstorage.read_only\n+\n  $ {command} example-cluster --scopes bigquery,storage-rw,compute-ro\n+\nMultiple SCOPEs can specified, separated by commas. The scopes\nnecessary for the cluster to function properly (compute-rw, storage-ro),\nare always added, even if not explicitly specified.\n+\nSCOPE can be either the full URI of the scope or an alias.\nAvailable aliases are:\n+\n[format="csv",options="header"]\n|========\nAlias,URI\nbigquery,https://www.googleapis.com/auth/bigquery\ncloud-platform,https://www.googleapis.com/auth/cloud-platform\ncloud-source-repos,https://www.googleapis.com/auth/source.full_control\ncloud-source-repos-ro,https://www.googleapis.com/auth/source.read_only\ncompute-ro,https://www.googleapis.com/auth/compute.readonly\ncompute-rw,https://www.googleapis.com/auth/compute\ndatastore,https://www.googleapis.com/auth/datastore\ndefault,https://www.googleapis.com/auth/cloud.useraccounts.readonly\n,https://www.googleapis.com/auth/devstorage.read_only\n,https://www.googleapis.com/auth/logging.write\n,https://www.googleapis.com/auth/monitoring.write\n,https://www.googleapis.com/auth/service.management.readonly\n,https://www.googleapis.com/auth/servicecontrol\nlogging-write,https://www.googleapis.com/auth/logging.write\nmonitoring,https://www.googleapis.com/auth/monitoring\nmonitoring-write,https://www.googleapis.com/auth/monitoring.write\nservice-control,https://www.googleapis.com/auth/servicecontrol\nservice-management,https://www.googleapis.com/auth/service.management.readonly\nsql,https://www.googleapis.com/auth/sqlservice\nsql-admin,https://www.googleapis.com/auth/sqlservice.admin\nstorage-full,https://www.googleapis.com/auth/devstorage.full_control\nstorage-ro,https://www.googleapis.com/auth/devstorage.read_only\nstorage-rw,https://www.googleapis.com/auth/devstorage.read_write\ntaskqueue,https://www.googleapis.com/auth/taskqueue\nuseraccounts-ro,https://www.googleapis.com/auth/cloud.useraccounts.readonly\nuseraccounts-rw,https://www.googleapis.com/auth/cloud.useraccounts\nuserinfo-email,https://www.googleapis.com/auth/userinfo.email\n|========',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--scopes',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'SCOPE'},
                                                                                                                        u'--service-account': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The Google Cloud Platform Service Account to be used by the node VMs. If no Service Account is specified, the "default" service account is used.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--service-account',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'SERVICE_ACCOUNT'},
                                                                                                                        u'--subnetwork': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the Google Compute Engine subnetwork (https://cloud.google.com/compute/docs/subnetworks) to which the cluster is connected. If specified, the cluster\'s network must be a "custom subnet" network.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--subnetwork',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'SUBNETWORK'},
                                                                                                                        u'--tags': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Applies the given Compute Engine tags (comma separated) on all nodes in the new\nnode-pool. Example:\n+\n  $ {command} example-cluster --tags=tag1,tag2\n+\nNew nodes, including ones created by resize or recreate, will have these tags\non the Compute Engine API instance object and can be used in firewall rules.\nSee https://cloud.google.com/sdk/gcloud/reference/compute/firewall-rules/create\nfor examples.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--tags',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'TAG'},
                                                                                                                        u'--timeout': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': 1800,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--timeout',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'int',
                                                                                                                                       u'value': u'TIMEOUT'},
                                                                                                                        u'--username': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': u'admin',
                                                                                                                                        u'description': u'The user name to use for cluster auth.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--username',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'USERNAME'},
                                                                                                                        u'--wait': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--wait',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'WAIT'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'create',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'container',
                                                                                                                       u'clusters',
                                                                                                                       u'create'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of this cluster.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Create a cluster for running containers.'}},
                                                                                                 u'delete': {u'capsule': u'*(ALPHA)* Delete an existing cluster for running containers.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--async': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u"Don't wait for the operation to complete.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--async',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'ASYNC'},
                                                                                                                        u'--no-async': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-async',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ASYNC'},
                                                                                                                        u'--no-wait': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-wait',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_WAIT'},
                                                                                                                        u'--timeout': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': 1800,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--timeout',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'int',
                                                                                                                                       u'value': u'TIMEOUT'},
                                                                                                                        u'--wait': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--wait',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'WAIT'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'delete',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'container',
                                                                                                                       u'clusters',
                                                                                                                       u'delete'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The names of the clusters to delete.',
                                                                                                                               u'name': u'names',
                                                                                                                               u'nargs': u'+',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Delete an existing cluster for running containers.'}},
                                                                                                 u'describe': {u'capsule': u'*(ALPHA)* Describe an existing cluster for running containers.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'describe',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'container',
                                                                                                                         u'clusters',
                                                                                                                         u'describe'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of this cluster.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Describe an existing cluster for running containers.'}},
                                                                                                 u'get-credentials': {u'capsule': u'*(ALPHA)* Fetch credentials for a running cluster.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'get-credentials',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'container',
                                                                                                                                u'clusters',
                                                                                                                                u'get-credentials'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the cluster to get credentials for. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Updates a kubeconfig file with appropriate credentials to point\nkubectl at a Container Engine Cluster. By default, credentials\nare written to HOME/.kube/config. You can provide an alternate\npath by setting the KUBECONFIG environment variable.\n\nSee [](https://cloud.google.com/container-engine/docs/kubectl) for\nkubectl documentation.'}},
                                                                                                 u'list': {u'capsule': u'*(ALPHA)* List existing clusters for running containers.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--filter',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--limit',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--page-size',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'FIELD'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'list',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'container',
                                                                                                                     u'clusters',
                                                                                                                     u'list'],
                                                                                                           u'positionals': [],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* List existing clusters for running containers.'}},
                                                                                                 u'resize': {u'capsule': u'*(ALPHA)* Resizes an existing cluster for running containers.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--async': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u"Don't wait for the operation to complete.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--async',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'ASYNC'},
                                                                                                                        u'--no-async': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-async',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ASYNC'},
                                                                                                                        u'--no-wait': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-wait',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_WAIT'},
                                                                                                                        u'--node-pool': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The node pool to resize.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--node-pool',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'NODE_POOL'},
                                                                                                                        u'--size': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Target number of nodes in the cluster.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--size',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'SIZE'},
                                                                                                                        u'--wait': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--wait',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'WAIT'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'resize',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'container',
                                                                                                                       u'clusters',
                                                                                                                       u'resize'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of this cluster.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'\n        Resize an existing cluster to a provided size.\n\nIf you have multiple node pools, you must specify which node pool to resize by\nusing the --node-pool flag. You are not required to use the flag if you have\na single node pool.\n\nWhen increasing the size of a container cluster, the new instances are created\nwith the same configuration as the existing instances.\nExisting pods are not moved onto the new instances,\nbut new pods (such as those created by resizing a replication controller)\nwill be scheduled onto the new instances.\n\nWhen decreasing a cluster, the pods that are scheduled on the instances being\nremoved will be killed. If your pods are being managed by a replication\ncontroller, the controller will attempt to reschedule them onto the remaining\ninstances. If your pods are not managed by a replication controller,\nthey will not be restarted.\nNote that when resizing down, instances running pods and instances without pods\nare not differentiated. Resize will pick instances to remove at random.\n'}},
                                                                                                 u'update': {u'capsule': u'*(ALPHA)* Update cluster settings for an existing container cluster.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--additional-zones': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The set of additional zones in which the cluster\'s node footprint should be\nreplicated. All zones must be in the same region as the cluster\'s primary zone.\n+\nNote that the exact same footprint will be replicated in all zones, such that\nif you created a cluster with 4 nodes in a single zone and then use this option\nto spread across 2 more zones, 8 additional nodes will be created.\n+\nMultiple locations can be specified, separated by commas. For example:\n+\n  $ {{command}} example-cluster --zone us-central1-a --additional-zones us-central1-b,us-central1-c\n+\nTo remove all zones other than the cluster\'s primary zone, pass the empty string\nto the flag. For example:\n+\n  $ {{command}} example-cluster --zone us-central1-a --additional-zones ""',
                                                                                                                                                u'group': u'update.1',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--additional-zones',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'list',
                                                                                                                                                u'value': u'ZONE'},
                                                                                                                        u'--async': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u"Don't wait for the operation to complete.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--async',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'ASYNC'},
                                                                                                                        u'--disable-autoscaling': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Disables autoscaling for a node pool.\n+\nDisables autoscaling in the node pool specified by --node-pool or\nthe default node pool if --node-pool is not provided.',
                                                                                                                                                   u'group': u'update.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--disable-autoscaling',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'DISABLE_AUTOSCALING'},
                                                                                                                        u'--enable-autoscaling': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'Enables autoscaling for a node pool.\n+\nEnables autoscaling in the node pool specified by --node-pool or\nthe default node pool if --node-pool is not provided.',
                                                                                                                                                  u'group': u'update.1',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--enable-autoscaling',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'ENABLE_AUTOSCALING'},
                                                                                                                        u'--max-nodes': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Maximum number of nodes in the node pool.\n+\nMaximum number of nodes to which the node pool specified by --node-pool\n(or default node pool if unspecified) can scale. Ignored unless\n--enable-autoscaling is also specified.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--max-nodes',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'MAX_NODES'},
                                                                                                                        u'--min-nodes': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Minimum number of nodes in the node pool.\n+\nMinimum number of nodes to which the node pool specified by --node-pool\n(or default node pool if unspecified) can scale. Ignored unless\n--enable-autoscaling is also specified.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--min-nodes',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'MIN_NODES'},
                                                                                                                        u'--monitoring-service': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The monitoring service to use for the cluster. Options are: "monitoring.googleapis.com" (the Google Cloud Monitoring service),  "none" (no metrics will be exported from the cluster)',
                                                                                                                                                  u'group': u'update.1',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--monitoring-service',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'MONITORING_SERVICE'},
                                                                                                                        u'--no-async': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-async',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ASYNC'},
                                                                                                                        u'--no-wait': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-wait',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_WAIT'},
                                                                                                                        u'--node-pool': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Node pool to be updated.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--node-pool',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'NODE_POOL'},
                                                                                                                        u'--update-addons': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Cluster addons to enable or disable. Options are\nHorizontalPodAutoscaling=ENABLED|DISABLED\nHttpLoadBalancing=ENABLED|DISABLED',
                                                                                                                                             u'group': u'update.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--update-addons',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'dict',
                                                                                                                                             u'value': u'ADDON=ENABLED|DISABLED'},
                                                                                                                        u'--wait': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--wait',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'WAIT'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {u'update.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                       u'is_mutex': True,
                                                                                                                                       u'is_required': True}},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'update',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'container',
                                                                                                                       u'clusters',
                                                                                                                       u'update'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the cluster to update.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Update cluster settings for an existing container cluster.'}},
                                                                                                 u'upgrade': {u'capsule': u'*(ALPHA)* Upgrade the Kubernetes version of an existing container cluster.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--async': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u"Don't wait for the operation to complete.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--async',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'ASYNC'},
                                                                                                                         u'--cluster-version': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"The Kubernetes release version to which to upgrade the cluster's nodes.\n+\nIf provided, the --cluster-version must be no greater than the cluster\nmaster's minor version (x.*X*.x), and must be a latest patch version\n(x.x.*X*).\n+\nYou can find the list of allowed versions for upgrades by running:\n+\n  $ gcloud container get-server-config",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--cluster-version',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'CLUSTER_VERSION'},
                                                                                                                         u'--image-type': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The image type to use for the cluster/node pool. Defaults to server-specified.\n+\nImage Type specifies the base OS that the nodes in the cluster/node pool will run on.\nIf an image type is specified, that will be assigned to the cluster/node pool and all\nfuture upgrades will use the specified image type. If it is not specified the\nserver will pick the default image type.\n+\nThe default image type and the list of valid image types are available\nusing the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--image-type',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'IMAGE_TYPE'},
                                                                                                                         u'--master': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u"Upgrade the cluster's master to the latest version of Kubernetes supported on Container Engine. Nodes cannot be upgraded at the same time as the master.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--master',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'MASTER'},
                                                                                                                         u'--no-async': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-async',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_ASYNC'},
                                                                                                                         u'--no-master': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-master',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_MASTER'},
                                                                                                                         u'--no-wait': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-wait',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_WAIT'},
                                                                                                                         u'--node-pool': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The node pool to upgrade.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--node-pool',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'NODE_POOL'},
                                                                                                                         u'--wait': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--wait',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'WAIT'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'upgrade',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'container',
                                                                                                                        u'clusters',
                                                                                                                        u'upgrade'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the cluster to upgrade.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u"Upgrades the Kubernetes version of an existing container cluster.\n\nThis command upgrades the Kubernetes version of the *nodes* of a cluster.\nThe Kubernetes version of the cluster's *master* is periodically upgraded\nautomatically as new releases are available.\n\n*By running this command, all of the cluster's nodes will be deleted and*\n*recreated one at a time.* While persistent Kubernetes resources, such as\npods backed by replication controllers, will be rescheduled onto new nodes,\na small cluster may experience a few minutes where there are insufficient\nnodes available to run all of the scheduled Kubernetes resources.\n\n*Please ensure that any data you wish to keep is stored on a persistent*\n*disk before upgrading the cluster.* Ephemeral Kubernetes resources--in\nparticular, pods without replication controllers--will be lost, while\npersistent Kubernetes resources will get rescheduled.\n",
                                                                                                                            u'EXAMPLES': u'Upgrade the nodes of <cluster> to the Kubernetes version of the cluster\'s\nmaster.\n\n  $ upgrade <cluster>\n\nUpgrade the nodes of <cluster> to Kubernetes version x.y.z.\n\n  $ upgrade <cluster> --cluster-version "x.y.z"\n'}}},
                                                                                   u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--zone',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'ZONE'}},
                                                                                   u'group': True,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'clusters',
                                                                                   u'path': [u'gcloud',
                                                                                             u'alpha',
                                                                                             u'container',
                                                                                             u'clusters'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'ALPHA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deploy and teardown Google Container Engine clusters.'}},
                                                                     u'get-server-config': {u'capsule': u'*(ALPHA)* Get Container Engine server config.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--zone',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'ZONE'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'get-server-config',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'alpha',
                                                                                                      u'container',
                                                                                                      u'get-server-config'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'ALPHA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Get Container Engine server config.'}},
                                                                     u'images': {u'capsule': u'*(ALPHA)* List and manipulate Google Container Registry images.',
                                                                                 u'commands': {u'add-tag': {u'capsule': u'*(ALPHA)* Adds tags to existing image.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'add-tag',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'container',
                                                                                                                      u'images',
                                                                                                                      u'add-tag'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The fully qualified image reference to add a tag for.\n*.gcr.io/repository:tag*.gcr.io/repository@digest',
                                                                                                                              u'name': u'src-image',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'SRC_IMAGE'},
                                                                                                                             {u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The fully qualified image reference to be the new tag.\n*.gcr.io/repository:tag',
                                                                                                                              u'name': u'dest-image',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'DEST_IMAGE'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'The container images add-tag command adds the tag specified in\nthe second tag parameter to the image referenced in the first\ntag parameter. Repositories must be hosted by the Google Container\nRegistry.\n',
                                                                                                                          u'EXAMPLES': u'Add a tag to another tag:\n\n  $ {command} gcr.io/myproject/myimage:mytag1\n    gcr.io/myproject/myimage:mytag2\n\nAdd a tag to a digest\n\n  $ {command} gcr.io/myproject/myimage@sha256:digest\n    gcr.io/myproject/myimage:mytag2\n\nAdd a tag to latest\n\n  $ {command} gcr.io/myproject/myimage\n    gcr.io/myproject/myimage:mytag2\n\nPromote a tag to latest\n\n  $ {command} gcr.io/myproject/myimage:mytag1\n    gcr.io/myproject/myimage:latest\n\n'}},
                                                                                               u'delete': {u'capsule': u'*(ALPHA)* Delete existing images.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'delete',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'container',
                                                                                                                     u'images',
                                                                                                                     u'delete'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The IMAGE_NAME or IMAGE_NAMES to delete\nFormat For Digest: *.gcr.io/repository@<digest>Format For Tag: *.gcr.io/repository:<tag>',
                                                                                                                             u'name': u'image-names',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'IMAGE_NAMES'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'The container images delete command deletes the specified tag or\ndigest from the registry. If a tag is specified, only the tag is\ndeleted from the registry and image layers remain accessible by\ndigest. If a digest is specified, image layers are fully deleted from\nthe registry.\n',
                                                                                                                         u'EXAMPLES': u'Deletes the tag or digest from the input IMAGE_NAME:\n\n  $ {command} <IMAGE_NAME>\n\n'}},
                                                                                               u'describe': {u'capsule': u'*(ALPHA)* Lists container analysis data for a given image.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--occurrence-filter': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': u'kind = "BUILD_DETAILS" OR kind = "PACKAGE_VULNERABILITY" OR kind = "IMAGE_BASIS"',
                                                                                                                                                 u'description': u'Additional filter to fetch occurrences for a given fully qualified image reference.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--occurrence-filter',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'OCCURRENCE_FILTER'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'container',
                                                                                                                       u'images',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The fully qualified image reference to describe.\n*.gcr.io/repository@digest, *.gcr.io/repository:tag',
                                                                                                                               u'name': u'image',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'IMAGE'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists container analysis data for a valid image.\n\n## EXAMPLES\n\nDescribe container analysis data for a specified image:\n\n  $ {command} gcr.io/myproject/myimage@digest\n        OR\n  $ {command} gcr.io/myproject/myimage:tag'}},
                                                                                               u'list': {u'capsule': u'*(ALPHA)* List existing images.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--repository': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the repository. Format: *.gcr.io/repository. Defaults to gcr.io/<project>, for the active project.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--repository',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REPOSITORY'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'container',
                                                                                                                   u'images',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'The container images list command of gcloud lists metadata about\nexisting container images in a specified repository. Repositories\nmust be hosted by the Google Container Registry.\n',
                                                                                                                       u'EXAMPLES': u'List the images in a specified repository:\n\n  $ {command} --repository=gcr.io/myproject\n\nList the images in the default repository:\n\n  $ {command}\n\n'}},
                                                                                               u'list-tags': {u'capsule': u'*(ALPHA)* List tags and digests for the specified image.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--filter',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'EXPRESSION'},
                                                                                                                         u'--limit': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--limit',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'LIMIT'},
                                                                                                                         u'--no-show-occurrences': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-show-occurrences',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_SHOW_OCCURRENCES'},
                                                                                                                         u'--occurrence-filter': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': u'kind = "BUILD_DETAILS" OR kind = "IMAGE_BASIS" OR kind = "PACKAGE_VULNERABILITY"',
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--occurrence-filter',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'OCCURRENCE_FILTER'},
                                                                                                                         u'--page-size': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--page-size',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                                                         u'--show-occurrences': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--show-occurrences',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'SHOW_OCCURRENCES'},
                                                                                                                         u'--sort-by': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--sort-by',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'FIELD'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'list-tags',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'container',
                                                                                                                        u'images',
                                                                                                                        u'list-tags'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the image. Format: *.gcr.io/repository/image',
                                                                                                                                u'name': u'image',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'IMAGE'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'The container images list-tags command of gcloud lists metadata about\ntags and digests for the specified container image. Images must be\nhosted by the Google Container Registry.\n',
                                                                                                                            u'EXAMPLES': u'List the tags in a specified image:\n\n  $ {command} gcr.io/myproject/myimage\n\n'}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'images',
                                                                                 u'path': [u'gcloud',
                                                                                           u'alpha',
                                                                                           u'container',
                                                                                           u'images'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'ALPHA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* List and manipulate Google Container Registry images.'}},
                                                                     u'node-pools': {u'capsule': u'*(ALPHA)* Create and delete operations for Google Container Engine node pools.',
                                                                                     u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a node pool in a running cluster.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The cluster to add the node pool to. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--cluster',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'CLUSTER'},
                                                                                                                          u'--disk-size': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Size in GB for node VM boot disks. Defaults to 100GB.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--disk-size',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'DISK_SIZE'},
                                                                                                                          u'--enable-autorepair': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--enable-autorepair',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'ENABLE_AUTOREPAIR'},
                                                                                                                          u'--enable-autoscaling': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Enables autoscaling for a node pool.\n+\nEnables autoscaling in the node pool specified by --node-pool or\nthe default node pool if --node-pool is not provided.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--enable-autoscaling',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'ENABLE_AUTOSCALING'},
                                                                                                                          u'--enable-autoupgrade': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Sets autoupgrade feature for a node-pool.\n+\n  $ {command} node-pool-1 --cluster=example-cluster --enable-autoupgrade\n+\nSee https://cloud.google.com/container-engine/docs/node-managament for more info.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--enable-autoupgrade',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'ENABLE_AUTOUPGRADE'},
                                                                                                                          u'--enable-cloud-endpoints': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': True,
                                                                                                                                                        u'description': u'Automatically enable Google Cloud Endpoints to take advantage of API management features. Enabled by default, use *--no-enable-cloud-endpoints* to disable.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--enable-cloud-endpoints',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'ENABLE_CLOUD_ENDPOINTS'},
                                                                                                                          u'--image-type': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The image type to use for the node pool. Defaults to server-specified.\n+\nImage Type specifies the base OS that the nodes in the node pool will run on.\nIf an image type is specified, that will be assigned to the node pool and all\nfuture upgrades will use the specified image type. If it is not specified the\nserver will pick the default image type.\n+\nThe default image type and the list of valid image types are available\nusing the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--image-type',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'IMAGE_TYPE'},
                                                                                                                          u'--local-ssd-count': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': 0,
                                                                                                                                                 u'description': u'The number of local SSD disks to provision on each node.\n+\nLocal SSDs have a fixed 375 GB capacity per device. The number of disks that\ncan be attached to an instance is limited by the maximum number of disks\navailable on a machine, which differs by compute zone. See\nhttps://cloud.google.com/compute/docs/disks/local-ssd for more information.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--local-ssd-count',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'int',
                                                                                                                                                 u'value': u'LOCAL_SSD_COUNT'},
                                                                                                                          u'--machine-type': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The type of machine to use for nodes. Defaults to server-specified.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--machine-type',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'MACHINE_TYPE'},
                                                                                                                          u'--max-nodes': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Maximum number of nodes in the node pool.\n+\nMaximum number of nodes to which the node pool specified by --node-pool\n(or default node pool if unspecified) can scale. Ignored unless\n--enable-autoscaling is also specified.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--max-nodes',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'MAX_NODES'},
                                                                                                                          u'--min-nodes': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Minimum number of nodes in the node pool.\n+\nMinimum number of nodes to which the node pool specified by --node-pool\n(or default node pool if unspecified) can scale. Ignored unless\n--enable-autoscaling is also specified.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--min-nodes',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'MIN_NODES'},
                                                                                                                          u'--no-enable-autorepair': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-enable-autorepair',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_ENABLE_AUTOREPAIR'},
                                                                                                                          u'--no-enable-autoscaling': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': True,
                                                                                                                                                       u'name': u'--no-enable-autoscaling',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_ENABLE_AUTOSCALING'},
                                                                                                                          u'--no-enable-autoupgrade': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': True,
                                                                                                                                                       u'name': u'--no-enable-autoupgrade',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_ENABLE_AUTOUPGRADE'},
                                                                                                                          u'--no-enable-cloud-endpoints': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': True,
                                                                                                                                                           u'description': u'',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': True,
                                                                                                                                                           u'name': u'--no-enable-cloud-endpoints',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'NO_ENABLE_CLOUD_ENDPOINTS'},
                                                                                                                          u'--no-preemptible': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-preemptible',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_PREEMPTIBLE'},
                                                                                                                          u'--node-labels': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Applies the given kubernetes labels on all nodes in the new node-pool. Example:\n+\n  $ {command} node-pool-1 --cluster=example-cluster --node-labels=label1=value1,label2=value2\n+\nNew nodes, including ones created by resize or recreate, will have these labels\non the kubernetes API node object and can be used in nodeSelectors.\nSee http://kubernetes.io/docs/user-guide/node-selection/ for examples.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--node-labels',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'dict',
                                                                                                                                             u'value': u'NODE_LABELS'},
                                                                                                                          u'--num-nodes': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': 3,
                                                                                                                                           u'description': u"The number of nodes in the node pool in each of the cluster's zones.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--num-nodes',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'int',
                                                                                                                                           u'value': u'NUM_NODES'},
                                                                                                                          u'--preemptible': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'Create nodes using preemptible VM instances in the new nodepool.\n+\n  $ {command} node-pool-1 --cluster=example-cluster --preemptible\n+\nNew nodes, including ones created by resize or recreate, will use preemptible\nVM instances. See https://cloud.google.com/container-engine/docs/preemptible-vm\nfor more information on how to use Preemptible VMs with Container Engine.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--preemptible',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'PREEMPTIBLE'},
                                                                                                                          u'--scopes': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Specifies scopes for the node instances. The project\'s default\nservice account is used. Examples:\n+\n  $ {command} node-pool-1 --cluster=example-cluster --scopes https://www.googleapis.com/auth/devstorage.read_only\n+\n  $ {command} node-pool-1 --cluster=example-cluster --scopes bigquery,storage-rw,compute-ro\n+\nMultiple SCOPEs can specified, separated by commas. The scopes\nnecessary for the cluster to function properly (compute-rw, storage-ro),\nare always added, even if not explicitly specified.\n+\nSCOPE can be either the full URI of the scope or an alias.\nAvailable aliases are:\n+\n[options="header",format="csv",grid="none",frame="none"]\n|========\nAlias,URI\nbigquery,https://www.googleapis.com/auth/bigquery\ncloud-platform,https://www.googleapis.com/auth/cloud-platform\ncloud-source-repos,https://www.googleapis.com/auth/source.full_control\ncloud-source-repos-ro,https://www.googleapis.com/auth/source.read_only\ncompute-ro,https://www.googleapis.com/auth/compute.readonly\ncompute-rw,https://www.googleapis.com/auth/compute\ndatastore,https://www.googleapis.com/auth/datastore\ndefault,https://www.googleapis.com/auth/cloud.useraccounts.readonly\n,https://www.googleapis.com/auth/devstorage.read_only\n,https://www.googleapis.com/auth/logging.write\n,https://www.googleapis.com/auth/monitoring.write\n,https://www.googleapis.com/auth/service.management.readonly\n,https://www.googleapis.com/auth/servicecontrol\nlogging-write,https://www.googleapis.com/auth/logging.write\nmonitoring,https://www.googleapis.com/auth/monitoring\nmonitoring-write,https://www.googleapis.com/auth/monitoring.write\nservice-control,https://www.googleapis.com/auth/servicecontrol\nservice-management,https://www.googleapis.com/auth/service.management.readonly\nsql,https://www.googleapis.com/auth/sqlservice\nsql-admin,https://www.googleapis.com/auth/sqlservice.admin\nstorage-full,https://www.googleapis.com/auth/devstorage.full_control\nstorage-ro,https://www.googleapis.com/auth/devstorage.read_only\nstorage-rw,https://www.googleapis.com/auth/devstorage.read_write\ntaskqueue,https://www.googleapis.com/auth/taskqueue\nuseraccounts-ro,https://www.googleapis.com/auth/cloud.useraccounts.readonly\nuseraccounts-rw,https://www.googleapis.com/auth/cloud.useraccounts\nuserinfo-email,https://www.googleapis.com/auth/userinfo.email\n|========',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--scopes',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'SCOPE'},
                                                                                                                          u'--service-account': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The Google Cloud Platform Service Account to be used by the node VMs. If no Service Account is specified, the "default" service account is used.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--service-account',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'SERVICE_ACCOUNT'},
                                                                                                                          u'--tags': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Applies the given Compute Engine tags (comma separated) on all nodes in the new\nnode-pool. Example:\n+\n  $ {command} node-pool-1 --cluster=example-cluster --tags=tag1,tag2\n+\nNew nodes, including ones created by resize or recreate, will have these tags\non the Compute Engine API instance object and can be used in firewall rules.\nSee https://cloud.google.com/sdk/gcloud/reference/compute/firewall-rules/create\nfor examples.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--tags',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'TAG'},
                                                                                                                          u'--timeout': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': 1800,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--timeout',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'int',
                                                                                                                                         u'value': u'TIMEOUT'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'create',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'container',
                                                                                                                         u'node-pools',
                                                                                                                         u'create'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the node pool to create.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*create* facilitates the creation of a node pool in a Google\nContainer Engine cluster. A variety of options exists to customize the\nnode configuration and the number of nodes created.\n',
                                                                                                                             u'EXAMPLES': u'To create a new node pool "node-pool-1" with the default options in the\ncluster "sample-cluster", run:\n\n  $ create node-pool-1 --cluster=example-cluster\n\nThe new node pool will show up in the cluster after all the nodes have\nbeen provisioned.\n\nTo create a node pool with 5 nodes, run:\n\n  $ create node-pool-1 --cluster=example-cluster --num-nodes=5\n'}},
                                                                                                   u'delete': {u'capsule': u'*(ALPHA)* Delete an existing node pool in a running cluster.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The cluster from which to delete the node pool. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--cluster',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'CLUSTER'},
                                                                                                                          u'--no-wait': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-wait',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_WAIT'},
                                                                                                                          u'--timeout': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': 1800,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--timeout',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'int',
                                                                                                                                         u'value': u'TIMEOUT'},
                                                                                                                          u'--wait': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'Poll the operation for completion after issuing a delete request. Enabled by default, use *--no-wait* to disable.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--wait',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'WAIT'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'delete',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'container',
                                                                                                                         u'node-pools',
                                                                                                                         u'delete'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the node pool to delete.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*delete* deletes a node pool from a Google Container Engine cluster.\n',
                                                                                                                             u'EXAMPLES': u'To delete the "node-pool-1" node pool from the cluster\n"sample-cluster", run:\n\n  $ delete node-pool-1 --cluster=sample-cluster\n'}},
                                                                                                   u'describe': {u'capsule': u'*(ALPHA)* Describe an existing node pool for a cluster.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The name of the cluster. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--cluster',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'CLUSTER'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'describe',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'container',
                                                                                                                           u'node-pools',
                                                                                                                           u'describe'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the node pool.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* *describe* displays all data associated with the node pool in the\nGoogle Container Engine cluster.'}},
                                                                                                   u'list': {u'capsule': u'*(ALPHA)* List existing node pools for a cluster.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the cluster. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--cluster',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'CLUSTER'},
                                                                                                                        u'--filter': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--limit',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_URI'},
                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--page-size',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'FIELD'},
                                                                                                                        u'--uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'URI'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'list',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'container',
                                                                                                                       u'node-pools',
                                                                                                                       u'list'],
                                                                                                             u'positionals': [],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*list* displays all node pools in the Google Container Engine\ncluster.\n',
                                                                                                                           u'EXAMPLES': u'To list all node pools in the cluster "sample-cluster" in table form,\nrun:\n\n  $ list --cluster=sample-cluster\n'}},
                                                                                                   u'rollback': {u'capsule': u'*(ALPHA)* Rollback a node-pool upgrade.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--async': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u"Don't wait for the operation to complete.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--async',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'ASYNC'},
                                                                                                                            u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The cluster from which to rollback the node pool. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--cluster',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'CLUSTER'},
                                                                                                                            u'--no-async': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-async',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_ASYNC'},
                                                                                                                            u'--no-wait': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-wait',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_WAIT'},
                                                                                                                            u'--timeout': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': 1800,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--timeout',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'int',
                                                                                                                                           u'value': u'TIMEOUT'},
                                                                                                                            u'--wait': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--wait',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'WAIT'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'rollback',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'container',
                                                                                                                           u'node-pools',
                                                                                                                           u'rollback'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the node pool to rollback.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'\n        Rollback a node-pool upgrade.\n\nRollback is a method used after a canceled or failed node-pool upgrade. It\nmakes a best-effort attempt to revert the pool back to its original state.\n'}},
                                                                                                   u'update': {u'capsule': u'*(ALPHA)* Updates a node pool in a running cluster.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The cluster this node pool belongs to. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--cluster',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'CLUSTER'},
                                                                                                                          u'--enable-autorepair': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--enable-autorepair',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'ENABLE_AUTOREPAIR'},
                                                                                                                          u'--enable-autoupgrade': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Sets autoupgrade feature for a node-pool.\n+\n  $ {command} node-pool-1 --cluster=example-cluster --enable-autoupgrade\n+\nSee https://cloud.google.com/container-engine/docs/node-managament for more info.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--enable-autoupgrade',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'ENABLE_AUTOUPGRADE'},
                                                                                                                          u'--no-enable-autorepair': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-enable-autorepair',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_ENABLE_AUTOREPAIR'},
                                                                                                                          u'--no-enable-autoupgrade': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': True,
                                                                                                                                                       u'name': u'--no-enable-autoupgrade',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_ENABLE_AUTOUPGRADE'},
                                                                                                                          u'--timeout': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': 1800,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--timeout',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'int',
                                                                                                                                         u'value': u'TIMEOUT'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'update',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'container',
                                                                                                                         u'node-pools',
                                                                                                                         u'update'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the node pool to update.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*update* updates a node pool in a Google Container Engine cluster.\n',
                                                                                                                             u'EXAMPLES': u'To turn on node auto repair in "node-pool-1" in the cluster\n"sample-cluster", run:\n\n  $ update node-pool-1 --cluster=example-cluster --enable-autoupgrade\n'}}},
                                                                                     u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--zone',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'ZONE'}},
                                                                                     u'group': True,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'node-pools',
                                                                                     u'path': [u'gcloud',
                                                                                               u'alpha',
                                                                                               u'container',
                                                                                               u'node-pools'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'ALPHA',
                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Create and delete operations for Google Container Engine node pools.'}},
                                                                     u'operations': {u'capsule': u'*(ALPHA)* Get and list operations for Google Container Engine clusters.',
                                                                                     u'commands': {u'cancel': {u'capsule': u'*(ALPHA)* Cancel a running operation.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'cancel',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'container',
                                                                                                                         u'operations',
                                                                                                                         u'cancel'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The operation id to cancel.',
                                                                                                                                 u'name': u'operation-id',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'OPERATION_ID'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'\n        Cancel a running operation.\n\nCancel is a best-effort method for aborting a running operation. Operations that\nhave already completed can not be cancelled. If the operation has passed the\n"point of no-return", cancel will have no effect.\n\nAn example of "point of no-return" in the context of Upgrade operations would\nbe if all the nodes have been upgraded but the operation hasn\'t been marked as\ncomplete.\n'}},
                                                                                                   u'describe': {u'capsule': u'*(ALPHA)* Describe an operation.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'describe',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'container',
                                                                                                                           u'operations',
                                                                                                                           u'describe'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The operation id to look up.',
                                                                                                                                   u'name': u'operation-id',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'OPERATION_ID'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Describe an operation.'}},
                                                                                                   u'list': {u'capsule': u'*(ALPHA)* List operations for container clusters.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--limit',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--page-size',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'FIELD'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'list',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'container',
                                                                                                                       u'operations',
                                                                                                                       u'list'],
                                                                                                             u'positionals': [],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* List operations for container clusters.'}},
                                                                                                   u'wait': {u'capsule': u'*(ALPHA)* Poll an operation for completion.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'wait',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'container',
                                                                                                                       u'operations',
                                                                                                                       u'wait'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The operation id to poll.',
                                                                                                                               u'name': u'operation-id',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'OPERATION_ID'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Poll an operation for completion.'}}},
                                                                                     u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--zone',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'ZONE'}},
                                                                                     u'group': True,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'operations',
                                                                                     u'path': [u'gcloud',
                                                                                               u'alpha',
                                                                                               u'container',
                                                                                               u'operations'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'ALPHA',
                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Get and list operations for Google Container Engine clusters.'}}},
                                                       u'flags': {u'--api-version': {u'attr': {u'property': {u'name': u'api_client_overrides/container'}},
                                                                                     u'category': u'',
                                                                                     u'choices': [],
                                                                                     u'completer': u'',
                                                                                     u'default': None,
                                                                                     u'description': u'',
                                                                                     u'group': u'',
                                                                                     u'hidden': True,
                                                                                     u'name': u'--api-version',
                                                                                     u'nargs': u'0',
                                                                                     u'required': False,
                                                                                     u'type': u'string',
                                                                                     u'value': u'API_VERSION'}},
                                                       u'group': True,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'container',
                                                       u'path': [u'gcloud',
                                                                 u'alpha',
                                                                 u'container'],
                                                       u'positionals': [],
                                                       u'release': u'ALPHA',
                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deploy and manage clusters of machines for running containers.'}},
                                        u'dataflow': {u'capsule': u'*(ALPHA)* Read and manipulate Google Dataflow resources.',
                                                      u'commands': {u'jobs': {u'capsule': u'*(ALPHA)* A group of subcommands for working with Dataflow jobs.',
                                                                              u'commands': {u'export-steps': {u'capsule': u'*(ALPHA)* Exports information about the steps for the given job.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'export-steps',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'dataflow',
                                                                                                                        u'jobs',
                                                                                                                        u'export-steps'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The job ID to operate on.',
                                                                                                                                u'name': u'job',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'JOB_ID'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* The only currently supported format is to a GraphViz dot file.'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'jobs',
                                                                              u'path': [u'gcloud',
                                                                                        u'alpha',
                                                                                        u'dataflow',
                                                                                        u'jobs'],
                                                                              u'positionals': [],
                                                                              u'release': u'ALPHA',
                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* A group of subcommands for working with Dataflow jobs.'}},
                                                                    u'logs': {u'capsule': u'*(ALPHA)* A group of subcommands for working with Dataflow logs.',
                                                                              u'commands': {u'list': {u'capsule': u'*(ALPHA)* Retrieve the job logs for a specific job.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--after': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Only display messages logged after the given time. Time format is yyyy-mm-dd hh-mm-ss',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--after',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'AFTER'},
                                                                                                                 u'--before': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Only display messages logged before the given time. Time format is yyyy-mm-dd hh-mm-ss',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--before',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'BEFORE'},
                                                                                                                 u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--importance': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [u'debug',
                                                                                                                                                u'detailed',
                                                                                                                                                u'warning',
                                                                                                                                                u'error'],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': u'warning',
                                                                                                                                   u'description': u'Minimum importance a message must have to be displayed. _IMPORTANCE_ must be one of: *debug*, *detailed*, *warning*, *error*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--importance',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'IMPORTANCE'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'dataflow',
                                                                                                                u'logs',
                                                                                                                u'list'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The job ID to operate on.',
                                                                                                                        u'name': u'job',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'JOB_ID'}],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Retrieves the job logs from a specified job using the Dataflow Messages API\nwith at least the specified importance level. Can also be used to display\nlogs between a given time period using the --before and --after flags. These\nlogs are produced by the service and are distinct from worker logs. Worker\nlogs can be found in Cloud Logging.\n\n## EXAMPLES\n\nRetrieve only error logs:\n\n  $ list --importance=error\n\nRetrieve all logs after some date:\n\n  $ list --after="2016-08-12 00:00:00"'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'logs',
                                                                              u'path': [u'gcloud',
                                                                                        u'alpha',
                                                                                        u'dataflow',
                                                                                        u'logs'],
                                                                              u'positionals': [],
                                                                              u'release': u'ALPHA',
                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* A group of subcommands for working with Dataflow logs.'}},
                                                                    u'metrics': {u'capsule': u'*(ALPHA)* A group of subcommands for working with Dataflow metrics.',
                                                                                 u'commands': {u'list': {u'capsule': u'*(ALPHA)* Retrieves the metrics from a specific job.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--changed-after': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Only display metrics that have changed after the given time',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--changed-after',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'CHANGED_AFTER'},
                                                                                                                    u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--hide-committed': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'If true, hide committed values.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--hide-committed',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'HIDE_COMMITTED'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-hide-committed': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-hide-committed',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_HIDE_COMMITTED'},
                                                                                                                    u'--no-tentative': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-tentative',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_TENTATIVE'},
                                                                                                                    u'--source': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [u'all',
                                                                                                                                               u'service',
                                                                                                                                               u'user'],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': u'all',
                                                                                                                                  u'description': u'Set the metrics source. _SOURCE_ must be one of:\n+\n*all*::: Retrieves all metrics.\n*service*::: Retrieves only dataflow service metrics.\n*user*::: Retrieves only custom user metrics.\n+',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--source',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'SOURCE'},
                                                                                                                    u'--tentative': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'If true, display tentative values.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--tentative',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'TENTATIVE'},
                                                                                                                    u'--transform': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Filters only the metrics that prefix match the given regex.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--transform',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'TRANSFORM'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'dataflow',
                                                                                                                   u'metrics',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The job ID to operate on.',
                                                                                                                           u'name': u'job',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'JOB_ID'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command can be used to explore the job\'s metrics at a fine-grained level.\n\n## EXAMPLES\n\nFilter metrics with the given name:\n\n  $ list --filter="name=ElementCount"\n\nFilter child metrics with matching transforms:\n\n  $ list --transform=WordCount\n\nFilter child output metrics:\n\n  $ list --transform=WordCount/Write.*out\n\nFilter all output metrics:\n\n  $ list --transform=.*out\n\nFilter all custom-defined user metrics\n\n  $ list --source=user\n\nFilter metrics with a scalar value greater than a threshold.\n\n  $ list --filter="scalar > 50"'}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'metrics',
                                                                                 u'path': [u'gcloud',
                                                                                           u'alpha',
                                                                                           u'dataflow',
                                                                                           u'metrics'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'ALPHA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* A group of subcommands for working with Dataflow metrics.'}}},
                                                      u'flags': {},
                                                      u'group': True,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'dataflow',
                                                      u'path': [u'gcloud',
                                                                u'alpha',
                                                                u'dataflow'],
                                                      u'positionals': [],
                                                      u'release': u'ALPHA',
                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Read and manipulate Google Dataflow resources.'}},
                                        u'deployment-manager': {u'capsule': u'*(ALPHA)* Manage deployments of cloud resources.',
                                                                u'commands': {u'deployments': {u'capsule': u'*(ALPHA)* Commands for Deployment Manager deployments.',
                                                                                               u'commands': {u'cancel-preview': {u'capsule': u'*(ALPHA)* Cancel a pending or running deployment preview.',
                                                                                                                                 u'commands': {},
                                                                                                                                 u'flags': {u'--async': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': False,
                                                                                                                                                         u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--async',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'ASYNC'},
                                                                                                                                            u'--fingerprint': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The fingerprint to use in requests to modify a deployment. If not specified, a get deployment request will be made to fetch the latest fingerprint. A fingerprint is a randomly generated value that is part of the update, stop, and cancel-preview request to perform optimistic locking. It is initially generated by Deployment Manager and changes after every request to modify data. The latest fingerprint is printed when deployment data is modified.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--fingerprint',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'FINGERPRINT'},
                                                                                                                                            u'--no-async': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': False,
                                                                                                                                                            u'description': u'',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': True,
                                                                                                                                                            u'name': u'--no-async',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'NO_ASYNC'}},
                                                                                                                                 u'group': False,
                                                                                                                                 u'groups': {},
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'cancel-preview',
                                                                                                                                 u'path': [u'gcloud',
                                                                                                                                           u'alpha',
                                                                                                                                           u'deployment-manager',
                                                                                                                                           u'deployments',
                                                                                                                                           u'cancel-preview'],
                                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Deployment name.',
                                                                                                                                                   u'name': u'deployment-name',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                                 u'release': u'ALPHA',
                                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command will cancel a currently running or pending preview operation on\na deployment.',
                                                                                                                                               u'EXAMPLES': u'To cancel a running operation on a deployment, run:\n\n  $ cancel-preview my-deployment\n\nTo issue a cancel preview command without waiting for the operation to complete, run:\n\n  $ cancel-preview my-deployment --async\n\nTo cancel a preview command providing a fingerprint:\n\n  $ cancel-preview my-deployment --fingerprint deployment-fingerprint\n'}},
                                                                                                             u'create': {u'capsule': u'*(ALPHA)* Create a deployment.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--async',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'ASYNC'},
                                                                                                                                    u'--config': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Filename of config which specifies resources to deploy.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--config',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': True,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'CONFIG'},
                                                                                                                                    u'--description': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Optional description of the deployment to insert.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--description',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                                    u'--labels': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--labels',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'dict',
                                                                                                                                                  u'value': u'KEY=VALUE'},
                                                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-async',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_ASYNC'},
                                                                                                                                    u'--no-preview': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-preview',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_PREVIEW'},
                                                                                                                                    u'--preview': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Preview the requested create without actually instantiating the underlying resources. (default=False)',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--preview',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'PREVIEW'},
                                                                                                                                    u'--properties': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'A comma seperated, key=value, map to be used when deploying a template file directly.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--properties',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'dict',
                                                                                                                                                      u'value': u'PROPERTIES'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'create',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'alpha',
                                                                                                                                   u'deployment-manager',
                                                                                                                                   u'deployments',
                                                                                                                                   u'create'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Deployment name.',
                                                                                                                                           u'name': u'deployment-name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                         u'release': u'ALPHA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command inserts (creates) a new deployment based on a provided config\nfile.',
                                                                                                                                       u'EXAMPLES': u'To create a new deployment, run:\n\n  $ create my-deployment --config config.yaml --description "My deployment"\n\nTo preview a deployment without actually creating resources, run:\n\n  $ create my-new-deployment --config config.yaml --preview\n\nTo instantiate a deployment that has been previewed, issue an update command for that deployment without specifying a config file.\n'}},
                                                                                                             u'delete': {u'capsule': u'*(ALPHA)* Delete a deployment.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--async',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'ASYNC'},
                                                                                                                                    u'--delete-policy': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [u'ABANDON',
                                                                                                                                                                      u'DELETE'],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': u'DELETE',
                                                                                                                                                         u'description': u'Delete policy for resources that will change as part of an update or delete. DELETE deletes the resource while ABANDON just removes the resource reference from the deployment. _DELETE_POLICY_ must be one of: *ABANDON*, *DELETE*.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--delete-policy',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'DELETE_POLICY'},
                                                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-async',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_ASYNC'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'delete',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'alpha',
                                                                                                                                   u'deployment-manager',
                                                                                                                                   u'deployments',
                                                                                                                                   u'delete'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Deployment name.',
                                                                                                                                           u'name': u'deployment-name',
                                                                                                                                           u'nargs': u'+',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                         u'release': u'ALPHA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command deletes a deployment and deletes all associated resources.',
                                                                                                                                       u'EXAMPLES': u'To delete a deployment, run:\n\n  $ delete my-deployment\n\nTo issue a delete command without waiting for the operation to complete, run:\n\n  $ delete my-deployment --async\n\nTo delete several deployments, run:\n\n  $ delete my-deployment-one my-deployment-two my-deployment-three\n\nTo disable the confirmation prompt on delete, run:\n\n  $ delete my-deployment -q\n'}},
                                                                                                             u'describe': {u'capsule': u'*(ALPHA)* Provide information about a deployment.',
                                                                                                                           u'commands': {},
                                                                                                                           u'flags': {},
                                                                                                                           u'group': False,
                                                                                                                           u'groups': {},
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'describe',
                                                                                                                           u'path': [u'gcloud',
                                                                                                                                     u'alpha',
                                                                                                                                     u'deployment-manager',
                                                                                                                                     u'deployments',
                                                                                                                                     u'describe'],
                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Deployment name.',
                                                                                                                                             u'name': u'deployment-name',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                           u'release': u'ALPHA',
                                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command prints out all available details about a deployment.',
                                                                                                                                         u'EXAMPLES': u'To display information about a deployment, run:\n\n  $ describe my-deployment\n'}},
                                                                                                             u'list': {u'capsule': u'*(ALPHA)* List deployments in a project.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--filter',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--limit',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'LIMIT'},
                                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-uri',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_URI'},
                                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--page-size',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                                  u'--simple-list': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--simple-list',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'SIMPLE_LIST'},
                                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'list',
                                                                                                                                                 u'value': u'FIELD'},
                                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'URI'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'list',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'deployment-manager',
                                                                                                                                 u'deployments',
                                                                                                                                 u'list'],
                                                                                                                       u'positionals': [],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on all deployments in the project.',
                                                                                                                                     u'EXAMPLES': u'To print out a list of deployments with some summary information about each, run:\n\n  $ list\n\nTo print only the name of each deployment, run:\n\n  $ list --simple-list\n'}},
                                                                                                             u'stop': {u'capsule': u'*(ALPHA)* Stop a pending or running deployment update or creation.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--async': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--async',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'ASYNC'},
                                                                                                                                  u'--fingerprint': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The fingerprint to use in requests to modify a deployment. If not specified, a get deployment request will be made to fetch the latest fingerprint. A fingerprint is a randomly generated value that is part of the update, stop, and cancel-preview request to perform optimistic locking. It is initially generated by Deployment Manager and changes after every request to modify data. The latest fingerprint is printed when deployment data is modified.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--fingerprint',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'FINGERPRINT'},
                                                                                                                                  u'--no-async': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--no-async',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_ASYNC'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'stop',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'deployment-manager',
                                                                                                                                 u'deployments',
                                                                                                                                 u'stop'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Deployment name.',
                                                                                                                                         u'name': u'deployment-name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command will stop a currently running or pending operation on\na deployment.',
                                                                                                                                     u'EXAMPLES': u'To stop a running operation on a deployment, run:\n\n  $ stop my-deployment\n\nTo issue a stop command without waiting for the operation to complete, run:\n\n  $ stop my-deployment --async\n\nTo stop a running operation on a deployment providing a fingerprint, run:\n\n  $ stop my-deployment --fingerprint deployment-fingerprint\n'}},
                                                                                                             u'update': {u'capsule': u'*(ALPHA)* Update a deployment based on a provided config file.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--async',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'ASYNC'},
                                                                                                                                    u'--config': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Filename of config which specifies resources to deploy. Required unless launching an already-previewed update to this deployment.',
                                                                                                                                                  u'group': u'update.1',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--config',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'CONFIG'},
                                                                                                                                    u'--create-policy': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [u'ACQUIRE',
                                                                                                                                                                      u'CREATE_OR_ACQUIRE'],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': u'CREATE_OR_ACQUIRE',
                                                                                                                                                         u'description': u'Create policy for resources that have changed in the update. _CREATE_POLICY_ must be one of: *ACQUIRE*, *CREATE_OR_ACQUIRE*.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--create-policy',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'CREATE_POLICY'},
                                                                                                                                    u'--delete-policy': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [u'ABANDON',
                                                                                                                                                                      u'DELETE'],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': u'DELETE',
                                                                                                                                                         u'description': u'Delete policy for resources that will change as part of an update or delete. DELETE deletes the resource while ABANDON just removes the resource reference from the deployment. _DELETE_POLICY_ must be one of: *ABANDON*, *DELETE*.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--delete-policy',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'DELETE_POLICY'},
                                                                                                                                    u'--description': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The new description of the deployment.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--description',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                                    u'--fingerprint': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The fingerprint to use in requests to modify a deployment. If not specified, a get deployment request will be made to fetch the latest fingerprint. A fingerprint is a randomly generated value that is part of the update, stop, and cancel-preview request to perform optimistic locking. It is initially generated by Deployment Manager and changes after every request to modify data. The latest fingerprint is printed when deployment data is modified.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--fingerprint',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'FINGERPRINT'},
                                                                                                                                    u'--manifest-id': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Manifest Id of a previous deployment. This flag cannot be used with --config.',
                                                                                                                                                       u'group': u'update.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--manifest-id',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'MANIFEST_ID'},
                                                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-async',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_ASYNC'},
                                                                                                                                    u'--no-preview': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-preview',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_PREVIEW'},
                                                                                                                                    u'--preview': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Preview the requested update without making any changes to theunderlying resources. (default=False)',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--preview',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'PREVIEW'},
                                                                                                                                    u'--properties': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'A comma seperated, key=value, map to be used when deploying a template file directly.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--properties',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'dict',
                                                                                                                                                      u'value': u'PROPERTIES'},
                                                                                                                                    u'--remove-labels': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'A list of label keys to remove. If a label does not exist it is\nsilently ignored.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--remove-labels',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'KEY'},
                                                                                                                                    u'--update-labels': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'A list of label KEY=VALUE pairs to update. If a label exists its value\nis modified, otherwise a new label is created.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--update-labels',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'dict',
                                                                                                                                                         u'value': u'KEY=VALUE'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {u'update.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                   u'is_mutex': True,
                                                                                                                                                   u'is_required': False}},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'update',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'alpha',
                                                                                                                                   u'deployment-manager',
                                                                                                                                   u'deployments',
                                                                                                                                   u'update'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Deployment name.',
                                                                                                                                           u'name': u'deployment-name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                         u'release': u'ALPHA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command will update a deployment with the new config file provided.\nDifferent policies for create, update, and delete policies can be specified.',
                                                                                                                                       u'EXAMPLES': u'To update an existing deployment with a new config file, run:\n\n  $ update my-deployment --config new_config.yaml\n\nTo preview an update to an existing deployment without actually modifying the resources, run:\n\n  $ update my-deployment --config new_config.yaml --preview\n\nTo apply an update that has been previewed, provide the name of the previewed deployment, and no config file:\n\n  $ update my-deployment\n\nTo specify different create, update, or delete policies, include any subset of the following flags;\n\n  $ update my-deployment --config new_config.yaml --create-policy ACQUIRE --delete-policy ABANDON\n\nTo perform an update without waiting for the operation to complete, run:\n\n  $ update my-deployment --config new_config.yaml --async\n\nTo update an existing deployment with a new config file and a fingerprint, run:\n\n  $ update my-deployment --config new_config.yaml --fingerprint deployment-fingerprint\n'}}},
                                                                                               u'flags': {},
                                                                                               u'group': True,
                                                                                               u'groups': {},
                                                                                               u'hidden': False,
                                                                                               u'name': u'deployments',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'alpha',
                                                                                                         u'deployment-manager',
                                                                                                         u'deployments'],
                                                                                               u'positionals': [],
                                                                                               u'release': u'ALPHA',
                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to create, update, delete, and examine deployments of resources.',
                                                                                                             u'EXAMPLES': u'To create a deployment, run:\n\n  $ deployments create my-deployment --config config.yaml\n\nTo update a deployment, run:\n\n  $ deployments update my-deployment --config new_config.yaml\n\nTo stop a deployment create or update in progress, run:\n\n  $ deployments stop my-deployment\n\nTo cancel a previewed create or update, run:\n\n  $ deployments cancel-preview my-deployment\n\nTo delete a deployment, run:\n\n  $ deployments delete my-deployment\n\nTo view the details of a deployment, run:\n\n  $ deployments describe my-deployment\n\nTo see the list of all deployments, run:\n\n  $ deployments list\n'}},
                                                                              u'manifests': {u'capsule': u'*(ALPHA)* Commands for Deployment Manager manifests.',
                                                                                             u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Provide information about a manifest.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--deployment': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Deployment name.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--deployment',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': True,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'DEPLOYMENT'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'describe',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'alpha',
                                                                                                                                   u'deployment-manager',
                                                                                                                                   u'manifests',
                                                                                                                                   u'describe'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Manifest name.',
                                                                                                                                           u'name': u'manifest',
                                                                                                                                           u'nargs': u'?',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'MANIFEST'}],
                                                                                                                         u'release': u'ALPHA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command prints out all available details about a manifest.',
                                                                                                                                       u'EXAMPLES': u'To display information about a manifest, run:\n\n  $ describe --deployment my-deployment manifest-name\n\nTo display information about the latest manifest, run:\n\n  $ describe --deployment my-deployment\n'}},
                                                                                                           u'list': {u'capsule': u'*(ALPHA)* List manifests in a deployment.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--deployment': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Deployment name.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--deployment',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': True,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'DEPLOYMENT'},
                                                                                                                                u'--filter': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--filter',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                                u'--limit': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--limit',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'LIMIT'},
                                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': True,
                                                                                                                                              u'description': u'',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': True,
                                                                                                                                              u'name': u'--no-uri',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'NO_URI'},
                                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--page-size',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                                u'--simple-list': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--simple-list',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'SIMPLE_LIST'},
                                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--sort-by',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'FIELD'},
                                                                                                                                u'--uri': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--uri',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'URI'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'list',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'deployment-manager',
                                                                                                                               u'manifests',
                                                                                                                               u'list'],
                                                                                                                     u'positionals': [],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on all manifests in the deployment.',
                                                                                                                                   u'EXAMPLES': u'To print out a list of manifests in a deployment, run:\n\n  $ list --deployment my-deployment\n\nTo print only the name of each manifest, run:\n\n  $ list --deployment my-deployment --simple-list\n'}}},
                                                                                             u'flags': {},
                                                                                             u'group': True,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'manifests',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'alpha',
                                                                                                       u'deployment-manager',
                                                                                                       u'manifests'],
                                                                                             u'positionals': [],
                                                                                             u'release': u'ALPHA',
                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to list and examine manifests within a deployment.',
                                                                                                           u'EXAMPLES': u'To view all details about a manifest, run:\n\n  $ manifests describe manifest-name --deployment my-deployment\n\nTo see the list of all manifests in a deployment, run:\n\n  $ manifests list --deployment my-deployment\n'}},
                                                                              u'operations': {u'capsule': u'*(ALPHA)* Commands for Deployment Manager operations.',
                                                                                              u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Provide information about an operation.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'describe',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'alpha',
                                                                                                                                    u'deployment-manager',
                                                                                                                                    u'operations',
                                                                                                                                    u'describe'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Operation name.',
                                                                                                                                            u'name': u'operation-name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'OPERATION_NAME'}],
                                                                                                                          u'release': u'ALPHA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command prints out all available details about an operation.',
                                                                                                                                        u'EXAMPLES': u'To display information about an operation, run:\n\n  $ describe operation-name\n'}},
                                                                                                            u'list': {u'capsule': u'*(ALPHA)* List operations in a project.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--filter',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--limit',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'LIMIT'},
                                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': True,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-uri',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_URI'},
                                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--page-size',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                                 u'--simple-list': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--simple-list',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'SIMPLE_LIST'},
                                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--sort-by',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'list',
                                                                                                                                                u'value': u'FIELD'},
                                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'URI'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'list',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'deployment-manager',
                                                                                                                                u'operations',
                                                                                                                                u'list'],
                                                                                                                      u'positionals': [],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on all operations in the project.',
                                                                                                                                    u'EXAMPLES': u'To print out a list of operations with some summary information about each, run:\n\n  $ list\n\nTo print only the name of each operation, run:\n\n  $ list --simple-list\n'}},
                                                                                                            u'wait': {u'capsule': u'*(ALPHA)* Wait for all operations specified to complete before returning.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'wait',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'deployment-manager',
                                                                                                                                u'operations',
                                                                                                                                u'wait'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Operation name.',
                                                                                                                                        u'name': u'operation-name',
                                                                                                                                        u'nargs': u'+',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'OPERATION_NAME'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Polls until all operations have finished, then prints the resulting operations\nalong with any operation errors.',
                                                                                                                                    u'EXAMPLES': u'To poll until an operation has completed, run:\n\n  $ wait operation-name\n\nTo poll until several operations have all completed, run:\n\n  $ wait operation-one operation-two operation-three\n'}}},
                                                                                              u'flags': {},
                                                                                              u'group': True,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'operations',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'alpha',
                                                                                                        u'deployment-manager',
                                                                                                        u'operations'],
                                                                                              u'positionals': [],
                                                                                              u'release': u'ALPHA',
                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to list, examine, and wait for long-running operations.',
                                                                                                            u'EXAMPLES': u'To view the details of an operation, run:\n\n  $ operations describe operation-name\n\nTo see the list of all operations, run:\n\n  $ operations list\n\nTo wait for an operation to complete, run:\n\n  $ operations wait operation-name\n'}},
                                                                              u'resources': {u'capsule': u'*(ALPHA)* Commands for Deployment Manager resources.',
                                                                                             u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Provide information about a resource.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'describe',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'alpha',
                                                                                                                                   u'deployment-manager',
                                                                                                                                   u'resources',
                                                                                                                                   u'describe'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Resource name.',
                                                                                                                                           u'name': u'resource',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'RESOURCE'}],
                                                                                                                         u'release': u'ALPHA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command prints out all available details about a resource.',
                                                                                                                                       u'EXAMPLES': u'To display information about a resource, run:\n\n  $ describe --deployment my-deployment my-resource-name\n'}},
                                                                                                           u'list': {u'capsule': u'*(ALPHA)* List resources in a deployment.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--filter',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                                u'--limit': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--limit',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'LIMIT'},
                                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': True,
                                                                                                                                              u'description': u'',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': True,
                                                                                                                                              u'name': u'--no-uri',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'NO_URI'},
                                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--page-size',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                                u'--simple-list': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--simple-list',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'SIMPLE_LIST'},
                                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--sort-by',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'FIELD'},
                                                                                                                                u'--uri': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--uri',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'URI'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'list',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'deployment-manager',
                                                                                                                               u'resources',
                                                                                                                               u'list'],
                                                                                                                     u'positionals': [],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on all resources in the deployment.',
                                                                                                                                   u'EXAMPLES': u'To print out a list of resources in the deployment with some summary information about each, run:\n\n  $ list --deployment my-deployment\n\nTo print only the name of each resource, run:\n\n  $ list --deployment my-deployment --simple-list\n'}}},
                                                                                             u'flags': {u'--deployment': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Deployment name',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--deployment',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'DEPLOYMENT'}},
                                                                                             u'group': True,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'resources',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'alpha',
                                                                                                       u'deployment-manager',
                                                                                                       u'resources'],
                                                                                             u'positionals': [],
                                                                                             u'release': u'ALPHA',
                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to list and examine resources within a deployment.',
                                                                                                           u'EXAMPLES': u'To view all details about a resource, run:\n\n  $ resources describe my-resource --deployment my-deployment\n\nTo see the list of all resources in a deployment, run:\n\n  $ resources list --deployment my-deployment\n'}},
                                                                              u'types': {u'capsule': u'*(ALPHA)* Commands for Deployment Manager types.',
                                                                                         u'commands': {u'list': {u'capsule': u'*(ALPHA)* Describe a type provider type.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--filter',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                                            u'--limit': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--limit',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'LIMIT'},
                                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_URI'},
                                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--page-size',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                                            u'--provider': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Type provider name.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--provider',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PROVIDER'},
                                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--sort-by',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'FIELD'},
                                                                                                                            u'--uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'URI'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'list',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'deployment-manager',
                                                                                                                           u'types',
                                                                                                                           u'list'],
                                                                                                                 u'positionals': [],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Describe a type provider type.',
                                                                                                                               u'EXAMPLES': u'To print out a list of all available type names, run:\n\n  $ list\n\nIf you only want the types for a specific provider, you can specify\nwhich one using --provider\n\n  $ list --provider=PROVIDER\n'}}},
                                                                                         u'flags': {},
                                                                                         u'group': True,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'types',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'alpha',
                                                                                                   u'deployment-manager',
                                                                                                   u'types'],
                                                                                         u'positionals': [],
                                                                                         u'release': u'ALPHA',
                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to show available resource types.',
                                                                                                       u'EXAMPLES': u'To see the list of all available resource types, run:\n\n  $ types list\n'}}},
                                                                u'flags': {},
                                                                u'group': True,
                                                                u'groups': {},
                                                                u'hidden': False,
                                                                u'name': u'deployment-manager',
                                                                u'path': [u'gcloud',
                                                                          u'alpha',
                                                                          u'deployment-manager'],
                                                                u'positionals': [],
                                                                u'release': u'ALPHA',
                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* The deployment-manager command group lets you manage the deployment of Google Cloud\nPlatform resources using Google Cloud Deployment Manager.\n\nGoogle Cloud Deployment Manager allows you to specify all the resources needed\nfor your application in a declarative format using YAML. You can also use\nPython or Jinja2 templates to parameterize the configuration and allow reuse\nof common deployment paradigms such as a load balanced, auto-scaled instance\ngroup.\n\nMore information on Cloud Deployment Manager can be found here:\nhttps://cloud.google.com/deployment-manager and detailed documentation can be\nfound here: https://cloud.google.com/deployment-manager/docs/'}},
                                        u'functions': {u'capsule': u'*(ALPHA)* Manages Google Cloud Functions.',
                                                       u'commands': {u'call': {u'capsule': u'*(ALPHA)* Call function synchronously for testing.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--data': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': u'',
                                                                                                      u'description': u'Data passed to the function (JSON string)',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--data',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'DATA'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'call',
                                                                               u'path': [u'gcloud',
                                                                                         u'alpha',
                                                                                         u'functions',
                                                                                         u'call'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Name of the function to be called.',
                                                                                                 u'name': u'name',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'NAME'}],
                                                                               u'release': u'ALPHA',
                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Call function synchronously for testing.'}},
                                                                     u'delete': {u'capsule': u'*(ALPHA)* Deletes a given function.',
                                                                                 u'commands': {},
                                                                                 u'flags': {},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'delete',
                                                                                 u'path': [u'gcloud',
                                                                                           u'alpha',
                                                                                           u'functions',
                                                                                           u'delete'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The name of the function to delete.',
                                                                                                   u'name': u'name',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'NAME'}],
                                                                                 u'release': u'ALPHA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes a given function.'}},
                                                                     u'deploy': {u'capsule': u'*(ALPHA)* Creates a new function or updates an existing one.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--entry-point': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'By default when a Google Cloud Function is triggered, it executes a\nJavaScript function with the same name. Or, if it cannot find a\nfunction with the same name, it executes a function named `function`.\nYou can use this flag to override the default behavior, by specifying\nthe name of a JavaScript function that will be executed when the\nGoogle Cloud Function is triggered.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--entry-point',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'ENTRY_POINT'},
                                                                                            u'--include-node-modules': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'Include the content of node_modules with deployed sources. This flag has an effect only if a function is deployed from a local directory.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--include-node-modules',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'INCLUDE_NODE_MODULES'},
                                                                                            u'--local-path': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Path to local directory with source code. Required with --stage-bucket flag.',
                                                                                                              u'group': u'deploy.1',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--local-path',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'LOCAL_PATH'},
                                                                                            u'--memory': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The amount of memory allocated to your function.\n+\nAllowed values are: 128MB, 256MB, 512MB, 1024MB, and 2048MB.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--memory',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'MEMORY'},
                                                                                            u'--no-include-node-modules': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-include-node-modules',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_INCLUDE_NODE_MODULES'},
                                                                                            u'--source-branch': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The branch that will be used to get the source code of the function.  The most recent revision on this branch will be used. Can be specified only together with --source-url parameter. If not specified defaults to `master`.',
                                                                                                                 u'group': u'deploy.2',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--source-branch',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'SOURCE_BRANCH'},
                                                                                            u'--source-path': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Path to directory with source code in Cloud Source Repositories, when you specify this parameter --source-url flag is required.',
                                                                                                               u'group': u'deploy.1',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--source-path',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'SOURCE_PATH'},
                                                                                            u'--source-revision': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The revision ID (for instance, git commit hash) that will be used to get the source code of the function. Can be specified only together with --source-url parameter.',
                                                                                                                   u'group': u'deploy.2',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--source-revision',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'SOURCE_REVISION'},
                                                                                            u'--source-tag': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The revision tag for the source that will be used as the source\ncode of the function. Can be specified only together with\n--source-url parameter.',
                                                                                                              u'group': u'deploy.2',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--source-tag',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'SOURCE_TAG'},
                                                                                            u'--source-url': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The Url of a remote repository that holds the function being deployed. It is of the form: https://source.developers.google.com/p/{project_id}/r/{repo_name}/, where you should substitute your data for values inside the curly brackets. You can omit "r/{repo_name}/" in which case the "default" repository is taken. One of the parameters --source-revision, --source-branch, or --source-tag can be given to specify the version in the repository. If none of them are provided, the last revision from the master branch is used. If this parameter is given, the parameter --source is required and describes the path inside the repository.',
                                                                                                              u'group': u'deploy.3',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--source-url',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'SOURCE_URL'},
                                                                                            u'--stage-bucket': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Name of Google Cloud Storage bucket in which source code will be stored. Required if a function is deployed from a local directory.',
                                                                                                                u'group': u'deploy.3',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--stage-bucket',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'STAGE_BUCKET'},
                                                                                            u'--timeout': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The function execution timeout, e.g. 30s for 30 seconds. Defaults to 60 seconds.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--timeout',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'TIMEOUT'},
                                                                                            u'--trigger-bucket': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Google Cloud Storage bucket name. Every change in files in this bucket will trigger function execution.',
                                                                                                                  u'group': u'deploy.4',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--trigger-bucket',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'TRIGGER_BUCKET'},
                                                                                            u'--trigger-event': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [u'topic.publish',
                                                                                                                              u'object.change',
                                                                                                                              u'user.create',
                                                                                                                              u'user.delete',
                                                                                                                              u'data.write'],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': True,
                                                                                                                 u'name': u'--trigger-event',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'EVENT_TYPE'},
                                                                                            u'--trigger-http': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'Function will be assigned an endpoint, which you can view by using\nthe `describe` command. Any HTTP request (of a supported type) to the\nendpoint will trigger function execution. Supported HTTP request\ntypes are: POST, PUT, GET, DELETE, and OPTIONS.',
                                                                                                                u'group': u'deploy.4',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--trigger-http',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'TRIGGER_HTTP'},
                                                                                            u'--trigger-provider': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [u'cloud.pubsub',
                                                                                                                                 u'cloud.storage',
                                                                                                                                 u'firebase.auth',
                                                                                                                                 u'firebase.database'],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'deploy.4',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--trigger-provider',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'PROVIDER'},
                                                                                            u'--trigger-resource': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--trigger-resource',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'RESOURCE'},
                                                                                            u'--trigger-topic': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Name of Pub/Sub topic. Every message published in this topic will trigger function execution with message contents passed as input data.',
                                                                                                                 u'group': u'deploy.4',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--trigger-topic',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'TRIGGER_TOPIC'}},
                                                                                 u'group': False,
                                                                                 u'groups': {u'deploy.1': {u'description': u'At most one of these may be specified:',
                                                                                                           u'is_mutex': True,
                                                                                                           u'is_required': False},
                                                                                             u'deploy.2': {u'description': u'At most one of these may be specified:',
                                                                                                           u'is_mutex': True,
                                                                                                           u'is_required': False},
                                                                                             u'deploy.3': {u'description': u'At most one of these may be specified:',
                                                                                                           u'is_mutex': True,
                                                                                                           u'is_required': False},
                                                                                             u'deploy.4': {u'description': u'Exactly one of these must be specified:',
                                                                                                           u'is_mutex': True,
                                                                                                           u'is_required': True}},
                                                                                 u'hidden': False,
                                                                                 u'name': u'deploy',
                                                                                 u'path': [u'gcloud',
                                                                                           u'alpha',
                                                                                           u'functions',
                                                                                           u'deploy'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'Intended name of the new function.',
                                                                                                   u'name': u'name',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'NAME'}],
                                                                                 u'release': u'ALPHA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Creates a new function or updates an existing one.'}},
                                                                     u'describe': {u'capsule': u'*(ALPHA)* Show description of a function.',
                                                                                   u'commands': {},
                                                                                   u'flags': {},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'describe',
                                                                                   u'path': [u'gcloud',
                                                                                             u'alpha',
                                                                                             u'functions',
                                                                                             u'describe'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The name of the function to describe.',
                                                                                                     u'name': u'name',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'ALPHA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Show description of a function.'}},
                                                                     u'event-types': {u'capsule': u'*(ALPHA)* Provides information about Google Cloud Functions Event Types.',
                                                                                      u'commands': {u'list': {u'capsule': u'*(ALPHA)* Describes the allowed values and meanings of --trigger-* flags.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'list',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'functions',
                                                                                                                        u'event-types',
                                                                                                                        u'list'],
                                                                                                              u'positionals': [],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints the table with list of all ways to deploy an event trigger. When using\n`gcloud functions deploy` Event Providers are specified as\n--trigger-provider and Event Types are specified as --trigger-event.\nThe table includes the type of resource expected in --trigger-resource.\n\n* For an event type, EVENT_TYPE_DEFAULT marks whether the given event type is\n  the default for its provider (in which case the --event-type flag may be\n  omitted).\n* For a resource, RESOURCE_OPTIONAL marks whether the resource has a\n  corresponding default value (in which case the --trigger-resource flag\n  may be omitted).'}}},
                                                                                      u'flags': {},
                                                                                      u'group': True,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'event-types',
                                                                                      u'path': [u'gcloud',
                                                                                                u'alpha',
                                                                                                u'functions',
                                                                                                u'event-types'],
                                                                                      u'positionals': [],
                                                                                      u'release': u'ALPHA',
                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Provides information about Google Cloud Functions Event Types.'}},
                                                                     u'get-logs': {u'capsule': u'*(ALPHA)* Show logs produced by functions.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--end-time': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Return only log entries which timestamps are not later than the specified time. The timestamp must be in RFC3339 UTC "Zulu" format. If --end-time is specified but --start-time is not, the command returns --limit latest log entries which appeared before --end-time.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--end-time',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'END_TIME'},
                                                                                              u'--execution-id': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Execution ID for which logs are to be displayed.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--execution-id',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'EXECUTION_ID'},
                                                                                              u'--filter': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--filter',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'EXPRESSION'},
                                                                                              u'--limit': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': 20,
                                                                                                           u'description': u'Number of log entries to be fetched; must not be greater than 1000.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--limit',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'int',
                                                                                                           u'value': u'LIMIT'},
                                                                                              u'--min-log-level': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [u'DEBUG',
                                                                                                                                u'INFO',
                                                                                                                                u'ERROR'],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Minimum level of logs to be fetched. _MIN_LOG_LEVEL_ must be one of: *DEBUG*, *INFO*, *ERROR*.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--min-log-level',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'MIN_LOG_LEVEL'},
                                                                                              u'--no-show-execution-ids': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': True,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-show-execution-ids',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_SHOW_EXECUTION_IDS'},
                                                                                              u'--no-show-function-names': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': True,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--no-show-function-names',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_SHOW_FUNCTION_NAMES'},
                                                                                              u'--no-show-log-levels': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': True,
                                                                                                                        u'description': u'',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': True,
                                                                                                                        u'name': u'--no-show-log-levels',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'NO_SHOW_LOG_LEVELS'},
                                                                                              u'--no-show-timestamps': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': True,
                                                                                                                        u'description': u'',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': True,
                                                                                                                        u'name': u'--no-show-timestamps',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'NO_SHOW_TIMESTAMPS'},
                                                                                              u'--no-uri': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': True,
                                                                                                            u'description': u'',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': True,
                                                                                                            u'name': u'--no-uri',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'NO_URI'},
                                                                                              u'--page-size': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--page-size',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                              u'--show-execution-ids': {u'attr': {u'inverted_synopsis': True},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': True,
                                                                                                                        u'description': u'Print an execution ID before each log entry. Enabled by default, use *--no-show-execution-ids* to disable.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--show-execution-ids',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'SHOW_EXECUTION_IDS'},
                                                                                              u'--show-function-names': {u'attr': {u'inverted_synopsis': True},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': True,
                                                                                                                         u'description': u'Print a function name before each log entry. Enabled by default, use *--no-show-function-names* to disable.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--show-function-names',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'SHOW_FUNCTION_NAMES'},
                                                                                              u'--show-log-levels': {u'attr': {u'inverted_synopsis': True},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'Print a log level of each log entry. Enabled by default, use *--no-show-log-levels* to disable.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--show-log-levels',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'SHOW_LOG_LEVELS'},
                                                                                              u'--show-timestamps': {u'attr': {u'inverted_synopsis': True},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'Print a UTC timestamp before each log entry. Enabled by default, use *--no-show-timestamps* to disable.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--show-timestamps',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'SHOW_TIMESTAMPS'},
                                                                                              u'--sort-by': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--sort-by',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'list',
                                                                                                             u'value': u'FIELD'},
                                                                                              u'--start-time': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Return only log entries which timestamps are not earlier than the specified time. The timestamp must be in RFC3339 UTC "Zulu" format. If --start-time is specified, the command returns --limit earliest log entries which appeared after --start-time.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--start-time',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'START_TIME'},
                                                                                              u'--uri': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': False,
                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--uri',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'URI'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'get-logs',
                                                                                   u'path': [u'gcloud',
                                                                                             u'alpha',
                                                                                             u'functions',
                                                                                             u'get-logs'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Name of the function which logs are to be displayed. If no name is specified, logs from all functions are displayed.',
                                                                                                     u'name': u'name',
                                                                                                     u'nargs': u'?',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'ALPHA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command displays log entries produced by all functions running in a\nregion, or by a single function if it is specified through a command argument.\nBy default, when no extra flags are specified, the most recent 20 log entries\nare displayed.'}},
                                                                     u'list': {u'capsule': u'*(ALPHA)* Lists all the functions in a given region.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--filter',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'EXPRESSION'},
                                                                                          u'--limit': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--limit',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'LIMIT'},
                                                                                          u'--no-uri': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-uri',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_URI'},
                                                                                          u'--page-size': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--page-size',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                          u'--sort-by': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--sort-by',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'list',
                                                                                                         u'value': u'FIELD'},
                                                                                          u'--uri': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--uri',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'URI'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'list',
                                                                               u'path': [u'gcloud',
                                                                                         u'alpha',
                                                                                         u'functions',
                                                                                         u'list'],
                                                                               u'positionals': [],
                                                                               u'release': u'ALPHA',
                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists all the functions in a given region.'}},
                                                                     u'logs': {u'capsule': u'*(ALPHA)* Manages Google Cloud Functions logs access.',
                                                                               u'commands': {u'read': {u'capsule': u'*(ALPHA)* Show logs produced by functions.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--end-time': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Return only log entries which timestamps are not later than the specified time. The timestamp must be in RFC3339 UTC "Zulu" format. If --end-time is specified but --start-time is not, the command returns --limit latest log entries which appeared before --end-time.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--end-time',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'END_TIME'},
                                                                                                                  u'--execution-id': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Execution ID for which logs are to be displayed.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--execution-id',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXECUTION_ID'},
                                                                                                                  u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': 20,
                                                                                                                               u'description': u'Number of log entries to be fetched; must not be greater than 1000.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'int',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--min-log-level': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [u'DEBUG',
                                                                                                                                                    u'INFO',
                                                                                                                                                    u'ERROR'],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Minimum level of logs to be fetched. _MIN_LOG_LEVEL_ must be one of: *DEBUG*, *INFO*, *ERROR*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--min-log-level',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'MIN_LOG_LEVEL'},
                                                                                                                  u'--no-show-execution-ids': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': True,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-show-execution-ids',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_SHOW_EXECUTION_IDS'},
                                                                                                                  u'--no-show-function-names': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-show-function-names',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_SHOW_FUNCTION_NAMES'},
                                                                                                                  u'--no-show-log-levels': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-show-log-levels',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_SHOW_LOG_LEVELS'},
                                                                                                                  u'--no-show-timestamps': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-show-timestamps',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_SHOW_TIMESTAMPS'},
                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_URI'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--show-execution-ids': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'Print an execution ID before each log entry. Enabled by default, use *--no-show-execution-ids* to disable.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--show-execution-ids',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'SHOW_EXECUTION_IDS'},
                                                                                                                  u'--show-function-names': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'Print a function name before each log entry. Enabled by default, use *--no-show-function-names* to disable.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--show-function-names',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'SHOW_FUNCTION_NAMES'},
                                                                                                                  u'--show-log-levels': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'Print a log level of each log entry. Enabled by default, use *--no-show-log-levels* to disable.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--show-log-levels',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'SHOW_LOG_LEVELS'},
                                                                                                                  u'--show-timestamps': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'Print a UTC timestamp before each log entry. Enabled by default, use *--no-show-timestamps* to disable.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--show-timestamps',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'SHOW_TIMESTAMPS'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'},
                                                                                                                  u'--start-time': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Return only log entries which timestamps are not earlier than the specified time. The timestamp must be in RFC3339 UTC "Zulu" format. If --start-time is specified, the command returns --limit earliest log entries which appeared after --start-time.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--start-time',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'START_TIME'},
                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'URI'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'read',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'functions',
                                                                                                                 u'logs',
                                                                                                                 u'read'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Name of the function which logs are to be displayed. If no name is specified, logs from all functions are displayed.',
                                                                                                                         u'name': u'name',
                                                                                                                         u'nargs': u'?',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'NAME'}],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Display log entries produced by all functions running in a region, or by a\nsingle function if it is specified through a command argument. By default,\nwhen no extra flags are specified, the most recent 20 log entries\nare displayed.'}}},
                                                                               u'flags': {},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'logs',
                                                                               u'path': [u'gcloud',
                                                                                         u'alpha',
                                                                                         u'functions',
                                                                                         u'logs'],
                                                                               u'positionals': [],
                                                                               u'release': u'ALPHA',
                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manages Google Cloud Functions logs access.'}},
                                                                     u'regions': {u'capsule': u'*(ALPHA)* Provides information about Google Cloud Functions regions.',
                                                                                  u'commands': {u'list': {u'capsule': u'*(ALPHA)* Returns a list of locations where functions can be deployed.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'functions',
                                                                                                                    u'regions',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* Returns a list of locations where functions can be deployed.'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'regions',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'functions',
                                                                                            u'regions'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Provides information about Google Cloud Functions regions.'}}},
                                                       u'flags': {u'--region': {u'attr': {},
                                                                                u'category': u'',
                                                                                u'choices': [],
                                                                                u'completer': u'',
                                                                                u'default': u'us-central1',
                                                                                u'description': u'The compute region (e.g. us-central1) to use',
                                                                                u'group': u'',
                                                                                u'hidden': False,
                                                                                u'name': u'--region',
                                                                                u'nargs': u'0',
                                                                                u'required': False,
                                                                                u'type': u'string',
                                                                                u'value': u'REGION'}},
                                                       u'group': True,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'functions',
                                                       u'path': [u'gcloud',
                                                                 u'alpha',
                                                                 u'functions'],
                                                       u'positionals': [],
                                                       u'release': u'ALPHA',
                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manages Google Cloud Functions.'}},
                                        u'genomics': {u'capsule': u'*(ALPHA)* Manage Genomics resources using version 1 of the API.',
                                                      u'commands': {u'callsets': {u'capsule': u'*(ALPHA)* Commands for Genomics callsets.',
                                                                                  u'commands': {u'create': {u'capsule': u'*(ALPHA)* Creates a call set with a specified name.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--name': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the call set being created.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'NAME'},
                                                                                                                       u'--variant-set-id': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Variant set that this call set belongs to.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--variant-set-id',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': True,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'VARIANT_SET_ID'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'create',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'callsets',
                                                                                                                      u'create'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* A call set is a collection of variant calls, typically for one sample.'}},
                                                                                                u'delete': {u'capsule': u'*(ALPHA)* Deletes a call set.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'delete',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'callsets',
                                                                                                                      u'delete'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The ID of the call set to be deleted.',
                                                                                                                              u'name': u'id',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'ID'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes a call set.'}},
                                                                                                u'describe': {u'capsule': u'*(ALPHA)* Returns details about a call set.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'genomics',
                                                                                                                        u'callsets',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The ID of the call set to be described.',
                                                                                                                                u'name': u'id',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'ID'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Returns details about a call set.'}},
                                                                                                u'list': {u'capsule': u'*(ALPHA)* List genomics call sets in a project.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--name': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Only return call sets for which a substring of the\n             name matches this string.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'NAME'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'genomics',
                                                                                                                    u'callsets',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Restrict the query to call sets within the given variant sets.\n             At least one ID must be provided.',
                                                                                                                            u'name': u'variant-set-ids',
                                                                                                                            u'nargs': u'+',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'VARIANT_SET_IDS'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on call sets in the project.'}},
                                                                                                u'update': {u'capsule': u'*(ALPHA)* Updates a call set name.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--name': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The new name of the call set.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'NAME'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'update',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'callsets',
                                                                                                                      u'update'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The ID of the call set to be updated.',
                                                                                                                              u'name': u'id',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'ID'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Updates a call set name.'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'callsets',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'genomics',
                                                                                            u'callsets'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to create, update, delete, and examine callsets.'}},
                                                                    u'datasets': {u'capsule': u'*(ALPHA)* Commands for Genomics datasets.',
                                                                                  u'commands': {u'add-iam-policy-binding': {u'capsule': u'*(ALPHA)* Add IAM policy binding for a dataset.',
                                                                                                                            u'commands': {},
                                                                                                                            u'flags': {u'--member': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The member to add to the binding.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--member',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': True,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'MEMBER'},
                                                                                                                                       u'--role': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Define the role of the member.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--role',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': True,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'ROLE'}},
                                                                                                                            u'group': False,
                                                                                                                            u'groups': {},
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'add-iam-policy-binding',
                                                                                                                            u'path': [u'gcloud',
                                                                                                                                      u'alpha',
                                                                                                                                      u'genomics',
                                                                                                                                      u'datasets',
                                                                                                                                      u'add-iam-policy-binding'],
                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The ID of the dataset.',
                                                                                                                                              u'name': u'id',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'value': u'ID'}],
                                                                                                                            u'release': u'ALPHA',
                                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command adds a policy binding to the IAM policy of a dataset,\ngiven a dataset ID and the binding.',
                                                                                                                                          u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on a dataset with\nidentifier '1000'\n\n  $ add-iam-policy-binding 1000 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                                                u'create': {u'capsule': u'*(ALPHA)* Creates a dataset with a specified name.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--name': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the dataset being created.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'NAME'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'create',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'datasets',
                                                                                                                      u'create'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* A dataset is a collection of genomics objects such as reads and variants.'}},
                                                                                                u'delete': {u'capsule': u'*(ALPHA)* Deletes a dataset.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'delete',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'datasets',
                                                                                                                      u'delete'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The ID of the dataset to be deleted.',
                                                                                                                              u'name': u'id',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'ID'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes a dataset.'}},
                                                                                                u'describe': {u'capsule': u'*(ALPHA)* Returns details about a dataset.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'genomics',
                                                                                                                        u'datasets',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The ID of the dataset to be described.',
                                                                                                                                u'name': u'id',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'ID'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Returns details about a dataset.'}},
                                                                                                u'get-iam-policy': {u'capsule': u'*(ALPHA)* Get IAM policy for a dataset.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'get-iam-policy',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'genomics',
                                                                                                                              u'datasets',
                                                                                                                              u'get-iam-policy'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The ID of the dataset.',
                                                                                                                                      u'name': u'id',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'ID'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command gets the IAM policy for a dataset, given a dataset ID.'}},
                                                                                                u'list': {u'capsule': u'*(ALPHA)* List Genomics datasets in a project.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'genomics',
                                                                                                                    u'datasets',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on datasets in the project.'}},
                                                                                                u'remove-iam-policy-binding': {u'capsule': u'*(ALPHA)* Remove IAM policy binding for a dataset.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--member': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The member to remove from the binding.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--member',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': True,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'MEMBER'},
                                                                                                                                          u'--role': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The role to remove the member from.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--role',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': True,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'ROLE'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'remove-iam-policy-binding',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'alpha',
                                                                                                                                         u'genomics',
                                                                                                                                         u'datasets',
                                                                                                                                         u'remove-iam-policy-binding'],
                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The ID of the dataset.',
                                                                                                                                                 u'name': u'id',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'value': u'ID'}],
                                                                                                                               u'release': u'ALPHA',
                                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command removes a policy binding to the IAM policy of a dataset,\ngiven a dataset ID and the binding.',
                                                                                                                                             u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on dataset with\nidentifier '1000'\n\n  $ remove-iam-policy-binding 1000 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                                                u'restore': {u'capsule': u'*(ALPHA)* Restores a deleted dataset.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'restore',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'genomics',
                                                                                                                       u'datasets',
                                                                                                                       u'restore'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The ID of the deleted dataset to be restored.',
                                                                                                                               u'name': u'id',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'ID'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Restores a deleted dataset.'}},
                                                                                                u'set-iam-policy': {u'capsule': u'*(ALPHA)* Set IAM policy for a dataset.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'set-iam-policy',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'genomics',
                                                                                                                              u'datasets',
                                                                                                                              u'set-iam-policy'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The ID of the dataset.',
                                                                                                                                      u'name': u'id',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'ID'},
                                                                                                                                     {u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'JSON file with the IAM policy',
                                                                                                                                      u'name': u'policy-file',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'POLICY_FILE'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command sets the IAM policy for a dataset, given a dataset ID and a\nfile that contains the JSON encoded IAM policy.',
                                                                                                                                  u'EXAMPLES': u"The following command will read an IAM policy defined in a JSON file\n'policy.json' and set it for a dataset with identifier '1000'\n\n  $ set-iam-policy 1000 policy.json\n\nSee https://cloud.google.com/genomics/v1/access-control for details on\nmanaging access control on Genomics datasets."}},
                                                                                                u'update': {u'capsule': u'*(ALPHA)* Updates a dataset name.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--name': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The new name of the dataset.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'NAME'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'update',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'datasets',
                                                                                                                      u'update'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The ID of the dataset to be updated.',
                                                                                                                              u'name': u'id',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'ID'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Updates a dataset name.'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'datasets',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'genomics',
                                                                                            u'datasets'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to create, update, delete, and examine datasets.'}},
                                                                    u'operations': {u'capsule': u'*(ALPHA)* Commands for Genomics operations.',
                                                                                    u'commands': {u'cancel': {u'capsule': u'*(ALPHA)* Cancels an operation.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'cancel',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'genomics',
                                                                                                                        u'operations',
                                                                                                                        u'cancel'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the operation to be canceled. The "operations/" prefix for the name is optional.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cancels an operation.'}},
                                                                                                  u'describe': {u'capsule': u'*(ALPHA)* Returns details about an operation.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'describe',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'genomics',
                                                                                                                          u'operations',
                                                                                                                          u'describe'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the operation to be described. The "operations/" prefix for the name is optional.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Returns details about an operation.'}},
                                                                                                  u'list': {u'capsule': u'*(ALPHA)* List Genomics operations in a project.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--limit': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--limit',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                       u'--where': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': u'',
                                                                                                                                    u'description': u'A string for filtering operations. The following filter fields are\nsupported:\n+\n    createTime - The time this job was created, in seconds from the\n                 epoch. Can use \'>=\' and/or \'<=\' operators.\n    status     - Can be \'RUNNING\', \'SUCCESS\', \'FAILURE\' or \'CANCELED\'.\n                 Only one status may be specified.\n    labels.key - \'key\' is a label key to match against a target value.\n+\nExample:\n+\n    \'createTime >= 1432140000 AND\n     createTime <= 1432150000 AND\n     labels.batch = test AND\n     status = RUNNING\'\n+\nTo calculate the timestamp as seconds from the epoch, on UNIX-like\nsystems (e.g.: Linux, Mac) use the \'date\' command:\n+\n  $ date --date \'20150701\' \'+%s\'\n+\n  1435734000\n+\nor with Python (e.g.: Linux, Mac, Windows):\n+\n  $ python -c \'from time import mktime, strptime; print int(mktime(strptime("01 July 2015", "%d %B %Y")))\'\n+\n  1435734000',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--where',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'WHERE'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'list',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'operations',
                                                                                                                      u'list'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on operations in the project.'}}},
                                                                                    u'flags': {},
                                                                                    u'group': True,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'operations',
                                                                                    u'path': [u'gcloud',
                                                                                              u'alpha',
                                                                                              u'genomics',
                                                                                              u'operations'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'ALPHA',
                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to list, cancel, and examine operations.'}},
                                                                    u'pipelines': {u'capsule': u'*(ALPHA)* Commands for Genomics pipelines.',
                                                                                   u'commands': {u'run': {u'capsule': u'*(ALPHA)* Defines and runs a pipeline.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--disk-size': {u'attr': {},
                                                                                                                                      u'category': u'COMMONLY USED',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The disk size(s) in GB, specified as a comma-separated list of\n            pairs of disk name and size. For example:\n            --disk-size "name:size,name2:size2".\n            Overrides any values specified in the pipeline-file.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--disk-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'DISK_SIZE'},
                                                                                                                     u'--inputs': {u'attr': {},
                                                                                                                                   u'category': u'COMMONLY USED',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Map of input PipelineParameter names to values.\n            Used to pass literal parameters to the pipeline, and to specify\n            input files in Google Cloud Storage that will have a localCopy\n            made. Specified as a comma-separated list: --inputs\n            file=gs://my-bucket/in.txt,name=hello',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--inputs',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'dict',
                                                                                                                                   u'value': u'NAME=VALUE'},
                                                                                                                     u'--inputs-from-file': {u'attr': {},
                                                                                                                                             u'category': u'COMMONLY USED',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Map of input PipelineParameter names to values.\n            Used to pass literal parameters to the pipeline where values come\n            from local files; this can be used to send large pipeline input\n            parameters, such as code, data, or configuration values.\n            Specified as a comma-separated list:\n            --inputs-from-file script=myshellscript.sh,pyfile=mypython.py',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--inputs-from-file',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'dict',
                                                                                                                                             u'value': u'NAME=FILE'},
                                                                                                                     u'--labels': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--labels',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'dict',
                                                                                                                                   u'value': u'KEY=VALUE'},
                                                                                                                     u'--logging': {u'attr': {},
                                                                                                                                    u'category': u'COMMONLY USED',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The location in Google Cloud Storage to which the pipeline logs\n            will be copied. Can be specified as a fully qualified directory\n            path, in which case logs will be output with a unique identifier\n            as the filename in that directory, or as a fully specified path,\n            which must end in `.log`, in which case that path will be\n            used. Stdout and stderr logs from the run are also generated and\n            output as `-stdout.log` and `-stderr.log`.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--logging',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LOGGING'},
                                                                                                                     u'--memory': {u'attr': {},
                                                                                                                                   u'category': u'COMMONLY USED',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The number of GB of RAM needed to run the pipeline. Overrides\n             any value specified in the pipeline-file.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--memory',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'MEMORY'},
                                                                                                                     u'--no-preemptible': {u'attr': {},
                                                                                                                                           u'category': u'COMMONLY USED',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-preemptible',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_PREEMPTIBLE'},
                                                                                                                     u'--outputs': {u'attr': {},
                                                                                                                                    u'category': u'COMMONLY USED',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Map of output PipelineParameter names to values.\n            Used to specify output files in Google Cloud Storage that will be\n            made from a localCopy. Specified as a comma-separated list:\n            --outputs ref=gs://my-bucket/foo,ref2=gs://my-bucket/bar',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--outputs',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'dict',
                                                                                                                                    u'value': u'NAME=VALUE'},
                                                                                                                     u'--pipeline-file': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'A YAML or JSON file containing a Pipeline object. See\n          [](https://cloud.google.com/genomics/reference/rest/v1alpha2/pipelines#Pipeline)\n+\n          YAML Example:\n            name: hello world\n+\n            inputParameters:\n            - name: greeting\n              defaultValue: Hello\n            - name: object\n              defaultValue: World\n+\n            outputParameters:\n            - name: outputFile\n              localCopy:\n                path: /data/output/greeting.txt\n                disk: boot\n+\n            resources:\n              minimumCpuCores: 1\n              minimumRamGb: 1\n              preemptible: true\n+\n            docker:\n              imageName: ubuntu\n              cmd: >\n                echo "${greeting} ${object}" > /data/output/greeting.txt',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--pipeline-file',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PIPELINE_FILE'},
                                                                                                                     u'--preemptible': {u'attr': {},
                                                                                                                                        u'category': u'COMMONLY USED',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Whether to use a preemptible VM for this pipeline. The\n            "resource" section of the pipeline-file must also set preemptible\n            to "true" for this flag to take effect.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--preemptible',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'PREEMPTIBLE'},
                                                                                                                     u'--run-id': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--run-id',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'RUN_ID'},
                                                                                                                     u'--service-account-email': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': u'default',
                                                                                                                                                  u'description': u'The service account used to run the pipeline. If unspecified,\n            defaults to the Compute Engine service account for your project.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--service-account-email',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'SERVICE_ACCOUNT_EMAIL'},
                                                                                                                     u'--service-account-scopes': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': [],
                                                                                                                                                   u'description': u'List of additional scopes to be made available for this service\n             account. The following scopes are always requested:\n+\n             https://www.googleapis.com/auth/compute\n             https://www.googleapis.com/auth/devstorage.full_control\n             https://www.googleapis.com/auth/genomics\n             https://www.googleapis.com/auth/logging.write\n             https://www.googleapis.com/auth/monitoring.write',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--service-account-scopes',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'list',
                                                                                                                                                   u'value': u'SCOPE'},
                                                                                                                     u'--zones': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'List of Compute Engine zones the pipeline can run in.\n+\nIf no zones are specified with the zones flag, then zones in the\npipeline definition file will be used.\n+\nIf no zones are specified in the pipeline definition, then the\ndefault zone in your local client configuration is used.\n+\nIf you have no default zone, then the pipeline may run in any zone.\n+\nFor more information on default zones, see\nhttps://cloud.google.com/compute/docs/gcloud-compute/#set_default_zone_and_region_in_your_local_client',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--zones',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'run',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'genomics',
                                                                                                                    u'pipelines',
                                                                                                                    u'run'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* A pipeline is a transformation of a set of inputs to a set of outputs.\nSupports docker-based commands.'}}},
                                                                                   u'flags': {},
                                                                                   u'group': True,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'pipelines',
                                                                                   u'path': [u'gcloud',
                                                                                             u'alpha',
                                                                                             u'genomics',
                                                                                             u'pipelines'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'ALPHA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Command to run a pipeline.'}},
                                                                    u'readgroupsets': {u'capsule': u'*(ALPHA)* Commands for Genomics read group sets.',
                                                                                       u'commands': {u'delete': {u'capsule': u'*(ALPHA)* Deletes a read group set.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'delete',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'genomics',
                                                                                                                           u'readgroupsets',
                                                                                                                           u'delete'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The ID of the read group set to be deleted.',
                                                                                                                                   u'name': u'id',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'ID'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes a read group set.'}},
                                                                                                     u'describe': {u'capsule': u'*(ALPHA)* Returns details about a read group set.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'describe',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'genomics',
                                                                                                                             u'readgroupsets',
                                                                                                                             u'describe'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The ID of the read group set to be described.',
                                                                                                                                     u'name': u'id',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'ID'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Returns details about a read group set.'}},
                                                                                                     u'export': {u'capsule': u'*(ALPHA)* Exports a read group set to a BAM file in cloud storage.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--export-uri': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Google Cloud Storage URI to which the BAM file (https://samtools.github.io/hts-specs/SAMv1.pdf) should be exported.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--export-uri',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'EXPORT_URI'},
                                                                                                                            u'--reference-names': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': [],
                                                                                                                                                   u'description': u'Comma separated list of reference names to be exported from the given read group set. Provide * to export unmapped reads. By default, all reads are exported.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--reference-names',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'list',
                                                                                                                                                   u'value': u'REFERENCE_NAMES'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'export',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'genomics',
                                                                                                                           u'readgroupsets',
                                                                                                                           u'export'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The ID of the read group set to export.',
                                                                                                                                   u'name': u'read-group-set-id',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'READ_GROUP_SET_ID'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Exports a read group set, optionally restricted by reference name, to a BAM\nfile in a provided Google Cloud Storage object. This command yields an\nasynchronous Operation resource which tracks the completion of this task. See\n[](https://cloud.google.com/genomics/managing-reads for more details)'}},
                                                                                                     u'import': {u'capsule': u'*(ALPHA)* Imports read group sets into a dataset.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--dataset-id': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The ID of the dataset the imported read group sets will belong to.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--dataset-id',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'DATASET_ID'},
                                                                                                                            u'--partition-strategy': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'One of "PER_FILE_PER_SAMPLE" or "MERGE_ALL". The partition strategy describes how read groups from the provided files are partitioned into read group sets. In general, use PER_FILE_PER_SAMPLE when importing multiple samples from multiple files and use MERGE_ALL when importing a single sample from multiple files. Defaults to PER_FILE_PER_SAMPLE',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--partition-strategy',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'PARTITION_STRATEGY'},
                                                                                                                            u'--reference-set-id': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The reference set ID to associate with the imported read group sets. The reference headers in the provided BAM files will be validated against this ID. The reference set ID can be used by consumers of your imported read group sets for more robust reference genome comparison.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--reference-set-id',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'REFERENCE_SET_ID'},
                                                                                                                            u'--source-uris': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Comma separated list of Google Cloud Storage URIs for BAM files (https://samtools.github.io/hts-specs/SAMv1.pdf) to be imported.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--source-uris',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'SOURCE_URIS'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'import',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'genomics',
                                                                                                                           u'readgroupsets',
                                                                                                                           u'import'],
                                                                                                                 u'positionals': [],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Imports read group sets from a set of BAM files in Google Cloud Storage. See\n[](https://cloud.google.com/genomics/managing-reads for more details)',
                                                                                                                               u'EXAMPLES': u'Import a single BAM file and associate with the GRCh38 reference set:\n\n  $ import --dataset-id 123 --reference-set-id "EMud_c37lKPXTQ" --source-uris "gs://mybucket/reads.bam"\n\nImport a single sample which is sharded across multiple BAM files:\n\n  $ import --dataset-id 123 --partition-strategy MERGE_ALL --source-uris "gs://mybucket/chr?.bam,gs://mybucket/mt.bam"\n'}},
                                                                                                     u'list': {u'capsule': u'*(ALPHA)* List genomics read group sets in a dataset.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--filter',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'EXPRESSION'},
                                                                                                                          u'--limit': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--limit',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'LIMIT'},
                                                                                                                          u'--name': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Only return read group sets for which a substring of the\n             name matches this string.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'NAME'},
                                                                                                                          u'--no-uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_URI'},
                                                                                                                          u'--page-size': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': 128,
                                                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--page-size',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'int',
                                                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                                                          u'--sort-by': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--sort-by',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'FIELD'},
                                                                                                                          u'--uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'URI'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'list',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'genomics',
                                                                                                                         u'readgroupsets',
                                                                                                                         u'list'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Restrict the query to read group sets within the given datasets.\n             At least one ID must be provided.',
                                                                                                                                 u'name': u'dataset-ids',
                                                                                                                                 u'nargs': u'+',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'DATASET_IDS'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on read group sets in the dataset.'}},
                                                                                                     u'update': {u'capsule': u'*(ALPHA)* Updates a readgroupset name and/or referenceSetId.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--name': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The new name of the readgroupset.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'NAME'},
                                                                                                                            u'--reference-set-id': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The new reference set ID of the readgroupset.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--reference-set-id',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'REFERENCE_SET_ID'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'update',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'genomics',
                                                                                                                           u'readgroupsets',
                                                                                                                           u'update'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The ID of the read group set to be updated.',
                                                                                                                                   u'name': u'id',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'ID'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Updates a readgroupset name and/or referenceSetId.'}}},
                                                                                       u'flags': {},
                                                                                       u'group': True,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'readgroupsets',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'alpha',
                                                                                                 u'genomics',
                                                                                                 u'readgroupsets'],
                                                                                       u'positionals': [],
                                                                                       u'release': u'ALPHA',
                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to delete, describe, import, update, and list read group sets.'}},
                                                                    u'reads': {u'capsule': u'*(ALPHA)* Commands for Genomics reads.',
                                                                               u'commands': {u'list': {u'capsule': u'*(ALPHA)* Lists reads within a given read group set.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--end': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The end of the window (0-based exclusive) for which overlapping reads should be returned. If unspecified or 0, defaults to the length of the reference.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--end',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'END'},
                                                                                                                  u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_URI'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': 512,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'int',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--reference-name': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Only return reads which are aligned to this reference. Pass * to list unmapped reads only.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--reference-name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REFERENCE_NAME'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'},
                                                                                                                  u'--start': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The beginning of the window (0-based inclusive) for which overlapping reads should be returned. If unspecified, defaults to 0.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--start',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'START'},
                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'URI'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'list',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'genomics',
                                                                                                                 u'reads',
                                                                                                                 u'list'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Restrict the list to reads in this read group set.',
                                                                                                                         u'name': u'read-group-set-id',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'READ_GROUP_SET_ID'}],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on reads in the read group set.\nResults may be restricted to reads which are aligned to a given reference\n(--reference-name) or may be further filtered to reads that have alignments\noverlapping a given range (--reference-name, --start, --end).'}}},
                                                                               u'flags': {},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'reads',
                                                                               u'path': [u'gcloud',
                                                                                         u'alpha',
                                                                                         u'genomics',
                                                                                         u'reads'],
                                                                               u'positionals': [],
                                                                               u'release': u'ALPHA',
                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to list reads.'}},
                                                                    u'references': {u'capsule': u'*(ALPHA)* Commands for Genomics references.',
                                                                                    u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Returns details about a reference.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'describe',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'alpha',
                                                                                                                          u'genomics',
                                                                                                                          u'references',
                                                                                                                          u'describe'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The ID of the reference to be described.',
                                                                                                                                  u'name': u'id',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'ID'}],
                                                                                                                u'release': u'ALPHA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Returns details about a reference.'}},
                                                                                                  u'list': {u'capsule': u'*(ALPHA)* List genomics references.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--accessions': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': [],
                                                                                                                                         u'description': u'Only return references from these accessions.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--accessions',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'ACCESSIONS'},
                                                                                                                       u'--filter': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--filter',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--limit',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                       u'--md5checksums': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': [],
                                                                                                                                           u'description': u'Only return references with these checksums.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--md5checksums',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'MD5CHECKSUMS'},
                                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_URI'},
                                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--page-size',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                                       u'--reference-set-id': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Only return references for this reference set.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--reference-set-id',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'REFERENCE_SET_ID'},
                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'FIELD'},
                                                                                                                       u'--uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'URI'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'list',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'references',
                                                                                                                      u'list'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on references.'}}},
                                                                                    u'flags': {},
                                                                                    u'group': True,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'references',
                                                                                    u'path': [u'gcloud',
                                                                                              u'alpha',
                                                                                              u'genomics',
                                                                                              u'references'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'ALPHA',
                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to list references.'}},
                                                                    u'referencesets': {u'capsule': u'*(ALPHA)* Commands for Genomics reference sets.',
                                                                                       u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Returns details about a reference set.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'describe',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'genomics',
                                                                                                                             u'referencesets',
                                                                                                                             u'describe'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The ID of the reference set to be described.',
                                                                                                                                     u'name': u'id',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'ID'}],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Returns details about a reference set.'}},
                                                                                                     u'list': {u'capsule': u'*(ALPHA)* List genomics reference sets.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--accessions': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': [],
                                                                                                                                            u'description': u'Only return reference sets from these accessions.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--accessions',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'ACCESSIONS'},
                                                                                                                          u'--assembly-id': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Only return reference sets for this assembly-id.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--assembly-id',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ASSEMBLY_ID'},
                                                                                                                          u'--filter': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--filter',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'EXPRESSION'},
                                                                                                                          u'--limit': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--limit',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'LIMIT'},
                                                                                                                          u'--md5checksums': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': [],
                                                                                                                                              u'description': u'Only return reference sets with these checksums.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--md5checksums',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'MD5CHECKSUMS'},
                                                                                                                          u'--no-uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_URI'},
                                                                                                                          u'--page-size': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--page-size',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                                                          u'--sort-by': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--sort-by',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'FIELD'},
                                                                                                                          u'--uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'URI'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'list',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'genomics',
                                                                                                                         u'referencesets',
                                                                                                                         u'list'],
                                                                                                               u'positionals': [],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on reference sets.'}}},
                                                                                       u'flags': {},
                                                                                       u'group': True,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'referencesets',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'alpha',
                                                                                                 u'genomics',
                                                                                                 u'referencesets'],
                                                                                       u'positionals': [],
                                                                                       u'release': u'ALPHA',
                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to describe and list reference sets.'}},
                                                                    u'variants': {u'capsule': u'*(ALPHA)* Commands for Genomics variants.',
                                                                                  u'commands': {u'delete': {u'capsule': u'*(ALPHA)* Deletes a variant.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'delete',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'variants',
                                                                                                                      u'delete'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The ID of the variant to be deleted.',
                                                                                                                              u'name': u'id',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'ID'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes a variant.'}},
                                                                                                u'describe': {u'capsule': u'*(ALPHA)* Returns details about a variant.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'genomics',
                                                                                                                        u'variants',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The ID of the variant to be described.',
                                                                                                                                u'name': u'id',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'ID'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Returns details about a variant.'}},
                                                                                                u'import': {u'capsule': u'*(ALPHA)* Imports variants into Google Genomics.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--file-format': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [u'COMPLETE_GENOMICS',
                                                                                                                                                       u'VCF'],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': u'VCF',
                                                                                                                                          u'description': u'Set the file format of the --source-uris. _FILE_FORMAT_ must be one of: *COMPLETE_GENOMICS*, *VCF*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--file-format',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'FILE_FORMAT'},
                                                                                                                       u'--info-merge-config': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"A mapping between VCF INFO field keys and the operations to be performed on them. Valid operations include: IGNORE_NEW - By default, variant info fields are persisted if the variant does not yet exist in the variant set.  If the variant is equivalent to a variant already in the variant set, the incoming variant's info field is ignored in favor of that of the already persisted variant. MOVE_TO_CALLS - Removes an info field from the incoming variant and persists this info field in each of the incoming variant's calls.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--info-merge-config',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'dict',
                                                                                                                                                u'value': u'INFO_MERGE_CONFIG'},
                                                                                                                       u'--no-normalize-reference-names': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': True,
                                                                                                                                                           u'description': u'',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': True,
                                                                                                                                                           u'name': u'--no-normalize-reference-names',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'NO_NORMALIZE_REFERENCE_NAMES'},
                                                                                                                       u'--normalize-reference-names': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': False,
                                                                                                                                                        u'description': u'Convert reference names to the canonical representation. hg19 haplotypes (those reference names containing "_hap") are not modified in any way. All other reference names are modified according to the following rules: The reference name is capitalized. The "chr" prefix is dropped for all autosomes and sex chromsomes. For example "chr17" becomes "17" and "chrX" becomes "X". All mitochondrial chromosomes ("chrM", "chrMT", etc) become "MT".',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--normalize-reference-names',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'NORMALIZE_REFERENCE_NAMES'},
                                                                                                                       u'--source-uris': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'A comma-delimited list of URI patterns referencing existing VCF or MasterVar files in Google Cloud Storage.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--source-uris',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'SOURCE_URIS'},
                                                                                                                       u'--variantset-id': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The ID of the destination variant set.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--variantset-id',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'VARIANTSET_ID'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'import',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'variants',
                                                                                                                      u'import'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Import variants from VCF or MasterVar files that are in Google Cloud Storage.'}},
                                                                                                u'list': {u'capsule': u'*(ALPHA)* Lists variants that match the search criteria.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--call-set-ids': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': [],
                                                                                                                                         u'description': u'Restrict the list to variants which have calls from the listed call sets. If omitted, a --variant-set-id must be specified.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--call-set-ids',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'CALL_SET_IDS'},
                                                                                                                     u'--end': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The end of the window (0-based exclusive) for which variants should be returned. If unspecified or 0, defaults to the length of the reference.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--end',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'END'},
                                                                                                                     u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--limit-calls': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The maximum number of calls to return.At least one variant will be returned even if it exceeds this limit.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--limit-calls',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'LIMIT_CALLS'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': 512,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'int',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--reference-name': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Only return variants in this reference sequence.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--reference-name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REFERENCE_NAME'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--start': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The beginning of the window (0-based inclusive) for which overlapping variants should be returned. If unspecified, defaults to 0.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--start',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'START'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'},
                                                                                                                     u'--variant-set-id': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Restrict the list to variants in this variant set. If omitted, a call set id must be included in the request.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--variant-set-id',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'VARIANT_SET_ID'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'genomics',
                                                                                                                    u'variants',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists variants that match the search criteria.'}},
                                                                                                u'update': {u'capsule': u'*(ALPHA)* Updates variant names.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--names': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The new variant names replace existing names.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--names',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'NAMES'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'update',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'genomics',
                                                                                                                      u'variants',
                                                                                                                      u'update'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The ID of the variant to be updated.',
                                                                                                                              u'name': u'id',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'ID'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Updates variant names.'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'variants',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'genomics',
                                                                                            u'variants'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to delete, describe, import, list, and update variants.'}},
                                                                    u'variantsets': {u'capsule': u'*(ALPHA)* Commands for Genomics variant sets.',
                                                                                     u'commands': {u'create': {u'capsule': u'*(ALPHA)* Creates a variant set belonging to a specified dataset.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--dataset-id': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The ID of the dataset the variant set will belong to.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--dataset-id',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'DATASET_ID'},
                                                                                                                          u'--description': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A description of the variant set.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--description',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DESCRIPTION'},
                                                                                                                          u'--name': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The user-defined name of the variant set. Name does not uniquely identify a variant set. It is for descriptive purposes only.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'NAME'},
                                                                                                                          u'--reference-set-id': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The reference set the variant set will be associated with. When variants are later added to this variant set, the API enforces consistency with this reference set.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--reference-set-id',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'REFERENCE_SET_ID'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'create',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'genomics',
                                                                                                                         u'variantsets',
                                                                                                                         u'create'],
                                                                                                               u'positionals': [],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Creates a variant set belonging to a specified dataset.'}},
                                                                                                   u'delete': {u'capsule': u'*(ALPHA)* Deletes a variant set.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'delete',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'genomics',
                                                                                                                         u'variantsets',
                                                                                                                         u'delete'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The ID of the variant set to be deleted.',
                                                                                                                                 u'name': u'variant-set-id',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'VARIANT_SET_ID'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes a variant set.'}},
                                                                                                   u'describe': {u'capsule': u'*(ALPHA)* Gets a variant set by ID.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'describe',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'genomics',
                                                                                                                           u'variantsets',
                                                                                                                           u'describe'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The ID of the variant set to describe.',
                                                                                                                                   u'name': u'id',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'ID'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Gets a variant set by ID.'}},
                                                                                                   u'export': {u'capsule': u'*(ALPHA)* Exports data from a variant set to an external destination.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--bigquery-dataset': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The BigQuery dataset to which data is exported.  This dataset must already exist.  Note that this is distinct from the Genomics concept of "dataset."',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--bigquery-dataset',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': True,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'BIGQUERY_DATASET'},
                                                                                                                          u'--bigquery-project': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The Google Cloud project ID that owns the destination BigQuery dataset.  The caller must have WRITE access to this project.  This project will also own the resulting export job.If not supplied, defaults to the gcloud project ID.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--bigquery-project',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'BIGQUERY_PROJECT'},
                                                                                                                          u'--call-set-ids': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'If provided, only variant call information from the specified call sets will be exported. By default all variant call sets are exported.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--call-set-ids',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'CALL_SET_IDS'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'export',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'genomics',
                                                                                                                         u'variantsets',
                                                                                                                         u'export'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The ID of the variant set to export.',
                                                                                                                                 u'name': u'id',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'ID'},
                                                                                                                                {u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The BigQuery table to which data is exported.  If this table does not exist, it will be created.  If it already exists, it will be overwritten.',
                                                                                                                                 u'name': u'table',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'TABLE'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Exports data from a variant set to an external destination.'}},
                                                                                                   u'list': {u'capsule': u'*(ALPHA)* List Genomics variant sets in a dataset.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--limit',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_URI'},
                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--page-size',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'FIELD'},
                                                                                                                        u'--uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'URI'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'list',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'genomics',
                                                                                                                       u'variantsets',
                                                                                                                       u'list'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Restrict the query to variant sets within the given dataset.',
                                                                                                                               u'name': u'dataset-id',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'DATASET_ID'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Prints a table with summary information on variant sets in the dataset.'}},
                                                                                                   u'update': {u'capsule': u'*(ALPHA)* Updates a variant set name or description.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--description': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The new description of the variant set.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--description',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DESCRIPTION'},
                                                                                                                          u'--name': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The new name of the variant set.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'NAME'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'update',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'genomics',
                                                                                                                         u'variantsets',
                                                                                                                         u'update'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The ID of the variant set to update.',
                                                                                                                                 u'name': u'id',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'ID'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Updates a variant set name or description.'}}},
                                                                                     u'flags': {},
                                                                                     u'group': True,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'variantsets',
                                                                                     u'path': [u'gcloud',
                                                                                               u'alpha',
                                                                                               u'genomics',
                                                                                               u'variantsets'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'ALPHA',
                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to create, export, delete, list and describe variant sets.'}}},
                                                      u'flags': {},
                                                      u'group': True,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'genomics',
                                                      u'path': [u'gcloud',
                                                                u'alpha',
                                                                u'genomics'],
                                                      u'positionals': [],
                                                      u'release': u'ALPHA',
                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage Genomics resources using version 1 of the API.'}},
                                        u'init': {u'capsule': u'*(ALPHA)* Initialize or reinitialize gcloud.',
                                                  u'commands': {},
                                                  u'flags': {u'--console-only': {u'attr': {},
                                                                                 u'category': u'',
                                                                                 u'choices': [],
                                                                                 u'completer': u'',
                                                                                 u'default': False,
                                                                                 u'description': u'Prevent the command from launching a browser for authorization.',
                                                                                 u'group': u'',
                                                                                 u'hidden': False,
                                                                                 u'name': u'--console-only',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'type': u'bool',
                                                                                 u'value': u'CONSOLE_ONLY'},
                                                             u'--no-console-only': {u'attr': {},
                                                                                    u'category': u'',
                                                                                    u'choices': [],
                                                                                    u'completer': u'',
                                                                                    u'default': True,
                                                                                    u'description': u'',
                                                                                    u'group': u'',
                                                                                    u'hidden': True,
                                                                                    u'name': u'--no-console-only',
                                                                                    u'nargs': u'0',
                                                                                    u'required': False,
                                                                                    u'type': u'bool',
                                                                                    u'value': u'NO_CONSOLE_ONLY'},
                                                             u'--no-skip-diagnostics': {u'attr': {},
                                                                                        u'category': u'',
                                                                                        u'choices': [],
                                                                                        u'completer': u'',
                                                                                        u'default': True,
                                                                                        u'description': u'',
                                                                                        u'group': u'',
                                                                                        u'hidden': True,
                                                                                        u'name': u'--no-skip-diagnostics',
                                                                                        u'nargs': u'0',
                                                                                        u'required': False,
                                                                                        u'type': u'bool',
                                                                                        u'value': u'NO_SKIP_DIAGNOSTICS'},
                                                             u'--skip-diagnostics': {u'attr': {},
                                                                                     u'category': u'',
                                                                                     u'choices': [],
                                                                                     u'completer': u'',
                                                                                     u'default': False,
                                                                                     u'description': u'Do not run diagnostics.',
                                                                                     u'group': u'',
                                                                                     u'hidden': False,
                                                                                     u'name': u'--skip-diagnostics',
                                                                                     u'nargs': u'0',
                                                                                     u'required': False,
                                                                                     u'type': u'bool',
                                                                                     u'value': u'SKIP_DIAGNOSTICS'}},
                                                  u'group': False,
                                                  u'groups': {},
                                                  u'hidden': False,
                                                  u'name': u'init',
                                                  u'path': [u'gcloud',
                                                            u'alpha',
                                                            u'init'],
                                                  u'positionals': [{u'completer': u'',
                                                                    u'default': None,
                                                                    u'description': u'',
                                                                    u'name': u'obsolete-project-arg',
                                                                    u'nargs': u'?',
                                                                    u'required': False,
                                                                    u'value': u'OBSOLETE_PROJECT_ARG'}],
                                                  u'release': u'ALPHA',
                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* init launches an interactive Getting Started workflow for gcloud.\nIt performs the following setup steps:\n\n- Authorizes gcloud and other SDK tools to access Google Cloud Platform using\n  your user account credentials, or lets you select from accounts whose\n  credentials are already available.\n- Sets properties in a gcloud configuration, including the current project and\n  the default Google Compute Engine region and zone.\n\ninit can be used for initial setup of gcloud and to create new or\nreinitialize gcloud configurations. More information can be found by\nrunning `gcloud topic configurations`.\n\nProperties set by init are local and persistend, and are not affected by\nremote changes to the project. For example, the default Compute Engine zone in\nyour configuration remains stable, even if you or another user changes the\nproject-level default zone in the Cloud Platform Console.\n\nTo sync the configuration, re-run init'}},
                                        u'ml': {u'capsule': u'*(ALPHA)* Manage Cloud ML jobs and models.',
                                                u'commands': {u'init-project': {u'capsule': u'*(ALPHA)* Initialize project for Cloud ML.',
                                                                                u'commands': {},
                                                                                u'flags': {},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'init-project',
                                                                                u'path': [u'gcloud',
                                                                                          u'alpha',
                                                                                          u'ml',
                                                                                          u'init-project'],
                                                                                u'positionals': [],
                                                                                u'release': u'ALPHA',
                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Initialize project for Cloud ML.\n\ninit-project initializes the current project for use with Google Cloud\nMachine Learning. Specifically, it adds the required Cloud Machine\nLearning service accounts to the current project as editors.\n'}},
                                                              u'jobs': {u'capsule': u'*(ALPHA)* Cloud ML Jobs commands.',
                                                                        u'commands': {u'cancel': {u'capsule': u'*(ALPHA)* Cancel a running Cloud ML job.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {},
                                                                                                  u'group': False,
                                                                                                  u'groups': {},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'cancel',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'alpha',
                                                                                                            u'ml',
                                                                                                            u'jobs',
                                                                                                            u'cancel'],
                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Name of the job.',
                                                                                                                    u'name': u'job',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'JOB'}],
                                                                                                  u'release': u'ALPHA',
                                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* *cancel* cancels a running Cloud ML job. If the job is already finished,\nthe command will not perform an operation and exit successfully.'}},
                                                                                      u'describe': {u'capsule': u'*(ALPHA)* Describe a Cloud ML job.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'describe',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'alpha',
                                                                                                              u'ml',
                                                                                                              u'jobs',
                                                                                                              u'describe'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Name of the job.',
                                                                                                                      u'name': u'job',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'JOB'}],
                                                                                                    u'release': u'ALPHA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* Describe a Cloud ML job.'}},
                                                                                      u'list': {u'capsule': u'*(ALPHA)* List existing Cloud ML jobs.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--filter',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                           u'--limit': {u'attr': {},
                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--limit',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'LIMIT'},
                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': True,
                                                                                                                         u'description': u'',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': True,
                                                                                                                         u'name': u'--no-uri',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'NO_URI'},
                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--page-size',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--sort-by',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'list',
                                                                                                                          u'value': u'FIELD'},
                                                                                                           u'--uri': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': False,
                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--uri',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'bool',
                                                                                                                      u'value': u'URI'}},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'list',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'alpha',
                                                                                                          u'ml',
                                                                                                          u'jobs',
                                                                                                          u'list'],
                                                                                                u'positionals': [],
                                                                                                u'release': u'ALPHA',
                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* List existing Cloud ML jobs.'}},
                                                                                      u'stream-logs': {u'capsule': u'*(ALPHA)* Show logs from a running Cloud ML job.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--allow-multiline-logs': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'Output multiline log messages as single records.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--allow-multiline-logs',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'ALLOW_MULTILINE_LOGS'},
                                                                                                                  u'--no-allow-multiline-logs': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': True,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--no-allow-multiline-logs',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'NO_ALLOW_MULTILINE_LOGS'},
                                                                                                                  u'--polling-interval': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': 60,
                                                                                                                                          u'description': u'Number of seconds to wait between efforts to fetch the latest log messages.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--polling-interval',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'int',
                                                                                                                                          u'value': u'POLLING_INTERVAL'},
                                                                                                                  u'--task-name': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'If set, display only the logs for this particular task.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--task-name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'TASK_NAME'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'stream-logs',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'ml',
                                                                                                                 u'jobs',
                                                                                                                 u'stream-logs'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Name of the job.',
                                                                                                                         u'name': u'job',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'JOB'}],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Show logs from a running Cloud ML job.'}},
                                                                                      u'submit': {u'capsule': u'*(ALPHA)* Cloud ML Jobs submit commands.',
                                                                                                  u'commands': {u'prediction': {u'capsule': u'*(ALPHA)* Start a Cloud ML batch prediction job.',
                                                                                                                                u'commands': {},
                                                                                                                                u'flags': {u'--data-format': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [u'TEXT',
                                                                                                                                                                           u'TF_RECORD',
                                                                                                                                                                           u'TF_RECORD_GZIP'],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Data format of the input files. _DATA_FORMAT_ must be one of:\n+\n*TEXT*::: Text files with instances separated by the new-line character.\n*TF_RECORD*::: TFRecord files; see https://www.tensorflow.org/versions/r0.12/how_tos/reading_data/index.html#file-formats\n*TF_RECORD_GZIP*::: GZIP-compressed TFRecord files.\n+',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--data-format',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': True,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'DATA_FORMAT'},
                                                                                                                                           u'--input-paths': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Google Cloud Storage paths to the instances to run prediction on.\n+\nWildcards (```*```) accepted at the *end* of a path. More than one path can be\nspecified if multiple file patterns are needed. For example,\n+\n    gs://my-bucket/instances*,gs://my-bucket/other-instances1\n+\nwill match any objects whose names start with `instances` in `my-bucket` as well\nas the `other-instances1` bucket, while\n+\n    gs://my-bucket/instance-dir/*\n+\nwill match any objects in the `instance-dir` "directory" (since directories\naren\'t a first-class Cloud Storage concept) of `my-bucket`.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--input-paths',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': True,
                                                                                                                                                              u'type': u'list',
                                                                                                                                                              u'value': u'INPUT_PATHS'},
                                                                                                                                           u'--max-worker-count': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The maximum number of workers to be used for parallel processing. Defaults to 10 if not specified.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--max-worker-count',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'MAX_WORKER_COUNT'},
                                                                                                                                           u'--model': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Name of the model to use for prediction.',
                                                                                                                                                        u'group': u'prediction.1',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--model',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'MODEL'},
                                                                                                                                           u'--model-dir': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Google Cloud Storage location where the model files are located.',
                                                                                                                                                            u'group': u'prediction.1',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--model-dir',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'MODEL_DIR'},
                                                                                                                                           u'--output-path': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Google Cloud Storage path to which to save the output. Example: gs://my-bucket/output.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--output-path',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': True,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'OUTPUT_PATH'},
                                                                                                                                           u'--region': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The Google Compute Engine region to run the job in.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--region',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': True,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'REGION'},
                                                                                                                                           u'--runtime-version': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The Google Cloud ML runtime version for this job. Defaults to the latest stable version. See https://cloud.google.com/ml/docs/concepts/runtime-version-list for a list of accepted versions.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--runtime-version',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'RUNTIME_VERSION'}},
                                                                                                                                u'group': False,
                                                                                                                                u'groups': {u'prediction.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                              u'is_mutex': True,
                                                                                                                                                              u'is_required': True}},
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'prediction',
                                                                                                                                u'path': [u'gcloud',
                                                                                                                                          u'alpha',
                                                                                                                                          u'ml',
                                                                                                                                          u'jobs',
                                                                                                                                          u'submit',
                                                                                                                                          u'prediction'],
                                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Name of the batch prediction job.',
                                                                                                                                                  u'name': u'job',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'value': u'JOB'}],
                                                                                                                                u'release': u'ALPHA',
                                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Start a Cloud ML batch prediction job.'}},
                                                                                                                u'training': {u'capsule': u'*(ALPHA)* Submits a Cloud Machine Learning training job.',
                                                                                                                              u'commands': {},
                                                                                                                              u'flags': {u'--async': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--async',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'ASYNC'},
                                                                                                                                         u'--config': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Path to the job configuration file. The file should be a YAML document (JSON\nalso accepted) containing a Job resource as defined in the API (all fields are\noptional): https://cloud.google.com/ml/reference/rest/v1beta1/projects.jobs\n+\nIf an option is specified both in the configuration file *and* via command line\narguments, the command line arguments override the configuration file.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--config',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'CONFIG'},
                                                                                                                                         u'--job-dir': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'A Google Cloud Storage path in which to store training outputs and\nother data needed for training.\n+\nThis path will be passed to your TensorFlow program as `--job_dir`\ncommand-line arg. The benefit of specifying this field is that Cloud\nML will validate the path for use in training.\n+\nIf packages must be uploaded and `--staging-bucket` is not provided,\nthis path will be used instead.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--job-dir',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'JOB_DIR'},
                                                                                                                                         u'--module-name': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Name of the module to run',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--module-name',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': True,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'MODULE_NAME'},
                                                                                                                                         u'--no-async': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': True,
                                                                                                                                                         u'description': u'',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': True,
                                                                                                                                                         u'name': u'--no-async',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'NO_ASYNC'},
                                                                                                                                         u'--package-path': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Path to a Python package to build. This should point to a directory containing\nthe Python source for the job. It will be built using setuptools (which must be\ninstalled) using its *parent* directory as context. If the parent directory\ncontains a `setup.py` file, the build will use that; otherwise, it will use a\nsimple built-in one.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--package-path',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'PACKAGE_PATH'},
                                                                                                                                         u'--packages': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': [],
                                                                                                                                                         u'description': u'Path to Python archives used for training. These can be local paths\n(absolute or relative), in which case they will be uploaded to the Cloud\nStorage bucket given by `--staging-bucket`, or Cloud Storage URLs\n(`gs://bucket-name/path/to/package.tar.gz`).',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--packages',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'PACKAGE'},
                                                                                                                                         u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u"The region of the machine learning training job to submit. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--region',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'REGION'},
                                                                                                                                         u'--runtime-version': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The Google Cloud ML runtime version for this job. Defaults to the latest stable version. See https://cloud.google.com/ml/docs/concepts/runtime-version-list for a list of accepted versions.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--runtime-version',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'RUNTIME_VERSION'},
                                                                                                                                         u'--scale-tier': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [u'BASIC',
                                                                                                                                                                        u'BASIC_GPU',
                                                                                                                                                                        u'CUSTOM',
                                                                                                                                                                        u'PREMIUM_1',
                                                                                                                                                                        u'STANDARD_1'],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Specifies the machine types, the number of replicas for workers and parameter servers. _SCALE_TIER_ must be one of:\n+\n*BASIC*::: A single worker instance. This tier is suitable for learning how to use Cloud ML, and for experimenting with new models using small datasets.\n*BASIC_GPU*::: A single worker instance with a GPU.\n*CUSTOM*::: The CUSTOM tier is not a set tier, but rather enables you to use your own\ncluster specification. When you use this tier, set values to configure your\nprocessing cluster according to these guidelines (using the --config flag):\n+\n* You _must_ set `TrainingInput.masterType` to specify the type of machine to\n  use for your master node. This is the only required setting.\n* You _may_ set `TrainingInput.workerCount` to specify the number of workers to\n  use. If you specify one or more workers, you _must_ also set\n  `TrainingInput.workerType` to specify the type of machine to use for your\n  worker nodes.\n* You _may_ set `TrainingInput.parameterServerCount` to specify the number of\n  parameter servers to use. If you specify one or more parameter servers, you\n  _must_ also set `TrainingInput.parameterServerType` to specify the type of\n  machine to use for your parameter servers.  Note that all of your workers must\n  use the same machine type, which can be different from your parameter server\n  type and master type. Your parameter servers must likewise use the same\n  machine type, which can be different from your worker type and master type.\n*PREMIUM_1*::: A large number of workers with many parameter servers.\n*STANDARD_1*::: Many workers and a few parameter servers.\n+',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--scale-tier',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'SCALE_TIER'},
                                                                                                                                         u'--staging-bucket': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'Bucket in which to stage training archives.\n+\nRequired only if a file upload is necessary (that is, other flags\ninclude local paths) and no other flags implicitly specify an upload\npath.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--staging-bucket',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'STAGING_BUCKET'}},
                                                                                                                              u'group': False,
                                                                                                                              u'groups': {},
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'training',
                                                                                                                              u'path': [u'gcloud',
                                                                                                                                        u'alpha',
                                                                                                                                        u'ml',
                                                                                                                                        u'jobs',
                                                                                                                                        u'submit',
                                                                                                                                        u'training'],
                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Name of the job.',
                                                                                                                                                u'name': u'job',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'value': u'JOB'},
                                                                                                                                               {u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"Additional user arguments to be fowarded to user code\n+\nThe '--' argument must be specified between gcloud specific args on the left and USER_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                                                                                                                                u'name': u'user-args',
                                                                                                                                                u'nargs': u'...',
                                                                                                                                                u'required': False,
                                                                                                                                                u'value': u'USER_ARGS'}],
                                                                                                                              u'release': u'ALPHA',
                                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* This creates temporary files and executes Python code staged\nby a user on Google Cloud Storage. Model code can either be\nspecified with a path, e.g.:\n\n    $ training my_job \\\n            --module-name trainer.task \\\n            --staging-bucket gs://my-bucket \\\n            --package-path /my/code/path/trainer \\\n            --packages additional-dep1.tar.gz,dep2.whl\n\nOr by specifying an already built package:\n\n    $ training my_job \\\n            --module-name trainer.task \\\n            --staging-bucket gs://my-bucket \\\n            --packages trainer-0.0.1.tar.gz,additional-dep1.tar.gz,dep2.whl\n\nIf --package-path /my/code/path/trainer is specified and there is a\nsetup.py file at /my/code/path/setup.py then that file will be invoked\nwith `sdist` and the generated tar files will be uploaded to Cloud Storage.\nOtherwise a temporary setup.py file will be generated for the build.\n\nBy default, this command blocks until the job finishes, streaming the logs in\nthe meantime. If the job succeeds, the command exits zero; otherwise, it exits\nnon-zero. To avoid blocking, pass the `--async` flag.\n\nFor more information, see:\nhttps://cloud.google.com/ml/docs/concepts/training-overview'}}},
                                                                                                  u'flags': {},
                                                                                                  u'group': True,
                                                                                                  u'groups': {},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'submit',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'alpha',
                                                                                                            u'ml',
                                                                                                            u'jobs',
                                                                                                            u'submit'],
                                                                                                  u'positionals': [],
                                                                                                  u'release': u'ALPHA',
                                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud ML Jobs submit commands.'}}},
                                                                        u'flags': {},
                                                                        u'group': True,
                                                                        u'groups': {},
                                                                        u'hidden': False,
                                                                        u'name': u'jobs',
                                                                        u'path': [u'gcloud',
                                                                                  u'alpha',
                                                                                  u'ml',
                                                                                  u'jobs'],
                                                                        u'positionals': [],
                                                                        u'release': u'ALPHA',
                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud ML Jobs commands.'}},
                                                              u'local': {u'capsule': u'*(ALPHA)* Cloud ML Local commands.',
                                                                         u'commands': {u'predict': {u'capsule': u'*(ALPHA)* Run prediction locally.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--json-instances': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Path to a local file from which instances are read.\nInstances are in JSON format; newline delimited.\n+\nAn example of the JSON instances file:\n+\n    {"images": [0.0, ..., 0.1], "key": 3}\n    {"images": [0.0, ..., 0.1], "key": 2}\n    ...\n+\nThis flag accepts "-" for stdin.',
                                                                                                                                     u'group': u'predict.1',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--json-instances',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'JSON_INSTANCES'},
                                                                                                               u'--model-dir': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Path to the model.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--model-dir',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'MODEL_DIR'},
                                                                                                               u'--text-instances': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Path to a local file from which instances are read.\nInstances are in UTF-8 encoded text format; newline delimited.\n+\nAn example of the text instances file:\n+\n    107,4.9,2.5,4.5,1.7\n    100,5.7,2.8,4.1,1.3\n    ...\n+\nThis flag accepts "-" for stdin.',
                                                                                                                                     u'group': u'predict.1',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--text-instances',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'TEXT_INSTANCES'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {u'predict.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                               u'is_mutex': True,
                                                                                                                               u'is_required': True}},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'predict',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'alpha',
                                                                                                              u'ml',
                                                                                                              u'local',
                                                                                                              u'predict'],
                                                                                                    u'positionals': [],
                                                                                                    u'release': u'ALPHA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* *predict* performs prediction locally with the given instances. It\nrequires the TensorFlow SDK be installed locally. Only Debian based systems\nare supported at this time.'}},
                                                                                       u'train': {u'capsule': u'*(ALPHA)* Run a Cloud ML training job locally.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {u'--distributed': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Runs the provided code in distributed mode by providing cluster configurations as environment variables to subprocesses',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--distributed',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'DISTRIBUTED'},
                                                                                                             u'--module-name': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Name of the module to run',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--module-name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'MODULE_NAME'},
                                                                                                             u'--no-distributed': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-distributed',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_DISTRIBUTED'},
                                                                                                             u'--package-path': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Path to a Python package to build. This should point to a directory containing\nthe Python source for the job. It will be built using setuptools (which must be\ninstalled) using its *parent* directory as context. If the parent directory\ncontains a `setup.py` file, the build will use that; otherwise, it will use a\nsimple built-in one.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--package-path',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PACKAGE_PATH'},
                                                                                                             u'--parameter-server-count': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Number of parameter servers with which to run. Ignored if --distributed is not specified. Default: 2',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--parameter-server-count',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'PARAMETER_SERVER_COUNT'},
                                                                                                             u'--start-port': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': 27182,
                                                                                                                               u'description': u'Start of the range of ports reserved by the local cluster. This command will use\na contiguous block of ports equal to parameter-server-count + worker-count + 1.\n+\nIf --distributed is not specified, this flag is ignored.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--start-port',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'int',
                                                                                                                               u'value': u'START_PORT'},
                                                                                                             u'--worker-count': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Number of workers with which to run. Ignored if --distributed is not specified. Default: 2',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--worker-count',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'WORKER_COUNT'}},
                                                                                                  u'group': False,
                                                                                                  u'groups': {},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'train',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'alpha',
                                                                                                            u'ml',
                                                                                                            u'local',
                                                                                                            u'train'],
                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"Additional user arguments to be fowarded to user code. Any relative paths will\nbe relative to the *parent* directory of `--package-path`.\n+\n\nThe '--' argument must be specified between gcloud specific args on the left and USER_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                                                                                                    u'name': u'user-args',
                                                                                                                    u'nargs': u'...',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'USER_ARGS'}],
                                                                                                  u'release': u'ALPHA',
                                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command runs the specified module in an environment\nsimilar to that of a live Cloud ML Training Job.\n\nThis is especially useful in the case of testing distributed models,\nas it allows you to validate that you are properly interacting with the\nCloud ML cluster configuration. If your model expects a specific\nnumber of parameter servers or workers (i.e. you expect to use the CUSTOM\nmachine type), use the --parameter-server-count and --worker-count flags to\nfurther specify the desired cluster configuration, just as you would in\nyour cloud training job configuration:\n\n    $ train --module-name trainer.task \\\n            --package-path /path/to/my/code/trainer \\\n            --distributed \\\n            --parameter-server-count 4 \\\n            --worker-count 8\n\nUnlike submitting a training job, the --package-path parameter can be\nomitted, and will use your current working directory.'}}},
                                                                         u'flags': {},
                                                                         u'group': True,
                                                                         u'groups': {},
                                                                         u'hidden': False,
                                                                         u'name': u'local',
                                                                         u'path': [u'gcloud',
                                                                                   u'alpha',
                                                                                   u'ml',
                                                                                   u'local'],
                                                                         u'positionals': [],
                                                                         u'release': u'ALPHA',
                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud ML Local commands.'}},
                                                              u'models': {u'capsule': u'*(ALPHA)* Cloud ML Models commands.',
                                                                          u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create a new Cloud ML model.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--enable-logging': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'If set, enables StackDriver Logging for online prediction.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--enable-logging',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'ENABLE_LOGGING'},
                                                                                                               u'--no-enable-logging': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-enable-logging',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ENABLE_LOGGING'},
                                                                                                               u'--regions': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"Comma separated list of Google Cloud regions where the model will be deployed.\nCurrently only one region per model is supported.\n+\nWill soon be required, but defaults to 'us-central1' for now.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--regions',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'REGION'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'create',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'alpha',
                                                                                                              u'ml',
                                                                                                              u'models',
                                                                                                              u'create'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Name of the model.',
                                                                                                                      u'name': u'model',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'MODEL'}],
                                                                                                    u'release': u'ALPHA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* Create a new Cloud ML model.'}},
                                                                                        u'delete': {u'capsule': u'*(ALPHA)* Delete an existing Cloud ML model.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'delete',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'alpha',
                                                                                                              u'ml',
                                                                                                              u'models',
                                                                                                              u'delete'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Name of the model.',
                                                                                                                      u'name': u'model',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'MODEL'}],
                                                                                                    u'release': u'ALPHA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* Delete an existing Cloud ML model.'}},
                                                                                        u'describe': {u'capsule': u'*(ALPHA)* Describe an existing Cloud ML model.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'describe',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'ml',
                                                                                                                u'models',
                                                                                                                u'describe'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Name of the model.',
                                                                                                                        u'name': u'model',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'MODEL'}],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Describe an existing Cloud ML model.'}},
                                                                                        u'list': {u'capsule': u'*(ALPHA)* List existing Cloud ML models.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--filter',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'EXPRESSION'},
                                                                                                             u'--limit': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--limit',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'LIMIT'},
                                                                                                             u'--no-uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': True,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_URI'},
                                                                                                             u'--page-size': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--page-size',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                                             u'--sort-by': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--sort-by',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'list',
                                                                                                                            u'value': u'FIELD'},
                                                                                                             u'--uri': {u'attr': {},
                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--uri',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'URI'}},
                                                                                                  u'group': False,
                                                                                                  u'groups': {},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'list',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'alpha',
                                                                                                            u'ml',
                                                                                                            u'models',
                                                                                                            u'list'],
                                                                                                  u'positionals': [],
                                                                                                  u'release': u'ALPHA',
                                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* List existing Cloud ML models.'}}},
                                                                          u'flags': {},
                                                                          u'group': True,
                                                                          u'groups': {},
                                                                          u'hidden': False,
                                                                          u'name': u'models',
                                                                          u'path': [u'gcloud',
                                                                                    u'alpha',
                                                                                    u'ml',
                                                                                    u'models'],
                                                                          u'positionals': [],
                                                                          u'release': u'ALPHA',
                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* A Cloud ML model is a container representing an ML application or service.\nA model may contain multiple versions which act as the implementation of\nthe service. See also $ gcloud beta ml versions --help.\n\nFor more information, please see\nhttps://cloud.google.com/ml/docs/concepts/technical-overview#models'}},
                                                              u'operations': {u'capsule': u'*(ALPHA)* Manage Cloud ML operations.',
                                                                              u'commands': {u'cancel': {u'capsule': u'*(ALPHA)* Cancel a Cloud ML operation.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'cancel',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'ml',
                                                                                                                  u'operations',
                                                                                                                  u'cancel'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Name of the operation.',
                                                                                                                          u'name': u'operation',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'OPERATION'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cancel a Cloud ML operation.'}},
                                                                                            u'delete': {u'capsule': u'*(ALPHA)* Delete a Cloud ML operation.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'delete',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'ml',
                                                                                                                  u'operations',
                                                                                                                  u'delete'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Name of the operation.',
                                                                                                                          u'name': u'operation',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'OPERATION'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Delete a Cloud ML operation.'}},
                                                                                            u'describe': {u'capsule': u'*(ALPHA)* Describe a Cloud ML operation.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'describe',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'ml',
                                                                                                                    u'operations',
                                                                                                                    u'describe'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Name of the operation.',
                                                                                                                            u'name': u'operation',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'OPERATION'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* Describe a Cloud ML operation.'}},
                                                                                            u'list': {u'capsule': u'*(ALPHA)* List existing Cloud ML jobs.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'ml',
                                                                                                                u'operations',
                                                                                                                u'list'],
                                                                                                      u'positionals': [],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* List existing Cloud ML jobs.'}},
                                                                                            u'wait': {u'capsule': u'*(ALPHA)* Wait for a Cloud ML operation to complete.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'wait',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'ml',
                                                                                                                u'operations',
                                                                                                                u'wait'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Name of the operation.',
                                                                                                                        u'name': u'operation',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'OPERATION'}],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Given an operation ID, this command polls the operation and blocks until it\ncompletes. At completion, the operation message is printed (which includes the\noperation response).'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'operations',
                                                                              u'path': [u'gcloud',
                                                                                        u'alpha',
                                                                                        u'ml',
                                                                                        u'operations'],
                                                                              u'positionals': [],
                                                                              u'release': u'ALPHA',
                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage Cloud ML operations.'}},
                                                              u'predict': {u'capsule': u'*(ALPHA)* Run Cloud ML online prediction.',
                                                                           u'commands': {},
                                                                           u'flags': {u'--json-instances': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Path to a local file from which instances are read.\nInstances are in JSON format; newline delimited.\n+\nAn example of the JSON instances file:\n+\n    {"images": [0.0, ..., 0.1], "key": 3}\n    {"images": [0.0, ..., 0.1], "key": 2}\n    ...\n+\nThis flag accepts "-" for stdin.',
                                                                                                            u'group': u'predict.1',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--json-instances',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'JSON_INSTANCES'},
                                                                                      u'--model': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'Name of the model.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--model',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': True,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'MODEL'},
                                                                                      u'--text-instances': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Path to a local file from which instances are read.\nInstances are in UTF-8 encoded text format; newline delimited.\n+\nAn example of the text instances file:\n+\n    107,4.9,2.5,4.5,1.7\n    100,5.7,2.8,4.1,1.3\n    ...\n+\nThis flag accepts "-" for stdin.',
                                                                                                            u'group': u'predict.1',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--text-instances',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'TEXT_INSTANCES'}},
                                                                           u'group': False,
                                                                           u'groups': {u'predict.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                      u'is_mutex': True,
                                                                                                      u'is_required': True}},
                                                                           u'hidden': False,
                                                                           u'name': u'predict',
                                                                           u'path': [u'gcloud',
                                                                                     u'alpha',
                                                                                     u'ml',
                                                                                     u'predict'],
                                                                           u'positionals': [],
                                                                           u'release': u'ALPHA',
                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* `predict` sends a prediction request to Cloud ML for the given instances.\nThis command will only accept up to 100 instances at a time. If you are\npredicting on more instances, you should use batch prediction via\n$ gcloud beta ml jobs submit prediction.'}},
                                                              u'versions': {u'capsule': u'*(ALPHA)* Cloud ML Versions commands.',
                                                                            u'commands': {u'delete': {u'capsule': u'*(ALPHA)* Delete an existing Cloud ML version.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--model': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Name of the model.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--model',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'MODEL'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'delete',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'ml',
                                                                                                                u'versions',
                                                                                                                u'delete'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Name of the model version.',
                                                                                                                        u'name': u'version',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'VERSION'}],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Delete an existing Cloud ML version.'}},
                                                                                          u'describe': {u'capsule': u'*(ALPHA)* Describe an existing Cloud ML version.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--model': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Name of the model.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--model',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'MODEL'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'describe',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'ml',
                                                                                                                  u'versions',
                                                                                                                  u'describe'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Name of the model version.',
                                                                                                                          u'name': u'version',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'VERSION'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Describe an existing Cloud ML version.'}},
                                                                                          u'list': {u'capsule': u'*(ALPHA)* List existing Cloud ML versions.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--filter',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                               u'--limit': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--limit',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'LIMIT'},
                                                                                                               u'--model': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Name of the model.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--model',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': True,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'MODEL'},
                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': True,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_URI'},
                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--page-size',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--sort-by',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'FIELD'},
                                                                                                               u'--uri': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--uri',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'URI'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'list',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'alpha',
                                                                                                              u'ml',
                                                                                                              u'versions',
                                                                                                              u'list'],
                                                                                                    u'positionals': [],
                                                                                                    u'release': u'ALPHA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* List existing Cloud ML versions.'}},
                                                                                          u'set-default': {u'capsule': u'*(ALPHA)* Sets an existing Cloud ML version as the default for its model.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--model': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Name of the model.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--model',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'MODEL'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'set-default',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'ml',
                                                                                                                     u'versions',
                                                                                                                     u'set-default'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Name of the model version.',
                                                                                                                             u'name': u'version',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'VERSION'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* *set-default* sets an existing Cloud ML version as the default for its model.\nOnly one version may be the default for a given version.'}}},
                                                                            u'flags': {},
                                                                            u'group': True,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'versions',
                                                                            u'path': [u'gcloud',
                                                                                      u'alpha',
                                                                                      u'ml',
                                                                                      u'versions'],
                                                                            u'positionals': [],
                                                                            u'release': u'ALPHA',
                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* A version is an implementation of a model, represented as a serialized\nTensorFlow graph with trained parameters.\n\nWhen you communicate with Cloud ML services, you use the combination of\nthe model, version, and current project to identify a specific model\nimplementation that is deployed in the cloud.'}}},
                                                u'flags': {},
                                                u'group': True,
                                                u'groups': {},
                                                u'hidden': False,
                                                u'name': u'ml',
                                                u'path': [u'gcloud',
                                                          u'alpha',
                                                          u'ml'],
                                                u'positionals': [],
                                                u'release': u'ALPHA',
                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* The ml command group lets you manage Google Cloud ML jobs and training\nmodels.\n\nCloud ML is a managed service that enables you to easily build machine\nlearning models, that work on any type of data, of any size. Create your model\nwith the powerful TensorFlow framework that powers many Google products, from\nGoogle Photos to Google Cloud Speech.\n\nMore information on Cloud ML can be found here: https://cloud.google.com/ml\nand detailed documentation can be found here:\nhttps://cloud.google.com/ml/docs/'}},
                                        u'organizations': {u'capsule': u'*(ALPHA)* Create and manage Google Cloud Platform Organizations.',
                                                           u'commands': {u'add-iam-policy-binding': {u'capsule': u'*(ALPHA)* Add IAM policy binding for a organization.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--member': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The member to add to the binding.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--member',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'MEMBER'},
                                                                                                                u'--role': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Define the role of the member.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--role',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': True,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'ROLE'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'add-iam-policy-binding',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'alpha',
                                                                                                               u'organizations',
                                                                                                               u'add-iam-policy-binding'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'ID for the organization to which you want to add a binding',
                                                                                                                       u'name': u'id',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'ORGANIZATION_ID'}],
                                                                                                     u'release': u'ALPHA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Adds a policy binding to the IAM policy of an organization,\ngiven an organization ID and the binding.',
                                                                                                                   u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on a organization with\nidentifier '123456789'\n\n  $ add-iam-policy-binding 123456789 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                         u'describe': {u'capsule': u'*(ALPHA)* Show metadata for an organization.',
                                                                                       u'commands': {},
                                                                                       u'flags': {},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'describe',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'alpha',
                                                                                                 u'organizations',
                                                                                                 u'describe'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'ID for the organization you want to describe.',
                                                                                                         u'name': u'id',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'value': u'ORGANIZATION_ID'}],
                                                                                       u'release': u'ALPHA',
                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Shows metadata for an organization, given a valid organization ID.\n\nThis command can fail for the following reasons:\n    * The organization specified does not exist.\n    * The active account does not have permission to access the given\n      organization.',
                                                                                                     u'EXAMPLES': u'The following command prints metadata for an organization with the\nID `3589215982`:\n\n  $ describe 3589215982\n'}},
                                                                         u'get-iam-policy': {u'capsule': u'*(ALPHA)* Get IAM policy for an organization.',
                                                                                             u'commands': {},
                                                                                             u'flags': {},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'get-iam-policy',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'alpha',
                                                                                                       u'organizations',
                                                                                                       u'get-iam-policy'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'ID for the organization whose policy you want to get.',
                                                                                                               u'name': u'id',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'ORGANIZATION_ID'}],
                                                                                             u'release': u'ALPHA',
                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Gets the IAM policy for an organization, given an organization ID.',
                                                                                                           u'EXAMPLES': u'The following command prints the IAM policy for an organization with\nthe ID `123456789`:\n\n  $ get-iam-policy 123456789\n'}},
                                                                         u'list': {u'capsule': u'*(ALPHA)* List organizations accessible by the active account.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--filter',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'EXPRESSION'},
                                                                                              u'--limit': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--limit',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'LIMIT'},
                                                                                              u'--no-uri': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': True,
                                                                                                            u'description': u'',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': True,
                                                                                                            u'name': u'--no-uri',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'NO_URI'},
                                                                                              u'--page-size': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--page-size',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                              u'--sort-by': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--sort-by',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'list',
                                                                                                             u'value': u'FIELD'},
                                                                                              u'--uri': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': False,
                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--uri',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'URI'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'list',
                                                                                   u'path': [u'gcloud',
                                                                                             u'alpha',
                                                                                             u'organizations',
                                                                                             u'list'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'ALPHA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists all organizations to which the user has access. Organizations are listed\nin an unspecified order.'}},
                                                                         u'remove-iam-policy-binding': {u'capsule': u'*(ALPHA)* Remove IAM policy binding for a organization.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--member': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The member to remove from the binding.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--member',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': True,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'MEMBER'},
                                                                                                                   u'--role': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The role to remove the member from.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--role',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': True,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'ROLE'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'remove-iam-policy-binding',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'organizations',
                                                                                                                  u'remove-iam-policy-binding'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'ID for the organization whose IAM binding you want to remove.',
                                                                                                                          u'name': u'id',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'ORGANIZATION_ID'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Removes a policy binding to the IAM policy of an organization, given an\norganization ID\nand the binding.',
                                                                                                                      u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on organization with\nidentifier 'example-organization-id-1'\n\n  $ remove-iam-policy-binding example-organization-id-1 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                         u'set-iam-policy': {u'capsule': u'*(ALPHA)* Set IAM policy for an organization.',
                                                                                             u'commands': {},
                                                                                             u'flags': {},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'set-iam-policy',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'alpha',
                                                                                                       u'organizations',
                                                                                                       u'set-iam-policy'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'ID for the organization whose IAM policy you want to set.',
                                                                                                               u'name': u'id',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'ORGANIZATION_ID'},
                                                                                                              {u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'JSON or YAML file containing the IAM policy.',
                                                                                                               u'name': u'policy-file',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'POLICY_FILE'}],
                                                                                             u'release': u'ALPHA',
                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Given an organization ID and a file encoded in JSON or YAML that contains the\nIAM policy, this command will set the IAM policy for that organization.',
                                                                                                           u'EXAMPLES': u'The following command reads an IAM policy defined in a JSON\nfile `policy.json` and sets it for an organization with the ID\n`123456789`:\n\n  $ set-iam-policy 123456789 policy.json'}}},
                                                           u'flags': {},
                                                           u'group': True,
                                                           u'groups': {},
                                                           u'hidden': False,
                                                           u'name': u'organizations',
                                                           u'path': [u'gcloud',
                                                                     u'alpha',
                                                                     u'organizations'],
                                                           u'positionals': [],
                                                           u'release': u'ALPHA',
                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* The organizations group lets you create and manage Cloud Organizations.\nGoogle Cloud Platform resources form a hierarchy with Organizations at the\nroot. Organizations contain projects, and Projects contain the remaining\nGoogle Cloud Platform resources.\n\nMore information on the Cloud Platform Resource Hierarchy and the Organization\nresource can be found here:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-organization\nand detailed documentation on creating and managing organizations can be found\nhere:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-organization'}},
                                        u'projects': {u'capsule': u'*(ALPHA)* Create and manage project access policies.',
                                                      u'commands': {u'add-iam-policy-binding': {u'capsule': u'*(ALPHA)* Add IAM policy binding for a project.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--member': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The member to add to the binding.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--member',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': True,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'MEMBER'},
                                                                                                           u'--role': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Define the role of the member.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--role',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': True,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'ROLE'}},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'add-iam-policy-binding',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'alpha',
                                                                                                          u'projects',
                                                                                                          u'add-iam-policy-binding'],
                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'ID for the project you want to add IAM policy binding to.',
                                                                                                                  u'name': u'id',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'value': u'PROJECT_ID'}],
                                                                                                u'release': u'ALPHA',
                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Adds a policy binding to the IAM policy of a project,\ngiven a project ID and the binding.',
                                                                                                              u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on a project with\nidentifier 'example-project-id-1'\n\n  $ add-iam-policy-binding example-project-id-1 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                    u'create': {u'capsule': u'*(ALPHA)* Create a new project.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--enable-cloud-apis': {u'attr': {u'inverted_synopsis': True},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': True,
                                                                                                                    u'description': u'Enable cloudapis.googleapis.com during creation. Enabled by default, use *--no-enable-cloud-apis* to disable.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--enable-cloud-apis',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'ENABLE_CLOUD_APIS'},
                                                                                           u'--folder': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'ID for the folder to use as a parent',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--folder',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'FOLDER_ID'},
                                                                                           u'--labels': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--labels',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'dict',
                                                                                                         u'value': u'KEY=VALUE'},
                                                                                           u'--name': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Name for the project you want to create. If not specified, will use project id as name.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'NAME'},
                                                                                           u'--no-enable-cloud-apis': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': True,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-enable-cloud-apis',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_ENABLE_CLOUD_APIS'},
                                                                                           u'--no-set-as-default': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-set-as-default',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_SET_AS_DEFAULT'},
                                                                                           u'--organization': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'ID for the organization to use as a parent',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--organization',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'ORGANIZATION_ID'},
                                                                                           u'--set-as-default': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'Set newly created project as [core.project] property.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--set-as-default',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'SET_AS_DEFAULT'}},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'create',
                                                                                u'path': [u'gcloud',
                                                                                          u'alpha',
                                                                                          u'projects',
                                                                                          u'create'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'ID for the project you want to create.\n+\nProject IDs must start with a lowercase letter and can have lowercase ASCII letters, digits or hyphens. Project IDs must be between 6 and 30 characters.',
                                                                                                  u'name': u'id',
                                                                                                  u'nargs': u'?',
                                                                                                  u'required': False,
                                                                                                  u'value': u'PROJECT_ID'}],
                                                                                u'release': u'ALPHA',
                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Creates a new project with the given project ID.\n\n## EXAMPLES\n\nThe following command creates a project with ID `example-foo-bar-1`, name\n`Happy project` and label `type=happy`:\n\n  $ create example-foo-bar-1 --name="Happy project" --labels=type=happy\n\nThe following command creates a project with ID `example-2` with parent\n`folders/12345`:\n\n  $ create example-2 --folder=12345\n\nThe following command creates a project with ID `example-3` with parent\n`organizations/2048`:\n\n  $ create example-3 --organization=2048'}},
                                                                    u'delete': {u'capsule': u'*(ALPHA)* Delete a project.',
                                                                                u'commands': {},
                                                                                u'flags': {},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'delete',
                                                                                u'path': [u'gcloud',
                                                                                          u'alpha',
                                                                                          u'projects',
                                                                                          u'delete'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'ID for the project you want to delete.',
                                                                                                  u'name': u'id',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'PROJECT_ID'}],
                                                                                u'release': u'ALPHA',
                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes the project with the given project ID.\n\nThis command can fail for the following reasons:\n* The project specified does not exist.\n* The active account does not have Owner permissions for the given project.\n\n## EXAMPLES\n\nThe following command deletes the project with the ID `example-foo-bar-1`:\n\n  $ delete example-foo-bar-1'}},
                                                                    u'describe': {u'capsule': u'*(ALPHA)* Show metadata for a project.',
                                                                                  u'commands': {},
                                                                                  u'flags': {},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'describe',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'projects',
                                                                                            u'describe'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'ID for the project you want to describe.',
                                                                                                    u'name': u'id',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'PROJECT_ID'}],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Shows metadata for a project given a valid project ID.\n\nThis command can fail for the following reasons:\n* The project specified does not exist.\n* The active account does not have permission to access the given project.\n\n## EXAMPLES\n\nThe following command prints metadata for a project with the ID\n`example-foo-bar-1`:\n\n  $ describe example-foo-bar-1'}},
                                                                    u'get-iam-policy': {u'capsule': u'*(ALPHA)* Get IAM policy for a project.',
                                                                                        u'commands': {},
                                                                                        u'flags': {},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'get-iam-policy',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'alpha',
                                                                                                  u'projects',
                                                                                                  u'get-iam-policy'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'ID for the project you want to get IAM policy for.',
                                                                                                          u'name': u'id',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'PROJECT_ID'}],
                                                                                        u'release': u'ALPHA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Gets the IAM policy for a project, given a project ID.\n\n## EXAMPLES\n\nThe following command prints the IAM policy for a project with the ID\n`example-project-id-1`:\n\n  $ get-iam-policy example-project-id-1'}},
                                                                    u'list': {u'capsule': u'*(ALPHA)* List projects accessible by the active account.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--filter',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'EXPRESSION'},
                                                                                         u'--limit': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--limit',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'LIMIT'},
                                                                                         u'--no-uri': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': True,
                                                                                                       u'description': u'',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': True,
                                                                                                       u'name': u'--no-uri',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'NO_URI'},
                                                                                         u'--page-size': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--page-size',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                         u'--sort-by': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--sort-by',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'list',
                                                                                                        u'value': u'FIELD'},
                                                                                         u'--uri': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': False,
                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--uri',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'URI'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'list',
                                                                              u'path': [u'gcloud',
                                                                                        u'alpha',
                                                                                        u'projects',
                                                                                        u'list'],
                                                                              u'positionals': [],
                                                                              u'release': u'ALPHA',
                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists all active projects, where the active account has Owner, Editor or\nViewer permissions. Projects are listed in alphabetical order by project name.\nProjects that have been deleted or are pending deletion are not included.\n\nYou can specify the maximum number of projects to list using the `--limit`\nflag.\n\n## EXAMPLES\n\nThe following command lists a maximum of five projects sorted alphabetically\nby name:\n\n  $ list --limit=5'}},
                                                                    u'move': {u'capsule': u'*(ALPHA)* Move a project into an organization.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--folder': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'ID for the folder to use as a parent',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--folder',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'FOLDER_ID'},
                                                                                         u'--organization': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'ID for the organization to use as a parent',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--organization',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'ORGANIZATION_ID'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'move',
                                                                              u'path': [u'gcloud',
                                                                                        u'alpha',
                                                                                        u'projects',
                                                                                        u'move'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'ID for the project you want to move.',
                                                                                                u'name': u'id',
                                                                                                u'nargs': u'0',
                                                                                                u'required': False,
                                                                                                u'value': u'PROJECT_ID'}],
                                                                              u'release': u'ALPHA',
                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Moves the given project into the given organization.\n\nThis command can fail for the following reasons:\n    * There is no project with the given ID.\n    * There is no organization with the given ID, if an organization is given\n      as the destination.\n    * There is no folder with the given ID, if a folder is given as the\n      destination.\n    * More than one of organization or folder is provided.\n    * The new destination is not in the same organization as the project, if\n      the project is already in an organization.\n    * The active account does not have  the\n      resourcemanager.projects.update permission for the given\n      project.\n    * The active account does not have  the\n      resourcemanager.projects.create permission for the given\n      organization.\n    * The given project is already in an organization.\n\n## EXAMPLES\n\nThe following command moves a project with the ID `super-awesome-project` into\nthe organization `25872158`:\n\n  $ move super-awesome-project --organization=25872158'}},
                                                                    u'remove-iam-policy-binding': {u'capsule': u'*(ALPHA)* Remove IAM policy binding for a project.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {u'--member': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The member to remove from the binding.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--member',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': True,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'MEMBER'},
                                                                                                              u'--role': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The role to remove the member from.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--role',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': True,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'ROLE'}},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'remove-iam-policy-binding',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'alpha',
                                                                                                             u'projects',
                                                                                                             u'remove-iam-policy-binding'],
                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'ID for the project you want to remove IAM policy binding from.',
                                                                                                                     u'name': u'id',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'PROJECT_ID'}],
                                                                                                   u'release': u'ALPHA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Removes a policy binding to the IAM policy of a project, given a project ID\nand the binding.',
                                                                                                                 u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on project with\nidentifier 'example-project-id-1'\n\n  $ remove-iam-policy-binding example-project-id-1 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                    u'set-iam-policy': {u'capsule': u'*(ALPHA)* Set IAM policy for a project.',
                                                                                        u'commands': {},
                                                                                        u'flags': {},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'set-iam-policy',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'alpha',
                                                                                                  u'projects',
                                                                                                  u'set-iam-policy'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'ID for the project you want to set IAM policy for.',
                                                                                                          u'name': u'id',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'PROJECT_ID'},
                                                                                                         {u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'JSON or YAML file with the IAM policy',
                                                                                                          u'name': u'policy-file',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'POLICY_FILE'}],
                                                                                        u'release': u'ALPHA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Sets the IAM policy for a project, given a project ID and a file encoded in\nJSON or YAML that contains the IAM policy.\n\n## EXAMPLES\n\nThe following command reads an IAM policy defined in a JSON file `policy.json`\nand sets it for a project with the ID `example-project-id-1`:\n\n  $ set-iam-policy example-project-id-1 policy.json'}},
                                                                    u'undelete': {u'capsule': u'*(ALPHA)* Undelete a project.',
                                                                                  u'commands': {},
                                                                                  u'flags': {},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'undelete',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'projects',
                                                                                            u'undelete'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'ID for the project you want to undelete.',
                                                                                                    u'name': u'id',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'PROJECT_ID'}],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Undeletes the project with the given project ID.\n\nThis command can fail for the following reasons:\n* There is no project with the given ID.\n* The active account does not have Owner or Editor permissions for the\n  given project.\n\n## EXAMPLES\n\nThe following command undeletes the project with the ID `example-foo-bar-1`:\n\n  $ undelete example-foo-bar-1'}},
                                                                    u'update': {u'capsule': u'*(ALPHA)* Update the name and/or labels of a project.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--name': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'New name for the project.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'NAME'},
                                                                                           u'--remove-labels': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'A list of label keys to remove. If a label does not exist it is\nsilently ignored.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--remove-labels',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'list',
                                                                                                                u'value': u'KEY'},
                                                                                           u'--update-labels': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'A list of label KEY=VALUE pairs to update. If a label exists its value\nis modified, otherwise a new label is created.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--update-labels',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'dict',
                                                                                                                u'value': u'KEY=VALUE'}},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'update',
                                                                                u'path': [u'gcloud',
                                                                                          u'alpha',
                                                                                          u'projects',
                                                                                          u'update'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'ID for the project you want to update.',
                                                                                                  u'name': u'id',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'PROJECT_ID'}],
                                                                                u'release': u'ALPHA',
                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* Update the the name and/or labels of the given project.\n\nThis command can fail for the following reasons:\n* There is no project with the given ID.\n* The active account does not have Owner or Editor permissions for the\n  given project.\n\n## EXAMPLES\n\nThe following command updates a project with the ID\n`example-foo-bar-1` to have the name "Foo Bar & Grill" and removes the\nlabel `dive`:\n\n  $ update example-foo-bar-1 --name="Foo Bar & Grill" --remove-labels=dive'}}},
                                                      u'flags': {},
                                                      u'group': True,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'projects',
                                                      u'path': [u'gcloud',
                                                                u'alpha',
                                                                u'projects'],
                                                      u'positionals': [],
                                                      u'release': u'ALPHA',
                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* The projects group lets you create and manage IAM policies for projects on\nthe Google Cloud Platform. Resources are organized hierarchically and assigned\nto a particular project.  A Project resource is required to use Google Cloud\nPlatform, and forms the basis for creating, enabling and using all Cloud\nPlatform services, managing APIs, enabling billing, adding and removing\ncollaborators, and managing permissions.\n\nMore information on the Cloud Platform Resource Hierarchy and the project\nresource can be found here:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-organization\nand detailed documentation on creating and managing projects can be found\nhere:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-projects'}},
                                        u'pubsub': {u'capsule': u'*(ALPHA)* Manage Cloud Pub/Sub topics and subscriptions.',
                                                    u'commands': {u'snapshots': {u'capsule': u'*(ALPHA)* These features are part of an invite-only release of the Cloud Pub/Sub API.',
                                                                                 u'commands': {u'create': {u'capsule': u'*(ALPHA)* This feature is part of an invite-only release of the Cloud Pub/Sub API.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--subscription': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"The subscription whose backlog the snapshot retains.  Specifically, the created snapshot is guaranteed to retain a) The existing backlog on the subscription, i.e., the set of messages in the subscription that are unacknowledged upon the successful completion of the create snapshot request, b) Any messages published to the subscription's topic following the successful creation of the snapshot.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--subscription',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'SUBSCRIPTION'},
                                                                                                                      u'--subscription-project': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': u'',
                                                                                                                                                  u'description': u'The name of the project the provided subscription belongs to. If not set, it defaults to the currently selected cloud project.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--subscription-project',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'SUBSCRIPTION_PROJECT'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'create',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'pubsub',
                                                                                                                     u'snapshots',
                                                                                                                     u'create'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'One or more snapshot names to create.',
                                                                                                                             u'name': u'snapshot',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'SNAPSHOT'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* Creates one or more Cloud Pub/Sub snapshots.\nThis feature is part of an invitation-only release of the underlying\nCloud Pub/Sub API. The command will generate errors unless you have access to\nthis API. This restriction should be relaxed in the near future. Please\ncontact cloud-pubsub@google.com with any questions in the meantime.'}},
                                                                                               u'delete': {u'capsule': u'*(ALPHA)* This feature is part of an invite-only release of the Cloud Pub/Sub API.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'delete',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'pubsub',
                                                                                                                     u'snapshots',
                                                                                                                     u'delete'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'One or more snapshot names to delete.',
                                                                                                                             u'name': u'snapshot',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'SNAPSHOT'}],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes one or more Cloud Pub/Sub snapshots.\nThis feature is part of an invitation-only release of the underlying\nCloud Pub/Sub API. The command will generate errors unless you have access to\nthis API. This restriction should be relaxed in the near future. Please\ncontact cloud-pubsub@google.com with any questions in the meantime.'}},
                                                                                               u'list': {u'capsule': u'*(ALPHA)* This feature is part of an invite-only release of the Cloud Pub/Sub API.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'pubsub',
                                                                                                                   u'snapshots',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists all the snapshots in a given project.\nThis feature is part of an invitation-only release of the underlying\nCloud Pub/Sub API. The command will generate errors unless you have access to\nthis API. This restriction should be relaxed in the near future. Please\ncontact cloud-pubsub@google.com with any questions in the meantime.'}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'snapshots',
                                                                                 u'path': [u'gcloud',
                                                                                           u'alpha',
                                                                                           u'pubsub',
                                                                                           u'snapshots'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'ALPHA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage Cloud Pub/Sub snapshots.\nThese features are part of an invitation-only release of the underlying\nCloud Pub/Sub API. These commands will generate errors unless you have access\nto this API. This restriction should be relaxed in the near future. Please\ncontact cloud-pubsub@google.com with any questions in the meantime.'}},
                                                                  u'subscriptions': {u'capsule': u'*(ALPHA)* Manage Cloud Pubsub subscriptions.',
                                                                                     u'commands': {u'ack': {u'capsule': u'*(ALPHA)* Acknowledges one or more messages on the specified subscription.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'ack',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'pubsub',
                                                                                                                      u'subscriptions',
                                                                                                                      u'ack'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Subscription name to ACK messages on.',
                                                                                                                              u'name': u'subscription',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'SUBSCRIPTION'},
                                                                                                                             {u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'One or more AckId to acknowledge.',
                                                                                                                              u'name': u'ackid',
                                                                                                                              u'nargs': u'+',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'ACKID'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Acknowledges one or more messages as having been successfully received.\nIf a delivered message is not acknowledged, Cloud Pub/Sub will attempt to\ndeliver it again.'}},
                                                                                                   u'create': {u'capsule': u'*(ALPHA)* Creates one or more Cloud Pub/Sub subscriptions.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--ack-deadline': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The number of seconds the system will wait for a subscriber to acknowledge receiving a message before re-attempting delivery.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--ack-deadline',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'ACK_DEADLINE'},
                                                                                                                          u'--message-retention-duration': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'How long to retain unacknowledged messages in the subscription\'s backlog, from the moment a message is published.  If --retain-acked-messages is true, this also configures the retention of acknowledged messages.  The default value is 7 days, the minimum is 10 minutes, and the maximum is 7 days.  Valid values are strings of the form INTEGER[UNIT], where UNIT is one of "s", "m", "h", and "d" for seconds, seconds, minutes, hours, and days, respectively.  If the unit is omitted, seconds is assumed.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--message-retention-duration',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'MESSAGE_RETENTION_DURATION'},
                                                                                                                          u'--no-retain-acked-messages': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-retain-acked-messages',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_RETAIN_ACKED_MESSAGES'},
                                                                                                                          u'--push-endpoint': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'A URL to use as the endpoint for this subscription. This will also automatically set the subscription type to PUSH.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--push-endpoint',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PUSH_ENDPOINT'},
                                                                                                                          u'--retain-acked-messages': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u"Whether or not to retain acknowledged messages.  If true, messages are not expunged from the subscription's backlog until they fall out of the --message-retention-duration window.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--retain-acked-messages',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'RETAIN_ACKED_MESSAGES'},
                                                                                                                          u'--topic': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the topic from which this subscription is receiving messages. Each subscription is attached to a single topic.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--topic',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'TOPIC'},
                                                                                                                          u'--topic-project': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The name of the project the provided topic belongs to. If not set, it defaults to the currently selected cloud project.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--topic-project',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'TOPIC_PROJECT'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'create',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'pubsub',
                                                                                                                         u'subscriptions',
                                                                                                                         u'create'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'One or more subscriptions to create.',
                                                                                                                                 u'name': u'subscription',
                                                                                                                                 u'nargs': u'+',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'SUBSCRIPTION'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Creates one or more Cloud Pub/Sub subscriptions for a given topic.\nThe new subscription defaults to a PULL subscription unless a push endpoint\nis specified.'}},
                                                                                                   u'delete': {u'capsule': u'*(ALPHA)* Deletes one or more Cloud Pub/Sub subscriptions.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'delete',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'pubsub',
                                                                                                                         u'subscriptions',
                                                                                                                         u'delete'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'One or more subscription names to delete.',
                                                                                                                                 u'name': u'subscription',
                                                                                                                                 u'nargs': u'+',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'SUBSCRIPTION'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes one or more Cloud Pub/Sub subscriptions.'}},
                                                                                                   u'list': {u'capsule': u'*(ALPHA)* Lists Cloud Pub/Sub subscriptions.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--limit',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_URI'},
                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--page-size',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'FIELD'},
                                                                                                                        u'--uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'URI'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'list',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'pubsub',
                                                                                                                       u'subscriptions',
                                                                                                                       u'list'],
                                                                                                             u'positionals': [],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists all of the Cloud Pub/Sub subscriptions that exist in a given project.'}},
                                                                                                   u'modify-ack-deadline': {u'capsule': u'*(ALPHA)* Modifies the ACK deadline for a specific Cloud Pub/Sub message.',
                                                                                                                            u'commands': {},
                                                                                                                            u'flags': {u'--ack-deadline': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The number of seconds the system will wait for a subscriber to acknowledge receiving a message before re-attempting delivery.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--ack-deadline',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': True,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'ACK_DEADLINE'}},
                                                                                                                            u'group': False,
                                                                                                                            u'groups': {},
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'modify-ack-deadline',
                                                                                                                            u'path': [u'gcloud',
                                                                                                                                      u'alpha',
                                                                                                                                      u'pubsub',
                                                                                                                                      u'subscriptions',
                                                                                                                                      u'modify-ack-deadline'],
                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Name of the subscription messages belong to.',
                                                                                                                                              u'name': u'subscription',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'value': u'SUBSCRIPTION'},
                                                                                                                                             {u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'One or more ACK_ID that identify the messages to modify the deadline for.',
                                                                                                                                              u'name': u'ackid',
                                                                                                                                              u'nargs': u'+',
                                                                                                                                              u'required': False,
                                                                                                                                              u'value': u'ACKID'}],
                                                                                                                            u'release': u'ALPHA',
                                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* This method is useful to indicate that more time is needed to process a\nmessage by the subscriber, or to make the message available for\nredelivery if the processing was interrupted.'}},
                                                                                                   u'modify-push-config': {u'capsule': u'*(ALPHA)* Modifies the push configuration of a Cloud Pub/Sub subscription.',
                                                                                                                           u'commands': {},
                                                                                                                           u'flags': {u'--push-endpoint': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'A URL to use as the endpoint for this subscription. This will also automatically set the subscription type to PUSH.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--push-endpoint',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': True,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'PUSH_ENDPOINT'}},
                                                                                                                           u'group': False,
                                                                                                                           u'groups': {},
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'modify-push-config',
                                                                                                                           u'path': [u'gcloud',
                                                                                                                                     u'alpha',
                                                                                                                                     u'pubsub',
                                                                                                                                     u'subscriptions',
                                                                                                                                     u'modify-push-config'],
                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Name of the subscription to modify.',
                                                                                                                                             u'name': u'subscription',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'SUBSCRIPTION'}],
                                                                                                                           u'release': u'ALPHA',
                                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* Modifies the push configuration of a Cloud Pub/Sub subscription.'}},
                                                                                                   u'pull': {u'capsule': u'*(ALPHA)* Pulls one or more Cloud Pub/Sub messages from a subscription.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--auto-ack': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Automatically ACK every message pulled from this subscription.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--auto-ack',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'AUTO_ACK'},
                                                                                                                        u'--filter': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--limit',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                        u'--max-messages': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': 1,
                                                                                                                                            u'description': u'The maximum number of messages that Cloud Pub/Sub can return in this response.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--max-messages',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'int',
                                                                                                                                            u'value': u'MAX_MESSAGES'},
                                                                                                                        u'--no-auto-ack': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-auto-ack',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_AUTO_ACK'},
                                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_URI'},
                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--page-size',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'FIELD'},
                                                                                                                        u'--uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'URI'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'pull',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'pubsub',
                                                                                                                       u'subscriptions',
                                                                                                                       u'pull'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Name of subscription to pull messages from.',
                                                                                                                               u'name': u'subscription',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'SUBSCRIPTION'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Returns one or more messages from the specified Cloud Pub/Sub subscription,\nif there are any messages enqueued.'}},
                                                                                                   u'seek': {u'capsule': u'*(ALPHA)* This feature is part of an invite-only release of the Cloud Pub/Sub API.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--snapshot': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The name of the snapshot. The snapshot's topic must be the same as that of the subscription.",
                                                                                                                                        u'group': u'seek.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--snapshot',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'SNAPSHOT'},
                                                                                                                        u'--snapshot-project': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': u'',
                                                                                                                                                u'description': u'The name of the project the snapshot belongs to (if seeking to a snapshot). If not set, it defaults to the currently selected cloud project.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--snapshot-project',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'SNAPSHOT_PROJECT'},
                                                                                                                        u'--time': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The time to seek to. Messages in the subscription that were published before this time are marked as acknowledged, and messages retained in the subscription that were published after this time are marked as unacknowledged. See `gcloud topic datetimes` for information on time formats.',
                                                                                                                                    u'group': u'seek.1',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--time',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'TIME'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {u'seek.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': True}},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'seek',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'pubsub',
                                                                                                                       u'subscriptions',
                                                                                                                       u'seek'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Name of the subscription to affect.',
                                                                                                                               u'name': u'subscription',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'SUBSCRIPTION'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u"*(ALPHA)* Resets a subscription's backlog to a point in time or to a given snapshot.\nThis feature is part of an invitation-only release of the underlying\nCloud Pub/Sub API. The command will generate errors unless you have access to\nthis API. This restriction should be relaxed in the near future. Please\ncontact cloud-pubsub@google.com with any questions in the meantime."}},
                                                                                                   u'update': {u'capsule': u'*(ALPHA)* This feature is part of an invite-only release of the Cloud Pub/Sub API.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--ack-deadline': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The number of seconds the system will wait for a subscriber to acknowledge receiving a message before re-attempting delivery.  If set to 0, the system default to be used.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--ack-deadline',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'ACK_DEADLINE'},
                                                                                                                          u'--message-retention-duration': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'How long to retain unacknowledged messages in the subscription\'s backlog, from the moment a message is published.  If --retain-acked-messages is true, this also configures the retention of acknowledged messages.  Specify "default" to use the default value.  Valid values are strings of the form INTEGER[UNIT] or "default", where UNIT is one of "s", "m", "h", and "d" for seconds, minutes, hours, and days, respectively.  If the unit is omitted, seconds is assumed.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--message-retention-duration',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'MESSAGE_RETENTION_DURATION'},
                                                                                                                          u'--no-retain-acked-messages': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-retain-acked-messages',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_RETAIN_ACKED_MESSAGES'},
                                                                                                                          u'--push-endpoint': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'A URL to use as the endpoint for this subscription. This will also automatically set the subscription type to PUSH.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--push-endpoint',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PUSH_ENDPOINT'},
                                                                                                                          u'--retain-acked-messages': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u"Whether or not to retain acknowledged messages.  If true, messages are not expunged from the subscription's backlog until they fall out of the --message-retention-duration window.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--retain-acked-messages',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'RETAIN_ACKED_MESSAGES'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'update',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'pubsub',
                                                                                                                         u'subscriptions',
                                                                                                                         u'update'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Name of the subscription to update.',
                                                                                                                                 u'name': u'subscription',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'SUBSCRIPTION'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Updates an existing Cloud Pub/Sub subscription.\nThis feature is part of an invitation-only release of the underlying\nCloud Pub/Sub API. The command will generate errors unless you have access to\nthis API. This restriction should be relaxed in the near future. Please\ncontact cloud-pubsub@google.com with any questions in the meantime.'}}},
                                                                                     u'flags': {},
                                                                                     u'group': True,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'subscriptions',
                                                                                     u'path': [u'gcloud',
                                                                                               u'alpha',
                                                                                               u'pubsub',
                                                                                               u'subscriptions'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'ALPHA',
                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage Cloud Pubsub subscriptions.'}},
                                                                  u'topics': {u'capsule': u'*(ALPHA)* Manage Cloud Pubsub topics.',
                                                                              u'commands': {u'create': {u'capsule': u'*(ALPHA)* Creates one or more Cloud Pub/Sub topics.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'create',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'pubsub',
                                                                                                                  u'topics',
                                                                                                                  u'create'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'One or more topic names to create.',
                                                                                                                          u'name': u'topic',
                                                                                                                          u'nargs': u'+',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'TOPIC'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Creates one or more Cloud Pub/Sub topics.'}},
                                                                                            u'delete': {u'capsule': u'*(ALPHA)* Deletes one or more Cloud Pub/Sub topics.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'delete',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'pubsub',
                                                                                                                  u'topics',
                                                                                                                  u'delete'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'One or more topic names to delete.',
                                                                                                                          u'name': u'topic',
                                                                                                                          u'nargs': u'+',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'TOPIC'}],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Deletes one or more Cloud Pub/Sub topics.'}},
                                                                                            u'list': {u'capsule': u'*(ALPHA)* Lists Cloud Pub/Sub topics within a project.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'pubsub',
                                                                                                                u'topics',
                                                                                                                u'list'],
                                                                                                      u'positionals': [],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists all of the Cloud Pub/Sub topics that exist in a given project that\nmatch the given topic name filter.',
                                                                                                                    u'EXAMPLES': u'To filter results by topic name (ie. only show topic \'mytopic\'), run:\n\n  $ list --filter=topicId:mytopic\n\nTo combine multiple filters (with AND or OR), run:\n\n  $ list --filter="topicId:mytopic AND topicId:myothertopic"\n\nTo filter topics that match an expression:\n\n  $ list --filter="topicId:mytopic_*"\n'}},
                                                                                            u'list-subscriptions': {u'capsule': u'*(ALPHA)* Lists Cloud Pub/Sub subscriptions from a given topic.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--filter',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--limit',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'FIELD'},
                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'URI'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'list-subscriptions',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'pubsub',
                                                                                                                              u'topics',
                                                                                                                              u'list-subscriptions'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the topic to list subscriptions for.',
                                                                                                                                      u'name': u'topic',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'TOPIC'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* Lists all of the Cloud Pub/Sub subscriptions attached to the given topic and\nthat match the given filter.',
                                                                                                                                  u'EXAMPLES': u'To filter results by subscription name\n(ie. only show subscription \'mysubs\'), run:\n\n  $ list-subscriptions --topic mytopic --filter=subscriptionId:mysubs\n\nTo combine multiple filters (with AND or OR), run:\n\n  $ list-subscriptions --topic mytopic --filter="subscriptionId:mysubs1 AND subscriptionId:mysubs2"\n\nTo filter subscriptions that match an expression:\n\n  $ list-subscriptions --topic mytopic --filter="subscriptionId:subs_*"\n'}},
                                                                                            u'publish': {u'capsule': u'*(ALPHA)* Publishes a message to the specified topic.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--attribute': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Comma-separated list of attributes. Each ATTRIBUTE has the form "name=value". You can specify up to 100 attributes.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--attribute',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'dict',
                                                                                                                                     u'value': u'ATTRIBUTE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'publish',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'pubsub',
                                                                                                                   u'topics',
                                                                                                                   u'publish'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Topic name to publish messages to.',
                                                                                                                           u'name': u'topic',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'TOPIC'},
                                                                                                                          {u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The body of the message to publish to the given topic name.\nInformation on message formatting and size limits can be found at:\nhttps://cloud.google.com/pubsub/docs/publisher#publish',
                                                                                                                           u'name': u'message-body',
                                                                                                                           u'nargs': u'?',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'MESSAGE_BODY'}],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* Publishes a message to the specified topic name for testing and\ntroubleshooting. Use with caution: all associated subscribers must be\nable to consume and acknowledge any message you publish, otherwise the\nsystem will continuously re-attempt delivery of the bad message for 7 days.'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'topics',
                                                                              u'path': [u'gcloud',
                                                                                        u'alpha',
                                                                                        u'pubsub',
                                                                                        u'topics'],
                                                                              u'positionals': [],
                                                                              u'release': u'ALPHA',
                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage Cloud Pubsub topics.'}}},
                                                    u'flags': {},
                                                    u'group': True,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'pubsub',
                                                    u'path': [u'gcloud',
                                                              u'alpha',
                                                              u'pubsub'],
                                                    u'positionals': [],
                                                    u'release': u'ALPHA',
                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage Cloud Pub/Sub topics and subscriptions.'}},
                                        u'search-help': {u'capsule': u'*(ALPHA)* Search the help text of gcloud commands.',
                                                         u'commands': {},
                                                         u'flags': {},
                                                         u'group': False,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'search-help',
                                                         u'path': [u'gcloud',
                                                                   u'alpha',
                                                                   u'search-help'],
                                                         u'positionals': [{u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u'Term to search for.',
                                                                           u'name': u'term',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'value': u'TERM'}],
                                                         u'release': u'ALPHA',
                                                         u'sections': {u'DESCRIPTION': u'Search the help text of gcloud commands for a term\nof interest. Prints the command name and a summary\nof the help text for any general release command whose\nhelp text contains the searched term.'}},
                                        u'service-management': {u'capsule': u'*(ALPHA)* Create, enable and manage API services.',
                                                                u'commands': {u'add-iam-policy-binding': {u'capsule': u'*(ALPHA)* Add IAM policy binding for a service.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--member': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The member to add to the binding.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--member',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'MEMBER'},
                                                                                                                     u'--role': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Define the role of the member.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--role',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': True,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'ROLE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'add-iam-policy-binding',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'service-management',
                                                                                                                    u'add-iam-policy-binding'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the service to which the member is to be added.',
                                                                                                                            u'name': u'service',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'SERVICE'}],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u"*(ALPHA)* Adds IAM policy binding to a service's access policy.",
                                                                                                                        u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/servicemanagement.serviceConsumer' for the user 'test-user@gmail.com' on a service with\nidentifier 'my-service'\n\n  $ add-iam-policy-binding my-service --member='user:test-user@gmail.com' --role='roles/servicemanagement.serviceConsumer'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                              u'check-iam-policy': {u'capsule': u"*(ALPHA)* Returns information about a member's permissions on a service.",
                                                                                                    u'commands': {},
                                                                                                    u'flags': {},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'check-iam-policy',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'alpha',
                                                                                                              u'service-management',
                                                                                                              u'check-iam-policy'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The name of the service for which to check the IAM policy.',
                                                                                                                      u'name': u'service',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'SERVICE'}],
                                                                                                    u'release': u'ALPHA',
                                                                                                    u'sections': {u'DESCRIPTION': u'This command lists the permissions that the current authenticated\ngcloud user has for a service. For example, if the authenticated user is\nable to delete the service, `servicemanagement.services.delete` will\nbe among the returned permissions.\n',
                                                                                                                  u'EXAMPLES': u'To check the permissions for the currently authenticated gcloud, run:\n\n  $ check-iam-policy my_produced_service_name\n'}},
                                                                              u'configs': {u'capsule': u'*(ALPHA)* View configurations for various services.',
                                                                                           u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Describes the configuration for a given version of a service.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--service': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The service from which to retrieve the configuration.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--service',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'SERVICE'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'describe',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'service-management',
                                                                                                                                 u'configs',
                                                                                                                                 u'describe'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The configuration ID to retrieve.',
                                                                                                                                         u'name': u'config-id',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'CONFIG_ID'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'This command prints out the configuration for the given version of a\ngiven service. You specify the name of the service and the ID of the\nconfiguration, and the command will print out the specified config.\n',
                                                                                                                                     u'EXAMPLES': u"To print the configuration with ID ``2017-01-01R0'' for the service\ncalled ``my-service'', run:\n\n  $ describe --service my-service 2017-01-01R0\n"}},
                                                                                                         u'list': {u'capsule': u'*(ALPHA)* Lists the configurations for a given service.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--filter',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--limit',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--page-size',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                              u'--service': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The name of service for which to list existing configurations.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--service',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': True,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'SERVICE'},
                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'FIELD'},
                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'URI'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'list',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'service-management',
                                                                                                                             u'configs',
                                                                                                                             u'list'],
                                                                                                                   u'positionals': [],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'This command lists all the configurations for a given service by ID.\n\nTo get more detailed information about a specific configuration, run:\n\n  $ configs describe\n',
                                                                                                                                 u'EXAMPLES': u'To list the configurations for a service named `my-service`, run:\n\n  $ list --service my-service\n'}}},
                                                                                           u'flags': {},
                                                                                           u'group': True,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'configs',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'alpha',
                                                                                                     u'service-management',
                                                                                                     u'configs'],
                                                                                           u'positionals': [],
                                                                                           u'release': u'ALPHA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* View configurations for various services.'}},
                                                                              u'convert-config': {u'capsule': u'*(ALPHA)* Convert Swagger specification to Google service configuration.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {},
                                                                                                  u'group': False,
                                                                                                  u'groups': {},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'convert-config',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'alpha',
                                                                                                            u'service-management',
                                                                                                            u'convert-config'],
                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The file path containing the Open API specification to convert.',
                                                                                                                    u'name': u'open-api-file',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'OPEN_API_FILE'},
                                                                                                                   {u'completer': u'',
                                                                                                                    u'default': u'',
                                                                                                                    u'description': u'The file path of the output file containing the converted configuration. Output to standard output if omitted.',
                                                                                                                    u'name': u'output-file',
                                                                                                                    u'nargs': u'?',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'OUTPUT_FILE'}],
                                                                                                  u'release': u'ALPHA',
                                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* DEPRECATED: This command is deprecated and will be removed soon.'}},
                                                                              u'delete': {u'capsule': u'*(ALPHA)* Deletes a service.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--async': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--async',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'ASYNC'},
                                                                                                     u'--no-async': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-async',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_ASYNC'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'delete',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'alpha',
                                                                                                    u'service-management',
                                                                                                    u'delete'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the service to delete.',
                                                                                                            u'name': u'service',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'SERVICE'}],
                                                                                          u'release': u'ALPHA',
                                                                                          u'sections': {u'DESCRIPTION': u'Deletes a service from Google Service Management.\n\nServices that are deleted will be retained in the system for 30 days.\nIf a deleted service is still within this retention window, it can be\nundeleted with the undelete command.\n',
                                                                                                        u'EXAMPLES': u'To delete a service named `my-service`, run:\n\n  $ delete my-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ delete my-service --async\n'}},
                                                                              u'deploy': {u'capsule': u'*(ALPHA)* Deploys a service configuration for the given service name.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--async': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--async',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'ASYNC'},
                                                                                                     u'--no-async': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-async',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_ASYNC'},
                                                                                                     u'--no-validate-only': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': True,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-validate-only',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_VALIDATE_ONLY'},
                                                                                                     u'--validate-only': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'If included, the command will only validate the service configuration(s). No configuration(s) will be persisted.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--validate-only',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'VALIDATE_ONLY'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'deploy',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'alpha',
                                                                                                    u'service-management',
                                                                                                    u'deploy'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The service configuration file (or files) containing the API specification to upload. Proto Descriptors, Open API (Swagger) specifications, and Google Service Configuration files in JSON and YAML formats are acceptable.',
                                                                                                            u'name': u'service-config-file',
                                                                                                            u'nargs': u'+',
                                                                                                            u'required': False,
                                                                                                            u'value': u'SERVICE_CONFIG_FILE'}],
                                                                                          u'release': u'ALPHA',
                                                                                          u'sections': {u'DESCRIPTION': u'This command is used to deploy a service configuration for a service\nto Google Service Management. As input, it takes one or more paths\nto service configurations that should be uploaded. These configuration\nfiles can be Proto Descriptors, Open API (Swagger) specifications,\nor Google Service Configuration files in JSON or YAML formats.\n\nIf a service name is present in multiple configuration files (given\nin the `host` field in OpenAPI specifications or the `name` field in\nGoogle Service Configuration files), the first one will take precedence.\n\nThis command will block until deployment is complete unless the\n`--async` flag is passed.\n',
                                                                                                        u'EXAMPLES': u'To deploy a single Open API service configuration, run:\n\n  $ deploy ~/my_app/openapi.json\n\nTo run the deployment asynchronously (non-blocking), run:\n\n  $ deploy ~/my_app/openapi.json --async\n\nTo deploy a service config with a Proto, run:\n\n  $ deploy ~/my_app/service-config.yaml ~/my_app/service-protos.pb\n'}},
                                                                              u'describe': {u'capsule': u'*(ALPHA)* Describes a service given a service name.',
                                                                                            u'commands': {},
                                                                                            u'flags': {},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'describe',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'alpha',
                                                                                                      u'service-management',
                                                                                                      u'describe'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the service to describe.',
                                                                                                              u'name': u'service',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'SERVICE'}],
                                                                                            u'release': u'ALPHA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Describes a service given a service name.'}},
                                                                              u'disable': {u'capsule': u'*(ALPHA)* Disables a service for consumption for a project.',
                                                                                           u'commands': {},
                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--async',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'ASYNC'},
                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': True,
                                                                                                                      u'description': u'',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': True,
                                                                                                                      u'name': u'--no-async',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'bool',
                                                                                                                      u'value': u'NO_ASYNC'}},
                                                                                           u'group': False,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'disable',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'alpha',
                                                                                                     u'service-management',
                                                                                                     u'disable'],
                                                                                           u'positionals': [{u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The name of the service to disable.',
                                                                                                             u'name': u'service',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'value': u'SERVICE'}],
                                                                                           u'release': u'ALPHA',
                                                                                           u'sections': {u'DESCRIPTION': u'This command disables a previously-enabled service for consumption.\n\nTo see a list of the enabled services for a project, run:\n\n  $ service-management list --enabled\n\nMore information on listing services can be found at:\nhttps://cloud.google.com/service-management/list-services and on\ndisabling a service at:\nhttps://cloud.google.com/service-management/enable-disable#disabling_services\n',
                                                                                                         u'EXAMPLES': u'To disable a service called `my-consumed-service` for the active\nproject, run:\n\n  $ disable my-consumed-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ disable my-consumed-service --async\n'}},
                                                                              u'enable': {u'capsule': u'*(ALPHA)* Enables a service for consumption for a project.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--async': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--async',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'ASYNC'},
                                                                                                     u'--no-async': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-async',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_ASYNC'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'enable',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'alpha',
                                                                                                    u'service-management',
                                                                                                    u'enable'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the service to enable.',
                                                                                                            u'name': u'service',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'SERVICE'}],
                                                                                          u'release': u'ALPHA',
                                                                                          u'sections': {u'DESCRIPTION': u'This command enables a service for consumption for a project.\n\nTo see a list of available services for a project, run:\n\n  $ service-management list --available\n\nMore information on listing services can be found at:\nhttps://cloud.google.com/service-management/list-services and on\nenabling a service at:\nhttps://cloud.google.com/service-management/enable-disable#enabling_services\n',
                                                                                                        u'EXAMPLES': u'To enable a service called `my-consumed-service` on the current\nproject, run:\n\n  $ enable my-consumed-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ enable my-consumed-service --async\n'}},
                                                                              u'get-iam-policy': {u'capsule': u'*(ALPHA)* Describes the IAM policy for a service.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {},
                                                                                                  u'group': False,
                                                                                                  u'groups': {},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'get-iam-policy',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'alpha',
                                                                                                            u'service-management',
                                                                                                            u'get-iam-policy'],
                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The name of the service whose IAM policy is to be described.',
                                                                                                                    u'name': u'service',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'SERVICE'}],
                                                                                                  u'release': u'ALPHA',
                                                                                                  u'sections': {u'DESCRIPTION': u'Gets the IAM policy for a produced service, given the service name.\n',
                                                                                                                u'EXAMPLES': u'To print the IAM policy for a service named `my-service`, run:\n\n  $ get-iam-policy my-service\n'}},
                                                                              u'list': {u'capsule': u'*(ALPHA)* List services for a project.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--available': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'Return the services available to the project to enable. This list will include any services that the project has already enabled. Or use one of --enabled or --produced.',
                                                                                                                    u'group': u'list.1',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--available',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'AVAILABLE'},
                                                                                                   u'--enabled': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'(DEFAULT) Return the services which the project has enabled. Or use one of --produced or --available.',
                                                                                                                  u'group': u'list.1',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--enabled',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'ENABLED'},
                                                                                                   u'--filter': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--filter',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                   u'--limit': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--limit',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'LIMIT'},
                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--page-size',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                   u'--produced': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u'Return the services that the project has produced. Or use one of --enabled or --available.',
                                                                                                                   u'group': u'list.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--produced',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'PRODUCED'},
                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--sort-by',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'list',
                                                                                                                  u'value': u'FIELD'}},
                                                                                        u'group': False,
                                                                                        u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                u'is_mutex': True,
                                                                                                                u'is_required': False}},
                                                                                        u'hidden': False,
                                                                                        u'name': u'list',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'alpha',
                                                                                                  u'service-management',
                                                                                                  u'list'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'ALPHA',
                                                                                        u'sections': {u'DESCRIPTION': u'This command lists the services that are produced, enabled, or\navailable to be enabled by a project. You can choose the mode in\nwhich the command will list services by using exactly one of the\n`--produced`, `--enabled`, or `--available` flags.\n`--produced` is the default.\n',
                                                                                                      u'EXAMPLES': u'To list the services the current project produces, run:\n\n  $ list --produced\n\nTo list the services the current project has enabled for consumption,\nrun:\n\n  $ list --enabled\n\nTo list the services the current project can enable for consumption,\nrun:\n\n  $ list --available\n'}},
                                                                              u'operations': {u'capsule': u'*(ALPHA)* Manage Operation for various services.',
                                                                                              u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Describes an operation resource for a given operation name.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--full': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'Print the entire operation resource, which could be large. By default, a summary will be printed instead.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--full',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'FULL'},
                                                                                                                                     u'--no-full': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-full',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_FULL'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'describe',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'alpha',
                                                                                                                                    u'service-management',
                                                                                                                                    u'operations',
                                                                                                                                    u'describe'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the operation to describe.',
                                                                                                                                            u'name': u'operation',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'OPERATION'}],
                                                                                                                          u'release': u'ALPHA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'This command will return information about an operation given the name\nof that operation.\n\nThe amount of information inside an operation can be very large, so by\ndefault, only a summary is returned. If you want the entire operation\nresource, you can include the `--full` flag.\n\nNote that the `operations/` prefix of the operation name is optional\nand may be omitted.\n',
                                                                                                                                        u'EXAMPLES': u'To describe an operation resource named\n`operations/serviceConfigs.my-service.1`, run:\n\n  $ describe serviceConfigs.my-service.1\n\nTo get the full operation resource, run:\n\n  $ describe serviceConfigs.my-service.1 --full\n'}},
                                                                                                            u'wait': {u'capsule': u'*(ALPHA)* Waits for an operation to complete.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'wait',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'alpha',
                                                                                                                                u'service-management',
                                                                                                                                u'operations',
                                                                                                                                u'wait'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the operation on which to wait.',
                                                                                                                                        u'name': u'operation',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'OPERATION'}],
                                                                                                                      u'release': u'ALPHA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'This command will block until an operation has been marked as complete.\n\nNote that the `operations/` prefix of the operation name is optional\nand may be omitted.\n',
                                                                                                                                    u'EXAMPLES': u'To wait on an operation named `operations/serviceConfigs.my-service.1`\nto complete, run:\n\n  $ wait serviceConfigs.my-service.1\n'}}},
                                                                                              u'flags': {},
                                                                                              u'group': True,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'operations',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'alpha',
                                                                                                        u'service-management',
                                                                                                        u'operations'],
                                                                                              u'positionals': [],
                                                                                              u'release': u'ALPHA',
                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage Operation for various services.'}},
                                                                              u'remove-iam-policy-binding': {u'capsule': u'*(ALPHA)* Remove IAM policy binding for a service.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--member': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The member to remove from the binding.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--member',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'MEMBER'},
                                                                                                                        u'--role': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The role to remove the member from.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--role',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'ROLE'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'remove-iam-policy-binding',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'service-management',
                                                                                                                       u'remove-iam-policy-binding'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the service from which the member is to be removed.',
                                                                                                                               u'name': u'service',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'SERVICE'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u"*(ALPHA)* Removes an IAM policy binding from a service's access policy.",
                                                                                                                           u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/servicemanagement.serviceConsumer' for the user 'test-user@gmail.com' on service with\nidentifier 'my-service'\n\n  $ remove-iam-policy-binding my-service --member='user:test-user@gmail.com' --role='roles/servicemanagement.serviceConsumer'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                              u'undelete': {u'capsule': u'*(ALPHA)* Undeletes a service given a service name.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--async': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--async',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'ASYNC'},
                                                                                                       u'--no-async': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': True,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-async',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_ASYNC'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'undelete',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'alpha',
                                                                                                      u'service-management',
                                                                                                      u'undelete'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the service to undelete.',
                                                                                                              u'name': u'service',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'SERVICE'}],
                                                                                            u'release': u'ALPHA',
                                                                                            u'sections': {u'DESCRIPTION': u'Undeletes a service configuration that was previously deleted.\n\nServices that are deleted will be retained in the system for 30 days.\nIf a deleted service is still within this retention window, it can be\nundeleted with this command.\n\nNote that this means that this command will not be effective for\nservice configurations marked for deletion more than 30 days ago.\n',
                                                                                                          u'EXAMPLES': u'To undelete a service named `my-service`, run:\n\n  $ undelete my-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ undelete my-service --async\n'}}},
                                                                u'flags': {},
                                                                u'group': True,
                                                                u'groups': {},
                                                                u'hidden': False,
                                                                u'name': u'service-management',
                                                                u'path': [u'gcloud',
                                                                          u'alpha',
                                                                          u'service-management'],
                                                                u'positionals': [],
                                                                u'release': u'ALPHA',
                                                                u'sections': {u'DESCRIPTION': u"*(ALPHA)* Google Service Management is an infrastructure service of Google Cloud\nPlatform that manages other APIs and services, including Google's own Cloud\nPlatform services and their APIs, and services created using Google Cloud\nEndpoints.\n\nMore information on Service Management can be found here:\nhttps://cloud.google.com/service-management and detailed documentation can be\nfound here: https://cloud.google.com/service-management/docs/"}},
                                        u'service-registry': {u'capsule': u'*(ALPHA)* Manage Service Registry entries.',
                                                              u'commands': {u'endpoints': {u'capsule': u'*(ALPHA)* Commands for Service Registry endpoints.',
                                                                                           u'commands': {u'create': {u'capsule': u'*(ALPHA)* Create an endpoint entry in Service Registry.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--async': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--async',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'ASYNC'},
                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': u'',
                                                                                                                                                   u'description': u'A description of your endpoint.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--enable-external': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'Externalize the endpoint through a cloud.goog record.(default=False)',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--enable-external',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'ENABLE_EXTERNAL'},
                                                                                                                                u'--networks': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': [],
                                                                                                                                                u'description': u'A comma separated list of networks your endpoint should have private DNS records created in. Each network is represented by its name or a full resource url. For example, to refer to the default network  in "my-project", you can use\n+\n   default\n+\nor\n+\n   https://www.googleapis.com/compute/v1/projects/my-project/global/networks/default\n+',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--networks',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'list',
                                                                                                                                                u'value': u'NETWORKS'},
                                                                                                                                u'--no-async': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-async',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_ASYNC'},
                                                                                                                                u'--no-enable-external': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-enable-external',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_ENABLE_EXTERNAL'},
                                                                                                                                u'--target': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A target specifies an address (with optional ports) for an endpoint. This argument is repeatable for multiple addresses and can take the form of a single address (hostname, IPv4, or IPv6) and port:\n+\n  ADDRESS[:PORT]\n+\nIn this format you must enclose IPv6 addresses in square brackets: e.g.\n+\n  [2001:db8:0:0:0:ff00:42:8329]:8080\n+\nYou can also use a fully keyed version when you want to specify port details:\n+\n  address=ADDRESS[;port_number=PORT[,protocol=PROTOCOL][,port_name=name]]+\n+\nport specifications are separated by semi-colons, and the "address=" portion must come first. If you are specifying more than one port, then port_name is required.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--target',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'api_lib.service_registry.arg_support.ArgEndpointAddress',
                                                                                                                                              u'value': u'TARGET'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'create',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'service-registry',
                                                                                                                               u'endpoints',
                                                                                                                               u'create'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Endpoint name.',
                                                                                                                                       u'name': u'endpoint-name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'ENDPOINT_NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Create an endpoint entry in Service Registry.',
                                                                                                                                   u'EXAMPLES': u'To create an endpoint in Service Registry:\n\n  $ create my_endpoint --target my_service.my_domain:8080 --networks NETWORK_URL\n\nFor additional targets, just repeat the address flag, and to see\nmore options use:\n\n  $ create --help\n'}},
                                                                                                         u'delete': {u'capsule': u'*(ALPHA)* Delete an endpoint.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--async': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--async',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'ASYNC'},
                                                                                                                                u'--no-async': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-async',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_ASYNC'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'delete',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'service-registry',
                                                                                                                               u'endpoints',
                                                                                                                               u'delete'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Endpoint name.',
                                                                                                                                       u'name': u'endpoint-name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'ENDPOINT_NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command deletes an endpoint entry in Service Registry.',
                                                                                                                                   u'EXAMPLES': u"To delete an endpoint in Service Registry\n\n  $ delete ENDPOINT_NAME\n\nAnd if you don't want to wait to see if the asynchronous delete was\nsuccessful, you can use the --async flag to have an Operation\nreturned immediately\n\n  $ delete ENDPOINT_NAME --async\n"}},
                                                                                                         u'describe': {u'capsule': u'*(ALPHA)* Describe an endpoint entry in Service Registry.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'describe',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'alpha',
                                                                                                                                 u'service-registry',
                                                                                                                                 u'endpoints',
                                                                                                                                 u'describe'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Endpoint name.',
                                                                                                                                         u'name': u'endpoint-name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'ENDPOINT_NAME'}],
                                                                                                                       u'release': u'ALPHA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Describe an endpoint entry in Service Registry.',
                                                                                                                                     u'EXAMPLES': u'To display information about an endpoint\n\n  $ describe ENDPOINT_NAME\n'}},
                                                                                                         u'list': {u'capsule': u'*(ALPHA)* List endpoints for a project.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--filter',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--limit',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--page-size',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'FIELD'},
                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'URI'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'list',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'alpha',
                                                                                                                             u'service-registry',
                                                                                                                             u'endpoints',
                                                                                                                             u'list'],
                                                                                                                   u'positionals': [],
                                                                                                                   u'release': u'ALPHA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command lists endpoint entries in Service Registry.',
                                                                                                                                 u'EXAMPLES': u'To print out a list of endpoints with some summary information about each\n\n  $ list\n\nTo limit the number of endpoints returned\n\n  $ list --limit=100\n'}},
                                                                                                         u'update': {u'capsule': u'*(ALPHA)* Update an endpoint.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--async': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--async',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'ASYNC'},
                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': u'',
                                                                                                                                                   u'description': u'A description of your endpoint.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--enable-external': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'Externalize the endpoint through a cloud.goog record.(default=False)',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--enable-external',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'ENABLE_EXTERNAL'},
                                                                                                                                u'--networks': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': [],
                                                                                                                                                u'description': u'A comma separated list of networks your endpoint should have private DNS records created in. Each network is represented by its name or a full resource url. For example, to refer to the default network  in "my-project", you can use\n+\n   default\n+\nor\n+\n   https://www.googleapis.com/compute/v1/projects/my-project/global/networks/default\n+',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--networks',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'list',
                                                                                                                                                u'value': u'NETWORKS'},
                                                                                                                                u'--no-async': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-async',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_ASYNC'},
                                                                                                                                u'--no-enable-external': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-enable-external',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_ENABLE_EXTERNAL'},
                                                                                                                                u'--target': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A target specifies an address (with optional ports) for an endpoint. This argument is repeatable for multiple addresses and can take the form of a single address (hostname, IPv4, or IPv6) and port:\n+\n  ADDRESS[:PORT]\n+\nIn this format you must enclose IPv6 addresses in square brackets: e.g.\n+\n  [2001:db8:0:0:0:ff00:42:8329]:8080\n+\nYou can also use a fully keyed version when you want to specify port details:\n+\n  address=ADDRESS[;port_number=PORT[,protocol=PROTOCOL][,port_name=name]]+\n+\nport specifications are separated by semi-colons, and the "address=" portion must come first. If you are specifying more than one port, then port_name is required.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--target',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'api_lib.service_registry.arg_support.ArgEndpointAddress',
                                                                                                                                              u'value': u'TARGET'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'update',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'service-registry',
                                                                                                                               u'endpoints',
                                                                                                                               u'update'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Endpoint name.',
                                                                                                                                       u'name': u'endpoint-name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'ENDPOINT_NAME'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command updates the contents of an endpoint entry in Service Registry.\n\n## EXAMPLES\n\nTo update an endpoint in Service Registry:\n\n  $ update ENDPOINT_NAME --target ADDRESS:PORT --networks NETWORK_URL\n\nFor additional addresses, just repeat the --address flag, and to see\nmore options be sure to use:\n\n  $ update --help'}}},
                                                                                           u'flags': {},
                                                                                           u'group': True,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'endpoints',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'alpha',
                                                                                                     u'service-registry',
                                                                                                     u'endpoints'],
                                                                                           u'positionals': [],
                                                                                           u'release': u'ALPHA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to create, update, delete, and examine Service Registry entries.',
                                                                                                         u'EXAMPLES': u'To print out a list of endpoints with some summary information about each\n\n  $ endpoints list\n\nTo display information about an endpoint\n\n  $ endpoints describe ENDPOINT_NAME\n\nTo create a new endpoint\n\n  $ endpoints my_endpoint --target my_service.my_domain:8080\n      --networks NETWORK_URL\n\nMore commands and options can be found with\n\n  $ endpoints --help\n'}},
                                                                            u'operations': {u'capsule': u'*(ALPHA)* Commands for Service Registry operations.',
                                                                                            u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Describe an operation.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'describe',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'alpha',
                                                                                                                                  u'service-registry',
                                                                                                                                  u'operations',
                                                                                                                                  u'describe'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Operation name.',
                                                                                                                                          u'name': u'operation',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'OPERATION'}],
                                                                                                                        u'release': u'ALPHA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* This command describes an operation in Service Registry.',
                                                                                                                                      u'EXAMPLES': u'To display information about an operation, run:\n\n  $ describe OPERATION_NAME\n'}},
                                                                                                          u'list': {u'capsule': u'*(ALPHA)* List Service Registry operations for a project.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--filter',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--limit',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'FIELD'},
                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'URI'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'list',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'service-registry',
                                                                                                                              u'operations',
                                                                                                                              u'list'],
                                                                                                                    u'positionals': [],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* List Service Registry operations for a project.',
                                                                                                                                  u'EXAMPLES': u'To print out a list of operations with some summary information about each, run:\n\n  $ list\n\nTo limit the number of operations returned:\n\n  $ list --limit=100\n'}},
                                                                                                          u'wait': {u'capsule': u'*(ALPHA)* Waits on operations in Service Registry to complete.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'wait',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'alpha',
                                                                                                                              u'service-registry',
                                                                                                                              u'operations',
                                                                                                                              u'wait'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Names of operations to wait on.',
                                                                                                                                      u'name': u'operations',
                                                                                                                                      u'nargs': u'+',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'OPERATIONS'}],
                                                                                                                    u'release': u'ALPHA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* Polls until specified Service Registry operations finish or it times out,\nthrowing an error if any operations fail or any are left unfinished on\ntimeout. The command will wait up to 10 minutes for each operation, polling\nthem sequentially.',
                                                                                                                                  u'EXAMPLES': u'To wait on a single operation\n\n  $ wait operation-123\n\nTo wait on multiple operations use a comma separated list\n\n  $ wait operation-123 operation-456\n'}}},
                                                                                            u'flags': {},
                                                                                            u'group': True,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'operations',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'alpha',
                                                                                                      u'service-registry',
                                                                                                      u'operations'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'ALPHA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Commands to inspect and monitor Service Registry operations.',
                                                                                                          u'EXAMPLES': u'To print out a list of operations with some summary information about each:\n\n  $ operations list\n\nTo limit the number of endpoints returned:\n\n  $ operations list --limit=100\n'}}},
                                                              u'flags': {},
                                                              u'group': True,
                                                              u'groups': {},
                                                              u'hidden': False,
                                                              u'name': u'service-registry',
                                                              u'path': [u'gcloud',
                                                                        u'alpha',
                                                                        u'service-registry'],
                                                              u'positionals': [],
                                                              u'release': u'ALPHA',
                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Manage Service Registry entries.'}},
                                        u'source': {u'capsule': u'*(ALPHA)* Cloud git repository commands.',
                                                    u'commands': {u'repos': {u'capsule': u'*(ALPHA)* Repos command group.',
                                                                             u'commands': {u'clone': {u'capsule': u'*(ALPHA)* Clone project git repository in the current directory.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--autocreate': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'If true, creates a named repo without prompting the user if the repo does not already exist.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--autocreate',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'AUTOCREATE'},
                                                                                                                 u'--dry-run': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--dry-run',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'DRY_RUN'},
                                                                                                                 u'--no-autocreate': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-autocreate',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_AUTOCREATE'},
                                                                                                                 u'--no-dry-run': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-dry-run',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_DRY_RUN'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'clone',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'alpha',
                                                                                                                u'source',
                                                                                                                u'repos',
                                                                                                                u'clone'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Name of the repository. Note: Google Cloud Platform projects generally have (if created) a repository named "default"',
                                                                                                                        u'name': u'src',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'REPOSITORY_NAME'},
                                                                                                                       {u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Directory name for the cloned repo. Defaults to the repository name.',
                                                                                                                        u'name': u'dst',
                                                                                                                        u'nargs': u'?',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'DIRECTORY_NAME'}],
                                                                                                      u'release': u'ALPHA',
                                                                                                      u'sections': {u'DESCRIPTION': u'This command clones git repository for the currently active\nGoogle Cloud Platform project into the specified folder in the\ncurrent directory.\n',
                                                                                                                    u'EXAMPLES': u"To use the default Google Cloud repository for development, use the\nfollowing commands. We recommend that you use your project name as\nTARGET_DIR to make it apparent which directory is used for which\nproject. We also recommend to clone the repository named 'default'\nsince it is automatically created for each project, and its\ncontents can be browsed and edited in the Developers Console.\n\n  $ gcloud init\n  $ gcloud source repos clone default TARGET_DIR\n  $ cd TARGET_DIR\n  ... create/edit files and create one or more commits ...\n  $ git push origin master\n"}},
                                                                                           u'create': {u'capsule': u'*(ALPHA)* Create a named git repo for the project in the current directory.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'create',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'source',
                                                                                                                 u'repos',
                                                                                                                 u'create'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Name of the repository. May contain between 3 and 63 (inclusive)\nlowercase letters, digits, and hyphens. Must start with a letter, and\nmay not end with a hyphen.',
                                                                                                                         u'name': u'name',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'REPOSITORY_NAME'}],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'This command creates a named git repository for the currently\nactive Google Cloud Platform project.\n',
                                                                                                                     u'EXAMPLES': u'To create a named repository in the current project issue the\nfollowing commands:\n\n  $ gcloud init\n  $ gcloud alpha source repos create REPO_NAME\n\nOnce you push contents to it, they can be browsed in the\nDevelopers Console.\n'}},
                                                                                           u'delete': {u'capsule': u'*(ALPHA)* Delete project git repository in the current directory.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'source',
                                                                                                                 u'repos',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Name of the repository.',
                                                                                                                         u'name': u'name',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'REPOSITORY_NAME'}],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'This command deletes a named git repository from the currently\nactive Google Cloud Platform project.\n',
                                                                                                                     u'EXAMPLES': u'To delete a named repository in the current project issue the\nfollowing commands:\n\n  $ gcloud init\n  $ gcloud alpha source repos delete REPO_NAME\n'}},
                                                                                           u'get-iam-policy': {u'capsule': u'*(ALPHA)* Get the IAM policy for the named repository.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'get-iam-policy',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'source',
                                                                                                                         u'repos',
                                                                                                                         u'get-iam-policy'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Name of the repository.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'REPOSITORY_NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'This command gets the IAM policy for the given repository.\n',
                                                                                                                             u'EXAMPLES': u'To get the IAM policy, issue the following command:\n\n  $ gcloud alpha source repos get-iam-policy REPO_NAME\n'}},
                                                                                           u'list': {u'capsule': u'*(ALPHA)* Lists all repositories in a particular project.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'alpha',
                                                                                                               u'source',
                                                                                                               u'repos',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'ALPHA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* By default, repos in the current project are listed; this can be overridden\nwith the gcloud --project flag.'}},
                                                                                           u'set-iam-policy': {u'capsule': u'*(ALPHA)* Sets the IAM policy for the named repository.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'set-iam-policy',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'source',
                                                                                                                         u'repos',
                                                                                                                         u'set-iam-policy'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Name of the repository.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'REPOSITORY_NAME'},
                                                                                                                                {u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'JSON file with IAM policy. See https://cloud.google.com/resource-manager/reference/rest/Shared.Types/Policy',
                                                                                                                                 u'name': u'policy-file',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'FILE_NAME'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'This command sets the IAM policy for the given repository from the\npolicy in the provided file.\n',
                                                                                                                             u'EXAMPLES': u'To set the IAM policy, issue the following command:\n  $ gcloud alpha source repos set-iam-policy REPO_NAME POLICY_FILE\n'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'repos',
                                                                             u'path': [u'gcloud',
                                                                                       u'alpha',
                                                                                       u'source',
                                                                                       u'repos'],
                                                                             u'positionals': [],
                                                                             u'release': u'ALPHA',
                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Repos command group.'}}},
                                                    u'flags': {},
                                                    u'group': True,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'source',
                                                    u'path': [u'gcloud',
                                                              u'alpha',
                                                              u'source'],
                                                    u'positionals': [],
                                                    u'release': u'ALPHA',
                                                    u'sections': {u'DESCRIPTION': u'*(ALPHA)* The source group lets you manipulate git repositories within a Google\nCloud project.'}},
                                        u'spanner': {u'capsule': u'*(ALPHA)* Command groups for Cloud Spanner.',
                                                     u'commands': {u'databases': {u'capsule': u'*(ALPHA)* Cloud Spanner databases commands.',
                                                                                  u'commands': {u'create': {u'capsule': u'*(ALPHA)* Cloud Spanner databases create command.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'ASYNC'},
                                                                                                                       u'--ddl': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Semi-colon separated DDL (data definition language) statements to run inside the newly created database. If there is an error in any statement, the database is not created. Full DDL specification is at https://cloud.google.com/spanner/docs/data-definition-language',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--ddl',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'DDL'},
                                                                                                                       u'--instance': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Cloud Spanner instance ID.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--instance',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'INSTANCE'},
                                                                                                                       u'--no-async': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-async',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_ASYNC'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'create',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'spanner',
                                                                                                                      u'databases',
                                                                                                                      u'create'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Cloud Spanner database name.',
                                                                                                                              u'name': u'database',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'DATABASE'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner databases create command.'}},
                                                                                                u'ddl': {u'capsule': u'*(ALPHA)* Cloud Spanner databases DDL commands.',
                                                                                                         u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Cloud Spanner databases DDL describe command.',
                                                                                                                                     u'commands': {},
                                                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--filter',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                                                u'--instance': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Cloud Spanner instance ID.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--instance',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': True,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'INSTANCE'},
                                                                                                                                                u'--limit': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--limit',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'LIMIT'},
                                                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': True,
                                                                                                                                                              u'description': u'',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': True,
                                                                                                                                                              u'name': u'--no-uri',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'bool',
                                                                                                                                                              u'value': u'NO_URI'},
                                                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--page-size',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--sort-by',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'list',
                                                                                                                                                               u'value': u'FIELD'},
                                                                                                                                                u'--uri': {u'attr': {},
                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': False,
                                                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--uri',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'URI'}},
                                                                                                                                     u'group': False,
                                                                                                                                     u'groups': {},
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'describe',
                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                               u'alpha',
                                                                                                                                               u'spanner',
                                                                                                                                               u'databases',
                                                                                                                                               u'ddl',
                                                                                                                                               u'describe'],
                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Cloud Spanner database name.',
                                                                                                                                                       u'name': u'database',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'value': u'DATABASE'}],
                                                                                                                                     u'release': u'ALPHA',
                                                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner databases DDL describe command.'}},
                                                                                                                       u'update': {u'capsule': u'*(ALPHA)* Cloud Spanner databases DDL update command.',
                                                                                                                                   u'commands': {},
                                                                                                                                   u'flags': {u'--async': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': False,
                                                                                                                                                           u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--async',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'ASYNC'},
                                                                                                                                              u'--ddl': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Semi-colon separated DDL (data definition language) statements to run inside the database. If a statement fails, all subsequent statements in the batch are automatically cancelled.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--ddl',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': True,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'DDL'},
                                                                                                                                              u'--instance': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Cloud Spanner instance ID.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--instance',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': True,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'INSTANCE'},
                                                                                                                                              u'--no-async': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': True,
                                                                                                                                                              u'description': u'',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': True,
                                                                                                                                                              u'name': u'--no-async',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'bool',
                                                                                                                                                              u'value': u'NO_ASYNC'}},
                                                                                                                                   u'group': False,
                                                                                                                                   u'groups': {},
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'update',
                                                                                                                                   u'path': [u'gcloud',
                                                                                                                                             u'alpha',
                                                                                                                                             u'spanner',
                                                                                                                                             u'databases',
                                                                                                                                             u'ddl',
                                                                                                                                             u'update'],
                                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Cloud Spanner database name.',
                                                                                                                                                     u'name': u'database',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'value': u'DATABASE'}],
                                                                                                                                   u'release': u'ALPHA',
                                                                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner databases DDL update command.'}}},
                                                                                                         u'flags': {},
                                                                                                         u'group': True,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'ddl',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'spanner',
                                                                                                                   u'databases',
                                                                                                                   u'ddl'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner databases DDL commands.'}},
                                                                                                u'delete': {u'capsule': u'*(ALPHA)* Cloud Spanner databases delete command.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--instance': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Cloud Spanner instance ID.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--instance',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'INSTANCE'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'delete',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'spanner',
                                                                                                                      u'databases',
                                                                                                                      u'delete'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Cloud Spanner database name.',
                                                                                                                              u'name': u'database',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'DATABASE'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner databases delete command.'}},
                                                                                                u'describe': {u'capsule': u'*(ALPHA)* Cloud Spanner databases describe command.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--instance': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Cloud Spanner instance ID.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--instance',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': True,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'INSTANCE'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'spanner',
                                                                                                                        u'databases',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Cloud Spanner database name.',
                                                                                                                                u'name': u'database',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'DATABASE'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner databases describe command.'}},
                                                                                                u'execute-sql': {u'capsule': u'*(ALPHA)* Cloud Spanner databases query.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--instance': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Cloud Spanner instance ID.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--instance',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'INSTANCE'},
                                                                                                                            u'--sql': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The SQL query to issue to the database. Cloud Spanner SQL is described at https://cloud.google.com/spanner/docs/query-syntax',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sql',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'SQL'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'execute-sql',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'spanner',
                                                                                                                           u'databases',
                                                                                                                           u'execute-sql'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Cloud Spanner database name.',
                                                                                                                                   u'name': u'database',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'DATABASE'}],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner databases query.'}},
                                                                                                u'list': {u'capsule': u'*(ALPHA)* Cloud Spanner databases list command.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--instance': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Cloud Spanner instance ID.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--instance',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': True,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'INSTANCE'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'spanner',
                                                                                                                    u'databases',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner databases list command.'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'databases',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'spanner',
                                                                                            u'databases'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner databases commands.'}},
                                                                   u'instance-configs': {u'capsule': u'*(ALPHA)* Cloud Spanner instance configs commands.',
                                                                                         u'commands': {u'describe': {u'capsule': u'*(ALPHA)* Cloud Spanner instance configs describe command.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'describe',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'alpha',
                                                                                                                               u'spanner',
                                                                                                                               u'instance-configs',
                                                                                                                               u'describe'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Cloud Spanner instance config.',
                                                                                                                                       u'name': u'config',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'INSTANCE-CONFIG'}],
                                                                                                                     u'release': u'ALPHA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner instance configs describe command.'}},
                                                                                                       u'list': {u'capsule': u'*(ALPHA)* Cloud Spanner instance configs list command.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--filter',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                                            u'--limit': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--limit',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'LIMIT'},
                                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_URI'},
                                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--page-size',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--sort-by',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'FIELD'},
                                                                                                                            u'--uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'URI'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'list',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'alpha',
                                                                                                                           u'spanner',
                                                                                                                           u'instance-configs',
                                                                                                                           u'list'],
                                                                                                                 u'positionals': [],
                                                                                                                 u'release': u'ALPHA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner instance configs list command.'}}},
                                                                                         u'flags': {},
                                                                                         u'group': True,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'instance-configs',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'alpha',
                                                                                                   u'spanner',
                                                                                                   u'instance-configs'],
                                                                                         u'positionals': [],
                                                                                         u'release': u'ALPHA',
                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner instance configs commands.'}},
                                                                   u'instances': {u'capsule': u'*(ALPHA)* Cloud Spanner instances commands.',
                                                                                  u'commands': {u'create': {u'capsule': u'*(ALPHA)* Cloud Spanner instances create command.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'ASYNC'},
                                                                                                                       u'--config': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Instance config for the instance.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--config',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': True,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'CONFIG'},
                                                                                                                       u'--description': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Description of the instance.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--description',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                                       u'--no-async': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-async',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_ASYNC'},
                                                                                                                       u'--nodes': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Number of nodes for the instance.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--nodes',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'NODES'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'create',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'spanner',
                                                                                                                      u'instances',
                                                                                                                      u'create'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Cloud Spanner instance ID.',
                                                                                                                              u'name': u'instance',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'INSTANCE'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner instances create command.'}},
                                                                                                u'delete': {u'capsule': u'*(ALPHA)* Cloud Spanner instances delete command.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'delete',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'spanner',
                                                                                                                      u'instances',
                                                                                                                      u'delete'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Cloud Spanner instance ID.',
                                                                                                                              u'name': u'instance',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'INSTANCE'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner instances delete command.'}},
                                                                                                u'describe': {u'capsule': u'*(ALPHA)* Cloud Spanner instances describe command.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'alpha',
                                                                                                                        u'spanner',
                                                                                                                        u'instances',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Cloud Spanner instance ID.',
                                                                                                                                u'name': u'instance',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'INSTANCE'}],
                                                                                                              u'release': u'ALPHA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner instances describe command.'}},
                                                                                                u'list': {u'capsule': u'*(ALPHA)* Cloud Spanner instances list command.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'alpha',
                                                                                                                    u'spanner',
                                                                                                                    u'instances',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'ALPHA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner instances list command.'}},
                                                                                                u'update': {u'capsule': u'*(ALPHA)* Cloud Spanner instances update command.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'ASYNC'},
                                                                                                                       u'--description': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Description of the instance.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--description',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                                       u'--no-async': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-async',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_ASYNC'},
                                                                                                                       u'--nodes': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Number of nodes for the instance.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--nodes',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'NODES'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'update',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'alpha',
                                                                                                                      u'spanner',
                                                                                                                      u'instances',
                                                                                                                      u'update'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Cloud Spanner instance ID.',
                                                                                                                              u'name': u'instance',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'INSTANCE'}],
                                                                                                            u'release': u'ALPHA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner instances update command.'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'instances',
                                                                                  u'path': [u'gcloud',
                                                                                            u'alpha',
                                                                                            u'spanner',
                                                                                            u'instances'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'ALPHA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner instances commands.'}},
                                                                   u'operations': {u'capsule': u'*(ALPHA)* Cloud Spanner operations commands.',
                                                                                   u'commands': {u'cancel': {u'capsule': u'*(ALPHA)* Cloud Spanner operations cancel command.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--database': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'For a database operation, the name of the database the operation is executing on.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--database',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DATABASE'},
                                                                                                                        u'--instance': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The ID of the instance the operation is executing on.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--instance',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': True,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'INSTANCE'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'cancel',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'alpha',
                                                                                                                       u'spanner',
                                                                                                                       u'operations',
                                                                                                                       u'cancel'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'ID of the operation',
                                                                                                                               u'name': u'operation',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'OPERATION-ID'}],
                                                                                                             u'release': u'ALPHA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner operations cancel command.'}},
                                                                                                 u'describe': {u'capsule': u'*(ALPHA)* Cloud Spanner operations describe command.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--database': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'For a database operation, the name of the database the operation is executing on.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--database',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'DATABASE'},
                                                                                                                          u'--instance': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The ID of the instance the operation is executing on.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--instance',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'INSTANCE'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'describe',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'alpha',
                                                                                                                         u'spanner',
                                                                                                                         u'operations',
                                                                                                                         u'describe'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'ID of the operation',
                                                                                                                                 u'name': u'operation',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'OPERATION-ID'}],
                                                                                                               u'release': u'ALPHA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner operations describe command.'}},
                                                                                                 u'list': {u'capsule': u'*(ALPHA)* Cloud Spanner operations list command.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--database': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'For database operations, the name of the database the operations are executing on.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--database',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'DATABASE'},
                                                                                                                      u'--filter': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--filter',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                      u'--instance': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The ID of the instance the operations are executing on.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--instance',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'INSTANCE'},
                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--limit',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-uri',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_URI'},
                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--page-size',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'FIELD'},
                                                                                                                      u'--uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'URI'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'list',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'alpha',
                                                                                                                     u'spanner',
                                                                                                                     u'operations',
                                                                                                                     u'list'],
                                                                                                           u'positionals': [],
                                                                                                           u'release': u'ALPHA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner operations list command.'}}},
                                                                                   u'flags': {},
                                                                                   u'group': True,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'operations',
                                                                                   u'path': [u'gcloud',
                                                                                             u'alpha',
                                                                                             u'spanner',
                                                                                             u'operations'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'ALPHA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(ALPHA)* Cloud Spanner operations commands.'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'spanner',
                                                     u'path': [u'gcloud',
                                                               u'alpha',
                                                               u'spanner'],
                                                     u'positionals': [],
                                                     u'release': u'ALPHA',
                                                     u'sections': {u'DESCRIPTION': u'*(ALPHA)* Command groups for Cloud Spanner.'}},
                                        u'test': {u'capsule': u'*(ALPHA)* Interact with Firebase Test Lab.',
                                                  u'commands': {u'android': {u'capsule': u'*(ALPHA)* Command group for Android application testing.',
                                                                             u'commands': {u'devices': {u'capsule': u'*(ALPHA)* Explore Android devices available in the Test Environment catalog.',
                                                                                                        u'commands': {u'list': {u'capsule': u'*(ALPHA)*  *(DEPRECATED)* List all Android device environments available for testing.',
                                                                                                                                u'commands': {},
                                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--filter',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--limit',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': True,
                                                                                                                                                         u'description': u'',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': True,
                                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--page-size',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'list',
                                                                                                                                                          u'value': u'FIELD'},
                                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--uri',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'URI'}},
                                                                                                                                u'group': False,
                                                                                                                                u'groups': {},
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'list',
                                                                                                                                u'path': [u'gcloud',
                                                                                                                                          u'alpha',
                                                                                                                                          u'test',
                                                                                                                                          u'android',
                                                                                                                                          u'devices',
                                                                                                                                          u'list'],
                                                                                                                                u'positionals': [],
                                                                                                                                u'release': u'ALPHA',
                                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)*  *(DEPRECATED)* List all Android device environments available for testing.\n\nThis command is deprecated. Please use `gcloud beta test android models list` instead.\n\n'}}},
                                                                                                        u'flags': {},
                                                                                                        u'group': True,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'devices',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'test',
                                                                                                                  u'android',
                                                                                                                  u'devices'],
                                                                                                        u'positionals': [],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Explore Android devices available in the Test Environment catalog.',
                                                                                                                      u'EXAMPLES': u'To list all Android devices available for running tests, along with\ntheir basic characteristics and supported Android OS versions, run:\n\n  $ devices list\n'}},
                                                                                           u'locales': {u'capsule': u'*(ALPHA)* Explore Android locales available for testing.',
                                                                                                        u'commands': {u'list': {u'capsule': u'*(ALPHA)* List all Android locales available for testing internationalized apps.',
                                                                                                                                u'commands': {},
                                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--filter',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--limit',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': True,
                                                                                                                                                         u'description': u'',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': True,
                                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--page-size',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'list',
                                                                                                                                                          u'value': u'FIELD'},
                                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--uri',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'URI'}},
                                                                                                                                u'group': False,
                                                                                                                                u'groups': {},
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'list',
                                                                                                                                u'path': [u'gcloud',
                                                                                                                                          u'alpha',
                                                                                                                                          u'test',
                                                                                                                                          u'android',
                                                                                                                                          u'locales',
                                                                                                                                          u'list'],
                                                                                                                                u'positionals': [],
                                                                                                                                u'release': u'ALPHA',
                                                                                                                                u'sections': {u'DESCRIPTION': u'*(ALPHA)* List all Android locales available for testing internationalized apps.'}}},
                                                                                                        u'flags': {},
                                                                                                        u'group': True,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'locales',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'alpha',
                                                                                                                  u'test',
                                                                                                                  u'android',
                                                                                                                  u'locales'],
                                                                                                        u'positionals': [],
                                                                                                        u'release': u'ALPHA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(ALPHA)* Explore Android locales available for testing.',
                                                                                                                      u'EXAMPLES': u'To list all available Android locales which can be used for testing\ninternational applications, run:\n\n  $ locales list\n'}},
                                                                                           u'models': {u'capsule': u'*(ALPHA)* Explore Android models available in the Test Environment catalog.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {},
                                                                                                       u'group': True,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'models',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'alpha',
                                                                                                                 u'test',
                                                                                                                 u'android',
                                                                                                                 u'models'],
                                                                                                       u'positionals': [],
                                                                                                       u'release': u'ALPHA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(ALPHA)* Explore Android models available in the Test Environment catalog.',
                                                                                                                     u'EXAMPLES': u'To list all Android models available for running tests, along with\ntheir basic characteristics and supported Android OS versions, run:\n\n  $ models list\n'}},
                                                                                           u'run': {u'capsule': u'*(ALPHA)* Invoke a test in Firebase Test Lab for Android and view test results.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--app': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The path to the application binary file. The path may be in the local filesystem or in Google Cloud Storage using gs:// notation.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--app',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'APP'},
                                                                                                               u'--app-initial-activity': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The initial activity used to start the app during a robo test.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--app-initial-activity',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'APP_INITIAL_ACTIVITY'},
                                                                                                               u'--app-package': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The Java package of the application under test (default: extracted from the APK manifest).',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--app-package',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'APP_PACKAGE'},
                                                                                                               u'--async': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Invoke a test asynchronously without waiting for test results.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--async',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'ASYNC'},
                                                                                                               u'--auto-google-login': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'Automatically log into the test device using a preconfigured Google account before beginning the test. Enabled by default, use *--no-auto-google-login* to disable.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--auto-google-login',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'AUTO_GOOGLE_LOGIN'},
                                                                                                               u'--device-ids': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The list of DEVICE_IDs to test against (default: one device determined by the Firebase Test Lab device catalog; see TAGS listed by the *$ {parent_command} devices list* command).',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--device-ids',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'DEVICE_ID'},
                                                                                                               u'--directories-to-pull': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"A list of paths that will be copied from the device's storage to the designated results bucket after the test is complete. (ex. --directories-to-pull /sdcard/tempDir1,/data/tempDir2)",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--directories-to-pull',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'DIR_TO_PULL'},
                                                                                                               u'--environment-variables': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A comma-separated, key=value, map of environment variables and their desired values. The environment variables passed here will be mirrored on to the adb run command. For example, specify --environment-variables coverage=true,coverageFile="/sdcard/tempDir/coverage.ec" to enable code coverage and provide a file path to store the coverage results.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--environment-variables',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'dict',
                                                                                                                                            u'value': u'KEY=VALUE'},
                                                                                                               u'--filter': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--filter',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                               u'--limit': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--limit',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'LIMIT'},
                                                                                                               u'--locales': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The list of LOCALEs to test against (default: a single locale determined by the Firebase Test Lab device catalog).',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--locales',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'LOCALE'},
                                                                                                               u'--max-depth': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The maximum depth of the traversal stack a robo test can explore. Needs to be at least 2 to make Robo explore the app beyond the first activity (default: 50).',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--max-depth',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'int'},
                                                                                                               u'--max-steps': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The maximum number of steps/actions a robo test can execute (default: no limit).',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--max-steps',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'int'},
                                                                                                               u'--no-async': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-async',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_ASYNC'},
                                                                                                               u'--no-auto-google-login': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-auto-google-login',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_AUTO_GOOGLE_LOGIN'},
                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': True,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_URI'},
                                                                                                               u'--obb-files': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A list of one or two Android OBB file names which will be copied to each test device before the tests will run (default: None). Each OBB file name must conform to the format as specified by Android (e.g. [main|patch].0300110.com.example.android.obb) and will be installed into <shared-storage>/Android/obb/<package-name>/ on the test device.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--obb-files',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'OBB_FILE'},
                                                                                                               u'--orientations': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': u'portrait',
                                                                                                                                   u'description': u'The device orientation(s) to test against. _ORIENTATION_ must be one of: *portrait*, *landscape*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--orientations',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'ORIENTATION'},
                                                                                                               u'--os-version-ids': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The list of OS_VERSION_IDs to test against (default: a version ID determined by the Firebase Test Lab device catalog).',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--os-version-ids',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'OS_VERSION_ID'},
                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--page-size',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                               u'--results-bucket': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of a Google Cloud Storage bucket where raw test results will be stored (default: "test-lab-<random-UUID>"). Note that using a non-default bucket will result in billing charges for the storage used.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--results-bucket',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'RESULTS_BUCKET'},
                                                                                                               u'--results-history-name': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The history name for your test results (an arbitrary string label; default: the application's label from the APK manifest). All tests which use the same history name will have their results grouped together in the Firebase console in a time-ordered test history list.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--results-history-name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'RESULTS_HISTORY_NAME'},
                                                                                                               u'--robo-directives': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'A comma-separated, key=value, map of robo_directives for use by Robo test. Each key should be the Android resource name of a target UI element, and each value should be the text input for that element. For example, specify "--robo-directives username_resource=username,password_resource=password" to provide custom login credentials for your app. Caution: You should only use credentials for test accounts that are not associated with real users.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--robo-directives',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'dict',
                                                                                                                                      u'value': u'ROBO_DIRECTIVES'},
                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--sort-by',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'FIELD'},
                                                                                                               u'--test': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The path to the test binary file. The given path may be in the local filesystem or in Google Cloud Storage using gs:// notation.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--test',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'TEST'},
                                                                                                               u'--test-package': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The Java package name of the test (default: extracted from the APK manifest).',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--test-package',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'TEST_PACKAGE'},
                                                                                                               u'--test-runner-class': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The fully-qualified Java class name of the instrumentation test runner (default: the last name extracted from the APK manifest).',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--test-runner-class',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'TEST_RUNNER_CLASS'},
                                                                                                               u'--test-targets': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A list of one or more test targets to be run (default: all targets). Each target must be fully qualified with the package name or class name, in one of these formats:\n* "package package_name"\n* "class package_name.class_name"\n* "class package_name.class_name#method_name".',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--test-targets',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'TEST_TARGET'},
                                                                                                               u'--timeout': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The max time this test execution can run before it is cancelled (default: 15m). It does not include any time necessary to prepare and clean up the target device. The _TIMEOUT_ units can be h, m, or s. If no unit is given, seconds are assumed. Examples:\n- *--timeout 1h* is 1 hour\n- *--timeout 5m* is 5 minutes\n- *--timeout 200s* is 200 seconds\n- *--timeout 100* is 100 seconds',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--timeout',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'TIMEOUT'},
                                                                                                               u'--type': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [u'instrumentation',
                                                                                                                                        u'robo'],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The type of test to run. _TYPE_ must be one of: *instrumentation*, *robo*.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--type',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'TYPE'},
                                                                                                               u'--uri': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--uri',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'URI'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'run',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'alpha',
                                                                                                              u'test',
                                                                                                              u'android',
                                                                                                              u'run'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'An ARG_FILE:ARG_GROUP_NAME pair, where ARG_FILE is the path to a file containing groups of test arguments in yaml format, and ARG_GROUP_NAME is the particular yaml object holding a group of arg:value pairs to use. Run *$ gcloud topic arg-files* for more information and examples.',
                                                                                                                      u'name': u'argspec',
                                                                                                                      u'nargs': u'?',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'ARGSPEC'}],
                                                                                                    u'release': u'ALPHA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*run* invokes and monitors tests in Firebase Test Lab for\nAndroid.\n\nTwo main types of tests are currently supported:\n- *robo*: runs a smart, automated exploration of the activities in\n  your Android app which records any installation failures or crashes\n  and builds an activity map with associated screenshots and video.\n- *instrumentation*: runs automated unit or integration tests written\n  using a testing framework. Firebase Test Lab for Android currently\n  supports the Espresso, Robotium and UI Automator 2.0 testing\n  frameworks.\n\nThe type of test to run can be specified with the *--type* flag,\nalthough the type can often be inferred from other flags.\nSpecifically, if the *--test* flag is present, the test *--type* will\ndefault to `instrumentation`. If *--test* is not present, then\n*--type* defaults to `robo`.\n\nAll arguments for *run* may be specified on the command line\nand/or within an argument file. Run *$ gcloud topic arg-files* for\nmore information about argument files.\n',
                                                                                                                  u'EXAMPLES': u"To invoke a robo test lasting 100 seconds against the default device\nenvironment, run:\n\n  $ run --app APP_APK --timeout 100s\n\nTo invoke a robo test against a virtual Nexus9 device in\nlandscape orientation, run:\n\n  $ run --app APP_APK --device-ids Nexus9 --orientations landscape\n\nTo invoke an instrumentation test (Espresso or Robotium) against a\nphysical Nexus 4 device (DEVICE_ID: mako) which is running Android API\nlevel 18 in French, run:\n\n  $ run --app APP_APK --test TEST_APK --device-ids mako --os-version-ids 18 --locales fr --orientations portrait\n\nTo run the same test as above using short flags, run:\n\n  $ run --app APP_APK --test TEST_APK -d mako -v 18 -l fr -o portrait\n\nTo run a series of 5-minute robo tests against a comprehensive matrix\nof virtual and physical devices, OS versions and locales, run:\n\n  $ run --app APP_APK --timeout 5m --device-ids mako,Nexus5,Nexus6,g3,zeroflte --os-version-ids 17,18,19,21,22 --locales de,en_US,en_GB,es,fr,it,ru,zh\n\nTo run an instrumentation test against the default test environment,\nbut using a specific Google Cloud Storage bucket to hold the raw test\nresults and specifying the name under which the history of your tests\nwill be collected and displayed in the Firebase console, run:\n\n  $ run --app APP_APK --test TEST_APK --results-bucket excelsior-app-results-bucket --results-history-name 'Excelsior App Test History'\n\nAll test arguments for a given test may alternatively be stored in an\nargument group within a YAML-formatted argument file. The _ARG_FILE_\nmay contain one or more named argument groups, and argument groups may\nbe combined using the `include:` attribute (Run *$ gcloud topic\narg-files* for more information). The ARG_FILE can easily be shared\nwith colleagues or placed under source control to ensure consistent\ntest executions.\n\nTo run a test using arguments loaded from an ARG_FILE named\n*excelsior_args*, which contains an argument group named *robo-args:*,\nuse the following syntax:\n\n  $ run path/to/excelsior_args:robo-args\n"}},
                                                                                           u'versions': {u'capsule': u'*(ALPHA)* Explore Android versions available for testing.',
                                                                                                         u'commands': {u'list': {u'capsule': u'*(ALPHA)* List all Android OS versions available for testing.',
                                                                                                                                 u'commands': {},
                                                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--filter',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                                                            u'--limit': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--limit',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'LIMIT'},
                                                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': True,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-uri',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_URI'},
                                                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--page-size',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--sort-by',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'list',
                                                                                                                                                           u'value': u'FIELD'},
                                                                                                                                            u'--uri': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--uri',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'URI'}},
                                                                                                                                 u'group': False,
                                                                                                                                 u'groups': {},
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'list',
                                                                                                                                 u'path': [u'gcloud',
                                                                                                                                           u'alpha',
                                                                                                                                           u'test',
                                                                                                                                           u'android',
                                                                                                                                           u'versions',
                                                                                                                                           u'list'],
                                                                                                                                 u'positionals': [],
                                                                                                                                 u'release': u'ALPHA',
                                                                                                                                 u'sections': {u'DESCRIPTION': u'*(ALPHA)* List all Android OS versions available for testing.'}}},
                                                                                                         u'flags': {},
                                                                                                         u'group': True,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'versions',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'alpha',
                                                                                                                   u'test',
                                                                                                                   u'android',
                                                                                                                   u'versions'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'ALPHA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(ALPHA)* Explore Android versions available for testing.',
                                                                                                                       u'EXAMPLES': u'To list information about all versions of the Android OS available\nfor running tests, including details such as OS code name and\nrelease date, run:\n\n  $ versions list\n'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'android',
                                                                             u'path': [u'gcloud',
                                                                                       u'alpha',
                                                                                       u'test',
                                                                                       u'android'],
                                                                             u'positionals': [],
                                                                             u'release': u'ALPHA',
                                                                             u'sections': {u'DESCRIPTION': u'Explore physical and virtual Android devices and Android OS versions\nwhich are available as test targets. Also run tests against your\nAndroid app on these devices, monitor your test progress, and view\ndetailed test results in the Firebase console.\n',
                                                                                           u'EXAMPLES': u'To see a list of available Android devices, their form factors, and\nsupported Android OS versions, run:\n\n  $ android devices list\n\nTo view details about available Android OS versions, such as their\ncode names and release dates, run:\n\n  $ android versions list\n\nTo view the list of available Android locales which can be used for\ntesting internationalized applications, run:\n\n  $ android locales list\n\nTo view all options available for running Android tests, run:\n\n  $ android run --help\n'}}},
                                                  u'flags': {},
                                                  u'group': True,
                                                  u'groups': {},
                                                  u'hidden': False,
                                                  u'name': u'test',
                                                  u'path': [u'gcloud',
                                                            u'alpha',
                                                            u'test'],
                                                  u'positionals': [],
                                                  u'release': u'ALPHA',
                                                  u'sections': {u'DESCRIPTION': u'*(ALPHA)* Explore devices and OS versions available as test targets, run tests, monitor\ntest progress, and view detailed test results.'}}},
                          u'flags': {},
                          u'group': True,
                          u'groups': {},
                          u'hidden': False,
                          u'name': u'alpha',
                          u'path': [u'gcloud', u'alpha'],
                          u'positionals': [],
                          u'release': u'ALPHA',
                          u'sections': {u'DESCRIPTION': u'*(ALPHA)* Alpha versions of gcloud commands.'}},
               u'app': {u'capsule': u'Manage your App Engine deployments.',
                        u'commands': {u'browse': {u'capsule': u'Open the current app in a web browser.',
                                                  u'commands': {},
                                                  u'flags': {u'--service': {u'attr': {},
                                                                            u'category': u'',
                                                                            u'choices': [],
                                                                            u'completer': u'',
                                                                            u'default': None,
                                                                            u'description': u'The service that should be opened. If not specified, use the default service. May be used in conjunction with `--version`.',
                                                                            u'group': u'',
                                                                            u'hidden': False,
                                                                            u'name': u'--service',
                                                                            u'nargs': u'0',
                                                                            u'required': False,
                                                                            u'type': u'string',
                                                                            u'value': u'SERVICE'}},
                                                  u'group': False,
                                                  u'groups': {},
                                                  u'hidden': False,
                                                  u'name': u'browse',
                                                  u'path': [u'gcloud',
                                                            u'app',
                                                            u'browse'],
                                                  u'positionals': [],
                                                  u'release': u'GA',
                                                  u'sections': {u'DESCRIPTION': u'Open the current app in a web browser.\n',
                                                                u'EXAMPLES': u'To open the default service, run:\n\n    $ browse\n\nTo open a specific service, run:\n\n    $ browse --service="myService"\n\nTo open a specific version, run:\n\n    $ browse --service="myService" --version="v1"\n'}},
                                      u'create': {u'capsule': u'Create an App Engine app within the current Google Cloud Project.',
                                                  u'commands': {},
                                                  u'flags': {u'--region': {u'attr': {},
                                                                           u'category': u'',
                                                                           u'choices': [],
                                                                           u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u'The region to create the app within.  Use `gcloud app regions list` to list available regions.  If not provided, select region interactively.',
                                                                           u'group': u'',
                                                                           u'hidden': False,
                                                                           u'name': u'--region',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'type': u'string',
                                                                           u'value': u'REGION'}},
                                                  u'group': False,
                                                  u'groups': {},
                                                  u'hidden': False,
                                                  u'name': u'create',
                                                  u'path': [u'gcloud',
                                                            u'app',
                                                            u'create'],
                                                  u'positionals': [],
                                                  u'release': u'GA',
                                                  u'sections': {u'DESCRIPTION': u'Create an App Engine app within the current Google Cloud Project.\n',
                                                                u'EXAMPLES': u'To create an app with region chosen interactively, run:\n\n    $ create\n\nTo create an app in the us-central region, run:\n\n    $ create --region=us-central\n\n'}},
                                      u'deploy': {u'capsule': u'Deploy the local code and/or configuration of your app to App Engine.',
                                                  u'commands': {},
                                                  u'flags': {u'--bucket': {u'attr': {},
                                                                           u'category': u'',
                                                                           u'choices': [],
                                                                           u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u"The Google Cloud Storage bucket used to stage files associated with the deployment. If this argument is not specified, the application's default code bucket is used.",
                                                                           u'group': u'',
                                                                           u'hidden': False,
                                                                           u'name': u'--bucket',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'type': u'string',
                                                                           u'value': u'BUCKET'},
                                                             u'--docker-build': {u'attr': {},
                                                                                 u'category': u'',
                                                                                 u'choices': [],
                                                                                 u'completer': u'',
                                                                                 u'default': None,
                                                                                 u'description': u'',
                                                                                 u'group': u'',
                                                                                 u'hidden': True,
                                                                                 u'name': u'--docker-build',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'type': u'string',
                                                                                 u'value': u'DOCKER_BUILD'},
                                                             u'--ignore-bad-certs': {u'attr': {},
                                                                                     u'category': u'',
                                                                                     u'choices': [],
                                                                                     u'completer': u'',
                                                                                     u'default': False,
                                                                                     u'description': u'',
                                                                                     u'group': u'',
                                                                                     u'hidden': True,
                                                                                     u'name': u'--ignore-bad-certs',
                                                                                     u'nargs': u'0',
                                                                                     u'required': False,
                                                                                     u'type': u'bool',
                                                                                     u'value': u'IGNORE_BAD_CERTS'},
                                                             u'--image-url': {u'attr': {},
                                                                              u'category': u'',
                                                                              u'choices': [],
                                                                              u'completer': u'',
                                                                              u'default': None,
                                                                              u'description': u'Deploy with a specific Docker image.  Docker url must be from one of the valid gcr hostnames.',
                                                                              u'group': u'',
                                                                              u'hidden': False,
                                                                              u'name': u'--image-url',
                                                                              u'nargs': u'0',
                                                                              u'required': False,
                                                                              u'type': u'string',
                                                                              u'value': u'IMAGE_URL'},
                                                             u'--no-ignore-bad-certs': {u'attr': {},
                                                                                        u'category': u'',
                                                                                        u'choices': [],
                                                                                        u'completer': u'',
                                                                                        u'default': False,
                                                                                        u'description': u'',
                                                                                        u'group': u'',
                                                                                        u'hidden': True,
                                                                                        u'name': u'--no-ignore-bad-certs',
                                                                                        u'nargs': u'0',
                                                                                        u'required': False,
                                                                                        u'type': u'bool',
                                                                                        u'value': u'NO_IGNORE_BAD_CERTS'},
                                                             u'--no-promote': {u'attr': {u'property': {u'name': u'app/promote_by_default'}},
                                                                               u'category': u'',
                                                                               u'choices': [],
                                                                               u'completer': u'',
                                                                               u'default': False,
                                                                               u'description': u'',
                                                                               u'group': u'',
                                                                               u'hidden': True,
                                                                               u'name': u'--no-promote',
                                                                               u'nargs': u'0',
                                                                               u'required': False,
                                                                               u'type': u'bool',
                                                                               u'value': u'NO_PROMOTE'},
                                                             u'--no-skip-image-url-validation': {u'attr': {},
                                                                                                 u'category': u'',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': False,
                                                                                                 u'description': u'',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': True,
                                                                                                 u'name': u'--no-skip-image-url-validation',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'type': u'bool',
                                                                                                 u'value': u'NO_SKIP_IMAGE_URL_VALIDATION'},
                                                             u'--no-skip-staging': {u'attr': {},
                                                                                    u'category': u'',
                                                                                    u'choices': [],
                                                                                    u'completer': u'',
                                                                                    u'default': False,
                                                                                    u'description': u'',
                                                                                    u'group': u'',
                                                                                    u'hidden': True,
                                                                                    u'name': u'--no-skip-staging',
                                                                                    u'nargs': u'0',
                                                                                    u'required': False,
                                                                                    u'type': u'bool',
                                                                                    u'value': u'NO_SKIP_STAGING'},
                                                             u'--no-stop-previous-version': {u'attr': {u'property': {u'name': u'app/stop_previous_version'}},
                                                                                             u'category': u'',
                                                                                             u'choices': [],
                                                                                             u'completer': u'',
                                                                                             u'default': False,
                                                                                             u'description': u'',
                                                                                             u'group': u'',
                                                                                             u'hidden': True,
                                                                                             u'name': u'--no-stop-previous-version',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'type': u'bool',
                                                                                             u'value': u'NO_STOP_PREVIOUS_VERSION'},
                                                             u'--promote': {u'attr': {u'inverted_synopsis': True,
                                                                                      u'property': {u'name': u'app/promote_by_default'}},
                                                                            u'category': u'',
                                                                            u'choices': [],
                                                                            u'completer': u'',
                                                                            u'default': False,
                                                                            u'description': u'Promote the deployed version to receive all traffic.\n+\nTrue by default. To change the default behavior for your current\nenvironment, run:\n+\n    $ gcloud config set app/promote_by_default false',
                                                                            u'group': u'',
                                                                            u'hidden': False,
                                                                            u'name': u'--promote',
                                                                            u'nargs': u'0',
                                                                            u'required': False,
                                                                            u'type': u'bool',
                                                                            u'value': u'PROMOTE'},
                                                             u'--server': {u'attr': {},
                                                                           u'category': u'',
                                                                           u'choices': [],
                                                                           u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u'',
                                                                           u'group': u'',
                                                                           u'hidden': True,
                                                                           u'name': u'--server',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'type': u'string',
                                                                           u'value': u'SERVER'},
                                                             u'--skip-image-url-validation': {u'attr': {},
                                                                                              u'category': u'',
                                                                                              u'choices': [],
                                                                                              u'completer': u'',
                                                                                              u'default': False,
                                                                                              u'description': u'',
                                                                                              u'group': u'',
                                                                                              u'hidden': True,
                                                                                              u'name': u'--skip-image-url-validation',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'type': u'bool',
                                                                                              u'value': u'SKIP_IMAGE_URL_VALIDATION'},
                                                             u'--skip-staging': {u'attr': {},
                                                                                 u'category': u'',
                                                                                 u'choices': [],
                                                                                 u'completer': u'',
                                                                                 u'default': False,
                                                                                 u'description': u'',
                                                                                 u'group': u'',
                                                                                 u'hidden': True,
                                                                                 u'name': u'--skip-staging',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'type': u'bool',
                                                                                 u'value': u'SKIP_STAGING'},
                                                             u'--stop-previous-version': {u'attr': {u'inverted_synopsis': True,
                                                                                                    u'property': {u'name': u'app/stop_previous_version'}},
                                                                                          u'category': u'',
                                                                                          u'choices': [],
                                                                                          u'completer': u'',
                                                                                          u'default': False,
                                                                                          u'description': u'Stop the previously running version when deploying a new version that receives all traffic. Overrides the default *app/stop_previous_version* property value for this command invocation. Use *--no-stop-previous-version* to disable.',
                                                                                          u'group': u'',
                                                                                          u'hidden': False,
                                                                                          u'name': u'--stop-previous-version',
                                                                                          u'nargs': u'0',
                                                                                          u'required': False,
                                                                                          u'type': u'bool',
                                                                                          u'value': u'STOP_PREVIOUS_VERSION'}},
                                                  u'group': False,
                                                  u'groups': {},
                                                  u'hidden': False,
                                                  u'name': u'deploy',
                                                  u'path': [u'gcloud',
                                                            u'app',
                                                            u'deploy'],
                                                  u'positionals': [{u'completer': u'',
                                                                    u'default': None,
                                                                    u'description': u'The yaml files for the services or configurations you want to deploy.\nIf not given, defaults to `app.yaml` in the current directory.\nIf that is not found, attempts to automatically generate necessary\nconfiguration files (such as app.yaml) in the current directory.',
                                                                    u'name': u'deployables',
                                                                    u'nargs': u'*',
                                                                    u'required': False,
                                                                    u'value': u'DEPLOYABLES'}],
                                                  u'release': u'GA',
                                                  u'sections': {u'DESCRIPTION': u"This command is used to deploy both code and configuration to the App\nEngine server.  As an input it takes one or more ``DEPLOYABLES'' that\nshould be uploaded.  A ``DEPLOYABLE'' can be a service's .yaml file or a\nconfiguration's .yaml file.\n\nThis command supports App Engine flexible task queue files. The format\nof task queue files can be found at:\nhttps://cloud.google.com/appengine/docs/python/config/queueref\n",
                                                                u'EXAMPLES': u'To deploy a single service, run:\n\n  $ deploy ~/my_app/app.yaml\n\nTo deploy multiple services, run:\n\n  $ deploy ~/my_app/app.yaml ~/my_app/another_service.yaml\n'}},
                                      u'describe': {u'capsule': u'Display all data about an existing service.',
                                                    u'commands': {},
                                                    u'flags': {},
                                                    u'group': False,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'describe',
                                                    u'path': [u'gcloud',
                                                              u'app',
                                                              u'describe'],
                                                    u'positionals': [],
                                                    u'release': u'GA',
                                                    u'sections': {u'DESCRIPTION': u'Display all data about an existing service.',
                                                                  u'EXAMPLES': u'To show all the data about the current application, run\n\n    $ describe\n'}},
                                      u'instances': {u'capsule': u'View and manage your App Engine instances.',
                                                     u'commands': {u'delete': {u'capsule': u'Delete a specified instance.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--service': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The service ID.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--service',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': True,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'SERVICE'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'delete',
                                                                               u'path': [u'gcloud',
                                                                                         u'app',
                                                                                         u'instances',
                                                                                         u'delete'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The instance ID.',
                                                                                                 u'name': u'instance',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'INSTANCE'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Delete a specified instance.',
                                                                                             u'EXAMPLES': u'To delete instance i1 of service s1 and version v1, run:\n\n  $ delete i1 --service=s1 --version=v1\n'}},
                                                                   u'describe': {u'capsule': u'Display all data about an existing instance.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--service': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The service ID.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--service',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': True,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'SERVICE'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'describe',
                                                                                 u'path': [u'gcloud',
                                                                                           u'app',
                                                                                           u'instances',
                                                                                           u'describe'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The instance ID.',
                                                                                                   u'name': u'instance',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'INSTANCE'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'Display all data about an existing instance.',
                                                                                               u'EXAMPLES': u'To show all data about instance i1 for service s1 and version v1, run:\n\n    $ describe --service=s1 --version=v1 i1\n'}},
                                                                   u'disable-debug': {u'capsule': u'Disables debug mode for an instance.',
                                                                                      u'commands': {},
                                                                                      u'flags': {u'--service': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'If specified, only match instances belonging to the given service.\nThis affects both interactive and non-interactive selection.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--service',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'SERVICE'}},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'disable-debug',
                                                                                      u'path': [u'gcloud',
                                                                                                u'app',
                                                                                                u'instances',
                                                                                                u'disable-debug'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The instance ID to disable debug mode on. If not specified,\nselect instance interactively. Must uniquely specify (with other\nflags) exactly one instance',
                                                                                                        u'name': u'instance',
                                                                                                        u'nargs': u'?',
                                                                                                        u'required': False,
                                                                                                        u'value': u'INSTANCE'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u"When not in debug mode, SSH will be disabled on the VMs. They will be included\nin the health checking pools.\n\nNote that any local changes to an instance will be **lost** if debug mode is\ndisabled on the instance. New instance(s) may spawn depending on the app's\nscaling settings.",
                                                                                                    u'EXAMPLES': u'To disable debug mode for a particular instance, run:\n\n    $ disable-debug --service=s1 --version=v1 i1\n\nTo disable debug mode for an instance chosen interactively, run:\n\n    $ disable-debug\n'}},
                                                                   u'enable-debug': {u'capsule': u'Enables debug mode for an instance.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--service': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'If specified, only match instances belonging to the given service.\nThis affects both interactive and non-interactive selection.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--service',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'SERVICE'}},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'enable-debug',
                                                                                     u'path': [u'gcloud',
                                                                                               u'app',
                                                                                               u'instances',
                                                                                               u'enable-debug'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The instance ID to enable debug mode on. If not specified,\nselect instance interactively. Must uniquely specify (with other\nflags) exactly one instance',
                                                                                                       u'name': u'instance',
                                                                                                       u'nargs': u'?',
                                                                                                       u'required': False,
                                                                                                       u'value': u'INSTANCE'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u"When in debug mode, SSH will be enabled on the VMs, and you can use\n`gcloud compute ssh` to login to them. They will be removed from the health\nchecking pools, but they still receive requests.\n\nNote that any local changes to an instance will be **lost** if debug mode is\ndisabled on the instance. New instance(s) may spawn depending on the app's\nscaling settings.",
                                                                                                   u'EXAMPLES': u'To enable debug mode for a particular instance, run:\n\n    $ enable-debug --service=s1 --version=v1 i1\n\nTo enable debug mode for an instance chosen interactively, run:\n\n    $ enable-debug\n'}},
                                                                   u'list': {u'capsule': u'List the instances affiliated with the current App Engine project.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--filter',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'EXPRESSION'},
                                                                                        u'--limit': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--limit',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'LIMIT'},
                                                                                        u'--no-uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': True,
                                                                                                      u'description': u'',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': True,
                                                                                                      u'name': u'--no-uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'NO_URI'},
                                                                                        u'--page-size': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--page-size',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                        u'--service': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'If specified, only list instances belonging to the given service.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--service',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'SERVICE'},
                                                                                        u'--sort-by': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--sort-by',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'FIELD'},
                                                                                        u'--uri': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': False,
                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--uri',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'URI'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'list',
                                                                             u'path': [u'gcloud',
                                                                                       u'app',
                                                                                       u'instances',
                                                                                       u'list'],
                                                                             u'positionals': [],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'List the instances affiliated with the current App Engine project.',
                                                                                           u'EXAMPLES': u'To list all App Engine instances, run:\n\n    $ list\n\nTo list all App Engine instances for a given service, run:\n\n    $ list -s myservice\n\nTo list all App Engine instances for a given version, run:\n\n    $ list -v v1\n'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'instances',
                                                     u'path': [u'gcloud',
                                                               u'app',
                                                               u'instances'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'This set of commands can be used to view and manage your existing App Engine\ninstances.\n\nFor more information on App Engine instances, see:\nhttps://cloud.google.com/appengine/docs/python/an-overview-of-app-engine',
                                                                   u'EXAMPLES': u'To list your App Engine instances, run:\n\n  $ instances list\n'}},
                                      u'logs': {u'capsule': u'Manage your App Engine logs.',
                                                u'commands': {u'read': {u'capsule': u'Reads log entries for the current App Engine app.',
                                                                        u'commands': {},
                                                                        u'flags': {u'--level': {u'attr': {},
                                                                                                u'category': u'',
                                                                                                u'choices': [u'critical',
                                                                                                             u'error',
                                                                                                             u'warning',
                                                                                                             u'info',
                                                                                                             u'debug',
                                                                                                             u'any'],
                                                                                                u'completer': u'',
                                                                                                u'default': u'any',
                                                                                                u'description': u'Filter entries with severity equal to or higher than a given level. _LEVEL_ must be one of: *critical*, *error*, *warning*, *info*, *debug*, *any*.',
                                                                                                u'group': u'',
                                                                                                u'hidden': False,
                                                                                                u'name': u'--level',
                                                                                                u'nargs': u'0',
                                                                                                u'required': False,
                                                                                                u'type': u'string',
                                                                                                u'value': u'LEVEL'},
                                                                                   u'--limit': {u'attr': {},
                                                                                                u'category': u'',
                                                                                                u'choices': [],
                                                                                                u'completer': u'',
                                                                                                u'default': 200,
                                                                                                u'description': u'Number of log entries to show.',
                                                                                                u'group': u'',
                                                                                                u'hidden': False,
                                                                                                u'name': u'--limit',
                                                                                                u'nargs': u'0',
                                                                                                u'required': False,
                                                                                                u'type': u'int',
                                                                                                u'value': u'LIMIT'},
                                                                                   u'--logs': {u'attr': {},
                                                                                               u'category': u'',
                                                                                               u'choices': [],
                                                                                               u'completer': u'',
                                                                                               u'default': [u'stderr',
                                                                                                            u'stdout',
                                                                                                            u'crash.log',
                                                                                                            u'nginx.requests',
                                                                                                            u'request_log'],
                                                                                               u'description': u'Filter entries from a particular set of logs. Must be a comma-separated list of log names (request_log, stdout, stderr, etc).',
                                                                                               u'group': u'',
                                                                                               u'hidden': False,
                                                                                               u'name': u'--logs',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'type': u'list',
                                                                                               u'value': u'APP_LOG'},
                                                                                   u'--service': {u'attr': {},
                                                                                                  u'category': u'',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'Limit to specific service.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--service',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'string',
                                                                                                  u'value': u'SERVICE'}},
                                                                        u'group': False,
                                                                        u'groups': {},
                                                                        u'hidden': False,
                                                                        u'name': u'read',
                                                                        u'path': [u'gcloud',
                                                                                  u'app',
                                                                                  u'logs',
                                                                                  u'read'],
                                                                        u'positionals': [],
                                                                        u'release': u'GA',
                                                                        u'sections': {u'DESCRIPTION': u'Display the latest log entries from stdout, stderr and crash log for the\ncurrent Google App Engine app in a human readable format.\n',
                                                                                      u'EXAMPLES': u'To display the latest entries for the current app, run:\n\n  $ read\n\nTo show only the entries with severity at `warning` or higher, run:\n\n  $ read --level=warning\n\nTo show only the entries with a specific version, run:\n\n  $ read --version=v1\n\nTo show only the 10 latest log entries for the default service, run:\n\n  $ read --limit 10 --service=default\n\nTo show only the logs from the request log for standard apps, run:\n\n  $ read --logs=request_log\n\nTo show only the logs from the request log for Flex apps, run:\n\n  $ read --logs=nginx.requests\n'}},
                                                              u'tail': {u'capsule': u'Streams logs for App Engine apps.',
                                                                        u'commands': {},
                                                                        u'flags': {u'--level': {u'attr': {},
                                                                                                u'category': u'',
                                                                                                u'choices': [u'critical',
                                                                                                             u'error',
                                                                                                             u'warning',
                                                                                                             u'info',
                                                                                                             u'debug',
                                                                                                             u'any'],
                                                                                                u'completer': u'',
                                                                                                u'default': u'any',
                                                                                                u'description': u'Filter entries with severity equal to or higher than a given level. _LEVEL_ must be one of: *critical*, *error*, *warning*, *info*, *debug*, *any*.',
                                                                                                u'group': u'',
                                                                                                u'hidden': False,
                                                                                                u'name': u'--level',
                                                                                                u'nargs': u'0',
                                                                                                u'required': False,
                                                                                                u'type': u'string',
                                                                                                u'value': u'LEVEL'},
                                                                                   u'--logs': {u'attr': {},
                                                                                               u'category': u'',
                                                                                               u'choices': [],
                                                                                               u'completer': u'',
                                                                                               u'default': [u'stderr',
                                                                                                            u'stdout',
                                                                                                            u'crash.log',
                                                                                                            u'nginx.requests',
                                                                                                            u'request_log'],
                                                                                               u'description': u'Filter entries from a particular set of logs. Must be a comma-separated list of log names (request_log, stdout, stderr, etc).',
                                                                                               u'group': u'',
                                                                                               u'hidden': False,
                                                                                               u'name': u'--logs',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'type': u'list',
                                                                                               u'value': u'APP_LOG'},
                                                                                   u'--service': {u'attr': {},
                                                                                                  u'category': u'',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'Limit to specific service.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--service',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'string',
                                                                                                  u'value': u'SERVICE'}},
                                                                        u'group': False,
                                                                        u'groups': {},
                                                                        u'hidden': False,
                                                                        u'name': u'tail',
                                                                        u'path': [u'gcloud',
                                                                                  u'app',
                                                                                  u'logs',
                                                                                  u'tail'],
                                                                        u'positionals': [],
                                                                        u'release': u'GA',
                                                                        u'sections': {u'DESCRIPTION': u'Streams logs for App Engine apps.',
                                                                                      u'EXAMPLES': u'To stream logs from a serving app, run:\n\n  $ tail\n\nTo show only logs with a specific service, version, and level, run:\n\n  $ tail --service=s1 --version=v1 --level=warning\n\nTo show only the logs from the request log for Standard apps, run:\n\n  $ tail --logs=request_log\n\nTo show only the logs from the request log for Flex apps, run:\n\n  $ tail --logs=nginx.requests\n'}}},
                                                u'flags': {},
                                                u'group': True,
                                                u'groups': {},
                                                u'hidden': False,
                                                u'name': u'logs',
                                                u'path': [u'gcloud',
                                                          u'app',
                                                          u'logs'],
                                                u'positionals': [],
                                                u'release': u'GA',
                                                u'sections': {u'DESCRIPTION': u'This set of commands can be used to view your existing App Engine logs.',
                                                              u'EXAMPLES': u'To read the logs for the current App Engine project, run:\n\n  $ logs read\n'}},
                                      u'open-console': {u'capsule': u'Open the App Engine dashboard, or log viewer, in a web browser.',
                                                        u'commands': {},
                                                        u'flags': {u'--logs': {u'attr': {},
                                                                               u'category': u'',
                                                                               u'choices': [],
                                                                               u'completer': u'',
                                                                               u'default': False,
                                                                               u'description': u'Open the log viewer instead of the App Engine dashboard.',
                                                                               u'group': u'',
                                                                               u'hidden': False,
                                                                               u'name': u'--logs',
                                                                               u'nargs': u'0',
                                                                               u'required': False,
                                                                               u'type': u'bool',
                                                                               u'value': u'LOGS'},
                                                                   u'--no-logs': {u'attr': {},
                                                                                  u'category': u'',
                                                                                  u'choices': [],
                                                                                  u'completer': u'',
                                                                                  u'default': False,
                                                                                  u'description': u'',
                                                                                  u'group': u'',
                                                                                  u'hidden': True,
                                                                                  u'name': u'--no-logs',
                                                                                  u'nargs': u'0',
                                                                                  u'required': False,
                                                                                  u'type': u'bool',
                                                                                  u'value': u'NO_LOGS'},
                                                                   u'--service': {u'attr': {},
                                                                                  u'category': u'',
                                                                                  u'choices': [],
                                                                                  u'completer': u'',
                                                                                  u'default': None,
                                                                                  u'description': u'The service to consider. If not specified, use the default service.',
                                                                                  u'group': u'',
                                                                                  u'hidden': False,
                                                                                  u'name': u'--service',
                                                                                  u'nargs': u'0',
                                                                                  u'required': False,
                                                                                  u'type': u'string',
                                                                                  u'value': u'SERVICE'}},
                                                        u'group': False,
                                                        u'groups': {},
                                                        u'hidden': False,
                                                        u'name': u'open-console',
                                                        u'path': [u'gcloud',
                                                                  u'app',
                                                                  u'open-console'],
                                                        u'positionals': [],
                                                        u'release': u'GA',
                                                        u'sections': {u'DESCRIPTION': u'Open the App Engine dashboard, or log viewer, in a web browser.\n',
                                                                      u'EXAMPLES': u'Open the App Engine dashboard for the default service:\n\n    $ open-console\n\nOpen the service specific dashboard view:\n\n    $ open-console --service="myService"\n\nOpen the version specific dashboard view:\n\n    $ open-console --service="myService" --version="v1"\n\nOpen the log viewer for the default service:\n\n    $ open-console --logs\n'}},
                                      u'operations': {u'capsule': u'View and manage your App Engine Operations.',
                                                      u'commands': {u'describe': {u'capsule': u'Describes the operation.',
                                                                                  u'commands': {},
                                                                                  u'flags': {},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'describe',
                                                                                  u'path': [u'gcloud',
                                                                                            u'app',
                                                                                            u'operations',
                                                                                            u'describe'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'ID of operation.',
                                                                                                    u'name': u'operation',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'OPERATION'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'Describes the operation.',
                                                                                                u'EXAMPLES': u'To describe an App Engine operation called o1, run:\n\n    $ describe o1\n'}},
                                                                    u'list': {u'capsule': u'List the operations.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--filter',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'EXPRESSION'},
                                                                                         u'--limit': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--limit',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'LIMIT'},
                                                                                         u'--no-pending': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': True,
                                                                                                           u'name': u'--no-pending',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'NO_PENDING'},
                                                                                         u'--no-uri': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': True,
                                                                                                       u'description': u'',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': True,
                                                                                                       u'name': u'--no-uri',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'NO_URI'},
                                                                                         u'--page-size': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--page-size',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                         u'--pending': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': False,
                                                                                                        u'description': u'Only display pending operations',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--pending',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'PENDING'},
                                                                                         u'--sort-by': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--sort-by',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'list',
                                                                                                        u'value': u'FIELD'},
                                                                                         u'--uri': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': False,
                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--uri',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'URI'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'list',
                                                                              u'path': [u'gcloud',
                                                                                        u'app',
                                                                                        u'operations',
                                                                                        u'list'],
                                                                              u'positionals': [],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'List the operations.',
                                                                                            u'EXAMPLES': u'To list all App Engine operations, run:\n\n    $ list\n\nTo list only 100 App Engine operations, run:\n\n    $ list --limit 100\n\nTo list only pending App Engine operations, run:\n\n    $ list --pending\n'}},
                                                                    u'wait': {u'capsule': u'Polls an operation until completion.',
                                                                              u'commands': {},
                                                                              u'flags': {},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'wait',
                                                                              u'path': [u'gcloud',
                                                                                        u'app',
                                                                                        u'operations',
                                                                                        u'wait'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'ID of operation.',
                                                                                                u'name': u'operation',
                                                                                                u'nargs': u'0',
                                                                                                u'required': False,
                                                                                                u'value': u'OPERATION'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'Polls an operation until completion.',
                                                                                            u'EXAMPLES': u'To wait for an App Engine operation called o1 to complete, run:\n\n    $ wait o1\n'}}},
                                                      u'flags': {},
                                                      u'group': True,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'operations',
                                                      u'path': [u'gcloud',
                                                                u'app',
                                                                u'operations'],
                                                      u'positionals': [],
                                                      u'release': u'GA',
                                                      u'sections': {u'DESCRIPTION': u'This set of commands can be used to view and manage your existing App Engine\noperations.',
                                                                    u'EXAMPLES': u'To list your App Engine operations, run:\n\n  $ operations list\n'}},
                                      u'regions': {u'capsule': u'View regional availability of App Engine runtime environments.',
                                                   u'commands': {u'list': {u'capsule': u'List the availability of flex and standard environments for each region.',
                                                                           u'commands': {},
                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--filter',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'EXPRESSION'},
                                                                                      u'--limit': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--limit',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'LIMIT'},
                                                                                      u'--no-uri': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': True,
                                                                                                    u'description': u'',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': True,
                                                                                                    u'name': u'--no-uri',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'NO_URI'},
                                                                                      u'--page-size': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--page-size',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                      u'--sort-by': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--sort-by',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'list',
                                                                                                     u'value': u'FIELD'},
                                                                                      u'--uri': {u'attr': {},
                                                                                                 u'category': u'LIST COMMAND',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': False,
                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'--uri',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'type': u'bool',
                                                                                                 u'value': u'URI'}},
                                                                           u'group': False,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'list',
                                                                           u'path': [u'gcloud',
                                                                                     u'app',
                                                                                     u'regions',
                                                                                     u'list'],
                                                                           u'positionals': [],
                                                                           u'release': u'GA',
                                                                           u'sections': {u'DESCRIPTION': u'List the availability of flex and standard environments for each region.',
                                                                                         u'EXAMPLES': u'To view regional availability of App Engine runtime environments, run:\n\n    $ list\n'}}},
                                                   u'flags': {},
                                                   u'group': True,
                                                   u'groups': {},
                                                   u'hidden': False,
                                                   u'name': u'regions',
                                                   u'path': [u'gcloud',
                                                             u'app',
                                                             u'regions'],
                                                   u'positionals': [],
                                                   u'release': u'GA',
                                                   u'sections': {u'DESCRIPTION': u'This command can be used to view availability of App Engine standard and\nflexible runtime environments in all geographic regions.',
                                                                 u'EXAMPLES': u'To view regional availability of App Engine runtime environments, run:\n\n  $ regions list\n'}},
                                      u'services': {u'capsule': u'View and manage your App Engine services.',
                                                    u'commands': {u'browse': {u'capsule': u'Open the specified service(s) in a browser.',
                                                                              u'commands': {},
                                                                              u'flags': {},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'browse',
                                                                              u'path': [u'gcloud',
                                                                                        u'app',
                                                                                        u'services',
                                                                                        u'browse'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'The services to open (optionally filtered by the --version flag).',
                                                                                                u'name': u'services',
                                                                                                u'nargs': u'+',
                                                                                                u'required': False,
                                                                                                u'value': u'SERVICES'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'Open the specified service(s) in a browser.',
                                                                                            u'EXAMPLES': u'To show the url for the default service in the browser, run:\n\n    $ browse default\n\nTo show version `v1` of service `myService` in the browser, run:\n\n    $ browse myService --version="v1"\n\nTo show multiple services side-by-side, run:\n\n    $ browse default otherService\n\nTo show multiple services side-by-side with a specific version, run:\n\n    $ browse s1 s2 --version v1\n'}},
                                                                  u'delete': {u'capsule': u'Delete services in the current project.',
                                                                              u'commands': {},
                                                                              u'flags': {},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'delete',
                                                                              u'path': [u'gcloud',
                                                                                        u'app',
                                                                                        u'services',
                                                                                        u'delete'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'The service(s) to delete.',
                                                                                                u'name': u'services',
                                                                                                u'nargs': u'+',
                                                                                                u'required': False,
                                                                                                u'value': u'SERVICES'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'Delete services in the current project.',
                                                                                            u'EXAMPLES': u'To delete a service (and all of its accompanying versions) in the\ncurrent project, run:\n\n  $ delete service1\n\nTo delete multiple services (and all of their accompanying versions)\nin the current project, run:\n\n  $ delete service1 service2\n'}},
                                                                  u'describe': {u'capsule': u'Display all data about an existing service.',
                                                                                u'commands': {},
                                                                                u'flags': {},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'describe',
                                                                                u'path': [u'gcloud',
                                                                                          u'app',
                                                                                          u'services',
                                                                                          u'describe'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'The service to describe.',
                                                                                                  u'name': u'service',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'SERVICE'}],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u'Display all data about an existing service.',
                                                                                              u'EXAMPLES': u'To show all the data about service s1, run\n\n    $ describe s1\n'}},
                                                                  u'list': {u'capsule': u'List your existing services.',
                                                                            u'commands': {},
                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--filter',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'EXPRESSION'},
                                                                                       u'--limit': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--limit',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'LIMIT'},
                                                                                       u'--no-uri': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': True,
                                                                                                     u'description': u'',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': True,
                                                                                                     u'name': u'--no-uri',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'NO_URI'},
                                                                                       u'--page-size': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--page-size',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                       u'--sort-by': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--sort-by',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'list',
                                                                                                      u'value': u'FIELD'},
                                                                                       u'--uri': {u'attr': {},
                                                                                                  u'category': u'LIST COMMAND',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': False,
                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--uri',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'bool',
                                                                                                  u'value': u'URI'}},
                                                                            u'group': False,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'list',
                                                                            u'path': [u'gcloud',
                                                                                      u'app',
                                                                                      u'services',
                                                                                      u'list'],
                                                                            u'positionals': [],
                                                                            u'release': u'GA',
                                                                            u'sections': {u'DESCRIPTION': u'This command lists all services that are currently deployed to the App Engine\nserver.',
                                                                                          u'EXAMPLES': u'To list all services in the current project, run:\n\n  $ list\n\n'}},
                                                                  u'set-traffic': {u'capsule': u'Set traffic splitting settings.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--migrate': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': False,
                                                                                                             u'description': u'The migrate flag determines whether or not to use traffic migration\nduring the operation. Traffic migration will attempt to automatically\nmigrate traffic from the previous version to the new version, giving\nthe autoscaler time to respond. See the documentation here:\n[](https://cloud.google.com/appengine/docs/python/console/trafficmigration)\nfor more information.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--migrate',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'MIGRATE'},
                                                                                              u'--no-migrate': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--no-migrate',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_MIGRATE'},
                                                                                              u'--split-by': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [u'cookie',
                                                                                                                           u'ip'],
                                                                                                              u'completer': u'',
                                                                                                              u'default': u'ip',
                                                                                                              u'description': u'Whether to split traffic based on cookies or IP addresses. _SPLIT_BY_ must be one of: *cookie*, *ip*.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--split-by',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'SPLIT_BY'},
                                                                                              u'--splits': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Key-value pairs describing what proportion of traffic should go to\neach version. The split values are added together and used as\nweights. The exact values do not matter, only their relation to each\nother. For example, v1=2,v2=2 is equivalent to v1=.5,v2=.5',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--splits',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': True,
                                                                                                            u'type': u'dict',
                                                                                                            u'value': u'SPLITS'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'set-traffic',
                                                                                   u'path': [u'gcloud',
                                                                                             u'app',
                                                                                             u'services',
                                                                                             u'set-traffic'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The services to modify.',
                                                                                                     u'name': u'services',
                                                                                                     u'nargs': u'*',
                                                                                                     u'required': False,
                                                                                                     u'value': u'SERVICES'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'This command sets the traffic split of versions across a service or a project.',
                                                                                                 u'EXAMPLES': u"To send all traffic to 'v2' of service 's1', run:\n\n  $ set-traffic s1 --splits v2=1\n\nTo split traffic evenly between 'v1' and 'v2' of service 's1', run:\n\n  $ set-traffic s1 --splits v2=.5,v1=.5\n\nTo split traffic across all services:\n\n  $ set-traffic --splits v2=.5,v1=.5\n"}}},
                                                    u'flags': {},
                                                    u'group': True,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'services',
                                                    u'path': [u'gcloud',
                                                              u'app',
                                                              u'services'],
                                                    u'positionals': [],
                                                    u'release': u'GA',
                                                    u'sections': {u'DESCRIPTION': u'This set of commands can be used to view and manage your existing App Engine\nservices.\n\nTo create new deployments, use `app deploy`.\n\nFor more information on App Engine services, see:\nhttps://cloud.google.com/appengine/docs/python/an-overview-of-app-engine',
                                                                  u'EXAMPLES': u'To list your deployed services, run:\n\n  $ services list\n'}},
                                      u'versions': {u'capsule': u'View and manage your App Engine versions.',
                                                    u'commands': {u'browse': {u'capsule': u'Open the specified versions in a browser.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--service': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'If specified, only open versions from the given service. If not specified, use the default service.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--service',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'SERVICE'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'browse',
                                                                              u'path': [u'gcloud',
                                                                                        u'app',
                                                                                        u'versions',
                                                                                        u'browse'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'The versions to open (optionally filtered by the --service flag).',
                                                                                                u'name': u'versions',
                                                                                                u'nargs': u'+',
                                                                                                u'required': False,
                                                                                                u'value': u'VERSIONS'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'Open the specified versions in a browser.',
                                                                                            u'EXAMPLES': u'To show version `v1` for the default service in the browser, run:\n\n    $ browse v1\n\nTo show version `v1` of a specific service in the browser, run:\n\n    $ browse v1 --service="myService"\n\nTo show multiple versions side-by-side, run:\n\n    $ browse v1 v2 --service="myService"\n'}},
                                                                  u'delete': {u'capsule': u'Delete a specified version.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--service': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'If specified, only delete versions from the given service.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--service',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'SERVICE'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'delete',
                                                                              u'path': [u'gcloud',
                                                                                        u'app',
                                                                                        u'versions',
                                                                                        u'delete'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'The versions to delete (optionally filtered by the --service flag).',
                                                                                                u'name': u'versions',
                                                                                                u'nargs': u'+',
                                                                                                u'required': False,
                                                                                                u'value': u'VERSIONS'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'You cannot delete a version of a service that is currently receiving traffic.',
                                                                                            u'EXAMPLES': u'To delete a specific version of a specific service, run:\n\n  $ delete --service myService v1\n\nTo delete a named version across all services, run:\n\n  $ delete v1\n\nTo delete multiple versions of a specific service, run:\n\n  $ delete --service myService v1 v2\n\nTo delete multiple named versions across all services, run:\n\n  $ delete v1 v2\n'}},
                                                                  u'describe': {u'capsule': u'Display all data about an existing version.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--service': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The service corresponding to the version to show.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--service',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': True,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'SERVICE'}},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'describe',
                                                                                u'path': [u'gcloud',
                                                                                          u'app',
                                                                                          u'versions',
                                                                                          u'describe'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'The ID of the version to show.',
                                                                                                  u'name': u'version',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'VERSION'}],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u'Display all data about an existing version.'}},
                                                                  u'list': {u'capsule': u'List your existing versions.',
                                                                            u'commands': {},
                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--filter',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'EXPRESSION'},
                                                                                       u'--hide-no-traffic': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'Only show versions that are receiving traffic.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--hide-no-traffic',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'HIDE_NO_TRAFFIC'},
                                                                                       u'--limit': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--limit',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'LIMIT'},
                                                                                       u'--no-hide-no-traffic': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': True,
                                                                                                                 u'description': u'',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': True,
                                                                                                                 u'name': u'--no-hide-no-traffic',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'NO_HIDE_NO_TRAFFIC'},
                                                                                       u'--no-uri': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': True,
                                                                                                     u'description': u'',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': True,
                                                                                                     u'name': u'--no-uri',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'NO_URI'},
                                                                                       u'--page-size': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--page-size',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                       u'--service': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Only show versions from this service.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--service',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'SERVICE'},
                                                                                       u'--sort-by': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--sort-by',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'list',
                                                                                                      u'value': u'FIELD'},
                                                                                       u'--uri': {u'attr': {},
                                                                                                  u'category': u'LIST COMMAND',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': False,
                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--uri',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'bool',
                                                                                                  u'value': u'URI'}},
                                                                            u'group': False,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'list',
                                                                            u'path': [u'gcloud',
                                                                                      u'app',
                                                                                      u'versions',
                                                                                      u'list'],
                                                                            u'positionals': [],
                                                                            u'release': u'GA',
                                                                            u'sections': {u'DESCRIPTION': u'This command lists all the versions of all services that are currently\ndeployed to the App Engine server.',
                                                                                          u'EXAMPLES': u'To list all services and versions, run:\n\n  $ list\n\nTo list all versions for a specific service, run:\n\n  $ list --service service1\n\nTo list only versions that are receiving traffic, run:\n\n  $ list --hide-no-traffic\n'}},
                                                                  u'migrate': {u'capsule': u'Migrate traffic from one version to another for a set of services.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--service': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'If specified, only migrate versions from the given service.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--service',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'SERVICE'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'migrate',
                                                                               u'path': [u'gcloud',
                                                                                         u'app',
                                                                                         u'versions',
                                                                                         u'migrate'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The version to migrate to.',
                                                                                                 u'name': u'version',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'VERSION'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Migrate traffic from one version to another for a set of services.',
                                                                                             u'EXAMPLES': u'This only works for automatically scaled Standard versions.\nTo migrate from one version to another for all services where there\nis a version v2 and shut down the previous version, run:\n\n  $ migrate v2\n\nTo migrate from one version to another for a specific service, run:\n\n  $ migrate v2 --service="s1"\n'}},
                                                                  u'start': {u'capsule': u'Start serving specified versions.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--service': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'If specified, only start versions from the given service.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--service',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'SERVICE'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'start',
                                                                             u'path': [u'gcloud',
                                                                                       u'app',
                                                                                       u'versions',
                                                                                       u'start'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'The versions to start. (optionally filtered by the --service flag).',
                                                                                               u'name': u'versions',
                                                                                               u'nargs': u'+',
                                                                                               u'required': False,
                                                                                               u'value': u'VERSIONS'}],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'This command starts serving the specified versions. It may only be used if the\nscaling module for your service has been set to manual.',
                                                                                           u'EXAMPLES': u'To start a specific version across all services, run:\n\n  $ start v1\n\nTo start multiple named versions across all services, run:\n\n  $ start v1 v2\n\nTo start a single version on a single service, run:\n\n  $ start --service servicename v1\n\nTo start multiple versions in a single service, run:\n\n  $ start --service servicename v1 v2\n'}},
                                                                  u'stop': {u'capsule': u'Stop serving specified versions.',
                                                                            u'commands': {},
                                                                            u'flags': {u'--service': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'If specified, only stop versions from the given service.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--service',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'SERVICE'}},
                                                                            u'group': False,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'stop',
                                                                            u'path': [u'gcloud',
                                                                                      u'app',
                                                                                      u'versions',
                                                                                      u'stop'],
                                                                            u'positionals': [{u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u'The versions to stop (optionally filtered by the --service flag).',
                                                                                              u'name': u'versions',
                                                                                              u'nargs': u'+',
                                                                                              u'required': False,
                                                                                              u'value': u'VERSIONS'}],
                                                                            u'release': u'GA',
                                                                            u'sections': {u'DESCRIPTION': u'This command stops serving the specified versions. It may only be used if the\nscaling module for your service has been set to manual.',
                                                                                          u'EXAMPLES': u'To stop a specific version across all services, run:\n\n  $ stop v1\n\nTo stop multiple named versions across all services, run:\n\n  $ stop v1 v2\n\nTo stop a single version on a single service, run:\n\n  $ stop --service servicename v1\n\nTo stop multiple versions in a single service, run:\n\n  $ stop --service servicename v1 v2\n\nNote that that last example may be more simply written using the\n`services stop` command (see its documentation for details).\n'}}},
                                                    u'flags': {},
                                                    u'group': True,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'versions',
                                                    u'path': [u'gcloud',
                                                              u'app',
                                                              u'versions'],
                                                    u'positionals': [],
                                                    u'release': u'GA',
                                                    u'sections': {u'DESCRIPTION': u'This set of commands can be used to view and manage your existing App Engine\nversions.\n\nTo create new deployments, use `app deploy`.\n\nFor more information on App Engine versions, see:\nhttps://cloud.google.com/appengine/docs/python/an-overview-of-app-engine\n\n## EXAMPLES\n\nTo list your deployed versions, run:\n\n  $ versions list'}}},
                        u'flags': {},
                        u'group': True,
                        u'groups': {},
                        u'hidden': False,
                        u'name': u'app',
                        u'path': [u'gcloud', u'app'],
                        u'positionals': [],
                        u'release': u'GA',
                        u'sections': {u'DESCRIPTION': u'\nThe gcloud app command group lets you deploy and manage your Google App\nEngine apps. These commands replace their equivalents in the appcfg\ntool.\n\nApp Engine is a platform for building scalable web applications\nand mobile backends. App Engine provides you with built-in services and\nAPIs such as NoSQL datastores, memcache, and a user authentication API,\ncommon to most applications.\n\nMore information on App Engine can be found here:\nhttps://cloud.google.com/appengine and detailed documentation can be\nfound here: https://cloud.google.com/appengine/docs/\n',
                                      u'EXAMPLES': u'To run your app locally in the development application server, run:\n\n  $ dev_appserver.py DEPLOYABLES\n\nTo create a new deployment of one or more services, run:\n\n  $ app deploy DEPLOYABLES\n\nTo list your existing deployments, run:\n\n  $ app versions list\n\nTo generate config files for your source directory:\n\n  $ app gen-config\n'}},
               u'auth': {u'capsule': u'Manage oauth2 credentials for the Google Cloud SDK.',
                         u'commands': {u'activate-service-account': {u'capsule': u'Authorize access to Google Cloud Platform using a service account.',
                                                                     u'commands': {},
                                                                     u'flags': {u'--key-file': {u'attr': {},
                                                                                                u'category': u'',
                                                                                                u'choices': [],
                                                                                                u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'Path to the private key file.',
                                                                                                u'group': u'',
                                                                                                u'hidden': False,
                                                                                                u'name': u'--key-file',
                                                                                                u'nargs': u'0',
                                                                                                u'required': True,
                                                                                                u'type': u'string',
                                                                                                u'value': u'KEY_FILE'},
                                                                                u'--password-file': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Path to a file containing the password for the service account private key (only for a .p12 file).',
                                                                                                     u'group': u'activate-service-account.1',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--password-file',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'PASSWORD_FILE'},
                                                                                u'--prompt-for-password': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'Prompt for the password for the service account private key (only for a .p12 file).',
                                                                                                           u'group': u'activate-service-account.1',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--prompt-for-password',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'PROMPT_FOR_PASSWORD'}},
                                                                     u'group': False,
                                                                     u'groups': {u'activate-service-account.1': {u'description': u'At most one of these may be specified:',
                                                                                                                 u'is_mutex': True,
                                                                                                                 u'is_required': False}},
                                                                     u'hidden': False,
                                                                     u'name': u'activate-service-account',
                                                                     u'path': [u'gcloud',
                                                                               u'auth',
                                                                               u'activate-service-account'],
                                                                     u'positionals': [{u'completer': u'',
                                                                                       u'default': None,
                                                                                       u'description': u'E-mail address of the service account.',
                                                                                       u'name': u'account',
                                                                                       u'nargs': u'?',
                                                                                       u'required': False,
                                                                                       u'value': u'ACCOUNT'}],
                                                                     u'release': u'GA',
                                                                     u'sections': {u'DESCRIPTION': u'Obtains access credentials for the service account using a .json (preferred)\nor .p12 file that contains a private authorization key. You obtain the key\nfile from the [Cloud Platform console](https://console.cloud.google.com). For\n.p12 files, a password is required. This password is displayed in the console\nwhen you create the key. If you specify a project using the `--project` flag,\nthe project is set in your active configuration.\n\nAny previously active credentials will still be retained,\nthey will just no longer be the active credentials.'}},
                                       u'application-default': {u'capsule': u'Manage your active Application Default Credentials.',
                                                                u'commands': {u'login': {u'capsule': u'Acquire new user credentials to use for Application Default Credentials.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--client-id-file': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'A file containing your own client id to use to login.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--client-id-file',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'CLIENT_ID_FILE'},
                                                                                                    u'--launch-browser': {u'attr': {u'inverted_synopsis': True},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': True,
                                                                                                                          u'description': u'Launch a browser for authorization. If not enabled or DISPLAY variable is not set, prints a URL to standard output to be copied. Enabled by default, use *--no-launch-browser* to disable.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--launch-browser',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'LAUNCH_BROWSER'},
                                                                                                    u'--no-launch-browser': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': True,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-launch-browser',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_LAUNCH_BROWSER'},
                                                                                                    u'--scopes': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The names of the scopes to authorize for. By default https://www.googleapis.com/auth/userinfo.email, https://www.googleapis.com/auth/cloud-platform scopes are used. The list of possible scopes can be found at: [](https://developers.google.com/identity/protocols/googlescopes).',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--scopes',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'list',
                                                                                                                  u'value': u'SCOPES'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'login',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'auth',
                                                                                                   u'application-default',
                                                                                                   u'login'],
                                                                                         u'positionals': [],
                                                                                         u'release': u'GA',
                                                                                         u'sections': {u'DESCRIPTION': u'Obtains user access credentials via a web flow and puts them in the\nwell-known location for Application Default Credentials to use them as a proxy\nfor a service account.\n\nThis command is useful for when you are developing code that would normally\nuse a service account, but you need to run the code in a local development\nenvironment, and it is easier to provide user credentials. The credentials\nwill apply to all API calls that make use of the Application Default\nCredentials client library.\n\nThis command has no effect on the user account(s) set up by the\n`gcloud auth login` command. Any credentials previously generated by this\ncommand will be overwritten.',
                                                                                                       u'EXAMPLES': u'If you want your local application to temporarily use your own user\ncredentials for API access, run:\n\n  $ login\n'}},
                                                                              u'print-access-token': {u'capsule': u'Print an access token for the your current Application Default Credentials.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'print-access-token',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'auth',
                                                                                                                u'application-default',
                                                                                                                u'print-access-token'],
                                                                                                      u'positionals': [],
                                                                                                      u'release': u'GA',
                                                                                                      u'sections': {u'DESCRIPTION': u'Once you have generated Application Default Credentials using\n`application-default login`, you can use this command to generate and print\nan access token that can be directly used for making an API call. This can be\nuseful for manually testing out APIs via curl.'}},
                                                                              u'revoke': {u'capsule': u'Revoke previously generated Application Default Credentials.',
                                                                                          u'commands': {},
                                                                                          u'flags': {},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'revoke',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'auth',
                                                                                                    u'application-default',
                                                                                                    u'revoke'],
                                                                                          u'positionals': [],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'Revokes Application Default Credentials that have been previously generated by\n`application-default login` and deletes the local credential file.\n\nThis does not effect any credentials set up through other means,\nfor example credentials referenced by the Application Default Credentials\nenvironment variable or service account credentials that are active on\na Google Compute Engine virtual machine.'}}},
                                                                u'flags': {},
                                                                u'group': True,
                                                                u'groups': {},
                                                                u'hidden': False,
                                                                u'name': u'application-default',
                                                                u'path': [u'gcloud',
                                                                          u'auth',
                                                                          u'application-default'],
                                                                u'positionals': [],
                                                                u'release': u'GA',
                                                                u'sections': {u'DESCRIPTION': u'Application Default Credentials (ADC) provide a method to get credentials used\nin calling Google APIs. The application-default command group allows you to manage\nactive credentials on your machine that are used for local application\ndevelopment.\n\nThese credentials are only used by Google client libraries in your own\napplication.\n\nMore information on ADC and how they work can be found here:\nhttps://developers.google.com/identity/protocols/application-default-credentials\n\n## EXAMPLES\n\nTo create a service account and have your application use it for API access,\nrun:\n\n  $ gcloud iam service-accounts create my-account\n  $ gcloud iam service-accounts keys create key.json\n    --iam-account=my-account@my-project.iam.gserviceaccount.com\n  $ export GOOGLE_APPLICATION_CREDENTIALS=key.json\n  $ ./my_application.sh\n\nTo temporarily use your own user credentials, run:\n\n  $ application-default login\n\nThis will take you through a web flow to acquire new user credentials.'}},
                                       u'list': {u'capsule': u'Lists credentialed accounts.',
                                                 u'commands': {},
                                                 u'flags': {u'--filter': {u'attr': {},
                                                                          u'category': u'LIST COMMAND',
                                                                          u'choices': [],
                                                                          u'completer': u'',
                                                                          u'default': None,
                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                          u'group': u'',
                                                                          u'hidden': False,
                                                                          u'name': u'--filter',
                                                                          u'nargs': u'0',
                                                                          u'required': False,
                                                                          u'type': u'string',
                                                                          u'value': u'EXPRESSION'},
                                                            u'--filter-account': {u'attr': {},
                                                                                  u'category': u'',
                                                                                  u'choices': [],
                                                                                  u'completer': u'',
                                                                                  u'default': None,
                                                                                  u'description': u'List only credentials for one account. Use\n--filter="account~_PATTERN_" to select accounts that match\n_PATTERN_.',
                                                                                  u'group': u'',
                                                                                  u'hidden': False,
                                                                                  u'name': u'--filter-account',
                                                                                  u'nargs': u'0',
                                                                                  u'required': False,
                                                                                  u'type': u'string',
                                                                                  u'value': u'FILTER_ACCOUNT'},
                                                            u'--limit': {u'attr': {},
                                                                         u'category': u'LIST COMMAND',
                                                                         u'choices': [],
                                                                         u'completer': u'',
                                                                         u'default': None,
                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                         u'group': u'',
                                                                         u'hidden': False,
                                                                         u'name': u'--limit',
                                                                         u'nargs': u'0',
                                                                         u'required': False,
                                                                         u'type': u'string',
                                                                         u'value': u'LIMIT'},
                                                            u'--page-size': {u'attr': {},
                                                                             u'category': u'LIST COMMAND',
                                                                             u'choices': [],
                                                                             u'completer': u'',
                                                                             u'default': None,
                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                             u'group': u'',
                                                                             u'hidden': False,
                                                                             u'name': u'--page-size',
                                                                             u'nargs': u'0',
                                                                             u'required': False,
                                                                             u'type': u'string',
                                                                             u'value': u'PAGE_SIZE'},
                                                            u'--sort-by': {u'attr': {},
                                                                           u'category': u'LIST COMMAND',
                                                                           u'choices': [],
                                                                           u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                           u'group': u'',
                                                                           u'hidden': False,
                                                                           u'name': u'--sort-by',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'type': u'list',
                                                                           u'value': u'FIELD'}},
                                                 u'group': False,
                                                 u'groups': {},
                                                 u'hidden': False,
                                                 u'name': u'list',
                                                 u'path': [u'gcloud',
                                                           u'auth',
                                                           u'list'],
                                                 u'positionals': [],
                                                 u'release': u'GA',
                                                 u'sections': {u'DESCRIPTION': u'Lists accounts whose credentials have been obtained using `gcloud init`,\n`gcloud auth login` and `gcloud auth activate-service-account`, and shows\nwhich account is active. The active account is used by gcloud and other Cloud\nSDK tools to access Google Cloud Platform.\n\n## EXAMPLES\n\nTo list the active account name:\n\n  $ gcloud auth list --filter=status:ACTIVE --format="value(account)"\n\nTo list the inactive account names with prefix `test`:\n\n  $ gcloud auth list --filter="-status:ACTIVE account:test*" --format="value(account)"'}},
                                       u'login': {u'capsule': u'Authorize gcloud to access Google Cloud Platform.',
                                                  u'commands': {},
                                                  u'flags': {u'--activate': {u'attr': {u'inverted_synopsis': True},
                                                                             u'category': u'',
                                                                             u'choices': [],
                                                                             u'completer': u'',
                                                                             u'default': True,
                                                                             u'description': u'Set the new account to active. Enabled by default, use *--no-activate* to disable.',
                                                                             u'group': u'',
                                                                             u'hidden': False,
                                                                             u'name': u'--activate',
                                                                             u'nargs': u'0',
                                                                             u'required': False,
                                                                             u'type': u'bool',
                                                                             u'value': u'ACTIVATE'},
                                                             u'--brief': {u'attr': {},
                                                                          u'category': u'',
                                                                          u'choices': [],
                                                                          u'completer': u'',
                                                                          u'default': False,
                                                                          u'description': u'Minimal user output.',
                                                                          u'group': u'',
                                                                          u'hidden': False,
                                                                          u'name': u'--brief',
                                                                          u'nargs': u'0',
                                                                          u'required': False,
                                                                          u'type': u'bool',
                                                                          u'value': u'BRIEF'},
                                                             u'--do-not-activate': {u'attr': {},
                                                                                    u'category': u'',
                                                                                    u'choices': [],
                                                                                    u'completer': u'',
                                                                                    u'default': True,
                                                                                    u'description': u'',
                                                                                    u'group': u'',
                                                                                    u'hidden': True,
                                                                                    u'name': u'--do-not-activate',
                                                                                    u'nargs': u'0',
                                                                                    u'required': False,
                                                                                    u'type': u'bool',
                                                                                    u'value': u'DO_NOT_ACTIVATE'},
                                                             u'--enable-gdrive-access': {u'attr': {},
                                                                                         u'category': u'',
                                                                                         u'choices': [],
                                                                                         u'completer': u'',
                                                                                         u'default': False,
                                                                                         u'description': u'Enable Google Drive access.',
                                                                                         u'group': u'',
                                                                                         u'hidden': False,
                                                                                         u'name': u'--enable-gdrive-access',
                                                                                         u'nargs': u'0',
                                                                                         u'required': False,
                                                                                         u'type': u'bool',
                                                                                         u'value': u'ENABLE_GDRIVE_ACCESS'},
                                                             u'--force': {u'attr': {},
                                                                          u'category': u'',
                                                                          u'choices': [],
                                                                          u'completer': u'',
                                                                          u'default': False,
                                                                          u'description': u'Re-run the web authorization flow even if the given account has valid credentials.',
                                                                          u'group': u'',
                                                                          u'hidden': False,
                                                                          u'name': u'--force',
                                                                          u'nargs': u'0',
                                                                          u'required': False,
                                                                          u'type': u'bool',
                                                                          u'value': u'FORCE'},
                                                             u'--launch-browser': {u'attr': {u'inverted_synopsis': True},
                                                                                   u'category': u'',
                                                                                   u'choices': [],
                                                                                   u'completer': u'',
                                                                                   u'default': True,
                                                                                   u'description': u'Launch a browser for authorization. If not enabled or DISPLAY variable is not set, prints a URL to standard output to be copied. Enabled by default, use *--no-launch-browser* to disable.',
                                                                                   u'group': u'',
                                                                                   u'hidden': False,
                                                                                   u'name': u'--launch-browser',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'type': u'bool',
                                                                                   u'value': u'LAUNCH_BROWSER'},
                                                             u'--no-activate': {u'attr': {},
                                                                                u'category': u'',
                                                                                u'choices': [],
                                                                                u'completer': u'',
                                                                                u'default': True,
                                                                                u'description': u'',
                                                                                u'group': u'',
                                                                                u'hidden': True,
                                                                                u'name': u'--no-activate',
                                                                                u'nargs': u'0',
                                                                                u'required': False,
                                                                                u'type': u'bool',
                                                                                u'value': u'NO_ACTIVATE'},
                                                             u'--no-brief': {u'attr': {},
                                                                             u'category': u'',
                                                                             u'choices': [],
                                                                             u'completer': u'',
                                                                             u'default': True,
                                                                             u'description': u'',
                                                                             u'group': u'',
                                                                             u'hidden': True,
                                                                             u'name': u'--no-brief',
                                                                             u'nargs': u'0',
                                                                             u'required': False,
                                                                             u'type': u'bool',
                                                                             u'value': u'NO_BRIEF'},
                                                             u'--no-do-not-activate': {u'attr': {},
                                                                                       u'category': u'',
                                                                                       u'choices': [],
                                                                                       u'completer': u'',
                                                                                       u'default': False,
                                                                                       u'description': u'',
                                                                                       u'group': u'',
                                                                                       u'hidden': True,
                                                                                       u'name': u'--no-do-not-activate',
                                                                                       u'nargs': u'0',
                                                                                       u'required': False,
                                                                                       u'type': u'bool',
                                                                                       u'value': u'NO_DO_NOT_ACTIVATE'},
                                                             u'--no-enable-gdrive-access': {u'attr': {},
                                                                                            u'category': u'',
                                                                                            u'choices': [],
                                                                                            u'completer': u'',
                                                                                            u'default': True,
                                                                                            u'description': u'',
                                                                                            u'group': u'',
                                                                                            u'hidden': True,
                                                                                            u'name': u'--no-enable-gdrive-access',
                                                                                            u'nargs': u'0',
                                                                                            u'required': False,
                                                                                            u'type': u'bool',
                                                                                            u'value': u'NO_ENABLE_GDRIVE_ACCESS'},
                                                             u'--no-force': {u'attr': {},
                                                                             u'category': u'',
                                                                             u'choices': [],
                                                                             u'completer': u'',
                                                                             u'default': True,
                                                                             u'description': u'',
                                                                             u'group': u'',
                                                                             u'hidden': True,
                                                                             u'name': u'--no-force',
                                                                             u'nargs': u'0',
                                                                             u'required': False,
                                                                             u'type': u'bool',
                                                                             u'value': u'NO_FORCE'},
                                                             u'--no-launch-browser': {u'attr': {},
                                                                                      u'category': u'',
                                                                                      u'choices': [],
                                                                                      u'completer': u'',
                                                                                      u'default': True,
                                                                                      u'description': u'',
                                                                                      u'group': u'',
                                                                                      u'hidden': True,
                                                                                      u'name': u'--no-launch-browser',
                                                                                      u'nargs': u'0',
                                                                                      u'required': False,
                                                                                      u'type': u'bool',
                                                                                      u'value': u'NO_LAUNCH_BROWSER'}},
                                                  u'group': False,
                                                  u'groups': {},
                                                  u'hidden': False,
                                                  u'name': u'login',
                                                  u'path': [u'gcloud',
                                                            u'auth',
                                                            u'login'],
                                                  u'positionals': [{u'completer': u'',
                                                                    u'default': None,
                                                                    u'description': u'User account used for authorization.',
                                                                    u'name': u'account',
                                                                    u'nargs': u'?',
                                                                    u'required': False,
                                                                    u'value': u'ACCOUNT'}],
                                                  u'release': u'GA',
                                                  u'sections': {u'DESCRIPTION': u'Obtains access credentials for your user account via a web-based authorization\nflow. When this command completes successfully, it sets the active account\nin the current configuration to the account specified. If no configuration\nexists, it creates a configuration named default.\n\nIf valid credentials for an account are already available from a prior\nauthorization, the account is set to active without rerunning the flow.\n\nUse `gcloud auth list` to view credentialed accounts.'}},
                                       u'revoke': {u'capsule': u'Revoke access credentials for an account.',
                                                   u'commands': {},
                                                   u'flags': {u'--all': {u'attr': {},
                                                                         u'category': u'',
                                                                         u'choices': [],
                                                                         u'completer': u'',
                                                                         u'default': False,
                                                                         u'description': u'Revoke credentials for all accounts.',
                                                                         u'group': u'',
                                                                         u'hidden': False,
                                                                         u'name': u'--all',
                                                                         u'nargs': u'0',
                                                                         u'required': False,
                                                                         u'type': u'bool',
                                                                         u'value': u'ALL'},
                                                              u'--no-all': {u'attr': {},
                                                                            u'category': u'',
                                                                            u'choices': [],
                                                                            u'completer': u'',
                                                                            u'default': True,
                                                                            u'description': u'',
                                                                            u'group': u'',
                                                                            u'hidden': True,
                                                                            u'name': u'--no-all',
                                                                            u'nargs': u'0',
                                                                            u'required': False,
                                                                            u'type': u'bool',
                                                                            u'value': u'NO_ALL'}},
                                                   u'group': False,
                                                   u'groups': {},
                                                   u'hidden': False,
                                                   u'name': u'revoke',
                                                   u'path': [u'gcloud',
                                                             u'auth',
                                                             u'revoke'],
                                                   u'positionals': [{u'completer': u'',
                                                                     u'default': None,
                                                                     u'description': u'Accounts whose credentials are to be revoked.',
                                                                     u'name': u'accounts',
                                                                     u'nargs': u'*',
                                                                     u'required': False,
                                                                     u'value': u'ACCOUNTS'}],
                                                   u'release': u'GA',
                                                   u'sections': {u'DESCRIPTION': u"Revokes credentials for the specified user accounts or service accounts.\nWhen you revoke the credentials, they are removed from the local machine. If\nno account is specified, this command revokes credentials for the currently\nactive account.\n\nYou can revoke credentials when you want to disallow access by gcloud and\nother Cloud SDK tools using a specified account. You don't need to revoke\ncredentials to switch between accounts."}}},
                         u'flags': {},
                         u'group': True,
                         u'groups': {},
                         u'hidden': False,
                         u'name': u'auth',
                         u'path': [u'gcloud', u'auth'],
                         u'positionals': [],
                         u'release': u'GA',
                         u'sections': {u'DESCRIPTION': u'The gcloud auth command group lets you grant and revoke authorization to Cloud\nSDK (gcloud) to access Google Cloud Platform.'}},
               u'beta': {u'capsule': u'*(BETA)* Beta versions of gcloud commands.',
                         u'commands': {u'app': {u'capsule': u'*(BETA)* Manage your App Engine deployments.',
                                                u'commands': {u'browse': {u'capsule': u'*(BETA)* Open the current app in a web browser.',
                                                                          u'commands': {},
                                                                          u'flags': {u'--service': {u'attr': {},
                                                                                                    u'category': u'',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The service that should be opened. If not specified, use the default service. May be used in conjunction with `--version`.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--service',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'SERVICE'}},
                                                                          u'group': False,
                                                                          u'groups': {},
                                                                          u'hidden': False,
                                                                          u'name': u'browse',
                                                                          u'path': [u'gcloud',
                                                                                    u'beta',
                                                                                    u'app',
                                                                                    u'browse'],
                                                                          u'positionals': [],
                                                                          u'release': u'BETA',
                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Open the current app in a web browser.\n',
                                                                                        u'EXAMPLES': u'To open the default service, run:\n\n    $ browse\n\nTo open a specific service, run:\n\n    $ browse --service="myService"\n\nTo open a specific version, run:\n\n    $ browse --service="myService" --version="v1"\n'}},
                                                              u'create': {u'capsule': u'*(BETA)* Create an App Engine app within the current Google Cloud Project.',
                                                                          u'commands': {},
                                                                          u'flags': {u'--region': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The region to create the app within.  Use `gcloud app regions list` to list available regions.  If not provided, select region interactively.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--region',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'REGION'}},
                                                                          u'group': False,
                                                                          u'groups': {},
                                                                          u'hidden': False,
                                                                          u'name': u'create',
                                                                          u'path': [u'gcloud',
                                                                                    u'beta',
                                                                                    u'app',
                                                                                    u'create'],
                                                                          u'positionals': [],
                                                                          u'release': u'BETA',
                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Create an App Engine app within the current Google Cloud Project.\n',
                                                                                        u'EXAMPLES': u'To create an app with region chosen interactively, run:\n\n    $ create\n\nTo create an app in the us-central region, run:\n\n    $ create --region=us-central\n\n'}},
                                                              u'deploy': {u'capsule': u'*(BETA)* Deploy the local code and/or configuration of your app to App Engine.',
                                                                          u'commands': {},
                                                                          u'flags': {u'--bucket': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u"The Google Cloud Storage bucket used to stage files associated with the deployment. If this argument is not specified, the application's default code bucket is used.",
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--bucket',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'BUCKET'},
                                                                                     u'--docker-build': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--docker-build',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'DOCKER_BUILD'},
                                                                                     u'--ignore-bad-certs': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': False,
                                                                                                             u'description': u'',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': True,
                                                                                                             u'name': u'--ignore-bad-certs',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'IGNORE_BAD_CERTS'},
                                                                                     u'--image-url': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Deploy with a specific Docker image.  Docker url must be from one of the valid gcr hostnames.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--image-url',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'IMAGE_URL'},
                                                                                     u'--no-ignore-bad-certs': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--no-ignore-bad-certs',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_IGNORE_BAD_CERTS'},
                                                                                     u'--no-promote': {u'attr': {u'property': {u'name': u'app/promote_by_default'}},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u'',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': True,
                                                                                                       u'name': u'--no-promote',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'NO_PROMOTE'},
                                                                                     u'--no-skip-image-url-validation': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': True,
                                                                                                                         u'name': u'--no-skip-image-url-validation',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'NO_SKIP_IMAGE_URL_VALIDATION'},
                                                                                     u'--no-skip-staging': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u'',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': True,
                                                                                                            u'name': u'--no-skip-staging',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'NO_SKIP_STAGING'},
                                                                                     u'--no-stop-previous-version': {u'attr': {u'property': {u'name': u'app/stop_previous_version'}},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': False,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-stop-previous-version',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_STOP_PREVIOUS_VERSION'},
                                                                                     u'--promote': {u'attr': {u'inverted_synopsis': True,
                                                                                                              u'property': {u'name': u'app/promote_by_default'}},
                                                                                                    u'category': u'',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': False,
                                                                                                    u'description': u'Promote the deployed version to receive all traffic.\n+\nTrue by default. To change the default behavior for your current\nenvironment, run:\n+\n    $ gcloud config set app/promote_by_default false',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--promote',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'PROMOTE'},
                                                                                     u'--server': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': True,
                                                                                                   u'name': u'--server',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'SERVER'},
                                                                                     u'--skip-image-url-validation': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': False,
                                                                                                                      u'description': u'',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': True,
                                                                                                                      u'name': u'--skip-image-url-validation',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'bool',
                                                                                                                      u'value': u'SKIP_IMAGE_URL_VALIDATION'},
                                                                                     u'--skip-staging': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': False,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--skip-staging',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'SKIP_STAGING'},
                                                                                     u'--stop-previous-version': {u'attr': {u'inverted_synopsis': True,
                                                                                                                            u'property': {u'name': u'app/stop_previous_version'}},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'Stop the previously running version when deploying a new version that receives all traffic. Overrides the default *app/stop_previous_version* property value for this command invocation. Use *--no-stop-previous-version* to disable.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--stop-previous-version',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'STOP_PREVIOUS_VERSION'}},
                                                                          u'group': False,
                                                                          u'groups': {},
                                                                          u'hidden': False,
                                                                          u'name': u'deploy',
                                                                          u'path': [u'gcloud',
                                                                                    u'beta',
                                                                                    u'app',
                                                                                    u'deploy'],
                                                                          u'positionals': [{u'completer': u'',
                                                                                            u'default': None,
                                                                                            u'description': u'The yaml files for the services or configurations you want to deploy.\nIf not given, defaults to `app.yaml` in the current directory.\nIf that is not found, attempts to automatically generate necessary\nconfiguration files (such as app.yaml) in the current directory.',
                                                                                            u'name': u'deployables',
                                                                                            u'nargs': u'*',
                                                                                            u'required': False,
                                                                                            u'value': u'DEPLOYABLES'}],
                                                                          u'release': u'BETA',
                                                                          u'sections': {u'DESCRIPTION': u"This command is used to deploy both code and configuration to the App\nEngine server.  As an input it takes one or more ``DEPLOYABLES'' that\nshould be uploaded.  A ``DEPLOYABLE'' can be a service's .yaml file or a\nconfiguration's .yaml file.\n\nThis command supports App Engine flexible task queue files. The format\nof task queue files can be found at:\nhttps://cloud.google.com/appengine/docs/python/config/queueref\n",
                                                                                        u'EXAMPLES': u'To deploy a single service, run:\n\n  $ deploy ~/my_app/app.yaml\n\nTo deploy multiple services, run:\n\n  $ deploy ~/my_app/app.yaml ~/my_app/another_service.yaml\n'}},
                                                              u'describe': {u'capsule': u'*(BETA)* Display all data about an existing service.',
                                                                            u'commands': {},
                                                                            u'flags': {},
                                                                            u'group': False,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'describe',
                                                                            u'path': [u'gcloud',
                                                                                      u'beta',
                                                                                      u'app',
                                                                                      u'describe'],
                                                                            u'positionals': [],
                                                                            u'release': u'BETA',
                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Display all data about an existing service.',
                                                                                          u'EXAMPLES': u'To show all the data about the current application, run\n\n    $ describe\n'}},
                                                              u'gen-config': {u'capsule': u'*(BETA)* Generate missing configuration files for a source directory.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--config': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The yaml file defining the service configuration.  This is normally one of the generated files, but when generating a custom runtime there can be an app.yaml containing parameters.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--config',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'CONFIG'},
                                                                                         u'--custom': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u'If true, generate config files for a custom runtime.  This will produce a Dockerfile, a .dockerignore file and an app.yaml (possibly other files as well, depending on the runtime).',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--custom',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'CUSTOM'},
                                                                                         u'--no-custom': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-custom',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_CUSTOM'},
                                                                                         u'--runtime': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Generate config files for a given runtime. Can be used in conjunction with --custom. Allowed runtimes are: contrib-dart, dart, go, php, php55, python, python27, python-compat, java, java7, nodejs, ruby.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--runtime',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'RUNTIME'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'gen-config',
                                                                              u'path': [u'gcloud',
                                                                                        u'beta',
                                                                                        u'app',
                                                                                        u'gen-config'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': u'',
                                                                                                u'description': u'The source directory to fingerprint.',
                                                                                                u'name': u'source-dir',
                                                                                                u'nargs': u'?',
                                                                                                u'required': False,
                                                                                                u'value': u'SOURCE_DIR'}],
                                                                              u'release': u'BETA',
                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Generate missing configuration files for a source directory.\n\nThis command generates all relevant config files (app.yaml, Dockerfile and a\nbuild Dockerfile) for your application in the current directory or emits an\nerror message if the source directory contents are not recognized.\n',
                                                                                            u'EXAMPLES': u'To generate configs for the current directory:\n\n  $ gen-config\n\nTo generate configs for ~/my_app:\n\n  $ gen-config ~/my_app\n'}},
                                                              u'instances': {u'capsule': u'*(BETA)* View and manage your App Engine instances.',
                                                                             u'commands': {u'delete': {u'capsule': u'*(BETA)* Delete a specified instance.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--service': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The service ID.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--service',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': True,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'SERVICE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'app',
                                                                                                                 u'instances',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The instance ID.',
                                                                                                                         u'name': u'instance',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'INSTANCE'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Delete a specified instance.',
                                                                                                                     u'EXAMPLES': u'To delete instance i1 of service s1 and version v1, run:\n\n  $ delete i1 --service=s1 --version=v1\n'}},
                                                                                           u'describe': {u'capsule': u'*(BETA)* Display all data about an existing instance.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--service': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The service ID.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--service',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'SERVICE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'app',
                                                                                                                   u'instances',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The instance ID.',
                                                                                                                           u'name': u'instance',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'INSTANCE'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Display all data about an existing instance.',
                                                                                                                       u'EXAMPLES': u'To show all data about instance i1 for service s1 and version v1, run:\n\n    $ describe --service=s1 --version=v1 i1\n'}},
                                                                                           u'disable-debug': {u'capsule': u'*(BETA)* Disables debug mode for an instance.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--service': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'If specified, only match instances belonging to the given service.\nThis affects both interactive and non-interactive selection.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--service',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'SERVICE'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'disable-debug',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'app',
                                                                                                                        u'instances',
                                                                                                                        u'disable-debug'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The instance ID to disable debug mode on. If not specified,\nselect instance interactively. Must uniquely specify (with other\nflags) exactly one instance',
                                                                                                                                u'name': u'instance',
                                                                                                                                u'nargs': u'?',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'INSTANCE'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u"*(BETA)* When not in debug mode, SSH will be disabled on the VMs. They will be included\nin the health checking pools.\n\nNote that any local changes to an instance will be **lost** if debug mode is\ndisabled on the instance. New instance(s) may spawn depending on the app's\nscaling settings.",
                                                                                                                            u'EXAMPLES': u'To disable debug mode for a particular instance, run:\n\n    $ disable-debug --service=s1 --version=v1 i1\n\nTo disable debug mode for an instance chosen interactively, run:\n\n    $ disable-debug\n'}},
                                                                                           u'enable-debug': {u'capsule': u'*(BETA)* Enables debug mode for an instance.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--service': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'If specified, only match instances belonging to the given service.\nThis affects both interactive and non-interactive selection.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--service',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'SERVICE'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'enable-debug',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'app',
                                                                                                                       u'instances',
                                                                                                                       u'enable-debug'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The instance ID to enable debug mode on. If not specified,\nselect instance interactively. Must uniquely specify (with other\nflags) exactly one instance',
                                                                                                                               u'name': u'instance',
                                                                                                                               u'nargs': u'?',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'INSTANCE'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u"*(BETA)* When in debug mode, SSH will be enabled on the VMs, and you can use\n`gcloud compute ssh` to login to them. They will be removed from the health\nchecking pools, but they still receive requests.\n\nNote that any local changes to an instance will be **lost** if debug mode is\ndisabled on the instance. New instance(s) may spawn depending on the app's\nscaling settings.",
                                                                                                                           u'EXAMPLES': u'To enable debug mode for a particular instance, run:\n\n    $ enable-debug --service=s1 --version=v1 i1\n\nTo enable debug mode for an instance chosen interactively, run:\n\n    $ enable-debug\n'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* List the instances affiliated with the current App Engine project.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--service': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'If specified, only list instances belonging to the given service.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--service',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'SERVICE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'app',
                                                                                                               u'instances',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* List the instances affiliated with the current App Engine project.',
                                                                                                                   u'EXAMPLES': u'To list all App Engine instances, run:\n\n    $ list\n\nTo list all App Engine instances for a given service, run:\n\n    $ list -s myservice\n\nTo list all App Engine instances for a given version, run:\n\n    $ list -v v1\n'}},
                                                                                           u'ssh': {u'capsule': u'*(BETA)* SSH into the VM of an App Engine Flexible instance.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--container': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Name of the container within the VM to connect to.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--container',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'CONTAINER'},
                                                                                                               u'--service': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The service ID.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--service',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'SERVICE'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'ssh',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'beta',
                                                                                                              u'app',
                                                                                                              u'instances',
                                                                                                              u'ssh'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The instance ID.',
                                                                                                                      u'name': u'instance',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'INSTANCE'}],
                                                                                                    u'release': u'BETA',
                                                                                                    u'sections': {u'DESCRIPTION': u"*ssh* lets you remotely log in to your running App Engine Flexible\ninstances. It resolves the instance's IP address and pre-populates the\nVM with a public key managed by gcloud.\n\nIf the gcloud managed key pair does not exist, it is generated the first\ntime an SSH command is run -- this may prompt you for a passphrase for\nprivate key encryption.\n\nAll SSH commands require the OpenSSH client suite to be installed on\nLinux and Mac OS X. Windows does not have any external requirements.\nIt has a PuTTY suite is bundled with gcloud instead.",
                                                                                                                  u'EXAMPLES': u'To SSH into an App Engine Flexible instance, run:\n\n    $ ssh --service s1 --version v1 i1\n\nTo SSH into the app container within an instance, run:\n\n    $ ssh --service s1 --version v1 i1 --container=gaeapp\n'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'instances',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'app',
                                                                                       u'instances'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* This set of commands can be used to view and manage your existing App Engine\ninstances.\n\nFor more information on App Engine instances, see:\nhttps://cloud.google.com/appengine/docs/python/an-overview-of-app-engine',
                                                                                           u'EXAMPLES': u'To list your App Engine instances, run:\n\n  $ instances list\n'}},
                                                              u'logs': {u'capsule': u'*(BETA)* Manage your App Engine logs.',
                                                                        u'commands': {u'read': {u'capsule': u'*(BETA)* Reads log entries for the current App Engine app.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--level': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [u'critical',
                                                                                                                                     u'error',
                                                                                                                                     u'warning',
                                                                                                                                     u'info',
                                                                                                                                     u'debug',
                                                                                                                                     u'any'],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': u'any',
                                                                                                                        u'description': u'Filter entries with severity equal to or higher than a given level. _LEVEL_ must be one of: *critical*, *error*, *warning*, *info*, *debug*, *any*.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--level',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'LEVEL'},
                                                                                                           u'--limit': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': 200,
                                                                                                                        u'description': u'Number of log entries to show.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--limit',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'int',
                                                                                                                        u'value': u'LIMIT'},
                                                                                                           u'--logs': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': [u'stderr',
                                                                                                                                    u'stdout',
                                                                                                                                    u'crash.log',
                                                                                                                                    u'nginx.requests',
                                                                                                                                    u'request_log'],
                                                                                                                       u'description': u'Filter entries from a particular set of logs. Must be a comma-separated list of log names (request_log, stdout, stderr, etc).',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--logs',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'list',
                                                                                                                       u'value': u'APP_LOG'},
                                                                                                           u'--service': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Limit to specific service.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--service',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'SERVICE'}},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'read',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'beta',
                                                                                                          u'app',
                                                                                                          u'logs',
                                                                                                          u'read'],
                                                                                                u'positionals': [],
                                                                                                u'release': u'BETA',
                                                                                                u'sections': {u'DESCRIPTION': u'Display the latest log entries from stdout, stderr and crash log for the\ncurrent Google App Engine app in a human readable format.\n',
                                                                                                              u'EXAMPLES': u'To display the latest entries for the current app, run:\n\n  $ read\n\nTo show only the entries with severity at `warning` or higher, run:\n\n  $ read --level=warning\n\nTo show only the entries with a specific version, run:\n\n  $ read --version=v1\n\nTo show only the 10 latest log entries for the default service, run:\n\n  $ read --limit 10 --service=default\n\nTo show only the logs from the request log for standard apps, run:\n\n  $ read --logs=request_log\n\nTo show only the logs from the request log for Flex apps, run:\n\n  $ read --logs=nginx.requests\n'}},
                                                                                      u'tail': {u'capsule': u'*(BETA)* Streams logs for App Engine apps.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--level': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [u'critical',
                                                                                                                                     u'error',
                                                                                                                                     u'warning',
                                                                                                                                     u'info',
                                                                                                                                     u'debug',
                                                                                                                                     u'any'],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': u'any',
                                                                                                                        u'description': u'Filter entries with severity equal to or higher than a given level. _LEVEL_ must be one of: *critical*, *error*, *warning*, *info*, *debug*, *any*.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--level',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'LEVEL'},
                                                                                                           u'--logs': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': [u'stderr',
                                                                                                                                    u'stdout',
                                                                                                                                    u'crash.log',
                                                                                                                                    u'nginx.requests',
                                                                                                                                    u'request_log'],
                                                                                                                       u'description': u'Filter entries from a particular set of logs. Must be a comma-separated list of log names (request_log, stdout, stderr, etc).',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--logs',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'list',
                                                                                                                       u'value': u'APP_LOG'},
                                                                                                           u'--service': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Limit to specific service.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--service',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'SERVICE'}},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'tail',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'beta',
                                                                                                          u'app',
                                                                                                          u'logs',
                                                                                                          u'tail'],
                                                                                                u'positionals': [],
                                                                                                u'release': u'BETA',
                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Streams logs for App Engine apps.',
                                                                                                              u'EXAMPLES': u'To stream logs from a serving app, run:\n\n  $ tail\n\nTo show only logs with a specific service, version, and level, run:\n\n  $ tail --service=s1 --version=v1 --level=warning\n\nTo show only the logs from the request log for Standard apps, run:\n\n  $ tail --logs=request_log\n\nTo show only the logs from the request log for Flex apps, run:\n\n  $ tail --logs=nginx.requests\n'}}},
                                                                        u'flags': {},
                                                                        u'group': True,
                                                                        u'groups': {},
                                                                        u'hidden': False,
                                                                        u'name': u'logs',
                                                                        u'path': [u'gcloud',
                                                                                  u'beta',
                                                                                  u'app',
                                                                                  u'logs'],
                                                                        u'positionals': [],
                                                                        u'release': u'BETA',
                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* This set of commands can be used to view your existing App Engine logs.',
                                                                                      u'EXAMPLES': u'To read the logs for the current App Engine project, run:\n\n  $ logs read\n'}},
                                                              u'open-console': {u'capsule': u'*(BETA)* Open the App Engine dashboard, or log viewer, in a web browser.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--logs': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u'Open the log viewer instead of the App Engine dashboard.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--logs',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'LOGS'},
                                                                                           u'--no-logs': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-logs',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_LOGS'},
                                                                                           u'--service': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The service to consider. If not specified, use the default service.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--service',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'SERVICE'}},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'open-console',
                                                                                u'path': [u'gcloud',
                                                                                          u'beta',
                                                                                          u'app',
                                                                                          u'open-console'],
                                                                                u'positionals': [],
                                                                                u'release': u'BETA',
                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Open the App Engine dashboard, or log viewer, in a web browser.\n',
                                                                                              u'EXAMPLES': u'Open the App Engine dashboard for the default service:\n\n    $ open-console\n\nOpen the service specific dashboard view:\n\n    $ open-console --service="myService"\n\nOpen the version specific dashboard view:\n\n    $ open-console --service="myService" --version="v1"\n\nOpen the log viewer for the default service:\n\n    $ open-console --logs\n'}},
                                                              u'operations': {u'capsule': u'*(BETA)* View and manage your App Engine Operations.',
                                                                              u'commands': {u'describe': {u'capsule': u'*(BETA)* Describes the operation.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'describe',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'app',
                                                                                                                    u'operations',
                                                                                                                    u'describe'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'ID of operation.',
                                                                                                                            u'name': u'operation',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'OPERATION'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Describes the operation.',
                                                                                                                        u'EXAMPLES': u'To describe an App Engine operation called o1, run:\n\n    $ describe o1\n'}},
                                                                                            u'list': {u'capsule': u'*(BETA)* List the operations.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-pending': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-pending',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_PENDING'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--pending': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Only display pending operations',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--pending',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'PENDING'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'app',
                                                                                                                u'operations',
                                                                                                                u'list'],
                                                                                                      u'positionals': [],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* List the operations.',
                                                                                                                    u'EXAMPLES': u'To list all App Engine operations, run:\n\n    $ list\n\nTo list only 100 App Engine operations, run:\n\n    $ list --limit 100\n\nTo list only pending App Engine operations, run:\n\n    $ list --pending\n'}},
                                                                                            u'wait': {u'capsule': u'*(BETA)* Polls an operation until completion.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'wait',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'app',
                                                                                                                u'operations',
                                                                                                                u'wait'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'ID of operation.',
                                                                                                                        u'name': u'operation',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'OPERATION'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Polls an operation until completion.',
                                                                                                                    u'EXAMPLES': u'To wait for an App Engine operation called o1 to complete, run:\n\n    $ wait o1\n'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'operations',
                                                                              u'path': [u'gcloud',
                                                                                        u'beta',
                                                                                        u'app',
                                                                                        u'operations'],
                                                                              u'positionals': [],
                                                                              u'release': u'BETA',
                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* This set of commands can be used to view and manage your existing App Engine\noperations.',
                                                                                            u'EXAMPLES': u'To list your App Engine operations, run:\n\n  $ operations list\n'}},
                                                              u'regions': {u'capsule': u'*(BETA)* View regional availability of App Engine runtime environments.',
                                                                           u'commands': {u'list': {u'capsule': u'*(BETA)* List the availability of flex and standard environments for each region.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--filter',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                              u'--limit': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--limit',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'LIMIT'},
                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': True,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--no-uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_URI'},
                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--page-size',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--sort-by',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'list',
                                                                                                                             u'value': u'FIELD'},
                                                                                                              u'--uri': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--uri',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'URI'}},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'list',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'app',
                                                                                                             u'regions',
                                                                                                             u'list'],
                                                                                                   u'positionals': [],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* List the availability of flex and standard environments for each region.',
                                                                                                                 u'EXAMPLES': u'To view regional availability of App Engine runtime environments, run:\n\n    $ list\n'}}},
                                                                           u'flags': {},
                                                                           u'group': True,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'regions',
                                                                           u'path': [u'gcloud',
                                                                                     u'beta',
                                                                                     u'app',
                                                                                     u'regions'],
                                                                           u'positionals': [],
                                                                           u'release': u'BETA',
                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* This command can be used to view availability of App Engine standard and\nflexible runtime environments in all geographic regions.',
                                                                                         u'EXAMPLES': u'To view regional availability of App Engine runtime environments, run:\n\n  $ regions list\n'}},
                                                              u'services': {u'capsule': u'*(BETA)* View and manage your App Engine services.',
                                                                            u'commands': {u'browse': {u'capsule': u'*(BETA)* Open the specified service(s) in a browser.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'browse',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'app',
                                                                                                                u'services',
                                                                                                                u'browse'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The services to open (optionally filtered by the --version flag).',
                                                                                                                        u'name': u'services',
                                                                                                                        u'nargs': u'+',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'SERVICES'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Open the specified service(s) in a browser.',
                                                                                                                    u'EXAMPLES': u'To show the url for the default service in the browser, run:\n\n    $ browse default\n\nTo show version `v1` of service `myService` in the browser, run:\n\n    $ browse myService --version="v1"\n\nTo show multiple services side-by-side, run:\n\n    $ browse default otherService\n\nTo show multiple services side-by-side with a specific version, run:\n\n    $ browse s1 s2 --version v1\n'}},
                                                                                          u'delete': {u'capsule': u'*(BETA)* Delete services in the current project.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'delete',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'app',
                                                                                                                u'services',
                                                                                                                u'delete'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The service(s) to delete.',
                                                                                                                        u'name': u'services',
                                                                                                                        u'nargs': u'+',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'SERVICES'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Delete services in the current project.',
                                                                                                                    u'EXAMPLES': u'To delete a service (and all of its accompanying versions) in the\ncurrent project, run:\n\n  $ delete service1\n\nTo delete multiple services (and all of their accompanying versions)\nin the current project, run:\n\n  $ delete service1 service2\n'}},
                                                                                          u'describe': {u'capsule': u'*(BETA)* Display all data about an existing service.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'describe',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'app',
                                                                                                                  u'services',
                                                                                                                  u'describe'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The service to describe.',
                                                                                                                          u'name': u'service',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'SERVICE'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Display all data about an existing service.',
                                                                                                                      u'EXAMPLES': u'To show all the data about service s1, run\n\n    $ describe s1\n'}},
                                                                                          u'list': {u'capsule': u'*(BETA)* List your existing services.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--filter',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                               u'--limit': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--limit',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'LIMIT'},
                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': True,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_URI'},
                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--page-size',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--sort-by',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'FIELD'},
                                                                                                               u'--uri': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--uri',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'URI'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'list',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'beta',
                                                                                                              u'app',
                                                                                                              u'services',
                                                                                                              u'list'],
                                                                                                    u'positionals': [],
                                                                                                    u'release': u'BETA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* This command lists all services that are currently deployed to the App Engine\nserver.',
                                                                                                                  u'EXAMPLES': u'To list all services in the current project, run:\n\n  $ list\n\n'}},
                                                                                          u'set-traffic': {u'capsule': u'*(BETA)* Set traffic splitting settings.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--migrate': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'The migrate flag determines whether or not to use traffic migration\nduring the operation. Traffic migration will attempt to automatically\nmigrate traffic from the previous version to the new version, giving\nthe autoscaler time to respond. See the documentation here:\n[](https://cloud.google.com/appengine/docs/python/console/trafficmigration)\nfor more information.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--migrate',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'MIGRATE'},
                                                                                                                      u'--no-migrate': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-migrate',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_MIGRATE'},
                                                                                                                      u'--split-by': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [u'cookie',
                                                                                                                                                   u'ip'],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': u'ip',
                                                                                                                                      u'description': u'Whether to split traffic based on cookies or IP addresses. _SPLIT_BY_ must be one of: *cookie*, *ip*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--split-by',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'SPLIT_BY'},
                                                                                                                      u'--splits': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Key-value pairs describing what proportion of traffic should go to\neach version. The split values are added together and used as\nweights. The exact values do not matter, only their relation to each\nother. For example, v1=2,v2=2 is equivalent to v1=.5,v2=.5',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--splits',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'dict',
                                                                                                                                    u'value': u'SPLITS'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'set-traffic',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'app',
                                                                                                                     u'services',
                                                                                                                     u'set-traffic'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The services to modify.',
                                                                                                                             u'name': u'services',
                                                                                                                             u'nargs': u'*',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'SERVICES'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* This command sets the traffic split of versions across a service or a project.',
                                                                                                                         u'EXAMPLES': u"To send all traffic to 'v2' of service 's1', run:\n\n  $ set-traffic s1 --splits v2=1\n\nTo split traffic evenly between 'v1' and 'v2' of service 's1', run:\n\n  $ set-traffic s1 --splits v2=.5,v1=.5\n\nTo split traffic across all services:\n\n  $ set-traffic --splits v2=.5,v1=.5\n"}}},
                                                                            u'flags': {},
                                                                            u'group': True,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'services',
                                                                            u'path': [u'gcloud',
                                                                                      u'beta',
                                                                                      u'app',
                                                                                      u'services'],
                                                                            u'positionals': [],
                                                                            u'release': u'BETA',
                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* This set of commands can be used to view and manage your existing App Engine\nservices.\n\nTo create new deployments, use `app deploy`.\n\nFor more information on App Engine services, see:\nhttps://cloud.google.com/appengine/docs/python/an-overview-of-app-engine',
                                                                                          u'EXAMPLES': u'To list your deployed services, run:\n\n  $ services list\n'}},
                                                              u'versions': {u'capsule': u'*(BETA)* View and manage your App Engine versions.',
                                                                            u'commands': {u'browse': {u'capsule': u'*(BETA)* Open the specified versions in a browser.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--service': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'If specified, only open versions from the given service. If not specified, use the default service.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--service',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'SERVICE'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'browse',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'app',
                                                                                                                u'versions',
                                                                                                                u'browse'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The versions to open (optionally filtered by the --service flag).',
                                                                                                                        u'name': u'versions',
                                                                                                                        u'nargs': u'+',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'VERSIONS'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Open the specified versions in a browser.',
                                                                                                                    u'EXAMPLES': u'To show version `v1` for the default service in the browser, run:\n\n    $ browse v1\n\nTo show version `v1` of a specific service in the browser, run:\n\n    $ browse v1 --service="myService"\n\nTo show multiple versions side-by-side, run:\n\n    $ browse v1 v2 --service="myService"\n'}},
                                                                                          u'delete': {u'capsule': u'*(BETA)* Delete a specified version.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--service': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'If specified, only delete versions from the given service.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--service',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'SERVICE'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'delete',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'app',
                                                                                                                u'versions',
                                                                                                                u'delete'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The versions to delete (optionally filtered by the --service flag).',
                                                                                                                        u'name': u'versions',
                                                                                                                        u'nargs': u'+',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'VERSIONS'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* You cannot delete a version of a service that is currently receiving traffic.',
                                                                                                                    u'EXAMPLES': u'To delete a specific version of a specific service, run:\n\n  $ delete --service myService v1\n\nTo delete a named version across all services, run:\n\n  $ delete v1\n\nTo delete multiple versions of a specific service, run:\n\n  $ delete --service myService v1 v2\n\nTo delete multiple named versions across all services, run:\n\n  $ delete v1 v2\n'}},
                                                                                          u'describe': {u'capsule': u'*(BETA)* Display all data about an existing version.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--service': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The service corresponding to the version to show.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--service',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'SERVICE'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'describe',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'app',
                                                                                                                  u'versions',
                                                                                                                  u'describe'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The ID of the version to show.',
                                                                                                                          u'name': u'version',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'VERSION'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Display all data about an existing version.'}},
                                                                                          u'list': {u'capsule': u'*(BETA)* List your existing versions.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--filter',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                               u'--hide-no-traffic': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'Only show versions that are receiving traffic.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--hide-no-traffic',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'HIDE_NO_TRAFFIC'},
                                                                                                               u'--limit': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--limit',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'LIMIT'},
                                                                                                               u'--no-hide-no-traffic': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-hide-no-traffic',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_HIDE_NO_TRAFFIC'},
                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': True,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_URI'},
                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--page-size',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                               u'--service': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Only show versions from this service.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--service',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'SERVICE'},
                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--sort-by',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'FIELD'},
                                                                                                               u'--uri': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--uri',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'URI'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'list',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'beta',
                                                                                                              u'app',
                                                                                                              u'versions',
                                                                                                              u'list'],
                                                                                                    u'positionals': [],
                                                                                                    u'release': u'BETA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* This command lists all the versions of all services that are currently\ndeployed to the App Engine server.',
                                                                                                                  u'EXAMPLES': u'To list all services and versions, run:\n\n  $ list\n\nTo list all versions for a specific service, run:\n\n  $ list --service service1\n\nTo list only versions that are receiving traffic, run:\n\n  $ list --hide-no-traffic\n'}},
                                                                                          u'migrate': {u'capsule': u'*(BETA)* Migrate traffic from one version to another for a set of services.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--service': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'If specified, only migrate versions from the given service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--service',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'SERVICE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'migrate',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'app',
                                                                                                                 u'versions',
                                                                                                                 u'migrate'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The version to migrate to.',
                                                                                                                         u'name': u'version',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'VERSION'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Migrate traffic from one version to another for a set of services.',
                                                                                                                     u'EXAMPLES': u'This only works for automatically scaled Standard versions.\nTo migrate from one version to another for all services where there\nis a version v2 and shut down the previous version, run:\n\n  $ migrate v2\n\nTo migrate from one version to another for a specific service, run:\n\n  $ migrate v2 --service="s1"\n'}},
                                                                                          u'start': {u'capsule': u'*(BETA)* Start serving specified versions.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--service': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'If specified, only start versions from the given service.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--service',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'SERVICE'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'start',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'app',
                                                                                                               u'versions',
                                                                                                               u'start'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The versions to start. (optionally filtered by the --service flag).',
                                                                                                                       u'name': u'versions',
                                                                                                                       u'nargs': u'+',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'VERSIONS'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* This command starts serving the specified versions. It may only be used if the\nscaling module for your service has been set to manual.',
                                                                                                                   u'EXAMPLES': u'To start a specific version across all services, run:\n\n  $ start v1\n\nTo start multiple named versions across all services, run:\n\n  $ start v1 v2\n\nTo start a single version on a single service, run:\n\n  $ start --service servicename v1\n\nTo start multiple versions in a single service, run:\n\n  $ start --service servicename v1 v2\n'}},
                                                                                          u'stop': {u'capsule': u'*(BETA)* Stop serving specified versions.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--service': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'If specified, only stop versions from the given service.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--service',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'SERVICE'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'stop',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'beta',
                                                                                                              u'app',
                                                                                                              u'versions',
                                                                                                              u'stop'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The versions to stop (optionally filtered by the --service flag).',
                                                                                                                      u'name': u'versions',
                                                                                                                      u'nargs': u'+',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'VERSIONS'}],
                                                                                                    u'release': u'BETA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* This command stops serving the specified versions. It may only be used if the\nscaling module for your service has been set to manual.',
                                                                                                                  u'EXAMPLES': u'To stop a specific version across all services, run:\n\n  $ stop v1\n\nTo stop multiple named versions across all services, run:\n\n  $ stop v1 v2\n\nTo stop a single version on a single service, run:\n\n  $ stop --service servicename v1\n\nTo stop multiple versions in a single service, run:\n\n  $ stop --service servicename v1 v2\n\nNote that that last example may be more simply written using the\n`services stop` command (see its documentation for details).\n'}}},
                                                                            u'flags': {},
                                                                            u'group': True,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'versions',
                                                                            u'path': [u'gcloud',
                                                                                      u'beta',
                                                                                      u'app',
                                                                                      u'versions'],
                                                                            u'positionals': [],
                                                                            u'release': u'BETA',
                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* This set of commands can be used to view and manage your existing App Engine\nversions.\n\nTo create new deployments, use `app deploy`.\n\nFor more information on App Engine versions, see:\nhttps://cloud.google.com/appengine/docs/python/an-overview-of-app-engine\n\n## EXAMPLES\n\nTo list your deployed versions, run:\n\n  $ versions list'}}},
                                                u'flags': {},
                                                u'group': True,
                                                u'groups': {},
                                                u'hidden': False,
                                                u'name': u'app',
                                                u'path': [u'gcloud',
                                                          u'beta',
                                                          u'app'],
                                                u'positionals': [],
                                                u'release': u'BETA',
                                                u'sections': {u'DESCRIPTION': u'\nThe gcloud app command group lets you deploy and manage your Google App\nEngine apps. These commands replace their equivalents in the appcfg\ntool.\n\nApp Engine is a platform for building scalable web applications\nand mobile backends. App Engine provides you with built-in services and\nAPIs such as NoSQL datastores, memcache, and a user authentication API,\ncommon to most applications.\n\nMore information on App Engine can be found here:\nhttps://cloud.google.com/appengine and detailed documentation can be\nfound here: https://cloud.google.com/appengine/docs/\n',
                                                              u'EXAMPLES': u'To run your app locally in the development application server, run:\n\n  $ dev_appserver.py DEPLOYABLES\n\nTo create a new deployment of one or more services, run:\n\n  $ app deploy DEPLOYABLES\n\nTo list your existing deployments, run:\n\n  $ app versions list\n\nTo generate config files for your source directory:\n\n  $ app gen-config\n'}},
                                       u'auth': {u'capsule': u'*(BETA)* Manage oauth2 credentials for the Google Cloud SDK.',
                                                 u'commands': {u'activate-service-account': {u'capsule': u'*(BETA)* Authorize access to Google Cloud Platform using a service account.',
                                                                                             u'commands': {},
                                                                                             u'flags': {u'--key-file': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Path to the private key file.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--key-file',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': True,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'KEY_FILE'},
                                                                                                        u'--password-file': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Path to a file containing the password for the service account private key (only for a .p12 file).',
                                                                                                                             u'group': u'activate-service-account.1',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--password-file',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'PASSWORD_FILE'},
                                                                                                        u'--prompt-for-password': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Prompt for the password for the service account private key (only for a .p12 file).',
                                                                                                                                   u'group': u'activate-service-account.1',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--prompt-for-password',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'PROMPT_FOR_PASSWORD'}},
                                                                                             u'group': False,
                                                                                             u'groups': {u'activate-service-account.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                         u'is_mutex': True,
                                                                                                                                         u'is_required': False}},
                                                                                             u'hidden': False,
                                                                                             u'name': u'activate-service-account',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'beta',
                                                                                                       u'auth',
                                                                                                       u'activate-service-account'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'E-mail address of the service account.',
                                                                                                               u'name': u'account',
                                                                                                               u'nargs': u'?',
                                                                                                               u'required': False,
                                                                                                               u'value': u'ACCOUNT'}],
                                                                                             u'release': u'BETA',
                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Obtains access credentials for the service account using a .json (preferred)\nor .p12 file that contains a private authorization key. You obtain the key\nfile from the [Cloud Platform console](https://console.cloud.google.com). For\n.p12 files, a password is required. This password is displayed in the console\nwhen you create the key. If you specify a project using the `--project` flag,\nthe project is set in your active configuration.\n\nAny previously active credentials will still be retained,\nthey will just no longer be the active credentials.'}},
                                                               u'application-default': {u'capsule': u'*(BETA)* Manage your active Application Default Credentials.',
                                                                                        u'commands': {u'login': {u'capsule': u'*(BETA)* Acquire new user credentials to use for Application Default Credentials.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--client-id-file': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'A file containing your own client id to use to login.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--client-id-file',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'CLIENT_ID_FILE'},
                                                                                                                            u'--launch-browser': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': True,
                                                                                                                                                  u'description': u'Launch a browser for authorization. If not enabled or DISPLAY variable is not set, prints a URL to standard output to be copied. Enabled by default, use *--no-launch-browser* to disable.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--launch-browser',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'LAUNCH_BROWSER'},
                                                                                                                            u'--no-launch-browser': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': True,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-launch-browser',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_LAUNCH_BROWSER'},
                                                                                                                            u'--scopes': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The names of the scopes to authorize for. By default https://www.googleapis.com/auth/userinfo.email, https://www.googleapis.com/auth/cloud-platform scopes are used. The list of possible scopes can be found at: [](https://developers.google.com/identity/protocols/googlescopes).',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--scopes',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'SCOPES'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'login',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'auth',
                                                                                                                           u'application-default',
                                                                                                                           u'login'],
                                                                                                                 u'positionals': [],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Obtains user access credentials via a web flow and puts them in the\nwell-known location for Application Default Credentials to use them as a proxy\nfor a service account.\n\nThis command is useful for when you are developing code that would normally\nuse a service account, but you need to run the code in a local development\nenvironment, and it is easier to provide user credentials. The credentials\nwill apply to all API calls that make use of the Application Default\nCredentials client library.\n\nThis command has no effect on the user account(s) set up by the\n`gcloud auth login` command. Any credentials previously generated by this\ncommand will be overwritten.',
                                                                                                                               u'EXAMPLES': u'If you want your local application to temporarily use your own user\ncredentials for API access, run:\n\n  $ login\n'}},
                                                                                                      u'print-access-token': {u'capsule': u'*(BETA)* Print an access token for the your current Application Default Credentials.',
                                                                                                                              u'commands': {},
                                                                                                                              u'flags': {},
                                                                                                                              u'group': False,
                                                                                                                              u'groups': {},
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'print-access-token',
                                                                                                                              u'path': [u'gcloud',
                                                                                                                                        u'beta',
                                                                                                                                        u'auth',
                                                                                                                                        u'application-default',
                                                                                                                                        u'print-access-token'],
                                                                                                                              u'positionals': [],
                                                                                                                              u'release': u'BETA',
                                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Once you have generated Application Default Credentials using\n`application-default login`, you can use this command to generate and print\nan access token that can be directly used for making an API call. This can be\nuseful for manually testing out APIs via curl.'}},
                                                                                                      u'revoke': {u'capsule': u'*(BETA)* Revoke previously generated Application Default Credentials.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'revoke',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'auth',
                                                                                                                            u'application-default',
                                                                                                                            u'revoke'],
                                                                                                                  u'positionals': [],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Revokes Application Default Credentials that have been previously generated by\n`application-default login` and deletes the local credential file.\n\nThis does not effect any credentials set up through other means,\nfor example credentials referenced by the Application Default Credentials\nenvironment variable or service account credentials that are active on\na Google Compute Engine virtual machine.'}}},
                                                                                        u'flags': {},
                                                                                        u'group': True,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'application-default',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'beta',
                                                                                                  u'auth',
                                                                                                  u'application-default'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'BETA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Application Default Credentials (ADC) provide a method to get credentials used\nin calling Google APIs. The application-default command group allows you to manage\nactive credentials on your machine that are used for local application\ndevelopment.\n\nThese credentials are only used by Google client libraries in your own\napplication.\n\nMore information on ADC and how they work can be found here:\nhttps://developers.google.com/identity/protocols/application-default-credentials\n\n## EXAMPLES\n\nTo create a service account and have your application use it for API access,\nrun:\n\n  $ gcloud iam service-accounts create my-account\n  $ gcloud iam service-accounts keys create key.json\n    --iam-account=my-account@my-project.iam.gserviceaccount.com\n  $ export GOOGLE_APPLICATION_CREDENTIALS=key.json\n  $ ./my_application.sh\n\nTo temporarily use your own user credentials, run:\n\n  $ application-default login\n\nThis will take you through a web flow to acquire new user credentials.'}},
                                                               u'list': {u'capsule': u'*(BETA)* Lists credentialed accounts.',
                                                                         u'commands': {},
                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                  u'category': u'LIST COMMAND',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--filter',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'string',
                                                                                                  u'value': u'EXPRESSION'},
                                                                                    u'--filter-account': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'List only credentials for one account. Use\n--filter="account~_PATTERN_" to select accounts that match\n_PATTERN_.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--filter-account',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'FILTER_ACCOUNT'},
                                                                                    u'--limit': {u'attr': {},
                                                                                                 u'category': u'LIST COMMAND',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'--limit',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'type': u'string',
                                                                                                 u'value': u'LIMIT'},
                                                                                    u'--page-size': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--page-size',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                    u'--sort-by': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--sort-by',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'list',
                                                                                                   u'value': u'FIELD'}},
                                                                         u'group': False,
                                                                         u'groups': {},
                                                                         u'hidden': False,
                                                                         u'name': u'list',
                                                                         u'path': [u'gcloud',
                                                                                   u'beta',
                                                                                   u'auth',
                                                                                   u'list'],
                                                                         u'positionals': [],
                                                                         u'release': u'BETA',
                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Lists accounts whose credentials have been obtained using `gcloud init`,\n`gcloud auth login` and `gcloud auth activate-service-account`, and shows\nwhich account is active. The active account is used by gcloud and other Cloud\nSDK tools to access Google Cloud Platform.\n\n## EXAMPLES\n\nTo list the active account name:\n\n  $ gcloud auth list --filter=status:ACTIVE --format="value(account)"\n\nTo list the inactive account names with prefix `test`:\n\n  $ gcloud auth list --filter="-status:ACTIVE account:test*" --format="value(account)"'}},
                                                               u'login': {u'capsule': u'*(BETA)* Authorize gcloud to access Google Cloud Platform.',
                                                                          u'commands': {},
                                                                          u'flags': {u'--activate': {u'attr': {u'inverted_synopsis': True},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': True,
                                                                                                     u'description': u'Set the new account to active. Enabled by default, use *--no-activate* to disable.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--activate',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'ACTIVATE'},
                                                                                     u'--brief': {u'attr': {},
                                                                                                  u'category': u'',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': False,
                                                                                                  u'description': u'Minimal user output.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--brief',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'bool',
                                                                                                  u'value': u'BRIEF'},
                                                                                     u'--do-not-activate': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': True,
                                                                                                            u'description': u'',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': True,
                                                                                                            u'name': u'--do-not-activate',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'DO_NOT_ACTIVATE'},
                                                                                     u'--enable-gdrive-access': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'Enable Google Drive access.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--enable-gdrive-access',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'ENABLE_GDRIVE_ACCESS'},
                                                                                     u'--force': {u'attr': {},
                                                                                                  u'category': u'',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': False,
                                                                                                  u'description': u'Re-run the web authorization flow even if the given account has valid credentials.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--force',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'bool',
                                                                                                  u'value': u'FORCE'},
                                                                                     u'--launch-browser': {u'attr': {u'inverted_synopsis': True},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': True,
                                                                                                           u'description': u'Launch a browser for authorization. If not enabled or DISPLAY variable is not set, prints a URL to standard output to be copied. Enabled by default, use *--no-launch-browser* to disable.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--launch-browser',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'LAUNCH_BROWSER'},
                                                                                     u'--no-activate': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-activate',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_ACTIVATE'},
                                                                                     u'--no-brief': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': True,
                                                                                                     u'description': u'',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': True,
                                                                                                     u'name': u'--no-brief',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'NO_BRIEF'},
                                                                                     u'--no-do-not-activate': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-do-not-activate',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_DO_NOT_ACTIVATE'},
                                                                                     u'--no-enable-gdrive-access': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': True,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-enable-gdrive-access',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_ENABLE_GDRIVE_ACCESS'},
                                                                                     u'--no-force': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': True,
                                                                                                     u'description': u'',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': True,
                                                                                                     u'name': u'--no-force',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'NO_FORCE'},
                                                                                     u'--no-launch-browser': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-launch-browser',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_LAUNCH_BROWSER'}},
                                                                          u'group': False,
                                                                          u'groups': {},
                                                                          u'hidden': False,
                                                                          u'name': u'login',
                                                                          u'path': [u'gcloud',
                                                                                    u'beta',
                                                                                    u'auth',
                                                                                    u'login'],
                                                                          u'positionals': [{u'completer': u'',
                                                                                            u'default': None,
                                                                                            u'description': u'User account used for authorization.',
                                                                                            u'name': u'account',
                                                                                            u'nargs': u'?',
                                                                                            u'required': False,
                                                                                            u'value': u'ACCOUNT'}],
                                                                          u'release': u'BETA',
                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Obtains access credentials for your user account via a web-based authorization\nflow. When this command completes successfully, it sets the active account\nin the current configuration to the account specified. If no configuration\nexists, it creates a configuration named default.\n\nIf valid credentials for an account are already available from a prior\nauthorization, the account is set to active without rerunning the flow.\n\nUse `gcloud auth list` to view credentialed accounts.'}},
                                                               u'revoke': {u'capsule': u'*(BETA)* Revoke access credentials for an account.',
                                                                           u'commands': {},
                                                                           u'flags': {u'--all': {u'attr': {},
                                                                                                 u'category': u'',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': False,
                                                                                                 u'description': u'Revoke credentials for all accounts.',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'--all',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'type': u'bool',
                                                                                                 u'value': u'ALL'},
                                                                                      u'--no-all': {u'attr': {},
                                                                                                    u'category': u'',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': True,
                                                                                                    u'description': u'',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': True,
                                                                                                    u'name': u'--no-all',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'NO_ALL'}},
                                                                           u'group': False,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'revoke',
                                                                           u'path': [u'gcloud',
                                                                                     u'beta',
                                                                                     u'auth',
                                                                                     u'revoke'],
                                                                           u'positionals': [{u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u'Accounts whose credentials are to be revoked.',
                                                                                             u'name': u'accounts',
                                                                                             u'nargs': u'*',
                                                                                             u'required': False,
                                                                                             u'value': u'ACCOUNTS'}],
                                                                           u'release': u'BETA',
                                                                           u'sections': {u'DESCRIPTION': u"*(BETA)* Revokes credentials for the specified user accounts or service accounts.\nWhen you revoke the credentials, they are removed from the local machine. If\nno account is specified, this command revokes credentials for the currently\nactive account.\n\nYou can revoke credentials when you want to disallow access by gcloud and\nother Cloud SDK tools using a specified account. You don't need to revoke\ncredentials to switch between accounts."}}},
                                                 u'flags': {},
                                                 u'group': True,
                                                 u'groups': {},
                                                 u'hidden': False,
                                                 u'name': u'auth',
                                                 u'path': [u'gcloud',
                                                           u'beta',
                                                           u'auth'],
                                                 u'positionals': [],
                                                 u'release': u'BETA',
                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* The gcloud auth command group lets you grant and revoke authorization to Cloud\nSDK (gcloud) to access Google Cloud Platform.'}},
                                       u'bigtable': {u'capsule': u'*(BETA)* Manage your Cloud Bigtable storage.',
                                                     u'commands': {u'clusters': {u'capsule': u'*(BETA)* Manage Cloud Bigtable clusters.',
                                                                                 u'commands': {u'list': {u'capsule': u'*(BETA)* List existing Bigtable clusters.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--instances': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'ID of the instance.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--instances',
                                                                                                                                     u'nargs': u'+',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'INSTANCES'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'bigtable',
                                                                                                                   u'clusters',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* List existing Bigtable clusters.'}},
                                                                                               u'update': {u'capsule': u"*(BETA)* Update a Bigtable cluster's friendly name and serving nodes.",
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Return immediately, without waiting for operation to complete.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--async',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ASYNC'},
                                                                                                                      u'--instance': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'ID of the instance.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--instance',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'INSTANCE'},
                                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-async',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ASYNC'},
                                                                                                                      u'--num-nodes': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Number of nodes to serve.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--num-nodes',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'NUM_NODES'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'update',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'bigtable',
                                                                                                                     u'clusters',
                                                                                                                     u'update'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'ID of the cluster.',
                                                                                                                             u'name': u'cluster',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'CLUSTER'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u"*(BETA)* Update a Bigtable cluster's friendly name and serving nodes."}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'clusters',
                                                                                 u'path': [u'gcloud',
                                                                                           u'beta',
                                                                                           u'bigtable',
                                                                                           u'clusters'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'BETA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Manage Cloud Bigtable clusters.'}},
                                                                   u'instances': {u'capsule': u'*(BETA)* Manage Cloud Bigtable instances.',
                                                                                  u'commands': {u'create': {u'capsule': u'*(BETA)* Create a new Bigtable instance.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'Return immediately, without waiting for operation to complete.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'ASYNC'},
                                                                                                                       u'--cluster': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'ID of the cluster.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--cluster',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'CLUSTER'},
                                                                                                                       u'--cluster-num-nodes': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Number of nodes to serve.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--cluster-num-nodes',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': True,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'CLUSTER_NUM_NODES'},
                                                                                                                       u'--cluster-storage-type': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [u'HDD',
                                                                                                                                                                u'SSD'],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': u'SSD',
                                                                                                                                                   u'description': u'Storage class for the cluster. _CLUSTER_STORAGE_TYPE_ must be one of: *HDD*, *SSD*.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--cluster-storage-type',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'CLUSTER_STORAGE_TYPE'},
                                                                                                                       u'--cluster-zone': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'ID of the zone where the cluster is located. As of this release supported zones are: asia-east1-b, us-central1-b, us-central1-c, europe-west1-c',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--cluster-zone',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'CLUSTER_ZONE'},
                                                                                                                       u'--description': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Friendly name of the instance.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--description',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                                       u'--no-async': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-async',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_ASYNC'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'create',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'bigtable',
                                                                                                                      u'instances',
                                                                                                                      u'create'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'ID of the instance.',
                                                                                                                              u'name': u'instance',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'INSTANCE'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Create a new Bigtable instance.'}},
                                                                                                u'delete': {u'capsule': u'*(BETA)* Delete an existing Bigtable instance.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'delete',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'bigtable',
                                                                                                                      u'instances',
                                                                                                                      u'delete'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'ID of the instance.',
                                                                                                                              u'name': u'instance',
                                                                                                                              u'nargs': u'+',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'INSTANCE'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Delete an existing Bigtable instance.'}},
                                                                                                u'describe': {u'capsule': u'*(BETA)* Describe an existing Bigtable instance.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'bigtable',
                                                                                                                        u'instances',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'ID of the instance.',
                                                                                                                                u'name': u'instance',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'INSTANCE'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Describe an existing Bigtable instance.'}},
                                                                                                u'list': {u'capsule': u'*(BETA)* List existing Bigtable instances.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'bigtable',
                                                                                                                    u'instances',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* List existing Bigtable instances.'}},
                                                                                                u'update': {u'capsule': u'*(BETA)* Modify an existing Bigtable instance.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--description': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Friendly name of the instance.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--description',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'DESCRIPTION'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'update',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'bigtable',
                                                                                                                      u'instances',
                                                                                                                      u'update'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'ID of the instance.',
                                                                                                                              u'name': u'instance',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'INSTANCE'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Modify an existing Bigtable instance.'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'instances',
                                                                                  u'path': [u'gcloud',
                                                                                            u'beta',
                                                                                            u'bigtable',
                                                                                            u'instances'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'BETA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Manage Cloud Bigtable instances.'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'bigtable',
                                                     u'path': [u'gcloud',
                                                               u'beta',
                                                               u'bigtable'],
                                                     u'positionals': [],
                                                     u'release': u'BETA',
                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Manage your Cloud Bigtable storage.'}},
                                       u'compute': {u'capsule': u'*(BETA)* Create and manipulate Google Compute Engine resources.',
                                                    u'commands': {u'accelerator-types': {u'capsule': u'*(BETA)* Read Google Compute Engine accelerator types.',
                                                                                         u'commands': {u'describe': {u'capsule': u'*(BETA)* Describe Google Compute Engine accelerator types.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The zone of the accelerator type to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--zone',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'describe',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'accelerator-types',
                                                                                                                               u'describe'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the accelerator type.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine accelerator type.\n'}},
                                                                                                       u'list': {u'capsule': u'*(BETA)* List Google Compute Engine accelerator types.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--filter',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                                            u'--limit': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--limit',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'LIMIT'},
                                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_URI'},
                                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--page-size',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--sort-by',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'FIELD'},
                                                                                                                            u'--uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'URI'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'list',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'compute',
                                                                                                                           u'accelerator-types',
                                                                                                                           u'list'],
                                                                                                                 u'positionals': [],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine accelerator types in a project.\n\nBy default, accelerator types from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                               u'EXAMPLES': u"To list all accelerator types in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all accelerator types in a project, run:\n\n  $ list --uri\n\nTo list all accelerator types in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                                         u'flags': {},
                                                                                         u'group': True,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'accelerator-types',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'beta',
                                                                                                   u'compute',
                                                                                                   u'accelerator-types'],
                                                                                         u'positionals': [],
                                                                                         u'release': u'BETA',
                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Read Google Compute Engine accelerator types.'}},
                                                                  u'addresses': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine addresses.',
                                                                                 u'commands': {u'create': {u'capsule': u'*(BETA)* Reserve IP addresses.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--addresses': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"Ephemeral IP addresses to promote to reserved status. Only addresses\nthat are being used by resources in the project can be promoted. When\nproviding this flag, a parallel list of names for the addresses can\nbe provided. For example,\n+\n  $ {command} ADDRESS-1 ADDRESS-2 --addresses 162.222.181.197,162.222.181.198 --region us-central1\n+\nwill result in 162.222.181.197 being reserved as\n'ADDRESS-1' and 162.222.181.198 as 'ADDRESS-2'. If\nno names are given, randomly-generated names will be assigned\nto the IP addresses.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--addresses',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'ADDRESS'},
                                                                                                                      u'--description': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'An optional textual description for the addresses.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--description',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'DESCRIPTION'},
                                                                                                                      u'--global': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'If provided, it is assumed the address name is global.',
                                                                                                                                    u'group': u'create.1',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--global',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'GLOBAL'},
                                                                                                                      u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"The region of the address name to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                    u'group': u'create.1',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--region',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'REGION'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False}},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'create',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'compute',
                                                                                                                     u'addresses',
                                                                                                                     u'create'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The address names to operate on.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'*',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u"*create* is used to reserve one or more IP addresses. Once\nan IP address is reserved, it will be associated with the\nproject until it is released using 'gcloud compute addresses\ndelete'. Ephemeral IP addresses that are in use by resources\nin the project, can be reserved using the ``--addresses''\nflag.\n",
                                                                                                                         u'EXAMPLES': u"To reserve three IP addresses in the ``us-central1'' region,\nrun:\n\n  $ create ADDRESS-1 ADDRESS-2 ADDRESS-3 --region us-central1\n\nTo reserve ephemeral IP addresses 162.222.181.198 and\n23.251.146.189 which are being used by virtual machine\ninstances in the ``us-central1'' region, run:\n\n  $ create --addresses 162.222.181.198,23.251.146.189 --region us-central1\n\nIn the above invocation, the two addresses will be assigned\nrandom names.\n"}},
                                                                                               u'delete': {u'capsule': u'*(BETA)* Release reserved IP addresses.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--global': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'If provided, it is assumed the address name is global.',
                                                                                                                                    u'group': u'delete.1',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--global',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'GLOBAL'},
                                                                                                                      u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"The region of the address name to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                    u'group': u'delete.1',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--region',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'REGION'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False}},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'delete',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'compute',
                                                                                                                     u'addresses',
                                                                                                                     u'delete'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The address names to operate on.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*delete* releases one or more Google Compute Engine IP addresses.\n'}},
                                                                                               u'describe': {u'capsule': u'*(BETA)* Display detailed information about an address.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--global': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'If provided, it is assumed that the requested resource is global.',
                                                                                                                                      u'group': u'describe.1',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--global',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'GLOBAL'},
                                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                      u'group': u'describe.1',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--region',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REGION'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                         u'is_mutex': True,
                                                                                                                                         u'is_required': False}},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'compute',
                                                                                                                       u'addresses',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the resource to fetch.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with an address in a project.\n',
                                                                                                                           u'EXAMPLES': u'To get details about a global address, run:\n\n  $ describe ADDRESS --global\n\nTo get details about a regional address, run:\n\n  $ describe ADDRESS --region us-central1\n'}},
                                                                                               u'list': {u'capsule': u'*(BETA)* List addresses.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--global': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'If provided, only global resources are shown.',
                                                                                                                                  u'group': u'list.1',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--global',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'GLOBAL'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--regexp': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--regexp',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'REGEXP'},
                                                                                                                    u'--regions': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                   u'group': u'list.1',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--regions',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'REGION'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                 u'is_mutex': True,
                                                                                                                                 u'is_required': False}},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'addresses',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': [],
                                                                                                                           u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'*',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*list* lists summary information of addresses in a project. The\n*--uri* option can be used to display URIs instead. Users who want to\nsee more data should use `gcloud compute addresses describe`.\n\nBy default, global addresses and addresses from all regions are listed.\nThe results can be narrowed down by providing the *--regions* or\n*--global* flag.\n',
                                                                                                                       u'EXAMPLES': u"To list all addresses in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all addresses in a project, run:\n\n  $ list --uri\n\nTo list all of the global addresses in a project, run:\n\n  $ list --global\n\nTo list all of the regional addresses in a project, run:\n\n  $ list --regions\n\nTo list all of the addresses from the ``us-central1'' and the\n``europe-west1'' regions, run:\n\n  $ list --regions us-central1,europe-west1\n"}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'addresses',
                                                                                 u'path': [u'gcloud',
                                                                                           u'beta',
                                                                                           u'compute',
                                                                                           u'addresses'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'BETA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine addresses.'}},
                                                                  u'backend-buckets': {u'capsule': u'*(BETA)* Read and manipulate backend buckets.',
                                                                                       u'commands': {u'create': {u'capsule': u'*(BETA)* Create a backend bucket.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--description': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'An optional, textual description for the backend bucket.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--description',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'DESCRIPTION'},
                                                                                                                            u'--enable-cdn': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'Enable Cloud CDN for the backend bucket. Cloud CDN can cache HTTP\nresponses from a backend bucket at the edge of the network, close to\nusers.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--enable-cdn',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'ENABLE_CDN'},
                                                                                                                            u'--gcs-bucket-name': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The name of the Google Cloud Storage bucket to serve from. The storage\n        bucket must be owned by the project's owner.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--gcs-bucket-name',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': True,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'GCS_BUCKET_NAME'},
                                                                                                                            u'--no-enable-cdn': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--no-enable-cdn',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'NO_ENABLE_CDN'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'create',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'compute',
                                                                                                                           u'backend-buckets',
                                                                                                                           u'create'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the backend bucket.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'\n*create* is used to create backend buckets. Backend buckets\ndefine a Google Cloud Storage bucket that can serve content. URL\nmaps define which requests are sent to which backend buckets.\n'}},
                                                                                                     u'delete': {u'capsule': u'*(BETA)* Delete backend buckets.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'delete',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'compute',
                                                                                                                           u'backend-buckets',
                                                                                                                           u'delete'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The resources to delete.',
                                                                                                                                   u'name': u'names',
                                                                                                                                   u'nargs': u'+',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* *delete* deletes one or more backend buckets.'}},
                                                                                                     u'describe': {u'capsule': u'*(BETA)* Describe a backend bucket.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'describe',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'beta',
                                                                                                                             u'compute',
                                                                                                                             u'backend-buckets',
                                                                                                                             u'describe'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the resource to fetch.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'BETA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a backend bucket in a\nproject.\n'}},
                                                                                                     u'list': {u'capsule': u'*(BETA)* List Google Compute Engine backend buckets.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--filter',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'EXPRESSION'},
                                                                                                                          u'--limit': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--limit',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'LIMIT'},
                                                                                                                          u'--no-uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_URI'},
                                                                                                                          u'--page-size': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--page-size',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                                                          u'--regexp': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--regexp',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REGEXP'},
                                                                                                                          u'--sort-by': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--sort-by',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'FIELD'},
                                                                                                                          u'--uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'URI'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'list',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'compute',
                                                                                                                         u'backend-buckets',
                                                                                                                         u'list'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': [],
                                                                                                                                 u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                 u'name': u'names',
                                                                                                                                 u'nargs': u'*',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine backend buckets in a project.\n',
                                                                                                                             u'EXAMPLES': u'To list all backend buckets in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all backend buckets in a project, run:\n\n  $ list --uri\n'}},
                                                                                                     u'update': {u'capsule': u'*(BETA)* Update a backend bucket.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--description': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'An optional, textual description for the backend bucket.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--description',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'DESCRIPTION'},
                                                                                                                            u'--enable-cdn': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'Enable Cloud CDN for the backend bucket. Cloud CDN can cache HTTP\nresponses from a backend bucket at the edge of the network, close to\nusers.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--enable-cdn',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'ENABLE_CDN'},
                                                                                                                            u'--gcs-bucket-name': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The name of the Google Cloud Storage bucket to serve from. The storage\n        bucket must be owned by the project's owner.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--gcs-bucket-name',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'GCS_BUCKET_NAME'},
                                                                                                                            u'--no-enable-cdn': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--no-enable-cdn',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'NO_ENABLE_CDN'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'update',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'compute',
                                                                                                                           u'backend-buckets',
                                                                                                                           u'update'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the backend bucket.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'\n*update* is used to update backend buckets.\n'}}},
                                                                                       u'flags': {},
                                                                                       u'group': True,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'backend-buckets',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'beta',
                                                                                                 u'compute',
                                                                                                 u'backend-buckets'],
                                                                                       u'positionals': [],
                                                                                       u'release': u'BETA',
                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate backend buckets.'}},
                                                                  u'backend-services': {u'capsule': u'*(BETA)* List, create, and delete backend services.',
                                                                                        u'commands': {u'add-backend': {u'capsule': u'*(BETA)* Add a backend to a backend service.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--balancing-mode': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [u'CONNECTION',
                                                                                                                                                                     u'RATE',
                                                                                                                                                                     u'UTILIZATION'],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Defines the strategy for balancing load.\n+\n*RATE* and the max rate arguments are available only\nin backend services with HTTP based protocols.\n+\nFor backend services with TCP/SSL protocol either *UTILIZATION* or\n*CONNECTION* are available.\n+\n_BALANCING_MODE_ must be one of:\n+\n*CONNECTION*:::           Spreads load based on how many concurrent connections the group\n          can handle. There are two ways to specify max connections:\n          *--max-connections* which defines the max number of connections\n          for the whole group or *--max-connections-per-instance*, which\n          defines the max number of connections on a per-instance basis.\n\n*RATE*:::           Spreads load based on how many requests per second (RPS) the group\n          can handle. There are two ways to specify max RPS: *--max-rate* which\n          defines the max RPS for the whole group or *--max-rate-per-instance*,\n          which defines the max RPS on a per-instance basis.\n\n*UTILIZATION*:::           Relies on the CPU utilization of the instances in the group when\n          balancing load. Use *--max-utilization* to set a maximum target CPU\n          utilization for each instance. Use *--max-rate-per-instance* or\n          *--max-rate* to optionally limit based on RPS in addition to CPU.\n          You can optionally also limit based on connections (for TCP/SSL) in\n          addition to CPU by setting *--max-connections* or\n          *--max-connections-per-instance*.\n\n+',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--balancing-mode',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'BALANCING_MODE'},
                                                                                                                                  u'--capacity-scaler': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u"A float in the range [0.0, 1.0] that scales the maximum\nparameters for the group (e.g., max rate). A value of 0.0 will\ncause no requests to be sent to the group (i.e., it adds the\ngroup in a ``drained'' state).",
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--capacity-scaler',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'CAPACITY_SCALER'},
                                                                                                                                  u'--description': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'An optional, textual description for the backend.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--description',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                                  u'--global': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                u'group': u'add-backend.1',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--global',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'GLOBAL'},
                                                                                                                                  u'--instance-group': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The name or URI of a Google Cloud Instance Group.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--instance-group',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': True,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'INSTANCE_GROUP'},
                                                                                                                                  u'--instance-group-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The region of the instance group to add to the backend service. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                               u'group': u'add-backend.2',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--instance-group-region',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'INSTANCE_GROUP_REGION'},
                                                                                                                                  u'--instance-group-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The zone of the instance group to add to the backend service. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                             u'group': u'add-backend.2',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--instance-group-zone',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'INSTANCE_GROUP_ZONE'},
                                                                                                                                  u'--max-connections': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Maximum concurrent connections that the group can handle.',
                                                                                                                                                         u'group': u'add-backend.3',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--max-connections',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'MAX_CONNECTIONS'},
                                                                                                                                  u'--max-connections-per-instance': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'The maximum concurrent connections per-instance.',
                                                                                                                                                                      u'group': u'add-backend.3',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--max-connections-per-instance',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'MAX_CONNECTIONS_PER_INSTANCE'},
                                                                                                                                  u'--max-rate': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Maximum requests per second (RPS) that the group can handle.',
                                                                                                                                                  u'group': u'add-backend.3',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--max-rate',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'MAX_RATE'},
                                                                                                                                  u'--max-rate-per-instance': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The maximum per-instance requests per second (RPS).',
                                                                                                                                                               u'group': u'add-backend.3',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--max-rate-per-instance',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'MAX_RATE_PER_INSTANCE'},
                                                                                                                                  u'--max-utilization': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The target CPU utilization for the group as a float in the range\n[0.0, 1.0]. This flag can only be provided when the balancing\nmode is *UTILIZATION*.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--max-utilization',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'MAX_UTILIZATION'},
                                                                                                                                  u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                u'group': u'add-backend.1',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--region',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'REGION'},
                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The zone of the instance group to add to the backend service. DEPRECATED, use --instance-group-zone flag instead. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                              u'group': u'add-backend.2',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--zone',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {u'add-backend.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                      u'is_mutex': True,
                                                                                                                                                      u'is_required': False},
                                                                                                                                   u'add-backend.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                      u'is_mutex': True,
                                                                                                                                                      u'is_required': False},
                                                                                                                                   u'add-backend.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                                      u'is_mutex': True,
                                                                                                                                                      u'is_required': False}},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'add-backend',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'beta',
                                                                                                                                 u'compute',
                                                                                                                                 u'backend-services',
                                                                                                                                 u'add-backend'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the backend service.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'BETA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'\n*add-backend* is used to add a backend to a backend service. A\nbackend is a group of tasks that can handle requests sent to a\nbackend service. Currently, the group of tasks can be one or\nmore Google Compute Engine virtual machine instances grouped\ntogether using an instance group.\n\nTraffic is first spread evenly across all virtual machines in\nthe group. When the group is full, traffic is sent to the next\nnearest group(s) that still have remaining capacity.\n\nTo modify the parameters of a backend after it has been added\nto the backend service, use\n`gcloud compute backend-services update-backend` or\n`gcloud compute backend-services edit`.\n'}},
                                                                                                      u'create': {u'capsule': u'*(BETA)* Create a backend service.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--affinity-cookie-ttl': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'If session-affinity is set to "generated_cookie", this flag sets\nthe TTL, in seconds, of the resulting cookie.  A setting of 0\nindicates that the cookie should be transient.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--affinity-cookie-ttl',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'AFFINITY_COOKIE_TTL'},
                                                                                                                             u'--connection-draining-timeout': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Connection draining timeout to be used during removal of VMs from\ninstance groups. This guarantees that for the specified time all existing\nconnections to a VM will remain untouched, but no new connections will be\naccepted. Set timeout to zero to disable connection draining. Enable\nfeature by specifying a timeout of up to one hour.\nIf the flag is omitted API default value (0s) will be used.\nValid units for this flag are `s` for seconds, `m` for minutes, and\n`h` for hours.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--connection-draining-timeout',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'CONNECTION_DRAINING_TIMEOUT'},
                                                                                                                             u'--description': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'An optional, textual description for the backend service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--description',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'DESCRIPTION'},
                                                                                                                             u'--enable-cdn': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'Enable Cloud CDN for the backend service. Cloud CDN can cache HTTP\nresponses from a backend service at the edge of the network, close to\nusers. Cloud CDN is disabled by default.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--enable-cdn',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'ENABLE_CDN'},
                                                                                                                             u'--global': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                           u'group': u'create.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--global',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'GLOBAL'},
                                                                                                                             u'--health-checks': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Specifies a list of health check objects for checking the health of\nthe backend service. Health checks need not be for the same protocol\nas that of the backend service.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--health-checks',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'list',
                                                                                                                                                  u'value': u'HEALTH_CHECK'},
                                                                                                                             u'--http-health-checks': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Specifies a list of HTTP health check objects for checking the health\nof the backend service.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--http-health-checks',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'list',
                                                                                                                                                       u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                             u'--https-health-checks': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Specifies a list of HTTPS health check objects for checking the health\nof the backend service.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--https-health-checks',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'HTTPS_HEALTH_CHECK'},
                                                                                                                             u'--iap': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"Configure Identity Aware Proxy (IAP) service. You can configure IAP to be\n'enabled' or 'disabled' (default). If it is enabled you can provide values\nfor 'oauth2-client-id' and 'oauth2-client-secret'. For example,\n'--iap=enabled,oauth2-client-id=foo,oauth2-client-secret=bar' will\nturn IAP on, and '--iap=disabled' will turn it off. See\nhttps://cloud.google.com/iap/ for more information about this feature.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--iap',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'disabled|enabled,[oauth2-client-id=OAUTH2-CLIENT-ID,oauth2-client-secret=OAUTH2-CLIENT-SECRET]'},
                                                                                                                             u'--load-balancing-scheme': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [u'INTERNAL',
                                                                                                                                                                       u'EXTERNAL'],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': u'EXTERNAL',
                                                                                                                                                          u'description': u'Specifies if this is internal or external load balancer. _LOAD_BALANCING_SCHEME_ must be one of: *INTERNAL*, *EXTERNAL*.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--load-balancing-scheme',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'LOAD_BALANCING_SCHEME'},
                                                                                                                             u'--no-enable-cdn': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--no-enable-cdn',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_ENABLE_CDN'},
                                                                                                                             u'--port': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The TCP port to use when connecting to the backend. --port is being deprecated in favor of --port-name.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--port',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PORT'},
                                                                                                                             u'--port-name': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"The name of a service that has been added to an instance group\nin this backend. Instance group services map a name to a port\nnumber which is used by the load balancing service.\nOnly one ``port-name'' may be added to a backend service, and that\nname must exist as a service on all instance groups that are a\npart of this backend service. The port number associated with the\nname may differ between instances. If you do not specify\nthis flag, your instance groups must have a service named ``http''\nconfigured. See also\n`gcloud compute instance-groups set-named-ports --help`.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--port-name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PORT_NAME'},
                                                                                                                             u'--protocol': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [u'HTTP',
                                                                                                                                                          u'HTTPS',
                                                                                                                                                          u'SSL',
                                                                                                                                                          u'TCP',
                                                                                                                                                          u'UDP'],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The protocol for incoming requests. _PROTOCOL_ must be one of: *HTTP*, *HTTPS*, *SSL*, *TCP*, *UDP*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--protocol',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PROTOCOL'},
                                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                           u'group': u'create.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--region',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGION'},
                                                                                                                             u'--session-affinity': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [u'CLIENT_IP',
                                                                                                                                                                  u'CLIENT_IP_PORT_PROTO',
                                                                                                                                                                  u'CLIENT_IP_PROTO',
                                                                                                                                                                  u'GENERATED_COOKIE',
                                                                                                                                                                  u'NONE'],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The type of session affinity to use for this backend service. _SESSION_AFFINITY_ must be one of:\n+\n*CLIENT_IP*::: Route requests to instances based on the hash of the client\'s IP address.\n*CLIENT_IP_PORT_PROTO*::: Connections from the same client IP with the same IP protocol and port will go to the same VM in the backend while that VM remains healthy. This option cannot be used for HTTP(S) load balancing.\n*CLIENT_IP_PROTO*::: Connections from the same client IP with the same IP protocol willgo to the same VM in the pool while that VM remains healthy. This option cannot be used for HTTP(s) load balancing.\n*GENERATED_COOKIE*::: Route requests to instances based on the contents of the "GCLB" cookie set by the load balancer.\n*NONE*::: Session affinity is disabled.\n+',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--session-affinity',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'SESSION_AFFINITY'},
                                                                                                                             u'--timeout': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': u'30s',
                                                                                                                                            u'description': u"The amount of time to wait for a backend to respond to a request\nbefore considering the request failed. For example, specifying\n``10s'' will give backends 10 seconds to respond to\nrequests. Valid units for this flag are ``s'' for seconds, ``m''\nfor minutes, and ``h'' for hours.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--timeout',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'TIMEOUT'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                            u'is_mutex': True,
                                                                                                                                            u'is_required': False}},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'create',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'backend-services',
                                                                                                                            u'create'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the backend service.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u"\n*create* is used to create backend services. Backend\nservices define groups of backends that can receive\ntraffic. Each backend group has parameters that define the\ngroup's capacity (e.g., max CPU utilization, max queries per\nsecond, ...). URL maps define which requests are sent to which\nbackend services.\n\nBackend services created through this command will start out\nwithout any backend groups. To add backend groups, use 'gcloud\ncompute backend-services add-backend' or 'gcloud compute\nbackend-services edit'.\n"}},
                                                                                                      u'delete': {u'capsule': u'*(BETA)* Delete backend services.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--global': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                           u'group': u'delete.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--global',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'GLOBAL'},
                                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                           u'group': u'delete.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--region',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGION'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                            u'is_mutex': True,
                                                                                                                                            u'is_required': False}},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'delete',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'backend-services',
                                                                                                                            u'delete'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The names of the backend services.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'+',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* *delete* deletes one or more backend services.'}},
                                                                                                      u'describe': {u'capsule': u'*(BETA)* Display detailed information about a backend service.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--global': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'If provided, it is assumed that the requested resource is global.',
                                                                                                                                             u'group': u'describe.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--global',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'GLOBAL'},
                                                                                                                               u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                             u'group': u'describe.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--region',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGION'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                u'is_mutex': True,
                                                                                                                                                u'is_required': False}},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'describe',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'backend-services',
                                                                                                                              u'describe'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the resource to fetch.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a backend service in a project.\n',
                                                                                                                                  u'EXAMPLES': u"\nTo get details about a global backend service, run:\n\n  $ describe --global\n\nTo get details about a regional backend service in the ``us-central1'' regions,\nrun:\n\n  $ describe --region us-central1\n"}},
                                                                                                      u'edit': {u'capsule': u'*(BETA)* Modify backend services.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--global': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                         u'group': u'edit.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--global',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'GLOBAL'},
                                                                                                                           u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                         u'group': u'edit.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--region',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGION'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {u'edit.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                        u'is_mutex': True,
                                                                                                                                        u'is_required': False}},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'edit',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'backend-services',
                                                                                                                          u'edit'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the backend service.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*edit* can be used to modify a backend service. The backend\nservice resource is fetched from the server and presented in a text\neditor. After the file is saved and closed, this command will\nupdate the resource. Only fields that can be modified are\ndisplayed in the editor.\n\nBackends are named by their associated instances groups, and one\nof the ``--group\'\' or ``--instance-group\'\' flags is required to\nidentify the backend that you are modifying.  You cannot "change"\nthe instance group associated with a backend, but you can accomplish\nsomething similar with ``backend-services remove-backend\'\' and\n``backend-services add-backend\'\'.\n\nThe editor used to modify the resource is chosen by inspecting\nthe ``EDITOR\'\' environment variable.\n'}},
                                                                                                      u'get-health': {u'capsule': u'*(BETA)* Get backend health statuses from a backend service.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--filter',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                                 u'--global': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                               u'group': u'get-health.1',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--global',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'GLOBAL'},
                                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--limit',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'LIMIT'},
                                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': True,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-uri',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_URI'},
                                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--page-size',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                               u'group': u'get-health.1',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--region',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'REGION'},
                                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--sort-by',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'list',
                                                                                                                                                u'value': u'FIELD'},
                                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'URI'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {u'get-health.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                    u'is_required': False}},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'get-health',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'compute',
                                                                                                                                u'backend-services',
                                                                                                                                u'get-health'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the backend service.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u"\n*get-health* is used to request the current health status of\ninstances in a backend service. Every group in the service\nis checked and the health status of each configured instance\nis printed.\n\nIf a group contains names of instances that don't exist or\ninstances that haven't yet been pushed to the load-balancing\nsystem, they will not show up. Those that are listed as\n``HEALTHY'' are able to receive load-balanced traffic. Those that\nare marked as ``UNHEALTHY'' are either failing the configured\nhealth-check or not responding to it.\n\nSince the health checks are performed continuously and in\na distributed manner, the state returned by this command is\nthe most recent result of a vote of several redundant health\nchecks. Backend services that do not have a valid global\nforwarding rule referencing it will not be health checked and\nso will have no health status.\n"}},
                                                                                                      u'list': {u'capsule': u'*(BETA)* List Google Compute Engine backend services.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--filter',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                           u'--global': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'If provided, only global resources are shown.',
                                                                                                                                         u'group': u'list.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--global',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'GLOBAL'},
                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--limit',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--page-size',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                           u'--regexp': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--regexp',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGEXP'},
                                                                                                                           u'--regions': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                          u'group': u'list.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--regions',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'REGION'},
                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'FIELD'},
                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'URI'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                        u'is_mutex': True,
                                                                                                                                        u'is_required': False}},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'list',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'backend-services',
                                                                                                                          u'list'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': [],
                                                                                                                                  u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                  u'name': u'names',
                                                                                                                                  u'nargs': u'*',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine backend services in a project.\n\nBy default, global backend services and backend services from all regions are listed. The results can be narrowed down by\nproviding the ``--global'' or ``--regions'' flag.\n",
                                                                                                                              u'EXAMPLES': u"To list all backend services in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all backend services in a project, run:\n\n  $ list --uri\n\nTo list all global backend services in a project, run:\n\n  $ list --global\n\nTo list all backend services in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n"}},
                                                                                                      u'remove-backend': {u'capsule': u'*(BETA)* Remove a backend from a backend service.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--global': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                   u'group': u'remove-backend.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--global',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'GLOBAL'},
                                                                                                                                     u'--instance-group': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The name or URI of a Google Cloud Instance Group.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--instance-group',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': True,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'INSTANCE_GROUP'},
                                                                                                                                     u'--instance-group-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The region of the instance group to remove from the backend service. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                  u'group': u'remove-backend.2',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--instance-group-region',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'INSTANCE_GROUP_REGION'},
                                                                                                                                     u'--instance-group-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The zone of the instance group to remove from the backend service. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                u'group': u'remove-backend.2',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--instance-group-zone',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'INSTANCE_GROUP_ZONE'},
                                                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                   u'group': u'remove-backend.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--region',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'REGION'},
                                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The zone of the instance group to remove from the backend service. DEPRECATED, use --instance-group-zone flag instead. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                 u'group': u'remove-backend.2',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--zone',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'ZONE'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {u'remove-backend.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                            u'is_required': False},
                                                                                                                                      u'remove-backend.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                            u'is_required': False}},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'remove-backend',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'beta',
                                                                                                                                    u'compute',
                                                                                                                                    u'backend-services',
                                                                                                                                    u'remove-backend'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the backend service.',
                                                                                                                                            u'name': u'name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'NAME'}],
                                                                                                                          u'release': u'BETA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* *remove-backend* is used to remove a backend from a backend\nservice.\n\nBefore removing a backend, it is a good idea to "drain" the\nbackend first. A backend can be drained by setting its\ncapacity scaler to zero through \'gcloud compute\nbackend-services edit\'.'}},
                                                                                                      u'update': {u'capsule': u'*(BETA)* Update a backend service.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--affinity-cookie-ttl': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'If session-affinity is set to "generated_cookie", this flag sets\nthe TTL, in seconds, of the resulting cookie.  A setting of 0\nindicates that the cookie should be transient.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--affinity-cookie-ttl',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'AFFINITY_COOKIE_TTL'},
                                                                                                                             u'--connection-draining-timeout': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Connection draining timeout to be used during removal of VMs from\ninstance groups. This guarantees that for the specified time all existing\nconnections to a VM will remain untouched, but no new connections will be\naccepted. Set timeout to zero to disable connection draining. Enable\nfeature by specifying a timeout of up to one hour.\nIf the flag is omitted API default value (0s) will be used.\nValid units for this flag are `s` for seconds, `m` for minutes, and\n`h` for hours.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--connection-draining-timeout',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'CONNECTION_DRAINING_TIMEOUT'},
                                                                                                                             u'--description': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'An optional, textual description for the backend service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--description',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'DESCRIPTION'},
                                                                                                                             u'--enable-cdn': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'Enable Cloud CDN for the backend service. Cloud CDN can cache HTTP\nresponses from a backend service at the edge of the network, close to\nusers. Cloud CDN is disabled by default.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--enable-cdn',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'ENABLE_CDN'},
                                                                                                                             u'--global': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                           u'group': u'update.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--global',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'GLOBAL'},
                                                                                                                             u'--health-checks': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Specifies a list of health check objects for checking the health of\nthe backend service. Health checks need not be for the same protocol\nas that of the backend service.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--health-checks',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'list',
                                                                                                                                                  u'value': u'HEALTH_CHECK'},
                                                                                                                             u'--http-health-checks': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Specifies a list of HTTP health check objects for checking the health\nof the backend service.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--http-health-checks',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'list',
                                                                                                                                                       u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                             u'--https-health-checks': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Specifies a list of HTTPS health check objects for checking the health\nof the backend service.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--https-health-checks',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'HTTPS_HEALTH_CHECK'},
                                                                                                                             u'--iap': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"Change the Identity Aware Proxy (IAP) service configuration for the\nbackend service. You can set IAP to 'enabled' or 'disabled', or modify\nthe OAuth2 client configuration (oauth2-client-id and\noauth2-client-secret) used by IAP. If any fields are unspecified, their\nvalues will not be modified. For instance, if IAP is enabled,\n'--iap=disabled' will disable IAP, and a subsequent '--iap=enabled' will\nthen enable it with the same OAuth2 client configuration as the first\ntime it was enabled. See\nhttps://cloud.google.com/iap/ for more information about this feature.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--iap',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'disabled|enabled,[oauth2-client-id=OAUTH2-CLIENT-ID,oauth2-client-secret=OAUTH2-CLIENT-SECRET]'},
                                                                                                                             u'--no-enable-cdn': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--no-enable-cdn',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_ENABLE_CDN'},
                                                                                                                             u'--port': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The TCP port to use when connecting to the backend. --port is being deprecated in favor of --port-name.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--port',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PORT'},
                                                                                                                             u'--port-name': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"The name of a service that has been added to an instance group\nin this backend. Instance group services map a name to a port\nnumber which is used by the load balancing service.\nOnly one ``port-name'' may be added to a backend service, and that\nname must exist as a service on all instance groups that are a\npart of this backend service. The port number associated with the\nname may differ between instances. If you do not specify\nthis flag, your instance groups must have a service named ``http''\nconfigured. See also\n`gcloud compute instance-groups set-named-ports --help`.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--port-name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PORT_NAME'},
                                                                                                                             u'--protocol': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [u'HTTP',
                                                                                                                                                          u'HTTPS',
                                                                                                                                                          u'SSL',
                                                                                                                                                          u'TCP',
                                                                                                                                                          u'UDP'],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The protocol for incoming requests. _PROTOCOL_ must be one of: *HTTP*, *HTTPS*, *SSL*, *TCP*, *UDP*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--protocol',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PROTOCOL'},
                                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                           u'group': u'update.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--region',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGION'},
                                                                                                                             u'--session-affinity': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [u'CLIENT_IP',
                                                                                                                                                                  u'CLIENT_IP_PORT_PROTO',
                                                                                                                                                                  u'CLIENT_IP_PROTO',
                                                                                                                                                                  u'GENERATED_COOKIE',
                                                                                                                                                                  u'NONE'],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The type of session affinity to use for this backend service. _SESSION_AFFINITY_ must be one of:\n+\n*CLIENT_IP*::: Route requests to instances based on the hash of the client\'s IP address.\n*CLIENT_IP_PORT_PROTO*::: Connections from the same client IP with the same IP protocol and port will go to the same VM in the backend while that VM remains healthy. This option cannot be used for HTTP(S) load balancing.\n*CLIENT_IP_PROTO*::: Connections from the same client IP with the same IP protocol willgo to the same VM in the pool while that VM remains healthy. This option cannot be used for HTTP(s) load balancing.\n*GENERATED_COOKIE*::: Route requests to instances based on the contents of the "GCLB" cookie set by the load balancer.\n*NONE*::: Session affinity is disabled.\n+',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--session-affinity',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'SESSION_AFFINITY'},
                                                                                                                             u'--timeout': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The amount of time to wait for a backend to respond to a request\nbefore considering the request failed. For example, specifying\n``10s'' will give backends 10 seconds to respond to\nrequests. Valid units for this flag are ``s'' for seconds, ``m''\nfor minutes, and ``h'' for hours.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--timeout',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'TIMEOUT'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {u'update.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                            u'is_mutex': True,
                                                                                                                                            u'is_required': False}},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'update',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'backend-services',
                                                                                                                            u'update'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the backend service.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'\n*update* is used to update backend services.\n'}},
                                                                                                      u'update-backend': {u'capsule': u'*(BETA)* Update an existing backend in a backend service.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--balancing-mode': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [u'CONNECTION',
                                                                                                                                                                        u'RATE',
                                                                                                                                                                        u'UTILIZATION'],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Defines the strategy for balancing load.\n+\n*RATE* and the max rate arguments are available only\nin backend services with HTTP based protocols.\n+\nFor backend services with TCP/SSL protocol either *UTILIZATION* or\n*CONNECTION* are available.\n+\n_BALANCING_MODE_ must be one of:\n+\n*CONNECTION*:::           Spreads load based on how many concurrent connections the group\n          can handle. There are two ways to specify max connections:\n          *--max-connections* which defines the max number of connections\n          for the whole group or *--max-connections-per-instance*, which\n          defines the max number of connections on a per-instance basis.\n\n*RATE*:::           Spreads load based on how many requests per second (RPS) the group\n          can handle. There are two ways to specify max RPS: *--max-rate* which\n          defines the max RPS for the whole group or *--max-rate-per-instance*,\n          which defines the max RPS on a per-instance basis.\n\n*UTILIZATION*:::           Relies on the CPU utilization of the instances in the group when\n          balancing load. Use *--max-utilization* to set a maximum target CPU\n          utilization for each instance. Use *--max-rate-per-instance* or\n          *--max-rate* to optionally limit based on RPS in addition to CPU.\n          You can optionally also limit based on connections (for TCP/SSL) in\n          addition to CPU by setting *--max-connections* or\n          *--max-connections-per-instance*.\n\n+',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--balancing-mode',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'BALANCING_MODE'},
                                                                                                                                     u'--capacity-scaler': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u"A float in the range [0.0, 1.0] that scales the maximum\nparameters for the group (e.g., max rate). A value of 0.0 will\ncause no requests to be sent to the group (i.e., it adds the\ngroup in a ``drained'' state).",
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--capacity-scaler',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'CAPACITY_SCALER'},
                                                                                                                                     u'--description': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'An optional, textual description for the backend.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--description',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'DESCRIPTION'},
                                                                                                                                     u'--global': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                   u'group': u'update-backend.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--global',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'GLOBAL'},
                                                                                                                                     u'--instance-group': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The name or URI of a Google Cloud Instance Group.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--instance-group',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': True,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'INSTANCE_GROUP'},
                                                                                                                                     u'--instance-group-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The region of the instance group to update the backend service. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                  u'group': u'update-backend.2',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--instance-group-region',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'INSTANCE_GROUP_REGION'},
                                                                                                                                     u'--instance-group-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The zone of the instance group to update the backend service. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                u'group': u'update-backend.2',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--instance-group-zone',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'INSTANCE_GROUP_ZONE'},
                                                                                                                                     u'--max-connections': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Maximum concurrent connections that the group can handle.',
                                                                                                                                                            u'group': u'update-backend.3',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--max-connections',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'MAX_CONNECTIONS'},
                                                                                                                                     u'--max-connections-per-instance': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The maximum concurrent connections per-instance.',
                                                                                                                                                                         u'group': u'update-backend.3',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--max-connections-per-instance',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'MAX_CONNECTIONS_PER_INSTANCE'},
                                                                                                                                     u'--max-rate': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Maximum requests per second (RPS) that the group can handle.',
                                                                                                                                                     u'group': u'update-backend.3',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--max-rate',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'MAX_RATE'},
                                                                                                                                     u'--max-rate-per-instance': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The maximum per-instance requests per second (RPS).',
                                                                                                                                                                  u'group': u'update-backend.3',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--max-rate-per-instance',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'MAX_RATE_PER_INSTANCE'},
                                                                                                                                     u'--max-utilization': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The target CPU utilization for the group as a float in the range\n[0.0, 1.0]. This flag can only be provided when the balancing\nmode is *UTILIZATION*.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--max-utilization',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'MAX_UTILIZATION'},
                                                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                   u'group': u'update-backend.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--region',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'REGION'},
                                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The zone of the instance group to update the backend service. DEPRECATED, use --instance-group-zone flag instead. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                 u'group': u'update-backend.2',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--zone',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'ZONE'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {u'update-backend.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                            u'is_required': False},
                                                                                                                                      u'update-backend.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                            u'is_required': False},
                                                                                                                                      u'update-backend.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                            u'is_required': False}},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'update-backend',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'beta',
                                                                                                                                    u'compute',
                                                                                                                                    u'backend-services',
                                                                                                                                    u'update-backend'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the backend service.',
                                                                                                                                            u'name': u'name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'NAME'}],
                                                                                                                          u'release': u'BETA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'\n*update-backend* updates a backend that is part of a backend\nservice. This is useful for changing the way a backend\nbehaves. Example changes that can be made include changing the\nload balancing policy and ``draining\'\' a backend by setting\nits capacity scaler to zero.\n\nBackends are named by their associated instances groups, and one\nof the ``--group\'\' or ``--instance-group\'\' flags is required to\nidentify the backend that you are modifying.  You cannot "change"\nthe instance group associated with a backend, but you can accomplish\nsomething similar with ``backend-services remove-backend\'\' and\n``backend-services add-backend\'\'.\n\n`gcloud compute backend-services edit` can also be used to\nupdate a backend if the use of a text editor is desired.\n'}}},
                                                                                        u'flags': {},
                                                                                        u'group': True,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'backend-services',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'beta',
                                                                                                  u'compute',
                                                                                                  u'backend-services'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'BETA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* List, create, and delete backend services.'}},
                                                                  u'config-ssh': {u'capsule': u'*(BETA)* Populate SSH config files with Host entries from each instance.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--dry-run': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u'If provided, the proposed changes to the SSH config file are printed to standard output and no actual changes are made.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--dry-run',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'DRY_RUN'},
                                                                                             u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--force-key-file-overwrite',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                             u'--no-dry-run': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': True,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-dry-run',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_DRY_RUN'},
                                                                                             u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-force-key-file-overwrite',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                             u'--no-remove': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-remove',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_REMOVE'},
                                                                                             u'--remove': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'If provided, any changes made to the SSH config file by this tool are reverted.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--remove',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'REMOVE'},
                                                                                             u'--ssh-config-file': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"Specifies an alternative per-user SSH configuration file. By\ndefault, this is ``~/.ssh/config''.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--ssh-config-file',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'SSH_CONFIG_FILE'},
                                                                                             u'--ssh-key-file': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--ssh-key-file',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'SSH_KEY_FILE'}},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'config-ssh',
                                                                                  u'path': [u'gcloud',
                                                                                            u'beta',
                                                                                            u'compute',
                                                                                            u'config-ssh'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'BETA',
                                                                                  u'sections': {u'DESCRIPTION': u"*config-ssh* makes SSHing to virtual machine instances easier\nby adding an alias for each instance to the user SSH configuration\n(``~/.ssh/config'') file.\n\nIn most cases, it is sufficient to run:\n\n  $ config-ssh\n\nEach instance will be given an alias of the form\n``NAME.ZONE.PROJECT''. For example, if ``example-instance'' resides in\n``us-central1-a'', you can SSH to it by running:\n\n  $ ssh example-instance.us-central1-a.MY-PROJECT\n\nOn some platforms, the host alias can be tab-completed, making\nthe long alias less daunting to type.\n\nThe aliases created interface with SSH-based programs like\n*scp(1)*, so it is possible to use the aliases elsewhere:\n\n  $ scp ~/MY-FILE example-instance.us-central1-a.MY-PROJECT:~\n\nWhenever instances are added, removed, or their external IP\naddresses are changed, this command should be re-executed to\nupdate the configuration.\n\nThis command ensures that the user's public SSH key is present\nin the project's metadata. If the user does not have a public\nSSH key, one is generated using *ssh-keygen(1)* (if the `--quiet`\nflag is given, the generated key will have an empty passphrase).\n"}},
                                                                  u'connect-to-serial-port': {u'capsule': u'*(BETA)* Connect to the serial port of an instance.',
                                                                                              u'commands': {},
                                                                                              u'flags': {u'--dry-run': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'If provided, the ssh command is printed to standard out rather than being executed.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--dry-run',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'DRY_RUN'},
                                                                                                         u'--extra-args': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': {},
                                                                                                                           u'description': u'Optional arguments can be passed to the serial port connection by\npassing key-value pairs to this flag, such as max-connections=N or\nreplay-lines=N. See https://cloud.google.com/compute/docs/instances/interacting-with-serial-console for additional options.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--extra-args',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'dict',
                                                                                                                           u'value': u'KEY=VALUE'},
                                                                                                         u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--force-key-file-overwrite',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                                         u'--no-dry-run': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': True,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-dry-run',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_DRY_RUN'},
                                                                                                         u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-force-key-file-overwrite',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                                         u'--no-plain': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': True,
                                                                                                                         u'description': u'',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': True,
                                                                                                                         u'name': u'--no-plain',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'NO_PLAIN'},
                                                                                                         u'--plain': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': False,
                                                                                                                      u'description': u'',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': True,
                                                                                                                      u'name': u'--plain',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'bool',
                                                                                                                      u'value': u'PLAIN'},
                                                                                                         u'--port': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The number of the requested serial port. Can be 1-4, default is 1.\n+\nInstances can support up to four serial ports. By default, this\ncommand will connect to the first serial port. Setting this flag\nwill connect to the requested serial port.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--port',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'PORT'},
                                                                                                         u'--serial-port-gateway': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': u'ssh-serialport.googleapis.com',
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--serial-port-gateway',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'SERIAL_PORT_GATEWAY'},
                                                                                                         u'--ssh-key-file': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--ssh-key-file',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'SSH_KEY_FILE'},
                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"The zone of the instance to connect to. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--zone',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'ZONE'}},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'connect-to-serial-port',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'beta',
                                                                                                        u'compute',
                                                                                                        u'connect-to-serial-port'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u"Specifies the user/instance for the serial port connection.\n+\n``USER'' specifies the username to authenticate as. If omitted,\nthe current OS user is selected.",
                                                                                                                u'name': u'user-host',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'[USER@]INSTANCE'}],
                                                                                              u'release': u'BETA',
                                                                                              u'sections': {u'DESCRIPTION': u"*connect-to-serial-port* allows users to connect to, and interact with, a VM's\nvirtual serial port using ssh as the secure, authenticated transport\nprotocol.\n\nThe user must first enable serial port access to a given VM by setting\nthe 'serial-port-enable=true' metadata key-value pair. Setting\n'serial-port-enable' on the project-level metadata enables serial port\naccess to all VMs in the project.\n\nThis command uses the same SSH key pair as the `gcloud compute ssh`\ncommand and also ensures that the user's public SSH key is present in\nthe project's metadata. If the user does not have a public SSH key,\none is generated using ssh-keygen.\n"}},
                                                                  u'copy-files': {u'capsule': u'*(BETA)* Copy files to and from Google Compute Engine virtual machines.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--dry-run': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--dry-run',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'DRY_RUN'},
                                                                                             u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--force-key-file-overwrite',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                             u'--no-dry-run': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': True,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-dry-run',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_DRY_RUN'},
                                                                                             u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-force-key-file-overwrite',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                             u'--no-plain': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': True,
                                                                                                             u'description': u'',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': True,
                                                                                                             u'name': u'--no-plain',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'NO_PLAIN'},
                                                                                             u'--plain': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u'Suppresses the automatic addition of *ssh(1)*/*scp(1)* flags. This flag\nis useful if you want to take care of authentication yourself or\nuse specific ssh/scp features.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--plain',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'PLAIN'},
                                                                                             u'--ssh-key-file': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--ssh-key-file',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'SSH_KEY_FILE'},
                                                                                             u'--strict-host-key-checking': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [u'yes',
                                                                                                                                          u'no',
                                                                                                                                          u'ask'],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"Override the default behavior of StrictHostKeyChecking. By default,\nStrictHostKeyChecking is set to 'no' the first time you connect to an\ninstance and will be set to 'yes' for all subsequent connections. Use\nthis flag to specify a value for the connection. _STRICT_HOST_KEY_CHECKING_ must be one of: *yes*, *no*, *ask*.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--strict-host-key-checking',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'STRICT_HOST_KEY_CHECKING'},
                                                                                             u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u"The zone of the instance to copy files to/from. If omitted,\nyou will be prompted to select a zone.\n+\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--zone',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'ZONE'}},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'copy-files',
                                                                                  u'path': [u'gcloud',
                                                                                            u'beta',
                                                                                            u'compute',
                                                                                            u'copy-files'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'Specifies a source file.',
                                                                                                    u'name': u'sources',
                                                                                                    u'nargs': u'+',
                                                                                                    u'required': False,
                                                                                                    u'value': u'[[USER@]INSTANCE:]SRC'},
                                                                                                   {u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'Specifies a destination for the source files.',
                                                                                                    u'name': u'destination',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'[[USER@]INSTANCE:]DEST'}],
                                                                                  u'release': u'BETA',
                                                                                  u'sections': {u'DESCRIPTION': u"*copy-files* copies files between a virtual machine instance\nand your local machine.\n\nTo denote a remote file, prefix the file name with the virtual\nmachine instance name (e.g., _example-instance_:~/_FILE_). To\ndenote a local file, do not add a prefix to the file name\n(e.g., ~/_FILE_). For example, to copy a remote directory\nto your local host, run:\n\n  $ copy-files example-instance:~/REMOTE-DIR ~/LOCAL-DIR --zone us-central1-a\n\nIn the above example, ``~/REMOTE-DIR'' from ``example-instance'' is\ncopied into the ~/_LOCAL-DIR_ directory.\n\nConversely, files from your local computer can be copied to a\nvirtual machine:\n\n  $ copy-files ~/LOCAL-FILE-1 ~/LOCAL-FILE-2 example-instance:~/REMOTE-DIR --zone us-central1-a\n\nIf a file contains a colon (``:''), you must specify it by\neither using an absolute path or a path that begins with\n``./''.\n\nUnder the covers, *scp(1)* is used to facilitate the transfer.\n\nWhen the destination is local, all sources must be the same\nvirtual machine instance. When the destination is remote, all\nsource must be local.\n\nThis command ensures that the user's public SSH key is present\nin the project's metadata. If the user does not have a public\nSSH key, one is generated using *ssh-keygen(1)* (if the the `--quiet`\nflag is given, the generated key will have an empty passphrase).\n"}},
                                                                  u'disk-types': {u'capsule': u'*(BETA)* Read Google Compute Engine virtual disk types.',
                                                                                  u'commands': {u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine disk type.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--zone',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'ZONE'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'compute',
                                                                                                                        u'disk-types',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the resource to fetch.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine disk type.\n'}},
                                                                                                u'list': {u'capsule': u'*(BETA)* List Google Compute Engine disk types.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--regexp': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--regexp',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'REGEXP'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'},
                                                                                                                     u'--zones': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': [],
                                                                                                                                  u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--zones',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'disk-types',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': [],
                                                                                                                            u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'*',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine disk types in a project.\n\nBy default, disk types from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                        u'EXAMPLES': u"To list all disk types in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all disk types in a project, run:\n\n  $ list --uri\n\nTo list all disk types in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'disk-types',
                                                                                  u'path': [u'gcloud',
                                                                                            u'beta',
                                                                                            u'compute',
                                                                                            u'disk-types'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'BETA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Read Google Compute Engine virtual disk types.'}},
                                                                  u'disks': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine disks.',
                                                                             u'commands': {u'create': {u'capsule': u'*(BETA)* Create Google Compute Engine persistent disks.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--csek-key-file',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'FILE'},
                                                                                                                  u'--description': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'An optional, textual description for the disks being created.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--description',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                  u'--image': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"An image to apply to the disks being created. When using\nthis option, the size of the disks must be at least as large as\nthe image size. Use ``--size'' to adjust the size of the disks.\n+\nThis flag is mutually exclusive with ``--source-snapshot'' and\n``--image-family''.",
                                                                                                                               u'group': u'create.1',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--image',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'IMAGE'},
                                                                                                                  u'--image-family': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The family of the image that the boot disk will be initialized with. When a family is used instead of an image, the latest non-deprecated image associated with that family is used.',
                                                                                                                                      u'group': u'create.1',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--image-family',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'IMAGE_FAMILY'},
                                                                                                                  u'--image-project': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The project against which all image and image family references will be\nresolved. See ``--image'' for more details.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--image-project',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'IMAGE_PROJECT'},
                                                                                                                  u'--no-require-csek-key-create': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': True,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-require-csek-key-create',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                  u'--require-csek-key-create': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': True,
                                                                                                                                                 u'description': u'Refuse to create resources not protected by a user managed key in\nthe key file when --csek-key-file is given. This behavior is enabled\nby default to prevent incorrect gcloud invocations from accidentally\ncreating resources with no user managed key. Disabling the check\nallows creation of some resources without a matching\nCustomer-Supplied Encryption Key in the supplied --csek-key-file.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details. Enabled by default, use *--no-require-csek-key-create* to disable.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--require-csek-key-create',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                  u'--size': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"Indicates the size of the disks. The value must be a whole\nnumber followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For\nexample, ``10GB'' will produce 10 gigabyte disks.  Disk size\nmust be a multiple of 10 GB.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--size',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'SIZE'},
                                                                                                                  u'--source-snapshot': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A source snapshot used to create the disks. It is safe to\ndelete a snapshot after a disk has been created from the\nsnapshot. In such cases, the disks will no longer reference\nthe deleted snapshot. To get a list of snapshots in your\ncurrent project, run `gcloud compute snapshots list`. A\nsnapshot from an existing disk can be created using the\n`gcloud compute disks snapshot` command. This flag is mutually\nexclusive with *--image*.\n+\nWhen using this option, the size of the disks must be at least\nas large as the snapshot size. Use *--size* to adjust the\nsize of the disks.',
                                                                                                                                         u'group': u'create.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--source-snapshot',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'SOURCE_SNAPSHOT'},
                                                                                                                  u'--type': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Specifies the type of disk to create. To get a\nlist of available disk types, run `gcloud compute disk-types list`.\nThe default disk type is pd-standard.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--type',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'TYPE'},
                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--zone',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'ZONE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                 u'is_mutex': True,
                                                                                                                                 u'is_required': False}},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'create',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'compute',
                                                                                                                 u'disks',
                                                                                                                 u'create'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The names of the disks.',
                                                                                                                         u'name': u'DISK-NAME',
                                                                                                                         u'nargs': u'+',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'DISK_NAME'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*create* creates one or more Google Compute Engine\npersistent disks. When creating virtual machine instances,\ndisks can be attached to the instances through the\n`gcloud compute instances create` command. Disks can also be\nattached to instances that are already running using\n`gcloud compute instances attach-disk`.\n\nDisks are zonal resources, so they reside in a particular zone\nfor their entire lifetime. The contents of a disk can be moved\nto a different zone by snapshotting the disk (using\n`gcloud compute disks snapshot`) and creating a new disk using\n`--source-snapshot` in the desired zone. The contents of a\ndisk can also be moved across project or zone by creating an\nimage (using `gcloud compute images create`) and creating a\nnew disk using `--image` in the desired project and/or\nzone.\n\nWhen creating disks, be sure to include the `--zone` option:\n\n  $ create my-disk-1 my-disk-2 --zone us-east1-a\n'}},
                                                                                           u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine persistent disks.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"The zone of the disk to delete. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--zone',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'ZONE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'compute',
                                                                                                                 u'disks',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The names of the disks.',
                                                                                                                         u'name': u'DISK-NAME',
                                                                                                                         u'nargs': u'+',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'DISK_NAME'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* *delete* deletes one or more Google Compute Engine\npersistent disks. Disks can be deleted only if they are not\nbeing used by any virtual machine instances.'}},
                                                                                           u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine disk.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--zone',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'ZONE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'disks',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the disk.',
                                                                                                                           u'name': u'DISK-NAME',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'DISK_NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine disk in a project.\n'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* List Google Compute Engine disks.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--regexp': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--regexp',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'REGEXP'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'},
                                                                                                                u'--zones': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': [],
                                                                                                                             u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--zones',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'list',
                                                                                                                             u'value': u'ZONE'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'compute',
                                                                                                               u'disks',
                                                                                                               u'list'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': [],
                                                                                                                       u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                       u'name': u'names',
                                                                                                                       u'nargs': u'*',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'NAME'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine disks in a project.\n\nBy default, disks from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                   u'EXAMPLES': u"To list all disks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all disks in a project, run:\n\n  $ list --uri\n\nTo list all disks in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}},
                                                                                           u'move': {u'capsule': u'*(BETA)* Move a disk between zones.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--async': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--async',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'ASYNC'},
                                                                                                                u'--destination-zone': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The zone to move the disk to.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--destination-zone',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': True,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DESTINATION_ZONE'},
                                                                                                                u'--no-async': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-async',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_ASYNC'},
                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--zone',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'ZONE'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'move',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'compute',
                                                                                                               u'disks',
                                                                                                               u'move'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The name of the disk.',
                                                                                                                       u'name': u'DISK-NAME',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'DISK_NAME'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*move* facilitates moving a Google Compute Engine disk volume from\none zone to another. You cannot move a disk if it is attached to a\nrunning or stopped instance; use the gcloud compute instances move\ncommand instead.\n\nFor example, running:\n\n   $ gcloud compute disks move example-disk-1 --zone us-central1-b --destination-zone us-central1-f\n\nwill move the disk called example-disk-1, currently running in\nus-central1-b, to us-central1-f.\n'}},
                                                                                           u'resize': {u'capsule': u'*(BETA)* Resize a disk or disks.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--size': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"Indicates the new size of the disks. The value must be a whole\nnumber followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For\nexample, ``10GB'' will produce 10 gigabyte disks.  Disk size\nmust be a multiple of 10 GB.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--size',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'SIZE'},
                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--zone',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'ZONE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'resize',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'compute',
                                                                                                                 u'disks',
                                                                                                                 u'resize'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The names of the disks.',
                                                                                                                         u'name': u'DISK-NAME',
                                                                                                                         u'nargs': u'+',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'DISK_NAME'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*resize* resizes a Google Compute Engine disk(s).\n\nOnly increasing disk size is supported. Disks can be resized\nregardless of whether they are attached.\n\n',
                                                                                                                     u'EXAMPLES': u'To resize a disk called example-disk-1 to new size 6TB, run:\n\n   $ resize example-disk-1 --size=6TB\n\nTo resize two disks called example-disk-2 and example-disk-3 to\nnew size 6TB, run:\n\n   $ resize example-disk-2 example-disk-3 --size=6TB\n\nThis assumes that original size of each of these disks is 6TB or less.\n'}},
                                                                                           u'snapshot': {u'capsule': u'*(BETA)* Create snapshots of Google Compute Engine persistent disks.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--async',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'ASYNC'},
                                                                                                                    u'--csek-key-file': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--csek-key-file',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'FILE'},
                                                                                                                    u'--description': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'An optional, textual description for the snapshots being created.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--description',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                    u'--guest-flush': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Create an application consistent snapshot by informing the OS to prepare for the snapshot process. Currently only supported on Windows instances using the Volume Shadow Copy Service (VSS).',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--guest-flush',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'GUEST_FLUSH'},
                                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_ASYNC'},
                                                                                                                    u'--no-guest-flush': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-guest-flush',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_GUEST_FLUSH'},
                                                                                                                    u'--snapshot-names': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"Names to assign to the snapshots. Without this option, the\nname of each snapshot will be a random, 16-character\nhexadecimal number that starts with a letter. The values of\nthis option run parallel to the disks specified. For example,\n+\n  $ {command} my-disk-1 my-disk-2 my-disk-3 --snapshot-names snapshot-1,snapshot-2,snapshot-3\n+\nwill result in ``my-disk-1'' being snapshotted as\n``snapshot-1'', ``my-disk-2'' as ``snapshot-2'', and so on.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--snapshot-names',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'SNAPSHOT_NAME'},
                                                                                                                    u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--zone',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'ZONE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'snapshot',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'disks',
                                                                                                                   u'snapshot'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The names of the disks.',
                                                                                                                           u'name': u'DISK-NAME',
                                                                                                                           u'nargs': u'+',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'DISK_NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u"Create snapshots of Google Compute Engine persistent disks.\n\n*snapshot* creates snapshots of persistent disks. Snapshots are useful\nfor backing up data or copying a persistent disk. Once created,\nsnapshots may be managed (listed, deleted, etc.) via\n``gcloud compute snapshots''.\n"}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'disks',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'compute',
                                                                                       u'disks'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine disks.'}},
                                                                  u'firewall-rules': {u'capsule': u'*(BETA)* List, create, update, and delete Google Compute Engine firewall rules.',
                                                                                      u'commands': {u'create': {u'capsule': u'*(BETA)* Create a Google Compute Engine firewall rule.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--allow': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'A list of protocols and ports whose traffic will be allowed.\n+\nPROTOCOL is the IP protocol whose traffic will be allowed.\nPROTOCOL can be either the name of a well-known protocol\n(e.g., tcp or icmp) or the IP protocol number.\nA list of IP protocols can be found at\nlink:http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml[].\n+\nA port or port range can be specified after PROTOCOL to\nallow traffic through specific ports. If no port or port range\nis specified, connections through all ranges are allowed. For\nexample, the following will create a rule that allows TCP traffic\nthrough port 80 and allows ICMP traffic:\n+\n  $ {command} MY-RULE --allow tcp:80,icmp\n+\nTCP and UDP rules must include a port or port range.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--allow',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': True,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'PROTOCOL[:PORT[-PORT]]'},
                                                                                                                           u'--description': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A textual description for the firewall rule.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--description',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'DESCRIPTION'},
                                                                                                                           u'--network': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': u'default',
                                                                                                                                          u'description': u"The network to which this rule is attached. If omitted, the\nrule is attached to the ``default'' network.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--network',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'NETWORK'},
                                                                                                                           u'--source-ranges': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': [],
                                                                                                                                                u'description': u'A list of IP address blocks that are allowed to make inbound\nconnections that match the firewall rule to the instances on\nthe network. The IP address blocks must be specified in CIDR\nformat:\nlink:http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing[].\n+\nIf neither --source-ranges nor --source-tags is provided, then this\nflag will default to 0.0.0.0/0, allowing all sources. Multiple IP\naddress blocks can be specified if they are separated by commas.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--source-ranges',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'list',
                                                                                                                                                u'value': u'CIDR_RANGE'},
                                                                                                                           u'--source-tags': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': [],
                                                                                                                                              u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may make network connections that match the\nfirewall rule. If omitted, all instances on the network can\nmake connections that match the rule.\n+\nTags can be assigned to instances during instance creation.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--source-tags',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'TAG'},
                                                                                                                           u'--target-tags': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': [],
                                                                                                                                              u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may accept inbound connections that match the\nfirewall rule. If omitted, all instances on the network can\nreceive inbound connections that match the rule.\n+\nTags can be assigned to instances during instance creation.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--target-tags',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'TAG'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'create',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'firewall-rules',
                                                                                                                          u'create'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the firewall rule to create.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* *create* is used to create firewall rules to allow incoming\ntraffic to a network.'}},
                                                                                                    u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine firewall rules.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'delete',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'firewall-rules',
                                                                                                                          u'delete'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The resources to delete.',
                                                                                                                                  u'name': u'names',
                                                                                                                                  u'nargs': u'+',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine firewall\n rules.\n'}},
                                                                                                    u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine firewall rule.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'describe',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'firewall-rules',
                                                                                                                            u'describe'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the resource to fetch.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* *describe* displays all data associated with a Google Compute\nEngine firewall rule in a project.'}},
                                                                                                    u'list': {u'capsule': u'*(BETA)* List Google Compute Engine firewall rules.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--filter',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'EXPRESSION'},
                                                                                                                         u'--limit': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--limit',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'LIMIT'},
                                                                                                                         u'--no-uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_URI'},
                                                                                                                         u'--page-size': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--page-size',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                                                         u'--regexp': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--regexp',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'REGEXP'},
                                                                                                                         u'--sort-by': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--sort-by',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'FIELD'},
                                                                                                                         u'--uri': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--uri',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'URI'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'list',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'compute',
                                                                                                                        u'firewall-rules',
                                                                                                                        u'list'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': [],
                                                                                                                                u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                u'name': u'names',
                                                                                                                                u'nargs': u'*',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine firewall rules in a project.\n',
                                                                                                                            u'EXAMPLES': u'To list all firewall rules in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all firewall rules in a project, run:\n\n  $ list --uri\n'}},
                                                                                                    u'update': {u'capsule': u'*(BETA)* Update a firewall rule.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--allow': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'A list of protocols and ports whose traffic will be allowed.\n+\nPROTOCOL is the IP protocol whose traffic will be allowed.\nPROTOCOL can be either the name of a well-known protocol\n(e.g., tcp or icmp) or the IP protocol number.\nA list of IP protocols can be found at\nlink:http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml[].\n+\nA port or port range can be specified after PROTOCOL to\nallow traffic through specific ports. If no port or port range\nis specified, connections through all ranges are allowed. For\nexample, the following will create a rule that allows TCP traffic\nthrough port 80 and allows ICMP traffic:\n+\n  $ {command} MY-RULE --allow tcp:80,icmp\n+\nTCP and UDP rules must include a port or port range.\n+\nSetting this will override the current values.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--allow',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'PROTOCOL[:PORT[-PORT]]'},
                                                                                                                           u'--description': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A textual description for the firewall rule. Set to an empty string to clear existing.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--description',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'DESCRIPTION'},
                                                                                                                           u'--source-ranges': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'A list of IP address blocks that are allowed to make inbound\nconnections that match the firewall rule to the instances on\nthe network. The IP address blocks must be specified in CIDR\nformat:\nlink:http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing[].\n+\nSetting this will override the existing source ranges for the firewall.\nThe following will clear the existing source ranges:\n+\n  $ {command} MY-RULE --source-ranges',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--source-ranges',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'list',
                                                                                                                                                u'value': u'CIDR_RANGE'},
                                                                                                                           u'--source-tags': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may make network connections that match the\nfirewall rule. If omitted, all instances on the network can\nmake connections that match the rule.\n+\nTags can be assigned to instances during instance creation.\n+\nSetting this will override the existing source tags for the firewall.\nThe following will clear the existing source tags:\n+\n  $ {command} MY-RULE --source-tags',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--source-tags',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'TAG'},
                                                                                                                           u'--target-tags': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may accept inbound connections that match the\nfirewall rule. If omitted, all instances on the network can\nreceive inbound connections that match the rule.\n+\nTags can be assigned to instances during instance creation.\n+\nSetting this will override the existing target tags for the firewall.\nThe following will clear the existing target tags:\n+\n  $ {command} MY-RULE --target-tags',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--target-tags',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'TAG'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'update',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'firewall-rules',
                                                                                                                          u'update'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the firewall rule to update.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*update* is used to update firewall rules that allow incoming\ntraffic to a network. Only arguments passed in will be updated on the\nfirewall rule.  Other attributes will remain unaffected.\n'}}},
                                                                                      u'flags': {},
                                                                                      u'group': True,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'firewall-rules',
                                                                                      u'path': [u'gcloud',
                                                                                                u'beta',
                                                                                                u'compute',
                                                                                                u'firewall-rules'],
                                                                                      u'positionals': [],
                                                                                      u'release': u'BETA',
                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* List, create, update, and delete Google Compute Engine firewall rules.'}},
                                                                  u'forwarding-rules': {u'capsule': u'*(BETA)* Read and manipulate forwarding rules to send traffic to load balancers.',
                                                                                        u'commands': {u'create': {u'capsule': u'*(BETA)* Create a forwarding rule to direct network traffic to a load balancer.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--address': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The external IP address that the forwarding rule will\nserve. All traffic sent to this IP address is directed to the\ntarget pointed to by the forwarding rule. If the address is\nreserved, it must either (1) reside in the global scope if the\nforwarding rule is being configured to point to a target HTTP\nproxy or (2) reside in the same region as the forwarding rule\nif the forwarding rule is being configured to point to a\ntarget pool or target instance. If this flag is omitted, an\nephemeral IP address is assigned.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--address',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'ADDRESS'},
                                                                                                                             u'--address-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The region of the address to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                   u'group': u'create.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--address-region',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'ADDRESS_REGION'},
                                                                                                                             u'--backend-service': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The target backend service that will receive the traffic.',
                                                                                                                                                    u'group': u'create.2',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--backend-service',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'BACKEND_SERVICE'},
                                                                                                                             u'--backend-service-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The region of the backend service to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                           u'group': u'create.3',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--backend-service-region',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'BACKEND_SERVICE_REGION'},
                                                                                                                             u'--description': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'An optional textual description for the forwarding rule.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--description',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'DESCRIPTION'},
                                                                                                                             u'--global': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'If provided, it is assumed the forwarding rule is global.',
                                                                                                                                           u'group': u'create.4',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--global',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'GLOBAL'},
                                                                                                                             u'--global-address': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'If provided, it is assumed the address is global.',
                                                                                                                                                   u'group': u'create.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--global-address',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'GLOBAL_ADDRESS'},
                                                                                                                             u'--global-backend-service': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': False,
                                                                                                                                                           u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                           u'group': u'create.3',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--global-backend-service',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'GLOBAL_BACKEND_SERVICE'},
                                                                                                                             u'--ip-protocol': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [u'AH',
                                                                                                                                                             u'ESP',
                                                                                                                                                             u'ICMP',
                                                                                                                                                             u'SCTP',
                                                                                                                                                             u'TCP',
                                                                                                                                                             u'UDP'],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The IP protocol that the rule will serve. The default is TCP. _IP_PROTOCOL_ must be one of: *AH*, *ESP*, *ICMP*, *SCTP*, *TCP*, *UDP*.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--ip-protocol',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'IP_PROTOCOL'},
                                                                                                                             u'--load-balancing-scheme': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [u'EXTERNAL',
                                                                                                                                                                       u'INTERNAL'],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': u'EXTERNAL',
                                                                                                                                                          u'description': u'This signifies what the forwarding rule will be used for. _LOAD_BALANCING_SCHEME_ must be one of:\n+\n*EXTERNAL*::: Used for HTTP or HTTPS for External Load Balancing.\n*INTERNAL*::: Used for Internal Network Load Balancing.\n+',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--load-balancing-scheme',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'LOAD_BALANCING_SCHEME'},
                                                                                                                             u'--network': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'(Only for Internal Load Balancing) The network that this forwarding\nrule applies to. If this field is not specified, the default network\nwill be used. In the absence of the default network, this field must\nbe specified.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--network',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'NETWORK'},
                                                                                                                             u'--port-range': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'DEPRECATED, use --ports. If specified, only packets addressed to ports in\nthe specified range will be forwarded. If not specified for regional\nforwarding rules, all ports are matched. This flag is required for global\nforwarding rules.\n+\nEither an individual port (`--port-range 80`) or a range of ports\n(`--port-range 3000-3100`) may be specified.',
                                                                                                                                               u'group': u'create.5',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--port-range',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'[PORT | PORT-PORT]'},
                                                                                                                             u'--ports': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': [],
                                                                                                                                          u'description': u'If specified, only packets addressed to ports in the specified\nlist will be forwarded. If not specified for regional forwarding\nrules, all ports are matched. This flag is required for global\nforwarding rules and accepts a single continuous set of ports.\n+\nIndividual ports and ranges can be specified,\nfor example (`--ports 8000-8004` or `--ports 80`).',
                                                                                                                                          u'group': u'create.5',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--ports',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'[PORT | PORT-PORT]'},
                                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The region of the forwarding rule to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                           u'group': u'create.4',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--region',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGION'},
                                                                                                                             u'--subnet': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'(Only for Internal Load Balancing) The subnetwork that this forwarding\nrule applies to. If the network configured for this forwarding rule is\nin auto subnet mode, the subnetwork is optional. However, if the\nnetwork is in custom subnet mode, a subnetwork must be specified.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--subnet',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'SUBNET'},
                                                                                                                             u'--subnet-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The region of the subnetwork to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--subnet-region',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'SUBNET_REGION'},
                                                                                                                             u'--target-http-proxy': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The target HTTP proxy that will receive the traffic.',
                                                                                                                                                      u'group': u'create.2',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--target-http-proxy',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'TARGET_HTTP_PROXY'},
                                                                                                                             u'--target-https-proxy': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The target HTTPS proxy that will receive the traffic.',
                                                                                                                                                       u'group': u'create.2',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--target-https-proxy',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'TARGET_HTTPS_PROXY'},
                                                                                                                             u'--target-instance': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The name of the target instance that will receive the traffic. The\ntarget instance must be in a zone that's in the forwarding rule's\nregion. Global forwarding rules may not direct traffic to target\ninstances.\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                    u'group': u'create.2',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--target-instance',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'TARGET_INSTANCE'},
                                                                                                                             u'--target-instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The zone of the target instance to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--target-instance-zone',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'TARGET_INSTANCE_ZONE'},
                                                                                                                             u'--target-pool': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The target pool that will receive the traffic. The target pool\nmust be in the same region as the forwarding rule. Global\nforwarding rules may not direct traffic to target pools.',
                                                                                                                                                u'group': u'create.2',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--target-pool',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'TARGET_POOL'},
                                                                                                                             u'--target-pool-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--target-pool-region',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'TARGET_POOL_REGION'},
                                                                                                                             u'--target-ssl-proxy': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The target SSL proxy that will receive the traffic.',
                                                                                                                                                     u'group': u'create.2',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--target-ssl-proxy',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'TARGET_SSL_PROXY'},
                                                                                                                             u'--target-vpn-gateway': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The target VPN gateway that will receive forwarded traffic.',
                                                                                                                                                       u'group': u'create.2',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--target-vpn-gateway',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'TARGET_VPN_GATEWAY'},
                                                                                                                             u'--target-vpn-gateway-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The region of the VPN gateway to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--target-vpn-gateway-region',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'TARGET_VPN_GATEWAY_REGION'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                            u'is_mutex': True,
                                                                                                                                            u'is_required': False},
                                                                                                                              u'create.2': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                            u'is_mutex': True,
                                                                                                                                            u'is_required': True},
                                                                                                                              u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                            u'is_mutex': True,
                                                                                                                                            u'is_required': False},
                                                                                                                              u'create.4': {u'description': u'At most one of these may be specified:',
                                                                                                                                            u'is_mutex': True,
                                                                                                                                            u'is_required': False},
                                                                                                                              u'create.5': {u'description': u'At most one of these may be specified:',
                                                                                                                                            u'is_mutex': True,
                                                                                                                                            u'is_required': False}},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'create',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'forwarding-rules',
                                                                                                                            u'create'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the forwarding rule.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u"*create* is used to create a forwarding rule.         Forwarding rules match and direct certain types of traffic to a load\nbalancer which is controlled by a target pool, a target instance,\nor a target HTTP proxy. Target pools and target instances perform load\nbalancing at the layer 3 of the OSI networking model\n(http://en.wikipedia.org/wiki/Network_layer). Target\nHTTP proxies perform load balancing at layer 7.\n\nForwarding rules can be either regional or global. They are\nregional if they point to a target pool or a target instance\nand global if they point to a target HTTP proxy.\n\nFor more information on load balancing, see\nhttps://cloud.google.com/compute/docs/load-balancing-and-autoscaling/.\n\n\nWhen creating a forwarding rule, exactly one of  ``--target-instance'',\n``--target-pool'', ``--target-http-proxy'', ``--target-https-proxy'',\n``--target-ssl-proxy'', or ``--target-vpn-gateway'' must be specified.\n"}},
                                                                                                      u'delete': {u'capsule': u'*(BETA)* Delete forwarding rules.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--global': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'If provided, it is assumed the forwarding rule is global.',
                                                                                                                                           u'group': u'delete.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--global',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'GLOBAL'},
                                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The region of the forwarding rule to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                           u'group': u'delete.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--region',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGION'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                            u'is_mutex': True,
                                                                                                                                            u'is_required': False}},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'delete',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'forwarding-rules',
                                                                                                                            u'delete'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The names of the forwarding rules.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'+',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* *delete* deletes one or more Google Compute Engine forwarding rules.'}},
                                                                                                      u'describe': {u'capsule': u'*(BETA)* Display detailed information about a forwarding rule.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--global': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'If provided, it is assumed that the requested resource is global.',
                                                                                                                                             u'group': u'describe.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--global',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'GLOBAL'},
                                                                                                                               u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                             u'group': u'describe.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--region',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGION'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                u'is_mutex': True,
                                                                                                                                                u'is_required': False}},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'describe',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'forwarding-rules',
                                                                                                                              u'describe'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the resource to fetch.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a forwarding rule\nin a project.\n',
                                                                                                                                  u'EXAMPLES': u'To get details about a global forwarding rule, run:\n\n  $ describe FORWARDING-RULE --global\n\nTo get details about a regional forwarding rule, run:\n\n  $ describe FORWARDING-RULE --region us-central1\n'}},
                                                                                                      u'list': {u'capsule': u'*(BETA)* List Google Compute Engine forwarding rules.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--filter',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                           u'--global': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'If provided, only global resources are shown.',
                                                                                                                                         u'group': u'list.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--global',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'GLOBAL'},
                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--limit',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--page-size',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                           u'--regexp': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--regexp',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGEXP'},
                                                                                                                           u'--regions': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                          u'group': u'list.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--regions',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'REGION'},
                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'FIELD'},
                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'URI'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                        u'is_mutex': True,
                                                                                                                                        u'is_required': False}},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'list',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'forwarding-rules',
                                                                                                                          u'list'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': [],
                                                                                                                                  u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                  u'name': u'names',
                                                                                                                                  u'nargs': u'*',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine forwarding rules in a project.\n\nBy default, global forwarding rules and forwarding rules from all regions are listed. The results can be narrowed down by\nproviding the ``--global'' or ``--regions'' flag.\n",
                                                                                                                              u'EXAMPLES': u"To list all forwarding rules in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all forwarding rules in a project, run:\n\n  $ list --uri\n\nTo list all global forwarding rules in a project, run:\n\n  $ list --global\n\nTo list all forwarding rules in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n"}},
                                                                                                      u'set-target': {u'capsule': u'*(BETA)* Modify a forwarding rule to direct network traffic to a new target.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The target backend service that will receive the traffic.',
                                                                                                                                                        u'group': u'set-target.1',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--backend-service',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'BACKEND_SERVICE'},
                                                                                                                                 u'--backend-service-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The region of the backend service to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                               u'group': u'set-target.2',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--backend-service-region',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'BACKEND_SERVICE_REGION'},
                                                                                                                                 u'--global': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'If provided, it is assumed the forwarding rule is global.',
                                                                                                                                               u'group': u'set-target.3',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--global',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'GLOBAL'},
                                                                                                                                 u'--global-backend-service': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': False,
                                                                                                                                                               u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                                               u'group': u'set-target.2',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--global-backend-service',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'bool',
                                                                                                                                                               u'value': u'GLOBAL_BACKEND_SERVICE'},
                                                                                                                                 u'--load-balancing-scheme': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [u'EXTERNAL',
                                                                                                                                                                           u'INTERNAL'],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': u'EXTERNAL',
                                                                                                                                                              u'description': u'This signifies what the forwarding rule will be used for. _LOAD_BALANCING_SCHEME_ must be one of:\n+\n*EXTERNAL*::: Used for HTTP or HTTPS for External Load Balancing.\n*INTERNAL*::: Used for Internal Network Load Balancing.\n+',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--load-balancing-scheme',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'LOAD_BALANCING_SCHEME'},
                                                                                                                                 u'--network': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'(Only for Internal Load Balancing) The network that this forwarding\nrule applies to. If this field is not specified, the default network\nwill be used. In the absence of the default network, this field must\nbe specified.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--network',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'NETWORK'},
                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"The region of the forwarding rule to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                               u'group': u'set-target.3',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--region',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'REGION'},
                                                                                                                                 u'--subnet': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'(Only for Internal Load Balancing) The subnetwork that this forwarding\nrule applies to. If the network configured for this forwarding rule is\nin auto subnet mode, the subnetwork is optional. However, if the\nnetwork is in custom subnet mode, a subnetwork must be specified.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--subnet',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'SUBNET'},
                                                                                                                                 u'--subnet-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The region of the subnetwork to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--subnet-region',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'SUBNET_REGION'},
                                                                                                                                 u'--target-http-proxy': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The target HTTP proxy that will receive the traffic.',
                                                                                                                                                          u'group': u'set-target.1',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--target-http-proxy',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'TARGET_HTTP_PROXY'},
                                                                                                                                 u'--target-https-proxy': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The target HTTPS proxy that will receive the traffic.',
                                                                                                                                                           u'group': u'set-target.1',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--target-https-proxy',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'TARGET_HTTPS_PROXY'},
                                                                                                                                 u'--target-instance': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u"The name of the target instance that will receive the traffic. The\ntarget instance must be in a zone that's in the forwarding rule's\nregion. Global forwarding rules may not direct traffic to target\ninstances.\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                        u'group': u'set-target.1',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--target-instance',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'TARGET_INSTANCE'},
                                                                                                                                 u'--target-instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The zone of the target instance to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--target-instance-zone',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'TARGET_INSTANCE_ZONE'},
                                                                                                                                 u'--target-pool': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The target pool that will receive the traffic. The target pool\nmust be in the same region as the forwarding rule. Global\nforwarding rules may not direct traffic to target pools.',
                                                                                                                                                    u'group': u'set-target.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--target-pool',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'TARGET_POOL'},
                                                                                                                                 u'--target-pool-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--target-pool-region',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'TARGET_POOL_REGION'},
                                                                                                                                 u'--target-ssl-proxy': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The target SSL proxy that will receive the traffic.',
                                                                                                                                                         u'group': u'set-target.1',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--target-ssl-proxy',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'TARGET_SSL_PROXY'},
                                                                                                                                 u'--target-vpn-gateway': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The target VPN gateway that will receive forwarded traffic.',
                                                                                                                                                           u'group': u'set-target.1',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--target-vpn-gateway',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'TARGET_VPN_GATEWAY'},
                                                                                                                                 u'--target-vpn-gateway-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The region of the VPN gateway to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--target-vpn-gateway-region',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'TARGET_VPN_GATEWAY_REGION'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {u'set-target.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                    u'is_required': True},
                                                                                                                                  u'set-target.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                    u'is_required': False},
                                                                                                                                  u'set-target.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                    u'is_required': False}},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'set-target',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'compute',
                                                                                                                                u'forwarding-rules',
                                                                                                                                u'set-target'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the forwarding rule.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u"*set-target* is used to set a new target for a forwarding\nrule.         Forwarding rules match and direct certain types of traffic to a load\nbalancer which is controlled by a target pool, a target instance,\nor a target HTTP proxy. Target pools and target instances perform load\nbalancing at the layer 3 of the OSI networking model\n(http://en.wikipedia.org/wiki/Network_layer). Target\nHTTP proxies perform load balancing at layer 7.\n\nForwarding rules can be either regional or global. They are\nregional if they point to a target pool or a target instance\nand global if they point to a target HTTP proxy.\n\nFor more information on load balancing, see\nhttps://cloud.google.com/compute/docs/load-balancing-and-autoscaling/.\n\n\nWhen creating a forwarding rule, exactly one of  ``--target-instance'',\n``--target-pool'', ``--target-http-proxy'', ``--target-https-proxy'',\n``--target-ssl-proxy'', or ``--target-vpn-gateway'' must be specified.\n"}}},
                                                                                        u'flags': {},
                                                                                        u'group': True,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'forwarding-rules',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'beta',
                                                                                                  u'compute',
                                                                                                  u'forwarding-rules'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'BETA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate forwarding rules to send traffic to load balancers.'}},
                                                                  u'groups': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine groups.',
                                                                              u'commands': {u'add-members': {u'capsule': u'*(BETA)* Add a user to a Google Compute Engine group.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--members': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The names or fully-qualified URLs of the users to add.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--members',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'USERNAME'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'add-members',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'compute',
                                                                                                                       u'groups',
                                                                                                                       u'add-members'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The names of the groups to add members to.',
                                                                                                                               u'name': u'names',
                                                                                                                               u'nargs': u'+',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* *add-members* adds a users to a Google Compute Engine group.',
                                                                                                                           u'EXAMPLES': u'To add a user to a group, run:\n\n  $ add-members example-group --members example-user\n\nTo add multiple users to multiple groups, run:\n\n  $ add-members example-group-1 example-group-2 --members example-user-1,example-user-2\n'}},
                                                                                            u'create': {u'capsule': u'*(BETA)* Create Google Compute Engine groups.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--description': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'An optional, textual description for the group being created.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--description',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'DESCRIPTION'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'create',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'compute',
                                                                                                                  u'groups',
                                                                                                                  u'create'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The name of the group to create.',
                                                                                                                          u'name': u'names',
                                                                                                                          u'nargs': u'+',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*create* creates Google Compute Engine groups.\n',
                                                                                                                      u'EXAMPLES': u'To create a group, run:\n\n  $ create example-group\n'}},
                                                                                            u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine groups.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'delete',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'compute',
                                                                                                                  u'groups',
                                                                                                                  u'delete'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The names of the groups to delete.',
                                                                                                                          u'name': u'names',
                                                                                                                          u'nargs': u'+',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine groups.\n',
                                                                                                                      u'EXAMPLES': u'To delete a group, run:\n\n  $ delete example-group\n\nTo delete multiple groups, run:\n\n  $ delete example-group-1 example-group-2\n'}},
                                                                                            u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine group.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'describe',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'groups',
                                                                                                                    u'describe'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the group to describe.',
                                                                                                                            u'name': u'name',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* *describe* displays all data associated with a Google Compute\nEngine group in a project.',
                                                                                                                        u'EXAMPLES': u'To describe a user, run:\n\n  $ describe example-user\n'}},
                                                                                            u'list': {u'capsule': u'*(BETA)* List Google Compute Engine groups.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--regexp': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--regexp',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'REGEXP'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'compute',
                                                                                                                u'groups',
                                                                                                                u'list'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': [],
                                                                                                                        u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                        u'name': u'names',
                                                                                                                        u'nargs': u'*',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'NAME'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine groups in a project.\n',
                                                                                                                    u'EXAMPLES': u'To list all groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all groups in a project, run:\n\n  $ list --uri\n'}},
                                                                                            u'remove-members': {u'capsule': u'*(BETA)* Remove a user from a Google Compute Engine group.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--members': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The names or fully-qualified URLs of the users to remove.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--members',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'USERNAME'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'remove-members',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'groups',
                                                                                                                          u'remove-members'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The names of the groups to remove members from.',
                                                                                                                                  u'name': u'names',
                                                                                                                                  u'nargs': u'+',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* *remove-members* removes a user from a Google Compute Engine group.',
                                                                                                                              u'EXAMPLES': u'To remove a user from a group, run:\n\n  $ remove-members example-group --members example-user\n\nTo remove multiple users from multiple groups with\none command, run\n\n  $ remove-members example-group-1 example-group-2 --members example-user-1,example-user-2\n'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'groups',
                                                                              u'path': [u'gcloud',
                                                                                        u'beta',
                                                                                        u'compute',
                                                                                        u'groups'],
                                                                              u'positionals': [],
                                                                              u'release': u'BETA',
                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine groups.'}},
                                                                  u'health-checks': {u'capsule': u'*(BETA)* Read and manipulate health checks for load balanced instances.',
                                                                                     u'commands': {u'create': {u'capsule': u'*(BETA)* Create health checks for load balanced instances.',
                                                                                                               u'commands': {u'http': {u'capsule': u'*(BETA)* Create a HTTP health check to monitor load balanced instances.',
                                                                                                                                       u'commands': {},
                                                                                                                                       u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': u'5s',
                                                                                                                                                                        u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--check-interval',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'CHECK_INTERVAL'},
                                                                                                                                                  u'--description': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'An optional, textual description for the HTTP health check.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--description',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                                                  u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': 2,
                                                                                                                                                                           u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--healthy-threshold',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'int',
                                                                                                                                                                           u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                  u'--host': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--host',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'HOST'},
                                                                                                                                                  u'--port': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': 80,
                                                                                                                                                              u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--port',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'int',
                                                                                                                                                              u'value': u'PORT'},
                                                                                                                                                  u'--port-name': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--port-name',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'PORT_NAME'},
                                                                                                                                                  u'--proxy-header': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [u'NONE',
                                                                                                                                                                                   u'PROXY_V1'],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': u'NONE',
                                                                                                                                                                      u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--proxy-header',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'PROXY_HEADER'},
                                                                                                                                                  u'--request-path': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': u'/',
                                                                                                                                                                      u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--request-path',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'REQUEST_PATH'},
                                                                                                                                                  u'--timeout': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': u'5s',
                                                                                                                                                                 u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--timeout',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'TIMEOUT'},
                                                                                                                                                  u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': 2,
                                                                                                                                                                             u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--unhealthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'int',
                                                                                                                                                                             u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                       u'group': False,
                                                                                                                                       u'groups': {},
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'http',
                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                 u'beta',
                                                                                                                                                 u'compute',
                                                                                                                                                 u'health-checks',
                                                                                                                                                 u'create',
                                                                                                                                                 u'http'],
                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name of the HTTP health check.',
                                                                                                                                                         u'name': u'name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                       u'release': u'BETA',
                                                                                                                                       u'sections': {u'DESCRIPTION': u'*http* is used to create a HTTP health check. HTTP health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                                             u'https': {u'capsule': u'*(BETA)* Create a HTTPS health check to monitor load balanced instances.',
                                                                                                                                        u'commands': {},
                                                                                                                                        u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': u'5s',
                                                                                                                                                                         u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--check-interval',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'CHECK_INTERVAL'},
                                                                                                                                                   u'--description': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'An optional, textual description for the HTTPS health check.',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--description',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                                                   u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': 2,
                                                                                                                                                                            u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--healthy-threshold',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'int',
                                                                                                                                                                            u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                   u'--host': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--host',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'HOST'},
                                                                                                                                                   u'--port': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': 80,
                                                                                                                                                               u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--port',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'int',
                                                                                                                                                               u'value': u'PORT'},
                                                                                                                                                   u'--port-name': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--port-name',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'PORT_NAME'},
                                                                                                                                                   u'--proxy-header': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [u'NONE',
                                                                                                                                                                                    u'PROXY_V1'],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': u'NONE',
                                                                                                                                                                       u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--proxy-header',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'PROXY_HEADER'},
                                                                                                                                                   u'--request-path': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': u'/',
                                                                                                                                                                       u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--request-path',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'REQUEST_PATH'},
                                                                                                                                                   u'--timeout': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': u'5s',
                                                                                                                                                                  u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--timeout',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'TIMEOUT'},
                                                                                                                                                   u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': 2,
                                                                                                                                                                              u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--unhealthy-threshold',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'int',
                                                                                                                                                                              u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                        u'group': False,
                                                                                                                                        u'groups': {},
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'https',
                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                  u'beta',
                                                                                                                                                  u'compute',
                                                                                                                                                  u'health-checks',
                                                                                                                                                  u'create',
                                                                                                                                                  u'https'],
                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The name of the HTTPS health check.',
                                                                                                                                                          u'name': u'name',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                        u'release': u'BETA',
                                                                                                                                        u'sections': {u'DESCRIPTION': u'*https* is used to create a HTTPS health check. HTTPS health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                                             u'ssl': {u'capsule': u'*(BETA)* Create a SSL health check to monitor load balanced instances.',
                                                                                                                                      u'commands': {},
                                                                                                                                      u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': u'5s',
                                                                                                                                                                       u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--check-interval',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'CHECK_INTERVAL'},
                                                                                                                                                 u'--description': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'An optional, textual description for the SSL health check.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--description',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                                 u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': 2,
                                                                                                                                                                          u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--healthy-threshold',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'int',
                                                                                                                                                                          u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                 u'--port': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': 80,
                                                                                                                                                             u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--port',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'int',
                                                                                                                                                             u'value': u'PORT'},
                                                                                                                                                 u'--port-name': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--port-name',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'PORT_NAME'},
                                                                                                                                                 u'--proxy-header': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [u'NONE',
                                                                                                                                                                                  u'PROXY_V1'],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': u'NONE',
                                                                                                                                                                     u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--proxy-header',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'PROXY_HEADER'},
                                                                                                                                                 u'--request': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--request',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'REQUEST'},
                                                                                                                                                 u'--response': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--response',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'RESPONSE'},
                                                                                                                                                 u'--timeout': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': u'5s',
                                                                                                                                                                u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--timeout',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'TIMEOUT'},
                                                                                                                                                 u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': 2,
                                                                                                                                                                            u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--unhealthy-threshold',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'int',
                                                                                                                                                                            u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                      u'group': False,
                                                                                                                                      u'groups': {},
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'ssl',
                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                u'beta',
                                                                                                                                                u'compute',
                                                                                                                                                u'health-checks',
                                                                                                                                                u'create',
                                                                                                                                                u'ssl'],
                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The name of the SSL health check.',
                                                                                                                                                        u'name': u'name',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                      u'release': u'BETA',
                                                                                                                                      u'sections': {u'DESCRIPTION': u'*ssl* is used to create a SSL health check. SSL health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                                             u'tcp': {u'capsule': u'*(BETA)* Create a TCP health check to monitor load balanced instances.',
                                                                                                                                      u'commands': {},
                                                                                                                                      u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': u'5s',
                                                                                                                                                                       u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--check-interval',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'CHECK_INTERVAL'},
                                                                                                                                                 u'--description': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'An optional, textual description for the TCP health check.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--description',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                                 u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': 2,
                                                                                                                                                                          u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--healthy-threshold',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'int',
                                                                                                                                                                          u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                 u'--port': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': 80,
                                                                                                                                                             u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--port',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'int',
                                                                                                                                                             u'value': u'PORT'},
                                                                                                                                                 u'--port-name': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--port-name',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'PORT_NAME'},
                                                                                                                                                 u'--proxy-header': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [u'NONE',
                                                                                                                                                                                  u'PROXY_V1'],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': u'NONE',
                                                                                                                                                                     u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--proxy-header',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'PROXY_HEADER'},
                                                                                                                                                 u'--request': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--request',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'REQUEST'},
                                                                                                                                                 u'--response': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--response',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'RESPONSE'},
                                                                                                                                                 u'--timeout': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': u'5s',
                                                                                                                                                                u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--timeout',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'TIMEOUT'},
                                                                                                                                                 u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': 2,
                                                                                                                                                                            u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--unhealthy-threshold',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'int',
                                                                                                                                                                            u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                      u'group': False,
                                                                                                                                      u'groups': {},
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'tcp',
                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                u'beta',
                                                                                                                                                u'compute',
                                                                                                                                                u'health-checks',
                                                                                                                                                u'create',
                                                                                                                                                u'tcp'],
                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The name of the TCP health check.',
                                                                                                                                                        u'name': u'name',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                      u'release': u'BETA',
                                                                                                                                      u'sections': {u'DESCRIPTION': u'*tcp* is used to create a TCP health check. TCP health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}}},
                                                                                                               u'flags': {},
                                                                                                               u'group': True,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'create',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'compute',
                                                                                                                         u'health-checks',
                                                                                                                         u'create'],
                                                                                                               u'positionals': [],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Create health checks for load balanced instances.'}},
                                                                                                   u'delete': {u'capsule': u'*(BETA)* Delete health checks.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'delete',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'compute',
                                                                                                                         u'health-checks',
                                                                                                                         u'delete'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The resources to delete.',
                                                                                                                                 u'name': u'names',
                                                                                                                                 u'nargs': u'+',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nhealth checks.\n'}},
                                                                                                   u'describe': {u'capsule': u'*(BETA)* Display detailed information about a health check.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'describe',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'compute',
                                                                                                                           u'health-checks',
                                                                                                                           u'describe'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the resource to fetch.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine health check in a project.\n'}},
                                                                                                   u'list': {u'capsule': u'*(BETA)* List Google Compute Engine health checks.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--limit',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_URI'},
                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--page-size',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                        u'--protocol': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'If protocol is specified, only health checks for that protocol are\nlisted, and protocol-specific columns are added to the output. By\ndefault, health checks for all protocols are listed.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--protocol',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'PROTOCOL'},
                                                                                                                        u'--regexp': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--regexp',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REGEXP'},
                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'FIELD'},
                                                                                                                        u'--uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'URI'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'list',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'compute',
                                                                                                                       u'health-checks',
                                                                                                                       u'list'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': [],
                                                                                                                               u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                               u'name': u'names',
                                                                                                                               u'nargs': u'*',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine health checks in a project.\n',
                                                                                                                           u'EXAMPLES': u'To list all health checks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all health checks in a project, run:\n\n  $ list --uri\n'}},
                                                                                                   u'update': {u'capsule': u'*(BETA)* Update health checks for load balanced instances.',
                                                                                                               u'commands': {u'http': {u'capsule': u'*(BETA)* Update a HTTP health check.',
                                                                                                                                       u'commands': {},
                                                                                                                                       u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--check-interval',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'CHECK_INTERVAL'},
                                                                                                                                                  u'--description': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'A textual description for the HTTP health check. Pass in an empty string to unset.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--description',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                                                  u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--healthy-threshold',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'string',
                                                                                                                                                                           u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                  u'--host': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--host',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'HOST'},
                                                                                                                                                  u'--port': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--port',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'PORT'},
                                                                                                                                                  u'--port-name': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--port-name',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'PORT_NAME'},
                                                                                                                                                  u'--proxy-header': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [u'NONE',
                                                                                                                                                                                   u'PROXY_V1'],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--proxy-header',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'PROXY_HEADER'},
                                                                                                                                                  u'--request-path': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--request-path',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'REQUEST_PATH'},
                                                                                                                                                  u'--timeout': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--timeout',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'TIMEOUT'},
                                                                                                                                                  u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--unhealthy-threshold',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                       u'group': False,
                                                                                                                                       u'groups': {},
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'http',
                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                 u'beta',
                                                                                                                                                 u'compute',
                                                                                                                                                 u'health-checks',
                                                                                                                                                 u'update',
                                                                                                                                                 u'http'],
                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name of the HTTP health check.',
                                                                                                                                                         u'name': u'name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                       u'release': u'BETA',
                                                                                                                                       u'sections': {u'DESCRIPTION': u'*http* is used to update an existing HTTP health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                                             u'https': {u'capsule': u'*(BETA)* Update a HTTPS health check.',
                                                                                                                                        u'commands': {},
                                                                                                                                        u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--check-interval',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'CHECK_INTERVAL'},
                                                                                                                                                   u'--description': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'A textual description for the HTTPS health check. Pass in an empty string to unset.',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--description',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                                                   u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--healthy-threshold',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                   u'--host': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--host',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'HOST'},
                                                                                                                                                   u'--port': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--port',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'PORT'},
                                                                                                                                                   u'--port-name': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--port-name',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'PORT_NAME'},
                                                                                                                                                   u'--proxy-header': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [u'NONE',
                                                                                                                                                                                    u'PROXY_V1'],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--proxy-header',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'PROXY_HEADER'},
                                                                                                                                                   u'--request-path': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--request-path',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'REQUEST_PATH'},
                                                                                                                                                   u'--timeout': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--timeout',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'TIMEOUT'},
                                                                                                                                                   u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--unhealthy-threshold',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                        u'group': False,
                                                                                                                                        u'groups': {},
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'https',
                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                  u'beta',
                                                                                                                                                  u'compute',
                                                                                                                                                  u'health-checks',
                                                                                                                                                  u'update',
                                                                                                                                                  u'https'],
                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The name of the HTTPS health check.',
                                                                                                                                                          u'name': u'name',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                        u'release': u'BETA',
                                                                                                                                        u'sections': {u'DESCRIPTION': u'*https* is used to update an existing HTTPS health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                                             u'ssl': {u'capsule': u'*(BETA)* Update a SSL health check.',
                                                                                                                                      u'commands': {},
                                                                                                                                      u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--check-interval',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'CHECK_INTERVAL'},
                                                                                                                                                 u'--description': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'A textual description for the SSL health check. Pass in an empty string to unset.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--description',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                                 u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--healthy-threshold',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                 u'--port': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--port',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'PORT'},
                                                                                                                                                 u'--port-name': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--port-name',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'PORT_NAME'},
                                                                                                                                                 u'--proxy-header': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [u'NONE',
                                                                                                                                                                                  u'PROXY_V1'],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--proxy-header',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'PROXY_HEADER'},
                                                                                                                                                 u'--request': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.\n+\nSetting this to an empty string will clear any existing request value.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--request',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'REQUEST'},
                                                                                                                                                 u'--response': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.\n      Setting this to an empty string will clear any existing\nresponse value.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--response',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'RESPONSE'},
                                                                                                                                                 u'--timeout': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--timeout',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'TIMEOUT'},
                                                                                                                                                 u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--unhealthy-threshold',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                      u'group': False,
                                                                                                                                      u'groups': {},
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'ssl',
                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                u'beta',
                                                                                                                                                u'compute',
                                                                                                                                                u'health-checks',
                                                                                                                                                u'update',
                                                                                                                                                u'ssl'],
                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The name of the SSL health check.',
                                                                                                                                                        u'name': u'name',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                      u'release': u'BETA',
                                                                                                                                      u'sections': {u'DESCRIPTION': u'*ssl* is used to update an existing SSL health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                                             u'tcp': {u'capsule': u'*(BETA)* Update a TCP health check.',
                                                                                                                                      u'commands': {},
                                                                                                                                      u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--check-interval',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'CHECK_INTERVAL'},
                                                                                                                                                 u'--description': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'A textual description for the TCP health check. Pass in an empty string to unset.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--description',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                                 u'--healthy-threshold': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--healthy-threshold',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                                 u'--port': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--port',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'PORT'},
                                                                                                                                                 u'--port-name': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--port-name',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'PORT_NAME'},
                                                                                                                                                 u'--proxy-header': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [u'NONE',
                                                                                                                                                                                  u'PROXY_V1'],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--proxy-header',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'PROXY_HEADER'},
                                                                                                                                                 u'--request': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.\n+\nSetting this to an empty string will clear any existing request value.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--request',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'REQUEST'},
                                                                                                                                                 u'--response': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.\n      Setting this to an empty string will clear any existing\nresponse value.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--response',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'RESPONSE'},
                                                                                                                                                 u'--timeout': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--timeout',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'TIMEOUT'},
                                                                                                                                                 u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--unhealthy-threshold',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                                      u'group': False,
                                                                                                                                      u'groups': {},
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'tcp',
                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                u'beta',
                                                                                                                                                u'compute',
                                                                                                                                                u'health-checks',
                                                                                                                                                u'update',
                                                                                                                                                u'tcp'],
                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The name of the TCP health check.',
                                                                                                                                                        u'name': u'name',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                      u'release': u'BETA',
                                                                                                                                      u'sections': {u'DESCRIPTION': u'*tcp* is used to update an existing TCP health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}}},
                                                                                                               u'flags': {},
                                                                                                               u'group': True,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'update',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'compute',
                                                                                                                         u'health-checks',
                                                                                                                         u'update'],
                                                                                                               u'positionals': [],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Update health checks for load balanced instances.'}}},
                                                                                     u'flags': {},
                                                                                     u'group': True,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'health-checks',
                                                                                     u'path': [u'gcloud',
                                                                                               u'beta',
                                                                                               u'compute',
                                                                                               u'health-checks'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'BETA',
                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate health checks for load balanced instances.'}},
                                                                  u'http-health-checks': {u'capsule': u'*(BETA)* Read and manipulate HTTP health checks for load balanced instances.',
                                                                                          u'commands': {u'create': {u'capsule': u'*(BETA)* Create an HTTP health check to monitor load balanced instances.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': u'5s',
                                                                                                                                                     u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--check-interval',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'CHECK_INTERVAL'},
                                                                                                                               u'--description': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'An optional, textual description for the HTTP health check.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--description',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'DESCRIPTION'},
                                                                                                                               u'--healthy-threshold': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': 2,
                                                                                                                                                        u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--healthy-threshold',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'int',
                                                                                                                                                        u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                               u'--host': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--host',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'HOST'},
                                                                                                                               u'--port': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': 80,
                                                                                                                                           u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--port',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'int',
                                                                                                                                           u'value': u'PORT'},
                                                                                                                               u'--request-path': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': u'/',
                                                                                                                                                   u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--request-path',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'REQUEST_PATH'},
                                                                                                                               u'--timeout': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': u'5s',
                                                                                                                                              u'description': u"If Google Compute Engine doesn't receive an HTTP 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--timeout',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'TIMEOUT'},
                                                                                                                               u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': 2,
                                                                                                                                                          u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--unhealthy-threshold',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'int',
                                                                                                                                                          u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'create',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'http-health-checks',
                                                                                                                              u'create'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the HTTP health check.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*create* is used to create an HTTP health check. HTTP health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                        u'delete': {u'capsule': u'*(BETA)* Delete HTTP health checks.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'delete',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'http-health-checks',
                                                                                                                              u'delete'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The resources to delete.',
                                                                                                                                      u'name': u'names',
                                                                                                                                      u'nargs': u'+',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nHTTP health checks.\n'}},
                                                                                                        u'describe': {u'capsule': u'*(BETA)* Display detailed information about an HTTP health check.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'describe',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'compute',
                                                                                                                                u'http-health-checks',
                                                                                                                                u'describe'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the resource to fetch.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine HTTP health check in a project.\n'}},
                                                                                                        u'list': {u'capsule': u'*(BETA)* List Google Compute Engine health checks.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--filter',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'EXPRESSION'},
                                                                                                                             u'--limit': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--limit',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'LIMIT'},
                                                                                                                             u'--no-uri': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-uri',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_URI'},
                                                                                                                             u'--page-size': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--page-size',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                                                             u'--regexp': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--regexp',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGEXP'},
                                                                                                                             u'--sort-by': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--sort-by',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'FIELD'},
                                                                                                                             u'--uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'URI'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'list',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'http-health-checks',
                                                                                                                            u'list'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': [],
                                                                                                                                    u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                    u'name': u'names',
                                                                                                                                    u'nargs': u'*',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine health checks in a project.\n',
                                                                                                                                u'EXAMPLES': u'To list all health checks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all health checks in a project, run:\n\n  $ list --uri\n'}},
                                                                                                        u'update': {u'capsule': u'*(BETA)* Update an HTTP health check.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--check-interval',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'CHECK_INTERVAL'},
                                                                                                                               u'--description': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'A textual description for the HTTP health check. Pass in an empty string to unset.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--description',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'DESCRIPTION'},
                                                                                                                               u'--healthy-threshold': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--healthy-threshold',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                               u'--host': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--host',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'HOST'},
                                                                                                                               u'--port': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--port',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'PORT'},
                                                                                                                               u'--request-path': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--request-path',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'REQUEST_PATH'},
                                                                                                                               u'--timeout': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"If Google Compute Engine doesn't receive an HTTP 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--timeout',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'TIMEOUT'},
                                                                                                                               u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--unhealthy-threshold',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'update',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'http-health-checks',
                                                                                                                              u'update'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the HTTP health check.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*update* is used to update an existing HTTP health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}}},
                                                                                          u'flags': {},
                                                                                          u'group': True,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'http-health-checks',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'beta',
                                                                                                    u'compute',
                                                                                                    u'http-health-checks'],
                                                                                          u'positionals': [],
                                                                                          u'release': u'BETA',
                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate HTTP health checks for load balanced instances.'}},
                                                                  u'https-health-checks': {u'capsule': u'*(BETA)* Read and manipulate HTTPS health checks for load balanced instances.',
                                                                                           u'commands': {u'create': {u'capsule': u'*(BETA)* Create an HTTPS health check to monitor load balanced instances.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': u'5s',
                                                                                                                                                      u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--check-interval',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'CHECK_INTERVAL'},
                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'An optional, textual description for the HTTPS health check.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--healthy-threshold': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': 2,
                                                                                                                                                         u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--healthy-threshold',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'int',
                                                                                                                                                         u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                u'--host': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The value of the host header used in this HTTPS health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--host',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'HOST'},
                                                                                                                                u'--port': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': 443,
                                                                                                                                            u'description': u'The TCP port number that this health check monitors. The default value\nis 443.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--port',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'int',
                                                                                                                                            u'value': u'PORT'},
                                                                                                                                u'--request-path': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': u'/',
                                                                                                                                                    u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--request-path',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'REQUEST_PATH'},
                                                                                                                                u'--timeout': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': u'5s',
                                                                                                                                               u'description': u"If Google Compute Engine doesn't receive an HTTPS 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--timeout',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'TIMEOUT'},
                                                                                                                                u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': 2,
                                                                                                                                                           u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--unhealthy-threshold',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'int',
                                                                                                                                                           u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'create',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'https-health-checks',
                                                                                                                               u'create'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the HTTPS health check.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*create* is used to create an HTTPS health check. HTTPS health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                         u'delete': {u'capsule': u'*(BETA)* Delete HTTPS health checks.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'delete',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'https-health-checks',
                                                                                                                               u'delete'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The resources to delete.',
                                                                                                                                       u'name': u'names',
                                                                                                                                       u'nargs': u'+',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nHTTPS health checks.\n'}},
                                                                                                         u'describe': {u'capsule': u'*(BETA)* Display detailed information about an HTTPS health check.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'describe',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'beta',
                                                                                                                                 u'compute',
                                                                                                                                 u'https-health-checks',
                                                                                                                                 u'describe'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the resource to fetch.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'BETA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine HTTPS health check in a project.\n'}},
                                                                                                         u'list': {u'capsule': u'*(BETA)* List Google Compute Engine HTTPS health checks.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--filter',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--limit',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--page-size',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                              u'--regexp': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--regexp',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGEXP'},
                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'FIELD'},
                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'URI'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'list',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'beta',
                                                                                                                             u'compute',
                                                                                                                             u'https-health-checks',
                                                                                                                             u'list'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                     u'name': u'names',
                                                                                                                                     u'nargs': u'*',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'BETA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine HTTPS health checks in a project.\n',
                                                                                                                                 u'EXAMPLES': u'To list all HTTPS health checks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all HTTPS health checks in a project, run:\n\n  $ list --uri\n'}},
                                                                                                         u'update': {u'capsule': u'*(BETA)* Update an HTTPS health check.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--check-interval',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'CHECK_INTERVAL'},
                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'A textual description for the HTTPS health check. Pass in an empty string to unset.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--healthy-threshold': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--healthy-threshold',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                                u'--host': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The value of the host header used in this HTTPS health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--host',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'HOST'},
                                                                                                                                u'--port': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--port',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PORT'},
                                                                                                                                u'--request-path': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--request-path',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'REQUEST_PATH'},
                                                                                                                                u'--timeout': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"If Google Compute Engine doesn't receive an HTTPS 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--timeout',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'TIMEOUT'},
                                                                                                                                u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--unhealthy-threshold',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'update',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'https-health-checks',
                                                                                                                               u'update'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the HTTPS health check.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*update* is used to update an existing HTTPS health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}}},
                                                                                           u'flags': {},
                                                                                           u'group': True,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'https-health-checks',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'beta',
                                                                                                     u'compute',
                                                                                                     u'https-health-checks'],
                                                                                           u'positionals': [],
                                                                                           u'release': u'BETA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate HTTPS health checks for load balanced instances.'}},
                                                                  u'images': {u'capsule': u'*(BETA)* List, create, and delete Google Compute Engine images.',
                                                                              u'commands': {u'create': {u'capsule': u'*(BETA)* Create Google Compute Engine images.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine images to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--csek-key-file',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'FILE'},
                                                                                                                   u'--description': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'An optional, textual description for the image being created.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--description',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                   u'--family': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The family of the image. When creating an instance or disk, specifying a family will cause the latest non-deprecated image in the family to be used.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--family',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'FAMILY'},
                                                                                                                   u'--guest-os-features': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'One or more features supported by the OS in the image. _GUEST_OS_FEATURE_ must be one of: *MULTI_IP_SUBNET*, *VIRTIO_SCSI_MULTIQUEUE*, *WINDOWS*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--guest-os-features',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'GUEST_OS_FEATURE'},
                                                                                                                   u'--licenses': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Comma-separated list of URIs to license resources.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--licenses',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'LICENSES'},
                                                                                                                   u'--no-require-csek-key-create': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': True,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-require-csek-key-create',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                   u'--require-csek-key-create': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': True,
                                                                                                                                                  u'description': u'Refuse to create images not protected by a user managed key in\nthe key file when --csek-key-file is given. This behavior is enabled\nby default to prevent incorrect gcloud invocations from accidentally\ncreating images with no user managed key. Disabling the check\nallows creation of some images without a matching\nCustomer-Supplied Encryption Key in the supplied --csek-key-file.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details. Enabled by default, use *--no-require-csek-key-create* to disable.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--require-csek-key-create',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                   u'--source-disk': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"A source disk to create the image from. The value for this option can be\nthe name of a disk with the zone specified via ``--source-disk-zone''\nflag.\n+\nThis flag is mutually exclusive with ``--source-uri''.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--source-disk',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'SOURCE_DISK'},
                                                                                                                   u'--source-disk-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The zone of the source disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--source-disk-zone',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'SOURCE_DISK_ZONE'},
                                                                                                                   u'--source-uri': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"The full Google Cloud Storage URI where the disk image is stored.\nThis file must be a gzip-compressed tarball whose name ends in\n``.tar.gz''.\n+\nThis flag is mutually exclusive with ``--source-disk''.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--source-uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'SOURCE_URI'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'create',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'compute',
                                                                                                                  u'images',
                                                                                                                  u'create'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The name of the disk image.',
                                                                                                                          u'name': u'name',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*create* is used to create custom disk images.\nThe resulting image can be provided during instance or disk creation\nso that the instance attached to the resulting disks has access\nto a known set of software or files from the image.\n\nImages can be created from gzipped compressed tarball containing raw\ndisk data or from existing disks in any zone.\n\nImages are global resources, so they can be used across zones and\nprojects.\n\nTo learn more about creating image tarballs, visit\n[](https://cloud.google.com/compute/docs/creating-custom-image)\n'}},
                                                                                            u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine images.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'delete',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'compute',
                                                                                                                  u'images',
                                                                                                                  u'delete'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The resources to delete.',
                                                                                                                          u'name': u'names',
                                                                                                                          u'nargs': u'+',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine images.\n'}},
                                                                                            u'deprecate': {u'capsule': u'*(BETA)* Manage deprecation status of Google Compute Engine images.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--delete-in': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"Specifies the amount of time until the image will be marked as DELETED.\nNote: The image will not actually be deleted - this field is only for\ninformational purposes (see below). For instance, specifying ``30d'' will\nmark as DELETED in 30 days from the current system time. Valid units for\nthis flag are ``s'' for seconds, ``m'' for minutes, ``h'' for hours and\n``d'' for days. If no unit is specified, seconds is assumed.\n+\nNote that the image will not be deleted automatically. The image will\nonly be marked as deleted. An explicit request to delete the image must\nbe made in order to remove it from the image list.\nThis flag is mutually exclusive with *--delete-on*.",
                                                                                                                                       u'group': u'deprecate.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--delete-in',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DELETE_IN'},
                                                                                                                      u'--delete-on': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"Similar to *--delete-in*, but specifies an absolute time when the image\nwill be marked as DELETED. Note: The image will not actually be\ndeleted - this field is for informational purposes (see the description\nof --delete-in for more details). The date and time specified must be\nvalid RFC 3339 full-date or date-time. For times in UTC, this looks\nlike ``YYYY-MM-DDTHH:MM:SSZ''. For example: 2020-01-02T00:00:00Z for\nmidnight on January 2, 2020 in UTC.\nThis flag is mutually exclusive with *--delete-in*.",
                                                                                                                                       u'group': u'deprecate.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--delete-on',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DELETE_ON'},
                                                                                                                      u'--obsolete-in': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Specifies time (in the same format as *--delete-in*) until the image\nwill be marked OBSOLETE. State will not be changed - it is only for\ninformational purposes.\nThis flag is mutually exclusive with *--obsolete-on*.',
                                                                                                                                         u'group': u'deprecate.2',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--obsolete-in',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'OBSOLETE_IN'},
                                                                                                                      u'--obsolete-on': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Specifies time (in the same format as *--delete-on*) when this image will\nbe marked as OBSOLETE. State will not be changed - it has only\ninformational purpose.\nThis flag is mutually exclusive with *--obsolete-in*.',
                                                                                                                                         u'group': u'deprecate.2',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--obsolete-on',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'OBSOLETE_ON'},
                                                                                                                      u'--replacement': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Specifies a Compute Engine image as a replacement for the image\nbeing phased out. Users of the deprecated image will be advised to switch\nto this replacement. For example, *--replacement example-image* or\n*--replacement projects/google/global/images/example-image*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--replacement',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REPLACEMENT'},
                                                                                                                      u'--state': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [u'ACTIVE',
                                                                                                                                                u'DELETED',
                                                                                                                                                u'DEPRECATED',
                                                                                                                                                u'OBSOLETE'],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': u'ACTIVE',
                                                                                                                                   u'description': u'The deprecation state to set on the image. _STATE_ must be one of:\n+\n*ACTIVE*::: The image is currently supported.\n*DELETED*::: New uses result in an error. Setting this state will not automatically delete the image. You must still make a request to delete the image to remove it from the image list.\n*DEPRECATED*::: Operations which create a new *DEPRECATED* resource return successfully, but with a warning indicating that the image is deprecated and recommending its replacement.\n*OBSOLETE*::: New uses result in an error.\n+',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--state',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'STATE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {u'deprecate.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                        u'is_mutex': True,
                                                                                                                                        u'is_required': False},
                                                                                                                       u'deprecate.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                        u'is_mutex': True,
                                                                                                                                        u'is_required': False}},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'deprecate',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'compute',
                                                                                                                     u'images',
                                                                                                                     u'deprecate'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the disk image.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* *deprecate* is used to deprecate images.',
                                                                                                                         u'EXAMPLES': u"To deprecate an image called 'IMAGE' immediately, mark it as\nobsolete in one day, and mark it as deleted in two days, use:\n\n  $ deprecate IMAGE --state DEPRECATED --obsolete-in 1d --delete-in 2d\n\nTo un-deprecate an image called 'IMAGE', use:\n\n  $ deprecate IMAGE --state ACTIVE\n"}},
                                                                                            u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine image.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'describe',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'images',
                                                                                                                    u'describe'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the resource to fetch.',
                                                                                                                            u'name': u'name',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine image in a project.\n'}},
                                                                                            u'describe-from-family': {u'capsule': u'*(BETA)* Describe the latest image from an image family.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'describe-from-family',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'compute',
                                                                                                                                u'images',
                                                                                                                                u'describe-from-family'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the resource to fetch.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* *describe-from-family* looks up the latest image from an image family and runs a describe\non it.'}},
                                                                                            u'list': {u'capsule': u'*(BETA)* List Google Compute Engine images.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-preview-images': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-preview-images',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_PREVIEW_IMAGES'},
                                                                                                                 u'--no-show-deprecated': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-show-deprecated',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_SHOW_DEPRECATED'},
                                                                                                                 u'--no-show-preview-images': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': True,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-show-preview-images',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_SHOW_PREVIEW_IMAGES'},
                                                                                                                 u'--no-standard-images': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-standard-images',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_STANDARD_IMAGES'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--preview-images': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Show images that are in limited preview. The preview image projects\nare: (none)',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--preview-images',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'PREVIEW_IMAGES'},
                                                                                                                 u'--regexp': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--regexp',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'REGEXP'},
                                                                                                                 u'--show-deprecated': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'If provided, deprecated images are shown.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--show-deprecated',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'SHOW_DEPRECATED'},
                                                                                                                 u'--show-preview-images': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--show-preview-images',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'SHOW_PREVIEW_IMAGES'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--standard-images': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'Show images from well-known image projects.  The well known image\nprojects are: centos-cloud, coreos-cloud, debian-cloud, cos-cloud, rhel-cloud, suse-cloud, ubuntu-os-cloud, windows-cloud, windows-sql-cloud. Enabled by default, use *--no-standard-images* to disable.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--standard-images',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'STANDARD_IMAGES'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'compute',
                                                                                                                u'images',
                                                                                                                u'list'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': [],
                                                                                                                        u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                        u'name': u'names',
                                                                                                                        u'nargs': u'*',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'NAME'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine images in a project.\n',
                                                                                                                    u'EXAMPLES': u'To list all images in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all images in a project, run:\n\n  $ list --uri\n'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'images',
                                                                              u'path': [u'gcloud',
                                                                                        u'beta',
                                                                                        u'compute',
                                                                                        u'images'],
                                                                              u'positionals': [],
                                                                              u'release': u'BETA',
                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* List, create, and delete Google Compute Engine images.'}},
                                                                  u'instance-groups': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine instance groups.',
                                                                                       u'commands': {u'describe': {u'capsule': u'*(BETA)* Display detailed information about an instance group.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                            u'group': u'describe.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'},
                                                                                                                              u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The zone of the resource to fetch. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                          u'group': u'describe.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--zone',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'ZONE'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                               u'is_mutex': True,
                                                                                                                                               u'is_required': False}},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'describe',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'beta',
                                                                                                                             u'compute',
                                                                                                                             u'instance-groups',
                                                                                                                             u'describe'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the resource to fetch.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'BETA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with an instance group in a project.\n',
                                                                                                                                 u'EXAMPLES': u"\nTo get details about a regional instance group in the ``us-central1'' regions,\nrun:\n\n  $ describe --region us-central1\n\nTo get details about a zonal instance group in the ``us-central1-b'' zone, run:\n\n  $ describe --zone us-central1-b\n"}},
                                                                                                     u'get-named-ports': {u'capsule': u'*(BETA)* Lists the named ports for an instance group resource.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--filter',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--limit',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': True,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--page-size',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                   u'group': u'get-named-ports.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--region',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'REGION'},
                                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'list',
                                                                                                                                                    u'value': u'FIELD'},
                                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--uri',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'URI'},
                                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                 u'group': u'get-named-ports.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--zone',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'ZONE'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {u'get-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                             u'is_required': False}},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'get-named-ports',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'beta',
                                                                                                                                    u'compute',
                                                                                                                                    u'instance-groups',
                                                                                                                                    u'get-named-ports'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the instance group.',
                                                                                                                                            u'name': u'name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'NAME'}],
                                                                                                                          u'release': u'BETA',
                                                                                                                          u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which indicates that the service\nis available on all instances in the group. This information is used\nby the HTTP Load Balancing service.\n\n*get-named-ports* lists the named ports (name and port tuples)\nfor an instance group.\n",
                                                                                                                                        u'EXAMPLES': u"For example, to list named ports for an instance group:\n\n  $ get-named-ports example-instance-group --zone us-central1-a\n\nThe above example lists named ports assigned to an instance\ngroup named 'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                     u'list': {u'capsule': u'*(BETA)* List Google Compute Engine instance groups.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--filter',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'EXPRESSION'},
                                                                                                                          u'--limit': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--limit',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'LIMIT'},
                                                                                                                          u'--no-uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_URI'},
                                                                                                                          u'--page-size': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--page-size',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                                                          u'--regexp': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--regexp',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REGEXP'},
                                                                                                                          u'--regions': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                         u'group': u'list.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--regions',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'REGION'},
                                                                                                                          u'--sort-by': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--sort-by',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'FIELD'},
                                                                                                                          u'--uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'URI'},
                                                                                                                          u'--zones': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'If provided, only zonal resources are shown. If arguments are provided, only resources from the given zones are shown.',
                                                                                                                                       u'group': u'list.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--zones',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'ZONE'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                       u'is_mutex': True,
                                                                                                                                       u'is_required': False}},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'list',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'compute',
                                                                                                                         u'instance-groups',
                                                                                                                         u'list'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': [],
                                                                                                                                 u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                 u'name': u'names',
                                                                                                                                 u'nargs': u'*',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine instance groups in a project.\n\nBy default, instance groups from all regions and instance groups from all zones are listed. The results can be narrowed down by\nproviding the ``--regions'' or ``--zones'' flag.\n",
                                                                                                                             u'EXAMPLES': u"To list all instance groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all instance groups in a project, run:\n\n  $ list --uri\n\nTo list all instance groups in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n\nTo list all instance groups in zones ``us-central1-b'' and ``europe-west1-d'',\nrun:\n\n  $ list --zones us-central1,europe-west1\n"}},
                                                                                                     u'list-instances': {u'capsule': u'*(BETA)* List instances present in the instance group.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--filter',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--limit',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': True,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--page-size',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                                    u'--regexp': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--regexp',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'REGEXP'},
                                                                                                                                    u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                  u'group': u'list-instances.1',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--region',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'REGION'},
                                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'list',
                                                                                                                                                   u'value': u'FIELD'},
                                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--uri',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'URI'},
                                                                                                                                    u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                u'group': u'list-instances.1',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--zone',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'ZONE'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {u'list-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                           u'is_mutex': True,
                                                                                                                                                           u'is_required': False}},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'list-instances',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'beta',
                                                                                                                                   u'compute',
                                                                                                                                   u'instance-groups',
                                                                                                                                   u'list-instances'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The name of the instance group.',
                                                                                                                                           u'name': u'name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'NAME'}],
                                                                                                                         u'release': u'BETA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*list-instances* list instances in an instance group.\n'}},
                                                                                                     u'managed': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine managed instance groups.',
                                                                                                                  u'commands': {u'abandon-instances': {u'capsule': u'*(BETA)* Abandon instances owned by a managed instance group.',
                                                                                                                                                       u'commands': {},
                                                                                                                                                       u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                                                   u'category': u'',
                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                   u'description': u'Names of instances to abandon.',
                                                                                                                                                                                   u'group': u'',
                                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                                   u'name': u'--instances',
                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                   u'required': True,
                                                                                                                                                                                   u'type': u'list',
                                                                                                                                                                                   u'value': u'INSTANCE'},
                                                                                                                                                                  u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                u'group': u'abandon-instances.1',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--region',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'REGION'},
                                                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                              u'group': u'abandon-instances.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--zone',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                                                       u'group': False,
                                                                                                                                                       u'groups': {u'abandon-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                                                            u'is_required': False}},
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'abandon-instances',
                                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                                 u'beta',
                                                                                                                                                                 u'compute',
                                                                                                                                                                 u'instance-groups',
                                                                                                                                                                 u'managed',
                                                                                                                                                                 u'abandon-instances'],
                                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the managed instance group.',
                                                                                                                                                                         u'name': u'name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                                       u'release': u'BETA',
                                                                                                                                                       u'sections': {u'DESCRIPTION': u'\n        *abandon-instances* abandons one or more instances from a managed instance\ngroup, thereby reducing the targetSize of the group. Once instances have been\nabandoned, the currentSize of the group is automatically reduced as well to\nreflect the change.\n\nAbandoning an instance does not delete the underlying virtual machine instances,\nbut just removes the instances from the instance group. If you would like the\ndelete the underlying instances, use the delete-instances command instead.\n'}},
                                                                                                                                u'create': {u'capsule': u'*(BETA)* Create a Compute Engine managed instance group.',
                                                                                                                                            u'commands': {},
                                                                                                                                            u'flags': {u'--base-instance-name': {u'attr': {},
                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'The base name to use for the Compute Engine instances that will be created with the managed instance group. If not provided base instance name will be the prefix of instance group name.',
                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--base-instance-name',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'BASE_INSTANCE_NAME'},
                                                                                                                                                       u'--description': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'An optional description for this group.',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--description',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                                                                       u'--http-health-check': {u'attr': {},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'Specifies the HTTP health check object used for autohealing instances in this group.',
                                                                                                                                                                                u'group': u'create.1',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--http-health-check',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                                                       u'--https-health-check': {u'attr': {},
                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'Specifies the HTTPS health check object used for autohealing instances in this group.',
                                                                                                                                                                                 u'group': u'create.1',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--https-health-check',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'HTTPS_HEALTH_CHECK'},
                                                                                                                                                       u'--initial-delay': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u"Specifies the length of the period during which the instance is known to\nbe initializing and should not be autohealed even if unhealthy.\nValid units for this flag are ``s'' for seconds, ``m'' for minutes and\n``h'' for hours. If no unit is specified, seconds is assumed. This value\ncannot be greater than 1 hour.",
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--initial-delay',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'INITIAL_DELAY'},
                                                                                                                                                       u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                     u'group': u'create.2',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--region',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'REGION'},
                                                                                                                                                       u'--size': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The initial number of instances you want in this group.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--size',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': True,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'SIZE'},
                                                                                                                                                       u'--target-pool': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'Specifies any target pools you want the instances of this managed instance group to be part of.',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--target-pool',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'list',
                                                                                                                                                                          u'value': u'TARGET_POOL'},
                                                                                                                                                       u'--template': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'Specifies the instance template to use when creating new instances.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--template',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': True,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'TEMPLATE'},
                                                                                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                   u'group': u'create.2',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--zone',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'ZONE'}},
                                                                                                                                            u'group': False,
                                                                                                                                            u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                      u'is_mutex': True,
                                                                                                                                                                      u'is_required': False},
                                                                                                                                                        u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                      u'is_mutex': True,
                                                                                                                                                                      u'is_required': False}},
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'create',
                                                                                                                                            u'path': [u'gcloud',
                                                                                                                                                      u'beta',
                                                                                                                                                      u'compute',
                                                                                                                                                      u'instance-groups',
                                                                                                                                                      u'managed',
                                                                                                                                                      u'create'],
                                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The name of the managed instance group.',
                                                                                                                                                              u'name': u'name',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'value': u'NAME'}],
                                                                                                                                            u'release': u'BETA',
                                                                                                                                            u'sections': {u'DESCRIPTION': u"        *create* creates a Google Compute Engine managed instance group.\n\nFor example, running:\n\n        $ create example-managed-instance-group --zone us-central1-a --template example-instance-template --size 1\n\nwill create one managed instance group called 'example-managed-instance-group'\nin the ``us-central1-a'' zone.\n"}},
                                                                                                                                u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine managed instance groups.',
                                                                                                                                            u'commands': {},
                                                                                                                                            u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                     u'group': u'delete.1',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--region',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'REGION'},
                                                                                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                   u'group': u'delete.1',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--zone',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'ZONE'}},
                                                                                                                                            u'group': False,
                                                                                                                                            u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                      u'is_mutex': True,
                                                                                                                                                                      u'is_required': False}},
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'delete',
                                                                                                                                            u'path': [u'gcloud',
                                                                                                                                                      u'beta',
                                                                                                                                                      u'compute',
                                                                                                                                                      u'instance-groups',
                                                                                                                                                      u'managed',
                                                                                                                                                      u'delete'],
                                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The names of the managed instance groups.',
                                                                                                                                                              u'name': u'names',
                                                                                                                                                              u'nargs': u'+',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'value': u'NAMES'}],
                                                                                                                                            u'release': u'BETA',
                                                                                                                                            u'sections': {u'DESCRIPTION': u'        *delete* deletes one or more Google Compute Engine managed instance\ngroups.\n'}},
                                                                                                                                u'delete-instances': {u'capsule': u'*(BETA)* Delete instances managed by managed instance group.',
                                                                                                                                                      u'commands': {},
                                                                                                                                                      u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                  u'description': u'Names of instances to delete.',
                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                  u'name': u'--instances',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': True,
                                                                                                                                                                                  u'type': u'list',
                                                                                                                                                                                  u'value': u'INSTANCE'},
                                                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                               u'group': u'delete-instances.1',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--region',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'REGION'},
                                                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                             u'group': u'delete-instances.1',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--zone',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                                                      u'group': False,
                                                                                                                                                      u'groups': {u'delete-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                          u'is_mutex': True,
                                                                                                                                                                                          u'is_required': False}},
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'delete-instances',
                                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                                u'beta',
                                                                                                                                                                u'compute',
                                                                                                                                                                u'instance-groups',
                                                                                                                                                                u'managed',
                                                                                                                                                                u'delete-instances'],
                                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The name of the managed instance group.',
                                                                                                                                                                        u'name': u'name',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                                      u'release': u'BETA',
                                                                                                                                                      u'sections': {u'DESCRIPTION': u'\n        *delete-instances* is used to deletes one or more instances from a managed\ninstance group. Once the instances are deleted, the size of the group is\nautomatically reduced to reflect the changes.\n\nIf you would like to keep the underlying virtual machines but still remove them\nfrom the managed instance group, use the abandon-instances command instead.\n'}},
                                                                                                                                u'describe': {u'capsule': u'*(BETA)* Display detailed information about a managed instance group.',
                                                                                                                                              u'commands': {},
                                                                                                                                              u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                       u'group': u'describe.1',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--region',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'REGION'},
                                                                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The zone of the resource to fetch. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                     u'group': u'describe.1',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--zone',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'ZONE'}},
                                                                                                                                              u'group': False,
                                                                                                                                              u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                          u'is_mutex': True,
                                                                                                                                                                          u'is_required': False}},
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'describe',
                                                                                                                                              u'path': [u'gcloud',
                                                                                                                                                        u'beta',
                                                                                                                                                        u'compute',
                                                                                                                                                        u'instance-groups',
                                                                                                                                                        u'managed',
                                                                                                                                                        u'describe'],
                                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The name of the resource to fetch.',
                                                                                                                                                                u'name': u'name',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'value': u'NAME'}],
                                                                                                                                              u'release': u'BETA',
                                                                                                                                              u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a managed instance group in a project.\n',
                                                                                                                                                            u'EXAMPLES': u"\nTo get details about a regional managed instance group in the ``us-central1'' regions,\nrun:\n\n  $ describe --region us-central1\n\nTo get details about a zonal managed instance group in the ``us-central1-b'' zone, run:\n\n  $ describe --zone us-central1-b\n"}},
                                                                                                                                u'get-named-ports': {u'capsule': u'*(BETA)* Lists the named ports for an instance group resource.',
                                                                                                                                                     u'commands': {},
                                                                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--filter',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                                                                u'--limit': {u'attr': {},
                                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--limit',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'LIMIT'},
                                                                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': True,
                                                                                                                                                                              u'description': u'',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': True,
                                                                                                                                                                              u'name': u'--no-uri',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'bool',
                                                                                                                                                                              u'value': u'NO_URI'},
                                                                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--page-size',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                              u'group': u'get-named-ports.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--region',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'REGION'},
                                                                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--sort-by',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'list',
                                                                                                                                                                               u'value': u'FIELD'},
                                                                                                                                                                u'--uri': {u'attr': {},
                                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': False,
                                                                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--uri',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'bool',
                                                                                                                                                                           u'value': u'URI'},
                                                                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                            u'group': u'get-named-ports.1',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--zone',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                                                     u'group': False,
                                                                                                                                                     u'groups': {u'get-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                        u'is_mutex': True,
                                                                                                                                                                                        u'is_required': False}},
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'get-named-ports',
                                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                                               u'beta',
                                                                                                                                                               u'compute',
                                                                                                                                                               u'instance-groups',
                                                                                                                                                               u'managed',
                                                                                                                                                               u'get-named-ports'],
                                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The name of the instance group.',
                                                                                                                                                                       u'name': u'name',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'value': u'NAME'}],
                                                                                                                                                     u'release': u'BETA',
                                                                                                                                                     u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which indicates that the service\nis available on all instances in the group. This information is used\nby the HTTP Load Balancing service.\n\n*get-named-ports* lists the named ports (name and port tuples)\nfor an instance group.\n",
                                                                                                                                                                   u'EXAMPLES': u"For example, to list named ports for an instance group:\n\n  $ get-named-ports example-instance-group --zone us-central1-a\n\nThe above example lists named ports assigned to an instance\ngroup named 'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                                                u'list': {u'capsule': u'*(BETA)* List Google Compute Engine managed instance groups.',
                                                                                                                                          u'commands': {},
                                                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--filter',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--limit',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': True,
                                                                                                                                                                   u'description': u'',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': True,
                                                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'bool',
                                                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--page-size',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                                                     u'--regexp': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--regexp',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'REGEXP'},
                                                                                                                                                     u'--regions': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                                                    u'group': u'list.1',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--regions',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'list',
                                                                                                                                                                    u'value': u'REGION'},
                                                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'list',
                                                                                                                                                                    u'value': u'FIELD'},
                                                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': False,
                                                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--uri',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                u'value': u'URI'},
                                                                                                                                                     u'--zones': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'If provided, only zonal resources are shown. If arguments are provided, only resources from the given zones are shown.',
                                                                                                                                                                  u'group': u'list.1',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--zones',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'list',
                                                                                                                                                                  u'value': u'ZONE'}},
                                                                                                                                          u'group': False,
                                                                                                                                          u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                  u'is_mutex': True,
                                                                                                                                                                  u'is_required': False}},
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'list',
                                                                                                                                          u'path': [u'gcloud',
                                                                                                                                                    u'beta',
                                                                                                                                                    u'compute',
                                                                                                                                                    u'instance-groups',
                                                                                                                                                    u'managed',
                                                                                                                                                    u'list'],
                                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                                            u'default': [],
                                                                                                                                                            u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                                            u'name': u'names',
                                                                                                                                                            u'nargs': u'*',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'value': u'NAME'}],
                                                                                                                                          u'release': u'BETA',
                                                                                                                                          u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine managed instance groups in a project.\n\nBy default, managed instance groups from all regions and managed instance groups from all zones are listed. The results can be narrowed down by\nproviding the ``--regions'' or ``--zones'' flag.\n",
                                                                                                                                                        u'EXAMPLES': u"To list all managed instance groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all managed instance groups in a project, run:\n\n  $ list --uri\n\nTo list all managed instance groups in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n\nTo list all managed instance groups in zones ``us-central1-b'' and ``europe-west1-d'',\nrun:\n\n  $ list --zones us-central1,europe-west1\n"}},
                                                                                                                                u'list-instances': {u'capsule': u'*(BETA)* List instances present in the managed instance group.',
                                                                                                                                                    u'commands': {},
                                                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--filter',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--limit',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': True,
                                                                                                                                                                             u'description': u'',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': True,
                                                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'bool',
                                                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                                                               u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                             u'group': u'list-instances.1',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--region',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'REGION'},
                                                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'list',
                                                                                                                                                                              u'value': u'FIELD'},
                                                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': False,
                                                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--uri',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'bool',
                                                                                                                                                                          u'value': u'URI'},
                                                                                                                                                               u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                           u'group': u'list-instances.1',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--zone',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'string',
                                                                                                                                                                           u'value': u'ZONE'}},
                                                                                                                                                    u'group': False,
                                                                                                                                                    u'groups': {u'list-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                      u'is_mutex': True,
                                                                                                                                                                                      u'is_required': False}},
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'list-instances',
                                                                                                                                                    u'path': [u'gcloud',
                                                                                                                                                              u'beta',
                                                                                                                                                              u'compute',
                                                                                                                                                              u'instance-groups',
                                                                                                                                                              u'managed',
                                                                                                                                                              u'list-instances'],
                                                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'The name of the managed instance group.',
                                                                                                                                                                      u'name': u'name',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'value': u'NAME'}],
                                                                                                                                                    u'release': u'BETA',
                                                                                                                                                    u'sections': {u'DESCRIPTION': u'*list-instances* list instances in a managed instance group.\n'}},
                                                                                                                                u'recreate-instances': {u'capsule': u'*(BETA)* Recreate instances managed by a managed instance group.',
                                                                                                                                                        u'commands': {},
                                                                                                                                                        u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                                                    u'category': u'',
                                                                                                                                                                                    u'choices': [],
                                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                                    u'default': None,
                                                                                                                                                                                    u'description': u'Names of instances to recreate.',
                                                                                                                                                                                    u'group': u'',
                                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                                    u'name': u'--instances',
                                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                                    u'required': True,
                                                                                                                                                                                    u'type': u'list',
                                                                                                                                                                                    u'value': u'INSTANCE'},
                                                                                                                                                                   u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                 u'group': u'recreate-instances.1',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--region',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'REGION'},
                                                                                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                               u'group': u'recreate-instances.1',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--zone',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'ZONE'}},
                                                                                                                                                        u'group': False,
                                                                                                                                                        u'groups': {u'recreate-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                              u'is_mutex': True,
                                                                                                                                                                                              u'is_required': False}},
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'recreate-instances',
                                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                                  u'beta',
                                                                                                                                                                  u'compute',
                                                                                                                                                                  u'instance-groups',
                                                                                                                                                                  u'managed',
                                                                                                                                                                  u'recreate-instances'],
                                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The name of the managed instance group.',
                                                                                                                                                                          u'name': u'name',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                                        u'release': u'BETA',
                                                                                                                                                        u'sections': {u'DESCRIPTION': u'\n        *recreate-instances* is used to recreate one or more instances in a managed\ninstance group. The underlying virtual machine instances are deleted and\nrecreated based on the latest instance template configured for the managed\ninstance group.\n'}},
                                                                                                                                u'resize': {u'capsule': u'*(BETA)* Set managed instance group size.',
                                                                                                                                            u'commands': {},
                                                                                                                                            u'flags': {u'--creation-retries': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': True,
                                                                                                                                                                               u'description': u'When instance creation fails retry it. Enabled by default, use *--no-creation-retries* to disable.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--creation-retries',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'bool',
                                                                                                                                                                               u'value': u'CREATION_RETRIES'},
                                                                                                                                                       u'--no-creation-retries': {u'attr': {},
                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': True,
                                                                                                                                                                                  u'description': u'',
                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                  u'hidden': True,
                                                                                                                                                                                  u'name': u'--no-creation-retries',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                  u'type': u'bool',
                                                                                                                                                                                  u'value': u'NO_CREATION_RETRIES'},
                                                                                                                                                       u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                     u'group': u'resize.1',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--region',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'REGION'},
                                                                                                                                                       u'--size': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'Target number of instances in managed instance group.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--size',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': True,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'SIZE'},
                                                                                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                   u'group': u'resize.1',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--zone',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'ZONE'}},
                                                                                                                                            u'group': False,
                                                                                                                                            u'groups': {u'resize.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                      u'is_mutex': True,
                                                                                                                                                                      u'is_required': False}},
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'resize',
                                                                                                                                            u'path': [u'gcloud',
                                                                                                                                                      u'beta',
                                                                                                                                                      u'compute',
                                                                                                                                                      u'instance-groups',
                                                                                                                                                      u'managed',
                                                                                                                                                      u'resize'],
                                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The name of the managed instance group.',
                                                                                                                                                              u'name': u'name',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'value': u'NAME'}],
                                                                                                                                            u'release': u'BETA',
                                                                                                                                            u'sections': {u'DESCRIPTION': u'\n        *resize* resize a managed instance group to a provided size.\n\nIf you resize down, the Instance Group Manager service deletes instances from\nthe group until the group reaches the desired size. To understand in what order\ninstances will be deleted, see the API documentation.\n\nIf you resize up, the service adds instances to the group using the current\ninstance template until the group reaches the desired size.\n'}},
                                                                                                                                u'set-autohealing': {u'capsule': u'*(BETA)* Set autohealing policy for managed instance group.',
                                                                                                                                                     u'commands': {},
                                                                                                                                                     u'flags': {u'--http-health-check': {u'attr': {},
                                                                                                                                                                                         u'category': u'',
                                                                                                                                                                                         u'choices': [],
                                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                                         u'default': None,
                                                                                                                                                                                         u'description': u'Specifies the HTTP health check object used for autohealing instances in this group.',
                                                                                                                                                                                         u'group': u'set-autohealing.1',
                                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                                         u'name': u'--http-health-check',
                                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                                         u'required': False,
                                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                                         u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                                                                u'--https-health-check': {u'attr': {},
                                                                                                                                                                                          u'category': u'',
                                                                                                                                                                                          u'choices': [],
                                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                                          u'default': None,
                                                                                                                                                                                          u'description': u'Specifies the HTTPS health check object used for autohealing instances in this group.',
                                                                                                                                                                                          u'group': u'set-autohealing.1',
                                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                                          u'name': u'--https-health-check',
                                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                                          u'required': False,
                                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                                          u'value': u'HTTPS_HEALTH_CHECK'},
                                                                                                                                                                u'--initial-delay': {u'attr': {},
                                                                                                                                                                                     u'category': u'',
                                                                                                                                                                                     u'choices': [],
                                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                                     u'default': None,
                                                                                                                                                                                     u'description': u"Specifies the length of the period during which the instance is known to\nbe initializing and should not be autohealed even if unhealthy.\nValid units for this flag are ``s'' for seconds, ``m'' for minutes and\n``h'' for hours. If no unit is specified, seconds is assumed. This value\ncannot be greater than 1 hour.",
                                                                                                                                                                                     u'group': u'',
                                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                                     u'name': u'--initial-delay',
                                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                                     u'required': False,
                                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                                     u'value': u'INITIAL_DELAY'},
                                                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                              u'group': u'set-autohealing.2',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--region',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'REGION'},
                                                                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                            u'group': u'set-autohealing.2',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--zone',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                                                     u'group': False,
                                                                                                                                                     u'groups': {u'set-autohealing.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                        u'is_mutex': True,
                                                                                                                                                                                        u'is_required': False},
                                                                                                                                                                 u'set-autohealing.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                        u'is_mutex': True,
                                                                                                                                                                                        u'is_required': False}},
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'set-autohealing',
                                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                                               u'beta',
                                                                                                                                                               u'compute',
                                                                                                                                                               u'instance-groups',
                                                                                                                                                               u'managed',
                                                                                                                                                               u'set-autohealing'],
                                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The name of the managed instance group.',
                                                                                                                                                                       u'name': u'name',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'value': u'NAME'}],
                                                                                                                                                     u'release': u'BETA',
                                                                                                                                                     u'sections': {u'DESCRIPTION': u"\n        *set-autohealing* updates the autohealing policy for an existing managed\ninstance group.\n\nIf --http-health-check or --https-health-check is specified, the resulting\nautohealing policy will be triggered by the health-check i.e. the autohealing\naction (RECREATE) on an instance will be performed if the health-check signals\nthat the instance is UNHEALTHY. If neither --http-health-check nor\n--https-health-check is specified, the resulting autohealing policy will be\ntriggered by instance's status i.e. the autohealing action (RECREATE) on an\ninstance will be performed if the instance.status is not RUNNING.\n--initial-delay specifies the length of the period during which IGM will\nrefrain from autohealing the instance even if the instance is reported as not\nRUNNING or UNHEALTHY. This value must be from range [0, 3600].\n"}},
                                                                                                                                u'set-autoscaling': {u'capsule': u'*(BETA)* Set autoscaling parameters of a managed instance group.',
                                                                                                                                                     u'commands': {},
                                                                                                                                                     u'flags': {u'--cool-down-period': {u'attr': {},
                                                                                                                                                                                        u'category': u'',
                                                                                                                                                                                        u'choices': [],
                                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                                        u'default': None,
                                                                                                                                                                                        u'description': u'Number of seconds Autoscaler will wait between resizing collection. Note: The Autoscaler waits 10 minutes before scaling down, the value entered here is in addition to the initial 10 minute period.',
                                                                                                                                                                                        u'group': u'',
                                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                                        u'name': u'--cool-down-period',
                                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                                        u'required': False,
                                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                                        u'value': u'COOL_DOWN_PERIOD'},
                                                                                                                                                                u'--custom-metric-utilization': {u'attr': {},
                                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                                 u'description': u'Adds a target metric value for the to the Autoscaler.\n+\n*metric*::: Protocol-free URL of a Google Cloud Monitoring metric.\n+\n*utilization-target*::: Value of the metric Autoscaler will aim to\nmaintain (greater than 0.0).\n+\n*utilization-target-type*::: How target is expressed. Valid values: DELTA_PER_MINUTE, DELTA_PER_SECOND, GAUGE.',
                                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                                 u'name': u'--custom-metric-utilization',
                                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                                 u'type': u'dict',
                                                                                                                                                                                                 u'value': u'CUSTOM_METRIC_UTILIZATION'},
                                                                                                                                                                u'--description': {u'attr': {},
                                                                                                                                                                                   u'category': u'',
                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                   u'description': u'Notes about Autoscaler.',
                                                                                                                                                                                   u'group': u'',
                                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                                   u'name': u'--description',
                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                   u'required': False,
                                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                                                u'--max-num-replicas': {u'attr': {},
                                                                                                                                                                                        u'category': u'',
                                                                                                                                                                                        u'choices': [],
                                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                                        u'default': None,
                                                                                                                                                                                        u'description': u'Maximum number of replicas Autoscaler will set.',
                                                                                                                                                                                        u'group': u'',
                                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                                        u'name': u'--max-num-replicas',
                                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                                        u'required': True,
                                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                                        u'value': u'MAX_NUM_REPLICAS'},
                                                                                                                                                                u'--min-num-replicas': {u'attr': {},
                                                                                                                                                                                        u'category': u'',
                                                                                                                                                                                        u'choices': [],
                                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                                        u'default': None,
                                                                                                                                                                                        u'description': u'Minimum number of replicas Autoscaler will set.',
                                                                                                                                                                                        u'group': u'',
                                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                                        u'name': u'--min-num-replicas',
                                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                                        u'required': False,
                                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                                        u'value': u'MIN_NUM_REPLICAS'},
                                                                                                                                                                u'--no-scale-based-on-cpu': {u'attr': {},
                                                                                                                                                                                             u'category': u'',
                                                                                                                                                                                             u'choices': [],
                                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                                             u'default': True,
                                                                                                                                                                                             u'description': u'',
                                                                                                                                                                                             u'group': u'',
                                                                                                                                                                                             u'hidden': True,
                                                                                                                                                                                             u'name': u'--no-scale-based-on-cpu',
                                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                                             u'required': False,
                                                                                                                                                                                             u'type': u'bool',
                                                                                                                                                                                             u'value': u'NO_SCALE_BASED_ON_CPU'},
                                                                                                                                                                u'--no-scale-based-on-load-balancing': {u'attr': {},
                                                                                                                                                                                                        u'category': u'',
                                                                                                                                                                                                        u'choices': [],
                                                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                                                        u'default': True,
                                                                                                                                                                                                        u'description': u'',
                                                                                                                                                                                                        u'group': u'',
                                                                                                                                                                                                        u'hidden': True,
                                                                                                                                                                                                        u'name': u'--no-scale-based-on-load-balancing',
                                                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                                                        u'required': False,
                                                                                                                                                                                                        u'type': u'bool',
                                                                                                                                                                                                        u'value': u'NO_SCALE_BASED_ON_LOAD_BALANCING'},
                                                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                              u'group': u'set-autoscaling.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--region',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'REGION'},
                                                                                                                                                                u'--scale-based-on-cpu': {u'attr': {},
                                                                                                                                                                                          u'category': u'',
                                                                                                                                                                                          u'choices': [],
                                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                                          u'default': False,
                                                                                                                                                                                          u'description': u'Autoscaler will be based on CPU utilization.',
                                                                                                                                                                                          u'group': u'',
                                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                                          u'name': u'--scale-based-on-cpu',
                                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                                          u'required': False,
                                                                                                                                                                                          u'type': u'bool',
                                                                                                                                                                                          u'value': u'SCALE_BASED_ON_CPU'},
                                                                                                                                                                u'--scale-based-on-load-balancing': {u'attr': {},
                                                                                                                                                                                                     u'category': u'',
                                                                                                                                                                                                     u'choices': [],
                                                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                                                     u'default': False,
                                                                                                                                                                                                     u'description': u'Use autoscaling based on load balancing utilization.',
                                                                                                                                                                                                     u'group': u'',
                                                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                                                     u'name': u'--scale-based-on-load-balancing',
                                                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                                                     u'required': False,
                                                                                                                                                                                                     u'type': u'bool',
                                                                                                                                                                                                     u'value': u'SCALE_BASED_ON_LOAD_BALANCING'},
                                                                                                                                                                u'--target-cpu-utilization': {u'attr': {},
                                                                                                                                                                                              u'category': u'',
                                                                                                                                                                                              u'choices': [],
                                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                                              u'default': None,
                                                                                                                                                                                              u'description': u'Autoscaler will aim to maintain CPU utilization at target level (0.0 to 1.0).',
                                                                                                                                                                                              u'group': u'',
                                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                                              u'name': u'--target-cpu-utilization',
                                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                                              u'required': False,
                                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                                              u'value': u'TARGET_CPU_UTILIZATION'},
                                                                                                                                                                u'--target-load-balancing-utilization': {u'attr': {},
                                                                                                                                                                                                         u'category': u'',
                                                                                                                                                                                                         u'choices': [],
                                                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                                                         u'default': None,
                                                                                                                                                                                                         u'description': u'Autoscaler will aim to maintain the load balancing utilization level (greater than 0.0).',
                                                                                                                                                                                                         u'group': u'',
                                                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                                                         u'name': u'--target-load-balancing-utilization',
                                                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                                                         u'required': False,
                                                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                                                         u'value': u'TARGET_LOAD_BALANCING_UTILIZATION'},
                                                                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                            u'group': u'set-autoscaling.1',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--zone',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                                                     u'group': False,
                                                                                                                                                     u'groups': {u'set-autoscaling.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                        u'is_mutex': True,
                                                                                                                                                                                        u'is_required': False}},
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'set-autoscaling',
                                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                                               u'beta',
                                                                                                                                                               u'compute',
                                                                                                                                                               u'instance-groups',
                                                                                                                                                               u'managed',
                                                                                                                                                               u'set-autoscaling'],
                                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The name of the managed instance group.',
                                                                                                                                                                       u'name': u'name',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'value': u'NAME'}],
                                                                                                                                                     u'release': u'BETA',
                                                                                                                                                     u'sections': {u'DESCRIPTION': u'        *set-autoscaling* sets autoscaling parameters of specified managed instance\ngroup.\n\nAutoscalers can use one or more policies listed below. Information on using\nmultiple policies can be found here: [](https://cloud.google.com/compute/docs/autoscaler/multiple-policies)\n'}},
                                                                                                                                u'set-instance-template': {u'capsule': u'*(BETA)* Set instance template for managed instance group.',
                                                                                                                                                           u'commands': {},
                                                                                                                                                           u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                    u'category': u'',
                                                                                                                                                                                    u'choices': [],
                                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                                    u'default': None,
                                                                                                                                                                                    u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                    u'group': u'set-instance-template.1',
                                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                                    u'name': u'--region',
                                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                                    u'required': False,
                                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                                    u'value': u'REGION'},
                                                                                                                                                                      u'--template': {u'attr': {},
                                                                                                                                                                                      u'category': u'',
                                                                                                                                                                                      u'choices': [],
                                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                                      u'default': None,
                                                                                                                                                                                      u'description': u'Compute Engine instance template resource to be used.',
                                                                                                                                                                                      u'group': u'',
                                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                                      u'name': u'--template',
                                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                                      u'required': True,
                                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                                      u'value': u'TEMPLATE'},
                                                                                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                                  u'category': u'',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                  u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                                  u'group': u'set-instance-template.1',
                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                  u'name': u'--zone',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                                  u'value': u'ZONE'}},
                                                                                                                                                           u'group': False,
                                                                                                                                                           u'groups': {u'set-instance-template.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                                                                    u'is_required': False}},
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'set-instance-template',
                                                                                                                                                           u'path': [u'gcloud',
                                                                                                                                                                     u'beta',
                                                                                                                                                                     u'compute',
                                                                                                                                                                     u'instance-groups',
                                                                                                                                                                     u'managed',
                                                                                                                                                                     u'set-instance-template'],
                                                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The name of the managed instance group.',
                                                                                                                                                                             u'name': u'name',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'value': u'NAME'}],
                                                                                                                                                           u'release': u'BETA',
                                                                                                                                                           u'sections': {u'DESCRIPTION': u"\n        *set-instance-template* updates the instance template for an existing managed instance group.\n\nThe new template won't apply to existing instances in the group unless they are\nrecreated using the recreate-instances command. But the new template does apply\nto all new instances added to the managed instance group.\n"}},
                                                                                                                                u'set-named-ports': {u'capsule': u'*(BETA)* Sets the list of named ports for an instance group.',
                                                                                                                                                     u'commands': {},
                                                                                                                                                     u'flags': {u'--named-ports': {u'attr': {},
                                                                                                                                                                                   u'category': u'',
                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                   u'description': u'The comma-separated list of key:value pairs representing\nthe service name and the port that it is running on.\n+\nTo clear the list of named ports pass empty list as flag value.\nFor example:\n+\n  $ {command} example-instance-group --named-ports ""',
                                                                                                                                                                                   u'group': u'',
                                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                                   u'name': u'--named-ports',
                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                   u'required': True,
                                                                                                                                                                                   u'type': u'list',
                                                                                                                                                                                   u'value': u'NAME:PORT'},
                                                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                              u'group': u'set-named-ports.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--region',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'REGION'},
                                                                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                            u'group': u'set-named-ports.1',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--zone',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                                                     u'group': False,
                                                                                                                                                     u'groups': {u'set-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                        u'is_mutex': True,
                                                                                                                                                                                        u'is_required': False}},
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'set-named-ports',
                                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                                               u'beta',
                                                                                                                                                               u'compute',
                                                                                                                                                               u'instance-groups',
                                                                                                                                                               u'managed',
                                                                                                                                                               u'set-named-ports'],
                                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The name of the instance group.',
                                                                                                                                                                       u'name': u'name',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'value': u'NAME'}],
                                                                                                                                                     u'release': u'BETA',
                                                                                                                                                     u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which\nindicates that the service is available on all instances in the\ngroup. This information is used by the HTTP Load Balancing\nservice.\n\n*set-named-ports* sets the list of named ports for all instances\nin an instance group.\n\nNote: Running this command will clear all existing named ports.\n",
                                                                                                                                                                   u'EXAMPLES': u'For example, to apply the named ports to an entire instance group:\n\n  $ set-named-ports example-instance-group --named-ports example-service:1111 --zone us-central1-a\n\nThe above example will assign a name \'example-service\' for port 1111\nto the instance group called \'example-instance-group\' in the\n``us-central1-a\'\' zone. The command removes any named ports that are\nalready set for this instance group.\n\nTo clear named ports from instance group provide empty named ports\nlist as parameter:\n\n  $ set-named-ports example-instance-group --named-ports "" --zone us-central1-a\n'}},
                                                                                                                                u'set-target-pools': {u'capsule': u'*(BETA)* Set target pools of managed instance group.',
                                                                                                                                                      u'commands': {},
                                                                                                                                                      u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                               u'group': u'set-target-pools.1',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--region',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'REGION'},
                                                                                                                                                                 u'--target-pools': {u'attr': {},
                                                                                                                                                                                     u'category': u'',
                                                                                                                                                                                     u'choices': [],
                                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                                     u'default': None,
                                                                                                                                                                                     u'description': u'Compute Engine Target Pools to add the instances to. Target Pools must be specified by name or by URL. Example: --target-pool target-pool-1,target-pool-2.',
                                                                                                                                                                                     u'group': u'',
                                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                                     u'name': u'--target-pools',
                                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                                     u'required': True,
                                                                                                                                                                                     u'type': u'list',
                                                                                                                                                                                     u'value': u'TARGET_POOL'},
                                                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                             u'group': u'set-target-pools.1',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--zone',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                                                      u'group': False,
                                                                                                                                                      u'groups': {u'set-target-pools.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                          u'is_mutex': True,
                                                                                                                                                                                          u'is_required': False}},
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'set-target-pools',
                                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                                u'beta',
                                                                                                                                                                u'compute',
                                                                                                                                                                u'instance-groups',
                                                                                                                                                                u'managed',
                                                                                                                                                                u'set-target-pools'],
                                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The name of the managed instance group.',
                                                                                                                                                                        u'name': u'name',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                                      u'release': u'BETA',
                                                                                                                                                      u'sections': {u'DESCRIPTION': u"\n        *set-target-pools* sets the target pools for an existing managed instance group.\nInstances that are part of the managed instance group will be added to the\ntarget pool automatically.\n\nSetting a new target pool won't apply to existing instances in the group unless\nthey are recreated using the recreate-instances command. But any new instances\ncreated in the managed instance group will be added to all of the provided\ntarget pools for load balancing purposes.\n"}},
                                                                                                                                u'stop-autoscaling': {u'capsule': u'*(BETA)* Stop autoscaling a managed instance group.',
                                                                                                                                                      u'commands': {},
                                                                                                                                                      u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                               u'group': u'stop-autoscaling.1',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--region',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'REGION'},
                                                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                             u'group': u'stop-autoscaling.1',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--zone',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                                                      u'group': False,
                                                                                                                                                      u'groups': {u'stop-autoscaling.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                          u'is_mutex': True,
                                                                                                                                                                                          u'is_required': False}},
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'stop-autoscaling',
                                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                                u'beta',
                                                                                                                                                                u'compute',
                                                                                                                                                                u'instance-groups',
                                                                                                                                                                u'managed',
                                                                                                                                                                u'stop-autoscaling'],
                                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The name of the managed instance group.',
                                                                                                                                                                        u'name': u'name',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                                      u'release': u'BETA',
                                                                                                                                                      u'sections': {u'DESCRIPTION': u'        *stop-autoscaling* stops autoscaling a managed instance group. If autoscaling\nis not enabled for the managed instance group, this command does nothing and\nwill report an error.\n'}},
                                                                                                                                u'wait-until-stable': {u'capsule': u'*(BETA)* Waits until state of managed instance group is stable.',
                                                                                                                                                       u'commands': {},
                                                                                                                                                       u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                u'group': u'wait-until-stable.1',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--region',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'REGION'},
                                                                                                                                                                  u'--timeout': {u'attr': {},
                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'Timeout in seconds for waiting for group becoming stable.',
                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--timeout',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'TIMEOUT'},
                                                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                              u'group': u'wait-until-stable.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--zone',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                                                       u'group': False,
                                                                                                                                                       u'groups': {u'wait-until-stable.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                                                            u'is_required': False}},
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'wait-until-stable',
                                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                                 u'beta',
                                                                                                                                                                 u'compute',
                                                                                                                                                                 u'instance-groups',
                                                                                                                                                                 u'managed',
                                                                                                                                                                 u'wait-until-stable'],
                                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the managed instance group.',
                                                                                                                                                                         u'name': u'name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                                       u'release': u'BETA',
                                                                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Waits until state of managed instance group is stable.'}}},
                                                                                                                  u'flags': {},
                                                                                                                  u'group': True,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'managed',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'instance-groups',
                                                                                                                            u'managed'],
                                                                                                                  u'positionals': [],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine managed instance groups.'}},
                                                                                                     u'set-named-ports': {u'capsule': u'*(BETA)* Sets the list of named ports for an instance group.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--named-ports': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The comma-separated list of key:value pairs representing\nthe service name and the port that it is running on.\n+\nTo clear the list of named ports pass empty list as flag value.\nFor example:\n+\n  $ {command} example-instance-group --named-ports ""',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--named-ports',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': True,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'NAME:PORT'},
                                                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                   u'group': u'set-named-ports.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--region',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'REGION'},
                                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                 u'group': u'set-named-ports.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--zone',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'ZONE'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {u'set-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                             u'is_required': False}},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'set-named-ports',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'beta',
                                                                                                                                    u'compute',
                                                                                                                                    u'instance-groups',
                                                                                                                                    u'set-named-ports'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of the instance group.',
                                                                                                                                            u'name': u'name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'NAME'}],
                                                                                                                          u'release': u'BETA',
                                                                                                                          u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which\nindicates that the service is available on all instances in the\ngroup. This information is used by the HTTP Load Balancing\nservice.\n\n*set-named-ports* sets the list of named ports for all instances\nin an instance group.\n\nNote: Running this command will clear all existing named ports.\n",
                                                                                                                                        u'EXAMPLES': u'For example, to apply the named ports to an entire instance group:\n\n  $ set-named-ports example-instance-group --named-ports example-service:1111 --zone us-central1-a\n\nThe above example will assign a name \'example-service\' for port 1111\nto the instance group called \'example-instance-group\' in the\n``us-central1-a\'\' zone. The command removes any named ports that are\nalready set for this instance group.\n\nTo clear named ports from instance group provide empty named ports\nlist as parameter:\n\n  $ set-named-ports example-instance-group --named-ports "" --zone us-central1-a\n'}},
                                                                                                     u'unmanaged': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine unmanaged instance group.',
                                                                                                                    u'commands': {u'add-instances': {u'capsule': u'*(BETA)* Adds instances to an unmanaged instance group by name.',
                                                                                                                                                     u'commands': {},
                                                                                                                                                     u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'A list of names of instances to add to the instance group. These must exist beforehand and must live in the same zone as the instance group.',
                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--instances',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': True,
                                                                                                                                                                                 u'type': u'list',
                                                                                                                                                                                 u'value': u'INSTANCE'},
                                                                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--zone',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                                                     u'group': False,
                                                                                                                                                     u'groups': {},
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'add-instances',
                                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                                               u'beta',
                                                                                                                                                               u'compute',
                                                                                                                                                               u'instance-groups',
                                                                                                                                                               u'unmanaged',
                                                                                                                                                               u'add-instances'],
                                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The name of the instance group.',
                                                                                                                                                                       u'name': u'name',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'value': u'NAME'}],
                                                                                                                                                     u'release': u'BETA',
                                                                                                                                                     u'sections': {u'DESCRIPTION': u'*add-instances* adds existing instances to an unmanaged instance group\nby name.\nFor example:\n\n  $ add-instances example-instance-group --instances example-instance-1 example-instance-2 --zone us-central1-a\n'}},
                                                                                                                                  u'create': {u'capsule': u'*(BETA)* Create a Compute Engine unmanaged instance group.',
                                                                                                                                              u'commands': {},
                                                                                                                                              u'flags': {u'--description': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'Specifies a textual description for the unmanaged instance group.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--description',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'DESCRIPTION'},
                                                                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--zone',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'ZONE'}},
                                                                                                                                              u'group': False,
                                                                                                                                              u'groups': {},
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'create',
                                                                                                                                              u'path': [u'gcloud',
                                                                                                                                                        u'beta',
                                                                                                                                                        u'compute',
                                                                                                                                                        u'instance-groups',
                                                                                                                                                        u'unmanaged',
                                                                                                                                                        u'create'],
                                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The name of the instance group.',
                                                                                                                                                                u'name': u'name',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'value': u'NAME'}],
                                                                                                                                              u'release': u'BETA',
                                                                                                                                              u'sections': {u'DESCRIPTION': u"*create* creates a new Google Compute Engine unmanaged\ninstance group.\nFor example:\n\n  $ create example-instance-group --zone us-central1-a\n\nThe above example creates one unmanaged instance group called\n'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                                                  u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine unmanaged instance groups.',
                                                                                                                                              u'commands': {},
                                                                                                                                              u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u"The zone of the resources to delete. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--zone',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'ZONE'}},
                                                                                                                                              u'group': False,
                                                                                                                                              u'groups': {},
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'delete',
                                                                                                                                              u'path': [u'gcloud',
                                                                                                                                                        u'beta',
                                                                                                                                                        u'compute',
                                                                                                                                                        u'instance-groups',
                                                                                                                                                        u'unmanaged',
                                                                                                                                                        u'delete'],
                                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The resources to delete.',
                                                                                                                                                                u'name': u'names',
                                                                                                                                                                u'nargs': u'+',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'value': u'NAME'}],
                                                                                                                                              u'release': u'BETA',
                                                                                                                                              u'sections': {u'DESCRIPTION': u"*delete* deletes one or more Google Compute Engine unmanaged\ninstance groups. This command just deletes the instance group and does\nnot delete the individual virtual machine instances\nin the instance group.\nFor example:\n\n  $ delete example-instance-group-1 example-instance-group-2 --zone us-central1-a\n\nThe above example deletes two instance groups, example-instance-group-1\nand example-instance-group-2, in the ``us-central1-a'' zone.\n"}},
                                                                                                                                  u'describe': {u'capsule': u'*(BETA)* Describe an instance group.',
                                                                                                                                                u'commands': {},
                                                                                                                                                u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--zone',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'ZONE'}},
                                                                                                                                                u'group': False,
                                                                                                                                                u'groups': {},
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'describe',
                                                                                                                                                u'path': [u'gcloud',
                                                                                                                                                          u'beta',
                                                                                                                                                          u'compute',
                                                                                                                                                          u'instance-groups',
                                                                                                                                                          u'unmanaged',
                                                                                                                                                          u'describe'],
                                                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The name of the resource to fetch.',
                                                                                                                                                                  u'name': u'name',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'value': u'NAME'}],
                                                                                                                                                u'release': u'BETA',
                                                                                                                                                u'sections': {u'DESCRIPTION': u'*describe* displays detailed information about a Google Compute\nEngine instance group.\n'}},
                                                                                                                                  u'get-named-ports': {u'capsule': u'*(BETA)* Lists the named ports for an instance group resource.',
                                                                                                                                                       u'commands': {},
                                                                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--filter',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--limit',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'LIMIT'},
                                                                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': True,
                                                                                                                                                                                u'description': u'',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': True,
                                                                                                                                                                                u'name': u'--no-uri',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                                u'value': u'NO_URI'},
                                                                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                                                   u'choices': [],
                                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                                   u'default': None,
                                                                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                                   u'group': u'',
                                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                                   u'name': u'--page-size',
                                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                                   u'required': False,
                                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                                                                  u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                                                u'group': u'get-named-ports.1',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--region',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'string',
                                                                                                                                                                                u'value': u'REGION'},
                                                                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'list',
                                                                                                                                                                                 u'value': u'FIELD'},
                                                                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': False,
                                                                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--uri',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'bool',
                                                                                                                                                                             u'value': u'URI'},
                                                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                                              u'group': u'get-named-ports.1',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--zone',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                                                       u'group': False,
                                                                                                                                                       u'groups': {u'get-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                                          u'is_mutex': True,
                                                                                                                                                                                          u'is_required': False}},
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'get-named-ports',
                                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                                 u'beta',
                                                                                                                                                                 u'compute',
                                                                                                                                                                 u'instance-groups',
                                                                                                                                                                 u'unmanaged',
                                                                                                                                                                 u'get-named-ports'],
                                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the instance group.',
                                                                                                                                                                         u'name': u'name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                                       u'release': u'BETA',
                                                                                                                                                       u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which indicates that the service\nis available on all instances in the group. This information is used\nby the HTTP Load Balancing service.\n\n*get-named-ports* lists the named ports (name and port tuples)\nfor an instance group.\n",
                                                                                                                                                                     u'EXAMPLES': u"For example, to list named ports for an instance group:\n\n  $ get-named-ports example-instance-group --zone us-central1-a\n\nThe above example lists named ports assigned to an instance\ngroup named 'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                                                  u'list': {u'capsule': u'*(BETA)* List Google Compute Engine unmanaged instance groups.',
                                                                                                                                            u'commands': {},
                                                                                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--filter',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--limit',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': True,
                                                                                                                                                                     u'description': u'',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': True,
                                                                                                                                                                     u'name': u'--no-uri',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'bool',
                                                                                                                                                                     u'value': u'NO_URI'},
                                                                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--page-size',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                                                                       u'--regexp': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--regexp',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'REGEXP'},
                                                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'list',
                                                                                                                                                                      u'value': u'FIELD'},
                                                                                                                                                       u'--uri': {u'attr': {},
                                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': False,
                                                                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--uri',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'bool',
                                                                                                                                                                  u'value': u'URI'},
                                                                                                                                                       u'--zones': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': [],
                                                                                                                                                                    u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--zones',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'list',
                                                                                                                                                                    u'value': u'ZONE'}},
                                                                                                                                            u'group': False,
                                                                                                                                            u'groups': {},
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'list',
                                                                                                                                            u'path': [u'gcloud',
                                                                                                                                                      u'beta',
                                                                                                                                                      u'compute',
                                                                                                                                                      u'instance-groups',
                                                                                                                                                      u'unmanaged',
                                                                                                                                                      u'list'],
                                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                                              u'default': [],
                                                                                                                                                              u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                                              u'name': u'names',
                                                                                                                                                              u'nargs': u'*',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'value': u'NAME'}],
                                                                                                                                            u'release': u'BETA',
                                                                                                                                            u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine unmanaged instance groups in a project.\n\nBy default, unmanaged instance groups from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                                                          u'EXAMPLES': u"To list all unmanaged instance groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all unmanaged instance groups in a project, run:\n\n  $ list --uri\n\nTo list all unmanaged instance groups in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}},
                                                                                                                                  u'list-instances': {u'capsule': u'*(BETA)* List instances present in the instance group.',
                                                                                                                                                      u'commands': {},
                                                                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--filter',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--limit',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'LIMIT'},
                                                                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': True,
                                                                                                                                                                               u'description': u'',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': True,
                                                                                                                                                                               u'name': u'--no-uri',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'bool',
                                                                                                                                                                               u'value': u'NO_URI'},
                                                                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                                                  u'choices': [],
                                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                                  u'default': None,
                                                                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                                  u'group': u'',
                                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                                  u'name': u'--page-size',
                                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                                  u'required': False,
                                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                                                                 u'--regexp': {u'attr': {},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--regexp',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'REGEXP'},
                                                                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': None,
                                                                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': False,
                                                                                                                                                                                u'name': u'--sort-by',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'list',
                                                                                                                                                                                u'value': u'FIELD'},
                                                                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': False,
                                                                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--uri',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'bool',
                                                                                                                                                                            u'value': u'URI'},
                                                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--zone',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                                                      u'group': False,
                                                                                                                                                      u'groups': {},
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'list-instances',
                                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                                u'beta',
                                                                                                                                                                u'compute',
                                                                                                                                                                u'instance-groups',
                                                                                                                                                                u'unmanaged',
                                                                                                                                                                u'list-instances'],
                                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The name of the instance group.',
                                                                                                                                                                        u'name': u'name',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'value': u'NAME'}],
                                                                                                                                                      u'release': u'BETA',
                                                                                                                                                      u'sections': {u'DESCRIPTION': u'*list-instances* list instances in an instance group.\n'}},
                                                                                                                                  u'remove-instances': {u'capsule': u'*(BETA)* Removes resources from an unmanaged instance group by instance name.',
                                                                                                                                                        u'commands': {},
                                                                                                                                                        u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                                                    u'category': u'',
                                                                                                                                                                                    u'choices': [],
                                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                                    u'default': None,
                                                                                                                                                                                    u'description': u'The names of the instances to remove from the instance group.',
                                                                                                                                                                                    u'group': u'',
                                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                                    u'name': u'--instances',
                                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                                    u'required': True,
                                                                                                                                                                                    u'type': u'list',
                                                                                                                                                                                    u'value': u'INSTANCE'},
                                                                                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                               u'category': u'',
                                                                                                                                                                               u'choices': [],
                                                                                                                                                                               u'completer': u'',
                                                                                                                                                                               u'default': None,
                                                                                                                                                                               u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                               u'group': u'',
                                                                                                                                                                               u'hidden': False,
                                                                                                                                                                               u'name': u'--zone',
                                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                                               u'required': False,
                                                                                                                                                                               u'type': u'string',
                                                                                                                                                                               u'value': u'ZONE'}},
                                                                                                                                                        u'group': False,
                                                                                                                                                        u'groups': {},
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'remove-instances',
                                                                                                                                                        u'path': [u'gcloud',
                                                                                                                                                                  u'beta',
                                                                                                                                                                  u'compute',
                                                                                                                                                                  u'instance-groups',
                                                                                                                                                                  u'unmanaged',
                                                                                                                                                                  u'remove-instances'],
                                                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The name of the instance group.',
                                                                                                                                                                          u'name': u'name',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'value': u'NAME'}],
                                                                                                                                                        u'release': u'BETA',
                                                                                                                                                        u'sections': {u'DESCRIPTION': u'*remove-instances* removes instances from an unmanaged instance group using\nthe instance name.\n\nThis does not delete the actual instance resources but removes\nit from the instance group.\n'}},
                                                                                                                                  u'set-named-ports': {u'capsule': u'*(BETA)* Sets the list of named ports for an instance group.',
                                                                                                                                                       u'commands': {},
                                                                                                                                                       u'flags': {u'--named-ports': {u'attr': {},
                                                                                                                                                                                     u'category': u'',
                                                                                                                                                                                     u'choices': [],
                                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                                     u'default': None,
                                                                                                                                                                                     u'description': u'The comma-separated list of key:value pairs representing\nthe service name and the port that it is running on.\n+\nTo clear the list of named ports pass empty list as flag value.\nFor example:\n+\n  $ {command} example-instance-group --named-ports ""',
                                                                                                                                                                                     u'group': u'',
                                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                                     u'name': u'--named-ports',
                                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                                     u'required': True,
                                                                                                                                                                                     u'type': u'list',
                                                                                                                                                                                     u'value': u'NAME:PORT'},
                                                                                                                                                                  u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--zone',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'ZONE'}},
                                                                                                                                                       u'group': False,
                                                                                                                                                       u'groups': {},
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'set-named-ports',
                                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                                 u'beta',
                                                                                                                                                                 u'compute',
                                                                                                                                                                 u'instance-groups',
                                                                                                                                                                 u'unmanaged',
                                                                                                                                                                 u'set-named-ports'],
                                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the instance group.',
                                                                                                                                                                         u'name': u'name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                                       u'release': u'BETA',
                                                                                                                                                       u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which\nindicates that the service is available on all instances in the\ngroup. This information is used by the HTTP Load Balancing\nservice.\n\n*set-named-ports* sets the list of named ports for all instances\nin an instance group.\n\nNote: Running this command will clear all existing named ports.\n",
                                                                                                                                                                     u'EXAMPLES': u'For example, to apply the named ports to an entire instance group:\n\n  $ set-named-ports example-instance-group --named-ports example-service:1111 --zone us-central1-a\n\nThe above example will assign a name \'example-service\' for port 1111\nto the instance group called \'example-instance-group\' in the\n``us-central1-a\'\' zone. The command removes any named ports that are\nalready set for this instance group.\n\nTo clear named ports from instance group provide empty named ports\nlist as parameter:\n\n  $ set-named-ports example-instance-group --named-ports "" --zone us-central1-a\n'}}},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': True,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'unmanaged',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'instance-groups',
                                                                                                                              u'unmanaged'],
                                                                                                                    u'positionals': [],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine unmanaged instance groups.'}}},
                                                                                       u'flags': {},
                                                                                       u'group': True,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'instance-groups',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'beta',
                                                                                                 u'compute',
                                                                                                 u'instance-groups'],
                                                                                       u'positionals': [],
                                                                                       u'release': u'BETA',
                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine instance groups. To accommodate the\ndifferences between managed and unmanaged instances, some commands (such as\n`delete`) are in the managed or unmanaged subgroups.'}},
                                                                  u'instance-templates': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine instances templates.',
                                                                                          u'commands': {u'create': {u'capsule': u'*(BETA)* Create a Compute Engine virtual machine instance template.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--address': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Assigns the given external IP address to the instance that is created.\nThis option can only be used when creating a single instance.',
                                                                                                                                              u'group': u'create.1',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--address',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'ADDRESS'},
                                                                                                                               u'--boot-disk-auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': True,
                                                                                                                                                            u'description': u'Automatically delete boot disks when their instances are deleted. Enabled by default, use *--no-boot-disk-auto-delete* to disable.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--boot-disk-auto-delete',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'BOOT_DISK_AUTO_DELETE'},
                                                                                                                               u'--boot-disk-device-name': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The name the guest operating system will see for the boot disk as.  This\noption can only be specified if a new boot disk is being created (as\nopposed to mounting an existing persistent disk).',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--boot-disk-device-name',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'BOOT_DISK_DEVICE_NAME'},
                                                                                                                               u'--boot-disk-size': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"The size of the boot disk. This option can only be specified if a new\nboot disk is being created (as opposed to mounting an existing\npersistent disk). The value must be a whole number followed by a size\nunit of ``KB'' for kilobyte, ``MB'' for megabyte, ``GB'' for gigabyte,\nor ``TB'' for terabyte. For example, ``10GB'' will produce a 10 gigabyte\ndisk. The minimum size a boot disk can have is 10 GB. Disk size must be a\nmultiple of 1 GB.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--boot-disk-size',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'BOOT_DISK_SIZE'},
                                                                                                                               u'--boot-disk-type': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The type of the boot disk. This option can only be specified if a new boot\ndisk is being created (as opposed to mounting an existing persistent\ndisk). To get a list of available disk types, run\n`$ gcloud compute disk-types list`.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--boot-disk-type',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'BOOT_DISK_TYPE'},
                                                                                                                               u'--can-ip-forward': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'If provided, allows the instances to send and receive packets with non-matching destination or source IP addresses.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--can-ip-forward',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'CAN_IP_FORWARD'},
                                                                                                                               u'--custom-cpu': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--custom-cpu',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'CUSTOM_CPU'},
                                                                                                                               u'--custom-memory': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--custom-memory',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'CUSTOM_MEMORY'},
                                                                                                                               u'--description': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Specifies a textual description for the instance template.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--description',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'DESCRIPTION'},
                                                                                                                               u'--disk': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"Attaches persistent disks to the instances. The disks\nspecified must already exist.\n+\n*name*::: The disk to attach to the instances. When creating\nmore than one instance and using this property, the only valid\nmode for attaching the disk is read-only (see *mode* below).\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default. It is an error for mode\nto be ``rw'' when creating more than one instance because\nread-write disks can only be attached to a single instance.\n+\n*boot*::: If ``yes'', indicates that this is a boot disk. The\nvirtual machines will use the first partition of the disk for\ntheir root file systems. The default value for this is ``no''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--disk',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'dict',
                                                                                                                                           u'value': u'DISK'},
                                                                                                                               u'--image': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"Specifies the boot image for the instances. For each\ninstance, a new boot disk will be created from the given\nimage. Each boot disk will have the same name as the\ninstance. To view a list of public images and projects, run\n`$ gcloud compute images list`.\n+\nWhen using this option, ``--boot-disk-device-name'' and\n``--boot-disk-size'' can be used to override the boot disk's\ndevice name and size, respectively.",
                                                                                                                                            u'group': u'create.2',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--image',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'IMAGE'},
                                                                                                                               u'--image-family': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The family of the image that the boot disk will be initialized\nwith. When a family is specified instead of an image, the latest\nnon-deprecated image associated with that family is used.\n+\nBy default, ``debian-8'' is assumed for this flag.",
                                                                                                                                                   u'group': u'create.2',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--image-family',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'IMAGE_FAMILY'},
                                                                                                                               u'--image-project': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The project against which all image and image family references will be\nresolved. See ``--image'' for more details.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--image-project',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'IMAGE_PROJECT'},
                                                                                                                               u'--local-ssd': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"Attaches a local SSD to the instances.\n+\nThis flag is currently in BETA and may change without notice.\n+\n*device-name*::: Optional. A name that indicates the disk name\nthe guest operating system will see.  If omitted, a device name\nof the form ``local-ssd-N'' will be used.\n+\n*interface*::: Optional. The kind of disk interface exposed to the VM\nfor this SSD.  Valid values are ``SCSI'' and ``NVME''.  SCSI is\nthe default and is supported by more guest operating systems.  NVME\nmay provide higher performance.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--local-ssd',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'dict',
                                                                                                                                                u'value': u'LOCAL_SSD'},
                                                                                                                               u'--machine-type': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--machine-type',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'MACHINE_TYPE'},
                                                                                                                               u'--maintenance-policy': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [u'MIGRATE',
                                                                                                                                                                      u'TERMINATE'],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--maintenance-policy',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'MAINTENANCE_POLICY'},
                                                                                                                               u'--metadata': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': {},
                                                                                                                                               u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--metadata',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'dict',
                                                                                                                                               u'value': u'KEY=VALUE'},
                                                                                                                               u'--metadata-from-file': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': {},
                                                                                                                                                         u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.",
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--metadata-from-file',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'dict',
                                                                                                                                                         u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                                                               u'--network': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Specifies the network that the instances will be part of. If --subnet is\nalso specified subnet must be a subnetwork of network specified by\n--network. If neither is specified, this defaults to the "default"\nnetwork.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--network',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'NETWORK'},
                                                                                                                               u'--network-interface': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Adds a network interface to the instance. Mutually exclusive with\n--address, --network, --network-tier, --subnet, and --private-network-ip\nflags.\n+\nThe following keys are allowed:\n*address*::: Assigns the given external address to the instance that is\ncreated. Specifying an empty string will assign an ephemeral IP.\nMutually exclusive with no-address. If neither key is present the\ninstance will get an ephemeral IP.\n+\n*network*::: Specifies the network that the interface will be part of.\nIf subnet is also specified it must be subnetwork of this network. If\nneither is specified, this defaults to the "default" network.\n+\n*no-address*::: If specified the interface will have no external IP.\nMutually exclusive with address. If neither key is present the\ninstance will get an ephemeral IP.\n+\n*subnet*::: Specifies the subnet that the interface will be part of.\nIf network key is also specified this must be a subnetwork of the\nspecified network.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--network-interface',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'dict',
                                                                                                                                                        u'value': u'PROPERTY=VALUE'},
                                                                                                                               u'--no-address': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'If provided, the instances will not be assigned external IP addresses.',
                                                                                                                                                 u'group': u'create.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--no-address',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'NO_ADDRESS'},
                                                                                                                               u'--no-boot-disk-auto-delete': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': True,
                                                                                                                                                               u'description': u'',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': True,
                                                                                                                                                               u'name': u'--no-boot-disk-auto-delete',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'bool',
                                                                                                                                                               u'value': u'NO_BOOT_DISK_AUTO_DELETE'},
                                                                                                                               u'--no-can-ip-forward': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': True,
                                                                                                                                                        u'description': u'',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': True,
                                                                                                                                                        u'name': u'--no-can-ip-forward',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'NO_CAN_IP_FORWARD'},
                                                                                                                               u'--no-preemptible': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-preemptible',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_PREEMPTIBLE'},
                                                                                                                               u'--no-restart-on-failure': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': True,
                                                                                                                                                            u'description': u'',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': True,
                                                                                                                                                            u'name': u'--no-restart-on-failure',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                                                               u'--no-scopes': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Create instance without scopes',
                                                                                                                                                u'group': u'create.3',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--no-scopes',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_SCOPES'},
                                                                                                                               u'--no-service-account': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': False,
                                                                                                                                                         u'description': u'Create instance without service account',
                                                                                                                                                         u'group': u'create.4',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--no-service-account',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                                                               u'--preemptible': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'If provided, instances will be preemptible and time-limited.\nInstances may be preempted to free up resources for standard VM instances,\nand will only be able to run for a limited amount of time. Preemptible\ninstances can not be restarted and will not migrate.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--preemptible',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'PREEMPTIBLE'},
                                                                                                                               u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"The region of the subnetwork to attach. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--region',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGION'},
                                                                                                                               u'--restart-on-failure': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': True,
                                                                                                                                                         u'description': u'The instances will be restarted if they are terminated by Compute Engine.\nThis does not affect terminations performed by the user. Enabled by default, use *--no-restart-on-failure* to disable.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--restart-on-failure',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'RESTART_ON_FAILURE'},
                                                                                                                               u'--scopes': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'If not provided, the instance will be assigned the default scopes, described below.\n+\nSCOPE can be either the full URI of the scope or an alias. Available\naliases are:\n+\n  default\n    Scopes assigned to instances by default:\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n    - https://www.googleapis.com/auth/devstorage.read_only\n    - https://www.googleapis.com/auth/logging.write\n    - https://www.googleapis.com/auth/monitoring.write\n    - https://www.googleapis.com/auth/service.management.readonly\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  bigquery\n    - https://www.googleapis.com/auth/bigquery\n+\n  cloud-platform\n    - https://www.googleapis.com/auth/cloud-platform\n+\n  compute-ro\n    - https://www.googleapis.com/auth/compute.readonly\n+\n  compute-rw\n    - https://www.googleapis.com/auth/compute\n+\n  datastore\n    - https://www.googleapis.com/auth/datastore\n+\n  logging-write\n    - https://www.googleapis.com/auth/logging.write\n+\n  monitoring\n    - https://www.googleapis.com/auth/monitoring\n+\n  monitoring-write\n    - https://www.googleapis.com/auth/monitoring.write\n+\n  service-control\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  service-management\n    - https://www.googleapis.com/auth/service.management.readonly\n+\n  sql\n    - https://www.googleapis.com/auth/sqlservice\n+\n  sql-admin\n    - https://www.googleapis.com/auth/sqlservice.admin\n+\n  storage-full\n    - https://www.googleapis.com/auth/devstorage.full_control\n+\n  storage-ro\n    - https://www.googleapis.com/auth/devstorage.read_only\n+\n  storage-rw\n    - https://www.googleapis.com/auth/devstorage.read_write\n+\n  taskqueue\n    - https://www.googleapis.com/auth/taskqueue\n+\n  useraccounts-ro\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n+\n  useraccounts-rw\n    - https://www.googleapis.com/auth/cloud.useraccounts\n+\n  userinfo-email\n    - https://www.googleapis.com/auth/userinfo.email',
                                                                                                                                             u'group': u'create.3',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--scopes',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'SCOPE'},
                                                                                                                               u'--service-account': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"A service account is an identity attached to the instance. Its access tokens\ncan be accessed through the instance metadata server and are used to\nauthenticate applications on the instance. The account can be either an email\naddress or an alias corresponding to a service account. You can explicitly\nspecify the Compute Engine default service account using the 'default' alias.\n+\nIf not provided, the instance will get project's default service account.",
                                                                                                                                                      u'group': u'create.4',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--service-account',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'SERVICE_ACCOUNT'},
                                                                                                                               u'--subnet': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Specifies the subnet that the instances will be part of. If --network is\nalso specified subnet must be a subnetwork of network specified by\n--network.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--subnet',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'SUBNET'},
                                                                                                                               u'--tags': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Specifies a list of tags to apply to the instances for\nidentifying the instances to which network firewall rules will\napply. See gcloud_compute_firewall-rules_create(1) for more\ndetails.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--tags',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'TAG'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                              u'is_mutex': True,
                                                                                                                                              u'is_required': False},
                                                                                                                                u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                              u'is_mutex': True,
                                                                                                                                              u'is_required': False},
                                                                                                                                u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                              u'is_mutex': True,
                                                                                                                                              u'is_required': False},
                                                                                                                                u'create.4': {u'description': u'At most one of these may be specified:',
                                                                                                                                              u'is_mutex': True,
                                                                                                                                              u'is_required': False}},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'create',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'instance-templates',
                                                                                                                              u'create'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the instance template.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u"*(BETA)* *create* facilitates the creation of Google Compute Engine\nvirtual machine instance templates. For example, running:\n\n    $ create INSTANCE-TEMPLATE\n\nwill create one instance templates called 'INSTANCE-TEMPLATE'.\n\nInstance templates are global resources, and can be used to create\ninstances in any zone."}},
                                                                                                        u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine virtual machine instance templates.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'delete',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'instance-templates',
                                                                                                                              u'delete'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The resources to delete.',
                                                                                                                                      u'name': u'names',
                                                                                                                                      u'nargs': u'+',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine virtual machine\ninstance templates.\n'}},
                                                                                                        u'describe': {u'capsule': u'*(BETA)* Describe a virtual machine instance template.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'describe',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'compute',
                                                                                                                                u'instance-templates',
                                                                                                                                u'describe'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the resource to fetch.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine virtual machine instance template.\n'}},
                                                                                                        u'list': {u'capsule': u'*(BETA)* List Google Compute Engine instance templates.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--filter',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'EXPRESSION'},
                                                                                                                             u'--limit': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--limit',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'LIMIT'},
                                                                                                                             u'--no-uri': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-uri',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_URI'},
                                                                                                                             u'--page-size': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--page-size',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                                                             u'--regexp': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--regexp',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGEXP'},
                                                                                                                             u'--sort-by': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--sort-by',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'FIELD'},
                                                                                                                             u'--uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'URI'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'list',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'instance-templates',
                                                                                                                            u'list'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': [],
                                                                                                                                    u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                    u'name': u'names',
                                                                                                                                    u'nargs': u'*',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine instance templates in a project.\n\nBy default, instance templates from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                                u'EXAMPLES': u"To list all instance templates in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all instance templates in a project, run:\n\n  $ list --uri\n\nTo list all instance templates in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                                          u'flags': {},
                                                                                          u'group': True,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'instance-templates',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'beta',
                                                                                                    u'compute',
                                                                                                    u'instance-templates'],
                                                                                          u'positionals': [],
                                                                                          u'release': u'BETA',
                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Lists, creates, deletes, and modifies Compute Engine instance templates.\n\nMore information on Compute Engine instance templates can be found here:\n[](https://cloud.google.com/compute/docs/instance-templates)'}},
                                                                  u'instances': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine virtual machine instances.',
                                                                                 u'commands': {u'add-access-config': {u'capsule': u'*(BETA)* Create a Google Compute Engine virtual machine access configuration.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--access-config-name': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': u'external-nat',
                                                                                                                                                           u'description': u"Specifies the name of the new access configuration. ``external-nat''\nis used as the default if this flag is not provided.",
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--access-config-name',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'ACCESS_CONFIG_NAME'},
                                                                                                                                 u'--address': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Specifies the external IP address of the new access\nconfiguration. If this is not specified, then the service will\nchoose an available ephemeral IP address. If an explicit IP\naddress is given, then that IP address must be reserved by the\nproject and not be in use by another resource.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--address',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'ADDRESS'},
                                                                                                                                 u'--network-interface': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': u'nic0',
                                                                                                                                                          u'description': u'Specifies the name of the network interface which contains the access\nconfiguration. If this is not provided, then "nic0" is used\nas the default.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--network-interface',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'NETWORK_INTERFACE'},
                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--zone',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'add-access-config',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'compute',
                                                                                                                                u'instances',
                                                                                                                                u'add-access-config'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the instance.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*add-access-config* is used to create access configurations for network\ninterfaces of Google Compute Engine virtual machines.\n'}},
                                                                                               u'add-metadata': {u'capsule': u'*(BETA)* Add or update instance metadata.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--metadata': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': {},
                                                                                                                                            u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--metadata',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'dict',
                                                                                                                                            u'value': u'KEY=VALUE'},
                                                                                                                            u'--metadata-from-file': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': {},
                                                                                                                                                      u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--metadata-from-file',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'dict',
                                                                                                                                                      u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The zone of the instance to set metadata on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--zone',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'ZONE'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'add-metadata',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'compute',
                                                                                                                           u'instances',
                                                                                                                           u'add-metadata'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the instance whose metadata should be modified.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'add-metadata can be used to add or update the metadata of a\nvirtual machine instance. Every instance has access to a\nmetadata server that can be used to query metadata that has\nbeen set through this tool. For information on metadata, see\n[](https://cloud.google.com/compute/docs/metadata)\n\nOnly metadata keys that are provided are mutated. Existing\nmetadata entries will remain unaffected.\n'}},
                                                                                               u'add-tags': {u'capsule': u'*(BETA)* Add tags to Google Compute Engine virtual machine instances.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--tags': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Specifies strings to be attached to the instance for later\nidentifying the instance when adding network firewall rules.\nMultiple tags can be attached by repeating this flag.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--tags',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'TAG'},
                                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"The zone of the instance to set tags on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--zone',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'ZONE'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'add-tags',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'compute',
                                                                                                                       u'instances',
                                                                                                                       u'add-tags'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the instance whose tags should be modified.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u"*add-tags* is used to add tags to Google Compute Engine virtual\nmachine instances. For example, running:\n\n  $ add-tags example-instance --tags tag-1,tag-2\n\nwill add tags ``tag-1'' and ``tag-2'' to 'example-instance'.\n\nTags can be used to identify the instances when adding network\nfirewall rules. Tags can also be used to get firewall rules that\nalready exist to be applied to the instance. See\ngcloud_compute_firewall-rules_create(1) for more details.\n"}},
                                                                                               u'attach-disk': {u'capsule': u'*(BETA)* Attach a disk to an instance.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--csek-key-file',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'FILE'},
                                                                                                                           u'--device-name': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'An optional name that indicates the disk name the guest operating system will see. (Note: Device name does not correspond to mounted volume name)',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--device-name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'DEVICE_NAME'},
                                                                                                                           u'--disk': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the disk to attach to the instance.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--disk',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DISK'},
                                                                                                                           u'--mode': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [u'ro',
                                                                                                                                                    u'rw'],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': u'rw',
                                                                                                                                       u'description': u'Specifies the mode of the disk. _MODE_ must be one of:\n+\n*ro*::: Read-only.\n*rw*::: Read-write. It is an error to attach a disk in read-write mode to more than one instance.\n+',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--mode',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'MODE'},
                                                                                                                           u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--zone',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'ZONE'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'attach-disk',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'instances',
                                                                                                                          u'attach-disk'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the instance.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u"*attach-disk* is used to attach a disk to an instance. For example,\n\n  $ gcloud compute instances attach-disk example-instance --disk DISK --zone us-central1-a\n\nattaches the disk named 'DISK' to the instance named\n'example-instance' in zone ``us-central1-a''.\n"}},
                                                                                               u'create': {u'capsule': u'*(BETA)* Create Google Compute Engine virtual machine instances.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--accelerator': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"Attaches accelerators (e.g. GPUs) to the instances.\n+\n*type*::: The specific type (e.g. nvidia-tesla-k80 for nVidia Tesla K80)\nof accelerator to attach to the instances. Use 'gcloud compute\naccelerator-types list' to learn about all available accelerator types.\n+\n*count*::: The number of pieces of the accelerator to attach to the\ninstances. The default value is 1.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--accelerator',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'dict',
                                                                                                                                         u'value': u'type=TYPE,[count=COUNT]'},
                                                                                                                      u'--address': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Assigns the given external address to the instance that is created.\nThe address may be an IP address or the name or URI of an address\nresource. This option can only be used when creating a single instance.',
                                                                                                                                     u'group': u'create.1',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--address',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'ADDRESS'},
                                                                                                                      u'--boot-disk-auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': True,
                                                                                                                                                   u'description': u'Automatically delete boot disks when their instances are deleted. Enabled by default, use *--no-boot-disk-auto-delete* to disable.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--boot-disk-auto-delete',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'BOOT_DISK_AUTO_DELETE'},
                                                                                                                      u'--boot-disk-device-name': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The name the guest operating system will see for the boot disk as.  This\noption can only be specified if a new boot disk is being created (as\nopposed to mounting an existing persistent disk).',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--boot-disk-device-name',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'BOOT_DISK_DEVICE_NAME'},
                                                                                                                      u'--boot-disk-size': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The size of the boot disk. This option can only be specified if a new\nboot disk is being created (as opposed to mounting an existing\npersistent disk). The value must be a whole number followed by a size\nunit of ``KB'' for kilobyte, ``MB'' for megabyte, ``GB'' for gigabyte,\nor ``TB'' for terabyte. For example, ``10GB'' will produce a 10 gigabyte\ndisk. The minimum size a boot disk can have is 10 GB. Disk size must be a\nmultiple of 1 GB.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--boot-disk-size',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'BOOT_DISK_SIZE'},
                                                                                                                      u'--boot-disk-type': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The type of the boot disk. This option can only be specified if a new boot\ndisk is being created (as opposed to mounting an existing persistent\ndisk). To get a list of available disk types, run\n`$ gcloud compute disk-types list`.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--boot-disk-type',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'BOOT_DISK_TYPE'},
                                                                                                                      u'--can-ip-forward': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'If provided, allows the instances to send and receive packets with non-matching destination or source IP addresses.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--can-ip-forward',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'CAN_IP_FORWARD'},
                                                                                                                      u'--csek-key-file': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--csek-key-file',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'FILE'},
                                                                                                                      u'--custom-cpu': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--custom-cpu',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'CUSTOM_CPU'},
                                                                                                                      u'--custom-memory': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--custom-memory',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'CUSTOM_MEMORY'},
                                                                                                                      u'--description': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Specifies a textual description of the instances.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--description',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'DESCRIPTION'},
                                                                                                                      u'--disk': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"Attaches persistent disks to the instances. The disks\nspecified must already exist.\n+\n*name*::: The disk to attach to the instances. When creating\nmore than one instance and using this property, the only valid\nmode for attaching the disk is read-only (see *mode* below).\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default. It is an error for mode\nto be ``rw'' when creating more than one instance because\nread-write disks can only be attached to a single instance.\n+\n*boot*::: If ``yes'', indicates that this is a boot disk. The\nvirtual machines will use the first partition of the disk for\ntheir root file systems. The default value for this is ``no''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--disk',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'dict',
                                                                                                                                  u'value': u'DISK'},
                                                                                                                      u'--image': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"Specifies the boot image for the instances. For each\ninstance, a new boot disk will be created from the given\nimage. Each boot disk will have the same name as the\ninstance. To view a list of public images and projects, run\n`$ gcloud compute images list`.\n+\nWhen using this option, ``--boot-disk-device-name'' and\n``--boot-disk-size'' can be used to override the boot disk's\ndevice name and size, respectively.",
                                                                                                                                   u'group': u'create.2',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--image',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'IMAGE'},
                                                                                                                      u'--image-family': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"The family of the image that the boot disk will be initialized\nwith. When a family is specified instead of an image, the latest\nnon-deprecated image associated with that family is used.\n+\nBy default, ``debian-8'' is assumed for this flag.",
                                                                                                                                          u'group': u'create.2',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--image-family',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'IMAGE_FAMILY'},
                                                                                                                      u'--image-project': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The project against which all image and image family references will be\nresolved. See ``--image'' for more details.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--image-project',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'IMAGE_PROJECT'},
                                                                                                                      u'--local-ssd': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"Attaches a local SSD to the instances.\n+\nThis flag is currently in BETA and may change without notice.\n+\n*device-name*::: Optional. A name that indicates the disk name\nthe guest operating system will see.  If omitted, a device name\nof the form ``local-ssd-N'' will be used.\n+\n*interface*::: Optional. The kind of disk interface exposed to the VM\nfor this SSD.  Valid values are ``SCSI'' and ``NVME''.  SCSI is\nthe default and is supported by more guest operating systems.  NVME\nmay provide higher performance.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--local-ssd',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'dict',
                                                                                                                                       u'value': u'LOCAL_SSD'},
                                                                                                                      u'--machine-type': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--machine-type',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'MACHINE_TYPE'},
                                                                                                                      u'--maintenance-policy': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [u'MIGRATE',
                                                                                                                                                             u'TERMINATE'],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--maintenance-policy',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'MAINTENANCE_POLICY'},
                                                                                                                      u'--metadata': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': {},
                                                                                                                                      u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--metadata',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'dict',
                                                                                                                                      u'value': u'KEY=VALUE'},
                                                                                                                      u'--metadata-from-file': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': {},
                                                                                                                                                u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--metadata-from-file',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'dict',
                                                                                                                                                u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                                                      u'--network': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Specifies the network that the instances will be part of. If --subnet is\nalso specified subnet must be a subnetwork of network specified by\n--network. If neither is specified, this defaults to the "default"\nnetwork.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--network',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'NETWORK'},
                                                                                                                      u'--network-interface': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Adds a network interface to the instance. Mutually exclusive with\n--address, --network, --network-tier, --subnet, and --private-network-ip\nflags.\n+\nThe following keys are allowed:\n*address*::: Assigns the given external address to the instance that is\ncreated. Specifying an empty string will assign an ephemeral IP.\nMutually exclusive with no-address. If neither key is present the\ninstance will get an ephemeral IP.\n+\n*network*::: Specifies the network that the interface will be part of.\nIf subnet is also specified it must be subnetwork of this network. If\nneither is specified, this defaults to the "default" network.\n+\n*no-address*::: If specified the interface will have no external IP.\nMutually exclusive with address. If neither key is present the\ninstance will get an ephemeral IP.\n+\n*private-network-ip*::: Assigns the given RFC1918 IP address to the\ninterface.\n+\n*subnet*::: Specifies the subnet that the interface will be part of.\nIf network key is also specified this must be a subnetwork of the\nspecified network.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--network-interface',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'dict',
                                                                                                                                               u'value': u'PROPERTY=VALUE'},
                                                                                                                      u'--no-address': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'If provided, the instances will not be assigned external IP addresses.',
                                                                                                                                        u'group': u'create.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--no-address',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ADDRESS'},
                                                                                                                      u'--no-boot-disk-auto-delete': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': True,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-boot-disk-auto-delete',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_BOOT_DISK_AUTO_DELETE'},
                                                                                                                      u'--no-can-ip-forward': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': True,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-can-ip-forward',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_CAN_IP_FORWARD'},
                                                                                                                      u'--no-preemptible': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-preemptible',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_PREEMPTIBLE'},
                                                                                                                      u'--no-require-csek-key-create': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': True,
                                                                                                                                                        u'description': u'',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': True,
                                                                                                                                                        u'name': u'--no-require-csek-key-create',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'NO_REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                      u'--no-restart-on-failure': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': True,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-restart-on-failure',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                                                      u'--no-scopes': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Create instance without scopes',
                                                                                                                                       u'group': u'create.3',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--no-scopes',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_SCOPES'},
                                                                                                                      u'--no-service-account': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Create instance without service account',
                                                                                                                                                u'group': u'create.4',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--no-service-account',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                                                      u'--preemptible': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'If provided, instances will be preemptible and time-limited.\nInstances may be preempted to free up resources for standard VM instances,\nand will only be able to run for a limited amount of time. Preemptible\ninstances can not be restarted and will not migrate.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--preemptible',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'PREEMPTIBLE'},
                                                                                                                      u'--private-network-ip': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Specifies the RFC1918 IP to assign to the instance. The IP should be in\nthe subnet or legacy network IP range.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--private-network-ip',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PRIVATE_NETWORK_IP'},
                                                                                                                      u'--require-csek-key-create': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': True,
                                                                                                                                                     u'description': u'Refuse to create resources not protected by a user managed key in\nthe key file when --csek-key-file is given. This behavior is enabled\nby default to prevent incorrect gcloud invocations from accidentally\ncreating resources with no user managed key. Disabling the check\nallows creation of some resources without a matching\nCustomer-Supplied Encryption Key in the supplied --csek-key-file.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details. Enabled by default, use *--no-require-csek-key-create* to disable.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--require-csek-key-create',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'REQUIRE_CSEK_KEY_CREATE'},
                                                                                                                      u'--restart-on-failure': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'The instances will be restarted if they are terminated by Compute Engine.\nThis does not affect terminations performed by the user. Enabled by default, use *--no-restart-on-failure* to disable.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--restart-on-failure',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'RESTART_ON_FAILURE'},
                                                                                                                      u'--scopes': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'If not provided, the instance will be assigned the default scopes, described below.\n+\nSCOPE can be either the full URI of the scope or an alias. Available\naliases are:\n+\n  default\n    Scopes assigned to instances by default:\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n    - https://www.googleapis.com/auth/devstorage.read_only\n    - https://www.googleapis.com/auth/logging.write\n    - https://www.googleapis.com/auth/monitoring.write\n    - https://www.googleapis.com/auth/service.management.readonly\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  bigquery\n    - https://www.googleapis.com/auth/bigquery\n+\n  cloud-platform\n    - https://www.googleapis.com/auth/cloud-platform\n+\n  compute-ro\n    - https://www.googleapis.com/auth/compute.readonly\n+\n  compute-rw\n    - https://www.googleapis.com/auth/compute\n+\n  datastore\n    - https://www.googleapis.com/auth/datastore\n+\n  logging-write\n    - https://www.googleapis.com/auth/logging.write\n+\n  monitoring\n    - https://www.googleapis.com/auth/monitoring\n+\n  monitoring-write\n    - https://www.googleapis.com/auth/monitoring.write\n+\n  service-control\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  service-management\n    - https://www.googleapis.com/auth/service.management.readonly\n+\n  sql\n    - https://www.googleapis.com/auth/sqlservice\n+\n  sql-admin\n    - https://www.googleapis.com/auth/sqlservice.admin\n+\n  storage-full\n    - https://www.googleapis.com/auth/devstorage.full_control\n+\n  storage-ro\n    - https://www.googleapis.com/auth/devstorage.read_only\n+\n  storage-rw\n    - https://www.googleapis.com/auth/devstorage.read_write\n+\n  taskqueue\n    - https://www.googleapis.com/auth/taskqueue\n+\n  useraccounts-ro\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n+\n  useraccounts-rw\n    - https://www.googleapis.com/auth/cloud.useraccounts\n+\n  userinfo-email\n    - https://www.googleapis.com/auth/userinfo.email',
                                                                                                                                    u'group': u'create.3',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--scopes',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'SCOPE'},
                                                                                                                      u'--service-account': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A service account is an identity attached to the instance. Its access tokens\ncan be accessed through the instance metadata server and are used to\nauthenticate applications on the instance. The account can be either an email\naddress or an alias corresponding to a service account. You can explicitly\nspecify the Compute Engine default service account using the 'default' alias.\n+\nIf not provided, the instance will get project's default service account.",
                                                                                                                                             u'group': u'create.4',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--service-account',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'SERVICE_ACCOUNT'},
                                                                                                                      u'--subnet': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Specifies the subnet that the instances will be part of. If --network is\nalso specified subnet must be a subnetwork of network specified by\n--network.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--subnet',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'SUBNET'},
                                                                                                                      u'--tags': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Specifies a list of tags to apply to the instances for\nidentifying the instances to which network firewall rules will\napply. See gcloud_compute_firewall-rules_create(1) for more\ndetails.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--tags',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'TAG'},
                                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--zone',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'ZONE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False},
                                                                                                                       u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False},
                                                                                                                       u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False},
                                                                                                                       u'create.4': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False}},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'create',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'compute',
                                                                                                                     u'instances',
                                                                                                                     u'create'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The names of the instances.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAMES'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*create* facilitates the creation of Google Compute Engine\nvirtual machines. For example, running:\n\n  $ create example-instance-1 example-instance-2 example-instance-3 --zone us-central1-a\n\nwill create three instances called `example-instance-1`,\n`example-instance-2`, and `example-instance-3` in the\n`us-central1-a` zone.\n\nWhen an instance is in RUNNING state and the system begins to boot,\nthe instance creation is considered finished, and the command returns\nwith a list of new virtual machines.  Note that you usually cannot log\ninto a new instance until it finishes booting. Check the progress of an\ninstance using `gcloud compute instances get-serial-port-output`.\n\nFor more examples, refer to the *EXAMPLES* section below.\n',
                                                                                                                         u'EXAMPLES': u"To create an instance with the latest ``Red Hat Enterprise Linux\n7'' image available, run:\n\n  $ create example-instance --image-family rhel-7 --image-project rhel-cloud --zone us-central1-a\n"}},
                                                                                               u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine virtual machine instances.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--delete-disks': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [u'all',
                                                                                                                                                       u'boot',
                                                                                                                                                       u'data'],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"The types of disks to delete with instance deletion regardless\nof the disks' auto-delete configuration. When this flag is\nprovided, the auto-delete bits on the attached disks are\nmodified accordingly before the instance deletion requests are\nissued. For more information on disk auto-deletion, see\n[](https://cloud.google.com/compute/docs/disks/persistent-disks#updateautodelete). _DISK-TYPE_ must be one of:\n+\n*all*::: All disk types.\n*boot*::: The first partition is reserved for the root filesystem.\n*data*::: A non-boot disk.\n+",
                                                                                                                                          u'group': u'delete.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--delete-disks',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'DISK-TYPE'},
                                                                                                                      u'--keep-disks': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [u'all',
                                                                                                                                                     u'boot',
                                                                                                                                                     u'data'],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The types of disks to not delete with instance deletion regardless\nof the disks' auto-delete configuration. When this flag is\nprovided, the auto-delete bits on the attached disks are\nmodified accordingly before the instance deletion requests are\nissued. For more information on disk auto-deletion, see\n[](https://cloud.google.com/compute/docs/disks/persistent-disks#updateautodelete). _DISK-TYPE_ must be one of:\n+\n*all*::: All disk types.\n*boot*::: The first partition is reserved for the root filesystem.\n*data*::: A non-boot disk.\n+",
                                                                                                                                        u'group': u'delete.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--keep-disks',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DISK-TYPE'},
                                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--zone',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'ZONE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False}},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'delete',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'compute',
                                                                                                                     u'instances',
                                                                                                                     u'delete'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The names of the instances.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAMES'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine virtual machine\ninstances.\n'}},
                                                                                               u'delete-access-config': {u'capsule': u'*(BETA)* Delete an access configuration from a virtual machine network interface.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--access-config-name': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': u'external-nat',
                                                                                                                                                              u'description': u"Specifies the name of the access configuration to delete.\n``external-nat'' is used as the default if this flag is not provided.",
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--access-config-name',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'ACCESS_CONFIG_NAME'},
                                                                                                                                    u'--network-interface': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': u'nic0',
                                                                                                                                                             u'description': u"Specifies the name of the network interface from which to delete the\naccess configuration. If this is not provided, then ``nic0'' is used\nas the default.",
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--network-interface',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'NETWORK_INTERFACE'},
                                                                                                                                    u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--zone',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'ZONE'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'delete-access-config',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'beta',
                                                                                                                                   u'compute',
                                                                                                                                   u'instances',
                                                                                                                                   u'delete-access-config'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The name of the instance.',
                                                                                                                                           u'name': u'name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'NAME'}],
                                                                                                                         u'release': u'BETA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* *delete-access-config* is used to delete access configurations from network\ninterfaces of Google Compute Engine virtual machines.'}},
                                                                                               u'describe': {u'capsule': u'*(BETA)* Describe a virtual machine instance.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--zone',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'ZONE'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'compute',
                                                                                                                       u'instances',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the resource to fetch.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine virtual machine instance.\n'}},
                                                                                               u'detach-disk': {u'capsule': u'*(BETA)* Detach disks from Compute Engine virtual machine instances.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--device-name': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"Specifies a disk to detach by its device name, which is the name\nthat the guest operating system sees. The device name is set\nat the time that the disk is attached to the instance, and needs not be\nthe same as the persistent disk name. If the disk's device name is\nspecified, then its persistent disk name must not be specified\nusing the ``--disk'' flag.",
                                                                                                                                              u'group': u'detach-disk.1',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--device-name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'DEVICE_NAME'},
                                                                                                                           u'--disk': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"Specifies a disk to detach by its resource name. If you specify a\ndisk to remove by persistent disk name, then you must not specify its\ndevice name using the ``--device-name'' flag.",
                                                                                                                                       u'group': u'detach-disk.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--disk',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DISK'},
                                                                                                                           u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--zone',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'ZONE'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {u'detach-disk.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                               u'is_mutex': True,
                                                                                                                                               u'is_required': True}},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'detach-disk',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'instances',
                                                                                                                          u'detach-disk'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the instance.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* *detach-disk* is used to detach disks from virtual machines.\n\nDetaching a disk without first unmounting it may result in\nincomplete I/O operations and data corruption.\nTo unmount a persistent disk on a Linux-based image,\nssh into the instance and run:\n\n    $ sudo umount /dev/disk/by-id/google-DEVICE_NAME'}},
                                                                                               u'get-serial-port-output': {u'capsule': u"*(BETA)* Read output from a virtual machine instance's serial port.",
                                                                                                                           u'commands': {},
                                                                                                                           u'flags': {u'--port': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Instances can support up to four serial port outputs, numbered 1 through\n4. By default, this command will return the output of the first serial\nport. Setting this flag will return the output of the requested serial\nport.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--port',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'PORT'},
                                                                                                                                      u'--start': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Specifies the byte index (zero-based) of the first byte you want\nreturned.  Use this flag if you want to continue getting the output from\na previous request that was too long to return in one attempt.  The last\nbyte returned in a request will be reported on STDERR.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--start',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'START'},
                                                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--zone',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'ZONE'}},
                                                                                                                           u'group': False,
                                                                                                                           u'groups': {},
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'get-serial-port-output',
                                                                                                                           u'path': [u'gcloud',
                                                                                                                                     u'beta',
                                                                                                                                     u'compute',
                                                                                                                                     u'instances',
                                                                                                                                     u'get-serial-port-output'],
                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The name of the instance.',
                                                                                                                                             u'name': u'name',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'NAME'}],
                                                                                                                           u'release': u'BETA',
                                                                                                                           u'sections': {u'DESCRIPTION': u"get-serial-port-output is used to get the output from a Google Compute\nEngine virtual machine's serial port. The serial port output\nfrom the virtual machine will be printed to standard output. This\ninformation can be useful for diagnostic purposes.\n"}},
                                                                                               u'list': {u'capsule': u'*(BETA)* List Google Compute Engine instances.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--regexp': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--regexp',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'REGEXP'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'},
                                                                                                                    u'--zones': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': [],
                                                                                                                                 u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--zones',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'ZONE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'instances',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': [],
                                                                                                                           u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'*',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine instances in a project.\n\nBy default, instances from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                       u'EXAMPLES': u"To list all instances in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all instances in a project, run:\n\n  $ list --uri\n\nTo list all instances in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}},
                                                                                               u'move': {u'capsule': u'*(BETA)* Move an instance between zones.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--async',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'ASYNC'},
                                                                                                                    u'--destination-zone': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The zone to move the instance to.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--destination-zone',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'DESTINATION_ZONE'},
                                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_ASYNC'},
                                                                                                                    u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--zone',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'ZONE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'move',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'instances',
                                                                                                                   u'move'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the instance.',
                                                                                                                           u'name': u'name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*move* facilitates moving a Google Compute Engine virtual machine\nfrom one zone to another. Moving a virtual machine may incur downtime\nif the guest OS must be shutdown in order to quiesce disk volumes\nprior to snapshotting.\n\nFor example, running:\n\n   $ gcloud compute instances move example-instance-1 --zone us-central1-b --destination-zone us-central1-f\n\nwill move the instance called example-instance-1, currently running in\nus-central1-b, to us-central1-f.\n'}},
                                                                                               u'remove-metadata': {u'capsule': u'*(BETA)* Remove instance metadata.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--all': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'If provided, all metadata entries are removed.',
                                                                                                                                          u'group': u'remove-metadata.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--all',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'ALL'},
                                                                                                                               u'--keys': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The keys of the entries to remove.',
                                                                                                                                           u'group': u'remove-metadata.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--keys',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'KEY'},
                                                                                                                               u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The zone of the instance to set metadata on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--zone',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'ZONE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {u'remove-metadata.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                       u'is_required': False}},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'remove-metadata',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'instances',
                                                                                                                              u'remove-metadata'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the instance whose metadata should be modified.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'remove-metadata can be used to remove instance metadata entries.\n'}},
                                                                                               u'remove-tags': {u'capsule': u'*(BETA)* Remove tags from Google Compute Engine virtual machine instances.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--all': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'Remove all tags from the instance.',
                                                                                                                                      u'group': u'remove-tags.1',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--all',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'ALL'},
                                                                                                                           u'--tags': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Specifies strings to be removed from the instance tags.\nMultiple tags can be removed by repeating this flag.',
                                                                                                                                       u'group': u'remove-tags.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--tags',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'TAG'},
                                                                                                                           u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The zone of the instance to set tags on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--zone',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'ZONE'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {u'remove-tags.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                               u'is_mutex': True,
                                                                                                                                               u'is_required': True}},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'remove-tags',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'instances',
                                                                                                                          u'remove-tags'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the instance whose tags should be modified.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u"*remove-tags* is used to remove tags to Google Compute Engine virtual\nmachine instances.  For example:\n\n  $ remove-tags example-instance --tags tag-1,tag-2\n\nwill remove tags ``tag-1'' and ``tag-2'' from the existing tags of\n'example-instance'.\n\nTags can be used to identify instances when adding network\nfirewall rules. Tags can also be used to get firewall rules that already\nexist to be applied to the instance. See\ngcloud_compute_firewall-rules_create(1) for more details.\n"}},
                                                                                               u'reset': {u'capsule': u'*(BETA)* Reset a virtual machine instance.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--zone',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'reset',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'instances',
                                                                                                                    u'reset'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The names of the instances.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'+',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAMES'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*reset* is used to perform a hard reset on a Google\nCompute Engine virtual machine.\n'}},
                                                                                               u'set-disk-auto-delete': {u'capsule': u'*(BETA)* Set auto-delete behavior for disks.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': True,
                                                                                                                                                       u'description': u'Enables auto-delete for the given disk. Enabled by default, use *--no-auto-delete* to disable.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--auto-delete',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'AUTO_DELETE'},
                                                                                                                                    u'--device-name': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u"Specifies a disk to set auto-delete for by its device name,\nwhich is the name that the guest operating system sees. The\ndevice name is set at the time that the disk is attached to the\ninstance, and need not be the same as the persistent disk name.\nIf the disk's device name is specified, then its persistent disk\nname must not be specified using the ``--disk'' flag.",
                                                                                                                                                       u'group': u'set-disk-auto-delete.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--device-name',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'DEVICE_NAME'},
                                                                                                                                    u'--disk': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"Specifies a disk to set auto-delete for by its resource name. If\nyou specify a disk to set auto-delete for by persistent disk name,\nthen you must not specify its device name using the\n``--device-name'' flag.",
                                                                                                                                                u'group': u'set-disk-auto-delete.1',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--disk',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'DISK'},
                                                                                                                                    u'--no-auto-delete': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': True,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-auto-delete',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_AUTO_DELETE'},
                                                                                                                                    u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--zone',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'ZONE'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {u'set-disk-auto-delete.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                                 u'is_mutex': True,
                                                                                                                                                                 u'is_required': True}},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'set-disk-auto-delete',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'beta',
                                                                                                                                   u'compute',
                                                                                                                                   u'instances',
                                                                                                                                   u'set-disk-auto-delete'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The name of the instance.',
                                                                                                                                           u'name': u'name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'NAME'}],
                                                                                                                         u'release': u'BETA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*$set-disk-auto-delete* is used to configure the auto-delete behavior for disks\nattached to Google Compute Engine virtual machines. When\nauto-delete is on, the persistent disk is deleted when the\ninstance it is attached to is deleted.\n'}},
                                                                                               u'set-machine-type': {u'capsule': u'*(BETA)* Set machine type for Google Compute Engine virtual machines.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--custom-cpu': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--custom-cpu',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'CUSTOM_CPU'},
                                                                                                                                u'--custom-memory': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--custom-memory',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'CUSTOM_MEMORY'},
                                                                                                                                u'--machine-type': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--machine-type',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'MACHINE_TYPE'},
                                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--zone',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'set-machine-type',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'instances',
                                                                                                                               u'set-machine-type'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the instance.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u"``set-machine-type'' allows you to change the machine type of a virtual machine\nin the *TERMINATED* state (that is, a virtual machine instance that\nhas been stopped).\n\nFor example, if ``example-instance'' is a ``g1-small'' virtual machine\ncurrently in the *TERMINATED* state, running:\n\n  $ set-machine-type example-instance --zone us-central1-b --machine-type n1-standard-4\n\nwill change the machine type to ``n1-standard-4'', so that when you\nnext start ``example-instance'', it will be provisioned as an\n``n1-standard-4'' instead of a ``g1-small''.\n\nSee [](https://cloud.google.com/compute/docs/machine-types) for more\ninformation on machine types.\n"}},
                                                                                               u'set-scheduling': {u'capsule': u'*(BETA)* Set scheduling options for Google Compute Engine virtual machines.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--maintenance-policy': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [u'MIGRATE',
                                                                                                                                                                     u'TERMINATE'],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--maintenance-policy',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'MAINTENANCE_POLICY'},
                                                                                                                              u'--no-restart-on-failure': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': False,
                                                                                                                                                           u'description': u'',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': True,
                                                                                                                                                           u'name': u'--no-restart-on-failure',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                                                              u'--restart-on-failure': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': False,
                                                                                                                                                        u'description': u'The instances will be restarted if they are terminated by Compute\nEngine.  This does not affect terminations performed by the user.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--restart-on-failure',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'RESTART_ON_FAILURE'},
                                                                                                                              u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--zone',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'ZONE'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'set-scheduling',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'beta',
                                                                                                                             u'compute',
                                                                                                                             u'instances',
                                                                                                                             u'set-scheduling'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the instance.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'BETA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*$set-scheduling* is used to configure scheduling options for Google Compute\nEngine virtual machines.\n'}},
                                                                                               u'set-scopes': {u'capsule': u'*(BETA)* Set scopes and service account for a Google Compute Engine instance.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--no-scopes': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'Remove all scopes from the instance',
                                                                                                                                           u'group': u'set-scopes.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--no-scopes',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_SCOPES'},
                                                                                                                          u'--no-service-account': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Remove service account from the instance',
                                                                                                                                                    u'group': u'set-scopes.2',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--no-service-account',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                                                          u'--scopes': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'If not provided, the instance will keep the scopes it currently has.\n+\nSCOPE can be either the full URI of the scope or an alias. Available\naliases are:\n+\n  default\n    Scopes assigned to instances by default:\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n    - https://www.googleapis.com/auth/devstorage.read_only\n    - https://www.googleapis.com/auth/logging.write\n    - https://www.googleapis.com/auth/monitoring.write\n    - https://www.googleapis.com/auth/service.management.readonly\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  bigquery\n    - https://www.googleapis.com/auth/bigquery\n+\n  cloud-platform\n    - https://www.googleapis.com/auth/cloud-platform\n+\n  compute-ro\n    - https://www.googleapis.com/auth/compute.readonly\n+\n  compute-rw\n    - https://www.googleapis.com/auth/compute\n+\n  datastore\n    - https://www.googleapis.com/auth/datastore\n+\n  logging-write\n    - https://www.googleapis.com/auth/logging.write\n+\n  monitoring\n    - https://www.googleapis.com/auth/monitoring\n+\n  monitoring-write\n    - https://www.googleapis.com/auth/monitoring.write\n+\n  service-control\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  service-management\n    - https://www.googleapis.com/auth/service.management.readonly\n+\n  sql\n    - https://www.googleapis.com/auth/sqlservice\n+\n  sql-admin\n    - https://www.googleapis.com/auth/sqlservice.admin\n+\n  storage-full\n    - https://www.googleapis.com/auth/devstorage.full_control\n+\n  storage-ro\n    - https://www.googleapis.com/auth/devstorage.read_only\n+\n  storage-rw\n    - https://www.googleapis.com/auth/devstorage.read_write\n+\n  taskqueue\n    - https://www.googleapis.com/auth/taskqueue\n+\n  useraccounts-ro\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n+\n  useraccounts-rw\n    - https://www.googleapis.com/auth/cloud.useraccounts\n+\n  userinfo-email\n    - https://www.googleapis.com/auth/userinfo.email',
                                                                                                                                        u'group': u'set-scopes.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--scopes',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'SCOPE'},
                                                                                                                          u'--service-account': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"A service account is an identity attached to the instance. Its access tokens\ncan be accessed through the instance metadata server and are used to\nauthenticate applications on the instance. The account can be either an email\naddress or an alias corresponding to a service account. You can explicitly\nspecify the Compute Engine default service account using the 'default' alias.\n+\nIf not provided, the instance will keep the service account it currently has.",
                                                                                                                                                 u'group': u'set-scopes.2',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--service-account',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'SERVICE_ACCOUNT'},
                                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--zone',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ZONE'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {u'set-scopes.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False},
                                                                                                                           u'set-scopes.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                             u'is_mutex': True,
                                                                                                                                             u'is_required': False}},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'set-scopes',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'compute',
                                                                                                                         u'instances',
                                                                                                                         u'set-scopes'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the instance.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Set scopes and service account for a Google Compute Engine instance.'}},
                                                                                               u'start': {u'capsule': u'*(BETA)* Start a stopped virtual machine instance.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--csek-key-file',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'FILE'},
                                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--zone',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'start',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'instances',
                                                                                                                    u'start'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The names of the instances.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'+',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAMES'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'Start a stopped virtual machine instance.\n\n*start* is used to start a stopped Google Compute Engine virtual\nmachine. Only a stopped virtual machine can be started.\n'}},
                                                                                               u'stop': {u'capsule': u'*(BETA)* Stop a virtual machine instance.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--discard-local-ssd': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'If provided, local SSD data is discarded.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--discard-local-ssd',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'DISCARD_LOCAL_SSD'},
                                                                                                                    u'--no-discard-local-ssd': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-discard-local-ssd',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_DISCARD_LOCAL_SSD'},
                                                                                                                    u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--zone',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'ZONE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'stop',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'instances',
                                                                                                                   u'stop'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The names of the instances.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'+',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAMES'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*stop* is used stop a Google Compute Engine virtual machine.\nStopping a VM performs a clean shutdown, much like invoking the shutdown\nfunctionality of a workstation or laptop. Stopping a VM with a local SSD\nis not supported and will result in an API error.\n'}},
                                                                                               u'tail-serial-port-output': {u'capsule': u"*(BETA)* Periodically fetch new output from a virtual machine instance's     serial port and display it as it becomes available.",
                                                                                                                            u'commands': {},
                                                                                                                            u'flags': {u'--port': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Instances can support up to four serial port outputs, numbered 1 through\n4. By default, this command will return the output of the first serial\nport. Setting this flag will return the output of the requested serial\nport.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--port',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'PORT'},
                                                                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--zone',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'ZONE'}},
                                                                                                                            u'group': False,
                                                                                                                            u'groups': {},
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'tail-serial-port-output',
                                                                                                                            u'path': [u'gcloud',
                                                                                                                                      u'beta',
                                                                                                                                      u'compute',
                                                                                                                                      u'instances',
                                                                                                                                      u'tail-serial-port-output'],
                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The name of the instance.',
                                                                                                                                              u'name': u'name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'value': u'NAME'}],
                                                                                                                            u'release': u'BETA',
                                                                                                                            u'sections': {u'DESCRIPTION': u"tail-serial-port-output is used to tail the output from a Google Compute\nEngine virtual machine instance's serial port. The serial port output\nfrom the instance will be printed to standard output. This\ninformation can be useful for diagnostic purposes.\n"}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'instances',
                                                                                 u'path': [u'gcloud',
                                                                                           u'beta',
                                                                                           u'compute',
                                                                                           u'instances'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'BETA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine virtual machine instances.'}},
                                                                  u'machine-types': {u'capsule': u'*(BETA)* Read Google Compute Engine virtual machine types.',
                                                                                     u'commands': {u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine machine type.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--zone',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'ZONE'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'describe',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'compute',
                                                                                                                           u'machine-types',
                                                                                                                           u'describe'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the resource to fetch.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine machine type.\n'}},
                                                                                                   u'list': {u'capsule': u'*(BETA)* List Google Compute Engine machine types.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--limit',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_URI'},
                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--page-size',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                        u'--regexp': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--regexp',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REGEXP'},
                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'FIELD'},
                                                                                                                        u'--uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'URI'},
                                                                                                                        u'--zones': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--zones',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'ZONE'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'list',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'compute',
                                                                                                                       u'machine-types',
                                                                                                                       u'list'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': [],
                                                                                                                               u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                               u'name': u'names',
                                                                                                                               u'nargs': u'*',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine machine types in a project.\n\nBy default, machine types from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                           u'EXAMPLES': u"To list all machine types in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all machine types in a project, run:\n\n  $ list --uri\n\nTo list all machine types in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                                     u'flags': {},
                                                                                     u'group': True,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'machine-types',
                                                                                     u'path': [u'gcloud',
                                                                                               u'beta',
                                                                                               u'compute',
                                                                                               u'machine-types'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'BETA',
                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Read Google Compute Engine virtual machine types.'}},
                                                                  u'networks': {u'capsule': u'*(BETA)* List, create, and delete Google Compute Engine networks.',
                                                                                u'commands': {u'create': {u'capsule': u'*(BETA)* Create a Google Compute Engine network.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--description': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'An optional, textual description for the network.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--description',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DESCRIPTION'},
                                                                                                                     u'--mode': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [u'auto',
                                                                                                                                              u'custom',
                                                                                                                                              u'legacy'],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The network type. _NETWORK_TYPE_ must be one of:\n+\n*auto*::: Subnets are created automatically. This is the recommended selection.\n*custom*::: Create subnets manually.\n*legacy*::: Create an old style network that has a range and cannot have subnets.\n+',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--mode',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'NETWORK_TYPE'},
                                                                                                                     u'--range': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Specifies the IPv4 address range of legacy mode networks. The range\nmust be specified in CIDR format:\n[](http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing)\n+\nThis flag only works if mode is legacy.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--range',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'RANGE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'create',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'networks',
                                                                                                                    u'create'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the network.',
                                                                                                                            u'name': u'name',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* *create* is used to create virtual networks. A network\nperforms the same function that a router does in a home\nnetwork: it describes the network range and gateway IP\naddress, handles communication between instances, and serves\nas a gateway between instances and callers outside the\nnetwork.'}},
                                                                                              u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine networks.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'delete',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'networks',
                                                                                                                    u'delete'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The resources to delete.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'+',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nnetworks. Networks can only be deleted when no other resources\n(e.g., virtual machine instances) refer to them.\n'}},
                                                                                              u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine network.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'describe',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'compute',
                                                                                                                      u'networks',
                                                                                                                      u'describe'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The name of the resource to fetch.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with Google Compute\nEngine network in a project.\n'}},
                                                                                              u'list': {u'capsule': u'*(BETA)* List Google Compute Engine networks.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--filter',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                                   u'--limit': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--limit',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'LIMIT'},
                                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_URI'},
                                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--page-size',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                                   u'--regexp': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--regexp',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'REGEXP'},
                                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--sort-by',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'FIELD'},
                                                                                                                   u'--uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'URI'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'list',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'compute',
                                                                                                                  u'networks',
                                                                                                                  u'list'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': [],
                                                                                                                          u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                          u'name': u'names',
                                                                                                                          u'nargs': u'*',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine networks in a project.\n',
                                                                                                                      u'EXAMPLES': u'To list all networks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all networks in a project, run:\n\n  $ list --uri\n'}},
                                                                                              u'subnets': {u'capsule': u'*(BETA)* List, describe, and delete Google Compute Engine subnetworks.',
                                                                                                           u'commands': {u'create': {u'capsule': u'*(BETA)* Define a subnet for a network in custom subnet mode.',
                                                                                                                                     u'commands': {},
                                                                                                                                     u'flags': {u'--description': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'An optional description of this subnetwork.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--description',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                                u'--network': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The network to which the subnetwork belongs.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--network',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': True,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'NETWORK'},
                                                                                                                                                u'--range': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The IP space allocated to this subnetwork in CIDR format.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--range',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': True,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'RANGE'},
                                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u"The region of the subnetwork to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--region',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'REGION'}},
                                                                                                                                     u'group': False,
                                                                                                                                     u'groups': {},
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'create',
                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                               u'beta',
                                                                                                                                               u'compute',
                                                                                                                                               u'networks',
                                                                                                                                               u'subnets',
                                                                                                                                               u'create'],
                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The name of the subnetwork.',
                                                                                                                                                       u'name': u'name',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'value': u'NAME'}],
                                                                                                                                     u'release': u'BETA',
                                                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Define a subnet for a network in custom subnet mode.'}},
                                                                                                                         u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine subnetworks.',
                                                                                                                                     u'commands': {},
                                                                                                                                     u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--region',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'REGION'}},
                                                                                                                                     u'group': False,
                                                                                                                                     u'groups': {},
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'delete',
                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                               u'beta',
                                                                                                                                               u'compute',
                                                                                                                                               u'networks',
                                                                                                                                               u'subnets',
                                                                                                                                               u'delete'],
                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The resources to delete.',
                                                                                                                                                       u'name': u'names',
                                                                                                                                                       u'nargs': u'+',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'value': u'NAME'}],
                                                                                                                                     u'release': u'BETA',
                                                                                                                                     u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nsubnetworks. Subnetworks can only be deleted when no other resources\n(e.g., virtual machine instances) refer to them.\n'}},
                                                                                                                         u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine subnetwork.',
                                                                                                                                       u'commands': {},
                                                                                                                                       u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--region',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'REGION'}},
                                                                                                                                       u'group': False,
                                                                                                                                       u'groups': {},
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'describe',
                                                                                                                                       u'path': [u'gcloud',
                                                                                                                                                 u'beta',
                                                                                                                                                 u'compute',
                                                                                                                                                 u'networks',
                                                                                                                                                 u'subnets',
                                                                                                                                                 u'describe'],
                                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The name of the resource to fetch.',
                                                                                                                                                         u'name': u'name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'value': u'NAME'}],
                                                                                                                                       u'release': u'BETA',
                                                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* *describe* displays all data associated with a Google Compute\nEngine subnetwork.'}},
                                                                                                                         u'expand-ip-range': {u'capsule': u'*(BETA)* Expand the IP range of a Google Compute Engine subnetwork.',
                                                                                                                                              u'commands': {},
                                                                                                                                              u'flags': {u'--prefix-length': {u'attr': {},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The new prefix length of the subnet. It must be smaller than the original and in the private address space 10.0.0.0/8, 172.16.0.0/12 or 192.168.0.0/16 defined in RFC 1918.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--prefix-length',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': True,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'PREFIX_LENGTH'},
                                                                                                                                                         u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u"The region of the subnetwork to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--region',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'REGION'}},
                                                                                                                                              u'group': False,
                                                                                                                                              u'groups': {},
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'expand-ip-range',
                                                                                                                                              u'path': [u'gcloud',
                                                                                                                                                        u'beta',
                                                                                                                                                        u'compute',
                                                                                                                                                        u'networks',
                                                                                                                                                        u'subnets',
                                                                                                                                                        u'expand-ip-range'],
                                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The name of the subnetwork.',
                                                                                                                                                                u'name': u'name',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'value': u'NAME'}],
                                                                                                                                              u'release': u'BETA',
                                                                                                                                              u'sections': {u'DESCRIPTION': u'*expand-ip-range* is used to expand the IP range of a subnetwork in a custom\nmode network.\n',
                                                                                                                                                            u'EXAMPLES': u"To expand the IP range of ``SUBNET'' to /16, run:\n\n  $ expand-ip-range SUBNET --region us-central1 --prefix-length 16\n"}},
                                                                                                                         u'list': {u'capsule': u'*(BETA)* List Google Compute Engine subnetworks.',
                                                                                                                                   u'commands': {},
                                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--filter',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--limit',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                                              u'--network': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Only show subnetworks of a specific network.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--network',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'NETWORK'},
                                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': True,
                                                                                                                                                            u'description': u'',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': True,
                                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'bool',
                                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--page-size',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                                              u'--regexp': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--regexp',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'REGEXP'},
                                                                                                                                              u'--regions': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': [],
                                                                                                                                                             u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--regions',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'list',
                                                                                                                                                             u'value': u'REGION'},
                                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'list',
                                                                                                                                                             u'value': u'FIELD'},
                                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': False,
                                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--uri',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'URI'}},
                                                                                                                                   u'group': False,
                                                                                                                                   u'groups': {},
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'list',
                                                                                                                                   u'path': [u'gcloud',
                                                                                                                                             u'beta',
                                                                                                                                             u'compute',
                                                                                                                                             u'networks',
                                                                                                                                             u'subnets',
                                                                                                                                             u'list'],
                                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                                     u'default': [],
                                                                                                                                                     u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                                     u'name': u'names',
                                                                                                                                                     u'nargs': u'*',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'value': u'NAME'}],
                                                                                                                                   u'release': u'BETA',
                                                                                                                                   u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine subnetworks in a project.\n\nBy default, subnetworks from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                                                 u'EXAMPLES': u"To list all subnetworks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all subnetworks in a project, run:\n\n  $ list --uri\n\nTo list all subnetworks in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}}},
                                                                                                           u'flags': {},
                                                                                                           u'group': True,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'subnets',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'compute',
                                                                                                                     u'networks',
                                                                                                                     u'subnets'],
                                                                                                           u'positionals': [],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* List, describe, and delete Google Compute Engine subnetworks.'}},
                                                                                              u'switch-mode': {u'capsule': u'*(BETA)* Switch the mode of a Google Compute Engine network.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--mode': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The target mode of the network. Only support "custom" now.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--mode',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'MODE'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'switch-mode',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'compute',
                                                                                                                         u'networks',
                                                                                                                         u'switch-mode'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the network for which to switch mode.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*switch-mode* is used to change the mode of a network. Currently, only\nchanging from auto to custom mode is supported.\n',
                                                                                                                             u'EXAMPLES': u"To switch ``NETWORK'' to custom subnet mode, run:\n\n  $ switch-mode NETWORK --mode custom\n"}}},
                                                                                u'flags': {},
                                                                                u'group': True,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'networks',
                                                                                u'path': [u'gcloud',
                                                                                          u'beta',
                                                                                          u'compute',
                                                                                          u'networks'],
                                                                                u'positionals': [],
                                                                                u'release': u'BETA',
                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* List, create, and delete Google Compute Engine networks.'}},
                                                                  u'operations': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine operations.',
                                                                                  u'commands': {u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine operation.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--global': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'If provided, it is assumed the operation is global.',
                                                                                                                                       u'group': u'describe.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--global',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'GLOBAL'},
                                                                                                                         u'--no-user-accounts': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': True,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--no-user-accounts',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'NO_USER_ACCOUNTS'},
                                                                                                                         u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The region of the operation to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                       u'group': u'describe.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--region',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'REGION'},
                                                                                                                         u'--user-accounts': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'If provided, it is assumed that the requested operation is a Compute User Accounts operation. Mutually exclusive with --global, --region, and --zone flags.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--user-accounts',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'USER_ACCOUNTS'},
                                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The zone of the operation to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                     u'group': u'describe.1',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--zone',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'ZONE'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                          u'is_mutex': True,
                                                                                                                                          u'is_required': False}},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'compute',
                                                                                                                        u'operations',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the operation.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine operation in a project.\n',
                                                                                                                            u'EXAMPLES': u'To get details about a global operation, run:\n\n  $ describe OPERATION --global\n\nTo get details about a regional operation, run:\n\n  $ describe OPERATION --region us-central1\n\nTo get details about a zonal operation, run:\n\n  $ describe OPERATION --zone us-central1-a\n\nTo get details about a Compute User Accounts operation, run:\n\n  $ describe OPERATION --user-accounts\n'}},
                                                                                                u'list': {u'capsule': u'*(BETA)* List Google Compute Engine operations.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--accounts': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'If provided, all accounts resources are shown.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--accounts',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'ACCOUNTS'},
                                                                                                                     u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--global': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'If provided, all global resources are shown.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--global',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'GLOBAL'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-accounts': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-accounts',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ACCOUNTS'},
                                                                                                                     u'--no-global': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-global',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_GLOBAL'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--regexp': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--regexp',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'REGEXP'},
                                                                                                                     u'--regions': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'If arguments are provided, only resources from the given regions are shown. If no arguments are provided all regional operations are shown.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--regions',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'REGION'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'},
                                                                                                                     u'--zones': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'If arguments are provided, only resources from the given zones are shown. If no arguments are provided all zonal operations are shown.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--zones',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'operations',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': [],
                                                                                                                            u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'*',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine operations in a\nproject.\n\nBy default, all global, regional, zonal and Compute Accounts operations\nare listed. The results can be narrowed by providing combinations of\nthe --zones, --regions, --global and --accounts flags.\n\nNote: *list* displays operations fewer than 14 days old, up to a\nmaximum of 5000.\n',
                                                                                                                        u'EXAMPLES': u'To list all operations in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all operations in a project, run:\n\n  $ list --uri\n\nTo list all operations in zones us-central1-b and\neurope-west1-d, run:\n\n   $ list --zones us-central1-b,europe-west1-d\n\nTo list all global operations in a project, run:\n\n   $ list --global\n\nTo list all regional operations in a project, run:\n\n   $ list --regions ""\n\nTo list all operations in the us-central1 and europe-west1\nregions and all operations in the us-central1-a zone, run:\n\n   $ list --zones us-central1-a --regions us-central1,europe-west1\n\nTo list all Compute Accounts operations, run:\n\n   $ list --accounts\n'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'operations',
                                                                                  u'path': [u'gcloud',
                                                                                            u'beta',
                                                                                            u'compute',
                                                                                            u'operations'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'BETA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine operations.'}},
                                                                  u'project-info': {u'capsule': u'*(BETA)* Read and manipulate project-level data like quotas and metadata.',
                                                                                    u'commands': {u'add-metadata': {u'capsule': u'*(BETA)* Add or update project-wide metadata.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--metadata': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': {},
                                                                                                                                               u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--metadata',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'dict',
                                                                                                                                               u'value': u'KEY=VALUE'},
                                                                                                                               u'--metadata-from-file': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': {},
                                                                                                                                                         u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--metadata-from-file',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'dict',
                                                                                                                                                         u'value': u'KEY=LOCAL_FILE_PATH'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'add-metadata',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'project-info',
                                                                                                                              u'add-metadata'],
                                                                                                                    u'positionals': [],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*add-metadata* can be used to add or update project-wide\nmetadata. Every instance has access to a metadata server that\ncan be used to query metadata that has been set through this\ntool. Project-wide metadata entries are visible to all\ninstances. To set metadata for individual instances, use\n`gcloud compute instances add-metadata`. For information on\nmetadata, see\n[](https://cloud.google.com/compute/docs/metadata)\n\nOnly metadata keys that are provided are mutated. Existing\nmetadata entries will remain unaffected.\n'}},
                                                                                                  u'describe': {u'capsule': u'*(BETA)* Describe the Google Compute Engine project resource.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'describe',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'project-info',
                                                                                                                          u'describe'],
                                                                                                                u'positionals': [],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u"*describe* displays all data associated with the Google\nCompute Engine project resource. The project resource contains\ndata such as global quotas, common instance metadata, and the\nproject's creation time.\n"}},
                                                                                                  u'remove-metadata': {u'capsule': u'*(BETA)* Remove project-wide metadata entries.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--all': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'If provided, all metadata entries are removed.',
                                                                                                                                             u'group': u'remove-metadata.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--all',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'ALL'},
                                                                                                                                  u'--keys': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The keys of the entries to remove.',
                                                                                                                                              u'group': u'remove-metadata.1',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--keys',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'KEY'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {u'remove-metadata.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                          u'is_mutex': True,
                                                                                                                                                          u'is_required': False}},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'remove-metadata',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'beta',
                                                                                                                                 u'compute',
                                                                                                                                 u'project-info',
                                                                                                                                 u'remove-metadata'],
                                                                                                                       u'positionals': [],
                                                                                                                       u'release': u'BETA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*remove-metadata* can be used to remove project-wide metadata entries.\n'}},
                                                                                                  u'set-usage-bucket': {u'capsule': u'*(BETA)* Set the usage reporting bucket for a project.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--bucket': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The URI of a Google Cloud Storage bucket where the usage\nreport object should be stored. The Google Service Account for\nperforming usage reporting is granted write access to this bucket.\nThe user running this command must be an owner of the bucket.\n+\nTo clear the usage bucket, use --no-bucket.',
                                                                                                                                                 u'group': u'set-usage-bucket.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--bucket',
                                                                                                                                                 u'nargs': u'?',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'BUCKET'},
                                                                                                                                   u'--no-bucket': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Unsets the bucket. This disables usage report storage.',
                                                                                                                                                    u'group': u'set-usage-bucket.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--no-bucket',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_BUCKET'},
                                                                                                                                   u'--prefix': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"An optional prefix for the name of the usage report object stored in\nthe bucket. If not supplied, then this defaults to ``usage''. The\nreport is stored as a CSV file named PREFIX_gce_YYYYMMDD.csv where\nYYYYMMDD is the day of the usage according to Pacific Time. The prefix\nshould conform to Google Cloud Storage object naming conventions.\nThis flag must not be provided when clearing the usage bucket.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--prefix',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'PREFIX'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {u'set-usage-bucket.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                            u'is_required': False}},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'set-usage-bucket',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'beta',
                                                                                                                                  u'compute',
                                                                                                                                  u'project-info',
                                                                                                                                  u'set-usage-bucket'],
                                                                                                                        u'positionals': [],
                                                                                                                        u'release': u'BETA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*set-usage-bucket* is used to configure usage reporting for projects.\n\nSetting usage reporting will cause a log of usage per resource to be\nwritten to a specified Google Cloud Storage bucket daily. For example,\n\n  $ gcloud compute project-info set-usage-bucket --bucket gs://my-bucket\n\nwill cause logs of the form usage_gce_YYYYMMDD.csv to be written daily\nto the bucket `my-bucket`. To disable this feature, issue the command:\n\n  $ gcloud compute project-info set-usage-bucket --no-bucket\n'}}},
                                                                                    u'flags': {},
                                                                                    u'group': True,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'project-info',
                                                                                    u'path': [u'gcloud',
                                                                                              u'beta',
                                                                                              u'compute',
                                                                                              u'project-info'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'BETA',
                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate project-level data like quotas and metadata.'}},
                                                                  u'regions': {u'capsule': u'*(BETA)* List Google Compute Engine regions.',
                                                                               u'commands': {u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine region.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'describe',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'compute',
                                                                                                                     u'regions',
                                                                                                                     u'describe'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the resource to fetch.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine region.\n'}},
                                                                                             u'list': {u'capsule': u'*(BETA)* List Google Compute Engine regions.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_URI'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--regexp': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--regexp',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'REGEXP'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'},
                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'URI'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'list',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'compute',
                                                                                                                 u'regions',
                                                                                                                 u'list'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': [],
                                                                                                                         u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                         u'name': u'names',
                                                                                                                         u'nargs': u'*',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'NAME'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine regions in a project.\n',
                                                                                                                     u'EXAMPLES': u'To list all regions in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all regions in a project, run:\n\n  $ list --uri\n'}}},
                                                                               u'flags': {},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'regions',
                                                                               u'path': [u'gcloud',
                                                                                         u'beta',
                                                                                         u'compute',
                                                                                         u'regions'],
                                                                               u'positionals': [],
                                                                               u'release': u'BETA',
                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* List Google Compute Engine regions.'}},
                                                                  u'reset-windows-password': {u'capsule': u'*(BETA)* Reset and return a password for a Windows machine instance.',
                                                                                              u'commands': {},
                                                                                              u'flags': {u'--user': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"``USER'' specifies the username to get the password for.\nIf omitted, the username is derived from your authenticated\naccount email address.",
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--user',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'USER'},
                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--zone',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'ZONE'}},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'reset-windows-password',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'beta',
                                                                                                        u'compute',
                                                                                                        u'reset-windows-password'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The name of the instance.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'BETA',
                                                                                              u'sections': {u'DESCRIPTION': u'*reset-windows-password* allows a user to reset and retrieve a password for\na Windows virtual machine instance. If the Windows account does not\nexist, this command will cause the account to be created and the\npassword for that new account will be returned.\n\nFor Windows instances that are running a domain controller, running\nthis command creates a new domain user if the user does not exist,\nor resets the password if the user does exist. It is not possible to\nuse this command to create a local user on a domain-controller\ninstance.\n\nFor all other instances, including domain-joined instances, running\nthis command creates a local user or resets the password for a local\nuser.\n\nWARNING: Resetting a password for an existing user can cause the\nloss of data encrypted with the current Windows password, such as\nencrypted files or stored passwords.\n\nThe user running this command must have write permission for the\nGoogle Compute Engine project containing the Windows instance.\n'}},
                                                                  u'routers': {u'capsule': u'*(BETA)* List, create, and delete Google Compute Engine routers.',
                                                                               u'commands': {u'add-bgp-peer': {u'capsule': u'*(BETA)* Add a BGP peer to a router.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--advertised-route-priority': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The priority of routes advertised to this BGP peer. In the case where there is more than one matching route of maximum length, the routes with lowest priority value win. 0 <= priority <= 65535.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--advertised-route-priority',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'ADVERTISED_ROUTE_PRIORITY'},
                                                                                                                          u'--interface': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The interface of the peer being added.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--interface',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'INTERFACE'},
                                                                                                                          u'--peer-asn': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The asn of the peer being added.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--peer-asn',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PEER_ASN'},
                                                                                                                          u'--peer-ip-address': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The link local address of the peer.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--peer-ip-address',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'PEER_IP_ADDRESS'},
                                                                                                                          u'--peer-name': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The name of the peer being added.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--peer-name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'PEER_NAME'},
                                                                                                                          u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--region',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REGION'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'add-bgp-peer',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'compute',
                                                                                                                         u'routers',
                                                                                                                         u'add-bgp-peer'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the router.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'\n*add-bgp-peer* is used to add a BGP peer to a router.\n'}},
                                                                                             u'add-interface': {u'capsule': u'*(BETA)* Add an interface to a router.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--interface-name': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The name of the interface being added.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--interface-name',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': True,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'INTERFACE_NAME'},
                                                                                                                           u'--ip-address': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The link local address of the router for this interface.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--ip-address',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'IP_ADDRESS'},
                                                                                                                           u'--mask-length': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The mask for network used for the server IP address.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--mask-length',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'MASK_LENGTH'},
                                                                                                                           u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--region',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGION'},
                                                                                                                           u'--vpn-tunnel': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The tunnel of the interface being added.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--vpn-tunnel',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': True,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'VPN_TUNNEL'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'add-interface',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'routers',
                                                                                                                          u'add-interface'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the router.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'\n*add-interface* is used to add an interface to a router.\n'}},
                                                                                             u'create': {u'capsule': u'*(BETA)* Create a router.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--asn': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The BGP asn for this router',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--asn',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': True,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'ASN'},
                                                                                                                    u'--description': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'An optional description of this router.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--description',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                    u'--network': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The network for this router',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--network',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'NETWORK'},
                                                                                                                    u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"The region of the router to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--region',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'REGION'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'create',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'routers',
                                                                                                                   u'create'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the router.',
                                                                                                                           u'name': u'name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'\n*create* is used to create a router for use in dynamic\nrouting with vpn tunnels.\n'}},
                                                                                             u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine routers.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--region',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'REGION'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'delete',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'routers',
                                                                                                                   u'delete'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The resources to delete.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'+',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nrouters. Routers can only be deleted when no other resources\n(e.g., virtual machine instances) refer to them.\n'}},
                                                                                             u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine router.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--region',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'REGION'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'describe',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'compute',
                                                                                                                     u'routers',
                                                                                                                     u'describe'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the resource to fetch.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* *describe* displays all data associated with a Google Compute\nEngine router.'}},
                                                                                             u'get-status': {u'capsule': u'*(BETA)* Get status of a Google Compute Engine router.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--region',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REGION'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'get-status',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'compute',
                                                                                                                       u'routers',
                                                                                                                       u'get-status'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the resource to fetch.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* *get-status* displays all runtime data associated with a Google Compute\nEngine router.'}},
                                                                                             u'list': {u'capsule': u'*(BETA)* List Google Compute Engine routers.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_URI'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--regexp': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--regexp',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'REGEXP'},
                                                                                                                  u'--regions': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': [],
                                                                                                                                 u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--regions',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'REGION'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'},
                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'URI'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'list',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'compute',
                                                                                                                 u'routers',
                                                                                                                 u'list'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': [],
                                                                                                                         u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                         u'name': u'names',
                                                                                                                         u'nargs': u'*',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'NAME'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine routers in a project.\n\nBy default, routers from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                     u'EXAMPLES': u"To list all routers in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all routers in a project, run:\n\n  $ list --uri\n\nTo list all routers in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}},
                                                                                             u'remove-bgp-peer': {u'capsule': u'*(BETA)* Remove a BGP peer from a router.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--peer-name': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The name of the peer being removed.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--peer-name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PEER_NAME'},
                                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--region',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGION'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'remove-bgp-peer',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'routers',
                                                                                                                            u'remove-bgp-peer'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the router.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'\n*remove-bgp-peer* removes a BGP peer from a router.\n'}},
                                                                                             u'remove-interface': {u'capsule': u'*(BETA)* Remove an interface from a router.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--interface-name': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The name of the interface being removed.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--interface-name',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': True,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'INTERFACE_NAME'},
                                                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'remove-interface',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'beta',
                                                                                                                             u'compute',
                                                                                                                             u'routers',
                                                                                                                             u'remove-interface'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the router.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'BETA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'\n*remove-interface* removes an interface from a router.\n'}},
                                                                                             u'update-bgp-peer': {u'capsule': u'*(BETA)* Update a BGP peer on a router.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--advertised-route-priority': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The priority of routes advertised to this BGP peer. In the case where there is more than one matching route of maximum length, the routes with lowest priority value win. 0 <= priority <= 65535.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--advertised-route-priority',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'ADVERTISED_ROUTE_PRIORITY'},
                                                                                                                             u'--interface': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The new interface of the peer being modified.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--interface',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'INTERFACE'},
                                                                                                                             u'--ip-address': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The new link local address of the router for this peer.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--ip-address',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'IP_ADDRESS'},
                                                                                                                             u'--peer-asn': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The new asn of the peer being modified.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--peer-asn',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PEER_ASN'},
                                                                                                                             u'--peer-ip-address': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The new link local address of the peer.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--peer-ip-address',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'PEER_IP_ADDRESS'},
                                                                                                                             u'--peer-name': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The name of the peer being modified.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--peer-name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PEER_NAME'},
                                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--region',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGION'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'update-bgp-peer',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'routers',
                                                                                                                            u'update-bgp-peer'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the router.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'\n*update-bgp-peer* is used to update a BGP peer on a router.\n'}},
                                                                                             u'update-interface': {u'capsule': u'*(BETA)* Update an interface on a router.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--interface-name': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The name of the interface being updated.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--interface-name',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': True,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'INTERFACE_NAME'},
                                                                                                                              u'--ip-address': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The link local address of the router for this interface.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--ip-address',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'IP_ADDRESS'},
                                                                                                                              u'--mask-length': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The mask for network used for the server IP address.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--mask-length',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'MASK_LENGTH'},
                                                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--region',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGION'},
                                                                                                                              u'--vpn-tunnel': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The tunnel of the interface being updated.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--vpn-tunnel',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'VPN_TUNNEL'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'update-interface',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'beta',
                                                                                                                             u'compute',
                                                                                                                             u'routers',
                                                                                                                             u'update-interface'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the router.',
                                                                                                                                     u'name': u'name',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'BETA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'\n*update-interface* is used to update an interface on a router.\n'}}},
                                                                               u'flags': {},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'routers',
                                                                               u'path': [u'gcloud',
                                                                                         u'beta',
                                                                                         u'compute',
                                                                                         u'routers'],
                                                                               u'positionals': [],
                                                                               u'release': u'BETA',
                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* List, create, and delete Google Compute Engine routers.'}},
                                                                  u'routes': {u'capsule': u'*(BETA)* Read and manipulate routes.',
                                                                              u'commands': {u'create': {u'capsule': u'*(BETA)* Create a new route.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--description': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'An optional, textual description for the route.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--description',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                   u'--destination-range': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The destination range of outgoing packets that the route will\napply to. To match all traffic, use ``0.0.0.0/0''.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--destination-range',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'DESTINATION_RANGE'},
                                                                                                                   u'--network': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': u'default',
                                                                                                                                  u'description': u'Specifies the network to which the route will be applied.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--network',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'NETWORK'},
                                                                                                                   u'--next-hop-address': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"Specifies the IP address of an instance that should handle\nmatching packets. The instance must have IP forwarding enabled\n(i.e., include ``--can-ip-forward'' when creating the instance\nusing `gcloud compute instances create`)",
                                                                                                                                           u'group': u'create.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--next-hop-address',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'NEXT_HOP_ADDRESS'},
                                                                                                                   u'--next-hop-gateway': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"Specifies the gateway that should handle matching\npackets. Currently, the only acceptable value is\n``default-internet-gateway'' which is a gateway operated by\nGoogle Compute Engine.",
                                                                                                                                           u'group': u'create.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--next-hop-gateway',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'NEXT_HOP_GATEWAY'},
                                                                                                                   u'--next-hop-instance': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"Specifies the name of an instance that should handle traffic\nmatching this route. When this flag is specified, the zone of\nthe instance must be specified using\n``--next-hop-instance-zone''.",
                                                                                                                                            u'group': u'create.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--next-hop-instance',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'NEXT_HOP_INSTANCE'},
                                                                                                                   u'--next-hop-instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"The zone of the next hop instance. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--next-hop-instance-zone',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'NEXT_HOP_INSTANCE_ZONE'},
                                                                                                                   u'--next-hop-vpn-tunnel': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The target VPN tunnel that will receive forwarded traffic.',
                                                                                                                                              u'group': u'create.1',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--next-hop-vpn-tunnel',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'NEXT_HOP_VPN_TUNNEL'},
                                                                                                                   u'--next-hop-vpn-tunnel-region': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"The region of the next hop vpn tunnel. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--next-hop-vpn-tunnel-region',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'NEXT_HOP_VPN_TUNNEL_REGION'},
                                                                                                                   u'--priority': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': 1000,
                                                                                                                                   u'description': u'Specifies the priority of this route relative to other routes\nwith the same specificity. The lower the value, the higher the\npriority.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--priority',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'int',
                                                                                                                                   u'value': u'PRIORITY'},
                                                                                                                   u'--tags': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': [],
                                                                                                                               u'description': u'Identifies the set of instances that this route will apply to. If no\ntags are provided, the route will apply to all instances in the network.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--tags',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'TAG'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {u'create.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                  u'is_mutex': True,
                                                                                                                                  u'is_required': True}},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'create',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'compute',
                                                                                                                  u'routes',
                                                                                                                  u'create'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The name to assign to the route.',
                                                                                                                          u'name': u'name',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u"*create* is used to create routes. A route is a rule that\nspecifies how certain packets should be handled by the virtual\nnetwork. Routes are associated with virtual machine instances\nby tag, and the set of routes for a particular VM is called\nits routing table. For each packet leaving a virtual machine,\nthe system searches that machine's routing table for a single\nbest matching route.\n\nRoutes match packets by destination IP address, preferring\nsmaller or more specific ranges over larger ones (see\n``--destination-range''). If there is a tie, the system selects\nthe route with the smallest priority value. If there is still\na tie, it uses the layer three and four packet headers to\nselect just one of the remaining matching routes. The packet\nis then forwarded as specified by ``--next-hop-address'',\n``--next-hop-instance'', ``--next-hop-vpn-tunnel'', or\n``--next-hop-gateway'' of the winning route. Packets that do\nnot match any route in the sending virtual machine routing\ntable will be dropped.\n\nExactly one of ``--next-hop-address'', ``--next-hop-gateway'',\n``--next-hop-vpn-tunnel'', or ``--next-hop-instance'' must be\nprovided with this command.\n"}},
                                                                                            u'delete': {u'capsule': u'*(BETA)* Delete routes.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'delete',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'compute',
                                                                                                                  u'routes',
                                                                                                                  u'delete'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The resources to delete.',
                                                                                                                          u'name': u'names',
                                                                                                                          u'nargs': u'+',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine routes.\n'}},
                                                                                            u'describe': {u'capsule': u'*(BETA)* Describe a route.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'describe',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'routes',
                                                                                                                    u'describe'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the resource to fetch.',
                                                                                                                            u'name': u'name',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine route in a project.\n'}},
                                                                                            u'list': {u'capsule': u'*(BETA)* List Google Compute Engine routes.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--regexp': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--regexp',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'REGEXP'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'compute',
                                                                                                                u'routes',
                                                                                                                u'list'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': [],
                                                                                                                        u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                        u'name': u'names',
                                                                                                                        u'nargs': u'*',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'NAME'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine routes in a project.\n',
                                                                                                                    u'EXAMPLES': u'To list all routes in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all routes in a project, run:\n\n  $ list --uri\n'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'routes',
                                                                              u'path': [u'gcloud',
                                                                                        u'beta',
                                                                                        u'compute',
                                                                                        u'routes'],
                                                                              u'positionals': [],
                                                                              u'release': u'BETA',
                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate routes.'}},
                                                                  u'scp': {u'capsule': u'*(BETA)* Copy files to and from Google Compute Engine virtual machines via scp.',
                                                                           u'commands': {},
                                                                           u'flags': {u'--compress': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': False,
                                                                                                      u'description': u'Enable compression.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--compress',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'COMPRESS'},
                                                                                      u'--dry-run': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--dry-run',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'DRY_RUN'},
                                                                                      u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': False,
                                                                                                                      u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--force-key-file-overwrite',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'bool',
                                                                                                                      u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                      u'--no-compress': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': True,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--no-compress',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'NO_COMPRESS'},
                                                                                      u'--no-dry-run': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-dry-run',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_DRY_RUN'},
                                                                                      u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': True,
                                                                                                                         u'name': u'--no-force-key-file-overwrite',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                      u'--no-plain': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': True,
                                                                                                      u'description': u'',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': True,
                                                                                                      u'name': u'--no-plain',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'NO_PLAIN'},
                                                                                      u'--no-recurse': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-recurse',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_RECURSE'},
                                                                                      u'--plain': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': False,
                                                                                                   u'description': u'Suppresses the automatic addition of *ssh(1)*/*scp(1)* flags. This flag\nis useful if you want to take care of authentication yourself or\nuse specific ssh/scp features.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--plain',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'PLAIN'},
                                                                                      u'--port': {u'attr': {},
                                                                                                  u'category': u'',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'The port to connect to.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--port',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'string',
                                                                                                  u'value': u'PORT'},
                                                                                      u'--recurse': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'Upload directories recursively.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--recurse',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'RECURSE'},
                                                                                      u'--scp-flag': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Extra flag to be sent to scp. This flag may be repeated.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--scp-flag',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'SCP_FLAG'},
                                                                                      u'--ssh-key-file': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--ssh-key-file',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'SSH_KEY_FILE'},
                                                                                      u'--strict-host-key-checking': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [u'yes',
                                                                                                                                   u'no',
                                                                                                                                   u'ask'],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"Override the default behavior of StrictHostKeyChecking. By default,\nStrictHostKeyChecking is set to 'no' the first time you connect to an\ninstance and will be set to 'yes' for all subsequent connections. Use\nthis flag to specify a value for the connection. _STRICT_HOST_KEY_CHECKING_ must be one of: *yes*, *no*, *ask*.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--strict-host-key-checking',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'STRICT_HOST_KEY_CHECKING'},
                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                  u'category': u'',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u"The zone of the instance to copy files to/from.\n+\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--zone',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'string',
                                                                                                  u'value': u'ZONE'}},
                                                                           u'group': False,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'scp',
                                                                           u'path': [u'gcloud',
                                                                                     u'beta',
                                                                                     u'compute',
                                                                                     u'scp'],
                                                                           u'positionals': [{u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u'Specifies the files to copy.',
                                                                                             u'name': u'sources',
                                                                                             u'nargs': u'+',
                                                                                             u'required': False,
                                                                                             u'value': u'[[USER@]INSTANCE:]SRC'},
                                                                                            {u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u'Specifies a destination for the source files.',
                                                                                             u'name': u'destination',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'value': u'[[USER@]INSTANCE:]DEST'}],
                                                                           u'release': u'BETA',
                                                                           u'sections': {u'DESCRIPTION': u"*scp* copies files between a virtual machine instance\nand your local machine using the scp command.\n\nTo denote a remote file, prefix the file name with the virtual\nmachine instance name (e.g., _example-instance_:~/_FILE_). To\ndenote a local file, do not add a prefix to the file name\n(e.g., ~/_FILE_). For example, to copy a remote directory\nto your local host, run:\n\n  $ scp example-instance:~/REMOTE-DIR ~/LOCAL-DIR --zone us-central1-a\n\nIn the above example, ``~/REMOTE-DIR'' from ``example-instance'' is\ncopied into the ~/_LOCAL-DIR_ directory.\n\nConversely, files from your local computer can be copied to a\nvirtual machine:\n\n  $ scp ~/LOCAL-FILE-1 ~/LOCAL-FILE-2 example-instance:~/REMOTE-DIR --zone us-central1-a\n\nIf a file contains a colon (``:''), you must specify it by\neither using an absolute path or a path that begins with\n``./''.\n\nUnder the covers, *scp(1)* or pscp (on Windows) is used to facilitate the transfer.\n\nWhen the destination is local, all sources must be the same\nvirtual machine instance. When the destination is remote, all\nsource must be local.\n"}},
                                                                  u'snapshots': {u'capsule': u'*(BETA)* List, describe, and delete Google Compute Engine snapshots.',
                                                                                 u'commands': {u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine snapshots.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'delete',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'compute',
                                                                                                                     u'snapshots',
                                                                                                                     u'delete'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The resources to delete.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine snapshots.\n'}},
                                                                                               u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine snapshot.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'compute',
                                                                                                                       u'snapshots',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the resource to fetch.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine snapshot in a project.\n'}},
                                                                                               u'list': {u'capsule': u'*(BETA)* List Google Compute Engine snapshots.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--regexp': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--regexp',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'REGEXP'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'snapshots',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': [],
                                                                                                                           u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                           u'name': u'names',
                                                                                                                           u'nargs': u'*',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine snapshots in a project.\n',
                                                                                                                       u'EXAMPLES': u'To list all snapshots in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all snapshots in a project, run:\n\n  $ list --uri\n'}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'snapshots',
                                                                                 u'path': [u'gcloud',
                                                                                           u'beta',
                                                                                           u'compute',
                                                                                           u'snapshots'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'BETA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* List, describe, and delete Google Compute Engine snapshots.'}},
                                                                  u'ssh': {u'capsule': u'*(BETA)* SSH into a virtual machine instance.',
                                                                           u'commands': {},
                                                                           u'flags': {u'--command': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'A command to run on the virtual machine.\n+\nRuns the command on the target instance and then exits.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--command',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'COMMAND'},
                                                                                      u'--container': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of a container inside of the virtual machine instance to\nconnect to. This only applies to virtual machines that are using\na Google container virtual machine image. For more information,\nsee [](https://cloud.google.com/compute/docs/containers)',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--container',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'CONTAINER'},
                                                                                      u'--dry-run': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--dry-run',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'DRY_RUN'},
                                                                                      u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': False,
                                                                                                                      u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--force-key-file-overwrite',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'bool',
                                                                                                                      u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                      u'--no-dry-run': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-dry-run',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_DRY_RUN'},
                                                                                      u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': True,
                                                                                                                         u'name': u'--no-force-key-file-overwrite',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                      u'--no-plain': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': True,
                                                                                                      u'description': u'',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': True,
                                                                                                      u'name': u'--no-plain',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'NO_PLAIN'},
                                                                                      u'--plain': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': False,
                                                                                                   u'description': u'Suppresses the automatic addition of *ssh(1)*/*scp(1)* flags. This flag\nis useful if you want to take care of authentication yourself or\nuse specific ssh/scp features.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--plain',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'PLAIN'},
                                                                                      u'--ssh-flag': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Additional flags to be passed to *ssh(1)*. It is recommended that flags\nbe passed using an assignment operator and quotes. This flag will\nreplace occurences of ``%USER%\'\' and ``%INSTANCE%\'\' with their\ndereferenced values. Example:\n+\n  $ {command} example-instance --zone us-central1-a --ssh-flag="-vvv" --ssh-flag="-L 80:%INSTANCE%:80"\n+\nis equivalent to passing the flags ``--vvv\'\' and ``-L\n80:162.222.181.197:80\'\' to *ssh(1)* if the external IP address of\n\'example-instance\' is 162.222.181.197.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--ssh-flag',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'SSH_FLAG'},
                                                                                      u'--ssh-key-file': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--ssh-key-file',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'SSH_KEY_FILE'},
                                                                                      u'--strict-host-key-checking': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [u'yes',
                                                                                                                                   u'no',
                                                                                                                                   u'ask'],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"Override the default behavior of StrictHostKeyChecking. By default,\nStrictHostKeyChecking is set to 'no' the first time you connect to an\ninstance and will be set to 'yes' for all subsequent connections. Use\nthis flag to specify a value for the connection. _STRICT_HOST_KEY_CHECKING_ must be one of: *yes*, *no*, *ask*.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--strict-host-key-checking',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'STRICT_HOST_KEY_CHECKING'},
                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                  u'category': u'',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u"The zone of the instance to connect to. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--zone',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'string',
                                                                                                  u'value': u'ZONE'}},
                                                                           u'group': False,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'ssh',
                                                                           u'path': [u'gcloud',
                                                                                     u'beta',
                                                                                     u'compute',
                                                                                     u'ssh'],
                                                                           u'positionals': [{u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u"Specifies the instance to SSH into.\n+\n``USER'' specifies the username with which to SSH. If omitted,\n$USER from the environment is selected.",
                                                                                             u'name': u'user-host',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'value': u'[USER@]INSTANCE'},
                                                                                            {u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u"Flags and positionals passed to the underlying ssh implementation.\n+\n\nThe '--' argument must be specified between gcloud specific args on the left and SSH_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017. Example:\n+\n        $ {command} example-instance --zone us-central1-a -- -vvv -L 80:%INSTANCE%:80",
                                                                                             u'name': u'ssh-args',
                                                                                             u'nargs': u'...',
                                                                                             u'required': False,
                                                                                             u'value': u'SSH_ARGS'}],
                                                                           u'release': u'BETA',
                                                                           u'sections': {u'DESCRIPTION': u"*ssh* is a thin wrapper around the *ssh(1)* command that\ntakes care of authentication and the translation of the\ninstance name into an IP address.\n\nThis command uses the Compute Accounts API to ensure that the user's\npublic SSH key is availibe to the VM. This form of key management\nwill only work with VMs configured to work with the Compute Accounts\nAPI. If the user does not have a public SSH key, one is generated using\n*ssh-keygen(1)* (if `the --quiet` flag is given, the generated key will\nhave an empty passphrase).\n\n",
                                                                                         u'EXAMPLES': u'To SSH into \'example-instance\' in zone ``us-central1-a\'\', run:\n\n  $ ssh example-instance --zone us-central1-a\n\nYou can also run a command on the virtual machine. For\nexample, to get a snapshot of the guest\'s process tree, run:\n\n  $ ssh example-instance --zone us-central1-a --command "ps -ejH"\n\nIf you are using the Google container virtual machine image, you\ncan SSH into one of your containers with:\n\n  $ ssh example-instance --zone us-central1-a --container CONTAINER\n'}},
                                                                  u'ssl-certificates': {u'capsule': u'*(BETA)* List, create, and delete Google Compute Engine SSL certificates.',
                                                                                        u'commands': {u'create': {u'capsule': u'*(BETA)* Create a Google Compute Engine SSL certificate.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--certificate': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The path to a local certificate file. The certificate must be in PEM\nformat.  The certificate chain must be no greater than 5 certs long. The\nchain must include at least one intermediate cert.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--certificate',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': True,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'LOCAL_FILE_PATH'},
                                                                                                                             u'--description': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'An optional, textual description for the SSL certificate.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--description',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'DESCRIPTION'},
                                                                                                                             u'--private-key': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The path to a local private key file. The private key must be in PEM\nformat and must use RSA or ECDSA encryption.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--private-key',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': True,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'LOCAL_FILE_PATH'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'create',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'ssl-certificates',
                                                                                                                            u'create'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the SSL certificate.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* *create* is used to create SSL certificates which can be used to\nconfigure a target HTTPS proxy. An SSL certificate consists of a\ncertificate and private key. The private key is encrypted before it is\nstored.'}},
                                                                                                      u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine SSL certificates.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'delete',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'ssl-certificates',
                                                                                                                            u'delete'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The resources to delete.',
                                                                                                                                    u'name': u'names',
                                                                                                                                    u'nargs': u'+',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine SSL certificates.\nSSL certificates can only be deleted when no other resources (e.g.,\ntarget HTTPS proxies) refer to them.\n'}},
                                                                                                      u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine SSL certificate.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'describe',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'ssl-certificates',
                                                                                                                              u'describe'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the resource to fetch.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with Google Compute\nEngine SSL certificate in a project.\n'}},
                                                                                                      u'list': {u'capsule': u'*(BETA)* List Google Compute Engine SSL certificates.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--filter',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--limit',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--page-size',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                           u'--regexp': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--regexp',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGEXP'},
                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'FIELD'},
                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'URI'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'list',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'ssl-certificates',
                                                                                                                          u'list'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': [],
                                                                                                                                  u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                  u'name': u'names',
                                                                                                                                  u'nargs': u'*',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine SSL certificates in a project.\n',
                                                                                                                              u'EXAMPLES': u'To list all SSL certificates in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all SSL certificates in a project, run:\n\n  $ list --uri\n'}}},
                                                                                        u'flags': {},
                                                                                        u'group': True,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'ssl-certificates',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'beta',
                                                                                                  u'compute',
                                                                                                  u'ssl-certificates'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'BETA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* List, create, and delete Google Compute Engine SSL certificates.'}},
                                                                  u'target-http-proxies': {u'capsule': u'*(BETA)* List, create, and delete target HTTP proxies.',
                                                                                           u'commands': {u'create': {u'capsule': u'*(BETA)* Create a target HTTP proxy.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'An optional, textual description for the target HTTP proxy.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--url-map': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'A reference to a URL map resource that defines the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTP proxy.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--url-map',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'URL_MAP'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'create',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'target-http-proxies',
                                                                                                                               u'create'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the target HTTP proxy.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u"\n*create* is used to create target HTTP proxies. A target\nHTTP proxy is referenced by one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTP proxy points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests.\n"}},
                                                                                                         u'delete': {u'capsule': u'*(BETA)* Delete target HTTP proxies.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'delete',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'target-http-proxies',
                                                                                                                               u'delete'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The resources to delete.',
                                                                                                                                       u'name': u'names',
                                                                                                                                       u'nargs': u'+',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*delete* deletes one or more target HTTP proxies.\n'}},
                                                                                                         u'describe': {u'capsule': u'*(BETA)* Display detailed information about a target HTTP proxy.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'describe',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'beta',
                                                                                                                                 u'compute',
                                                                                                                                 u'target-http-proxies',
                                                                                                                                 u'describe'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the resource to fetch.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'BETA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a target HTTP proxy\nin a project.\n'}},
                                                                                                         u'list': {u'capsule': u'*(BETA)* List Google Compute Engine target HTTP proxies.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--filter',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--limit',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--page-size',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                              u'--regexp': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--regexp',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGEXP'},
                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'FIELD'},
                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'URI'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'list',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'beta',
                                                                                                                             u'compute',
                                                                                                                             u'target-http-proxies',
                                                                                                                             u'list'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                     u'name': u'names',
                                                                                                                                     u'nargs': u'*',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'BETA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine target HTTP proxies in a project.\n',
                                                                                                                                 u'EXAMPLES': u'To list all target HTTP proxies in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target HTTP proxies in a project, run:\n\n  $ list --uri\n'}},
                                                                                                         u'update': {u'capsule': u'*(BETA)* Update a target HTTP proxy.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--url-map': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'A reference to a URL map resource that will define the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTP proxy.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--url-map',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'URL_MAP'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'update',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'target-http-proxies',
                                                                                                                               u'update'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the target HTTP proxy.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u"*update* is used to change the URL map of existing\ntarget HTTP proxies. A target HTTP proxy is referenced\nby one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTP proxy in turn points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests.\n"}}},
                                                                                           u'flags': {},
                                                                                           u'group': True,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'target-http-proxies',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'beta',
                                                                                                     u'compute',
                                                                                                     u'target-http-proxies'],
                                                                                           u'positionals': [],
                                                                                           u'release': u'BETA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* List, create, and delete target HTTP proxies.'}},
                                                                  u'target-https-proxies': {u'capsule': u'*(BETA)* List, create, and delete target HTTPS proxies.',
                                                                                            u'commands': {u'create': {u'capsule': u'*(BETA)* Create a target HTTPS proxy.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--description': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'An optional, textual description for the target HTTPS proxy.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--description',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                 u'--ssl-certificate': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target HTTPS proxy.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--ssl-certificate',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': True,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'SSL_CERTIFICATE'},
                                                                                                                                 u'--url-map': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'A reference to a URL map resource that defines the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTPS proxy.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--url-map',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': True,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'URL_MAP'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'create',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'compute',
                                                                                                                                u'target-https-proxies',
                                                                                                                                u'create'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the target HTTPS proxy.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u"\n*create* is used to create target HTTPS proxies. A target\nHTTPS proxy is referenced by one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTPS proxy points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests. The target\nHTTPS proxy also points to an SSL certificate used for\nserver-side authentication.\n"}},
                                                                                                          u'delete': {u'capsule': u'*(BETA)* Delete target HTTPS proxies.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'delete',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'compute',
                                                                                                                                u'target-https-proxies',
                                                                                                                                u'delete'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The resources to delete.',
                                                                                                                                        u'name': u'names',
                                                                                                                                        u'nargs': u'+',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*delete* deletes one or more target HTTPS proxies.\n'}},
                                                                                                          u'describe': {u'capsule': u'*(BETA)* Display detailed information about a target HTTPS proxy.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'describe',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'beta',
                                                                                                                                  u'compute',
                                                                                                                                  u'target-https-proxies',
                                                                                                                                  u'describe'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the resource to fetch.',
                                                                                                                                          u'name': u'name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'NAME'}],
                                                                                                                        u'release': u'BETA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a target HTTPS proxy\nin a project.\n'}},
                                                                                                          u'list': {u'capsule': u'*(BETA)* List Google Compute Engine target HTTPS proxies.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--filter',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--limit',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                               u'--regexp': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--regexp',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGEXP'},
                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'FIELD'},
                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'URI'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'list',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'target-https-proxies',
                                                                                                                              u'list'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': [],
                                                                                                                                      u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                      u'name': u'names',
                                                                                                                                      u'nargs': u'*',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine target HTTPS proxies in a project.\n',
                                                                                                                                  u'EXAMPLES': u'To list all target HTTPS proxies in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target HTTPS proxies in a project, run:\n\n  $ list --uri\n'}},
                                                                                                          u'update': {u'capsule': u'*(BETA)* Update a target HTTPS proxy.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--ssl-certificate': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target HTTPS proxy.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--ssl-certificate',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'SSL_CERTIFICATE'},
                                                                                                                                 u'--url-map': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'A reference to a URL map resource that defines the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTPS proxy.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--url-map',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'URL_MAP'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'update',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'compute',
                                                                                                                                u'target-https-proxies',
                                                                                                                                u'update'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the target HTTPS proxy.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u"*update* is used to change the SSL certificate and/or URL map of\nexisting target HTTPS proxies. A target HTTPS proxy is referenced\nby one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTPS proxy in turn points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests. The target\nHTTPS proxy also points to an SSL certificate used for\nserver-side authentication.\n"}}},
                                                                                            u'flags': {},
                                                                                            u'group': True,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'target-https-proxies',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'beta',
                                                                                                      u'compute',
                                                                                                      u'target-https-proxies'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'BETA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* List, create, and delete target HTTPS proxies.'}},
                                                                  u'target-instances': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine virtual target instances.',
                                                                                        u'commands': {u'create': {u'capsule': u'*(BETA)* Create a target instance for handling traffic from a forwarding rule.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--description': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'An optional, textual description of the target instance.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--description',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'DESCRIPTION'},
                                                                                                                             u'--instance': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The name of the virtual machine instance that will handle the traffic.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--instance',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': True,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'INSTANCE'},
                                                                                                                             u'--instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The zone of the instance to operate on. If not specified, it will be set to the same as zone. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--instance-zone',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'INSTANCE_ZONE'},
                                                                                                                             u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"The zone of the target instance to create the target instance in. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--zone',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'ZONE'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'create',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'target-instances',
                                                                                                                            u'create'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the target instance.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*create* is used to create a target instance for handling\ntraffic from one or more forwarding rules. Target instances\nare ideal for traffic that should be managed by a single\nsource. For more information on target instances, see\n[](https://cloud.google.com/compute/docs/protocol-forwarding/#targetinstances)\n'}},
                                                                                                      u'delete': {u'capsule': u'*(BETA)* Delete target instances.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"The zone of the resources to delete. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--zone',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'ZONE'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'delete',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'target-instances',
                                                                                                                            u'delete'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The resources to delete.',
                                                                                                                                    u'name': u'names',
                                                                                                                                    u'nargs': u'+',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine target\ninstances. Target instances can be deleted only if they are\nnot being used by any other resources like forwarding rules.\n'}},
                                                                                                      u'describe': {u'capsule': u'*(BETA)* Describe a target instance.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--zone',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'ZONE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'describe',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'target-instances',
                                                                                                                              u'describe'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the resource to fetch.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine target instance in a project.\n'}},
                                                                                                      u'list': {u'capsule': u'*(BETA)* List Google Compute Engine target instances.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--filter',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--limit',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--page-size',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                           u'--regexp': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--regexp',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGEXP'},
                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'FIELD'},
                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'URI'},
                                                                                                                           u'--zones': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': [],
                                                                                                                                        u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--zones',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'ZONE'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'list',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'target-instances',
                                                                                                                          u'list'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': [],
                                                                                                                                  u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                  u'name': u'names',
                                                                                                                                  u'nargs': u'*',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine target instances in a project.\n\nBy default, target instances from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                              u'EXAMPLES': u"To list all target instances in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target instances in a project, run:\n\n  $ list --uri\n\nTo list all target instances in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                                        u'flags': {},
                                                                                        u'group': True,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'target-instances',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'beta',
                                                                                                  u'compute',
                                                                                                  u'target-instances'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'BETA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine virtual target instances.'}},
                                                                  u'target-pools': {u'capsule': u'*(BETA)* Control Compute Engine target pools for network load balancing.',
                                                                                    u'commands': {u'add-health-checks': {u'capsule': u'*(BETA)* Add an HTTP health check to a target pool.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--http-health-check': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Specifies an HTTP health check object to add to the target pool.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--http-health-check',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': True,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                                    u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u"The region of the target pool to add health checks to. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--region',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'REGION'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'add-health-checks',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'beta',
                                                                                                                                   u'compute',
                                                                                                                                   u'target-pools',
                                                                                                                                   u'add-health-checks'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The name of the target pool to which to add the health check.',
                                                                                                                                           u'name': u'name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'NAME'}],
                                                                                                                         u'release': u'BETA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* *add-health-checks* is used to add an HTTP health check\nto a target pool. Health checks are used to determine\nthe health status of instances in the target pool. Only one\nhealth check can be attached to a target pool, so this command\nwill fail if there as already a health check attached to the target\npool. For more information on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)'}},
                                                                                                  u'add-instances': {u'capsule': u'*(BETA)* Add instances to a target pool.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Specifies a list of instances to add to the target pool.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--instances',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': True,
                                                                                                                                                 u'type': u'list',
                                                                                                                                                 u'value': u'INSTANCE'},
                                                                                                                                u'--instances-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"The zone of the instances to add to the target pool. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--instances-zone',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'INSTANCES_ZONE'},
                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the instances. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--region',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'REGION'},
                                                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The zone of the instances to add to the target pool. DEPRECATED, use --instances-zone. If not specified, you will be prompted to select a zone. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--zone',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'add-instances',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'target-pools',
                                                                                                                               u'add-instances'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the target pool to which to add the instances.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*add-instances* is used to add one or more instances to a target pool.\nFor more information on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                  u'create': {u'capsule': u'*(BETA)* Define a load-balanced pool of virtual machine instances.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--backup-pool': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"Together with ``--failover-ratio'', this flag defines the fallback\nbehavior of the target pool (primary pool) to be created by this\ncommand. If the ratio of the healthy instances in the primary pool\nis at or below the specified ``--failover-ratio value'', then traffic\narriving at the load-balanced IP address will be directed to the\nbackup pool. If this flag is provided, then ``--failover-ratio'' is\nrequired.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--backup-pool',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'BACKUP_POOL'},
                                                                                                                         u'--description': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'An optional description of this target pool.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--description',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'DESCRIPTION'},
                                                                                                                         u'--failover-ratio': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"Together with ``--backup-pool'', defines the fallback behavior of the\ntarget pool (primary pool) to be created by this command. If the\nratio of the healthy instances in the primary pool is at or below this\nnumber, traffic arriving at the load-balanced IP address will be\ndirected to the backup pool. For example, if 0.4 is chosen as the\nfailover ratio, then traffic will fail over to the backup pool if\nmore than 40% of the instances become unhealthy.\nIf not set, the traffic will be directed the\ninstances in this pool in the ``force'' mode, where traffic will be\nspread to the healthy instances with the best effort, or to all\ninstances when no instance is healthy.\nIf this flag is provided, then ``--backup-pool'' is required.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--failover-ratio',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'FAILOVER_RATIO'},
                                                                                                                         u'--health-check': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'DEPRECATED, use --http-health-check.\nSpecifies an HTTP health check resource to use to determine the health\nof instances in this pool. If no health check is specified, traffic will\nbe sent to all instances in this target pool as if the instances\nwere healthy, but the health status of this pool will appear as\nunhealthy as a warning that this target pool does not have a health\ncheck.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--health-check',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'HEALTH_CHECK'},
                                                                                                                         u'--http-health-check': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Specifies an HTTP health check resource to use to determine the health\nof instances in this pool. If no health check is specified, traffic will\nbe sent to all instances in this target pool as if the instances\nwere healthy, but the health status of this pool will appear as\nunhealthy as a warning that this target pool does not have a health\ncheck.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--http-health-check',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                         u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The region of the target pool to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--region',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'REGION'},
                                                                                                                         u'--session-affinity': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [u'CLIENT_IP',
                                                                                                                                                              u'CLIENT_IP_PROTO',
                                                                                                                                                              u'GENERATED_COOKIE',
                                                                                                                                                              u'NONE'],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': u'NONE',
                                                                                                                                                 u'description': u'The type of session affinity to use for this backend service. _SESSION_AFFINITY_ must be one of:\n+\n*CLIENT_IP*::: Route requests to instances based on the hash of the client\'s IP address.\n*CLIENT_IP_PROTO*::: Connections from the same client IP with the same IP protocol willgo to the same VM in the pool while that VM remains healthy. This option cannot be used for HTTP(s) load balancing.\n*GENERATED_COOKIE*::: Route requests to instances based on the contents of the "GCLB" cookie set by the load balancer.\n*NONE*::: Session affinity is disabled.\n+',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--session-affinity',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'SESSION_AFFINITY'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'create',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'compute',
                                                                                                                        u'target-pools',
                                                                                                                        u'create'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the target pool.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u"*(BETA)* *create* is used to create a target pool. A target pool resource\ndefines a group of instances that can receive incoming traffic\nfrom forwarding rules. When a forwarding rule directs traffic to a\ntarget pool, Google Compute Engine picks an instance from the\ntarget pool based on a hash of the source and\ndestination IP addresses and ports. For more\ninformation on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n\nTo add instances to a target pool, use 'gcloud compute\ntarget-pools add-instances'."}},
                                                                                                  u'delete': {u'capsule': u'*(BETA)* Delete target pools.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--region',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'REGION'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'delete',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'compute',
                                                                                                                        u'target-pools',
                                                                                                                        u'delete'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The resources to delete.',
                                                                                                                                u'name': u'names',
                                                                                                                                u'nargs': u'+',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine target pools.\n'}},
                                                                                                  u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine target pool.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--region',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'REGION'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'describe',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'compute',
                                                                                                                          u'target-pools',
                                                                                                                          u'describe'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the resource to fetch.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* *describe* displays all data associated with a Google Compute\nEngine target pool in a project.'}},
                                                                                                  u'get-health': {u'capsule': u'*(BETA)* Get the health of instances in a target pool.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The region of the target pool to get health information for. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--region',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGION'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'get-health',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'target-pools',
                                                                                                                            u'get-health'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the target pool.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*get-health* displays the health of instances in a target pool.\n'}},
                                                                                                  u'list': {u'capsule': u'*(BETA)* List Google Compute Engine target pools.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--filter',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--limit',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_URI'},
                                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--page-size',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                                       u'--regexp': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--regexp',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'REGEXP'},
                                                                                                                       u'--regions': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': [],
                                                                                                                                      u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--regions',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'REGION'},
                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'FIELD'},
                                                                                                                       u'--uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'URI'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'list',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'compute',
                                                                                                                      u'target-pools',
                                                                                                                      u'list'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': [],
                                                                                                                              u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                              u'name': u'names',
                                                                                                                              u'nargs': u'*',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine target pools in a project.\n\nBy default, target pools from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                          u'EXAMPLES': u"To list all target pools in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target pools in a project, run:\n\n  $ list --uri\n\nTo list all target pools in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}},
                                                                                                  u'remove-health-checks': {u'capsule': u'*(BETA)* Remove an HTTP health check from a target pool.',
                                                                                                                            u'commands': {},
                                                                                                                            u'flags': {u'--http-health-check': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Specifies an HTTP health check object to remove from the target pool.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--http-health-check',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': True,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                                                       u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"The region of the target pool to remove health checks from. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--region',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'REGION'}},
                                                                                                                            u'group': False,
                                                                                                                            u'groups': {},
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'remove-health-checks',
                                                                                                                            u'path': [u'gcloud',
                                                                                                                                      u'beta',
                                                                                                                                      u'compute',
                                                                                                                                      u'target-pools',
                                                                                                                                      u'remove-health-checks'],
                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The name of the target pool from which to remove the health check.',
                                                                                                                                              u'name': u'name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'value': u'NAME'}],
                                                                                                                            u'release': u'BETA',
                                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* *remove-health-checks* is used to remove an HTTP health check\nfrom a target pool. Health checks are used to determine\nthe health status of instances in the target pool. For more\ninformation on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)'}},
                                                                                                  u'remove-instances': {u'capsule': u'*(BETA)* Remove instances from a target pool.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'Specifies a list of instances to remove from the target pool.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--instances',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': True,
                                                                                                                                                    u'type': u'list',
                                                                                                                                                    u'value': u'INSTANCE'},
                                                                                                                                   u'--instances-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u"The zone of the instances to remove from the target pool. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--instances-zone',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'INSTANCES_ZONE'},
                                                                                                                                   u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the instances. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--region',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'REGION'},
                                                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The zone of the instances to remove from the target pool. DEPRECATED, use --instances-zone. If not specified, you will be prompted to select a zone. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--zone',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'ZONE'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'remove-instances',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'beta',
                                                                                                                                  u'compute',
                                                                                                                                  u'target-pools',
                                                                                                                                  u'remove-instances'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the target pool from which to remove the instances.',
                                                                                                                                          u'name': u'name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'NAME'}],
                                                                                                                        u'release': u'BETA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*remove-instances* is used to remove one or more instances from a\ntarget pool.\nFor more information on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                  u'set-backup': {u'capsule': u'*(BETA)* Set a backup pool for a target pool.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--backup-pool': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Name of the target pool that will serve as backup.',
                                                                                                                                                u'group': u'set-backup.1',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--backup-pool',
                                                                                                                                                u'nargs': u'?',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'BACKUP_POOL'},
                                                                                                                             u'--failover-ratio': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The new failover ratio value for the target pool. This must be a float in the range of [0, 1].',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--failover-ratio',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'FAILOVER_RATIO'},
                                                                                                                             u'--no-backup-pool': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Unsets the backup pool. This disables failover.',
                                                                                                                                                   u'group': u'set-backup.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--no-backup-pool',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_BACKUP_POOL'},
                                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"The region of the target pool to set a backup pool for. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--region',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGION'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {u'set-backup.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                u'is_mutex': True,
                                                                                                                                                u'is_required': False}},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'set-backup',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'target-pools',
                                                                                                                            u'set-backup'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of the target pool for which to set the backup pool.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u"*set-backup* is used to set a backup target pool for a primary\ntarget pool, which defines the fallback behavior of the primary\npool. If the ratio of the healthy instances in the primary pool\nis at or below the specified ``--failover-ratio value'', then traffic\narriving at the load-balanced IP address will be directed to the\nbackup pool.\n",
                                                                                                                                u'EXAMPLES': u"To cause `TARGET-POOL` (in region `us-central1`) to fail over\nto `BACKUP-POOL` when more than half of the `TARGET-POOL`\ninstances are unhealthy, run:\n\n  $ set-backup TARGET-POOL --backup-pool BACKUP-POOL --failover-ratio 0.5 --region us-central1\n\nTo remove `BACKUP-POOL` as a backup to `TARGET-POOL`, run:\n\n  $ set-backup TARGET-POOL --backup-pool '' --region us-central1\n"}}},
                                                                                    u'flags': {},
                                                                                    u'group': True,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'target-pools',
                                                                                    u'path': [u'gcloud',
                                                                                              u'beta',
                                                                                              u'compute',
                                                                                              u'target-pools'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'BETA',
                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Control Compute Engine target pools for network load balancing.'}},
                                                                  u'target-ssl-proxies': {u'capsule': u'*(BETA)* List, create, and delete target SSL proxies.',
                                                                                          u'commands': {u'create': {u'capsule': u'*(BETA)* Create a target SSL proxy.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'A backend service that will be used for connections to the target SSL\nproxy.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--backend-service',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': True,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'BACKEND_SERVICE'},
                                                                                                                               u'--description': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'An optional, textual description for the target SSL proxy.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--description',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'DESCRIPTION'},
                                                                                                                               u'--proxy-header': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [u'NONE',
                                                                                                                                                                u'PROXY_V1'],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': u'NONE',
                                                                                                                                                   u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Enables PROXY protocol (version 1) for passing client connection information.\n+',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--proxy-header',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'PROXY_HEADER'},
                                                                                                                               u'--ssl-certificate': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target SSL proxy.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--ssl-certificate',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': True,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'SSL_CERTIFICATE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'create',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'target-ssl-proxies',
                                                                                                                              u'create'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the target SSL proxy.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'\n*create* is used to create target SSL proxies. A target\nSSL proxy is referenced by one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget SSL proxy points to a backend service which handle the\nactual requests. The target SSL proxy also points to an SSL\ncertificate used for server-side authentication.\n'}},
                                                                                                        u'delete': {u'capsule': u'*(BETA)* Delete target SSL proxies.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'delete',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'target-ssl-proxies',
                                                                                                                              u'delete'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The names of the target SSL proxies.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'+',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*delete* deletes one or more target SSL proxies.\n'}},
                                                                                                        u'describe': {u'capsule': u'*(BETA)* Display detailed information about a target SSL proxy.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'describe',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'compute',
                                                                                                                                u'target-ssl-proxies',
                                                                                                                                u'describe'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the target SSL proxy.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a target SSL proxy\nin a project.\n'}},
                                                                                                        u'list': {u'capsule': u'*(BETA)* List Google Compute Engine target SSL proxies.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--filter',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'EXPRESSION'},
                                                                                                                             u'--limit': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--limit',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'LIMIT'},
                                                                                                                             u'--no-uri': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-uri',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_URI'},
                                                                                                                             u'--page-size': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--page-size',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                                                             u'--regexp': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--regexp',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGEXP'},
                                                                                                                             u'--sort-by': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--sort-by',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'FIELD'},
                                                                                                                             u'--uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'URI'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'list',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'compute',
                                                                                                                            u'target-ssl-proxies',
                                                                                                                            u'list'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': [],
                                                                                                                                    u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                    u'name': u'names',
                                                                                                                                    u'nargs': u'*',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine target SSL proxies in a project.\n',
                                                                                                                                u'EXAMPLES': u'To list all target SSL proxies in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target SSL proxies in a project, run:\n\n  $ list --uri\n'}},
                                                                                                        u'update': {u'capsule': u'*(BETA)* Update a target SSL proxy.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'A backend service that will be used for connections to the target SSL\nproxy.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--backend-service',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'BACKEND_SERVICE'},
                                                                                                                               u'--proxy-header': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [u'NONE',
                                                                                                                                                                u'PROXY_V1'],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Enables PROXY protocol (version 1) for passing client connection information.\n+',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--proxy-header',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'PROXY_HEADER'},
                                                                                                                               u'--ssl-certificate': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target SSL proxy.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--ssl-certificate',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'SSL_CERTIFICATE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'update',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'target-ssl-proxies',
                                                                                                                              u'update'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the target SSL proxy.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'\n*update* is used to change the SSL certificate, backend\nservice or proxy header of existing target SSL proxies. A\ntarget SSL proxy is referenced by one or more forwarding rules\nwhich define which packets the proxy is responsible for\nrouting. The target SSL proxy in turn points to a backend\nservice which will handle the requests. The target SSL proxy\nalso points to an SSL certificate used for server-side\nauthentication.  '}}},
                                                                                          u'flags': {},
                                                                                          u'group': True,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'target-ssl-proxies',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'beta',
                                                                                                    u'compute',
                                                                                                    u'target-ssl-proxies'],
                                                                                          u'positionals': [],
                                                                                          u'release': u'BETA',
                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* List, create, and delete target SSL proxies.'}},
                                                                  u'target-vpn-gateways': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine VPN Gateways.',
                                                                                           u'commands': {u'create': {u'capsule': u'*(BETA)* Create a target VPN Gateway.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--description': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'An optional, textual description for the target VPN Gateway.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--description',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                                u'--network': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'A reference to a network in this project to\ncontain the VPN Gateway.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--network',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'NETWORK'},
                                                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"The region of the Target VPN Gateway to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--region',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'REGION'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'create',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'target-vpn-gateways',
                                                                                                                               u'create'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the target VPN Gateway.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'\n*create* is used to create a target VPN Gateway. A target VPN\nGateway can reference one or more VPN tunnels that connect it to\nexternal VPN gateways. A VPN Gateway may also be referenced by\none or more forwarding rules that define which packets the\ngateway is responsible for routing.\n'}},
                                                                                                         u'delete': {u'capsule': u'*(BETA)* Delete target vpn gateways.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--region',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'REGION'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'delete',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'compute',
                                                                                                                               u'target-vpn-gateways',
                                                                                                                               u'delete'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The resources to delete.',
                                                                                                                                       u'name': u'names',
                                                                                                                                       u'nargs': u'+',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine target vpn\ngateways.\n'}},
                                                                                                         u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine target vpn gateway.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--region',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'REGION'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'describe',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'beta',
                                                                                                                                 u'compute',
                                                                                                                                 u'target-vpn-gateways',
                                                                                                                                 u'describe'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the resource to fetch.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'BETA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine target vpn gateway in a project.\n'}},
                                                                                                         u'list': {u'capsule': u'*(BETA)* List Google Compute Engine target VPN gateways.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--filter',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--limit',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--page-size',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                              u'--regexp': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--regexp',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'REGEXP'},
                                                                                                                              u'--regions': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': [],
                                                                                                                                             u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--regions',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'REGION'},
                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'FIELD'},
                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'URI'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'list',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'beta',
                                                                                                                             u'compute',
                                                                                                                             u'target-vpn-gateways',
                                                                                                                             u'list'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                     u'name': u'names',
                                                                                                                                     u'nargs': u'*',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'NAME'}],
                                                                                                                   u'release': u'BETA',
                                                                                                                   u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine target VPN gateways in a project.\n\nBy default, target VPN gateways from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                                 u'EXAMPLES': u"To list all target VPN gateways in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target VPN gateways in a project, run:\n\n  $ list --uri\n\nTo list all target VPN gateways in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}}},
                                                                                           u'flags': {},
                                                                                           u'group': True,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'target-vpn-gateways',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'beta',
                                                                                                     u'compute',
                                                                                                     u'target-vpn-gateways'],
                                                                                           u'positionals': [],
                                                                                           u'release': u'BETA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine VPN Gateways.'}},
                                                                  u'url-maps': {u'capsule': u'*(BETA)* List, create, and delete URL maps.',
                                                                                u'commands': {u'add-host-rule': {u'capsule': u'*(BETA)* Add a rule to a URL map to map hosts to a path matcher.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--description': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'An optional, textual description for the host rule.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--description',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'DESCRIPTION'},
                                                                                                                            u'--hosts': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"The set of hosts to match requests against. Each host must be\na fully qualified domain name (FQDN) with the exception that\nthe host can begin with a ``*'' or ``*-''. ``*'' acts as a\nglob and will match any string of atoms to the left where an\natom is separated by dots (``.'') or dashes (``-'').",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--hosts',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': True,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'HOST'},
                                                                                                                            u'--path-matcher-name': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The name of the patch matcher to use if a request matches this\nhost rule. The patch matcher must already exist in the URL map\n(see `gcloud compute url-maps add-path-matcher`).',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--path-matcher-name',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': True,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'PATH_MATCHER_NAME'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'add-host-rule',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'compute',
                                                                                                                           u'url-maps',
                                                                                                                           u'add-host-rule'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the URL map.',
                                                                                                                                   u'name': u'name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'NAME'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*add-host-rule* is used to add a mapping of hosts to a patch\nmatcher in a URL map. The mapping will match the host\ncomponent of HTTP requests to path matchers which in turn map\nthe request to a backend service. Before adding a host rule,\nat least one path matcher must exist in the URL map to take\ncare of the path component of the requests.\n`gcloud compute url-maps add-path-matcher` or\n`gcloud compute url-maps edit` can be used to add path matchers.\n',
                                                                                                                               u'EXAMPLES': u"To create a host rule mapping the ```*-foo.google.com``` and\n```google.com``` hosts to the ```www``` path matcher, run:\n\n  $ add-host-rule MY-URL-MAP --hosts '*-foo.google.com,google.com' --path-matcher-name www\n"}},
                                                                                              u'add-path-matcher': {u'capsule': u'*(BETA)* Add a path matcher to a URL map.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--backend-bucket-path-rules': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': {},
                                                                                                                                                                u'description': u'Rules for mapping request paths to backend buckets.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--backend-bucket-path-rules',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'dict',
                                                                                                                                                                u'value': u'PATH=BUCKET'},
                                                                                                                               u'--backend-service-path-rules': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': {},
                                                                                                                                                                 u'description': u'Rules for mapping request paths to services.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--backend-service-path-rules',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'dict',
                                                                                                                                                                 u'value': u'PATH=SERVICE'},
                                                                                                                               u'--default-backend-bucket': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'A backend bucket that will be used for requests that the path matcher cannot match. Exactly one of --default-service or --default-backend-bucket is required.',
                                                                                                                                                             u'group': u'add-path-matcher.1',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--default-backend-bucket',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'DEFAULT_BACKEND_BUCKET'},
                                                                                                                               u'--default-service': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'A backend service that will be used for requests that the path matcher cannot match. Exactly one of --default-service or --default-backend-bucket is required.',
                                                                                                                                                      u'group': u'add-path-matcher.1',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--default-service',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'DEFAULT_SERVICE'},
                                                                                                                               u'--delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': False,
                                                                                                                                                                   u'description': u'If provided and a path matcher is orphaned as a result of this command, the command removes the orphaned path matcher instead of failing.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--delete-orphaned-path-matcher',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'bool',
                                                                                                                                                                   u'value': u'DELETE_ORPHANED_PATH_MATCHER'},
                                                                                                                               u'--description': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'An optional, textual description for the path matcher.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--description',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'DESCRIPTION'},
                                                                                                                               u'--existing-host': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'An existing host rule to tie the new path matcher to. Although\nhost rules can contain more than one host, only a single host\nis needed to uniquely identify the host rule.',
                                                                                                                                                    u'group': u'add-path-matcher.2',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--existing-host',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'EXISTING_HOST'},
                                                                                                                               u'--new-hosts': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'If specified, a new host rule with the given hosts is created and the path matcher is tied to the new host rule.',
                                                                                                                                                u'group': u'add-path-matcher.2',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--new-hosts',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'list',
                                                                                                                                                u'value': u'NEW_HOST'},
                                                                                                                               u'--no-delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': False,
                                                                                                                                                                      u'description': u'',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': True,
                                                                                                                                                                      u'name': u'--no-delete-orphaned-path-matcher',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'bool',
                                                                                                                                                                      u'value': u'NO_DELETE_ORPHANED_PATH_MATCHER'},
                                                                                                                               u'--path-matcher-name': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The name to assign to the path matcher.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--path-matcher-name',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': True,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'PATH_MATCHER_NAME'},
                                                                                                                               u'--path-rules': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': {},
                                                                                                                                                 u'description': u'Rules for mapping request paths to services.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--path-rules',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'dict',
                                                                                                                                                 u'value': u'PATH=SERVICE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {u'add-path-matcher.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                        u'is_mutex': True,
                                                                                                                                                        u'is_required': True},
                                                                                                                                u'add-path-matcher.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                                        u'is_mutex': True,
                                                                                                                                                        u'is_required': False}},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'add-path-matcher',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'url-maps',
                                                                                                                              u'add-path-matcher'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the URL map.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u"*add-path-matcher* is used to add a path matcher to a URL map. A path\nmatcher maps HTTP request paths to backend services or backend\nbuckets. Each path matcher must be referenced by at least one\nhost rule. This command can create a new host rule through the\n``--new-hosts'' flag or it can reconfigure an existing host rule\nto point to the newly added path matcher using ``--existing-host''.\nIn the latter case, if a path matcher is orphaned as a result\nof the operation, this command will fail unless\n``--delete-orphaned-path-matcher'' is provided.\n",
                                                                                                                                  u'EXAMPLES': u"To create a rule for mapping the path ```/search/*``` to the\nhypothetical ```search-service```, ```/static/*``` to the\n```static-bucket``` backend bucket and ```/images/*``` to the\n```images-service``` under the hosts ```google.com``` and\n```*.google.com```, run:\n\n  $ add-path-matcher MY-URL-MAP --path-matcher-name MY-MATCHER --default-service MY-DEFAULT-SERVICE --backend-service-path-rules '/search/*=search_service,/images/*=images-service' --backend-bucket-path-rules '/static/*=static-bucket' --new-hosts google.com '*.google.com'\n\nNote that a default service or default backend bucket must be\nprovided to handle paths for which there is no mapping.\n"}},
                                                                                              u'create': {u'capsule': u'*(BETA)* Create a URL map.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--default-backend-bucket': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'A backend bucket that will be used for requests for which this URL map has no mappings. Exactly one of --default-service or --default-backend-bucket is required.',
                                                                                                                                                   u'group': u'create.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--default-backend-bucket',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'DEFAULT_BACKEND_BUCKET'},
                                                                                                                     u'--default-service': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A backend service that will be used for requests for which this URL map has no mappings. Exactly one of --default-service or --default-backend-bucket is required.',
                                                                                                                                            u'group': u'create.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--default-service',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'DEFAULT_SERVICE'},
                                                                                                                     u'--description': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'An optional, textual description for the URL map.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--description',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DESCRIPTION'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {u'create.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                    u'is_mutex': True,
                                                                                                                                    u'is_required': True}},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'create',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'url-maps',
                                                                                                                    u'create'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the URL map.',
                                                                                                                            u'name': u'name',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u"\n*create* is used to create URL maps which map HTTP and\nHTTPS request URLs to backend services and backend buckets.\nMappings are done using a longest-match strategy.\n\nThere are two components to a mapping: a host rule and a path\nmatcher. A host rule maps one or more hosts to a path\nmatcher. A path matcher maps request paths to backend\nservices or backend buckets. For example, a host rule can map\nthe hosts ``*.google.com'' and ``google.com'' to a path\nmatcher called ``www''. The ``www'' path matcher in turn can\nmap the path ``/search/*'' to the search backend service, the\npath ``/static/*'' to the static backend bucket  and everything\nelse to a default backend service or default backend bucket.\n\nHost rules and patch matchers can be added to the URL map\nafter the map is created by using `gcloud compute url-maps edit`\nor by using `gcloud compute url-maps add-path-matcher`\nand `gcloud compute url-maps add-host-rule`.\n"}},
                                                                                              u'delete': {u'capsule': u'*(BETA)* Delete URL maps.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'delete',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'compute',
                                                                                                                    u'url-maps',
                                                                                                                    u'delete'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The resources to delete.',
                                                                                                                            u'name': u'names',
                                                                                                                            u'nargs': u'+',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'NAME'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* *delete* deletes one or more URL maps.'}},
                                                                                              u'describe': {u'capsule': u'*(BETA)* Describe a URL map.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--region',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'REGION'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'describe',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'compute',
                                                                                                                      u'url-maps',
                                                                                                                      u'describe'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The name of the resource to fetch.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a URL map in a\nproject.\n'}},
                                                                                              u'edit': {u'capsule': u'*(BETA)* Modify URL maps.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'edit',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'compute',
                                                                                                                  u'url-maps',
                                                                                                                  u'edit'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The name of the URL map.',
                                                                                                                          u'name': u'name',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u"*edit* can be used to modify a URL map. The URL map\nresource is fetched from the server and presented in a text\neditor. After the file is saved and closed, this command will\nupdate the resource. Only fields that can be modified are\ndisplayed in the editor.\n\nThe editor used to modify the resource is chosen by inspecting\nthe ``EDITOR'' environment variable.\n"}},
                                                                                              u'invalidate-cdn-cache': {u'capsule': u'*(BETA)* Invalidate specified objects for a URL map in Cloud CDN caches.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--async': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Do not wait for the operation to complete.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--async',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'ASYNC'},
                                                                                                                                   u'--host': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'If set, this invalidation will apply only to requests to the\nspecified host.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--host',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'HOST'},
                                                                                                                                   u'--no-async': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': True,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-async',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_ASYNC'},
                                                                                                                                   u'--path': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"A path specifying which objects to invalidate. PATH must start with\n``/'' and the only place a ``*'' is allowed is at the end following a\n``/''. It will be matched against URL paths, which do not include\nscheme, host, or any text after the first ``?'' or ``#'' (and those\ncharacters are not allowed here). For example, for the URL\n``https://example.com/whatever/x.html?a=b'', the path is\n``/whatever/x.html''.\n+\nIf PATH ends with ``*'', the preceding string is a prefix, and all URLs\nwhose paths begin with it will be invalidated. If PATH doesn't end with\n``*'', then only URLs with exactly that path will be invalidated.\n+\nExamples:\n- ``'', ``*'', anything that doesn't start with ``/'': error\n- ``/'': just the root URL\n- ``/*'': everything\n- ``/x/y'': ``/x/y'' only (and not ``/x/y/'')\n- ``/x/y/'': ``/x/y/'' only (and not ``/x/y'')\n- ``/x/y/*'': ``/x/y/'' and everything under it",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--path',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PATH'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'invalidate-cdn-cache',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'beta',
                                                                                                                                  u'compute',
                                                                                                                                  u'url-maps',
                                                                                                                                  u'invalidate-cdn-cache'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the URL map.',
                                                                                                                                          u'name': u'name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'URLMAP'}],
                                                                                                                        u'release': u'BETA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'\n*invalidate-cdn-cache* requests that Cloud CDN stop using cached content for\nresources at a particular URL path or set of URL paths.\n\n*invalidate-cdn-cache* may succeed even if no content is cached for some or all\nURLs with the given path.\n'}},
                                                                                              u'list': {u'capsule': u'*(BETA)* List Google Compute Engine URL maps.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--filter',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                                   u'--limit': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--limit',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'LIMIT'},
                                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_URI'},
                                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--page-size',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                                   u'--regexp': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--regexp',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'REGEXP'},
                                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--sort-by',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'FIELD'},
                                                                                                                   u'--uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'URI'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'list',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'compute',
                                                                                                                  u'url-maps',
                                                                                                                  u'list'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': [],
                                                                                                                          u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                          u'name': u'names',
                                                                                                                          u'nargs': u'*',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'NAME'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine URL maps in a project.\n',
                                                                                                                      u'EXAMPLES': u'To list all URL maps in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all URL maps in a project, run:\n\n  $ list --uri\n'}},
                                                                                              u'list-cdn-cache-invalidations': {u'capsule': u'*(BETA)* List Cloud CDN cache invalidations for a URL map.',
                                                                                                                                u'commands': {},
                                                                                                                                u'flags': {u'--limit': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The maximum number of invalidations to list.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--limit',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'LIMIT'}},
                                                                                                                                u'group': False,
                                                                                                                                u'groups': {},
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'list-cdn-cache-invalidations',
                                                                                                                                u'path': [u'gcloud',
                                                                                                                                          u'beta',
                                                                                                                                          u'compute',
                                                                                                                                          u'url-maps',
                                                                                                                                          u'list-cdn-cache-invalidations'],
                                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The name of the URL map.',
                                                                                                                                                  u'name': u'urlmap',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'value': u'URLMAP'}],
                                                                                                                                u'release': u'BETA',
                                                                                                                                u'sections': {u'DESCRIPTION': u'List Cloud CDN cache invalidations for a URL map. A cache invalidation instructs\nCloud CDN to stop using cached content. You can list invalidations to check\nwhich have completed.\n'}},
                                                                                              u'remove-host-rule': {u'capsule': u'*(BETA)* Remove a host rule from a URL map.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': False,
                                                                                                                                                                   u'description': u'If provided and a path matcher is orphaned as a result of this command, the command removes the orphaned path matcher instead of failing.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--delete-orphaned-path-matcher',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'bool',
                                                                                                                                                                   u'value': u'DELETE_ORPHANED_PATH_MATCHER'},
                                                                                                                               u'--host': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'One of the hosts in the host rule to remove.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--host',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'HOST'},
                                                                                                                               u'--no-delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': False,
                                                                                                                                                                      u'description': u'',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': True,
                                                                                                                                                                      u'name': u'--no-delete-orphaned-path-matcher',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'bool',
                                                                                                                                                                      u'value': u'NO_DELETE_ORPHANED_PATH_MATCHER'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'remove-host-rule',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'compute',
                                                                                                                              u'url-maps',
                                                                                                                              u'remove-host-rule'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the URL map.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u"*remove-host-rule* is used to remove a host rule from a URL map. When\na host rule is removed, its path matcher is only removed if\nit is not referenced by any other host rules and\n``--delete-orphaned-path-matcher'' is provided.\n",
                                                                                                                                  u'EXAMPLES': u"To remove a host rule that contains the host ``google.com''\nfrom the URL map named ``MY-URL-MAP'', you can use this\ncommand:\n\n  $ remove-host-rule MY-URL-MAP --host google.com\n"}},
                                                                                              u'remove-path-matcher': {u'capsule': u'*(BETA)* Remove a path matcher from a URL map.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--path-matcher-name': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The name of the path matcher to remove.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--path-matcher-name',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': True,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'PATH_MATCHER_NAME'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'remove-path-matcher',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'beta',
                                                                                                                                 u'compute',
                                                                                                                                 u'url-maps',
                                                                                                                                 u'remove-path-matcher'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the URL map.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'BETA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*remove-path-matcher* is used to remove a path matcher from a URL\n map. When a path matcher is removed, all host rules that\n refer to the path matcher are also removed.\n',
                                                                                                                                     u'EXAMPLES': u"To remove the path matcher named ``MY-MATCHER'' from the URL map named\n``MY-URL-MAP'', you can use this command:\n\n  $ remove-path-matcher MY-URL-MAP --path-matcher MY-MATCHER\n"}},
                                                                                              u'set-default-service': {u'capsule': u'*(BETA)* Change the default service or default bucket of a URL map.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--default-backend-bucket': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'A backend bucket that will be used for requests for which this URL map has no mappings.',
                                                                                                                                                                u'group': u'set-default-service.1',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--default-backend-bucket',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'DEFAULT_BACKEND_BUCKET'},
                                                                                                                                  u'--default-service': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'A backend service that will be used for requests for which this URL map has no mappings.',
                                                                                                                                                         u'group': u'set-default-service.1',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--default-service',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'DEFAULT_SERVICE'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {u'set-default-service.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                              u'is_mutex': True,
                                                                                                                                                              u'is_required': True}},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'set-default-service',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'beta',
                                                                                                                                 u'compute',
                                                                                                                                 u'url-maps',
                                                                                                                                 u'set-default-service'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the URL map.',
                                                                                                                                         u'name': u'name',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'NAME'}],
                                                                                                                       u'release': u'BETA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*set-default-service* is used to change the default service or default\nbucket of a URL map. The default service or default bucket is\nused for any requests for which there is no mapping in the\nURL map.\n'}}},
                                                                                u'flags': {},
                                                                                u'group': True,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'url-maps',
                                                                                u'path': [u'gcloud',
                                                                                          u'beta',
                                                                                          u'compute',
                                                                                          u'url-maps'],
                                                                                u'positionals': [],
                                                                                u'release': u'BETA',
                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* List, create, and delete URL maps.'}},
                                                                  u'users': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine users.',
                                                                             u'commands': {u'add-keys': {u'capsule': u'*(BETA)* Add public keys to a Google Compute Engine user.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--description': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'A description of the public keys',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--description',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                    u'--expire': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"Public keys can be configured to expire after a specified amount\nof time. For example, specifying ``12h'' will cause the key to expire\nafter 12 hours. Valid units for this flag are ``s'' for seconds, ``m''\nfor minutes, ``h'' for hours, and ''d'' for days.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--expire',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPIRE'},
                                                                                                                    u'--public-key-files': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The path to a public-key file.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--public-key-files',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'LOCAL_FILE_PATH'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'add-keys',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'users',
                                                                                                                   u'add-keys'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'If provided, the name of the user to add a public key to. Else, the default user will be used. The default username is mapped from the email address of the\nauthenticated account.\nPlease run:\n+\n  $ gcloud config set account ACCOUNT\n+\nto change the authenticated account.',
                                                                                                                           u'name': u'name',
                                                                                                                           u'nargs': u'?',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* *add-keys* adds public keys to a Google Compute Engine user.',
                                                                                                                       u'EXAMPLES': u'To add a public key to a user, run:\n\n  $ add-keys example-user --public-key-files ~/.ssh/pubkey.pub\n\nMultiple public keys can be specified by providing multiple paths\nto key files on the local machine.\n'}},
                                                                                           u'create': {u'capsule': u'*(BETA)* Create Google Compute Engine users.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--description': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'An optional, textual description for the user being created.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--description',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'DESCRIPTION'},
                                                                                                                  u'--owner': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The owner of the user to be created. The owner must be an email address associated with a Google account',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--owner',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'OWNER'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'create',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'compute',
                                                                                                                 u'users',
                                                                                                                 u'create'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'If provided, the name of the user to create. Else, the default user will be created. The default username is mapped from the email address of the\nauthenticated account.\nPlease run:\n+\n  $ gcloud config set account ACCOUNT\n+\nto change the authenticated account.',
                                                                                                                         u'name': u'name',
                                                                                                                         u'nargs': u'?',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'NAME'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*create* creates a Google Compute Engine user.\n',
                                                                                                                     u'EXAMPLES': u"To create a user with the specified name and owner, run:\n\n  $ create example-user --owner example-owner@google.com\n\nTo create a user with the currently authenticated Google account as\nowner and a default username mapped from that account's email, run:\n\n  $ create\n\nTo create a user with the specified name and the currently\nauthenticated Google account as owner, run:\n\n  $ create example-user\n\nTo create a user with the specified owner and a default username\nmapped from the owner email, run:\n\n  $ create --owner example-owner@google.com\n\n"}},
                                                                                           u'delete': {u'capsule': u'*(BETA)* Delete Google Compute Engine users.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--no-owners': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-owners',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_OWNERS'},
                                                                                                                  u'--owners': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'The owner of the user to be created. The owner must be an email address associated with a Google account',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--owners',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'OWNERS'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'compute',
                                                                                                                 u'users',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The names of the users to delete.',
                                                                                                                         u'name': u'names',
                                                                                                                         u'nargs': u'+',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'NAME'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine users.\n',
                                                                                                                     u'EXAMPLES': u'To delete one or more users by name, run:\n\n  $ delete example-user-1 example-user-2\n\nTo delete all users for one or more owners, run:\n\n  $ delete example-owner-1@gmail.com example-owner-2@gmail.com --owners\n'}},
                                                                                           u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine user.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'users',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'If provided, the name of the user to describe. Else, the default user will be described. The default username is mapped from the email address of the\nauthenticated account.\nPlease run:\n+\n  $ gcloud config set account ACCOUNT\n+\nto change the authenticated account.',
                                                                                                                           u'name': u'name',
                                                                                                                           u'nargs': u'?',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* *describe* displays all data associated with a Google Compute\nEngine user in a project.',
                                                                                                                       u'EXAMPLES': u'To describe a user, run:\n\n  $ describe example-user\n\nTo describe the default user mapped from the currently authenticated\nGoogle account email, run:\n\n  $ describe\n'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* List Google Compute Engine users.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--regexp': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--regexp',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'REGEXP'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'compute',
                                                                                                               u'users',
                                                                                                               u'list'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': [],
                                                                                                                       u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                       u'name': u'names',
                                                                                                                       u'nargs': u'*',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'NAME'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine users in a project.\n',
                                                                                                                   u'EXAMPLES': u'To list all users in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all users in a project, run:\n\n  $ list --uri\n'}},
                                                                                           u'remove-keys': {u'capsule': u'*(BETA)* Remove a public key from a Google Compute Engine user.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--fingerprints': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The fingerprints of the public keys to remove from the user.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--fingerprints',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'FINGERPRINT'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'remove-keys',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'compute',
                                                                                                                      u'users',
                                                                                                                      u'remove-keys'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'If provided, the name of the user to remove public keys from. Else, the default user will be used. The default username is mapped from the email address of the\nauthenticated account.\nPlease run:\n+\n  $ gcloud config set account ACCOUNT\n+\nto change the authenticated account.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'?',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* *remove-keys* removes public keys from a Google Compute Engine user.',
                                                                                                                          u'EXAMPLES': u'To remove all public keys for a user, run:\n\n  $ remove-keys example-user\n\nTo remove a specific public key, first describe the user\n(using `gcloud compute users describe example-user`) to determine the\nfingerprints of the public keys you wish\nto remove. Then run:\n\n  $ remove-keys example-user --fingerprints b3ca856958b524f3f12c3e43f6c9065d\n'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'users',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'compute',
                                                                                       u'users'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine users.'}},
                                                                  u'vpn-tunnels': {u'capsule': u'*(BETA)* Read and manipulate Google Compute Engine VPN Tunnels.',
                                                                                   u'commands': {u'create': {u'capsule': u'*(BETA)* Create a VPN tunnel.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--description': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'An optional, textual description for the target VPN tunnel.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--description',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'DESCRIPTION'},
                                                                                                                        u'--ike-networks': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--ike-networks',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'IKE_NETWORKS'},
                                                                                                                        u'--ike-version': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [1,
                                                                                                                                                        2],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Internet Key Exchange protocol version number. Default is 2. _IKE_VERSION_ must be one of: *1*, *2*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--ike-version',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'IKE_VERSION'},
                                                                                                                        u'--local-traffic-selector': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Traffic selector is an agreement between IKE peers to permit traffic through a tunnel if the traffic matches a specified pair of local and remote addresses.\n+\nlocal_traffic_selector allows to configure the local addresses that are permitted. The value should be a comma separated list of CIDR formatted strings. Example: 192.168.0.0/16,10.0.0.0/24.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--local-traffic-selector',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'list',
                                                                                                                                                      u'value': u'CIDR'},
                                                                                                                        u'--peer-address': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A valid IP-v4 address representing the remote tunnel endpoint',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--peer-address',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PEER_ADDRESS'},
                                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The region of the VPN Tunnel to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--region',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REGION'},
                                                                                                                        u'--remote-traffic-selector': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Traffic selector is an agreement between IKE peers to permit traffic through a tunnel if the traffic matches a specified pair of local and remote addresses.\n+\nremote_traffic_selector allows to configure the remote addresses that are permitted. The value should be a comma separated list of CIDR formatted strings. Example: 192.168.0.0/16,10.0.0.0/24.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--remote-traffic-selector',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'list',
                                                                                                                                                       u'value': u'CIDR'},
                                                                                                                        u'--router': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The Router to use for dynamic routing.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--router',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ROUTER'},
                                                                                                                        u'--shared-secret': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A shared secret consisting of printable characters.  Valid\narguments match the regular expression [ -~]+',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--shared-secret',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': True,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'SHARED_SECRET'},
                                                                                                                        u'--target-vpn-gateway': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'A reference to a target vpn gateway',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--target-vpn-gateway',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': True,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'TARGET_VPN_GATEWAY'},
                                                                                                                        u'--target-vpn-gateway-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The region of the Target VPN Gateway to operate on. Should be the same as region, if not specified, it will be automatically set. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--target-vpn-gateway-region',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'TARGET_VPN_GATEWAY_REGION'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'create',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'compute',
                                                                                                                       u'vpn-tunnels',
                                                                                                                       u'create'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the VPN tunnel.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'\n*create* is used to create a VPN tunnel between a VPN Gateway\nin Google Cloud Platform and an external gateway that is\nidentified by --peer-address.\n'}},
                                                                                                 u'delete': {u'capsule': u'*(BETA)* Delete vpn tunnels.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--region',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REGION'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'delete',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'compute',
                                                                                                                       u'vpn-tunnels',
                                                                                                                       u'delete'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The resources to delete.',
                                                                                                                               u'name': u'names',
                                                                                                                               u'nargs': u'+',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine vpn tunnels.\n'}},
                                                                                                 u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine vpn tunnel.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--region',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REGION'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'describe',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'compute',
                                                                                                                         u'vpn-tunnels',
                                                                                                                         u'describe'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the resource to fetch.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine vpn tunnel in a project.\n'}},
                                                                                                 u'list': {u'capsule': u'*(BETA)* List Google Compute Engine VPN tunnels.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--filter',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--limit',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-uri',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_URI'},
                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--page-size',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                      u'--regexp': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--regexp',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'REGEXP'},
                                                                                                                      u'--regions': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--regions',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'REGION'},
                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'FIELD'},
                                                                                                                      u'--uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'URI'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'list',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'compute',
                                                                                                                     u'vpn-tunnels',
                                                                                                                     u'list'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': [],
                                                                                                                             u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'*',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine VPN tunnels in a project.\n\nBy default, VPN tunnels from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                         u'EXAMPLES': u"To list all VPN tunnels in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all VPN tunnels in a project, run:\n\n  $ list --uri\n\nTo list all VPN tunnels in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}}},
                                                                                   u'flags': {},
                                                                                   u'group': True,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'vpn-tunnels',
                                                                                   u'path': [u'gcloud',
                                                                                             u'beta',
                                                                                             u'compute',
                                                                                             u'vpn-tunnels'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'BETA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* Read and manipulate Google Compute Engine VPN Tunnels.'}},
                                                                  u'xpn': {u'capsule': u'*(BETA)* View cross-project networking (XPN).',
                                                                           u'commands': {u'get-host-project': {u'capsule': u'*(BETA)* Get the XPN host project that the given project is linked to.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'get-host-project',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'compute',
                                                                                                                         u'xpn',
                                                                                                                         u'get-host-project'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'ID for the project to get the host project for',
                                                                                                                                 u'name': u'project',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'PROJECT_ID'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Get the cross-project networking (XPN) host project of this project, whose\nnetworks can be accessed from this one via XPN.',
                                                                                                                             u'EXAMPLES': u'\nIf the project `xpn-user` can use the project `xpn-host` via XPN,\n\n  $ get-host-project xpn-user\n\nwill show the `xpn-host` project.\n'}},
                                                                                         u'organizations': {u'capsule': u'*(BETA)* View organizations for cross-project networking (XPN).',
                                                                                                            u'commands': {u'list-host-projects': {u'capsule': u'*(BETA)* List projects in a given organization that are enabled as XPN hosts.',
                                                                                                                                                  u'commands': {},
                                                                                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--filter',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'string',
                                                                                                                                                                           u'value': u'EXPRESSION'},
                                                                                                                                                             u'--limit': {u'attr': {},
                                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--limit',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'LIMIT'},
                                                                                                                                                             u'--no-uri': {u'attr': {},
                                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': True,
                                                                                                                                                                           u'description': u'',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': True,
                                                                                                                                                                           u'name': u'--no-uri',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'bool',
                                                                                                                                                                           u'value': u'NO_URI'},
                                                                                                                                                             u'--page-size': {u'attr': {},
                                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--page-size',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                                                                                             u'--sort-by': {u'attr': {},
                                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--sort-by',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'list',
                                                                                                                                                                            u'value': u'FIELD'},
                                                                                                                                                             u'--uri': {u'attr': {},
                                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': False,
                                                                                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--uri',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'bool',
                                                                                                                                                                        u'value': u'URI'}},
                                                                                                                                                  u'group': False,
                                                                                                                                                  u'groups': {},
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'list-host-projects',
                                                                                                                                                  u'path': [u'gcloud',
                                                                                                                                                            u'beta',
                                                                                                                                                            u'compute',
                                                                                                                                                            u'xpn',
                                                                                                                                                            u'organizations',
                                                                                                                                                            u'list-host-projects'],
                                                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'ID for the organization whose XPN host projects to list.',
                                                                                                                                                                    u'name': u'id',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'value': u'ORGANIZATION_ID'}],
                                                                                                                                                  u'release': u'BETA',
                                                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* List projects in a given organization that are enabled as XPN hosts.',
                                                                                                                                                                u'EXAMPLES': u'\nTo list the XPN host projects in the organization with ID 12345, run:\n\n  $ list-host-projects 12345\n  NAME       CREATION_TIMESTAMP            XPN_PROJECT_STATUS\n  xpn-host1  2000-01-01T12:00:00.00-00:00  HOST\n  xpn-host2  2000-01-02T12:00:00.00-00:00  HOST\n'}}},
                                                                                                            u'flags': {},
                                                                                                            u'group': True,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'organizations',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'compute',
                                                                                                                      u'xpn',
                                                                                                                      u'organizations'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* View organizations for cross-project networking (XPN).'}}},
                                                                           u'flags': {},
                                                                           u'group': True,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'xpn',
                                                                           u'path': [u'gcloud',
                                                                                     u'beta',
                                                                                     u'compute',
                                                                                     u'xpn'],
                                                                           u'positionals': [],
                                                                           u'release': u'BETA',
                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* View cross-project networking (XPN).'}},
                                                                  u'zones': {u'capsule': u'*(BETA)* List Google Compute Engine zones.',
                                                                             u'commands': {u'describe': {u'capsule': u'*(BETA)* Describe a Google Compute Engine zone.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'compute',
                                                                                                                   u'zones',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the resource to fetch.',
                                                                                                                           u'name': u'name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine zone.\n'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* List Google Compute Engine zones.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--regexp': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--regexp',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'REGEXP'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'compute',
                                                                                                               u'zones',
                                                                                                               u'list'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': [],
                                                                                                                       u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                       u'name': u'names',
                                                                                                                       u'nargs': u'*',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'NAME'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine zones in a project.\n',
                                                                                                                   u'EXAMPLES': u'To list all zones in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all zones in a project, run:\n\n  $ list --uri\n'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'zones',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'compute',
                                                                                       u'zones'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* List Google Compute Engine zones.'}}},
                                                    u'flags': {},
                                                    u'group': True,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'compute',
                                                    u'path': [u'gcloud',
                                                              u'beta',
                                                              u'compute'],
                                                    u'positionals': [],
                                                    u'release': u'BETA',
                                                    u'sections': {u'DESCRIPTION': u"The gcloud compute command group lets you create, configure and\nmanipulate Google Compute Engine virtual machines.\n\nWith Compute Engine you can create and run virtual machines\non Google infrastructure. Compute Engine offers scale, performance, and\nvalue that allows you to easily launch large compute clusters on\nGoogle's infrastructure.\n\nMore information on Compute Engine can be found here:\nhttps://cloud.google.com/compute/ and detailed documentation can be\nfound here: https://cloud.google.com/compute/docs/\n"}},
                                       u'config': {u'capsule': u'*(BETA)* View and edit Cloud SDK properties.',
                                                   u'commands': {u'configurations': {u'capsule': u'*(BETA)* Manage the set of gcloud named configurations.',
                                                                                     u'commands': {u'activate': {u'capsule': u'*(BETA)* Activates an existing named configuration.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'activate',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'config',
                                                                                                                           u'configurations',
                                                                                                                           u'activate'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Name of the configuration to activate',
                                                                                                                                   u'name': u'configuration-name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'CONFIGURATION_NAME'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Activates an existing named configuration.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                                               u'EXAMPLES': u'To activate an existing named configuration, run:\n\n  $ activate my_config\n\nTo list all properties in the activated configuration, run:\n\n  $ gcloud config list --all\n'}},
                                                                                                   u'create': {u'capsule': u'*(BETA)* Creates a new named configuration.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--activate': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'If true, activate this configuration upon create. Enabled by default, use *--no-activate* to disable.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--activate',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'ACTIVATE'},
                                                                                                                          u'--no-activate': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-activate',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_ACTIVATE'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'create',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'config',
                                                                                                                         u'configurations',
                                                                                                                         u'create'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Name of the configuration to create',
                                                                                                                                 u'name': u'configuration-name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'CONFIGURATION_NAME'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u"*(BETA)* Creates a new named configuration.\n\nExcept for special cases (NONE), configuration names start with a\nlower case letter and contain only lower case letters a-z, digits 0-9,\nand hyphens '-'.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n",
                                                                                                                             u'EXAMPLES': u'To create a new named configuration, run:\n\n  $ create my-config\n'}},
                                                                                                   u'delete': {u'capsule': u'*(BETA)* Deletes a named configuration.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'delete',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'config',
                                                                                                                         u'configurations',
                                                                                                                         u'delete'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Name of the configuration to delete. Cannot be currently active configuration.',
                                                                                                                                 u'name': u'configuration-names',
                                                                                                                                 u'nargs': u'+',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'CONFIGURATION_NAMES'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes a named configuration. You cannot delete a configuration that is active, even\nwhen overridden with the --configuration flag.  To delete the current\nactive configuration, first `gcloud config configurations activate`\nanother one.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                                             u'EXAMPLES': u'To delete a named configuration, run:\n\n  $ delete my_config\n\nTo delete more than one configuration, run:\n\n  $ delete my_config1 my_config2\n\nTo list existing configurations, run:\n\n  $ gcloud config configurations list\n'}},
                                                                                                   u'describe': {u'capsule': u'*(BETA)* Describes a named configuration by listing its properties.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--all': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Include unset properties in output.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--all',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'ALL'},
                                                                                                                            u'--no-all': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-all',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_ALL'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'describe',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'config',
                                                                                                                           u'configurations',
                                                                                                                           u'describe'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Name of the configuration to describe',
                                                                                                                                   u'name': u'configuration-name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'CONFIGURATION_NAME'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Describes a named configuration by listing its properties.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                                               u'EXAMPLES': u'To describe existing named configuration, run:\n\n  $ describe my_config\n\nThis is similar to:\n\n  $ gcloud config configurations activate my_config\n\n  $ gcloud config list\n'}},
                                                                                                   u'list': {u'capsule': u'*(BETA)* Lists existing named configurations.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--limit',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'FIELD'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'list',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'config',
                                                                                                                       u'configurations',
                                                                                                                       u'list'],
                                                                                                             u'positionals': [],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Lists existing named configurations.\n\nRun `$ gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                                           u'EXAMPLES': u'To list all available configurations, run:\n\n  $ list\n'}}},
                                                                                     u'flags': {},
                                                                                     u'group': True,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'configurations',
                                                                                     u'path': [u'gcloud',
                                                                                               u'beta',
                                                                                               u'config',
                                                                                               u'configurations'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'BETA',
                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Manage the set of gcloud named configurations.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n'}},
                                                                 u'get-value': {u'capsule': u'*(BETA)* Print the value of a Cloud SDK property.',
                                                                                u'commands': {},
                                                                                u'flags': {},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'get-value',
                                                                                u'path': [u'gcloud',
                                                                                          u'beta',
                                                                                          u'config',
                                                                                          u'get-value'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'The property to be fetched. Note that `SECTION/` is optional while referring to properties in the core section.',
                                                                                                  u'name': u'property',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'SECTION/PROPERTY'}],
                                                                                u'release': u'BETA',
                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* get-value prints the property value from your active configuration only.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo print the project property in the core section, run:\n\n  $ get-value project\n\nTo print the zone property in the compute section, run:\n\n  $ get-value compute/zone'}},
                                                                 u'list': {u'capsule': u'*(BETA)* View Cloud SDK properties.',
                                                                           u'commands': {},
                                                                           u'flags': {u'--all': {u'attr': {},
                                                                                                 u'category': u'',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': False,
                                                                                                 u'description': u'List all set and unset properties that match the arguments.',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'--all',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'type': u'bool',
                                                                                                 u'value': u'ALL'},
                                                                                      u'--filter': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--filter',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'EXPRESSION'},
                                                                                      u'--limit': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--limit',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'LIMIT'},
                                                                                      u'--no-all': {u'attr': {},
                                                                                                    u'category': u'',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': True,
                                                                                                    u'description': u'',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': True,
                                                                                                    u'name': u'--no-all',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'NO_ALL'},
                                                                                      u'--sort-by': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--sort-by',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'list',
                                                                                                     u'value': u'FIELD'}},
                                                                           u'group': False,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'list',
                                                                           u'path': [u'gcloud',
                                                                                     u'beta',
                                                                                     u'config',
                                                                                     u'list'],
                                                                           u'positionals': [{u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u'The property to be listed. Note that SECTION/ is optional while referring to properties in the core section.',
                                                                                             u'name': u'property',
                                                                                             u'nargs': u'?',
                                                                                             u'required': False,
                                                                                             u'value': u'SECTION/PROPERTY'}],
                                                                           u'release': u'BETA',
                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all properties in your active configuration. These include the\naccount used to authorize access to the Cloud Platform, the current Cloud\nPlatform project, and the default Compute Engine region and zone, if set. See\n`gcloud topic configurations` for more information.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo list the project property in the core section, run:\n\n  $ list project\n\nTo list the zone property in the compute section, run:\n\n  $ list compute/zone\n\nTo list all the properties, run:\n\n  $ list --all\n\nNote you cannot specify both --all and a property name.'}},
                                                                 u'set': {u'capsule': u'*(BETA)* Set a Cloud SDK property.',
                                                                          u'commands': {},
                                                                          u'flags': {u'--installation': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': False,
                                                                                                         u'description': u'Typically properties are updated only in the currently active\nconfiguration, but when `--installation` is given the property is\nupdated for the entire gcloud installation.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--installation',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'INSTALLATION'},
                                                                                     u'--no-installation': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': True,
                                                                                                            u'description': u'',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': True,
                                                                                                            u'name': u'--no-installation',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'NO_INSTALLATION'}},
                                                                          u'group': False,
                                                                          u'groups': {},
                                                                          u'hidden': False,
                                                                          u'name': u'set',
                                                                          u'path': [u'gcloud',
                                                                                    u'beta',
                                                                                    u'config',
                                                                                    u'set'],
                                                                          u'positionals': [{u'completer': u'',
                                                                                            u'default': None,
                                                                                            u'description': u'The property to be set. Note that SECTION/ is optional while referring to properties in the core section.',
                                                                                            u'name': u'property',
                                                                                            u'nargs': u'0',
                                                                                            u'required': False,
                                                                                            u'value': u'SECTION/PROPERTY'},
                                                                                           {u'completer': u'',
                                                                                            u'default': None,
                                                                                            u'description': u'The value to be set.',
                                                                                            u'name': u'value',
                                                                                            u'nargs': u'0',
                                                                                            u'required': False,
                                                                                            u'value': u'VALUE'}],
                                                                          u'release': u'BETA',
                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* By default, sets the property in your active configuration only. Use the\n`--installation` flag to set the property across all configurations. See\n`gcloud topic configurations` for more information.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo set the project property in the core section, run:\n\n  $ set project myProject\n\nTo set the zone property in the compute section, run:\n\n  $ set compute/zone zone3'}},
                                                                 u'unset': {u'capsule': u'*(BETA)* Unset a Cloud SDK property.',
                                                                            u'commands': {},
                                                                            u'flags': {u'--installation': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'Typically properties are updated only in the currently active\nconfiguration, but when `--installation` is given the property is\nupdated for the entire gcloud installation.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--installation',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'INSTALLATION'},
                                                                                       u'--no-installation': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-installation',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_INSTALLATION'}},
                                                                            u'group': False,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'unset',
                                                                            u'path': [u'gcloud',
                                                                                      u'beta',
                                                                                      u'config',
                                                                                      u'unset'],
                                                                            u'positionals': [{u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u'The property to be unset. Note that SECTION/ is optional while referring to properties in the core section.',
                                                                                              u'name': u'property',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'value': u'SECTION/PROPERTY'}],
                                                                            u'release': u'BETA',
                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* By default, unsets the property in your active configuration only. Use the\n`--installation` flag to unset the property across all configurations. See\n`gcloud topic configurations` for more information.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo unset the project property in the core section, run:\n\n  $ unset project\n\nTo unset the zone property in the compute section, run:\n\n  $ unset compute/zone'}}},
                                                   u'flags': {},
                                                   u'group': True,
                                                   u'groups': {},
                                                   u'hidden': False,
                                                   u'name': u'config',
                                                   u'path': [u'gcloud',
                                                             u'beta',
                                                             u'config'],
                                                   u'positionals': [],
                                                   u'release': u'BETA',
                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* The config command group lets you set, view and unset properties used by\nCloud SDK.\n\nA configuration is a set of properties that govern the behavior of gcloud\nand other Cloud SDK tools. The initial `default` configuration is set when\n`gcloud init` is run. You can create additional named configurations using\n`gcloud init` or `config configurations create`.\n\nTo switch between configurations, use `config configurations activate`.\n\ngcloud supports several flags that have the same effect as properties in\na configuration (for example, gcloud supports both the `--project` flag and\n`project` property). Properties differ from flags in that flags affect command\nbehavior on a per-invocation basis. Properties allow you to maintain the same\nsettings across command executions.\n\nFor more information on configurations, see `gcloud topic configurations`.\n\n## AVAILABLE PROPERTIES\n\n{properties}'}},
                                       u'container': {u'capsule': u'*(BETA)* Deploy and manage clusters of machines for running containers.',
                                                      u'commands': {u'builds': {u'capsule': u'*(BETA)* Create and manage container builds.',
                                                                                u'commands': {u'cancel': {u'capsule': u'*(BETA)* Cancel an ongoing build.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'cancel',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'container',
                                                                                                                    u'builds',
                                                                                                                    u'cancel'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The build to cancel. The ID of the build is printed at the end of the build submission process, or in the ID column when listing builds.',
                                                                                                                            u'name': u'build',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'BUILD'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Cancel an ongoing build.'}},
                                                                                              u'describe': {u'capsule': u'*(BETA)* Get information about a particular build.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'describe',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'container',
                                                                                                                      u'builds',
                                                                                                                      u'describe'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The build to describe. The ID of the build is printed at the end of the build submission process, or in the ID column when listing builds.',
                                                                                                                              u'name': u'build',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'BUILD'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Get information about a particular build.'}},
                                                                                              u'list': {u'capsule': u'*(BETA)* List builds.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--filter',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                                   u'--limit': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': 50,
                                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--limit',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'int',
                                                                                                                                u'value': u'LIMIT'},
                                                                                                                   u'--no-ongoing': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-ongoing',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_ONGOING'},
                                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_URI'},
                                                                                                                   u'--ongoing': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'Only list builds that are currently QUEUED or WORKING.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--ongoing',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'ONGOING'},
                                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--page-size',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--sort-by',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'FIELD'},
                                                                                                                   u'--uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'URI'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'list',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'container',
                                                                                                                  u'builds',
                                                                                                                  u'list'],
                                                                                                        u'positionals': [],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* List builds.'}},
                                                                                              u'log': {u'capsule': u'*(BETA)* Stream the logs for a build.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--no-stream': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-stream',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_STREAM'},
                                                                                                                  u'--stream': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'If a build is ongoing, stream the logs to stdout until termination.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--stream',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'STREAM'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'log',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'container',
                                                                                                                 u'builds',
                                                                                                                 u'log'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The build whose logs shall be printed. The ID of the build is printed at the end of the build submission process, or in the ID column when listing builds.',
                                                                                                                         u'name': u'build',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'BUILD'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Stream the logs for a build.'}},
                                                                                              u'submit': {u'capsule': u'*(BETA)* Submit a build using the Google Container Builder service.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--async': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--async',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'ASYNC'},
                                                                                                                     u'--config': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The .yaml or .json file to use for build configuration.',
                                                                                                                                   u'group': u'submit.1',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--config',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'CONFIG'},
                                                                                                                     u'--gcs-log-dir': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Directory in Google Cloud Storage to hold build logs. If the bucket does not exist, it will be created. If not set, ```gs://<project id>_cloudbuild/logs``` is used.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--gcs-log-dir',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'GCS_LOG_DIR'},
                                                                                                                     u'--gcs-source-staging-dir': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Directory in Google Cloud Storage to stage a copy of the source used for the build. If the bucket does not exist, it will be created. If not set, ```gs://<project id>_cloudbuild/source``` is used.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--gcs-source-staging-dir',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'GCS_SOURCE_STAGING_DIR'},
                                                                                                                     u'--no-async': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-async',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_ASYNC'},
                                                                                                                     u'--substitutions': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Parameters to be substituted in the build specification.\n+\nFor example (using some nonsensical substitution keys; all keys must begin with\nan underscore):\n+\n    $ gcloud container builds submit . \\\n        --config config.yaml \\\n        --substitutions _FAVORITE_COLOR=blue,_NUM_CANDIES=10\n+\nThis will result in a build where every occurrence of ```${_FAVORITE_COLOR}```\nin certain fields is replaced by "blue", and similarly for ```${_NUM_CANDIES}```\nand "10".\n+\nFor more details, see:\nhttps://cloud.google.com/container-builder/docs/api/build-requests#substitutions',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--substitutions',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'dict',
                                                                                                                                          u'value': u'```_```KEY=VALUE'},
                                                                                                                     u'--tag': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The tag to use with a "docker build" image creation. The Container Builder service will run a remote "docker build -t $TAG .", where $TAG is the tag provided by this flag. The tag must be in the gcr.io/* or *.gcr.io/* namespaces.',
                                                                                                                                u'group': u'submit.1',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--tag',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'TAG'},
                                                                                                                     u'--timeout': {u'attr': {u'property': {u'name': u'container/build_timeout'}},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Maximum time a build can last before it is failed as "TIMEOUT", written as a duration (eg "2h15m5s" is two hours, fifteen minutes, and five seconds). If no unit is specified, seconds is assumed (eg "10" is 10 seconds). Overrides the default *container/build_timeout* property value for this command invocation.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--timeout',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'TIMEOUT'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {u'submit.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                    u'is_mutex': True,
                                                                                                                                    u'is_required': True}},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'submit',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'container',
                                                                                                                    u'builds',
                                                                                                                    u'submit'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The source directory on local disk or tarball in Google Cloud Storage or disk to use for this build.',
                                                                                                                            u'name': u'source',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'SOURCE'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Submit a build using the Google Container Builder service.'}}},
                                                                                u'flags': {},
                                                                                u'group': True,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'builds',
                                                                                u'path': [u'gcloud',
                                                                                          u'beta',
                                                                                          u'container',
                                                                                          u'builds'],
                                                                                u'positionals': [],
                                                                                u'release': u'BETA',
                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Create and manage container builds.'}},
                                                                    u'clusters': {u'capsule': u'*(BETA)* Deploy and teardown Google Container Engine clusters.',
                                                                                  u'commands': {u'create': {u'capsule': u'*(BETA)* Create a cluster for running containers.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--additional-zones': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"The set of additional zones in which the specified node footprint should be\nreplicated. All zones must be in the same region as the cluster's primary zone.\nIf additional-zones is not specified, all nodes will be in the cluster's primary\nzone.\n+\nNote that `NUM_NODES` nodes will be created in each zone, such that if you\nspecify `--num-nodes=4` and choose one additional zone, 8 nodes will be created.\n+\nMultiple locations can be specified, separated by commas. For example:\n+\n  $ {command} example-cluster --zone us-central1-a --additional-zones us-central1-b,us-central1-c",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--additional-zones',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'ZONE'},
                                                                                                                       u'--async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u"Don't wait for the operation to complete.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'ASYNC'},
                                                                                                                       u'--cluster-ipv4-cidr': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The IP address range for the pods in this cluster in CIDR notation (e.g. 10.0.0.0/14). Due to kube-proxy limitations, this range must be a subset of the 10.0.0.0/8 space. Defaults to server-specified.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--cluster-ipv4-cidr',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'CLUSTER_IPV4_CIDR'},
                                                                                                                       u'--cluster-version': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The Kubernetes version to use for the master and nodes. Defaults to\nserver-specified.\n+\nThe default Kubernetes version are available using the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--cluster-version',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'CLUSTER_VERSION'},
                                                                                                                       u'--disable-addons': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'List of cluster addons to disable. Options are HttpLoadBalancing, HorizontalPodAutoscaling. _DISABLE_ADDONS_ must be one of: *HttpLoadBalancing*, *HorizontalPodAutoscaling*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--disable-addons',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'DISABLE_ADDONS'},
                                                                                                                       u'--disk-size': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Size in GB for node VM boot disks. Defaults to 100GB.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--disk-size',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'DISK_SIZE'},
                                                                                                                       u'--enable-autorepair': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--enable-autorepair',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'ENABLE_AUTOREPAIR'},
                                                                                                                       u'--enable-autoscaling': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--enable-autoscaling',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'ENABLE_AUTOSCALING'},
                                                                                                                       u'--enable-autoupgrade': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u"Sets autoupgrade feature for a cluster's default node-pool(s).\n+\n  $ {command} example-cluster --enable-autoupgrade\n+\nSee https://cloud.google.com/container-engine/docs/node-managament for more info.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--enable-autoupgrade',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'ENABLE_AUTOUPGRADE'},
                                                                                                                       u'--enable-cloud-endpoints': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': True,
                                                                                                                                                     u'description': u'Automatically enable Google Cloud Endpoints to take advantage of API management features. Enabled by default, use *--no-enable-cloud-endpoints* to disable.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--enable-cloud-endpoints',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'ENABLE_CLOUD_ENDPOINTS'},
                                                                                                                       u'--enable-cloud-logging': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': True,
                                                                                                                                                   u'description': u'Automatically send logs from the cluster to the Google Cloud Logging API. Enabled by default, use *--no-enable-cloud-logging* to disable.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--enable-cloud-logging',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'ENABLE_CLOUD_LOGGING'},
                                                                                                                       u'--enable-cloud-monitoring': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': True,
                                                                                                                                                      u'description': u'Automatically send metrics from pods in the cluster to the Google Cloud Monitoring API. VM metrics will be collected by Google Compute Engine regardless of this setting. Enabled by default, use *--no-enable-cloud-monitoring* to disable.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--enable-cloud-monitoring',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'ENABLE_CLOUD_MONITORING'},
                                                                                                                       u'--enable-kubernetes-alpha': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'Enable Kubernetes alpha features on this cluster. Selecting this\noption will result in the cluster having all Kubernetes alpha API groups and\nfeatures turned on. Cluster upgrades (both manual and automatic) will be\ndisabled and the cluster will be automatically deleted after 30 days.\n+\nAlpha clusters are not covered by the Container Engine SLA and should not be\nused for production workloads.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--enable-kubernetes-alpha',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'ENABLE_KUBERNETES_ALPHA'},
                                                                                                                       u'--image-type': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The image type to use for the cluster. Defaults to server-specified.\n+\nImage Type specifies the base OS that the nodes in the cluster will run on.\nIf an image type is specified, that will be assigned to the cluster and all\nfuture upgrades will use the specified image type. If it is not specified the\nserver will pick the default image type.\n+\nThe default image type and the list of valid image types are available\nusing the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--image-type',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'IMAGE_TYPE'},
                                                                                                                       u'--local-ssd-count': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': 0,
                                                                                                                                              u'description': u'The number of local SSD disks to provision on each node.\n+\nLocal SSDs have a fixed 375 GB capacity per device. The number of disks that\ncan be attached to an instance is limited by the maximum number of disks\navailable on a machine, which differs by compute zone. See\nhttps://cloud.google.com/compute/docs/disks/local-ssd for more information.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--local-ssd-count',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'int',
                                                                                                                                              u'value': u'LOCAL_SSD_COUNT'},
                                                                                                                       u'--machine-type': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The type of machine to use for nodes. Defaults to server-specified.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--machine-type',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'MACHINE_TYPE'},
                                                                                                                       u'--max-nodes': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--max-nodes',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'MAX_NODES'},
                                                                                                                       u'--max-nodes-per-pool': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The maximum number of nodes to allocate per default initial node pool. Container engine will automatically create enough nodes pools such that each node pool contains less than --max-nodes-per-pool nodes. Defaults to 1000 nodes, but can be set as low as 100 nodes per pool on initial create.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--max-nodes-per-pool',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'MAX_NODES_PER_POOL'},
                                                                                                                       u'--min-nodes': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--min-nodes',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'MIN_NODES'},
                                                                                                                       u'--network': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The Compute Engine Network that the cluster will connect to. Google Container Engine will use this network when creating routes and firewalls for the clusters. Defaults to the 'default' network.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--network',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'NETWORK'},
                                                                                                                       u'--no-async': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-async',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_ASYNC'},
                                                                                                                       u'--no-enable-autorepair': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-enable-autorepair',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_ENABLE_AUTOREPAIR'},
                                                                                                                       u'--no-enable-autoscaling': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-enable-autoscaling',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_ENABLE_AUTOSCALING'},
                                                                                                                       u'--no-enable-autoupgrade': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': True,
                                                                                                                                                    u'name': u'--no-enable-autoupgrade',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'NO_ENABLE_AUTOUPGRADE'},
                                                                                                                       u'--no-enable-cloud-endpoints': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': True,
                                                                                                                                                        u'description': u'',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': True,
                                                                                                                                                        u'name': u'--no-enable-cloud-endpoints',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'NO_ENABLE_CLOUD_ENDPOINTS'},
                                                                                                                       u'--no-enable-cloud-logging': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': True,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-enable-cloud-logging',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_ENABLE_CLOUD_LOGGING'},
                                                                                                                       u'--no-enable-cloud-monitoring': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': True,
                                                                                                                                                         u'description': u'',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': True,
                                                                                                                                                         u'name': u'--no-enable-cloud-monitoring',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'NO_ENABLE_CLOUD_MONITORING'},
                                                                                                                       u'--no-enable-kubernetes-alpha': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': True,
                                                                                                                                                         u'description': u'',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': True,
                                                                                                                                                         u'name': u'--no-enable-kubernetes-alpha',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'NO_ENABLE_KUBERNETES_ALPHA'},
                                                                                                                       u'--no-preemptible': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-preemptible',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_PREEMPTIBLE'},
                                                                                                                       u'--no-wait': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-wait',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_WAIT'},
                                                                                                                       u'--node-labels': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Applies the given kubernetes labels on all nodes in the new node-pool. Example:\n+\n  $ {command} example-cluster --node-labels=label-a=value1,label-2=value2\n+\nNew nodes, including ones created by resize or recreate, will have these labels\non the kubernetes API node object and can be used in nodeSelectors.\nSee http://kubernetes.io/docs/user-guide/node-selection/ for examples.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--node-labels',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'dict',
                                                                                                                                          u'value': u'NODE_LABELS'},
                                                                                                                       u'--num-nodes': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': 3,
                                                                                                                                        u'description': u"The number of nodes to be created in each of the cluster's zones.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--num-nodes',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'int',
                                                                                                                                        u'value': u'NUM_NODES'},
                                                                                                                       u'--password': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The password to use for cluster auth. Defaults to a server-specified randomly-generated string.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--password',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'PASSWORD'},
                                                                                                                       u'--preemptible': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'Create nodes using preemptible VM instances in the new cluster.\n+\n  $ {command} example-cluster --preemptible\n+\nNew nodes, including ones created by resize or recreate, will use preemptible\nVM instances. See https://cloud.google.com/container-engine/docs/preemptible-vm\nfor more information on how to use Preemptible VMs with Container Engine.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--preemptible',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'PREEMPTIBLE'},
                                                                                                                       u'--scopes': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Specifies scopes for the node instances. The project\'s default\nservice account is used. Examples:\n+\n  $ {command} example-cluster --scopes https://www.googleapis.com/auth/devstorage.read_only\n+\n  $ {command} example-cluster --scopes bigquery,storage-rw,compute-ro\n+\nMultiple SCOPEs can specified, separated by commas. The scopes\nnecessary for the cluster to function properly (compute-rw, storage-ro),\nare always added, even if not explicitly specified.\n+\nSCOPE can be either the full URI of the scope or an alias.\nAvailable aliases are:\n+\n[format="csv",options="header"]\n|========\nAlias,URI\nbigquery,https://www.googleapis.com/auth/bigquery\ncloud-platform,https://www.googleapis.com/auth/cloud-platform\ncloud-source-repos,https://www.googleapis.com/auth/source.full_control\ncloud-source-repos-ro,https://www.googleapis.com/auth/source.read_only\ncompute-ro,https://www.googleapis.com/auth/compute.readonly\ncompute-rw,https://www.googleapis.com/auth/compute\ndatastore,https://www.googleapis.com/auth/datastore\ndefault,https://www.googleapis.com/auth/cloud.useraccounts.readonly\n,https://www.googleapis.com/auth/devstorage.read_only\n,https://www.googleapis.com/auth/logging.write\n,https://www.googleapis.com/auth/monitoring.write\n,https://www.googleapis.com/auth/service.management.readonly\n,https://www.googleapis.com/auth/servicecontrol\nlogging-write,https://www.googleapis.com/auth/logging.write\nmonitoring,https://www.googleapis.com/auth/monitoring\nmonitoring-write,https://www.googleapis.com/auth/monitoring.write\nservice-control,https://www.googleapis.com/auth/servicecontrol\nservice-management,https://www.googleapis.com/auth/service.management.readonly\nsql,https://www.googleapis.com/auth/sqlservice\nsql-admin,https://www.googleapis.com/auth/sqlservice.admin\nstorage-full,https://www.googleapis.com/auth/devstorage.full_control\nstorage-ro,https://www.googleapis.com/auth/devstorage.read_only\nstorage-rw,https://www.googleapis.com/auth/devstorage.read_write\ntaskqueue,https://www.googleapis.com/auth/taskqueue\nuseraccounts-ro,https://www.googleapis.com/auth/cloud.useraccounts.readonly\nuseraccounts-rw,https://www.googleapis.com/auth/cloud.useraccounts\nuserinfo-email,https://www.googleapis.com/auth/userinfo.email\n|========',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--scopes',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'SCOPE'},
                                                                                                                       u'--service-account': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The Google Cloud Platform Service Account to be used by the node VMs. If no Service Account is specified, the "default" service account is used.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--service-account',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'SERVICE_ACCOUNT'},
                                                                                                                       u'--subnetwork': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The name of the Google Compute Engine subnetwork (https://cloud.google.com/compute/docs/subnetworks) to which the cluster is connected. If specified, the cluster\'s network must be a "custom subnet" network.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--subnetwork',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'SUBNETWORK'},
                                                                                                                       u'--tags': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Applies the given Compute Engine tags (comma separated) on all nodes in the new\nnode-pool. Example:\n+\n  $ {command} example-cluster --tags=tag1,tag2\n+\nNew nodes, including ones created by resize or recreate, will have these tags\non the Compute Engine API instance object and can be used in firewall rules.\nSee https://cloud.google.com/sdk/gcloud/reference/compute/firewall-rules/create\nfor examples.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--tags',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'TAG'},
                                                                                                                       u'--timeout': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': 1800,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--timeout',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'int',
                                                                                                                                      u'value': u'TIMEOUT'},
                                                                                                                       u'--username': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': u'admin',
                                                                                                                                       u'description': u'The user name to use for cluster auth.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--username',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'USERNAME'},
                                                                                                                       u'--wait': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--wait',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'WAIT'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'create',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'container',
                                                                                                                      u'clusters',
                                                                                                                      u'create'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The name of this cluster.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Create a cluster for running containers.'}},
                                                                                                u'delete': {u'capsule': u'*(BETA)* Delete an existing cluster for running containers.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u"Don't wait for the operation to complete.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'ASYNC'},
                                                                                                                       u'--no-async': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-async',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_ASYNC'},
                                                                                                                       u'--no-wait': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-wait',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_WAIT'},
                                                                                                                       u'--timeout': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': 1800,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--timeout',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'int',
                                                                                                                                      u'value': u'TIMEOUT'},
                                                                                                                       u'--wait': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--wait',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'WAIT'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'delete',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'container',
                                                                                                                      u'clusters',
                                                                                                                      u'delete'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The names of the clusters to delete.',
                                                                                                                              u'name': u'names',
                                                                                                                              u'nargs': u'+',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Delete an existing cluster for running containers.'}},
                                                                                                u'describe': {u'capsule': u'*(BETA)* Describe an existing cluster for running containers.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'container',
                                                                                                                        u'clusters',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of this cluster.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Describe an existing cluster for running containers.'}},
                                                                                                u'get-credentials': {u'capsule': u'*(BETA)* Fetch credentials for a running cluster.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'get-credentials',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'container',
                                                                                                                               u'clusters',
                                                                                                                               u'get-credentials'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the cluster to get credentials for. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                       u'name': u'name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Updates a kubeconfig file with appropriate credentials to point\nkubectl at a Container Engine Cluster. By default, credentials\nare written to HOME/.kube/config. You can provide an alternate\npath by setting the KUBECONFIG environment variable.\n\nSee [](https://cloud.google.com/container-engine/docs/kubectl) for\nkubectl documentation.'}},
                                                                                                u'list': {u'capsule': u'*(BETA)* List existing clusters for running containers.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'container',
                                                                                                                    u'clusters',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* List existing clusters for running containers.'}},
                                                                                                u'resize': {u'capsule': u'*(BETA)* Resizes an existing cluster for running containers.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u"Don't wait for the operation to complete.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'ASYNC'},
                                                                                                                       u'--no-async': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-async',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_ASYNC'},
                                                                                                                       u'--no-wait': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-wait',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_WAIT'},
                                                                                                                       u'--node-pool': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The node pool to resize.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--node-pool',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'NODE_POOL'},
                                                                                                                       u'--size': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Target number of nodes in the cluster.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'SIZE'},
                                                                                                                       u'--wait': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--wait',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'WAIT'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'resize',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'container',
                                                                                                                      u'clusters',
                                                                                                                      u'resize'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The name of this cluster.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'\n        Resize an existing cluster to a provided size.\n\nIf you have multiple node pools, you must specify which node pool to resize by\nusing the --node-pool flag. You are not required to use the flag if you have\na single node pool.\n\nWhen increasing the size of a container cluster, the new instances are created\nwith the same configuration as the existing instances.\nExisting pods are not moved onto the new instances,\nbut new pods (such as those created by resizing a replication controller)\nwill be scheduled onto the new instances.\n\nWhen decreasing a cluster, the pods that are scheduled on the instances being\nremoved will be killed. If your pods are being managed by a replication\ncontroller, the controller will attempt to reschedule them onto the remaining\ninstances. If your pods are not managed by a replication controller,\nthey will not be restarted.\nNote that when resizing down, instances running pods and instances without pods\nare not differentiated. Resize will pick instances to remove at random.\n'}},
                                                                                                u'update': {u'capsule': u'*(BETA)* Update cluster settings for an existing container cluster.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--additional-zones': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The set of additional zones in which the cluster\'s node footprint should be\nreplicated. All zones must be in the same region as the cluster\'s primary zone.\n+\nNote that the exact same footprint will be replicated in all zones, such that\nif you created a cluster with 4 nodes in a single zone and then use this option\nto spread across 2 more zones, 8 additional nodes will be created.\n+\nMultiple locations can be specified, separated by commas. For example:\n+\n  $ {{command}} example-cluster --zone us-central1-a --additional-zones us-central1-b,us-central1-c\n+\nTo remove all zones other than the cluster\'s primary zone, pass the empty string\nto the flag. For example:\n+\n  $ {{command}} example-cluster --zone us-central1-a --additional-zones ""',
                                                                                                                                               u'group': u'update.1',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--additional-zones',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'ZONE'},
                                                                                                                       u'--async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u"Don't wait for the operation to complete.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'ASYNC'},
                                                                                                                       u'--disable-autoscaling': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'update.1',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--disable-autoscaling',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'DISABLE_AUTOSCALING'},
                                                                                                                       u'--enable-autoscaling': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'update.1',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--enable-autoscaling',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'ENABLE_AUTOSCALING'},
                                                                                                                       u'--max-nodes': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--max-nodes',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'MAX_NODES'},
                                                                                                                       u'--min-nodes': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--min-nodes',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'MIN_NODES'},
                                                                                                                       u'--monitoring-service': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The monitoring service to use for the cluster. Options are: "monitoring.googleapis.com" (the Google Cloud Monitoring service),  "none" (no metrics will be exported from the cluster)',
                                                                                                                                                 u'group': u'update.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--monitoring-service',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'MONITORING_SERVICE'},
                                                                                                                       u'--no-async': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-async',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_ASYNC'},
                                                                                                                       u'--no-wait': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-wait',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_WAIT'},
                                                                                                                       u'--node-pool': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Node pool to be updated.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--node-pool',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'NODE_POOL'},
                                                                                                                       u'--update-addons': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Cluster addons to enable or disable. Options are\nHorizontalPodAutoscaling=ENABLED|DISABLED\nHttpLoadBalancing=ENABLED|DISABLED',
                                                                                                                                            u'group': u'update.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--update-addons',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'dict',
                                                                                                                                            u'value': u'ADDON=ENABLED|DISABLED'},
                                                                                                                       u'--wait': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--wait',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'WAIT'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {u'update.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                      u'is_mutex': True,
                                                                                                                                      u'is_required': True}},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'update',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'container',
                                                                                                                      u'clusters',
                                                                                                                      u'update'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The name of the cluster to update.',
                                                                                                                              u'name': u'name',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'NAME'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Update cluster settings for an existing container cluster.'}},
                                                                                                u'upgrade': {u'capsule': u'*(BETA)* Upgrade the Kubernetes version of an existing container cluster.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--async': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u"Don't wait for the operation to complete.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--async',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'ASYNC'},
                                                                                                                        u'--cluster-version': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"The Kubernetes release version to which to upgrade the cluster's nodes.\n+\nIf provided, the --cluster-version must be no greater than the cluster\nmaster's minor version (x.*X*.x), and must be a latest patch version\n(x.x.*X*).\n+\nYou can find the list of allowed versions for upgrades by running:\n+\n  $ gcloud container get-server-config",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--cluster-version',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'CLUSTER_VERSION'},
                                                                                                                        u'--image-type': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The image type to use for the cluster/node pool. Defaults to server-specified.\n+\nImage Type specifies the base OS that the nodes in the cluster/node pool will run on.\nIf an image type is specified, that will be assigned to the cluster/node pool and all\nfuture upgrades will use the specified image type. If it is not specified the\nserver will pick the default image type.\n+\nThe default image type and the list of valid image types are available\nusing the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--image-type',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'IMAGE_TYPE'},
                                                                                                                        u'--master': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u"Upgrade the cluster's master to the latest version of Kubernetes supported on Container Engine. Nodes cannot be upgraded at the same time as the master.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--master',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'MASTER'},
                                                                                                                        u'--no-async': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-async',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ASYNC'},
                                                                                                                        u'--no-master': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-master',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_MASTER'},
                                                                                                                        u'--no-wait': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-wait',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_WAIT'},
                                                                                                                        u'--node-pool': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The node pool to upgrade.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--node-pool',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'NODE_POOL'},
                                                                                                                        u'--wait': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--wait',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'WAIT'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'upgrade',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'container',
                                                                                                                       u'clusters',
                                                                                                                       u'upgrade'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the cluster to upgrade.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u"Upgrades the Kubernetes version of an existing container cluster.\n\nThis command upgrades the Kubernetes version of the *nodes* of a cluster.\nThe Kubernetes version of the cluster's *master* is periodically upgraded\nautomatically as new releases are available.\n\n*By running this command, all of the cluster's nodes will be deleted and*\n*recreated one at a time.* While persistent Kubernetes resources, such as\npods backed by replication controllers, will be rescheduled onto new nodes,\na small cluster may experience a few minutes where there are insufficient\nnodes available to run all of the scheduled Kubernetes resources.\n\n*Please ensure that any data you wish to keep is stored on a persistent*\n*disk before upgrading the cluster.* Ephemeral Kubernetes resources--in\nparticular, pods without replication controllers--will be lost, while\npersistent Kubernetes resources will get rescheduled.\n",
                                                                                                                           u'EXAMPLES': u'Upgrade the nodes of <cluster> to the Kubernetes version of the cluster\'s\nmaster.\n\n  $ upgrade <cluster>\n\nUpgrade the nodes of <cluster> to Kubernetes version x.y.z.\n\n  $ upgrade <cluster> --cluster-version "x.y.z"\n'}}},
                                                                                  u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--zone',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'ZONE'}},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'clusters',
                                                                                  u'path': [u'gcloud',
                                                                                            u'beta',
                                                                                            u'container',
                                                                                            u'clusters'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'BETA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Deploy and teardown Google Container Engine clusters.'}},
                                                                    u'get-server-config': {u'capsule': u'*(BETA)* Get Container Engine server config.',
                                                                                           u'commands': {},
                                                                                           u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--zone',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'ZONE'}},
                                                                                           u'group': False,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'get-server-config',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'beta',
                                                                                                     u'container',
                                                                                                     u'get-server-config'],
                                                                                           u'positionals': [],
                                                                                           u'release': u'BETA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Get Container Engine server config.'}},
                                                                    u'images': {u'capsule': u'*(BETA)* List and manipulate Google Container Registry images.',
                                                                                u'commands': {u'add-tag': {u'capsule': u'*(BETA)* Adds tags to existing image.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'add-tag',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'container',
                                                                                                                     u'images',
                                                                                                                     u'add-tag'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The fully qualified image reference to add a tag for.\n*.gcr.io/repository:tag*.gcr.io/repository@digest',
                                                                                                                             u'name': u'src-image',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'SRC_IMAGE'},
                                                                                                                            {u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The fully qualified image reference to be the new tag.\n*.gcr.io/repository:tag',
                                                                                                                             u'name': u'dest-image',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'DEST_IMAGE'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'The container images add-tag command adds the tag specified in\nthe second tag parameter to the image referenced in the first\ntag parameter. Repositories must be hosted by the Google Container\nRegistry.\n',
                                                                                                                         u'EXAMPLES': u'Add a tag to another tag:\n\n  $ {command} gcr.io/myproject/myimage:mytag1\n    gcr.io/myproject/myimage:mytag2\n\nAdd a tag to a digest\n\n  $ {command} gcr.io/myproject/myimage@sha256:digest\n    gcr.io/myproject/myimage:mytag2\n\nAdd a tag to latest\n\n  $ {command} gcr.io/myproject/myimage\n    gcr.io/myproject/myimage:mytag2\n\nPromote a tag to latest\n\n  $ {command} gcr.io/myproject/myimage:mytag1\n    gcr.io/myproject/myimage:latest\n\n'}},
                                                                                              u'delete': {u'capsule': u'*(BETA)* Delete existing images.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'delete',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'container',
                                                                                                                    u'images',
                                                                                                                    u'delete'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The IMAGE_NAME or IMAGE_NAMES to delete\nFormat For Digest: *.gcr.io/repository@<digest>Format For Tag: *.gcr.io/repository:<tag>',
                                                                                                                            u'name': u'image-names',
                                                                                                                            u'nargs': u'+',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'IMAGE_NAMES'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'The container images delete command deletes the specified tag or\ndigest from the registry. If a tag is specified, only the tag is\ndeleted from the registry and image layers remain accessible by\ndigest. If a digest is specified, image layers are fully deleted from\nthe registry.\n',
                                                                                                                        u'EXAMPLES': u'Deletes the tag or digest from the input IMAGE_NAME:\n\n  $ {command} <IMAGE_NAME>\n\n'}},
                                                                                              u'describe': {u'capsule': u'*(BETA)* Lists container analysis data for a given image.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--occurrence-filter': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': u'kind = "BUILD_DETAILS" OR kind = "PACKAGE_VULNERABILITY" OR kind = "IMAGE_BASIS"',
                                                                                                                                                u'description': u'Additional filter to fetch occurrences for a given fully qualified image reference.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--occurrence-filter',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'OCCURRENCE_FILTER'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'describe',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'container',
                                                                                                                      u'images',
                                                                                                                      u'describe'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The fully qualified image reference to describe.\n*.gcr.io/repository@digest, *.gcr.io/repository:tag',
                                                                                                                              u'name': u'image',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'IMAGE'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Lists container analysis data for a valid image.\n\n## EXAMPLES\n\nDescribe container analysis data for a specified image:\n\n  $ {command} gcr.io/myproject/myimage@digest\n        OR\n  $ {command} gcr.io/myproject/myimage:tag'}},
                                                                                              u'list': {u'capsule': u'*(BETA)* List existing images.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--filter',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                                   u'--limit': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--limit',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'LIMIT'},
                                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_URI'},
                                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--page-size',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                                   u'--repository': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the repository. Format: *.gcr.io/repository. Defaults to gcr.io/<project>, for the active project.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--repository',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'REPOSITORY'},
                                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--sort-by',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'FIELD'},
                                                                                                                   u'--uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'URI'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'list',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'container',
                                                                                                                  u'images',
                                                                                                                  u'list'],
                                                                                                        u'positionals': [],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'The container images list command of gcloud lists metadata about\nexisting container images in a specified repository. Repositories\nmust be hosted by the Google Container Registry.\n',
                                                                                                                      u'EXAMPLES': u'List the images in a specified repository:\n\n  $ {command} --repository=gcr.io/myproject\n\nList the images in the default repository:\n\n  $ {command}\n\n'}},
                                                                                              u'list-tags': {u'capsule': u'*(BETA)* List tags and digests for the specified image.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--limit',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                        u'--no-show-occurrences': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-show-occurrences',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_SHOW_OCCURRENCES'},
                                                                                                                        u'--occurrence-filter': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': u'kind = "BUILD_DETAILS" OR kind = "IMAGE_BASIS" OR kind = "PACKAGE_VULNERABILITY"',
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--occurrence-filter',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'OCCURRENCE_FILTER'},
                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--page-size',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                        u'--show-occurrences': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--show-occurrences',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'SHOW_OCCURRENCES'},
                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'FIELD'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'list-tags',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'container',
                                                                                                                       u'images',
                                                                                                                       u'list-tags'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the image. Format: *.gcr.io/repository/image',
                                                                                                                               u'name': u'image',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'IMAGE'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'The container images list-tags command of gcloud lists metadata about\ntags and digests for the specified container image. Images must be\nhosted by the Google Container Registry.\n',
                                                                                                                           u'EXAMPLES': u'List the tags in a specified image:\n\n  $ {command} gcr.io/myproject/myimage\n\n'}}},
                                                                                u'flags': {},
                                                                                u'group': True,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'images',
                                                                                u'path': [u'gcloud',
                                                                                          u'beta',
                                                                                          u'container',
                                                                                          u'images'],
                                                                                u'positionals': [],
                                                                                u'release': u'BETA',
                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* List and manipulate Google Container Registry images.'}},
                                                                    u'node-pools': {u'capsule': u'*(BETA)* Create and delete operations for Google Container Engine node pools.',
                                                                                    u'commands': {u'create': {u'capsule': u'*(BETA)* Create a node pool in a running cluster.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The cluster to add the node pool to. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--cluster',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'CLUSTER'},
                                                                                                                         u'--disk-size': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Size in GB for node VM boot disks. Defaults to 100GB.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--disk-size',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'DISK_SIZE'},
                                                                                                                         u'--enable-autorepair': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--enable-autorepair',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'ENABLE_AUTOREPAIR'},
                                                                                                                         u'--enable-autoscaling': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--enable-autoscaling',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'ENABLE_AUTOSCALING'},
                                                                                                                         u'--enable-autoupgrade': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Sets autoupgrade feature for a node-pool.\n+\n  $ {command} node-pool-1 --cluster=example-cluster --enable-autoupgrade\n+\nSee https://cloud.google.com/container-engine/docs/node-managament for more info.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--enable-autoupgrade',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'ENABLE_AUTOUPGRADE'},
                                                                                                                         u'--enable-cloud-endpoints': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': True,
                                                                                                                                                       u'description': u'Automatically enable Google Cloud Endpoints to take advantage of API management features. Enabled by default, use *--no-enable-cloud-endpoints* to disable.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--enable-cloud-endpoints',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'ENABLE_CLOUD_ENDPOINTS'},
                                                                                                                         u'--image-type': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The image type to use for the node pool. Defaults to server-specified.\n+\nImage Type specifies the base OS that the nodes in the node pool will run on.\nIf an image type is specified, that will be assigned to the node pool and all\nfuture upgrades will use the specified image type. If it is not specified the\nserver will pick the default image type.\n+\nThe default image type and the list of valid image types are available\nusing the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--image-type',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'IMAGE_TYPE'},
                                                                                                                         u'--local-ssd-count': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': 0,
                                                                                                                                                u'description': u'The number of local SSD disks to provision on each node.\n+\nLocal SSDs have a fixed 375 GB capacity per device. The number of disks that\ncan be attached to an instance is limited by the maximum number of disks\navailable on a machine, which differs by compute zone. See\nhttps://cloud.google.com/compute/docs/disks/local-ssd for more information.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--local-ssd-count',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'int',
                                                                                                                                                u'value': u'LOCAL_SSD_COUNT'},
                                                                                                                         u'--machine-type': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The type of machine to use for nodes. Defaults to server-specified.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--machine-type',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'MACHINE_TYPE'},
                                                                                                                         u'--max-nodes': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--max-nodes',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'MAX_NODES'},
                                                                                                                         u'--min-nodes': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--min-nodes',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'MIN_NODES'},
                                                                                                                         u'--no-enable-autorepair': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-enable-autorepair',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_ENABLE_AUTOREPAIR'},
                                                                                                                         u'--no-enable-autoscaling': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-enable-autoscaling',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_ENABLE_AUTOSCALING'},
                                                                                                                         u'--no-enable-autoupgrade': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-enable-autoupgrade',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_ENABLE_AUTOUPGRADE'},
                                                                                                                         u'--no-enable-cloud-endpoints': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': True,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-enable-cloud-endpoints',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_ENABLE_CLOUD_ENDPOINTS'},
                                                                                                                         u'--no-preemptible': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': True,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-preemptible',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_PREEMPTIBLE'},
                                                                                                                         u'--node-labels': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Applies the given kubernetes labels on all nodes in the new node-pool. Example:\n+\n  $ {command} node-pool-1 --cluster=example-cluster --node-labels=label1=value1,label2=value2\n+\nNew nodes, including ones created by resize or recreate, will have these labels\non the kubernetes API node object and can be used in nodeSelectors.\nSee http://kubernetes.io/docs/user-guide/node-selection/ for examples.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--node-labels',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'dict',
                                                                                                                                            u'value': u'NODE_LABELS'},
                                                                                                                         u'--num-nodes': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': 3,
                                                                                                                                          u'description': u"The number of nodes in the node pool in each of the cluster's zones.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--num-nodes',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'int',
                                                                                                                                          u'value': u'NUM_NODES'},
                                                                                                                         u'--preemptible': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'Create nodes using preemptible VM instances in the new nodepool.\n+\n  $ {command} node-pool-1 --cluster=example-cluster --preemptible\n+\nNew nodes, including ones created by resize or recreate, will use preemptible\nVM instances. See https://cloud.google.com/container-engine/docs/preemptible-vm\nfor more information on how to use Preemptible VMs with Container Engine.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--preemptible',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'PREEMPTIBLE'},
                                                                                                                         u'--scopes': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Specifies scopes for the node instances. The project\'s default\nservice account is used. Examples:\n+\n  $ {command} node-pool-1 --cluster=example-cluster --scopes https://www.googleapis.com/auth/devstorage.read_only\n+\n  $ {command} node-pool-1 --cluster=example-cluster --scopes bigquery,storage-rw,compute-ro\n+\nMultiple SCOPEs can specified, separated by commas. The scopes\nnecessary for the cluster to function properly (compute-rw, storage-ro),\nare always added, even if not explicitly specified.\n+\nSCOPE can be either the full URI of the scope or an alias.\nAvailable aliases are:\n+\n[options="header",format="csv",grid="none",frame="none"]\n|========\nAlias,URI\nbigquery,https://www.googleapis.com/auth/bigquery\ncloud-platform,https://www.googleapis.com/auth/cloud-platform\ncloud-source-repos,https://www.googleapis.com/auth/source.full_control\ncloud-source-repos-ro,https://www.googleapis.com/auth/source.read_only\ncompute-ro,https://www.googleapis.com/auth/compute.readonly\ncompute-rw,https://www.googleapis.com/auth/compute\ndatastore,https://www.googleapis.com/auth/datastore\ndefault,https://www.googleapis.com/auth/cloud.useraccounts.readonly\n,https://www.googleapis.com/auth/devstorage.read_only\n,https://www.googleapis.com/auth/logging.write\n,https://www.googleapis.com/auth/monitoring.write\n,https://www.googleapis.com/auth/service.management.readonly\n,https://www.googleapis.com/auth/servicecontrol\nlogging-write,https://www.googleapis.com/auth/logging.write\nmonitoring,https://www.googleapis.com/auth/monitoring\nmonitoring-write,https://www.googleapis.com/auth/monitoring.write\nservice-control,https://www.googleapis.com/auth/servicecontrol\nservice-management,https://www.googleapis.com/auth/service.management.readonly\nsql,https://www.googleapis.com/auth/sqlservice\nsql-admin,https://www.googleapis.com/auth/sqlservice.admin\nstorage-full,https://www.googleapis.com/auth/devstorage.full_control\nstorage-ro,https://www.googleapis.com/auth/devstorage.read_only\nstorage-rw,https://www.googleapis.com/auth/devstorage.read_write\ntaskqueue,https://www.googleapis.com/auth/taskqueue\nuseraccounts-ro,https://www.googleapis.com/auth/cloud.useraccounts.readonly\nuseraccounts-rw,https://www.googleapis.com/auth/cloud.useraccounts\nuserinfo-email,https://www.googleapis.com/auth/userinfo.email\n|========',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--scopes',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'SCOPE'},
                                                                                                                         u'--service-account': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The Google Cloud Platform Service Account to be used by the node VMs. If no Service Account is specified, the "default" service account is used.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--service-account',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'SERVICE_ACCOUNT'},
                                                                                                                         u'--tags': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Applies the given Compute Engine tags (comma separated) on all nodes in the new\nnode-pool. Example:\n+\n  $ {command} node-pool-1 --cluster=example-cluster --tags=tag1,tag2\n+\nNew nodes, including ones created by resize or recreate, will have these tags\non the Compute Engine API instance object and can be used in firewall rules.\nSee https://cloud.google.com/sdk/gcloud/reference/compute/firewall-rules/create\nfor examples.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--tags',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'TAG'},
                                                                                                                         u'--timeout': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': 1800,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--timeout',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'int',
                                                                                                                                        u'value': u'TIMEOUT'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'create',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'container',
                                                                                                                        u'node-pools',
                                                                                                                        u'create'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the node pool to create.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*create* facilitates the creation of a node pool in a Google\nContainer Engine cluster. A variety of options exists to customize the\nnode configuration and the number of nodes created.\n',
                                                                                                                            u'EXAMPLES': u'To create a new node pool "node-pool-1" with the default options in the\ncluster "sample-cluster", run:\n\n  $ create node-pool-1 --cluster=example-cluster\n\nThe new node pool will show up in the cluster after all the nodes have\nbeen provisioned.\n\nTo create a node pool with 5 nodes, run:\n\n  $ create node-pool-1 --cluster=example-cluster --num-nodes=5\n'}},
                                                                                                  u'delete': {u'capsule': u'*(BETA)* Delete an existing node pool in a running cluster.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The cluster from which to delete the node pool. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--cluster',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'CLUSTER'},
                                                                                                                         u'--no-wait': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-wait',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_WAIT'},
                                                                                                                         u'--timeout': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': 1800,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--timeout',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'int',
                                                                                                                                        u'value': u'TIMEOUT'},
                                                                                                                         u'--wait': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'Poll the operation for completion after issuing a delete request. Enabled by default, use *--no-wait* to disable.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--wait',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'WAIT'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'delete',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'container',
                                                                                                                        u'node-pools',
                                                                                                                        u'delete'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the node pool to delete.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*delete* deletes a node pool from a Google Container Engine cluster.\n',
                                                                                                                            u'EXAMPLES': u'To delete the "node-pool-1" node pool from the cluster\n"sample-cluster", run:\n\n  $ delete node-pool-1 --cluster=sample-cluster\n'}},
                                                                                                  u'describe': {u'capsule': u'*(BETA)* Describe an existing node pool for a cluster.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the cluster. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--cluster',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'CLUSTER'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'describe',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'container',
                                                                                                                          u'node-pools',
                                                                                                                          u'describe'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the node pool.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* *describe* displays all data associated with the node pool in the\nGoogle Container Engine cluster.'}},
                                                                                                  u'list': {u'capsule': u'*(BETA)* List existing node pools for a cluster.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the cluster. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--cluster',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'CLUSTER'},
                                                                                                                       u'--filter': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--filter',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--limit',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_URI'},
                                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--page-size',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'FIELD'},
                                                                                                                       u'--uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'URI'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'list',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'container',
                                                                                                                      u'node-pools',
                                                                                                                      u'list'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*list* displays all node pools in the Google Container Engine\ncluster.\n',
                                                                                                                          u'EXAMPLES': u'To list all node pools in the cluster "sample-cluster" in table form,\nrun:\n\n  $ list --cluster=sample-cluster\n'}},
                                                                                                  u'update': {u'capsule': u'*(BETA)* Updates a node pool in a running cluster.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The cluster this node pool belongs to. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--cluster',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'CLUSTER'},
                                                                                                                         u'--enable-autorepair': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--enable-autorepair',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'ENABLE_AUTOREPAIR'},
                                                                                                                         u'--enable-autoupgrade': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Sets autoupgrade feature for a node-pool.\n+\n  $ {command} node-pool-1 --cluster=example-cluster --enable-autoupgrade\n+\nSee https://cloud.google.com/container-engine/docs/node-managament for more info.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--enable-autoupgrade',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'ENABLE_AUTOUPGRADE'},
                                                                                                                         u'--no-enable-autorepair': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-enable-autorepair',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_ENABLE_AUTOREPAIR'},
                                                                                                                         u'--no-enable-autoupgrade': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-enable-autoupgrade',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_ENABLE_AUTOUPGRADE'},
                                                                                                                         u'--timeout': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': 1800,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--timeout',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'int',
                                                                                                                                        u'value': u'TIMEOUT'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'update',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'container',
                                                                                                                        u'node-pools',
                                                                                                                        u'update'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the node pool to update.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*update* updates a node pool in a Google Container Engine cluster.\n',
                                                                                                                            u'EXAMPLES': u'To turn on node auto repair in "node-pool-1" in the cluster\n"sample-cluster", run:\n\n  $ update node-pool-1 --cluster=example-cluster --enable-autoupgrade\n'}}},
                                                                                    u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--zone',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'ZONE'}},
                                                                                    u'group': True,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'node-pools',
                                                                                    u'path': [u'gcloud',
                                                                                              u'beta',
                                                                                              u'container',
                                                                                              u'node-pools'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'BETA',
                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Create and delete operations for Google Container Engine node pools.'}},
                                                                    u'operations': {u'capsule': u'*(BETA)* Get and list operations for Google Container Engine clusters.',
                                                                                    u'commands': {u'describe': {u'capsule': u'*(BETA)* Describe an operation.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'describe',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'container',
                                                                                                                          u'operations',
                                                                                                                          u'describe'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The operation id to look up.',
                                                                                                                                  u'name': u'operation-id',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'OPERATION_ID'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Describe an operation.'}},
                                                                                                  u'list': {u'capsule': u'*(BETA)* List operations for container clusters.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--filter',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--limit',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--page-size',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'FIELD'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'list',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'container',
                                                                                                                      u'operations',
                                                                                                                      u'list'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* List operations for container clusters.'}},
                                                                                                  u'wait': {u'capsule': u'*(BETA)* Poll an operation for completion.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'wait',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'container',
                                                                                                                      u'operations',
                                                                                                                      u'wait'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The operation id to poll.',
                                                                                                                              u'name': u'operation-id',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'OPERATION_ID'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Poll an operation for completion.'}}},
                                                                                    u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--zone',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'ZONE'}},
                                                                                    u'group': True,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'operations',
                                                                                    u'path': [u'gcloud',
                                                                                              u'beta',
                                                                                              u'container',
                                                                                              u'operations'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'BETA',
                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Get and list operations for Google Container Engine clusters.'}}},
                                                      u'flags': {u'--api-version': {u'attr': {u'property': {u'name': u'api_client_overrides/container'}},
                                                                                    u'category': u'',
                                                                                    u'choices': [],
                                                                                    u'completer': u'',
                                                                                    u'default': None,
                                                                                    u'description': u'',
                                                                                    u'group': u'',
                                                                                    u'hidden': True,
                                                                                    u'name': u'--api-version',
                                                                                    u'nargs': u'0',
                                                                                    u'required': False,
                                                                                    u'type': u'string',
                                                                                    u'value': u'API_VERSION'}},
                                                      u'group': True,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'container',
                                                      u'path': [u'gcloud',
                                                                u'beta',
                                                                u'container'],
                                                      u'positionals': [],
                                                      u'release': u'BETA',
                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Deploy and manage clusters of machines for running containers.'}},
                                       u'dataflow': {u'capsule': u'*(BETA)* Manage Google Cloud Dataflow jobs.',
                                                     u'commands': {u'jobs': {u'capsule': u'*(BETA)* A group of subcommands for working with Dataflow jobs.',
                                                                             u'commands': {u'cancel': {u'capsule': u'*(BETA)* Cancels all jobs that match the command line arguments.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'cancel',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'dataflow',
                                                                                                                 u'jobs',
                                                                                                                 u'cancel'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The jobs to operate on.',
                                                                                                                         u'name': u'jobs',
                                                                                                                         u'nargs': u'+',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'JOB'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Cancels all jobs that match the command line arguments.'}},
                                                                                           u'describe': {u'capsule': u'*(BETA)* Outputs the Job object resulting from the Get API.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--full': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'Retrieve the full Job rather than the summary view',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--full',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'FULL'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'dataflow',
                                                                                                                   u'jobs',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The job ID to operate on.',
                                                                                                                           u'name': u'job',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'JOB_ID'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* By default this will display the Summary view which includes:\n  - Project ID\n  - Job ID\n  - Job Name\n  - Job Type (Batch vs. Streaming)\n  - Job Create Time\n  - Job Status (Running, Done, Cancelled, Failed)\n  - Job Status Time\n\nNotable values that are only in the full view:\n  - Environment (staging Jars, information about workers, etc.)\n  - Steps from the workflow graph'}},
                                                                                           u'drain': {u'capsule': u'*(BETA)* Drains all jobs that match the command line arguments.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'drain',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'dataflow',
                                                                                                                u'jobs',
                                                                                                                u'drain'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The jobs to operate on.',
                                                                                                                        u'name': u'jobs',
                                                                                                                        u'nargs': u'+',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'JOB'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Once Drain is triggered, the pipeline will stop accepting new inputs.\nThe input watermark will be advanced to infinity. Elements already in the\npipeline will continue to be processed. Drained jobs can safely be\ncancelled.'}},
                                                                                           u'export-steps': {u'capsule': u'*(BETA)* Exports information about the steps for the given job.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'export-steps',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'dataflow',
                                                                                                                       u'jobs',
                                                                                                                       u'export-steps'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The job ID to operate on.',
                                                                                                                               u'name': u'job',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'JOB_ID'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* The only currently supported format is to a GraphViz dot file.'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* Lists all jobs in a particular project.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--created-after': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Filter the jobs to those created after the given time',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--created-after',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'CREATED_AFTER'},
                                                                                                                u'--created-before': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Filter the jobs to those created before the given time',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--created-before',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'CREATED_BEFORE'},
                                                                                                                u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--status': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [u'active',
                                                                                                                                           u'all',
                                                                                                                                           u'terminated'],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Filter the jobs to those with the selected status. _STATUS_ must be one of:\n+\n*active*::: Filters the jobs that are running ordered on the creation timestamp.\n*all*::: Returns running jobs first, ordered on creation timestamp, then, returns all terminated jobs ordered on the termination timestamp.\n*terminated*::: Filters the jobs that have a terminated state, ordered on the termination timestamp. Example terminated states: Done, Updated, Cancelled, etc.\n+',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--status',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'STATUS'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'dataflow',
                                                                                                               u'jobs',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* By default, jobs in the current project are listed; this can be overridden\nwith the gcloud --project flag.\n\n## EXAMPLES\n\nFilter jobs with the given name:\n\n  $ list --filter="name=my-wordcount"'}},
                                                                                           u'run': {u'capsule': u'*(BETA)* Runs a job from the specified path.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--gcs-location': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The location of the job template to run.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--gcs-location',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'GCS_LOCATION'},
                                                                                                               u'--max-workers': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of workers to run.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--max-workers',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'MAX_WORKERS'},
                                                                                                               u'--parameters': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The parameters to pass to the job.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--parameters',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'dict',
                                                                                                                                 u'value': u'PARAMETERS'},
                                                                                                               u'--service-account-email': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The service account to run the workers as.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--service-account-email',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'SERVICE_ACCOUNT_EMAIL'},
                                                                                                               u'--zone': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The zone to run the workers in.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--zone',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'ZONE'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'run',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'beta',
                                                                                                              u'dataflow',
                                                                                                              u'jobs',
                                                                                                              u'run'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The unique name to assign to the job.',
                                                                                                                      u'name': u'job-name',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'JOB_NAME'}],
                                                                                                    u'release': u'BETA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Runs a job from the specified path.'}},
                                                                                           u'show': {u'capsule': u'*(BETA)* Shows a short description of the given job.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--environment': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'If present, the environment will be listed.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--environment',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ENVIRONMENT'},
                                                                                                                u'--no-environment': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-environment',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ENVIRONMENT'},
                                                                                                                u'--no-steps': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-steps',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_STEPS'},
                                                                                                                u'--steps': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'If present, the steps will be listed.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--steps',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'STEPS'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'show',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'dataflow',
                                                                                                               u'jobs',
                                                                                                               u'show'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The job ID to operate on.',
                                                                                                                       u'name': u'job',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'JOB_ID'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Shows a short description of the given job.'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'jobs',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'dataflow',
                                                                                       u'jobs'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* A group of subcommands for working with Dataflow jobs.'}},
                                                                   u'logs': {u'capsule': u'*(BETA)* A group of subcommands for working with Dataflow logs.',
                                                                             u'commands': {u'list': {u'capsule': u'*(BETA)* Retrieve the job logs for a specific job.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--after': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Only display messages logged after the given time. Time format is yyyy-mm-dd hh-mm-ss',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--after',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'AFTER'},
                                                                                                                u'--before': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Only display messages logged before the given time. Time format is yyyy-mm-dd hh-mm-ss',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--before',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'BEFORE'},
                                                                                                                u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--importance': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [u'debug',
                                                                                                                                               u'detailed',
                                                                                                                                               u'warning',
                                                                                                                                               u'error'],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': u'warning',
                                                                                                                                  u'description': u'Minimum importance a message must have to be displayed. _IMPORTANCE_ must be one of: *debug*, *detailed*, *warning*, *error*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--importance',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'IMPORTANCE'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'dataflow',
                                                                                                               u'logs',
                                                                                                               u'list'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The job ID to operate on.',
                                                                                                                       u'name': u'job',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'JOB_ID'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Retrieves the job logs from a specified job using the Dataflow Messages API\nwith at least the specified importance level. Can also be used to display\nlogs between a given time period using the --before and --after flags. These\nlogs are produced by the service and are distinct from worker logs. Worker\nlogs can be found in Cloud Logging.\n\n## EXAMPLES\n\nRetrieve only error logs:\n\n  $ list --importance=error\n\nRetrieve all logs after some date:\n\n  $ list --after="2016-08-12 00:00:00"'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'logs',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'dataflow',
                                                                                       u'logs'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* A group of subcommands for working with Dataflow logs.'}},
                                                                   u'metrics': {u'capsule': u'*(BETA)* A group of subcommands for working with Dataflow metrics.',
                                                                                u'commands': {u'list': {u'capsule': u'*(BETA)* Retrieves the metrics from a specific job.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--changed-after': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Only display metrics that have changed after the given time',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--changed-after',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'CHANGED_AFTER'},
                                                                                                                   u'--filter': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--filter',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                                   u'--hide-committed': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'If true, hide committed values.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--hide-committed',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'HIDE_COMMITTED'},
                                                                                                                   u'--limit': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--limit',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'LIMIT'},
                                                                                                                   u'--no-hide-committed': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-hide-committed',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_HIDE_COMMITTED'},
                                                                                                                   u'--no-tentative': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-tentative',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_TENTATIVE'},
                                                                                                                   u'--source': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [u'all',
                                                                                                                                              u'service',
                                                                                                                                              u'user'],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': u'all',
                                                                                                                                 u'description': u'Set the metrics source. _SOURCE_ must be one of:\n+\n*all*::: Retrieves all metrics.\n*service*::: Retrieves only dataflow service metrics.\n*user*::: Retrieves only custom user metrics.\n+',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--source',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'SOURCE'},
                                                                                                                   u'--tentative': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'If true, display tentative values.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--tentative',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'TENTATIVE'},
                                                                                                                   u'--transform': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Filters only the metrics that prefix match the given regex.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--transform',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'TRANSFORM'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'list',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'dataflow',
                                                                                                                  u'metrics',
                                                                                                                  u'list'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The job ID to operate on.',
                                                                                                                          u'name': u'job',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'JOB_ID'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* This command can be used to explore the job\'s metrics at a fine-grained level.\n\n## EXAMPLES\n\nFilter metrics with the given name:\n\n  $ list --filter="name=ElementCount"\n\nFilter child metrics with matching transforms:\n\n  $ list --transform=WordCount\n\nFilter child output metrics:\n\n  $ list --transform=WordCount/Write.*out\n\nFilter all output metrics:\n\n  $ list --transform=.*out\n\nFilter all custom-defined user metrics\n\n  $ list --source=user\n\nFilter metrics with a scalar value greater than a threshold.\n\n  $ list --filter="scalar > 50"'}}},
                                                                                u'flags': {},
                                                                                u'group': True,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'metrics',
                                                                                u'path': [u'gcloud',
                                                                                          u'beta',
                                                                                          u'dataflow',
                                                                                          u'metrics'],
                                                                                u'positionals': [],
                                                                                u'release': u'BETA',
                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* A group of subcommands for working with Dataflow metrics.'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'dataflow',
                                                     u'path': [u'gcloud',
                                                               u'beta',
                                                               u'dataflow'],
                                                     u'positionals': [],
                                                     u'release': u'BETA',
                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* The gcloud dataflow command group lets you manage Google Cloud Dataflow jobs.\n\nCloud Dataflow is a unified programming model and a managed service for\ndeveloping and executing a wide range of data processing patterns\nincluding ETL, batch computation, and continuous computation.\n\nMore information on Cloud Dataflow can be found here:\nhttps://cloud.google.com/dataflow and detailed documentation can be found\nhere: https://cloud.google.com/dataflow/docs/'}},
                                       u'dataproc': {u'capsule': u'*(BETA)* Create and manage Google Cloud Dataproc clusters and jobs.',
                                                     u'commands': {u'clusters': {u'capsule': u'*(BETA)* Create and manage Google Cloud Dataproc clusters.',
                                                                                 u'commands': {u'create': {u'capsule': u'*(BETA)* Create a cluster.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--async',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ASYNC'},
                                                                                                                      u'--bucket': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The Google Cloud Storage bucket to use with the Google Cloud Storage connector. A bucket is auto created when this parameter is not specified.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--bucket',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'BUCKET'},
                                                                                                                      u'--image': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--image',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'IMAGE'},
                                                                                                                      u'--image-version': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The image version to use for the cluster. Defaults to the latest version.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--image-version',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'VERSION'},
                                                                                                                      u'--initialization-action-timeout': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': u'10m',
                                                                                                                                                           u'description': u'The maximum duration of each initialization action.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--initialization-action-timeout',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'TIMEOUT'},
                                                                                                                      u'--initialization-actions': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'A list of Google Cloud Storage URIs of executables to run on each node in the cluster.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--initialization-actions',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'list',
                                                                                                                                                    u'value': u'CLOUD_STORAGE_URI'},
                                                                                                                      u'--labels': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--labels',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'dict',
                                                                                                                                    u'value': u'KEY=VALUE'},
                                                                                                                      u'--master-boot-disk-size': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The size of the boot disk. The value must be a\nwhole number followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For example,\n``10GB'' will produce a 10 gigabyte disk. The minimum size a boot disk\ncan have is 10 GB. Disk size must be a multiple of 1 GB.",
                                                                                                                                                   u'group': u'create.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--master-boot-disk-size',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'MASTER_BOOT_DISK_SIZE'},
                                                                                                                      u'--master-boot-disk-size-gb': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'create.1',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--master-boot-disk-size-gb',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'MASTER_BOOT_DISK_SIZE_GB'},
                                                                                                                      u'--master-machine-type': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The type of machine to use for the master. Defaults to server-specified.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--master-machine-type',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'MASTER_MACHINE_TYPE'},
                                                                                                                      u'--metadata': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Metadata to be made available to the guest operating system running on the instances',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--metadata',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'dict',
                                                                                                                                      u'value': u'KEY=VALUE'},
                                                                                                                      u'--network': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The Compute Engine network that the VM instances of the cluster will be\npart of. This is mutually exclusive with --subnet. If neither is\nspecified, this defaults to the "default" network.',
                                                                                                                                     u'group': u'create.2',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--network',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'NETWORK'},
                                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-async',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ASYNC'},
                                                                                                                      u'--num-master-local-ssds': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The number of local SSDs to attach to the master in a cluster.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--num-master-local-ssds',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'NUM_MASTER_LOCAL_SSDS'},
                                                                                                                      u'--num-masters': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The number of master nodes in the cluster.\n+\n[format="csv",options="header"]\n|========\nNumber of Masters,Cluster Mode\n1,Standard\n3,High Availability\n|========',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--num-masters',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'NUM_MASTERS'},
                                                                                                                      u'--num-preemptible-workers': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The number of preemptible worker nodes in the cluster.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--num-preemptible-workers',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'NUM_PREEMPTIBLE_WORKERS'},
                                                                                                                      u'--num-worker-local-ssds': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The number of local SSDs to attach to each worker in a cluster.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--num-worker-local-ssds',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'NUM_WORKER_LOCAL_SSDS'},
                                                                                                                      u'--num-workers': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The number of worker nodes in the cluster. Defaults to server-specified.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--num-workers',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'NUM_WORKERS'},
                                                                                                                      u'--preemptible-worker-boot-disk-size': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u"The size of the boot disk. The value must be a\nwhole number followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For example,\n``10GB'' will produce a 10 gigabyte disk. The minimum size a boot disk\ncan have is 10 GB. Disk size must be a multiple of 1 GB.",
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--preemptible-worker-boot-disk-size',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'PREEMPTIBLE_WORKER_BOOT_DISK_SIZE'},
                                                                                                                      u'--properties': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': {},
                                                                                                                                        u'description': u'Specifies configuration properties for installed packages, such as Hadoop\nand Spark.\n+\nProperties are mapped to configuration files by specifying a prefix, such as\n"core:io.serializations". The following are supported prefixes and their\nmappings:\n+\n[format="csv",options="header"]\n|========\nPrefix,Target Configuration File\ncore,core-site.xml\nhdfs,hdfs-site.xml\nmapred,mapred-site.xml\nyarn,yarn-site.xml\nhive,hive-site.xml\npig,pig.properties\nspark,spark-defaults.conf\n|========\n+',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--properties',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'dict',
                                                                                                                                        u'value': u'PREFIX:PROPERTY=VALUE'},
                                                                                                                      u'--scopes': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Specifies scopes for the node instances. The project\'s default service account\nis used. Multiple SCOPEs can specified, separated by commas.\nExamples:\n+\n  $ {command} example-cluster --scopes https://www.googleapis.com/auth/bigtable.admin\n+\n  $ {command} example-cluster --scopes sqlservice,bigquery\n+\nThe following scopes necessary for the cluster to function properly are always\nadded, even if not explicitly specified:\n+\n[format="csv"]\n|========\nhttps://www.googleapis.com/auth/cloud.useraccounts.readonly\nhttps://www.googleapis.com/auth/devstorage.read_write\nhttps://www.googleapis.com/auth/logging.write\n|========\n+\nIf this flag is not specified the following default scopes are also included:\n+\n[format="csv"]\n|========\nhttps://www.googleapis.com/auth/bigquery\nhttps://www.googleapis.com/auth/bigtable.admin.table\nhttps://www.googleapis.com/auth/bigtable.data\nhttps://www.googleapis.com/auth/devstorage.full_control\n|========\n+\nIf you want to enable all scopes use the \'cloud-platform\' scope.\n+\nSCOPE can be either the full URI of the scope or an alias.\nAvailable aliases are:\n+\n[format="csv",options="header"]\n|========\nAlias,URI\nbigquery,https://www.googleapis.com/auth/bigquery\ncloud-platform,https://www.googleapis.com/auth/cloud-platform\ncloud-source-repos,https://www.googleapis.com/auth/source.full_control\ncloud-source-repos-ro,https://www.googleapis.com/auth/source.read_only\ncompute-ro,https://www.googleapis.com/auth/compute.readonly\ncompute-rw,https://www.googleapis.com/auth/compute\ndatastore,https://www.googleapis.com/auth/datastore\ndefault,https://www.googleapis.com/auth/cloud.useraccounts.readonly\n,https://www.googleapis.com/auth/devstorage.read_only\n,https://www.googleapis.com/auth/logging.write\n,https://www.googleapis.com/auth/monitoring.write\n,https://www.googleapis.com/auth/service.management.readonly\n,https://www.googleapis.com/auth/servicecontrol\nlogging-write,https://www.googleapis.com/auth/logging.write\nmonitoring,https://www.googleapis.com/auth/monitoring\nmonitoring-write,https://www.googleapis.com/auth/monitoring.write\nservice-control,https://www.googleapis.com/auth/servicecontrol\nservice-management,https://www.googleapis.com/auth/service.management.readonly\nsql,https://www.googleapis.com/auth/sqlservice\nsql-admin,https://www.googleapis.com/auth/sqlservice.admin\nstorage-full,https://www.googleapis.com/auth/devstorage.full_control\nstorage-ro,https://www.googleapis.com/auth/devstorage.read_only\nstorage-rw,https://www.googleapis.com/auth/devstorage.read_write\ntaskqueue,https://www.googleapis.com/auth/taskqueue\nuseraccounts-ro,https://www.googleapis.com/auth/cloud.useraccounts.readonly\nuseraccounts-rw,https://www.googleapis.com/auth/cloud.useraccounts\nuserinfo-email,https://www.googleapis.com/auth/userinfo.email\n|========',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--scopes',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'SCOPE'},
                                                                                                                      u'--service-account': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The Google Cloud IAM service account to be authenticated as.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--service-account',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'SERVICE_ACCOUNT'},
                                                                                                                      u'--subnet': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Specifies the subnet that the cluster will be part of. This is mutally\nexclusive with --network.',
                                                                                                                                    u'group': u'create.2',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--subnet',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'SUBNET'},
                                                                                                                      u'--tags': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Specifies a list of tags to apply to the instances for\nidentifying the instances to which network firewall rules will\napply. See gcloud_compute_firewall-rules_create(1) for more\ndetails.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--tags',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'TAG'},
                                                                                                                      u'--worker-boot-disk-size': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The size of the boot disk. The value must be a\nwhole number followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For example,\n``10GB'' will produce a 10 gigabyte disk. The minimum size a boot disk\ncan have is 10 GB. Disk size must be a multiple of 1 GB.",
                                                                                                                                                   u'group': u'create.3',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--worker-boot-disk-size',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'WORKER_BOOT_DISK_SIZE'},
                                                                                                                      u'--worker-boot-disk-size-gb': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'create.3',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--worker-boot-disk-size-gb',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'WORKER_BOOT_DISK_SIZE_GB'},
                                                                                                                      u'--worker-machine-type': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The type of machine to use for workers. Defaults to server-specified.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--worker-machine-type',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'WORKER_MACHINE_TYPE'},
                                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--zone',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'ZONE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False},
                                                                                                                       u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False},
                                                                                                                       u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False}},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'create',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'dataproc',
                                                                                                                     u'clusters',
                                                                                                                     u'create'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of this cluster.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Create a cluster.',
                                                                                                                         u'EXAMPLES': u'To create a cluster, run:\n\n  $ create my_cluster\n'}},
                                                                                               u'delete': {u'capsule': u'*(BETA)* Delete a cluster.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--async',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ASYNC'},
                                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-async',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ASYNC'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'delete',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'dataproc',
                                                                                                                     u'clusters',
                                                                                                                     u'delete'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the cluster to delete.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Delete a cluster.',
                                                                                                                         u'EXAMPLES': u'To delete a cluster, run:\n\n  $ delete my_cluster\n'}},
                                                                                               u'describe': {u'capsule': u'*(BETA)* View the details of a cluster.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'dataproc',
                                                                                                                       u'clusters',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the cluster to describe.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* View the details of a cluster.',
                                                                                                                           u'EXAMPLES': u'To view the details of a cluster, run:\n\n  $ describe my_cluster\n'}},
                                                                                               u'diagnose': {u'capsule': u'*(BETA)* Run a detailed diagnostic on a cluster.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'diagnose',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'dataproc',
                                                                                                                       u'clusters',
                                                                                                                       u'diagnose'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the cluster to diagnose.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Run a detailed diagnostic on a cluster.'}},
                                                                                               u'list': {u'capsule': u'*(BETA)* View a list of clusters in a project.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': 100,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'int',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'dataproc',
                                                                                                                   u'clusters',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u"*(BETA)* View a list of clusters in a project. An optional filter can be used to\nconstrain the clusters returned. Filters are case-sensitive and have the\nfollowing syntax:\n\n  field = value [AND [field = value]] ...\n\nwhere `field` is one of `status.state`, `clusterName`, or `labels.[KEY]`,\nand `[KEY]` is a label key. `value` can be ```*``` to match all values.\n`status.state` can be one of the following: `ACTIVE`, `INACTIVE`,\n`CREATING`, `RUNNING`, `ERROR`, `DELETING`, or `UPDATING`. `ACTIVE`\ncontains the `CREATING`, `UPDATING`, and `RUNNING` states. `INACTIVE`\ncontains the `DELETING` and `ERROR` states. `clusterName` is the name of the\ncluster provided at creation time. Only the logical `AND` operator is\nsupported; space-separated items are treated as having an implicit `AND`\noperator.\n\n## EXAMPLES\n\nTo see the list of all clusters, run:\n\n  $ list\n\nTo show a cluster whose name is `mycluster`, run:\n\n  $ list --filter='clusterName = mycluster'\n\nTo see the list of all clusters with particular labels, run:\n\n  $ list --filter='labels.env = staging AND labels.starred = *'\n\nTo see a list of all active clusters with particular labels, run:\n\n  $ list --filter='status.state = ACTIVE labels.env = staging AND labels.starred = *'"}},
                                                                                               u'update': {u'capsule': u'*(BETA)* Update labels and/or the number of worker nodes in a cluster.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--async',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ASYNC'},
                                                                                                                      u'--new-num-workers': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--new-num-workers',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'NEW_NUM_WORKERS'},
                                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-async',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ASYNC'},
                                                                                                                      u'--num-preemptible-workers': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The new number of preemptible worker nodes in the cluster.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--num-preemptible-workers',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'NUM_PREEMPTIBLE_WORKERS'},
                                                                                                                      u'--num-workers': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The new number of worker nodes in the cluster.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--num-workers',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'NUM_WORKERS'},
                                                                                                                      u'--remove-labels': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'A list of label keys to remove. If a label does not exist it is\nsilently ignored.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--remove-labels',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'KEY'},
                                                                                                                      u'--update-labels': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'A list of label KEY=VALUE pairs to update. If a label exists its value\nis modified, otherwise a new label is created.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--update-labels',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'dict',
                                                                                                                                           u'value': u'KEY=VALUE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'update',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'dataproc',
                                                                                                                     u'clusters',
                                                                                                                     u'update'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the cluster to update.',
                                                                                                                             u'name': u'name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u"*(BETA)* Update the number of worker nodes and/or the labels in a cluster.\n\n## EXAMPLES\n\nTo resize a cluster, run:\n\n  $ update my_cluster --num-workers 5\n\nTo change the number preemptible workers in a cluster, run:\n\n  $ update my_cluster --num-preemptible-workers 5\n\nTo add the label 'customer=acme' to a cluster, run:\n\n  $ update my_cluster --update-labels=customer=acme\n\nTo update the label 'customer=ackme' to 'customer=acme', run:\n\n  $ update my_cluster --update-labels=customer=acme\n\nTo remove the label whose key is 'customer', run:\n\n  $ update my_cluster --remove-labels=customer"}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'clusters',
                                                                                 u'path': [u'gcloud',
                                                                                           u'beta',
                                                                                           u'dataproc',
                                                                                           u'clusters'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'BETA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Create and manage Google Cloud Dataproc clusters.\n\n## EXAMPLES\n\nTo create a cluster, run:\n\n  $ clusters create my_cluster\n\nTo resize a cluster, run:\n\n  $ clusters update my_cluster --num_workers 5\n\nTo delete a cluster, run:\n\n  $ clusters delete my_cluster\n\nTo view the details of a cluster, run:\n\n  $ clusters describe my_cluster\n\nTo see the list of all clusters, run:\n\n  $ clusters list'}},
                                                                   u'jobs': {u'capsule': u'*(BETA)* Submit and manage Google Cloud Dataproc jobs.',
                                                                             u'commands': {u'delete': {u'capsule': u'*(BETA)* Delete the record of an inactive job.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'dataproc',
                                                                                                                 u'jobs',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The ID of the job to delete.',
                                                                                                                         u'name': u'id',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'JOB_ID'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Delete the record of an inactive job.\n\n## EXAMPLES\n\nTo delete the record of a job, run:\n\n  $ delete job_id'}},
                                                                                           u'describe': {u'capsule': u'*(BETA)* View the details of a job.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'dataproc',
                                                                                                                   u'jobs',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The ID of the job to describe.',
                                                                                                                           u'name': u'id',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'JOB_ID'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* View the details of a job.\n\n## EXAMPLES\n\nTo view the details of a job, run:\n\n  $ describe job_id'}},
                                                                                           u'kill': {u'capsule': u'*(BETA)* Kill an active job.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'kill',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'dataproc',
                                                                                                               u'jobs',
                                                                                                               u'kill'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The ID of the job to kill.',
                                                                                                                       u'name': u'id',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'JOB_ID'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Kill an active job.\n\n## EXAMPLES\n\nTo cancel a job, run:\n\n  $ kill job_id'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* List jobs in a project.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--cluster': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Restrict to the jobs of this Dataproc cluster.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--cluster',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'CLUSTER'},
                                                                                                                u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': 100,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'int',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--state-filter': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [u'active',
                                                                                                                                                 u'inactive'],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Filter by job state. _STATE_FILTER_ must be one of: *active*, *inactive*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--state-filter',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'STATE_FILTER'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'dataproc',
                                                                                                               u'jobs',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u"*(BETA)* List jobs in a project. An optional filter can be used to constrain the jobs\nreturned. Filters are case-sensitive and have the following syntax:\n\n  [field = value] AND [field [= value]] ...\n\nwhere `field` is `status.state` or `labels.[KEY]`, and `[KEY]` is a label\nkey. `value` can be ```*``` to match all values. `status.state` can be either\n`ACTIVE` or `INACTIVE`. Only the logical `AND` operator is supported;\nspace-separated items are treated as having an implicit `AND` operator.\n\n## EXAMPLES\n\nTo see the list of all jobs, run:\n\n  $ list\n\nTo see a list of all active jobs in cluster `my_cluster` with a label of\n`env=staging`, run:\n\n  $ list --filter='status.state = ACTIVE AND placement.clusterName = my_cluster AND labels.env = staging'"}},
                                                                                           u'submit': {u'capsule': u'*(BETA)* Submit Google Cloud Dataproc jobs to execute on a cluster.',
                                                                                                       u'commands': {u'hadoop': {u'capsule': u'*(BETA)* Submit a Hadoop job to a cluster.',
                                                                                                                                 u'commands': {},
                                                                                                                                 u'flags': {u'--archives': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': [],
                                                                                                                                                            u'description': u'Comma separated list of archives to be provided to the job. must be one of the following file formats: .zip, .tar, .tar.gz, or .tgz.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--archives',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'list',
                                                                                                                                                            u'value': u'ARCHIVE'},
                                                                                                                                            u'--class': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The class containing the main method of the driver. Must be in a provided jar or jar that is already on the classpath',
                                                                                                                                                         u'group': u'hadoop.1',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--class',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'CLASS'},
                                                                                                                                            u'--cluster': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--cluster',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': True,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'CLUSTER'},
                                                                                                                                            u'--driver-log-levels': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'A list of package to log4j log level pairs to configure driver logging. For example: root=FATAL,com.example=INFO',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--driver-log-levels',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'dict',
                                                                                                                                                                     u'value': u'PACKAGE=LEVEL'},
                                                                                                                                            u'--files': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': [],
                                                                                                                                                         u'description': u'Comma separated list of files to be provided to the job.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--files',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'FILE'},
                                                                                                                                            u'--jar': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The HCFS URI of jar file containing the driver jar.',
                                                                                                                                                       u'group': u'hadoop.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--jar',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'JAR'},
                                                                                                                                            u'--jars': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': [],
                                                                                                                                                        u'description': u'Comma separated list of jar files to be provided to the MR and driver classpaths.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--jars',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'JAR'},
                                                                                                                                            u'--labels': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--labels',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'dict',
                                                                                                                                                          u'value': u'KEY=VALUE'},
                                                                                                                                            u'--max-failures-per-hour': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': True,
                                                                                                                                                                         u'name': u'--max-failures-per-hour',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'MAX_FAILURES_PER_HOUR'},
                                                                                                                                            u'--properties': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'A list of key value pairs to configure Hadoop.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--properties',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'dict',
                                                                                                                                                              u'value': u'PROPERTY=VALUE'}},
                                                                                                                                 u'group': False,
                                                                                                                                 u'groups': {u'hadoop.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                           u'is_mutex': True,
                                                                                                                                                           u'is_required': True}},
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'hadoop',
                                                                                                                                 u'path': [u'gcloud',
                                                                                                                                           u'beta',
                                                                                                                                           u'dataproc',
                                                                                                                                           u'jobs',
                                                                                                                                           u'submit',
                                                                                                                                           u'hadoop'],
                                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u"The arguments to pass to the driver.\n+\nThe '--' argument must be specified between gcloud specific args on the left and JOB_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                                                                                                                                   u'name': u'job-args',
                                                                                                                                                   u'nargs': u'...',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'value': u'JOB_ARGS'}],
                                                                                                                                 u'release': u'BETA',
                                                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Submit a Hadoop job to a cluster.\n\n## EXAMPLES\n\nTo submit a Hadoop job that runs the main class of a jar, run:\n\n  $ hadoop --cluster my_cluster --jar my_jar.jar arg1 arg2\n\nTo submit a Hadoop job that runs a specific class of a jar, run:\n\n  $ hadoop --cluster my_cluster --class org.my.main.Class --jars my_jar1.jar,my_jar2.jar arg1 arg2\n\nTo submit a Hadoop job that runs a jar that is already on the cluster, run:\n\n  $ hadoop --cluster my_cluster --jar file:///usr/lib/hadoop-op/hadoop-op-examples.jar wordcount gs://my_bucket/my_file.txt gs://my_bucket/output'}},
                                                                                                                     u'hive': {u'capsule': u'*(BETA)* Submit a Hive job to a cluster.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--cluster': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--cluster',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': True,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'CLUSTER'},
                                                                                                                                          u'--continue-on-failure': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': False,
                                                                                                                                                                     u'description': u'Whether to continue if a single query fails.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--continue-on-failure',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'bool',
                                                                                                                                                                     u'value': u'CONTINUE_ON_FAILURE'},
                                                                                                                                          u'--execute': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': [],
                                                                                                                                                         u'description': u'A Hive query to execute as part of the job.',
                                                                                                                                                         u'group': u'hive.1',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--execute',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'QUERY'},
                                                                                                                                          u'--file': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'HCFS URI of file containing Hive script to execute as the job.',
                                                                                                                                                      u'group': u'hive.1',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--file',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'FILE'},
                                                                                                                                          u'--jars': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': [],
                                                                                                                                                      u'description': u'Comma separated list of jar files to be provided to the Hive and MR. May contain UDFs.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--jars',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'list',
                                                                                                                                                      u'value': u'JAR'},
                                                                                                                                          u'--labels': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--labels',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'dict',
                                                                                                                                                        u'value': u'KEY=VALUE'},
                                                                                                                                          u'--max-failures-per-hour': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': True,
                                                                                                                                                                       u'name': u'--max-failures-per-hour',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'MAX_FAILURES_PER_HOUR'},
                                                                                                                                          u'--no-continue-on-failure': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': True,
                                                                                                                                                                        u'description': u'',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': True,
                                                                                                                                                                        u'name': u'--no-continue-on-failure',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'bool',
                                                                                                                                                                        u'value': u'NO_CONTINUE_ON_FAILURE'},
                                                                                                                                          u'--params': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'A list of key value pairs to set variables in the Hive queries.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--params',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'dict',
                                                                                                                                                        u'value': u'PARAM=VALUE'},
                                                                                                                                          u'--properties': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'A list of key value pairs to configure Hive.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--properties',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'dict',
                                                                                                                                                            u'value': u'PROPERTY=VALUE'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {u'hive.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                       u'is_mutex': True,
                                                                                                                                                       u'is_required': True}},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'hive',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'beta',
                                                                                                                                         u'dataproc',
                                                                                                                                         u'jobs',
                                                                                                                                         u'submit',
                                                                                                                                         u'hive'],
                                                                                                                               u'positionals': [],
                                                                                                                               u'release': u'BETA',
                                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Submit a Hive job to a cluster.\n\n## EXAMPLES\n\nTo submit a Hive job with a local script, run:\n\n  $ hive --cluster my_cluster --file my_queries.q\n\nTo submit a Hive job with inline queries, run:\n\n  $ hive --cluster my_cluster -e "CREATE EXTERNAL TABLE foo(bar int) LOCATION \'gs://my_bucket/\'" -e "SELECT * FROM foo WHERE bar > 2"'}},
                                                                                                                     u'pig': {u'capsule': u'*(BETA)* Submit a Pig job to a cluster.',
                                                                                                                              u'commands': {},
                                                                                                                              u'flags': {u'--cluster': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--cluster',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': True,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'CLUSTER'},
                                                                                                                                         u'--continue-on-failure': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': False,
                                                                                                                                                                    u'description': u'Whether to continue if a single query fails.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--continue-on-failure',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'bool',
                                                                                                                                                                    u'value': u'CONTINUE_ON_FAILURE'},
                                                                                                                                         u'--driver-log-levels': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'A list of package to log4j log level pairs to configure driver logging. For example: root=FATAL,com.example=INFO',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--driver-log-levels',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'dict',
                                                                                                                                                                  u'value': u'PACKAGE=LEVEL'},
                                                                                                                                         u'--execute': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': [],
                                                                                                                                                        u'description': u'A Pig query to execute as part of the job.',
                                                                                                                                                        u'group': u'pig.1',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--execute',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'QUERY'},
                                                                                                                                         u'--file': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'HCFS URI of file containing Pig script to execute as the job.',
                                                                                                                                                     u'group': u'pig.1',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--file',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'FILE'},
                                                                                                                                         u'--jars': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': [],
                                                                                                                                                     u'description': u'Comma separated list of jar files to be provided to Pig and MR. May contain UDFs.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--jars',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'list',
                                                                                                                                                     u'value': u'JAR'},
                                                                                                                                         u'--labels': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--labels',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'dict',
                                                                                                                                                       u'value': u'KEY=VALUE'},
                                                                                                                                         u'--max-failures-per-hour': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': True,
                                                                                                                                                                      u'name': u'--max-failures-per-hour',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'MAX_FAILURES_PER_HOUR'},
                                                                                                                                         u'--no-continue-on-failure': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': True,
                                                                                                                                                                       u'description': u'',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': True,
                                                                                                                                                                       u'name': u'--no-continue-on-failure',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'bool',
                                                                                                                                                                       u'value': u'NO_CONTINUE_ON_FAILURE'},
                                                                                                                                         u'--params': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A list of key value pairs to set variables in the Pig queries.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--params',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'dict',
                                                                                                                                                       u'value': u'PARAM=VALUE'},
                                                                                                                                         u'--properties': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'A list of key value pairs to configure Pig.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--properties',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'dict',
                                                                                                                                                           u'value': u'PROPERTY=VALUE'}},
                                                                                                                              u'group': False,
                                                                                                                              u'groups': {u'pig.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                     u'is_mutex': True,
                                                                                                                                                     u'is_required': True}},
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'pig',
                                                                                                                              u'path': [u'gcloud',
                                                                                                                                        u'beta',
                                                                                                                                        u'dataproc',
                                                                                                                                        u'jobs',
                                                                                                                                        u'submit',
                                                                                                                                        u'pig'],
                                                                                                                              u'positionals': [],
                                                                                                                              u'release': u'BETA',
                                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Submit a Pig job to a cluster.\n\n## EXAMPLES\n\nTo submit a Pig job with a local script, run:\n\n  $ pig --cluster my_cluster --file my_queries.pig\n\nTo submit a Pig job with inline queries, run:\n\n  $ pig --cluster my_cluster -e "LNS = LOAD \'gs://my_bucket/my_file.txt\' AS (line)" -e "WORDS = FOREACH LNS GENERATE FLATTEN(TOKENIZE(line)) AS word" -e "GROUPS = GROUP WORDS BY word" -e "WORD_COUNTS = FOREACH GROUPS GENERATE group, COUNT(WORDS)" -e "DUMP WORD_COUNTS"',
                                                                                                                                            u'EXAMPLES': u'To submit a Pig job with a local script, run:\n\n  $ pig --cluster my_cluster --file my_queries.pig\n\nTo submit a Pig job with inline queries, run:\n\n  $ pig --cluster my_cluster -e "LNS = LOAD \'gs://my_bucket/my_file.txt\' AS (line)" -e "WORDS = FOREACH LNS GENERATE FLATTEN(TOKENIZE(line)) AS word" -e "GROUPS = GROUP WORDS BY word" -e "WORD_COUNTS = FOREACH GROUPS GENERATE group, COUNT(WORDS)" -e "DUMP WORD_COUNTS"\n'}},
                                                                                                                     u'pyspark': {u'capsule': u'*(BETA)* Submit a PySpark job to a cluster.',
                                                                                                                                  u'commands': {},
                                                                                                                                  u'flags': {u'--archives': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': [],
                                                                                                                                                             u'description': u'Comma separated list of archives to be provided to the job. must be one of the following file formats: .zip, .tar, .tar.gz, or .tgz.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--archives',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'list',
                                                                                                                                                             u'value': u'ARCHIVE'},
                                                                                                                                             u'--cluster': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--cluster',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': True,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'CLUSTER'},
                                                                                                                                             u'--driver-log-levels': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'A list of package to log4j log level pairs to configure driver logging. For example: root=FATAL,com.example=INFO',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--driver-log-levels',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'dict',
                                                                                                                                                                      u'value': u'PACKAGE=LEVEL'},
                                                                                                                                             u'--files': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': [],
                                                                                                                                                          u'description': u'Comma separated list of files to be provided to the job.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--files',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'list',
                                                                                                                                                          u'value': u'FILE'},
                                                                                                                                             u'--jars': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': [],
                                                                                                                                                         u'description': u'Comma separated list of jar files to be provided to the executor and driver classpaths.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--jars',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'JAR'},
                                                                                                                                             u'--labels': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--labels',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'dict',
                                                                                                                                                           u'value': u'KEY=VALUE'},
                                                                                                                                             u'--max-failures-per-hour': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': True,
                                                                                                                                                                          u'name': u'--max-failures-per-hour',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'MAX_FAILURES_PER_HOUR'},
                                                                                                                                             u'--properties': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'A list of key value pairs to configure PySpark.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--properties',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'dict',
                                                                                                                                                               u'value': u'PROPERTY=VALUE'},
                                                                                                                                             u'--py-files': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': [],
                                                                                                                                                             u'description': u'Comma separated list of Python files to be provided to the job.Must be one of the following file formats" .py, ,.zip, or .egg',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--py-files',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'list',
                                                                                                                                                             u'value': u'PY_FILE'}},
                                                                                                                                  u'group': False,
                                                                                                                                  u'groups': {},
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'pyspark',
                                                                                                                                  u'path': [u'gcloud',
                                                                                                                                            u'beta',
                                                                                                                                            u'dataproc',
                                                                                                                                            u'jobs',
                                                                                                                                            u'submit',
                                                                                                                                            u'pyspark'],
                                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The main .py file to run as the driver.',
                                                                                                                                                    u'name': u'py-file',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'value': u'PY_FILE'},
                                                                                                                                                   {u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The arguments to pass to the driver.\n+\nThe '--' argument must be specified between gcloud specific args on the left and JOB_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                                                                                                                                    u'name': u'job-args',
                                                                                                                                                    u'nargs': u'...',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'value': u'JOB_ARGS'}],
                                                                                                                                  u'release': u'BETA',
                                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Submit a PySpark job to a cluster.\n\n## EXAMPLES\nTo submit a PySpark job with a local script, run:\n\n  $ pyspark --cluster my_cluster my_script.py\n\nTo submit a Spark job that runs a script that is already on the cluster, run:\n\n  $ pyspark --cluster my_cluster file:///usr/lib/spark/examples/src/main/python/pi.py 100',
                                                                                                                                                u'EXAMPLES': u'To submit a PySpark job with a local script, run:\n\n  $ pyspark --cluster my_cluster my_script.py\n\nTo submit a Spark job that runs a script that is already on the   cluster, run:\n\n  $ pyspark --cluster my_cluster file:///usr/lib/spark/examples/src/main/python/pi.py 100\n'}},
                                                                                                                     u'spark': {u'capsule': u'*(BETA)* Submit a Spark job to a cluster.',
                                                                                                                                u'commands': {},
                                                                                                                                u'flags': {u'--archives': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': [],
                                                                                                                                                           u'description': u'Comma separated list of archives to be provided to the job. must be one of the following file formats: .zip, .tar, .tar.gz, or .tgz.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--archives',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'list',
                                                                                                                                                           u'value': u'ARCHIVE'},
                                                                                                                                           u'--class': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The class containing the main method of the driver. Must be in a provided jar or jar that is already on the classpath',
                                                                                                                                                        u'group': u'spark.1',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--class',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'CLASS'},
                                                                                                                                           u'--cluster': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--cluster',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': True,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'CLUSTER'},
                                                                                                                                           u'--driver-log-levels': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'A list of package to log4j log level pairs to configure driver logging. For example: root=FATAL,com.example=INFO',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--driver-log-levels',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'dict',
                                                                                                                                                                    u'value': u'PACKAGE=LEVEL'},
                                                                                                                                           u'--files': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': [],
                                                                                                                                                        u'description': u'Comma separated list of files to be provided to the job.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--files',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'FILE'},
                                                                                                                                           u'--jar': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The HCFS URI of jar file containing the driver jar.',
                                                                                                                                                      u'group': u'spark.1',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--jar',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'JAR'},
                                                                                                                                           u'--jars': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': [],
                                                                                                                                                       u'description': u'Comma separated list of jar files to be provided to the executor and driver classpaths.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--jars',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'list',
                                                                                                                                                       u'value': u'JAR'},
                                                                                                                                           u'--labels': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--labels',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'dict',
                                                                                                                                                         u'value': u'KEY=VALUE'},
                                                                                                                                           u'--max-failures-per-hour': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': True,
                                                                                                                                                                        u'name': u'--max-failures-per-hour',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'MAX_FAILURES_PER_HOUR'},
                                                                                                                                           u'--properties': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'A list of key value pairs to configure Spark.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--properties',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'dict',
                                                                                                                                                             u'value': u'PROPERTY=VALUE'}},
                                                                                                                                u'group': False,
                                                                                                                                u'groups': {u'spark.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                         u'is_mutex': True,
                                                                                                                                                         u'is_required': True}},
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'spark',
                                                                                                                                u'path': [u'gcloud',
                                                                                                                                          u'beta',
                                                                                                                                          u'dataproc',
                                                                                                                                          u'jobs',
                                                                                                                                          u'submit',
                                                                                                                                          u'spark'],
                                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u"The arguments to pass to the driver.\n+\nThe '--' argument must be specified between gcloud specific args on the left and JOB_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                                                                                                                                  u'name': u'job-args',
                                                                                                                                                  u'nargs': u'...',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'value': u'JOB_ARGS'}],
                                                                                                                                u'release': u'BETA',
                                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Submit a Spark job to a cluster.\n\n## EXAMPLES\n\nTo submit a Spark job that runs the main class of a jar, run:\n\n  $ spark --cluster my_cluster --jar my_jar.jar arg1 arg2\n\nTo submit a Spark job that runs a specific class of a jar, run:\n\n  $ spark --cluster my_cluster --class org.my.main.Class --jars my_jar1.jar,my_jar2.jar arg1 arg2\n\nTo submit a Spark job that runs a jar that is already on the cluster, run:\n\n  $ spark --cluster my_cluster --class org.apache.spark.examples.SparkPi --jars file:///usr/lib/spark/lib/spark-examples.jar 1000'}},
                                                                                                                     u'spark-sql': {u'capsule': u'*(BETA)* Submit a Spark SQL job to a cluster.',
                                                                                                                                    u'commands': {},
                                                                                                                                    u'flags': {u'--cluster': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--cluster',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': True,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'CLUSTER'},
                                                                                                                                               u'--driver-log-levels': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'A list of package to log4j log level pairs to configure driver logging. For example: root=FATAL,com.example=INFO',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--driver-log-levels',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'dict',
                                                                                                                                                                        u'value': u'PACKAGE=LEVEL'},
                                                                                                                                               u'--execute': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': [],
                                                                                                                                                              u'description': u'A Spark SQL query to execute as part of the job.',
                                                                                                                                                              u'group': u'spark-sql.1',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--execute',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'QUERY'},
                                                                                                                                               u'--file': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'HCFS URI of file containing Spark SQL script to execute as the job.',
                                                                                                                                                           u'group': u'spark-sql.1',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--file',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'FILE'},
                                                                                                                                               u'--jars': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': [],
                                                                                                                                                           u'description': u'Comma separated list of jar files to be provided to the executor and driver classpaths. May contain UDFs.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--jars',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'list',
                                                                                                                                                           u'value': u'JAR'},
                                                                                                                                               u'--labels': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--labels',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'dict',
                                                                                                                                                             u'value': u'KEY=VALUE'},
                                                                                                                                               u'--max-failures-per-hour': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': True,
                                                                                                                                                                            u'name': u'--max-failures-per-hour',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'MAX_FAILURES_PER_HOUR'},
                                                                                                                                               u'--params': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'A list of key value pairs to set variables in the Hive queries.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--params',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'dict',
                                                                                                                                                             u'value': u'PARAM=VALUE'},
                                                                                                                                               u'--properties': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'A list of key value pairs to configure Hive.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--properties',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'dict',
                                                                                                                                                                 u'value': u'PROPERTY=VALUE'}},
                                                                                                                                    u'group': False,
                                                                                                                                    u'groups': {u'spark-sql.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                                 u'is_mutex': True,
                                                                                                                                                                 u'is_required': True}},
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'spark-sql',
                                                                                                                                    u'path': [u'gcloud',
                                                                                                                                              u'beta',
                                                                                                                                              u'dataproc',
                                                                                                                                              u'jobs',
                                                                                                                                              u'submit',
                                                                                                                                              u'spark-sql'],
                                                                                                                                    u'positionals': [],
                                                                                                                                    u'release': u'BETA',
                                                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Submit a Spark SQL job to a cluster.\n\n## EXAMPLES\n\nTo submit a Spark SQL job with a local script, run:\n\n  $ spark-sql --cluster my_cluster --file my_queries.ql\n\nTo submit a Spark SQL job with inline queries, run:\n\n  $ spark-sql --cluster my_cluster -e "CREATE EXTERNAL TABLE foo(bar int) LOCATION \'gs://my_bucket/\'" -e "SELECT * FROM foo WHERE bar > 2"'}}},
                                                                                                       u'flags': {u'--async': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Does not wait for the job to run.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--async',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'ASYNC'},
                                                                                                                  u'--bucket': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"The Cloud Storage bucket to stage files in. Defaults to the cluster's configured bucket.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--bucket',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'BUCKET'},
                                                                                                                  u'--id': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--id',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'ID'},
                                                                                                                  u'--no-async': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-async',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_ASYNC'}},
                                                                                                       u'group': True,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'submit',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'dataproc',
                                                                                                                 u'jobs',
                                                                                                                 u'submit'],
                                                                                                       u'positionals': [],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Submit Google Cloud Dataproc jobs to execute on a cluster.\n\n## EXAMPLES\n\nTo submit a Hadoop MapReduce job, run:\n\n  $ submit hadoop --cluster my_cluster --jar my_jar.jar arg1 arg2\n\nTo submit a Spark Scala or Java job, run:\n\n  $ submit spark --cluster my_cluster --jar my_jar.jar arg1 arg2\n\nTo submit a PySpark job, run:\n\n  $ submit pyspark --cluster my_cluster my_script.py arg1 arg2\n\nTo submit a Spark SQL job, run:\n\n  $ submit spark-sql --cluster my_cluster --file my_queries.q\n\nTo submit a Pig job, run:\n\n  $ submit pig --cluster my_cluster --file my_script.pig\n\nTo submit a Hive job, run:\n\n  $ submit hive --cluster my_cluster --file my_queries.q'}},
                                                                                           u'update': {u'capsule': u'*(BETA)* Update the labels for a job.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--remove-labels': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'A list of label keys to remove. If a label does not exist it is\nsilently ignored.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--remove-labels',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'list',
                                                                                                                                       u'value': u'KEY'},
                                                                                                                  u'--update-labels': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'A list of label KEY=VALUE pairs to update. If a label exists its value\nis modified, otherwise a new label is created.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--update-labels',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'dict',
                                                                                                                                       u'value': u'KEY=VALUE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'update',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'dataproc',
                                                                                                                 u'jobs',
                                                                                                                 u'update'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The ID of the job to describe.',
                                                                                                                         u'name': u'id',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'JOB_ID'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u"*(BETA)* Update the labels for a job.\n\n## EXAMPLES\n\nTo add the label 'customer=acme' to a job , run:\n\n  $ update job_id --update-labels=customer=acme\n\nTo update the label 'customer=ackme' to 'customer=acme', run:\n\n  $ update job_id --update-labels=customer=acme\n\nTo remove the label whose key is 'customer', run:\n\n  $ update job_id --remove-labels=customer"}},
                                                                                           u'wait': {u'capsule': u'*(BETA)* View the output of a job as it runs or after it completes.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'wait',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'dataproc',
                                                                                                               u'jobs',
                                                                                                               u'wait'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The ID of the job to wait.',
                                                                                                                       u'name': u'id',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'JOB_ID'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* View the output of a job as it runs or after it completes.\n\n## EXAMPLES\n\nTo view the output of a job as it runs, run:\n\n  $ wait job_id'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'jobs',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'dataproc',
                                                                                       u'jobs'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Submit and manage Google Cloud Dataproc jobs.\n\n## EXAMPLES\n\nTo learn about the types of jobs that can be submitted, run:\n\n  $ jobs submit\n\nTo view the output of a job as it runs, run:\n\n  $ jobs wait job_id\n\nTo cancel an active job, run:\n\n  $ jobs kill job_id\n\nTo view the details of a job, run:\n\n  $ jobs describe job_id\n\nTo see the list of all jobs, run:\n\n  $ jobs list\n\nTo delete the record of an inactive job, run:\n\n  $ jobs delete job_id'}},
                                                                   u'operations': {u'capsule': u'*(BETA)* View and manage Google Cloud Dataproc operations.',
                                                                                   u'commands': {u'cancel': {u'capsule': u'*(BETA)* Cancel an active operation.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'cancel',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'dataproc',
                                                                                                                       u'operations',
                                                                                                                       u'cancel'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The ID of the operation to cancel.',
                                                                                                                               u'name': u'operation',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'OPERATION'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Cancel an active operation.\n\n## EXAMPLES\n\nTo cancel an operation, run:\n\n  $ cancel operation_id'}},
                                                                                                 u'delete': {u'capsule': u'*(BETA)* Delete the record of an inactive operation.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'delete',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'dataproc',
                                                                                                                       u'operations',
                                                                                                                       u'delete'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The ID of the operation to delete.',
                                                                                                                               u'name': u'operation',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'OPERATION'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Delete the record of an inactive operation.\n\n## EXAMPLES\n\nTo delete the record of an operation, run:\n\n  $ delete operation_id'}},
                                                                                                 u'describe': {u'capsule': u'*(BETA)* View the details of an operation.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'describe',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'dataproc',
                                                                                                                         u'operations',
                                                                                                                         u'describe'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The ID of the operation to describe.',
                                                                                                                                 u'name': u'operation',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'OPERATION'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* View the details of an operation.\n\n## EXAMPLES\n\nTo view the details of an operation, run:\n\n  $ describe operation_id'}},
                                                                                                 u'list': {u'capsule': u'*(BETA)* View the list of all operations.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--cluster': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Restrict to the operations of this Dataproc cluster. This flag is ignored when --filter is specified. The equivalent term in a --filter expression is: `clusterName = myclustername`',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--cluster',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'CLUSTER'},
                                                                                                                      u'--filter': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--filter',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--limit',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': 100,
                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--page-size',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'int',
                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'FIELD'},
                                                                                                                      u'--state-filter': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [u'active',
                                                                                                                                                       u'inactive'],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Filter by cluster state. This flag is ignored when --filter is specified. The equivalent term in a --filter expression is: `status.state = ACTIVE`. _STATE_FILTER_ must be one of: *active*, *inactive*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--state-filter',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'STATE_FILTER'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'list',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'dataproc',
                                                                                                                     u'operations',
                                                                                                                     u'list'],
                                                                                                           u'positionals': [],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u"*(BETA)* View a list of operations in a project. An optional filter can be used to\nconstrain the operations returned. Filters are case-sensitive and have the\nfollowing syntax:\n\n  field = value [AND [field = value]] ...\n\nwhere `field` is either of `status.state` or `labels.[KEY]`, where `[KEY]` is\na label key. `value` can be ```*``` to match all values. `status.state` is\none of: `PENDING`, `ACTIVE`, `DONE`. Only the logical `AND` operator is\nsupported; space-separated items are treated as having an implicit `AND`\noperator.\n\n## EXAMPLES\n\nTo see the list of all operations, run:\n\n  $ list\n\nTo see the list of all active operations in a cluster named mycluster, run:\n\n  $ list --filter='status.state = RUNNING AND clusterName = mycluster'\n\nTo see a list of all pending operations the label `env=staging` on cluster `mycluster`, run:\n\n  $ list --filter='status.state = PENDING  AND labels.env = staging AND clusterName = mycluster'"}}},
                                                                                   u'flags': {},
                                                                                   u'group': True,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'operations',
                                                                                   u'path': [u'gcloud',
                                                                                             u'beta',
                                                                                             u'dataproc',
                                                                                             u'operations'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'BETA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* View and manage Google Cloud Dataproc operations.\n\n## EXAMPLES\n\nTo cancel an active operation, run:\n\n  $ operations cancel operation_id\n\nTo view the details of an operation, run:\n\n  $ operations describe operation_id\n\nTo see the list of all operations, run:\n\n  $ operations list\n\nTo delete the record of an inactive operation, run:\n\n  $ operations delete operation_id'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'dataproc',
                                                     u'path': [u'gcloud',
                                                               u'beta',
                                                               u'dataproc'],
                                                     u'positionals': [],
                                                     u'release': u'BETA',
                                                     u'sections': {u'DESCRIPTION': u'The gcloud dataproc command group lets you create and manage Google\nCloud Dataproc clusters and jobs.\n\nCloud Dataproc is an Apache Hadoop, Apache Spark, Apache Pig, and Apache\nHive service. It easily processes big datasets at low cost, creating\nmanaged clusters of any size that scale down once processing is\ncomplete.\n\nMore information on Cloud Dataproc can be found here:\nhttps://cloud.google.com/dataproc and detailed documentation can be\nfound here: https://cloud.google.com/dataproc/docs/\n\n## EXAMPLES\n\nTo see how to create and manage clusters, run:\n\n    $ dataproc clusters\n\nTo see how to submit and manage jobs, run:\n\n    $ dataproc jobs\n'}},
                                       u'debug': {u'capsule': u'*(BETA)* Commands for interacting with the Cloud Debugger.',
                                                  u'commands': {u'logpoints': {u'capsule': u'*(BETA)* Commands for interacting with Cloud Debugger logpoints.',
                                                                               u'commands': {u'create': {u'capsule': u'*(BETA)* Create debug logpoints.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--condition': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'A condition to restrict when the log output is generated. When the\nlogpoint is hit, the condition will be evaluated, and the log output\nwill be generated only if the condition is true.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--condition',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'CONDITION'},
                                                                                                                    u'--log-level': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [u'info',
                                                                                                                                                  u'warning',
                                                                                                                                                  u'error'],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': u'info',
                                                                                                                                     u'description': u'The logging level to use when producing the log message. _LOG_LEVEL_ must be one of: *info*, *warning*, *error*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--log-level',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'LOG_LEVEL'},
                                                                                                                    u'--wait': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': 10,
                                                                                                                                u'description': u'The number of seconds to wait to ensure that no error is returned\nfrom a debugger agent when creating the logpoint. When a logpoint\nis created, there will be a delay before the agents see and apply\nthe logpoint. Until at least one agent has attempted to\nenable the logpoint, it cannot be determined if the logpoint is\nvalid.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--wait',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'int',
                                                                                                                                u'value': u'WAIT'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'create',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'debug',
                                                                                                                   u'logpoints',
                                                                                                                   u'create'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The logpoint location. Locations are of\nthe form FILE:LINE, where FILE can be simply the file name, or the\nfile name preceded by enough path components to differentiate it\nfrom other files with the same name. It is an error to provide a\nfile name that is not unique in the debug target.',
                                                                                                                           u'name': u'location',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'LOCATION'},
                                                                                                                          {u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'A format string which will be logged every time the logpoint\nlocation is executed. If the string contains curly braces (\'{\' and\n\'}\'), any text within the curly braces will be interpreted as a\nrun-time expression in the debug target\'s language, which will be\nevaluated when the logpoint is hit.\n+\nThe value of the expression will then replace the {} expression in\nthe resulting log output. For example, if you specify the format\nstring "a={a}, b={b}", and the logpoint is hit when local variable\na is 1 and b is 2, the resulting log output would be "a=1, b=2".',
                                                                                                                           u'name': u'log-format-string',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'LOG_FORMAT_STRING'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'This command adds a debug logpoint to a debug target. Logpoints add\nlogging to your running service without changing your code or\nrestarting your application. When you create a logpoint, the message\nyou specify will be added to your logs whenever any instance of your\nservice executes the specified line of code.\n\nThe default lifetime of a logpoint is 24 hours from creation, and the\noutput will go to the standard log for the programming language of the\ntarget (java.logging for Java, logging.* for Python, etc.)\n'}},
                                                                                             u'delete': {u'capsule': u'*(BETA)* Delete debug logpoints.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--all-users': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'If set, any location regexp will match logpoints from all users,\nrather than only logpoints created by the current user. This flag is\nnot required when specifying the exact ID of a logpoint created by\nanother user.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--all-users',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'ALL_USERS'},
                                                                                                                    u'--include-inactive': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'If set, any location regexp will also match inactive logpoints,\nrather than only logpoints which have not expired. This flag is\nnot required when specifying the exact ID of an inactive logpoint.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--include-inactive',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'INCLUDE_INACTIVE'},
                                                                                                                    u'--location': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'A regular expression to match against logpoint\nlocations. All logpoints matching this value will be\ndeleted.  You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n      --location foo.py:[1-3] --location bar.py:4',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--location',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LOCATION-REGEXP'},
                                                                                                                    u'--no-all-users': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-all-users',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ALL_USERS'},
                                                                                                                    u'--no-include-inactive': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-include-inactive',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_INCLUDE_INACTIVE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'delete',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'debug',
                                                                                                                   u'logpoints',
                                                                                                                   u'delete'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Zero or more logpoint resource identifiers. The specified\nlogpoints will be deleted.',
                                                                                                                           u'name': u'ids',
                                                                                                                           u'nargs': u'*',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'ID'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* This command deletes logpoints from a Cloud Debugger debug target. It will\nask for confirmation before deleting any logpoints. To suppress confirmation,\nuse the global --quiet option.'}},
                                                                                             u'list': {u'capsule': u'*(BETA)* List debug logpoints.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--all-users': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'If false, display only logpoints created by the current user. Enabled by default, use *--no-all-users* to disable.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--all-users',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ALL_USERS'},
                                                                                                                  u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--include-inactive': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': 300,
                                                                                                                                          u'description': u'Include logpoints which failed or expired in the last\nINCLUDE_INACTIVE seconds. If the value is "unlimited", all failed\nor expired logpoints will be included.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--include-inactive',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'int',
                                                                                                                                          u'value': u'INCLUDE_INACTIVE'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--location': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A regular expression to match against logpoint\nlocations. All logpoints matching this value will be\nlisted.  You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n      --location foo.py:[1-3] --location bar.py:4',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--location',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LOCATION-REGEXP'},
                                                                                                                  u'--no-all-users': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-all-users',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ALL_USERS'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'list',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'debug',
                                                                                                                 u'logpoints',
                                                                                                                 u'list'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Zero or more logpoint resource identifiers. The specified\nlogpoints will be listed.',
                                                                                                                         u'name': u'ids',
                                                                                                                         u'nargs': u'*',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'ID'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'This command displays a list of the active debug logpoints for a\nCloud Debugger debug target.\n'}}},
                                                                               u'flags': {u'--target': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"The debug target. It may be a target ID or name obtained from\n'debug targets list', or it may be a regular expression uniquely\nspecifying a debuggee based on its description or name. For App\nEngine projects, if not specified, the default target is\nthe most recent deployment of the default module and version.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--target',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'(ID|DESCRIPTION_REGEXP)'}},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'logpoints',
                                                                               u'path': [u'gcloud',
                                                                                         u'beta',
                                                                                         u'debug',
                                                                                         u'logpoints'],
                                                                               u'positionals': [],
                                                                               u'release': u'BETA',
                                                                               u'sections': {u'DESCRIPTION': u"*(BETA)* Logpoints allow you to inject logging into running services without\nrestarting or interfering with the normal function of the service. Log output\nwill be sent to the appropriate log for the target's environment.\nOn App Engine, for example, output will go to the request log.",
                                                                                             u'EXAMPLES': u'\nThe following command would log the value of the "name" attribute\nof the "product" variable whenever any request executes line 123 of\nthe file product.py:\n\n    $ logpoints create product.py:123               "No description for {product.name}"\n\nThe log output will appear wherever explicit logging output from your\nprogram is normally written. For example, for an App Engine Standard\napplication, the output would appear in the request log.\n\nIf you want to log output only when certain runtime conditions are met,\nyou can add a "--condition" option:\n\n    $ logpoints create product.py:123               "Suspicious price: {product.name} costs {price}"               --condition "price < .50"\n\nLogpoints remain active for 24 hours after creation. If you want to\ndisable a logpoint, use the logpoints delete command:\n\n    $ logpoints delete product.*\n\nThe above command would delete all logpoints in any file whose name\nbegins with "product". If you want to delete only a single logpoint, you\nshould first determine the logpoint ID using the logpoints list command,\nthen delete that specific ID:\n\n    $ logpoints list\n    ID                        LOCATION    ...\n    567890abcdef1-1234-56789  product.py:123  ...\n    $ logpoints delete 567890abcdef1-1234-56789\n\nFor App Engine services, logpoint resources include the "logQuery"\nproperty, which is suitable for use with the "gcloud beta logging read"\ncommand. You can save this property\'s value and use it to read logs from\nthe command line:\n\n    $ log_query=$(logpoints create product.py:123               "No description for {product.name}" --format="value(logQuery)")\n    $ gcloud beta logging read "$log_query"\n'}},
                                                                u'snapshots': {u'capsule': u'*(BETA)* Commands for interacting with Cloud Debugger snapshots.',
                                                                               u'commands': {u'create': {u'capsule': u'*(BETA)* Create debug snapshots.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--condition': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'A condition to restrict when the snapshot is taken. When the\nsnapshot location is executed, the condition will be evaluated, and\nthe snapshot will be generated only if the condition is true.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--condition',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'CONDITION'},
                                                                                                                    u'--expression': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'An expression to evaluate when the snapshot is taken. You may\nspecify --expression multiple times.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--expression',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                    u'--wait': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': 10,
                                                                                                                                u'description': u'The number of seconds to wait to ensure that no error is returned\nfrom a debugger agent when creating the snapshot. When a snapshot\nis created, there will be a delay before the agents see and apply\nthe snapshot. Until at least one agent has attempted to\nenable the snapshot, it cannot be determined if the snapshot is\nvalid.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--wait',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'int',
                                                                                                                                u'value': u'WAIT'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'create',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'debug',
                                                                                                                   u'snapshots',
                                                                                                                   u'create'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The location where the snapshot should be taken. Locations are of\nthe form FILE:LINE, where FILE can be simply the file name, or the\nfile name preceded by enough path components to differntiate it from\nother files with the same name. If the file name is not unique in\nthe debug target, the behavior is unspecified.',
                                                                                                                           u'name': u'location',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'LOCATION'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'This command creates a debug snapshot on a Cloud Debugger debug\ntarget. Snapshots allow you to capture stack traces and local\nvariables from your running service without interfering with normal\noperations.\n\nWhen any instance of the target executes the snapshot location, the\noptional condition expression is evaluated. If the result is true\n(or if there is no condition), the instance captures the current\nthread state and reports it back to Cloud Debugger. Once any instance\ncaptures a snapshot, the snapshot is marked as completed, and it\nwill not be captured again.\n\nYou can most easily view snapshot results in the developer console. It\nis also possible to inspect snapshot results with the "snapshots\ndescribe" command.\n'}},
                                                                                             u'delete': {u'capsule': u'*(BETA)* Delete debug snapshots.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--all-users': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'If set, matching snapshots from all users will be deleted, rather\nthan only snapshots created by the current user.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--all-users',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'ALL_USERS'},
                                                                                                                    u'--include-inactive': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'If set, also delete snapshots which have been completed. By default,\nonly pending snapshots will be deleted.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--include-inactive',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'INCLUDE_INACTIVE'},
                                                                                                                    u'--location': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'A regular expression to match against snapshot\nlocations. All snapshots matching this value will be\ndeleted.  You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n      --location foo.py:[1-3] --location bar.py:4',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--location',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LOCATION-REGEXP'},
                                                                                                                    u'--no-all-users': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-all-users',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ALL_USERS'},
                                                                                                                    u'--no-include-inactive': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-include-inactive',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_INCLUDE_INACTIVE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'delete',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'debug',
                                                                                                                   u'snapshots',
                                                                                                                   u'delete'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Zero or more snapshot resource identifiers. The specified\nsnapshots will be deleted.',
                                                                                                                           u'name': u'ids',
                                                                                                                           u'nargs': u'*',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'ID'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* This command deletes snapshots from a Cloud Debugger debug target. It will\nask for confirmation before deleting any snapshots. To suppress confirmation,\nuse the global --quiet option.'}},
                                                                                             u'describe': {u'capsule': u'*(BETA)* Describe debug snapshots.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--location': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'A regular expression to match against snapshot\nlocations. All snapshots matching this value will be\ndisplayed.  You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n      --location foo.py:[1-3] --location bar.py:4',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--location',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'LOCATION-REGEXP'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'describe',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'debug',
                                                                                                                     u'snapshots',
                                                                                                                     u'describe'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Zero or more snapshot resource identifiers. The specified\nsnapshots will be displayed.',
                                                                                                                             u'name': u'ids',
                                                                                                                             u'nargs': u'*',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'ID'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'This command describes debug snapshots for a Cloud Debugger debug\ntarget. If the snapshot has been completed, the output will include\ndetails on the stack trace and local variables, stored in a compact\nform which is primarily intended to be machine-readable rather than\nhuman-readable.\n'}},
                                                                                             u'list': {u'capsule': u'*(BETA)* List debug snapshots.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--all-users': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'If set, display snapshots from all users, rather than only the\ncurrent user.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--all-users',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ALL_USERS'},
                                                                                                                  u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--include-inactive': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': 300,
                                                                                                                                          u'description': u'Include snapshots which have completed in the last INCLUDE_INACTIVE\nseconds. If the value is "unlimited", all inactive snapshots will\nbe included.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--include-inactive',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'int',
                                                                                                                                          u'value': u'INCLUDE_INACTIVE'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--location': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A regular expression to match against snapshot\nlocations. All snapshots matching this value will be\ndisplayed.  You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n      --location foo.py:[1-3] --location bar.py:4',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--location',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LOCATION-REGEXP'},
                                                                                                                  u'--no-all-users': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-all-users',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ALL_USERS'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'list',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'debug',
                                                                                                                 u'snapshots',
                                                                                                                 u'list'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Zero or more snapshot resource identifiers. The specified\nsnapshots will be displayed.',
                                                                                                                         u'name': u'ids',
                                                                                                                         u'nargs': u'*',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'ID'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'This command displays a list of the active debug snapshots for a\nCloud Debugger debug target.\n'}},
                                                                                             u'wait': {u'capsule': u'*(BETA)* Wait for debug snapshots to complete.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--all': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'If set, wait for all of the specified snapshots to complete, instead of\nwaiting for any one of them to complete.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--all',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'ALL'},
                                                                                                                  u'--all-users': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'If set, wait for matching snapshots from all users, rather than\nonly the current user.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--all-users',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ALL_USERS'},
                                                                                                                  u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--location': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A regular expression to match against snapshot\nlocations. The command will wait for any snapshots matching these\ncriteria to complete. You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n    --location foo.py:[1-3] --location bar.py:3',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--location',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LOCATION-REGEXP'},
                                                                                                                  u'--no-all': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-all',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_ALL'},
                                                                                                                  u'--no-all-users': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-all-users',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ALL_USERS'},
                                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_URI'},
                                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--page-size',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'},
                                                                                                                  u'--timeout': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': u'unlimited',
                                                                                                                                 u'description': u'Maximum number of seconds to wait for a snapshot to complete. By\ndefault, wait indefinitely.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--timeout',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'TIMEOUT'},
                                                                                                                  u'--uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'URI'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'wait',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'debug',
                                                                                                                 u'snapshots',
                                                                                                                 u'wait'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Zero or more snapshot resource identifiers. The command will\nwait for any of the specified snapshots to complete.',
                                                                                                                         u'name': u'ids',
                                                                                                                         u'nargs': u'*',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'ID'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'This command waits for one or more snapshots on a Cloud Debugger debug\ntarget to become completed. A snapshot is considered completed either\nif there was an error setting the snapshot or if the snapshot was hit\non an instance of the debug target.\n'}}},
                                                                               u'flags': {u'--target': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"The debug target. It may be a target ID or name obtained from\n'debug targets list', or it may be a regular expression uniquely\nspecifying a debuggee based on its description or name. For App\nEngine projects, if not specified, the default target is\nthe most recent deployment of the default module and version.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--target',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'(ID|DESCRIPTION_REGEXP)'}},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'snapshots',
                                                                               u'path': [u'gcloud',
                                                                                         u'beta',
                                                                                         u'debug',
                                                                                         u'snapshots'],
                                                                               u'positionals': [],
                                                                               u'release': u'BETA',
                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Commands to interact with debug snapshots. Snapshots allow you to capture\nstack traces and local variables from running services without interfering\nwith the normal function of the service.'}},
                                                                u'source': {u'capsule': u'*(BETA)* Commands to manage source information for Stackdriver tools.',
                                                                            u'commands': {u'gen-repo-info-file': {u'capsule': u'*(BETA)* Generates repository information files for the Stackdriver Debugger.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--output-directory': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': u'.',
                                                                                                                                                     u'description': u'The directory in which to create the source context files.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--output-directory',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'OUTPUT_DIRECTORY'},
                                                                                                                             u'--source-directory': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': u'.',
                                                                                                                                                     u'description': u'The directory containing the source code for the build.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--source-directory',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'SOURCE_DIRECTORY'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'gen-repo-info-file',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'debug',
                                                                                                                            u'source',
                                                                                                                            u'gen-repo-info-file'],
                                                                                                                  u'positionals': [],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'This command generates two files, source-context.json and\nsource-contexts.json, containing information on the source revision\nand remote repository associated with the given source directory.\n',
                                                                                                                                u'EXAMPLES': u'To generate repository information files for your app,\nfrom your source directory run:\n\n  $ gen-repo-info-file\n'}}},
                                                                            u'flags': {},
                                                                            u'group': True,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'source',
                                                                            u'path': [u'gcloud',
                                                                                      u'beta',
                                                                                      u'debug',
                                                                                      u'source'],
                                                                            u'positionals': [],
                                                                            u'release': u'BETA',
                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* This set of commands allows you to provide Stackdriver tools with source\ncode version information.'}},
                                                                u'targets': {u'capsule': u'*(BETA)* Commands for interacting with Cloud Debugger debug targets.',
                                                                             u'commands': {u'list': {u'capsule': u'*(BETA)* List debug targets.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--include-inactive': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'If set, include targets which are no longer active.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--include-inactive',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'INCLUDE_INACTIVE'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-include-inactive': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-include-inactive',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_INCLUDE_INACTIVE'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'debug',
                                                                                                               u'targets',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* This command displays a list of the active debug targets registered\nwith the Cloud Debugger.'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'targets',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'debug',
                                                                                       u'targets'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Commands to interact with debug targets. A debug target can be an App Engine\nmodule version or any other entity enabled for use with the cloud debugger.',
                                                                                           u'EXAMPLES': u'To view all available debug targets, run:\n\n    $ targets list\n'}}},
                                                  u'flags': {},
                                                  u'group': True,
                                                  u'groups': {},
                                                  u'hidden': False,
                                                  u'name': u'debug',
                                                  u'path': [u'gcloud',
                                                            u'beta',
                                                            u'debug'],
                                                  u'positionals': [],
                                                  u'release': u'BETA',
                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* The debug command group provides interaction with Stackdriver Debugger,\nallowing you to list and manipulate debugging targets, snapshots and\nlogpoints.\n\nStackdriver Debugger is a feature of the Google Cloud Platform that lets you\ninspect the state of an application at any code location without using logging\nstatements and without stopping or slowing down your applications.\n\nMore information on Stackdriver Debugger can be found here:\nhttps://cloud.google.com/debugger and detailed documentation can be found\nhere: https://cloud.google.com/debugger/docs/\n\n## EXAMPLES\n\nTo view all available debug targets, run:\n\n  $ debug targets list\n\n  NAME           ID             DESCRIPTION\n  default-test   gcp:1234:5678  myproject-test-9876543\n  default-test2  gcp:9012:3456  myproject-test2-1234567\n\nTo create a snapshot in a for a particular target:\n\n  $ debug snapshots create --target=default-test foo.py:12\n\nNote that if there is not a target with the exact name or ID specified, the\ntarget is treated as a regular expression to match against the name or\ndescription:\n\n  $ debug snapshots create --target=test foo.py:12\n\n  ERROR: (gcloud.beta.debug.snapshots.create) Multiple possible targets found.\n  Use the --target option to select one of the following targets:\n      default-test\n      default-test2\n\n  In the above case, "test" matches both targets\' names. Specifying \'test$\'\n  would match only "default-test" (by name), while "9876" would match\n  "default-test" by description.'}},
                                       u'deployment-manager': {u'capsule': u'*(BETA)* Manage deployments of cloud resources.',
                                                               u'commands': {u'deployments': {u'capsule': u'*(BETA)* Commands for Deployment Manager deployments.',
                                                                                              u'commands': {u'cancel-preview': {u'capsule': u'*(BETA)* Cancel a pending or running deployment preview.',
                                                                                                                                u'commands': {},
                                                                                                                                u'flags': {u'--async': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': False,
                                                                                                                                                        u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--async',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'ASYNC'},
                                                                                                                                           u'--fingerprint': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The fingerprint to use in requests to modify a deployment. If not specified, a get deployment request will be made to fetch the latest fingerprint. A fingerprint is a randomly generated value that is part of the update, stop, and cancel-preview request to perform optimistic locking. It is initially generated by Deployment Manager and changes after every request to modify data. The latest fingerprint is printed when deployment data is modified.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--fingerprint',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'FINGERPRINT'},
                                                                                                                                           u'--no-async': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': False,
                                                                                                                                                           u'description': u'',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': True,
                                                                                                                                                           u'name': u'--no-async',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'NO_ASYNC'}},
                                                                                                                                u'group': False,
                                                                                                                                u'groups': {},
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'cancel-preview',
                                                                                                                                u'path': [u'gcloud',
                                                                                                                                          u'beta',
                                                                                                                                          u'deployment-manager',
                                                                                                                                          u'deployments',
                                                                                                                                          u'cancel-preview'],
                                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Deployment name.',
                                                                                                                                                  u'name': u'deployment-name',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                                u'release': u'BETA',
                                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* This command will cancel a currently running or pending preview operation on\na deployment.',
                                                                                                                                              u'EXAMPLES': u'To cancel a running operation on a deployment, run:\n\n  $ cancel-preview my-deployment\n\nTo issue a cancel preview command without waiting for the operation to complete, run:\n\n  $ cancel-preview my-deployment --async\n\nTo cancel a preview command providing a fingerprint:\n\n  $ cancel-preview my-deployment --fingerprint deployment-fingerprint\n'}},
                                                                                                            u'create': {u'capsule': u'*(BETA)* Create a deployment.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--async': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--async',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'ASYNC'},
                                                                                                                                   u'--config': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Filename of config which specifies resources to deploy.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--config',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': True,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'CONFIG'},
                                                                                                                                   u'--description': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Optional description of the deployment to insert.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--description',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                                   u'--no-async': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-async',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_ASYNC'},
                                                                                                                                   u'--no-preview': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-preview',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_PREVIEW'},
                                                                                                                                   u'--preview': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'Preview the requested create without actually instantiating the underlying resources. (default=False)',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--preview',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'PREVIEW'},
                                                                                                                                   u'--properties': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'A comma seperated, key=value, map to be used when deploying a template file directly.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--properties',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'dict',
                                                                                                                                                     u'value': u'PROPERTIES'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'create',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'beta',
                                                                                                                                  u'deployment-manager',
                                                                                                                                  u'deployments',
                                                                                                                                  u'create'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Deployment name.',
                                                                                                                                          u'name': u'deployment-name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                        u'release': u'BETA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* This command inserts (creates) a new deployment based on a provided config\nfile.',
                                                                                                                                      u'EXAMPLES': u'To create a new deployment, run:\n\n  $ create my-deployment --config config.yaml --description "My deployment"\n\nTo preview a deployment without actually creating resources, run:\n\n  $ create my-new-deployment --config config.yaml --preview\n\nTo instantiate a deployment that has been previewed, issue an update command for that deployment without specifying a config file.\n'}},
                                                                                                            u'delete': {u'capsule': u'*(BETA)* Delete a deployment.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--async': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--async',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'ASYNC'},
                                                                                                                                   u'--delete-policy': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [u'ABANDON',
                                                                                                                                                                     u'DELETE'],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': u'DELETE',
                                                                                                                                                        u'description': u'Delete policy for resources that will change as part of an update or delete. DELETE deletes the resource while ABANDON just removes the resource reference from the deployment. _DELETE_POLICY_ must be one of: *ABANDON*, *DELETE*.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--delete-policy',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'DELETE_POLICY'},
                                                                                                                                   u'--no-async': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-async',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_ASYNC'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'delete',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'beta',
                                                                                                                                  u'deployment-manager',
                                                                                                                                  u'deployments',
                                                                                                                                  u'delete'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Deployment name.',
                                                                                                                                          u'name': u'deployment-name',
                                                                                                                                          u'nargs': u'+',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                        u'release': u'BETA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* This command deletes a deployment and deletes all associated resources.',
                                                                                                                                      u'EXAMPLES': u'To delete a deployment, run:\n\n  $ delete my-deployment\n\nTo issue a delete command without waiting for the operation to complete, run:\n\n  $ delete my-deployment --async\n\nTo delete several deployments, run:\n\n  $ delete my-deployment-one my-deployment-two my-deployment-three\n\nTo disable the confirmation prompt on delete, run:\n\n  $ delete my-deployment -q\n'}},
                                                                                                            u'describe': {u'capsule': u'*(BETA)* Provide information about a deployment.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'describe',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'beta',
                                                                                                                                    u'deployment-manager',
                                                                                                                                    u'deployments',
                                                                                                                                    u'describe'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Deployment name.',
                                                                                                                                            u'name': u'deployment-name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                          u'release': u'BETA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* This command prints out all available details about a deployment.',
                                                                                                                                        u'EXAMPLES': u'To display information about a deployment, run:\n\n  $ describe my-deployment\n'}},
                                                                                                            u'list': {u'capsule': u'*(BETA)* List deployments in a project.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--filter',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--limit',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'LIMIT'},
                                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': True,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-uri',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_URI'},
                                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--page-size',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                                 u'--simple-list': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--simple-list',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'SIMPLE_LIST'},
                                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--sort-by',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'list',
                                                                                                                                                u'value': u'FIELD'},
                                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'URI'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'list',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'deployment-manager',
                                                                                                                                u'deployments',
                                                                                                                                u'list'],
                                                                                                                      u'positionals': [],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Prints a table with summary information on all deployments in the project.',
                                                                                                                                    u'EXAMPLES': u'To print out a list of deployments with some summary information about each, run:\n\n  $ list\n\nTo print only the name of each deployment, run:\n\n  $ list --simple-list\n'}},
                                                                                                            u'stop': {u'capsule': u'*(BETA)* Stop a pending or running deployment update or creation.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--async': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--async',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'ASYNC'},
                                                                                                                                 u'--fingerprint': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The fingerprint to use in requests to modify a deployment. If not specified, a get deployment request will be made to fetch the latest fingerprint. A fingerprint is a randomly generated value that is part of the update, stop, and cancel-preview request to perform optimistic locking. It is initially generated by Deployment Manager and changes after every request to modify data. The latest fingerprint is printed when deployment data is modified.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--fingerprint',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'FINGERPRINT'},
                                                                                                                                 u'--no-async': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--no-async',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'NO_ASYNC'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'stop',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'deployment-manager',
                                                                                                                                u'deployments',
                                                                                                                                u'stop'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Deployment name.',
                                                                                                                                        u'name': u'deployment-name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* This command will stop a currently running or pending operation on\na deployment.',
                                                                                                                                    u'EXAMPLES': u'To stop a running operation on a deployment, run:\n\n  $ stop my-deployment\n\nTo issue a stop command without waiting for the operation to complete, run:\n\n  $ stop my-deployment --async\n\nTo stop a running operation on a deployment providing a fingerprint, run:\n\n  $ stop my-deployment --fingerprint deployment-fingerprint\n'}},
                                                                                                            u'update': {u'capsule': u'*(BETA)* Update a deployment based on a provided config file.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--async': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--async',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'ASYNC'},
                                                                                                                                   u'--config': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Filename of config which specifies resources to deploy. Required unless launching an already-previewed update to this deployment.',
                                                                                                                                                 u'group': u'update.1',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--config',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'CONFIG'},
                                                                                                                                   u'--create-policy': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [u'ACQUIRE',
                                                                                                                                                                     u'CREATE_OR_ACQUIRE'],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': u'CREATE_OR_ACQUIRE',
                                                                                                                                                        u'description': u'Create policy for resources that have changed in the update. _CREATE_POLICY_ must be one of: *ACQUIRE*, *CREATE_OR_ACQUIRE*.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--create-policy',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'CREATE_POLICY'},
                                                                                                                                   u'--delete-policy': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [u'ABANDON',
                                                                                                                                                                     u'DELETE'],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': u'DELETE',
                                                                                                                                                        u'description': u'Delete policy for resources that will change as part of an update or delete. DELETE deletes the resource while ABANDON just removes the resource reference from the deployment. _DELETE_POLICY_ must be one of: *ABANDON*, *DELETE*.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--delete-policy',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'DELETE_POLICY'},
                                                                                                                                   u'--description': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The new description of the deployment.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--description',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                                                   u'--fingerprint': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The fingerprint to use in requests to modify a deployment. If not specified, a get deployment request will be made to fetch the latest fingerprint. A fingerprint is a randomly generated value that is part of the update, stop, and cancel-preview request to perform optimistic locking. It is initially generated by Deployment Manager and changes after every request to modify data. The latest fingerprint is printed when deployment data is modified.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--fingerprint',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'FINGERPRINT'},
                                                                                                                                   u'--manifest-id': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Manifest Id of a previous deployment. This flag cannot be used with --config.',
                                                                                                                                                      u'group': u'update.1',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--manifest-id',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'MANIFEST_ID'},
                                                                                                                                   u'--no-async': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-async',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_ASYNC'},
                                                                                                                                   u'--no-preview': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-preview',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_PREVIEW'},
                                                                                                                                   u'--preview': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'Preview the requested update without making any changes to theunderlying resources. (default=False)',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--preview',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'PREVIEW'},
                                                                                                                                   u'--properties': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'A comma seperated, key=value, map to be used when deploying a template file directly.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--properties',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'dict',
                                                                                                                                                     u'value': u'PROPERTIES'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {u'update.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                  u'is_mutex': True,
                                                                                                                                                  u'is_required': False}},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'update',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'beta',
                                                                                                                                  u'deployment-manager',
                                                                                                                                  u'deployments',
                                                                                                                                  u'update'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Deployment name.',
                                                                                                                                          u'name': u'deployment-name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'DEPLOYMENT_NAME'}],
                                                                                                                        u'release': u'BETA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* This command will update a deployment with the new config file provided.\nDifferent policies for create, update, and delete policies can be specified.',
                                                                                                                                      u'EXAMPLES': u'To update an existing deployment with a new config file, run:\n\n  $ update my-deployment --config new_config.yaml\n\nTo preview an update to an existing deployment without actually modifying the resources, run:\n\n  $ update my-deployment --config new_config.yaml --preview\n\nTo apply an update that has been previewed, provide the name of the previewed deployment, and no config file:\n\n  $ update my-deployment\n\nTo specify different create, update, or delete policies, include any subset of the following flags;\n\n  $ update my-deployment --config new_config.yaml --create-policy ACQUIRE --delete-policy ABANDON\n\nTo perform an update without waiting for the operation to complete, run:\n\n  $ update my-deployment --config new_config.yaml --async\n\nTo update an existing deployment with a new config file and a fingerprint, run:\n\n  $ update my-deployment --config new_config.yaml --fingerprint deployment-fingerprint\n'}}},
                                                                                              u'flags': {},
                                                                                              u'group': True,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'deployments',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'beta',
                                                                                                        u'deployment-manager',
                                                                                                        u'deployments'],
                                                                                              u'positionals': [],
                                                                                              u'release': u'BETA',
                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Commands to create, update, delete, and examine deployments of resources.',
                                                                                                            u'EXAMPLES': u'To create a deployment, run:\n\n  $ deployments create my-deployment --config config.yaml\n\nTo update a deployment, run:\n\n  $ deployments update my-deployment --config new_config.yaml\n\nTo stop a deployment create or update in progress, run:\n\n  $ deployments stop my-deployment\n\nTo cancel a previewed create or update, run:\n\n  $ deployments cancel-preview my-deployment\n\nTo delete a deployment, run:\n\n  $ deployments delete my-deployment\n\nTo view the details of a deployment, run:\n\n  $ deployments describe my-deployment\n\nTo see the list of all deployments, run:\n\n  $ deployments list\n'}},
                                                                             u'manifests': {u'capsule': u'*(BETA)* Commands for Deployment Manager manifests.',
                                                                                            u'commands': {u'describe': {u'capsule': u'*(BETA)* Provide information about a manifest.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--deployment': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Deployment name.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--deployment',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': True,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'DEPLOYMENT'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'describe',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'beta',
                                                                                                                                  u'deployment-manager',
                                                                                                                                  u'manifests',
                                                                                                                                  u'describe'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Manifest name.',
                                                                                                                                          u'name': u'manifest',
                                                                                                                                          u'nargs': u'?',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'MANIFEST'}],
                                                                                                                        u'release': u'BETA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* This command prints out all available details about a manifest.',
                                                                                                                                      u'EXAMPLES': u'To display information about a manifest, run:\n\n  $ describe --deployment my-deployment manifest-name\n\nTo display information about the latest manifest, run:\n\n  $ describe --deployment my-deployment\n'}},
                                                                                                          u'list': {u'capsule': u'*(BETA)* List manifests in a deployment.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--deployment': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Deployment name.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--deployment',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': True,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'DEPLOYMENT'},
                                                                                                                               u'--filter': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--filter',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--limit',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                               u'--simple-list': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--simple-list',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'SIMPLE_LIST'},
                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'FIELD'},
                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'URI'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'list',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'deployment-manager',
                                                                                                                              u'manifests',
                                                                                                                              u'list'],
                                                                                                                    u'positionals': [],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Prints a table with summary information on all manifests in the deployment.',
                                                                                                                                  u'EXAMPLES': u'To print out a list of manifests in a deployment, run:\n\n  $ list --deployment my-deployment\n\nTo print only the name of each manifest, run:\n\n  $ list --deployment my-deployment --simple-list\n'}}},
                                                                                            u'flags': {},
                                                                                            u'group': True,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'manifests',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'beta',
                                                                                                      u'deployment-manager',
                                                                                                      u'manifests'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'BETA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Commands to list and examine manifests within a deployment.',
                                                                                                          u'EXAMPLES': u'To view all details about a manifest, run:\n\n  $ manifests describe manifest-name --deployment my-deployment\n\nTo see the list of all manifests in a deployment, run:\n\n  $ manifests list --deployment my-deployment\n'}},
                                                                             u'operations': {u'capsule': u'*(BETA)* Commands for Deployment Manager operations.',
                                                                                             u'commands': {u'describe': {u'capsule': u'*(BETA)* Provide information about an operation.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'describe',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'beta',
                                                                                                                                   u'deployment-manager',
                                                                                                                                   u'operations',
                                                                                                                                   u'describe'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Operation name.',
                                                                                                                                           u'name': u'operation-name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'OPERATION_NAME'}],
                                                                                                                         u'release': u'BETA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* This command prints out all available details about an operation.',
                                                                                                                                       u'EXAMPLES': u'To display information about an operation, run:\n\n  $ describe operation-name\n'}},
                                                                                                           u'list': {u'capsule': u'*(BETA)* List operations in a project.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--filter',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                                u'--limit': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--limit',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'LIMIT'},
                                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': True,
                                                                                                                                              u'description': u'',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': True,
                                                                                                                                              u'name': u'--no-uri',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'NO_URI'},
                                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--page-size',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                                u'--simple-list': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--simple-list',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'SIMPLE_LIST'},
                                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--sort-by',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'list',
                                                                                                                                               u'value': u'FIELD'},
                                                                                                                                u'--uri': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--uri',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'URI'}},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'list',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'deployment-manager',
                                                                                                                               u'operations',
                                                                                                                               u'list'],
                                                                                                                     u'positionals': [],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Prints a table with summary information on all operations in the project.',
                                                                                                                                   u'EXAMPLES': u'To print out a list of operations with some summary information about each, run:\n\n  $ list\n\nTo print only the name of each operation, run:\n\n  $ list --simple-list\n'}},
                                                                                                           u'wait': {u'capsule': u'*(BETA)* Wait for all operations specified to complete before returning.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'wait',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'deployment-manager',
                                                                                                                               u'operations',
                                                                                                                               u'wait'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Operation name.',
                                                                                                                                       u'name': u'operation-name',
                                                                                                                                       u'nargs': u'+',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'OPERATION_NAME'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Polls until all operations have finished, then prints the resulting operations\nalong with any operation errors.',
                                                                                                                                   u'EXAMPLES': u'To poll until an operation has completed, run:\n\n  $ wait operation-name\n\nTo poll until several operations have all completed, run:\n\n  $ wait operation-one operation-two operation-three\n'}}},
                                                                                             u'flags': {},
                                                                                             u'group': True,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'operations',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'beta',
                                                                                                       u'deployment-manager',
                                                                                                       u'operations'],
                                                                                             u'positionals': [],
                                                                                             u'release': u'BETA',
                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Commands to list, examine, and wait for long-running operations.',
                                                                                                           u'EXAMPLES': u'To view the details of an operation, run:\n\n  $ operations describe operation-name\n\nTo see the list of all operations, run:\n\n  $ operations list\n\nTo wait for an operation to complete, run:\n\n  $ operations wait operation-name\n'}},
                                                                             u'resources': {u'capsule': u'*(BETA)* Commands for Deployment Manager resources.',
                                                                                            u'commands': {u'describe': {u'capsule': u'*(BETA)* Provide information about a resource.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'describe',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'beta',
                                                                                                                                  u'deployment-manager',
                                                                                                                                  u'resources',
                                                                                                                                  u'describe'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Resource name.',
                                                                                                                                          u'name': u'resource',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'RESOURCE'}],
                                                                                                                        u'release': u'BETA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* This command prints out all available details about a resource.',
                                                                                                                                      u'EXAMPLES': u'To display information about a resource, run:\n\n  $ describe --deployment my-deployment my-resource-name\n'}},
                                                                                                          u'list': {u'capsule': u'*(BETA)* List resources in a deployment.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--filter',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--limit',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                               u'--simple-list': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--simple-list',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'SIMPLE_LIST'},
                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'FIELD'},
                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'URI'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'list',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'deployment-manager',
                                                                                                                              u'resources',
                                                                                                                              u'list'],
                                                                                                                    u'positionals': [],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Prints a table with summary information on all resources in the deployment.',
                                                                                                                                  u'EXAMPLES': u'To print out a list of resources in the deployment with some summary information about each, run:\n\n  $ list --deployment my-deployment\n\nTo print only the name of each resource, run:\n\n  $ list --deployment my-deployment --simple-list\n'}}},
                                                                                            u'flags': {u'--deployment': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Deployment name',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--deployment',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'DEPLOYMENT'}},
                                                                                            u'group': True,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'resources',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'beta',
                                                                                                      u'deployment-manager',
                                                                                                      u'resources'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'BETA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Commands to list and examine resources within a deployment.',
                                                                                                          u'EXAMPLES': u'To view all details about a resource, run:\n\n  $ resources describe my-resource --deployment my-deployment\n\nTo see the list of all resources in a deployment, run:\n\n  $ resources list --deployment my-deployment\n'}},
                                                                             u'types': {u'capsule': u'*(BETA)* Commands for Deployment Manager types.',
                                                                                        u'commands': {},
                                                                                        u'flags': {},
                                                                                        u'group': True,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'types',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'beta',
                                                                                                  u'deployment-manager',
                                                                                                  u'types'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'BETA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Commands to show available resource types.',
                                                                                                      u'EXAMPLES': u'To see the list of all available resource types, run:\n\n  $ types list\n'}}},
                                                               u'flags': {},
                                                               u'group': True,
                                                               u'groups': {},
                                                               u'hidden': False,
                                                               u'name': u'deployment-manager',
                                                               u'path': [u'gcloud',
                                                                         u'beta',
                                                                         u'deployment-manager'],
                                                               u'positionals': [],
                                                               u'release': u'BETA',
                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* The deployment-manager command group lets you manage the deployment of Google Cloud\nPlatform resources using Google Cloud Deployment Manager.\n\nGoogle Cloud Deployment Manager allows you to specify all the resources needed\nfor your application in a declarative format using YAML. You can also use\nPython or Jinja2 templates to parameterize the configuration and allow reuse\nof common deployment paradigms such as a load balanced, auto-scaled instance\ngroup.\n\nMore information on Cloud Deployment Manager can be found here:\nhttps://cloud.google.com/deployment-manager and detailed documentation can be\nfound here: https://cloud.google.com/deployment-manager/docs/'}},
                                       u'emulators': {u'capsule': u'*(BETA)* Set up your local development environment using emulators.',
                                                      u'commands': {u'bigtable': {u'capsule': u'*(BETA)* Manage your local Bigtable emulator.',
                                                                                  u'commands': {u'env-init': {u'capsule': u"*(BETA)* Print the commands required to export Bigtable emulator's env variables.",
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'env-init',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'emulators',
                                                                                                                        u'bigtable',
                                                                                                                        u'env-init'],
                                                                                                              u'positionals': [],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u"*(BETA)* Print the commands required to export Bigtable emulator's env variables.",
                                                                                                                            u'EXAMPLES': u'To print the env variables exports for a Bigtable emulator, run:\n\n  $ env-init\n'}},
                                                                                                u'start': {u'capsule': u'*(BETA)* Start a local Bigtable emulator.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--host-port': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The host:port to which the emulator should be bound.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--host-port',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'HOST_PORT'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'start',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'emulators',
                                                                                                                     u'bigtable',
                                                                                                                     u'start'],
                                                                                                           u'positionals': [],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* This command starts a local Bigtable emulator.',
                                                                                                                         u'EXAMPLES': u'To start a local Bigtable emulator, run:\n\n  $ start\n'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'bigtable',
                                                                                  u'path': [u'gcloud',
                                                                                            u'beta',
                                                                                            u'emulators',
                                                                                            u'bigtable'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'BETA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* This set of commands allows you to start and use a local Bigtable emulator.',
                                                                                                u'EXAMPLES': u'To start a local Bigtable emulator, run:\n\n  $ bigtable start\n'}},
                                                                    u'datastore': {u'capsule': u'*(BETA)* Manage your local datastore emulator.',
                                                                                   u'commands': {u'env-init': {u'capsule': u'*(BETA)* Print the commands required to export env variables of a datastore.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'env-init',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'emulators',
                                                                                                                         u'datastore',
                                                                                                                         u'env-init'],
                                                                                                               u'positionals': [],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Prints the commands but does not execute them. It will output\nin shell syntax or on Windows it will be in cmd.exe syntax.\n\n## EXAMPLES\n\nTo print the env variables exports for a datastore emulator, run:\n\n  $ env-init --data-dir DATA-DIR'}},
                                                                                                 u'env-unset': {u'capsule': u'*(BETA)* Print the commands required to unset a datastore emulators env variables.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'env-unset',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'emulators',
                                                                                                                          u'datastore',
                                                                                                                          u'env-unset'],
                                                                                                                u'positionals': [],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Print the commands required to unset a datastore emulators env variables.',
                                                                                                                              u'EXAMPLES': u'To print the commands necessary to unset the env variables for\na datastore emulator, run:\n\n  $ env-unset --data-dir DATA-DIR\n'}},
                                                                                                 u'start': {u'capsule': u'*(BETA)* Start a local datastore emulator.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--consistency': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': 0.9,
                                                                                                                                          u'description': u'Fraction of datastore operations that should succeed.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--consistency',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'float',
                                                                                                                                          u'value': u'CONSISTENCY'},
                                                                                                                       u'--host-port': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The host:port to which the emulator should be bound. Can take the form of a single address (hostname, IPv4, or IPv6) and port:\n+\n  ADDRESS[:PORT]\n+\nIn this format you must enclose IPv6 addresses in square brackets: e.g.\n+\n  [2001:db8:0:0:0:ff00:42:8329]:8080\n+',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--host-port',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'HOST_PORT'},
                                                                                                                       u'--no-store-on-disk': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': True,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-store-on-disk',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_STORE_ON_DISK'},
                                                                                                                       u'--store-on-disk': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'Whether data should be persisted to disk. Enabled by default, use *--no-store-on-disk* to disable.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--store-on-disk',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'STORE_ON_DISK'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'start',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'emulators',
                                                                                                                      u'datastore',
                                                                                                                      u'start'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* This command starts a local datastore emulator.',
                                                                                                                          u'EXAMPLES': u'To start a local datastore emulator, run:\n\n  $ start --data-dir DATA-DIR\n'}}},
                                                                                   u'flags': {u'--data-dir': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The directory to be used to store/retrieve data/config for an emulator run.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--data-dir',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'DATA_DIR'},
                                                                                              u'--legacy': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u'Set to use the legacy emulator which supports Cloud Datastore API v1beta2.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--legacy',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'LEGACY'},
                                                                                              u'--no-legacy': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-legacy',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_LEGACY'}},
                                                                                   u'group': True,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'datastore',
                                                                                   u'path': [u'gcloud',
                                                                                             u'beta',
                                                                                             u'emulators',
                                                                                             u'datastore'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'BETA',
                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* This set of commands allows you to start and use a local datastore emulator.',
                                                                                                 u'EXAMPLES': u'To start a local datastore emulator, run:\n\n  $ datastore start\n'}},
                                                                    u'pubsub': {u'capsule': u'*(BETA)* Manage your local pubsub emulator.',
                                                                                u'commands': {u'env-init': {u'capsule': u"*(BETA)* Print the commands required to export pubsub emulator's env variables.",
                                                                                                            u'commands': {},
                                                                                                            u'flags': {},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'env-init',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'emulators',
                                                                                                                      u'pubsub',
                                                                                                                      u'env-init'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u"*(BETA)* Print the commands required to export pubsub emulator's env variables.",
                                                                                                                          u'EXAMPLES': u'To print the env variables exports for a pubsub emulator, run:\n\n  $ env-init --data-dir DATA-DIR\n'}},
                                                                                              u'start': {u'capsule': u'*(BETA)* Start a local pubsub emulator.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--host-port': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The host:port to which the emulator should be bound.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--host-port',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'HOST_PORT'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'start',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'emulators',
                                                                                                                   u'pubsub',
                                                                                                                   u'start'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* This command starts a local pubsub emulator.',
                                                                                                                       u'EXAMPLES': u'To start a local pubsub emulator, run:\n\n  $ start --data-dir DATA-DIR\n'}}},
                                                                                u'flags': {u'--data-dir': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The directory to be used to store/retrieve data/config for an emulator run.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--data-dir',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'DATA_DIR'}},
                                                                                u'group': True,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'pubsub',
                                                                                u'path': [u'gcloud',
                                                                                          u'beta',
                                                                                          u'emulators',
                                                                                          u'pubsub'],
                                                                                u'positionals': [],
                                                                                u'release': u'BETA',
                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* This set of commands allows you to start and use a local pubsub emulator.',
                                                                                              u'EXAMPLES': u'To start a local pubsub emulator, run:\n\n  $ pubsub start\n'}}},
                                                      u'flags': {},
                                                      u'group': True,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'emulators',
                                                      u'path': [u'gcloud',
                                                                u'beta',
                                                                u'emulators'],
                                                      u'positionals': [],
                                                      u'release': u'BETA',
                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Set up your local development environment using emulators.'}},
                                       u'error-reporting': {u'capsule': u'*(BETA)* Manage Stackdriver Error Reporting.',
                                                            u'commands': {u'events': {u'capsule': u"*(BETA)* Manages your project's events data.",
                                                                                      u'commands': {u'delete': {u'capsule': u'*(BETA)* Deletes all error events of the project.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'delete',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'error-reporting',
                                                                                                                          u'events',
                                                                                                                          u'delete'],
                                                                                                                u'positionals': [],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes all error events of the project.\nAll error events which are stored for the given project are deleted and\nthe error counters are reset to zero.\n'}},
                                                                                                    u'report': {u'capsule': u'*(BETA)* Report an error.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--message': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Inline details of the error',
                                                                                                                                          u'group': u'report.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--message',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'MESSAGE'},
                                                                                                                           u'--message-file': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'File containing details of the error',
                                                                                                                                               u'group': u'report.1',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--message-file',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'MESSAGE_FILE'},
                                                                                                                           u'--service': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the service that generated the error',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--service',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'SERVICE'},
                                                                                                                           u'--service-version': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The release version of the service',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--service-version',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'SERVICE_VERSION'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {u'report.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                          u'is_mutex': True,
                                                                                                                                          u'is_required': True}},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'report',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'error-reporting',
                                                                                                                          u'events',
                                                                                                                          u'report'],
                                                                                                                u'positionals': [],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* report is used to report errors using the error-reporting service.\nThe required arguments are a service name and either an\nerror-file containing details of an error or an inline error message.\n\nGuidelines on formatting error messages can be found at\nhttps://cloud.google.com/error-reporting/docs/formatting-error-messages\n\n## EXAMPLES\n\nTo report an error, run:\n\n  $ report --service service-name --message error-message\n\nor:\n\n  $ report --service service-name --message-file error-message.ext.'}}},
                                                                                      u'flags': {},
                                                                                      u'group': True,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'events',
                                                                                      u'path': [u'gcloud',
                                                                                                u'beta',
                                                                                                u'error-reporting',
                                                                                                u'events'],
                                                                                      u'positionals': [],
                                                                                      u'release': u'BETA',
                                                                                      u'sections': {u'DESCRIPTION': u"*(BETA)* Manages your project's events data."}}},
                                                            u'flags': {},
                                                            u'group': True,
                                                            u'groups': {},
                                                            u'hidden': False,
                                                            u'name': u'error-reporting',
                                                            u'path': [u'gcloud',
                                                                      u'beta',
                                                                      u'error-reporting'],
                                                            u'positionals': [],
                                                            u'release': u'BETA',
                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Manage Stackdriver Error Reporting.'}},
                                       u'functions': {u'capsule': u'*(BETA)* Manages Google Cloud Functions.',
                                                      u'commands': {u'call': {u'capsule': u'*(BETA)* Call function synchronously for testing.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--data': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': u'',
                                                                                                     u'description': u'Data passed to the function (JSON string)',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--data',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'DATA'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'call',
                                                                              u'path': [u'gcloud',
                                                                                        u'beta',
                                                                                        u'functions',
                                                                                        u'call'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'Name of the function to be called.',
                                                                                                u'name': u'name',
                                                                                                u'nargs': u'0',
                                                                                                u'required': False,
                                                                                                u'value': u'NAME'}],
                                                                              u'release': u'BETA',
                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Call function synchronously for testing.'}},
                                                                    u'delete': {u'capsule': u'*(BETA)* Deletes a given function.',
                                                                                u'commands': {},
                                                                                u'flags': {},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'delete',
                                                                                u'path': [u'gcloud',
                                                                                          u'beta',
                                                                                          u'functions',
                                                                                          u'delete'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'The name of the function to delete.',
                                                                                                  u'name': u'name',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'NAME'}],
                                                                                u'release': u'BETA',
                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes a given function.'}},
                                                                    u'deploy': {u'capsule': u'*(BETA)* Creates a new function or updates an existing one.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--entry-point': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'By default when a Google Cloud Function is triggered, it executes a\nJavaScript function with the same name. Or, if it cannot find a\nfunction with the same name, it executes a function named `function`.\nYou can use this flag to override the default behavior, by specifying\nthe name of a JavaScript function that will be executed when the\nGoogle Cloud Function is triggered.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--entry-point',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'ENTRY_POINT'},
                                                                                           u'--include-node-modules': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'Include the content of node_modules with deployed sources. This flag has an effect only if a function is deployed from a local directory.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--include-node-modules',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'INCLUDE_NODE_MODULES'},
                                                                                           u'--local-path': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Path to local directory with source code. Required with --stage-bucket flag.',
                                                                                                             u'group': u'deploy.1',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--local-path',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'LOCAL_PATH'},
                                                                                           u'--memory': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The amount of memory allocated to your function.\n+\nAllowed values are: 128MB, 256MB, 512MB, 1024MB, and 2048MB.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--memory',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'MEMORY'},
                                                                                           u'--no-include-node-modules': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-include-node-modules',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_INCLUDE_NODE_MODULES'},
                                                                                           u'--source-branch': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The branch that will be used to get the source code of the function.  The most recent revision on this branch will be used. Can be specified only together with --source-url parameter. If not specified defaults to `master`.',
                                                                                                                u'group': u'deploy.2',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--source-branch',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'SOURCE_BRANCH'},
                                                                                           u'--source-path': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Path to directory with source code in Cloud Source Repositories, when you specify this parameter --source-url flag is required.',
                                                                                                              u'group': u'deploy.1',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--source-path',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'SOURCE_PATH'},
                                                                                           u'--source-revision': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The revision ID (for instance, git commit hash) that will be used to get the source code of the function. Can be specified only together with --source-url parameter.',
                                                                                                                  u'group': u'deploy.2',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--source-revision',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'SOURCE_REVISION'},
                                                                                           u'--source-tag': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The revision tag for the source that will be used as the source\ncode of the function. Can be specified only together with\n--source-url parameter.',
                                                                                                             u'group': u'deploy.2',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--source-tag',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'SOURCE_TAG'},
                                                                                           u'--source-url': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The Url of a remote repository that holds the function being deployed. It is of the form: https://source.developers.google.com/p/{project_id}/r/{repo_name}/, where you should substitute your data for values inside the curly brackets. You can omit "r/{repo_name}/" in which case the "default" repository is taken. One of the parameters --source-revision, --source-branch, or --source-tag can be given to specify the version in the repository. If none of them are provided, the last revision from the master branch is used. If this parameter is given, the parameter --source is required and describes the path inside the repository.',
                                                                                                             u'group': u'deploy.3',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--source-url',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'SOURCE_URL'},
                                                                                           u'--stage-bucket': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Name of Google Cloud Storage bucket in which source code will be stored. Required if a function is deployed from a local directory.',
                                                                                                               u'group': u'deploy.3',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--stage-bucket',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'STAGE_BUCKET'},
                                                                                           u'--timeout': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The function execution timeout, e.g. 30s for 30 seconds. Defaults to 60 seconds.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--timeout',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'TIMEOUT'},
                                                                                           u'--trigger-bucket': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Google Cloud Storage bucket name. Every change in files in this bucket will trigger function execution.',
                                                                                                                 u'group': u'deploy.4',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--trigger-bucket',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'TRIGGER_BUCKET'},
                                                                                           u'--trigger-event': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [u'topic.publish',
                                                                                                                             u'object.change',
                                                                                                                             u'user.create',
                                                                                                                             u'user.delete',
                                                                                                                             u'data.write'],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--trigger-event',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'EVENT_TYPE'},
                                                                                           u'--trigger-http': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'Function will be assigned an endpoint, which you can view by using\nthe `describe` command. Any HTTP request (of a supported type) to the\nendpoint will trigger function execution. Supported HTTP request\ntypes are: POST, PUT, GET, DELETE, and OPTIONS.',
                                                                                                               u'group': u'deploy.4',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--trigger-http',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'TRIGGER_HTTP'},
                                                                                           u'--trigger-provider': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [u'cloud.pubsub',
                                                                                                                                u'cloud.storage',
                                                                                                                                u'firebase.auth',
                                                                                                                                u'firebase.database'],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'deploy.4',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--trigger-provider',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'PROVIDER'},
                                                                                           u'--trigger-resource': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--trigger-resource',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'RESOURCE'},
                                                                                           u'--trigger-topic': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Name of Pub/Sub topic. Every message published in this topic will trigger function execution with message contents passed as input data.',
                                                                                                                u'group': u'deploy.4',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--trigger-topic',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'TRIGGER_TOPIC'}},
                                                                                u'group': False,
                                                                                u'groups': {u'deploy.1': {u'description': u'At most one of these may be specified:',
                                                                                                          u'is_mutex': True,
                                                                                                          u'is_required': False},
                                                                                            u'deploy.2': {u'description': u'At most one of these may be specified:',
                                                                                                          u'is_mutex': True,
                                                                                                          u'is_required': False},
                                                                                            u'deploy.3': {u'description': u'At most one of these may be specified:',
                                                                                                          u'is_mutex': True,
                                                                                                          u'is_required': False},
                                                                                            u'deploy.4': {u'description': u'Exactly one of these must be specified:',
                                                                                                          u'is_mutex': True,
                                                                                                          u'is_required': True}},
                                                                                u'hidden': False,
                                                                                u'name': u'deploy',
                                                                                u'path': [u'gcloud',
                                                                                          u'beta',
                                                                                          u'functions',
                                                                                          u'deploy'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'Intended name of the new function.',
                                                                                                  u'name': u'name',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'NAME'}],
                                                                                u'release': u'BETA',
                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Creates a new function or updates an existing one.'}},
                                                                    u'describe': {u'capsule': u'*(BETA)* Show description of a function.',
                                                                                  u'commands': {},
                                                                                  u'flags': {},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'describe',
                                                                                  u'path': [u'gcloud',
                                                                                            u'beta',
                                                                                            u'functions',
                                                                                            u'describe'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The name of the function to describe.',
                                                                                                    u'name': u'name',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAME'}],
                                                                                  u'release': u'BETA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Show description of a function.'}},
                                                                    u'event-types': {u'capsule': u'*(BETA)* Provides information about Google Cloud Functions Event Types.',
                                                                                     u'commands': {u'list': {u'capsule': u'*(BETA)* Describes the allowed values and meanings of --trigger-* flags.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'list',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'functions',
                                                                                                                       u'event-types',
                                                                                                                       u'list'],
                                                                                                             u'positionals': [],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Prints the table with list of all ways to deploy an event trigger. When using\n`gcloud functions deploy` Event Providers are specified as\n--trigger-provider and Event Types are specified as --trigger-event.\nThe table includes the type of resource expected in --trigger-resource.\n\n* For an event type, EVENT_TYPE_DEFAULT marks whether the given event type is\n  the default for its provider (in which case the --event-type flag may be\n  omitted).\n* For a resource, RESOURCE_OPTIONAL marks whether the resource has a\n  corresponding default value (in which case the --trigger-resource flag\n  may be omitted).'}}},
                                                                                     u'flags': {},
                                                                                     u'group': True,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'event-types',
                                                                                     u'path': [u'gcloud',
                                                                                               u'beta',
                                                                                               u'functions',
                                                                                               u'event-types'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'BETA',
                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Provides information about Google Cloud Functions Event Types.'}},
                                                                    u'list': {u'capsule': u'*(BETA)* Lists all the functions in a given region.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--filter',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'EXPRESSION'},
                                                                                         u'--limit': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--limit',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'LIMIT'},
                                                                                         u'--no-uri': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': True,
                                                                                                       u'description': u'',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': True,
                                                                                                       u'name': u'--no-uri',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'NO_URI'},
                                                                                         u'--page-size': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--page-size',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                         u'--sort-by': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--sort-by',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'list',
                                                                                                        u'value': u'FIELD'},
                                                                                         u'--uri': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': False,
                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--uri',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'URI'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'list',
                                                                              u'path': [u'gcloud',
                                                                                        u'beta',
                                                                                        u'functions',
                                                                                        u'list'],
                                                                              u'positionals': [],
                                                                              u'release': u'BETA',
                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all the functions in a given region.'}},
                                                                    u'logs': {u'capsule': u'*(BETA)* Manages Google Cloud Functions logs access.',
                                                                              u'commands': {u'read': {u'capsule': u'*(BETA)* Show logs produced by functions.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--end-time': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Return only log entries which timestamps are not later than the specified time. The timestamp must be in RFC3339 UTC "Zulu" format. If --end-time is specified but --start-time is not, the command returns --limit latest log entries which appeared before --end-time.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--end-time',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'END_TIME'},
                                                                                                                 u'--execution-id': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Execution ID for which logs are to be displayed.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--execution-id',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'EXECUTION_ID'},
                                                                                                                 u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': 20,
                                                                                                                              u'description': u'Number of log entries to be fetched; must not be greater than 1000.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'int',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--min-log-level': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [u'DEBUG',
                                                                                                                                                   u'INFO',
                                                                                                                                                   u'ERROR'],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Minimum level of logs to be fetched. _MIN_LOG_LEVEL_ must be one of: *DEBUG*, *INFO*, *ERROR*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--min-log-level',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'MIN_LOG_LEVEL'},
                                                                                                                 u'--no-show-execution-ids': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': True,
                                                                                                                                              u'description': u'',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': True,
                                                                                                                                              u'name': u'--no-show-execution-ids',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'NO_SHOW_EXECUTION_IDS'},
                                                                                                                 u'--no-show-function-names': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': True,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-show-function-names',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_SHOW_FUNCTION_NAMES'},
                                                                                                                 u'--no-show-log-levels': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-show-log-levels',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_SHOW_LOG_LEVELS'},
                                                                                                                 u'--no-show-timestamps': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-show-timestamps',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_SHOW_TIMESTAMPS'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--show-execution-ids': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'Print an execution ID before each log entry. Enabled by default, use *--no-show-execution-ids* to disable.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--show-execution-ids',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'SHOW_EXECUTION_IDS'},
                                                                                                                 u'--show-function-names': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'Print a function name before each log entry. Enabled by default, use *--no-show-function-names* to disable.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--show-function-names',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'SHOW_FUNCTION_NAMES'},
                                                                                                                 u'--show-log-levels': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'Print a log level of each log entry. Enabled by default, use *--no-show-log-levels* to disable.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--show-log-levels',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'SHOW_LOG_LEVELS'},
                                                                                                                 u'--show-timestamps': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'Print a UTC timestamp before each log entry. Enabled by default, use *--no-show-timestamps* to disable.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--show-timestamps',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'SHOW_TIMESTAMPS'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--start-time': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Return only log entries which timestamps are not earlier than the specified time. The timestamp must be in RFC3339 UTC "Zulu" format. If --start-time is specified, the command returns --limit earliest log entries which appeared after --start-time.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--start-time',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'START_TIME'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'read',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'functions',
                                                                                                                u'logs',
                                                                                                                u'read'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Name of the function which logs are to be displayed. If no name is specified, logs from all functions are displayed.',
                                                                                                                        u'name': u'name',
                                                                                                                        u'nargs': u'?',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'NAME'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Display log entries produced by all functions running in a region, or by a\nsingle function if it is specified through a command argument. By default,\nwhen no extra flags are specified, the most recent 20 log entries\nare displayed.'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'logs',
                                                                              u'path': [u'gcloud',
                                                                                        u'beta',
                                                                                        u'functions',
                                                                                        u'logs'],
                                                                              u'positionals': [],
                                                                              u'release': u'BETA',
                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Manages Google Cloud Functions logs access.'}},
                                                                    u'regions': {u'capsule': u'*(BETA)* Provides information about Google Cloud Functions regions.',
                                                                                 u'commands': {u'list': {u'capsule': u'*(BETA)* Returns a list of locations where functions can be deployed.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'functions',
                                                                                                                   u'regions',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Returns a list of locations where functions can be deployed.'}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'regions',
                                                                                 u'path': [u'gcloud',
                                                                                           u'beta',
                                                                                           u'functions',
                                                                                           u'regions'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'BETA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Provides information about Google Cloud Functions regions.'}}},
                                                      u'flags': {u'--region': {u'attr': {},
                                                                               u'category': u'',
                                                                               u'choices': [],
                                                                               u'completer': u'',
                                                                               u'default': u'us-central1',
                                                                               u'description': u'The compute region (e.g. us-central1) to use',
                                                                               u'group': u'',
                                                                               u'hidden': False,
                                                                               u'name': u'--region',
                                                                               u'nargs': u'0',
                                                                               u'required': False,
                                                                               u'type': u'string',
                                                                               u'value': u'REGION'}},
                                                      u'group': True,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'functions',
                                                      u'path': [u'gcloud',
                                                                u'beta',
                                                                u'functions'],
                                                      u'positionals': [],
                                                      u'release': u'BETA',
                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Manages Google Cloud Functions.'}},
                                       u'iam': {u'capsule': u'*(BETA)* Manage IAM service accounts and keys.',
                                                u'commands': {u'list-grantable-roles': {u'capsule': u'*(BETA)* List IAM grantable roles for a resource.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--filter',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'EXPRESSION'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'list-grantable-roles',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'beta',
                                                                                                  u'iam',
                                                                                                  u'list-grantable-roles'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The full resource name to get the list of roles for.',
                                                                                                          u'name': u'resource',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'RESOURCE'}],
                                                                                        u'release': u'BETA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* This command displays the list of grantable roles for a resource.\nThe resource can be referenced either via the full resource name or via a URI.\nUser can then add IAM policy bindings to grant the roles.',
                                                                                                      u'EXAMPLES': u'List grantable roles for a resource identified via full resource name:\n\n  $ list-grantable-roles //compute.googleapis.com/projects/example-project/zones/us-central1-f/instances/example-instance\n\nList grantable roles for a resource identified via URI:\n\n  $ list-grantable-roles https://www.googleapis.com/compute/v1/projects/example-project/zones/us-central1-f/instances/example-instance\n'}},
                                                              u'service-accounts': {u'capsule': u'*(BETA)* Create and manipulate service accounts.',
                                                                                    u'commands': {u'add-iam-policy-binding': {u'capsule': u'*(BETA)* Add IAM policy binding for a service account.',
                                                                                                                              u'commands': {},
                                                                                                                              u'flags': {u'--member': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The member to add to the binding.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--member',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': True,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'MEMBER'},
                                                                                                                                         u'--role': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Define the role of the member.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--role',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': True,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'ROLE'}},
                                                                                                                              u'group': False,
                                                                                                                              u'groups': {},
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'add-iam-policy-binding',
                                                                                                                              u'path': [u'gcloud',
                                                                                                                                        u'beta',
                                                                                                                                        u'iam',
                                                                                                                                        u'service-accounts',
                                                                                                                                        u'add-iam-policy-binding'],
                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The service account whose policy to add bindings to.',
                                                                                                                                                u'name': u'account',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'value': u'IAM-ACCOUNT'}],
                                                                                                                              u'release': u'BETA',
                                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* This command adds a policy binding to the IAM policy of a service account,\ngiven an IAM-ACCOUNT and the binding.',
                                                                                                                                            u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on a service account with\nidentifier 'my-iam-account@somedomain.com'\n\n  $ add-iam-policy-binding my-iam-account@somedomain.com --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                                                  u'create': {u'capsule': u'*(BETA)* Create a service account for a project.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--display-name': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A textual name to display for the account.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--display-name',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DISPLAY_NAME'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'create',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'iam',
                                                                                                                        u'service-accounts',
                                                                                                                        u'create'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The internal name of the new service account. Used to generate an IAM-ACCOUNT (an IAM internal email address used as an identifier of service account), which must be passed to subsequent commands.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* This command creates a service account with the provided name. For\nsubsequent commands regarding service accounts, this service account should be\nreferred to by the email account in the response.',
                                                                                                                            u'EXAMPLES': u'To create a service account for your project, run:\n\n  $ create some-account-name --display-name "My Service Account"\n\nTo work with this service account in subsequent IAM commands, use the\nemail resulting from this call as the IAM-ACCOUNT argument.\n'}},
                                                                                                  u'delete': {u'capsule': u'*(BETA)* Delete a service account from a project.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'delete',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'iam',
                                                                                                                        u'service-accounts',
                                                                                                                        u'delete'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The service account to delete.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'IAM-ACCOUNT'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Delete a service account from a project.',
                                                                                                                            u'EXAMPLES': u'To delete an service account from your project, run:\n\n  $ delete my-iam-account@somedomain.com\n'}},
                                                                                                  u'describe': {u'capsule': u'*(BETA)* Show metadata for a service account from a project.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'describe',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'iam',
                                                                                                                          u'service-accounts',
                                                                                                                          u'describe'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The service account to describe.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'IAM-ACCOUNT'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'This command shows metadata for a service account.\n\nThis call can fail for the following reasons:\n    * The service account specified does not exist.\n    * The active user does not have permission to access the given\n      service account.\n',
                                                                                                                              u'EXAMPLES': u'To print metadata for a service account from your project, run:\n\n  $ describe my-iam-account@somedomain.com\n'}},
                                                                                                  u'get-iam-policy': {u'capsule': u'*(BETA)* Get the IAM policy for a service account.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'get-iam-policy',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'iam',
                                                                                                                                u'service-accounts',
                                                                                                                                u'get-iam-policy'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The service account whose policy to get.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'IAM-ACCOUNT'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* This command gets the IAM policy for a service account. If formatted as\nJSON, the output can be edited and used as a policy file for\nset-iam-policy. The output includes an "etag" field identifying the version\nemitted and allowing detection of concurrent policy updates; see\n$ gcloud iam service-accounts set-iam-policy for additional details.',
                                                                                                                                    u'EXAMPLES': u'To print the IAM policy for a given service account, run:\n\n  $ get-iam-policy my-iam-account@somedomain.com\n'}},
                                                                                                  u'keys': {u'capsule': u'*(BETA)* Manage service account keys.',
                                                                                                            u'commands': {u'create': {u'capsule': u'*(BETA)* Create a private key for a service account.',
                                                                                                                                      u'commands': {},
                                                                                                                                      u'flags': {u'--iam-account': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The service account for which to create a key.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--iam-account',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': True,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'IAM_ACCOUNT'},
                                                                                                                                                 u'--key-file-type': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [u'json',
                                                                                                                                                                                   u'p12'],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': u'json',
                                                                                                                                                                      u'description': u'The type of key to create. _KEY_FILE_TYPE_ must be one of: *json*, *p12*.',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--key-file-type',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'KEY_FILE_TYPE'}},
                                                                                                                                      u'group': False,
                                                                                                                                      u'groups': {},
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'create',
                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                u'beta',
                                                                                                                                                u'iam',
                                                                                                                                                u'service-accounts',
                                                                                                                                                u'keys',
                                                                                                                                                u'create'],
                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The path where the resulting private key should be written.',
                                                                                                                                                        u'name': u'output',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'value': u'OUTPUT-FILE'}],
                                                                                                                                      u'release': u'BETA',
                                                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Create a private key for a service account.',
                                                                                                                                                    u'EXAMPLES': u'To create a new private key for a service account, and save a copy\nof it locally, run:\n\n  $ create --iam-account my-iam-account@somedomain.com key.json\n',
                                                                                                                                                    u'NOTES': u"The option --key-file-type=p12 is available here only for legacy\nreasons; all new use cases are encouraged to use the default 'json'\nformat.\n"}},
                                                                                                                          u'delete': {u'capsule': u'*(BETA)* Delete a user-managed key from a service account.',
                                                                                                                                      u'commands': {},
                                                                                                                                      u'flags': {u'--iam-account': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'The service account whose key to delete.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--iam-account',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': True,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'IAM_ACCOUNT'}},
                                                                                                                                      u'group': False,
                                                                                                                                      u'groups': {},
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'delete',
                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                u'beta',
                                                                                                                                                u'iam',
                                                                                                                                                u'service-accounts',
                                                                                                                                                u'keys',
                                                                                                                                                u'delete'],
                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The key to delete.',
                                                                                                                                                        u'name': u'key',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'value': u'KEY-ID'}],
                                                                                                                                      u'release': u'BETA',
                                                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Delete a user-managed key from a service account.'}},
                                                                                                                          u'get-public-key': {u'capsule': u'*(BETA)* Get the public key for a service account key pair.',
                                                                                                                                              u'commands': {},
                                                                                                                                              u'flags': {u'--iam-account': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'A textual name to display for the account.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--iam-account',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': True,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'IAM_ACCOUNT'},
                                                                                                                                                         u'--output-file': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': None,
                                                                                                                                                                            u'description': u'The output file to write the public key.',
                                                                                                                                                                            u'group': u'',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--output-file',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': True,
                                                                                                                                                                            u'type': u'string',
                                                                                                                                                                            u'value': u'OUTPUT_FILE'},
                                                                                                                                                         u'--type': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [u'pem',
                                                                                                                                                                                  u'raw'],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': u'pem',
                                                                                                                                                                     u'description': u'The type of the public key to get. _TYPE_ must be one of: *pem*, *raw*.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--type',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'TYPE'}},
                                                                                                                                              u'group': False,
                                                                                                                                              u'groups': {},
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'get-public-key',
                                                                                                                                              u'path': [u'gcloud',
                                                                                                                                                        u'beta',
                                                                                                                                                        u'iam',
                                                                                                                                                        u'service-accounts',
                                                                                                                                                        u'keys',
                                                                                                                                                        u'get-public-key'],
                                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'The key to get.',
                                                                                                                                                                u'name': u'key',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'value': u'KEY-ID'}],
                                                                                                                                              u'release': u'BETA',
                                                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Get the public key for a service account key pair in pem or raw format.\n\n## EXAMPLES\n\nTo get the public key for some key ID for some service account\n(to validate a blob or JWT signature, for example), run:\n\n  $ get-public-key keyid --output-file key-file --iam-account my-iam-account@ab.com'}},
                                                                                                                          u'list': {u'capsule': u'*(BETA)* List the keys for a service account.',
                                                                                                                                    u'commands': {},
                                                                                                                                    u'flags': {u'--created-before': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'Return only keys created before the specified time. Common time formats are accepted. This is equivalent to --filter="validAfterTime<DATE_TIME".',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--created-before',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'CREATED_BEFORE'},
                                                                                                                                               u'--filter': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--filter',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                                               u'--iam-account': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'A textual name to display for the account.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--iam-account',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': True,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'IAM_ACCOUNT'},
                                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--limit',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                                               u'--managed-by': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [u'user',
                                                                                                                                                                              u'system',
                                                                                                                                                                              u'any'],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': u'any',
                                                                                                                                                                 u'description': u'The types of keys to list. _MANAGED_BY_ must be one of: *user*, *system*, *any*.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--managed-by',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'MANAGED_BY'},
                                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': True,
                                                                                                                                                             u'description': u'',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': True,
                                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'bool',
                                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'list',
                                                                                                                                                              u'value': u'FIELD'},
                                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--uri',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'URI'}},
                                                                                                                                    u'group': False,
                                                                                                                                    u'groups': {},
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'list',
                                                                                                                                    u'path': [u'gcloud',
                                                                                                                                              u'beta',
                                                                                                                                              u'iam',
                                                                                                                                              u'service-accounts',
                                                                                                                                              u'keys',
                                                                                                                                              u'list'],
                                                                                                                                    u'positionals': [],
                                                                                                                                    u'release': u'BETA',
                                                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* List the keys for a service account.',
                                                                                                                                                  u'EXAMPLES': u'To list all user-managed keys created before noon on July 19th, 2015\n(to perform key rotation, for example), run:\n\n  $ list --iam-account my-iam-account@somedomain.com --managed-by user --created-before 2015-07-19T12:00:00Z\n'}}},
                                                                                                            u'flags': {},
                                                                                                            u'group': True,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'keys',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'iam',
                                                                                                                      u'service-accounts',
                                                                                                                      u'keys'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Manage service account keys.'}},
                                                                                                  u'list': {u'capsule': u"*(BETA)* List all of a project's service accounts.",
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--filter',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--limit',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'FIELD'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'list',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'iam',
                                                                                                                      u'service-accounts',
                                                                                                                      u'list'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u"*(BETA)* List all of a project's service accounts."}},
                                                                                                  u'remove-iam-policy-binding': {u'capsule': u'*(BETA)* Remove IAM policy binding for a service account.',
                                                                                                                                 u'commands': {},
                                                                                                                                 u'flags': {u'--member': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The member to remove from the binding.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--member',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': True,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'MEMBER'},
                                                                                                                                            u'--role': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The role to remove the member from.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--role',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': True,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'ROLE'}},
                                                                                                                                 u'group': False,
                                                                                                                                 u'groups': {},
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'remove-iam-policy-binding',
                                                                                                                                 u'path': [u'gcloud',
                                                                                                                                           u'beta',
                                                                                                                                           u'iam',
                                                                                                                                           u'service-accounts',
                                                                                                                                           u'remove-iam-policy-binding'],
                                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The service account whose policy to remove the binding from.',
                                                                                                                                                   u'name': u'name',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'value': u'IAM-ACCOUNT'}],
                                                                                                                                 u'release': u'BETA',
                                                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* This command removes a policy binding to the IAM policy of a service account,\ngiven an IAM-ACCOUNT and the binding.',
                                                                                                                                               u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on service account with\nidentifier 'my-iam-account@somedomain.com'\n\n  $ remove-iam-policy-binding my-iam-account@somedomain.com --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                                                  u'set-iam-policy': {u'capsule': u'*(BETA)* Set IAM policy for a service account.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'set-iam-policy',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'iam',
                                                                                                                                u'service-accounts',
                                                                                                                                u'set-iam-policy'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The service account whose policy to set.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'IAM-ACCOUNT'},
                                                                                                                                       {u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Path to a local JSON or YAML formatted file containing a valid policy.',
                                                                                                                                        u'name': u'policy-file',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'POLICY-FILE'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* This command replaces the existing IAM policy for a service account, given\nan IAM-ACCOUNT and a file encoded in JSON or YAML that contains the IAM\npolicy. If the given policy file specifies an "etag" value, then the\nreplacement will succeed only if the policy already in place matches that\netag. (An etag obtained via $ gcloud iam service-accounts get-iam-policy will\nprevent the replacement if the policy for the service account has been\nsubsequently updated.) A policy file that does not contain an etag value will\nreplace any existing policy for the service account.',
                                                                                                                                    u'EXAMPLES': u"The following command will read an IAM policy defined in a JSON file\n'policy.json' and set it for a service account with identifier 'my-iam-account@somedomain.com'\n\n  $ set-iam-policy my-iam-account@somedomain.com policy.json\n\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof the policy file format and contents."}},
                                                                                                  u'sign-blob': {u'capsule': u'*(BETA)* Sign a blob with a managed service account key.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--iam-account': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The service account to sign as.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--iam-account',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'IAM_ACCOUNT'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'sign-blob',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'iam',
                                                                                                                           u'service-accounts',
                                                                                                                           u'sign-blob'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A path to the blob file to be signed.',
                                                                                                                                   u'name': u'input',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'INPUT-FILE'},
                                                                                                                                  {u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A path the resulting signed blob will be written to.',
                                                                                                                                   u'name': u'output',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'OUTPUT-FILE'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* This command signs a file containing arbitrary binary data (a blob) using a\nsystem-managed service account key.',
                                                                                                                               u'EXAMPLES': u'To sign a blob file with a system-managed service account key,\nrun:\n\n  $ sign-blob --iam-account my-account@somedomain.com input.bin output.bin\n',
                                                                                                                               u'SEE ALSO': u'For more information on how this command ties into the wider cloud\ninfrastructure, please see\n[](https://cloud.google.com/appengine/docs/java/appidentity/)\n'}},
                                                                                                  u'sign-jwt': {u'capsule': u'*(BETA)* Sign a JWT with a managed service account key.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--iam-account': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The service account to sign as.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--iam-account',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'IAM_ACCOUNT'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'sign-jwt',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'iam',
                                                                                                                          u'service-accounts',
                                                                                                                          u'sign-jwt'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A path to the file containing the JSON JWT Claim set to be signed.',
                                                                                                                                  u'name': u'input',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'INPUT-FILE'},
                                                                                                                                 {u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A path the resulting signed JWT will be written to.',
                                                                                                                                  u'name': u'output',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'OUTPUT-FILE'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* This command signs a JWT using a system-managed service account key.\n\n## EXAMPLES:\nTo create a sign JWT with a system-managed service account key,\nrun:\n\n  $ sign-jwt --iam-account my-account@somedomain.com input.json output.jwt\n\n## SEE ALSO:\nFor more information on how this command ties into the wider cloud\ninfrastructure, please see\n[](https://cloud.google.com/appengine/docs/java/appidentity/).'}},
                                                                                                  u'update': {u'capsule': u'*(BETA)* Update the metadata of an IAM service account.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--display-name': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The new textual name to display for the account.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--display-name',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DISPLAY_NAME'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'update',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'iam',
                                                                                                                        u'service-accounts',
                                                                                                                        u'update'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The IAM service account to update.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'IAM-ACCOUNT'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Update the metadata of an IAM service account.'}}},
                                                                                    u'flags': {},
                                                                                    u'group': True,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'service-accounts',
                                                                                    u'path': [u'gcloud',
                                                                                              u'beta',
                                                                                              u'iam',
                                                                                              u'service-accounts'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'BETA',
                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Create and manipulate IAM service accounts. More information on service\naccounts can be found at:\nhttps://cloud.google.com/iam/docs/service-accounts'}}},
                                                u'flags': {},
                                                u'group': True,
                                                u'groups': {},
                                                u'hidden': False,
                                                u'name': u'iam',
                                                u'path': [u'gcloud',
                                                          u'beta',
                                                          u'iam'],
                                                u'positionals': [],
                                                u'release': u'BETA',
                                                u'sections': {u'DESCRIPTION': u'*(BETA)* The gcloud iam command group lets you manage Google Cloud Identity &\nAccess Management (IAM) service accounts and keys.\n\nCloud IAM authorizes who can take action on specific resources, giving you\nfull control and visibility to manage cloud resources centrally. For\nestablished enterprises with complex organizational structures, hundreds of\nworkgroups and potentially many more projects, Cloud IAM provides a unified\nview into security policy across your entire organization, with built-in\nauditing to ease compliance processes.\n\nMore information on Cloud IAM can be found here:\nhttps://cloud.google.com/iam and detailed documentation can be found here:\nhttps://cloud.google.com/iam/docs/'}},
                                       u'init': {u'capsule': u'*(BETA)* Initialize or reinitialize gcloud.',
                                                 u'commands': {},
                                                 u'flags': {u'--console-only': {u'attr': {},
                                                                                u'category': u'',
                                                                                u'choices': [],
                                                                                u'completer': u'',
                                                                                u'default': False,
                                                                                u'description': u'Prevent the command from launching a browser for authorization.',
                                                                                u'group': u'',
                                                                                u'hidden': False,
                                                                                u'name': u'--console-only',
                                                                                u'nargs': u'0',
                                                                                u'required': False,
                                                                                u'type': u'bool',
                                                                                u'value': u'CONSOLE_ONLY'},
                                                            u'--no-console-only': {u'attr': {},
                                                                                   u'category': u'',
                                                                                   u'choices': [],
                                                                                   u'completer': u'',
                                                                                   u'default': True,
                                                                                   u'description': u'',
                                                                                   u'group': u'',
                                                                                   u'hidden': True,
                                                                                   u'name': u'--no-console-only',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'type': u'bool',
                                                                                   u'value': u'NO_CONSOLE_ONLY'},
                                                            u'--no-skip-diagnostics': {u'attr': {},
                                                                                       u'category': u'',
                                                                                       u'choices': [],
                                                                                       u'completer': u'',
                                                                                       u'default': True,
                                                                                       u'description': u'',
                                                                                       u'group': u'',
                                                                                       u'hidden': True,
                                                                                       u'name': u'--no-skip-diagnostics',
                                                                                       u'nargs': u'0',
                                                                                       u'required': False,
                                                                                       u'type': u'bool',
                                                                                       u'value': u'NO_SKIP_DIAGNOSTICS'},
                                                            u'--skip-diagnostics': {u'attr': {},
                                                                                    u'category': u'',
                                                                                    u'choices': [],
                                                                                    u'completer': u'',
                                                                                    u'default': False,
                                                                                    u'description': u'Do not run diagnostics.',
                                                                                    u'group': u'',
                                                                                    u'hidden': False,
                                                                                    u'name': u'--skip-diagnostics',
                                                                                    u'nargs': u'0',
                                                                                    u'required': False,
                                                                                    u'type': u'bool',
                                                                                    u'value': u'SKIP_DIAGNOSTICS'}},
                                                 u'group': False,
                                                 u'groups': {},
                                                 u'hidden': False,
                                                 u'name': u'init',
                                                 u'path': [u'gcloud',
                                                           u'beta',
                                                           u'init'],
                                                 u'positionals': [{u'completer': u'',
                                                                   u'default': None,
                                                                   u'description': u'',
                                                                   u'name': u'obsolete-project-arg',
                                                                   u'nargs': u'?',
                                                                   u'required': False,
                                                                   u'value': u'OBSOLETE_PROJECT_ARG'}],
                                                 u'release': u'BETA',
                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* init launches an interactive Getting Started workflow for gcloud.\nIt performs the following setup steps:\n\n- Authorizes gcloud and other SDK tools to access Google Cloud Platform using\n  your user account credentials, or lets you select from accounts whose\n  credentials are already available.\n- Sets properties in a gcloud configuration, including the current project and\n  the default Google Compute Engine region and zone.\n\ninit can be used for initial setup of gcloud and to create new or\nreinitialize gcloud configurations. More information can be found by\nrunning `gcloud topic configurations`.\n\nProperties set by init are local and persistend, and are not affected by\nremote changes to the project. For example, the default Compute Engine zone in\nyour configuration remains stable, even if you or another user changes the\nproject-level default zone in the Cloud Platform Console.\n\nTo sync the configuration, re-run init'}},
                                       u'kms': {u'capsule': u'*(BETA)* Manage cryptographic keys in the cloud.',
                                                u'commands': {u'cryptokeys': {u'capsule': u'*(BETA)* Create and manage CryptoKeys.',
                                                                              u'commands': {u'add-iam-policy-binding': {u'capsule': u'*(BETA)* Add IAM policy binding to a CryptoKey.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--member': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The member to add to the binding.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--member',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': True,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'MEMBER'},
                                                                                                                                   u'--role': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Define the role of the member.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--role',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'ROLE'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'add-iam-policy-binding',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'beta',
                                                                                                                                  u'kms',
                                                                                                                                  u'cryptokeys',
                                                                                                                                  u'add-iam-policy-binding'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Name of the CryptoKey whose IAM policy to modify.',
                                                                                                                                          u'name': u'cryptokey',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'CRYPTOKEY'}],
                                                                                                                        u'release': u'BETA',
                                                                                                                        u'sections': {u'DESCRIPTION': u"*(BETA)* Adds IAM policy binding to the given CryptoKey.\n\nSee https://cloud.google.com/iam/docs/managing-policies for details of\npolicy role and member types.\n\n## EXAMPLES\nThe following command will add an IAM policy binding for the role of\n'roles/editor' for the user 'test-user@gmail.com' on the CryptoKey\n`frodo` with the KeyRing `fellowship` and Location `global`:\n\n  $ add-iam-policy-binding frodo \\\n--keyring fellowship \\\n--location global \\\n--member='user:test-user@gmail.com' \\\n--role='roles/editor'"}},
                                                                                            u'create': {u'capsule': u'*(BETA)* Create a new CryptoKey.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--next-rotation-time': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Next automatic rotation time of the CryptoKey.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--next-rotation-time',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'NEXT_ROTATION_TIME'},
                                                                                                                   u'--purpose': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [u'encryption'],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The "purpose" of the CryptoKey. _PURPOSE_ must be (currenly only one value is supported): *encryption*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--purpose',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PURPOSE'},
                                                                                                                   u'--rotation-period': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Automatic rotation period of the CryptoKey.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--rotation-period',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'ROTATION_PERIOD'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'create',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'kms',
                                                                                                                  u'cryptokeys',
                                                                                                                  u'create'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Name of the CryptoKey to create.',
                                                                                                                          u'name': u'cryptokey',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'CRYPTOKEY'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Creates a new CryptoKey within the given KeyRing.\n\nThe optional flags `--rotation-period` and `--next-rotation-time` define a\nrotation schedule for the CryptoKey. A schedule can also be defined\nby the `create-rotation-schedule` command.\n\nThe flag `--next-rotation-time` must be in ISO or RFC3339 format,\nand `--rotation-period` must be in the form INTEGER[UNIT], where units\ncan be one of seconds (s), minutes (m), hours (h) or days (d).\n\n## EXAMPLES\n\nThe following command creates a CryptoKey named `frodo` within the\nKeyRing `fellowship` and location `us-east1`:\n\n  $ create frodo \\\n--location us-east1 \\\n--keyring fellowship \\\n--purpose encryption\n\nThe following command creates a CryptoKey named `strider` within the\nKeyRing `rangers` and location `global` with a specified rotation\nschedule:\n\n  $ create strider \\\n--location global --keyring rangers \\\n--purpose encryption \\\n--rotation-period 30d \\\n--next-rotation-time 2017-10-12T12:34:56.1234Z'}},
                                                                                            u'describe': {u'capsule': u'*(BETA)* Get metadata for a given CryptoKey.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'describe',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'kms',
                                                                                                                    u'cryptokeys',
                                                                                                                    u'describe'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Name of the CryptoKey to describe.',
                                                                                                                            u'name': u'cryptokey',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'CRYPTOKEY'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Returns metadata for the given CryptoKey.\n\n## EXAMPLES\n\nThe following command returns metadata for the CryptoKey `frodo` within\nthe KeyRing `fellowship` in the location `us-east1`:\n\n  $ describe frodo --keyring fellowship --location us-east1'}},
                                                                                            u'get-iam-policy': {u'capsule': u'*(BETA)* Get the IAM policy for a CryptoKey.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'get-iam-policy',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'kms',
                                                                                                                          u'cryptokeys',
                                                                                                                          u'get-iam-policy'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Name of the CryptoKey whose IAM policy to fetch.',
                                                                                                                                  u'name': u'cryptokey',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'CRYPTOKEY'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Gets the IAM policy for the given CryptoKey.\n\nReturns an empty policy if the resource does not have a policy\nset.\n\n## EXAMPLES\n\nThe following command gets the IAM policy for the CryptoKey `frodo` within\nthe KeyRing `fellowship` and Location `global`:\n\n  $ get-iam-policy frodo --keyring fellowship --location global'}},
                                                                                            u'list': {u'capsule': u'*(BETA)* List the CryptoKeys within a KeyRing.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'kms',
                                                                                                                u'cryptokeys',
                                                                                                                u'list'],
                                                                                                      u'positionals': [],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all CryptoKeys within the given KeyRing.\n\n## EXAMPLES\n\nThe following command lists all CryptoKeys within the\nKeyRing `fellowship` and Location `global`:\n\n  $ list --keyring fellowship --location global'}},
                                                                                            u'remove-iam-policy-binding': {u'capsule': u'*(BETA)* Remove an IAM policy binding from a CryptoKey.',
                                                                                                                           u'commands': {},
                                                                                                                           u'flags': {u'--member': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The member to remove from the binding.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--member',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': True,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'MEMBER'},
                                                                                                                                      u'--role': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The role to remove the member from.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--role',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': True,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'ROLE'}},
                                                                                                                           u'group': False,
                                                                                                                           u'groups': {},
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'remove-iam-policy-binding',
                                                                                                                           u'path': [u'gcloud',
                                                                                                                                     u'beta',
                                                                                                                                     u'kms',
                                                                                                                                     u'cryptokeys',
                                                                                                                                     u'remove-iam-policy-binding'],
                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Name of the CryptoKey from which to remove a policy binding.',
                                                                                                                                             u'name': u'cryptokey',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'CRYPTOKEY'}],
                                                                                                                           u'release': u'BETA',
                                                                                                                           u'sections': {u'DESCRIPTION': u"*(BETA)* Removes an IAM policy binding from the given CryptoKey.\n\nSee https://cloud.google.com/iam/docs/managing-policies for details of\npolicy role and member types.\n\n## EXAMPLES\nThe following command will remove an IAM policy binding for the role of\n'roles/editor' for the user 'test-user@gmail.com' on the CryptoKey\n`frodo` with the KeyRing `fellowship` and Location `global`:\n\n  $ remove-iam-policy-binding frodo \\\n--keyring fellowship --location global \\\n--member='user:test-user@gmail.com' \\\n--role='roles/editor'"}},
                                                                                            u'remove-rotation-schedule': {u'capsule': u'*(BETA)* Remove the rotation schedule for a CryptoKey.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'remove-rotation-schedule',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'beta',
                                                                                                                                    u'kms',
                                                                                                                                    u'cryptokeys',
                                                                                                                                    u'remove-rotation-schedule'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Name of the CryptoKey from which to clear the rotation schedule.',
                                                                                                                                            u'name': u'cryptokey',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'CRYPTOKEY'}],
                                                                                                                          u'release': u'BETA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Removes the rotation schedule for the the given CryptoKey.\n\n## EXAMPLES\n\nThe following command removes the rotation schedule for the CryptoKey\nnamed `frodo` within the KeyRing `fellowship` and location `global`:\n\n  $ remove-rotation-schedule frodo \\\n--location global \\\n--keyring fellowship'}},
                                                                                            u'set-iam-policy': {u'capsule': u'*(BETA)* Set the IAM policy for a CryptoKey.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'set-iam-policy',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'kms',
                                                                                                                          u'cryptokeys',
                                                                                                                          u'set-iam-policy'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Name of the CryptoKey whose IAM policy to update.',
                                                                                                                                  u'name': u'cryptokey',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'CRYPTOKEY'},
                                                                                                                                 {u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'JSON file with the IAM policy',
                                                                                                                                  u'name': u'policy-file',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'POLICY_FILE'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u"*(BETA)* Sets the IAM policy for the given CryptoKey as defined in a JSON file.\n\nSee https://cloud.google.com/iam/docs/managing-policies for details of\nthe policy file format and contents.\n\n## EXAMPLES\nThe following command will read am IAM policy defined in a JSON file\n'policy.json' and set it for the CryptoKey `frodo` with the KeyRing\n`fellowship` and Location `global`:\n\n  $ set-iam-policy frodo policy.json --keyring fellowship --location global"}},
                                                                                            u'set-primary-version': {u'capsule': u'*(BETA)* Set the primary version of a CryptoKey.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'set-primary-version',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'kms',
                                                                                                                               u'cryptokeys',
                                                                                                                               u'set-primary-version'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Name of the CryptoKey to modify.',
                                                                                                                                       u'name': u'cryptokey',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'CRYPTOKEY'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Sets the specified CryptoKeyVersion as the primary version of the\ngiven CryptoKey.\nThe CryptoKeyVersion is specified by its version number assigned on creation.\n\n## EXAMPLES\n\nThe following command sets version 9 as the primary version of the\nCryptoKey `samwise` within KeyRing `fellowship` and location `global`:\n\n  $ set-primary-version samwise --version 9 --keyring fellowship --location global'}},
                                                                                            u'set-rotation-schedule': {u'capsule': u'*(BETA)* Update the rotation schedule for a CryptoKey.',
                                                                                                                       u'commands': {},
                                                                                                                       u'flags': {u'--next-rotation-time': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Next automatic rotation time of the CryptoKey.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--next-rotation-time',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'NEXT_ROTATION_TIME'},
                                                                                                                                  u'--rotation-period': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Automatic rotation period of the CryptoKey.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--rotation-period',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'ROTATION_PERIOD'}},
                                                                                                                       u'group': False,
                                                                                                                       u'groups': {},
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'set-rotation-schedule',
                                                                                                                       u'path': [u'gcloud',
                                                                                                                                 u'beta',
                                                                                                                                 u'kms',
                                                                                                                                 u'cryptokeys',
                                                                                                                                 u'set-rotation-schedule'],
                                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Name of the CryptoKey to update the schedule of.',
                                                                                                                                         u'name': u'cryptokey',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'value': u'CRYPTOKEY'}],
                                                                                                                       u'release': u'BETA',
                                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Updates the rotation schedule for the the given CryptoKey. The schedule\nautomatically creates a new primary CryptoKeyVersion for the CryptoKey\naccording to the `--next-rotation-time` and `--rotation-period` flags.\n\nThe flag `--next-rotation-time` must be in ISO or RFC3339 format,\nand `--rotation-period` must be in the form INTEGER[UNIT], where units\ncan be one of seconds (s), minutes (m), hours (h) or days (d).\n\nKey rotations performed manually via `update-primary-version` and the\nCryptoKeyVersion `create` do not affect the stored `--next-rotation-time`.\n\n## EXAMPLES\n\nThe following command sets a 30 day rotation period for the CryptoKey\nnamed `frodo` within the KeyRing `fellowship` and location `global`\nstarting at the specified time:\n\n  $ set-rotation-schedule frodo \\\n--location global \\\n--keyring fellowship \\\n--rotation-period 30d \\\n--next-rotation-time 2017-10-12T12:34:56.1234Z'}},
                                                                                            u'versions': {u'capsule': u'*(BETA)* Create and manage CryptoKeyVersions.',
                                                                                                          u'commands': {u'create': {u'capsule': u'*(BETA)* Create a new CryptoKeyVersion.',
                                                                                                                                    u'commands': {},
                                                                                                                                    u'flags': {u'--no-primary': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': True,
                                                                                                                                                                 u'description': u'',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': True,
                                                                                                                                                                 u'name': u'--no-primary',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'bool',
                                                                                                                                                                 u'value': u'NO_PRIMARY'},
                                                                                                                                               u'--primary': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': False,
                                                                                                                                                              u'description': u'If specified, immediately make the new version primary.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--primary',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'bool',
                                                                                                                                                              u'value': u'PRIMARY'}},
                                                                                                                                    u'group': False,
                                                                                                                                    u'groups': {},
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'create',
                                                                                                                                    u'path': [u'gcloud',
                                                                                                                                              u'beta',
                                                                                                                                              u'kms',
                                                                                                                                              u'cryptokeys',
                                                                                                                                              u'versions',
                                                                                                                                              u'create'],
                                                                                                                                    u'positionals': [],
                                                                                                                                    u'release': u'BETA',
                                                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Creates a new CryptoKeyVersion within the given CryptoKey.\n\n## EXAMPLES\n\nThe following command creates a new CryptoKeyVersion within the `frodo`\nCryptoKey, `fellowship` KeyRing, and `global` Location and sets it as\nthe primary version:\n\n  $ create --location global \\\n--keyring fellowship \\\n--cryptokey frodo --primary'}},
                                                                                                                        u'describe': {u'capsule': u'*(BETA)* Get metadata for a given CryptoKeyVersion.',
                                                                                                                                      u'commands': {},
                                                                                                                                      u'flags': {},
                                                                                                                                      u'group': False,
                                                                                                                                      u'groups': {},
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'describe',
                                                                                                                                      u'path': [u'gcloud',
                                                                                                                                                u'beta',
                                                                                                                                                u'kms',
                                                                                                                                                u'cryptokeys',
                                                                                                                                                u'versions',
                                                                                                                                                u'describe'],
                                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Name of the CryptoKeyVersion to describe.',
                                                                                                                                                        u'name': u'version',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'value': u'VERSION'}],
                                                                                                                                      u'release': u'BETA',
                                                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Returns metadata for the given CryptoKeyVersion.\n\n## EXAMPLES\n\nThe following command returns metadata for version 2 within CryptoKey `frodo`\nwithin the KeyRing `fellowship` in the location `us-east1`:\n\n  $ describe 2 --cryptokey frodo --keyring fellowship --location us-east1'}},
                                                                                                                        u'destroy': {u'capsule': u'*(BETA)* Schedule a CryptoKeyVersion to be destroyed.',
                                                                                                                                     u'commands': {},
                                                                                                                                     u'flags': {},
                                                                                                                                     u'group': False,
                                                                                                                                     u'groups': {},
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'destroy',
                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                               u'beta',
                                                                                                                                               u'kms',
                                                                                                                                               u'cryptokeys',
                                                                                                                                               u'versions',
                                                                                                                                               u'destroy'],
                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Name of the CryptoKeyVersion to destroy.',
                                                                                                                                                       u'name': u'version',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'value': u'VERSION'}],
                                                                                                                                     u'release': u'BETA',
                                                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Schedules the given CryptoKeyVersion for destruction in 24 hours.\n\nAfter that time period passes it is automatically destroyed. Once\ndestroyed, the key material is removed but the version number can\nnot be reused.\n\nOnly CryptoKeyVersions which are Enabled or Disabled can be Scheduled\nfor destruction.\n\n## EXAMPLES\n\nThe following command schedules version 9 of CryptoKey `frodo` within\nKeyRing `fellowship` and Location `us-east1` for destruction:\n\n  $ destroy 9 --location us-east1 --keyring fellowship --cryptokey frodo'}},
                                                                                                                        u'disable': {u'capsule': u'*(BETA)* Disable a given CryptoKeyVersion.',
                                                                                                                                     u'commands': {},
                                                                                                                                     u'flags': {},
                                                                                                                                     u'group': False,
                                                                                                                                     u'groups': {},
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'disable',
                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                               u'beta',
                                                                                                                                               u'kms',
                                                                                                                                               u'cryptokeys',
                                                                                                                                               u'versions',
                                                                                                                                               u'disable'],
                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Name of the CryptoKeyVersion to disable.',
                                                                                                                                                       u'name': u'version',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'value': u'VERSION'}],
                                                                                                                                     u'release': u'BETA',
                                                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Disables the specified CryptoKeyVersion within the given CryptoKey.\n\nOnly a CryptoKeyVersion which is Enabled can be Disabled.\n\n## EXAMPLES\n\nThe following command disables version 3 of CryptoKey `frodo` within\nKeyRing `fellowship` and Location `us-east1`:\n\n  $ disable 3 --location us-east1 --keyring fellowship --cryptokey frodo'}},
                                                                                                                        u'enable': {u'capsule': u'*(BETA)* Enable a given CryptoKeyVersion.',
                                                                                                                                    u'commands': {},
                                                                                                                                    u'flags': {},
                                                                                                                                    u'group': False,
                                                                                                                                    u'groups': {},
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'enable',
                                                                                                                                    u'path': [u'gcloud',
                                                                                                                                              u'beta',
                                                                                                                                              u'kms',
                                                                                                                                              u'cryptokeys',
                                                                                                                                              u'versions',
                                                                                                                                              u'enable'],
                                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Name of the CryptoKeyVersion to enable.',
                                                                                                                                                      u'name': u'version',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'value': u'VERSION'}],
                                                                                                                                    u'release': u'BETA',
                                                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Enables the specified CryptoKeyVersion within the given CryptoKey.\n\nOnly a CryptoKeyVersion which is Disabled can be Enabled.\n\n## EXAMPLES\n\nThe following command enables version 3 of CryptoKey `frodo` within\nKeyRing `fellowship` and Location `us-east1`:\n\n  $ enable 3 --location us-east1 --keyring fellowship --cryptokey frodo'}},
                                                                                                                        u'list': {u'capsule': u'*(BETA)* List the versions within a CryptoKey.',
                                                                                                                                  u'commands': {},
                                                                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--filter',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'EXPRESSION'},
                                                                                                                                             u'--limit': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--limit',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'LIMIT'},
                                                                                                                                             u'--no-uri': {u'attr': {},
                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': True,
                                                                                                                                                           u'description': u'',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': True,
                                                                                                                                                           u'name': u'--no-uri',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'bool',
                                                                                                                                                           u'value': u'NO_URI'},
                                                                                                                                             u'--page-size': {u'attr': {},
                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--page-size',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                                                                             u'--sort-by': {u'attr': {},
                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--sort-by',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'list',
                                                                                                                                                            u'value': u'FIELD'},
                                                                                                                                             u'--uri': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': False,
                                                                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--uri',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'URI'}},
                                                                                                                                  u'group': False,
                                                                                                                                  u'groups': {},
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'list',
                                                                                                                                  u'path': [u'gcloud',
                                                                                                                                            u'beta',
                                                                                                                                            u'kms',
                                                                                                                                            u'cryptokeys',
                                                                                                                                            u'versions',
                                                                                                                                            u'list'],
                                                                                                                                  u'positionals': [],
                                                                                                                                  u'release': u'BETA',
                                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all of the CryptoKeyVersions within the given CryptoKey.\n\n## EXAMPLES\n\nThe following command lists all CryptoKeyVersions within the\nCryptoKey `frodo`, KeyRing `fellowship`, and Location `global`:\n\n  $ list --location global \\\n--keyring fellowship \\\n--cryptokey frodo'}},
                                                                                                                        u'restore': {u'capsule': u'*(BETA)* Restore a CryptoKeyVersion scheduled for destruction.',
                                                                                                                                     u'commands': {},
                                                                                                                                     u'flags': {},
                                                                                                                                     u'group': False,
                                                                                                                                     u'groups': {},
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'restore',
                                                                                                                                     u'path': [u'gcloud',
                                                                                                                                               u'beta',
                                                                                                                                               u'kms',
                                                                                                                                               u'cryptokeys',
                                                                                                                                               u'versions',
                                                                                                                                               u'restore'],
                                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Name of the CryptoKeyVersion to restore.',
                                                                                                                                                       u'name': u'version',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'value': u'VERSION'}],
                                                                                                                                     u'release': u'BETA',
                                                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Restores the given CryptoKeyVersion that was scheduled to be destroyed.\n\nThis moves the CryptoKeyVersion from Scheduled for destruction to Disabled.\nOnly CryptoKeyVersions which are Scheduled for destruction can be Restored.\n\n## EXAMPLES\n\nThe following command restores version 9 of CryptoKey `frodo` within\nKeyRing `fellowship` and Location `us-east1` which was previously scheduled\nfor destruction:\n\n  $ restore 9 --location us-east1 --keyring fellowship --cryptokey frodo'}}},
                                                                                                          u'flags': {u'--cryptokey': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The containing CryptoKey.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--cryptokey',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'CRYPTOKEY'}},
                                                                                                          u'group': True,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'versions',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'kms',
                                                                                                                    u'cryptokeys',
                                                                                                                    u'versions'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* A CryptoKeyVersion represents an individual cryptographic key and the\nassociated key material.'}}},
                                                                              u'flags': {u'--keyring': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The containing KeyRing.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--keyring',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'KEYRING'},
                                                                                         u'--location': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The location of the requested resource.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--location',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'LOCATION'}},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'cryptokeys',
                                                                              u'path': [u'gcloud',
                                                                                        u'beta',
                                                                                        u'kms',
                                                                                        u'cryptokeys'],
                                                                              u'positionals': [],
                                                                              u'release': u'BETA',
                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* A CryptoKey represents a logical key that can be used for cryptographic\noperations.'}},
                                                              u'keyrings': {u'capsule': u'*(BETA)* Create and manage KeyRings.',
                                                                            u'commands': {u'add-iam-policy-binding': {u'capsule': u'*(BETA)* Add IAM policy binding to a KeyRing.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--member': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The member to add to the binding.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--member',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'MEMBER'},
                                                                                                                                 u'--role': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Define the role of the member.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--role',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': True,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ROLE'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'add-iam-policy-binding',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'kms',
                                                                                                                                u'keyrings',
                                                                                                                                u'add-iam-policy-binding'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Name of the KeyRing whose IAM policy to modify.',
                                                                                                                                        u'name': u'keyring',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'KEYRING'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u"*(BETA)* Adds IAM policy binding to the given KeyRing.\n\nSee https://cloud.google.com/iam/docs/managing-policies for details of\npolicy role and member types.\n\n## EXAMPLES\nThe following command will add an IAM policy binding for the role of\n'roles/editor' for the user 'test-user@gmail.com' on the KeyRing\n`fellowship` with Location `global`:\n\n  $ add-iam-policy-binding fellowship --location global \\\n--member='user:test-user@gmail.com' \\\n--role='roles/editor'"}},
                                                                                          u'create': {u'capsule': u'*(BETA)* Create a new KeyRing.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'create',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'kms',
                                                                                                                u'keyrings',
                                                                                                                u'create'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Name of the KeyRing to create.',
                                                                                                                        u'name': u'keyring',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'KEYRING'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Creates a new KeyRing within the given Location.\n\n## Examples\n\nThe following command creates a KeyRing named `fellowship` within the\nLocation `global`:\n\n  $ create fellowship --location global'}},
                                                                                          u'describe': {u'capsule': u'*(BETA)* Get metadata for a KeyRing.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'describe',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'kms',
                                                                                                                  u'keyrings',
                                                                                                                  u'describe'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Name of the KeyRing to describe.',
                                                                                                                          u'name': u'keyring',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'KEYRING'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Returns metadata for the given KeyRing.\n\n## EXAMPLES\n\nThe following command returns the metadata for the KeyRing `towers`\nin the location `us-east1`:\n\n  $ describe towers --location us-east1'}},
                                                                                          u'get-iam-policy': {u'capsule': u'*(BETA)* Get the IAM policy for a KeyRing.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'get-iam-policy',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'kms',
                                                                                                                        u'keyrings',
                                                                                                                        u'get-iam-policy'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Name of the KeyRing whose IAM policy to fetch.',
                                                                                                                                u'name': u'keyring',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'KEYRING'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Gets the IAM policy for the given KeyRing.\n\nReturns an empty policy if the resource does not have a policy set.\n\n## EXAMPLES\n\nThe following command gets the IAM policy for the KeyRing `fellowship`\nwithin the location `us-central1`:\n\n  $ get-iam-policy fellowship --location us-central1'}},
                                                                                          u'list': {u'capsule': u'*(BETA)* List KeyRings within a Location.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--filter',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                               u'--limit': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--limit',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'LIMIT'},
                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': True,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-uri',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_URI'},
                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--page-size',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--sort-by',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'FIELD'},
                                                                                                               u'--uri': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--uri',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'URI'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'list',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'beta',
                                                                                                              u'kms',
                                                                                                              u'keyrings',
                                                                                                              u'list'],
                                                                                                    u'positionals': [],
                                                                                                    u'release': u'BETA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all KeyRings within the given Location.\n\n## EXAMPLES\n\nThe following command lists a maximum of five KeyRings in the Location\n`global`:\n\n  $ list --location global --limit=5'}},
                                                                                          u'remove-iam-policy-binding': {u'capsule': u'*(BETA)* Remove a policy binding from a KeyRing.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--member': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The member to remove from the binding.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--member',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': True,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'MEMBER'},
                                                                                                                                    u'--role': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The role to remove the member from.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--role',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': True,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'ROLE'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'remove-iam-policy-binding',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'beta',
                                                                                                                                   u'kms',
                                                                                                                                   u'keyrings',
                                                                                                                                   u'remove-iam-policy-binding'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Name of the KeyRing from which to remove an IAM policy binding.',
                                                                                                                                           u'name': u'keyring',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'KEYRING'}],
                                                                                                                         u'release': u'BETA',
                                                                                                                         u'sections': {u'DESCRIPTION': u"*(BETA)* Removes an IAM policy binding from the given KeyRing.\n\nSee https://cloud.google.com/iam/docs/managing-policies for details of\npolicy role and member types.\n\n## EXAMPLES\nThe following command will remove an IAM policy binding for the role of\n'roles/editor' for the user 'test-user@gmail.com' on the KeyRing\n`fellowship` with Location `global`:\n\n  $ remove-iam-policy-binding fellowship --location global \\\n--member='user:test-user@gmail.com' \\\n--role='roles/editor'"}},
                                                                                          u'set-iam-policy': {u'capsule': u'*(BETA)* Set the IAM policy for a KeyRing.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'set-iam-policy',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'kms',
                                                                                                                        u'keyrings',
                                                                                                                        u'set-iam-policy'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Name of the KeyRing whose IAM policy to update.',
                                                                                                                                u'name': u'keyring',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'KEYRING'},
                                                                                                                               {u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'JSON file with the IAM policy',
                                                                                                                                u'name': u'policy-file',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'POLICY_FILE'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u"*(BETA)* Sets the IAM policy for the given CryptoKey as defined in a JSON file.\n\nSee https://cloud.google.com/iam/docs/managing-policies for details of\nthe policy file format and contents.\n\n## EXAMPLES\nThe following command will read am IAM policy defined in a JSON file\n'policy.json' and set it for the KeyRing `fellowship` with Location `global`:\n\n  $ set-iam-policy fellowship policy.json --location global"}}},
                                                                            u'flags': {u'--location': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The location of the requested resource.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--location',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'LOCATION'}},
                                                                            u'group': True,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'keyrings',
                                                                            u'path': [u'gcloud',
                                                                                      u'beta',
                                                                                      u'kms',
                                                                                      u'keyrings'],
                                                                            u'positionals': [],
                                                                            u'release': u'BETA',
                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* A KeyRings is a toplevel logical grouping of CryptoKeys.'}},
                                                              u'locations': {u'capsule': u'*(BETA)* View locations available for a project.',
                                                                             u'commands': {u'list': {u'capsule': u"*(BETA)* List the project's locations.",
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'kms',
                                                                                                               u'locations',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all locations available for this project.'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'locations',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'kms',
                                                                                       u'locations'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* View locations available for a project.'}}},
                                                u'flags': {},
                                                u'group': True,
                                                u'groups': {},
                                                u'hidden': False,
                                                u'name': u'kms',
                                                u'path': [u'gcloud',
                                                          u'beta',
                                                          u'kms'],
                                                u'positionals': [],
                                                u'release': u'BETA',
                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Manage cryptographic keys in the cloud.'}},
                                       u'logging': {u'capsule': u'*(BETA)* Manage Stackdriver Logging.',
                                                    u'commands': {u'logs': {u'capsule': u"*(BETA)* Manages your project's logs.",
                                                                            u'commands': {u'delete': {u'capsule': u'*(BETA)* Deletes all entries from a log.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'delete',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'logging',
                                                                                                                u'logs',
                                                                                                                u'delete'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Log name.',
                                                                                                                        u'name': u'log-name',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'LOG_NAME'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u"*(BETA)* Deletes all entries from a log.\nWith no entries, the log will not appear in the list of your\nproject's logs. However, you can write new entries to the log.\n"}},
                                                                                          u'list': {u'capsule': u"*(BETA)* Lists your project's logs.",
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--filter',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                               u'--limit': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--limit',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'LIMIT'},
                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--sort-by',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'FIELD'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'list',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'beta',
                                                                                                              u'logging',
                                                                                                              u'logs',
                                                                                                              u'list'],
                                                                                                    u'positionals': [],
                                                                                                    u'release': u'BETA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Only logs that contain log entries are listed.'}}},
                                                                            u'flags': {},
                                                                            u'group': True,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'logs',
                                                                            u'path': [u'gcloud',
                                                                                      u'beta',
                                                                                      u'logging',
                                                                                      u'logs'],
                                                                            u'positionals': [],
                                                                            u'release': u'BETA',
                                                                            u'sections': {u'DESCRIPTION': u"*(BETA)* Manages your project's logs."}},
                                                                  u'metrics': {u'capsule': u'*(BETA)* Manages logs-based metrics.',
                                                                               u'commands': {u'create': {u'capsule': u'*(BETA)* Creates a logs-based metric.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--description': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The metric's description.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--description',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                    u'--log-filter': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The metric's filter expression. The filter must be for a V2 LogEntry.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--log-filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'LOG_FILTER'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'create',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'logging',
                                                                                                                   u'metrics',
                                                                                                                   u'create'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the new metric.',
                                                                                                                           u'name': u'metric-name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'METRIC_NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'Creates a logs-based metric to count the number of log entries that\nmatch a filter expression.\nWhen creating a metric, the filter expression must not be empty.\n',
                                                                                                                       u'EXAMPLES': u'To create a metric that counts the number of log entries with a\nseverity level higher than WARNING, run:\n\n  $ create high_severity_count --description="Number of high severity log entries" --log-filter="severity > WARNING"\n\nDetailed information about filters can be found at:\n[](https://cloud.google.com/logging/docs/view/advanced_filters)\n'}},
                                                                                             u'delete': {u'capsule': u'*(BETA)* Deletes a logs-based metric.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'delete',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'logging',
                                                                                                                   u'metrics',
                                                                                                                   u'delete'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the metric to delete.',
                                                                                                                           u'name': u'metric-name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'METRIC_NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'Deletes a logs-based metric called high_severity_count.\n',
                                                                                                                       u'EXAMPLES': u'To delete a metric called high_severity_count, run:\n\n  $ delete high_severity_count\n'}},
                                                                                             u'describe': {u'capsule': u'*(BETA)* Shows the definition of a logs-based metric.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'describe',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'logging',
                                                                                                                     u'metrics',
                                                                                                                     u'describe'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the metric.',
                                                                                                                             u'name': u'metric-name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'METRIC_NAME'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'Shows the definition of a logs-based metric.\n',
                                                                                                                         u'EXAMPLES': u'To show the definition of a metric called high_severity_count, run:\n\n  $ describe high_severity_count\n'}},
                                                                                             u'list': {u'capsule': u'*(BETA)* Displays all logs-based metrics.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--filter',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'EXPRESSION'},
                                                                                                                  u'--limit': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--limit',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'LIMIT'},
                                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--sort-by',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FIELD'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'list',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'logging',
                                                                                                                 u'metrics',
                                                                                                                 u'list'],
                                                                                                       u'positionals': [],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'Lists all logs-based metrics.\n',
                                                                                                                     u'EXAMPLES': u'$ list --limit=10\n'}},
                                                                                             u'update': {u'capsule': u'*(BETA)* Updates the definition of a logs-based metric.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--description': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'A new description for the metric. If omitted, the description is not changed.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--description',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                                    u'--log-filter': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'A new filter string for the metric. If omitted, the filter is not changed.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--log-filter',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'LOG_FILTER'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'update',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'logging',
                                                                                                                   u'metrics',
                                                                                                                   u'update'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the log-based metric to update.',
                                                                                                                           u'name': u'metric-name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'METRIC_NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'Updates the description or the filter expression of an existing\nlogs-based metric.\n',
                                                                                                                       u'EXAMPLES': u'To update the description of a metric called high_severity_count, run:\n\n  $ update high_severity_count --description="Count of high-severity log entries."\n\nTo update the filter expression of the metric, run:\n\n  $ update high_severity_count --log-filter="severity >= WARNING"\n\nDetailed information about filters can be found at:\n[](https://cloud.google.com/logging/docs/view/advanced_filters)\n'}}},
                                                                               u'flags': {},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'metrics',
                                                                               u'path': [u'gcloud',
                                                                                         u'beta',
                                                                                         u'logging',
                                                                                         u'metrics'],
                                                                               u'positionals': [],
                                                                               u'release': u'BETA',
                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Manages logs-based metrics.'}},
                                                                  u'read': {u'capsule': u'*(BETA)* Reads log entries.',
                                                                            u'commands': {},
                                                                            u'flags': {u'--billing-account': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Read log entries associated with this billing account.',
                                                                                                              u'group': u'read.1',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--billing-account',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'BILLING_ACCOUNT_ID'},
                                                                                       u'--folder': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Read log entries associated with this folder.',
                                                                                                     u'group': u'read.1',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--folder',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'FOLDER_ID'},
                                                                                       u'--freshness': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': u'1d',
                                                                                                        u'description': u'Return entries that are not older than this value. Works only with DESC ordering and filters without a timestamp.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--freshness',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'FRESHNESS'},
                                                                                       u'--limit': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--limit',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'LIMIT'},
                                                                                       u'--order': {u'attr': {},
                                                                                                    u'category': u'',
                                                                                                    u'choices': [u'DESC',
                                                                                                                 u'ASC'],
                                                                                                    u'completer': u'',
                                                                                                    u'default': u'DESC',
                                                                                                    u'description': u'Ordering of returned log entries based on timestamp field. _ORDER_ must be one of: *DESC*, *ASC*.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--order',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'ORDER'},
                                                                                       u'--organization': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Read log entries associated with this organization.',
                                                                                                           u'group': u'read.1',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--organization',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'ORGANIZATION_ID'}},
                                                                            u'group': False,
                                                                            u'groups': {u'read.1': {u'description': u'At most one of these may be specified:',
                                                                                                    u'is_mutex': True,
                                                                                                    u'is_required': False}},
                                                                            u'hidden': False,
                                                                            u'name': u'read',
                                                                            u'path': [u'gcloud',
                                                                                      u'beta',
                                                                                      u'logging',
                                                                                      u'read'],
                                                                            u'positionals': [{u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u'A filter expression that specifies the log entries to return.',
                                                                                              u'name': u'log-filter',
                                                                                              u'nargs': u'?',
                                                                                              u'required': False,
                                                                                              u'value': u'LOG_FILTER'}],
                                                                            u'release': u'BETA',
                                                                            u'sections': {u'DESCRIPTION': u'Reads log entries.  Log entries matching *log-filter* are returned in\norder of decreasing timestamps, most-recent entries first.  If the log\nentries come from multiple logs, then entries from different logs\nmight be intermingled in the results.\n',
                                                                                          u'EXAMPLES': u'To read log entries from Google Compute Engine instances, run:\n\n  $ read "resource.type=gce_instance"\n\nTo read log entries with severity ERROR or higher, run:\n\n  $ read "severity>=ERROR"\n\nTo read log entries written in a specific time window, run:\n\n  $ read \'timestamp<="2015-05-31T23:59:59Z" AND timestamp>="2015-05-31T00:00:00Z"\'\n\nDetailed information about filters can be found at:\n[](https://cloud.google.com/logging/docs/view/advanced_filters)\n'}},
                                                                  u'resource-descriptors': {u'capsule': u'*(BETA)* Get information about resource descriptors.',
                                                                                            u'commands': {u'list': {u'capsule': u'*(BETA)* Lists all available resource descriptors.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--filter',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--limit',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'FIELD'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'list',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'logging',
                                                                                                                              u'resource-descriptors',
                                                                                                                              u'list'],
                                                                                                                    u'positionals': [],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'Lists all available resource descriptors that are used by Stackdriver\nLogging. Each log entry must be associated with a valid resource\ndescriptor.\n'}}},
                                                                                            u'flags': {},
                                                                                            u'group': True,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'resource-descriptors',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'beta',
                                                                                                      u'logging',
                                                                                                      u'resource-descriptors'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'BETA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Get information about resource descriptors.'}},
                                                                  u'sinks': {u'capsule': u'*(BETA)* Manages sinks used to export logs.',
                                                                             u'commands': {u'create': {u'capsule': u'*(BETA)* Creates a sink.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--billing-account': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Create a sink associated with this billing account.',
                                                                                                                                         u'group': u'create.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--billing-account',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'BILLING_ACCOUNT_ID'},
                                                                                                                  u'--folder': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Create a sink associated with this folder.',
                                                                                                                                u'group': u'create.1',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--folder',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'FOLDER_ID'},
                                                                                                                  u'--log-filter': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'A filter expression for the sink. If present, the filter specifies which log entries to export.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--log-filter',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LOG_FILTER'},
                                                                                                                  u'--no-unique-writer-identity': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': True,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-unique-writer-identity',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_UNIQUE_WRITER_IDENTITY'},
                                                                                                                  u'--organization': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Create a sink associated with this organization.',
                                                                                                                                      u'group': u'create.1',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--organization',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ORGANIZATION_ID'},
                                                                                                                  u'--output-version-format': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [u'V1',
                                                                                                                                                            u'V2'],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': u'V1',
                                                                                                                                               u'description': u'DEPRECATED. Format of the log entries being exported. Detailed information: https://cloud.google.com/logging/docs/api/introduction_v2. _OUTPUT_VERSION_FORMAT_ must be one of: *V1*, *V2*.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--output-version-format',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'OUTPUT_VERSION_FORMAT'},
                                                                                                                  u'--unique-writer-identity': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'DEPRECATED. Whether to create a new writer identity for this sink. Only available for v2 sinks. Enabled by default, use *--no-unique-writer-identity* to disable.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--unique-writer-identity',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'UNIQUE_WRITER_IDENTITY'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                 u'is_mutex': True,
                                                                                                                                 u'is_required': False}},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'create',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'logging',
                                                                                                                 u'sinks',
                                                                                                                 u'create'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The name for the sink.',
                                                                                                                         u'name': u'sink-name',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'SINK_NAME'},
                                                                                                                        {u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The destination for the sink.',
                                                                                                                         u'name': u'destination',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'DESTINATION'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'Creates a sink used to export entries from one or more logs to\na destination.\nA "log" sink exports a single log, specified by the *--log* flag.\nA "log service" sink exports all logs from a log service,\nspecified by the *--log-service* flag.\nIf you don\'t include one of the *--log* or *--log-service* flags,\nthis command creates a "v2" sink.\nA "v2" sink exports all logs that matches *--log-filter* flag.\nAn empty filter matches all logs.\nThe sink\'s destination can be a Cloud Storage bucket,\na BigQuery dataset, or a Cloud Pub/Sub topic.\nThe destination must already exist and Stackdriver Logging must have\npermission to write to it.\nLog entries are exported as soon as the sink is created.\nSee https://cloud.google.com/logging/docs/export/configure_export_v2#destination_authorization\n',
                                                                                                                     u'EXAMPLES': u'To export all Google App Engine logs to BigQuery, run:\n\n  $ create --log-service=appengine.googleapis.com my-bq-sink bigquery.googleapis.com/projects/my-project/datasets/my_dataset\n\nTo export "syslog" from App Engine Flexible to Cloud Storage, run:\n\n  $ create --log=appengine.googleapis.com/syslog my-gcs-sink storage.googleapis.com/my-bucket\n\nTo export Google App Engine logs with ERROR severity, run:\n\n  $ create my-error-logs bigquery.googleapis.com/projects/my-project/datasets/my_dataset --log-filter=\'resource.type="gae_app" AND severity=ERROR\'\n\nDetailed information about filters can be found at:\n[](https://cloud.google.com/logging/docs/view/advanced_filters)\n'}},
                                                                                           u'delete': {u'capsule': u'*(BETA)* Deletes a sink.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--billing-account': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Delete a sink associated with this billing account.',
                                                                                                                                         u'group': u'delete.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--billing-account',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'BILLING_ACCOUNT_ID'},
                                                                                                                  u'--folder': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Delete a sink associated with this folder.',
                                                                                                                                u'group': u'delete.1',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--folder',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'FOLDER_ID'},
                                                                                                                  u'--organization': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Delete a sink associated with this organization.',
                                                                                                                                      u'group': u'delete.1',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--organization',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ORGANIZATION_ID'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                 u'is_mutex': True,
                                                                                                                                 u'is_required': False}},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'logging',
                                                                                                                 u'sinks',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The name of the sink to delete.',
                                                                                                                         u'name': u'sink-name',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'SINK_NAME'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u"Deletes a sink and halts the export of log entries associated\nwith that sink.\nIf you don't include one of the *--log* or *--log-service* flags,\nthis command deletes a v2 sink.\nDeleting a sink does not affect log entries already exported\nthrough the deleted sink, and will not affect other sinks that are\nexporting the same log(s).\n"}},
                                                                                           u'describe': {u'capsule': u'*(BETA)* Displays information about a sink.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--billing-account': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Describe a sink associated with this billing account.',
                                                                                                                                           u'group': u'describe.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--billing-account',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'BILLING_ACCOUNT_ID'},
                                                                                                                    u'--folder': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Describe a sink associated with this folder.',
                                                                                                                                  u'group': u'describe.1',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--folder',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'FOLDER_ID'},
                                                                                                                    u'--organization': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Describe a sink associated with this organization.',
                                                                                                                                        u'group': u'describe.1',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--organization',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'ORGANIZATION_ID'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False}},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'logging',
                                                                                                                   u'sinks',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the sink to describe.',
                                                                                                                           u'name': u'sink-name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'SINK_NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u"Displays information about a sink.\nIf you don't include one of the *--log* or *--log-service* flags,\nthis command displays information about a v2 sink.\n"}},
                                                                                           u'list': {u'capsule': u'*(BETA)* Lists the defined sinks.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--billing-account': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'List sinks associated with this billing account.',
                                                                                                                                       u'group': u'list.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--billing-account',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'BILLING_ACCOUNT_ID'},
                                                                                                                u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--folder': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'List sinks associated with this folder.',
                                                                                                                              u'group': u'list.1',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--folder',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'FOLDER_ID'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-only-v2-sinks': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': True,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-only-v2-sinks',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_ONLY_V2_SINKS'},
                                                                                                                u'--only-v2-sinks': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'Display only v2 sinks.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--only-v2-sinks',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'ONLY_V2_SINKS'},
                                                                                                                u'--organization': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'List sinks associated with this organization.',
                                                                                                                                    u'group': u'list.1',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--organization',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'ORGANIZATION_ID'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                             u'is_mutex': True,
                                                                                                                             u'is_required': False}},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'logging',
                                                                                                               u'sinks',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Lists the defined sinks.\nIf either the *--log* or *--log-service* flags are included, then\nthe only sinks listed are for that log or that service.\nIf *--only-v2-sinks* flag is included, then only v2 sinks\nare listed.\nIf none of the flags are included, then all sinks in use are listed.\n'}},
                                                                                           u'update': {u'capsule': u'*(BETA)* Updates a sink.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--billing-account': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Update a sink associated with this billing account.',
                                                                                                                                         u'group': u'update.1',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--billing-account',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'BILLING_ACCOUNT_ID'},
                                                                                                                  u'--folder': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Update a sink associated with this folder.',
                                                                                                                                u'group': u'update.1',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--folder',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'FOLDER_ID'},
                                                                                                                  u'--log-filter': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A new filter expression for the sink. If omitted, the sink's existing filter (if any) is unchanged.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--log-filter',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LOG_FILTER'},
                                                                                                                  u'--no-unique-writer-identity': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': True,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-unique-writer-identity',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_UNIQUE_WRITER_IDENTITY'},
                                                                                                                  u'--organization': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Update a sink associated with this organization.',
                                                                                                                                      u'group': u'update.1',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--organization',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ORGANIZATION_ID'},
                                                                                                                  u'--output-version-format': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [u'V1',
                                                                                                                                                            u'V2'],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Format of the log entries being exported. Detailed information: https://cloud.google.com/logging/docs/api/introduction_v2. _OUTPUT_VERSION_FORMAT_ must be one of: *V1*, *V2*.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--output-version-format',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'OUTPUT_VERSION_FORMAT'},
                                                                                                                  u'--unique-writer-identity': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'Whether to create a new writer identity for this sink. Only available for project sinks. Enabled by default, use *--no-unique-writer-identity* to disable.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--unique-writer-identity',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'UNIQUE_WRITER_IDENTITY'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {u'update.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                 u'is_mutex': True,
                                                                                                                                 u'is_required': False}},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'update',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'logging',
                                                                                                                 u'sinks',
                                                                                                                 u'update'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The name of the sink to update.',
                                                                                                                         u'name': u'sink-name',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'SINK_NAME'},
                                                                                                                        {u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u"A new destination for the sink. If omitted, the sink's existing destination is unchanged.",
                                                                                                                         u'name': u'destination',
                                                                                                                         u'nargs': u'?',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'DESTINATION'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u"Changes the *[destination]* or *--log-filter* associated with a sink.\nIf you don't include one of the *--log* or *--log-service* flags,\nthis command updates a v2 sink.\nThe new destination must already exist and Stackdriver Logging must have\npermission to write to it.\nLog entries are exported to the new destination immediately.\n",
                                                                                                                     u'EXAMPLES': u"To only update a sink filter, run:\n\n  $ update my-sink --log-filter='severity>=ERROR'\n\nDetailed information about filters can be found at:\n[](https://cloud.google.com/logging/docs/view/advanced_filters)\n"}}},
                                                                             u'flags': {u'--log': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'DEPRECATED. The name of a log. Use this argument only if the sink applies to a single log.',
                                                                                                   u'group': u'sinks.1',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--log',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'LOG'},
                                                                                        u'--log-service': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'DEPRECATED. The name of a log service. Use this argument only if the sink applies to all logs from a log service.',
                                                                                                           u'group': u'sinks.1',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--log-service',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'LOG_SERVICE'}},
                                                                             u'group': True,
                                                                             u'groups': {u'sinks.1': {u'description': u'At most one of these may be specified:',
                                                                                                      u'is_mutex': True,
                                                                                                      u'is_required': False}},
                                                                             u'hidden': False,
                                                                             u'name': u'sinks',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'logging',
                                                                                       u'sinks'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Manages sinks used to export logs.'}},
                                                                  u'write': {u'capsule': u'*(BETA)* Writes a log entry.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--billing-account': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Write log entries associated with this billing account.',
                                                                                                               u'group': u'write.1',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--billing-account',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'BILLING_ACCOUNT_ID'},
                                                                                        u'--folder': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Write log entries associated with this folder.',
                                                                                                      u'group': u'write.1',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--folder',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'FOLDER_ID'},
                                                                                        u'--organization': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Write log entries associated with this organization.',
                                                                                                            u'group': u'write.1',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--organization',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'ORGANIZATION_ID'},
                                                                                        u'--payload-type': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [u'text',
                                                                                                                         u'json'],
                                                                                                            u'completer': u'',
                                                                                                            u'default': u'text',
                                                                                                            u'description': u'Type of the log entry payload. _PAYLOAD_TYPE_ must be one of: *text*, *json*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--payload-type',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'PAYLOAD_TYPE'},
                                                                                        u'--severity': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [u'DEFAULT',
                                                                                                                     u'DEBUG',
                                                                                                                     u'INFO',
                                                                                                                     u'NOTICE',
                                                                                                                     u'WARNING',
                                                                                                                     u'ERROR',
                                                                                                                     u'CRITICAL',
                                                                                                                     u'ALERT',
                                                                                                                     u'EMERGENCY'],
                                                                                                        u'completer': u'',
                                                                                                        u'default': u'DEFAULT',
                                                                                                        u'description': u'Severity level of the log entry. _SEVERITY_ must be one of: *DEFAULT*, *DEBUG*, *INFO*, *NOTICE*, *WARNING*, *ERROR*, *CRITICAL*, *ALERT*, *EMERGENCY*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--severity',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'SEVERITY'}},
                                                                             u'group': False,
                                                                             u'groups': {u'write.1': {u'description': u'At most one of these may be specified:',
                                                                                                      u'is_mutex': True,
                                                                                                      u'is_required': False}},
                                                                             u'hidden': False,
                                                                             u'name': u'write',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'logging',
                                                                                       u'write'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'The name of the log where the log entry will be written.',
                                                                                               u'name': u'log-name',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'value': u'LOG_NAME'},
                                                                                              {u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'The message to put in the log entry. It can be JSON if you include --payload-type=json.',
                                                                                               u'name': u'message',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'value': u'MESSAGE'}],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Writes a log entry.\nIf the destination log does not exist, it will be created.\nAll log entries written with this command are considered to be from\nthe "custom.googleapis.com" v1 service or the "global" v2 resource type.\nThe log entries will be listed in the Logs Viewer under that service or\nresource type.\n\nwrite should be used for simple testing purposes.\nCheck Stackdriver Logging agent for a proper way to send log entries:\n[](https://cloud.google.com/logging/docs/agent/)\n',
                                                                                           u'EXAMPLES': u'To create a log entry in a given log, run:\n\n  $ write LOG_NAME "A simple entry"\n\nTo create a high severity log entry, run:\n\n  $ write LOG_NAME "Urgent message" --severity=alert\n\nTo create a structured log, run:\n\n  $ write LOG_NAME \'{"key": "value"}\' --payload-type=json\n'}}},
                                                    u'flags': {},
                                                    u'group': True,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'logging',
                                                    u'path': [u'gcloud',
                                                              u'beta',
                                                              u'logging'],
                                                    u'positionals': [],
                                                    u'release': u'BETA',
                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Manage Stackdriver Logging.'}},
                                       u'ml': {u'capsule': u'*(BETA)* Manage Cloud ML jobs and models.',
                                               u'commands': {u'init-project': {u'capsule': u'*(BETA)* Initialize project for Cloud ML.',
                                                                               u'commands': {},
                                                                               u'flags': {},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'init-project',
                                                                               u'path': [u'gcloud',
                                                                                         u'beta',
                                                                                         u'ml',
                                                                                         u'init-project'],
                                                                               u'positionals': [],
                                                                               u'release': u'BETA',
                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Initialize project for Cloud ML.\n\ninit-project initializes the current project for use with Google Cloud\nMachine Learning. Specifically, it adds the required Cloud Machine\nLearning service accounts to the current project as editors.\n'}},
                                                             u'jobs': {u'capsule': u'*(BETA)* Cloud ML Jobs commands.',
                                                                       u'commands': {u'cancel': {u'capsule': u'*(BETA)* Cancel a running Cloud ML job.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'cancel',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'beta',
                                                                                                           u'ml',
                                                                                                           u'jobs',
                                                                                                           u'cancel'],
                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Name of the job.',
                                                                                                                   u'name': u'job',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'JOB'}],
                                                                                                 u'release': u'BETA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* *cancel* cancels a running Cloud ML job. If the job is already finished,\nthe command will not perform an operation and exit successfully.'}},
                                                                                     u'describe': {u'capsule': u'*(BETA)* Describe a Cloud ML job.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'describe',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'ml',
                                                                                                             u'jobs',
                                                                                                             u'describe'],
                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'Name of the job.',
                                                                                                                     u'name': u'job',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'JOB'}],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* Describe a Cloud ML job.'}},
                                                                                     u'list': {u'capsule': u'*(BETA)* List existing Cloud ML jobs.',
                                                                                               u'commands': {},
                                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--filter',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'EXPRESSION'},
                                                                                                          u'--limit': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--limit',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'LIMIT'},
                                                                                                          u'--no-uri': {u'attr': {},
                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': True,
                                                                                                                        u'description': u'',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': True,
                                                                                                                        u'name': u'--no-uri',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'NO_URI'},
                                                                                                          u'--page-size': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--page-size',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                                          u'--sort-by': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--sort-by',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'list',
                                                                                                                         u'value': u'FIELD'},
                                                                                                          u'--uri': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': False,
                                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--uri',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'URI'}},
                                                                                               u'group': False,
                                                                                               u'groups': {},
                                                                                               u'hidden': False,
                                                                                               u'name': u'list',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'beta',
                                                                                                         u'ml',
                                                                                                         u'jobs',
                                                                                                         u'list'],
                                                                                               u'positionals': [],
                                                                                               u'release': u'BETA',
                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* List existing Cloud ML jobs.'}},
                                                                                     u'stream-logs': {u'capsule': u'*(BETA)* Show logs from a running Cloud ML job.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--allow-multiline-logs': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'Output multiline log messages as single records.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--allow-multiline-logs',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'ALLOW_MULTILINE_LOGS'},
                                                                                                                 u'--no-allow-multiline-logs': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-allow-multiline-logs',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_ALLOW_MULTILINE_LOGS'},
                                                                                                                 u'--polling-interval': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': 60,
                                                                                                                                         u'description': u'Number of seconds to wait between efforts to fetch the latest log messages.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--polling-interval',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'int',
                                                                                                                                         u'value': u'POLLING_INTERVAL'},
                                                                                                                 u'--task-name': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'If set, display only the logs for this particular task.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--task-name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'TASK_NAME'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'stream-logs',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'ml',
                                                                                                                u'jobs',
                                                                                                                u'stream-logs'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Name of the job.',
                                                                                                                        u'name': u'job',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'JOB'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Show logs from a running Cloud ML job.'}},
                                                                                     u'submit': {u'capsule': u'*(BETA)* Cloud ML Jobs submit commands.',
                                                                                                 u'commands': {u'prediction': {u'capsule': u'*(BETA)* Start a Cloud ML batch prediction job.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--data-format': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [u'TEXT',
                                                                                                                                                                          u'TF_RECORD',
                                                                                                                                                                          u'TF_RECORD_GZIP'],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Data format of the input files. _DATA_FORMAT_ must be one of:\n+\n*TEXT*::: Text files with instances separated by the new-line character.\n*TF_RECORD*::: TFRecord files; see https://www.tensorflow.org/versions/r0.12/how_tos/reading_data/index.html#file-formats\n*TF_RECORD_GZIP*::: GZIP-compressed TFRecord files.\n+',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--data-format',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': True,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'DATA_FORMAT'},
                                                                                                                                          u'--input-paths': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Google Cloud Storage paths to the instances to run prediction on.\n+\nWildcards (```*```) accepted at the *end* of a path. More than one path can be\nspecified if multiple file patterns are needed. For example,\n+\n    gs://my-bucket/instances*,gs://my-bucket/other-instances1\n+\nwill match any objects whose names start with `instances` in `my-bucket` as well\nas the `other-instances1` bucket, while\n+\n    gs://my-bucket/instance-dir/*\n+\nwill match any objects in the `instance-dir` "directory" (since directories\naren\'t a first-class Cloud Storage concept) of `my-bucket`.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--input-paths',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': True,
                                                                                                                                                             u'type': u'list',
                                                                                                                                                             u'value': u'INPUT_PATHS'},
                                                                                                                                          u'--max-worker-count': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The maximum number of workers to be used for parallel processing. Defaults to 10 if not specified.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--max-worker-count',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'MAX_WORKER_COUNT'},
                                                                                                                                          u'--model': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Name of the model to use for prediction.',
                                                                                                                                                       u'group': u'prediction.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--model',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'MODEL'},
                                                                                                                                          u'--model-dir': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Google Cloud Storage location where the model files are located.',
                                                                                                                                                           u'group': u'prediction.1',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--model-dir',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'MODEL_DIR'},
                                                                                                                                          u'--output-path': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Google Cloud Storage path to which to save the output. Example: gs://my-bucket/output.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--output-path',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': True,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'OUTPUT_PATH'},
                                                                                                                                          u'--region': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The Google Compute Engine region to run the job in.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--region',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': True,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'REGION'},
                                                                                                                                          u'--runtime-version': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The Google Cloud ML runtime version for this job. Defaults to the latest stable version. See https://cloud.google.com/ml/docs/concepts/runtime-version-list for a list of accepted versions.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--runtime-version',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'RUNTIME_VERSION'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {u'prediction.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                                             u'is_mutex': True,
                                                                                                                                                             u'is_required': True}},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'prediction',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'beta',
                                                                                                                                         u'ml',
                                                                                                                                         u'jobs',
                                                                                                                                         u'submit',
                                                                                                                                         u'prediction'],
                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Name of the batch prediction job.',
                                                                                                                                                 u'name': u'job',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'value': u'JOB'}],
                                                                                                                               u'release': u'BETA',
                                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Start a Cloud ML batch prediction job.'}},
                                                                                                               u'training': {u'capsule': u'*(BETA)* Submits a Cloud Machine Learning training job.',
                                                                                                                             u'commands': {},
                                                                                                                             u'flags': {u'--async': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--async',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'ASYNC'},
                                                                                                                                        u'--config': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Path to the job configuration file. The file should be a YAML document (JSON\nalso accepted) containing a Job resource as defined in the API (all fields are\noptional): https://cloud.google.com/ml/reference/rest/v1beta1/projects.jobs\n+\nIf an option is specified both in the configuration file *and* via command line\narguments, the command line arguments override the configuration file.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--config',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'CONFIG'},
                                                                                                                                        u'--job-dir': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A Google Cloud Storage path in which to store training outputs and\nother data needed for training.\n+\nThis path will be passed to your TensorFlow program as `--job_dir`\ncommand-line arg. The benefit of specifying this field is that Cloud\nML will validate the path for use in training.\n+\nIf packages must be uploaded and `--staging-bucket` is not provided,\nthis path will be used instead.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--job-dir',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'JOB_DIR'},
                                                                                                                                        u'--module-name': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Name of the module to run',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--module-name',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': True,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'MODULE_NAME'},
                                                                                                                                        u'--no-async': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': True,
                                                                                                                                                        u'description': u'',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': True,
                                                                                                                                                        u'name': u'--no-async',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'NO_ASYNC'},
                                                                                                                                        u'--package-path': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Path to a Python package to build. This should point to a directory containing\nthe Python source for the job. It will be built using setuptools (which must be\ninstalled) using its *parent* directory as context. If the parent directory\ncontains a `setup.py` file, the build will use that; otherwise, it will use a\nsimple built-in one.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--package-path',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'PACKAGE_PATH'},
                                                                                                                                        u'--packages': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': [],
                                                                                                                                                        u'description': u'Path to Python archives used for training. These can be local paths\n(absolute or relative), in which case they will be uploaded to the Cloud\nStorage bucket given by `--staging-bucket`, or Cloud Storage URLs\n(`gs://bucket-name/path/to/package.tar.gz`).',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--packages',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'PACKAGE'},
                                                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"The region of the machine learning training job to submit. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--region',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'REGION'},
                                                                                                                                        u'--runtime-version': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The Google Cloud ML runtime version for this job. Defaults to the latest stable version. See https://cloud.google.com/ml/docs/concepts/runtime-version-list for a list of accepted versions.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--runtime-version',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'RUNTIME_VERSION'},
                                                                                                                                        u'--scale-tier': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [u'BASIC',
                                                                                                                                                                       u'BASIC_GPU',
                                                                                                                                                                       u'CUSTOM',
                                                                                                                                                                       u'PREMIUM_1',
                                                                                                                                                                       u'STANDARD_1'],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'Specifies the machine types, the number of replicas for workers and parameter servers. _SCALE_TIER_ must be one of:\n+\n*BASIC*::: A single worker instance. This tier is suitable for learning how to use Cloud ML, and for experimenting with new models using small datasets.\n*BASIC_GPU*::: A single worker instance with a GPU.\n*CUSTOM*::: The CUSTOM tier is not a set tier, but rather enables you to use your own\ncluster specification. When you use this tier, set values to configure your\nprocessing cluster according to these guidelines (using the --config flag):\n+\n* You _must_ set `TrainingInput.masterType` to specify the type of machine to\n  use for your master node. This is the only required setting.\n* You _may_ set `TrainingInput.workerCount` to specify the number of workers to\n  use. If you specify one or more workers, you _must_ also set\n  `TrainingInput.workerType` to specify the type of machine to use for your\n  worker nodes.\n* You _may_ set `TrainingInput.parameterServerCount` to specify the number of\n  parameter servers to use. If you specify one or more parameter servers, you\n  _must_ also set `TrainingInput.parameterServerType` to specify the type of\n  machine to use for your parameter servers.  Note that all of your workers must\n  use the same machine type, which can be different from your parameter server\n  type and master type. Your parameter servers must likewise use the same\n  machine type, which can be different from your worker type and master type.\n*PREMIUM_1*::: A large number of workers with many parameter servers.\n*STANDARD_1*::: Many workers and a few parameter servers.\n+',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--scale-tier',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'SCALE_TIER'},
                                                                                                                                        u'--staging-bucket': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Bucket in which to stage training archives.\n+\nRequired only if a file upload is necessary (that is, other flags\ninclude local paths) and no other flags implicitly specify an upload\npath.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--staging-bucket',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'STAGING_BUCKET'}},
                                                                                                                             u'group': False,
                                                                                                                             u'groups': {},
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'training',
                                                                                                                             u'path': [u'gcloud',
                                                                                                                                       u'beta',
                                                                                                                                       u'ml',
                                                                                                                                       u'jobs',
                                                                                                                                       u'submit',
                                                                                                                                       u'training'],
                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Name of the job.',
                                                                                                                                               u'name': u'job',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'value': u'JOB'},
                                                                                                                                              {u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"Additional user arguments to be fowarded to user code\n+\nThe '--' argument must be specified between gcloud specific args on the left and USER_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                                                                                                                               u'name': u'user-args',
                                                                                                                                               u'nargs': u'...',
                                                                                                                                               u'required': False,
                                                                                                                                               u'value': u'USER_ARGS'}],
                                                                                                                             u'release': u'BETA',
                                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* This creates temporary files and executes Python code staged\nby a user on Google Cloud Storage. Model code can either be\nspecified with a path, e.g.:\n\n    $ training my_job \\\n            --module-name trainer.task \\\n            --staging-bucket gs://my-bucket \\\n            --package-path /my/code/path/trainer \\\n            --packages additional-dep1.tar.gz,dep2.whl\n\nOr by specifying an already built package:\n\n    $ training my_job \\\n            --module-name trainer.task \\\n            --staging-bucket gs://my-bucket \\\n            --packages trainer-0.0.1.tar.gz,additional-dep1.tar.gz,dep2.whl\n\nIf --package-path /my/code/path/trainer is specified and there is a\nsetup.py file at /my/code/path/setup.py then that file will be invoked\nwith `sdist` and the generated tar files will be uploaded to Cloud Storage.\nOtherwise a temporary setup.py file will be generated for the build.\n\nBy default, this command blocks until the job finishes, streaming the logs in\nthe meantime. If the job succeeds, the command exits zero; otherwise, it exits\nnon-zero. To avoid blocking, pass the `--async` flag.\n\nFor more information, see:\nhttps://cloud.google.com/ml/docs/concepts/training-overview'}}},
                                                                                                 u'flags': {},
                                                                                                 u'group': True,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'submit',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'beta',
                                                                                                           u'ml',
                                                                                                           u'jobs',
                                                                                                           u'submit'],
                                                                                                 u'positionals': [],
                                                                                                 u'release': u'BETA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud ML Jobs submit commands.'}}},
                                                                       u'flags': {},
                                                                       u'group': True,
                                                                       u'groups': {},
                                                                       u'hidden': False,
                                                                       u'name': u'jobs',
                                                                       u'path': [u'gcloud',
                                                                                 u'beta',
                                                                                 u'ml',
                                                                                 u'jobs'],
                                                                       u'positionals': [],
                                                                       u'release': u'BETA',
                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud ML Jobs commands.'}},
                                                             u'local': {u'capsule': u'*(BETA)* Cloud ML Local commands.',
                                                                        u'commands': {u'predict': {u'capsule': u'*(BETA)* Run prediction locally.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {u'--json-instances': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Path to a local file from which instances are read.\nInstances are in JSON format; newline delimited.\n+\nAn example of the JSON instances file:\n+\n    {"images": [0.0, ..., 0.1], "key": 3}\n    {"images": [0.0, ..., 0.1], "key": 2}\n    ...\n+\nThis flag accepts "-" for stdin.',
                                                                                                                                    u'group': u'predict.1',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--json-instances',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'JSON_INSTANCES'},
                                                                                                              u'--model-dir': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Path to the model.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--model-dir',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': True,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'MODEL_DIR'},
                                                                                                              u'--text-instances': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Path to a local file from which instances are read.\nInstances are in UTF-8 encoded text format; newline delimited.\n+\nAn example of the text instances file:\n+\n    107,4.9,2.5,4.5,1.7\n    100,5.7,2.8,4.1,1.3\n    ...\n+\nThis flag accepts "-" for stdin.',
                                                                                                                                    u'group': u'predict.1',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--text-instances',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'TEXT_INSTANCES'}},
                                                                                                   u'group': False,
                                                                                                   u'groups': {u'predict.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                              u'is_mutex': True,
                                                                                                                              u'is_required': True}},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'predict',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'ml',
                                                                                                             u'local',
                                                                                                             u'predict'],
                                                                                                   u'positionals': [],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* *predict* performs prediction locally with the given instances. It\nrequires the TensorFlow SDK be installed locally. Only Debian based systems\nare supported at this time.'}},
                                                                                      u'train': {u'capsule': u'*(BETA)* Run a Cloud ML training job locally.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {u'--distributed': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Runs the provided code in distributed mode by providing cluster configurations as environment variables to subprocesses',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--distributed',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'DISTRIBUTED'},
                                                                                                            u'--module-name': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Name of the module to run',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--module-name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': True,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'MODULE_NAME'},
                                                                                                            u'--no-distributed': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-distributed',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_DISTRIBUTED'},
                                                                                                            u'--package-path': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Path to a Python package to build. This should point to a directory containing\nthe Python source for the job. It will be built using setuptools (which must be\ninstalled) using its *parent* directory as context. If the parent directory\ncontains a `setup.py` file, the build will use that; otherwise, it will use a\nsimple built-in one.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--package-path',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'PACKAGE_PATH'},
                                                                                                            u'--parameter-server-count': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Number of parameter servers with which to run. Ignored if --distributed is not specified. Default: 2',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--parameter-server-count',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PARAMETER_SERVER_COUNT'},
                                                                                                            u'--start-port': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': 27182,
                                                                                                                              u'description': u'Start of the range of ports reserved by the local cluster. This command will use\na contiguous block of ports equal to parameter-server-count + worker-count + 1.\n+\nIf --distributed is not specified, this flag is ignored.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--start-port',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'int',
                                                                                                                              u'value': u'START_PORT'},
                                                                                                            u'--worker-count': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Number of workers with which to run. Ignored if --distributed is not specified. Default: 2',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--worker-count',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'WORKER_COUNT'}},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'train',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'beta',
                                                                                                           u'ml',
                                                                                                           u'local',
                                                                                                           u'train'],
                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"Additional user arguments to be fowarded to user code. Any relative paths will\nbe relative to the *parent* directory of `--package-path`.\n+\n\nThe '--' argument must be specified between gcloud specific args on the left and USER_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                                                                                                   u'name': u'user-args',
                                                                                                                   u'nargs': u'...',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'USER_ARGS'}],
                                                                                                 u'release': u'BETA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* This command runs the specified module in an environment\nsimilar to that of a live Cloud ML Training Job.\n\nThis is especially useful in the case of testing distributed models,\nas it allows you to validate that you are properly interacting with the\nCloud ML cluster configuration. If your model expects a specific\nnumber of parameter servers or workers (i.e. you expect to use the CUSTOM\nmachine type), use the --parameter-server-count and --worker-count flags to\nfurther specify the desired cluster configuration, just as you would in\nyour cloud training job configuration:\n\n    $ train --module-name trainer.task \\\n            --package-path /path/to/my/code/trainer \\\n            --distributed \\\n            --parameter-server-count 4 \\\n            --worker-count 8\n\nUnlike submitting a training job, the --package-path parameter can be\nomitted, and will use your current working directory.'}}},
                                                                        u'flags': {},
                                                                        u'group': True,
                                                                        u'groups': {},
                                                                        u'hidden': False,
                                                                        u'name': u'local',
                                                                        u'path': [u'gcloud',
                                                                                  u'beta',
                                                                                  u'ml',
                                                                                  u'local'],
                                                                        u'positionals': [],
                                                                        u'release': u'BETA',
                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud ML Local commands.'}},
                                                             u'models': {u'capsule': u'*(BETA)* Cloud ML Models commands.',
                                                                         u'commands': {u'create': {u'capsule': u'*(BETA)* Create a new Cloud ML model.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {u'--enable-logging': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'If set, enables StackDriver Logging for online prediction.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--enable-logging',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'ENABLE_LOGGING'},
                                                                                                              u'--no-enable-logging': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-enable-logging',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_ENABLE_LOGGING'},
                                                                                                              u'--regions': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"Comma separated list of Google Cloud regions where the model will be deployed.\nCurrently only one region per model is supported.\n+\nWill soon be required, but defaults to 'us-central1' for now.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--regions',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'list',
                                                                                                                             u'value': u'REGION'}},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'create',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'ml',
                                                                                                             u'models',
                                                                                                             u'create'],
                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'Name of the model.',
                                                                                                                     u'name': u'model',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'MODEL'}],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* Create a new Cloud ML model.'}},
                                                                                       u'delete': {u'capsule': u'*(BETA)* Delete an existing Cloud ML model.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'delete',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'ml',
                                                                                                             u'models',
                                                                                                             u'delete'],
                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'Name of the model.',
                                                                                                                     u'name': u'model',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'MODEL'}],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* Delete an existing Cloud ML model.'}},
                                                                                       u'describe': {u'capsule': u'*(BETA)* Describe an existing Cloud ML model.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'describe',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'ml',
                                                                                                               u'models',
                                                                                                               u'describe'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Name of the model.',
                                                                                                                       u'name': u'model',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'MODEL'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Describe an existing Cloud ML model.'}},
                                                                                       u'list': {u'capsule': u'*(BETA)* List existing Cloud ML models.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--filter',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                            u'--limit': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--limit',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'LIMIT'},
                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': True,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-uri',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_URI'},
                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--page-size',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--sort-by',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'list',
                                                                                                                           u'value': u'FIELD'},
                                                                                                            u'--uri': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--uri',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'URI'}},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'list',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'beta',
                                                                                                           u'ml',
                                                                                                           u'models',
                                                                                                           u'list'],
                                                                                                 u'positionals': [],
                                                                                                 u'release': u'BETA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* List existing Cloud ML models.'}},
                                                                                       u'versions': {u'capsule': u'*(BETA)* Cloud ML Versions commands.',
                                                                                                     u'commands': {u'create': {u'capsule': u'*(BETA)*  *(DEPRECATED)* Create a new Cloud ML version.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--async': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--async',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'ASYNC'},
                                                                                                                                          u'--model': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Name of the model.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--model',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': True,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'MODEL'},
                                                                                                                                          u'--no-async': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': True,
                                                                                                                                                          u'description': u'',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': True,
                                                                                                                                                          u'name': u'--no-async',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'NO_ASYNC'},
                                                                                                                                          u'--origin': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Location of ```model/``` "directory" (as output by\nhttps://www.tensorflow.org/versions/r0.12/api_docs/python/state_ops.html#Saver).\n+\nCan be a Google Cloud Storage (`gs://`) path or local file path (no prefix). In\nthe latter case the files will be uploaded to Google Cloud Storage and a\n`--staging-bucket` argument is required.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--origin',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': True,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'ORIGIN'},
                                                                                                                                          u'--runtime-version': {u'attr': {},
                                                                                                                                                                 u'category': u'',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The Google Cloud ML runtime version for this job. Defaults to the latest stable version. See https://cloud.google.com/ml/docs/concepts/runtime-version-list for a list of accepted versions.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--runtime-version',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'RUNTIME_VERSION'},
                                                                                                                                          u'--staging-bucket': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Bucket in which to stage training archives.\n+\nRequired only if a file upload is necessary (that is, other flags\ninclude local paths) and no other flags implicitly specify an upload\npath.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--staging-bucket',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'STAGING_BUCKET'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'create',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'beta',
                                                                                                                                         u'ml',
                                                                                                                                         u'models',
                                                                                                                                         u'versions',
                                                                                                                                         u'create'],
                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Name of the model version.',
                                                                                                                                                 u'name': u'version',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'value': u'VERSION'}],
                                                                                                                               u'release': u'BETA',
                                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)*  *(DEPRECATED)* Create a new Cloud ML version.\n\nThis command is deprecated. Please use `gcloud beta ml versions create` instead.\n\n'}},
                                                                                                                   u'delete': {u'capsule': u'*(BETA)*  *(DEPRECATED)* Delete an existing Cloud ML version.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--model': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Name of the model.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--model',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': True,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'MODEL'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'delete',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'beta',
                                                                                                                                         u'ml',
                                                                                                                                         u'models',
                                                                                                                                         u'versions',
                                                                                                                                         u'delete'],
                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Name of the model version.',
                                                                                                                                                 u'name': u'version',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'value': u'VERSION'}],
                                                                                                                               u'release': u'BETA',
                                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)*  *(DEPRECATED)* Delete an existing Cloud ML version.\n\nThis command is deprecated. Please use `gcloud beta ml versions delete` instead.\n\n'}},
                                                                                                                   u'describe': {u'capsule': u'*(BETA)*  *(DEPRECATED)* ',
                                                                                                                                 u'commands': {},
                                                                                                                                 u'flags': {u'--model': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Name of the model.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--model',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': True,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'MODEL'}},
                                                                                                                                 u'group': False,
                                                                                                                                 u'groups': {},
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'describe',
                                                                                                                                 u'path': [u'gcloud',
                                                                                                                                           u'beta',
                                                                                                                                           u'ml',
                                                                                                                                           u'models',
                                                                                                                                           u'versions',
                                                                                                                                           u'describe'],
                                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'Name of the model version.',
                                                                                                                                                   u'name': u'version',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'value': u'VERSION'}],
                                                                                                                                 u'release': u'BETA',
                                                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)*  *(DEPRECATED)* \n\nThis command is deprecated. Please use `gcloud beta ml versions describe` instead.\n\n'}},
                                                                                                                   u'list': {u'capsule': u'*(BETA)*  *(DEPRECATED)* List existing Cloud ML versions.',
                                                                                                                             u'commands': {},
                                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--filter',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--limit',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                                        u'--model': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Name of the model.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--model',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': True,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'MODEL'},
                                                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': True,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-uri',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_URI'},
                                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--page-size',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'list',
                                                                                                                                                       u'value': u'FIELD'},
                                                                                                                                        u'--uri': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--uri',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'URI'}},
                                                                                                                             u'group': False,
                                                                                                                             u'groups': {},
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'list',
                                                                                                                             u'path': [u'gcloud',
                                                                                                                                       u'beta',
                                                                                                                                       u'ml',
                                                                                                                                       u'models',
                                                                                                                                       u'versions',
                                                                                                                                       u'list'],
                                                                                                                             u'positionals': [],
                                                                                                                             u'release': u'BETA',
                                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)*  *(DEPRECATED)* List existing Cloud ML versions.\n\nThis command is deprecated. Please use `gcloud beta ml versions list` instead.\n\n'}},
                                                                                                                   u'set-default': {u'capsule': u'*(BETA)*  *(DEPRECATED)* Sets an existing Cloud ML version as the default for its model.',
                                                                                                                                    u'commands': {},
                                                                                                                                    u'flags': {u'--model': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Name of the model.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--model',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': True,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'MODEL'}},
                                                                                                                                    u'group': False,
                                                                                                                                    u'groups': {},
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'set-default',
                                                                                                                                    u'path': [u'gcloud',
                                                                                                                                              u'beta',
                                                                                                                                              u'ml',
                                                                                                                                              u'models',
                                                                                                                                              u'versions',
                                                                                                                                              u'set-default'],
                                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Name of the model version.',
                                                                                                                                                      u'name': u'version',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'value': u'VERSION'}],
                                                                                                                                    u'release': u'BETA',
                                                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)*  *(DEPRECATED)* Sets an existing Cloud ML version as the default for its model.\n\nThis command is deprecated. Please use `gcloud beta ml versions set-default` instead.\n\n'}}},
                                                                                                     u'flags': {},
                                                                                                     u'group': True,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'versions',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'ml',
                                                                                                               u'models',
                                                                                                               u'versions'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud ML Versions commands.'}}},
                                                                         u'flags': {},
                                                                         u'group': True,
                                                                         u'groups': {},
                                                                         u'hidden': False,
                                                                         u'name': u'models',
                                                                         u'path': [u'gcloud',
                                                                                   u'beta',
                                                                                   u'ml',
                                                                                   u'models'],
                                                                         u'positionals': [],
                                                                         u'release': u'BETA',
                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* A Cloud ML model is a container representing an ML application or service.\nA model may contain multiple versions which act as the implementation of\nthe service. See also $ gcloud beta ml versions --help.\n\nFor more information, please see\nhttps://cloud.google.com/ml/docs/concepts/technical-overview#models'}},
                                                             u'operations': {u'capsule': u'*(BETA)* Manage Cloud ML operations.',
                                                                             u'commands': {u'cancel': {u'capsule': u'*(BETA)* Cancel a Cloud ML operation.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'cancel',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'ml',
                                                                                                                 u'operations',
                                                                                                                 u'cancel'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Name of the operation.',
                                                                                                                         u'name': u'operation',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'OPERATION'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Cancel a Cloud ML operation.'}},
                                                                                           u'delete': {u'capsule': u'*(BETA)* Delete a Cloud ML operation.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'ml',
                                                                                                                 u'operations',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Name of the operation.',
                                                                                                                         u'name': u'operation',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'OPERATION'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Delete a Cloud ML operation.'}},
                                                                                           u'describe': {u'capsule': u'*(BETA)* Describe a Cloud ML operation.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'ml',
                                                                                                                   u'operations',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Name of the operation.',
                                                                                                                           u'name': u'operation',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'OPERATION'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Describe a Cloud ML operation.'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* List existing Cloud ML jobs.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'ml',
                                                                                                               u'operations',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* List existing Cloud ML jobs.'}},
                                                                                           u'wait': {u'capsule': u'*(BETA)* Wait for a Cloud ML operation to complete.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'wait',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'ml',
                                                                                                               u'operations',
                                                                                                               u'wait'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Name of the operation.',
                                                                                                                       u'name': u'operation',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'OPERATION'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Given an operation ID, this command polls the operation and blocks until it\ncompletes. At completion, the operation message is printed (which includes the\noperation response).'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'operations',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'ml',
                                                                                       u'operations'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Manage Cloud ML operations.'}},
                                                             u'predict': {u'capsule': u'*(BETA)* Run Cloud ML online prediction.',
                                                                          u'commands': {},
                                                                          u'flags': {u'--json-instances': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Path to a local file from which instances are read.\nInstances are in JSON format; newline delimited.\n+\nAn example of the JSON instances file:\n+\n    {"images": [0.0, ..., 0.1], "key": 3}\n    {"images": [0.0, ..., 0.1], "key": 2}\n    ...\n+\nThis flag accepts "-" for stdin.',
                                                                                                           u'group': u'predict.1',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--json-instances',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'JSON_INSTANCES'},
                                                                                     u'--model': {u'attr': {},
                                                                                                  u'category': u'',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'Name of the model.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--model',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': True,
                                                                                                  u'type': u'string',
                                                                                                  u'value': u'MODEL'},
                                                                                     u'--text-instances': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Path to a local file from which instances are read.\nInstances are in UTF-8 encoded text format; newline delimited.\n+\nAn example of the text instances file:\n+\n    107,4.9,2.5,4.5,1.7\n    100,5.7,2.8,4.1,1.3\n    ...\n+\nThis flag accepts "-" for stdin.',
                                                                                                           u'group': u'predict.1',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--text-instances',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'TEXT_INSTANCES'}},
                                                                          u'group': False,
                                                                          u'groups': {u'predict.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                     u'is_mutex': True,
                                                                                                     u'is_required': True}},
                                                                          u'hidden': False,
                                                                          u'name': u'predict',
                                                                          u'path': [u'gcloud',
                                                                                    u'beta',
                                                                                    u'ml',
                                                                                    u'predict'],
                                                                          u'positionals': [],
                                                                          u'release': u'BETA',
                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* `predict` sends a prediction request to Cloud ML for the given instances.\nThis command will only accept up to 100 instances at a time. If you are\npredicting on more instances, you should use batch prediction via\n$ gcloud beta ml jobs submit prediction.'}},
                                                             u'versions': {u'capsule': u'*(BETA)* Cloud ML Versions commands.',
                                                                           u'commands': {u'create': {u'capsule': u'*(BETA)* Create a new Cloud ML version.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--async': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--async',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'ASYNC'},
                                                                                                                u'--model': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Name of the model.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--model',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': True,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'MODEL'},
                                                                                                                u'--no-async': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-async',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_ASYNC'},
                                                                                                                u'--origin': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Location of ```model/``` "directory" (as output by\nhttps://www.tensorflow.org/versions/r0.12/api_docs/python/state_ops.html#Saver).\n+\nCan be a Google Cloud Storage (`gs://`) path or local file path (no prefix). In\nthe latter case the files will be uploaded to Google Cloud Storage and a\n`--staging-bucket` argument is required.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--origin',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'ORIGIN'},
                                                                                                                u'--runtime-version': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The Google Cloud ML runtime version for this job. Defaults to the latest stable version. See https://cloud.google.com/ml/docs/concepts/runtime-version-list for a list of accepted versions.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--runtime-version',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'RUNTIME_VERSION'},
                                                                                                                u'--staging-bucket': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Bucket in which to stage training archives.\n+\nRequired only if a file upload is necessary (that is, other flags\ninclude local paths) and no other flags implicitly specify an upload\npath.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--staging-bucket',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'STAGING_BUCKET'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'create',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'ml',
                                                                                                               u'versions',
                                                                                                               u'create'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Name of the model version.',
                                                                                                                       u'name': u'version',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'VERSION'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Create a new Cloud ML version.'}},
                                                                                         u'delete': {u'capsule': u'*(BETA)* Delete an existing Cloud ML version.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--model': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Name of the model.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--model',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': True,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'MODEL'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'delete',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'ml',
                                                                                                               u'versions',
                                                                                                               u'delete'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Name of the model version.',
                                                                                                                       u'name': u'version',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'VERSION'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Delete an existing Cloud ML version.'}},
                                                                                         u'describe': {u'capsule': u'*(BETA)* Describe an existing Cloud ML version.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--model': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Name of the model.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--model',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': True,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'MODEL'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'describe',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'ml',
                                                                                                                 u'versions',
                                                                                                                 u'describe'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Name of the model version.',
                                                                                                                         u'name': u'version',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'VERSION'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Describe an existing Cloud ML version.'}},
                                                                                         u'list': {u'capsule': u'*(BETA)* List existing Cloud ML versions.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--filter',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                              u'--limit': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--limit',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'LIMIT'},
                                                                                                              u'--model': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Name of the model.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--model',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': True,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'MODEL'},
                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': True,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--no-uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_URI'},
                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--page-size',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--sort-by',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'list',
                                                                                                                             u'value': u'FIELD'},
                                                                                                              u'--uri': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--uri',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'URI'}},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'list',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'ml',
                                                                                                             u'versions',
                                                                                                             u'list'],
                                                                                                   u'positionals': [],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* List existing Cloud ML versions.'}},
                                                                                         u'set-default': {u'capsule': u'*(BETA)* Sets an existing Cloud ML version as the default for its model.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--model': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Name of the model.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--model',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'MODEL'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'set-default',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'ml',
                                                                                                                    u'versions',
                                                                                                                    u'set-default'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Name of the model version.',
                                                                                                                            u'name': u'version',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'VERSION'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* *set-default* sets an existing Cloud ML version as the default for its model.\nOnly one version may be the default for a given version.'}}},
                                                                           u'flags': {},
                                                                           u'group': True,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'versions',
                                                                           u'path': [u'gcloud',
                                                                                     u'beta',
                                                                                     u'ml',
                                                                                     u'versions'],
                                                                           u'positionals': [],
                                                                           u'release': u'BETA',
                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* A version is an implementation of a model, represented as a serialized\nTensorFlow graph with trained parameters.\n\nWhen you communicate with Cloud ML services, you use the combination of\nthe model, version, and current project to identify a specific model\nimplementation that is deployed in the cloud.'}}},
                                               u'flags': {},
                                               u'group': True,
                                               u'groups': {},
                                               u'hidden': False,
                                               u'name': u'ml',
                                               u'path': [u'gcloud',
                                                         u'beta',
                                                         u'ml'],
                                               u'positionals': [],
                                               u'release': u'BETA',
                                               u'sections': {u'DESCRIPTION': u'*(BETA)* The ml command group lets you manage Google Cloud ML jobs and training\nmodels.\n\nCloud ML is a managed service that enables you to easily build machine\nlearning models, that work on any type of data, of any size. Create your model\nwith the powerful TensorFlow framework that powers many Google products, from\nGoogle Photos to Google Cloud Speech.\n\nMore information on Cloud ML can be found here: https://cloud.google.com/ml\nand detailed documentation can be found here:\nhttps://cloud.google.com/ml/docs/'}},
                                       u'organizations': {u'capsule': u'*(BETA)* Create and manage Google Cloud Platform Organizations.',
                                                          u'commands': {u'add-iam-policy-binding': {u'capsule': u'*(BETA)* Add IAM policy binding for a organization.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--member': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The member to add to the binding.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--member',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': True,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'MEMBER'},
                                                                                                               u'--role': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Define the role of the member.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--role',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': True,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'ROLE'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'add-iam-policy-binding',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'beta',
                                                                                                              u'organizations',
                                                                                                              u'add-iam-policy-binding'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'ID for the organization to which you want to add a binding',
                                                                                                                      u'name': u'id',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'ORGANIZATION_ID'}],
                                                                                                    u'release': u'BETA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Adds a policy binding to the IAM policy of an organization,\ngiven an organization ID and the binding.',
                                                                                                                  u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on a organization with\nidentifier '123456789'\n\n  $ add-iam-policy-binding 123456789 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                        u'describe': {u'capsule': u'*(BETA)* Show metadata for an organization.',
                                                                                      u'commands': {},
                                                                                      u'flags': {},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'describe',
                                                                                      u'path': [u'gcloud',
                                                                                                u'beta',
                                                                                                u'organizations',
                                                                                                u'describe'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'ID for the organization you want to describe.',
                                                                                                        u'name': u'id',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'value': u'ORGANIZATION_ID'}],
                                                                                      u'release': u'BETA',
                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Shows metadata for an organization, given a valid organization ID.\n\nThis command can fail for the following reasons:\n    * The organization specified does not exist.\n    * The active account does not have permission to access the given\n      organization.',
                                                                                                    u'EXAMPLES': u'The following command prints metadata for an organization with the\nID `3589215982`:\n\n  $ describe 3589215982\n'}},
                                                                        u'get-iam-policy': {u'capsule': u'*(BETA)* Get IAM policy for an organization.',
                                                                                            u'commands': {},
                                                                                            u'flags': {},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'get-iam-policy',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'beta',
                                                                                                      u'organizations',
                                                                                                      u'get-iam-policy'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'ID for the organization whose policy you want to get.',
                                                                                                              u'name': u'id',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'ORGANIZATION_ID'}],
                                                                                            u'release': u'BETA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Gets the IAM policy for an organization, given an organization ID.',
                                                                                                          u'EXAMPLES': u'The following command prints the IAM policy for an organization with\nthe ID `123456789`:\n\n  $ get-iam-policy 123456789\n'}},
                                                                        u'list': {u'capsule': u'*(BETA)* List organizations accessible by the active account.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--filter',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'EXPRESSION'},
                                                                                             u'--limit': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--limit',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'LIMIT'},
                                                                                             u'--no-uri': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': True,
                                                                                                           u'description': u'',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': True,
                                                                                                           u'name': u'--no-uri',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'NO_URI'},
                                                                                             u'--page-size': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--page-size',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                             u'--sort-by': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--sort-by',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'list',
                                                                                                            u'value': u'FIELD'},
                                                                                             u'--uri': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': False,
                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--uri',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'URI'}},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'list',
                                                                                  u'path': [u'gcloud',
                                                                                            u'beta',
                                                                                            u'organizations',
                                                                                            u'list'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'BETA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all organizations to which the user has access. Organizations are listed\nin an unspecified order.'}},
                                                                        u'remove-iam-policy-binding': {u'capsule': u'*(BETA)* Remove IAM policy binding for a organization.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--member': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The member to remove from the binding.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--member',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'MEMBER'},
                                                                                                                  u'--role': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The role to remove the member from.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--role',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'ROLE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'remove-iam-policy-binding',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'organizations',
                                                                                                                 u'remove-iam-policy-binding'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'ID for the organization whose IAM binding you want to remove.',
                                                                                                                         u'name': u'id',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'ORGANIZATION_ID'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Removes a policy binding to the IAM policy of an organization, given an\norganization ID\nand the binding.',
                                                                                                                     u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on organization with\nidentifier 'example-organization-id-1'\n\n  $ remove-iam-policy-binding example-organization-id-1 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                        u'set-iam-policy': {u'capsule': u'*(BETA)* Set IAM policy for an organization.',
                                                                                            u'commands': {},
                                                                                            u'flags': {},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'set-iam-policy',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'beta',
                                                                                                      u'organizations',
                                                                                                      u'set-iam-policy'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'ID for the organization whose IAM policy you want to set.',
                                                                                                              u'name': u'id',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'ORGANIZATION_ID'},
                                                                                                             {u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'JSON or YAML file containing the IAM policy.',
                                                                                                              u'name': u'policy-file',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'POLICY_FILE'}],
                                                                                            u'release': u'BETA',
                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Given an organization ID and a file encoded in JSON or YAML that contains the\nIAM policy, this command will set the IAM policy for that organization.',
                                                                                                          u'EXAMPLES': u'The following command reads an IAM policy defined in a JSON\nfile `policy.json` and sets it for an organization with the ID\n`123456789`:\n\n  $ set-iam-policy 123456789 policy.json'}}},
                                                          u'flags': {},
                                                          u'group': True,
                                                          u'groups': {},
                                                          u'hidden': False,
                                                          u'name': u'organizations',
                                                          u'path': [u'gcloud',
                                                                    u'beta',
                                                                    u'organizations'],
                                                          u'positionals': [],
                                                          u'release': u'BETA',
                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* The organizations group lets you create and manage Cloud Organizations.\nGoogle Cloud Platform resources form a hierarchy with Organizations at the\nroot. Organizations contain projects, and Projects contain the remaining\nGoogle Cloud Platform resources.\n\nMore information on the Cloud Platform Resource Hierarchy and the Organization\nresource can be found here:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-organization\nand detailed documentation on creating and managing organizations can be found\nhere:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-organization'}},
                                       u'projects': {u'capsule': u'*(BETA)* Create and manage project access policies.',
                                                     u'commands': {u'add-iam-policy-binding': {u'capsule': u'*(BETA)* Add IAM policy binding for a project.',
                                                                                               u'commands': {},
                                                                                               u'flags': {u'--member': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The member to add to the binding.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--member',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': True,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'MEMBER'},
                                                                                                          u'--role': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Define the role of the member.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--role',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': True,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'ROLE'}},
                                                                                               u'group': False,
                                                                                               u'groups': {},
                                                                                               u'hidden': False,
                                                                                               u'name': u'add-iam-policy-binding',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'beta',
                                                                                                         u'projects',
                                                                                                         u'add-iam-policy-binding'],
                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'ID for the project you want to add IAM policy binding to.',
                                                                                                                 u'name': u'id',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'value': u'PROJECT_ID'}],
                                                                                               u'release': u'BETA',
                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Adds a policy binding to the IAM policy of a project,\ngiven a project ID and the binding.',
                                                                                                             u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on a project with\nidentifier 'example-project-id-1'\n\n  $ add-iam-policy-binding example-project-id-1 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                   u'delete': {u'capsule': u'*(BETA)* Delete a project.',
                                                                               u'commands': {},
                                                                               u'flags': {},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'delete',
                                                                               u'path': [u'gcloud',
                                                                                         u'beta',
                                                                                         u'projects',
                                                                                         u'delete'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'ID for the project you want to delete.',
                                                                                                 u'name': u'id',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'PROJECT_ID'}],
                                                                               u'release': u'BETA',
                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes the project with the given project ID.\n\nThis command can fail for the following reasons:\n* The project specified does not exist.\n* The active account does not have Owner permissions for the given project.\n\n## EXAMPLES\n\nThe following command deletes the project with the ID `example-foo-bar-1`:\n\n  $ delete example-foo-bar-1'}},
                                                                   u'describe': {u'capsule': u'*(BETA)* Show metadata for a project.',
                                                                                 u'commands': {},
                                                                                 u'flags': {},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'describe',
                                                                                 u'path': [u'gcloud',
                                                                                           u'beta',
                                                                                           u'projects',
                                                                                           u'describe'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'ID for the project you want to describe.',
                                                                                                   u'name': u'id',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'PROJECT_ID'}],
                                                                                 u'release': u'BETA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Shows metadata for a project given a valid project ID.\n\nThis command can fail for the following reasons:\n* The project specified does not exist.\n* The active account does not have permission to access the given project.\n\n## EXAMPLES\n\nThe following command prints metadata for a project with the ID\n`example-foo-bar-1`:\n\n  $ describe example-foo-bar-1'}},
                                                                   u'get-iam-policy': {u'capsule': u'*(BETA)* Get IAM policy for a project.',
                                                                                       u'commands': {},
                                                                                       u'flags': {},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'get-iam-policy',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'beta',
                                                                                                 u'projects',
                                                                                                 u'get-iam-policy'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'ID for the project you want to get IAM policy for.',
                                                                                                         u'name': u'id',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'value': u'PROJECT_ID'}],
                                                                                       u'release': u'BETA',
                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Gets the IAM policy for a project, given a project ID.\n\n## EXAMPLES\n\nThe following command prints the IAM policy for a project with the ID\n`example-project-id-1`:\n\n  $ get-iam-policy example-project-id-1'}},
                                                                   u'list': {u'capsule': u'*(BETA)* List projects accessible by the active account.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--filter',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'EXPRESSION'},
                                                                                        u'--limit': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--limit',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'LIMIT'},
                                                                                        u'--no-uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': True,
                                                                                                      u'description': u'',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': True,
                                                                                                      u'name': u'--no-uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'NO_URI'},
                                                                                        u'--page-size': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--page-size',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                        u'--sort-by': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--sort-by',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'FIELD'},
                                                                                        u'--uri': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': False,
                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--uri',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'URI'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'list',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'projects',
                                                                                       u'list'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all active projects, where the active account has Owner, Editor or\nViewer permissions. Projects are listed in alphabetical order by project name.\nProjects that have been deleted or are pending deletion are not included.\n\nYou can specify the maximum number of projects to list using the `--limit`\nflag.\n\n## EXAMPLES\n\nThe following command lists a maximum of five projects sorted alphabetically\nby name:\n\n  $ list --limit=5'}},
                                                                   u'move': {u'capsule': u'*(BETA)* Move a project into an organization.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--folder': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'ID for the folder to use as a parent',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--folder',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'FOLDER_ID'},
                                                                                        u'--organization': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'ID for the organization to use as a parent',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--organization',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'ORGANIZATION_ID'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'move',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'projects',
                                                                                       u'move'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'ID for the project you want to move.',
                                                                                               u'name': u'id',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'value': u'PROJECT_ID'}],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Moves the given project into the given organization.\n\nThis command can fail for the following reasons:\n    * There is no project with the given ID.\n    * There is no organization with the given ID, if an organization is given\n      as the destination.\n    * There is no folder with the given ID, if a folder is given as the\n      destination.\n    * More than one of organization or folder is provided.\n    * The new destination is not in the same organization as the project, if\n      the project is already in an organization.\n    * The active account does not have  the\n      resourcemanager.projects.update permission for the given\n      project.\n    * The active account does not have  the\n      resourcemanager.projects.create permission for the given\n      organization.\n    * The given project is already in an organization.\n\n## EXAMPLES\n\nThe following command moves a project with the ID `super-awesome-project` into\nthe organization `25872158`:\n\n  $ move super-awesome-project --organization=25872158'}},
                                                                   u'remove-iam-policy-binding': {u'capsule': u'*(BETA)* Remove IAM policy binding for a project.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {u'--member': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The member to remove from the binding.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--member',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': True,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'MEMBER'},
                                                                                                             u'--role': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The role to remove the member from.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--role',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': True,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'ROLE'}},
                                                                                                  u'group': False,
                                                                                                  u'groups': {},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'remove-iam-policy-binding',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'beta',
                                                                                                            u'projects',
                                                                                                            u'remove-iam-policy-binding'],
                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'ID for the project you want to remove IAM policy binding from.',
                                                                                                                    u'name': u'id',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'PROJECT_ID'}],
                                                                                                  u'release': u'BETA',
                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Removes a policy binding to the IAM policy of a project, given a project ID\nand the binding.',
                                                                                                                u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on project with\nidentifier 'example-project-id-1'\n\n  $ remove-iam-policy-binding example-project-id-1 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                   u'set-iam-policy': {u'capsule': u'*(BETA)* Set IAM policy for a project.',
                                                                                       u'commands': {},
                                                                                       u'flags': {},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'set-iam-policy',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'beta',
                                                                                                 u'projects',
                                                                                                 u'set-iam-policy'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'ID for the project you want to set IAM policy for.',
                                                                                                         u'name': u'id',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'value': u'PROJECT_ID'},
                                                                                                        {u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'JSON or YAML file with the IAM policy',
                                                                                                         u'name': u'policy-file',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'value': u'POLICY_FILE'}],
                                                                                       u'release': u'BETA',
                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Sets the IAM policy for a project, given a project ID and a file encoded in\nJSON or YAML that contains the IAM policy.\n\n## EXAMPLES\n\nThe following command reads an IAM policy defined in a JSON file `policy.json`\nand sets it for a project with the ID `example-project-id-1`:\n\n  $ set-iam-policy example-project-id-1 policy.json'}},
                                                                   u'undelete': {u'capsule': u'*(BETA)* Undelete a project.',
                                                                                 u'commands': {},
                                                                                 u'flags': {},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'undelete',
                                                                                 u'path': [u'gcloud',
                                                                                           u'beta',
                                                                                           u'projects',
                                                                                           u'undelete'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'ID for the project you want to undelete.',
                                                                                                   u'name': u'id',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'PROJECT_ID'}],
                                                                                 u'release': u'BETA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Undeletes the project with the given project ID.\n\nThis command can fail for the following reasons:\n* There is no project with the given ID.\n* The active account does not have Owner or Editor permissions for the\n  given project.\n\n## EXAMPLES\n\nThe following command undeletes the project with the ID `example-foo-bar-1`:\n\n  $ undelete example-foo-bar-1'}},
                                                                   u'update': {u'capsule': u'*(BETA)* Update the name of a project.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--name': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'New name for the project.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--name',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'NAME'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'update',
                                                                               u'path': [u'gcloud',
                                                                                         u'beta',
                                                                                         u'projects',
                                                                                         u'update'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'ID for the project you want to update.',
                                                                                                 u'name': u'id',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'PROJECT_ID'}],
                                                                               u'release': u'BETA',
                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* Update the the name of the given project.\n\nThis command can fail for the following reasons:\n* There is no project with the given ID.\n* The active account does not have Owner or Editor permissions for the\n  given project.\n\n## EXAMPLES\n\nThe following command updates a project with the ID\n`example-foo-bar-1` to have the name "Foo Bar & Grill":\n\n  $ update example-foo-bar-1 --name="Foo Bar & Grill"'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'projects',
                                                     u'path': [u'gcloud',
                                                               u'beta',
                                                               u'projects'],
                                                     u'positionals': [],
                                                     u'release': u'BETA',
                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* The projects group lets you create and manage IAM policies for projects on\nthe Google Cloud Platform. Resources are organized hierarchically and assigned\nto a particular project.  A Project resource is required to use Google Cloud\nPlatform, and forms the basis for creating, enabling and using all Cloud\nPlatform services, managing APIs, enabling billing, adding and removing\ncollaborators, and managing permissions.\n\nMore information on the Cloud Platform Resource Hierarchy and the project\nresource can be found here:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-organization\nand detailed documentation on creating and managing projects can be found\nhere:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-projects'}},
                                       u'pubsub': {u'capsule': u'*(BETA)* Manage Cloud Pub/Sub topics and subscriptions.',
                                                   u'commands': {u'subscriptions': {u'capsule': u'*(BETA)* Manage Cloud Pubsub subscriptions.',
                                                                                    u'commands': {u'ack': {u'capsule': u'*(BETA)* Acknowledges one or more messages on the specified subscription.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'ack',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'pubsub',
                                                                                                                     u'subscriptions',
                                                                                                                     u'ack'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Subscription name to ACK messages on.',
                                                                                                                             u'name': u'subscription',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'SUBSCRIPTION'},
                                                                                                                            {u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'One or more AckId to acknowledge.',
                                                                                                                             u'name': u'ackid',
                                                                                                                             u'nargs': u'+',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'ACKID'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Acknowledges one or more messages as having been successfully received.\nIf a delivered message is not acknowledged, Cloud Pub/Sub will attempt to\ndeliver it again.'}},
                                                                                                  u'create': {u'capsule': u'*(BETA)* Creates one or more Cloud Pub/Sub subscriptions.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--ack-deadline': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The number of seconds the system will wait for a subscriber to acknowledge receiving a message before re-attempting delivery.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--ack-deadline',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ACK_DEADLINE'},
                                                                                                                         u'--push-endpoint': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A URL to use as the endpoint for this subscription. This will also automatically set the subscription type to PUSH.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--push-endpoint',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PUSH_ENDPOINT'},
                                                                                                                         u'--topic': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the topic from which this subscription is receiving messages. Each subscription is attached to a single topic.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--topic',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'TOPIC'},
                                                                                                                         u'--topic-project': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The name of the project the provided topic belongs to. If not set, it defaults to the currently selected cloud project.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--topic-project',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'TOPIC_PROJECT'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'create',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'pubsub',
                                                                                                                        u'subscriptions',
                                                                                                                        u'create'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'One or more subscriptions to create.',
                                                                                                                                u'name': u'subscription',
                                                                                                                                u'nargs': u'+',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'SUBSCRIPTION'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Creates one or more Cloud Pub/Sub subscriptions for a given topic.\nThe new subscription defaults to a PULL subscription unless a push endpoint\nis specified.'}},
                                                                                                  u'delete': {u'capsule': u'*(BETA)* Deletes one or more Cloud Pub/Sub subscriptions.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'delete',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'pubsub',
                                                                                                                        u'subscriptions',
                                                                                                                        u'delete'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'One or more subscription names to delete.',
                                                                                                                                u'name': u'subscription',
                                                                                                                                u'nargs': u'+',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'SUBSCRIPTION'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes one or more Cloud Pub/Sub subscriptions.'}},
                                                                                                  u'list': {u'capsule': u'*(BETA)* Lists Cloud Pub/Sub subscriptions.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--filter',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--limit',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_URI'},
                                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--page-size',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'FIELD'},
                                                                                                                       u'--uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'URI'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'list',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'pubsub',
                                                                                                                      u'subscriptions',
                                                                                                                      u'list'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all of the Cloud Pub/Sub subscriptions that exist in a given project.'}},
                                                                                                  u'modify-ack-deadline': {u'capsule': u'*(BETA)* Modifies the ACK deadline for a specific Cloud Pub/Sub message.',
                                                                                                                           u'commands': {},
                                                                                                                           u'flags': {u'--ack-deadline': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The number of seconds the system will wait for a subscriber to acknowledge receiving a message before re-attempting delivery.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--ack-deadline',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': True,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'ACK_DEADLINE'}},
                                                                                                                           u'group': False,
                                                                                                                           u'groups': {},
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'modify-ack-deadline',
                                                                                                                           u'path': [u'gcloud',
                                                                                                                                     u'beta',
                                                                                                                                     u'pubsub',
                                                                                                                                     u'subscriptions',
                                                                                                                                     u'modify-ack-deadline'],
                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Name of the subscription messages belong to.',
                                                                                                                                             u'name': u'subscription',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'SUBSCRIPTION'},
                                                                                                                                            {u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'One or more ACK_ID that identify the messages to modify the deadline for.',
                                                                                                                                             u'name': u'ackid',
                                                                                                                                             u'nargs': u'+',
                                                                                                                                             u'required': False,
                                                                                                                                             u'value': u'ACKID'}],
                                                                                                                           u'release': u'BETA',
                                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* This method is useful to indicate that more time is needed to process a\nmessage by the subscriber, or to make the message available for\nredelivery if the processing was interrupted.'}},
                                                                                                  u'modify-push-config': {u'capsule': u'*(BETA)* Modifies the push configuration of a Cloud Pub/Sub subscription.',
                                                                                                                          u'commands': {},
                                                                                                                          u'flags': {u'--push-endpoint': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'A URL to use as the endpoint for this subscription. This will also automatically set the subscription type to PUSH.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--push-endpoint',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': True,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'PUSH_ENDPOINT'}},
                                                                                                                          u'group': False,
                                                                                                                          u'groups': {},
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'modify-push-config',
                                                                                                                          u'path': [u'gcloud',
                                                                                                                                    u'beta',
                                                                                                                                    u'pubsub',
                                                                                                                                    u'subscriptions',
                                                                                                                                    u'modify-push-config'],
                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Name of the subscription to modify.',
                                                                                                                                            u'name': u'subscription',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'value': u'SUBSCRIPTION'}],
                                                                                                                          u'release': u'BETA',
                                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Modifies the push configuration of a Cloud Pub/Sub subscription.'}},
                                                                                                  u'pull': {u'capsule': u'*(BETA)* Pulls one or more Cloud Pub/Sub messages from a subscription.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--auto-ack': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Automatically ACK every message pulled from this subscription.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--auto-ack',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'AUTO_ACK'},
                                                                                                                       u'--filter': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--filter',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--limit',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                       u'--max-messages': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': 1,
                                                                                                                                           u'description': u'The maximum number of messages that Cloud Pub/Sub can return in this response.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--max-messages',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'int',
                                                                                                                                           u'value': u'MAX_MESSAGES'},
                                                                                                                       u'--no-auto-ack': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-auto-ack',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_AUTO_ACK'},
                                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_URI'},
                                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--page-size',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'FIELD'},
                                                                                                                       u'--uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'URI'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'pull',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'pubsub',
                                                                                                                      u'subscriptions',
                                                                                                                      u'pull'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Name of subscription to pull messages from.',
                                                                                                                              u'name': u'subscription',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'SUBSCRIPTION'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Returns one or more messages from the specified Cloud Pub/Sub subscription,\nif there are any messages enqueued.'}}},
                                                                                    u'flags': {},
                                                                                    u'group': True,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'subscriptions',
                                                                                    u'path': [u'gcloud',
                                                                                              u'beta',
                                                                                              u'pubsub',
                                                                                              u'subscriptions'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'BETA',
                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Manage Cloud Pubsub subscriptions.'}},
                                                                 u'topics': {u'capsule': u'*(BETA)* Manage Cloud Pubsub topics.',
                                                                             u'commands': {u'create': {u'capsule': u'*(BETA)* Creates one or more Cloud Pub/Sub topics.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'create',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'pubsub',
                                                                                                                 u'topics',
                                                                                                                 u'create'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'One or more topic names to create.',
                                                                                                                         u'name': u'topic',
                                                                                                                         u'nargs': u'+',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'TOPIC'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Creates one or more Cloud Pub/Sub topics.'}},
                                                                                           u'delete': {u'capsule': u'*(BETA)* Deletes one or more Cloud Pub/Sub topics.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'pubsub',
                                                                                                                 u'topics',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'One or more topic names to delete.',
                                                                                                                         u'name': u'topic',
                                                                                                                         u'nargs': u'+',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'TOPIC'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes one or more Cloud Pub/Sub topics.'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* Lists Cloud Pub/Sub topics within a project.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'pubsub',
                                                                                                               u'topics',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all of the Cloud Pub/Sub topics that exist in a given project that\nmatch the given topic name filter.',
                                                                                                                   u'EXAMPLES': u'To filter results by topic name (ie. only show topic \'mytopic\'), run:\n\n  $ list --filter=topicId:mytopic\n\nTo combine multiple filters (with AND or OR), run:\n\n  $ list --filter="topicId:mytopic AND topicId:myothertopic"\n\nTo filter topics that match an expression:\n\n  $ list --filter="topicId:mytopic_*"\n'}},
                                                                                           u'list-subscriptions': {u'capsule': u'*(BETA)* Lists Cloud Pub/Sub subscriptions from a given topic.',
                                                                                                                   u'commands': {},
                                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--filter',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                                              u'--limit': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--limit',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'LIMIT'},
                                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-uri',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_URI'},
                                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--page-size',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--sort-by',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'FIELD'},
                                                                                                                              u'--uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'URI'}},
                                                                                                                   u'group': False,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'list-subscriptions',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'beta',
                                                                                                                             u'pubsub',
                                                                                                                             u'topics',
                                                                                                                             u'list-subscriptions'],
                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The name of the topic to list subscriptions for.',
                                                                                                                                     u'name': u'topic',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'value': u'TOPIC'}],
                                                                                                                   u'release': u'BETA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all of the Cloud Pub/Sub subscriptions attached to the given topic and\nthat match the given filter.',
                                                                                                                                 u'EXAMPLES': u'To filter results by subscription name\n(ie. only show subscription \'mysubs\'), run:\n\n  $ list-subscriptions --topic mytopic --filter=subscriptionId:mysubs\n\nTo combine multiple filters (with AND or OR), run:\n\n  $ list-subscriptions --topic mytopic --filter="subscriptionId:mysubs1 AND subscriptionId:mysubs2"\n\nTo filter subscriptions that match an expression:\n\n  $ list-subscriptions --topic mytopic --filter="subscriptionId:subs_*"\n'}},
                                                                                           u'publish': {u'capsule': u'*(BETA)* Publishes a message to the specified topic.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--attribute': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Comma-separated list of attributes. Each ATTRIBUTE has the form "name=value". You can specify up to 100 attributes.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--attribute',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'dict',
                                                                                                                                    u'value': u'ATTRIBUTE'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'publish',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'pubsub',
                                                                                                                  u'topics',
                                                                                                                  u'publish'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Topic name to publish messages to.',
                                                                                                                          u'name': u'topic',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'TOPIC'},
                                                                                                                         {u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The body of the message to publish to the given topic name.\nInformation on message formatting and size limits can be found at:\nhttps://cloud.google.com/pubsub/docs/publisher#publish',
                                                                                                                          u'name': u'message-body',
                                                                                                                          u'nargs': u'?',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'MESSAGE_BODY'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Publishes a message to the specified topic name for testing and\ntroubleshooting. Use with caution: all associated subscribers must be\nable to consume and acknowledge any message you publish, otherwise the\nsystem will continuously re-attempt delivery of the bad message for 7 days.'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'topics',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'pubsub',
                                                                                       u'topics'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Manage Cloud Pubsub topics.'}}},
                                                   u'flags': {},
                                                   u'group': True,
                                                   u'groups': {},
                                                   u'hidden': False,
                                                   u'name': u'pubsub',
                                                   u'path': [u'gcloud',
                                                             u'beta',
                                                             u'pubsub'],
                                                   u'positionals': [],
                                                   u'release': u'BETA',
                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* Manage Cloud Pub/Sub topics and subscriptions.'}},
                                       u'runtime-config': {u'capsule': u'*(BETA)* Manage runtime configuration resources.',
                                                           u'commands': {u'configs': {u'capsule': u'*(BETA)* Commands for RuntimeConfig configs.',
                                                                                      u'commands': {u'create': {u'capsule': u'*(BETA)* Create runtime-config resources.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--description': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Optional description of the runtime-config resource.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--description',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'DESCRIPTION'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'create',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'runtime-config',
                                                                                                                          u'configs',
                                                                                                                          u'create'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The runtime-config resource name.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* This command creates a new runtime-config resource with the specified name\nand optional description.',
                                                                                                                              u'EXAMPLES': u'To create a runtime-config resource named "my-config", run:\n\n  $ create my-config\n\nTo create a runtime-config resource named "my-config" with a\ndescription, run:\n\n  $ create --description "my new configuration" my-config\n'}},
                                                                                                    u'delete': {u'capsule': u'*(BETA)* Delete runtime-config resources.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'delete',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'runtime-config',
                                                                                                                          u'configs',
                                                                                                                          u'delete'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The runtime-config resource name.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* This command deletes the runtime-config resource with the specified name and\nall of its variable and waiter children.',
                                                                                                                              u'EXAMPLES': u'To delete a runtime-config resource named "my-config", run:\n\n  $ delete my-config\n'}},
                                                                                                    u'describe': {u'capsule': u'*(BETA)* Describe runtime-config resources.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'describe',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'runtime-config',
                                                                                                                            u'configs',
                                                                                                                            u'describe'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The runtime-config resource name.',
                                                                                                                                    u'name': u'name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* This command displays information about the runtime-config resource with the\nspecified name.',
                                                                                                                                u'EXAMPLES': u'To describe a runtime-config resource named "my-config", run:\n\n  $ describe my-config\n'}},
                                                                                                    u'list': {u'capsule': u'*(BETA)* List runtime-config resources within the current project.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--filter',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'EXPRESSION'},
                                                                                                                         u'--limit': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--limit',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'LIMIT'},
                                                                                                                         u'--no-uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_URI'},
                                                                                                                         u'--page-size': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--page-size',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                                                         u'--sort-by': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--sort-by',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'list',
                                                                                                                                        u'value': u'FIELD'},
                                                                                                                         u'--uri': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--uri',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'URI'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'list',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'runtime-config',
                                                                                                                        u'configs',
                                                                                                                        u'list'],
                                                                                                              u'positionals': [],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* This command lists runtime-config resources for the current project.',
                                                                                                                            u'EXAMPLES': u"To list all runtime-config resources for the current project, run:\n\n  $ list\n\nThe --filter parameter can be used to filter results based on content.\nFor example, to list all runtime-config resources with names that\nbegin with 'foo', run:\n\n  $ list --filter 'name=foo*'\n"}},
                                                                                                    u'update': {u'capsule': u'*(BETA)* Update runtime-config resources.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--description': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The new description of the configuration.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--description',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': True,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'DESCRIPTION'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'update',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'runtime-config',
                                                                                                                          u'configs',
                                                                                                                          u'update'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The configuration name.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* This command updates the runtime-config resource with the specified\ndescription.',
                                                                                                                              u'EXAMPLES': u'To update a runtime-config resource\'s description, run:\n\n  $ update --description "My new description" my-config\n\nTo remove a runtime-config resource\'s description, run:\n\n  $ update --description "" my-config\n'}},
                                                                                                    u'variables': {u'capsule': u'*(BETA)* Manage variable resources.',
                                                                                                                   u'commands': {u'describe': {u'capsule': u'*(BETA)* Describe variable resources.',
                                                                                                                                               u'commands': {},
                                                                                                                                               u'flags': {u'--config-name': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': None,
                                                                                                                                                                             u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--config-name',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'string',
                                                                                                                                                                             u'value': u'CONFIG_NAME'}},
                                                                                                                                               u'group': False,
                                                                                                                                               u'groups': {},
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'describe',
                                                                                                                                               u'path': [u'gcloud',
                                                                                                                                                         u'beta',
                                                                                                                                                         u'runtime-config',
                                                                                                                                                         u'configs',
                                                                                                                                                         u'variables',
                                                                                                                                                         u'describe'],
                                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The variable name.',
                                                                                                                                                                 u'name': u'name',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'value': u'NAME'}],
                                                                                                                                               u'release': u'BETA',
                                                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* This command displays information about the variable resource with the\nspecified name.',
                                                                                                                                                             u'EXAMPLES': u'To describe a variable named "my-var", run:\n\n  $ describe --config-name my-config my-var\n'}},
                                                                                                                                 u'get-value': {u'capsule': u'*(BETA)* Output values of variable resources.',
                                                                                                                                                u'commands': {},
                                                                                                                                                u'flags': {u'--config-name': {u'attr': {},
                                                                                                                                                                              u'category': u'',
                                                                                                                                                                              u'choices': [],
                                                                                                                                                                              u'completer': u'',
                                                                                                                                                                              u'default': None,
                                                                                                                                                                              u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                              u'group': u'',
                                                                                                                                                                              u'hidden': False,
                                                                                                                                                                              u'name': u'--config-name',
                                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                                              u'required': False,
                                                                                                                                                                              u'type': u'string',
                                                                                                                                                                              u'value': u'CONFIG_NAME'}},
                                                                                                                                                u'group': False,
                                                                                                                                                u'groups': {},
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'get-value',
                                                                                                                                                u'path': [u'gcloud',
                                                                                                                                                          u'beta',
                                                                                                                                                          u'runtime-config',
                                                                                                                                                          u'configs',
                                                                                                                                                          u'variables',
                                                                                                                                                          u'get-value'],
                                                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'The variable name.',
                                                                                                                                                                  u'name': u'name',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'value': u'NAME'}],
                                                                                                                                                u'release': u'BETA',
                                                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* This command prints only the value of the variable resource with the\nspecified name, and does not append a trailing newline character.\nIt can be used as part of shell expansions.',
                                                                                                                                                              u'EXAMPLES': u'To print the value of a variable named "my-var", run:\n\n  $ get-value --config-name my-config my-var\n\nValues will be automatically base64-decoded.\n'}},
                                                                                                                                 u'list': {u'capsule': u'*(BETA)* List variable resources within a configuration.',
                                                                                                                                           u'commands': {},
                                                                                                                                           u'flags': {u'--config-name': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--config-name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'CONFIG_NAME'},
                                                                                                                                                      u'--filter': {u'attr': {},
                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--filter',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--limit',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'string',
                                                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': True,
                                                                                                                                                                    u'description': u'',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': True,
                                                                                                                                                                    u'name': u'--no-uri',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'bool',
                                                                                                                                                                    u'value': u'NO_URI'},
                                                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--page-size',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'list',
                                                                                                                                                                     u'value': u'FIELD'},
                                                                                                                                                      u'--uri': {u'attr': {},
                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': False,
                                                                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--uri',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'bool',
                                                                                                                                                                 u'value': u'URI'}},
                                                                                                                                           u'group': False,
                                                                                                                                           u'groups': {},
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'list',
                                                                                                                                           u'path': [u'gcloud',
                                                                                                                                                     u'beta',
                                                                                                                                                     u'runtime-config',
                                                                                                                                                     u'configs',
                                                                                                                                                     u'variables',
                                                                                                                                                     u'list'],
                                                                                                                                           u'positionals': [],
                                                                                                                                           u'release': u'BETA',
                                                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* This command lists the variable resources within a specified configuration.',
                                                                                                                                                         u'EXAMPLES': u'To list all variables within the configuration named "my-config", run:\n\n  $ list --config-name my-config\n\nThe --filter parameter can be used to filter results based on content.\nFor example, to list all variables under the path \'status/\', run:\n\n  $ list --config-name my-config --filter \'name=status/*\'\n'}},
                                                                                                                                 u'set': {u'capsule': u'*(BETA)* Create or update variable resources.',
                                                                                                                                          u'commands': {},
                                                                                                                                          u'flags': {u'--config-name': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': None,
                                                                                                                                                                        u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--config-name',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'string',
                                                                                                                                                                        u'value': u'CONFIG_NAME'},
                                                                                                                                                     u'--fail-if-absent': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': False,
                                                                                                                                                                           u'description': u'Fail if a variable with the specified name does not exist.',
                                                                                                                                                                           u'group': u'set.1',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--fail-if-absent',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'bool',
                                                                                                                                                                           u'value': u'FAIL_IF_ABSENT'},
                                                                                                                                                     u'--fail-if-present': {u'attr': {},
                                                                                                                                                                            u'category': u'',
                                                                                                                                                                            u'choices': [],
                                                                                                                                                                            u'completer': u'',
                                                                                                                                                                            u'default': False,
                                                                                                                                                                            u'description': u'Fail if a variable with the specified name already exists.',
                                                                                                                                                                            u'group': u'set.1',
                                                                                                                                                                            u'hidden': False,
                                                                                                                                                                            u'name': u'--fail-if-present',
                                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                                            u'required': False,
                                                                                                                                                                            u'type': u'bool',
                                                                                                                                                                            u'value': u'FAIL_IF_PRESENT'},
                                                                                                                                                     u'--is-text': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': False,
                                                                                                                                                                    u'description': u'If True, send and store the value as text. Can be used if the value contains only text (UTF-8 encoded). This affects how the variable is transmitted on the wire and requires less quota on the backend.',
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--is-text',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'bool',
                                                                                                                                                                    u'value': u'IS_TEXT'},
                                                                                                                                                     u'--no-is-text': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': False,
                                                                                                                                                                       u'description': u'',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': True,
                                                                                                                                                                       u'name': u'--no-is-text',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'bool',
                                                                                                                                                                       u'value': u'NO_IS_TEXT'}},
                                                                                                                                          u'group': False,
                                                                                                                                          u'groups': {u'set.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                 u'is_mutex': True,
                                                                                                                                                                 u'is_required': False}},
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'set',
                                                                                                                                          u'path': [u'gcloud',
                                                                                                                                                    u'beta',
                                                                                                                                                    u'runtime-config',
                                                                                                                                                    u'configs',
                                                                                                                                                    u'variables',
                                                                                                                                                    u'set'],
                                                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The variable name.',
                                                                                                                                                            u'name': u'name',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'value': u'NAME'},
                                                                                                                                                           {u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The variable value. If absent, the value will be read from stdin. The value is automatically base64-encoded, unless --is-text flag is set.',
                                                                                                                                                            u'name': u'value',
                                                                                                                                                            u'nargs': u'?',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'value': u'VALUE'}],
                                                                                                                                          u'release': u'BETA',
                                                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* This command creates or updates a variable resource, setting its value to\nthe specified string or file contents.',
                                                                                                                                                        u'EXAMPLES': u'To create or update a variable named "my-var", run:\n\n  $ set --config-name my-config my-var "my value"\n\nTo create or update a variable with a hierarchical name, such as\n"results/task1", run:\n\n  $ set --config-name my-config results/task1 "my value"\n\nTo create a variable, but fail if it already exists, run:\n\n  $ set --config-name my-config my-var "my-value" --fail-if-present\n\nTo update a variable, but fail if it does not exist, run:\n\n  $ set --config-name my-config my-var "my-value" --fail-if-absent\n\nIt is possible to provide --is-text flag if the value contains only\ntext (UTF-8 encoded). This affects how the variable is transmitted on\nthe wire and requires less quota on the backend.\n\n  $ set --config-name my-config --is-text my-var "my value"\n\nIf the variable\'s value parameter is not specified, the value will be\nread from standard input. This allows setting variables to large values\nor values that contain non-printable characters. The variable value\nwill be automatically base64-encoded. For example, to set a variable\'s\nvalue to the contents of a file, run:\n\n  $ cat my-file | set --config-name my-config my-var\n'}},
                                                                                                                                 u'unset': {u'capsule': u'*(BETA)* Delete variable resources.',
                                                                                                                                            u'commands': {},
                                                                                                                                            u'flags': {u'--config-name': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--config-name',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'CONFIG_NAME'},
                                                                                                                                                       u'--fail-if-absent': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': False,
                                                                                                                                                                             u'description': u'Fail if a variable with the specified name does not exist.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--fail-if-absent',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'bool',
                                                                                                                                                                             u'value': u'FAIL_IF_ABSENT'},
                                                                                                                                                       u'--no-fail-if-absent': {u'attr': {},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': True,
                                                                                                                                                                                u'description': u'',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': True,
                                                                                                                                                                                u'name': u'--no-fail-if-absent',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                                u'value': u'NO_FAIL_IF_ABSENT'},
                                                                                                                                                       u'--no-recursive': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': True,
                                                                                                                                                                           u'description': u'',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': True,
                                                                                                                                                                           u'name': u'--no-recursive',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'bool',
                                                                                                                                                                           u'value': u'NO_RECURSIVE'},
                                                                                                                                                       u'--recursive': {u'attr': {},
                                                                                                                                                                        u'category': u'',
                                                                                                                                                                        u'choices': [],
                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                        u'default': False,
                                                                                                                                                                        u'description': u'Delete a parent node and all of its children.',
                                                                                                                                                                        u'group': u'',
                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                        u'name': u'--recursive',
                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                        u'required': False,
                                                                                                                                                                        u'type': u'bool',
                                                                                                                                                                        u'value': u'RECURSIVE'}},
                                                                                                                                            u'group': False,
                                                                                                                                            u'groups': {},
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'unset',
                                                                                                                                            u'path': [u'gcloud',
                                                                                                                                                      u'beta',
                                                                                                                                                      u'runtime-config',
                                                                                                                                                      u'configs',
                                                                                                                                                      u'variables',
                                                                                                                                                      u'unset'],
                                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'The variable name.',
                                                                                                                                                              u'name': u'name',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'value': u'NAME'}],
                                                                                                                                            u'release': u'BETA',
                                                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* This command deletes the variable resource with the specified name.',
                                                                                                                                                          u'EXAMPLES': u'To delete a variable named "my-var", run:\n\n  $ unset --config-name my-config my-var\n\nTo delete a variable, but fail if it does not exist, run:\n\n  $ unset --config-name my-config my-var --fail-if-absent\n\nTo recursively delete a parent variable and its children, run:\n\n  $ unset --config-name my-config my-parent-var --recursive\n'}},
                                                                                                                                 u'watch': {u'capsule': u'*(BETA)* Wait for a variable resources to change.',
                                                                                                                                            u'commands': {},
                                                                                                                                            u'flags': {u'--config-name': {u'attr': {},
                                                                                                                                                                          u'category': u'',
                                                                                                                                                                          u'choices': [],
                                                                                                                                                                          u'completer': u'',
                                                                                                                                                                          u'default': None,
                                                                                                                                                                          u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                          u'group': u'',
                                                                                                                                                                          u'hidden': False,
                                                                                                                                                                          u'name': u'--config-name',
                                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                                          u'required': False,
                                                                                                                                                                          u'type': u'string',
                                                                                                                                                                          u'value': u'CONFIG_NAME'},
                                                                                                                                                       u'--max-wait': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'An optional maximum number of seconds to wait.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--max-wait',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'MAX_WAIT'},
                                                                                                                                                       u'--newer-than': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'Return immediately if the stored\n                        variable is newer than this timestamp.',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--newer-than',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'NEWER_THAN'}},
                                                                                                                                            u'group': False,
                                                                                                                                            u'groups': {},
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'watch',
                                                                                                                                            u'path': [u'gcloud',
                                                                                                                                                      u'beta',
                                                                                                                                                      u'runtime-config',
                                                                                                                                                      u'configs',
                                                                                                                                                      u'variables',
                                                                                                                                                      u'watch'],
                                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Variable name.',
                                                                                                                                                              u'name': u'name',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'value': u'NAME'}],
                                                                                                                                            u'release': u'BETA',
                                                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* This command waits for the variable resource with the specified name to either\nhave its value changed or be deleted.',
                                                                                                                                                          u'EXAMPLES': u'To wait for a variable to change or be deleted, run:\n\n  $ watch my-var --config-name my-config\n\nThis command will return after the variable changes,\nis deleted, or a server-defined timeout elapses.\n\nTo wait for user-specified period of 20 seconds, run:\n\n  $ watch my-var --config-name my-config --max-wait 20\n\nIf a watch command returns due to a timeout, the command\'s exit value\nwill be 2. All other errors result in an exit value of 1. If the\nwatched variable changes prior to the timeout, the command will exit\nsuccessfully with a value of 0.\n\nOptionally, a --newer-than parameter can be specified to wait only\nif the variable hasn\'t changed since the specified time. If the\nvariable has changed since the time passed to --newer-than, the\ncommand returns without waiting. For example:\n\n  $ watch my-var --config-name my-config --newer-than "2016-04-05T12:00:00Z"\n'}}},
                                                                                                                   u'flags': {},
                                                                                                                   u'group': True,
                                                                                                                   u'groups': {},
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'variables',
                                                                                                                   u'path': [u'gcloud',
                                                                                                                             u'beta',
                                                                                                                             u'runtime-config',
                                                                                                                             u'configs',
                                                                                                                             u'variables'],
                                                                                                                   u'positionals': [],
                                                                                                                   u'release': u'BETA',
                                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* Manage variable resources.'}},
                                                                                                    u'waiters': {u'capsule': u'*(BETA)* Manage waiter resources.',
                                                                                                                 u'commands': {u'create': {u'capsule': u'*(BETA)* Create waiter resources.',
                                                                                                                                           u'commands': {},
                                                                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                                                                   u'category': u'',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': False,
                                                                                                                                                                   u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--async',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'bool',
                                                                                                                                                                   u'value': u'ASYNC'},
                                                                                                                                                      u'--config-name': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--config-name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'CONFIG_NAME'},
                                                                                                                                                      u'--failure-cardinality-number': {u'attr': {},
                                                                                                                                                                                        u'category': u'',
                                                                                                                                                                                        u'choices': [],
                                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                                        u'default': 1,
                                                                                                                                                                                        u'description': u'The minimum required number of failure variables.',
                                                                                                                                                                                        u'group': u'',
                                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                                        u'name': u'--failure-cardinality-number',
                                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                                        u'required': False,
                                                                                                                                                                                        u'type': u'int',
                                                                                                                                                                                        u'value': u'FAILURE_CARDINALITY_NUMBER'},
                                                                                                                                                      u'--failure-cardinality-path': {u'attr': {},
                                                                                                                                                                                      u'category': u'',
                                                                                                                                                                                      u'choices': [],
                                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                                      u'default': None,
                                                                                                                                                                                      u'description': u'The path where failure variables are written.',
                                                                                                                                                                                      u'group': u'',
                                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                                      u'name': u'--failure-cardinality-path',
                                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                                      u'required': False,
                                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                                      u'value': u'FAILURE_CARDINALITY_PATH'},
                                                                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': True,
                                                                                                                                                                      u'description': u'',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': True,
                                                                                                                                                                      u'name': u'--no-async',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'bool',
                                                                                                                                                                      u'value': u'NO_ASYNC'},
                                                                                                                                                      u'--success-cardinality-number': {u'attr': {},
                                                                                                                                                                                        u'category': u'',
                                                                                                                                                                                        u'choices': [],
                                                                                                                                                                                        u'completer': u'',
                                                                                                                                                                                        u'default': 1,
                                                                                                                                                                                        u'description': u'The minimum required number of success variables.',
                                                                                                                                                                                        u'group': u'',
                                                                                                                                                                                        u'hidden': False,
                                                                                                                                                                                        u'name': u'--success-cardinality-number',
                                                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                                                        u'required': False,
                                                                                                                                                                                        u'type': u'int',
                                                                                                                                                                                        u'value': u'SUCCESS_CARDINALITY_NUMBER'},
                                                                                                                                                      u'--success-cardinality-path': {u'attr': {},
                                                                                                                                                                                      u'category': u'',
                                                                                                                                                                                      u'choices': [],
                                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                                      u'default': None,
                                                                                                                                                                                      u'description': u'The path where success variables are written.',
                                                                                                                                                                                      u'group': u'',
                                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                                      u'name': u'--success-cardinality-path',
                                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                                      u'required': True,
                                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                                      u'value': u'SUCCESS_CARDINALITY_PATH'},
                                                                                                                                                      u'--timeout': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u"The amount of time to wait before failing with DEADLINE_EXCEEDED.\nTimeout values can be specified as seconds, minutes, or hours, using the\n's', 'm', and 'h' suffixes respectively. If no suffix is specified, the\nunit is assumed to be seconds.",
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--timeout',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': True,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'TIMEOUT'}},
                                                                                                                                           u'group': False,
                                                                                                                                           u'groups': {},
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'create',
                                                                                                                                           u'path': [u'gcloud',
                                                                                                                                                     u'beta',
                                                                                                                                                     u'runtime-config',
                                                                                                                                                     u'configs',
                                                                                                                                                     u'waiters',
                                                                                                                                                     u'create'],
                                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The waiter name.',
                                                                                                                                                             u'name': u'name',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'value': u'NAME'}],
                                                                                                                                           u'release': u'BETA',
                                                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* This command creates a new waiter resource with the specified name and\nparameters.',
                                                                                                                                                         u'EXAMPLES': u'To create a waiter in "my-config" with success and failure paths\nnested under "/status", run:\n\n  $ create my-waiter --config-name my-config --timeout 15m --success-cardinality-path /status/success --success-cardinality-number 5 --failure-cardinality-path /status/failure --failure-cardinality-number 1\n\nThis waiter will wait for at most 15 minutes for the first of two\npossible scenarios: 1) five or more variables are written to the\n/status/success/ path; or 2) one or more variables are written to the\n/status/failure/ path.\n\nTo create a waiter without a failure path, run:\n\n  $ create my-waiter --config-name my-config --timeout 15m --success-cardinality-path /status/success --success-cardinality-number 5\n\nThis waiter will wait until 5 or more success variables are written,\nor the 15 minute timeout elapses.\n'}},
                                                                                                                               u'delete': {u'capsule': u'*(BETA)* Delete waiter resources.',
                                                                                                                                           u'commands': {},
                                                                                                                                           u'flags': {u'--config-name': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--config-name',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'string',
                                                                                                                                                                         u'value': u'CONFIG_NAME'}},
                                                                                                                                           u'group': False,
                                                                                                                                           u'groups': {},
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'delete',
                                                                                                                                           u'path': [u'gcloud',
                                                                                                                                                     u'beta',
                                                                                                                                                     u'runtime-config',
                                                                                                                                                     u'configs',
                                                                                                                                                     u'waiters',
                                                                                                                                                     u'delete'],
                                                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The waiter name.',
                                                                                                                                                             u'name': u'name',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'value': u'NAME'}],
                                                                                                                                           u'release': u'BETA',
                                                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* This command deletes the waiter resource with the specified name.',
                                                                                                                                                         u'EXAMPLES': u'To delete a waiter named "my-waiter" within a configuration named\n"my-config", run:\n\n  $ delete my-waiter --config-name my-config\n'}},
                                                                                                                               u'describe': {u'capsule': u'*(BETA)* Describe waiter resources.',
                                                                                                                                             u'commands': {},
                                                                                                                                             u'flags': {u'--config-name': {u'attr': {},
                                                                                                                                                                           u'category': u'',
                                                                                                                                                                           u'choices': [],
                                                                                                                                                                           u'completer': u'',
                                                                                                                                                                           u'default': None,
                                                                                                                                                                           u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                           u'group': u'',
                                                                                                                                                                           u'hidden': False,
                                                                                                                                                                           u'name': u'--config-name',
                                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                                           u'required': False,
                                                                                                                                                                           u'type': u'string',
                                                                                                                                                                           u'value': u'CONFIG_NAME'}},
                                                                                                                                             u'group': False,
                                                                                                                                             u'groups': {},
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'describe',
                                                                                                                                             u'path': [u'gcloud',
                                                                                                                                                       u'beta',
                                                                                                                                                       u'runtime-config',
                                                                                                                                                       u'configs',
                                                                                                                                                       u'waiters',
                                                                                                                                                       u'describe'],
                                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'The waiter name.',
                                                                                                                                                               u'name': u'name',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'value': u'NAME'}],
                                                                                                                                             u'release': u'BETA',
                                                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* This command displays information about the waiter resource with the\nspecified name.',
                                                                                                                                                           u'EXAMPLES': u'To describe a waiter named "my-waiter" within a configuration named\n"my-config", run:\n\n  $ describe my-waiter --config-name my-config\n'}},
                                                                                                                               u'list': {u'capsule': u'*(BETA)* List waiter resources within a configuration.',
                                                                                                                                         u'commands': {},
                                                                                                                                         u'flags': {u'--config-name': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--config-name',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'CONFIG_NAME'},
                                                                                                                                                    u'--filter': {u'attr': {},
                                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': None,
                                                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--filter',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'string',
                                                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                                                 u'choices': [],
                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                 u'default': None,
                                                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                                 u'group': u'',
                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                 u'name': u'--limit',
                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                 u'required': False,
                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': True,
                                                                                                                                                                  u'description': u'',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': True,
                                                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'bool',
                                                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': None,
                                                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': False,
                                                                                                                                                                     u'name': u'--page-size',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'string',
                                                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                                   u'choices': [],
                                                                                                                                                                   u'completer': u'',
                                                                                                                                                                   u'default': None,
                                                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                                   u'group': u'',
                                                                                                                                                                   u'hidden': False,
                                                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                                   u'required': False,
                                                                                                                                                                   u'type': u'list',
                                                                                                                                                                   u'value': u'FIELD'},
                                                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': False,
                                                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--uri',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': False,
                                                                                                                                                               u'type': u'bool',
                                                                                                                                                               u'value': u'URI'}},
                                                                                                                                         u'group': False,
                                                                                                                                         u'groups': {},
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'list',
                                                                                                                                         u'path': [u'gcloud',
                                                                                                                                                   u'beta',
                                                                                                                                                   u'runtime-config',
                                                                                                                                                   u'configs',
                                                                                                                                                   u'waiters',
                                                                                                                                                   u'list'],
                                                                                                                                         u'positionals': [],
                                                                                                                                         u'release': u'BETA',
                                                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* This command lists the waiter resources within a specified configuration.',
                                                                                                                                                       u'EXAMPLES': u'To list all waiters within the configuration named "my-config", run:\n\n  $ list --config-name my-config\n\nThe --filter parameter can be used to filter results based on content.\nFor example, to list all waiters with names that begin with \'foo\',\nrun:\n\n  $ list --config-name my-config --filter \'name=foo*\'\n'}},
                                                                                                                               u'wait': {u'capsule': u'*(BETA)* Wait for a waiter to end in success or failure.',
                                                                                                                                         u'commands': {},
                                                                                                                                         u'flags': {u'--config-name': {u'attr': {},
                                                                                                                                                                       u'category': u'',
                                                                                                                                                                       u'choices': [],
                                                                                                                                                                       u'completer': u'',
                                                                                                                                                                       u'default': None,
                                                                                                                                                                       u'description': u'The name of the configuration resource to use.',
                                                                                                                                                                       u'group': u'',
                                                                                                                                                                       u'hidden': False,
                                                                                                                                                                       u'name': u'--config-name',
                                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                                       u'required': False,
                                                                                                                                                                       u'type': u'string',
                                                                                                                                                                       u'value': u'CONFIG_NAME'},
                                                                                                                                                    u'--max-wait': {u'attr': {},
                                                                                                                                                                    u'category': u'',
                                                                                                                                                                    u'choices': [],
                                                                                                                                                                    u'completer': u'',
                                                                                                                                                                    u'default': None,
                                                                                                                                                                    u'description': u"The maximum amount of time to wait for a waiter to finish.\nTimeout values can be specified as seconds, minutes, or hours, using the\n's', 'm', and 'h' suffixes respectively. If no suffix is specified, the\nunit is assumed to be seconds.",
                                                                                                                                                                    u'group': u'',
                                                                                                                                                                    u'hidden': False,
                                                                                                                                                                    u'name': u'--max-wait',
                                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                                    u'required': False,
                                                                                                                                                                    u'type': u'string',
                                                                                                                                                                    u'value': u'MAX_WAIT'}},
                                                                                                                                         u'group': False,
                                                                                                                                         u'groups': {},
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'wait',
                                                                                                                                         u'path': [u'gcloud',
                                                                                                                                                   u'beta',
                                                                                                                                                   u'runtime-config',
                                                                                                                                                   u'configs',
                                                                                                                                                   u'waiters',
                                                                                                                                                   u'wait'],
                                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The waiter name.',
                                                                                                                                                           u'name': u'name',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'value': u'NAME'}],
                                                                                                                                         u'release': u'BETA',
                                                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* This command waits for a waiter to end in success or failure.',
                                                                                                                                                       u'EXAMPLES': u'To wait for a waiter named "my-waiter" within a configuration named\n"my-config", run:\n\n  $ wait my-waiter --config-name my-config\n'}}},
                                                                                                                 u'flags': {},
                                                                                                                 u'group': True,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'waiters',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'runtime-config',
                                                                                                                           u'configs',
                                                                                                                           u'waiters'],
                                                                                                                 u'positionals': [],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Manage waiter resources.'}}},
                                                                                      u'flags': {},
                                                                                      u'group': True,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'configs',
                                                                                      u'path': [u'gcloud',
                                                                                                u'beta',
                                                                                                u'runtime-config',
                                                                                                u'configs'],
                                                                                      u'positionals': [],
                                                                                      u'release': u'BETA',
                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Commands for RuntimeConfig configs.'}}},
                                                           u'flags': {},
                                                           u'group': True,
                                                           u'groups': {},
                                                           u'hidden': False,
                                                           u'name': u'runtime-config',
                                                           u'path': [u'gcloud',
                                                                     u'beta',
                                                                     u'runtime-config'],
                                                           u'positionals': [],
                                                           u'release': u'BETA',
                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Manage runtime configuration resources.'}},
                                       u'service-management': {u'capsule': u'*(BETA)* Create, enable and manage API services.',
                                                               u'commands': {u'add-iam-policy-binding': {u'capsule': u'*(BETA)* Add IAM policy binding for a service.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--member': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The member to add to the binding.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--member',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'MEMBER'},
                                                                                                                    u'--role': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Define the role of the member.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--role',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'ROLE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'add-iam-policy-binding',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'service-management',
                                                                                                                   u'add-iam-policy-binding'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name of the service to which the member is to be added.',
                                                                                                                           u'name': u'service',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'SERVICE'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u"*(BETA)* Adds IAM policy binding to a service's access policy.",
                                                                                                                       u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/servicemanagement.serviceConsumer' for the user 'test-user@gmail.com' on a service with\nidentifier 'my-service'\n\n  $ add-iam-policy-binding my-service --member='user:test-user@gmail.com' --role='roles/servicemanagement.serviceConsumer'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                             u'check-iam-policy': {u'capsule': u"*(BETA)* Returns information about a member's permissions on a service.",
                                                                                                   u'commands': {},
                                                                                                   u'flags': {},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'check-iam-policy',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'service-management',
                                                                                                             u'check-iam-policy'],
                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The name of the service for which to check the IAM policy.',
                                                                                                                     u'name': u'service',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'SERVICE'}],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'This command lists the permissions that the current authenticated\ngcloud user has for a service. For example, if the authenticated user is\nable to delete the service, `servicemanagement.services.delete` will\nbe among the returned permissions.\n',
                                                                                                                 u'EXAMPLES': u'To check the permissions for the currently authenticated gcloud, run:\n\n  $ check-iam-policy my_produced_service_name\n'}},
                                                                             u'configs': {u'capsule': u'*(BETA)* View configurations for various services.',
                                                                                          u'commands': {u'describe': {u'capsule': u'*(BETA)* Describes the configuration for a given version of a service.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--service': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The service from which to retrieve the configuration.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--service',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'SERVICE'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'describe',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'beta',
                                                                                                                                u'service-management',
                                                                                                                                u'configs',
                                                                                                                                u'describe'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The configuration ID to retrieve.',
                                                                                                                                        u'name': u'config-id',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'CONFIG_ID'}],
                                                                                                                      u'release': u'BETA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'This command prints out the configuration for the given version of a\ngiven service. You specify the name of the service and the ID of the\nconfiguration, and the command will print out the specified config.\n',
                                                                                                                                    u'EXAMPLES': u"To print the configuration with ID ``2017-01-01R0'' for the service\ncalled ``my-service'', run:\n\n  $ describe --service my-service 2017-01-01R0\n"}},
                                                                                                        u'list': {u'capsule': u'*(BETA)* Lists the configurations for a given service.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--filter',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'EXPRESSION'},
                                                                                                                             u'--limit': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--limit',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'LIMIT'},
                                                                                                                             u'--no-uri': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-uri',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_URI'},
                                                                                                                             u'--page-size': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--page-size',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                                                             u'--service': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The name of service for which to list existing configurations.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--service',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'SERVICE'},
                                                                                                                             u'--sort-by': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--sort-by',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'FIELD'},
                                                                                                                             u'--uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'URI'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'list',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'beta',
                                                                                                                            u'service-management',
                                                                                                                            u'configs',
                                                                                                                            u'list'],
                                                                                                                  u'positionals': [],
                                                                                                                  u'release': u'BETA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'This command lists all the configurations for a given service by ID.\n\nTo get more detailed information about a specific configuration, run:\n\n  $ configs describe\n',
                                                                                                                                u'EXAMPLES': u'To list the configurations for a service named `my-service`, run:\n\n  $ list --service my-service\n'}}},
                                                                                          u'flags': {},
                                                                                          u'group': True,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'configs',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'beta',
                                                                                                    u'service-management',
                                                                                                    u'configs'],
                                                                                          u'positionals': [],
                                                                                          u'release': u'BETA',
                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* View configurations for various services.'}},
                                                                             u'convert-config': {u'capsule': u'*(BETA)* Convert Swagger specification to Google service configuration.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'convert-config',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'beta',
                                                                                                           u'service-management',
                                                                                                           u'convert-config'],
                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The file path containing the Open API specification to convert.',
                                                                                                                   u'name': u'open-api-file',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'OPEN_API_FILE'},
                                                                                                                  {u'completer': u'',
                                                                                                                   u'default': u'',
                                                                                                                   u'description': u'The file path of the output file containing the converted configuration. Output to standard output if omitted.',
                                                                                                                   u'name': u'output-file',
                                                                                                                   u'nargs': u'?',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'OUTPUT_FILE'}],
                                                                                                 u'release': u'BETA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* DEPRECATED: This command is deprecated and will be removed soon.'}},
                                                                             u'delete': {u'capsule': u'*(BETA)* Deletes a service.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--async',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'ASYNC'},
                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': True,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-async',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_ASYNC'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'delete',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'beta',
                                                                                                   u'service-management',
                                                                                                   u'delete'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The name of the service to delete.',
                                                                                                           u'name': u'service',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'SERVICE'}],
                                                                                         u'release': u'BETA',
                                                                                         u'sections': {u'DESCRIPTION': u'Deletes a service from Google Service Management.\n\nServices that are deleted will be retained in the system for 30 days.\nIf a deleted service is still within this retention window, it can be\nundeleted with the undelete command.\n',
                                                                                                       u'EXAMPLES': u'To delete a service named `my-service`, run:\n\n  $ delete my-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ delete my-service --async\n'}},
                                                                             u'deploy': {u'capsule': u'*(BETA)* Deploys a service configuration for the given service name.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--async',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'ASYNC'},
                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': True,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-async',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_ASYNC'},
                                                                                                    u'--no-validate-only': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': True,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--no-validate-only',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_VALIDATE_ONLY'},
                                                                                                    u'--validate-only': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'If included, the command will only validate the service configuration(s). No configuration(s) will be persisted.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--validate-only',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'VALIDATE_ONLY'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'deploy',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'beta',
                                                                                                   u'service-management',
                                                                                                   u'deploy'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The service configuration file (or files) containing the API specification to upload. Proto Descriptors, Open API (Swagger) specifications, and Google Service Configuration files in JSON and YAML formats are acceptable.',
                                                                                                           u'name': u'service-config-file',
                                                                                                           u'nargs': u'+',
                                                                                                           u'required': False,
                                                                                                           u'value': u'SERVICE_CONFIG_FILE'}],
                                                                                         u'release': u'BETA',
                                                                                         u'sections': {u'DESCRIPTION': u'This command is used to deploy a service configuration for a service\nto Google Service Management. As input, it takes one or more paths\nto service configurations that should be uploaded. These configuration\nfiles can be Proto Descriptors, Open API (Swagger) specifications,\nor Google Service Configuration files in JSON or YAML formats.\n\nIf a service name is present in multiple configuration files (given\nin the `host` field in OpenAPI specifications or the `name` field in\nGoogle Service Configuration files), the first one will take precedence.\n\nThis command will block until deployment is complete unless the\n`--async` flag is passed.\n',
                                                                                                       u'EXAMPLES': u'To deploy a single Open API service configuration, run:\n\n  $ deploy ~/my_app/openapi.json\n\nTo run the deployment asynchronously (non-blocking), run:\n\n  $ deploy ~/my_app/openapi.json --async\n\nTo deploy a service config with a Proto, run:\n\n  $ deploy ~/my_app/service-config.yaml ~/my_app/service-protos.pb\n'}},
                                                                             u'describe': {u'capsule': u'*(BETA)* Describes a service given a service name.',
                                                                                           u'commands': {},
                                                                                           u'flags': {},
                                                                                           u'group': False,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'describe',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'beta',
                                                                                                     u'service-management',
                                                                                                     u'describe'],
                                                                                           u'positionals': [{u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The name of the service to describe.',
                                                                                                             u'name': u'service',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'value': u'SERVICE'}],
                                                                                           u'release': u'BETA',
                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Describes a service given a service name.'}},
                                                                             u'disable': {u'capsule': u'*(BETA)* Disables a service for consumption for a project.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--async': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--async',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'ASYNC'},
                                                                                                     u'--no-async': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-async',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_ASYNC'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'disable',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'beta',
                                                                                                    u'service-management',
                                                                                                    u'disable'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the service to disable.',
                                                                                                            u'name': u'service',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'SERVICE'}],
                                                                                          u'release': u'BETA',
                                                                                          u'sections': {u'DESCRIPTION': u'This command disables a previously-enabled service for consumption.\n\nTo see a list of the enabled services for a project, run:\n\n  $ service-management list --enabled\n\nMore information on listing services can be found at:\nhttps://cloud.google.com/service-management/list-services and on\ndisabling a service at:\nhttps://cloud.google.com/service-management/enable-disable#disabling_services\n',
                                                                                                        u'EXAMPLES': u'To disable a service called `my-consumed-service` for the active\nproject, run:\n\n  $ disable my-consumed-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ disable my-consumed-service --async\n'}},
                                                                             u'enable': {u'capsule': u'*(BETA)* Enables a service for consumption for a project.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--async',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'ASYNC'},
                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': True,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-async',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_ASYNC'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'enable',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'beta',
                                                                                                   u'service-management',
                                                                                                   u'enable'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The name of the service to enable.',
                                                                                                           u'name': u'service',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'SERVICE'}],
                                                                                         u'release': u'BETA',
                                                                                         u'sections': {u'DESCRIPTION': u'This command enables a service for consumption for a project.\n\nTo see a list of available services for a project, run:\n\n  $ service-management list --available\n\nMore information on listing services can be found at:\nhttps://cloud.google.com/service-management/list-services and on\nenabling a service at:\nhttps://cloud.google.com/service-management/enable-disable#enabling_services\n',
                                                                                                       u'EXAMPLES': u'To enable a service called `my-consumed-service` on the current\nproject, run:\n\n  $ enable my-consumed-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ enable my-consumed-service --async\n'}},
                                                                             u'get-iam-policy': {u'capsule': u'*(BETA)* Describes the IAM policy for a service.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'get-iam-policy',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'beta',
                                                                                                           u'service-management',
                                                                                                           u'get-iam-policy'],
                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The name of the service whose IAM policy is to be described.',
                                                                                                                   u'name': u'service',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'SERVICE'}],
                                                                                                 u'release': u'BETA',
                                                                                                 u'sections': {u'DESCRIPTION': u'Gets the IAM policy for a produced service, given the service name.\n',
                                                                                                               u'EXAMPLES': u'To print the IAM policy for a service named `my-service`, run:\n\n  $ get-iam-policy my-service\n'}},
                                                                             u'list': {u'capsule': u'*(BETA)* List services for a project.',
                                                                                       u'commands': {},
                                                                                       u'flags': {u'--available': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u'Return the services available to the project to enable. This list will include any services that the project has already enabled. Or use one of --enabled or --produced.',
                                                                                                                   u'group': u'list.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--available',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'AVAILABLE'},
                                                                                                  u'--enabled': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'(DEFAULT) Return the services which the project has enabled. Or use one of --produced or --available.',
                                                                                                                 u'group': u'list.1',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--enabled',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'ENABLED'},
                                                                                                  u'--filter': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--filter',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'EXPRESSION'},
                                                                                                  u'--limit': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--limit',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'LIMIT'},
                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--page-size',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                  u'--produced': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'Return the services that the project has produced. Or use one of --enabled or --available.',
                                                                                                                  u'group': u'list.1',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--produced',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'PRODUCED'},
                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--sort-by',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'list',
                                                                                                                 u'value': u'FIELD'}},
                                                                                       u'group': False,
                                                                                       u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                               u'is_mutex': True,
                                                                                                               u'is_required': False}},
                                                                                       u'hidden': False,
                                                                                       u'name': u'list',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'beta',
                                                                                                 u'service-management',
                                                                                                 u'list'],
                                                                                       u'positionals': [],
                                                                                       u'release': u'BETA',
                                                                                       u'sections': {u'DESCRIPTION': u'This command lists the services that are produced, enabled, or\navailable to be enabled by a project. You can choose the mode in\nwhich the command will list services by using exactly one of the\n`--produced`, `--enabled`, or `--available` flags.\n`--produced` is the default.\n',
                                                                                                     u'EXAMPLES': u'To list the services the current project produces, run:\n\n  $ list --produced\n\nTo list the services the current project has enabled for consumption,\nrun:\n\n  $ list --enabled\n\nTo list the services the current project can enable for consumption,\nrun:\n\n  $ list --available\n'}},
                                                                             u'operations': {u'capsule': u'*(BETA)* Manage Operation for various services.',
                                                                                             u'commands': {u'describe': {u'capsule': u'*(BETA)* Describes an operation resource for a given operation name.',
                                                                                                                         u'commands': {},
                                                                                                                         u'flags': {u'--full': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': False,
                                                                                                                                                u'description': u'Print the entire operation resource, which could be large. By default, a summary will be printed instead.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--full',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'FULL'},
                                                                                                                                    u'--no-full': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': True,
                                                                                                                                                   u'name': u'--no-full',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'NO_FULL'}},
                                                                                                                         u'group': False,
                                                                                                                         u'groups': {},
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'describe',
                                                                                                                         u'path': [u'gcloud',
                                                                                                                                   u'beta',
                                                                                                                                   u'service-management',
                                                                                                                                   u'operations',
                                                                                                                                   u'describe'],
                                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The name of the operation to describe.',
                                                                                                                                           u'name': u'operation',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'value': u'OPERATION'}],
                                                                                                                         u'release': u'BETA',
                                                                                                                         u'sections': {u'DESCRIPTION': u'This command will return information about an operation given the name\nof that operation.\n\nThe amount of information inside an operation can be very large, so by\ndefault, only a summary is returned. If you want the entire operation\nresource, you can include the `--full` flag.\n\nNote that the `operations/` prefix of the operation name is optional\nand may be omitted.\n',
                                                                                                                                       u'EXAMPLES': u'To describe an operation resource named\n`operations/serviceConfigs.my-service.1`, run:\n\n  $ describe serviceConfigs.my-service.1\n\nTo get the full operation resource, run:\n\n  $ describe serviceConfigs.my-service.1 --full\n'}},
                                                                                                           u'wait': {u'capsule': u'*(BETA)* Waits for an operation to complete.',
                                                                                                                     u'commands': {},
                                                                                                                     u'flags': {},
                                                                                                                     u'group': False,
                                                                                                                     u'groups': {},
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'wait',
                                                                                                                     u'path': [u'gcloud',
                                                                                                                               u'beta',
                                                                                                                               u'service-management',
                                                                                                                               u'operations',
                                                                                                                               u'wait'],
                                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The name of the operation on which to wait.',
                                                                                                                                       u'name': u'operation',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'value': u'OPERATION'}],
                                                                                                                     u'release': u'BETA',
                                                                                                                     u'sections': {u'DESCRIPTION': u'This command will block until an operation has been marked as complete.\n\nNote that the `operations/` prefix of the operation name is optional\nand may be omitted.\n',
                                                                                                                                   u'EXAMPLES': u'To wait on an operation named `operations/serviceConfigs.my-service.1`\nto complete, run:\n\n  $ wait serviceConfigs.my-service.1\n'}}},
                                                                                             u'flags': {},
                                                                                             u'group': True,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'operations',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'beta',
                                                                                                       u'service-management',
                                                                                                       u'operations'],
                                                                                             u'positionals': [],
                                                                                             u'release': u'BETA',
                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Manage Operation for various services.'}},
                                                                             u'remove-iam-policy-binding': {u'capsule': u'*(BETA)* Remove IAM policy binding for a service.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--member': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The member to remove from the binding.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--member',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': True,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'MEMBER'},
                                                                                                                       u'--role': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The role to remove the member from.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--role',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'ROLE'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'remove-iam-policy-binding',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'service-management',
                                                                                                                      u'remove-iam-policy-binding'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The name of the service from which the member is to be removed.',
                                                                                                                              u'name': u'service',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'SERVICE'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u"*(BETA)* Removes an IAM policy binding from a service's access policy.",
                                                                                                                          u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/servicemanagement.serviceConsumer' for the user 'test-user@gmail.com' on service with\nidentifier 'my-service'\n\n  $ remove-iam-policy-binding my-service --member='user:test-user@gmail.com' --role='roles/servicemanagement.serviceConsumer'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                             u'undelete': {u'capsule': u'*(BETA)* Undeletes a service given a service name.',
                                                                                           u'commands': {},
                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--async',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'ASYNC'},
                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': True,
                                                                                                                      u'description': u'',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': True,
                                                                                                                      u'name': u'--no-async',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'bool',
                                                                                                                      u'value': u'NO_ASYNC'}},
                                                                                           u'group': False,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'undelete',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'beta',
                                                                                                     u'service-management',
                                                                                                     u'undelete'],
                                                                                           u'positionals': [{u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The name of the service to undelete.',
                                                                                                             u'name': u'service',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'value': u'SERVICE'}],
                                                                                           u'release': u'BETA',
                                                                                           u'sections': {u'DESCRIPTION': u'Undeletes a service configuration that was previously deleted.\n\nServices that are deleted will be retained in the system for 30 days.\nIf a deleted service is still within this retention window, it can be\nundeleted with this command.\n\nNote that this means that this command will not be effective for\nservice configurations marked for deletion more than 30 days ago.\n',
                                                                                                         u'EXAMPLES': u'To undelete a service named `my-service`, run:\n\n  $ undelete my-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ undelete my-service --async\n'}}},
                                                               u'flags': {},
                                                               u'group': True,
                                                               u'groups': {},
                                                               u'hidden': False,
                                                               u'name': u'service-management',
                                                               u'path': [u'gcloud',
                                                                         u'beta',
                                                                         u'service-management'],
                                                               u'positionals': [],
                                                               u'release': u'BETA',
                                                               u'sections': {u'DESCRIPTION': u"*(BETA)* Google Service Management is an infrastructure service of Google Cloud\nPlatform that manages other APIs and services, including Google's own Cloud\nPlatform services and their APIs, and services created using Google Cloud\nEndpoints.\n\nMore information on Service Management can be found here:\nhttps://cloud.google.com/service-management and detailed documentation can be\nfound here: https://cloud.google.com/service-management/docs/"}},
                                       u'source': {u'capsule': u'*(BETA)* Cloud git repository commands.',
                                                   u'commands': {u'repos': {u'capsule': u'*(BETA)* Repos command group.',
                                                                            u'commands': {u'clone': {u'capsule': u'*(BETA)* Clone project git repository in the current directory.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--dry-run': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--dry-run',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'DRY_RUN'},
                                                                                                                u'--no-dry-run': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-dry-run',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_DRY_RUN'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'clone',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'source',
                                                                                                               u'repos',
                                                                                                               u'clone'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Name of the repository. Note: Google Cloud Platform projects generally have (if created) a repository named "default"',
                                                                                                                       u'name': u'src',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'REPOSITORY_NAME'},
                                                                                                                      {u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Directory name for the cloned repo. Defaults to the repository name.',
                                                                                                                       u'name': u'dst',
                                                                                                                       u'nargs': u'?',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'DIRECTORY_NAME'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'This command clones git repository for the currently active\nGoogle Cloud Platform project into the specified folder in the\ncurrent directory.\n',
                                                                                                                   u'EXAMPLES': u"To use the default Google Cloud repository for development, use the\nfollowing commands. We recommend that you use your project name as\nTARGET_DIR to make it apparent which directory is used for which\nproject. We also recommend to clone the repository named 'default'\nsince it is automatically created for each project, and its\ncontents can be browsed and edited in the Developers Console.\n\n  $ gcloud init\n  $ gcloud source repos clone default TARGET_DIR\n  $ cd TARGET_DIR\n  ... create/edit files and create one or more commits ...\n  $ git push origin master\n"}}},
                                                                            u'flags': {},
                                                                            u'group': True,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'repos',
                                                                            u'path': [u'gcloud',
                                                                                      u'beta',
                                                                                      u'source',
                                                                                      u'repos'],
                                                                            u'positionals': [],
                                                                            u'release': u'BETA',
                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Repos command group.'}}},
                                                   u'flags': {},
                                                   u'group': True,
                                                   u'groups': {},
                                                   u'hidden': False,
                                                   u'name': u'source',
                                                   u'path': [u'gcloud',
                                                             u'beta',
                                                             u'source'],
                                                   u'positionals': [],
                                                   u'release': u'BETA',
                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* The source group lets you manipulate git repositories within a Google\nCloud project.'}},
                                       u'spanner': {u'capsule': u'*(BETA)* Command groups for Cloud Spanner.',
                                                    u'commands': {u'databases': {u'capsule': u'*(BETA)* Cloud Spanner databases commands.',
                                                                                 u'commands': {u'create': {u'capsule': u'*(BETA)* Cloud Spanner databases create command.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--async',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ASYNC'},
                                                                                                                      u'--ddl': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Semi-colon separated DDL (data definition language) statements to run inside the newly created database. If there is an error in any statement, the database is not created. Full DDL specification is at https://cloud.google.com/spanner/docs/data-definition-language',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--ddl',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'DDL'},
                                                                                                                      u'--instance': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Cloud Spanner instance ID.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--instance',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'INSTANCE'},
                                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-async',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ASYNC'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'create',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'spanner',
                                                                                                                     u'databases',
                                                                                                                     u'create'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Cloud Spanner database name.',
                                                                                                                             u'name': u'database',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'DATABASE'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner databases create command.'}},
                                                                                               u'ddl': {u'capsule': u'*(BETA)* Cloud Spanner databases DDL commands.',
                                                                                                        u'commands': {u'describe': {u'capsule': u'*(BETA)* Cloud Spanner databases DDL describe command.',
                                                                                                                                    u'commands': {},
                                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--filter',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                                               u'--instance': {u'attr': {},
                                                                                                                                                               u'category': u'',
                                                                                                                                                               u'choices': [],
                                                                                                                                                               u'completer': u'',
                                                                                                                                                               u'default': None,
                                                                                                                                                               u'description': u'Cloud Spanner instance ID.',
                                                                                                                                                               u'group': u'',
                                                                                                                                                               u'hidden': False,
                                                                                                                                                               u'name': u'--instance',
                                                                                                                                                               u'nargs': u'0',
                                                                                                                                                               u'required': True,
                                                                                                                                                               u'type': u'string',
                                                                                                                                                               u'value': u'INSTANCE'},
                                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--limit',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': True,
                                                                                                                                                             u'description': u'',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': True,
                                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'bool',
                                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': False,
                                                                                                                                                              u'type': u'list',
                                                                                                                                                              u'value': u'FIELD'},
                                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--uri',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'URI'}},
                                                                                                                                    u'group': False,
                                                                                                                                    u'groups': {},
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'describe',
                                                                                                                                    u'path': [u'gcloud',
                                                                                                                                              u'beta',
                                                                                                                                              u'spanner',
                                                                                                                                              u'databases',
                                                                                                                                              u'ddl',
                                                                                                                                              u'describe'],
                                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Cloud Spanner database name.',
                                                                                                                                                      u'name': u'database',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'value': u'DATABASE'}],
                                                                                                                                    u'release': u'BETA',
                                                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner databases DDL describe command.'}},
                                                                                                                      u'update': {u'capsule': u'*(BETA)* Cloud Spanner databases DDL update command.',
                                                                                                                                  u'commands': {},
                                                                                                                                  u'flags': {u'--async': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': False,
                                                                                                                                                          u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--async',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'bool',
                                                                                                                                                          u'value': u'ASYNC'},
                                                                                                                                             u'--ddl': {u'attr': {},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Semi-colon separated DDL (data definition language) statements to run inside the database. If a statement fails, all subsequent statements in the batch are automatically cancelled.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--ddl',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': True,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'DDL'},
                                                                                                                                             u'--instance': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Cloud Spanner instance ID.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--instance',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': True,
                                                                                                                                                             u'type': u'string',
                                                                                                                                                             u'value': u'INSTANCE'},
                                                                                                                                             u'--no-async': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': True,
                                                                                                                                                             u'description': u'',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': True,
                                                                                                                                                             u'name': u'--no-async',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': False,
                                                                                                                                                             u'type': u'bool',
                                                                                                                                                             u'value': u'NO_ASYNC'}},
                                                                                                                                  u'group': False,
                                                                                                                                  u'groups': {},
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'update',
                                                                                                                                  u'path': [u'gcloud',
                                                                                                                                            u'beta',
                                                                                                                                            u'spanner',
                                                                                                                                            u'databases',
                                                                                                                                            u'ddl',
                                                                                                                                            u'update'],
                                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'Cloud Spanner database name.',
                                                                                                                                                    u'name': u'database',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'value': u'DATABASE'}],
                                                                                                                                  u'release': u'BETA',
                                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner databases DDL update command.'}}},
                                                                                                        u'flags': {},
                                                                                                        u'group': True,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'ddl',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'spanner',
                                                                                                                  u'databases',
                                                                                                                  u'ddl'],
                                                                                                        u'positionals': [],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner databases DDL commands.'}},
                                                                                               u'delete': {u'capsule': u'*(BETA)* Cloud Spanner databases delete command.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--instance': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Cloud Spanner instance ID.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--instance',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'INSTANCE'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'delete',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'spanner',
                                                                                                                     u'databases',
                                                                                                                     u'delete'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Cloud Spanner database name.',
                                                                                                                             u'name': u'database',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'DATABASE'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner databases delete command.'}},
                                                                                               u'describe': {u'capsule': u'*(BETA)* Cloud Spanner databases describe command.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--instance': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Cloud Spanner instance ID.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--instance',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': True,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'INSTANCE'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'spanner',
                                                                                                                       u'databases',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Cloud Spanner database name.',
                                                                                                                               u'name': u'database',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'DATABASE'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner databases describe command.'}},
                                                                                               u'execute-sql': {u'capsule': u'*(BETA)* Cloud Spanner databases query.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--instance': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Cloud Spanner instance ID.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--instance',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'INSTANCE'},
                                                                                                                           u'--sql': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The SQL query to issue to the database. Cloud Spanner SQL is described at https://cloud.google.com/spanner/docs/query-syntax',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--sql',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'SQL'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'execute-sql',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'spanner',
                                                                                                                          u'databases',
                                                                                                                          u'execute-sql'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Cloud Spanner database name.',
                                                                                                                                  u'name': u'database',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'DATABASE'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner databases query.'}},
                                                                                               u'list': {u'capsule': u'*(BETA)* Cloud Spanner databases list command.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--instance': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Cloud Spanner instance ID.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--instance',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'INSTANCE'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'spanner',
                                                                                                                   u'databases',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner databases list command.'}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'databases',
                                                                                 u'path': [u'gcloud',
                                                                                           u'beta',
                                                                                           u'spanner',
                                                                                           u'databases'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'BETA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner databases commands.'}},
                                                                  u'instance-configs': {u'capsule': u'*(BETA)* Cloud Spanner instance configs commands.',
                                                                                        u'commands': {u'describe': {u'capsule': u'*(BETA)* Cloud Spanner instance configs describe command.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'describe',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'beta',
                                                                                                                              u'spanner',
                                                                                                                              u'instance-configs',
                                                                                                                              u'describe'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Cloud Spanner instance config.',
                                                                                                                                      u'name': u'config',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'INSTANCE-CONFIG'}],
                                                                                                                    u'release': u'BETA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner instance configs describe command.'}},
                                                                                                      u'list': {u'capsule': u'*(BETA)* Cloud Spanner instance configs list command.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--filter',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--limit',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': True,
                                                                                                                                         u'description': u'',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': True,
                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--page-size',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'FIELD'},
                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--uri',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'URI'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'list',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'spanner',
                                                                                                                          u'instance-configs',
                                                                                                                          u'list'],
                                                                                                                u'positionals': [],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner instance configs list command.'}}},
                                                                                        u'flags': {},
                                                                                        u'group': True,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'instance-configs',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'beta',
                                                                                                  u'spanner',
                                                                                                  u'instance-configs'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'BETA',
                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner instance configs commands.'}},
                                                                  u'instances': {u'capsule': u'*(BETA)* Cloud Spanner instances commands.',
                                                                                 u'commands': {u'create': {u'capsule': u'*(BETA)* Cloud Spanner instances create command.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--async',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ASYNC'},
                                                                                                                      u'--config': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Instance config for the instance.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--config',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'CONFIG'},
                                                                                                                      u'--description': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Description of the instance.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--description',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': True,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'DESCRIPTION'},
                                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-async',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ASYNC'},
                                                                                                                      u'--nodes': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Number of nodes for the instance.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--nodes',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'NODES'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'create',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'spanner',
                                                                                                                     u'instances',
                                                                                                                     u'create'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Cloud Spanner instance ID.',
                                                                                                                             u'name': u'instance',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'INSTANCE'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner instances create command.'}},
                                                                                               u'delete': {u'capsule': u'*(BETA)* Cloud Spanner instances delete command.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'delete',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'spanner',
                                                                                                                     u'instances',
                                                                                                                     u'delete'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Cloud Spanner instance ID.',
                                                                                                                             u'name': u'instance',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'INSTANCE'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner instances delete command.'}},
                                                                                               u'describe': {u'capsule': u'*(BETA)* Cloud Spanner instances describe command.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'describe',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'beta',
                                                                                                                       u'spanner',
                                                                                                                       u'instances',
                                                                                                                       u'describe'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Cloud Spanner instance ID.',
                                                                                                                               u'name': u'instance',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'INSTANCE'}],
                                                                                                             u'release': u'BETA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner instances describe command.'}},
                                                                                               u'list': {u'capsule': u'*(BETA)* Cloud Spanner instances list command.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--filter',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'EXPRESSION'},
                                                                                                                    u'--limit': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--limit',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'LIMIT'},
                                                                                                                    u'--no-uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_URI'},
                                                                                                                    u'--page-size': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--page-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                                                    u'--sort-by': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--sort-by',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'FIELD'},
                                                                                                                    u'--uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'URI'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'list',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'spanner',
                                                                                                                   u'instances',
                                                                                                                   u'list'],
                                                                                                         u'positionals': [],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner instances list command.'}},
                                                                                               u'update': {u'capsule': u'*(BETA)* Cloud Spanner instances update command.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--async': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--async',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ASYNC'},
                                                                                                                      u'--description': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Description of the instance.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--description',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'DESCRIPTION'},
                                                                                                                      u'--no-async': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': True,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-async',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ASYNC'},
                                                                                                                      u'--nodes': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Number of nodes for the instance.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--nodes',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'NODES'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'update',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'beta',
                                                                                                                     u'spanner',
                                                                                                                     u'instances',
                                                                                                                     u'update'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Cloud Spanner instance ID.',
                                                                                                                             u'name': u'instance',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'INSTANCE'}],
                                                                                                           u'release': u'BETA',
                                                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner instances update command.'}}},
                                                                                 u'flags': {},
                                                                                 u'group': True,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'instances',
                                                                                 u'path': [u'gcloud',
                                                                                           u'beta',
                                                                                           u'spanner',
                                                                                           u'instances'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'BETA',
                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner instances commands.'}},
                                                                  u'operations': {u'capsule': u'*(BETA)* Cloud Spanner operations commands.',
                                                                                  u'commands': {u'cancel': {u'capsule': u'*(BETA)* Cloud Spanner operations cancel command.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--database': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'For a database operation, the name of the database the operation is executing on.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--database',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'DATABASE'},
                                                                                                                       u'--instance': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The ID of the instance the operation is executing on.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--instance',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'INSTANCE'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'cancel',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'beta',
                                                                                                                      u'spanner',
                                                                                                                      u'operations',
                                                                                                                      u'cancel'],
                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'ID of the operation',
                                                                                                                              u'name': u'operation',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'value': u'OPERATION-ID'}],
                                                                                                            u'release': u'BETA',
                                                                                                            u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner operations cancel command.'}},
                                                                                                u'describe': {u'capsule': u'*(BETA)* Cloud Spanner operations describe command.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--database': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'For a database operation, the name of the database the operation is executing on.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--database',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'DATABASE'},
                                                                                                                         u'--instance': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The ID of the instance the operation is executing on.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--instance',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': True,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'INSTANCE'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'beta',
                                                                                                                        u'spanner',
                                                                                                                        u'operations',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'ID of the operation',
                                                                                                                                u'name': u'operation',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'OPERATION-ID'}],
                                                                                                              u'release': u'BETA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner operations describe command.'}},
                                                                                                u'list': {u'capsule': u'*(BETA)* Cloud Spanner operations list command.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--database': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'For database operations, the name of the database the operations are executing on.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--database',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'DATABASE'},
                                                                                                                     u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--instance': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The ID of the instance the operations are executing on.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--instance',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': True,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'INSTANCE'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'spanner',
                                                                                                                    u'operations',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner operations list command.'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'operations',
                                                                                  u'path': [u'gcloud',
                                                                                            u'beta',
                                                                                            u'spanner',
                                                                                            u'operations'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'BETA',
                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Cloud Spanner operations commands.'}}},
                                                    u'flags': {},
                                                    u'group': True,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'spanner',
                                                    u'path': [u'gcloud',
                                                              u'beta',
                                                              u'spanner'],
                                                    u'positionals': [],
                                                    u'release': u'BETA',
                                                    u'sections': {u'DESCRIPTION': u'*(BETA)* Command groups for Cloud Spanner.'}},
                                       u'sql': {u'capsule': u'*(BETA)* Create and manage Google Cloud SQL databases.',
                                                u'commands': {u'backups': {u'capsule': u'*(BETA)* Provide commands for working with backups of Cloud SQL instances.',
                                                                           u'commands': {u'create': {u'capsule': u'*(BETA)* Creates a backup of a Cloud SQL instance.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--async': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Do not wait for the operation to complete.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--async',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'ASYNC'},
                                                                                                                u'--description': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A friendly description of the backup.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--description',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                                u'--instance': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Cloud SQL instance ID.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--instance',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'INSTANCE'},
                                                                                                                u'--no-async': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-async',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_ASYNC'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'create',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'sql',
                                                                                                               u'backups',
                                                                                                               u'create'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Creates a backup of a Cloud SQL instance.'}},
                                                                                         u'delete': {u'capsule': u'*(BETA)* Delete a backup of a Cloud SQL instance.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--async': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--async',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'ASYNC'},
                                                                                                                u'--instance': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Cloud SQL instance ID.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--instance',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'INSTANCE'},
                                                                                                                u'--no-async': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-async',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_ASYNC'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'delete',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'sql',
                                                                                                               u'backups',
                                                                                                               u'delete'],
                                                                                                     u'positionals': [{u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The ID of the backup run. You can find the ID by running\n            $ gcloud beta sql backups list.',
                                                                                                                       u'name': u'id',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'value': u'ID'}],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Delete a backup of a Cloud SQL instance.'}},
                                                                                         u'describe': {u'capsule': u'*(BETA)* Retrieves information about a backup.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--instance': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Cloud SQL instance ID.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--instance',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'INSTANCE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'describe',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'sql',
                                                                                                                 u'backups',
                                                                                                                 u'describe'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The ID of the Backup Run.',
                                                                                                                         u'name': u'id',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'ID'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Retrieves information about a backup.'}},
                                                                                         u'list': {u'capsule': u'*(BETA)* Lists all backups associated with a given instance.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--filter',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                              u'--instance': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Cloud SQL instance ID.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--instance',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'INSTANCE'},
                                                                                                              u'--limit': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--limit',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'LIMIT'},
                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': True,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--no-uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_URI'},
                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--page-size',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--sort-by',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'list',
                                                                                                                             u'value': u'FIELD'},
                                                                                                              u'--uri': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--uri',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'URI'}},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'list',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'sql',
                                                                                                             u'backups',
                                                                                                             u'list'],
                                                                                                   u'positionals': [],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all backups associated with a given Cloud SQL instance and\nconfiguration in the reverse chronological order of the enqueued time.'}},
                                                                                         u'restore': {u'capsule': u'*(BETA)* Restores a backup of a Cloud SQL instance.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--async': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'Do not wait for the operation to complete.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--async',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'ASYNC'},
                                                                                                                 u'--backup-instance': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The ID of the instance that the backup was taken from.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--backup-instance',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'BACKUP_INSTANCE'},
                                                                                                                 u'--no-async': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-async',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_ASYNC'},
                                                                                                                 u'--restore-instance': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Cloud SQL instance ID that will be restored.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--restore-instance',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': True,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'RESTORE_INSTANCE'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'restore',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'sql',
                                                                                                                u'backups',
                                                                                                                u'restore'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The ID of the backup run to restore from.',
                                                                                                                        u'name': u'backup-id',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'BACKUP_ID'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Restores a backup of a Cloud SQL instance.'}}},
                                                                           u'flags': {},
                                                                           u'group': True,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'backups',
                                                                           u'path': [u'gcloud',
                                                                                     u'beta',
                                                                                     u'sql',
                                                                                     u'backups'],
                                                                           u'positionals': [],
                                                                           u'release': u'BETA',
                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Provide commands for working with backups of Cloud SQL instances\nincluding listing and getting information about backups for a Cloud SQL\ninstance.'}},
                                                              u'connect': {u'capsule': u'*(BETA)* Connects to a Cloud SQL instance.',
                                                                           u'commands': {},
                                                                           u'flags': {u'--user': {u'attr': {},
                                                                                                  u'category': u'',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'Cloud SQL instance user to connect as.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--user',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'string',
                                                                                                  u'value': u'USER'}},
                                                                           u'group': False,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'connect',
                                                                           u'path': [u'gcloud',
                                                                                     u'beta',
                                                                                     u'sql',
                                                                                     u'connect'],
                                                                           u'positionals': [{u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u'Cloud SQL instance ID.',
                                                                                             u'name': u'instance',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'value': u'INSTANCE'}],
                                                                           u'release': u'BETA',
                                                                           u'sections': {u'DESCRIPTION': u'*(BETA)* Connects to a Cloud SQL instance.',
                                                                                         u'EXAMPLES': u'To connect to a Cloud SQL instance, run:\n\n  $ connect my-instance --user=root\n'}},
                                                              u'databases': {u'capsule': u'*(BETA)* Provide commands for managing databases of Cloud SQL instances.',
                                                                             u'commands': {u'create': {u'capsule': u'*(BETA)* Creates a database for a Cloud SQL instance.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--async': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--async',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'ASYNC'},
                                                                                                                  u'--charset': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Cloud SQL database charset setting, which specifies the set of symbols and encodings used to store the data in your database. Each database version may support a different set of charsets.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--charset',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'CHARSET'},
                                                                                                                  u'--collation': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Cloud SQL database collation setting, which specifies the set of rules for comparing characters in a character set. Each database version may support a different set of collations.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--collation',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'COLLATION'},
                                                                                                                  u'--instance': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Cloud SQL instance ID.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--instance',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'INSTANCE'},
                                                                                                                  u'--no-async': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-async',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_ASYNC'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'create',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'sql',
                                                                                                                 u'databases',
                                                                                                                 u'create'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Cloud SQL database name.',
                                                                                                                         u'name': u'database',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'DATABASE'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Creates a database for a Cloud SQL instance.'}},
                                                                                           u'delete': {u'capsule': u'*(BETA)* Deletes a Cloud SQL database.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--instance': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Cloud SQL instance ID.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--instance',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'INSTANCE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'sql',
                                                                                                                 u'databases',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Cloud SQL database name.',
                                                                                                                         u'name': u'database',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'DATABASE'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes a Cloud SQL database.'}},
                                                                                           u'describe': {u'capsule': u'*(BETA)* Displays configuration and metadata about a Cloud SQL database.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--instance': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Cloud SQL instance ID.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--instance',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'INSTANCE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'sql',
                                                                                                                   u'databases',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Cloud SQL database name.',
                                                                                                                           u'name': u'database',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'DATABASE'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Information such as database name, charset, and collation will be displayed.'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* Lists databases for a Cloud SQL instance.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--instance': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Cloud SQL instance ID.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--instance',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'INSTANCE'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'sql',
                                                                                                               u'databases',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Lists databases for a Cloud SQL instance.'}},
                                                                                           u'patch': {u'capsule': u'*(BETA)* Patches the settings of a Cloud SQL database.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--charset': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Cloud SQL database charset setting, which specifies the set of symbols and encodings used to store the data in your database. Each database version may support a different set of charsets.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--charset',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'CHARSET'},
                                                                                                                 u'--collation': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Cloud SQL database collation setting, which specifies the set of rules for comparing characters in a character set. Each database version may support a different set of collations.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--collation',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'COLLATION'},
                                                                                                                 u'--diff': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Show what changed as a result of the patch.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--diff',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'DIFF'},
                                                                                                                 u'--instance': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Cloud SQL instance ID.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--instance',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': True,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'INSTANCE'},
                                                                                                                 u'--no-diff': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-diff',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_DIFF'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'patch',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'sql',
                                                                                                                u'databases',
                                                                                                                u'patch'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Cloud SQL database name.',
                                                                                                                        u'name': u'database',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'DATABASE'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Patches the settings of a Cloud SQL database.'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'databases',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'sql',
                                                                                       u'databases'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Provide commands for managing databases of Cloud SQL instances,\nincluding creating, deleting, listing, patching, updating, and getting\ninformation about databases.'}},
                                                              u'flags': {u'capsule': u'*(BETA)* Provide a command to list flags.',
                                                                         u'commands': {u'list': {u'capsule': u'*(BETA)* List customizable flags for Google Cloud SQL instances.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {u'--database-version': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [u'MYSQL_5_5',
                                                                                                                                                 u'MYSQL_5_6',
                                                                                                                                                 u'MYSQL_5_7',
                                                                                                                                                 u'POSTGRES_9_6'],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--database-version',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'DATABASE_VERSION'},
                                                                                                            u'--filter': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--filter',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                            u'--limit': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--limit',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'LIMIT'},
                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': True,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-uri',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_URI'},
                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--page-size',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--sort-by',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'list',
                                                                                                                           u'value': u'FIELD'},
                                                                                                            u'--uri': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--uri',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'URI'}},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'list',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'beta',
                                                                                                           u'sql',
                                                                                                           u'flags',
                                                                                                           u'list'],
                                                                                                 u'positionals': [],
                                                                                                 u'release': u'BETA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* List customizable flags for Google Cloud SQL instances.'}}},
                                                                         u'flags': {},
                                                                         u'group': True,
                                                                         u'groups': {},
                                                                         u'hidden': False,
                                                                         u'name': u'flags',
                                                                         u'path': [u'gcloud',
                                                                                   u'beta',
                                                                                   u'sql',
                                                                                   u'flags'],
                                                                         u'positionals': [],
                                                                         u'release': u'BETA',
                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Provide a command to list flags.'}},
                                                              u'instances': {u'capsule': u'*(BETA)* Provide commands for managing Cloud SQL instances.',
                                                                             u'commands': {u'clone': {u'capsule': u'*(BETA)* Clones a Cloud SQL instance.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--async': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--async',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'ASYNC'},
                                                                                                                 u'--bin-log-file-name': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Represents the name of the binary log file created by the source\ninstance if it has binary logs enabled.\nIf specified, is the point up to which the source instance is cloned.\nIt must be specified along with --bin-log-position to form a valid\nbinary log coordinates.\ne.g., mysql-bin.000001',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--bin-log-file-name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'BIN_LOG_FILE_NAME'},
                                                                                                                 u'--bin-log-position': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Represents the position (offset) inside the binary log file created by\nthe source instance if it has binary logs enabled.\nIf specified, is the point up to which the source instance is cloned.\nIt must be specified along with --bin-log-file to form a valid binary\nlog coordinates.\ne.g., 123 (a numeric value)',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--bin-log-position',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'BIN_LOG_POSITION'},
                                                                                                                 u'--no-async': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-async',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_ASYNC'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'clone',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'sql',
                                                                                                                u'instances',
                                                                                                                u'clone'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Cloud SQL instance ID of the source.',
                                                                                                                        u'name': u'source',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'SOURCE'},
                                                                                                                       {u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Cloud SQL instance ID of the clone.',
                                                                                                                        u'name': u'destination',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'DESTINATION'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* *clone* creates a clone of the Cloud SQL instance. The source and the\ndestination instances must be in the same project. The clone once created\nwill be an independent Cloud SQL instance.\n\nThe binary log coordinates, if specified, act as the point up to which the\nsource instance is cloned. If not specified, the source instance is\ncloned up to the most recent binary log coordinates at the time the command is\nexecuted.\n\n## EXAMPLES\n\nTo clone a source instance to the most recent binary log coordinates:\n\n  $ clone instance-foo instance-bar\n\nor to clone at specific binary log coordinates:\n\n  $ clone instance-foo instance-bar --bin-log-file-name mysql-bin.000020 --bin-log-position 170'}},
                                                                                           u'create': {u'capsule': u'*(BETA)* Creates a new Cloud SQL instance.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--activation-policy': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [u'ALWAYS',
                                                                                                                                                        u'NEVER',
                                                                                                                                                        u'ON_DEMAND'],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The activation policy for this instance. This specifies when the instance should be activated and is applicable only when the instance state is RUNNABLE. More information on activation policies can be found here: https://cloud.google.com/sql/faq#activation_policy. _ACTIVATION_POLICY_ must be one of: *ALWAYS*, *NEVER*, *ON_DEMAND*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--activation-policy',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'ACTIVATION_POLICY'},
                                                                                                                  u'--assign-ip': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'Specified if the instance must be assigned an IP address.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--assign-ip',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'ASSIGN_IP'},
                                                                                                                  u'--async': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--async',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'ASYNC'},
                                                                                                                  u'--authorized-gae-apps': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': [],
                                                                                                                                             u'description': u'List of App Engine app IDs that can access this instance.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--authorized-gae-apps',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'APP'},
                                                                                                                  u'--authorized-networks': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': [],
                                                                                                                                             u'description': u"The list of external networks that are allowed to connect to the instance. Specified in CIDR notation, also known as 'slash' notation (e.g. 192.168.100.0/24).",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--authorized-networks',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'list',
                                                                                                                                             u'value': u'NETWORK'},
                                                                                                                  u'--backup': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'Enables daily backup. Enabled by default, use *--no-backup* to disable.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--backup',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'BACKUP'},
                                                                                                                  u'--backup-start-time': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The start time of daily backups, specified in the 24 hour format - HH:MM, in the UTC timezone.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--backup-start-time',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'BACKUP_START_TIME'},
                                                                                                                  u'--cpu': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'A whole number value indicating how many cores are desired inthe machine. Both --cpu and --memory must be specified if a custom machine type is desired, and the --tier flag must be omitted.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--cpu',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'CPU'},
                                                                                                                  u'--database-flags': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'A comma-separated list of database flags to set on the instance. Use an equals sign to separate flag name and value. Flags without values, like skip_grant_tables, can be written out without a value after, e.g., `skip_grant_tables=`. Use on/off for booleans. View the Instance Resource API for allowed flags. (e.g., `--database-flags max_allowed_packet=55555,skip_grant_tables=,log_output=1`)',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--database-flags',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'dict',
                                                                                                                                        u'value': u'FLAG=VALUE'},
                                                                                                                  u'--database-version': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': u'MYSQL_5_6',
                                                                                                                                          u'description': u'The database engine type and version. Can be MYSQL_5_5, MYSQL_5_6, or MYSQL_5_7.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--database-version',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'DATABASE_VERSION'},
                                                                                                                  u'--enable-bin-log': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Specified if binary log should be enabled. If backup configuration is disabled, binary log must be disabled as well.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--enable-bin-log',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'ENABLE_BIN_LOG'},
                                                                                                                  u'--failover-replica-name': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Also create a failover replica with the specified name.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--failover-replica-name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'FAILOVER_REPLICA_NAME'},
                                                                                                                  u'--follow-gae-app': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The App Engine app this instance should follow. It must be in the same region as the instance.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--follow-gae-app',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'FOLLOW_GAE_APP'},
                                                                                                                  u'--gce-zone': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The preferred Compute Engine zone (e.g. us-central1-a, us-central1-b, etc.).',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--gce-zone',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'GCE_ZONE'},
                                                                                                                  u'--maintenance-release-channel': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [u'preview',
                                                                                                                                                                  u'production'],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"Which channel's updates to apply during the maintenance window. _MAINTENANCE_RELEASE_CHANNEL_ must be one of:\n+\n*preview*::: Preview updates release prior to production updates. You may wish to use the preview channel for dev/test applications so that you can preview their compatibility with your application prior to the production release.\n*production*::: Production updates are stable and recommended for applications in production.\n+",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--maintenance-release-channel',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'MAINTENANCE_RELEASE_CHANNEL'},
                                                                                                                  u'--maintenance-window-day': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [u'SUN',
                                                                                                                                                             u'MON',
                                                                                                                                                             u'TUE',
                                                                                                                                                             u'WED',
                                                                                                                                                             u'THU',
                                                                                                                                                             u'FRI',
                                                                                                                                                             u'SAT'],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Day of week for maintenance window, in UTC time zone. _MAINTENANCE_WINDOW_DAY_ must be one of: *SUN*, *MON*, *TUE*, *WED*, *THU*, *FRI*, *SAT*.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--maintenance-window-day',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'MAINTENANCE_WINDOW_DAY'},
                                                                                                                  u'--maintenance-window-hour': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'Hour of day for maintenance window, in UTC time zone.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--maintenance-window-hour',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'MAINTENANCE_WINDOW_HOUR'},
                                                                                                                  u'--master-instance-name': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Name of the instance which will act as master in the replication setup. The newly created instance will be a read replica of the specified master instance.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--master-instance-name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'MASTER_INSTANCE_NAME'},
                                                                                                                  u'--memory': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A whole number value indicating how much memory is desired in the machine. A size unit should be provided (eg. 3072MiB or 9GiB) - if no units are specified, GiB is assumed. Both --cpu and --memory must be specified if a custom machine type is desired, and the --tier flag must be omitted.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--memory',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'MEMORY'},
                                                                                                                  u'--no-assign-ip': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': False,
                                                                                                                                      u'description': u'',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': True,
                                                                                                                                      u'name': u'--no-assign-ip',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'bool',
                                                                                                                                      u'value': u'NO_ASSIGN_IP'},
                                                                                                                  u'--no-async': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-async',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_ASYNC'},
                                                                                                                  u'--no-backup': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-backup',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_BACKUP'},
                                                                                                                  u'--no-enable-bin-log': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-enable-bin-log',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_ENABLE_BIN_LOG'},
                                                                                                                  u'--no-require-ssl': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': True,
                                                                                                                                        u'name': u'--no-require-ssl',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'NO_REQUIRE_SSL'},
                                                                                                                  u'--no-storage-auto-increase': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--no-storage-auto-increase',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_STORAGE_AUTO_INCREASE'},
                                                                                                                  u'--on-premises-host-port': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--on-premises-host-port',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'ON_PREMISES_HOST_PORT'},
                                                                                                                  u'--pricing-plan': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [u'PER_USE',
                                                                                                                                                   u'PACKAGE'],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': u'PER_USE',
                                                                                                                                      u'description': u'The pricing plan for this instance. _PRICING_PLAN_ must be one of: *PER_USE*, *PACKAGE*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--pricing-plan',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PRICING_PLAN'},
                                                                                                                  u'--region': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': u'us-central',
                                                                                                                                u'description': u'The regional location (e.g. asia-east1, us-east1). See the full list of regions at https://cloud.google.com/sql/docs/instance-locations.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--region',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'REGION'},
                                                                                                                  u'--replica-type': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [u'READ',
                                                                                                                                                   u'FAILOVER'],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The type of replica to create. _REPLICA_TYPE_ must be one of: *READ*, *FAILOVER*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--replica-type',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REPLICA_TYPE'},
                                                                                                                  u'--replication': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [u'SYNCHRONOUS',
                                                                                                                                                  u'ASYNCHRONOUS'],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The type of replication this instance uses. _REPLICATION_ must be one of: *SYNCHRONOUS*, *ASYNCHRONOUS*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--replication',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'REPLICATION'},
                                                                                                                  u'--require-ssl': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'Specified if users connecting over IP must use SSL.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--require-ssl',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'REQUIRE_SSL'},
                                                                                                                  u'--storage-auto-increase': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'Storage size can be increased, but it cannot be decreased; storage increases are permanent for the life of the instance. With this setting enabled, a spike in storage requirements can result in permanently increased storage costs for your instance. However, if an instance runs out of available space, it can result in the instance going offline, dropping existing connections.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--storage-auto-increase',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'STORAGE_AUTO_INCREASE'},
                                                                                                                  u'--storage-size': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Amount of storage allocated to the instance. Must be an integer number of GB between 10GB and 10230GB inclusive.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--storage-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'STORAGE_SIZE'},
                                                                                                                  u'--storage-type': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [u'SSD',
                                                                                                                                                   u'HDD'],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The storage type for the instance. _STORAGE_TYPE_ must be one of: *SSD*, *HDD*.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--storage-type',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'STORAGE_TYPE'},
                                                                                                                  u'--tier': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The tier for first generation Cloud SQL instances, for example  D0, D1, D2. A complete list of tiers is available here: https://cloud.google.com/sql/pricing#packages',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--tier',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'TIER'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'create',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'sql',
                                                                                                                 u'instances',
                                                                                                                 u'create'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Cloud SQL instance ID.',
                                                                                                                         u'name': u'instance',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'INSTANCE'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Creates a new Cloud SQL instance.'}},
                                                                                           u'delete': {u'capsule': u'*(BETA)* Deletes a Cloud SQL instance.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--async': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--async',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'ASYNC'},
                                                                                                                  u'--no-async': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-async',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_ASYNC'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'sql',
                                                                                                                 u'instances',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Cloud SQL instance ID.',
                                                                                                                         u'name': u'instance',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'INSTANCE'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes a Cloud SQL instance.'}},
                                                                                           u'describe': {u'capsule': u'*(BETA)* Displays configuration and metadata about a Cloud SQL instance.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'sql',
                                                                                                                   u'instances',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Cloud SQL instance ID.',
                                                                                                                           u'name': u'instance',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'INSTANCE'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Displays configuration and metadata about a Cloud SQL instance.\n\nInformation such as instance name, IP address, region, the CA certificate\nand configuration settings will be displayed.'}},
                                                                                           u'export': {u'capsule': u'*(BETA)* Exports data from a Cloud SQL instance.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--async': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--async',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'ASYNC'},
                                                                                                                  u'--database': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Database (for example, guestbook) from which the export is made. If unspecified, all databases are exported.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--database',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'DATABASE'},
                                                                                                                  u'--no-async': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-async',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_ASYNC'},
                                                                                                                  u'--table': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Tables to export from the specified database. If you specify tables, specify one and only one database.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--table',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'TABLE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'export',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'sql',
                                                                                                                 u'instances',
                                                                                                                 u'export'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Cloud SQL instance ID.',
                                                                                                                         u'name': u'instance',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'INSTANCE'},
                                                                                                                        {u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The path to the file in Google Cloud Storage where the export will be stored. The URI is in the form gs://bucketName/fileName. If the file already exists, the operation fails. If the filename ends with .gz, the contents are compressed.',
                                                                                                                         u'name': u'uri',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'URI'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Exports data from a Cloud SQL instance to a Google Cloud Storage\nbucket as a MySQL dump file.'}},
                                                                                           u'failover': {u'capsule': u'*(BETA)* Causes a high-availability Cloud SQL instance to failover.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u'Do not wait for the operation to complete.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--async',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'ASYNC'},
                                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_ASYNC'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'failover',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'sql',
                                                                                                                   u'instances',
                                                                                                                   u'failover'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Cloud SQL instance ID.',
                                                                                                                           u'name': u'instance',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'INSTANCE'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Causes a high-availability Cloud SQL instance to failover.'}},
                                                                                           u'import': {u'capsule': u'*(BETA)* Imports data into a Cloud SQL instance from Google Cloud Storage.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--async': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'Do not wait for the operation to complete.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--async',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'ASYNC'},
                                                                                                                  u'--database': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The database (for example, guestbook) to which the import is made. If not set, it is assumed that the database is specified in the file to be imported.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--database',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'DATABASE'},
                                                                                                                  u'--no-async': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-async',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_ASYNC'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'import',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'sql',
                                                                                                                 u'instances',
                                                                                                                 u'import'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Cloud SQL instance ID.',
                                                                                                                         u'name': u'instance',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'INSTANCE'},
                                                                                                                        {u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Path to the MySQL dump file in Google Cloud Storage from which the import is made. The URI is in the form gs://bucketName/fileName. Compressed gzip files (.gz) are also supported.',
                                                                                                                         u'name': u'uri',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'URI'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Note: authorization is required. For more information on importing data\ninto Google Cloud SQL see\n[](https://cloud.google.com/sql/docs/import-export/importing).'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* Lists Cloud SQL instances in a given project.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'sql',
                                                                                                               u'instances',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Lists Cloud SQL instances in a given project in the alphabetical\norder of the instance name.'}},
                                                                                           u'patch': {u'capsule': u'*(BETA)* Updates the settings of a Cloud SQL instance.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--activation-policy': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [u'ALWAYS',
                                                                                                                                                       u'NEVER',
                                                                                                                                                       u'ON_DEMAND'],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The activation policy for this instance. This specifies when the instance should be activated and is applicable only when the instance state is RUNNABLE. _ACTIVATION_POLICY_ must be one of: *ALWAYS*, *NEVER*, *ON_DEMAND*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--activation-policy',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'ACTIVATION_POLICY'},
                                                                                                                 u'--assign-ip': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'The instance must be assigned an IP address.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--assign-ip',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'ASSIGN_IP'},
                                                                                                                 u'--async': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'Do not wait for the operation to complete.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--async',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'ASYNC'},
                                                                                                                 u'--authorized-gae-apps': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A list of App Engine app IDs that can access this instance.',
                                                                                                                                            u'group': u'patch.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--authorized-gae-apps',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'APP'},
                                                                                                                 u'--authorized-networks': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"The list of external networks that are allowed to connect to the instance. Specified in CIDR notation, also known as 'slash' notation (e.g. 192.168.100.0/24).",
                                                                                                                                            u'group': u'patch.2',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--authorized-networks',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'NETWORK'},
                                                                                                                 u'--backup-start-time': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The start time of daily backups, specified in the 24 hour format - HH:MM, in the UTC timezone.',
                                                                                                                                          u'group': u'patch.3',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--backup-start-time',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'BACKUP_START_TIME'},
                                                                                                                 u'--clear-authorized-networks': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'Clear the list of external networks that are allowed to connect to the instance.',
                                                                                                                                                  u'group': u'patch.2',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--clear-authorized-networks',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'CLEAR_AUTHORIZED_NETWORKS'},
                                                                                                                 u'--clear-database-flags': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'Clear the database flags set on the instance. WARNING: Instance will be restarted.',
                                                                                                                                             u'group': u'patch.4',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--clear-database-flags',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'CLEAR_DATABASE_FLAGS'},
                                                                                                                 u'--clear-gae-apps': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Specified to clear the list of App Engine apps that can access this instance.',
                                                                                                                                       u'group': u'patch.1',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--clear-gae-apps',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'CLEAR_GAE_APPS'},
                                                                                                                 u'--cpu': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'A whole number value indicating how many cores are desired inthe machine. Both --cpu and --memory must be specified if a custom machine type is desired, and the --tier flag must be omitted.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--cpu',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'CPU'},
                                                                                                                 u'--database-flags': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'A comma-separated list of database flags to set on the instance. Use an equals sign to separate flag name and value. Flags without values, like skip_grant_tables, can be written out without a value after, e.g., `skip_grant_tables=`. Use on/off for booleans. View the Instance Resource API for allowed flags. (e.g., `--database-flags max_allowed_packet=55555,skip_grant_tables=,log_output=1`)',
                                                                                                                                       u'group': u'patch.4',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--database-flags',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'dict',
                                                                                                                                       u'value': u'FLAG=VALUE'},
                                                                                                                 u'--diff': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'Show what changed as a result of the update.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--diff',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'DIFF'},
                                                                                                                 u'--enable-bin-log': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Enable binary log. If backup configuration is disabled, binary log should be disabled as well.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--enable-bin-log',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'ENABLE_BIN_LOG'},
                                                                                                                 u'--enable-database-replication': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Enable database replication. Applicable only for read replica instance(s). WARNING: Instance will be restarted.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--enable-database-replication',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'ENABLE_DATABASE_REPLICATION'},
                                                                                                                 u'--follow-gae-app': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The App Engine app this instance should follow. It must be in the same region as the instance. WARNING: Instance may be restarted.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--follow-gae-app',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'FOLLOW_GAE_APP'},
                                                                                                                 u'--gce-zone': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The preferred Compute Engine zone (e.g. us-central1-a, us-central1-b, etc.). WARNING: Instance may be restarted.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--gce-zone',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'GCE_ZONE'},
                                                                                                                 u'--maintenance-release-channel': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [u'preview',
                                                                                                                                                                 u'production'],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"Which channel's updates to apply during the maintenance window. _MAINTENANCE_RELEASE_CHANNEL_ must be one of:\n+\n*preview*::: Preview updates release prior to production updates. You may wish to use the preview channel for dev/test applications so that you can preview their compatibility with your application prior to the production release.\n*production*::: Production updates are stable and recommended for applications in production.\n+",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--maintenance-release-channel',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'MAINTENANCE_RELEASE_CHANNEL'},
                                                                                                                 u'--maintenance-window-any': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': False,
                                                                                                                                               u'description': u'Removes the user-specified maintenance window.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--maintenance-window-any',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'MAINTENANCE_WINDOW_ANY'},
                                                                                                                 u'--maintenance-window-day': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [u'SUN',
                                                                                                                                                            u'MON',
                                                                                                                                                            u'TUE',
                                                                                                                                                            u'WED',
                                                                                                                                                            u'THU',
                                                                                                                                                            u'FRI',
                                                                                                                                                            u'SAT'],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Day of week for maintenance window, in UTC time zone. _MAINTENANCE_WINDOW_DAY_ must be one of: *SUN*, *MON*, *TUE*, *WED*, *THU*, *FRI*, *SAT*.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--maintenance-window-day',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'MAINTENANCE_WINDOW_DAY'},
                                                                                                                 u'--maintenance-window-hour': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Hour of day for maintenance window, in UTC time zone.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--maintenance-window-hour',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'MAINTENANCE_WINDOW_HOUR'},
                                                                                                                 u'--memory': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'A whole number value indicating how much memory is desired in the machine. A size unit should be provided (eg. 3072MiB or 9GiB) - if no units are specified, GiB is assumed. Both --cpu and --memory must be specified if a custom machine type is desired, and the --tier flag must be omitted.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--memory',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'MEMORY'},
                                                                                                                 u'--no-assign-ip': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': False,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-assign-ip',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_ASSIGN_IP'},
                                                                                                                 u'--no-async': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-async',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_ASYNC'},
                                                                                                                 u'--no-backup': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'Specified if daily backup should be disabled.',
                                                                                                                                  u'group': u'patch.3',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--no-backup',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_BACKUP'},
                                                                                                                 u'--no-diff': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-diff',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_DIFF'},
                                                                                                                 u'--no-enable-bin-log': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-enable-bin-log',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_ENABLE_BIN_LOG'},
                                                                                                                 u'--no-enable-database-replication': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': False,
                                                                                                                                                       u'description': u'',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': True,
                                                                                                                                                       u'name': u'--no-enable-database-replication',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_ENABLE_DATABASE_REPLICATION'},
                                                                                                                 u'--no-maintenance-window-any': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': True,
                                                                                                                                                  u'description': u'',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': True,
                                                                                                                                                  u'name': u'--no-maintenance-window-any',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'NO_MAINTENANCE_WINDOW_ANY'},
                                                                                                                 u'--no-require-ssl': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-require-ssl',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_REQUIRE_SSL'},
                                                                                                                 u'--no-storage-auto-increase': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': False,
                                                                                                                                                 u'description': u'',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': True,
                                                                                                                                                 u'name': u'--no-storage-auto-increase',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'bool',
                                                                                                                                                 u'value': u'NO_STORAGE_AUTO_INCREASE'},
                                                                                                                 u'--pricing-plan': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [u'PER_USE',
                                                                                                                                                  u'PACKAGE'],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The pricing plan for this instance. _PRICING_PLAN_ must be one of: *PER_USE*, *PACKAGE*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--pricing-plan',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PRICING_PLAN'},
                                                                                                                 u'--replication': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [u'SYNCHRONOUS',
                                                                                                                                                 u'ASYNCHRONOUS'],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The type of replication this instance uses. _REPLICATION_ must be one of: *SYNCHRONOUS*, *ASYNCHRONOUS*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--replication',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'REPLICATION'},
                                                                                                                 u'--require-ssl': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': False,
                                                                                                                                    u'description': u"mysqld should default to 'REQUIRE X509' for users connecting over IP.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--require-ssl',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'REQUIRE_SSL'},
                                                                                                                 u'--storage-auto-increase': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'Storage size can be increased, but it cannot be decreased; storage increases are permanent for the life of the instance. With this setting enabled, a spike in storage requirements can result in permanently increased storage costs for your instance. However, if an instance runs out of available space, it can result in the instance going offline, dropping existing connections.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--storage-auto-increase',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'STORAGE_AUTO_INCREASE'},
                                                                                                                 u'--storage-size': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Amount of storage allocated to the instance. Must be an integer number of GB between 10GB and 10230GB inclusive.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--storage-size',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'STORAGE_SIZE'},
                                                                                                                 u'--tier': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The tier of service for this instance, for example D0, D1. WARNING: Instance will be restarted.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--tier',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'TIER'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {u'patch.1': {u'description': u'At most one of these may be specified:',
                                                                                                                               u'is_mutex': True,
                                                                                                                               u'is_required': False},
                                                                                                                  u'patch.2': {u'description': u'At most one of these may be specified:',
                                                                                                                               u'is_mutex': True,
                                                                                                                               u'is_required': False},
                                                                                                                  u'patch.3': {u'description': u'At most one of these may be specified:',
                                                                                                                               u'is_mutex': True,
                                                                                                                               u'is_required': False},
                                                                                                                  u'patch.4': {u'description': u'At most one of these may be specified:',
                                                                                                                               u'is_mutex': True,
                                                                                                                               u'is_required': False}},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'patch',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'sql',
                                                                                                                u'instances',
                                                                                                                u'patch'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Cloud SQL instance ID.',
                                                                                                                        u'name': u'instance',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'INSTANCE'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Updates the settings of a Cloud SQL instance.'}},
                                                                                           u'promote-replica': {u'capsule': u'*(BETA)* Promotes Cloud SQL read replica to a stand-alone instance.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--async': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--async',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'ASYNC'},
                                                                                                                           u'--no-async': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-async',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_ASYNC'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'promote-replica',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'beta',
                                                                                                                          u'sql',
                                                                                                                          u'instances',
                                                                                                                          u'promote-replica'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Cloud SQL read replica ID.',
                                                                                                                                  u'name': u'replica',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'REPLICA'}],
                                                                                                                u'release': u'BETA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* Promotes Cloud SQL read replica to a stand-alone instance.'}},
                                                                                           u'reset-ssl-config': {u'capsule': u'*(BETA)* Deletes all client certificates and generates a new server certificate.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--async': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': False,
                                                                                                                                         u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--async',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'bool',
                                                                                                                                         u'value': u'ASYNC'},
                                                                                                                            u'--no-async': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': True,
                                                                                                                                            u'description': u'',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': True,
                                                                                                                                            u'name': u'--no-async',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'NO_ASYNC'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'reset-ssl-config',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'beta',
                                                                                                                           u'sql',
                                                                                                                           u'instances',
                                                                                                                           u'reset-ssl-config'],
                                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Cloud SQL instance ID.',
                                                                                                                                   u'name': u'instance',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'value': u'INSTANCE'}],
                                                                                                                 u'release': u'BETA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes all client certificates and generates a new server certificate.'}},
                                                                                           u'restart': {u'capsule': u'*(BETA)* Restarts a Cloud SQL instance.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--async': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--async',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'ASYNC'},
                                                                                                                   u'--no-async': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-async',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_ASYNC'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'restart',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'sql',
                                                                                                                  u'instances',
                                                                                                                  u'restart'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Cloud SQL instance ID.',
                                                                                                                          u'name': u'instance',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'INSTANCE'}],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Restarts a Cloud SQL instance.'}},
                                                                                           u'restore-backup': {u'capsule': u'*(BETA)* Restores a backup of a Cloud SQL instance.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--async': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Do not wait for the operation to complete.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--async',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'ASYNC'},
                                                                                                                          u'--backup-id': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The ID of the backup run to restore from.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--backup-id',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'BACKUP_ID'},
                                                                                                                          u'--backup-instance': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The ID of the instance that the backup was taken from.',
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--backup-instance',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'BACKUP_INSTANCE'},
                                                                                                                          u'--no-async': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-async',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_ASYNC'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'restore-backup',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'beta',
                                                                                                                         u'sql',
                                                                                                                         u'instances',
                                                                                                                         u'restore-backup'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Cloud SQL instance ID that will be restored.',
                                                                                                                                 u'name': u'instance',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'INSTANCE'}],
                                                                                                               u'release': u'BETA',
                                                                                                               u'sections': {u'DESCRIPTION': u"*(BETA)* DEPRECATED: This command is deprecated and will be removed.\nUse 'gcloud beta sql backups restore' instead."}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'instances',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'sql',
                                                                                       u'instances'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Provide commands for managing Cloud SQL instances including creating,\nconfiguring, restarting, and deleting instances.'}},
                                                              u'operations': {u'capsule': u'*(BETA)* Provide commands for working with Cloud SQL instance operations.',
                                                                              u'commands': {u'describe': {u'capsule': u'*(BETA)* Retrieves information about a Cloud SQL instance operation.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'describe',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'beta',
                                                                                                                    u'sql',
                                                                                                                    u'operations',
                                                                                                                    u'describe'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Name that uniquely identifies the operation.',
                                                                                                                            u'name': u'operation',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'OPERATION'}],
                                                                                                          u'release': u'BETA',
                                                                                                          u'sections': {u'DESCRIPTION': u'*(BETA)* Retrieves information about a Cloud SQL instance operation.'}},
                                                                                            u'list': {u'capsule': u'*(BETA)* Lists all instance operations for the given Cloud SQL instance.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--filter',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'EXPRESSION'},
                                                                                                                 u'--instance': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Cloud SQL instance ID.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--instance',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': True,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'INSTANCE'},
                                                                                                                 u'--limit': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--limit',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'LIMIT'},
                                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-uri',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_URI'},
                                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--page-size',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--sort-by',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FIELD'},
                                                                                                                 u'--uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'URI'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'list',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'sql',
                                                                                                                u'operations',
                                                                                                                u'list'],
                                                                                                      u'positionals': [],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all instance operations for the given Cloud SQL instance.'}},
                                                                                            u'wait': {u'capsule': u'*(BETA)* Waits for one or more operations to complete.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'wait',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'sql',
                                                                                                                u'operations',
                                                                                                                u'wait'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'An identifier that uniquely identifies the operation.',
                                                                                                                        u'name': u'operation',
                                                                                                                        u'nargs': u'+',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'OPERATION'}],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Waits for one or more operations to complete.'}}},
                                                                              u'flags': {},
                                                                              u'group': True,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'operations',
                                                                              u'path': [u'gcloud',
                                                                                        u'beta',
                                                                                        u'sql',
                                                                                        u'operations'],
                                                                              u'positionals': [],
                                                                              u'release': u'BETA',
                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* Provide commands for working with Cloud SQL instance operations, including\nlisting and getting information about instance operations of a Cloud SQL\ninstance.'}},
                                                              u'ssl-certs': {u'capsule': u'*(BETA)* Provide commands for managing SSL certificates of Cloud SQL instances.',
                                                                             u'commands': {u'create': {u'capsule': u'*(BETA)* Creates an SSL certificate for a Cloud SQL instance.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--instance': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Cloud SQL instance ID.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--instance',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'INSTANCE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'create',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'sql',
                                                                                                                 u'ssl-certs',
                                                                                                                 u'create'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'User supplied name. Constrained to ```[a-zA-Z.-_ ]+```.',
                                                                                                                         u'name': u'common-name',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'COMMON_NAME'},
                                                                                                                        {u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Location of file which the private key of the created ssl-cert will be written to.',
                                                                                                                         u'name': u'cert-file',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'CERT_FILE'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Creates an SSL certificate for a Cloud SQL instance.'}},
                                                                                           u'delete': {u'capsule': u'*(BETA)* Deletes an SSL certificate for a Cloud SQL instance.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--async': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--async',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'ASYNC'},
                                                                                                                  u'--instance': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'Cloud SQL instance ID.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--instance',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'INSTANCE'},
                                                                                                                  u'--no-async': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-async',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_ASYNC'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'delete',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'sql',
                                                                                                                 u'ssl-certs',
                                                                                                                 u'delete'],
                                                                                                       u'positionals': [{u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'User supplied name. Constrained to ```[a-zA-Z.-_ ]+```.',
                                                                                                                         u'name': u'common-name',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'value': u'COMMON_NAME'}],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes an SSL certificate for a Cloud SQL instance.'}},
                                                                                           u'describe': {u'capsule': u'*(BETA)* Retrieves information about an SSL cert for a Cloud SQL instance.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--instance': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Cloud SQL instance ID.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--instance',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'INSTANCE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'describe',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'sql',
                                                                                                                   u'ssl-certs',
                                                                                                                   u'describe'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'User supplied name. Constrained to ```[a-zA-Z.-_ ]+```.',
                                                                                                                           u'name': u'common-name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'COMMON_NAME'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Retrieves information about an SSL cert for a Cloud SQL instance.'}},
                                                                                           u'list': {u'capsule': u'*(BETA)* Lists all SSL certs for a Cloud SQL instance.',
                                                                                                     u'commands': {},
                                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--filter',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'EXPRESSION'},
                                                                                                                u'--instance': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Cloud SQL instance ID.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--instance',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'INSTANCE'},
                                                                                                                u'--limit': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--limit',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'LIMIT'},
                                                                                                                u'--no-uri': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-uri',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_URI'},
                                                                                                                u'--page-size': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--page-size',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                                u'--sort-by': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--sort-by',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'FIELD'},
                                                                                                                u'--uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'URI'}},
                                                                                                     u'group': False,
                                                                                                     u'groups': {},
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'list',
                                                                                                     u'path': [u'gcloud',
                                                                                                               u'beta',
                                                                                                               u'sql',
                                                                                                               u'ssl-certs',
                                                                                                               u'list'],
                                                                                                     u'positionals': [],
                                                                                                     u'release': u'BETA',
                                                                                                     u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all SSL certs for a Cloud SQL instance.'}}},
                                                                             u'flags': {},
                                                                             u'group': True,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'ssl-certs',
                                                                             u'path': [u'gcloud',
                                                                                       u'beta',
                                                                                       u'sql',
                                                                                       u'ssl-certs'],
                                                                             u'positionals': [],
                                                                             u'release': u'BETA',
                                                                             u'sections': {u'DESCRIPTION': u'*(BETA)* Provide commands for managing SSL certificates of Cloud SQL instances,\nincluding creating, deleting, listing, and getting information about\ncertificates.'}},
                                                              u'tiers': {u'capsule': u'*(BETA)* Provide a command to list tiers.',
                                                                         u'commands': {u'list': {u'capsule': u'*(BETA)* Lists all available service tiers for Google Cloud SQL.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'list',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'beta',
                                                                                                           u'sql',
                                                                                                           u'tiers',
                                                                                                           u'list'],
                                                                                                 u'positionals': [],
                                                                                                 u'release': u'BETA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Lists all available service tiers for Google Cloud SQL.'}}},
                                                                         u'flags': {},
                                                                         u'group': True,
                                                                         u'groups': {},
                                                                         u'hidden': False,
                                                                         u'name': u'tiers',
                                                                         u'path': [u'gcloud',
                                                                                   u'beta',
                                                                                   u'sql',
                                                                                   u'tiers'],
                                                                         u'positionals': [],
                                                                         u'release': u'BETA',
                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Provide a command to list tiers.'}},
                                                              u'users': {u'capsule': u'*(BETA)* Provide commands for managing Cloud SQL users.',
                                                                         u'commands': {u'create': {u'capsule': u'*(BETA)* Creates a user in a given instance.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {u'--async': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--async',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'ASYNC'},
                                                                                                              u'--instance': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Cloud SQL instance ID.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--instance',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'INSTANCE'},
                                                                                                              u'--no-async': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-async',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_ASYNC'},
                                                                                                              u'--password': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"Cloud SQL user's password.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--password',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'PASSWORD'}},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'create',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'sql',
                                                                                                             u'users',
                                                                                                             u'create'],
                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'Cloud SQL username.',
                                                                                                                     u'name': u'username',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'USERNAME'},
                                                                                                                    {u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"Cloud SQL user's host.",
                                                                                                                     u'name': u'host',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'HOST'}],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* Creates a user in a given instance with specified username, host, and\npassword.'}},
                                                                                       u'delete': {u'capsule': u'*(BETA)* Deletes a Cloud SQL user in a given instance.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {u'--async': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--async',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'ASYNC'},
                                                                                                              u'--instance': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Cloud SQL instance ID.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--instance',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'INSTANCE'},
                                                                                                              u'--no-async': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-async',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_ASYNC'}},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'delete',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'sql',
                                                                                                             u'users',
                                                                                                             u'delete'],
                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'Cloud SQL username.',
                                                                                                                     u'name': u'username',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'USERNAME'},
                                                                                                                    {u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"Cloud SQL user's host.",
                                                                                                                     u'name': u'host',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'HOST'}],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*(BETA)* Deletes a Cloud SQL user in a given instance specified by username and host.'}},
                                                                                       u'list': {u'capsule': u'*(BETA)* Lists Cloud SQL users in a given instance.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--filter',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                            u'--instance': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Cloud SQL instance ID.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--instance',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': True,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'INSTANCE'},
                                                                                                            u'--limit': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--limit',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'LIMIT'},
                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': True,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-uri',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_URI'},
                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--page-size',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--sort-by',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'list',
                                                                                                                           u'value': u'FIELD'},
                                                                                                            u'--uri': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--uri',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'URI'}},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'list',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'beta',
                                                                                                           u'sql',
                                                                                                           u'users',
                                                                                                           u'list'],
                                                                                                 u'positionals': [],
                                                                                                 u'release': u'BETA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Lists Cloud SQL users in a given instance in the alphabetical\norder of the user name.'}},
                                                                                       u'set-password': {u'capsule': u"*(BETA)* Changes a user's password in a given instance.",
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--async',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'ASYNC'},
                                                                                                                    u'--instance': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Cloud SQL instance ID.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--instance',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'INSTANCE'},
                                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-async',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_ASYNC'},
                                                                                                                    u'--password': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"Cloud SQL user's password.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--password',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'PASSWORD'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'set-password',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'beta',
                                                                                                                   u'sql',
                                                                                                                   u'users',
                                                                                                                   u'set-password'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Cloud SQL username.',
                                                                                                                           u'name': u'username',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'USERNAME'},
                                                                                                                          {u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"Cloud SQL user's host.",
                                                                                                                           u'name': u'host',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'HOST'}],
                                                                                                         u'release': u'BETA',
                                                                                                         u'sections': {u'DESCRIPTION': u"*(BETA)* Changes a user's password in a given instance with specified username and\nhost."}}},
                                                                         u'flags': {},
                                                                         u'group': True,
                                                                         u'groups': {},
                                                                         u'hidden': False,
                                                                         u'name': u'users',
                                                                         u'path': [u'gcloud',
                                                                                   u'beta',
                                                                                   u'sql',
                                                                                   u'users'],
                                                                         u'positionals': [],
                                                                         u'release': u'BETA',
                                                                         u'sections': {u'DESCRIPTION': u'*(BETA)* Provide commands for managing Cloud SQL users including creating,\nlisting, and deleting users.'}}},
                                                u'flags': {u'--api-version': {u'attr': {u'property': {u'name': u'api_endpoint_overrides/sql'}},
                                                                              u'category': u'',
                                                                              u'choices': [u'v1beta3',
                                                                                           u'v1beta4'],
                                                                              u'completer': u'',
                                                                              u'default': None,
                                                                              u'description': u'',
                                                                              u'group': u'',
                                                                              u'hidden': True,
                                                                              u'name': u'--api-version',
                                                                              u'nargs': u'0',
                                                                              u'required': False,
                                                                              u'type': u'string',
                                                                              u'value': u'API_VERSION'}},
                                                u'group': True,
                                                u'groups': {},
                                                u'hidden': False,
                                                u'name': u'sql',
                                                u'path': [u'gcloud',
                                                          u'beta',
                                                          u'sql'],
                                                u'positionals': [],
                                                u'release': u'BETA',
                                                u'sections': {u'DESCRIPTION': u'The gcloud sql command group lets you create and manage Google Cloud SQL\ndatabases.\n\nCloud SQL is a fully-managed database service that makes it easy to set\nup, maintain, manage, and administer your relational MySQL databases in\nthe cloud.\n\nMore information on Cloud SQL can be found here:\nhttps://cloud.google.com/sql and detailed documentation can be found\nhere: https://cloud.google.com/sql/docs/\n'}},
                                       u'test': {u'capsule': u'*(BETA)* Interact with Firebase Test Lab.',
                                                 u'commands': {u'android': {u'capsule': u'*(BETA)* Command group for Android application testing.',
                                                                            u'commands': {u'devices': {u'capsule': u'*(BETA)* Explore Android devices available in the Test Environment catalog.',
                                                                                                       u'commands': {u'list': {u'capsule': u'*(BETA)*  *(DEPRECATED)* List all Android device environments available for testing.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--filter',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'EXPRESSION'},
                                                                                                                                          u'--limit': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--limit',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'LIMIT'},
                                                                                                                                          u'--no-uri': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': True,
                                                                                                                                                        u'description': u'',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': True,
                                                                                                                                                        u'name': u'--no-uri',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'NO_URI'},
                                                                                                                                          u'--page-size': {u'attr': {},
                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--page-size',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                                                                          u'--sort-by': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--sort-by',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'FIELD'},
                                                                                                                                          u'--uri': {u'attr': {},
                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--uri',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'URI'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'list',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'beta',
                                                                                                                                         u'test',
                                                                                                                                         u'android',
                                                                                                                                         u'devices',
                                                                                                                                         u'list'],
                                                                                                                               u'positionals': [],
                                                                                                                               u'release': u'BETA',
                                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)*  *(DEPRECATED)* List all Android device environments available for testing.\n\nThis command is deprecated. Please use `gcloud beta test android models list` instead.\n\n'}}},
                                                                                                       u'flags': {},
                                                                                                       u'group': True,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'devices',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'test',
                                                                                                                 u'android',
                                                                                                                 u'devices'],
                                                                                                       u'positionals': [],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Explore Android devices available in the Test Environment catalog.',
                                                                                                                     u'EXAMPLES': u'To list all Android devices available for running tests, along with\ntheir basic characteristics and supported Android OS versions, run:\n\n  $ devices list\n'}},
                                                                                          u'locales': {u'capsule': u'*(BETA)* Explore Android locales available for testing.',
                                                                                                       u'commands': {u'list': {u'capsule': u'*(BETA)* List all Android locales available for testing internationalized apps.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--filter',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'EXPRESSION'},
                                                                                                                                          u'--limit': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--limit',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'LIMIT'},
                                                                                                                                          u'--no-uri': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': True,
                                                                                                                                                        u'description': u'',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': True,
                                                                                                                                                        u'name': u'--no-uri',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'NO_URI'},
                                                                                                                                          u'--page-size': {u'attr': {},
                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--page-size',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                                                                          u'--sort-by': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--sort-by',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'FIELD'},
                                                                                                                                          u'--uri': {u'attr': {},
                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--uri',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'URI'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'list',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'beta',
                                                                                                                                         u'test',
                                                                                                                                         u'android',
                                                                                                                                         u'locales',
                                                                                                                                         u'list'],
                                                                                                                               u'positionals': [],
                                                                                                                               u'release': u'BETA',
                                                                                                                               u'sections': {u'DESCRIPTION': u'*(BETA)* List all Android locales available for testing internationalized apps.'}}},
                                                                                                       u'flags': {},
                                                                                                       u'group': True,
                                                                                                       u'groups': {},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'locales',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'beta',
                                                                                                                 u'test',
                                                                                                                 u'android',
                                                                                                                 u'locales'],
                                                                                                       u'positionals': [],
                                                                                                       u'release': u'BETA',
                                                                                                       u'sections': {u'DESCRIPTION': u'*(BETA)* Explore Android locales available for testing.',
                                                                                                                     u'EXAMPLES': u'To list all available Android locales which can be used for testing\ninternational applications, run:\n\n  $ locales list\n'}},
                                                                                          u'models': {u'capsule': u'*(BETA)* Explore Android models available in the Test Environment catalog.',
                                                                                                      u'commands': {u'describe': {u'capsule': u'*(BETA)* Describe an Android model.',
                                                                                                                                  u'commands': {},
                                                                                                                                  u'flags': {},
                                                                                                                                  u'group': False,
                                                                                                                                  u'groups': {},
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'describe',
                                                                                                                                  u'path': [u'gcloud',
                                                                                                                                            u'beta',
                                                                                                                                            u'test',
                                                                                                                                            u'android',
                                                                                                                                            u'models',
                                                                                                                                            u'describe'],
                                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'ID of the model to describe, found using $ {parent_command} list.',
                                                                                                                                                    u'name': u'model-id',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'value': u'MODEL_ID'}],
                                                                                                                                  u'release': u'BETA',
                                                                                                                                  u'sections': {u'DESCRIPTION': u'*(BETA)* Describe an Android model.'}},
                                                                                                                    u'list': {u'capsule': u'*(BETA)* List all Android models available for testing.',
                                                                                                                              u'commands': {},
                                                                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--filter',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'EXPRESSION'},
                                                                                                                                         u'--limit': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--limit',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'LIMIT'},
                                                                                                                                         u'--no-uri': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': True,
                                                                                                                                                       u'description': u'',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': True,
                                                                                                                                                       u'name': u'--no-uri',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_URI'},
                                                                                                                                         u'--page-size': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--page-size',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                                                                         u'--sort-by': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--sort-by',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'FIELD'},
                                                                                                                                         u'--uri': {u'attr': {},
                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--uri',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'URI'}},
                                                                                                                              u'group': False,
                                                                                                                              u'groups': {},
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'list',
                                                                                                                              u'path': [u'gcloud',
                                                                                                                                        u'beta',
                                                                                                                                        u'test',
                                                                                                                                        u'android',
                                                                                                                                        u'models',
                                                                                                                                        u'list'],
                                                                                                                              u'positionals': [],
                                                                                                                              u'release': u'BETA',
                                                                                                                              u'sections': {u'DESCRIPTION': u'*(BETA)* List all Android models available for testing.'}}},
                                                                                                      u'flags': {},
                                                                                                      u'group': True,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'models',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'beta',
                                                                                                                u'test',
                                                                                                                u'android',
                                                                                                                u'models'],
                                                                                                      u'positionals': [],
                                                                                                      u'release': u'BETA',
                                                                                                      u'sections': {u'DESCRIPTION': u'*(BETA)* Explore Android models available in the Test Environment catalog.',
                                                                                                                    u'EXAMPLES': u'To list all Android models available for running tests, along with\ntheir basic characteristics and supported Android OS versions, run:\n\n  $ models list\n'}},
                                                                                          u'run': {u'capsule': u'*(BETA)* Invoke a test in Firebase Test Lab for Android and view test results.',
                                                                                                   u'commands': {},
                                                                                                   u'flags': {u'--app': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The path to the application binary file. The path may be in the local filesystem or in Google Cloud Storage using gs:// notation.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--app',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'APP'},
                                                                                                              u'--app-initial-activity': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The initial activity used to start the app during a robo test.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--app-initial-activity',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'APP_INITIAL_ACTIVITY'},
                                                                                                              u'--app-package': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The Java package of the application under test (default: extracted from the APK manifest).',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--app-package',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'APP_PACKAGE'},
                                                                                                              u'--async': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Invoke a test asynchronously without waiting for test results.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--async',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'ASYNC'},
                                                                                                              u'--auto-google-login': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'Automatically log into the test device using a preconfigured Google account before beginning the test. Enabled by default, use *--no-auto-google-login* to disable.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--auto-google-login',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'AUTO_GOOGLE_LOGIN'},
                                                                                                              u'--device-ids': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The list of DEVICE_IDs to test against (default: one device determined by the Firebase Test Lab device catalog; see TAGS listed by the *$ {parent_command} devices list* command).',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--device-ids',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'DEVICE_ID'},
                                                                                                              u'--directories-to-pull': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"A list of paths that will be copied from the device's storage to the designated results bucket after the test is complete. (ex. --directories-to-pull /sdcard/tempDir1,/data/tempDir2)",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--directories-to-pull',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'list',
                                                                                                                                         u'value': u'DIR_TO_PULL'},
                                                                                                              u'--environment-variables': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'A comma-separated, key=value, map of environment variables and their desired values. The environment variables passed here will be mirrored on to the adb run command. For example, specify --environment-variables coverage=true,coverageFile="/sdcard/tempDir/coverage.ec" to enable code coverage and provide a file path to store the coverage results.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--environment-variables',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'dict',
                                                                                                                                           u'value': u'KEY=VALUE'},
                                                                                                              u'--filter': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--filter',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'EXPRESSION'},
                                                                                                              u'--limit': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--limit',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'LIMIT'},
                                                                                                              u'--locales': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The list of LOCALEs to test against (default: a single locale determined by the Firebase Test Lab device catalog).',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--locales',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'list',
                                                                                                                             u'value': u'LOCALE'},
                                                                                                              u'--max-depth': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum depth of the traversal stack a robo test can explore. Needs to be at least 2 to make Robo explore the app beyond the first activity (default: 50).',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--max-depth',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'int'},
                                                                                                              u'--max-steps': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The maximum number of steps/actions a robo test can execute (default: no limit).',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--max-steps',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'int'},
                                                                                                              u'--no-async': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-async',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_ASYNC'},
                                                                                                              u'--no-auto-google-login': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-auto-google-login',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_AUTO_GOOGLE_LOGIN'},
                                                                                                              u'--no-uri': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': True,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--no-uri',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_URI'},
                                                                                                              u'--obb-files': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'A list of one or two Android OBB file names which will be copied to each test device before the tests will run (default: None). Each OBB file name must conform to the format as specified by Android (e.g. [main|patch].0300110.com.example.android.obb) and will be installed into <shared-storage>/Android/obb/<package-name>/ on the test device.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--obb-files',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'OBB_FILE'},
                                                                                                              u'--orientations': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': u'portrait',
                                                                                                                                  u'description': u'The device orientation(s) to test against. _ORIENTATION_ must be one of: *portrait*, *landscape*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--orientations',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'ORIENTATION'},
                                                                                                              u'--os-version-ids': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The list of OS_VERSION_IDs to test against (default: a version ID determined by the Firebase Test Lab device catalog).',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--os-version-ids',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'OS_VERSION_ID'},
                                                                                                              u'--page-size': {u'attr': {},
                                                                                                                               u'category': u'LIST COMMAND',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--page-size',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                                              u'--results-bucket': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name of a Google Cloud Storage bucket where raw test results will be stored (default: "test-lab-<random-UUID>"). Note that using a non-default bucket will result in billing charges for the storage used.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--results-bucket',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'RESULTS_BUCKET'},
                                                                                                              u'--results-history-name': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"The history name for your test results (an arbitrary string label; default: the application's label from the APK manifest). All tests which use the same history name will have their results grouped together in the Firebase console in a time-ordered test history list.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--results-history-name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'RESULTS_HISTORY_NAME'},
                                                                                                              u'--robo-directives': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'A comma-separated, key=value, map of robo_directives for use by Robo test. Each key should be the Android resource name of a target UI element, and each value should be the text input for that element. For example, specify "--robo-directives username_resource=username,password_resource=password" to provide custom login credentials for your app. Caution: You should only use credentials for test accounts that are not associated with real users.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--robo-directives',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'dict',
                                                                                                                                     u'value': u'ROBO_DIRECTIVES'},
                                                                                                              u'--sort-by': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--sort-by',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'list',
                                                                                                                             u'value': u'FIELD'},
                                                                                                              u'--test': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The path to the test binary file. The given path may be in the local filesystem or in Google Cloud Storage using gs:// notation.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--test',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'TEST'},
                                                                                                              u'--test-package': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The Java package name of the test (default: extracted from the APK manifest).',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--test-package',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'TEST_PACKAGE'},
                                                                                                              u'--test-runner-class': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The fully-qualified Java class name of the instrumentation test runner (default: the last name extracted from the APK manifest).',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--test-runner-class',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'TEST_RUNNER_CLASS'},
                                                                                                              u'--test-targets': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A list of one or more test targets to be run (default: all targets). Each target must be fully qualified with the package name or class name, in one of these formats:\n* "package package_name"\n* "class package_name.class_name"\n* "class package_name.class_name#method_name".',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--test-targets',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'TEST_TARGET'},
                                                                                                              u'--timeout': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The max time this test execution can run before it is cancelled (default: 15m). It does not include any time necessary to prepare and clean up the target device. The _TIMEOUT_ units can be h, m, or s. If no unit is given, seconds are assumed. Examples:\n- *--timeout 1h* is 1 hour\n- *--timeout 5m* is 5 minutes\n- *--timeout 200s* is 200 seconds\n- *--timeout 100* is 100 seconds',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--timeout',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'TIMEOUT'},
                                                                                                              u'--type': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [u'instrumentation',
                                                                                                                                       u'robo'],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The type of test to run. _TYPE_ must be one of: *instrumentation*, *robo*.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--type',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'TYPE'},
                                                                                                              u'--uri': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--uri',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'URI'}},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'run',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'beta',
                                                                                                             u'test',
                                                                                                             u'android',
                                                                                                             u'run'],
                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'An ARG_FILE:ARG_GROUP_NAME pair, where ARG_FILE is the path to a file containing groups of test arguments in yaml format, and ARG_GROUP_NAME is the particular yaml object holding a group of arg:value pairs to use. Run *$ gcloud topic arg-files* for more information and examples.',
                                                                                                                     u'name': u'argspec',
                                                                                                                     u'nargs': u'?',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'ARGSPEC'}],
                                                                                                   u'release': u'BETA',
                                                                                                   u'sections': {u'DESCRIPTION': u'*run* invokes and monitors tests in Firebase Test Lab for\nAndroid.\n\nTwo main types of tests are currently supported:\n- *robo*: runs a smart, automated exploration of the activities in\n  your Android app which records any installation failures or crashes\n  and builds an activity map with associated screenshots and video.\n- *instrumentation*: runs automated unit or integration tests written\n  using a testing framework. Firebase Test Lab for Android currently\n  supports the Espresso, Robotium and UI Automator 2.0 testing\n  frameworks.\n\nThe type of test to run can be specified with the *--type* flag,\nalthough the type can often be inferred from other flags.\nSpecifically, if the *--test* flag is present, the test *--type* will\ndefault to `instrumentation`. If *--test* is not present, then\n*--type* defaults to `robo`.\n\nAll arguments for *run* may be specified on the command line\nand/or within an argument file. Run *$ gcloud topic arg-files* for\nmore information about argument files.\n',
                                                                                                                 u'EXAMPLES': u"To invoke a robo test lasting 100 seconds against the default device\nenvironment, run:\n\n  $ run --app APP_APK --timeout 100s\n\nTo invoke a robo test against a virtual Nexus9 device in\nlandscape orientation, run:\n\n  $ run --app APP_APK --device-ids Nexus9 --orientations landscape\n\nTo invoke an instrumentation test (Espresso or Robotium) against a\nphysical Nexus 4 device (DEVICE_ID: mako) which is running Android API\nlevel 18 in French, run:\n\n  $ run --app APP_APK --test TEST_APK --device-ids mako --os-version-ids 18 --locales fr --orientations portrait\n\nTo run the same test as above using short flags, run:\n\n  $ run --app APP_APK --test TEST_APK -d mako -v 18 -l fr -o portrait\n\nTo run a series of 5-minute robo tests against a comprehensive matrix\nof virtual and physical devices, OS versions and locales, run:\n\n  $ run --app APP_APK --timeout 5m --device-ids mako,Nexus5,Nexus6,g3,zeroflte --os-version-ids 17,18,19,21,22 --locales de,en_US,en_GB,es,fr,it,ru,zh\n\nTo run an instrumentation test against the default test environment,\nbut using a specific Google Cloud Storage bucket to hold the raw test\nresults and specifying the name under which the history of your tests\nwill be collected and displayed in the Firebase console, run:\n\n  $ run --app APP_APK --test TEST_APK --results-bucket excelsior-app-results-bucket --results-history-name 'Excelsior App Test History'\n\nAll test arguments for a given test may alternatively be stored in an\nargument group within a YAML-formatted argument file. The _ARG_FILE_\nmay contain one or more named argument groups, and argument groups may\nbe combined using the `include:` attribute (Run *$ gcloud topic\narg-files* for more information). The ARG_FILE can easily be shared\nwith colleagues or placed under source control to ensure consistent\ntest executions.\n\nTo run a test using arguments loaded from an ARG_FILE named\n*excelsior_args*, which contains an argument group named *robo-args:*,\nuse the following syntax:\n\n  $ run path/to/excelsior_args:robo-args\n"}},
                                                                                          u'versions': {u'capsule': u'*(BETA)* Explore Android versions available for testing.',
                                                                                                        u'commands': {u'list': {u'capsule': u'*(BETA)* List all Android OS versions available for testing.',
                                                                                                                                u'commands': {},
                                                                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--filter',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'EXPRESSION'},
                                                                                                                                           u'--limit': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--limit',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'LIMIT'},
                                                                                                                                           u'--no-uri': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': True,
                                                                                                                                                         u'description': u'',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': True,
                                                                                                                                                         u'name': u'--no-uri',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'bool',
                                                                                                                                                         u'value': u'NO_URI'},
                                                                                                                                           u'--page-size': {u'attr': {},
                                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--page-size',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                                                                           u'--sort-by': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--sort-by',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'list',
                                                                                                                                                          u'value': u'FIELD'},
                                                                                                                                           u'--uri': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': False,
                                                                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--uri',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'URI'}},
                                                                                                                                u'group': False,
                                                                                                                                u'groups': {},
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'list',
                                                                                                                                u'path': [u'gcloud',
                                                                                                                                          u'beta',
                                                                                                                                          u'test',
                                                                                                                                          u'android',
                                                                                                                                          u'versions',
                                                                                                                                          u'list'],
                                                                                                                                u'positionals': [],
                                                                                                                                u'release': u'BETA',
                                                                                                                                u'sections': {u'DESCRIPTION': u'*(BETA)* List all Android OS versions available for testing.'}}},
                                                                                                        u'flags': {},
                                                                                                        u'group': True,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'versions',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'beta',
                                                                                                                  u'test',
                                                                                                                  u'android',
                                                                                                                  u'versions'],
                                                                                                        u'positionals': [],
                                                                                                        u'release': u'BETA',
                                                                                                        u'sections': {u'DESCRIPTION': u'*(BETA)* Explore Android versions available for testing.',
                                                                                                                      u'EXAMPLES': u'To list information about all versions of the Android OS available\nfor running tests, including details such as OS code name and\nrelease date, run:\n\n  $ versions list\n'}}},
                                                                            u'flags': {},
                                                                            u'group': True,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'android',
                                                                            u'path': [u'gcloud',
                                                                                      u'beta',
                                                                                      u'test',
                                                                                      u'android'],
                                                                            u'positionals': [],
                                                                            u'release': u'BETA',
                                                                            u'sections': {u'DESCRIPTION': u'Explore physical and virtual Android devices and Android OS versions\nwhich are available as test targets. Also run tests against your\nAndroid app on these devices, monitor your test progress, and view\ndetailed test results in the Firebase console.\n',
                                                                                          u'EXAMPLES': u'To see a list of available Android devices, their form factors, and\nsupported Android OS versions, run:\n\n  $ android devices list\n\nTo view details about available Android OS versions, such as their\ncode names and release dates, run:\n\n  $ android versions list\n\nTo view the list of available Android locales which can be used for\ntesting internationalized applications, run:\n\n  $ android locales list\n\nTo view all options available for running Android tests, run:\n\n  $ android run --help\n'}}},
                                                 u'flags': {},
                                                 u'group': True,
                                                 u'groups': {},
                                                 u'hidden': False,
                                                 u'name': u'test',
                                                 u'path': [u'gcloud',
                                                           u'beta',
                                                           u'test'],
                                                 u'positionals': [],
                                                 u'release': u'BETA',
                                                 u'sections': {u'DESCRIPTION': u'*(BETA)* Explore devices and OS versions available as test targets, run tests, monitor\ntest progress, and view detailed test results.'}}},
                         u'flags': {},
                         u'group': True,
                         u'groups': {},
                         u'hidden': False,
                         u'name': u'beta',
                         u'path': [u'gcloud', u'beta'],
                         u'positionals': [],
                         u'release': u'BETA',
                         u'sections': {u'DESCRIPTION': u'*(BETA)* Beta versions of gcloud commands.'}},
               u'components': {u'capsule': u'List, install, update, or remove Google Cloud SDK components.',
                               u'commands': {u'install': {u'capsule': u'Install one or more Cloud SDK components.',
                                                          u'commands': {},
                                                          u'flags': {u'--allow-no-backup': {u'attr': {},
                                                                                            u'category': u'',
                                                                                            u'choices': [],
                                                                                            u'completer': u'',
                                                                                            u'default': False,
                                                                                            u'description': u'',
                                                                                            u'group': u'',
                                                                                            u'hidden': True,
                                                                                            u'name': u'--allow-no-backup',
                                                                                            u'nargs': u'0',
                                                                                            u'required': False,
                                                                                            u'type': u'bool',
                                                                                            u'value': u'ALLOW_NO_BACKUP'},
                                                                     u'--no-allow-no-backup': {u'attr': {},
                                                                                               u'category': u'',
                                                                                               u'choices': [],
                                                                                               u'completer': u'',
                                                                                               u'default': True,
                                                                                               u'description': u'',
                                                                                               u'group': u'',
                                                                                               u'hidden': True,
                                                                                               u'name': u'--no-allow-no-backup',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'type': u'bool',
                                                                                               u'value': u'NO_ALLOW_NO_BACKUP'}},
                                                          u'group': False,
                                                          u'groups': {},
                                                          u'hidden': False,
                                                          u'name': u'install',
                                                          u'path': [u'gcloud',
                                                                    u'components',
                                                                    u'install'],
                                                          u'positionals': [{u'completer': u'',
                                                                            u'default': None,
                                                                            u'description': u'The IDs of the components to be installed.',
                                                                            u'name': u'component-ids',
                                                                            u'nargs': u'+',
                                                                            u'required': False,
                                                                            u'value': u'COMPONENT-IDS'}],
                                                          u'release': u'GA',
                                                          u'sections': {u'DESCRIPTION': u"Ensure that each of the specified components (as well as any dependent\ncomponents) is installed on the local workstation.  Components are installed\nwithout performing any upgrades to your existing SDK installation.  All\ncomponents are installed at the current version of your SDK.\n\nComponents that are available for installation can be viewed by\nrunning:\n\n  $ components list\n\nInstalling a given component will also install all components on which\nit depends.  The command lists all components it is about to install,\nand asks for confirmation before proceeding.\n\n``install'' installs components from the version of the Cloud SDK\nyou currently have installed.  You can see your current version by\nrunning:\n\n  $ {top_command} version\n\nIf you want to update your Cloud SDK installation to the latest\navailable version, use:\n\n  $ components update\n",
                                                                        u'EXAMPLES': u"The following command installs ``COMPONENT-1'', ``COMPONENT-2'',\nand all components that they depend on:\n\n  $ install COMPONENT-1 COMPONENT-2\n"}},
                                             u'list': {u'capsule': u'List the status of all Cloud SDK components.',
                                                       u'commands': {},
                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                u'category': u'LIST COMMAND',
                                                                                u'choices': [],
                                                                                u'completer': u'',
                                                                                u'default': None,
                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                u'group': u'',
                                                                                u'hidden': False,
                                                                                u'name': u'--filter',
                                                                                u'nargs': u'0',
                                                                                u'required': False,
                                                                                u'type': u'string',
                                                                                u'value': u'EXPRESSION'},
                                                                  u'--limit': {u'attr': {},
                                                                               u'category': u'LIST COMMAND',
                                                                               u'choices': [],
                                                                               u'completer': u'',
                                                                               u'default': None,
                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                               u'group': u'',
                                                                               u'hidden': False,
                                                                               u'name': u'--limit',
                                                                               u'nargs': u'0',
                                                                               u'required': False,
                                                                               u'type': u'string',
                                                                               u'value': u'LIMIT'},
                                                                  u'--no-show-versions': {u'attr': {},
                                                                                          u'category': u'',
                                                                                          u'choices': [],
                                                                                          u'completer': u'',
                                                                                          u'default': True,
                                                                                          u'description': u'',
                                                                                          u'group': u'',
                                                                                          u'hidden': True,
                                                                                          u'name': u'--no-show-versions',
                                                                                          u'nargs': u'0',
                                                                                          u'required': False,
                                                                                          u'type': u'bool',
                                                                                          u'value': u'NO_SHOW_VERSIONS'},
                                                                  u'--show-versions': {u'attr': {},
                                                                                       u'category': u'',
                                                                                       u'choices': [],
                                                                                       u'completer': u'',
                                                                                       u'default': False,
                                                                                       u'description': u'Show installed and available versions of all components.',
                                                                                       u'group': u'',
                                                                                       u'hidden': False,
                                                                                       u'name': u'--show-versions',
                                                                                       u'nargs': u'0',
                                                                                       u'required': False,
                                                                                       u'type': u'bool',
                                                                                       u'value': u'SHOW_VERSIONS'},
                                                                  u'--sort-by': {u'attr': {},
                                                                                 u'category': u'LIST COMMAND',
                                                                                 u'choices': [],
                                                                                 u'completer': u'',
                                                                                 u'default': None,
                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                 u'group': u'',
                                                                                 u'hidden': False,
                                                                                 u'name': u'--sort-by',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'type': u'list',
                                                                                 u'value': u'FIELD'}},
                                                       u'group': False,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'list',
                                                       u'path': [u'gcloud',
                                                                 u'components',
                                                                 u'list'],
                                                       u'positionals': [],
                                                       u'release': u'GA',
                                                       u'sections': {u'DESCRIPTION': u'This command lists all the available components in the Cloud SDK. For\neach component, the command lists the following information:\n\n* Status on your local workstation: not installed, installed (and\n  up to date), and update available (installed, but not up to date)\n* Name of the component (a description)\n* ID of the component (used to refer to the component in other\n  [components] commands)\n* Size of the component\n\nIn addition, if the `--show-versions` flag is specified, the command\nlists the currently installed version (if any) and the latest\navailable version of each individual component.\n',
                                                                     u'EXAMPLES': u'$ list\n\n$ list --show-versions\n'}},
                                             u'reinstall': {u'capsule': u'Reinstall the Cloud SDK with the same components you have now.',
                                                            u'commands': {},
                                                            u'flags': {},
                                                            u'group': False,
                                                            u'groups': {},
                                                            u'hidden': False,
                                                            u'name': u'reinstall',
                                                            u'path': [u'gcloud',
                                                                      u'components',
                                                                      u'reinstall'],
                                                            u'positionals': [],
                                                            u'release': u'GA',
                                                            u'sections': {u'DESCRIPTION': u'If your Cloud SDK installation becomes corrupt, this command attempts to fix\nit by downloading the latest version of the Cloud SDK and reinstalling it.\nThis will replace your existing installation with a fresh one.  The command is\nthe equivalent of deleting your current installation, downloading a fresh\ncopy of the SDK, and installing in the same location.'}},
                                             u'remove': {u'capsule': u'Remove one or more installed components.',
                                                         u'commands': {},
                                                         u'flags': {u'--allow-no-backup': {u'attr': {},
                                                                                           u'category': u'',
                                                                                           u'choices': [],
                                                                                           u'completer': u'',
                                                                                           u'default': False,
                                                                                           u'description': u'',
                                                                                           u'group': u'',
                                                                                           u'hidden': True,
                                                                                           u'name': u'--allow-no-backup',
                                                                                           u'nargs': u'0',
                                                                                           u'required': False,
                                                                                           u'type': u'bool',
                                                                                           u'value': u'ALLOW_NO_BACKUP'},
                                                                    u'--no-allow-no-backup': {u'attr': {},
                                                                                              u'category': u'',
                                                                                              u'choices': [],
                                                                                              u'completer': u'',
                                                                                              u'default': True,
                                                                                              u'description': u'',
                                                                                              u'group': u'',
                                                                                              u'hidden': True,
                                                                                              u'name': u'--no-allow-no-backup',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'type': u'bool',
                                                                                              u'value': u'NO_ALLOW_NO_BACKUP'}},
                                                         u'group': False,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'remove',
                                                         u'path': [u'gcloud',
                                                                   u'components',
                                                                   u'remove'],
                                                         u'positionals': [{u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u'The IDs of the components to be removed.',
                                                                           u'name': u'component-ids',
                                                                           u'nargs': u'+',
                                                                           u'required': False,
                                                                           u'value': u'COMPONENT-ID'}],
                                                         u'release': u'GA',
                                                         u'sections': {u'DESCRIPTION': u'Uninstall all listed components, as well as all components that\ndirectly or indirectly depend on them.\n\nThe command lists all components it is about to remove, and asks for\nconfirmation before proceeding.\n',
                                                                       u'EXAMPLES': u"To remove ``COMPONENT-1'', ``COMPONENT-2'', and all components that\ndirectly or indirectly depend on ``COMPONENT-1'' or ``COMPONENT-2'',\ntype the following:\n\n  $ remove COMPONENT-1 COMPONENT-2\n"}},
                                             u'repositories': {u'capsule': u'Manage additional component repositories for Trusted Tester programs.',
                                                               u'commands': {u'add': {u'capsule': u'Add a new Trusted Tester component repository.',
                                                                                      u'commands': {},
                                                                                      u'flags': {},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'add',
                                                                                      u'path': [u'gcloud',
                                                                                                u'components',
                                                                                                u'repositories',
                                                                                                u'add'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'One or more URLs for the component repositories you want to add.',
                                                                                                        u'name': u'url',
                                                                                                        u'nargs': u'+',
                                                                                                        u'required': False,
                                                                                                        u'value': u'URL'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'Add a new Trusted Tester component repository to the list of\nrepositories used by the component manager.  This will allow you to\ninstall and update components found in this repository.\n\nIf you are participating in a Trusted Tester program, you will be\ninstructed on the location of repositories with additional versions of\none or more Cloud SDK components.\n',
                                                                                                    u'EXAMPLES': u'To add the Trusted Tester component repository\nhttp://repo.location.com run:\n\n  $ gcloud components repositories add http://repo.location.com\n'}},
                                                                             u'list': {u'capsule': u'List any Trusted Tester component repositories you have registered.',
                                                                                       u'commands': {},
                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--filter',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'EXPRESSION'},
                                                                                                  u'--limit': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--limit',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'LIMIT'},
                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--sort-by',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'list',
                                                                                                                 u'value': u'FIELD'}},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'list',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'components',
                                                                                                 u'repositories',
                                                                                                 u'list'],
                                                                                       u'positionals': [],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u'List all Trusted Tester component repositories that are registered\nwith the component manager.  If you have additional repositories, the\ncomponent manager will look at them to discover additional components\nto install, or different versions of existing components that are\navailable.\n'}},
                                                                             u'remove': {u'capsule': u'Remove a registered Trusted Test component repository.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--all': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'Remove all registered repositories.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--all',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'ALL'},
                                                                                                    u'--no-all': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': True,
                                                                                                                  u'description': u'',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': True,
                                                                                                                  u'name': u'--no-all',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'NO_ALL'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'remove',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'components',
                                                                                                   u'repositories',
                                                                                                   u'remove'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Zero or more URLs for the component repositories you want to remove.  If none are given, you will be prompted to choose which existing repository you want to remove.',
                                                                                                           u'name': u'url',
                                                                                                           u'nargs': u'*',
                                                                                                           u'required': False,
                                                                                                           u'value': u'URL'}],
                                                                                         u'release': u'GA',
                                                                                         u'sections': {u'DESCRIPTION': u'Remove a registered Trusted Tester component repository from the list\nof repositories used by the component manager.  After removing a\nrepository, you can run:\n  $ gcloud components update\nto revert back to the standard version of any components that were\ninstalled from that repository.\n',
                                                                                                       u'EXAMPLES': u'To be prompted for registered Trusted Tester component repositories to\nremove run:\n\n  $ gcloud components repositories remove\n'}}},
                                                               u'flags': {},
                                                               u'group': True,
                                                               u'groups': {},
                                                               u'hidden': False,
                                                               u'name': u'repositories',
                                                               u'path': [u'gcloud',
                                                                         u'components',
                                                                         u'repositories'],
                                                               u'positionals': [],
                                                               u'release': u'GA',
                                                               u'sections': {u'DESCRIPTION': u'List, add, and remove component repositories for Trusted Tester\nprograms.  If you are not participating in a Trusted Tester program,\nthese commands are not necessary for updating your Cloud SDK\ninstallation.\n\nIf you are participating in a Trusted Tester program, you will be\ninstructed on the location of repositories that you should add.\nThese commands allow you to manage the set of repositories you have\nregistered.\n\nOnce you have a repository registered, the component manager will use\nthat location to locate new Cloud SDK components that are available,\nor possibly different versions of existing components that can be\ninstalled.\n\nIf you want to revert to a standard version of the Cloud SDK at any\ntime, you may remove all repositories and then run:\n\n  $ gcloud components update\n\nto revert to a standard installation.\n'}},
                                             u'restore': {u'capsule': u'Restore the Cloud SDK installation to its previous state.',
                                                          u'commands': {},
                                                          u'flags': {},
                                                          u'group': False,
                                                          u'groups': {},
                                                          u'hidden': False,
                                                          u'name': u'restore',
                                                          u'path': [u'gcloud',
                                                                    u'components',
                                                                    u'restore'],
                                                          u'positionals': [],
                                                          u'release': u'GA',
                                                          u'sections': {u'DESCRIPTION': u'This is an undo operation, which restores the Cloud SDK installation on the\nlocal workstation to the state it was in just before the most recent\n`components update`, `components remove`, or\n`components install` command. Only the state before the most recent such\nstate is remembered, so it is impossible to restore the state that existed\nbefore the two most recent `update` commands, for example. A `restore` command\ndoes not undo a previous `restore` command.'}},
                                             u'update': {u'capsule': u'Update all of your installed components to the latest version.',
                                                         u'commands': {},
                                                         u'flags': {u'--allow-no-backup': {u'attr': {},
                                                                                           u'category': u'',
                                                                                           u'choices': [],
                                                                                           u'completer': u'',
                                                                                           u'default': False,
                                                                                           u'description': u'',
                                                                                           u'group': u'',
                                                                                           u'hidden': True,
                                                                                           u'name': u'--allow-no-backup',
                                                                                           u'nargs': u'0',
                                                                                           u'required': False,
                                                                                           u'type': u'bool',
                                                                                           u'value': u'ALLOW_NO_BACKUP'},
                                                                    u'--no-allow-no-backup': {u'attr': {},
                                                                                              u'category': u'',
                                                                                              u'choices': [],
                                                                                              u'completer': u'',
                                                                                              u'default': True,
                                                                                              u'description': u'',
                                                                                              u'group': u'',
                                                                                              u'hidden': True,
                                                                                              u'name': u'--no-allow-no-backup',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'type': u'bool',
                                                                                              u'value': u'NO_ALLOW_NO_BACKUP'}},
                                                         u'group': False,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'update',
                                                         u'path': [u'gcloud',
                                                                   u'components',
                                                                   u'update'],
                                                         u'positionals': [{u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u'',
                                                                           u'name': u'component-ids',
                                                                           u'nargs': u'*',
                                                                           u'required': False,
                                                                           u'value': u'COMPONENT-IDS'}],
                                                         u'release': u'GA',
                                                         u'sections': {u'DESCRIPTION': u'Ensure that the latest version of all installed components is installed on the\nlocal workstation.\n\nThe command lists all components it is about to update, and asks for\nconfirmation before proceeding.\n\nBy default, this command will update all components to their latest\nversion.  This can be configured by using the --version flag to choose\na specific version to update to.  This version may also be a version\nolder than the one that is currently installed.\n\nYou can see your current Cloud SDK version by running:\n\n  $ {top_command} version\n',
                                                                       u'EXAMPLES': u'To update all installed components to the latest version:\n\n  $ update\n\nTo update all installed components to version 1.2.3:\n\n  $ update --version 1.2.3\n'}}},
                               u'flags': {u'--architecture-override': {u'attr': {},
                                                                       u'category': u'',
                                                                       u'choices': [],
                                                                       u'completer': u'',
                                                                       u'default': None,
                                                                       u'description': u'',
                                                                       u'group': u'',
                                                                       u'hidden': True,
                                                                       u'name': u'--architecture-override',
                                                                       u'nargs': u'0',
                                                                       u'required': False,
                                                                       u'type': u'string',
                                                                       u'value': u'ARCHITECTURE_OVERRIDE'},
                                          u'--operating-system-override': {u'attr': {},
                                                                           u'category': u'',
                                                                           u'choices': [],
                                                                           u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u'',
                                                                           u'group': u'',
                                                                           u'hidden': True,
                                                                           u'name': u'--operating-system-override',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'type': u'string',
                                                                           u'value': u'OPERATING_SYSTEM_OVERRIDE'},
                                          u'--sdk-root-override': {u'attr': {},
                                                                   u'category': u'',
                                                                   u'choices': [],
                                                                   u'completer': u'',
                                                                   u'default': None,
                                                                   u'description': u'',
                                                                   u'group': u'',
                                                                   u'hidden': True,
                                                                   u'name': u'--sdk-root-override',
                                                                   u'nargs': u'0',
                                                                   u'required': False,
                                                                   u'type': u'string',
                                                                   u'value': u'SDK_ROOT_OVERRIDE'},
                                          u'--snapshot-url-override': {u'attr': {},
                                                                       u'category': u'',
                                                                       u'choices': [],
                                                                       u'completer': u'',
                                                                       u'default': None,
                                                                       u'description': u'',
                                                                       u'group': u'',
                                                                       u'hidden': True,
                                                                       u'name': u'--snapshot-url-override',
                                                                       u'nargs': u'0',
                                                                       u'required': False,
                                                                       u'type': u'string',
                                                                       u'value': u'SNAPSHOT_URL_OVERRIDE'}},
                               u'group': True,
                               u'groups': {},
                               u'hidden': False,
                               u'name': u'components',
                               u'path': [u'gcloud', u'components'],
                               u'positionals': [],
                               u'release': u'GA',
                               u'sections': {u'DESCRIPTION': u"The components command group lets you control which tools are installed\nin the Cloud SDK. It can be used to install, update and remove components of\nthe Cloud SDK, ensuring a lean, up-to-date installation.\n\ncomponents regularly checks whether updates are available for the\ntools you already have installed, and gives you the opportunity to upgrade to\nthe latest version.\n\nCertain components have dependencies. components will install any dependencies,\nand during removal, any dependant components will be uninstalled\nautomatically.\n\n## EXAMPLES\n\nTo see all available components:\n\n  $ components list\n\nTo install a component you don't have:\n\n  $ components install COMPONENT\n\nTo remove a component you no longer need:\n\n  $ components remove COMPONENT\n\nTo update all components you have to their latest version:\n\n  $ components update\n\nTo update all installed components to version 1.2.3:\n\n  $ components update --version 1.2.3"}},
               u'compute': {u'capsule': u'Create and manipulate Google Compute Engine resources.',
                            u'commands': {u'addresses': {u'capsule': u'Read and manipulate Google Compute Engine addresses.',
                                                         u'commands': {u'create': {u'capsule': u'Reserve IP addresses.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--addresses': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"Ephemeral IP addresses to promote to reserved status. Only addresses\nthat are being used by resources in the project can be promoted. When\nproviding this flag, a parallel list of names for the addresses can\nbe provided. For example,\n+\n  $ {command} ADDRESS-1 ADDRESS-2 --addresses 162.222.181.197,162.222.181.198 --region us-central1\n+\nwill result in 162.222.181.197 being reserved as\n'ADDRESS-1' and 162.222.181.198 as 'ADDRESS-2'. If\nno names are given, randomly-generated names will be assigned\nto the IP addresses.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--addresses',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'list',
                                                                                                               u'value': u'ADDRESS'},
                                                                                              u'--description': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'An optional textual description for the addresses.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--description',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'DESCRIPTION'},
                                                                                              u'--global': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u'If provided, it is assumed the address name is global.',
                                                                                                            u'group': u'create.1',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--global',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'GLOBAL'},
                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u"The region of the address name to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                            u'group': u'create.1',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--region',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'REGION'}},
                                                                                   u'group': False,
                                                                                   u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                             u'is_mutex': True,
                                                                                                             u'is_required': False}},
                                                                                   u'hidden': False,
                                                                                   u'name': u'create',
                                                                                   u'path': [u'gcloud',
                                                                                             u'compute',
                                                                                             u'addresses',
                                                                                             u'create'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The address names to operate on.',
                                                                                                     u'name': u'name',
                                                                                                     u'nargs': u'*',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u"*create* is used to reserve one or more IP addresses. Once\nan IP address is reserved, it will be associated with the\nproject until it is released using 'gcloud compute addresses\ndelete'. Ephemeral IP addresses that are in use by resources\nin the project, can be reserved using the ``--addresses''\nflag.\n",
                                                                                                 u'EXAMPLES': u"To reserve three IP addresses in the ``us-central1'' region,\nrun:\n\n  $ create ADDRESS-1 ADDRESS-2 ADDRESS-3 --region us-central1\n\nTo reserve ephemeral IP addresses 162.222.181.198 and\n23.251.146.189 which are being used by virtual machine\ninstances in the ``us-central1'' region, run:\n\n  $ create --addresses 162.222.181.198,23.251.146.189 --region us-central1\n\nIn the above invocation, the two addresses will be assigned\nrandom names.\n"}},
                                                                       u'delete': {u'capsule': u'Release reserved IP addresses.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--global': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u'If provided, it is assumed the address name is global.',
                                                                                                            u'group': u'delete.1',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--global',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'GLOBAL'},
                                                                                              u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u"The region of the address name to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                            u'group': u'delete.1',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--region',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'REGION'}},
                                                                                   u'group': False,
                                                                                   u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                             u'is_mutex': True,
                                                                                                             u'is_required': False}},
                                                                                   u'hidden': False,
                                                                                   u'name': u'delete',
                                                                                   u'path': [u'gcloud',
                                                                                             u'compute',
                                                                                             u'addresses',
                                                                                             u'delete'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The address names to operate on.',
                                                                                                     u'name': u'name',
                                                                                                     u'nargs': u'+',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'*delete* releases one or more Google Compute Engine IP addresses.\n'}},
                                                                       u'describe': {u'capsule': u'Display detailed information about an address.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--global': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'If provided, it is assumed that the requested resource is global.',
                                                                                                              u'group': u'describe.1',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--global',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'GLOBAL'},
                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                              u'group': u'describe.1',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--region',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'REGION'}},
                                                                                     u'group': False,
                                                                                     u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                 u'is_mutex': True,
                                                                                                                 u'is_required': False}},
                                                                                     u'hidden': False,
                                                                                     u'name': u'describe',
                                                                                     u'path': [u'gcloud',
                                                                                               u'compute',
                                                                                               u'addresses',
                                                                                               u'describe'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of the resource to fetch.',
                                                                                                       u'name': u'name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with an address in a project.\n',
                                                                                                   u'EXAMPLES': u'To get details about a global address, run:\n\n  $ describe ADDRESS --global\n\nTo get details about a regional address, run:\n\n  $ describe ADDRESS --region us-central1\n'}},
                                                                       u'list': {u'capsule': u'List addresses.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--filter',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'EXPRESSION'},
                                                                                            u'--global': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u'If provided, only global resources are shown.',
                                                                                                          u'group': u'list.1',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--global',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'GLOBAL'},
                                                                                            u'--limit': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--limit',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'LIMIT'},
                                                                                            u'--no-uri': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-uri',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_URI'},
                                                                                            u'--page-size': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--page-size',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                            u'--regexp': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--regexp',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'REGEXP'},
                                                                                            u'--regions': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                           u'group': u'list.1',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--regions',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'list',
                                                                                                           u'value': u'REGION'},
                                                                                            u'--sort-by': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--sort-by',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'list',
                                                                                                           u'value': u'FIELD'},
                                                                                            u'--uri': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--uri',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'URI'}},
                                                                                 u'group': False,
                                                                                 u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                         u'is_mutex': True,
                                                                                                         u'is_required': False}},
                                                                                 u'hidden': False,
                                                                                 u'name': u'list',
                                                                                 u'path': [u'gcloud',
                                                                                           u'compute',
                                                                                           u'addresses',
                                                                                           u'list'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': [],
                                                                                                   u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                   u'name': u'names',
                                                                                                   u'nargs': u'*',
                                                                                                   u'required': False,
                                                                                                   u'value': u'NAME'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'*list* lists summary information of addresses in a project. The\n*--uri* option can be used to display URIs instead. Users who want to\nsee more data should use `gcloud compute addresses describe`.\n\nBy default, global addresses and addresses from all regions are listed.\nThe results can be narrowed down by providing the *--regions* or\n*--global* flag.\n',
                                                                                               u'EXAMPLES': u"To list all addresses in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all addresses in a project, run:\n\n  $ list --uri\n\nTo list all of the global addresses in a project, run:\n\n  $ list --global\n\nTo list all of the regional addresses in a project, run:\n\n  $ list --regions\n\nTo list all of the addresses from the ``us-central1'' and the\n``europe-west1'' regions, run:\n\n  $ list --regions us-central1,europe-west1\n"}}},
                                                         u'flags': {},
                                                         u'group': True,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'addresses',
                                                         u'path': [u'gcloud',
                                                                   u'compute',
                                                                   u'addresses'],
                                                         u'positionals': [],
                                                         u'release': u'GA',
                                                         u'sections': {u'DESCRIPTION': u'Read and manipulate Google Compute Engine addresses.'}},
                                          u'backend-services': {u'capsule': u'List, create, and delete backend services.',
                                                                u'commands': {u'add-backend': {u'capsule': u'Add a backend to a backend service.',
                                                                                               u'commands': {},
                                                                                               u'flags': {u'--balancing-mode': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [u'CONNECTION',
                                                                                                                                             u'RATE',
                                                                                                                                             u'UTILIZATION'],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Defines the strategy for balancing load.\n+\n*RATE* and the max rate arguments are available only\nin backend services with HTTP based protocols.\n+\nFor backend services with TCP/SSL protocol either *UTILIZATION* or\n*CONNECTION* are available.\n+\n_BALANCING_MODE_ must be one of:\n+\n*CONNECTION*:::           Spreads load based on how many concurrent connections the group\n          can handle. There are two ways to specify max connections:\n          *--max-connections* which defines the max number of connections\n          for the whole group or *--max-connections-per-instance*, which\n          defines the max number of connections on a per-instance basis.\n\n*RATE*:::           Spreads load based on how many requests per second (RPS) the group\n          can handle. There are two ways to specify max RPS: *--max-rate* which\n          defines the max RPS for the whole group or *--max-rate-per-instance*,\n          which defines the max RPS on a per-instance basis.\n\n*UTILIZATION*:::           Relies on the CPU utilization of the instances in the group when\n          balancing load. Use *--max-utilization* to set a maximum target CPU\n          utilization for each instance. Use *--max-rate-per-instance* or\n          *--max-rate* to optionally limit based on RPS in addition to CPU.\n          You can optionally also limit based on connections (for TCP/SSL) in\n          addition to CPU by setting *--max-connections* or\n          *--max-connections-per-instance*.\n\n+',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--balancing-mode',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'BALANCING_MODE'},
                                                                                                          u'--capacity-scaler': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"A float in the range [0.0, 1.0] that scales the maximum\nparameters for the group (e.g., max rate). A value of 0.0 will\ncause no requests to be sent to the group (i.e., it adds the\ngroup in a ``drained'' state).",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--capacity-scaler',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'CAPACITY_SCALER'},
                                                                                                          u'--description': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'An optional, textual description for the backend.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--description',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'DESCRIPTION'},
                                                                                                          u'--global': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                        u'group': u'add-backend.1',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--global',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'GLOBAL'},
                                                                                                          u'--instance-group': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name or URI of a Google Cloud Instance Group.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--instance-group',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'INSTANCE_GROUP'},
                                                                                                          u'--instance-group-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The region of the instance group to add to the backend service. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                       u'group': u'add-backend.2',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--instance-group-region',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'INSTANCE_GROUP_REGION'},
                                                                                                          u'--instance-group-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The zone of the instance group to add to the backend service. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                     u'group': u'add-backend.2',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--instance-group-zone',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'INSTANCE_GROUP_ZONE'},
                                                                                                          u'--max-connections': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Maximum concurrent connections that the group can handle.',
                                                                                                                                 u'group': u'add-backend.3',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--max-connections',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'MAX_CONNECTIONS'},
                                                                                                          u'--max-connections-per-instance': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The maximum concurrent connections per-instance.',
                                                                                                                                              u'group': u'add-backend.3',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--max-connections-per-instance',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'MAX_CONNECTIONS_PER_INSTANCE'},
                                                                                                          u'--max-rate': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Maximum requests per second (RPS) that the group can handle.',
                                                                                                                          u'group': u'add-backend.3',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--max-rate',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'MAX_RATE'},
                                                                                                          u'--max-rate-per-instance': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The maximum per-instance requests per second (RPS).',
                                                                                                                                       u'group': u'add-backend.3',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--max-rate-per-instance',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'MAX_RATE_PER_INSTANCE'},
                                                                                                          u'--max-utilization': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The target CPU utilization for the group as a float in the range\n[0.0, 1.0]. This flag can only be provided when the balancing\nmode is *UTILIZATION*.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--max-utilization',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'MAX_UTILIZATION'},
                                                                                                          u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                        u'group': u'add-backend.1',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--region',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'REGION'},
                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The zone of the instance group to add to the backend service. DEPRECATED, use --instance-group-zone flag instead. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                      u'group': u'add-backend.2',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--zone',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'ZONE'}},
                                                                                               u'group': False,
                                                                                               u'groups': {u'add-backend.1': {u'description': u'At most one of these may be specified:',
                                                                                                                              u'is_mutex': True,
                                                                                                                              u'is_required': False},
                                                                                                           u'add-backend.2': {u'description': u'At most one of these may be specified:',
                                                                                                                              u'is_mutex': True,
                                                                                                                              u'is_required': False},
                                                                                                           u'add-backend.3': {u'description': u'At most one of these may be specified:',
                                                                                                                              u'is_mutex': True,
                                                                                                                              u'is_required': False}},
                                                                                               u'hidden': False,
                                                                                               u'name': u'add-backend',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'compute',
                                                                                                         u'backend-services',
                                                                                                         u'add-backend'],
                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The name of the backend service.',
                                                                                                                 u'name': u'name',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'value': u'NAME'}],
                                                                                               u'release': u'GA',
                                                                                               u'sections': {u'DESCRIPTION': u'\n*add-backend* is used to add a backend to a backend service. A\nbackend is a group of tasks that can handle requests sent to a\nbackend service. Currently, the group of tasks can be one or\nmore Google Compute Engine virtual machine instances grouped\ntogether using an instance group.\n\nTraffic is first spread evenly across all virtual machines in\nthe group. When the group is full, traffic is sent to the next\nnearest group(s) that still have remaining capacity.\n\nTo modify the parameters of a backend after it has been added\nto the backend service, use\n`gcloud compute backend-services update-backend` or\n`gcloud compute backend-services edit`.\n'}},
                                                                              u'create': {u'capsule': u'Create a backend service.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--affinity-cookie-ttl': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'If session-affinity is set to "generated_cookie", this flag sets\nthe TTL, in seconds, of the resulting cookie.  A setting of 0\nindicates that the cookie should be transient.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--affinity-cookie-ttl',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'AFFINITY_COOKIE_TTL'},
                                                                                                     u'--connection-draining-timeout': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Connection draining timeout to be used during removal of VMs from\ninstance groups. This guarantees that for the specified time all existing\nconnections to a VM will remain untouched, but no new connections will be\naccepted. Set timeout to zero to disable connection draining. Enable\nfeature by specifying a timeout of up to one hour.\nIf the flag is omitted API default value (0s) will be used.\nValid units for this flag are `s` for seconds, `m` for minutes, and\n`h` for hours.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--connection-draining-timeout',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'CONNECTION_DRAINING_TIMEOUT'},
                                                                                                     u'--description': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'An optional, textual description for the backend service.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--description',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'DESCRIPTION'},
                                                                                                     u'--enable-cdn': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'Enable Cloud CDN for the backend service. Cloud CDN can cache HTTP\nresponses from a backend service at the edge of the network, close to\nusers. Cloud CDN is disabled by default.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--enable-cdn',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'ENABLE_CDN'},
                                                                                                     u'--global': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                   u'group': u'create.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--global',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'GLOBAL'},
                                                                                                     u'--health-checks': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Specifies a list of health check objects for checking the health of\nthe backend service. Health checks need not be for the same protocol\nas that of the backend service.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--health-checks',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'list',
                                                                                                                          u'value': u'HEALTH_CHECK'},
                                                                                                     u'--http-health-checks': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Specifies a list of HTTP health check objects for checking the health\nof the backend service.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--http-health-checks',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                     u'--https-health-checks': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Specifies a list of HTTPS health check objects for checking the health\nof the backend service.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--https-health-checks',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'HTTPS_HEALTH_CHECK'},
                                                                                                     u'--load-balancing-scheme': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [u'INTERNAL',
                                                                                                                                               u'EXTERNAL'],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': u'EXTERNAL',
                                                                                                                                  u'description': u'Specifies if this is internal or external load balancer. _LOAD_BALANCING_SCHEME_ must be one of: *INTERNAL*, *EXTERNAL*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--load-balancing-scheme',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LOAD_BALANCING_SCHEME'},
                                                                                                     u'--no-enable-cdn': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-enable-cdn',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_ENABLE_CDN'},
                                                                                                     u'--port': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The TCP port to use when connecting to the backend. --port is being deprecated in favor of --port-name.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--port',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'PORT'},
                                                                                                     u'--port-name': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"The name of a service that has been added to an instance group\nin this backend. Instance group services map a name to a port\nnumber which is used by the load balancing service.\nOnly one ``port-name'' may be added to a backend service, and that\nname must exist as a service on all instance groups that are a\npart of this backend service. The port number associated with the\nname may differ between instances. If you do not specify\nthis flag, your instance groups must have a service named ``http''\nconfigured. See also\n`gcloud compute instance-groups set-named-ports --help`.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--port-name',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'PORT_NAME'},
                                                                                                     u'--protocol': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [u'HTTP',
                                                                                                                                  u'HTTPS',
                                                                                                                                  u'SSL',
                                                                                                                                  u'TCP',
                                                                                                                                  u'UDP'],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The protocol for incoming requests. _PROTOCOL_ must be one of: *HTTP*, *HTTPS*, *SSL*, *TCP*, *UDP*.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--protocol',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'PROTOCOL'},
                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                   u'group': u'create.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--region',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGION'},
                                                                                                     u'--session-affinity': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [u'CLIENT_IP',
                                                                                                                                          u'GENERATED_COOKIE',
                                                                                                                                          u'NONE'],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The type of session affinity to use for this backend service. _SESSION_AFFINITY_ must be one of:\n+\n*CLIENT_IP*::: Route requests to instances based on the hash of the client\'s IP address.\n*GENERATED_COOKIE*::: Route requests to instances based on the contents of the "GCLB" cookie set by the load balancer.\n*NONE*::: Session affinity is disabled.\n+',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--session-affinity',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'SESSION_AFFINITY'},
                                                                                                     u'--timeout': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': u'30s',
                                                                                                                    u'description': u"The amount of time to wait for a backend to respond to a request\nbefore considering the request failed. For example, specifying\n``10s'' will give backends 10 seconds to respond to\nrequests. Valid units for this flag are ``s'' for seconds, ``m''\nfor minutes, and ``h'' for hours.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--timeout',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'TIMEOUT'}},
                                                                                          u'group': False,
                                                                                          u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                    u'is_mutex': True,
                                                                                                                    u'is_required': False}},
                                                                                          u'hidden': False,
                                                                                          u'name': u'create',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'backend-services',
                                                                                                    u'create'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the backend service.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u"\n*create* is used to create backend services. Backend\nservices define groups of backends that can receive\ntraffic. Each backend group has parameters that define the\ngroup's capacity (e.g., max CPU utilization, max queries per\nsecond, ...). URL maps define which requests are sent to which\nbackend services.\n\nBackend services created through this command will start out\nwithout any backend groups. To add backend groups, use 'gcloud\ncompute backend-services add-backend' or 'gcloud compute\nbackend-services edit'.\n"}},
                                                                              u'delete': {u'capsule': u'Delete backend services.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--global': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                   u'group': u'delete.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--global',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'GLOBAL'},
                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                   u'group': u'delete.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--region',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGION'}},
                                                                                          u'group': False,
                                                                                          u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                    u'is_mutex': True,
                                                                                                                    u'is_required': False}},
                                                                                          u'hidden': False,
                                                                                          u'name': u'delete',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'backend-services',
                                                                                                    u'delete'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The names of the backend services.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'+',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'*delete* deletes one or more backend services.'}},
                                                                              u'describe': {u'capsule': u'Display detailed information about a backend service.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--global': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': False,
                                                                                                                     u'description': u'If provided, it is assumed that the requested resource is global.',
                                                                                                                     u'group': u'describe.1',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--global',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'GLOBAL'},
                                                                                                       u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                     u'group': u'describe.1',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--region',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'REGION'}},
                                                                                            u'group': False,
                                                                                            u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                        u'is_mutex': True,
                                                                                                                        u'is_required': False}},
                                                                                            u'hidden': False,
                                                                                            u'name': u'describe',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'backend-services',
                                                                                                      u'describe'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the resource to fetch.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a backend service in a project.\n',
                                                                                                          u'EXAMPLES': u"\nTo get details about a global backend service, run:\n\n  $ describe --global\n\nTo get details about a regional backend service in the ``us-central1'' regions,\nrun:\n\n  $ describe --region us-central1\n"}},
                                                                              u'edit': {u'capsule': u'Modify backend services.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--global': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                 u'group': u'edit.1',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--global',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'GLOBAL'},
                                                                                                   u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                 u'group': u'edit.1',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--region',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'REGION'}},
                                                                                        u'group': False,
                                                                                        u'groups': {u'edit.1': {u'description': u'At most one of these may be specified:',
                                                                                                                u'is_mutex': True,
                                                                                                                u'is_required': False}},
                                                                                        u'hidden': False,
                                                                                        u'name': u'edit',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'backend-services',
                                                                                                  u'edit'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The name of the backend service.',
                                                                                                          u'name': u'name',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'*edit* can be used to modify a backend service. The backend\nservice resource is fetched from the server and presented in a text\neditor. After the file is saved and closed, this command will\nupdate the resource. Only fields that can be modified are\ndisplayed in the editor.\n\nBackends are named by their associated instances groups, and one\nof the ``--group\'\' or ``--instance-group\'\' flags is required to\nidentify the backend that you are modifying.  You cannot "change"\nthe instance group associated with a backend, but you can accomplish\nsomething similar with ``backend-services remove-backend\'\' and\n``backend-services add-backend\'\'.\n\nThe editor used to modify the resource is chosen by inspecting\nthe ``EDITOR\'\' environment variable.\n'}},
                                                                              u'get-health': {u'capsule': u'Get backend health statuses from a backend service.',
                                                                                              u'commands': {},
                                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--filter',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'EXPRESSION'},
                                                                                                         u'--global': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                       u'group': u'get-health.1',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--global',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'GLOBAL'},
                                                                                                         u'--limit': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--limit',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'LIMIT'},
                                                                                                         u'--no-uri': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': True,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-uri',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_URI'},
                                                                                                         u'--page-size': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--page-size',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                                         u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                       u'group': u'get-health.1',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--region',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'REGION'},
                                                                                                         u'--sort-by': {u'attr': {},
                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--sort-by',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'list',
                                                                                                                        u'value': u'FIELD'},
                                                                                                         u'--uri': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--uri',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'URI'}},
                                                                                              u'group': False,
                                                                                              u'groups': {u'get-health.1': {u'description': u'At most one of these may be specified:',
                                                                                                                            u'is_mutex': True,
                                                                                                                            u'is_required': False}},
                                                                                              u'hidden': False,
                                                                                              u'name': u'get-health',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'compute',
                                                                                                        u'backend-services',
                                                                                                        u'get-health'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The name of the backend service.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u"\n*get-health* is used to request the current health status of\ninstances in a backend service. Every group in the service\nis checked and the health status of each configured instance\nis printed.\n\nIf a group contains names of instances that don't exist or\ninstances that haven't yet been pushed to the load-balancing\nsystem, they will not show up. Those that are listed as\n``HEALTHY'' are able to receive load-balanced traffic. Those that\nare marked as ``UNHEALTHY'' are either failing the configured\nhealth-check or not responding to it.\n\nSince the health checks are performed continuously and in\na distributed manner, the state returned by this command is\nthe most recent result of a vote of several redundant health\nchecks. Backend services that do not have a valid global\nforwarding rule referencing it will not be health checked and\nso will have no health status.\n"}},
                                                                              u'list': {u'capsule': u'List Google Compute Engine backend services.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--filter',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                   u'--global': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'If provided, only global resources are shown.',
                                                                                                                 u'group': u'list.1',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--global',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'GLOBAL'},
                                                                                                   u'--limit': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--limit',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'LIMIT'},
                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': True,
                                                                                                                 u'description': u'',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': True,
                                                                                                                 u'name': u'--no-uri',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'NO_URI'},
                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--page-size',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                   u'--regexp': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--regexp',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'REGEXP'},
                                                                                                   u'--regions': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                  u'group': u'list.1',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--regions',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'list',
                                                                                                                  u'value': u'REGION'},
                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--sort-by',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'list',
                                                                                                                  u'value': u'FIELD'},
                                                                                                   u'--uri': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--uri',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'URI'}},
                                                                                        u'group': False,
                                                                                        u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                u'is_mutex': True,
                                                                                                                u'is_required': False}},
                                                                                        u'hidden': False,
                                                                                        u'name': u'list',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'backend-services',
                                                                                                  u'list'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': [],
                                                                                                          u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                          u'name': u'names',
                                                                                                          u'nargs': u'*',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine backend services in a project.\n\nBy default, global backend services and backend services from all regions are listed. The results can be narrowed down by\nproviding the ``--global'' or ``--regions'' flag.\n",
                                                                                                      u'EXAMPLES': u"To list all backend services in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all backend services in a project, run:\n\n  $ list --uri\n\nTo list all global backend services in a project, run:\n\n  $ list --global\n\nTo list all backend services in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n"}},
                                                                              u'remove-backend': {u'capsule': u'Remove a backend from a backend service.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {u'--global': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                           u'group': u'remove-backend.1',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--global',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'GLOBAL'},
                                                                                                             u'--instance-group': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name or URI of a Google Cloud Instance Group.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--instance-group',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'INSTANCE_GROUP'},
                                                                                                             u'--instance-group-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The region of the instance group to remove from the backend service. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                          u'group': u'remove-backend.2',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--instance-group-region',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'INSTANCE_GROUP_REGION'},
                                                                                                             u'--instance-group-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The zone of the instance group to remove from the backend service. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                        u'group': u'remove-backend.2',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--instance-group-zone',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'INSTANCE_GROUP_ZONE'},
                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                           u'group': u'remove-backend.1',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--region',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'REGION'},
                                                                                                             u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The zone of the instance group to remove from the backend service. DEPRECATED, use --instance-group-zone flag instead. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                         u'group': u'remove-backend.2',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--zone',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'ZONE'}},
                                                                                                  u'group': False,
                                                                                                  u'groups': {u'remove-backend.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                    u'is_mutex': True,
                                                                                                                                    u'is_required': False},
                                                                                                              u'remove-backend.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                    u'is_mutex': True,
                                                                                                                                    u'is_required': False}},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'remove-backend',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'compute',
                                                                                                            u'backend-services',
                                                                                                            u'remove-backend'],
                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The name of the backend service.',
                                                                                                                    u'name': u'name',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'NAME'}],
                                                                                                  u'release': u'GA',
                                                                                                  u'sections': {u'DESCRIPTION': u'*remove-backend* is used to remove a backend from a backend\nservice.\n\nBefore removing a backend, it is a good idea to "drain" the\nbackend first. A backend can be drained by setting its\ncapacity scaler to zero through \'gcloud compute\nbackend-services edit\'.'}},
                                                                              u'update': {u'capsule': u'Update a backend service.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--affinity-cookie-ttl': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'If session-affinity is set to "generated_cookie", this flag sets\nthe TTL, in seconds, of the resulting cookie.  A setting of 0\nindicates that the cookie should be transient.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--affinity-cookie-ttl',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'AFFINITY_COOKIE_TTL'},
                                                                                                     u'--connection-draining-timeout': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Connection draining timeout to be used during removal of VMs from\ninstance groups. This guarantees that for the specified time all existing\nconnections to a VM will remain untouched, but no new connections will be\naccepted. Set timeout to zero to disable connection draining. Enable\nfeature by specifying a timeout of up to one hour.\nIf the flag is omitted API default value (0s) will be used.\nValid units for this flag are `s` for seconds, `m` for minutes, and\n`h` for hours.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--connection-draining-timeout',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'CONNECTION_DRAINING_TIMEOUT'},
                                                                                                     u'--description': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'An optional, textual description for the backend service.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--description',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'DESCRIPTION'},
                                                                                                     u'--enable-cdn': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'Enable Cloud CDN for the backend service. Cloud CDN can cache HTTP\nresponses from a backend service at the edge of the network, close to\nusers. Cloud CDN is disabled by default.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--enable-cdn',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'ENABLE_CDN'},
                                                                                                     u'--global': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                   u'group': u'update.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--global',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'GLOBAL'},
                                                                                                     u'--health-checks': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Specifies a list of health check objects for checking the health of\nthe backend service. Health checks need not be for the same protocol\nas that of the backend service.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--health-checks',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'list',
                                                                                                                          u'value': u'HEALTH_CHECK'},
                                                                                                     u'--http-health-checks': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Specifies a list of HTTP health check objects for checking the health\nof the backend service.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--http-health-checks',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                     u'--https-health-checks': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Specifies a list of HTTPS health check objects for checking the health\nof the backend service.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--https-health-checks',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'HTTPS_HEALTH_CHECK'},
                                                                                                     u'--no-enable-cdn': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-enable-cdn',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_ENABLE_CDN'},
                                                                                                     u'--port': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The TCP port to use when connecting to the backend. --port is being deprecated in favor of --port-name.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--port',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'PORT'},
                                                                                                     u'--port-name': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"The name of a service that has been added to an instance group\nin this backend. Instance group services map a name to a port\nnumber which is used by the load balancing service.\nOnly one ``port-name'' may be added to a backend service, and that\nname must exist as a service on all instance groups that are a\npart of this backend service. The port number associated with the\nname may differ between instances. If you do not specify\nthis flag, your instance groups must have a service named ``http''\nconfigured. See also\n`gcloud compute instance-groups set-named-ports --help`.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--port-name',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'PORT_NAME'},
                                                                                                     u'--protocol': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [u'HTTP',
                                                                                                                                  u'HTTPS',
                                                                                                                                  u'SSL',
                                                                                                                                  u'TCP',
                                                                                                                                  u'UDP'],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The protocol for incoming requests. _PROTOCOL_ must be one of: *HTTP*, *HTTPS*, *SSL*, *TCP*, *UDP*.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--protocol',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'PROTOCOL'},
                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                   u'group': u'update.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--region',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGION'},
                                                                                                     u'--session-affinity': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [u'CLIENT_IP',
                                                                                                                                          u'CLIENT_IP_PORT_PROTO',
                                                                                                                                          u'CLIENT_IP_PROTO',
                                                                                                                                          u'GENERATED_COOKIE',
                                                                                                                                          u'NONE'],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The type of session affinity to use for this backend service. _SESSION_AFFINITY_ must be one of:\n+\n*CLIENT_IP*::: Route requests to instances based on the hash of the client\'s IP address.\n*CLIENT_IP_PORT_PROTO*::: Connections from the same client IP with the same IP protocol and port will go to the same VM in the backend while that VM remains healthy. This option cannot be used for HTTP(S) load balancing.\n*CLIENT_IP_PROTO*::: Connections from the same client IP with the same IP protocol willgo to the same VM in the pool while that VM remains healthy. This option cannot be used for HTTP(s) load balancing.\n*GENERATED_COOKIE*::: Route requests to instances based on the contents of the "GCLB" cookie set by the load balancer.\n*NONE*::: Session affinity is disabled.\n+',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--session-affinity',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'SESSION_AFFINITY'},
                                                                                                     u'--timeout': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"The amount of time to wait for a backend to respond to a request\nbefore considering the request failed. For example, specifying\n``10s'' will give backends 10 seconds to respond to\nrequests. Valid units for this flag are ``s'' for seconds, ``m''\nfor minutes, and ``h'' for hours.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--timeout',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'TIMEOUT'}},
                                                                                          u'group': False,
                                                                                          u'groups': {u'update.1': {u'description': u'At most one of these may be specified:',
                                                                                                                    u'is_mutex': True,
                                                                                                                    u'is_required': False}},
                                                                                          u'hidden': False,
                                                                                          u'name': u'update',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'backend-services',
                                                                                                    u'update'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the backend service.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'\n*update* is used to update backend services.\n'}},
                                                                              u'update-backend': {u'capsule': u'Update an existing backend in a backend service.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {u'--balancing-mode': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [u'CONNECTION',
                                                                                                                                                u'RATE',
                                                                                                                                                u'UTILIZATION'],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Defines the strategy for balancing load.\n+\n*RATE* and the max rate arguments are available only\nin backend services with HTTP based protocols.\n+\nFor backend services with TCP/SSL protocol either *UTILIZATION* or\n*CONNECTION* are available.\n+\n_BALANCING_MODE_ must be one of:\n+\n*CONNECTION*:::           Spreads load based on how many concurrent connections the group\n          can handle. There are two ways to specify max connections:\n          *--max-connections* which defines the max number of connections\n          for the whole group or *--max-connections-per-instance*, which\n          defines the max number of connections on a per-instance basis.\n\n*RATE*:::           Spreads load based on how many requests per second (RPS) the group\n          can handle. There are two ways to specify max RPS: *--max-rate* which\n          defines the max RPS for the whole group or *--max-rate-per-instance*,\n          which defines the max RPS on a per-instance basis.\n\n*UTILIZATION*:::           Relies on the CPU utilization of the instances in the group when\n          balancing load. Use *--max-utilization* to set a maximum target CPU\n          utilization for each instance. Use *--max-rate-per-instance* or\n          *--max-rate* to optionally limit based on RPS in addition to CPU.\n          You can optionally also limit based on connections (for TCP/SSL) in\n          addition to CPU by setting *--max-connections* or\n          *--max-connections-per-instance*.\n\n+',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--balancing-mode',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'BALANCING_MODE'},
                                                                                                             u'--capacity-scaler': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A float in the range [0.0, 1.0] that scales the maximum\nparameters for the group (e.g., max rate). A value of 0.0 will\ncause no requests to be sent to the group (i.e., it adds the\ngroup in a ``drained'' state).",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--capacity-scaler',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'CAPACITY_SCALER'},
                                                                                                             u'--description': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'An optional, textual description for the backend.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--description',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'DESCRIPTION'},
                                                                                                             u'--global': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                           u'group': u'update-backend.1',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--global',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'GLOBAL'},
                                                                                                             u'--instance-group': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name or URI of a Google Cloud Instance Group.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--instance-group',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'INSTANCE_GROUP'},
                                                                                                             u'--instance-group-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The region of the instance group to update the backend service. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                          u'group': u'update-backend.2',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--instance-group-region',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'INSTANCE_GROUP_REGION'},
                                                                                                             u'--instance-group-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The zone of the instance group to update the backend service. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                        u'group': u'update-backend.2',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--instance-group-zone',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'INSTANCE_GROUP_ZONE'},
                                                                                                             u'--max-connections': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Maximum concurrent connections that the group can handle.',
                                                                                                                                    u'group': u'update-backend.3',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--max-connections',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'MAX_CONNECTIONS'},
                                                                                                             u'--max-connections-per-instance': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The maximum concurrent connections per-instance.',
                                                                                                                                                 u'group': u'update-backend.3',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--max-connections-per-instance',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'MAX_CONNECTIONS_PER_INSTANCE'},
                                                                                                             u'--max-rate': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Maximum requests per second (RPS) that the group can handle.',
                                                                                                                             u'group': u'update-backend.3',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--max-rate',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'MAX_RATE'},
                                                                                                             u'--max-rate-per-instance': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The maximum per-instance requests per second (RPS).',
                                                                                                                                          u'group': u'update-backend.3',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--max-rate-per-instance',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'MAX_RATE_PER_INSTANCE'},
                                                                                                             u'--max-utilization': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The target CPU utilization for the group as a float in the range\n[0.0, 1.0]. This flag can only be provided when the balancing\nmode is *UTILIZATION*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--max-utilization',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'MAX_UTILIZATION'},
                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The region of the backend service to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                           u'group': u'update-backend.1',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--region',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'REGION'},
                                                                                                             u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The zone of the instance group to update the backend service. DEPRECATED, use --instance-group-zone flag instead. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                         u'group': u'update-backend.2',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--zone',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'ZONE'}},
                                                                                                  u'group': False,
                                                                                                  u'groups': {u'update-backend.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                    u'is_mutex': True,
                                                                                                                                    u'is_required': False},
                                                                                                              u'update-backend.2': {u'description': u'At most one of these may be specified:',
                                                                                                                                    u'is_mutex': True,
                                                                                                                                    u'is_required': False},
                                                                                                              u'update-backend.3': {u'description': u'At most one of these may be specified:',
                                                                                                                                    u'is_mutex': True,
                                                                                                                                    u'is_required': False}},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'update-backend',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'compute',
                                                                                                            u'backend-services',
                                                                                                            u'update-backend'],
                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The name of the backend service.',
                                                                                                                    u'name': u'name',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'NAME'}],
                                                                                                  u'release': u'GA',
                                                                                                  u'sections': {u'DESCRIPTION': u'\n*update-backend* updates a backend that is part of a backend\nservice. This is useful for changing the way a backend\nbehaves. Example changes that can be made include changing the\nload balancing policy and ``draining\'\' a backend by setting\nits capacity scaler to zero.\n\nBackends are named by their associated instances groups, and one\nof the ``--group\'\' or ``--instance-group\'\' flags is required to\nidentify the backend that you are modifying.  You cannot "change"\nthe instance group associated with a backend, but you can accomplish\nsomething similar with ``backend-services remove-backend\'\' and\n``backend-services add-backend\'\'.\n\n`gcloud compute backend-services edit` can also be used to\nupdate a backend if the use of a text editor is desired.\n'}}},
                                                                u'flags': {},
                                                                u'group': True,
                                                                u'groups': {},
                                                                u'hidden': False,
                                                                u'name': u'backend-services',
                                                                u'path': [u'gcloud',
                                                                          u'compute',
                                                                          u'backend-services'],
                                                                u'positionals': [],
                                                                u'release': u'GA',
                                                                u'sections': {u'DESCRIPTION': u'List, create, and delete backend services.'}},
                                          u'config-ssh': {u'capsule': u'Populate SSH config files with Host entries from each instance.',
                                                          u'commands': {},
                                                          u'flags': {u'--dry-run': {u'attr': {},
                                                                                    u'category': u'',
                                                                                    u'choices': [],
                                                                                    u'completer': u'',
                                                                                    u'default': False,
                                                                                    u'description': u'If provided, the proposed changes to the SSH config file are printed to standard output and no actual changes are made.',
                                                                                    u'group': u'',
                                                                                    u'hidden': False,
                                                                                    u'name': u'--dry-run',
                                                                                    u'nargs': u'0',
                                                                                    u'required': False,
                                                                                    u'type': u'bool',
                                                                                    u'value': u'DRY_RUN'},
                                                                     u'--force-key-file-overwrite': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--force-key-file-overwrite',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                     u'--no-dry-run': {u'attr': {},
                                                                                       u'category': u'',
                                                                                       u'choices': [],
                                                                                       u'completer': u'',
                                                                                       u'default': True,
                                                                                       u'description': u'',
                                                                                       u'group': u'',
                                                                                       u'hidden': True,
                                                                                       u'name': u'--no-dry-run',
                                                                                       u'nargs': u'0',
                                                                                       u'required': False,
                                                                                       u'type': u'bool',
                                                                                       u'value': u'NO_DRY_RUN'},
                                                                     u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': False,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-force-key-file-overwrite',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                     u'--no-remove': {u'attr': {},
                                                                                      u'category': u'',
                                                                                      u'choices': [],
                                                                                      u'completer': u'',
                                                                                      u'default': True,
                                                                                      u'description': u'',
                                                                                      u'group': u'',
                                                                                      u'hidden': True,
                                                                                      u'name': u'--no-remove',
                                                                                      u'nargs': u'0',
                                                                                      u'required': False,
                                                                                      u'type': u'bool',
                                                                                      u'value': u'NO_REMOVE'},
                                                                     u'--remove': {u'attr': {},
                                                                                   u'category': u'',
                                                                                   u'choices': [],
                                                                                   u'completer': u'',
                                                                                   u'default': False,
                                                                                   u'description': u'If provided, any changes made to the SSH config file by this tool are reverted.',
                                                                                   u'group': u'',
                                                                                   u'hidden': False,
                                                                                   u'name': u'--remove',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'type': u'bool',
                                                                                   u'value': u'REMOVE'},
                                                                     u'--ssh-config-file': {u'attr': {},
                                                                                            u'category': u'',
                                                                                            u'choices': [],
                                                                                            u'completer': u'',
                                                                                            u'default': None,
                                                                                            u'description': u"Specifies an alternative per-user SSH configuration file. By\ndefault, this is ``~/.ssh/config''.",
                                                                                            u'group': u'',
                                                                                            u'hidden': False,
                                                                                            u'name': u'--ssh-config-file',
                                                                                            u'nargs': u'0',
                                                                                            u'required': False,
                                                                                            u'type': u'string',
                                                                                            u'value': u'SSH_CONFIG_FILE'},
                                                                     u'--ssh-key-file': {u'attr': {},
                                                                                         u'category': u'',
                                                                                         u'choices': [],
                                                                                         u'completer': u'',
                                                                                         u'default': None,
                                                                                         u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                         u'group': u'',
                                                                                         u'hidden': False,
                                                                                         u'name': u'--ssh-key-file',
                                                                                         u'nargs': u'0',
                                                                                         u'required': False,
                                                                                         u'type': u'string',
                                                                                         u'value': u'SSH_KEY_FILE'}},
                                                          u'group': False,
                                                          u'groups': {},
                                                          u'hidden': False,
                                                          u'name': u'config-ssh',
                                                          u'path': [u'gcloud',
                                                                    u'compute',
                                                                    u'config-ssh'],
                                                          u'positionals': [],
                                                          u'release': u'GA',
                                                          u'sections': {u'DESCRIPTION': u"*config-ssh* makes SSHing to virtual machine instances easier\nby adding an alias for each instance to the user SSH configuration\n(``~/.ssh/config'') file.\n\nIn most cases, it is sufficient to run:\n\n  $ config-ssh\n\nEach instance will be given an alias of the form\n``NAME.ZONE.PROJECT''. For example, if ``example-instance'' resides in\n``us-central1-a'', you can SSH to it by running:\n\n  $ ssh example-instance.us-central1-a.MY-PROJECT\n\nOn some platforms, the host alias can be tab-completed, making\nthe long alias less daunting to type.\n\nThe aliases created interface with SSH-based programs like\n*scp(1)*, so it is possible to use the aliases elsewhere:\n\n  $ scp ~/MY-FILE example-instance.us-central1-a.MY-PROJECT:~\n\nWhenever instances are added, removed, or their external IP\naddresses are changed, this command should be re-executed to\nupdate the configuration.\n\nThis command ensures that the user's public SSH key is present\nin the project's metadata. If the user does not have a public\nSSH key, one is generated using *ssh-keygen(1)* (if the `--quiet`\nflag is given, the generated key will have an empty passphrase).\n"}},
                                          u'connect-to-serial-port': {u'capsule': u'Connect to the serial port of an instance.',
                                                                      u'commands': {},
                                                                      u'flags': {u'--dry-run': {u'attr': {},
                                                                                                u'category': u'',
                                                                                                u'choices': [],
                                                                                                u'completer': u'',
                                                                                                u'default': False,
                                                                                                u'description': u'If provided, the ssh command is printed to standard out rather than being executed.',
                                                                                                u'group': u'',
                                                                                                u'hidden': False,
                                                                                                u'name': u'--dry-run',
                                                                                                u'nargs': u'0',
                                                                                                u'required': False,
                                                                                                u'type': u'bool',
                                                                                                u'value': u'DRY_RUN'},
                                                                                 u'--extra-args': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': {},
                                                                                                   u'description': u'Optional arguments can be passed to the serial port connection by\npassing key-value pairs to this flag, such as max-connections=N or\nreplay-lines=N. See https://cloud.google.com/compute/docs/instances/interacting-with-serial-console for additional options.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--extra-args',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'dict',
                                                                                                   u'value': u'KEY=VALUE'},
                                                                                 u'--force-key-file-overwrite': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--force-key-file-overwrite',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                                 u'--no-dry-run': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': True,
                                                                                                   u'description': u'',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': True,
                                                                                                   u'name': u'--no-dry-run',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'NO_DRY_RUN'},
                                                                                 u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-force-key-file-overwrite',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                                 u'--no-plain': {u'attr': {},
                                                                                                 u'category': u'',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': True,
                                                                                                 u'description': u'',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': True,
                                                                                                 u'name': u'--no-plain',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'type': u'bool',
                                                                                                 u'value': u'NO_PLAIN'},
                                                                                 u'--plain': {u'attr': {},
                                                                                              u'category': u'',
                                                                                              u'choices': [],
                                                                                              u'completer': u'',
                                                                                              u'default': False,
                                                                                              u'description': u'',
                                                                                              u'group': u'',
                                                                                              u'hidden': True,
                                                                                              u'name': u'--plain',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'type': u'bool',
                                                                                              u'value': u'PLAIN'},
                                                                                 u'--port': {u'attr': {},
                                                                                             u'category': u'',
                                                                                             u'choices': [],
                                                                                             u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u'The number of the requested serial port. Can be 1-4, default is 1.\n+\nInstances can support up to four serial ports. By default, this\ncommand will connect to the first serial port. Setting this flag\nwill connect to the requested serial port.',
                                                                                             u'group': u'',
                                                                                             u'hidden': False,
                                                                                             u'name': u'--port',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'type': u'string',
                                                                                             u'value': u'PORT'},
                                                                                 u'--serial-port-gateway': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': u'ssh-serialport.googleapis.com',
                                                                                                            u'description': u'',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': True,
                                                                                                            u'name': u'--serial-port-gateway',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'SERIAL_PORT_GATEWAY'},
                                                                                 u'--ssh-key-file': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--ssh-key-file',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'SSH_KEY_FILE'},
                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                             u'category': u'',
                                                                                             u'choices': [],
                                                                                             u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u"The zone of the instance to connect to. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                             u'group': u'',
                                                                                             u'hidden': False,
                                                                                             u'name': u'--zone',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'type': u'string',
                                                                                             u'value': u'ZONE'}},
                                                                      u'group': False,
                                                                      u'groups': {},
                                                                      u'hidden': False,
                                                                      u'name': u'connect-to-serial-port',
                                                                      u'path': [u'gcloud',
                                                                                u'compute',
                                                                                u'connect-to-serial-port'],
                                                                      u'positionals': [{u'completer': u'',
                                                                                        u'default': None,
                                                                                        u'description': u"Specifies the user/instance for the serial port connection.\n+\n``USER'' specifies the username to authenticate as. If omitted,\nthe current OS user is selected.",
                                                                                        u'name': u'user-host',
                                                                                        u'nargs': u'0',
                                                                                        u'required': False,
                                                                                        u'value': u'[USER@]INSTANCE'}],
                                                                      u'release': u'GA',
                                                                      u'sections': {u'DESCRIPTION': u"*connect-to-serial-port* allows users to connect to, and interact with, a VM's\nvirtual serial port using ssh as the secure, authenticated transport\nprotocol.\n\nThe user must first enable serial port access to a given VM by setting\nthe 'serial-port-enable=true' metadata key-value pair. Setting\n'serial-port-enable' on the project-level metadata enables serial port\naccess to all VMs in the project.\n\nThis command uses the same SSH key pair as the `gcloud compute ssh`\ncommand and also ensures that the user's public SSH key is present in\nthe project's metadata. If the user does not have a public SSH key,\none is generated using ssh-keygen.\n"}},
                                          u'copy-files': {u'capsule': u'Copy files to and from Google Compute Engine virtual machines.',
                                                          u'commands': {},
                                                          u'flags': {u'--dry-run': {u'attr': {},
                                                                                    u'category': u'',
                                                                                    u'choices': [],
                                                                                    u'completer': u'',
                                                                                    u'default': False,
                                                                                    u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                                    u'group': u'',
                                                                                    u'hidden': False,
                                                                                    u'name': u'--dry-run',
                                                                                    u'nargs': u'0',
                                                                                    u'required': False,
                                                                                    u'type': u'bool',
                                                                                    u'value': u'DRY_RUN'},
                                                                     u'--force-key-file-overwrite': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--force-key-file-overwrite',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                                     u'--no-dry-run': {u'attr': {},
                                                                                       u'category': u'',
                                                                                       u'choices': [],
                                                                                       u'completer': u'',
                                                                                       u'default': True,
                                                                                       u'description': u'',
                                                                                       u'group': u'',
                                                                                       u'hidden': True,
                                                                                       u'name': u'--no-dry-run',
                                                                                       u'nargs': u'0',
                                                                                       u'required': False,
                                                                                       u'type': u'bool',
                                                                                       u'value': u'NO_DRY_RUN'},
                                                                     u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': False,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-force-key-file-overwrite',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                                     u'--no-plain': {u'attr': {},
                                                                                     u'category': u'',
                                                                                     u'choices': [],
                                                                                     u'completer': u'',
                                                                                     u'default': True,
                                                                                     u'description': u'',
                                                                                     u'group': u'',
                                                                                     u'hidden': True,
                                                                                     u'name': u'--no-plain',
                                                                                     u'nargs': u'0',
                                                                                     u'required': False,
                                                                                     u'type': u'bool',
                                                                                     u'value': u'NO_PLAIN'},
                                                                     u'--plain': {u'attr': {},
                                                                                  u'category': u'',
                                                                                  u'choices': [],
                                                                                  u'completer': u'',
                                                                                  u'default': False,
                                                                                  u'description': u'Suppresses the automatic addition of *ssh(1)*/*scp(1)* flags. This flag\nis useful if you want to take care of authentication yourself or\nuse specific ssh/scp features.',
                                                                                  u'group': u'',
                                                                                  u'hidden': False,
                                                                                  u'name': u'--plain',
                                                                                  u'nargs': u'0',
                                                                                  u'required': False,
                                                                                  u'type': u'bool',
                                                                                  u'value': u'PLAIN'},
                                                                     u'--ssh-key-file': {u'attr': {},
                                                                                         u'category': u'',
                                                                                         u'choices': [],
                                                                                         u'completer': u'',
                                                                                         u'default': None,
                                                                                         u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                         u'group': u'',
                                                                                         u'hidden': False,
                                                                                         u'name': u'--ssh-key-file',
                                                                                         u'nargs': u'0',
                                                                                         u'required': False,
                                                                                         u'type': u'string',
                                                                                         u'value': u'SSH_KEY_FILE'},
                                                                     u'--strict-host-key-checking': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [u'yes',
                                                                                                                  u'no',
                                                                                                                  u'ask'],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u"Override the default behavior of StrictHostKeyChecking. By default,\nStrictHostKeyChecking is set to 'no' the first time you connect to an\ninstance and will be set to 'yes' for all subsequent connections. Use\nthis flag to specify a value for the connection. _STRICT_HOST_KEY_CHECKING_ must be one of: *yes*, *no*, *ask*.",
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--strict-host-key-checking',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'STRICT_HOST_KEY_CHECKING'},
                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                 u'category': u'',
                                                                                 u'choices': [],
                                                                                 u'completer': u'',
                                                                                 u'default': None,
                                                                                 u'description': u"The zone of the instance to copy files to/from. If omitted,\nyou will be prompted to select a zone.\n+\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                 u'group': u'',
                                                                                 u'hidden': False,
                                                                                 u'name': u'--zone',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'type': u'string',
                                                                                 u'value': u'ZONE'}},
                                                          u'group': False,
                                                          u'groups': {},
                                                          u'hidden': False,
                                                          u'name': u'copy-files',
                                                          u'path': [u'gcloud',
                                                                    u'compute',
                                                                    u'copy-files'],
                                                          u'positionals': [{u'completer': u'',
                                                                            u'default': None,
                                                                            u'description': u'Specifies a source file.',
                                                                            u'name': u'sources',
                                                                            u'nargs': u'+',
                                                                            u'required': False,
                                                                            u'value': u'[[USER@]INSTANCE:]SRC'},
                                                                           {u'completer': u'',
                                                                            u'default': None,
                                                                            u'description': u'Specifies a destination for the source files.',
                                                                            u'name': u'destination',
                                                                            u'nargs': u'0',
                                                                            u'required': False,
                                                                            u'value': u'[[USER@]INSTANCE:]DEST'}],
                                                          u'release': u'GA',
                                                          u'sections': {u'DESCRIPTION': u"*copy-files* copies files between a virtual machine instance\nand your local machine.\n\nTo denote a remote file, prefix the file name with the virtual\nmachine instance name (e.g., _example-instance_:~/_FILE_). To\ndenote a local file, do not add a prefix to the file name\n(e.g., ~/_FILE_). For example, to copy a remote directory\nto your local host, run:\n\n  $ copy-files example-instance:~/REMOTE-DIR ~/LOCAL-DIR --zone us-central1-a\n\nIn the above example, ``~/REMOTE-DIR'' from ``example-instance'' is\ncopied into the ~/_LOCAL-DIR_ directory.\n\nConversely, files from your local computer can be copied to a\nvirtual machine:\n\n  $ copy-files ~/LOCAL-FILE-1 ~/LOCAL-FILE-2 example-instance:~/REMOTE-DIR --zone us-central1-a\n\nIf a file contains a colon (``:''), you must specify it by\neither using an absolute path or a path that begins with\n``./''.\n\nUnder the covers, *scp(1)* is used to facilitate the transfer.\n\nWhen the destination is local, all sources must be the same\nvirtual machine instance. When the destination is remote, all\nsource must be local.\n\nThis command ensures that the user's public SSH key is present\nin the project's metadata. If the user does not have a public\nSSH key, one is generated using *ssh-keygen(1)* (if the the `--quiet`\nflag is given, the generated key will have an empty passphrase).\n"}},
                                          u'disk-types': {u'capsule': u'Read Google Compute Engine virtual disk types.',
                                                          u'commands': {u'describe': {u'capsule': u'Describe a Google Compute Engine disk type.',
                                                                                      u'commands': {},
                                                                                      u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--zone',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'ZONE'}},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'describe',
                                                                                      u'path': [u'gcloud',
                                                                                                u'compute',
                                                                                                u'disk-types',
                                                                                                u'describe'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The name of the resource to fetch.',
                                                                                                        u'name': u'name',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'value': u'NAME'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine disk type.\n'}},
                                                                        u'list': {u'capsule': u'List Google Compute Engine disk types.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--filter',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'EXPRESSION'},
                                                                                             u'--limit': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--limit',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'LIMIT'},
                                                                                             u'--no-uri': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': True,
                                                                                                           u'description': u'',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': True,
                                                                                                           u'name': u'--no-uri',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'NO_URI'},
                                                                                             u'--page-size': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--page-size',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                             u'--regexp': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--regexp',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'REGEXP'},
                                                                                             u'--sort-by': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--sort-by',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'list',
                                                                                                            u'value': u'FIELD'},
                                                                                             u'--uri': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': False,
                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--uri',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'URI'},
                                                                                             u'--zones': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': [],
                                                                                                          u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--zones',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'list',
                                                                                                          u'value': u'ZONE'}},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'list',
                                                                                  u'path': [u'gcloud',
                                                                                            u'compute',
                                                                                            u'disk-types',
                                                                                            u'list'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': [],
                                                                                                    u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                    u'name': u'names',
                                                                                                    u'nargs': u'*',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAME'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine disk types in a project.\n\nBy default, disk types from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                u'EXAMPLES': u"To list all disk types in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all disk types in a project, run:\n\n  $ list --uri\n\nTo list all disk types in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                          u'flags': {},
                                                          u'group': True,
                                                          u'groups': {},
                                                          u'hidden': False,
                                                          u'name': u'disk-types',
                                                          u'path': [u'gcloud',
                                                                    u'compute',
                                                                    u'disk-types'],
                                                          u'positionals': [],
                                                          u'release': u'GA',
                                                          u'sections': {u'DESCRIPTION': u'Read Google Compute Engine virtual disk types.'}},
                                          u'disks': {u'capsule': u'Read and manipulate Google Compute Engine disks.',
                                                     u'commands': {u'create': {u'capsule': u'Create Google Compute Engine persistent disks.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--csek-key-file',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'FILE'},
                                                                                          u'--description': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'An optional, textual description for the disks being created.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--description',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'DESCRIPTION'},
                                                                                          u'--image': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u"An image to apply to the disks being created. When using\nthis option, the size of the disks must be at least as large as\nthe image size. Use ``--size'' to adjust the size of the disks.\n+\nThis flag is mutually exclusive with ``--source-snapshot'' and\n``--image-family''.",
                                                                                                       u'group': u'create.1',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--image',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'IMAGE'},
                                                                                          u'--image-family': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The family of the image that the boot disk will be initialized with. When a family is used instead of an image, the latest non-deprecated image associated with that family is used.',
                                                                                                              u'group': u'create.1',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--image-family',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'IMAGE_FAMILY'},
                                                                                          u'--image-project': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"The project against which all image and image family references will be\nresolved. See ``--image'' for more details.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--image-project',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'IMAGE_PROJECT'},
                                                                                          u'--no-require-csek-key-create': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': True,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--no-require-csek-key-create',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_REQUIRE_CSEK_KEY_CREATE'},
                                                                                          u'--require-csek-key-create': {u'attr': {u'inverted_synopsis': True},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': True,
                                                                                                                         u'description': u'Refuse to create resources not protected by a user managed key in\nthe key file when --csek-key-file is given. This behavior is enabled\nby default to prevent incorrect gcloud invocations from accidentally\ncreating resources with no user managed key. Disabling the check\nallows creation of some resources without a matching\nCustomer-Supplied Encryption Key in the supplied --csek-key-file.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details. Enabled by default, use *--no-require-csek-key-create* to disable.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--require-csek-key-create',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'REQUIRE_CSEK_KEY_CREATE'},
                                                                                          u'--size': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u"Indicates the size of the disks. The value must be a whole\nnumber followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For\nexample, ``10GB'' will produce 10 gigabyte disks.  Disk size\nmust be a multiple of 10 GB.",
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--size',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'SIZE'},
                                                                                          u'--source-snapshot': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'A source snapshot used to create the disks. It is safe to\ndelete a snapshot after a disk has been created from the\nsnapshot. In such cases, the disks will no longer reference\nthe deleted snapshot. To get a list of snapshots in your\ncurrent project, run `gcloud compute snapshots list`. A\nsnapshot from an existing disk can be created using the\n`gcloud compute disks snapshot` command. This flag is mutually\nexclusive with *--image*.\n+\nWhen using this option, the size of the disks must be at least\nas large as the snapshot size. Use *--size* to adjust the\nsize of the disks.',
                                                                                                                 u'group': u'create.1',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--source-snapshot',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'SOURCE_SNAPSHOT'},
                                                                                          u'--type': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Specifies the type of disk to create. To get a\nlist of available disk types, run `gcloud compute disk-types list`.\nThe default disk type is pd-standard.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--type',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'TYPE'},
                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--zone',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'ZONE'}},
                                                                               u'group': False,
                                                                               u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                         u'is_mutex': True,
                                                                                                         u'is_required': False}},
                                                                               u'hidden': False,
                                                                               u'name': u'create',
                                                                               u'path': [u'gcloud',
                                                                                         u'compute',
                                                                                         u'disks',
                                                                                         u'create'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The names of the disks.',
                                                                                                 u'name': u'DISK-NAME',
                                                                                                 u'nargs': u'+',
                                                                                                 u'required': False,
                                                                                                 u'value': u'DISK_NAME'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'*create* creates one or more Google Compute Engine\npersistent disks. When creating virtual machine instances,\ndisks can be attached to the instances through the\n`gcloud compute instances create` command. Disks can also be\nattached to instances that are already running using\n`gcloud compute instances attach-disk`.\n\nDisks are zonal resources, so they reside in a particular zone\nfor their entire lifetime. The contents of a disk can be moved\nto a different zone by snapshotting the disk (using\n`gcloud compute disks snapshot`) and creating a new disk using\n`--source-snapshot` in the desired zone. The contents of a\ndisk can also be moved across project or zone by creating an\nimage (using `gcloud compute images create`) and creating a\nnew disk using `--image` in the desired project and/or\nzone.\n\nWhen creating disks, be sure to include the `--zone` option:\n\n  $ create my-disk-1 my-disk-2 --zone us-east1-a\n'}},
                                                                   u'delete': {u'capsule': u'Delete Google Compute Engine persistent disks.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u"The zone of the disk to delete. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--zone',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'ZONE'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'delete',
                                                                               u'path': [u'gcloud',
                                                                                         u'compute',
                                                                                         u'disks',
                                                                                         u'delete'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The names of the disks.',
                                                                                                 u'name': u'DISK-NAME',
                                                                                                 u'nargs': u'+',
                                                                                                 u'required': False,
                                                                                                 u'value': u'DISK_NAME'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\npersistent disks. Disks can be deleted only if they are not\nbeing used by any virtual machine instances.'}},
                                                                   u'describe': {u'capsule': u'Describe a Google Compute Engine disk.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--zone',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'ZONE'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'describe',
                                                                                 u'path': [u'gcloud',
                                                                                           u'compute',
                                                                                           u'disks',
                                                                                           u'describe'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The name of the disk.',
                                                                                                   u'name': u'DISK-NAME',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'DISK_NAME'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine disk in a project.\n'}},
                                                                   u'list': {u'capsule': u'List Google Compute Engine disks.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--filter',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'EXPRESSION'},
                                                                                        u'--limit': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--limit',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'LIMIT'},
                                                                                        u'--no-uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': True,
                                                                                                      u'description': u'',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': True,
                                                                                                      u'name': u'--no-uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'NO_URI'},
                                                                                        u'--page-size': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--page-size',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                        u'--regexp': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--regexp',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'REGEXP'},
                                                                                        u'--sort-by': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--sort-by',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'FIELD'},
                                                                                        u'--uri': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': False,
                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--uri',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'URI'},
                                                                                        u'--zones': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': [],
                                                                                                     u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--zones',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'list',
                                                                                                     u'value': u'ZONE'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'list',
                                                                             u'path': [u'gcloud',
                                                                                       u'compute',
                                                                                       u'disks',
                                                                                       u'list'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': [],
                                                                                               u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                               u'name': u'names',
                                                                                               u'nargs': u'*',
                                                                                               u'required': False,
                                                                                               u'value': u'NAME'}],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine disks in a project.\n\nBy default, disks from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                           u'EXAMPLES': u"To list all disks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all disks in a project, run:\n\n  $ list --uri\n\nTo list all disks in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}},
                                                                   u'move': {u'capsule': u'Move a disk between zones.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--async': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--async',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'ASYNC'},
                                                                                        u'--destination-zone': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The zone to move the disk to.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--destination-zone',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': True,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'DESTINATION_ZONE'},
                                                                                        u'--no-async': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-async',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_ASYNC'},
                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                    u'category': u'',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--zone',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'ZONE'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'move',
                                                                             u'path': [u'gcloud',
                                                                                       u'compute',
                                                                                       u'disks',
                                                                                       u'move'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'The name of the disk.',
                                                                                               u'name': u'DISK-NAME',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'value': u'DISK_NAME'}],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'*move* facilitates moving a Google Compute Engine disk volume from\none zone to another. You cannot move a disk if it is attached to a\nrunning or stopped instance; use the gcloud compute instances move\ncommand instead.\n\nFor example, running:\n\n   $ gcloud compute disks move example-disk-1 --zone us-central1-b --destination-zone us-central1-f\n\nwill move the disk called example-disk-1, currently running in\nus-central1-b, to us-central1-f.\n'}},
                                                                   u'resize': {u'capsule': u'Resize a disk or disks.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--size': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u"Indicates the new size of the disks. The value must be a whole\nnumber followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For\nexample, ``10GB'' will produce 10 gigabyte disks.  Disk size\nmust be a multiple of 10 GB.",
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--size',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': True,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'SIZE'},
                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--zone',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'ZONE'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'resize',
                                                                               u'path': [u'gcloud',
                                                                                         u'compute',
                                                                                         u'disks',
                                                                                         u'resize'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The names of the disks.',
                                                                                                 u'name': u'DISK-NAME',
                                                                                                 u'nargs': u'+',
                                                                                                 u'required': False,
                                                                                                 u'value': u'DISK_NAME'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'*resize* resizes a Google Compute Engine disk(s).\n\nOnly increasing disk size is supported. Disks can be resized\nregardless of whether they are attached.\n\n',
                                                                                             u'EXAMPLES': u'To resize a disk called example-disk-1 to new size 6TB, run:\n\n   $ resize example-disk-1 --size=6TB\n\nTo resize two disks called example-disk-2 and example-disk-3 to\nnew size 6TB, run:\n\n   $ resize example-disk-2 example-disk-3 --size=6TB\n\nThis assumes that original size of each of these disks is 6TB or less.\n'}},
                                                                   u'snapshot': {u'capsule': u'Create snapshots of Google Compute Engine persistent disks.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--async': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': False,
                                                                                                         u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--async',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'ASYNC'},
                                                                                            u'--csek-key-file': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--csek-key-file',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'FILE'},
                                                                                            u'--description': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'An optional, textual description for the snapshots being created.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--description',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'DESCRIPTION'},
                                                                                            u'--guest-flush': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'Create an application consistent snapshot by informing the OS to prepare for the snapshot process. Currently only supported on Windows instances using the Volume Shadow Copy Service (VSS).',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--guest-flush',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'GUEST_FLUSH'},
                                                                                            u'--no-async': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': True,
                                                                                                            u'description': u'',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': True,
                                                                                                            u'name': u'--no-async',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'NO_ASYNC'},
                                                                                            u'--no-guest-flush': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': True,
                                                                                                                  u'name': u'--no-guest-flush',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'NO_GUEST_FLUSH'},
                                                                                            u'--snapshot-names': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"Names to assign to the snapshots. Without this option, the\nname of each snapshot will be a random, 16-character\nhexadecimal number that starts with a letter. The values of\nthis option run parallel to the disks specified. For example,\n+\n  $ {command} my-disk-1 my-disk-2 my-disk-3 --snapshot-names snapshot-1,snapshot-2,snapshot-3\n+\nwill result in ``my-disk-1'' being snapshotted as\n``snapshot-1'', ``my-disk-2'' as ``snapshot-2'', and so on.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--snapshot-names',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'list',
                                                                                                                  u'value': u'SNAPSHOT_NAME'},
                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"The zone of the disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--zone',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'ZONE'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'snapshot',
                                                                                 u'path': [u'gcloud',
                                                                                           u'compute',
                                                                                           u'disks',
                                                                                           u'snapshot'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The names of the disks.',
                                                                                                   u'name': u'DISK-NAME',
                                                                                                   u'nargs': u'+',
                                                                                                   u'required': False,
                                                                                                   u'value': u'DISK_NAME'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u"Create snapshots of Google Compute Engine persistent disks.\n\n*snapshot* creates snapshots of persistent disks. Snapshots are useful\nfor backing up data or copying a persistent disk. Once created,\nsnapshots may be managed (listed, deleted, etc.) via\n``gcloud compute snapshots''.\n"}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'disks',
                                                     u'path': [u'gcloud',
                                                               u'compute',
                                                               u'disks'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'Read and manipulate Google Compute Engine disks.'}},
                                          u'firewall-rules': {u'capsule': u'List, create, update, and delete Google Compute Engine firewall rules.',
                                                              u'commands': {u'create': {u'capsule': u'Create a Google Compute Engine firewall rule.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--allow': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'A list of protocols and ports whose traffic will be allowed.\n+\nPROTOCOL is the IP protocol whose traffic will be allowed.\nPROTOCOL can be either the name of a well-known protocol\n(e.g., tcp or icmp) or the IP protocol number.\nA list of IP protocols can be found at\nlink:http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml[].\n+\nA port or port range can be specified after PROTOCOL to\nallow traffic through specific ports. If no port or port range\nis specified, connections through all ranges are allowed. For\nexample, the following will create a rule that allows TCP traffic\nthrough port 80 and allows ICMP traffic:\n+\n  $ {command} MY-RULE --allow tcp:80,icmp\n+\nTCP and UDP rules must include a port or port range.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--allow',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': True,
                                                                                                                u'type': u'list',
                                                                                                                u'value': u'PROTOCOL[:PORT[-PORT]]'},
                                                                                                   u'--description': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'A textual description for the firewall rule.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--description',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                   u'--network': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': u'default',
                                                                                                                  u'description': u"The network to which this rule is attached. If omitted, the\nrule is attached to the ``default'' network.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--network',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'NETWORK'},
                                                                                                   u'--source-ranges': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': [],
                                                                                                                        u'description': u'A list of IP address blocks that are allowed to make inbound\nconnections that match the firewall rule to the instances on\nthe network. The IP address blocks must be specified in CIDR\nformat:\nlink:http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing[].\n+\nIf neither --source-ranges nor --source-tags is provided, then this\nflag will default to 0.0.0.0/0, allowing all sources. Multiple IP\naddress blocks can be specified if they are separated by commas.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--source-ranges',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'list',
                                                                                                                        u'value': u'CIDR_RANGE'},
                                                                                                   u'--source-tags': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': [],
                                                                                                                      u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may make network connections that match the\nfirewall rule. If omitted, all instances on the network can\nmake connections that match the rule.\n+\nTags can be assigned to instances during instance creation.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--source-tags',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'list',
                                                                                                                      u'value': u'TAG'},
                                                                                                   u'--target-tags': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': [],
                                                                                                                      u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may accept inbound connections that match the\nfirewall rule. If omitted, all instances on the network can\nreceive inbound connections that match the rule.\n+\nTags can be assigned to instances during instance creation.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--target-tags',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'list',
                                                                                                                      u'value': u'TAG'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'create',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'firewall-rules',
                                                                                                  u'create'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The name of the firewall rule to create.',
                                                                                                          u'name': u'name',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'*create* is used to create firewall rules to allow incoming\ntraffic to a network.'}},
                                                                            u'delete': {u'capsule': u'Delete Google Compute Engine firewall rules.',
                                                                                        u'commands': {},
                                                                                        u'flags': {},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'delete',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'firewall-rules',
                                                                                                  u'delete'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The resources to delete.',
                                                                                                          u'name': u'names',
                                                                                                          u'nargs': u'+',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine firewall\n rules.\n'}},
                                                                            u'describe': {u'capsule': u'Describe a Google Compute Engine firewall rule.',
                                                                                          u'commands': {},
                                                                                          u'flags': {},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'describe',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'firewall-rules',
                                                                                                    u'describe'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the resource to fetch.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine firewall rule in a project.'}},
                                                                            u'list': {u'capsule': u'List Google Compute Engine firewall rules.',
                                                                                      u'commands': {},
                                                                                      u'flags': {u'--filter': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--filter',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'EXPRESSION'},
                                                                                                 u'--limit': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--limit',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'LIMIT'},
                                                                                                 u'--no-uri': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': True,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-uri',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_URI'},
                                                                                                 u'--page-size': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--page-size',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'PAGE_SIZE'},
                                                                                                 u'--regexp': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--regexp',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'REGEXP'},
                                                                                                 u'--sort-by': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--sort-by',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'list',
                                                                                                                u'value': u'FIELD'},
                                                                                                 u'--uri': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--uri',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'URI'}},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'list',
                                                                                      u'path': [u'gcloud',
                                                                                                u'compute',
                                                                                                u'firewall-rules',
                                                                                                u'list'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': [],
                                                                                                        u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                        u'name': u'names',
                                                                                                        u'nargs': u'*',
                                                                                                        u'required': False,
                                                                                                        u'value': u'NAME'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine firewall rules in a project.\n',
                                                                                                    u'EXAMPLES': u'To list all firewall rules in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all firewall rules in a project, run:\n\n  $ list --uri\n'}},
                                                                            u'update': {u'capsule': u'Update a firewall rule.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--allow': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'A list of protocols and ports whose traffic will be allowed.\n+\nPROTOCOL is the IP protocol whose traffic will be allowed.\nPROTOCOL can be either the name of a well-known protocol\n(e.g., tcp or icmp) or the IP protocol number.\nA list of IP protocols can be found at\nlink:http://www.iana.org/assignments/protocol-numbers/protocol-numbers.xhtml[].\n+\nA port or port range can be specified after PROTOCOL to\nallow traffic through specific ports. If no port or port range\nis specified, connections through all ranges are allowed. For\nexample, the following will create a rule that allows TCP traffic\nthrough port 80 and allows ICMP traffic:\n+\n  $ {command} MY-RULE --allow tcp:80,icmp\n+\nTCP and UDP rules must include a port or port range.\n+\nSetting this will override the current values.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--allow',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'list',
                                                                                                                u'value': u'PROTOCOL[:PORT[-PORT]]'},
                                                                                                   u'--description': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'A textual description for the firewall rule. Set to an empty string to clear existing.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--description',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'DESCRIPTION'},
                                                                                                   u'--source-ranges': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'A list of IP address blocks that are allowed to make inbound\nconnections that match the firewall rule to the instances on\nthe network. The IP address blocks must be specified in CIDR\nformat:\nlink:http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing[].\n+\nSetting this will override the existing source ranges for the firewall.\nThe following will clear the existing source ranges:\n+\n  $ {command} MY-RULE --source-ranges',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--source-ranges',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'list',
                                                                                                                        u'value': u'CIDR_RANGE'},
                                                                                                   u'--source-tags': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may make network connections that match the\nfirewall rule. If omitted, all instances on the network can\nmake connections that match the rule.\n+\nTags can be assigned to instances during instance creation.\n+\nSetting this will override the existing source tags for the firewall.\nThe following will clear the existing source tags:\n+\n  $ {command} MY-RULE --source-tags',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--source-tags',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'list',
                                                                                                                      u'value': u'TAG'},
                                                                                                   u'--target-tags': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'A list of instance tags indicating the set of instances on the\nnetwork which may accept inbound connections that match the\nfirewall rule. If omitted, all instances on the network can\nreceive inbound connections that match the rule.\n+\nTags can be assigned to instances during instance creation.\n+\nSetting this will override the existing target tags for the firewall.\nThe following will clear the existing target tags:\n+\n  $ {command} MY-RULE --target-tags',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--target-tags',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'list',
                                                                                                                      u'value': u'TAG'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'update',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'firewall-rules',
                                                                                                  u'update'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The name of the firewall rule to update.',
                                                                                                          u'name': u'name',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'*update* is used to update firewall rules that allow incoming\ntraffic to a network. Only arguments passed in will be updated on the\nfirewall rule.  Other attributes will remain unaffected.\n'}}},
                                                              u'flags': {},
                                                              u'group': True,
                                                              u'groups': {},
                                                              u'hidden': False,
                                                              u'name': u'firewall-rules',
                                                              u'path': [u'gcloud',
                                                                        u'compute',
                                                                        u'firewall-rules'],
                                                              u'positionals': [],
                                                              u'release': u'GA',
                                                              u'sections': {u'DESCRIPTION': u'List, create, update, and delete Google Compute Engine firewall rules.'}},
                                          u'forwarding-rules': {u'capsule': u'Read and manipulate forwarding rules to send traffic to load balancers.',
                                                                u'commands': {u'create': {u'capsule': u'Create a forwarding rule to direct network traffic to a load balancer.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--address': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The external IP address that the forwarding rule will\nserve. All traffic sent to this IP address is directed to the\ntarget pointed to by the forwarding rule. If the address is\nreserved, it must either (1) reside in the global scope if the\nforwarding rule is being configured to point to a target HTTP\nproxy or (2) reside in the same region as the forwarding rule\nif the forwarding rule is being configured to point to a\ntarget pool or target instance. If this flag is omitted, an\nephemeral IP address is assigned.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--address',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'ADDRESS'},
                                                                                                     u'--address-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"The region of the address to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                           u'group': u'create.1',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--address-region',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'ADDRESS_REGION'},
                                                                                                     u'--backend-service': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The target backend service that will receive the traffic.',
                                                                                                                            u'group': u'create.2',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--backend-service',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'BACKEND_SERVICE'},
                                                                                                     u'--backend-service-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The region of the backend service to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                   u'group': u'create.3',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--backend-service-region',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'BACKEND_SERVICE_REGION'},
                                                                                                     u'--description': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'An optional textual description for the forwarding rule.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--description',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'DESCRIPTION'},
                                                                                                     u'--global': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u'If provided, it is assumed the forwarding rule is global.',
                                                                                                                   u'group': u'create.4',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--global',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'GLOBAL'},
                                                                                                     u'--global-address': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'If provided, it is assumed the address is global.',
                                                                                                                           u'group': u'create.1',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--global-address',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'GLOBAL_ADDRESS'},
                                                                                                     u'--global-backend-service': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                   u'group': u'create.3',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--global-backend-service',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'GLOBAL_BACKEND_SERVICE'},
                                                                                                     u'--ip-protocol': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [u'AH',
                                                                                                                                     u'ESP',
                                                                                                                                     u'ICMP',
                                                                                                                                     u'SCTP',
                                                                                                                                     u'TCP',
                                                                                                                                     u'UDP'],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The IP protocol that the rule will serve. The default is TCP. _IP_PROTOCOL_ must be one of: *AH*, *ESP*, *ICMP*, *SCTP*, *TCP*, *UDP*.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--ip-protocol',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'IP_PROTOCOL'},
                                                                                                     u'--load-balancing-scheme': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [u'EXTERNAL',
                                                                                                                                               u'INTERNAL'],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': u'EXTERNAL',
                                                                                                                                  u'description': u'This signifies what the forwarding rule will be used for. _LOAD_BALANCING_SCHEME_ must be one of:\n+\n*EXTERNAL*::: Used for HTTP or HTTPS for External Load Balancing.\n*INTERNAL*::: Used for Internal Network Load Balancing.\n+',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--load-balancing-scheme',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LOAD_BALANCING_SCHEME'},
                                                                                                     u'--network': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'(Only for Internal Load Balancing) The network that this forwarding\nrule applies to. If this field is not specified, the default network\nwill be used. In the absence of the default network, this field must\nbe specified.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--network',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'NETWORK'},
                                                                                                     u'--port-range': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'DEPRECATED, use --ports. If specified, only packets addressed to ports in\nthe specified range will be forwarded. If not specified for regional\nforwarding rules, all ports are matched. This flag is required for global\nforwarding rules.\n+\nEither an individual port (`--port-range 80`) or a range of ports\n(`--port-range 3000-3100`) may be specified.',
                                                                                                                       u'group': u'create.5',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--port-range',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'[PORT | PORT-PORT]'},
                                                                                                     u'--ports': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': [],
                                                                                                                  u'description': u'If specified, only packets addressed to ports in the specified\nlist will be forwarded. If not specified for regional forwarding\nrules, all ports are matched. This flag is required for global\nforwarding rules and accepts a single continuous set of ports.\n+\nIndividual ports and ranges can be specified,\nfor example (`--ports 8000-8004` or `--ports 80`).',
                                                                                                                  u'group': u'create.5',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--ports',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'list',
                                                                                                                  u'value': u'[PORT | PORT-PORT]'},
                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"The region of the forwarding rule to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                   u'group': u'create.4',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--region',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGION'},
                                                                                                     u'--subnet': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'(Only for Internal Load Balancing) The subnetwork that this forwarding\nrule applies to. If the network configured for this forwarding rule is\nin auto subnet mode, the subnetwork is optional. However, if the\nnetwork is in custom subnet mode, a subnetwork must be specified.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--subnet',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'SUBNET'},
                                                                                                     u'--subnet-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The region of the subnetwork to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--subnet-region',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'SUBNET_REGION'},
                                                                                                     u'--target-http-proxy': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The target HTTP proxy that will receive the traffic.',
                                                                                                                              u'group': u'create.2',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--target-http-proxy',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'TARGET_HTTP_PROXY'},
                                                                                                     u'--target-https-proxy': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The target HTTPS proxy that will receive the traffic.',
                                                                                                                               u'group': u'create.2',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--target-https-proxy',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'TARGET_HTTPS_PROXY'},
                                                                                                     u'--target-instance': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u"The name of the target instance that will receive the traffic. The\ntarget instance must be in a zone that's in the forwarding rule's\nregion. Global forwarding rules may not direct traffic to target\ninstances.\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                            u'group': u'create.2',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--target-instance',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'TARGET_INSTANCE'},
                                                                                                     u'--target-instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The zone of the target instance to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--target-instance-zone',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'TARGET_INSTANCE_ZONE'},
                                                                                                     u'--target-pool': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The target pool that will receive the traffic. The target pool\nmust be in the same region as the forwarding rule. Global\nforwarding rules may not direct traffic to target pools.',
                                                                                                                        u'group': u'create.2',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--target-pool',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'TARGET_POOL'},
                                                                                                     u'--target-pool-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--target-pool-region',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'TARGET_POOL_REGION'},
                                                                                                     u'--target-ssl-proxy': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The target SSL proxy that will receive the traffic.',
                                                                                                                             u'group': u'create.2',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--target-ssl-proxy',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'TARGET_SSL_PROXY'},
                                                                                                     u'--target-vpn-gateway': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The target VPN gateway that will receive forwarded traffic.',
                                                                                                                               u'group': u'create.2',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--target-vpn-gateway',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'TARGET_VPN_GATEWAY'},
                                                                                                     u'--target-vpn-gateway-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The region of the VPN gateway to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--target-vpn-gateway-region',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'TARGET_VPN_GATEWAY_REGION'}},
                                                                                          u'group': False,
                                                                                          u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                    u'is_mutex': True,
                                                                                                                    u'is_required': False},
                                                                                                      u'create.2': {u'description': u'Exactly one of these must be specified:',
                                                                                                                    u'is_mutex': True,
                                                                                                                    u'is_required': True},
                                                                                                      u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                                    u'is_mutex': True,
                                                                                                                    u'is_required': False},
                                                                                                      u'create.4': {u'description': u'At most one of these may be specified:',
                                                                                                                    u'is_mutex': True,
                                                                                                                    u'is_required': False},
                                                                                                      u'create.5': {u'description': u'At most one of these may be specified:',
                                                                                                                    u'is_mutex': True,
                                                                                                                    u'is_required': False}},
                                                                                          u'hidden': False,
                                                                                          u'name': u'create',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'forwarding-rules',
                                                                                                    u'create'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the forwarding rule.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u"*create* is used to create a forwarding rule.         Forwarding rules match and direct certain types of traffic to a load\nbalancer which is controlled by a target pool, a target instance,\nor a target HTTP proxy. Target pools and target instances perform load\nbalancing at the layer 3 of the OSI networking model\n(http://en.wikipedia.org/wiki/Network_layer). Target\nHTTP proxies perform load balancing at layer 7.\n\nForwarding rules can be either regional or global. They are\nregional if they point to a target pool or a target instance\nand global if they point to a target HTTP proxy.\n\nFor more information on load balancing, see\nhttps://cloud.google.com/compute/docs/load-balancing-and-autoscaling/.\n\n\nWhen creating a forwarding rule, exactly one of  ``--target-instance'',\n``--target-pool'', ``--target-http-proxy'', ``--target-https-proxy'',\n``--target-ssl-proxy'', or ``--target-vpn-gateway'' must be specified.\n"}},
                                                                              u'delete': {u'capsule': u'Delete forwarding rules.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--global': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u'If provided, it is assumed the forwarding rule is global.',
                                                                                                                   u'group': u'delete.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--global',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'GLOBAL'},
                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"The region of the forwarding rule to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                   u'group': u'delete.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--region',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGION'}},
                                                                                          u'group': False,
                                                                                          u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                    u'is_mutex': True,
                                                                                                                    u'is_required': False}},
                                                                                          u'hidden': False,
                                                                                          u'name': u'delete',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'forwarding-rules',
                                                                                                    u'delete'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The names of the forwarding rules.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'+',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine forwarding rules.'}},
                                                                              u'describe': {u'capsule': u'Display detailed information about a forwarding rule.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--global': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': False,
                                                                                                                     u'description': u'If provided, it is assumed that the requested resource is global.',
                                                                                                                     u'group': u'describe.1',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--global',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'GLOBAL'},
                                                                                                       u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                     u'group': u'describe.1',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--region',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'REGION'}},
                                                                                            u'group': False,
                                                                                            u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                        u'is_mutex': True,
                                                                                                                        u'is_required': False}},
                                                                                            u'hidden': False,
                                                                                            u'name': u'describe',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'forwarding-rules',
                                                                                                      u'describe'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the resource to fetch.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a forwarding rule\nin a project.\n',
                                                                                                          u'EXAMPLES': u'To get details about a global forwarding rule, run:\n\n  $ describe FORWARDING-RULE --global\n\nTo get details about a regional forwarding rule, run:\n\n  $ describe FORWARDING-RULE --region us-central1\n'}},
                                                                              u'list': {u'capsule': u'List Google Compute Engine forwarding rules.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--filter',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                   u'--global': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'If provided, only global resources are shown.',
                                                                                                                 u'group': u'list.1',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--global',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'GLOBAL'},
                                                                                                   u'--limit': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--limit',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'LIMIT'},
                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': True,
                                                                                                                 u'description': u'',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': True,
                                                                                                                 u'name': u'--no-uri',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'NO_URI'},
                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--page-size',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                   u'--regexp': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--regexp',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'REGEXP'},
                                                                                                   u'--regions': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                  u'group': u'list.1',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--regions',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'list',
                                                                                                                  u'value': u'REGION'},
                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--sort-by',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'list',
                                                                                                                  u'value': u'FIELD'},
                                                                                                   u'--uri': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--uri',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'URI'}},
                                                                                        u'group': False,
                                                                                        u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                u'is_mutex': True,
                                                                                                                u'is_required': False}},
                                                                                        u'hidden': False,
                                                                                        u'name': u'list',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'forwarding-rules',
                                                                                                  u'list'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': [],
                                                                                                          u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                          u'name': u'names',
                                                                                                          u'nargs': u'*',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine forwarding rules in a project.\n\nBy default, global forwarding rules and forwarding rules from all regions are listed. The results can be narrowed down by\nproviding the ``--global'' or ``--regions'' flag.\n",
                                                                                                      u'EXAMPLES': u"To list all forwarding rules in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all forwarding rules in a project, run:\n\n  $ list --uri\n\nTo list all global forwarding rules in a project, run:\n\n  $ list --global\n\nTo list all forwarding rules in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n"}},
                                                                              u'set-target': {u'capsule': u'Modify a forwarding rule to direct network traffic to a new target.',
                                                                                              u'commands': {},
                                                                                              u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The target backend service that will receive the traffic.',
                                                                                                                                u'group': u'set-target.1',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--backend-service',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'BACKEND_SERVICE'},
                                                                                                         u'--backend-service-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The region of the backend service to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                       u'group': u'set-target.2',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--backend-service-region',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'BACKEND_SERVICE_REGION'},
                                                                                                         u'--global': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'If provided, it is assumed the forwarding rule is global.',
                                                                                                                       u'group': u'set-target.3',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--global',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'GLOBAL'},
                                                                                                         u'--global-backend-service': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'If provided, it is assumed the backend service is global.',
                                                                                                                                       u'group': u'set-target.2',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--global-backend-service',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'GLOBAL_BACKEND_SERVICE'},
                                                                                                         u'--load-balancing-scheme': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [u'EXTERNAL',
                                                                                                                                                   u'INTERNAL'],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': u'EXTERNAL',
                                                                                                                                      u'description': u'This signifies what the forwarding rule will be used for. _LOAD_BALANCING_SCHEME_ must be one of:\n+\n*EXTERNAL*::: Used for HTTP or HTTPS for External Load Balancing.\n*INTERNAL*::: Used for Internal Network Load Balancing.\n+',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--load-balancing-scheme',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'LOAD_BALANCING_SCHEME'},
                                                                                                         u'--network': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'(Only for Internal Load Balancing) The network that this forwarding\nrule applies to. If this field is not specified, the default network\nwill be used. In the absence of the default network, this field must\nbe specified.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--network',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'NETWORK'},
                                                                                                         u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u"The region of the forwarding rule to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                       u'group': u'set-target.3',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--region',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'REGION'},
                                                                                                         u'--subnet': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'(Only for Internal Load Balancing) The subnetwork that this forwarding\nrule applies to. If the network configured for this forwarding rule is\nin auto subnet mode, the subnetwork is optional. However, if the\nnetwork is in custom subnet mode, a subnetwork must be specified.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--subnet',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'SUBNET'},
                                                                                                         u'--subnet-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The region of the subnetwork to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--subnet-region',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'SUBNET_REGION'},
                                                                                                         u'--target-http-proxy': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The target HTTP proxy that will receive the traffic.',
                                                                                                                                  u'group': u'set-target.1',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--target-http-proxy',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'TARGET_HTTP_PROXY'},
                                                                                                         u'--target-https-proxy': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The target HTTPS proxy that will receive the traffic.',
                                                                                                                                   u'group': u'set-target.1',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--target-https-proxy',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'TARGET_HTTPS_PROXY'},
                                                                                                         u'--target-instance': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u"The name of the target instance that will receive the traffic. The\ntarget instance must be in a zone that's in the forwarding rule's\nregion. Global forwarding rules may not direct traffic to target\ninstances.\nIf not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                u'group': u'set-target.1',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--target-instance',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'TARGET_INSTANCE'},
                                                                                                         u'--target-instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The zone of the target instance to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--target-instance-zone',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'TARGET_INSTANCE_ZONE'},
                                                                                                         u'--target-pool': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The target pool that will receive the traffic. The target pool\nmust be in the same region as the forwarding rule. Global\nforwarding rules may not direct traffic to target pools.',
                                                                                                                            u'group': u'set-target.1',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--target-pool',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'TARGET_POOL'},
                                                                                                         u'--target-pool-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--target-pool-region',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'TARGET_POOL_REGION'},
                                                                                                         u'--target-ssl-proxy': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The target SSL proxy that will receive the traffic.',
                                                                                                                                 u'group': u'set-target.1',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--target-ssl-proxy',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'TARGET_SSL_PROXY'},
                                                                                                         u'--target-vpn-gateway': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The target VPN gateway that will receive forwarded traffic.',
                                                                                                                                   u'group': u'set-target.1',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--target-vpn-gateway',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'TARGET_VPN_GATEWAY'},
                                                                                                         u'--target-vpn-gateway-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The region of the VPN gateway to operate on. If not specified it will be set the region of the forwarding rule. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--target-vpn-gateway-region',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'TARGET_VPN_GATEWAY_REGION'}},
                                                                                              u'group': False,
                                                                                              u'groups': {u'set-target.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                            u'is_mutex': True,
                                                                                                                            u'is_required': True},
                                                                                                          u'set-target.2': {u'description': u'At most one of these may be specified:',
                                                                                                                            u'is_mutex': True,
                                                                                                                            u'is_required': False},
                                                                                                          u'set-target.3': {u'description': u'At most one of these may be specified:',
                                                                                                                            u'is_mutex': True,
                                                                                                                            u'is_required': False}},
                                                                                              u'hidden': False,
                                                                                              u'name': u'set-target',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'compute',
                                                                                                        u'forwarding-rules',
                                                                                                        u'set-target'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The name of the forwarding rule.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u"*set-target* is used to set a new target for a forwarding\nrule.         Forwarding rules match and direct certain types of traffic to a load\nbalancer which is controlled by a target pool, a target instance,\nor a target HTTP proxy. Target pools and target instances perform load\nbalancing at the layer 3 of the OSI networking model\n(http://en.wikipedia.org/wiki/Network_layer). Target\nHTTP proxies perform load balancing at layer 7.\n\nForwarding rules can be either regional or global. They are\nregional if they point to a target pool or a target instance\nand global if they point to a target HTTP proxy.\n\nFor more information on load balancing, see\nhttps://cloud.google.com/compute/docs/load-balancing-and-autoscaling/.\n\n\nWhen creating a forwarding rule, exactly one of  ``--target-instance'',\n``--target-pool'', ``--target-http-proxy'', ``--target-https-proxy'',\n``--target-ssl-proxy'', or ``--target-vpn-gateway'' must be specified.\n"}}},
                                                                u'flags': {},
                                                                u'group': True,
                                                                u'groups': {},
                                                                u'hidden': False,
                                                                u'name': u'forwarding-rules',
                                                                u'path': [u'gcloud',
                                                                          u'compute',
                                                                          u'forwarding-rules'],
                                                                u'positionals': [],
                                                                u'release': u'GA',
                                                                u'sections': {u'DESCRIPTION': u'Read and manipulate forwarding rules to send traffic to load balancers.'}},
                                          u'health-checks': {u'capsule': u'Read and manipulate health checks for load balanced instances.',
                                                             u'commands': {u'create': {u'capsule': u'Create health checks for load balanced instances.',
                                                                                       u'commands': {u'http': {u'capsule': u'Create a HTTP health check to monitor load balanced instances.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': u'5s',
                                                                                                                                                u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--check-interval',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'CHECK_INTERVAL'},
                                                                                                                          u'--description': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'An optional, textual description for the HTTP health check.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--description',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DESCRIPTION'},
                                                                                                                          u'--healthy-threshold': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': 2,
                                                                                                                                                   u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--healthy-threshold',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'int',
                                                                                                                                                   u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                          u'--host': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--host',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'HOST'},
                                                                                                                          u'--port': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': 80,
                                                                                                                                      u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--port',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'int',
                                                                                                                                      u'value': u'PORT'},
                                                                                                                          u'--port-name': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--port-name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'PORT_NAME'},
                                                                                                                          u'--proxy-header': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [u'NONE',
                                                                                                                                                           u'PROXY_V1'],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': u'NONE',
                                                                                                                                              u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--proxy-header',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PROXY_HEADER'},
                                                                                                                          u'--request-path': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': u'/',
                                                                                                                                              u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--request-path',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'REQUEST_PATH'},
                                                                                                                          u'--timeout': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': u'5s',
                                                                                                                                         u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--timeout',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'TIMEOUT'},
                                                                                                                          u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': 2,
                                                                                                                                                     u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--unhealthy-threshold',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'int',
                                                                                                                                                     u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'http',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'compute',
                                                                                                                         u'health-checks',
                                                                                                                         u'create',
                                                                                                                         u'http'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the HTTP health check.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'GA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*http* is used to create a HTTP health check. HTTP health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                     u'https': {u'capsule': u'Create a HTTPS health check to monitor load balanced instances.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': u'5s',
                                                                                                                                                 u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--check-interval',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'CHECK_INTERVAL'},
                                                                                                                           u'--description': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'An optional, textual description for the HTTPS health check.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--description',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'DESCRIPTION'},
                                                                                                                           u'--healthy-threshold': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': 2,
                                                                                                                                                    u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--healthy-threshold',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'int',
                                                                                                                                                    u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                           u'--host': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--host',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'HOST'},
                                                                                                                           u'--port': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': 80,
                                                                                                                                       u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--port',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'int',
                                                                                                                                       u'value': u'PORT'},
                                                                                                                           u'--port-name': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--port-name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PORT_NAME'},
                                                                                                                           u'--proxy-header': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [u'NONE',
                                                                                                                                                            u'PROXY_V1'],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': u'NONE',
                                                                                                                                               u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--proxy-header',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PROXY_HEADER'},
                                                                                                                           u'--request-path': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': u'/',
                                                                                                                                               u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--request-path',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'REQUEST_PATH'},
                                                                                                                           u'--timeout': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': u'5s',
                                                                                                                                          u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--timeout',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'TIMEOUT'},
                                                                                                                           u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': 2,
                                                                                                                                                      u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--unhealthy-threshold',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'int',
                                                                                                                                                      u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'https',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'compute',
                                                                                                                          u'health-checks',
                                                                                                                          u'create',
                                                                                                                          u'https'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the HTTPS health check.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'GA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*https* is used to create a HTTPS health check. HTTPS health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                     u'ssl': {u'capsule': u'Create a SSL health check to monitor load balanced instances.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': u'5s',
                                                                                                                                               u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--check-interval',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'CHECK_INTERVAL'},
                                                                                                                         u'--description': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'An optional, textual description for the SSL health check.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--description',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'DESCRIPTION'},
                                                                                                                         u'--healthy-threshold': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': 2,
                                                                                                                                                  u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--healthy-threshold',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'int',
                                                                                                                                                  u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                         u'--port': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': 80,
                                                                                                                                     u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--port',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'int',
                                                                                                                                     u'value': u'PORT'},
                                                                                                                         u'--port-name': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--port-name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PORT_NAME'},
                                                                                                                         u'--proxy-header': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [u'NONE',
                                                                                                                                                          u'PROXY_V1'],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': u'NONE',
                                                                                                                                             u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--proxy-header',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PROXY_HEADER'},
                                                                                                                         u'--request': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--request',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REQUEST'},
                                                                                                                         u'--response': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--response',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'RESPONSE'},
                                                                                                                         u'--timeout': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': u'5s',
                                                                                                                                        u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--timeout',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'TIMEOUT'},
                                                                                                                         u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': 2,
                                                                                                                                                    u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--unhealthy-threshold',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'int',
                                                                                                                                                    u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'ssl',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'compute',
                                                                                                                        u'health-checks',
                                                                                                                        u'create',
                                                                                                                        u'ssl'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the SSL health check.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'GA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*ssl* is used to create a SSL health check. SSL health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                                     u'tcp': {u'capsule': u'Create a TCP health check to monitor load balanced instances.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': u'5s',
                                                                                                                                               u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--check-interval',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'CHECK_INTERVAL'},
                                                                                                                         u'--description': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'An optional, textual description for the TCP health check.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--description',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'DESCRIPTION'},
                                                                                                                         u'--healthy-threshold': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': 2,
                                                                                                                                                  u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--healthy-threshold',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'int',
                                                                                                                                                  u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                         u'--port': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': 80,
                                                                                                                                     u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--port',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'int',
                                                                                                                                     u'value': u'PORT'},
                                                                                                                         u'--port-name': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The port name that this health check monitors. By default, this is\nempty.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--port-name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PORT_NAME'},
                                                                                                                         u'--proxy-header': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [u'NONE',
                                                                                                                                                          u'PROXY_V1'],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': u'NONE',
                                                                                                                                             u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--proxy-header',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PROXY_HEADER'},
                                                                                                                         u'--request': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--request',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REQUEST'},
                                                                                                                         u'--response': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--response',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'RESPONSE'},
                                                                                                                         u'--timeout': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': u'5s',
                                                                                                                                        u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--timeout',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'TIMEOUT'},
                                                                                                                         u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': 2,
                                                                                                                                                    u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--unhealthy-threshold',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'int',
                                                                                                                                                    u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'tcp',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'compute',
                                                                                                                        u'health-checks',
                                                                                                                        u'create',
                                                                                                                        u'tcp'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the TCP health check.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'GA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*tcp* is used to create a TCP health check. TCP health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}}},
                                                                                       u'flags': {},
                                                                                       u'group': True,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'create',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'compute',
                                                                                                 u'health-checks',
                                                                                                 u'create'],
                                                                                       u'positionals': [],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u'Create health checks for load balanced instances.'}},
                                                                           u'delete': {u'capsule': u'Delete health checks.',
                                                                                       u'commands': {},
                                                                                       u'flags': {},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'delete',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'compute',
                                                                                                 u'health-checks',
                                                                                                 u'delete'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The resources to delete.',
                                                                                                         u'name': u'names',
                                                                                                         u'nargs': u'+',
                                                                                                         u'required': False,
                                                                                                         u'value': u'NAME'}],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nhealth checks.\n'}},
                                                                           u'describe': {u'capsule': u'Display detailed information about a health check.',
                                                                                         u'commands': {},
                                                                                         u'flags': {},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'describe',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'compute',
                                                                                                   u'health-checks',
                                                                                                   u'describe'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The name of the resource to fetch.',
                                                                                                           u'name': u'name',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'NAME'}],
                                                                                         u'release': u'GA',
                                                                                         u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine health check in a project.\n'}},
                                                                           u'list': {u'capsule': u'List Google Compute Engine health checks.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--filter',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'EXPRESSION'},
                                                                                                u'--limit': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--limit',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'LIMIT'},
                                                                                                u'--no-uri': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-uri',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_URI'},
                                                                                                u'--page-size': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--page-size',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                u'--protocol': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'If protocol is specified, only health checks for that protocol are\nlisted, and protocol-specific columns are added to the output. By\ndefault, health checks for all protocols are listed.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--protocol',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'PROTOCOL'},
                                                                                                u'--regexp': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--regexp',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'REGEXP'},
                                                                                                u'--sort-by': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--sort-by',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'list',
                                                                                                               u'value': u'FIELD'},
                                                                                                u'--uri': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--uri',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'URI'}},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'list',
                                                                                     u'path': [u'gcloud',
                                                                                               u'compute',
                                                                                               u'health-checks',
                                                                                               u'list'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': [],
                                                                                                       u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                       u'name': u'names',
                                                                                                       u'nargs': u'*',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine health checks in a project.\n',
                                                                                                   u'EXAMPLES': u'To list all health checks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all health checks in a project, run:\n\n  $ list --uri\n'}},
                                                                           u'update': {u'capsule': u'Update health checks for load balanced instances.',
                                                                                       u'commands': {u'http': {u'capsule': u'Update a HTTP health check.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--check-interval',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'CHECK_INTERVAL'},
                                                                                                                          u'--description': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A textual description for the HTTP health check. Pass in an empty string to unset.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--description',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'DESCRIPTION'},
                                                                                                                          u'--healthy-threshold': {u'attr': {},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--healthy-threshold',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                          u'--host': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--host',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'HOST'},
                                                                                                                          u'--port': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--port',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PORT'},
                                                                                                                          u'--port-name': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--port-name',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'PORT_NAME'},
                                                                                                                          u'--proxy-header': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [u'NONE',
                                                                                                                                                           u'PROXY_V1'],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--proxy-header',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PROXY_HEADER'},
                                                                                                                          u'--request-path': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--request-path',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'REQUEST_PATH'},
                                                                                                                          u'--timeout': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--timeout',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'TIMEOUT'},
                                                                                                                          u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--unhealthy-threshold',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'http',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'compute',
                                                                                                                         u'health-checks',
                                                                                                                         u'update',
                                                                                                                         u'http'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the HTTP health check.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'GA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*http* is used to update an existing HTTP health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                     u'https': {u'capsule': u'Update a HTTPS health check.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                                 u'category': u'',
                                                                                                                                                 u'choices': [],
                                                                                                                                                 u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                                 u'group': u'',
                                                                                                                                                 u'hidden': False,
                                                                                                                                                 u'name': u'--check-interval',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'type': u'string',
                                                                                                                                                 u'value': u'CHECK_INTERVAL'},
                                                                                                                           u'--description': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A textual description for the HTTPS health check. Pass in an empty string to unset.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--description',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'DESCRIPTION'},
                                                                                                                           u'--healthy-threshold': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--healthy-threshold',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                           u'--host': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--host',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'HOST'},
                                                                                                                           u'--port': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--port',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'PORT'},
                                                                                                                           u'--port-name': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--port-name',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'PORT_NAME'},
                                                                                                                           u'--proxy-header': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [u'NONE',
                                                                                                                                                            u'PROXY_V1'],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--proxy-header',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'PROXY_HEADER'},
                                                                                                                           u'--request-path': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--request-path',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'REQUEST_PATH'},
                                                                                                                           u'--timeout': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--timeout',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'TIMEOUT'},
                                                                                                                           u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--unhealthy-threshold',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'https',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'compute',
                                                                                                                          u'health-checks',
                                                                                                                          u'update',
                                                                                                                          u'https'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The name of the HTTPS health check.',
                                                                                                                                  u'name': u'name',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'NAME'}],
                                                                                                                u'release': u'GA',
                                                                                                                u'sections': {u'DESCRIPTION': u'*https* is used to update an existing HTTPS health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                     u'ssl': {u'capsule': u'Update a SSL health check.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--check-interval',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'CHECK_INTERVAL'},
                                                                                                                         u'--description': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A textual description for the SSL health check. Pass in an empty string to unset.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--description',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'DESCRIPTION'},
                                                                                                                         u'--healthy-threshold': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--healthy-threshold',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                         u'--port': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--port',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PORT'},
                                                                                                                         u'--port-name': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--port-name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PORT_NAME'},
                                                                                                                         u'--proxy-header': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [u'NONE',
                                                                                                                                                          u'PROXY_V1'],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--proxy-header',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PROXY_HEADER'},
                                                                                                                         u'--request': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.\n+\nSetting this to an empty string will clear any existing request value.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--request',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REQUEST'},
                                                                                                                         u'--response': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.\n      Setting this to an empty string will clear any existing\nresponse value.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--response',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'RESPONSE'},
                                                                                                                         u'--timeout': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--timeout',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'TIMEOUT'},
                                                                                                                         u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--unhealthy-threshold',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'ssl',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'compute',
                                                                                                                        u'health-checks',
                                                                                                                        u'update',
                                                                                                                        u'ssl'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the SSL health check.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'GA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*ssl* is used to update an existing SSL health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}},
                                                                                                     u'tcp': {u'capsule': u'Update a TCP health check.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--check-interval',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'CHECK_INTERVAL'},
                                                                                                                         u'--description': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A textual description for the TCP health check. Pass in an empty string to unset.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--description',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'DESCRIPTION'},
                                                                                                                         u'--healthy-threshold': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--healthy-threshold',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'HEALTHY_THRESHOLD'},
                                                                                                                         u'--port': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The TCP port number that this health check monitors.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--port',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'PORT'},
                                                                                                                         u'--port-name': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The port name that this health check monitors. By default, this is\nempty. Setting this to an empty string will clear any existing\nport-name value.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--port-name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'PORT_NAME'},
                                                                                                                         u'--proxy-header': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [u'NONE',
                                                                                                                                                          u'PROXY_V1'],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Adds the header "PROXY UNKNOWN\\r\\n".\n+',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--proxy-header',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PROXY_HEADER'},
                                                                                                                         u'--request': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Application data to send once the TCP connection has been established. By\ndefault, this is empty. If both request and response are empty, the\nconnection establishment alone will indicate health of the TCP connection.\n+\nSetting this to an empty string will clear any existing request value.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--request',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REQUEST'},
                                                                                                                         u'--response': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The bytes to match against the beginning of the response data. By default,\nthis is empty. If empty, any response will indicate health of the TCP\nconnection.\n      Setting this to an empty string will clear any existing\nresponse value.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--response',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'RESPONSE'},
                                                                                                                         u'--timeout': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"If Google Compute Engine doesn't receive a healthy response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--timeout',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'TIMEOUT'},
                                                                                                                         u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--unhealthy-threshold',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'tcp',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'compute',
                                                                                                                        u'health-checks',
                                                                                                                        u'update',
                                                                                                                        u'tcp'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name of the TCP health check.',
                                                                                                                                u'name': u'name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'NAME'}],
                                                                                                              u'release': u'GA',
                                                                                                              u'sections': {u'DESCRIPTION': u'*tcp* is used to update an existing TCP health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}}},
                                                                                       u'flags': {},
                                                                                       u'group': True,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'update',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'compute',
                                                                                                 u'health-checks',
                                                                                                 u'update'],
                                                                                       u'positionals': [],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u'Update health checks for load balanced instances.'}}},
                                                             u'flags': {},
                                                             u'group': True,
                                                             u'groups': {},
                                                             u'hidden': False,
                                                             u'name': u'health-checks',
                                                             u'path': [u'gcloud',
                                                                       u'compute',
                                                                       u'health-checks'],
                                                             u'positionals': [],
                                                             u'release': u'GA',
                                                             u'sections': {u'DESCRIPTION': u'Read and manipulate health checks for load balanced instances.'}},
                                          u'http-health-checks': {u'capsule': u'Read and manipulate HTTP health checks for load balanced instances.',
                                                                  u'commands': {u'create': {u'capsule': u'Create an HTTP health check to monitor load balanced instances.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': u'5s',
                                                                                                                             u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--check-interval',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'CHECK_INTERVAL'},
                                                                                                       u'--description': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'An optional, textual description for the HTTP health check.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--description',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                       u'--healthy-threshold': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': 2,
                                                                                                                                u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--healthy-threshold',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'int',
                                                                                                                                u'value': u'HEALTHY_THRESHOLD'},
                                                                                                       u'--host': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--host',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'HOST'},
                                                                                                       u'--port': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': 80,
                                                                                                                   u'description': u'The TCP port number that this health check monitors. The default value\nis 80.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--port',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'int',
                                                                                                                   u'value': u'PORT'},
                                                                                                       u'--request-path': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': u'/',
                                                                                                                           u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--request-path',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'REQUEST_PATH'},
                                                                                                       u'--timeout': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': u'5s',
                                                                                                                      u'description': u"If Google Compute Engine doesn't receive an HTTP 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--timeout',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'TIMEOUT'},
                                                                                                       u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': 2,
                                                                                                                                  u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--unhealthy-threshold',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'int',
                                                                                                                                  u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'create',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'http-health-checks',
                                                                                                      u'create'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the HTTP health check.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*create* is used to create an HTTP health check. HTTP health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                u'delete': {u'capsule': u'Delete HTTP health checks.',
                                                                                            u'commands': {},
                                                                                            u'flags': {},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'delete',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'http-health-checks',
                                                                                                      u'delete'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The resources to delete.',
                                                                                                              u'name': u'names',
                                                                                                              u'nargs': u'+',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nHTTP health checks.\n'}},
                                                                                u'describe': {u'capsule': u'Display detailed information about an HTTP health check.',
                                                                                              u'commands': {},
                                                                                              u'flags': {},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'describe',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'compute',
                                                                                                        u'http-health-checks',
                                                                                                        u'describe'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The name of the resource to fetch.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine HTTP health check in a project.\n'}},
                                                                                u'list': {u'capsule': u'List Google Compute Engine health checks.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--filter',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                     u'--limit': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--limit',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'LIMIT'},
                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': True,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--no-uri',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'NO_URI'},
                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--page-size',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                     u'--regexp': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--regexp',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGEXP'},
                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--sort-by',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'list',
                                                                                                                    u'value': u'FIELD'},
                                                                                                     u'--uri': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--uri',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'URI'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'list',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'http-health-checks',
                                                                                                    u'list'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': [],
                                                                                                            u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                            u'name': u'names',
                                                                                                            u'nargs': u'*',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine health checks in a project.\n',
                                                                                                        u'EXAMPLES': u'To list all health checks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all health checks in a project, run:\n\n  $ list --uri\n'}},
                                                                                u'update': {u'capsule': u'Update an HTTP health check.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--check-interval',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'CHECK_INTERVAL'},
                                                                                                       u'--description': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'A textual description for the HTTP health check. Pass in an empty string to unset.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--description',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                       u'--healthy-threshold': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--healthy-threshold',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'HEALTHY_THRESHOLD'},
                                                                                                       u'--host': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The value of the host header used in this HTTP health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--host',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'HOST'},
                                                                                                       u'--port': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The TCP port number that this health check monitors.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--port',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'PORT'},
                                                                                                       u'--request-path': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--request-path',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'REQUEST_PATH'},
                                                                                                       u'--timeout': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"If Google Compute Engine doesn't receive an HTTP 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--timeout',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'TIMEOUT'},
                                                                                                       u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--unhealthy-threshold',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'update',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'http-health-checks',
                                                                                                      u'update'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the HTTP health check.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*update* is used to update an existing HTTP health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}}},
                                                                  u'flags': {},
                                                                  u'group': True,
                                                                  u'groups': {},
                                                                  u'hidden': False,
                                                                  u'name': u'http-health-checks',
                                                                  u'path': [u'gcloud',
                                                                            u'compute',
                                                                            u'http-health-checks'],
                                                                  u'positionals': [],
                                                                  u'release': u'GA',
                                                                  u'sections': {u'DESCRIPTION': u'Read and manipulate HTTP health checks for load balanced instances.'}},
                                          u'https-health-checks': {u'capsule': u'Read and manipulate HTTPS health checks for load balanced instances.',
                                                                   u'commands': {u'create': {u'capsule': u'Create an HTTPS health check to monitor load balanced instances.',
                                                                                             u'commands': {},
                                                                                             u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': u'5s',
                                                                                                                              u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.\nThe default value is ``5s''.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--check-interval',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'CHECK_INTERVAL'},
                                                                                                        u'--description': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'An optional, textual description for the HTTPS health check.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--description',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'DESCRIPTION'},
                                                                                                        u'--healthy-threshold': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': 2,
                                                                                                                                 u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy. The default is 2.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--healthy-threshold',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'int',
                                                                                                                                 u'value': u'HEALTHY_THRESHOLD'},
                                                                                                        u'--host': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The value of the host header used in this HTTPS health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--host',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'HOST'},
                                                                                                        u'--port': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': 443,
                                                                                                                    u'description': u'The TCP port number that this health check monitors. The default value\nis 443.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--port',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'int',
                                                                                                                    u'value': u'PORT'},
                                                                                                        u'--request-path': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': u'/',
                                                                                                                            u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''. The default value is ``/''.",
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--request-path',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'REQUEST_PATH'},
                                                                                                        u'--timeout': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': u'5s',
                                                                                                                       u'description': u"If Google Compute Engine doesn't receive an HTTPS 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.  The default value is ``5s''.",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--timeout',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'TIMEOUT'},
                                                                                                        u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': 2,
                                                                                                                                   u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy. The default is 2.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--unhealthy-threshold',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'int',
                                                                                                                                   u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'create',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'compute',
                                                                                                       u'https-health-checks',
                                                                                                       u'create'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The name of the HTTPS health check.',
                                                                                                               u'name': u'name',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'*create* is used to create an HTTPS health check. HTTPS health checks\nmonitor instances in a load balancer controlled by a target pool. All\narguments to the command are optional except for the name of the health\ncheck. For more information on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                                 u'delete': {u'capsule': u'Delete HTTPS health checks.',
                                                                                             u'commands': {},
                                                                                             u'flags': {},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'delete',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'compute',
                                                                                                       u'https-health-checks',
                                                                                                       u'delete'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The resources to delete.',
                                                                                                               u'name': u'names',
                                                                                                               u'nargs': u'+',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nHTTPS health checks.\n'}},
                                                                                 u'describe': {u'capsule': u'Display detailed information about an HTTPS health check.',
                                                                                               u'commands': {},
                                                                                               u'flags': {},
                                                                                               u'group': False,
                                                                                               u'groups': {},
                                                                                               u'hidden': False,
                                                                                               u'name': u'describe',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'compute',
                                                                                                         u'https-health-checks',
                                                                                                         u'describe'],
                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The name of the resource to fetch.',
                                                                                                                 u'name': u'name',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'value': u'NAME'}],
                                                                                               u'release': u'GA',
                                                                                               u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine HTTPS health check in a project.\n'}},
                                                                                 u'list': {u'capsule': u'List Google Compute Engine HTTPS health checks.',
                                                                                           u'commands': {},
                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--filter',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                      u'--limit': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--limit',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'LIMIT'},
                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': True,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-uri',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_URI'},
                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--page-size',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                      u'--regexp': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--regexp',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'REGEXP'},
                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--sort-by',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'list',
                                                                                                                     u'value': u'FIELD'},
                                                                                                      u'--uri': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--uri',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'URI'}},
                                                                                           u'group': False,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'list',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'compute',
                                                                                                     u'https-health-checks',
                                                                                                     u'list'],
                                                                                           u'positionals': [{u'completer': u'',
                                                                                                             u'default': [],
                                                                                                             u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                             u'name': u'names',
                                                                                                             u'nargs': u'*',
                                                                                                             u'required': False,
                                                                                                             u'value': u'NAME'}],
                                                                                           u'release': u'GA',
                                                                                           u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine HTTPS health checks in a project.\n',
                                                                                                         u'EXAMPLES': u'To list all HTTPS health checks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all HTTPS health checks in a project, run:\n\n  $ list --uri\n'}},
                                                                                 u'update': {u'capsule': u'Update an HTTPS health check.',
                                                                                             u'commands': {},
                                                                                             u'flags': {u'--check-interval': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"How often to perform a health check for an instance. For example,\nspecifying ``10s'' will run the check every 10 seconds. Valid units\nfor this flag are ``s'' for seconds and ``m'' for minutes.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--check-interval',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'CHECK_INTERVAL'},
                                                                                                        u'--description': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'A textual description for the HTTPS health check. Pass in an empty string to unset.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--description',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'DESCRIPTION'},
                                                                                                        u'--healthy-threshold': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The number of consecutive successful health checks before an\nunhealthy instance is marked as healthy.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--healthy-threshold',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'HEALTHY_THRESHOLD'},
                                                                                                        u'--host': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The value of the host header used in this HTTPS health check request.\nBy default, this is empty and Google Compute Engine automatically sets\nthe host header in health requests to the same external IP address as\nthe forwarding rule associated with the target pool. Setting this to\nan empty string will clear any existing host value.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--host',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'HOST'},
                                                                                                        u'--port': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The TCP port number that this health check monitors.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--port',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'PORT'},
                                                                                                        u'--request-path': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u"The request path that this health check monitors. For example,\n``/healthcheck''.",
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--request-path',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'REQUEST_PATH'},
                                                                                                        u'--timeout': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u"If Google Compute Engine doesn't receive an HTTPS 200 response from the\ninstance by the time specified by the value of this flag, the health\ncheck request is considered a failure. For example, specifying ``10s''\nwill cause the check to wait for 10 seconds before considering the\nrequest a failure.  Valid units for this flag are ``s'' for seconds and\n``m'' for minutes.",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--timeout',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'TIMEOUT'},
                                                                                                        u'--unhealthy-threshold': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The number of consecutive health check failures before a healthy\ninstance is marked as unhealthy.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--unhealthy-threshold',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'UNHEALTHY_THRESHOLD'}},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'update',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'compute',
                                                                                                       u'https-health-checks',
                                                                                                       u'update'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The name of the HTTPS health check.',
                                                                                                               u'name': u'name',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'*update* is used to update an existing HTTPS health check. Only\narguments passed in will be updated on the health check. Other\nattributes will remain unaffected.\n'}}},
                                                                   u'flags': {},
                                                                   u'group': True,
                                                                   u'groups': {},
                                                                   u'hidden': False,
                                                                   u'name': u'https-health-checks',
                                                                   u'path': [u'gcloud',
                                                                             u'compute',
                                                                             u'https-health-checks'],
                                                                   u'positionals': [],
                                                                   u'release': u'GA',
                                                                   u'sections': {u'DESCRIPTION': u'Read and manipulate HTTPS health checks for load balanced instances.'}},
                                          u'images': {u'capsule': u'List, create, and delete Google Compute Engine images.',
                                                      u'commands': {u'create': {u'capsule': u'Create Google Compute Engine images.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine images to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--csek-key-file',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'FILE'},
                                                                                           u'--description': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'An optional, textual description for the image being created.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--description',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'DESCRIPTION'},
                                                                                           u'--family': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The family of the image. When creating an instance or disk, specifying a family will cause the latest non-deprecated image in the family to be used.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--family',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'FAMILY'},
                                                                                           u'--licenses': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Comma-separated list of URIs to license resources.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--licenses',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'list',
                                                                                                           u'value': u'LICENSES'},
                                                                                           u'--no-require-csek-key-create': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': True,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-require-csek-key-create',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_REQUIRE_CSEK_KEY_CREATE'},
                                                                                           u'--require-csek-key-create': {u'attr': {u'inverted_synopsis': True},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': True,
                                                                                                                          u'description': u'Refuse to create images not protected by a user managed key in\nthe key file when --csek-key-file is given. This behavior is enabled\nby default to prevent incorrect gcloud invocations from accidentally\ncreating images with no user managed key. Disabling the check\nallows creation of some images without a matching\nCustomer-Supplied Encryption Key in the supplied --csek-key-file.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details. Enabled by default, use *--no-require-csek-key-create* to disable.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--require-csek-key-create',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'REQUIRE_CSEK_KEY_CREATE'},
                                                                                           u'--source-disk': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u"A source disk to create the image from. The value for this option can be\nthe name of a disk with the zone specified via ``--source-disk-zone''\nflag.\n+\nThis flag is mutually exclusive with ``--source-uri''.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--source-disk',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'SOURCE_DISK'},
                                                                                           u'--source-disk-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"The zone of the source disk to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--source-disk-zone',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'SOURCE_DISK_ZONE'},
                                                                                           u'--source-uri': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u"The full Google Cloud Storage URI where the disk image is stored.\nThis file must be a gzip-compressed tarball whose name ends in\n``.tar.gz''.\n+\nThis flag is mutually exclusive with ``--source-disk''.",
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--source-uri',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'SOURCE_URI'}},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'create',
                                                                                u'path': [u'gcloud',
                                                                                          u'compute',
                                                                                          u'images',
                                                                                          u'create'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'The name of the disk image.',
                                                                                                  u'name': u'name',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'NAME'}],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u'*create* is used to create custom disk images.\nThe resulting image can be provided during instance or disk creation\nso that the instance attached to the resulting disks has access\nto a known set of software or files from the image.\n\nImages can be created from gzipped compressed tarball containing raw\ndisk data or from existing disks in any zone.\n\nImages are global resources, so they can be used across zones and\nprojects.\n\nTo learn more about creating image tarballs, visit\n[](https://cloud.google.com/compute/docs/creating-custom-image)\n'}},
                                                                    u'delete': {u'capsule': u'Delete Google Compute Engine images.',
                                                                                u'commands': {},
                                                                                u'flags': {},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'delete',
                                                                                u'path': [u'gcloud',
                                                                                          u'compute',
                                                                                          u'images',
                                                                                          u'delete'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'The resources to delete.',
                                                                                                  u'name': u'names',
                                                                                                  u'nargs': u'+',
                                                                                                  u'required': False,
                                                                                                  u'value': u'NAME'}],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine images.\n'}},
                                                                    u'deprecate': {u'capsule': u'Manage deprecation status of Google Compute Engine images.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--delete-in': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"Specifies the amount of time until the image will be marked as DELETED.\nNote: The image will not actually be deleted - this field is only for\ninformational purposes (see below). For instance, specifying ``30d'' will\nmark as DELETED in 30 days from the current system time. Valid units for\nthis flag are ``s'' for seconds, ``m'' for minutes, ``h'' for hours and\n``d'' for days. If no unit is specified, seconds is assumed.\n+\nNote that the image will not be deleted automatically. The image will\nonly be marked as deleted. An explicit request to delete the image must\nbe made in order to remove it from the image list.\nThis flag is mutually exclusive with *--delete-on*.",
                                                                                                               u'group': u'deprecate.1',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--delete-in',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'DELETE_IN'},
                                                                                              u'--delete-on': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"Similar to *--delete-in*, but specifies an absolute time when the image\nwill be marked as DELETED. Note: The image will not actually be\ndeleted - this field is for informational purposes (see the description\nof --delete-in for more details). The date and time specified must be\nvalid RFC 3339 full-date or date-time. For times in UTC, this looks\nlike ``YYYY-MM-DDTHH:MM:SSZ''. For example: 2020-01-02T00:00:00Z for\nmidnight on January 2, 2020 in UTC.\nThis flag is mutually exclusive with *--delete-in*.",
                                                                                                               u'group': u'deprecate.1',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--delete-on',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'DELETE_ON'},
                                                                                              u'--obsolete-in': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Specifies time (in the same format as *--delete-in*) until the image\nwill be marked OBSOLETE. State will not be changed - it is only for\ninformational purposes.\nThis flag is mutually exclusive with *--obsolete-on*.',
                                                                                                                 u'group': u'deprecate.2',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--obsolete-in',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'OBSOLETE_IN'},
                                                                                              u'--obsolete-on': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Specifies time (in the same format as *--delete-on*) when this image will\nbe marked as OBSOLETE. State will not be changed - it has only\ninformational purpose.\nThis flag is mutually exclusive with *--obsolete-in*.',
                                                                                                                 u'group': u'deprecate.2',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--obsolete-on',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'OBSOLETE_ON'},
                                                                                              u'--replacement': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Specifies a Compute Engine image as a replacement for the image\nbeing phased out. Users of the deprecated image will be advised to switch\nto this replacement. For example, *--replacement example-image* or\n*--replacement projects/google/global/images/example-image*.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--replacement',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'REPLACEMENT'},
                                                                                              u'--state': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [u'ACTIVE',
                                                                                                                        u'DELETED',
                                                                                                                        u'DEPRECATED',
                                                                                                                        u'OBSOLETE'],
                                                                                                           u'completer': u'',
                                                                                                           u'default': u'ACTIVE',
                                                                                                           u'description': u'The deprecation state to set on the image. _STATE_ must be one of:\n+\n*ACTIVE*::: The image is currently supported.\n*DELETED*::: New uses result in an error. Setting this state will not automatically delete the image. You must still make a request to delete the image to remove it from the image list.\n*DEPRECATED*::: Operations which create a new *DEPRECATED* resource return successfully, but with a warning indicating that the image is deprecated and recommending its replacement.\n*OBSOLETE*::: New uses result in an error.\n+',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--state',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': True,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'STATE'}},
                                                                                   u'group': False,
                                                                                   u'groups': {u'deprecate.1': {u'description': u'At most one of these may be specified:',
                                                                                                                u'is_mutex': True,
                                                                                                                u'is_required': False},
                                                                                               u'deprecate.2': {u'description': u'At most one of these may be specified:',
                                                                                                                u'is_mutex': True,
                                                                                                                u'is_required': False}},
                                                                                   u'hidden': False,
                                                                                   u'name': u'deprecate',
                                                                                   u'path': [u'gcloud',
                                                                                             u'compute',
                                                                                             u'images',
                                                                                             u'deprecate'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The name of the disk image.',
                                                                                                     u'name': u'name',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'*deprecate* is used to deprecate images.',
                                                                                                 u'EXAMPLES': u"To deprecate an image called 'IMAGE' immediately, mark it as\nobsolete in one day, and mark it as deleted in two days, use:\n\n  $ deprecate IMAGE --state DEPRECATED --obsolete-in 1d --delete-in 2d\n\nTo un-deprecate an image called 'IMAGE', use:\n\n  $ deprecate IMAGE --state ACTIVE\n"}},
                                                                    u'describe': {u'capsule': u'Describe a Google Compute Engine image.',
                                                                                  u'commands': {},
                                                                                  u'flags': {},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'describe',
                                                                                  u'path': [u'gcloud',
                                                                                            u'compute',
                                                                                            u'images',
                                                                                            u'describe'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The name of the resource to fetch.',
                                                                                                    u'name': u'name',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAME'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine image in a project.\n'}},
                                                                    u'describe-from-family': {u'capsule': u'Describe the latest image from an image family.',
                                                                                              u'commands': {},
                                                                                              u'flags': {},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'describe-from-family',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'compute',
                                                                                                        u'images',
                                                                                                        u'describe-from-family'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The name of the resource to fetch.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'*describe-from-family* looks up the latest image from an image family and runs a describe\non it.'}},
                                                                    u'list': {u'capsule': u'List Google Compute Engine images.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--filter',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'EXPRESSION'},
                                                                                         u'--limit': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--limit',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'LIMIT'},
                                                                                         u'--no-preview-images': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': True,
                                                                                                                  u'name': u'--no-preview-images',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'NO_PREVIEW_IMAGES'},
                                                                                         u'--no-show-deprecated': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': True,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--no-show-deprecated',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'NO_SHOW_DEPRECATED'},
                                                                                         u'--no-show-preview-images': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': True,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-show-preview-images',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_SHOW_PREVIEW_IMAGES'},
                                                                                         u'--no-standard-images': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': True,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--no-standard-images',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'NO_STANDARD_IMAGES'},
                                                                                         u'--no-uri': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': True,
                                                                                                       u'description': u'',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': True,
                                                                                                       u'name': u'--no-uri',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'NO_URI'},
                                                                                         u'--page-size': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--page-size',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                         u'--preview-images': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'Show images that are in limited preview. The preview image projects\nare: (none)',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--preview-images',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'PREVIEW_IMAGES'},
                                                                                         u'--regexp': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--regexp',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'REGEXP'},
                                                                                         u'--show-deprecated': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'If provided, deprecated images are shown.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--show-deprecated',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'SHOW_DEPRECATED'},
                                                                                         u'--show-preview-images': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--show-preview-images',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'SHOW_PREVIEW_IMAGES'},
                                                                                         u'--sort-by': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--sort-by',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'list',
                                                                                                        u'value': u'FIELD'},
                                                                                         u'--standard-images': {u'attr': {u'inverted_synopsis': True},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': True,
                                                                                                                u'description': u'Show images from well-known image projects.  The well known image\nprojects are: centos-cloud, coreos-cloud, debian-cloud, cos-cloud, rhel-cloud, suse-cloud, ubuntu-os-cloud, windows-cloud, windows-sql-cloud. Enabled by default, use *--no-standard-images* to disable.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--standard-images',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'STANDARD_IMAGES'},
                                                                                         u'--uri': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': False,
                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--uri',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'URI'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'list',
                                                                              u'path': [u'gcloud',
                                                                                        u'compute',
                                                                                        u'images',
                                                                                        u'list'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': [],
                                                                                                u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                u'name': u'names',
                                                                                                u'nargs': u'*',
                                                                                                u'required': False,
                                                                                                u'value': u'NAME'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine images in a project.\n',
                                                                                            u'EXAMPLES': u'To list all images in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all images in a project, run:\n\n  $ list --uri\n'}}},
                                                      u'flags': {},
                                                      u'group': True,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'images',
                                                      u'path': [u'gcloud',
                                                                u'compute',
                                                                u'images'],
                                                      u'positionals': [],
                                                      u'release': u'GA',
                                                      u'sections': {u'DESCRIPTION': u'List, create, and delete Google Compute Engine images.'}},
                                          u'instance-groups': {u'capsule': u'Read and manipulate Google Compute Engine instance groups.',
                                                               u'commands': {u'describe': {u'capsule': u'Display detailed information about an instance group.',
                                                                                           u'commands': {},
                                                                                           u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                    u'group': u'describe.1',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--region',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'REGION'},
                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The zone of the resource to fetch. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                  u'group': u'describe.1',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--zone',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'ZONE'}},
                                                                                           u'group': False,
                                                                                           u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                       u'is_mutex': True,
                                                                                                                       u'is_required': False}},
                                                                                           u'hidden': False,
                                                                                           u'name': u'describe',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'compute',
                                                                                                     u'instance-groups',
                                                                                                     u'describe'],
                                                                                           u'positionals': [{u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The name of the resource to fetch.',
                                                                                                             u'name': u'name',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'value': u'NAME'}],
                                                                                           u'release': u'GA',
                                                                                           u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with an instance group in a project.\n',
                                                                                                         u'EXAMPLES': u"\nTo get details about a regional instance group in the ``us-central1'' regions,\nrun:\n\n  $ describe --region us-central1\n\nTo get details about a zonal instance group in the ``us-central1-b'' zone, run:\n\n  $ describe --zone us-central1-b\n"}},
                                                                             u'get-named-ports': {u'capsule': u'Lists the named ports for an instance group resource.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--filter',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'EXPRESSION'},
                                                                                                             u'--limit': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--limit',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'LIMIT'},
                                                                                                             u'--no-uri': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': True,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-uri',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_URI'},
                                                                                                             u'--page-size': {u'attr': {},
                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--page-size',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                           u'group': u'get-named-ports.1',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--region',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'REGION'},
                                                                                                             u'--sort-by': {u'attr': {},
                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--sort-by',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'list',
                                                                                                                            u'value': u'FIELD'},
                                                                                                             u'--uri': {u'attr': {},
                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--uri',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'URI'},
                                                                                                             u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                         u'group': u'get-named-ports.1',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--zone',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'ZONE'}},
                                                                                                  u'group': False,
                                                                                                  u'groups': {u'get-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False}},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'get-named-ports',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'compute',
                                                                                                            u'instance-groups',
                                                                                                            u'get-named-ports'],
                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The name of the instance group.',
                                                                                                                    u'name': u'name',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'NAME'}],
                                                                                                  u'release': u'GA',
                                                                                                  u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which indicates that the service\nis available on all instances in the group. This information is used\nby the HTTP Load Balancing service.\n\n*get-named-ports* lists the named ports (name and port tuples)\nfor an instance group.\n",
                                                                                                                u'EXAMPLES': u"For example, to list named ports for an instance group:\n\n  $ get-named-ports example-instance-group --zone us-central1-a\n\nThe above example lists named ports assigned to an instance\ngroup named 'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                             u'list': {u'capsule': u'List Google Compute Engine instance groups.',
                                                                                       u'commands': {},
                                                                                       u'flags': {u'--filter': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--filter',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'EXPRESSION'},
                                                                                                  u'--limit': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--limit',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'LIMIT'},
                                                                                                  u'--no-uri': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': True,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--no-uri',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_URI'},
                                                                                                  u'--only-managed': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': False,
                                                                                                                      u'description': u'If provided, a list of managed instance groups will be returned.',
                                                                                                                      u'group': u'list.1',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--only-managed',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'bool',
                                                                                                                      u'value': u'ONLY_MANAGED'},
                                                                                                  u'--only-unmanaged': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'If provided, a list of unmanaged instance groups will be returned.',
                                                                                                                        u'group': u'list.1',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--only-unmanaged',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'ONLY_UNMANAGED'},
                                                                                                  u'--page-size': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--page-size',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'PAGE_SIZE'},
                                                                                                  u'--regexp': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--regexp',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'REGEXP'},
                                                                                                  u'--regions': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                 u'group': u'list.2',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--regions',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'list',
                                                                                                                 u'value': u'REGION'},
                                                                                                  u'--sort-by': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--sort-by',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'list',
                                                                                                                 u'value': u'FIELD'},
                                                                                                  u'--uri': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': False,
                                                                                                             u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--uri',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'URI'},
                                                                                                  u'--zones': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'If provided, only zonal resources are shown. If arguments are provided, only resources from the given zones are shown.',
                                                                                                               u'group': u'list.2',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--zones',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'list',
                                                                                                               u'value': u'ZONE'}},
                                                                                       u'group': False,
                                                                                       u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                               u'is_mutex': True,
                                                                                                               u'is_required': False},
                                                                                                   u'list.2': {u'description': u'At most one of these may be specified:',
                                                                                                               u'is_mutex': True,
                                                                                                               u'is_required': False}},
                                                                                       u'hidden': False,
                                                                                       u'name': u'list',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'compute',
                                                                                                 u'instance-groups',
                                                                                                 u'list'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': [],
                                                                                                         u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                         u'name': u'names',
                                                                                                         u'nargs': u'*',
                                                                                                         u'required': False,
                                                                                                         u'value': u'NAME'}],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine instance groups in a project.\n\nBy default, instance groups from all regions and instance groups from all zones are listed. The results can be narrowed down by\nproviding the ``--regions'' or ``--zones'' flag.\n",
                                                                                                     u'EXAMPLES': u"To list all instance groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all instance groups in a project, run:\n\n  $ list --uri\n\nTo list all instance groups in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n\nTo list all instance groups in zones ``us-central1-b'' and ``europe-west1-d'',\nrun:\n\n  $ list --zones us-central1,europe-west1\n"}},
                                                                             u'list-instances': {u'capsule': u'List instances present in the instance group.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--filter',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                            u'--limit': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--limit',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'LIMIT'},
                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': True,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-uri',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_URI'},
                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--page-size',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                            u'--regexp': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--regexp',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'REGEXP'},
                                                                                                            u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                          u'group': u'list-instances.1',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--region',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'REGION'},
                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--sort-by',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'list',
                                                                                                                           u'value': u'FIELD'},
                                                                                                            u'--uri': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--uri',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'URI'},
                                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                        u'group': u'list-instances.1',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--zone',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'ZONE'}},
                                                                                                 u'group': False,
                                                                                                 u'groups': {u'list-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                   u'is_mutex': True,
                                                                                                                                   u'is_required': False}},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'list-instances',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'compute',
                                                                                                           u'instance-groups',
                                                                                                           u'list-instances'],
                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The name of the instance group.',
                                                                                                                   u'name': u'name',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'NAME'}],
                                                                                                 u'release': u'GA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*list-instances* list instances in an instance group.\n'}},
                                                                             u'managed': {u'capsule': u'Read and manipulate Google Compute Engine managed instance groups.',
                                                                                          u'commands': {u'abandon-instances': {u'capsule': u'Abandon instances owned by a managed instance group.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Names of instances to abandon.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--instances',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': True,
                                                                                                                                                           u'type': u'list',
                                                                                                                                                           u'value': u'INSTANCE'},
                                                                                                                                          u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                        u'group': u'abandon-instances.1',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--region',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'REGION'},
                                                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                      u'group': u'abandon-instances.1',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--zone',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'ZONE'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {u'abandon-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                                    u'is_required': False}},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'abandon-instances',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'compute',
                                                                                                                                         u'instance-groups',
                                                                                                                                         u'managed',
                                                                                                                                         u'abandon-instances'],
                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The name of the managed instance group.',
                                                                                                                                                 u'name': u'name',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'value': u'NAME'}],
                                                                                                                               u'release': u'GA',
                                                                                                                               u'sections': {u'DESCRIPTION': u'\n        *abandon-instances* abandons one or more instances from a managed instance\ngroup, thereby reducing the targetSize of the group. Once instances have been\nabandoned, the currentSize of the group is automatically reduced as well to\nreflect the change.\n\nAbandoning an instance does not delete the underlying virtual machine instances,\nbut just removes the instances from the instance group. If you would like the\ndelete the underlying instances, use the delete-instances command instead.\n'}},
                                                                                                        u'create': {u'capsule': u'Create a Compute Engine managed instance group.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--base-instance-name': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The base name to use for the Compute Engine instances that will be created with the managed instance group. If not provided base instance name will be the prefix of instance group name.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--base-instance-name',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'BASE_INSTANCE_NAME'},
                                                                                                                               u'--description': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'An optional description for this group.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--description',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'string',
                                                                                                                                                  u'value': u'DESCRIPTION'},
                                                                                                                               u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                             u'group': u'create.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--region',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGION'},
                                                                                                                               u'--size': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The initial number of instances you want in this group.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--size',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'SIZE'},
                                                                                                                               u'--target-pool': {u'attr': {},
                                                                                                                                                  u'category': u'',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'Specifies any target pools you want the instances of this managed instance group to be part of.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--target-pool',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'list',
                                                                                                                                                  u'value': u'TARGET_POOL'},
                                                                                                                               u'--template': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'Specifies the instance template to use when creating new instances.',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--template',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': True,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'TEMPLATE'},
                                                                                                                               u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                           u'group': u'create.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--zone',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'ZONE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                              u'is_mutex': True,
                                                                                                                                              u'is_required': False}},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'create',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'compute',
                                                                                                                              u'instance-groups',
                                                                                                                              u'managed',
                                                                                                                              u'create'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the managed instance group.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'GA',
                                                                                                                    u'sections': {u'DESCRIPTION': u"        *create* creates a Google Compute Engine managed instance group.\n\nFor example, running:\n\n        $ create example-managed-instance-group --zone us-central1-a --template example-instance-template --size 1\n\nwill create one managed instance group called 'example-managed-instance-group'\nin the ``us-central1-a'' zone.\n"}},
                                                                                                        u'delete': {u'capsule': u'Delete Google Compute Engine managed instance groups.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                             u'group': u'delete.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--region',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGION'},
                                                                                                                               u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                           u'group': u'delete.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--zone',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'ZONE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                              u'is_mutex': True,
                                                                                                                                              u'is_required': False}},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'delete',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'compute',
                                                                                                                              u'instance-groups',
                                                                                                                              u'managed',
                                                                                                                              u'delete'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The names of the managed instance groups.',
                                                                                                                                      u'name': u'names',
                                                                                                                                      u'nargs': u'+',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAMES'}],
                                                                                                                    u'release': u'GA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'        *delete* deletes one or more Google Compute Engine managed instance\ngroups.\n'}},
                                                                                                        u'delete-instances': {u'capsule': u'Delete instances managed by managed instance group.',
                                                                                                                              u'commands': {},
                                                                                                                              u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'Names of instances to delete.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--instances',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': True,
                                                                                                                                                          u'type': u'list',
                                                                                                                                                          u'value': u'INSTANCE'},
                                                                                                                                         u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                       u'group': u'delete-instances.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--region',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'REGION'},
                                                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                     u'group': u'delete-instances.1',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--zone',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'ZONE'}},
                                                                                                                              u'group': False,
                                                                                                                              u'groups': {u'delete-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                  u'is_mutex': True,
                                                                                                                                                                  u'is_required': False}},
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'delete-instances',
                                                                                                                              u'path': [u'gcloud',
                                                                                                                                        u'compute',
                                                                                                                                        u'instance-groups',
                                                                                                                                        u'managed',
                                                                                                                                        u'delete-instances'],
                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The name of the managed instance group.',
                                                                                                                                                u'name': u'name',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'value': u'NAME'}],
                                                                                                                              u'release': u'GA',
                                                                                                                              u'sections': {u'DESCRIPTION': u'\n        *delete-instances* is used to deletes one or more instances from a managed\ninstance group. Once the instances are deleted, the size of the group is\nautomatically reduced to reflect the changes.\n\nIf you would like to keep the underlying virtual machines but still remove them\nfrom the managed instance group, use the abandon-instances command instead.\n'}},
                                                                                                        u'describe': {u'capsule': u'Display detailed information about a managed instance group.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The region of the resource to fetch. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                               u'group': u'describe.1',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--region',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'REGION'},
                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The zone of the resource to fetch. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                             u'group': u'describe.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--zone',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                  u'is_mutex': True,
                                                                                                                                                  u'is_required': False}},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'describe',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'compute',
                                                                                                                                u'instance-groups',
                                                                                                                                u'managed',
                                                                                                                                u'describe'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the resource to fetch.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'GA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a managed instance group in a project.\n',
                                                                                                                                    u'EXAMPLES': u"\nTo get details about a regional managed instance group in the ``us-central1'' regions,\nrun:\n\n  $ describe --region us-central1\n\nTo get details about a zonal managed instance group in the ``us-central1-b'' zone, run:\n\n  $ describe --zone us-central1-b\n"}},
                                                                                                        u'get-named-ports': {u'capsule': u'Lists the named ports for an instance group resource.',
                                                                                                                             u'commands': {},
                                                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--filter',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                                                        u'--limit': {u'attr': {},
                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--limit',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'LIMIT'},
                                                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': True,
                                                                                                                                                      u'description': u'',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': True,
                                                                                                                                                      u'name': u'--no-uri',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'bool',
                                                                                                                                                      u'value': u'NO_URI'},
                                                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--page-size',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                      u'group': u'get-named-ports.1',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--region',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'REGION'},
                                                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--sort-by',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'list',
                                                                                                                                                       u'value': u'FIELD'},
                                                                                                                                        u'--uri': {u'attr': {},
                                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': False,
                                                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                   u'group': u'',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--uri',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'bool',
                                                                                                                                                   u'value': u'URI'},
                                                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                    u'group': u'get-named-ports.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--zone',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'ZONE'}},
                                                                                                                             u'group': False,
                                                                                                                             u'groups': {u'get-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                u'is_mutex': True,
                                                                                                                                                                u'is_required': False}},
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'get-named-ports',
                                                                                                                             u'path': [u'gcloud',
                                                                                                                                       u'compute',
                                                                                                                                       u'instance-groups',
                                                                                                                                       u'managed',
                                                                                                                                       u'get-named-ports'],
                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The name of the instance group.',
                                                                                                                                               u'name': u'name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'value': u'NAME'}],
                                                                                                                             u'release': u'GA',
                                                                                                                             u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which indicates that the service\nis available on all instances in the group. This information is used\nby the HTTP Load Balancing service.\n\n*get-named-ports* lists the named ports (name and port tuples)\nfor an instance group.\n",
                                                                                                                                           u'EXAMPLES': u"For example, to list named ports for an instance group:\n\n  $ get-named-ports example-instance-group --zone us-central1-a\n\nThe above example lists named ports assigned to an instance\ngroup named 'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                        u'list': {u'capsule': u'List Google Compute Engine managed instance groups.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--filter',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'EXPRESSION'},
                                                                                                                             u'--limit': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--limit',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'LIMIT'},
                                                                                                                             u'--no-uri': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': True,
                                                                                                                                           u'description': u'',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': True,
                                                                                                                                           u'name': u'--no-uri',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'NO_URI'},
                                                                                                                             u'--page-size': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--page-size',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                                                             u'--regexp': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--regexp',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'REGEXP'},
                                                                                                                             u'--regions': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                                                            u'group': u'list.1',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--regions',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'REGION'},
                                                                                                                             u'--sort-by': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--sort-by',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'FIELD'},
                                                                                                                             u'--uri': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': False,
                                                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--uri',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'bool',
                                                                                                                                        u'value': u'URI'},
                                                                                                                             u'--zones': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'If provided, only zonal resources are shown. If arguments are provided, only resources from the given zones are shown.',
                                                                                                                                          u'group': u'list.1',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--zones',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'list',
                                                                                                                                          u'value': u'ZONE'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                          u'is_mutex': True,
                                                                                                                                          u'is_required': False}},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'list',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'compute',
                                                                                                                            u'instance-groups',
                                                                                                                            u'managed',
                                                                                                                            u'list'],
                                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                                    u'default': [],
                                                                                                                                    u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                    u'name': u'names',
                                                                                                                                    u'nargs': u'*',
                                                                                                                                    u'required': False,
                                                                                                                                    u'value': u'NAME'}],
                                                                                                                  u'release': u'GA',
                                                                                                                  u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine managed instance groups in a project.\n\nBy default, managed instance groups from all regions and managed instance groups from all zones are listed. The results can be narrowed down by\nproviding the ``--regions'' or ``--zones'' flag.\n",
                                                                                                                                u'EXAMPLES': u"To list all managed instance groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all managed instance groups in a project, run:\n\n  $ list --uri\n\nTo list all managed instance groups in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n\nTo list all managed instance groups in zones ``us-central1-b'' and ``europe-west1-d'',\nrun:\n\n  $ list --zones us-central1,europe-west1\n"}},
                                                                                                        u'list-instances': {u'capsule': u'List instances present in the managed instance group.',
                                                                                                                            u'commands': {},
                                                                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--filter',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--limit',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': True,
                                                                                                                                                     u'description': u'',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': True,
                                                                                                                                                     u'name': u'--no-uri',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'NO_URI'},
                                                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--page-size',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                                                       u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                     u'group': u'list-instances.1',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--region',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'REGION'},
                                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'list',
                                                                                                                                                      u'value': u'FIELD'},
                                                                                                                                       u'--uri': {u'attr': {},
                                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                                  u'choices': [],
                                                                                                                                                  u'completer': u'',
                                                                                                                                                  u'default': False,
                                                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                  u'group': u'',
                                                                                                                                                  u'hidden': False,
                                                                                                                                                  u'name': u'--uri',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'type': u'bool',
                                                                                                                                                  u'value': u'URI'},
                                                                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                   u'category': u'',
                                                                                                                                                   u'choices': [],
                                                                                                                                                   u'completer': u'',
                                                                                                                                                   u'default': None,
                                                                                                                                                   u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                   u'group': u'list-instances.1',
                                                                                                                                                   u'hidden': False,
                                                                                                                                                   u'name': u'--zone',
                                                                                                                                                   u'nargs': u'0',
                                                                                                                                                   u'required': False,
                                                                                                                                                   u'type': u'string',
                                                                                                                                                   u'value': u'ZONE'}},
                                                                                                                            u'group': False,
                                                                                                                            u'groups': {u'list-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                              u'is_mutex': True,
                                                                                                                                                              u'is_required': False}},
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'list-instances',
                                                                                                                            u'path': [u'gcloud',
                                                                                                                                      u'compute',
                                                                                                                                      u'instance-groups',
                                                                                                                                      u'managed',
                                                                                                                                      u'list-instances'],
                                                                                                                            u'positionals': [{u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'The name of the managed instance group.',
                                                                                                                                              u'name': u'name',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'value': u'NAME'}],
                                                                                                                            u'release': u'GA',
                                                                                                                            u'sections': {u'DESCRIPTION': u'*list-instances* list instances in a managed instance group.\n'}},
                                                                                                        u'recreate-instances': {u'capsule': u'Recreate instances managed by a managed instance group.',
                                                                                                                                u'commands': {},
                                                                                                                                u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'Names of instances to recreate.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--instances',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': True,
                                                                                                                                                            u'type': u'list',
                                                                                                                                                            u'value': u'INSTANCE'},
                                                                                                                                           u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                         u'group': u'recreate-instances.1',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--region',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'REGION'},
                                                                                                                                           u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                       u'group': u'recreate-instances.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--zone',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'ZONE'}},
                                                                                                                                u'group': False,
                                                                                                                                u'groups': {u'recreate-instances.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                      u'is_mutex': True,
                                                                                                                                                                      u'is_required': False}},
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'recreate-instances',
                                                                                                                                u'path': [u'gcloud',
                                                                                                                                          u'compute',
                                                                                                                                          u'instance-groups',
                                                                                                                                          u'managed',
                                                                                                                                          u'recreate-instances'],
                                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The name of the managed instance group.',
                                                                                                                                                  u'name': u'name',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'value': u'NAME'}],
                                                                                                                                u'release': u'GA',
                                                                                                                                u'sections': {u'DESCRIPTION': u'\n        *recreate-instances* is used to recreate one or more instances in a managed\ninstance group. The underlying virtual machine instances are deleted and\nrecreated based on the latest instance template configured for the managed\ninstance group.\n'}},
                                                                                                        u'resize': {u'capsule': u'Set managed instance group size.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                             u'group': u'resize.1',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--region',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGION'},
                                                                                                                               u'--size': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'Target number of instances in managed instance group.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--size',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': True,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'SIZE'},
                                                                                                                               u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                           u'group': u'resize.1',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--zone',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'ZONE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {u'resize.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                              u'is_mutex': True,
                                                                                                                                              u'is_required': False}},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'resize',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'compute',
                                                                                                                              u'instance-groups',
                                                                                                                              u'managed',
                                                                                                                              u'resize'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The name of the managed instance group.',
                                                                                                                                      u'name': u'name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'GA',
                                                                                                                    u'sections': {u'DESCRIPTION': u'\n        *resize* resize a managed instance group to a provided size.\n\nIf you resize down, the Instance Group Manager service deletes instances from\nthe group until the group reaches the desired size. To understand in what order\ninstances will be deleted, see the API documentation.\n\nIf you resize up, the service adds instances to the group using the current\ninstance template until the group reaches the desired size.\n'}},
                                                                                                        u'set-autoscaling': {u'capsule': u'Set autoscaling parameters of a managed instance group.',
                                                                                                                             u'commands': {},
                                                                                                                             u'flags': {u'--cool-down-period': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Number of seconds Autoscaler will wait between resizing collection. Note: The Autoscaler waits 10 minutes before scaling down, the value entered here is in addition to the initial 10 minute period.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--cool-down-period',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'COOL_DOWN_PERIOD'},
                                                                                                                                        u'--custom-metric-utilization': {u'attr': {},
                                                                                                                                                                         u'category': u'',
                                                                                                                                                                         u'choices': [],
                                                                                                                                                                         u'completer': u'',
                                                                                                                                                                         u'default': None,
                                                                                                                                                                         u'description': u'Adds a target metric value for the to the Autoscaler.\n+\n*metric*::: Protocol-free URL of a Google Cloud Monitoring metric.\n+\n*utilization-target*::: Value of the metric Autoscaler will aim to\nmaintain (greater than 0.0).\n+\n*utilization-target-type*::: How target is expressed. Valid values: DELTA_PER_MINUTE, DELTA_PER_SECOND, GAUGE.',
                                                                                                                                                                         u'group': u'',
                                                                                                                                                                         u'hidden': False,
                                                                                                                                                                         u'name': u'--custom-metric-utilization',
                                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                                         u'required': False,
                                                                                                                                                                         u'type': u'dict',
                                                                                                                                                                         u'value': u'CUSTOM_METRIC_UTILIZATION'},
                                                                                                                                        u'--description': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Notes about Autoscaler.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--description',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'DESCRIPTION'},
                                                                                                                                        u'--max-num-replicas': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Maximum number of replicas Autoscaler will set.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--max-num-replicas',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': True,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'MAX_NUM_REPLICAS'},
                                                                                                                                        u'--min-num-replicas': {u'attr': {},
                                                                                                                                                                u'category': u'',
                                                                                                                                                                u'choices': [],
                                                                                                                                                                u'completer': u'',
                                                                                                                                                                u'default': None,
                                                                                                                                                                u'description': u'Minimum number of replicas Autoscaler will set.',
                                                                                                                                                                u'group': u'',
                                                                                                                                                                u'hidden': False,
                                                                                                                                                                u'name': u'--min-num-replicas',
                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                u'required': False,
                                                                                                                                                                u'type': u'string',
                                                                                                                                                                u'value': u'MIN_NUM_REPLICAS'},
                                                                                                                                        u'--no-scale-based-on-cpu': {u'attr': {},
                                                                                                                                                                     u'category': u'',
                                                                                                                                                                     u'choices': [],
                                                                                                                                                                     u'completer': u'',
                                                                                                                                                                     u'default': True,
                                                                                                                                                                     u'description': u'',
                                                                                                                                                                     u'group': u'',
                                                                                                                                                                     u'hidden': True,
                                                                                                                                                                     u'name': u'--no-scale-based-on-cpu',
                                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                                     u'required': False,
                                                                                                                                                                     u'type': u'bool',
                                                                                                                                                                     u'value': u'NO_SCALE_BASED_ON_CPU'},
                                                                                                                                        u'--no-scale-based-on-load-balancing': {u'attr': {},
                                                                                                                                                                                u'category': u'',
                                                                                                                                                                                u'choices': [],
                                                                                                                                                                                u'completer': u'',
                                                                                                                                                                                u'default': True,
                                                                                                                                                                                u'description': u'',
                                                                                                                                                                                u'group': u'',
                                                                                                                                                                                u'hidden': True,
                                                                                                                                                                                u'name': u'--no-scale-based-on-load-balancing',
                                                                                                                                                                                u'nargs': u'0',
                                                                                                                                                                                u'required': False,
                                                                                                                                                                                u'type': u'bool',
                                                                                                                                                                                u'value': u'NO_SCALE_BASED_ON_LOAD_BALANCING'},
                                                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                      u'group': u'set-autoscaling.1',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--region',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'REGION'},
                                                                                                                                        u'--scale-based-on-cpu': {u'attr': {},
                                                                                                                                                                  u'category': u'',
                                                                                                                                                                  u'choices': [],
                                                                                                                                                                  u'completer': u'',
                                                                                                                                                                  u'default': False,
                                                                                                                                                                  u'description': u'Autoscaler will be based on CPU utilization.',
                                                                                                                                                                  u'group': u'',
                                                                                                                                                                  u'hidden': False,
                                                                                                                                                                  u'name': u'--scale-based-on-cpu',
                                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                                  u'required': False,
                                                                                                                                                                  u'type': u'bool',
                                                                                                                                                                  u'value': u'SCALE_BASED_ON_CPU'},
                                                                                                                                        u'--scale-based-on-load-balancing': {u'attr': {},
                                                                                                                                                                             u'category': u'',
                                                                                                                                                                             u'choices': [],
                                                                                                                                                                             u'completer': u'',
                                                                                                                                                                             u'default': False,
                                                                                                                                                                             u'description': u'Use autoscaling based on load balancing utilization.',
                                                                                                                                                                             u'group': u'',
                                                                                                                                                                             u'hidden': False,
                                                                                                                                                                             u'name': u'--scale-based-on-load-balancing',
                                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                                             u'required': False,
                                                                                                                                                                             u'type': u'bool',
                                                                                                                                                                             u'value': u'SCALE_BASED_ON_LOAD_BALANCING'},
                                                                                                                                        u'--target-cpu-utilization': {u'attr': {},
                                                                                                                                                                      u'category': u'',
                                                                                                                                                                      u'choices': [],
                                                                                                                                                                      u'completer': u'',
                                                                                                                                                                      u'default': None,
                                                                                                                                                                      u'description': u'Autoscaler will aim to maintain CPU utilization at target level (0.0 to 1.0).',
                                                                                                                                                                      u'group': u'',
                                                                                                                                                                      u'hidden': False,
                                                                                                                                                                      u'name': u'--target-cpu-utilization',
                                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                                      u'required': False,
                                                                                                                                                                      u'type': u'string',
                                                                                                                                                                      u'value': u'TARGET_CPU_UTILIZATION'},
                                                                                                                                        u'--target-load-balancing-utilization': {u'attr': {},
                                                                                                                                                                                 u'category': u'',
                                                                                                                                                                                 u'choices': [],
                                                                                                                                                                                 u'completer': u'',
                                                                                                                                                                                 u'default': None,
                                                                                                                                                                                 u'description': u'Autoscaler will aim to maintain the load balancing utilization level (greater than 0.0).',
                                                                                                                                                                                 u'group': u'',
                                                                                                                                                                                 u'hidden': False,
                                                                                                                                                                                 u'name': u'--target-load-balancing-utilization',
                                                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                                                 u'required': False,
                                                                                                                                                                                 u'type': u'string',
                                                                                                                                                                                 u'value': u'TARGET_LOAD_BALANCING_UTILIZATION'},
                                                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                    u'group': u'set-autoscaling.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--zone',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'ZONE'}},
                                                                                                                             u'group': False,
                                                                                                                             u'groups': {u'set-autoscaling.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                u'is_mutex': True,
                                                                                                                                                                u'is_required': False}},
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'set-autoscaling',
                                                                                                                             u'path': [u'gcloud',
                                                                                                                                       u'compute',
                                                                                                                                       u'instance-groups',
                                                                                                                                       u'managed',
                                                                                                                                       u'set-autoscaling'],
                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The name of the managed instance group.',
                                                                                                                                               u'name': u'name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'value': u'NAME'}],
                                                                                                                             u'release': u'GA',
                                                                                                                             u'sections': {u'DESCRIPTION': u'        *set-autoscaling* sets autoscaling parameters of specified managed instance\ngroup.\n\nAutoscalers can use one or more policies listed below. Information on using\nmultiple policies can be found here: [](https://cloud.google.com/compute/docs/autoscaler/multiple-policies)\n'}},
                                                                                                        u'set-instance-template': {u'capsule': u'Set instance template for managed instance group.',
                                                                                                                                   u'commands': {},
                                                                                                                                   u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                            u'group': u'set-instance-template.1',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--region',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': False,
                                                                                                                                                            u'type': u'string',
                                                                                                                                                            u'value': u'REGION'},
                                                                                                                                              u'--template': {u'attr': {},
                                                                                                                                                              u'category': u'',
                                                                                                                                                              u'choices': [],
                                                                                                                                                              u'completer': u'',
                                                                                                                                                              u'default': None,
                                                                                                                                                              u'description': u'Compute Engine instance template resource to be used.',
                                                                                                                                                              u'group': u'',
                                                                                                                                                              u'hidden': False,
                                                                                                                                                              u'name': u'--template',
                                                                                                                                                              u'nargs': u'0',
                                                                                                                                                              u'required': True,
                                                                                                                                                              u'type': u'string',
                                                                                                                                                              u'value': u'TEMPLATE'},
                                                                                                                                              u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                          u'category': u'',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                          u'group': u'set-instance-template.1',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--zone',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'ZONE'}},
                                                                                                                                   u'group': False,
                                                                                                                                   u'groups': {u'set-instance-template.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                            u'is_mutex': True,
                                                                                                                                                                            u'is_required': False}},
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'set-instance-template',
                                                                                                                                   u'path': [u'gcloud',
                                                                                                                                             u'compute',
                                                                                                                                             u'instance-groups',
                                                                                                                                             u'managed',
                                                                                                                                             u'set-instance-template'],
                                                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The name of the managed instance group.',
                                                                                                                                                     u'name': u'name',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'value': u'NAME'}],
                                                                                                                                   u'release': u'GA',
                                                                                                                                   u'sections': {u'DESCRIPTION': u"\n        *set-instance-template* updates the instance template for an existing managed instance group.\n\nThe new template won't apply to existing instances in the group unless they are\nrecreated using the recreate-instances command. But the new template does apply\nto all new instances added to the managed instance group.\n"}},
                                                                                                        u'set-named-ports': {u'capsule': u'Sets the list of named ports for an instance group.',
                                                                                                                             u'commands': {},
                                                                                                                             u'flags': {u'--named-ports': {u'attr': {},
                                                                                                                                                           u'category': u'',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'The comma-separated list of key:value pairs representing\nthe service name and the port that it is running on.\n+\nTo clear the list of named ports pass empty list as flag value.\nFor example:\n+\n  $ {command} example-instance-group --named-ports ""',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--named-ports',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': True,
                                                                                                                                                           u'type': u'list',
                                                                                                                                                           u'value': u'NAME:PORT'},
                                                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                      u'group': u'set-named-ports.1',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--region',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'REGION'},
                                                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                    u'group': u'set-named-ports.1',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--zone',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'ZONE'}},
                                                                                                                             u'group': False,
                                                                                                                             u'groups': {u'set-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                u'is_mutex': True,
                                                                                                                                                                u'is_required': False}},
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'set-named-ports',
                                                                                                                             u'path': [u'gcloud',
                                                                                                                                       u'compute',
                                                                                                                                       u'instance-groups',
                                                                                                                                       u'managed',
                                                                                                                                       u'set-named-ports'],
                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The name of the instance group.',
                                                                                                                                               u'name': u'name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'value': u'NAME'}],
                                                                                                                             u'release': u'GA',
                                                                                                                             u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which\nindicates that the service is available on all instances in the\ngroup. This information is used by the HTTP Load Balancing\nservice.\n\n*set-named-ports* sets the list of named ports for all instances\nin an instance group.\n\nNote: Running this command will clear all existing named ports.\n",
                                                                                                                                           u'EXAMPLES': u'For example, to apply the named ports to an entire instance group:\n\n  $ set-named-ports example-instance-group --named-ports example-service:1111 --zone us-central1-a\n\nThe above example will assign a name \'example-service\' for port 1111\nto the instance group called \'example-instance-group\' in the\n``us-central1-a\'\' zone. The command removes any named ports that are\nalready set for this instance group.\n\nTo clear named ports from instance group provide empty named ports\nlist as parameter:\n\n  $ set-named-ports example-instance-group --named-ports "" --zone us-central1-a\n'}},
                                                                                                        u'set-target-pools': {u'capsule': u'Set target pools of managed instance group.',
                                                                                                                              u'commands': {},
                                                                                                                              u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                       u'group': u'set-target-pools.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--region',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'REGION'},
                                                                                                                                         u'--target-pools': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'Compute Engine Target Pools to add the instances to. Target Pools must be specified by name or by URL. Example: --target-pool target-pool-1,target-pool-2.',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--target-pools',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': True,
                                                                                                                                                             u'type': u'list',
                                                                                                                                                             u'value': u'TARGET_POOL'},
                                                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                     u'group': u'set-target-pools.1',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--zone',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'ZONE'}},
                                                                                                                              u'group': False,
                                                                                                                              u'groups': {u'set-target-pools.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                  u'is_mutex': True,
                                                                                                                                                                  u'is_required': False}},
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'set-target-pools',
                                                                                                                              u'path': [u'gcloud',
                                                                                                                                        u'compute',
                                                                                                                                        u'instance-groups',
                                                                                                                                        u'managed',
                                                                                                                                        u'set-target-pools'],
                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The name of the managed instance group.',
                                                                                                                                                u'name': u'name',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'value': u'NAME'}],
                                                                                                                              u'release': u'GA',
                                                                                                                              u'sections': {u'DESCRIPTION': u"\n        *set-target-pools* sets the target pools for an existing managed instance group.\nInstances that are part of the managed instance group will be added to the\ntarget pool automatically.\n\nSetting a new target pool won't apply to existing instances in the group unless\nthey are recreated using the recreate-instances command. But any new instances\ncreated in the managed instance group will be added to all of the provided\ntarget pools for load balancing purposes.\n"}},
                                                                                                        u'stop-autoscaling': {u'capsule': u'Stop autoscaling a managed instance group.',
                                                                                                                              u'commands': {},
                                                                                                                              u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                       u'group': u'stop-autoscaling.1',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--region',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'REGION'},
                                                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                     u'group': u'stop-autoscaling.1',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--zone',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'ZONE'}},
                                                                                                                              u'group': False,
                                                                                                                              u'groups': {u'stop-autoscaling.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                  u'is_mutex': True,
                                                                                                                                                                  u'is_required': False}},
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'stop-autoscaling',
                                                                                                                              u'path': [u'gcloud',
                                                                                                                                        u'compute',
                                                                                                                                        u'instance-groups',
                                                                                                                                        u'managed',
                                                                                                                                        u'stop-autoscaling'],
                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The name of the managed instance group.',
                                                                                                                                                u'name': u'name',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'value': u'NAME'}],
                                                                                                                              u'release': u'GA',
                                                                                                                              u'sections': {u'DESCRIPTION': u'        *stop-autoscaling* stops autoscaling a managed instance group. If autoscaling\nis not enabled for the managed instance group, this command does nothing and\nwill report an error.\n'}},
                                                                                                        u'wait-until-stable': {u'capsule': u'Waits until state of managed instance group is stable.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                                        u'category': u'',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'The region of the managed instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                                                        u'group': u'wait-until-stable.1',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--region',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'REGION'},
                                                                                                                                          u'--timeout': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'Timeout in seconds for waiting for group becoming stable.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--timeout',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'string',
                                                                                                                                                         u'value': u'TIMEOUT'},
                                                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The zone of the managed instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                                                      u'group': u'wait-until-stable.1',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--zone',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'ZONE'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {u'wait-until-stable.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                                                    u'is_mutex': True,
                                                                                                                                                                    u'is_required': False}},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'wait-until-stable',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'compute',
                                                                                                                                         u'instance-groups',
                                                                                                                                         u'managed',
                                                                                                                                         u'wait-until-stable'],
                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The name of the managed instance group.',
                                                                                                                                                 u'name': u'name',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'value': u'NAME'}],
                                                                                                                               u'release': u'GA',
                                                                                                                               u'sections': {u'DESCRIPTION': u'Waits until state of managed instance group is stable.'}}},
                                                                                          u'flags': {},
                                                                                          u'group': True,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'managed',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'instance-groups',
                                                                                                    u'managed'],
                                                                                          u'positionals': [],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'Read and manipulate Google Compute Engine managed instance groups.'}},
                                                                             u'set-named-ports': {u'capsule': u'Sets the list of named ports for an instance group.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {u'--named-ports': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The comma-separated list of key:value pairs representing\nthe service name and the port that it is running on.\n+\nTo clear the list of named ports pass empty list as flag value.\nFor example:\n+\n  $ {command} example-instance-group --named-ports ""',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--named-ports',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'NAME:PORT'},
                                                                                                             u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The region of the instance group to operate on. If not specified, you will be prompted to select a region.\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nOverrides the default *compute/region* property value for this command invocation.',
                                                                                                                           u'group': u'set-named-ports.1',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--region',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'REGION'},
                                                                                                             u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nOverrides the default *compute/zone* property value for this command invocation.',
                                                                                                                         u'group': u'set-named-ports.1',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--zone',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'ZONE'}},
                                                                                                  u'group': False,
                                                                                                  u'groups': {u'set-named-ports.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                     u'is_mutex': True,
                                                                                                                                     u'is_required': False}},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'set-named-ports',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'compute',
                                                                                                            u'instance-groups',
                                                                                                            u'set-named-ports'],
                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The name of the instance group.',
                                                                                                                    u'name': u'name',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'NAME'}],
                                                                                                  u'release': u'GA',
                                                                                                  u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which\nindicates that the service is available on all instances in the\ngroup. This information is used by the HTTP Load Balancing\nservice.\n\n*set-named-ports* sets the list of named ports for all instances\nin an instance group.\n\nNote: Running this command will clear all existing named ports.\n",
                                                                                                                u'EXAMPLES': u'For example, to apply the named ports to an entire instance group:\n\n  $ set-named-ports example-instance-group --named-ports example-service:1111 --zone us-central1-a\n\nThe above example will assign a name \'example-service\' for port 1111\nto the instance group called \'example-instance-group\' in the\n``us-central1-a\'\' zone. The command removes any named ports that are\nalready set for this instance group.\n\nTo clear named ports from instance group provide empty named ports\nlist as parameter:\n\n  $ set-named-ports example-instance-group --named-ports "" --zone us-central1-a\n'}},
                                                                             u'unmanaged': {u'capsule': u'Read and manipulate Google Compute Engine unmanaged instance group.',
                                                                                            u'commands': {u'add-instances': {u'capsule': u'Adds instances to an unmanaged instance group by name.',
                                                                                                                             u'commands': {},
                                                                                                                             u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                         u'category': u'',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u'A list of names of instances to add to the instance group. These must exist beforehand and must live in the same zone as the instance group.',
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--instances',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': True,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'INSTANCE'},
                                                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--zone',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'ZONE'}},
                                                                                                                             u'group': False,
                                                                                                                             u'groups': {},
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'add-instances',
                                                                                                                             u'path': [u'gcloud',
                                                                                                                                       u'compute',
                                                                                                                                       u'instance-groups',
                                                                                                                                       u'unmanaged',
                                                                                                                                       u'add-instances'],
                                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u'The name of the instance group.',
                                                                                                                                               u'name': u'name',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'value': u'NAME'}],
                                                                                                                             u'release': u'GA',
                                                                                                                             u'sections': {u'DESCRIPTION': u'*add-instances* adds existing instances to an unmanaged instance group\nby name.\nFor example:\n\n  $ add-instances example-instance-group --instances example-instance-1 example-instance-2 --zone us-central1-a\n'}},
                                                                                                          u'create': {u'capsule': u'Create a Compute Engine unmanaged instance group.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--description': {u'attr': {},
                                                                                                                                                    u'category': u'',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': None,
                                                                                                                                                    u'description': u'Specifies a textual description for the unmanaged instance group.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--description',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'string',
                                                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--zone',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'create',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'compute',
                                                                                                                                u'instance-groups',
                                                                                                                                u'unmanaged',
                                                                                                                                u'create'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the instance group.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'GA',
                                                                                                                      u'sections': {u'DESCRIPTION': u"*create* creates a new Google Compute Engine unmanaged\ninstance group.\nFor example:\n\n  $ create example-instance-group --zone us-central1-a\n\nThe above example creates one unmanaged instance group called\n'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                          u'delete': {u'capsule': u'Delete Google Compute Engine unmanaged instance groups.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u"The zone of the resources to delete. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--zone',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'ZONE'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'delete',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'compute',
                                                                                                                                u'instance-groups',
                                                                                                                                u'unmanaged',
                                                                                                                                u'delete'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The resources to delete.',
                                                                                                                                        u'name': u'names',
                                                                                                                                        u'nargs': u'+',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'GA',
                                                                                                                      u'sections': {u'DESCRIPTION': u"*delete* deletes one or more Google Compute Engine unmanaged\ninstance groups. This command just deletes the instance group and does\nnot delete the individual virtual machine instances\nin the instance group.\nFor example:\n\n  $ delete example-instance-group-1 example-instance-group-2 --zone us-central1-a\n\nThe above example deletes two instance groups, example-instance-group-1\nand example-instance-group-2, in the ``us-central1-a'' zone.\n"}},
                                                                                                          u'describe': {u'capsule': u'Describe an instance group.',
                                                                                                                        u'commands': {},
                                                                                                                        u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--zone',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'ZONE'}},
                                                                                                                        u'group': False,
                                                                                                                        u'groups': {},
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'describe',
                                                                                                                        u'path': [u'gcloud',
                                                                                                                                  u'compute',
                                                                                                                                  u'instance-groups',
                                                                                                                                  u'unmanaged',
                                                                                                                                  u'describe'],
                                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'The name of the resource to fetch.',
                                                                                                                                          u'name': u'name',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'value': u'NAME'}],
                                                                                                                        u'release': u'GA',
                                                                                                                        u'sections': {u'DESCRIPTION': u'*describe* displays detailed information about a Google Compute\nEngine instance group.\n'}},
                                                                                                          u'get-named-ports': {u'capsule': u'Lists the named ports for an instance group resource.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--filter',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'string',
                                                                                                                                                        u'value': u'EXPRESSION'},
                                                                                                                                          u'--limit': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--limit',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'LIMIT'},
                                                                                                                                          u'--no-uri': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': True,
                                                                                                                                                        u'description': u'',
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': True,
                                                                                                                                                        u'name': u'--no-uri',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'bool',
                                                                                                                                                        u'value': u'NO_URI'},
                                                                                                                                          u'--page-size': {u'attr': {},
                                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                                           u'choices': [],
                                                                                                                                                           u'completer': u'',
                                                                                                                                                           u'default': None,
                                                                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                           u'group': u'',
                                                                                                                                                           u'hidden': False,
                                                                                                                                                           u'name': u'--page-size',
                                                                                                                                                           u'nargs': u'0',
                                                                                                                                                           u'required': False,
                                                                                                                                                           u'type': u'string',
                                                                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                                                                          u'--sort-by': {u'attr': {},
                                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                                         u'choices': [],
                                                                                                                                                         u'completer': u'',
                                                                                                                                                         u'default': None,
                                                                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                         u'group': u'',
                                                                                                                                                         u'hidden': False,
                                                                                                                                                         u'name': u'--sort-by',
                                                                                                                                                         u'nargs': u'0',
                                                                                                                                                         u'required': False,
                                                                                                                                                         u'type': u'list',
                                                                                                                                                         u'value': u'FIELD'},
                                                                                                                                          u'--uri': {u'attr': {},
                                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': False,
                                                                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--uri',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'bool',
                                                                                                                                                     u'value': u'URI'},
                                                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--zone',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'ZONE'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'get-named-ports',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'compute',
                                                                                                                                         u'instance-groups',
                                                                                                                                         u'unmanaged',
                                                                                                                                         u'get-named-ports'],
                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The name of the instance group.',
                                                                                                                                                 u'name': u'name',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'value': u'NAME'}],
                                                                                                                               u'release': u'GA',
                                                                                                                               u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which indicates that the service\nis available on all instances in the group. This information is used\nby the HTTP Load Balancing service.\n\n*get-named-ports* lists the named ports (name and port tuples)\nfor an instance group.\n",
                                                                                                                                             u'EXAMPLES': u"For example, to list named ports for an instance group:\n\n  $ get-named-ports example-instance-group --zone us-central1-a\n\nThe above example lists named ports assigned to an instance\ngroup named 'example-instance-group' in the ``us-central1-a'' zone.\n"}},
                                                                                                          u'list': {u'capsule': u'List Google Compute Engine unmanaged instance groups.',
                                                                                                                    u'commands': {},
                                                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--filter',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'EXPRESSION'},
                                                                                                                               u'--limit': {u'attr': {},
                                                                                                                                            u'category': u'LIST COMMAND',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--limit',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'LIMIT'},
                                                                                                                               u'--no-uri': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': True,
                                                                                                                                             u'description': u'',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': True,
                                                                                                                                             u'name': u'--no-uri',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'NO_URI'},
                                                                                                                               u'--page-size': {u'attr': {},
                                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--page-size',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'string',
                                                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                                                               u'--regexp': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--regexp',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'REGEXP'},
                                                                                                                               u'--sort-by': {u'attr': {},
                                                                                                                                              u'category': u'LIST COMMAND',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--sort-by',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'list',
                                                                                                                                              u'value': u'FIELD'},
                                                                                                                               u'--uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': False,
                                                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'URI'},
                                                                                                                               u'--zones': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': [],
                                                                                                                                            u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--zones',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'list',
                                                                                                                                            u'value': u'ZONE'}},
                                                                                                                    u'group': False,
                                                                                                                    u'groups': {},
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'list',
                                                                                                                    u'path': [u'gcloud',
                                                                                                                              u'compute',
                                                                                                                              u'instance-groups',
                                                                                                                              u'unmanaged',
                                                                                                                              u'list'],
                                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                                      u'default': [],
                                                                                                                                      u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                                      u'name': u'names',
                                                                                                                                      u'nargs': u'*',
                                                                                                                                      u'required': False,
                                                                                                                                      u'value': u'NAME'}],
                                                                                                                    u'release': u'GA',
                                                                                                                    u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine unmanaged instance groups in a project.\n\nBy default, unmanaged instance groups from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                                                  u'EXAMPLES': u"To list all unmanaged instance groups in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all unmanaged instance groups in a project, run:\n\n  $ list --uri\n\nTo list all unmanaged instance groups in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}},
                                                                                                          u'list-instances': {u'capsule': u'List instances present in the instance group.',
                                                                                                                              u'commands': {},
                                                                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--filter',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'EXPRESSION'},
                                                                                                                                         u'--limit': {u'attr': {},
                                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--limit',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'LIMIT'},
                                                                                                                                         u'--no-uri': {u'attr': {},
                                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': True,
                                                                                                                                                       u'description': u'',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': True,
                                                                                                                                                       u'name': u'--no-uri',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'bool',
                                                                                                                                                       u'value': u'NO_URI'},
                                                                                                                                         u'--page-size': {u'attr': {},
                                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                                          u'choices': [],
                                                                                                                                                          u'completer': u'',
                                                                                                                                                          u'default': None,
                                                                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                                          u'group': u'',
                                                                                                                                                          u'hidden': False,
                                                                                                                                                          u'name': u'--page-size',
                                                                                                                                                          u'nargs': u'0',
                                                                                                                                                          u'required': False,
                                                                                                                                                          u'type': u'string',
                                                                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                                                                         u'--regexp': {u'attr': {},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--regexp',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'REGEXP'},
                                                                                                                                         u'--sort-by': {u'attr': {},
                                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                                        u'choices': [],
                                                                                                                                                        u'completer': u'',
                                                                                                                                                        u'default': None,
                                                                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                                        u'group': u'',
                                                                                                                                                        u'hidden': False,
                                                                                                                                                        u'name': u'--sort-by',
                                                                                                                                                        u'nargs': u'0',
                                                                                                                                                        u'required': False,
                                                                                                                                                        u'type': u'list',
                                                                                                                                                        u'value': u'FIELD'},
                                                                                                                                         u'--uri': {u'attr': {},
                                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                                    u'choices': [],
                                                                                                                                                    u'completer': u'',
                                                                                                                                                    u'default': False,
                                                                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                                    u'group': u'',
                                                                                                                                                    u'hidden': False,
                                                                                                                                                    u'name': u'--uri',
                                                                                                                                                    u'nargs': u'0',
                                                                                                                                                    u'required': False,
                                                                                                                                                    u'type': u'bool',
                                                                                                                                                    u'value': u'URI'},
                                                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                     u'category': u'',
                                                                                                                                                     u'choices': [],
                                                                                                                                                     u'completer': u'',
                                                                                                                                                     u'default': None,
                                                                                                                                                     u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                     u'group': u'',
                                                                                                                                                     u'hidden': False,
                                                                                                                                                     u'name': u'--zone',
                                                                                                                                                     u'nargs': u'0',
                                                                                                                                                     u'required': False,
                                                                                                                                                     u'type': u'string',
                                                                                                                                                     u'value': u'ZONE'}},
                                                                                                                              u'group': False,
                                                                                                                              u'groups': {},
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'list-instances',
                                                                                                                              u'path': [u'gcloud',
                                                                                                                                        u'compute',
                                                                                                                                        u'instance-groups',
                                                                                                                                        u'unmanaged',
                                                                                                                                        u'list-instances'],
                                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'The name of the instance group.',
                                                                                                                                                u'name': u'name',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'value': u'NAME'}],
                                                                                                                              u'release': u'GA',
                                                                                                                              u'sections': {u'DESCRIPTION': u'*list-instances* list instances in an instance group.\n'}},
                                                                                                          u'remove-instances': {u'capsule': u'Removes resources from an unmanaged instance group by instance name.',
                                                                                                                                u'commands': {},
                                                                                                                                u'flags': {u'--instances': {u'attr': {},
                                                                                                                                                            u'category': u'',
                                                                                                                                                            u'choices': [],
                                                                                                                                                            u'completer': u'',
                                                                                                                                                            u'default': None,
                                                                                                                                                            u'description': u'The names of the instances to remove from the instance group.',
                                                                                                                                                            u'group': u'',
                                                                                                                                                            u'hidden': False,
                                                                                                                                                            u'name': u'--instances',
                                                                                                                                                            u'nargs': u'0',
                                                                                                                                                            u'required': True,
                                                                                                                                                            u'type': u'list',
                                                                                                                                                            u'value': u'INSTANCE'},
                                                                                                                                           u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                       u'category': u'',
                                                                                                                                                       u'choices': [],
                                                                                                                                                       u'completer': u'',
                                                                                                                                                       u'default': None,
                                                                                                                                                       u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                       u'group': u'',
                                                                                                                                                       u'hidden': False,
                                                                                                                                                       u'name': u'--zone',
                                                                                                                                                       u'nargs': u'0',
                                                                                                                                                       u'required': False,
                                                                                                                                                       u'type': u'string',
                                                                                                                                                       u'value': u'ZONE'}},
                                                                                                                                u'group': False,
                                                                                                                                u'groups': {},
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'remove-instances',
                                                                                                                                u'path': [u'gcloud',
                                                                                                                                          u'compute',
                                                                                                                                          u'instance-groups',
                                                                                                                                          u'unmanaged',
                                                                                                                                          u'remove-instances'],
                                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                                  u'default': None,
                                                                                                                                                  u'description': u'The name of the instance group.',
                                                                                                                                                  u'name': u'name',
                                                                                                                                                  u'nargs': u'0',
                                                                                                                                                  u'required': False,
                                                                                                                                                  u'value': u'NAME'}],
                                                                                                                                u'release': u'GA',
                                                                                                                                u'sections': {u'DESCRIPTION': u'*remove-instances* removes instances from an unmanaged instance group using\nthe instance name.\n\nThis does not delete the actual instance resources but removes\nit from the instance group.\n'}},
                                                                                                          u'set-named-ports': {u'capsule': u'Sets the list of named ports for an instance group.',
                                                                                                                               u'commands': {},
                                                                                                                               u'flags': {u'--named-ports': {u'attr': {},
                                                                                                                                                             u'category': u'',
                                                                                                                                                             u'choices': [],
                                                                                                                                                             u'completer': u'',
                                                                                                                                                             u'default': None,
                                                                                                                                                             u'description': u'The comma-separated list of key:value pairs representing\nthe service name and the port that it is running on.\n+\nTo clear the list of named ports pass empty list as flag value.\nFor example:\n+\n  $ {command} example-instance-group --named-ports ""',
                                                                                                                                                             u'group': u'',
                                                                                                                                                             u'hidden': False,
                                                                                                                                                             u'name': u'--named-ports',
                                                                                                                                                             u'nargs': u'0',
                                                                                                                                                             u'required': True,
                                                                                                                                                             u'type': u'list',
                                                                                                                                                             u'value': u'NAME:PORT'},
                                                                                                                                          u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u"The zone of the instance group to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--zone',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': False,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'ZONE'}},
                                                                                                                               u'group': False,
                                                                                                                               u'groups': {},
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'set-named-ports',
                                                                                                                               u'path': [u'gcloud',
                                                                                                                                         u'compute',
                                                                                                                                         u'instance-groups',
                                                                                                                                         u'unmanaged',
                                                                                                                                         u'set-named-ports'],
                                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                                 u'default': None,
                                                                                                                                                 u'description': u'The name of the instance group.',
                                                                                                                                                 u'name': u'name',
                                                                                                                                                 u'nargs': u'0',
                                                                                                                                                 u'required': False,
                                                                                                                                                 u'value': u'NAME'}],
                                                                                                                               u'release': u'GA',
                                                                                                                               u'sections': {u'DESCRIPTION': u"Named ports are key:value pairs metadata representing\nthe service name and the port that it's running on. Named ports\ncan be assigned to an instance group, which\nindicates that the service is available on all instances in the\ngroup. This information is used by the HTTP Load Balancing\nservice.\n\n*set-named-ports* sets the list of named ports for all instances\nin an instance group.\n\nNote: Running this command will clear all existing named ports.\n",
                                                                                                                                             u'EXAMPLES': u'For example, to apply the named ports to an entire instance group:\n\n  $ set-named-ports example-instance-group --named-ports example-service:1111 --zone us-central1-a\n\nThe above example will assign a name \'example-service\' for port 1111\nto the instance group called \'example-instance-group\' in the\n``us-central1-a\'\' zone. The command removes any named ports that are\nalready set for this instance group.\n\nTo clear named ports from instance group provide empty named ports\nlist as parameter:\n\n  $ set-named-ports example-instance-group --named-ports "" --zone us-central1-a\n'}}},
                                                                                            u'flags': {},
                                                                                            u'group': True,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'unmanaged',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'instance-groups',
                                                                                                      u'unmanaged'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'Read and manipulate Google Compute Engine unmanaged instance groups.'}}},
                                                               u'flags': {},
                                                               u'group': True,
                                                               u'groups': {},
                                                               u'hidden': False,
                                                               u'name': u'instance-groups',
                                                               u'path': [u'gcloud',
                                                                         u'compute',
                                                                         u'instance-groups'],
                                                               u'positionals': [],
                                                               u'release': u'GA',
                                                               u'sections': {u'DESCRIPTION': u'Read and manipulate Google Compute Engine instance groups. To accommodate the\ndifferences between managed and unmanaged instances, some commands (such as\n`delete`) are in the managed or unmanaged subgroups.'}},
                                          u'instance-templates': {u'capsule': u'Read and manipulate Google Compute Engine instances templates.',
                                                                  u'commands': {u'create': {u'capsule': u'Create a Compute Engine virtual machine instance template.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--address': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Assigns the given external IP address to the instance that is created.\nThis option can only be used when creating a single instance.',
                                                                                                                      u'group': u'create.1',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--address',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'ADDRESS'},
                                                                                                       u'--boot-disk-auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'Automatically delete boot disks when their instances are deleted. Enabled by default, use *--no-boot-disk-auto-delete* to disable.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--boot-disk-auto-delete',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'BOOT_DISK_AUTO_DELETE'},
                                                                                                       u'--boot-disk-device-name': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The name the guest operating system will see for the boot disk as.  This\noption can only be specified if a new boot disk is being created (as\nopposed to mounting an existing persistent disk).',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--boot-disk-device-name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'BOOT_DISK_DEVICE_NAME'},
                                                                                                       u'--boot-disk-size': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"The size of the boot disk. This option can only be specified if a new\nboot disk is being created (as opposed to mounting an existing\npersistent disk). The value must be a whole number followed by a size\nunit of ``KB'' for kilobyte, ``MB'' for megabyte, ``GB'' for gigabyte,\nor ``TB'' for terabyte. For example, ``10GB'' will produce a 10 gigabyte\ndisk. The minimum size a boot disk can have is 10 GB. Disk size must be a\nmultiple of 1 GB.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--boot-disk-size',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'BOOT_DISK_SIZE'},
                                                                                                       u'--boot-disk-type': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The type of the boot disk. This option can only be specified if a new boot\ndisk is being created (as opposed to mounting an existing persistent\ndisk). To get a list of available disk types, run\n`$ gcloud compute disk-types list`.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--boot-disk-type',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'BOOT_DISK_TYPE'},
                                                                                                       u'--can-ip-forward': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'If provided, allows the instances to send and receive packets with non-matching destination or source IP addresses.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--can-ip-forward',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'CAN_IP_FORWARD'},
                                                                                                       u'--custom-cpu': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--custom-cpu',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'CUSTOM_CPU'},
                                                                                                       u'--custom-memory': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--custom-memory',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'CUSTOM_MEMORY'},
                                                                                                       u'--description': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Specifies a textual description for the instance template.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--description',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                       u'--disk': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"Attaches persistent disks to the instances. The disks\nspecified must already exist.\n+\n*name*::: The disk to attach to the instances. When creating\nmore than one instance and using this property, the only valid\nmode for attaching the disk is read-only (see *mode* below).\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default. It is an error for mode\nto be ``rw'' when creating more than one instance because\nread-write disks can only be attached to a single instance.\n+\n*boot*::: If ``yes'', indicates that this is a boot disk. The\nvirtual machines will use the first partition of the disk for\ntheir root file systems. The default value for this is ``no''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--disk',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'dict',
                                                                                                                   u'value': u'DISK'},
                                                                                                       u'--image': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"Specifies the boot image for the instances. For each\ninstance, a new boot disk will be created from the given\nimage. Each boot disk will have the same name as the\ninstance. To view a list of public images and projects, run\n`$ gcloud compute images list`.\n+\nWhen using this option, ``--boot-disk-device-name'' and\n``--boot-disk-size'' can be used to override the boot disk's\ndevice name and size, respectively.",
                                                                                                                    u'group': u'create.2',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--image',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'IMAGE'},
                                                                                                       u'--image-family': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"The family of the image that the boot disk will be initialized\nwith. When a family is specified instead of an image, the latest\nnon-deprecated image associated with that family is used.\n+\nBy default, ``debian-8'' is assumed for this flag.",
                                                                                                                           u'group': u'create.2',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--image-family',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'IMAGE_FAMILY'},
                                                                                                       u'--image-project': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u"The project against which all image and image family references will be\nresolved. See ``--image'' for more details.",
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--image-project',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'IMAGE_PROJECT'},
                                                                                                       u'--local-ssd': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u"Attaches a local SSD to the instances.\n+\nThis flag is currently in BETA and may change without notice.\n+\n*device-name*::: Optional. A name that indicates the disk name\nthe guest operating system will see.  If omitted, a device name\nof the form ``local-ssd-N'' will be used.\n+\n*interface*::: Optional. The kind of disk interface exposed to the VM\nfor this SSD.  Valid values are ``SCSI'' and ``NVME''.  SCSI is\nthe default and is supported by more guest operating systems.  NVME\nmay provide higher performance.",
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--local-ssd',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'dict',
                                                                                                                        u'value': u'LOCAL_SSD'},
                                                                                                       u'--machine-type': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--machine-type',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'MACHINE_TYPE'},
                                                                                                       u'--maintenance-policy': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [u'MIGRATE',
                                                                                                                                              u'TERMINATE'],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--maintenance-policy',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'MAINTENANCE_POLICY'},
                                                                                                       u'--metadata': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': {},
                                                                                                                       u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--metadata',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'dict',
                                                                                                                       u'value': u'KEY=VALUE'},
                                                                                                       u'--metadata-from-file': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': {},
                                                                                                                                 u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--metadata-from-file',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'dict',
                                                                                                                                 u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                                       u'--network': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Specifies the network that the instances will be part of. If --subnet is\nalso specified subnet must be a subnetwork of network specified by\n--network. If neither is specified, this defaults to the "default"\nnetwork.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--network',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'NETWORK'},
                                                                                                       u'--no-address': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'If provided, the instances will not be assigned external IP addresses.',
                                                                                                                         u'group': u'create.1',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--no-address',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'NO_ADDRESS'},
                                                                                                       u'--no-boot-disk-auto-delete': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': True,
                                                                                                                                       u'description': u'',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': True,
                                                                                                                                       u'name': u'--no-boot-disk-auto-delete',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'NO_BOOT_DISK_AUTO_DELETE'},
                                                                                                       u'--no-can-ip-forward': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-can-ip-forward',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_CAN_IP_FORWARD'},
                                                                                                       u'--no-preemptible': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-preemptible',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_PREEMPTIBLE'},
                                                                                                       u'--no-restart-on-failure': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-restart-on-failure',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                                       u'--no-scopes': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'Create instance without scopes',
                                                                                                                        u'group': u'create.3',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--no-scopes',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'NO_SCOPES'},
                                                                                                       u'--no-service-account': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u'Create instance without service account',
                                                                                                                                 u'group': u'create.4',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--no-service-account',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                                       u'--preemptible': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'If provided, instances will be preemptible and time-limited.\nInstances may be preempted to free up resources for standard VM instances,\nand will only be able to run for a limited amount of time. Preemptible\ninstances can not be restarted and will not migrate.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--preemptible',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'PREEMPTIBLE'},
                                                                                                       u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"The region of the subnetwork to attach. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--region',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'REGION'},
                                                                                                       u'--restart-on-failure': {u'attr': {u'inverted_synopsis': True},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'The instances will be restarted if they are terminated by Compute Engine.\nThis does not affect terminations performed by the user. Enabled by default, use *--no-restart-on-failure* to disable.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--restart-on-failure',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'RESTART_ON_FAILURE'},
                                                                                                       u'--scopes': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'If not provided, the instance will be assigned the default scopes, described below.\n+\nSCOPE can be either the full URI of the scope or an alias. Available\naliases are:\n+\n  default\n    Scopes assigned to instances by default:\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n    - https://www.googleapis.com/auth/devstorage.read_only\n    - https://www.googleapis.com/auth/logging.write\n    - https://www.googleapis.com/auth/monitoring.write\n    - https://www.googleapis.com/auth/service.management.readonly\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  bigquery\n    - https://www.googleapis.com/auth/bigquery\n+\n  cloud-platform\n    - https://www.googleapis.com/auth/cloud-platform\n+\n  compute-ro\n    - https://www.googleapis.com/auth/compute.readonly\n+\n  compute-rw\n    - https://www.googleapis.com/auth/compute\n+\n  datastore\n    - https://www.googleapis.com/auth/datastore\n+\n  logging-write\n    - https://www.googleapis.com/auth/logging.write\n+\n  monitoring\n    - https://www.googleapis.com/auth/monitoring\n+\n  monitoring-write\n    - https://www.googleapis.com/auth/monitoring.write\n+\n  service-control\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  service-management\n    - https://www.googleapis.com/auth/service.management.readonly\n+\n  sql\n    - https://www.googleapis.com/auth/sqlservice\n+\n  sql-admin\n    - https://www.googleapis.com/auth/sqlservice.admin\n+\n  storage-full\n    - https://www.googleapis.com/auth/devstorage.full_control\n+\n  storage-ro\n    - https://www.googleapis.com/auth/devstorage.read_only\n+\n  storage-rw\n    - https://www.googleapis.com/auth/devstorage.read_write\n+\n  taskqueue\n    - https://www.googleapis.com/auth/taskqueue\n+\n  useraccounts-ro\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n+\n  useraccounts-rw\n    - https://www.googleapis.com/auth/cloud.useraccounts\n+\n  userinfo-email\n    - https://www.googleapis.com/auth/userinfo.email',
                                                                                                                     u'group': u'create.3',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--scopes',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'list',
                                                                                                                     u'value': u'SCOPE'},
                                                                                                       u'--service-account': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"A service account is an identity attached to the instance. Its access tokens\ncan be accessed through the instance metadata server and are used to\nauthenticate applications on the instance. The account can be either an email\naddress or an alias corresponding to a service account. You can explicitly\nspecify the Compute Engine default service account using the 'default' alias.\n+\nIf not provided, the instance will get project's default service account.",
                                                                                                                              u'group': u'create.4',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--service-account',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'SERVICE_ACCOUNT'},
                                                                                                       u'--subnet': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'Specifies the subnet that the instances will be part of. If --network is\nalso specified subnet must be a subnetwork of network specified by\n--network.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--subnet',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'SUBNET'},
                                                                                                       u'--tags': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Specifies a list of tags to apply to the instances for\nidentifying the instances to which network firewall rules will\napply. See gcloud_compute_firewall-rules_create(1) for more\ndetails.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--tags',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'list',
                                                                                                                   u'value': u'TAG'}},
                                                                                            u'group': False,
                                                                                            u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                                      u'is_mutex': True,
                                                                                                                      u'is_required': False},
                                                                                                        u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                                      u'is_mutex': True,
                                                                                                                      u'is_required': False},
                                                                                                        u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                                      u'is_mutex': True,
                                                                                                                      u'is_required': False},
                                                                                                        u'create.4': {u'description': u'At most one of these may be specified:',
                                                                                                                      u'is_mutex': True,
                                                                                                                      u'is_required': False}},
                                                                                            u'hidden': False,
                                                                                            u'name': u'create',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'instance-templates',
                                                                                                      u'create'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the instance template.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u"*create* facilitates the creation of Google Compute Engine\nvirtual machine instance templates. For example, running:\n\n    $ create INSTANCE-TEMPLATE\n\nwill create one instance templates called 'INSTANCE-TEMPLATE'.\n\nInstance templates are global resources, and can be used to create\ninstances in any zone."}},
                                                                                u'delete': {u'capsule': u'Delete Google Compute Engine virtual machine instance templates.',
                                                                                            u'commands': {},
                                                                                            u'flags': {},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'delete',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'instance-templates',
                                                                                                      u'delete'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The resources to delete.',
                                                                                                              u'name': u'names',
                                                                                                              u'nargs': u'+',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine virtual machine\ninstance templates.\n'}},
                                                                                u'describe': {u'capsule': u'Describe a virtual machine instance template.',
                                                                                              u'commands': {},
                                                                                              u'flags': {},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'describe',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'compute',
                                                                                                        u'instance-templates',
                                                                                                        u'describe'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The name of the resource to fetch.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine virtual machine instance template.\n'}},
                                                                                u'list': {u'capsule': u'List Google Compute Engine instance templates.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--filter',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                     u'--limit': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--limit',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'LIMIT'},
                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': True,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--no-uri',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'NO_URI'},
                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--page-size',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                     u'--regexp': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--regexp',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGEXP'},
                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--sort-by',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'list',
                                                                                                                    u'value': u'FIELD'},
                                                                                                     u'--uri': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--uri',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'URI'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'list',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'instance-templates',
                                                                                                    u'list'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': [],
                                                                                                            u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                            u'name': u'names',
                                                                                                            u'nargs': u'*',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine instance templates in a project.\n\nBy default, instance templates from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                        u'EXAMPLES': u"To list all instance templates in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all instance templates in a project, run:\n\n  $ list --uri\n\nTo list all instance templates in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                  u'flags': {},
                                                                  u'group': True,
                                                                  u'groups': {},
                                                                  u'hidden': False,
                                                                  u'name': u'instance-templates',
                                                                  u'path': [u'gcloud',
                                                                            u'compute',
                                                                            u'instance-templates'],
                                                                  u'positionals': [],
                                                                  u'release': u'GA',
                                                                  u'sections': {u'DESCRIPTION': u'Lists, creates, deletes, and modifies Compute Engine instance templates.\n\nMore information on Compute Engine instance templates can be found here:\n[](https://cloud.google.com/compute/docs/instance-templates)'}},
                                          u'instances': {u'capsule': u'Read and manipulate Google Compute Engine virtual machine instances.',
                                                         u'commands': {u'add-access-config': {u'capsule': u'Create a Google Compute Engine virtual machine access configuration.',
                                                                                              u'commands': {},
                                                                                              u'flags': {u'--access-config-name': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': u'external-nat',
                                                                                                                                   u'description': u"Specifies the name of the new access configuration. ``external-nat''\nis used as the default if this flag is not provided.",
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--access-config-name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'ACCESS_CONFIG_NAME'},
                                                                                                         u'--address': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Specifies the external IP address of the new access\nconfiguration. If this is not specified, then the service will\nchoose an available ephemeral IP address. If an explicit IP\naddress is given, then that IP address must be reserved by the\nproject and not be in use by another resource.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--address',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'ADDRESS'},
                                                                                                         u'--network-interface': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': u'nic0',
                                                                                                                                  u'description': u'Specifies the name of the network interface which contains the access\nconfiguration. If this is not provided, then "nic0" is used\nas the default.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--network-interface',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'NETWORK_INTERFACE'},
                                                                                                         u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--zone',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'ZONE'}},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'add-access-config',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'compute',
                                                                                                        u'instances',
                                                                                                        u'add-access-config'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The name of the instance.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'*add-access-config* is used to create access configurations for network\ninterfaces of Google Compute Engine virtual machines.\n'}},
                                                                       u'add-metadata': {u'capsule': u'Add or update instance metadata.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--metadata': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': {},
                                                                                                                    u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--metadata',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'dict',
                                                                                                                    u'value': u'KEY=VALUE'},
                                                                                                    u'--metadata-from-file': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': {},
                                                                                                                              u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--metadata-from-file',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'dict',
                                                                                                                              u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                                    u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u"The zone of the instance to set metadata on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--zone',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'ZONE'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'add-metadata',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'compute',
                                                                                                   u'instances',
                                                                                                   u'add-metadata'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The name of the instance whose metadata should be modified.',
                                                                                                           u'name': u'name',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'NAME'}],
                                                                                         u'release': u'GA',
                                                                                         u'sections': {u'DESCRIPTION': u'add-metadata can be used to add or update the metadata of a\nvirtual machine instance. Every instance has access to a\nmetadata server that can be used to query metadata that has\nbeen set through this tool. For information on metadata, see\n[](https://cloud.google.com/compute/docs/metadata)\n\nOnly metadata keys that are provided are mutated. Existing\nmetadata entries will remain unaffected.\n'}},
                                                                       u'add-tags': {u'capsule': u'Add tags to Google Compute Engine virtual machine instances.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--tags': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Specifies strings to be attached to the instance for later\nidentifying the instance when adding network firewall rules.\nMultiple tags can be attached by repeating this flag.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--tags',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': True,
                                                                                                            u'type': u'list',
                                                                                                            u'value': u'TAG'},
                                                                                                u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u"The zone of the instance to set tags on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--zone',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'ZONE'}},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'add-tags',
                                                                                     u'path': [u'gcloud',
                                                                                               u'compute',
                                                                                               u'instances',
                                                                                               u'add-tags'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of the instance whose tags should be modified.',
                                                                                                       u'name': u'name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u"*add-tags* is used to add tags to Google Compute Engine virtual\nmachine instances. For example, running:\n\n  $ add-tags example-instance --tags tag-1,tag-2\n\nwill add tags ``tag-1'' and ``tag-2'' to 'example-instance'.\n\nTags can be used to identify the instances when adding network\nfirewall rules. Tags can also be used to get firewall rules that\nalready exist to be applied to the instance. See\ngcloud_compute_firewall-rules_create(1) for more details.\n"}},
                                                                       u'attach-disk': {u'capsule': u'Attach a disk to an instance.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--csek-key-file',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'FILE'},
                                                                                                   u'--device-name': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'An optional name that indicates the disk name the guest operating system will see. (Note: Device name does not correspond to mounted volume name)',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--device-name',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'DEVICE_NAME'},
                                                                                                   u'--disk': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The name of the disk to attach to the instance.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--disk',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': True,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'DISK'},
                                                                                                   u'--mode': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [u'ro',
                                                                                                                            u'rw'],
                                                                                                               u'completer': u'',
                                                                                                               u'default': u'rw',
                                                                                                               u'description': u'Specifies the mode of the disk. _MODE_ must be one of:\n+\n*ro*::: Read-only.\n*rw*::: Read-write. It is an error to attach a disk in read-write mode to more than one instance.\n+',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--mode',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'MODE'},
                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--zone',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'ZONE'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'attach-disk',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'instances',
                                                                                                  u'attach-disk'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The name of the instance.',
                                                                                                          u'name': u'name',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u"*attach-disk* is used to attach a disk to an instance. For example,\n\n  $ gcloud compute instances attach-disk example-instance --disk DISK --zone us-central1-a\n\nattaches the disk named 'DISK' to the instance named\n'example-instance' in zone ``us-central1-a''.\n"}},
                                                                       u'create': {u'capsule': u'Create Google Compute Engine virtual machine instances.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--address': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Assigns the given external address to the instance that is created.\nThe address may be an IP address or the name or URI of an address\nresource. This option can only be used when creating a single instance.',
                                                                                                             u'group': u'create.1',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--address',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'ADDRESS'},
                                                                                              u'--boot-disk-auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': True,
                                                                                                                           u'description': u'Automatically delete boot disks when their instances are deleted. Enabled by default, use *--no-boot-disk-auto-delete* to disable.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--boot-disk-auto-delete',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'BOOT_DISK_AUTO_DELETE'},
                                                                                              u'--boot-disk-device-name': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The name the guest operating system will see for the boot disk as.  This\noption can only be specified if a new boot disk is being created (as\nopposed to mounting an existing persistent disk).',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--boot-disk-device-name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'BOOT_DISK_DEVICE_NAME'},
                                                                                              u'--boot-disk-size': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"The size of the boot disk. This option can only be specified if a new\nboot disk is being created (as opposed to mounting an existing\npersistent disk). The value must be a whole number followed by a size\nunit of ``KB'' for kilobyte, ``MB'' for megabyte, ``GB'' for gigabyte,\nor ``TB'' for terabyte. For example, ``10GB'' will produce a 10 gigabyte\ndisk. The minimum size a boot disk can have is 10 GB. Disk size must be a\nmultiple of 1 GB.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--boot-disk-size',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'BOOT_DISK_SIZE'},
                                                                                              u'--boot-disk-type': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The type of the boot disk. This option can only be specified if a new boot\ndisk is being created (as opposed to mounting an existing persistent\ndisk). To get a list of available disk types, run\n`$ gcloud compute disk-types list`.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--boot-disk-type',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'BOOT_DISK_TYPE'},
                                                                                              u'--can-ip-forward': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'If provided, allows the instances to send and receive packets with non-matching destination or source IP addresses.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--can-ip-forward',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'CAN_IP_FORWARD'},
                                                                                              u'--csek-key-file': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--csek-key-file',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'FILE'},
                                                                                              u'--custom-cpu': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--custom-cpu',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'CUSTOM_CPU'},
                                                                                              u'--custom-memory': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--custom-memory',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'CUSTOM_MEMORY'},
                                                                                              u'--description': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Specifies a textual description of the instances.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--description',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'DESCRIPTION'},
                                                                                              u'--disk': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"Attaches persistent disks to the instances. The disks\nspecified must already exist.\n+\n*name*::: The disk to attach to the instances. When creating\nmore than one instance and using this property, the only valid\nmode for attaching the disk is read-only (see *mode* below).\n+\n*mode*::: Specifies the mode of the disk. Supported options\nare ``ro'' for read-only and ``rw'' for read-write. If\nomitted, ``rw'' is used as a default. It is an error for mode\nto be ``rw'' when creating more than one instance because\nread-write disks can only be attached to a single instance.\n+\n*boot*::: If ``yes'', indicates that this is a boot disk. The\nvirtual machines will use the first partition of the disk for\ntheir root file systems. The default value for this is ``no''.\n+\n*device-name*::: An optional name that indicates the disk name\nthe guest operating system will see. If omitted, a device name\nof the form ``persistent-disk-N'' will be used.\n+\n*auto-delete*::: If ``yes'',  this persistent disk will be\nautomatically deleted when the instance is deleted. However,\nif the disk is later detached from the instance, this option\nwon't apply. The default value for this is ``no''.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--disk',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'dict',
                                                                                                          u'value': u'DISK'},
                                                                                              u'--image': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u"Specifies the boot image for the instances. For each\ninstance, a new boot disk will be created from the given\nimage. Each boot disk will have the same name as the\ninstance. To view a list of public images and projects, run\n`$ gcloud compute images list`.\n+\nWhen using this option, ``--boot-disk-device-name'' and\n``--boot-disk-size'' can be used to override the boot disk's\ndevice name and size, respectively.",
                                                                                                           u'group': u'create.2',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--image',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'IMAGE'},
                                                                                              u'--image-family': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"The family of the image that the boot disk will be initialized\nwith. When a family is specified instead of an image, the latest\nnon-deprecated image associated with that family is used.\n+\nBy default, ``debian-8'' is assumed for this flag.",
                                                                                                                  u'group': u'create.2',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--image-family',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'IMAGE_FAMILY'},
                                                                                              u'--image-project': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"The project against which all image and image family references will be\nresolved. See ``--image'' for more details.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--image-project',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'IMAGE_PROJECT'},
                                                                                              u'--local-ssd': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"Attaches a local SSD to the instances.\n+\nThis flag is currently in BETA and may change without notice.\n+\n*device-name*::: Optional. A name that indicates the disk name\nthe guest operating system will see.  If omitted, a device name\nof the form ``local-ssd-N'' will be used.\n+\n*interface*::: Optional. The kind of disk interface exposed to the VM\nfor this SSD.  Valid values are ``SCSI'' and ``NVME''.  SCSI is\nthe default and is supported by more guest operating systems.  NVME\nmay provide higher performance.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--local-ssd',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'dict',
                                                                                                               u'value': u'LOCAL_SSD'},
                                                                                              u'--machine-type': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--machine-type',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'MACHINE_TYPE'},
                                                                                              u'--maintenance-policy': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [u'MIGRATE',
                                                                                                                                     u'TERMINATE'],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--maintenance-policy',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'MAINTENANCE_POLICY'},
                                                                                              u'--metadata': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': {},
                                                                                                              u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--metadata',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'dict',
                                                                                                              u'value': u'KEY=VALUE'},
                                                                                              u'--metadata-from-file': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': {},
                                                                                                                        u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.",
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--metadata-from-file',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'dict',
                                                                                                                        u'value': u'KEY=LOCAL_FILE_PATH'},
                                                                                              u'--network': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Specifies the network that the instances will be part of. If --subnet is\nalso specified subnet must be a subnetwork of network specified by\n--network. If neither is specified, this defaults to the "default"\nnetwork.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--network',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'NETWORK'},
                                                                                              u'--no-address': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'If provided, the instances will not be assigned external IP addresses.',
                                                                                                                u'group': u'create.1',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--no-address',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_ADDRESS'},
                                                                                              u'--no-boot-disk-auto-delete': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-boot-disk-auto-delete',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_BOOT_DISK_AUTO_DELETE'},
                                                                                              u'--no-can-ip-forward': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': True,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-can-ip-forward',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_CAN_IP_FORWARD'},
                                                                                              u'--no-preemptible': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-preemptible',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_PREEMPTIBLE'},
                                                                                              u'--no-require-csek-key-create': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-require-csek-key-create',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_REQUIRE_CSEK_KEY_CREATE'},
                                                                                              u'--no-restart-on-failure': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': True,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-restart-on-failure',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                              u'--no-scopes': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'Create instance without scopes',
                                                                                                               u'group': u'create.3',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--no-scopes',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_SCOPES'},
                                                                                              u'--no-service-account': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'Create instance without service account',
                                                                                                                        u'group': u'create.4',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--no-service-account',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'NO_SERVICE_ACCOUNT'},
                                                                                              u'--preemptible': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'If provided, instances will be preemptible and time-limited.\nInstances may be preempted to free up resources for standard VM instances,\nand will only be able to run for a limited amount of time. Preemptible\ninstances can not be restarted and will not migrate.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--preemptible',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'PREEMPTIBLE'},
                                                                                              u'--private-network-ip': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Specifies the RFC1918 IP to assign to the instance. The IP should be in\nthe subnet or legacy network IP range.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--private-network-ip',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'PRIVATE_NETWORK_IP'},
                                                                                              u'--require-csek-key-create': {u'attr': {u'inverted_synopsis': True},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': True,
                                                                                                                             u'description': u'Refuse to create resources not protected by a user managed key in\nthe key file when --csek-key-file is given. This behavior is enabled\nby default to prevent incorrect gcloud invocations from accidentally\ncreating resources with no user managed key. Disabling the check\nallows creation of some resources without a matching\nCustomer-Supplied Encryption Key in the supplied --csek-key-file.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details. Enabled by default, use *--no-require-csek-key-create* to disable.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--require-csek-key-create',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'REQUIRE_CSEK_KEY_CREATE'},
                                                                                              u'--restart-on-failure': {u'attr': {u'inverted_synopsis': True},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': True,
                                                                                                                        u'description': u'The instances will be restarted if they are terminated by Compute Engine.\nThis does not affect terminations performed by the user. Enabled by default, use *--no-restart-on-failure* to disable.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--restart-on-failure',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'RESTART_ON_FAILURE'},
                                                                                              u'--scopes': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'If not provided, the instance will be assigned the default scopes, described below.\n+\nSCOPE can be either the full URI of the scope or an alias. Available\naliases are:\n+\n  default\n    Scopes assigned to instances by default:\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n    - https://www.googleapis.com/auth/devstorage.read_only\n    - https://www.googleapis.com/auth/logging.write\n    - https://www.googleapis.com/auth/monitoring.write\n    - https://www.googleapis.com/auth/service.management.readonly\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  bigquery\n    - https://www.googleapis.com/auth/bigquery\n+\n  cloud-platform\n    - https://www.googleapis.com/auth/cloud-platform\n+\n  compute-ro\n    - https://www.googleapis.com/auth/compute.readonly\n+\n  compute-rw\n    - https://www.googleapis.com/auth/compute\n+\n  datastore\n    - https://www.googleapis.com/auth/datastore\n+\n  logging-write\n    - https://www.googleapis.com/auth/logging.write\n+\n  monitoring\n    - https://www.googleapis.com/auth/monitoring\n+\n  monitoring-write\n    - https://www.googleapis.com/auth/monitoring.write\n+\n  service-control\n    - https://www.googleapis.com/auth/servicecontrol\n+\n  service-management\n    - https://www.googleapis.com/auth/service.management.readonly\n+\n  sql\n    - https://www.googleapis.com/auth/sqlservice\n+\n  sql-admin\n    - https://www.googleapis.com/auth/sqlservice.admin\n+\n  storage-full\n    - https://www.googleapis.com/auth/devstorage.full_control\n+\n  storage-ro\n    - https://www.googleapis.com/auth/devstorage.read_only\n+\n  storage-rw\n    - https://www.googleapis.com/auth/devstorage.read_write\n+\n  taskqueue\n    - https://www.googleapis.com/auth/taskqueue\n+\n  useraccounts-ro\n    - https://www.googleapis.com/auth/cloud.useraccounts.readonly\n+\n  useraccounts-rw\n    - https://www.googleapis.com/auth/cloud.useraccounts\n+\n  userinfo-email\n    - https://www.googleapis.com/auth/userinfo.email',
                                                                                                            u'group': u'create.3',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--scopes',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'list',
                                                                                                            u'value': u'SCOPE'},
                                                                                              u'--service-account': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"A service account is an identity attached to the instance. Its access tokens\ncan be accessed through the instance metadata server and are used to\nauthenticate applications on the instance. The account can be either an email\naddress or an alias corresponding to a service account. You can explicitly\nspecify the Compute Engine default service account using the 'default' alias.\n+\nIf not provided, the instance will get project's default service account.",
                                                                                                                     u'group': u'create.4',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--service-account',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'SERVICE_ACCOUNT'},
                                                                                              u'--subnet': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Specifies the subnet that the instances will be part of. If --network is\nalso specified subnet must be a subnetwork of network specified by\n--network.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--subnet',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'SUBNET'},
                                                                                              u'--tags': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Specifies a list of tags to apply to the instances for\nidentifying the instances to which network firewall rules will\napply. See gcloud_compute_firewall-rules_create(1) for more\ndetails.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--tags',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'list',
                                                                                                          u'value': u'TAG'},
                                                                                              u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--zone',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'ZONE'}},
                                                                                   u'group': False,
                                                                                   u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                             u'is_mutex': True,
                                                                                                             u'is_required': False},
                                                                                               u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                             u'is_mutex': True,
                                                                                                             u'is_required': False},
                                                                                               u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                             u'is_mutex': True,
                                                                                                             u'is_required': False},
                                                                                               u'create.4': {u'description': u'At most one of these may be specified:',
                                                                                                             u'is_mutex': True,
                                                                                                             u'is_required': False}},
                                                                                   u'hidden': False,
                                                                                   u'name': u'create',
                                                                                   u'path': [u'gcloud',
                                                                                             u'compute',
                                                                                             u'instances',
                                                                                             u'create'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The names of the instances.',
                                                                                                     u'name': u'names',
                                                                                                     u'nargs': u'+',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAMES'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'*create* facilitates the creation of Google Compute Engine\nvirtual machines. For example, running:\n\n  $ create example-instance-1 example-instance-2 example-instance-3 --zone us-central1-a\n\nwill create three instances called `example-instance-1`,\n`example-instance-2`, and `example-instance-3` in the\n`us-central1-a` zone.\n\nWhen an instance is in RUNNING state and the system begins to boot,\nthe instance creation is considered finished, and the command returns\nwith a list of new virtual machines.  Note that you usually cannot log\ninto a new instance until it finishes booting. Check the progress of an\ninstance using `gcloud compute instances get-serial-port-output`.\n\nFor more examples, refer to the *EXAMPLES* section below.\n',
                                                                                                 u'EXAMPLES': u"To create an instance with the latest ``Red Hat Enterprise Linux\n7'' image available, run:\n\n  $ create example-instance --image-family rhel-7 --image-project rhel-cloud --zone us-central1-a\n"}},
                                                                       u'delete': {u'capsule': u'Delete Google Compute Engine virtual machine instances.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--delete-disks': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [u'all',
                                                                                                                               u'boot',
                                                                                                                               u'data'],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"The types of disks to delete with instance deletion regardless\nof the disks' auto-delete configuration. When this flag is\nprovided, the auto-delete bits on the attached disks are\nmodified accordingly before the instance deletion requests are\nissued. For more information on disk auto-deletion, see\n[](https://cloud.google.com/compute/docs/disks/persistent-disks#updateautodelete). _DISK-TYPE_ must be one of:\n+\n*all*::: All disk types.\n*boot*::: The first partition is reserved for the root filesystem.\n*data*::: A non-boot disk.\n+",
                                                                                                                  u'group': u'delete.1',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--delete-disks',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'DISK-TYPE'},
                                                                                              u'--keep-disks': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [u'all',
                                                                                                                             u'boot',
                                                                                                                             u'data'],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u"The types of disks to not delete with instance deletion regardless\nof the disks' auto-delete configuration. When this flag is\nprovided, the auto-delete bits on the attached disks are\nmodified accordingly before the instance deletion requests are\nissued. For more information on disk auto-deletion, see\n[](https://cloud.google.com/compute/docs/disks/persistent-disks#updateautodelete). _DISK-TYPE_ must be one of:\n+\n*all*::: All disk types.\n*boot*::: The first partition is reserved for the root filesystem.\n*data*::: A non-boot disk.\n+",
                                                                                                                u'group': u'delete.1',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--keep-disks',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'DISK-TYPE'},
                                                                                              u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--zone',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'ZONE'}},
                                                                                   u'group': False,
                                                                                   u'groups': {u'delete.1': {u'description': u'At most one of these may be specified:',
                                                                                                             u'is_mutex': True,
                                                                                                             u'is_required': False}},
                                                                                   u'hidden': False,
                                                                                   u'name': u'delete',
                                                                                   u'path': [u'gcloud',
                                                                                             u'compute',
                                                                                             u'instances',
                                                                                             u'delete'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The names of the instances.',
                                                                                                     u'name': u'names',
                                                                                                     u'nargs': u'+',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAMES'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine virtual machine\ninstances.\n'}},
                                                                       u'delete-access-config': {u'capsule': u'Delete an access configuration from a virtual machine network interface.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {u'--access-config-name': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': u'external-nat',
                                                                                                                                      u'description': u"Specifies the name of the access configuration to delete.\n``external-nat'' is used as the default if this flag is not provided.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--access-config-name',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ACCESS_CONFIG_NAME'},
                                                                                                            u'--network-interface': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': u'nic0',
                                                                                                                                     u'description': u"Specifies the name of the network interface from which to delete the\naccess configuration. If this is not provided, then ``nic0'' is used\nas the default.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--network-interface',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'NETWORK_INTERFACE'},
                                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--zone',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'ZONE'}},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'delete-access-config',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'compute',
                                                                                                           u'instances',
                                                                                                           u'delete-access-config'],
                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The name of the instance.',
                                                                                                                   u'name': u'name',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'NAME'}],
                                                                                                 u'release': u'GA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*delete-access-config* is used to delete access configurations from network\ninterfaces of Google Compute Engine virtual machines.'}},
                                                                       u'describe': {u'capsule': u'Describe a virtual machine instance.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--zone',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'ZONE'}},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'describe',
                                                                                     u'path': [u'gcloud',
                                                                                               u'compute',
                                                                                               u'instances',
                                                                                               u'describe'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of the resource to fetch.',
                                                                                                       u'name': u'name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine virtual machine instance.\n'}},
                                                                       u'detach-disk': {u'capsule': u'Detach disks from Compute Engine virtual machine instances.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--device-name': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"Specifies a disk to detach by its device name, which is the name\nthat the guest operating system sees. The device name is set\nat the time that the disk is attached to the instance, and needs not be\nthe same as the persistent disk name. If the disk's device name is\nspecified, then its persistent disk name must not be specified\nusing the ``--disk'' flag.",
                                                                                                                      u'group': u'detach-disk.1',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--device-name',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'DEVICE_NAME'},
                                                                                                   u'--disk': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"Specifies a disk to detach by its resource name. If you specify a\ndisk to remove by persistent disk name, then you must not specify its\ndevice name using the ``--device-name'' flag.",
                                                                                                               u'group': u'detach-disk.1',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--disk',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'DISK'},
                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--zone',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'ZONE'}},
                                                                                        u'group': False,
                                                                                        u'groups': {u'detach-disk.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                       u'is_mutex': True,
                                                                                                                       u'is_required': True}},
                                                                                        u'hidden': False,
                                                                                        u'name': u'detach-disk',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'instances',
                                                                                                  u'detach-disk'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The name of the instance.',
                                                                                                          u'name': u'name',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'*detach-disk* is used to detach disks from virtual machines.\n\nDetaching a disk without first unmounting it may result in\nincomplete I/O operations and data corruption.\nTo unmount a persistent disk on a Linux-based image,\nssh into the instance and run:\n\n    $ sudo umount /dev/disk/by-id/google-DEVICE_NAME'}},
                                                                       u'get-serial-port-output': {u'capsule': u"Read output from a virtual machine instance's serial port.",
                                                                                                   u'commands': {},
                                                                                                   u'flags': {u'--port': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Instances can support up to four serial port outputs, numbered 1 through\n4. By default, this command will return the output of the first serial\nport. Setting this flag will return the output of the requested serial\nport.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--port',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'PORT'},
                                                                                                              u'--start': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Specifies the byte index (zero-based) of the first byte you want\nreturned.  Use this flag if you want to continue getting the output from\na previous request that was too long to return in one attempt.  The last\nbyte returned in a request will be reported on STDERR.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--start',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'START'},
                                                                                                              u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--zone',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'ZONE'}},
                                                                                                   u'group': False,
                                                                                                   u'groups': {},
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'get-serial-port-output',
                                                                                                   u'path': [u'gcloud',
                                                                                                             u'compute',
                                                                                                             u'instances',
                                                                                                             u'get-serial-port-output'],
                                                                                                   u'positionals': [{u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The name of the instance.',
                                                                                                                     u'name': u'name',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'value': u'NAME'}],
                                                                                                   u'release': u'GA',
                                                                                                   u'sections': {u'DESCRIPTION': u"get-serial-port-output is used to get the output from a Google Compute\nEngine virtual machine's serial port. The serial port output\nfrom the virtual machine will be printed to standard output. This\ninformation can be useful for diagnostic purposes.\n"}},
                                                                       u'list': {u'capsule': u'List Google Compute Engine instances.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--filter',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'EXPRESSION'},
                                                                                            u'--limit': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--limit',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'LIMIT'},
                                                                                            u'--no-uri': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-uri',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_URI'},
                                                                                            u'--page-size': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--page-size',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                            u'--regexp': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--regexp',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'REGEXP'},
                                                                                            u'--sort-by': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--sort-by',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'list',
                                                                                                           u'value': u'FIELD'},
                                                                                            u'--uri': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--uri',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'URI'},
                                                                                            u'--zones': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': [],
                                                                                                         u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--zones',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'list',
                                                                                                         u'value': u'ZONE'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'list',
                                                                                 u'path': [u'gcloud',
                                                                                           u'compute',
                                                                                           u'instances',
                                                                                           u'list'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': [],
                                                                                                   u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                   u'name': u'names',
                                                                                                   u'nargs': u'*',
                                                                                                   u'required': False,
                                                                                                   u'value': u'NAME'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine instances in a project.\n\nBy default, instances from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                               u'EXAMPLES': u"To list all instances in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all instances in a project, run:\n\n  $ list --uri\n\nTo list all instances in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}},
                                                                       u'move': {u'capsule': u'Move an instance between zones.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--async': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': False,
                                                                                                         u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--async',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'ASYNC'},
                                                                                            u'--destination-zone': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The zone to move the instance to.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--destination-zone',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': True,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'DESTINATION_ZONE'},
                                                                                            u'--no-async': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': True,
                                                                                                            u'description': u'',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': True,
                                                                                                            u'name': u'--no-async',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'NO_ASYNC'},
                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--zone',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'ZONE'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'move',
                                                                                 u'path': [u'gcloud',
                                                                                           u'compute',
                                                                                           u'instances',
                                                                                           u'move'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The name of the instance.',
                                                                                                   u'name': u'name',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'NAME'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'*move* facilitates moving a Google Compute Engine virtual machine\nfrom one zone to another. Moving a virtual machine may incur downtime\nif the guest OS must be shutdown in order to quiesce disk volumes\nprior to snapshotting.\n\nFor example, running:\n\n   $ gcloud compute instances move example-instance-1 --zone us-central1-b --destination-zone us-central1-f\n\nwill move the instance called example-instance-1, currently running in\nus-central1-b, to us-central1-f.\n'}},
                                                                       u'remove-metadata': {u'capsule': u'Remove instance metadata.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--all': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'If provided, all metadata entries are removed.',
                                                                                                                  u'group': u'remove-metadata.1',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--all',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'ALL'},
                                                                                                       u'--keys': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The keys of the entries to remove.',
                                                                                                                   u'group': u'remove-metadata.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--keys',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'list',
                                                                                                                   u'value': u'KEY'},
                                                                                                       u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"The zone of the instance to set metadata on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--zone',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'ZONE'}},
                                                                                            u'group': False,
                                                                                            u'groups': {u'remove-metadata.1': {u'description': u'At most one of these may be specified:',
                                                                                                                               u'is_mutex': True,
                                                                                                                               u'is_required': False}},
                                                                                            u'hidden': False,
                                                                                            u'name': u'remove-metadata',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'instances',
                                                                                                      u'remove-metadata'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the instance whose metadata should be modified.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'remove-metadata can be used to remove instance metadata entries.\n'}},
                                                                       u'remove-tags': {u'capsule': u'Remove tags from Google Compute Engine virtual machine instances.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--all': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'Remove all tags from the instance.',
                                                                                                              u'group': u'remove-tags.1',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--all',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'ALL'},
                                                                                                   u'--tags': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Specifies strings to be removed from the instance tags.\nMultiple tags can be removed by repeating this flag.',
                                                                                                               u'group': u'remove-tags.1',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--tags',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'list',
                                                                                                               u'value': u'TAG'},
                                                                                                   u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"The zone of the instance to set tags on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--zone',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'ZONE'}},
                                                                                        u'group': False,
                                                                                        u'groups': {u'remove-tags.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                       u'is_mutex': True,
                                                                                                                       u'is_required': True}},
                                                                                        u'hidden': False,
                                                                                        u'name': u'remove-tags',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'instances',
                                                                                                  u'remove-tags'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The name of the instance whose tags should be modified.',
                                                                                                          u'name': u'name',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u"*remove-tags* is used to remove tags to Google Compute Engine virtual\nmachine instances.  For example:\n\n  $ remove-tags example-instance --tags tag-1,tag-2\n\nwill remove tags ``tag-1'' and ``tag-2'' from the existing tags of\n'example-instance'.\n\nTags can be used to identify instances when adding network\nfirewall rules. Tags can also be used to get firewall rules that already\nexist to be applied to the instance. See\ngcloud_compute_firewall-rules_create(1) for more details.\n"}},
                                                                       u'reset': {u'capsule': u'Reset a virtual machine instance.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--zone',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'ZONE'}},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'reset',
                                                                                  u'path': [u'gcloud',
                                                                                            u'compute',
                                                                                            u'instances',
                                                                                            u'reset'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The names of the instances.',
                                                                                                    u'name': u'names',
                                                                                                    u'nargs': u'+',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAMES'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'*reset* is used to perform a hard reset on a Google\nCompute Engine virtual machine.\n'}},
                                                                       u'set-disk-auto-delete': {u'capsule': u'Set auto-delete behavior for disks.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {u'--auto-delete': {u'attr': {u'inverted_synopsis': True},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'Enables auto-delete for the given disk. Enabled by default, use *--no-auto-delete* to disable.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--auto-delete',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'AUTO_DELETE'},
                                                                                                            u'--device-name': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u"Specifies a disk to set auto-delete for by its device name,\nwhich is the name that the guest operating system sees. The\ndevice name is set at the time that the disk is attached to the\ninstance, and need not be the same as the persistent disk name.\nIf the disk's device name is specified, then its persistent disk\nname must not be specified using the ``--disk'' flag.",
                                                                                                                               u'group': u'set-disk-auto-delete.1',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--device-name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'DEVICE_NAME'},
                                                                                                            u'--disk': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u"Specifies a disk to set auto-delete for by its resource name. If\nyou specify a disk to set auto-delete for by persistent disk name,\nthen you must not specify its device name using the\n``--device-name'' flag.",
                                                                                                                        u'group': u'set-disk-auto-delete.1',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--disk',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'DISK'},
                                                                                                            u'--no-auto-delete': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-auto-delete',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_AUTO_DELETE'},
                                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--zone',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'ZONE'}},
                                                                                                 u'group': False,
                                                                                                 u'groups': {u'set-disk-auto-delete.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                         u'is_mutex': True,
                                                                                                                                         u'is_required': True}},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'set-disk-auto-delete',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'compute',
                                                                                                           u'instances',
                                                                                                           u'set-disk-auto-delete'],
                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The name of the instance.',
                                                                                                                   u'name': u'name',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'NAME'}],
                                                                                                 u'release': u'GA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*$set-disk-auto-delete* is used to configure the auto-delete behavior for disks\nattached to Google Compute Engine virtual machines. When\nauto-delete is on, the persistent disk is deleted when the\ninstance it is attached to is deleted.\n'}},
                                                                       u'set-machine-type': {u'capsule': u'Set machine type for Google Compute Engine virtual machines.',
                                                                                             u'commands': {},
                                                                                             u'flags': {u'--custom-cpu': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'A whole number value indicating how many cores are desired in the custom\nmachine type. Both --custom-cpu and --custom-memory must be specified if\na custom machine type is desired, and the --machine-type flag must be\nomitted.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--custom-cpu',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'CUSTOM_CPU'},
                                                                                                        u'--custom-memory': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'A whole number value indicating how much memory is desired in the custom\nmachine type. A size unit should be provided (eg. 3072MiB or 9GiB) - if\nno units are specified, GiB is assumed. Both --custom-cpu and\n--custom-memory must be specified if a custom machine type is desired,\nand the --machine-type flag must be omitted.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--custom-memory',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'CUSTOM_MEMORY'},
                                                                                                        u'--machine-type': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u"Specifies the machine type used for the instances. To get a\nlist of available machine types, run 'gcloud compute\nmachine-types list'. If unspecified, the default type is n1-standard-1.",
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--machine-type',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'MACHINE_TYPE'},
                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--zone',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'ZONE'}},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'set-machine-type',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'compute',
                                                                                                       u'instances',
                                                                                                       u'set-machine-type'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The name of the instance.',
                                                                                                               u'name': u'name',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u"``set-machine-type'' allows you to change the machine type of a virtual machine\nin the *TERMINATED* state (that is, a virtual machine instance that\nhas been stopped).\n\nFor example, if ``example-instance'' is a ``g1-small'' virtual machine\ncurrently in the *TERMINATED* state, running:\n\n  $ set-machine-type example-instance --zone us-central1-b --machine-type n1-standard-4\n\nwill change the machine type to ``n1-standard-4'', so that when you\nnext start ``example-instance'', it will be provisioned as an\n``n1-standard-4'' instead of a ``g1-small''.\n\nSee [](https://cloud.google.com/compute/docs/machine-types) for more\ninformation on machine types.\n"}},
                                                                       u'set-scheduling': {u'capsule': u'Set scheduling options for Google Compute Engine virtual machines.',
                                                                                           u'commands': {},
                                                                                           u'flags': {u'--maintenance-policy': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [u'MIGRATE',
                                                                                                                                             u'TERMINATE'],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'Specifies the behavior of the instances when their host machines undergo maintenance. The default is MIGRATE. _MAINTENANCE_POLICY_ must be one of:\n+\n*MIGRATE*::: The instances should be migrated to a new host. This will temporarily impact the performance of instances during a migration event.\n*TERMINATE*::: The instances should be terminated.\n+',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--maintenance-policy',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'MAINTENANCE_POLICY'},
                                                                                                      u'--no-restart-on-failure': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-restart-on-failure',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_RESTART_ON_FAILURE'},
                                                                                                      u'--restart-on-failure': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'The instances will be restarted if they are terminated by Compute\nEngine.  This does not affect terminations performed by the user.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--restart-on-failure',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'RESTART_ON_FAILURE'},
                                                                                                      u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--zone',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'ZONE'}},
                                                                                           u'group': False,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'set-scheduling',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'compute',
                                                                                                     u'instances',
                                                                                                     u'set-scheduling'],
                                                                                           u'positionals': [{u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The name of the instance.',
                                                                                                             u'name': u'name',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'value': u'NAME'}],
                                                                                           u'release': u'GA',
                                                                                           u'sections': {u'DESCRIPTION': u'*$set-scheduling* is used to configure scheduling options for Google Compute\nEngine virtual machines.\n'}},
                                                                       u'start': {u'capsule': u'Start a stopped virtual machine instance.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--csek-key-file': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Path to a Customer-Supplied Encryption Key (CSEK) key file, mapping\nGoogle Compute Engine resources to user managed keys to be used when\ncreating, mounting, or snapshotting disks.\nSee https://cloud.google.com/compute/docs/disks/customer-supplied-encryption for more details.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--csek-key-file',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'FILE'},
                                                                                             u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--zone',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'ZONE'}},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'start',
                                                                                  u'path': [u'gcloud',
                                                                                            u'compute',
                                                                                            u'instances',
                                                                                            u'start'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The names of the instances.',
                                                                                                    u'name': u'names',
                                                                                                    u'nargs': u'+',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAMES'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'Start a stopped virtual machine instance.\n\n*start* is used to start a stopped Google Compute Engine virtual\nmachine. Only a stopped virtual machine can be started.\n'}},
                                                                       u'stop': {u'capsule': u'Stop a virtual machine instance.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--discard-local-ssd': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': False,
                                                                                                                     u'description': u'If provided, local SSD data is discarded.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--discard-local-ssd',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'DISCARD_LOCAL_SSD'},
                                                                                            u'--no-discard-local-ssd': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': True,
                                                                                                                        u'description': u'',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': True,
                                                                                                                        u'name': u'--no-discard-local-ssd',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'NO_DISCARD_LOCAL_SSD'},
                                                                                            u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--zone',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'ZONE'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'stop',
                                                                                 u'path': [u'gcloud',
                                                                                           u'compute',
                                                                                           u'instances',
                                                                                           u'stop'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The names of the instances.',
                                                                                                   u'name': u'names',
                                                                                                   u'nargs': u'+',
                                                                                                   u'required': False,
                                                                                                   u'value': u'NAMES'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'*stop* is used stop a Google Compute Engine virtual machine.\nStopping a VM performs a clean shutdown, much like invoking the shutdown\nfunctionality of a workstation or laptop. Stopping a VM with a local SSD\nis not supported and will result in an API error.\n'}},
                                                                       u'tail-serial-port-output': {u'capsule': u"Periodically fetch new output from a virtual machine instance's     serial port and display it as it becomes available.",
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--port': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Instances can support up to four serial port outputs, numbered 1 through\n4. By default, this command will return the output of the first serial\nport. Setting this flag will return the output of the requested serial\nport.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--port',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'PORT'},
                                                                                                               u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--zone',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'ZONE'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'tail-serial-port-output',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'compute',
                                                                                                              u'instances',
                                                                                                              u'tail-serial-port-output'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The name of the instance.',
                                                                                                                      u'name': u'name',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'NAME'}],
                                                                                                    u'release': u'GA',
                                                                                                    u'sections': {u'DESCRIPTION': u"tail-serial-port-output is used to tail the output from a Google Compute\nEngine virtual machine instance's serial port. The serial port output\nfrom the instance will be printed to standard output. This\ninformation can be useful for diagnostic purposes.\n"}}},
                                                         u'flags': {},
                                                         u'group': True,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'instances',
                                                         u'path': [u'gcloud',
                                                                   u'compute',
                                                                   u'instances'],
                                                         u'positionals': [],
                                                         u'release': u'GA',
                                                         u'sections': {u'DESCRIPTION': u'Read and manipulate Google Compute Engine virtual machine instances.'}},
                                          u'machine-types': {u'capsule': u'Read Google Compute Engine virtual machine types.',
                                                             u'commands': {u'describe': {u'capsule': u'Describe a Google Compute Engine machine type.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--zone',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'ZONE'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'describe',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'compute',
                                                                                                   u'machine-types',
                                                                                                   u'describe'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The name of the resource to fetch.',
                                                                                                           u'name': u'name',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'NAME'}],
                                                                                         u'release': u'GA',
                                                                                         u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine machine type.\n'}},
                                                                           u'list': {u'capsule': u'List Google Compute Engine machine types.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--filter',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'EXPRESSION'},
                                                                                                u'--limit': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--limit',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'LIMIT'},
                                                                                                u'--no-uri': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-uri',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_URI'},
                                                                                                u'--page-size': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--page-size',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'PAGE_SIZE'},
                                                                                                u'--regexp': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--regexp',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'REGEXP'},
                                                                                                u'--sort-by': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--sort-by',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'list',
                                                                                                               u'value': u'FIELD'},
                                                                                                u'--uri': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--uri',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'URI'},
                                                                                                u'--zones': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': [],
                                                                                                             u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--zones',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'list',
                                                                                                             u'value': u'ZONE'}},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'list',
                                                                                     u'path': [u'gcloud',
                                                                                               u'compute',
                                                                                               u'machine-types',
                                                                                               u'list'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': [],
                                                                                                       u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                       u'name': u'names',
                                                                                                       u'nargs': u'*',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine machine types in a project.\n\nBy default, machine types from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                   u'EXAMPLES': u"To list all machine types in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all machine types in a project, run:\n\n  $ list --uri\n\nTo list all machine types in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                             u'flags': {},
                                                             u'group': True,
                                                             u'groups': {},
                                                             u'hidden': False,
                                                             u'name': u'machine-types',
                                                             u'path': [u'gcloud',
                                                                       u'compute',
                                                                       u'machine-types'],
                                                             u'positionals': [],
                                                             u'release': u'GA',
                                                             u'sections': {u'DESCRIPTION': u'Read Google Compute Engine virtual machine types.'}},
                                          u'networks': {u'capsule': u'List, create, and delete Google Compute Engine networks.',
                                                        u'commands': {u'create': {u'capsule': u'Create a Google Compute Engine network.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--description': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'An optional, textual description for the network.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--description',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'DESCRIPTION'},
                                                                                             u'--mode': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [u'auto',
                                                                                                                      u'custom',
                                                                                                                      u'legacy'],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The network type. _NETWORK_TYPE_ must be one of:\n+\n*auto*::: Subnets are created automatically. This is the recommended selection.\n*custom*::: Create subnets manually.\n*legacy*::: Create an old style network that has a range and cannot have subnets.\n+',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--mode',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'NETWORK_TYPE'},
                                                                                             u'--range': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Specifies the IPv4 address range of legacy mode networks. The range\nmust be specified in CIDR format:\n[](http://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing)\n+\nThis flag only works if mode is legacy.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--range',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'RANGE'}},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'create',
                                                                                  u'path': [u'gcloud',
                                                                                            u'compute',
                                                                                            u'networks',
                                                                                            u'create'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The name of the network.',
                                                                                                    u'name': u'name',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAME'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'*create* is used to create virtual networks. A network\nperforms the same function that a router does in a home\nnetwork: it describes the network range and gateway IP\naddress, handles communication between instances, and serves\nas a gateway between instances and callers outside the\nnetwork.'}},
                                                                      u'delete': {u'capsule': u'Delete Google Compute Engine networks.',
                                                                                  u'commands': {},
                                                                                  u'flags': {},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'delete',
                                                                                  u'path': [u'gcloud',
                                                                                            u'compute',
                                                                                            u'networks',
                                                                                            u'delete'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The resources to delete.',
                                                                                                    u'name': u'names',
                                                                                                    u'nargs': u'+',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAME'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nnetworks. Networks can only be deleted when no other resources\n(e.g., virtual machine instances) refer to them.\n'}},
                                                                      u'describe': {u'capsule': u'Describe a Google Compute Engine network.',
                                                                                    u'commands': {},
                                                                                    u'flags': {},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'describe',
                                                                                    u'path': [u'gcloud',
                                                                                              u'compute',
                                                                                              u'networks',
                                                                                              u'describe'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The name of the resource to fetch.',
                                                                                                      u'name': u'name',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'value': u'NAME'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with Google Compute\nEngine network in a project.\n'}},
                                                                      u'list': {u'capsule': u'List Google Compute Engine networks.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--filter',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'EXPRESSION'},
                                                                                           u'--limit': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--limit',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'LIMIT'},
                                                                                           u'--no-uri': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': True,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--no-uri',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'NO_URI'},
                                                                                           u'--page-size': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--page-size',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                           u'--regexp': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--regexp',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'REGEXP'},
                                                                                           u'--sort-by': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--sort-by',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'list',
                                                                                                          u'value': u'FIELD'},
                                                                                           u'--uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': False,
                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'URI'}},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'list',
                                                                                u'path': [u'gcloud',
                                                                                          u'compute',
                                                                                          u'networks',
                                                                                          u'list'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': [],
                                                                                                  u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                  u'name': u'names',
                                                                                                  u'nargs': u'*',
                                                                                                  u'required': False,
                                                                                                  u'value': u'NAME'}],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine networks in a project.\n',
                                                                                              u'EXAMPLES': u'To list all networks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all networks in a project, run:\n\n  $ list --uri\n'}},
                                                                      u'subnets': {u'capsule': u'List, describe, and delete Google Compute Engine subnetworks.',
                                                                                   u'commands': {u'create': {u'capsule': u'Define a subnet for a network in custom subnet mode.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--description': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u'An optional description of this subnetwork.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--description',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'string',
                                                                                                                                           u'value': u'DESCRIPTION'},
                                                                                                                        u'--network': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'The network to which the subnetwork belongs.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--network',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'NETWORK'},
                                                                                                                        u'--range': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'The IP space allocated to this subnetwork in CIDR format.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--range',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': True,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'RANGE'},
                                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The region of the subnetwork to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--region',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REGION'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'create',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'compute',
                                                                                                                       u'networks',
                                                                                                                       u'subnets',
                                                                                                                       u'create'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The name of the subnetwork.',
                                                                                                                               u'name': u'name',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'GA',
                                                                                                             u'sections': {u'DESCRIPTION': u'Define a subnet for a network in custom subnet mode.'}},
                                                                                                 u'delete': {u'capsule': u'Delete Google Compute Engine subnetworks.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--region',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'REGION'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'delete',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'compute',
                                                                                                                       u'networks',
                                                                                                                       u'subnets',
                                                                                                                       u'delete'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The resources to delete.',
                                                                                                                               u'name': u'names',
                                                                                                                               u'nargs': u'+',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'NAME'}],
                                                                                                             u'release': u'GA',
                                                                                                             u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nsubnetworks. Subnetworks can only be deleted when no other resources\n(e.g., virtual machine instances) refer to them.\n'}},
                                                                                                 u'describe': {u'capsule': u'Describe a Google Compute Engine subnetwork.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--region',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'REGION'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'describe',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'compute',
                                                                                                                         u'networks',
                                                                                                                         u'subnets',
                                                                                                                         u'describe'],
                                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The name of the resource to fetch.',
                                                                                                                                 u'name': u'name',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'value': u'NAME'}],
                                                                                                               u'release': u'GA',
                                                                                                               u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine subnetwork.'}},
                                                                                                 u'expand-ip-range': {u'capsule': u'Expand the IP range of a Google Compute Engine subnetwork.',
                                                                                                                      u'commands': {},
                                                                                                                      u'flags': {u'--prefix-length': {u'attr': {},
                                                                                                                                                      u'category': u'',
                                                                                                                                                      u'choices': [],
                                                                                                                                                      u'completer': u'',
                                                                                                                                                      u'default': None,
                                                                                                                                                      u'description': u'The new prefix length of the subnet. It must be smaller than the original and in the private address space 10.0.0.0/8, 172.16.0.0/12 or 192.168.0.0/16 defined in RFC 1918.',
                                                                                                                                                      u'group': u'',
                                                                                                                                                      u'hidden': False,
                                                                                                                                                      u'name': u'--prefix-length',
                                                                                                                                                      u'nargs': u'0',
                                                                                                                                                      u'required': True,
                                                                                                                                                      u'type': u'string',
                                                                                                                                                      u'value': u'PREFIX_LENGTH'},
                                                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': None,
                                                                                                                                               u'description': u"The region of the subnetwork to operate on. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': False,
                                                                                                                                               u'name': u'--region',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'string',
                                                                                                                                               u'value': u'REGION'}},
                                                                                                                      u'group': False,
                                                                                                                      u'groups': {},
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'expand-ip-range',
                                                                                                                      u'path': [u'gcloud',
                                                                                                                                u'compute',
                                                                                                                                u'networks',
                                                                                                                                u'subnets',
                                                                                                                                u'expand-ip-range'],
                                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'The name of the subnetwork.',
                                                                                                                                        u'name': u'name',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'value': u'NAME'}],
                                                                                                                      u'release': u'GA',
                                                                                                                      u'sections': {u'DESCRIPTION': u'*expand-ip-range* is used to expand the IP range of a subnetwork in a custom\nmode network.\n',
                                                                                                                                    u'EXAMPLES': u"To expand the IP range of ``SUBNET'' to /16, run:\n\n  $ expand-ip-range SUBNET --region us-central1 --prefix-length 16\n"}},
                                                                                                 u'list': {u'capsule': u'List Google Compute Engine subnetworks.',
                                                                                                           u'commands': {},
                                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--filter',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                                      u'--limit': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--limit',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'LIMIT'},
                                                                                                                      u'--network': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Only show subnetworks of a specific network.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--network',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'NETWORK'},
                                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': True,
                                                                                                                                    u'description': u'',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': True,
                                                                                                                                    u'name': u'--no-uri',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'bool',
                                                                                                                                    u'value': u'NO_URI'},
                                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--page-size',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                                      u'--regexp': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--regexp',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'REGEXP'},
                                                                                                                      u'--regions': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--regions',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'REGION'},
                                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--sort-by',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'FIELD'},
                                                                                                                      u'--uri': {u'attr': {},
                                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': False,
                                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--uri',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'URI'}},
                                                                                                           u'group': False,
                                                                                                           u'groups': {},
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'list',
                                                                                                           u'path': [u'gcloud',
                                                                                                                     u'compute',
                                                                                                                     u'networks',
                                                                                                                     u'subnets',
                                                                                                                     u'list'],
                                                                                                           u'positionals': [{u'completer': u'',
                                                                                                                             u'default': [],
                                                                                                                             u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                                             u'name': u'names',
                                                                                                                             u'nargs': u'*',
                                                                                                                             u'required': False,
                                                                                                                             u'value': u'NAME'}],
                                                                                                           u'release': u'GA',
                                                                                                           u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine subnetworks in a project.\n\nBy default, subnetworks from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                                         u'EXAMPLES': u"To list all subnetworks in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all subnetworks in a project, run:\n\n  $ list --uri\n\nTo list all subnetworks in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}}},
                                                                                   u'flags': {},
                                                                                   u'group': True,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'subnets',
                                                                                   u'path': [u'gcloud',
                                                                                             u'compute',
                                                                                             u'networks',
                                                                                             u'subnets'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'List, describe, and delete Google Compute Engine subnetworks.'}},
                                                                      u'switch-mode': {u'capsule': u'Switch the mode of a Google Compute Engine network.',
                                                                                       u'commands': {},
                                                                                       u'flags': {u'--mode': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The target mode of the network. Only support "custom" now.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--mode',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': True,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'MODE'}},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'switch-mode',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'compute',
                                                                                                 u'networks',
                                                                                                 u'switch-mode'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The name of the network for which to switch mode.',
                                                                                                         u'name': u'name',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'value': u'NAME'}],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u'*switch-mode* is used to change the mode of a network. Currently, only\nchanging from auto to custom mode is supported.\n',
                                                                                                     u'EXAMPLES': u"To switch ``NETWORK'' to custom subnet mode, run:\n\n  $ switch-mode NETWORK --mode custom\n"}}},
                                                        u'flags': {},
                                                        u'group': True,
                                                        u'groups': {},
                                                        u'hidden': False,
                                                        u'name': u'networks',
                                                        u'path': [u'gcloud',
                                                                  u'compute',
                                                                  u'networks'],
                                                        u'positionals': [],
                                                        u'release': u'GA',
                                                        u'sections': {u'DESCRIPTION': u'List, create, and delete Google Compute Engine networks.'}},
                                          u'operations': {u'capsule': u'Read and manipulate Google Compute Engine operations.',
                                                          u'commands': {u'describe': {u'capsule': u'Describe a Google Compute Engine operation.',
                                                                                      u'commands': {},
                                                                                      u'flags': {u'--global': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'If provided, it is assumed the operation is global.',
                                                                                                               u'group': u'describe.1',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--global',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'GLOBAL'},
                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The region of the operation to operate on. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                               u'group': u'describe.1',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--region',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'REGION'},
                                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The zone of the operation to operate on. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                             u'group': u'describe.1',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--zone',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'ZONE'}},
                                                                                      u'group': False,
                                                                                      u'groups': {u'describe.1': {u'description': u'At most one of these may be specified:',
                                                                                                                  u'is_mutex': True,
                                                                                                                  u'is_required': False}},
                                                                                      u'hidden': False,
                                                                                      u'name': u'describe',
                                                                                      u'path': [u'gcloud',
                                                                                                u'compute',
                                                                                                u'operations',
                                                                                                u'describe'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The name of the operation.',
                                                                                                        u'name': u'name',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'value': u'NAME'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine operation in a project.\n',
                                                                                                    u'EXAMPLES': u'To get details about a global operation, run:\n\n  $ describe OPERATION --global\n\nTo get details about a regional operation, run:\n\n  $ describe OPERATION --region us-central1\n\nTo get details about a zonal operation, run:\n\n  $ describe OPERATION --zone us-central1-a\n'}},
                                                                        u'list': {u'capsule': u'List Google Compute Engine operations.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--filter',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'EXPRESSION'},
                                                                                             u'--global': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'If provided, only global resources are shown.',
                                                                                                           u'group': u'list.1',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--global',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'GLOBAL'},
                                                                                             u'--limit': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--limit',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'LIMIT'},
                                                                                             u'--no-uri': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': True,
                                                                                                           u'description': u'',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': True,
                                                                                                           u'name': u'--no-uri',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'NO_URI'},
                                                                                             u'--page-size': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--page-size',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                             u'--regexp': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--regexp',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'REGEXP'},
                                                                                             u'--regions': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'If provided, only regional resources are shown. If arguments are provided, only resources from the given regions are shown.',
                                                                                                            u'group': u'list.1',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--regions',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'list',
                                                                                                            u'value': u'REGION'},
                                                                                             u'--sort-by': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--sort-by',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'list',
                                                                                                            u'value': u'FIELD'},
                                                                                             u'--uri': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': False,
                                                                                                        u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--uri',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'URI'},
                                                                                             u'--zones': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'If provided, only zonal resources are shown. If arguments are provided, only resources from the given zones are shown.',
                                                                                                          u'group': u'list.1',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--zones',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'list',
                                                                                                          u'value': u'ZONE'}},
                                                                                  u'group': False,
                                                                                  u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                                          u'is_mutex': True,
                                                                                                          u'is_required': False}},
                                                                                  u'hidden': False,
                                                                                  u'name': u'list',
                                                                                  u'path': [u'gcloud',
                                                                                            u'compute',
                                                                                            u'operations',
                                                                                            u'list'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': [],
                                                                                                    u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                    u'name': u'names',
                                                                                                    u'nargs': u'*',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAME'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine operations in a project.\n\nBy default, global operations and operations from all regions are listed. The results can be narrowed down by\nproviding the ``--global'' or ``--regions'' flag.\n",
                                                                                                u'EXAMPLES': u"To list all operations in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all operations in a project, run:\n\n  $ list --uri\n\nTo list all global operations in a project, run:\n\n  $ list --global\n\nTo list all operations in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1,europe-west1\n"}}},
                                                          u'flags': {},
                                                          u'group': True,
                                                          u'groups': {},
                                                          u'hidden': False,
                                                          u'name': u'operations',
                                                          u'path': [u'gcloud',
                                                                    u'compute',
                                                                    u'operations'],
                                                          u'positionals': [],
                                                          u'release': u'GA',
                                                          u'sections': {u'DESCRIPTION': u'Read and manipulate Google Compute Engine operations.'}},
                                          u'project-info': {u'capsule': u'Read and manipulate project-level data like quotas and metadata.',
                                                            u'commands': {u'add-metadata': {u'capsule': u'Add or update project-wide metadata.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--metadata': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': {},
                                                                                                                       u'description': u"Metadata to be made available to the guest operating system\nrunning on the instances. Each metadata entry is a key/value\npair separated by an equals sign. Metadata keys must be unique\nand less than 128 bytes in length. Values must be less than or\nequal to 32,768 bytes in length. Multiple arguments can be\npassed to this flag, e.g.,\n``--metadata key-1=value-1,key-2=value-2,key-3=value-3''.\n+\nIn images that have Compute Engine tools installed on them,\nsuch as the\nlink:https://cloud.google.com/compute/docs/images[official images],\nthe following metadata keys have special meanings:\n+\n*startup-script*::: Specifies a script that will be executed\nby the instances once they start running. For convenience,\n``--metadata-from-file'' can be used to pull the value from a\nfile.\n+\n*startup-script-url*::: Same as ``startup-script'' except that\nthe script contents are pulled from a publicly-accessible\nlocation on the web.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--metadata',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'dict',
                                                                                                                       u'value': u'KEY=VALUE'},
                                                                                                       u'--metadata-from-file': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': {},
                                                                                                                                 u'description': u"Same as ``--metadata'' except that the value for the entry will\nbe read from a local file. This is useful for values that are\ntoo large such as ``startup-script'' contents.\n+\n\nAt least one of [--metadata] or [--metadata-from-file] is required.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--metadata-from-file',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'dict',
                                                                                                                                 u'value': u'KEY=LOCAL_FILE_PATH'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'add-metadata',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'project-info',
                                                                                                      u'add-metadata'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*add-metadata* can be used to add or update project-wide\nmetadata. Every instance has access to a metadata server that\ncan be used to query metadata that has been set through this\ntool. Project-wide metadata entries are visible to all\ninstances. To set metadata for individual instances, use\n`gcloud compute instances add-metadata`. For information on\nmetadata, see\n[](https://cloud.google.com/compute/docs/metadata)\n\nOnly metadata keys that are provided are mutated. Existing\nmetadata entries will remain unaffected.\n'}},
                                                                          u'describe': {u'capsule': u'Describe the Google Compute Engine project resource.',
                                                                                        u'commands': {},
                                                                                        u'flags': {},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'describe',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'project-info',
                                                                                                  u'describe'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u"*describe* displays all data associated with the Google\nCompute Engine project resource. The project resource contains\ndata such as global quotas, common instance metadata, and the\nproject's creation time.\n"}},
                                                                          u'remove-metadata': {u'capsule': u'Remove project-wide metadata entries.',
                                                                                               u'commands': {},
                                                                                               u'flags': {u'--all': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': False,
                                                                                                                     u'description': u'If provided, all metadata entries are removed.',
                                                                                                                     u'group': u'remove-metadata.1',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--all',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'ALL'},
                                                                                                          u'--keys': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The keys of the entries to remove.',
                                                                                                                      u'group': u'remove-metadata.1',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--keys',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'list',
                                                                                                                      u'value': u'KEY'}},
                                                                                               u'group': False,
                                                                                               u'groups': {u'remove-metadata.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                  u'is_mutex': True,
                                                                                                                                  u'is_required': False}},
                                                                                               u'hidden': False,
                                                                                               u'name': u'remove-metadata',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'compute',
                                                                                                         u'project-info',
                                                                                                         u'remove-metadata'],
                                                                                               u'positionals': [],
                                                                                               u'release': u'GA',
                                                                                               u'sections': {u'DESCRIPTION': u'*remove-metadata* can be used to remove project-wide metadata entries.\n'}},
                                                                          u'set-usage-bucket': {u'capsule': u'Set the usage reporting bucket for a project.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--bucket': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The URI of a Google Cloud Storage bucket where the usage\nreport object should be stored. The Google Service Account for\nperforming usage reporting is granted write access to this bucket.\nThe user running this command must be an owner of the bucket.\n+\nTo clear the usage bucket, use --no-bucket.',
                                                                                                                         u'group': u'set-usage-bucket.1',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--bucket',
                                                                                                                         u'nargs': u'?',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'BUCKET'},
                                                                                                           u'--no-bucket': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Unsets the bucket. This disables usage report storage.',
                                                                                                                            u'group': u'set-usage-bucket.1',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--no-bucket',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_BUCKET'},
                                                                                                           u'--prefix': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u"An optional prefix for the name of the usage report object stored in\nthe bucket. If not supplied, then this defaults to ``usage''. The\nreport is stored as a CSV file named PREFIX_gce_YYYYMMDD.csv where\nYYYYMMDD is the day of the usage according to Pacific Time. The prefix\nshould conform to Google Cloud Storage object naming conventions.\nThis flag must not be provided when clearing the usage bucket.",
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--prefix',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'PREFIX'}},
                                                                                                u'group': False,
                                                                                                u'groups': {u'set-usage-bucket.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                    u'is_mutex': True,
                                                                                                                                    u'is_required': False}},
                                                                                                u'hidden': False,
                                                                                                u'name': u'set-usage-bucket',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'compute',
                                                                                                          u'project-info',
                                                                                                          u'set-usage-bucket'],
                                                                                                u'positionals': [],
                                                                                                u'release': u'GA',
                                                                                                u'sections': {u'DESCRIPTION': u'*set-usage-bucket* is used to configure usage reporting for projects.\n\nSetting usage reporting will cause a log of usage per resource to be\nwritten to a specified Google Cloud Storage bucket daily. For example,\n\n  $ gcloud compute project-info set-usage-bucket --bucket gs://my-bucket\n\nwill cause logs of the form usage_gce_YYYYMMDD.csv to be written daily\nto the bucket `my-bucket`. To disable this feature, issue the command:\n\n  $ gcloud compute project-info set-usage-bucket --no-bucket\n'}}},
                                                            u'flags': {},
                                                            u'group': True,
                                                            u'groups': {},
                                                            u'hidden': False,
                                                            u'name': u'project-info',
                                                            u'path': [u'gcloud',
                                                                      u'compute',
                                                                      u'project-info'],
                                                            u'positionals': [],
                                                            u'release': u'GA',
                                                            u'sections': {u'DESCRIPTION': u'Read and manipulate project-level data like quotas and metadata.'}},
                                          u'regions': {u'capsule': u'List Google Compute Engine regions.',
                                                       u'commands': {u'describe': {u'capsule': u'Describe a Google Compute Engine region.',
                                                                                   u'commands': {},
                                                                                   u'flags': {},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'describe',
                                                                                   u'path': [u'gcloud',
                                                                                             u'compute',
                                                                                             u'regions',
                                                                                             u'describe'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The name of the resource to fetch.',
                                                                                                     u'name': u'name',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine region.\n'}},
                                                                     u'list': {u'capsule': u'List Google Compute Engine regions.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--filter',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'EXPRESSION'},
                                                                                          u'--limit': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--limit',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'LIMIT'},
                                                                                          u'--no-uri': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-uri',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_URI'},
                                                                                          u'--page-size': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--page-size',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                          u'--regexp': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--regexp',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'REGEXP'},
                                                                                          u'--sort-by': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--sort-by',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'list',
                                                                                                         u'value': u'FIELD'},
                                                                                          u'--uri': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--uri',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'URI'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'list',
                                                                               u'path': [u'gcloud',
                                                                                         u'compute',
                                                                                         u'regions',
                                                                                         u'list'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': [],
                                                                                                 u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                 u'name': u'names',
                                                                                                 u'nargs': u'*',
                                                                                                 u'required': False,
                                                                                                 u'value': u'NAME'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine regions in a project.\n',
                                                                                             u'EXAMPLES': u'To list all regions in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all regions in a project, run:\n\n  $ list --uri\n'}}},
                                                       u'flags': {},
                                                       u'group': True,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'regions',
                                                       u'path': [u'gcloud',
                                                                 u'compute',
                                                                 u'regions'],
                                                       u'positionals': [],
                                                       u'release': u'GA',
                                                       u'sections': {u'DESCRIPTION': u'List Google Compute Engine regions.'}},
                                          u'reset-windows-password': {u'capsule': u'Reset and return a password for a Windows machine instance.',
                                                                      u'commands': {},
                                                                      u'flags': {u'--user': {u'attr': {},
                                                                                             u'category': u'',
                                                                                             u'choices': [],
                                                                                             u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u"``USER'' specifies the username to get the password for.\nIf omitted, the username is derived from your authenticated\naccount email address.",
                                                                                             u'group': u'',
                                                                                             u'hidden': False,
                                                                                             u'name': u'--user',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'type': u'string',
                                                                                             u'value': u'USER'},
                                                                                 u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                             u'category': u'',
                                                                                             u'choices': [],
                                                                                             u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u"The zone of the instance to operate on. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                             u'group': u'',
                                                                                             u'hidden': False,
                                                                                             u'name': u'--zone',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'type': u'string',
                                                                                             u'value': u'ZONE'}},
                                                                      u'group': False,
                                                                      u'groups': {},
                                                                      u'hidden': False,
                                                                      u'name': u'reset-windows-password',
                                                                      u'path': [u'gcloud',
                                                                                u'compute',
                                                                                u'reset-windows-password'],
                                                                      u'positionals': [{u'completer': u'',
                                                                                        u'default': None,
                                                                                        u'description': u'The name of the instance.',
                                                                                        u'name': u'name',
                                                                                        u'nargs': u'0',
                                                                                        u'required': False,
                                                                                        u'value': u'NAME'}],
                                                                      u'release': u'GA',
                                                                      u'sections': {u'DESCRIPTION': u'*reset-windows-password* allows a user to reset and retrieve a password for\na Windows virtual machine instance. If the Windows account does not\nexist, this command will cause the account to be created and the\npassword for that new account will be returned.\n\nFor Windows instances that are running a domain controller, running\nthis command creates a new domain user if the user does not exist,\nor resets the password if the user does exist. It is not possible to\nuse this command to create a local user on a domain-controller\ninstance.\n\nFor all other instances, including domain-joined instances, running\nthis command creates a local user or resets the password for a local\nuser.\n\nWARNING: Resetting a password for an existing user can cause the\nloss of data encrypted with the current Windows password, such as\nencrypted files or stored passwords.\n\nThe user running this command must have write permission for the\nGoogle Compute Engine project containing the Windows instance.\n'}},
                                          u'routers': {u'capsule': u'List, create, and delete Google Compute Engine routers.',
                                                       u'commands': {u'add-bgp-peer': {u'capsule': u'Add a BGP peer to a router.',
                                                                                       u'commands': {},
                                                                                       u'flags': {u'--advertised-route-priority': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The priority of routes advertised to this BGP peer. In the case where there is more than one matching route of maximum length, the routes with lowest priority value win. 0 <= priority <= 65535.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--advertised-route-priority',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'ADVERTISED_ROUTE_PRIORITY'},
                                                                                                  u'--interface': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The interface of the peer being added.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--interface',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': True,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'INTERFACE'},
                                                                                                  u'--peer-asn': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The asn of the peer being added.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--peer-asn',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': True,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'PEER_ASN'},
                                                                                                  u'--peer-ip-address': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The link local address of the peer.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--peer-ip-address',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'PEER_IP_ADDRESS'},
                                                                                                  u'--peer-name': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The name of the peer being added.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--peer-name',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': True,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'PEER_NAME'},
                                                                                                  u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--region',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'REGION'}},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'add-bgp-peer',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'compute',
                                                                                                 u'routers',
                                                                                                 u'add-bgp-peer'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The name of the router.',
                                                                                                         u'name': u'name',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'value': u'NAME'}],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u'\n*add-bgp-peer* is used to add a BGP peer to a router.\n'}},
                                                                     u'add-interface': {u'capsule': u'Add an interface to a router.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--interface-name': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The name of the interface being added.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--interface-name',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': True,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'INTERFACE_NAME'},
                                                                                                   u'--ip-address': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The link local address of the router for this interface.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--ip-address',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'IP_ADDRESS'},
                                                                                                   u'--mask-length': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The mask for network used for the server IP address.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--mask-length',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'MASK_LENGTH'},
                                                                                                   u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--region',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'REGION'},
                                                                                                   u'--vpn-tunnel': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The tunnel of the interface being added.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--vpn-tunnel',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': True,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'VPN_TUNNEL'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'add-interface',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'routers',
                                                                                                  u'add-interface'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The name of the router.',
                                                                                                          u'name': u'name',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'\n*add-interface* is used to add an interface to a router.\n'}},
                                                                     u'create': {u'capsule': u'Create a router.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--asn': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The BGP asn for this router',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--asn',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': True,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'ASN'},
                                                                                            u'--description': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'An optional description of this router.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--description',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'DESCRIPTION'},
                                                                                            u'--network': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The network for this router',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--network',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': True,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'NETWORK'},
                                                                                            u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"The region of the router to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--region',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'REGION'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'create',
                                                                                 u'path': [u'gcloud',
                                                                                           u'compute',
                                                                                           u'routers',
                                                                                           u'create'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The name of the router.',
                                                                                                   u'name': u'name',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'NAME'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'\n*create* is used to create a router for use in dynamic\nrouting with vpn tunnels.\n'}},
                                                                     u'delete': {u'capsule': u'Delete Google Compute Engine routers.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--region',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'REGION'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'delete',
                                                                                 u'path': [u'gcloud',
                                                                                           u'compute',
                                                                                           u'routers',
                                                                                           u'delete'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The resources to delete.',
                                                                                                   u'name': u'names',
                                                                                                   u'nargs': u'+',
                                                                                                   u'required': False,
                                                                                                   u'value': u'NAME'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine\nrouters. Routers can only be deleted when no other resources\n(e.g., virtual machine instances) refer to them.\n'}},
                                                                     u'describe': {u'capsule': u'Describe a Google Compute Engine router.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--region',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'REGION'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'describe',
                                                                                   u'path': [u'gcloud',
                                                                                             u'compute',
                                                                                             u'routers',
                                                                                             u'describe'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The name of the resource to fetch.',
                                                                                                     u'name': u'name',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine router.'}},
                                                                     u'get-status': {u'capsule': u'Get status of a Google Compute Engine router.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--region',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'REGION'}},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'get-status',
                                                                                     u'path': [u'gcloud',
                                                                                               u'compute',
                                                                                               u'routers',
                                                                                               u'get-status'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of the resource to fetch.',
                                                                                                       u'name': u'name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'*get-status* displays all runtime data associated with a Google Compute\nEngine router.'}},
                                                                     u'list': {u'capsule': u'List Google Compute Engine routers.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--filter',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'EXPRESSION'},
                                                                                          u'--limit': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--limit',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'LIMIT'},
                                                                                          u'--no-uri': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-uri',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_URI'},
                                                                                          u'--page-size': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--page-size',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                          u'--regexp': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--regexp',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'REGEXP'},
                                                                                          u'--regions': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': [],
                                                                                                         u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--regions',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'list',
                                                                                                         u'value': u'REGION'},
                                                                                          u'--sort-by': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--sort-by',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'list',
                                                                                                         u'value': u'FIELD'},
                                                                                          u'--uri': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--uri',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'URI'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'list',
                                                                               u'path': [u'gcloud',
                                                                                         u'compute',
                                                                                         u'routers',
                                                                                         u'list'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': [],
                                                                                                 u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                 u'name': u'names',
                                                                                                 u'nargs': u'*',
                                                                                                 u'required': False,
                                                                                                 u'value': u'NAME'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine routers in a project.\n\nBy default, routers from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                             u'EXAMPLES': u"To list all routers in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all routers in a project, run:\n\n  $ list --uri\n\nTo list all routers in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}},
                                                                     u'remove-bgp-peer': {u'capsule': u'Remove a BGP peer from a router.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--peer-name': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The name of the peer being removed.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--peer-name',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': True,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'PEER_NAME'},
                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--region',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGION'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'remove-bgp-peer',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'routers',
                                                                                                    u'remove-bgp-peer'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the router.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'\n*remove-bgp-peer* removes a BGP peer from a router.\n'}},
                                                                     u'remove-interface': {u'capsule': u'Remove an interface from a router.',
                                                                                           u'commands': {},
                                                                                           u'flags': {u'--interface-name': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the interface being removed.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--interface-name',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': True,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'INTERFACE_NAME'},
                                                                                                      u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--region',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'REGION'}},
                                                                                           u'group': False,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'remove-interface',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'compute',
                                                                                                     u'routers',
                                                                                                     u'remove-interface'],
                                                                                           u'positionals': [{u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The name of the router.',
                                                                                                             u'name': u'name',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'value': u'NAME'}],
                                                                                           u'release': u'GA',
                                                                                           u'sections': {u'DESCRIPTION': u'\n*remove-interface* removes an interface from a router.\n'}},
                                                                     u'update-bgp-peer': {u'capsule': u'Update a BGP peer on a router.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--advertised-route-priority': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The priority of routes advertised to this BGP peer. In the case where there is more than one matching route of maximum length, the routes with lowest priority value win. 0 <= priority <= 65535.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--advertised-route-priority',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ADVERTISED_ROUTE_PRIORITY'},
                                                                                                     u'--interface': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The new interface of the peer being modified.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--interface',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'INTERFACE'},
                                                                                                     u'--ip-address': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The new link local address of the router for this peer.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--ip-address',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'IP_ADDRESS'},
                                                                                                     u'--peer-asn': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The new asn of the peer being modified.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--peer-asn',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'PEER_ASN'},
                                                                                                     u'--peer-ip-address': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The new link local address of the peer.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--peer-ip-address',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'PEER_IP_ADDRESS'},
                                                                                                     u'--peer-name': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The name of the peer being modified.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--peer-name',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': True,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'PEER_NAME'},
                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--region',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGION'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'update-bgp-peer',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'routers',
                                                                                                    u'update-bgp-peer'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the router.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'\n*update-bgp-peer* is used to update a BGP peer on a router.\n'}},
                                                                     u'update-interface': {u'capsule': u'Update an interface on a router.',
                                                                                           u'commands': {},
                                                                                           u'flags': {u'--interface-name': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The name of the interface being updated.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--interface-name',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': True,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'INTERFACE_NAME'},
                                                                                                      u'--ip-address': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The link local address of the router for this interface.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--ip-address',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'IP_ADDRESS'},
                                                                                                      u'--mask-length': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The mask for network used for the server IP address.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--mask-length',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'MASK_LENGTH'},
                                                                                                      u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"The region of the router to update. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--region',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'REGION'},
                                                                                                      u'--vpn-tunnel': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The tunnel of the interface being updated.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--vpn-tunnel',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'VPN_TUNNEL'}},
                                                                                           u'group': False,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'update-interface',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'compute',
                                                                                                     u'routers',
                                                                                                     u'update-interface'],
                                                                                           u'positionals': [{u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The name of the router.',
                                                                                                             u'name': u'name',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'value': u'NAME'}],
                                                                                           u'release': u'GA',
                                                                                           u'sections': {u'DESCRIPTION': u'\n*update-interface* is used to update an interface on a router.\n'}}},
                                                       u'flags': {},
                                                       u'group': True,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'routers',
                                                       u'path': [u'gcloud',
                                                                 u'compute',
                                                                 u'routers'],
                                                       u'positionals': [],
                                                       u'release': u'GA',
                                                       u'sections': {u'DESCRIPTION': u'List, create, and delete Google Compute Engine routers.'}},
                                          u'routes': {u'capsule': u'Read and manipulate routes.',
                                                      u'commands': {u'create': {u'capsule': u'Create a new route.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--description': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'An optional, textual description for the route.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--description',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'DESCRIPTION'},
                                                                                           u'--destination-range': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"The destination range of outgoing packets that the route will\napply to. To match all traffic, use ``0.0.0.0/0''.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--destination-range',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': True,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'DESTINATION_RANGE'},
                                                                                           u'--network': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': u'default',
                                                                                                          u'description': u'Specifies the network to which the route will be applied.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--network',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'NETWORK'},
                                                                                           u'--next-hop-address': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"Specifies the IP address of an instance that should handle\nmatching packets. The instance must have IP forwarding enabled\n(i.e., include ``--can-ip-forward'' when creating the instance\nusing `gcloud compute instances create`)",
                                                                                                                   u'group': u'create.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--next-hop-address',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'NEXT_HOP_ADDRESS'},
                                                                                           u'--next-hop-gateway': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"Specifies the gateway that should handle matching\npackets. Currently, the only acceptable value is\n``default-internet-gateway'' which is a gateway operated by\nGoogle Compute Engine.",
                                                                                                                   u'group': u'create.1',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--next-hop-gateway',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'NEXT_HOP_GATEWAY'},
                                                                                           u'--next-hop-instance': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"Specifies the name of an instance that should handle traffic\nmatching this route. When this flag is specified, the zone of\nthe instance must be specified using\n``--next-hop-instance-zone''.",
                                                                                                                    u'group': u'create.1',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--next-hop-instance',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'NEXT_HOP_INSTANCE'},
                                                                                           u'--next-hop-instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u"The zone of the next hop instance. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--next-hop-instance-zone',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'NEXT_HOP_INSTANCE_ZONE'},
                                                                                           u'--next-hop-vpn-tunnel': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The target VPN tunnel that will receive forwarded traffic.',
                                                                                                                      u'group': u'create.1',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--next-hop-vpn-tunnel',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'NEXT_HOP_VPN_TUNNEL'},
                                                                                           u'--next-hop-vpn-tunnel-region': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"The region of the next hop vpn tunnel. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--next-hop-vpn-tunnel-region',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'NEXT_HOP_VPN_TUNNEL_REGION'},
                                                                                           u'--priority': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': 1000,
                                                                                                           u'description': u'Specifies the priority of this route relative to other routes\nwith the same specificity. The lower the value, the higher the\npriority.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--priority',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'int',
                                                                                                           u'value': u'PRIORITY'},
                                                                                           u'--tags': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': [],
                                                                                                       u'description': u'Identifies the set of instances that this route will apply to. If no\ntags are provided, the route will apply to all instances in the network.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--tags',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'TAG'}},
                                                                                u'group': False,
                                                                                u'groups': {u'create.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                          u'is_mutex': True,
                                                                                                          u'is_required': True}},
                                                                                u'hidden': False,
                                                                                u'name': u'create',
                                                                                u'path': [u'gcloud',
                                                                                          u'compute',
                                                                                          u'routes',
                                                                                          u'create'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'The name to assign to the route.',
                                                                                                  u'name': u'name',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'NAME'}],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u"*create* is used to create routes. A route is a rule that\nspecifies how certain packets should be handled by the virtual\nnetwork. Routes are associated with virtual machine instances\nby tag, and the set of routes for a particular VM is called\nits routing table. For each packet leaving a virtual machine,\nthe system searches that machine's routing table for a single\nbest matching route.\n\nRoutes match packets by destination IP address, preferring\nsmaller or more specific ranges over larger ones (see\n``--destination-range''). If there is a tie, the system selects\nthe route with the smallest priority value. If there is still\na tie, it uses the layer three and four packet headers to\nselect just one of the remaining matching routes. The packet\nis then forwarded as specified by ``--next-hop-address'',\n``--next-hop-instance'', ``--next-hop-vpn-tunnel'', or\n``--next-hop-gateway'' of the winning route. Packets that do\nnot match any route in the sending virtual machine routing\ntable will be dropped.\n\nExactly one of ``--next-hop-address'', ``--next-hop-gateway'',\n``--next-hop-vpn-tunnel'', or ``--next-hop-instance'' must be\nprovided with this command.\n"}},
                                                                    u'delete': {u'capsule': u'Delete routes.',
                                                                                u'commands': {},
                                                                                u'flags': {},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'delete',
                                                                                u'path': [u'gcloud',
                                                                                          u'compute',
                                                                                          u'routes',
                                                                                          u'delete'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'The resources to delete.',
                                                                                                  u'name': u'names',
                                                                                                  u'nargs': u'+',
                                                                                                  u'required': False,
                                                                                                  u'value': u'NAME'}],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine routes.\n'}},
                                                                    u'describe': {u'capsule': u'Describe a route.',
                                                                                  u'commands': {},
                                                                                  u'flags': {},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'describe',
                                                                                  u'path': [u'gcloud',
                                                                                            u'compute',
                                                                                            u'routes',
                                                                                            u'describe'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The name of the resource to fetch.',
                                                                                                    u'name': u'name',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAME'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine route in a project.\n'}},
                                                                    u'list': {u'capsule': u'List Google Compute Engine routes.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--filter',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'EXPRESSION'},
                                                                                         u'--limit': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--limit',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'LIMIT'},
                                                                                         u'--no-uri': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': True,
                                                                                                       u'description': u'',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': True,
                                                                                                       u'name': u'--no-uri',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'NO_URI'},
                                                                                         u'--page-size': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--page-size',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                         u'--regexp': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--regexp',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'REGEXP'},
                                                                                         u'--sort-by': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--sort-by',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'list',
                                                                                                        u'value': u'FIELD'},
                                                                                         u'--uri': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': False,
                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--uri',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'URI'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'list',
                                                                              u'path': [u'gcloud',
                                                                                        u'compute',
                                                                                        u'routes',
                                                                                        u'list'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': [],
                                                                                                u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                u'name': u'names',
                                                                                                u'nargs': u'*',
                                                                                                u'required': False,
                                                                                                u'value': u'NAME'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine routes in a project.\n',
                                                                                            u'EXAMPLES': u'To list all routes in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all routes in a project, run:\n\n  $ list --uri\n'}}},
                                                      u'flags': {},
                                                      u'group': True,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'routes',
                                                      u'path': [u'gcloud',
                                                                u'compute',
                                                                u'routes'],
                                                      u'positionals': [],
                                                      u'release': u'GA',
                                                      u'sections': {u'DESCRIPTION': u'Read and manipulate routes.'}},
                                          u'snapshots': {u'capsule': u'List, describe, and delete Google Compute Engine snapshots.',
                                                         u'commands': {u'delete': {u'capsule': u'Delete Google Compute Engine snapshots.',
                                                                                   u'commands': {},
                                                                                   u'flags': {},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'delete',
                                                                                   u'path': [u'gcloud',
                                                                                             u'compute',
                                                                                             u'snapshots',
                                                                                             u'delete'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The resources to delete.',
                                                                                                     u'name': u'names',
                                                                                                     u'nargs': u'+',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine snapshots.\n'}},
                                                                       u'describe': {u'capsule': u'Describe a Google Compute Engine snapshot.',
                                                                                     u'commands': {},
                                                                                     u'flags': {},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'describe',
                                                                                     u'path': [u'gcloud',
                                                                                               u'compute',
                                                                                               u'snapshots',
                                                                                               u'describe'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of the resource to fetch.',
                                                                                                       u'name': u'name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine snapshot in a project.\n'}},
                                                                       u'list': {u'capsule': u'List Google Compute Engine snapshots.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--filter',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'EXPRESSION'},
                                                                                            u'--limit': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--limit',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'LIMIT'},
                                                                                            u'--no-uri': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-uri',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_URI'},
                                                                                            u'--page-size': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--page-size',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                            u'--regexp': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--regexp',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'REGEXP'},
                                                                                            u'--sort-by': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--sort-by',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'list',
                                                                                                           u'value': u'FIELD'},
                                                                                            u'--uri': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--uri',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'URI'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'list',
                                                                                 u'path': [u'gcloud',
                                                                                           u'compute',
                                                                                           u'snapshots',
                                                                                           u'list'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': [],
                                                                                                   u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                   u'name': u'names',
                                                                                                   u'nargs': u'*',
                                                                                                   u'required': False,
                                                                                                   u'value': u'NAME'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine snapshots in a project.\n',
                                                                                               u'EXAMPLES': u'To list all snapshots in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all snapshots in a project, run:\n\n  $ list --uri\n'}}},
                                                         u'flags': {},
                                                         u'group': True,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'snapshots',
                                                         u'path': [u'gcloud',
                                                                   u'compute',
                                                                   u'snapshots'],
                                                         u'positionals': [],
                                                         u'release': u'GA',
                                                         u'sections': {u'DESCRIPTION': u'List, describe, and delete Google Compute Engine snapshots.'}},
                                          u'ssh': {u'capsule': u'SSH into a virtual machine instance.',
                                                   u'commands': {},
                                                   u'flags': {u'--command': {u'attr': {},
                                                                             u'category': u'',
                                                                             u'choices': [],
                                                                             u'completer': u'',
                                                                             u'default': None,
                                                                             u'description': u'A command to run on the virtual machine.\n+\nRuns the command on the target instance and then exits.',
                                                                             u'group': u'',
                                                                             u'hidden': False,
                                                                             u'name': u'--command',
                                                                             u'nargs': u'0',
                                                                             u'required': False,
                                                                             u'type': u'string',
                                                                             u'value': u'COMMAND'},
                                                              u'--container': {u'attr': {},
                                                                               u'category': u'',
                                                                               u'choices': [],
                                                                               u'completer': u'',
                                                                               u'default': None,
                                                                               u'description': u'The name of a container inside of the virtual machine instance to\nconnect to. This only applies to virtual machines that are using\na Google container virtual machine image. For more information,\nsee [](https://cloud.google.com/compute/docs/containers)',
                                                                               u'group': u'',
                                                                               u'hidden': False,
                                                                               u'name': u'--container',
                                                                               u'nargs': u'0',
                                                                               u'required': False,
                                                                               u'type': u'string',
                                                                               u'value': u'CONTAINER'},
                                                              u'--dry-run': {u'attr': {},
                                                                             u'category': u'',
                                                                             u'choices': [],
                                                                             u'completer': u'',
                                                                             u'default': False,
                                                                             u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                             u'group': u'',
                                                                             u'hidden': False,
                                                                             u'name': u'--dry-run',
                                                                             u'nargs': u'0',
                                                                             u'required': False,
                                                                             u'type': u'bool',
                                                                             u'value': u'DRY_RUN'},
                                                              u'--force-key-file-overwrite': {u'attr': {},
                                                                                              u'category': u'',
                                                                                              u'choices': [],
                                                                                              u'completer': u'',
                                                                                              u'default': False,
                                                                                              u'description': u'If enabled gcloud will regenerate and overwrite the files associated\nwith a broken SSH key without asking for confirmation in both\ninteractive and non-interactive environment.\n+\nIf disabled gcloud will not attempt to regenerate the files associated\nwith a broken SSH key and fail in both interactive and non-interactive\nenvironment.',
                                                                                              u'group': u'',
                                                                                              u'hidden': False,
                                                                                              u'name': u'--force-key-file-overwrite',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'type': u'bool',
                                                                                              u'value': u'FORCE_KEY_FILE_OVERWRITE'},
                                                              u'--no-dry-run': {u'attr': {},
                                                                                u'category': u'',
                                                                                u'choices': [],
                                                                                u'completer': u'',
                                                                                u'default': True,
                                                                                u'description': u'',
                                                                                u'group': u'',
                                                                                u'hidden': True,
                                                                                u'name': u'--no-dry-run',
                                                                                u'nargs': u'0',
                                                                                u'required': False,
                                                                                u'type': u'bool',
                                                                                u'value': u'NO_DRY_RUN'},
                                                              u'--no-force-key-file-overwrite': {u'attr': {},
                                                                                                 u'category': u'',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': False,
                                                                                                 u'description': u'',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': True,
                                                                                                 u'name': u'--no-force-key-file-overwrite',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'type': u'bool',
                                                                                                 u'value': u'NO_FORCE_KEY_FILE_OVERWRITE'},
                                                              u'--no-plain': {u'attr': {},
                                                                              u'category': u'',
                                                                              u'choices': [],
                                                                              u'completer': u'',
                                                                              u'default': True,
                                                                              u'description': u'',
                                                                              u'group': u'',
                                                                              u'hidden': True,
                                                                              u'name': u'--no-plain',
                                                                              u'nargs': u'0',
                                                                              u'required': False,
                                                                              u'type': u'bool',
                                                                              u'value': u'NO_PLAIN'},
                                                              u'--plain': {u'attr': {},
                                                                           u'category': u'',
                                                                           u'choices': [],
                                                                           u'completer': u'',
                                                                           u'default': False,
                                                                           u'description': u'Suppresses the automatic addition of *ssh(1)*/*scp(1)* flags. This flag\nis useful if you want to take care of authentication yourself or\nuse specific ssh/scp features.',
                                                                           u'group': u'',
                                                                           u'hidden': False,
                                                                           u'name': u'--plain',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'type': u'bool',
                                                                           u'value': u'PLAIN'},
                                                              u'--ssh-flag': {u'attr': {},
                                                                              u'category': u'',
                                                                              u'choices': [],
                                                                              u'completer': u'',
                                                                              u'default': None,
                                                                              u'description': u'Additional flags to be passed to *ssh(1)*. It is recommended that flags\nbe passed using an assignment operator and quotes. This flag will\nreplace occurences of ``%USER%\'\' and ``%INSTANCE%\'\' with their\ndereferenced values. Example:\n+\n  $ {command} example-instance --zone us-central1-a --ssh-flag="-vvv" --ssh-flag="-L 80:%INSTANCE%:80"\n+\nis equivalent to passing the flags ``--vvv\'\' and ``-L\n80:162.222.181.197:80\'\' to *ssh(1)* if the external IP address of\n\'example-instance\' is 162.222.181.197.',
                                                                              u'group': u'',
                                                                              u'hidden': False,
                                                                              u'name': u'--ssh-flag',
                                                                              u'nargs': u'0',
                                                                              u'required': False,
                                                                              u'type': u'string',
                                                                              u'value': u'SSH_FLAG'},
                                                              u'--ssh-key-file': {u'attr': {},
                                                                                  u'category': u'',
                                                                                  u'choices': [],
                                                                                  u'completer': u'',
                                                                                  u'default': None,
                                                                                  u'description': u"The path to the SSH key file. By default, this is ``~/.ssh/google_compute_engine''.",
                                                                                  u'group': u'',
                                                                                  u'hidden': False,
                                                                                  u'name': u'--ssh-key-file',
                                                                                  u'nargs': u'0',
                                                                                  u'required': False,
                                                                                  u'type': u'string',
                                                                                  u'value': u'SSH_KEY_FILE'},
                                                              u'--strict-host-key-checking': {u'attr': {},
                                                                                              u'category': u'',
                                                                                              u'choices': [u'yes',
                                                                                                           u'no',
                                                                                                           u'ask'],
                                                                                              u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u"Override the default behavior of StrictHostKeyChecking. By default,\nStrictHostKeyChecking is set to 'no' the first time you connect to an\ninstance and will be set to 'yes' for all subsequent connections. Use\nthis flag to specify a value for the connection. _STRICT_HOST_KEY_CHECKING_ must be one of: *yes*, *no*, *ask*.",
                                                                                              u'group': u'',
                                                                                              u'hidden': False,
                                                                                              u'name': u'--strict-host-key-checking',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'type': u'string',
                                                                                              u'value': u'STRICT_HOST_KEY_CHECKING'},
                                                              u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                          u'category': u'',
                                                                          u'choices': [],
                                                                          u'completer': u'',
                                                                          u'default': None,
                                                                          u'description': u"The zone of the instance to connect to. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                          u'group': u'',
                                                                          u'hidden': False,
                                                                          u'name': u'--zone',
                                                                          u'nargs': u'0',
                                                                          u'required': False,
                                                                          u'type': u'string',
                                                                          u'value': u'ZONE'}},
                                                   u'group': False,
                                                   u'groups': {},
                                                   u'hidden': False,
                                                   u'name': u'ssh',
                                                   u'path': [u'gcloud',
                                                             u'compute',
                                                             u'ssh'],
                                                   u'positionals': [{u'completer': u'',
                                                                     u'default': None,
                                                                     u'description': u"Specifies the instance to SSH into.\n+\n``USER'' specifies the username with which to SSH. If omitted,\n$USER from the environment is selected.",
                                                                     u'name': u'user-host',
                                                                     u'nargs': u'0',
                                                                     u'required': False,
                                                                     u'value': u'[USER@]INSTANCE'},
                                                                    {u'completer': u'',
                                                                     u'default': None,
                                                                     u'description': u"Flags and positionals passed to the underlying ssh implementation.\n+\n\nThe '--' argument must be specified between gcloud specific args on the left and SSH_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017. Example:\n+\n        $ {command} example-instance --zone us-central1-a -- -vvv -L 80:%INSTANCE%:80",
                                                                     u'name': u'ssh-args',
                                                                     u'nargs': u'...',
                                                                     u'required': False,
                                                                     u'value': u'SSH_ARGS'}],
                                                   u'release': u'GA',
                                                   u'sections': {u'DESCRIPTION': u"*ssh* is a thin wrapper around the *ssh(1)* command that\ntakes care of authentication and the translation of the\ninstance name into an IP address.\n\nThis command ensures that the user's public SSH key is present\nin the project's metadata. If the user does not have a public\nSSH key, one is generated using *ssh-keygen(1)* (if the `--quiet`\nflag is given, the generated key will have an empty passphrase).\n",
                                                                 u'EXAMPLES': u'To SSH into \'example-instance\' in zone ``us-central1-a\'\', run:\n\n  $ ssh example-instance --zone us-central1-a\n\nYou can also run a command on the virtual machine. For\nexample, to get a snapshot of the guest\'s process tree, run:\n\n  $ ssh example-instance --zone us-central1-a --command "ps -ejH"\n\nIf you are using the Google container virtual machine image, you\ncan SSH into one of your containers with:\n\n  $ ssh example-instance --zone us-central1-a --container CONTAINER\n'}},
                                          u'ssl-certificates': {u'capsule': u'List, create, and delete Google Compute Engine SSL certificates.',
                                                                u'commands': {u'create': {u'capsule': u'Create a Google Compute Engine SSL certificate.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--certificate': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The path to a local certificate file. The certificate must be in PEM\nformat.  The certificate chain must be no greater than 5 certs long. The\nchain must include at least one intermediate cert.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--certificate',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': True,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'LOCAL_FILE_PATH'},
                                                                                                     u'--description': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'An optional, textual description for the SSL certificate.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--description',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'DESCRIPTION'},
                                                                                                     u'--private-key': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The path to a local private key file. The private key must be in PEM\nformat and must use RSA or ECDSA encryption.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--private-key',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': True,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'LOCAL_FILE_PATH'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'create',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'ssl-certificates',
                                                                                                    u'create'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the SSL certificate.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'*create* is used to create SSL certificates which can be used to\nconfigure a target HTTPS proxy. An SSL certificate consists of a\ncertificate and private key. The private key is encrypted before it is\nstored.'}},
                                                                              u'delete': {u'capsule': u'Delete Google Compute Engine SSL certificates.',
                                                                                          u'commands': {},
                                                                                          u'flags': {},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'delete',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'ssl-certificates',
                                                                                                    u'delete'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The resources to delete.',
                                                                                                            u'name': u'names',
                                                                                                            u'nargs': u'+',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine SSL certificates.\nSSL certificates can only be deleted when no other resources (e.g.,\ntarget HTTPS proxies) refer to them.\n'}},
                                                                              u'describe': {u'capsule': u'Describe a Google Compute Engine SSL certificate.',
                                                                                            u'commands': {},
                                                                                            u'flags': {},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'describe',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'ssl-certificates',
                                                                                                      u'describe'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the resource to fetch.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with Google Compute\nEngine SSL certificate in a project.\n'}},
                                                                              u'list': {u'capsule': u'List Google Compute Engine SSL certificates.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--filter',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                   u'--limit': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--limit',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'LIMIT'},
                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': True,
                                                                                                                 u'description': u'',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': True,
                                                                                                                 u'name': u'--no-uri',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'NO_URI'},
                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--page-size',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                   u'--regexp': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--regexp',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'REGEXP'},
                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--sort-by',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'list',
                                                                                                                  u'value': u'FIELD'},
                                                                                                   u'--uri': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--uri',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'URI'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'list',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'ssl-certificates',
                                                                                                  u'list'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': [],
                                                                                                          u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                          u'name': u'names',
                                                                                                          u'nargs': u'*',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine SSL certificates in a project.\n',
                                                                                                      u'EXAMPLES': u'To list all SSL certificates in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all SSL certificates in a project, run:\n\n  $ list --uri\n'}}},
                                                                u'flags': {},
                                                                u'group': True,
                                                                u'groups': {},
                                                                u'hidden': False,
                                                                u'name': u'ssl-certificates',
                                                                u'path': [u'gcloud',
                                                                          u'compute',
                                                                          u'ssl-certificates'],
                                                                u'positionals': [],
                                                                u'release': u'GA',
                                                                u'sections': {u'DESCRIPTION': u'List, create, and delete Google Compute Engine SSL certificates.'}},
                                          u'target-http-proxies': {u'capsule': u'List, create, and delete target HTTP proxies.',
                                                                   u'commands': {u'create': {u'capsule': u'Create a target HTTP proxy.',
                                                                                             u'commands': {},
                                                                                             u'flags': {u'--description': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'An optional, textual description for the target HTTP proxy.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--description',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'DESCRIPTION'},
                                                                                                        u'--url-map': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'A reference to a URL map resource that defines the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTP proxy.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--url-map',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': True,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'URL_MAP'}},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'create',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'compute',
                                                                                                       u'target-http-proxies',
                                                                                                       u'create'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The name of the target HTTP proxy.',
                                                                                                               u'name': u'name',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u"\n*create* is used to create target HTTP proxies. A target\nHTTP proxy is referenced by one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTP proxy points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests.\n"}},
                                                                                 u'delete': {u'capsule': u'Delete target HTTP proxies.',
                                                                                             u'commands': {},
                                                                                             u'flags': {},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'delete',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'compute',
                                                                                                       u'target-http-proxies',
                                                                                                       u'delete'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The resources to delete.',
                                                                                                               u'name': u'names',
                                                                                                               u'nargs': u'+',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'*delete* deletes one or more target HTTP proxies.\n'}},
                                                                                 u'describe': {u'capsule': u'Display detailed information about a target HTTP proxy.',
                                                                                               u'commands': {},
                                                                                               u'flags': {},
                                                                                               u'group': False,
                                                                                               u'groups': {},
                                                                                               u'hidden': False,
                                                                                               u'name': u'describe',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'compute',
                                                                                                         u'target-http-proxies',
                                                                                                         u'describe'],
                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The name of the resource to fetch.',
                                                                                                                 u'name': u'name',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'value': u'NAME'}],
                                                                                               u'release': u'GA',
                                                                                               u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a target HTTP proxy\nin a project.\n'}},
                                                                                 u'list': {u'capsule': u'List Google Compute Engine target HTTP proxies.',
                                                                                           u'commands': {},
                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--filter',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                      u'--limit': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--limit',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'LIMIT'},
                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': True,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-uri',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_URI'},
                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--page-size',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                      u'--regexp': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--regexp',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'REGEXP'},
                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--sort-by',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'list',
                                                                                                                     u'value': u'FIELD'},
                                                                                                      u'--uri': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--uri',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'URI'}},
                                                                                           u'group': False,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'list',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'compute',
                                                                                                     u'target-http-proxies',
                                                                                                     u'list'],
                                                                                           u'positionals': [{u'completer': u'',
                                                                                                             u'default': [],
                                                                                                             u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                             u'name': u'names',
                                                                                                             u'nargs': u'*',
                                                                                                             u'required': False,
                                                                                                             u'value': u'NAME'}],
                                                                                           u'release': u'GA',
                                                                                           u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine target HTTP proxies in a project.\n',
                                                                                                         u'EXAMPLES': u'To list all target HTTP proxies in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target HTTP proxies in a project, run:\n\n  $ list --uri\n'}},
                                                                                 u'update': {u'capsule': u'Update a target HTTP proxy.',
                                                                                             u'commands': {},
                                                                                             u'flags': {u'--url-map': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'A reference to a URL map resource that will define the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTP proxy.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--url-map',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': True,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'URL_MAP'}},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'update',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'compute',
                                                                                                       u'target-http-proxies',
                                                                                                       u'update'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The name of the target HTTP proxy.',
                                                                                                               u'name': u'name',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u"*update* is used to change the URL map of existing\ntarget HTTP proxies. A target HTTP proxy is referenced\nby one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTP proxy in turn points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests.\n"}}},
                                                                   u'flags': {},
                                                                   u'group': True,
                                                                   u'groups': {},
                                                                   u'hidden': False,
                                                                   u'name': u'target-http-proxies',
                                                                   u'path': [u'gcloud',
                                                                             u'compute',
                                                                             u'target-http-proxies'],
                                                                   u'positionals': [],
                                                                   u'release': u'GA',
                                                                   u'sections': {u'DESCRIPTION': u'List, create, and delete target HTTP proxies.'}},
                                          u'target-https-proxies': {u'capsule': u'List, create, and delete target HTTPS proxies.',
                                                                    u'commands': {u'create': {u'capsule': u'Create a target HTTPS proxy.',
                                                                                              u'commands': {},
                                                                                              u'flags': {u'--description': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'An optional, textual description for the target HTTPS proxy.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--description',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'DESCRIPTION'},
                                                                                                         u'--ssl-certificate': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target HTTPS proxy.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--ssl-certificate',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'SSL_CERTIFICATE'},
                                                                                                         u'--url-map': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'A reference to a URL map resource that defines the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTPS proxy.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--url-map',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': True,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'URL_MAP'}},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'create',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'compute',
                                                                                                        u'target-https-proxies',
                                                                                                        u'create'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The name of the target HTTPS proxy.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u"\n*create* is used to create target HTTPS proxies. A target\nHTTPS proxy is referenced by one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTPS proxy points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests. The target\nHTTPS proxy also points to an SSL certificate used for\nserver-side authentication.\n"}},
                                                                                  u'delete': {u'capsule': u'Delete target HTTPS proxies.',
                                                                                              u'commands': {},
                                                                                              u'flags': {},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'delete',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'compute',
                                                                                                        u'target-https-proxies',
                                                                                                        u'delete'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The resources to delete.',
                                                                                                                u'name': u'names',
                                                                                                                u'nargs': u'+',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'*delete* deletes one or more target HTTPS proxies.\n'}},
                                                                                  u'describe': {u'capsule': u'Display detailed information about a target HTTPS proxy.',
                                                                                                u'commands': {},
                                                                                                u'flags': {},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'describe',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'compute',
                                                                                                          u'target-https-proxies',
                                                                                                          u'describe'],
                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The name of the resource to fetch.',
                                                                                                                  u'name': u'name',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'value': u'NAME'}],
                                                                                                u'release': u'GA',
                                                                                                u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a target HTTPS proxy\nin a project.\n'}},
                                                                                  u'list': {u'capsule': u'List Google Compute Engine target HTTPS proxies.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--filter',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                       u'--limit': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--limit',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'LIMIT'},
                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-uri',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_URI'},
                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--page-size',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                       u'--regexp': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--regexp',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'REGEXP'},
                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--sort-by',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'list',
                                                                                                                      u'value': u'FIELD'},
                                                                                                       u'--uri': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--uri',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'URI'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'list',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'target-https-proxies',
                                                                                                      u'list'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': [],
                                                                                                              u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                              u'name': u'names',
                                                                                                              u'nargs': u'*',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine target HTTPS proxies in a project.\n',
                                                                                                          u'EXAMPLES': u'To list all target HTTPS proxies in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target HTTPS proxies in a project, run:\n\n  $ list --uri\n'}},
                                                                                  u'update': {u'capsule': u'Update a target HTTPS proxy.',
                                                                                              u'commands': {},
                                                                                              u'flags': {u'--ssl-certificate': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target HTTPS proxy.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--ssl-certificate',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'SSL_CERTIFICATE'},
                                                                                                         u'--url-map': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'A reference to a URL map resource that defines the mapping of\nURLs to backend services. The URL map must exist and cannot be\ndeleted while referenced by a target HTTPS proxy.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--url-map',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'URL_MAP'}},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'update',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'compute',
                                                                                                        u'target-https-proxies',
                                                                                                        u'update'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The name of the target HTTPS proxy.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u"*update* is used to change the SSL certificate and/or URL map of\nexisting target HTTPS proxies. A target HTTPS proxy is referenced\nby one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget HTTPS proxy in turn points to a URL map that defines the rules\nfor routing the requests. The URL map's job is to map URLs to\nbackend services which handle the actual requests. The target\nHTTPS proxy also points to an SSL certificate used for\nserver-side authentication.\n"}}},
                                                                    u'flags': {},
                                                                    u'group': True,
                                                                    u'groups': {},
                                                                    u'hidden': False,
                                                                    u'name': u'target-https-proxies',
                                                                    u'path': [u'gcloud',
                                                                              u'compute',
                                                                              u'target-https-proxies'],
                                                                    u'positionals': [],
                                                                    u'release': u'GA',
                                                                    u'sections': {u'DESCRIPTION': u'List, create, and delete target HTTPS proxies.'}},
                                          u'target-instances': {u'capsule': u'Read and manipulate Google Compute Engine virtual target instances.',
                                                                u'commands': {u'create': {u'capsule': u'Create a target instance for handling traffic from a forwarding rule.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--description': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'An optional, textual description of the target instance.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--description',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'DESCRIPTION'},
                                                                                                     u'--instance': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The name of the virtual machine instance that will handle the traffic.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--instance',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': True,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'INSTANCE'},
                                                                                                     u'--instance-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The zone of the instance to operate on. If not specified, it will be set to the same as zone. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--instance-zone',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'INSTANCE_ZONE'},
                                                                                                     u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"The zone of the target instance to create the target instance in. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--zone',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'ZONE'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'create',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'target-instances',
                                                                                                    u'create'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the target instance.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'*create* is used to create a target instance for handling\ntraffic from one or more forwarding rules. Target instances\nare ideal for traffic that should be managed by a single\nsource. For more information on target instances, see\n[](https://cloud.google.com/compute/docs/protocol-forwarding/#targetinstances)\n'}},
                                                                              u'delete': {u'capsule': u'Delete target instances.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"The zone of the resources to delete. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--zone',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'ZONE'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'delete',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'target-instances',
                                                                                                    u'delete'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The resources to delete.',
                                                                                                            u'name': u'names',
                                                                                                            u'nargs': u'+',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine target\ninstances. Target instances can be deleted only if they are\nnot being used by any other resources like forwarding rules.\n'}},
                                                                              u'describe': {u'capsule': u'Describe a target instance.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"The zone of the resource to fetch. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--zone',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'ZONE'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'describe',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'target-instances',
                                                                                                      u'describe'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the resource to fetch.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine target instance in a project.\n'}},
                                                                              u'list': {u'capsule': u'List Google Compute Engine target instances.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--filter',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                   u'--limit': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--limit',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'LIMIT'},
                                                                                                   u'--no-uri': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': True,
                                                                                                                 u'description': u'',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': True,
                                                                                                                 u'name': u'--no-uri',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'NO_URI'},
                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--page-size',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'PAGE_SIZE'},
                                                                                                   u'--regexp': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--regexp',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'REGEXP'},
                                                                                                   u'--sort-by': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--sort-by',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'list',
                                                                                                                  u'value': u'FIELD'},
                                                                                                   u'--uri': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--uri',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'URI'},
                                                                                                   u'--zones': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': [],
                                                                                                                u'description': u'If provided, only resources from the given zones are queried.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--zones',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'list',
                                                                                                                u'value': u'ZONE'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'list',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'target-instances',
                                                                                                  u'list'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': [],
                                                                                                          u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                          u'name': u'names',
                                                                                                          u'nargs': u'*',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine target instances in a project.\n\nBy default, target instances from all zones are listed. The results can be narrowed\ndown by providing the ``--zones'' flag.\n",
                                                                                                      u'EXAMPLES': u"To list all target instances in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target instances in a project, run:\n\n  $ list --uri\n\nTo list all target instances in the ``us-central1-b'' and ``europe-west1-d'' zones,\nrun:\n\n  $ list --zones us-central1-b europe-west1-d\n"}}},
                                                                u'flags': {},
                                                                u'group': True,
                                                                u'groups': {},
                                                                u'hidden': False,
                                                                u'name': u'target-instances',
                                                                u'path': [u'gcloud',
                                                                          u'compute',
                                                                          u'target-instances'],
                                                                u'positionals': [],
                                                                u'release': u'GA',
                                                                u'sections': {u'DESCRIPTION': u'Read and manipulate Google Compute Engine virtual target instances.'}},
                                          u'target-pools': {u'capsule': u'Control Compute Engine target pools for network load balancing.',
                                                            u'commands': {u'add-health-checks': {u'capsule': u'Add an HTTP health check to a target pool.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {u'--http-health-check': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Specifies an HTTP health check object to add to the target pool.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--http-health-check',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': True,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                            u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u"The region of the target pool to add health checks to. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--region',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'REGION'}},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'add-health-checks',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'compute',
                                                                                                           u'target-pools',
                                                                                                           u'add-health-checks'],
                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The name of the target pool to which to add the health check.',
                                                                                                                   u'name': u'name',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'NAME'}],
                                                                                                 u'release': u'GA',
                                                                                                 u'sections': {u'DESCRIPTION': u'*add-health-checks* is used to add an HTTP health check\nto a target pool. Health checks are used to determine\nthe health status of instances in the target pool. Only one\nhealth check can be attached to a target pool, so this command\nwill fail if there as already a health check attached to the target\npool. For more information on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)'}},
                                                                          u'add-instances': {u'capsule': u'Add instances to a target pool.',
                                                                                             u'commands': {},
                                                                                             u'flags': {u'--instances': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Specifies a list of instances to add to the target pool.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--instances',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': True,
                                                                                                                         u'type': u'list',
                                                                                                                         u'value': u'INSTANCE'},
                                                                                                        u'--instances-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u"The zone of the instances to add to the target pool. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--instances-zone',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'INSTANCES_ZONE'},
                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the instances. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--region',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'REGION'},
                                                                                                        u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The zone of the instances to add to the target pool. DEPRECATED, use --instances-zone. If not specified, you will be prompted to select a zone. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--zone',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'ZONE'}},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'add-instances',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'compute',
                                                                                                       u'target-pools',
                                                                                                       u'add-instances'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The name of the target pool to which to add the instances.',
                                                                                                               u'name': u'name',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'*add-instances* is used to add one or more instances to a target pool.\nFor more information on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                          u'create': {u'capsule': u'Define a load-balanced pool of virtual machine instances.',
                                                                                      u'commands': {},
                                                                                      u'flags': {u'--backup-pool': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"Together with ``--failover-ratio'', this flag defines the fallback\nbehavior of the target pool (primary pool) to be created by this\ncommand. If the ratio of the healthy instances in the primary pool\nis at or below the specified ``--failover-ratio value'', then traffic\narriving at the load-balanced IP address will be directed to the\nbackup pool. If this flag is provided, then ``--failover-ratio'' is\nrequired.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--backup-pool',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'BACKUP_POOL'},
                                                                                                 u'--description': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'An optional description of this target pool.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--description',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'DESCRIPTION'},
                                                                                                 u'--failover-ratio': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u"Together with ``--backup-pool'', defines the fallback behavior of the\ntarget pool (primary pool) to be created by this command. If the\nratio of the healthy instances in the primary pool is at or below this\nnumber, traffic arriving at the load-balanced IP address will be\ndirected to the backup pool. For example, if 0.4 is chosen as the\nfailover ratio, then traffic will fail over to the backup pool if\nmore than 40% of the instances become unhealthy.\nIf not set, the traffic will be directed the\ninstances in this pool in the ``force'' mode, where traffic will be\nspread to the healthy instances with the best effort, or to all\ninstances when no instance is healthy.\nIf this flag is provided, then ``--backup-pool'' is required.",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--failover-ratio',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'FAILOVER_RATIO'},
                                                                                                 u'--health-check': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'DEPRECATED, use --http-health-check.\nSpecifies an HTTP health check resource to use to determine the health\nof instances in this pool. If no health check is specified, traffic will\nbe sent to all instances in this target pool as if the instances\nwere healthy, but the health status of this pool will appear as\nunhealthy as a warning that this target pool does not have a health\ncheck.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--health-check',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'HEALTH_CHECK'},
                                                                                                 u'--http-health-check': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Specifies an HTTP health check resource to use to determine the health\nof instances in this pool. If no health check is specified, traffic will\nbe sent to all instances in this target pool as if the instances\nwere healthy, but the health status of this pool will appear as\nunhealthy as a warning that this target pool does not have a health\ncheck.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--http-health-check',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                 u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"The region of the target pool to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--region',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'REGION'},
                                                                                                 u'--session-affinity': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [u'CLIENT_IP',
                                                                                                                                      u'CLIENT_IP_PROTO',
                                                                                                                                      u'GENERATED_COOKIE',
                                                                                                                                      u'NONE'],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': u'NONE',
                                                                                                                         u'description': u'The type of session affinity to use for this backend service. _SESSION_AFFINITY_ must be one of:\n+\n*CLIENT_IP*::: Route requests to instances based on the hash of the client\'s IP address.\n*CLIENT_IP_PROTO*::: Connections from the same client IP with the same IP protocol willgo to the same VM in the pool while that VM remains healthy. This option cannot be used for HTTP(s) load balancing.\n*GENERATED_COOKIE*::: Route requests to instances based on the contents of the "GCLB" cookie set by the load balancer.\n*NONE*::: Session affinity is disabled.\n+',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--session-affinity',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'SESSION_AFFINITY'}},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'create',
                                                                                      u'path': [u'gcloud',
                                                                                                u'compute',
                                                                                                u'target-pools',
                                                                                                u'create'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The name of the target pool.',
                                                                                                        u'name': u'name',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'value': u'NAME'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u"*create* is used to create a target pool. A target pool resource\ndefines a group of instances that can receive incoming traffic\nfrom forwarding rules. When a forwarding rule directs traffic to a\ntarget pool, Google Compute Engine picks an instance from the\ntarget pool based on a hash of the source and\ndestination IP addresses and ports. For more\ninformation on load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n\nTo add instances to a target pool, use 'gcloud compute\ntarget-pools add-instances'."}},
                                                                          u'delete': {u'capsule': u'Delete target pools.',
                                                                                      u'commands': {},
                                                                                      u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--region',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'REGION'}},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'delete',
                                                                                      u'path': [u'gcloud',
                                                                                                u'compute',
                                                                                                u'target-pools',
                                                                                                u'delete'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The resources to delete.',
                                                                                                        u'name': u'names',
                                                                                                        u'nargs': u'+',
                                                                                                        u'required': False,
                                                                                                        u'value': u'NAME'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine target pools.\n'}},
                                                                          u'describe': {u'capsule': u'Describe a Google Compute Engine target pool.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--region',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'REGION'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'describe',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'compute',
                                                                                                  u'target-pools',
                                                                                                  u'describe'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The name of the resource to fetch.',
                                                                                                          u'name': u'name',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine target pool in a project.'}},
                                                                          u'get-health': {u'capsule': u'Get the health of instances in a target pool.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"The region of the target pool to get health information for. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--region',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGION'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'get-health',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'target-pools',
                                                                                                    u'get-health'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the target pool.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'*get-health* displays the health of instances in a target pool.\n'}},
                                                                          u'list': {u'capsule': u'List Google Compute Engine target pools.',
                                                                                    u'commands': {},
                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--filter',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'EXPRESSION'},
                                                                                               u'--limit': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--limit',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'LIMIT'},
                                                                                               u'--no-uri': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': True,
                                                                                                             u'description': u'',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': True,
                                                                                                             u'name': u'--no-uri',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'NO_URI'},
                                                                                               u'--page-size': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--page-size',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                               u'--regexp': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--regexp',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'REGEXP'},
                                                                                               u'--regions': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': [],
                                                                                                              u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--regions',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'list',
                                                                                                              u'value': u'REGION'},
                                                                                               u'--sort-by': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--sort-by',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'list',
                                                                                                              u'value': u'FIELD'},
                                                                                               u'--uri': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--uri',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'URI'}},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'list',
                                                                                    u'path': [u'gcloud',
                                                                                              u'compute',
                                                                                              u'target-pools',
                                                                                              u'list'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': [],
                                                                                                      u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                      u'name': u'names',
                                                                                                      u'nargs': u'*',
                                                                                                      u'required': False,
                                                                                                      u'value': u'NAME'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine target pools in a project.\n\nBy default, target pools from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                  u'EXAMPLES': u"To list all target pools in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target pools in a project, run:\n\n  $ list --uri\n\nTo list all target pools in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}},
                                                                          u'remove-health-checks': {u'capsule': u'Remove an HTTP health check from a target pool.',
                                                                                                    u'commands': {},
                                                                                                    u'flags': {u'--http-health-check': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Specifies an HTTP health check object to remove from the target pool.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--http-health-check',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': True,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'HTTP_HEALTH_CHECK'},
                                                                                                               u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u"The region of the target pool to remove health checks from. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--region',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'REGION'}},
                                                                                                    u'group': False,
                                                                                                    u'groups': {},
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'remove-health-checks',
                                                                                                    u'path': [u'gcloud',
                                                                                                              u'compute',
                                                                                                              u'target-pools',
                                                                                                              u'remove-health-checks'],
                                                                                                    u'positionals': [{u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The name of the target pool from which to remove the health check.',
                                                                                                                      u'name': u'name',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'value': u'NAME'}],
                                                                                                    u'release': u'GA',
                                                                                                    u'sections': {u'DESCRIPTION': u'*remove-health-checks* is used to remove an HTTP health check\nfrom a target pool. Health checks are used to determine\nthe health status of instances in the target pool. For more\ninformation on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)'}},
                                                                          u'remove-instances': {u'capsule': u'Remove instances from a target pool.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--instances': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'Specifies a list of instances to remove from the target pool.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--instances',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': True,
                                                                                                                            u'type': u'list',
                                                                                                                            u'value': u'INSTANCE'},
                                                                                                           u'--instances-zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u"The zone of the instances to remove from the target pool. If not specified, you will be prompted to select a zone.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/zone'' property:\n+\n  $ gcloud config set compute/zone ZONE\n+\nA list of zones can be fetched by running:\n+\n  $ gcloud compute zones list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/zone\n+\nAlternatively, the zone can be stored in the environment variable\n``CLOUDSDK_COMPUTE_ZONE''.",
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--instances-zone',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'INSTANCES_ZONE'},
                                                                                                           u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The region of the target pool to operate on. If not specified it will be set the region of the instances. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--region',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'REGION'},
                                                                                                           u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The zone of the instances to remove from the target pool. DEPRECATED, use --instances-zone. If not specified, you will be prompted to select a zone. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--zone',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'ZONE'}},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'remove-instances',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'compute',
                                                                                                          u'target-pools',
                                                                                                          u'remove-instances'],
                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The name of the target pool from which to remove the instances.',
                                                                                                                  u'name': u'name',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'value': u'NAME'}],
                                                                                                u'release': u'GA',
                                                                                                u'sections': {u'DESCRIPTION': u'*remove-instances* is used to remove one or more instances from a\ntarget pool.\nFor more information on health checks and load balancing, see\n[](https://cloud.google.com/compute/docs/load-balancing-and-autoscaling/)\n'}},
                                                                          u'set-backup': {u'capsule': u'Set a backup pool for a target pool.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--backup-pool': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Name of the target pool that will serve as backup.',
                                                                                                                        u'group': u'set-backup.1',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--backup-pool',
                                                                                                                        u'nargs': u'?',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'BACKUP_POOL'},
                                                                                                     u'--failover-ratio': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The new failover ratio value for the target pool. This must be a float in the range of [0, 1].',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--failover-ratio',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'FAILOVER_RATIO'},
                                                                                                     u'--no-backup-pool': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Unsets the backup pool. This disables failover.',
                                                                                                                           u'group': u'set-backup.1',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--no-backup-pool',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_BACKUP_POOL'},
                                                                                                     u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u"The region of the target pool to set a backup pool for. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--region',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGION'}},
                                                                                          u'group': False,
                                                                                          u'groups': {u'set-backup.1': {u'description': u'At most one of these may be specified:',
                                                                                                                        u'is_mutex': True,
                                                                                                                        u'is_required': False}},
                                                                                          u'hidden': False,
                                                                                          u'name': u'set-backup',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'target-pools',
                                                                                                    u'set-backup'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The name of the target pool for which to set the backup pool.',
                                                                                                            u'name': u'name',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u"*set-backup* is used to set a backup target pool for a primary\ntarget pool, which defines the fallback behavior of the primary\npool. If the ratio of the healthy instances in the primary pool\nis at or below the specified ``--failover-ratio value'', then traffic\narriving at the load-balanced IP address will be directed to the\nbackup pool.\n",
                                                                                                        u'EXAMPLES': u"To cause `TARGET-POOL` (in region `us-central1`) to fail over\nto `BACKUP-POOL` when more than half of the `TARGET-POOL`\ninstances are unhealthy, run:\n\n  $ set-backup TARGET-POOL --backup-pool BACKUP-POOL --failover-ratio 0.5 --region us-central1\n\nTo remove `BACKUP-POOL` as a backup to `TARGET-POOL`, run:\n\n  $ set-backup TARGET-POOL --backup-pool '' --region us-central1\n"}}},
                                                            u'flags': {},
                                                            u'group': True,
                                                            u'groups': {},
                                                            u'hidden': False,
                                                            u'name': u'target-pools',
                                                            u'path': [u'gcloud',
                                                                      u'compute',
                                                                      u'target-pools'],
                                                            u'positionals': [],
                                                            u'release': u'GA',
                                                            u'sections': {u'DESCRIPTION': u'Control Compute Engine target pools for network load balancing.'}},
                                          u'target-ssl-proxies': {u'capsule': u'List, create, and delete target SSL proxies.',
                                                                  u'commands': {u'create': {u'capsule': u'Create a target SSL proxy.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'A backend service that will be used for connections to the target SSL\nproxy.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--backend-service',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'BACKEND_SERVICE'},
                                                                                                       u'--description': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'An optional, textual description for the target SSL proxy.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--description',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                       u'--proxy-header': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [u'NONE',
                                                                                                                                        u'PROXY_V1'],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': u'NONE',
                                                                                                                           u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Enables PROXY protocol (version 1) for passing client connection information.\n+',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--proxy-header',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'PROXY_HEADER'},
                                                                                                       u'--ssl-certificate': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target SSL proxy.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--ssl-certificate',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'SSL_CERTIFICATE'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'create',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'target-ssl-proxies',
                                                                                                      u'create'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the target SSL proxy.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'\n*create* is used to create target SSL proxies. A target\nSSL proxy is referenced by one or more forwarding rules which\ndefine which packets the proxy is responsible for routing. The\ntarget SSL proxy points to a backend service which handle the\nactual requests. The target SSL proxy also points to an SSL\ncertificate used for server-side authentication.\n'}},
                                                                                u'delete': {u'capsule': u'Delete target SSL proxies.',
                                                                                            u'commands': {},
                                                                                            u'flags': {},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'delete',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'target-ssl-proxies',
                                                                                                      u'delete'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The names of the target SSL proxies.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'+',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'*delete* deletes one or more target SSL proxies.\n'}},
                                                                                u'describe': {u'capsule': u'Display detailed information about a target SSL proxy.',
                                                                                              u'commands': {},
                                                                                              u'flags': {},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'describe',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'compute',
                                                                                                        u'target-ssl-proxies',
                                                                                                        u'describe'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The name of the target SSL proxy.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a target SSL proxy\nin a project.\n'}},
                                                                                u'list': {u'capsule': u'List Google Compute Engine target SSL proxies.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--filter',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                     u'--limit': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--limit',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'LIMIT'},
                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': True,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--no-uri',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'NO_URI'},
                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--page-size',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                     u'--regexp': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--regexp',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'REGEXP'},
                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--sort-by',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'list',
                                                                                                                    u'value': u'FIELD'},
                                                                                                     u'--uri': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--uri',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'URI'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'list',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'compute',
                                                                                                    u'target-ssl-proxies',
                                                                                                    u'list'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': [],
                                                                                                            u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                            u'name': u'names',
                                                                                                            u'nargs': u'*',
                                                                                                            u'required': False,
                                                                                                            u'value': u'NAME'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine target SSL proxies in a project.\n',
                                                                                                        u'EXAMPLES': u'To list all target SSL proxies in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target SSL proxies in a project, run:\n\n  $ list --uri\n'}},
                                                                                u'update': {u'capsule': u'Update a target SSL proxy.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--backend-service': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'A backend service that will be used for connections to the target SSL\nproxy.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--backend-service',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'BACKEND_SERVICE'},
                                                                                                       u'--proxy-header': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [u'NONE',
                                                                                                                                        u'PROXY_V1'],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The type of proxy protocol header to be sent to the backend. _PROXY_HEADER_ must be one of:\n+\n*NONE*::: No proxy header is added.\n*PROXY_V1*::: Enables PROXY protocol (version 1) for passing client connection information.\n+',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--proxy-header',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'PROXY_HEADER'},
                                                                                                       u'--ssl-certificate': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'A reference to an SSL certificate resource that is used for\nserver-side authentication. The SSL certificate must exist and cannot\nbe deleted while referenced by a target SSL proxy.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--ssl-certificate',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'SSL_CERTIFICATE'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'update',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'target-ssl-proxies',
                                                                                                      u'update'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the target SSL proxy.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'\n*update* is used to change the SSL certificate, backend\nservice or proxy header of existing target SSL proxies. A\ntarget SSL proxy is referenced by one or more forwarding rules\nwhich define which packets the proxy is responsible for\nrouting. The target SSL proxy in turn points to a backend\nservice which will handle the requests. The target SSL proxy\nalso points to an SSL certificate used for server-side\nauthentication.  '}}},
                                                                  u'flags': {},
                                                                  u'group': True,
                                                                  u'groups': {},
                                                                  u'hidden': False,
                                                                  u'name': u'target-ssl-proxies',
                                                                  u'path': [u'gcloud',
                                                                            u'compute',
                                                                            u'target-ssl-proxies'],
                                                                  u'positionals': [],
                                                                  u'release': u'GA',
                                                                  u'sections': {u'DESCRIPTION': u'List, create, and delete target SSL proxies.'}},
                                          u'target-vpn-gateways': {u'capsule': u'Read and manipulate Google Compute Engine VPN Gateways.',
                                                                   u'commands': {u'create': {u'capsule': u'Create a target VPN Gateway.',
                                                                                             u'commands': {},
                                                                                             u'flags': {u'--description': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'An optional, textual description for the target VPN Gateway.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--description',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'DESCRIPTION'},
                                                                                                        u'--network': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'A reference to a network in this project to\ncontain the VPN Gateway.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--network',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': True,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'NETWORK'},
                                                                                                        u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"The region of the Target VPN Gateway to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--region',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'REGION'}},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'create',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'compute',
                                                                                                       u'target-vpn-gateways',
                                                                                                       u'create'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The name of the target VPN Gateway.',
                                                                                                               u'name': u'name',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'\n*create* is used to create a target VPN Gateway. A target VPN\nGateway can reference one or more VPN tunnels that connect it to\nexternal VPN gateways. A VPN Gateway may also be referenced by\none or more forwarding rules that define which packets the\ngateway is responsible for routing.\n'}},
                                                                                 u'delete': {u'capsule': u'Delete target vpn gateways.',
                                                                                             u'commands': {},
                                                                                             u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--region',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'REGION'}},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'delete',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'compute',
                                                                                                       u'target-vpn-gateways',
                                                                                                       u'delete'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The resources to delete.',
                                                                                                               u'name': u'names',
                                                                                                               u'nargs': u'+',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine target vpn\ngateways.\n'}},
                                                                                 u'describe': {u'capsule': u'Describe a Google Compute Engine target vpn gateway.',
                                                                                               u'commands': {},
                                                                                               u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--region',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'REGION'}},
                                                                                               u'group': False,
                                                                                               u'groups': {},
                                                                                               u'hidden': False,
                                                                                               u'name': u'describe',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'compute',
                                                                                                         u'target-vpn-gateways',
                                                                                                         u'describe'],
                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The name of the resource to fetch.',
                                                                                                                 u'name': u'name',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'value': u'NAME'}],
                                                                                               u'release': u'GA',
                                                                                               u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine target vpn gateway in a project.\n'}},
                                                                                 u'list': {u'capsule': u'List Google Compute Engine target VPN gateways.',
                                                                                           u'commands': {},
                                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--filter',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'EXPRESSION'},
                                                                                                      u'--limit': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--limit',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'LIMIT'},
                                                                                                      u'--no-uri': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': True,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-uri',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_URI'},
                                                                                                      u'--page-size': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--page-size',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                                      u'--regexp': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--regexp',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'REGEXP'},
                                                                                                      u'--regions': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': [],
                                                                                                                     u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--regions',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'list',
                                                                                                                     u'value': u'REGION'},
                                                                                                      u'--sort-by': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--sort-by',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'list',
                                                                                                                     u'value': u'FIELD'},
                                                                                                      u'--uri': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--uri',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'URI'}},
                                                                                           u'group': False,
                                                                                           u'groups': {},
                                                                                           u'hidden': False,
                                                                                           u'name': u'list',
                                                                                           u'path': [u'gcloud',
                                                                                                     u'compute',
                                                                                                     u'target-vpn-gateways',
                                                                                                     u'list'],
                                                                                           u'positionals': [{u'completer': u'',
                                                                                                             u'default': [],
                                                                                                             u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                             u'name': u'names',
                                                                                                             u'nargs': u'*',
                                                                                                             u'required': False,
                                                                                                             u'value': u'NAME'}],
                                                                                           u'release': u'GA',
                                                                                           u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine target VPN gateways in a project.\n\nBy default, target VPN gateways from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                         u'EXAMPLES': u"To list all target VPN gateways in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all target VPN gateways in a project, run:\n\n  $ list --uri\n\nTo list all target VPN gateways in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}}},
                                                                   u'flags': {},
                                                                   u'group': True,
                                                                   u'groups': {},
                                                                   u'hidden': False,
                                                                   u'name': u'target-vpn-gateways',
                                                                   u'path': [u'gcloud',
                                                                             u'compute',
                                                                             u'target-vpn-gateways'],
                                                                   u'positionals': [],
                                                                   u'release': u'GA',
                                                                   u'sections': {u'DESCRIPTION': u'Read and manipulate Google Compute Engine VPN Gateways.'}},
                                          u'url-maps': {u'capsule': u'List, create, and delete URL maps.',
                                                        u'commands': {u'add-host-rule': {u'capsule': u'Add a rule to a URL map to map hosts to a path matcher.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--description': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'An optional, textual description for the host rule.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--description',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'DESCRIPTION'},
                                                                                                    u'--hosts': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u"The set of hosts to match requests against. Each host must be\na fully qualified domain name (FQDN) with the exception that\nthe host can begin with a ``*'' or ``*-''. ``*'' acts as a\nglob and will match any string of atoms to the left where an\natom is separated by dots (``.'') or dashes (``-'').",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--hosts',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': True,
                                                                                                                 u'type': u'list',
                                                                                                                 u'value': u'HOST'},
                                                                                                    u'--path-matcher-name': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The name of the patch matcher to use if a request matches this\nhost rule. The patch matcher must already exist in the URL map\n(see `gcloud compute url-maps add-path-matcher`).',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--path-matcher-name',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': True,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'PATH_MATCHER_NAME'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'add-host-rule',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'compute',
                                                                                                   u'url-maps',
                                                                                                   u'add-host-rule'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The name of the URL map.',
                                                                                                           u'name': u'name',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'NAME'}],
                                                                                         u'release': u'GA',
                                                                                         u'sections': {u'DESCRIPTION': u'*add-host-rule* is used to add a mapping of hosts to a patch\nmatcher in a URL map. The mapping will match the host\ncomponent of HTTP requests to path matchers which in turn map\nthe request to a backend service. Before adding a host rule,\nat least one path matcher must exist in the URL map to take\ncare of the path component of the requests.\n`gcloud compute url-maps add-path-matcher` or\n`gcloud compute url-maps edit` can be used to add path matchers.\n',
                                                                                                       u'EXAMPLES': u"To create a host rule mapping the ```*-foo.google.com``` and\n```google.com``` hosts to the ```www``` path matcher, run:\n\n  $ add-host-rule MY-URL-MAP --hosts '*-foo.google.com,google.com' --path-matcher-name www\n"}},
                                                                      u'add-path-matcher': {u'capsule': u'Add a path matcher to a URL map.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--default-service': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'A backend service that will be used for requests that the path matcher cannot match.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--default-service',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': True,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'DEFAULT_SERVICE'},
                                                                                                       u'--delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'If provided and a path matcher is orphaned as a result of this command, the command removes the orphaned path matcher instead of failing.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--delete-orphaned-path-matcher',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'DELETE_ORPHANED_PATH_MATCHER'},
                                                                                                       u'--description': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'An optional, textual description for the path matcher.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--description',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'DESCRIPTION'},
                                                                                                       u'--existing-host': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'An existing host rule to tie the new path matcher to. Although\nhost rules can contain more than one host, only a single host\nis needed to uniquely identify the host rule.',
                                                                                                                            u'group': u'add-path-matcher.1',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--existing-host',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'EXISTING_HOST'},
                                                                                                       u'--new-hosts': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'If specified, a new host rule with the given hosts is created and the path matcher is tied to the new host rule.',
                                                                                                                        u'group': u'add-path-matcher.1',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--new-hosts',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'list',
                                                                                                                        u'value': u'NEW_HOST'},
                                                                                                       u'--no-delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': True,
                                                                                                                                              u'name': u'--no-delete-orphaned-path-matcher',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'NO_DELETE_ORPHANED_PATH_MATCHER'},
                                                                                                       u'--path-matcher-name': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The name to assign to the path matcher.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--path-matcher-name',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'PATH_MATCHER_NAME'},
                                                                                                       u'--path-rules': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': {},
                                                                                                                         u'description': u'Rules for mapping request paths to services.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--path-rules',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'dict',
                                                                                                                         u'value': u'PATH=SERVICE'}},
                                                                                            u'group': False,
                                                                                            u'groups': {u'add-path-matcher.1': {u'description': u'At most one of these may be specified:',
                                                                                                                                u'is_mutex': True,
                                                                                                                                u'is_required': False}},
                                                                                            u'hidden': False,
                                                                                            u'name': u'add-path-matcher',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'url-maps',
                                                                                                      u'add-path-matcher'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the URL map.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u"*add-path-matcher* is used to add a path matcher to a URL map. A path\nmatcher maps HTTP request paths to backend services. Each path\nmatcher must be referenced by at least one host rule. This\ncommand can create a new host rule through the ``--new-hosts''\nflag or it can reconfigure an existing host rule to point to\nthe newly added path matcher using ``--existing-host''. In the\nlatter case, if a path matcher is orphaned as a result of the\noperation, this command will fail unless\n``--delete-orphaned-path-matcher'' is provided.\n",
                                                                                                          u'EXAMPLES': u"To create a rule for mapping the path ```/search/*``` to the\nhypothetical ```search-service``` and ```/images/*``` to the\n```images-service``` under the hosts ```google.com``` and\n```*.google.com```, run:\n\n  $ add-path-matcher MY-URL-MAP --path-matcher-name MY-MATCHER --default-service MY-DEFAULT-SERVICE --path-rules '/search/*=search_service,/images/*=images-service' --new-hosts 'google.com,*.google.com'\n\nNote that a default service must be provided to handle paths\nfor which there is no mapping.\n"}},
                                                                      u'create': {u'capsule': u'Create a URL map.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--default-service': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'A backend service that will be used for requests for which this URL map has no mappings.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--default-service',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': True,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'DEFAULT_SERVICE'},
                                                                                             u'--description': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'An optional, textual description for the URL map.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--description',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'DESCRIPTION'}},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'create',
                                                                                  u'path': [u'gcloud',
                                                                                            u'compute',
                                                                                            u'url-maps',
                                                                                            u'create'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The name of the URL map.',
                                                                                                    u'name': u'name',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAME'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u"\n*create* is used to create URL maps which map HTTP and\nHTTPS request URLs to backend services. Mappings are done\nusing a longest-match strategy.\n\nThere are two components to a mapping: a host rule and a path\nmatcher. A host rule maps one or more hosts to a path\nmatcher. A path matcher maps request paths to backend\nservices. For example, a host rule can map the hosts\n``*.google.com'' and ``google.com'' to a path matcher called\n``www''. The ``www'' path matcher in turn can map the path\n``/search/*'' to the search backend service and everything\nelse to a default backend service.\n\nHost rules and patch matchers can be added to the URL map\nafter the map is created by using `gcloud compute url-maps edit`\nor by using `gcloud compute url-maps add-path-matcher`\nand `gcloud compute url-maps add-host-rule`.\n"}},
                                                                      u'delete': {u'capsule': u'Delete URL maps.',
                                                                                  u'commands': {},
                                                                                  u'flags': {},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'delete',
                                                                                  u'path': [u'gcloud',
                                                                                            u'compute',
                                                                                            u'url-maps',
                                                                                            u'delete'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The resources to delete.',
                                                                                                    u'name': u'names',
                                                                                                    u'nargs': u'+',
                                                                                                    u'required': False,
                                                                                                    u'value': u'NAME'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'*delete* deletes one or more URL maps.'}},
                                                                      u'describe': {u'capsule': u'Describe a URL map.',
                                                                                    u'commands': {},
                                                                                    u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--region',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'REGION'}},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'describe',
                                                                                    u'path': [u'gcloud',
                                                                                              u'compute',
                                                                                              u'url-maps',
                                                                                              u'describe'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The name of the resource to fetch.',
                                                                                                      u'name': u'name',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'value': u'NAME'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a URL map in a\nproject.\n'}},
                                                                      u'edit': {u'capsule': u'Modify URL maps.',
                                                                                u'commands': {},
                                                                                u'flags': {},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'edit',
                                                                                u'path': [u'gcloud',
                                                                                          u'compute',
                                                                                          u'url-maps',
                                                                                          u'edit'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'The name of the URL map.',
                                                                                                  u'name': u'name',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'NAME'}],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u"*edit* can be used to modify a URL map. The URL map\nresource is fetched from the server and presented in a text\neditor. After the file is saved and closed, this command will\nupdate the resource. Only fields that can be modified are\ndisplayed in the editor.\n\nThe editor used to modify the resource is chosen by inspecting\nthe ``EDITOR'' environment variable.\n"}},
                                                                      u'invalidate-cdn-cache': {u'capsule': u'Invalidate specified objects for a URL map in Cloud CDN caches.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--async': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'Do not wait for the operation to complete.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--async',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'ASYNC'},
                                                                                                           u'--host': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'If set, this invalidation will apply only to requests to the\nspecified host.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--host',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'HOST'},
                                                                                                           u'--no-async': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': True,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-async',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_ASYNC'},
                                                                                                           u'--path': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u"A path specifying which objects to invalidate. PATH must start with\n``/'' and the only place a ``*'' is allowed is at the end following a\n``/''. It will be matched against URL paths, which do not include\nscheme, host, or any text after the first ``?'' or ``#'' (and those\ncharacters are not allowed here). For example, for the URL\n``https://example.com/whatever/x.html?a=b'', the path is\n``/whatever/x.html''.\n+\nIf PATH ends with ``*'', the preceding string is a prefix, and all URLs\nwhose paths begin with it will be invalidated. If PATH doesn't end with\n``*'', then only URLs with exactly that path will be invalidated.\n+\nExamples:\n- ``'', ``*'', anything that doesn't start with ``/'': error\n- ``/'': just the root URL\n- ``/*'': everything\n- ``/x/y'': ``/x/y'' only (and not ``/x/y/'')\n- ``/x/y/'': ``/x/y/'' only (and not ``/x/y'')\n- ``/x/y/*'': ``/x/y/'' and everything under it",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--path',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': True,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'PATH'}},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'invalidate-cdn-cache',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'compute',
                                                                                                          u'url-maps',
                                                                                                          u'invalidate-cdn-cache'],
                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The name of the URL map.',
                                                                                                                  u'name': u'name',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'value': u'URLMAP'}],
                                                                                                u'release': u'GA',
                                                                                                u'sections': {u'DESCRIPTION': u'\n*invalidate-cdn-cache* requests that Cloud CDN stop using cached content for\nresources at a particular URL path or set of URL paths.\n\n*invalidate-cdn-cache* may succeed even if no content is cached for some or all\nURLs with the given path.\n'}},
                                                                      u'list': {u'capsule': u'List Google Compute Engine URL maps.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--filter',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'EXPRESSION'},
                                                                                           u'--limit': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--limit',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'LIMIT'},
                                                                                           u'--no-uri': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': True,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--no-uri',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'NO_URI'},
                                                                                           u'--page-size': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--page-size',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                           u'--regexp': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--regexp',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'REGEXP'},
                                                                                           u'--sort-by': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--sort-by',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'list',
                                                                                                          u'value': u'FIELD'},
                                                                                           u'--uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': False,
                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'URI'}},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'list',
                                                                                u'path': [u'gcloud',
                                                                                          u'compute',
                                                                                          u'url-maps',
                                                                                          u'list'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': [],
                                                                                                  u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                  u'name': u'names',
                                                                                                  u'nargs': u'*',
                                                                                                  u'required': False,
                                                                                                  u'value': u'NAME'}],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine URL maps in a project.\n',
                                                                                              u'EXAMPLES': u'To list all URL maps in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all URL maps in a project, run:\n\n  $ list --uri\n'}},
                                                                      u'list-cdn-cache-invalidations': {u'capsule': u'List Cloud CDN cache invalidations for a URL map.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--limit': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The maximum number of invalidations to list.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--limit',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'LIMIT'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'list-cdn-cache-invalidations',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'compute',
                                                                                                                  u'url-maps',
                                                                                                                  u'list-cdn-cache-invalidations'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The name of the URL map.',
                                                                                                                          u'name': u'urlmap',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'URLMAP'}],
                                                                                                        u'release': u'GA',
                                                                                                        u'sections': {u'DESCRIPTION': u'List Cloud CDN cache invalidations for a URL map. A cache invalidation instructs\nCloud CDN to stop using cached content. You can list invalidations to check\nwhich have completed.\n'}},
                                                                      u'remove-host-rule': {u'capsule': u'Remove a host rule from a URL map.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                           u'category': u'',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': False,
                                                                                                                                           u'description': u'If provided and a path matcher is orphaned as a result of this command, the command removes the orphaned path matcher instead of failing.',
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--delete-orphaned-path-matcher',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'bool',
                                                                                                                                           u'value': u'DELETE_ORPHANED_PATH_MATCHER'},
                                                                                                       u'--host': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'One of the hosts in the host rule to remove.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--host',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': True,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'HOST'},
                                                                                                       u'--no-delete-orphaned-path-matcher': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': False,
                                                                                                                                              u'description': u'',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': True,
                                                                                                                                              u'name': u'--no-delete-orphaned-path-matcher',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'bool',
                                                                                                                                              u'value': u'NO_DELETE_ORPHANED_PATH_MATCHER'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'remove-host-rule',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'compute',
                                                                                                      u'url-maps',
                                                                                                      u'remove-host-rule'],
                                                                                            u'positionals': [{u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the URL map.',
                                                                                                              u'name': u'name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'value': u'NAME'}],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u"*remove-host-rule* is used to remove a host rule from a URL map. When\na host rule is removed, its path matcher is only removed if\nit is not referenced by any other host rules and\n``--delete-orphaned-path-matcher'' is provided.\n",
                                                                                                          u'EXAMPLES': u"To remove a host rule that contains the host ``google.com''\nfrom the URL map named ``MY-URL-MAP'', you can use this\ncommand:\n\n  $ remove-host-rule MY-URL-MAP --host google.com\n"}},
                                                                      u'remove-path-matcher': {u'capsule': u'Remove a path matcher from a URL map.',
                                                                                               u'commands': {},
                                                                                               u'flags': {u'--path-matcher-name': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The name of the path matcher to remove.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--path-matcher-name',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'PATH_MATCHER_NAME'}},
                                                                                               u'group': False,
                                                                                               u'groups': {},
                                                                                               u'hidden': False,
                                                                                               u'name': u'remove-path-matcher',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'compute',
                                                                                                         u'url-maps',
                                                                                                         u'remove-path-matcher'],
                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The name of the URL map.',
                                                                                                                 u'name': u'name',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'value': u'NAME'}],
                                                                                               u'release': u'GA',
                                                                                               u'sections': {u'DESCRIPTION': u'*remove-path-matcher* is used to remove a path matcher from a URL\n map. When a path matcher is removed, all host rules that\n refer to the path matcher are also removed.\n',
                                                                                                             u'EXAMPLES': u"To remove the path matcher named ``MY-MATCHER'' from the URL map named\n``MY-URL-MAP'', you can use this command:\n\n  $ remove-path-matcher MY-URL-MAP --path-matcher MY-MATCHER\n"}},
                                                                      u'set-default-service': {u'capsule': u'Change the default service of a URL map.',
                                                                                               u'commands': {},
                                                                                               u'flags': {u'--default-service': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'A backend service that will be used for requests for which this URL map has no mappings.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--default-service',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': True,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'DEFAULT_SERVICE'}},
                                                                                               u'group': False,
                                                                                               u'groups': {},
                                                                                               u'hidden': False,
                                                                                               u'name': u'set-default-service',
                                                                                               u'path': [u'gcloud',
                                                                                                         u'compute',
                                                                                                         u'url-maps',
                                                                                                         u'set-default-service'],
                                                                                               u'positionals': [{u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The name of the URL map.',
                                                                                                                 u'name': u'name',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'value': u'NAME'}],
                                                                                               u'release': u'GA',
                                                                                               u'sections': {u'DESCRIPTION': u'*set-default-service* is used to change the default service of a URL\nmap. The default service is used for any requests for which\nthere is no mapping in the URL map.\n'}}},
                                                        u'flags': {},
                                                        u'group': True,
                                                        u'groups': {},
                                                        u'hidden': False,
                                                        u'name': u'url-maps',
                                                        u'path': [u'gcloud',
                                                                  u'compute',
                                                                  u'url-maps'],
                                                        u'positionals': [],
                                                        u'release': u'GA',
                                                        u'sections': {u'DESCRIPTION': u'List, create, and delete URL maps.'}},
                                          u'vpn-tunnels': {u'capsule': u'Read and manipulate Google Compute Engine VPN Tunnels.',
                                                           u'commands': {u'create': {u'capsule': u'Create a VPN tunnel.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--description': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'An optional, textual description for the target VPN tunnel.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--description',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'DESCRIPTION'},
                                                                                                u'--ike-networks': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--ike-networks',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'list',
                                                                                                                    u'value': u'IKE_NETWORKS'},
                                                                                                u'--ike-version': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [1,
                                                                                                                                2],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Internet Key Exchange protocol version number. Default is 2. _IKE_VERSION_ must be one of: *1*, *2*.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--ike-version',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'IKE_VERSION'},
                                                                                                u'--local-traffic-selector': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Traffic selector is an agreement between IKE peers to permit traffic through a tunnel if the traffic matches a specified pair of local and remote addresses.\n+\nlocal_traffic_selector allows to configure the local addresses that are permitted. The value should be a comma separated list of CIDR formatted strings. Example: 192.168.0.0/16,10.0.0.0/24.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--local-traffic-selector',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'CIDR'},
                                                                                                u'--peer-address': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'A valid IP-v4 address representing the remote tunnel endpoint',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--peer-address',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': True,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'PEER_ADDRESS'},
                                                                                                u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u"The region of the VPN Tunnel to create. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--region',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'REGION'},
                                                                                                u'--remote-traffic-selector': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'Traffic selector is an agreement between IKE peers to permit traffic through a tunnel if the traffic matches a specified pair of local and remote addresses.\n+\nremote_traffic_selector allows to configure the remote addresses that are permitted. The value should be a comma separated list of CIDR formatted strings. Example: 192.168.0.0/16,10.0.0.0/24.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--remote-traffic-selector',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'CIDR'},
                                                                                                u'--router': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The Router to use for dynamic routing.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--router',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'ROUTER'},
                                                                                                u'--shared-secret': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'A shared secret consisting of printable characters.  Valid\narguments match the regular expression [ -~]+',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--shared-secret',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': True,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'SHARED_SECRET'},
                                                                                                u'--target-vpn-gateway': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'A reference to a target vpn gateway',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--target-vpn-gateway',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': True,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'TARGET_VPN_GATEWAY'},
                                                                                                u'--target-vpn-gateway-region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The region of the Target VPN Gateway to operate on. Should be the same as region, if not specified, it will be automatically set. Overrides the default *compute/region* property value for this command invocation.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--target-vpn-gateway-region',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'TARGET_VPN_GATEWAY_REGION'}},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'create',
                                                                                     u'path': [u'gcloud',
                                                                                               u'compute',
                                                                                               u'vpn-tunnels',
                                                                                               u'create'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of the VPN tunnel.',
                                                                                                       u'name': u'name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'\n*create* is used to create a VPN tunnel between a VPN Gateway\nin Google Cloud Platform and an external gateway that is\nidentified by --peer-address.\n'}},
                                                                         u'delete': {u'capsule': u'Delete vpn tunnels.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u"The region of the resources to delete. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--region',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'REGION'}},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'delete',
                                                                                     u'path': [u'gcloud',
                                                                                               u'compute',
                                                                                               u'vpn-tunnels',
                                                                                               u'delete'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The resources to delete.',
                                                                                                       u'name': u'names',
                                                                                                       u'nargs': u'+',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'*delete* deletes one or more Google Compute Engine vpn tunnels.\n'}},
                                                                         u'describe': {u'capsule': u'Describe a Google Compute Engine vpn tunnel.',
                                                                                       u'commands': {},
                                                                                       u'flags': {u'--region': {u'attr': {u'property': {u'name': u'compute/region'}},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u"The region of the resource to fetch. If not specified, you will be prompted to select a region.\n+\nTo avoid prompting when this flag is omitted, you can set the\n``compute/region'' property:\n+\n  $ gcloud config set compute/region REGION\n+\nA list of regions can be fetched by running:\n+\n  $ gcloud compute regions list\n+\nTo unset the property, run:\n+\n  $ gcloud config unset compute/region\n+\nAlternatively, the region can be stored in the environment\nvariable ``CLOUDSDK_COMPUTE_REGION''.",
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--region',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'REGION'}},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'describe',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'compute',
                                                                                                 u'vpn-tunnels',
                                                                                                 u'describe'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The name of the resource to fetch.',
                                                                                                         u'name': u'name',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'value': u'NAME'}],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine vpn tunnel in a project.\n'}},
                                                                         u'list': {u'capsule': u'List Google Compute Engine VPN tunnels.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--filter': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--filter',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'EXPRESSION'},
                                                                                              u'--limit': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--limit',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'LIMIT'},
                                                                                              u'--no-uri': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': True,
                                                                                                            u'description': u'',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': True,
                                                                                                            u'name': u'--no-uri',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'NO_URI'},
                                                                                              u'--page-size': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--page-size',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                              u'--regexp': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--regexp',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'REGEXP'},
                                                                                              u'--regions': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': [],
                                                                                                             u'description': u'If provided, only resources from the given regions are queried.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--regions',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'list',
                                                                                                             u'value': u'REGION'},
                                                                                              u'--sort-by': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--sort-by',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'list',
                                                                                                             u'value': u'FIELD'},
                                                                                              u'--uri': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': False,
                                                                                                         u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--uri',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'URI'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'list',
                                                                                   u'path': [u'gcloud',
                                                                                             u'compute',
                                                                                             u'vpn-tunnels',
                                                                                             u'list'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': [],
                                                                                                     u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                                     u'name': u'names',
                                                                                                     u'nargs': u'*',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u"*list* displays all Google Compute Engine VPN tunnels in a project.\n\nBy default, VPN tunnels from all regions are listed. The results can be\nnarrowed down by providing the ``--regions'' flag.\n",
                                                                                                 u'EXAMPLES': u"To list all VPN tunnels in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all VPN tunnels in a project, run:\n\n  $ list --uri\n\nTo list all VPN tunnels in the ``us-central1'' and ``europe-west1'' regions,\nrun:\n\n  $ list --regions us-central1 europe-west1\n"}}},
                                                           u'flags': {},
                                                           u'group': True,
                                                           u'groups': {},
                                                           u'hidden': False,
                                                           u'name': u'vpn-tunnels',
                                                           u'path': [u'gcloud',
                                                                     u'compute',
                                                                     u'vpn-tunnels'],
                                                           u'positionals': [],
                                                           u'release': u'GA',
                                                           u'sections': {u'DESCRIPTION': u'Read and manipulate Google Compute Engine VPN Tunnels.'}},
                                          u'zones': {u'capsule': u'List Google Compute Engine zones.',
                                                     u'commands': {u'describe': {u'capsule': u'Describe a Google Compute Engine zone.',
                                                                                 u'commands': {},
                                                                                 u'flags': {},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'describe',
                                                                                 u'path': [u'gcloud',
                                                                                           u'compute',
                                                                                           u'zones',
                                                                                           u'describe'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The name of the resource to fetch.',
                                                                                                   u'name': u'name',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'NAME'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with a Google Compute\nEngine zone.\n'}},
                                                                   u'list': {u'capsule': u'List Google Compute Engine zones.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--filter',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'EXPRESSION'},
                                                                                        u'--limit': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--limit',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'LIMIT'},
                                                                                        u'--no-uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': True,
                                                                                                      u'description': u'',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': True,
                                                                                                      u'name': u'--no-uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'NO_URI'},
                                                                                        u'--page-size': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--page-size',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                        u'--regexp': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'A regular expression to filter the names of the results on. Any names\nthat do not match the entire regular expression will be filtered out.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--regexp',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'REGEXP'},
                                                                                        u'--sort-by': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--sort-by',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'FIELD'},
                                                                                        u'--uri': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': False,
                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--uri',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'URI'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'list',
                                                                             u'path': [u'gcloud',
                                                                                       u'compute',
                                                                                       u'zones',
                                                                                       u'list'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': [],
                                                                                               u'description': u'If provided, show details for the specified names and/or URIs of resources.',
                                                                                               u'name': u'names',
                                                                                               u'nargs': u'*',
                                                                                               u'required': False,
                                                                                               u'value': u'NAME'}],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'*list* displays all Google Compute Engine zones in a project.\n',
                                                                                           u'EXAMPLES': u'To list all zones in a project in table form, run:\n\n  $ list\n\nTo list the URIs of all zones in a project, run:\n\n  $ list --uri\n'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'zones',
                                                     u'path': [u'gcloud',
                                                               u'compute',
                                                               u'zones'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'List Google Compute Engine zones.'}}},
                            u'flags': {},
                            u'group': True,
                            u'groups': {},
                            u'hidden': False,
                            u'name': u'compute',
                            u'path': [u'gcloud', u'compute'],
                            u'positionals': [],
                            u'release': u'GA',
                            u'sections': {u'DESCRIPTION': u"The gcloud compute command group lets you create, configure and\nmanipulate Google Compute Engine virtual machines.\n\nWith Compute Engine you can create and run virtual machines\non Google infrastructure. Compute Engine offers scale, performance, and\nvalue that allows you to easily launch large compute clusters on\nGoogle's infrastructure.\n\nMore information on Compute Engine can be found here:\nhttps://cloud.google.com/compute/ and detailed documentation can be\nfound here: https://cloud.google.com/compute/docs/\n"}},
               u'config': {u'capsule': u'View and edit Cloud SDK properties.',
                           u'commands': {u'configurations': {u'capsule': u'Manage the set of gcloud named configurations.',
                                                             u'commands': {u'activate': {u'capsule': u'Activates an existing named configuration.',
                                                                                         u'commands': {},
                                                                                         u'flags': {},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'activate',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'config',
                                                                                                   u'configurations',
                                                                                                   u'activate'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Name of the configuration to activate',
                                                                                                           u'name': u'configuration-name',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'CONFIGURATION_NAME'}],
                                                                                         u'release': u'GA',
                                                                                         u'sections': {u'DESCRIPTION': u'Activates an existing named configuration.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                       u'EXAMPLES': u'To activate an existing named configuration, run:\n\n  $ activate my_config\n\nTo list all properties in the activated configuration, run:\n\n  $ gcloud config list --all\n'}},
                                                                           u'create': {u'capsule': u'Creates a new named configuration.',
                                                                                       u'commands': {},
                                                                                       u'flags': {u'--activate': {u'attr': {u'inverted_synopsis': True},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': True,
                                                                                                                  u'description': u'If true, activate this configuration upon create. Enabled by default, use *--no-activate* to disable.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--activate',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'ACTIVATE'},
                                                                                                  u'--no-activate': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-activate',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_ACTIVATE'}},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'create',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'config',
                                                                                                 u'configurations',
                                                                                                 u'create'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Name of the configuration to create',
                                                                                                         u'name': u'configuration-name',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'value': u'CONFIGURATION_NAME'}],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u"Creates a new named configuration.\n\nExcept for special cases (NONE), configuration names start with a\nlower case letter and contain only lower case letters a-z, digits 0-9,\nand hyphens '-'.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n",
                                                                                                     u'EXAMPLES': u'To create a new named configuration, run:\n\n  $ create my-config\n'}},
                                                                           u'delete': {u'capsule': u'Deletes a named configuration.',
                                                                                       u'commands': {},
                                                                                       u'flags': {},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'delete',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'config',
                                                                                                 u'configurations',
                                                                                                 u'delete'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Name of the configuration to delete. Cannot be currently active configuration.',
                                                                                                         u'name': u'configuration-names',
                                                                                                         u'nargs': u'+',
                                                                                                         u'required': False,
                                                                                                         u'value': u'CONFIGURATION_NAMES'}],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u'Deletes a named configuration. You cannot delete a configuration that is active, even\nwhen overridden with the --configuration flag.  To delete the current\nactive configuration, first `gcloud config configurations activate`\nanother one.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                     u'EXAMPLES': u'To delete a named configuration, run:\n\n  $ delete my_config\n\nTo delete more than one configuration, run:\n\n  $ delete my_config1 my_config2\n\nTo list existing configurations, run:\n\n  $ gcloud config configurations list\n'}},
                                                                           u'describe': {u'capsule': u'Describes a named configuration by listing its properties.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--all': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'Include unset properties in output.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--all',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'ALL'},
                                                                                                    u'--no-all': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': True,
                                                                                                                  u'description': u'',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': True,
                                                                                                                  u'name': u'--no-all',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'NO_ALL'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'describe',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'config',
                                                                                                   u'configurations',
                                                                                                   u'describe'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Name of the configuration to describe',
                                                                                                           u'name': u'configuration-name',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'CONFIGURATION_NAME'}],
                                                                                         u'release': u'GA',
                                                                                         u'sections': {u'DESCRIPTION': u'Describes a named configuration by listing its properties.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                       u'EXAMPLES': u'To describe existing named configuration, run:\n\n  $ describe my_config\n\nThis is similar to:\n\n  $ gcloud config configurations activate my_config\n\n  $ gcloud config list\n'}},
                                                                           u'list': {u'capsule': u'Lists existing named configurations.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--filter': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--filter',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'EXPRESSION'},
                                                                                                u'--limit': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--limit',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'LIMIT'},
                                                                                                u'--sort-by': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--sort-by',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'list',
                                                                                                               u'value': u'FIELD'}},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'list',
                                                                                     u'path': [u'gcloud',
                                                                                               u'config',
                                                                                               u'configurations',
                                                                                               u'list'],
                                                                                     u'positionals': [],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'Lists existing named configurations.\n\nRun `$ gcloud topic configurations` for an overview of named\nconfigurations.\n',
                                                                                                   u'EXAMPLES': u'To list all available configurations, run:\n\n  $ list\n'}}},
                                                             u'flags': {},
                                                             u'group': True,
                                                             u'groups': {},
                                                             u'hidden': False,
                                                             u'name': u'configurations',
                                                             u'path': [u'gcloud',
                                                                       u'config',
                                                                       u'configurations'],
                                                             u'positionals': [],
                                                             u'release': u'GA',
                                                             u'sections': {u'DESCRIPTION': u'Manage the set of gcloud named configurations.\n\nSee `gcloud topic configurations` for an overview of named\nconfigurations.\n'}},
                                         u'get-value': {u'capsule': u'Print the value of a Cloud SDK property.',
                                                        u'commands': {},
                                                        u'flags': {},
                                                        u'group': False,
                                                        u'groups': {},
                                                        u'hidden': False,
                                                        u'name': u'get-value',
                                                        u'path': [u'gcloud',
                                                                  u'config',
                                                                  u'get-value'],
                                                        u'positionals': [{u'completer': u'',
                                                                          u'default': None,
                                                                          u'description': u'The property to be fetched. Note that `SECTION/` is optional while referring to properties in the core section.',
                                                                          u'name': u'property',
                                                                          u'nargs': u'0',
                                                                          u'required': False,
                                                                          u'value': u'SECTION/PROPERTY'}],
                                                        u'release': u'GA',
                                                        u'sections': {u'DESCRIPTION': u'get-value prints the property value from your active configuration only.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo print the project property in the core section, run:\n\n  $ get-value project\n\nTo print the zone property in the compute section, run:\n\n  $ get-value compute/zone'}},
                                         u'list': {u'capsule': u'View Cloud SDK properties.',
                                                   u'commands': {},
                                                   u'flags': {u'--all': {u'attr': {},
                                                                         u'category': u'',
                                                                         u'choices': [],
                                                                         u'completer': u'',
                                                                         u'default': False,
                                                                         u'description': u'List all set and unset properties that match the arguments.',
                                                                         u'group': u'',
                                                                         u'hidden': False,
                                                                         u'name': u'--all',
                                                                         u'nargs': u'0',
                                                                         u'required': False,
                                                                         u'type': u'bool',
                                                                         u'value': u'ALL'},
                                                              u'--filter': {u'attr': {},
                                                                            u'category': u'LIST COMMAND',
                                                                            u'choices': [],
                                                                            u'completer': u'',
                                                                            u'default': None,
                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                            u'group': u'',
                                                                            u'hidden': False,
                                                                            u'name': u'--filter',
                                                                            u'nargs': u'0',
                                                                            u'required': False,
                                                                            u'type': u'string',
                                                                            u'value': u'EXPRESSION'},
                                                              u'--limit': {u'attr': {},
                                                                           u'category': u'LIST COMMAND',
                                                                           u'choices': [],
                                                                           u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                           u'group': u'',
                                                                           u'hidden': False,
                                                                           u'name': u'--limit',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'type': u'string',
                                                                           u'value': u'LIMIT'},
                                                              u'--no-all': {u'attr': {},
                                                                            u'category': u'',
                                                                            u'choices': [],
                                                                            u'completer': u'',
                                                                            u'default': True,
                                                                            u'description': u'',
                                                                            u'group': u'',
                                                                            u'hidden': True,
                                                                            u'name': u'--no-all',
                                                                            u'nargs': u'0',
                                                                            u'required': False,
                                                                            u'type': u'bool',
                                                                            u'value': u'NO_ALL'},
                                                              u'--sort-by': {u'attr': {},
                                                                             u'category': u'LIST COMMAND',
                                                                             u'choices': [],
                                                                             u'completer': u'',
                                                                             u'default': None,
                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                             u'group': u'',
                                                                             u'hidden': False,
                                                                             u'name': u'--sort-by',
                                                                             u'nargs': u'0',
                                                                             u'required': False,
                                                                             u'type': u'list',
                                                                             u'value': u'FIELD'}},
                                                   u'group': False,
                                                   u'groups': {},
                                                   u'hidden': False,
                                                   u'name': u'list',
                                                   u'path': [u'gcloud',
                                                             u'config',
                                                             u'list'],
                                                   u'positionals': [{u'completer': u'',
                                                                     u'default': None,
                                                                     u'description': u'The property to be listed. Note that SECTION/ is optional while referring to properties in the core section.',
                                                                     u'name': u'property',
                                                                     u'nargs': u'?',
                                                                     u'required': False,
                                                                     u'value': u'SECTION/PROPERTY'}],
                                                   u'release': u'GA',
                                                   u'sections': {u'DESCRIPTION': u'Lists all properties in your active configuration. These include the\naccount used to authorize access to the Cloud Platform, the current Cloud\nPlatform project, and the default Compute Engine region and zone, if set. See\n`gcloud topic configurations` for more information.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo list the project property in the core section, run:\n\n  $ list project\n\nTo list the zone property in the compute section, run:\n\n  $ list compute/zone\n\nTo list all the properties, run:\n\n  $ list --all\n\nNote you cannot specify both --all and a property name.'}},
                                         u'set': {u'capsule': u'Set a Cloud SDK property.',
                                                  u'commands': {},
                                                  u'flags': {u'--installation': {u'attr': {},
                                                                                 u'category': u'',
                                                                                 u'choices': [],
                                                                                 u'completer': u'',
                                                                                 u'default': False,
                                                                                 u'description': u'Typically properties are updated only in the currently active\nconfiguration, but when `--installation` is given the property is\nupdated for the entire gcloud installation.',
                                                                                 u'group': u'',
                                                                                 u'hidden': False,
                                                                                 u'name': u'--installation',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'type': u'bool',
                                                                                 u'value': u'INSTALLATION'},
                                                             u'--no-installation': {u'attr': {},
                                                                                    u'category': u'',
                                                                                    u'choices': [],
                                                                                    u'completer': u'',
                                                                                    u'default': True,
                                                                                    u'description': u'',
                                                                                    u'group': u'',
                                                                                    u'hidden': True,
                                                                                    u'name': u'--no-installation',
                                                                                    u'nargs': u'0',
                                                                                    u'required': False,
                                                                                    u'type': u'bool',
                                                                                    u'value': u'NO_INSTALLATION'}},
                                                  u'group': False,
                                                  u'groups': {},
                                                  u'hidden': False,
                                                  u'name': u'set',
                                                  u'path': [u'gcloud',
                                                            u'config',
                                                            u'set'],
                                                  u'positionals': [{u'completer': u'',
                                                                    u'default': None,
                                                                    u'description': u'The property to be set. Note that SECTION/ is optional while referring to properties in the core section.',
                                                                    u'name': u'property',
                                                                    u'nargs': u'0',
                                                                    u'required': False,
                                                                    u'value': u'SECTION/PROPERTY'},
                                                                   {u'completer': u'',
                                                                    u'default': None,
                                                                    u'description': u'The value to be set.',
                                                                    u'name': u'value',
                                                                    u'nargs': u'0',
                                                                    u'required': False,
                                                                    u'value': u'VALUE'}],
                                                  u'release': u'GA',
                                                  u'sections': {u'DESCRIPTION': u'By default, sets the property in your active configuration only. Use the\n`--installation` flag to set the property across all configurations. See\n`gcloud topic configurations` for more information.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo set the project property in the core section, run:\n\n  $ set project myProject\n\nTo set the zone property in the compute section, run:\n\n  $ set compute/zone zone3'}},
                                         u'unset': {u'capsule': u'Unset a Cloud SDK property.',
                                                    u'commands': {},
                                                    u'flags': {u'--installation': {u'attr': {},
                                                                                   u'category': u'',
                                                                                   u'choices': [],
                                                                                   u'completer': u'',
                                                                                   u'default': False,
                                                                                   u'description': u'Typically properties are updated only in the currently active\nconfiguration, but when `--installation` is given the property is\nupdated for the entire gcloud installation.',
                                                                                   u'group': u'',
                                                                                   u'hidden': False,
                                                                                   u'name': u'--installation',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'type': u'bool',
                                                                                   u'value': u'INSTALLATION'},
                                                               u'--no-installation': {u'attr': {},
                                                                                      u'category': u'',
                                                                                      u'choices': [],
                                                                                      u'completer': u'',
                                                                                      u'default': True,
                                                                                      u'description': u'',
                                                                                      u'group': u'',
                                                                                      u'hidden': True,
                                                                                      u'name': u'--no-installation',
                                                                                      u'nargs': u'0',
                                                                                      u'required': False,
                                                                                      u'type': u'bool',
                                                                                      u'value': u'NO_INSTALLATION'}},
                                                    u'group': False,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'unset',
                                                    u'path': [u'gcloud',
                                                              u'config',
                                                              u'unset'],
                                                    u'positionals': [{u'completer': u'',
                                                                      u'default': None,
                                                                      u'description': u'The property to be unset. Note that SECTION/ is optional while referring to properties in the core section.',
                                                                      u'name': u'property',
                                                                      u'nargs': u'0',
                                                                      u'required': False,
                                                                      u'value': u'SECTION/PROPERTY'}],
                                                    u'release': u'GA',
                                                    u'sections': {u'DESCRIPTION': u'By default, unsets the property in your active configuration only. Use the\n`--installation` flag to unset the property across all configurations. See\n`gcloud topic configurations` for more information.\n\n## AVAILABLE PROPERTIES\n\n{properties}\n\n## EXAMPLES\n\nTo unset the project property in the core section, run:\n\n  $ unset project\n\nTo unset the zone property in the compute section, run:\n\n  $ unset compute/zone'}}},
                           u'flags': {},
                           u'group': True,
                           u'groups': {},
                           u'hidden': False,
                           u'name': u'config',
                           u'path': [u'gcloud', u'config'],
                           u'positionals': [],
                           u'release': u'GA',
                           u'sections': {u'DESCRIPTION': u'The config command group lets you set, view and unset properties used by\nCloud SDK.\n\nA configuration is a set of properties that govern the behavior of gcloud\nand other Cloud SDK tools. The initial `default` configuration is set when\n`gcloud init` is run. You can create additional named configurations using\n`gcloud init` or `config configurations create`.\n\nTo switch between configurations, use `config configurations activate`.\n\ngcloud supports several flags that have the same effect as properties in\na configuration (for example, gcloud supports both the `--project` flag and\n`project` property). Properties differ from flags in that flags affect command\nbehavior on a per-invocation basis. Properties allow you to maintain the same\nsettings across command executions.\n\nFor more information on configurations, see `gcloud topic configurations`.\n\n## AVAILABLE PROPERTIES\n\n{properties}'}},
               u'container': {u'capsule': u'Deploy and manage clusters of machines for running containers.',
                              u'commands': {u'builds': {u'capsule': u'Create and manage container builds.',
                                                        u'commands': {u'cancel': {u'capsule': u'Cancel an ongoing build.',
                                                                                  u'commands': {},
                                                                                  u'flags': {},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'cancel',
                                                                                  u'path': [u'gcloud',
                                                                                            u'container',
                                                                                            u'builds',
                                                                                            u'cancel'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The build to cancel. The ID of the build is printed at the end of the build submission process, or in the ID column when listing builds.',
                                                                                                    u'name': u'build',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'BUILD'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'Cancel an ongoing build.'}},
                                                                      u'describe': {u'capsule': u'Get information about a particular build.',
                                                                                    u'commands': {},
                                                                                    u'flags': {},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'describe',
                                                                                    u'path': [u'gcloud',
                                                                                              u'container',
                                                                                              u'builds',
                                                                                              u'describe'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The build to describe. The ID of the build is printed at the end of the build submission process, or in the ID column when listing builds.',
                                                                                                      u'name': u'build',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'value': u'BUILD'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'Get information about a particular build.'}},
                                                                      u'list': {u'capsule': u'List builds.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--filter',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'EXPRESSION'},
                                                                                           u'--limit': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': 50,
                                                                                                        u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--limit',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'int',
                                                                                                        u'value': u'LIMIT'},
                                                                                           u'--no-ongoing': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': True,
                                                                                                             u'description': u'',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': True,
                                                                                                             u'name': u'--no-ongoing',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'NO_ONGOING'},
                                                                                           u'--no-uri': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': True,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--no-uri',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'NO_URI'},
                                                                                           u'--ongoing': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u'Only list builds that are currently QUEUED or WORKING.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--ongoing',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'ONGOING'},
                                                                                           u'--page-size': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--page-size',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'PAGE_SIZE'},
                                                                                           u'--sort-by': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--sort-by',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'list',
                                                                                                          u'value': u'FIELD'},
                                                                                           u'--uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': False,
                                                                                                      u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'URI'}},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'list',
                                                                                u'path': [u'gcloud',
                                                                                          u'container',
                                                                                          u'builds',
                                                                                          u'list'],
                                                                                u'positionals': [],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u'List builds.'}},
                                                                      u'log': {u'capsule': u'Stream the logs for a build.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--no-stream': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': True,
                                                                                                           u'description': u'',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': True,
                                                                                                           u'name': u'--no-stream',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'NO_STREAM'},
                                                                                          u'--stream': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': False,
                                                                                                        u'description': u'If a build is ongoing, stream the logs to stdout until termination.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--stream',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'STREAM'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'log',
                                                                               u'path': [u'gcloud',
                                                                                         u'container',
                                                                                         u'builds',
                                                                                         u'log'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The build whose logs shall be printed. The ID of the build is printed at the end of the build submission process, or in the ID column when listing builds.',
                                                                                                 u'name': u'build',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'BUILD'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Stream the logs for a build.'}},
                                                                      u'submit': {u'capsule': u'Submit a build using the Google Container Builder service.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--async': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--async',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'ASYNC'},
                                                                                             u'--config': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The .yaml or .json file to use for build configuration.',
                                                                                                           u'group': u'submit.1',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--config',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'CONFIG'},
                                                                                             u'--gcs-log-dir': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Directory in Google Cloud Storage to hold build logs. If the bucket does not exist, it will be created. If not set, ```gs://<project id>_cloudbuild/logs``` is used.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--gcs-log-dir',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'GCS_LOG_DIR'},
                                                                                             u'--gcs-source-staging-dir': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'Directory in Google Cloud Storage to stage a copy of the source used for the build. If the bucket does not exist, it will be created. If not set, ```gs://<project id>_cloudbuild/source``` is used.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--gcs-source-staging-dir',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'GCS_SOURCE_STAGING_DIR'},
                                                                                             u'--no-async': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': True,
                                                                                                             u'description': u'',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': True,
                                                                                                             u'name': u'--no-async',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'NO_ASYNC'},
                                                                                             u'--substitutions': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Parameters to be substituted in the build specification.\n+\nFor example (using some nonsensical substitution keys; all keys must begin with\nan underscore):\n+\n    $ gcloud container builds submit . \\\n        --config config.yaml \\\n        --substitutions _FAVORITE_COLOR=blue,_NUM_CANDIES=10\n+\nThis will result in a build where every occurrence of ```${_FAVORITE_COLOR}```\nin certain fields is replaced by "blue", and similarly for ```${_NUM_CANDIES}```\nand "10".\n+\nFor more details, see:\nhttps://cloud.google.com/container-builder/docs/api/build-requests#substitutions',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--substitutions',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'dict',
                                                                                                                  u'value': u'```_```KEY=VALUE'},
                                                                                             u'--tag': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The tag to use with a "docker build" image creation. The Container Builder service will run a remote "docker build -t $TAG .", where $TAG is the tag provided by this flag. The tag must be in the gcr.io/* or *.gcr.io/* namespaces.',
                                                                                                        u'group': u'submit.1',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--tag',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'TAG'},
                                                                                             u'--timeout': {u'attr': {u'property': {u'name': u'container/build_timeout'}},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Maximum time a build can last before it is failed as "TIMEOUT", written as a duration (eg "2h15m5s" is two hours, fifteen minutes, and five seconds). If no unit is specified, seconds is assumed (eg "10" is 10 seconds). Overrides the default *container/build_timeout* property value for this command invocation.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--timeout',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'TIMEOUT'}},
                                                                                  u'group': False,
                                                                                  u'groups': {u'submit.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                            u'is_mutex': True,
                                                                                                            u'is_required': True}},
                                                                                  u'hidden': False,
                                                                                  u'name': u'submit',
                                                                                  u'path': [u'gcloud',
                                                                                            u'container',
                                                                                            u'builds',
                                                                                            u'submit'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'The source directory on local disk or tarball in Google Cloud Storage or disk to use for this build.',
                                                                                                    u'name': u'source',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'SOURCE'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'Submit a build using the Google Container Builder service.'}}},
                                                        u'flags': {},
                                                        u'group': True,
                                                        u'groups': {},
                                                        u'hidden': False,
                                                        u'name': u'builds',
                                                        u'path': [u'gcloud',
                                                                  u'container',
                                                                  u'builds'],
                                                        u'positionals': [],
                                                        u'release': u'GA',
                                                        u'sections': {u'DESCRIPTION': u'Create and manage container builds.'}},
                                            u'clusters': {u'capsule': u'Deploy and teardown Google Container Engine clusters.',
                                                          u'commands': {u'create': {u'capsule': u'Create a cluster for running containers.',
                                                                                    u'commands': {},
                                                                                    u'flags': {u'--additional-zones': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u"The set of additional zones in which the specified node footprint should be\nreplicated. All zones must be in the same region as the cluster's primary zone.\nIf additional-zones is not specified, all nodes will be in the cluster's primary\nzone.\n+\nNote that `NUM_NODES` nodes will be created in each zone, such that if you\nspecify `--num-nodes=4` and choose one additional zone, 8 nodes will be created.\n+\nMultiple locations can be specified, separated by commas. For example:\n+\n  $ {command} example-cluster --zone us-central1-a --additional-zones us-central1-b,us-central1-c",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--additional-zones',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'list',
                                                                                                                       u'value': u'ZONE'},
                                                                                               u'--async': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u"Don't wait for the operation to complete.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--async',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'ASYNC'},
                                                                                               u'--cluster-ipv4-cidr': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The IP address range for the pods in this cluster in CIDR notation (e.g. 10.0.0.0/14). Due to kube-proxy limitations, this range must be a subset of the 10.0.0.0/8 space. Defaults to server-specified.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--cluster-ipv4-cidr',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'CLUSTER_IPV4_CIDR'},
                                                                                               u'--cluster-version': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': True,
                                                                                                                      u'name': u'--cluster-version',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'CLUSTER_VERSION'},
                                                                                               u'--disable-addons': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'List of cluster addons to disable. Options are HttpLoadBalancing, HorizontalPodAutoscaling. _DISABLE_ADDONS_ must be one of: *HttpLoadBalancing*, *HorizontalPodAutoscaling*.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--disable-addons',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'list',
                                                                                                                     u'value': u'DISABLE_ADDONS'},
                                                                                               u'--disk-size': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Size in GB for node VM boot disks. Defaults to 100GB.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--disk-size',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'DISK_SIZE'},
                                                                                               u'--enable-autorepair': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': True,
                                                                                                                        u'name': u'--enable-autorepair',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'ENABLE_AUTOREPAIR'},
                                                                                               u'--enable-autoscaling': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': True,
                                                                                                                         u'name': u'--enable-autoscaling',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'ENABLE_AUTOSCALING'},
                                                                                               u'--enable-autoupgrade': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': True,
                                                                                                                         u'name': u'--enable-autoupgrade',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'ENABLE_AUTOUPGRADE'},
                                                                                               u'--enable-cloud-endpoints': {u'attr': {u'inverted_synopsis': True},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': True,
                                                                                                                             u'description': u'Automatically enable Google Cloud Endpoints to take advantage of API management features. Enabled by default, use *--no-enable-cloud-endpoints* to disable.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--enable-cloud-endpoints',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'ENABLE_CLOUD_ENDPOINTS'},
                                                                                               u'--enable-cloud-logging': {u'attr': {u'inverted_synopsis': True},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': True,
                                                                                                                           u'description': u'Automatically send logs from the cluster to the Google Cloud Logging API. Enabled by default, use *--no-enable-cloud-logging* to disable.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--enable-cloud-logging',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'ENABLE_CLOUD_LOGGING'},
                                                                                               u'--enable-cloud-monitoring': {u'attr': {u'inverted_synopsis': True},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'Automatically send metrics from pods in the cluster to the Google Cloud Monitoring API. VM metrics will be collected by Google Compute Engine regardless of this setting. Enabled by default, use *--no-enable-cloud-monitoring* to disable.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--enable-cloud-monitoring',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'ENABLE_CLOUD_MONITORING'},
                                                                                               u'--enable-kubernetes-alpha': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--enable-kubernetes-alpha',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'ENABLE_KUBERNETES_ALPHA'},
                                                                                               u'--image-type': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The image type to use for the cluster. Defaults to server-specified.\n+\nImage Type specifies the base OS that the nodes in the cluster will run on.\nIf an image type is specified, that will be assigned to the cluster and all\nfuture upgrades will use the specified image type. If it is not specified the\nserver will pick the default image type.\n+\nThe default image type and the list of valid image types are available\nusing the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--image-type',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'IMAGE_TYPE'},
                                                                                               u'--local-ssd-count': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': 0,
                                                                                                                      u'description': u'',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': True,
                                                                                                                      u'name': u'--local-ssd-count',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'int',
                                                                                                                      u'value': u'LOCAL_SSD_COUNT'},
                                                                                               u'--machine-type': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The type of machine to use for nodes. Defaults to server-specified.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--machine-type',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'MACHINE_TYPE'},
                                                                                               u'--max-nodes': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--max-nodes',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'MAX_NODES'},
                                                                                               u'--max-nodes-per-pool': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The maximum number of nodes to allocate per default initial node pool. Container engine will automatically create enough nodes pools such that each node pool contains less than --max-nodes-per-pool nodes. Defaults to 1000 nodes, but can be set as low as 100 nodes per pool on initial create.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--max-nodes-per-pool',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'MAX_NODES_PER_POOL'},
                                                                                               u'--min-nodes': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--min-nodes',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'MIN_NODES'},
                                                                                               u'--network': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u"The Compute Engine Network that the cluster will connect to. Google Container Engine will use this network when creating routes and firewalls for the clusters. Defaults to the 'default' network.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--network',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'NETWORK'},
                                                                                               u'--no-async': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-async',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_ASYNC'},
                                                                                               u'--no-enable-autorepair': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-enable-autorepair',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_ENABLE_AUTOREPAIR'},
                                                                                               u'--no-enable-autoscaling': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--no-enable-autoscaling',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_ENABLE_AUTOSCALING'},
                                                                                               u'--no-enable-autoupgrade': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': True,
                                                                                                                            u'name': u'--no-enable-autoupgrade',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'NO_ENABLE_AUTOUPGRADE'},
                                                                                               u'--no-enable-cloud-endpoints': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': True,
                                                                                                                                u'description': u'',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': True,
                                                                                                                                u'name': u'--no-enable-cloud-endpoints',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'NO_ENABLE_CLOUD_ENDPOINTS'},
                                                                                               u'--no-enable-cloud-logging': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': True,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-enable-cloud-logging',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_ENABLE_CLOUD_LOGGING'},
                                                                                               u'--no-enable-cloud-monitoring': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-enable-cloud-monitoring',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_ENABLE_CLOUD_MONITORING'},
                                                                                               u'--no-enable-kubernetes-alpha': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': True,
                                                                                                                                 u'description': u'',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': True,
                                                                                                                                 u'name': u'--no-enable-kubernetes-alpha',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'bool',
                                                                                                                                 u'value': u'NO_ENABLE_KUBERNETES_ALPHA'},
                                                                                               u'--no-preemptible': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-preemptible',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_PREEMPTIBLE'},
                                                                                               u'--no-wait': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-wait',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_WAIT'},
                                                                                               u'--node-labels': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Applies the given kubernetes labels on all nodes in the new node-pool. Example:\n+\n  $ {command} example-cluster --node-labels=label-a=value1,label-2=value2\n+\nNew nodes, including ones created by resize or recreate, will have these labels\non the kubernetes API node object and can be used in nodeSelectors.\nSee http://kubernetes.io/docs/user-guide/node-selection/ for examples.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--node-labels',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'dict',
                                                                                                                  u'value': u'NODE_LABELS'},
                                                                                               u'--num-nodes': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': 3,
                                                                                                                u'description': u"The number of nodes to be created in each of the cluster's zones.",
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--num-nodes',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'int',
                                                                                                                u'value': u'NUM_NODES'},
                                                                                               u'--password': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The password to use for cluster auth. Defaults to a server-specified randomly-generated string.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--password',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'PASSWORD'},
                                                                                               u'--preemptible': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': True,
                                                                                                                  u'name': u'--preemptible',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'PREEMPTIBLE'},
                                                                                               u'--scopes': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Specifies scopes for the node instances. The project\'s default\nservice account is used. Examples:\n+\n  $ {command} example-cluster --scopes https://www.googleapis.com/auth/devstorage.read_only\n+\n  $ {command} example-cluster --scopes bigquery,storage-rw,compute-ro\n+\nMultiple SCOPEs can specified, separated by commas. The scopes\nnecessary for the cluster to function properly (compute-rw, storage-ro),\nare always added, even if not explicitly specified.\n+\nSCOPE can be either the full URI of the scope or an alias.\nAvailable aliases are:\n+\n[format="csv",options="header"]\n|========\nAlias,URI\nbigquery,https://www.googleapis.com/auth/bigquery\ncloud-platform,https://www.googleapis.com/auth/cloud-platform\ncloud-source-repos,https://www.googleapis.com/auth/source.full_control\ncloud-source-repos-ro,https://www.googleapis.com/auth/source.read_only\ncompute-ro,https://www.googleapis.com/auth/compute.readonly\ncompute-rw,https://www.googleapis.com/auth/compute\ndatastore,https://www.googleapis.com/auth/datastore\ndefault,https://www.googleapis.com/auth/cloud.useraccounts.readonly\n,https://www.googleapis.com/auth/devstorage.read_only\n,https://www.googleapis.com/auth/logging.write\n,https://www.googleapis.com/auth/monitoring.write\n,https://www.googleapis.com/auth/service.management.readonly\n,https://www.googleapis.com/auth/servicecontrol\nlogging-write,https://www.googleapis.com/auth/logging.write\nmonitoring,https://www.googleapis.com/auth/monitoring\nmonitoring-write,https://www.googleapis.com/auth/monitoring.write\nservice-control,https://www.googleapis.com/auth/servicecontrol\nservice-management,https://www.googleapis.com/auth/service.management.readonly\nsql,https://www.googleapis.com/auth/sqlservice\nsql-admin,https://www.googleapis.com/auth/sqlservice.admin\nstorage-full,https://www.googleapis.com/auth/devstorage.full_control\nstorage-ro,https://www.googleapis.com/auth/devstorage.read_only\nstorage-rw,https://www.googleapis.com/auth/devstorage.read_write\ntaskqueue,https://www.googleapis.com/auth/taskqueue\nuseraccounts-ro,https://www.googleapis.com/auth/cloud.useraccounts.readonly\nuseraccounts-rw,https://www.googleapis.com/auth/cloud.useraccounts\nuserinfo-email,https://www.googleapis.com/auth/userinfo.email\n|========',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--scopes',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'list',
                                                                                                             u'value': u'SCOPE'},
                                                                                               u'--service-account': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': True,
                                                                                                                      u'name': u'--service-account',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'SERVICE_ACCOUNT'},
                                                                                               u'--subnetwork': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The name of the Google Compute Engine subnetwork (https://cloud.google.com/compute/docs/subnetworks) to which the cluster is connected. If specified, the cluster\'s network must be a "custom subnet" network.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--subnetwork',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'SUBNETWORK'},
                                                                                               u'--tags': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Applies the given Compute Engine tags (comma separated) on all nodes in the new\nnode-pool. Example:\n+\n  $ {command} example-cluster --tags=tag1,tag2\n+\nNew nodes, including ones created by resize or recreate, will have these tags\non the Compute Engine API instance object and can be used in firewall rules.\nSee https://cloud.google.com/sdk/gcloud/reference/compute/firewall-rules/create\nfor examples.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--tags',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'list',
                                                                                                           u'value': u'TAG'},
                                                                                               u'--timeout': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': 1800,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--timeout',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'int',
                                                                                                              u'value': u'TIMEOUT'},
                                                                                               u'--username': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': u'admin',
                                                                                                               u'description': u'The user name to use for cluster auth.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--username',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'USERNAME'},
                                                                                               u'--wait': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--wait',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'WAIT'}},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'create',
                                                                                    u'path': [u'gcloud',
                                                                                              u'container',
                                                                                              u'clusters',
                                                                                              u'create'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The name of this cluster.',
                                                                                                      u'name': u'name',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'value': u'NAME'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'Create a cluster for running containers.'}},
                                                                        u'delete': {u'capsule': u'Delete an existing cluster for running containers.',
                                                                                    u'commands': {},
                                                                                    u'flags': {u'--async': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u"Don't wait for the operation to complete.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--async',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'ASYNC'},
                                                                                               u'--no-async': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-async',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_ASYNC'},
                                                                                               u'--no-wait': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-wait',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_WAIT'},
                                                                                               u'--timeout': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': 1800,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--timeout',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'int',
                                                                                                              u'value': u'TIMEOUT'},
                                                                                               u'--wait': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--wait',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'WAIT'}},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'delete',
                                                                                    u'path': [u'gcloud',
                                                                                              u'container',
                                                                                              u'clusters',
                                                                                              u'delete'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The names of the clusters to delete.',
                                                                                                      u'name': u'names',
                                                                                                      u'nargs': u'+',
                                                                                                      u'required': False,
                                                                                                      u'value': u'NAME'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'Delete an existing cluster for running containers.'}},
                                                                        u'describe': {u'capsule': u'Describe an existing cluster for running containers.',
                                                                                      u'commands': {},
                                                                                      u'flags': {},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'describe',
                                                                                      u'path': [u'gcloud',
                                                                                                u'container',
                                                                                                u'clusters',
                                                                                                u'describe'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The name of this cluster.',
                                                                                                        u'name': u'name',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'value': u'NAME'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'Describe an existing cluster for running containers.'}},
                                                                        u'get-credentials': {u'capsule': u'Fetch credentials for a running cluster.',
                                                                                             u'commands': {},
                                                                                             u'flags': {},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'get-credentials',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'container',
                                                                                                       u'clusters',
                                                                                                       u'get-credentials'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The name of the cluster to get credentials for. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                               u'name': u'name',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'Updates a kubeconfig file with appropriate credentials to point\nkubectl at a Container Engine Cluster. By default, credentials\nare written to HOME/.kube/config. You can provide an alternate\npath by setting the KUBECONFIG environment variable.\n\nSee [](https://cloud.google.com/container-engine/docs/kubectl) for\nkubectl documentation.'}},
                                                                        u'list': {u'capsule': u'List existing clusters for running containers.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--filter': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--filter',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'EXPRESSION'},
                                                                                             u'--limit': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--limit',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'LIMIT'},
                                                                                             u'--page-size': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--page-size',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'PAGE_SIZE'},
                                                                                             u'--sort-by': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--sort-by',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'list',
                                                                                                            u'value': u'FIELD'}},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'list',
                                                                                  u'path': [u'gcloud',
                                                                                            u'container',
                                                                                            u'clusters',
                                                                                            u'list'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'List existing clusters for running containers.'}},
                                                                        u'resize': {u'capsule': u'Resizes an existing cluster for running containers.',
                                                                                    u'commands': {},
                                                                                    u'flags': {u'--async': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u"Don't wait for the operation to complete.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--async',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'ASYNC'},
                                                                                               u'--no-async': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-async',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_ASYNC'},
                                                                                               u'--no-wait': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-wait',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_WAIT'},
                                                                                               u'--node-pool': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The node pool to resize.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--node-pool',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'NODE_POOL'},
                                                                                               u'--size': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Target number of nodes in the cluster.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--size',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': True,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'SIZE'},
                                                                                               u'--wait': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--wait',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'WAIT'}},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'resize',
                                                                                    u'path': [u'gcloud',
                                                                                              u'container',
                                                                                              u'clusters',
                                                                                              u'resize'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The name of this cluster.',
                                                                                                      u'name': u'name',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'value': u'NAME'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'\n        Resize an existing cluster to a provided size.\n\nIf you have multiple node pools, you must specify which node pool to resize by\nusing the --node-pool flag. You are not required to use the flag if you have\na single node pool.\n\nWhen increasing the size of a container cluster, the new instances are created\nwith the same configuration as the existing instances.\nExisting pods are not moved onto the new instances,\nbut new pods (such as those created by resizing a replication controller)\nwill be scheduled onto the new instances.\n\nWhen decreasing a cluster, the pods that are scheduled on the instances being\nremoved will be killed. If your pods are being managed by a replication\ncontroller, the controller will attempt to reschedule them onto the remaining\ninstances. If your pods are not managed by a replication controller,\nthey will not be restarted.\nNote that when resizing down, instances running pods and instances without pods\nare not differentiated. Resize will pick instances to remove at random.\n'}},
                                                                        u'update': {u'capsule': u'Update cluster settings for an existing container cluster.',
                                                                                    u'commands': {},
                                                                                    u'flags': {u'--async': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u"Don't wait for the operation to complete.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--async',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'ASYNC'},
                                                                                               u'--disable-autoscaling': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'update.1',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--disable-autoscaling',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'DISABLE_AUTOSCALING'},
                                                                                               u'--enable-autoscaling': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'',
                                                                                                                         u'group': u'update.1',
                                                                                                                         u'hidden': True,
                                                                                                                         u'name': u'--enable-autoscaling',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'ENABLE_AUTOSCALING'},
                                                                                               u'--max-nodes': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--max-nodes',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'MAX_NODES'},
                                                                                               u'--min-nodes': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--min-nodes',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'MIN_NODES'},
                                                                                               u'--monitoring-service': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The monitoring service to use for the cluster. Options are: "monitoring.googleapis.com" (the Google Cloud Monitoring service),  "none" (no metrics will be exported from the cluster)',
                                                                                                                         u'group': u'update.1',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--monitoring-service',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'MONITORING_SERVICE'},
                                                                                               u'--no-async': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-async',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_ASYNC'},
                                                                                               u'--no-wait': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-wait',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_WAIT'},
                                                                                               u'--node-pool': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Node pool to be updated.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--node-pool',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'NODE_POOL'},
                                                                                               u'--update-addons': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Cluster addons to enable or disable. Options are\nHorizontalPodAutoscaling=ENABLED|DISABLED\nHttpLoadBalancing=ENABLED|DISABLED',
                                                                                                                    u'group': u'update.1',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--update-addons',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'dict',
                                                                                                                    u'value': u'ADDON=ENABLED|DISABLED'},
                                                                                               u'--wait': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--wait',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'WAIT'}},
                                                                                    u'group': False,
                                                                                    u'groups': {u'update.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                              u'is_mutex': True,
                                                                                                              u'is_required': True}},
                                                                                    u'hidden': False,
                                                                                    u'name': u'update',
                                                                                    u'path': [u'gcloud',
                                                                                              u'container',
                                                                                              u'clusters',
                                                                                              u'update'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The name of the cluster to update.',
                                                                                                      u'name': u'name',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'value': u'NAME'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'Update cluster settings for an existing container cluster.'}},
                                                                        u'upgrade': {u'capsule': u'Upgrade the Kubernetes version of an existing container cluster.',
                                                                                     u'commands': {},
                                                                                     u'flags': {u'--async': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': False,
                                                                                                             u'description': u"Don't wait for the operation to complete.",
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--async',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'ASYNC'},
                                                                                                u'--cluster-version': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u"The Kubernetes release version to which to upgrade the cluster's nodes.\n+\nIf provided, the --cluster-version must be no greater than the cluster\nmaster's minor version (x.*X*.x), and must be a latest patch version\n(x.x.*X*).\n+\nYou can find the list of allowed versions for upgrades by running:\n+\n  $ gcloud container get-server-config",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--cluster-version',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'CLUSTER_VERSION'},
                                                                                                u'--image-type': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The image type to use for the cluster/node pool. Defaults to server-specified.\n+\nImage Type specifies the base OS that the nodes in the cluster/node pool will run on.\nIf an image type is specified, that will be assigned to the cluster/node pool and all\nfuture upgrades will use the specified image type. If it is not specified the\nserver will pick the default image type.\n+\nThe default image type and the list of valid image types are available\nusing the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--image-type',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'IMAGE_TYPE'},
                                                                                                u'--master': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u"Upgrade the cluster's master to the latest version of Kubernetes supported on Container Engine. Nodes cannot be upgraded at the same time as the master.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--master',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'MASTER'},
                                                                                                u'--no-async': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--no-async',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_ASYNC'},
                                                                                                u'--no-master': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': True,
                                                                                                                 u'description': u'',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': True,
                                                                                                                 u'name': u'--no-master',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'NO_MASTER'},
                                                                                                u'--no-wait': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-wait',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_WAIT'},
                                                                                                u'--node-pool': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The node pool to upgrade.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--node-pool',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'NODE_POOL'},
                                                                                                u'--wait': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u'DEPRECATED, use --no-async. Poll the operation for completion after issuing a create request.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--wait',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'WAIT'}},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'upgrade',
                                                                                     u'path': [u'gcloud',
                                                                                               u'container',
                                                                                               u'clusters',
                                                                                               u'upgrade'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of the cluster to upgrade.',
                                                                                                       u'name': u'name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u"Upgrades the Kubernetes version of an existing container cluster.\n\nThis command upgrades the Kubernetes version of the *nodes* of a cluster.\nThe Kubernetes version of the cluster's *master* is periodically upgraded\nautomatically as new releases are available.\n\n*By running this command, all of the cluster's nodes will be deleted and*\n*recreated one at a time.* While persistent Kubernetes resources, such as\npods backed by replication controllers, will be rescheduled onto new nodes,\na small cluster may experience a few minutes where there are insufficient\nnodes available to run all of the scheduled Kubernetes resources.\n\n*Please ensure that any data you wish to keep is stored on a persistent*\n*disk before upgrading the cluster.* Ephemeral Kubernetes resources--in\nparticular, pods without replication controllers--will be lost, while\npersistent Kubernetes resources will get rescheduled.\n",
                                                                                                   u'EXAMPLES': u'Upgrade the nodes of <cluster> to the Kubernetes version of the cluster\'s\nmaster.\n\n  $ upgrade <cluster>\n\nUpgrade the nodes of <cluster> to Kubernetes version x.y.z.\n\n  $ upgrade <cluster> --cluster-version "x.y.z"\n'}}},
                                                          u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                 u'category': u'',
                                                                                 u'choices': [],
                                                                                 u'completer': u'',
                                                                                 u'default': None,
                                                                                 u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                 u'group': u'',
                                                                                 u'hidden': False,
                                                                                 u'name': u'--zone',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'type': u'string',
                                                                                 u'value': u'ZONE'}},
                                                          u'group': True,
                                                          u'groups': {},
                                                          u'hidden': False,
                                                          u'name': u'clusters',
                                                          u'path': [u'gcloud',
                                                                    u'container',
                                                                    u'clusters'],
                                                          u'positionals': [],
                                                          u'release': u'GA',
                                                          u'sections': {u'DESCRIPTION': u'Deploy and teardown Google Container Engine clusters.'}},
                                            u'get-server-config': {u'capsule': u'Get Container Engine server config.',
                                                                   u'commands': {},
                                                                   u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                          u'category': u'',
                                                                                          u'choices': [],
                                                                                          u'completer': u'',
                                                                                          u'default': None,
                                                                                          u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                          u'group': u'',
                                                                                          u'hidden': False,
                                                                                          u'name': u'--zone',
                                                                                          u'nargs': u'0',
                                                                                          u'required': False,
                                                                                          u'type': u'string',
                                                                                          u'value': u'ZONE'}},
                                                                   u'group': False,
                                                                   u'groups': {},
                                                                   u'hidden': False,
                                                                   u'name': u'get-server-config',
                                                                   u'path': [u'gcloud',
                                                                             u'container',
                                                                             u'get-server-config'],
                                                                   u'positionals': [],
                                                                   u'release': u'GA',
                                                                   u'sections': {u'DESCRIPTION': u'Get Container Engine server config.'}},
                                            u'node-pools': {u'capsule': u'Create and delete operations for Google Container Engine node pools.',
                                                            u'commands': {u'create': {u'capsule': u'Create a node pool in a running cluster.',
                                                                                      u'commands': {},
                                                                                      u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The cluster to add the node pool to. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--cluster',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'CLUSTER'},
                                                                                                 u'--disk-size': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Size in GB for node VM boot disks. Defaults to 100GB.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--disk-size',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'DISK_SIZE'},
                                                                                                 u'--enable-autorepair': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--enable-autorepair',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'ENABLE_AUTOREPAIR'},
                                                                                                 u'--enable-autoscaling': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--enable-autoscaling',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'ENABLE_AUTOSCALING'},
                                                                                                 u'--enable-autoupgrade': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--enable-autoupgrade',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'ENABLE_AUTOUPGRADE'},
                                                                                                 u'--enable-cloud-endpoints': {u'attr': {u'inverted_synopsis': True},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': True,
                                                                                                                               u'description': u'Automatically enable Google Cloud Endpoints to take advantage of API management features. Enabled by default, use *--no-enable-cloud-endpoints* to disable.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--enable-cloud-endpoints',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'ENABLE_CLOUD_ENDPOINTS'},
                                                                                                 u'--image-type': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The image type to use for the node pool. Defaults to server-specified.\n+\nImage Type specifies the base OS that the nodes in the node pool will run on.\nIf an image type is specified, that will be assigned to the node pool and all\nfuture upgrades will use the specified image type. If it is not specified the\nserver will pick the default image type.\n+\nThe default image type and the list of valid image types are available\nusing the following command.\n+\n  $ gcloud container get-server-config',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--image-type',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'IMAGE_TYPE'},
                                                                                                 u'--local-ssd-count': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': 0,
                                                                                                                        u'description': u'',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': True,
                                                                                                                        u'name': u'--local-ssd-count',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'int',
                                                                                                                        u'value': u'LOCAL_SSD_COUNT'},
                                                                                                 u'--machine-type': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The type of machine to use for nodes. Defaults to server-specified.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--machine-type',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'MACHINE_TYPE'},
                                                                                                 u'--max-nodes': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': True,
                                                                                                                  u'name': u'--max-nodes',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'MAX_NODES'},
                                                                                                 u'--min-nodes': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': True,
                                                                                                                  u'name': u'--min-nodes',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'MIN_NODES'},
                                                                                                 u'--no-enable-autorepair': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-enable-autorepair',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_ENABLE_AUTOREPAIR'},
                                                                                                 u'--no-enable-autoscaling': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-enable-autoscaling',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_ENABLE_AUTOSCALING'},
                                                                                                 u'--no-enable-autoupgrade': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': False,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--no-enable-autoupgrade',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'bool',
                                                                                                                              u'value': u'NO_ENABLE_AUTOUPGRADE'},
                                                                                                 u'--no-enable-cloud-endpoints': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': True,
                                                                                                                                  u'description': u'',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': True,
                                                                                                                                  u'name': u'--no-enable-cloud-endpoints',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'NO_ENABLE_CLOUD_ENDPOINTS'},
                                                                                                 u'--no-preemptible': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': True,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-preemptible',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_PREEMPTIBLE'},
                                                                                                 u'--node-labels': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Applies the given kubernetes labels on all nodes in the new node-pool. Example:\n+\n  $ {command} node-pool-1 --cluster=example-cluster --node-labels=label1=value1,label2=value2\n+\nNew nodes, including ones created by resize or recreate, will have these labels\non the kubernetes API node object and can be used in nodeSelectors.\nSee http://kubernetes.io/docs/user-guide/node-selection/ for examples.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--node-labels',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'dict',
                                                                                                                    u'value': u'NODE_LABELS'},
                                                                                                 u'--num-nodes': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': 3,
                                                                                                                  u'description': u"The number of nodes in the node pool in each of the cluster's zones.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--num-nodes',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'int',
                                                                                                                  u'value': u'NUM_NODES'},
                                                                                                 u'--preemptible': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--preemptible',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'PREEMPTIBLE'},
                                                                                                 u'--scopes': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Specifies scopes for the node instances. The project\'s default\nservice account is used. Examples:\n+\n  $ {command} node-pool-1 --cluster=example-cluster --scopes https://www.googleapis.com/auth/devstorage.read_only\n+\n  $ {command} node-pool-1 --cluster=example-cluster --scopes bigquery,storage-rw,compute-ro\n+\nMultiple SCOPEs can specified, separated by commas. The scopes\nnecessary for the cluster to function properly (compute-rw, storage-ro),\nare always added, even if not explicitly specified.\n+\nSCOPE can be either the full URI of the scope or an alias.\nAvailable aliases are:\n+\n[options="header",format="csv",grid="none",frame="none"]\n|========\nAlias,URI\nbigquery,https://www.googleapis.com/auth/bigquery\ncloud-platform,https://www.googleapis.com/auth/cloud-platform\ncloud-source-repos,https://www.googleapis.com/auth/source.full_control\ncloud-source-repos-ro,https://www.googleapis.com/auth/source.read_only\ncompute-ro,https://www.googleapis.com/auth/compute.readonly\ncompute-rw,https://www.googleapis.com/auth/compute\ndatastore,https://www.googleapis.com/auth/datastore\ndefault,https://www.googleapis.com/auth/cloud.useraccounts.readonly\n,https://www.googleapis.com/auth/devstorage.read_only\n,https://www.googleapis.com/auth/logging.write\n,https://www.googleapis.com/auth/monitoring.write\n,https://www.googleapis.com/auth/service.management.readonly\n,https://www.googleapis.com/auth/servicecontrol\nlogging-write,https://www.googleapis.com/auth/logging.write\nmonitoring,https://www.googleapis.com/auth/monitoring\nmonitoring-write,https://www.googleapis.com/auth/monitoring.write\nservice-control,https://www.googleapis.com/auth/servicecontrol\nservice-management,https://www.googleapis.com/auth/service.management.readonly\nsql,https://www.googleapis.com/auth/sqlservice\nsql-admin,https://www.googleapis.com/auth/sqlservice.admin\nstorage-full,https://www.googleapis.com/auth/devstorage.full_control\nstorage-ro,https://www.googleapis.com/auth/devstorage.read_only\nstorage-rw,https://www.googleapis.com/auth/devstorage.read_write\ntaskqueue,https://www.googleapis.com/auth/taskqueue\nuseraccounts-ro,https://www.googleapis.com/auth/cloud.useraccounts.readonly\nuseraccounts-rw,https://www.googleapis.com/auth/cloud.useraccounts\nuserinfo-email,https://www.googleapis.com/auth/userinfo.email\n|========',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--scopes',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'list',
                                                                                                               u'value': u'SCOPE'},
                                                                                                 u'--service-account': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': True,
                                                                                                                        u'name': u'--service-account',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'SERVICE_ACCOUNT'},
                                                                                                 u'--tags': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Applies the given Compute Engine tags (comma separated) on all nodes in the new\nnode-pool. Example:\n+\n  $ {command} node-pool-1 --cluster=example-cluster --tags=tag1,tag2\n+\nNew nodes, including ones created by resize or recreate, will have these tags\non the Compute Engine API instance object and can be used in firewall rules.\nSee https://cloud.google.com/sdk/gcloud/reference/compute/firewall-rules/create\nfor examples.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--tags',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'list',
                                                                                                             u'value': u'TAG'},
                                                                                                 u'--timeout': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': 1800,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--timeout',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'int',
                                                                                                                u'value': u'TIMEOUT'}},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'create',
                                                                                      u'path': [u'gcloud',
                                                                                                u'container',
                                                                                                u'node-pools',
                                                                                                u'create'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The name of the node pool to create.',
                                                                                                        u'name': u'name',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'value': u'NAME'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'*create* facilitates the creation of a node pool in a Google\nContainer Engine cluster. A variety of options exists to customize the\nnode configuration and the number of nodes created.\n',
                                                                                                    u'EXAMPLES': u'To create a new node pool "node-pool-1" with the default options in the\ncluster "sample-cluster", run:\n\n  $ create node-pool-1 --cluster=example-cluster\n\nThe new node pool will show up in the cluster after all the nodes have\nbeen provisioned.\n\nTo create a node pool with 5 nodes, run:\n\n  $ create node-pool-1 --cluster=example-cluster --num-nodes=5\n'}},
                                                                          u'delete': {u'capsule': u'Delete an existing node pool in a running cluster.',
                                                                                      u'commands': {},
                                                                                      u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The cluster from which to delete the node pool. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--cluster',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'CLUSTER'},
                                                                                                 u'--no-wait': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': True,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--no-wait',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_WAIT'},
                                                                                                 u'--timeout': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': 1800,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--timeout',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'int',
                                                                                                                u'value': u'TIMEOUT'},
                                                                                                 u'--wait': {u'attr': {u'inverted_synopsis': True},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': True,
                                                                                                             u'description': u'Poll the operation for completion after issuing a delete request. Enabled by default, use *--no-wait* to disable.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--wait',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'WAIT'}},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'delete',
                                                                                      u'path': [u'gcloud',
                                                                                                u'container',
                                                                                                u'node-pools',
                                                                                                u'delete'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The name of the node pool to delete.',
                                                                                                        u'name': u'name',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'value': u'NAME'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'*delete* deletes a node pool from a Google Container Engine cluster.\n',
                                                                                                    u'EXAMPLES': u'To delete the "node-pool-1" node pool from the cluster\n"sample-cluster", run:\n\n  $ delete node-pool-1 --cluster=sample-cluster\n'}},
                                                                          u'describe': {u'capsule': u'Describe an existing node pool for a cluster.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The name of the cluster. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--cluster',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'CLUSTER'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'describe',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'container',
                                                                                                  u'node-pools',
                                                                                                  u'describe'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The name of the node pool.',
                                                                                                          u'name': u'name',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'NAME'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'*describe* displays all data associated with the node pool in the\nGoogle Container Engine cluster.'}},
                                                                          u'list': {u'capsule': u'List existing node pools for a cluster.',
                                                                                    u'commands': {},
                                                                                    u'flags': {u'--cluster': {u'attr': {u'property': {u'name': u'container/cluster'}},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The name of the cluster. Overrides the default *container/cluster* property value for this command invocation.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--cluster',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'CLUSTER'},
                                                                                               u'--filter': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--filter',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'EXPRESSION'},
                                                                                               u'--limit': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--limit',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'LIMIT'},
                                                                                               u'--no-uri': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': True,
                                                                                                             u'description': u'',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': True,
                                                                                                             u'name': u'--no-uri',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'NO_URI'},
                                                                                               u'--page-size': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--page-size',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                               u'--sort-by': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--sort-by',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'list',
                                                                                                              u'value': u'FIELD'},
                                                                                               u'--uri': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--uri',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'URI'}},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'list',
                                                                                    u'path': [u'gcloud',
                                                                                              u'container',
                                                                                              u'node-pools',
                                                                                              u'list'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'*list* displays all node pools in the Google Container Engine\ncluster.\n',
                                                                                                  u'EXAMPLES': u'To list all node pools in the cluster "sample-cluster" in table form,\nrun:\n\n  $ list --cluster=sample-cluster\n'}}},
                                                            u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                   u'category': u'',
                                                                                   u'choices': [],
                                                                                   u'completer': u'',
                                                                                   u'default': None,
                                                                                   u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                   u'group': u'',
                                                                                   u'hidden': False,
                                                                                   u'name': u'--zone',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'type': u'string',
                                                                                   u'value': u'ZONE'}},
                                                            u'group': True,
                                                            u'groups': {},
                                                            u'hidden': False,
                                                            u'name': u'node-pools',
                                                            u'path': [u'gcloud',
                                                                      u'container',
                                                                      u'node-pools'],
                                                            u'positionals': [],
                                                            u'release': u'GA',
                                                            u'sections': {u'DESCRIPTION': u'Create and delete operations for Google Container Engine node pools.'}},
                                            u'operations': {u'capsule': u'Get and list operations for Google Container Engine clusters.',
                                                            u'commands': {u'describe': {u'capsule': u'Describe an operation.',
                                                                                        u'commands': {},
                                                                                        u'flags': {},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'describe',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'container',
                                                                                                  u'operations',
                                                                                                  u'describe'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The operation id to look up.',
                                                                                                          u'name': u'operation-id',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'OPERATION_ID'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'Describe an operation.'}},
                                                                          u'list': {u'capsule': u'List operations for container clusters.',
                                                                                    u'commands': {},
                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--filter',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'EXPRESSION'},
                                                                                               u'--limit': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--limit',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'LIMIT'},
                                                                                               u'--page-size': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--page-size',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'PAGE_SIZE'},
                                                                                               u'--sort-by': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--sort-by',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'list',
                                                                                                              u'value': u'FIELD'}},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'list',
                                                                                    u'path': [u'gcloud',
                                                                                              u'container',
                                                                                              u'operations',
                                                                                              u'list'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'List operations for container clusters.'}},
                                                                          u'wait': {u'capsule': u'Poll an operation for completion.',
                                                                                    u'commands': {},
                                                                                    u'flags': {},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'wait',
                                                                                    u'path': [u'gcloud',
                                                                                              u'container',
                                                                                              u'operations',
                                                                                              u'wait'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The operation id to poll.',
                                                                                                      u'name': u'operation-id',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'value': u'OPERATION_ID'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'Poll an operation for completion.'}}},
                                                            u'flags': {u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                   u'category': u'',
                                                                                   u'choices': [],
                                                                                   u'completer': u'',
                                                                                   u'default': None,
                                                                                   u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                   u'group': u'',
                                                                                   u'hidden': False,
                                                                                   u'name': u'--zone',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'type': u'string',
                                                                                   u'value': u'ZONE'}},
                                                            u'group': True,
                                                            u'groups': {},
                                                            u'hidden': False,
                                                            u'name': u'operations',
                                                            u'path': [u'gcloud',
                                                                      u'container',
                                                                      u'operations'],
                                                            u'positionals': [],
                                                            u'release': u'GA',
                                                            u'sections': {u'DESCRIPTION': u'Get and list operations for Google Container Engine clusters.'}}},
                              u'flags': {u'--api-version': {u'attr': {u'property': {u'name': u'api_client_overrides/container'}},
                                                            u'category': u'',
                                                            u'choices': [],
                                                            u'completer': u'',
                                                            u'default': None,
                                                            u'description': u'',
                                                            u'group': u'',
                                                            u'hidden': True,
                                                            u'name': u'--api-version',
                                                            u'nargs': u'0',
                                                            u'required': False,
                                                            u'type': u'string',
                                                            u'value': u'API_VERSION'}},
                              u'group': True,
                              u'groups': {},
                              u'hidden': False,
                              u'name': u'container',
                              u'path': [u'gcloud', u'container'],
                              u'positionals': [],
                              u'release': u'GA',
                              u'sections': {u'DESCRIPTION': u'The gcloud container command group lets you create and manage Google Container\nEngine containers and clusters.\n\nContainer Engine is a cluster manager and orchestration system for\nrunning your Docker containers. Container Engine schedules your containers\ninto the cluster and manages them automatically based on requirements you\ndefine, such as CPU and memory.\n\nMore information on Container Engine can be found here:\nhttps://cloud.google.com/container-engine and detailed documentation\ncan be found here: https://cloud.google.com/container-engine/docs/'}},
               u'dataflow': {u'capsule': u'Manage Google Cloud Dataflow jobs.',
                             u'commands': {u'jobs': {u'capsule': u'A group of subcommands for working with Dataflow jobs.',
                                                     u'commands': {u'cancel': {u'capsule': u'Cancels all jobs that match the command line arguments.',
                                                                               u'commands': {},
                                                                               u'flags': {},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'cancel',
                                                                               u'path': [u'gcloud',
                                                                                         u'dataflow',
                                                                                         u'jobs',
                                                                                         u'cancel'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The jobs to operate on.',
                                                                                                 u'name': u'jobs',
                                                                                                 u'nargs': u'+',
                                                                                                 u'required': False,
                                                                                                 u'value': u'JOB'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Cancels all jobs that match the command line arguments.'}},
                                                                   u'describe': {u'capsule': u'Outputs the Job object resulting from the Get API.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--full': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'Retrieve the full Job rather than the summary view',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--full',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'FULL'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'describe',
                                                                                 u'path': [u'gcloud',
                                                                                           u'dataflow',
                                                                                           u'jobs',
                                                                                           u'describe'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The job ID to operate on.',
                                                                                                   u'name': u'job',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'JOB_ID'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'By default this will display the Summary view which includes:\n  - Project ID\n  - Job ID\n  - Job Name\n  - Job Type (Batch vs. Streaming)\n  - Job Create Time\n  - Job Status (Running, Done, Cancelled, Failed)\n  - Job Status Time\n\nNotable values that are only in the full view:\n  - Environment (staging Jars, information about workers, etc.)\n  - Steps from the workflow graph'}},
                                                                   u'drain': {u'capsule': u'Drains all jobs that match the command line arguments.',
                                                                              u'commands': {},
                                                                              u'flags': {},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'drain',
                                                                              u'path': [u'gcloud',
                                                                                        u'dataflow',
                                                                                        u'jobs',
                                                                                        u'drain'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'The jobs to operate on.',
                                                                                                u'name': u'jobs',
                                                                                                u'nargs': u'+',
                                                                                                u'required': False,
                                                                                                u'value': u'JOB'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'Once Drain is triggered, the pipeline will stop accepting new inputs.\nThe input watermark will be advanced to infinity. Elements already in the\npipeline will continue to be processed. Drained jobs can safely be\ncancelled.'}},
                                                                   u'list': {u'capsule': u'Lists all jobs in a particular project.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--created-after': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Filter the jobs to those created after the given time',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--created-after',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'CREATED_AFTER'},
                                                                                        u'--created-before': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Filter the jobs to those created before the given time',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--created-before',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'CREATED_BEFORE'},
                                                                                        u'--filter': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--filter',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'EXPRESSION'},
                                                                                        u'--limit': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--limit',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'LIMIT'},
                                                                                        u'--no-uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': True,
                                                                                                      u'description': u'',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': True,
                                                                                                      u'name': u'--no-uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'NO_URI'},
                                                                                        u'--page-size': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--page-size',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                        u'--sort-by': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--sort-by',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'FIELD'},
                                                                                        u'--status': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [u'active',
                                                                                                                   u'all',
                                                                                                                   u'terminated'],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Filter the jobs to those with the selected status. _STATUS_ must be one of:\n+\n*active*::: Filters the jobs that are running ordered on the creation timestamp.\n*all*::: Returns running jobs first, ordered on creation timestamp, then, returns all terminated jobs ordered on the termination timestamp.\n*terminated*::: Filters the jobs that have a terminated state, ordered on the termination timestamp. Example terminated states: Done, Updated, Cancelled, etc.\n+',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--status',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'STATUS'},
                                                                                        u'--uri': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': False,
                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--uri',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'URI'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'list',
                                                                             u'path': [u'gcloud',
                                                                                       u'dataflow',
                                                                                       u'jobs',
                                                                                       u'list'],
                                                                             u'positionals': [],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'By default, jobs in the current project are listed; this can be overridden\nwith the gcloud --project flag.\n\n## EXAMPLES\n\nFilter jobs with the given name:\n\n  $ list --filter="name=my-wordcount"'}},
                                                                   u'run': {u'capsule': u'Runs a job from the specified path.',
                                                                            u'commands': {},
                                                                            u'flags': {u'--gcs-location': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The location of the job template to run.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--gcs-location',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': True,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'GCS_LOCATION'},
                                                                                       u'--max-workers': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The maximum number of workers to run.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--max-workers',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'MAX_WORKERS'},
                                                                                       u'--parameters': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The parameters to pass to the job.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--parameters',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'dict',
                                                                                                         u'value': u'PARAMETERS'},
                                                                                       u'--service-account-email': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The service account to run the workers as.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--service-account-email',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'SERVICE_ACCOUNT_EMAIL'},
                                                                                       u'--zone': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The zone to run the workers in.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--zone',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'ZONE'}},
                                                                            u'group': False,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'run',
                                                                            u'path': [u'gcloud',
                                                                                      u'dataflow',
                                                                                      u'jobs',
                                                                                      u'run'],
                                                                            u'positionals': [{u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u'The unique name to assign to the job.',
                                                                                              u'name': u'job-name',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'value': u'JOB_NAME'}],
                                                                            u'release': u'GA',
                                                                            u'sections': {u'DESCRIPTION': u'Runs a job from the specified path.'}},
                                                                   u'show': {u'capsule': u'Shows a short description of the given job.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--environment': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'If present, the environment will be listed.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--environment',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'ENVIRONMENT'},
                                                                                        u'--no-environment': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-environment',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_ENVIRONMENT'},
                                                                                        u'--no-steps': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-steps',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_STEPS'},
                                                                                        u'--steps': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'If present, the steps will be listed.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--steps',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'STEPS'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'show',
                                                                             u'path': [u'gcloud',
                                                                                       u'dataflow',
                                                                                       u'jobs',
                                                                                       u'show'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'The job ID to operate on.',
                                                                                               u'name': u'job',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'value': u'JOB_ID'}],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'Shows a short description of the given job.'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'jobs',
                                                     u'path': [u'gcloud',
                                                               u'dataflow',
                                                               u'jobs'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'A group of subcommands for working with Dataflow jobs.'}}},
                             u'flags': {},
                             u'group': True,
                             u'groups': {},
                             u'hidden': False,
                             u'name': u'dataflow',
                             u'path': [u'gcloud', u'dataflow'],
                             u'positionals': [],
                             u'release': u'GA',
                             u'sections': {u'DESCRIPTION': u'The gcloud dataflow command group lets you manage Google Cloud Dataflow jobs.\n\nCloud Dataflow is a unified programming model and a managed service for\ndeveloping and executing a wide range of data processing patterns\nincluding ETL, batch computation, and continuous computation.\n\nMore information on Cloud Dataflow can be found here:\nhttps://cloud.google.com/dataflow and detailed documentation can be found\nhere: https://cloud.google.com/dataflow/docs/'}},
               u'dataproc': {u'capsule': u'Create and manage Google Cloud Dataproc clusters and jobs.',
                             u'commands': {u'clusters': {u'capsule': u'Create and manage Google Cloud Dataproc clusters.',
                                                         u'commands': {u'create': {u'capsule': u'Create a cluster.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--async': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--async',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'ASYNC'},
                                                                                              u'--bucket': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The Google Cloud Storage bucket to use with the Google Cloud Storage connector. A bucket is auto created when this parameter is not specified.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--bucket',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'BUCKET'},
                                                                                              u'--image': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': True,
                                                                                                           u'name': u'--image',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'IMAGE'},
                                                                                              u'--image-version': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The image version to use for the cluster. Defaults to the latest version.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--image-version',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'VERSION'},
                                                                                              u'--initialization-action-timeout': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': u'10m',
                                                                                                                                   u'description': u'The maximum duration of each initialization action.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--initialization-action-timeout',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'TIMEOUT'},
                                                                                              u'--initialization-actions': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'A list of Google Cloud Storage URIs of executables to run on each node in the cluster.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--initialization-actions',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'list',
                                                                                                                            u'value': u'CLOUD_STORAGE_URI'},
                                                                                              u'--labels': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--labels',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'dict',
                                                                                                            u'value': u'KEY=VALUE'},
                                                                                              u'--master-boot-disk-size': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"The size of the boot disk. The value must be a\nwhole number followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For example,\n``10GB'' will produce a 10 gigabyte disk. The minimum size a boot disk\ncan have is 10 GB. Disk size must be a multiple of 1 GB.",
                                                                                                                           u'group': u'create.1',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--master-boot-disk-size',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'MASTER_BOOT_DISK_SIZE'},
                                                                                              u'--master-boot-disk-size-gb': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'create.1',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--master-boot-disk-size-gb',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'MASTER_BOOT_DISK_SIZE_GB'},
                                                                                              u'--master-machine-type': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The type of machine to use for the master. Defaults to server-specified.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--master-machine-type',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'MASTER_MACHINE_TYPE'},
                                                                                              u'--metadata': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'Metadata to be made available to the guest operating system running on the instances',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--metadata',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'dict',
                                                                                                              u'value': u'KEY=VALUE'},
                                                                                              u'--network': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The Compute Engine network that the VM instances of the cluster will be\npart of. This is mutually exclusive with --subnet. If neither is\nspecified, this defaults to the "default" network.',
                                                                                                             u'group': u'create.2',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--network',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'NETWORK'},
                                                                                              u'--no-async': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-async',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_ASYNC'},
                                                                                              u'--num-master-local-ssds': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The number of local SSDs to attach to the master in a cluster.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--num-master-local-ssds',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'NUM_MASTER_LOCAL_SSDS'},
                                                                                              u'--num-masters': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': True,
                                                                                                                 u'name': u'--num-masters',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'NUM_MASTERS'},
                                                                                              u'--num-preemptible-workers': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The number of preemptible worker nodes in the cluster.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--num-preemptible-workers',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'NUM_PREEMPTIBLE_WORKERS'},
                                                                                              u'--num-worker-local-ssds': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The number of local SSDs to attach to each worker in a cluster.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--num-worker-local-ssds',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'NUM_WORKER_LOCAL_SSDS'},
                                                                                              u'--num-workers': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The number of worker nodes in the cluster. Defaults to server-specified.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--num-workers',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'NUM_WORKERS'},
                                                                                              u'--preemptible-worker-boot-disk-size': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u"The size of the boot disk. The value must be a\nwhole number followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For example,\n``10GB'' will produce a 10 gigabyte disk. The minimum size a boot disk\ncan have is 10 GB. Disk size must be a multiple of 1 GB.",
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--preemptible-worker-boot-disk-size',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'PREEMPTIBLE_WORKER_BOOT_DISK_SIZE'},
                                                                                              u'--properties': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': {},
                                                                                                                u'description': u'Specifies configuration properties for installed packages, such as Hadoop\nand Spark.\n+\nProperties are mapped to configuration files by specifying a prefix, such as\n"core:io.serializations". The following are supported prefixes and their\nmappings:\n+\n[format="csv",options="header"]\n|========\nPrefix,Target Configuration File\ncore,core-site.xml\nhdfs,hdfs-site.xml\nmapred,mapred-site.xml\nyarn,yarn-site.xml\nhive,hive-site.xml\npig,pig.properties\nspark,spark-defaults.conf\n|========\n+',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--properties',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'dict',
                                                                                                                u'value': u'PREFIX:PROPERTY=VALUE'},
                                                                                              u'--scopes': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Specifies scopes for the node instances. The project\'s default service account\nis used. Multiple SCOPEs can specified, separated by commas.\nExamples:\n+\n  $ {command} example-cluster --scopes https://www.googleapis.com/auth/bigtable.admin\n+\n  $ {command} example-cluster --scopes sqlservice,bigquery\n+\nThe following scopes necessary for the cluster to function properly are always\nadded, even if not explicitly specified:\n+\n[format="csv"]\n|========\nhttps://www.googleapis.com/auth/cloud.useraccounts.readonly\nhttps://www.googleapis.com/auth/devstorage.read_write\nhttps://www.googleapis.com/auth/logging.write\n|========\n+\nIf this flag is not specified the following default scopes are also included:\n+\n[format="csv"]\n|========\nhttps://www.googleapis.com/auth/bigquery\nhttps://www.googleapis.com/auth/bigtable.admin.table\nhttps://www.googleapis.com/auth/bigtable.data\nhttps://www.googleapis.com/auth/devstorage.full_control\n|========\n+\nIf you want to enable all scopes use the \'cloud-platform\' scope.\n+\nSCOPE can be either the full URI of the scope or an alias.\nAvailable aliases are:\n+\n[format="csv",options="header"]\n|========\nAlias,URI\nbigquery,https://www.googleapis.com/auth/bigquery\ncloud-platform,https://www.googleapis.com/auth/cloud-platform\ncloud-source-repos,https://www.googleapis.com/auth/source.full_control\ncloud-source-repos-ro,https://www.googleapis.com/auth/source.read_only\ncompute-ro,https://www.googleapis.com/auth/compute.readonly\ncompute-rw,https://www.googleapis.com/auth/compute\ndatastore,https://www.googleapis.com/auth/datastore\ndefault,https://www.googleapis.com/auth/cloud.useraccounts.readonly\n,https://www.googleapis.com/auth/devstorage.read_only\n,https://www.googleapis.com/auth/logging.write\n,https://www.googleapis.com/auth/monitoring.write\n,https://www.googleapis.com/auth/service.management.readonly\n,https://www.googleapis.com/auth/servicecontrol\nlogging-write,https://www.googleapis.com/auth/logging.write\nmonitoring,https://www.googleapis.com/auth/monitoring\nmonitoring-write,https://www.googleapis.com/auth/monitoring.write\nservice-control,https://www.googleapis.com/auth/servicecontrol\nservice-management,https://www.googleapis.com/auth/service.management.readonly\nsql,https://www.googleapis.com/auth/sqlservice\nsql-admin,https://www.googleapis.com/auth/sqlservice.admin\nstorage-full,https://www.googleapis.com/auth/devstorage.full_control\nstorage-ro,https://www.googleapis.com/auth/devstorage.read_only\nstorage-rw,https://www.googleapis.com/auth/devstorage.read_write\ntaskqueue,https://www.googleapis.com/auth/taskqueue\nuseraccounts-ro,https://www.googleapis.com/auth/cloud.useraccounts.readonly\nuseraccounts-rw,https://www.googleapis.com/auth/cloud.useraccounts\nuserinfo-email,https://www.googleapis.com/auth/userinfo.email\n|========',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--scopes',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'list',
                                                                                                            u'value': u'SCOPE'},
                                                                                              u'--service-account': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The Google Cloud IAM service account to be authenticated as.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--service-account',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'SERVICE_ACCOUNT'},
                                                                                              u'--subnet': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Specifies the subnet that the cluster will be part of. This is mutally\nexclusive with --network.',
                                                                                                            u'group': u'create.2',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--subnet',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'SUBNET'},
                                                                                              u'--tags': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Specifies a list of tags to apply to the instances for\nidentifying the instances to which network firewall rules will\napply. See gcloud_compute_firewall-rules_create(1) for more\ndetails.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--tags',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'list',
                                                                                                          u'value': u'TAG'},
                                                                                              u'--worker-boot-disk-size': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"The size of the boot disk. The value must be a\nwhole number followed by a size unit of ``KB'' for kilobyte, ``MB''\nfor megabyte, ``GB'' for gigabyte, or ``TB'' for terabyte. For example,\n``10GB'' will produce a 10 gigabyte disk. The minimum size a boot disk\ncan have is 10 GB. Disk size must be a multiple of 1 GB.",
                                                                                                                           u'group': u'create.3',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--worker-boot-disk-size',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'string',
                                                                                                                           u'value': u'WORKER_BOOT_DISK_SIZE'},
                                                                                              u'--worker-boot-disk-size-gb': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'',
                                                                                                                              u'group': u'create.3',
                                                                                                                              u'hidden': True,
                                                                                                                              u'name': u'--worker-boot-disk-size-gb',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'WORKER_BOOT_DISK_SIZE_GB'},
                                                                                              u'--worker-machine-type': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'The type of machine to use for workers. Defaults to server-specified.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--worker-machine-type',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'WORKER_MACHINE_TYPE'},
                                                                                              u'--zone': {u'attr': {u'property': {u'name': u'compute/zone'}},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The compute zone (e.g. us-central1-a) for the cluster. Overrides the default *compute/zone* property value for this command invocation.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--zone',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'ZONE'}},
                                                                                   u'group': False,
                                                                                   u'groups': {u'create.1': {u'description': u'At most one of these may be specified:',
                                                                                                             u'is_mutex': True,
                                                                                                             u'is_required': False},
                                                                                               u'create.2': {u'description': u'At most one of these may be specified:',
                                                                                                             u'is_mutex': True,
                                                                                                             u'is_required': False},
                                                                                               u'create.3': {u'description': u'At most one of these may be specified:',
                                                                                                             u'is_mutex': True,
                                                                                                             u'is_required': False}},
                                                                                   u'hidden': False,
                                                                                   u'name': u'create',
                                                                                   u'path': [u'gcloud',
                                                                                             u'dataproc',
                                                                                             u'clusters',
                                                                                             u'create'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The name of this cluster.',
                                                                                                     u'name': u'name',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'Create a cluster.',
                                                                                                 u'EXAMPLES': u'To create a cluster, run:\n\n  $ create my_cluster\n'}},
                                                                       u'delete': {u'capsule': u'Delete a cluster.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--async': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--async',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'ASYNC'},
                                                                                              u'--no-async': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-async',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_ASYNC'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'delete',
                                                                                   u'path': [u'gcloud',
                                                                                             u'dataproc',
                                                                                             u'clusters',
                                                                                             u'delete'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The name of the cluster to delete.',
                                                                                                     u'name': u'name',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'Delete a cluster.',
                                                                                                 u'EXAMPLES': u'To delete a cluster, run:\n\n  $ delete my_cluster\n'}},
                                                                       u'describe': {u'capsule': u'View the details of a cluster.',
                                                                                     u'commands': {},
                                                                                     u'flags': {},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'describe',
                                                                                     u'path': [u'gcloud',
                                                                                               u'dataproc',
                                                                                               u'clusters',
                                                                                               u'describe'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of the cluster to describe.',
                                                                                                       u'name': u'name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'View the details of a cluster.',
                                                                                                   u'EXAMPLES': u'To view the details of a cluster, run:\n\n  $ describe my_cluster\n'}},
                                                                       u'diagnose': {u'capsule': u'Run a detailed diagnostic on a cluster.',
                                                                                     u'commands': {},
                                                                                     u'flags': {},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'diagnose',
                                                                                     u'path': [u'gcloud',
                                                                                               u'dataproc',
                                                                                               u'clusters',
                                                                                               u'diagnose'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of the cluster to diagnose.',
                                                                                                       u'name': u'name',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'Run a detailed diagnostic on a cluster.'}},
                                                                       u'list': {u'capsule': u'View a list of clusters in a project.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--filter',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'EXPRESSION'},
                                                                                            u'--limit': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--limit',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'LIMIT'},
                                                                                            u'--page-size': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': 100,
                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--page-size',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'int',
                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                            u'--sort-by': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--sort-by',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'list',
                                                                                                           u'value': u'FIELD'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'list',
                                                                                 u'path': [u'gcloud',
                                                                                           u'dataproc',
                                                                                           u'clusters',
                                                                                           u'list'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u"View a list of clusters in a project. An optional filter can be used to\nconstrain the clusters returned. Filters are case-sensitive and have the\nfollowing syntax:\n\n  field = value [AND [field = value]] ...\n\nwhere `field` is one of `status.state`, `clusterName`, or `labels.[KEY]`,\nand `[KEY]` is a label key. `value` can be ```*``` to match all values.\n`status.state` can be one of the following: `ACTIVE`, `INACTIVE`,\n`CREATING`, `RUNNING`, `ERROR`, `DELETING`, or `UPDATING`. `ACTIVE`\ncontains the `CREATING`, `UPDATING`, and `RUNNING` states. `INACTIVE`\ncontains the `DELETING` and `ERROR` states. `clusterName` is the name of the\ncluster provided at creation time. Only the logical `AND` operator is\nsupported; space-separated items are treated as having an implicit `AND`\noperator.\n\n## EXAMPLES\n\nTo see the list of all clusters, run:\n\n  $ list\n\nTo show a cluster whose name is `mycluster`, run:\n\n  $ list --filter='clusterName = mycluster'\n\nTo see the list of all clusters with particular labels, run:\n\n  $ list --filter='labels.env = staging AND labels.starred = *'\n\nTo see a list of all active clusters with particular labels, run:\n\n  $ list --filter='status.state = ACTIVE labels.env = staging AND labels.starred = *'"}},
                                                                       u'update': {u'capsule': u'Update labels and/or the number of worker nodes in a cluster.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--async': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--async',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'ASYNC'},
                                                                                              u'--new-num-workers': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--new-num-workers',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'NEW_NUM_WORKERS'},
                                                                                              u'--no-async': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-async',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_ASYNC'},
                                                                                              u'--num-preemptible-workers': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'The new number of preemptible worker nodes in the cluster.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--num-preemptible-workers',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'NUM_PREEMPTIBLE_WORKERS'},
                                                                                              u'--num-workers': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'The new number of worker nodes in the cluster.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--num-workers',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'NUM_WORKERS'},
                                                                                              u'--remove-labels': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'A list of label keys to remove. If a label does not exist it is\nsilently ignored.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--remove-labels',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'list',
                                                                                                                   u'value': u'KEY'},
                                                                                              u'--update-labels': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'A list of label KEY=VALUE pairs to update. If a label exists its value\nis modified, otherwise a new label is created.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--update-labels',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'dict',
                                                                                                                   u'value': u'KEY=VALUE'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'update',
                                                                                   u'path': [u'gcloud',
                                                                                             u'dataproc',
                                                                                             u'clusters',
                                                                                             u'update'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The name of the cluster to update.',
                                                                                                     u'name': u'name',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'value': u'NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u"Update the number of worker nodes and/or the labels in a cluster.\n\n## EXAMPLES\n\nTo resize a cluster, run:\n\n  $ update my_cluster --num-workers 5\n\nTo change the number preemptible workers in a cluster, run:\n\n  $ update my_cluster --num-preemptible-workers 5\n\nTo add the label 'customer=acme' to a cluster, run:\n\n  $ update my_cluster --update-labels=customer=acme\n\nTo update the label 'customer=ackme' to 'customer=acme', run:\n\n  $ update my_cluster --update-labels=customer=acme\n\nTo remove the label whose key is 'customer', run:\n\n  $ update my_cluster --remove-labels=customer"}}},
                                                         u'flags': {},
                                                         u'group': True,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'clusters',
                                                         u'path': [u'gcloud',
                                                                   u'dataproc',
                                                                   u'clusters'],
                                                         u'positionals': [],
                                                         u'release': u'GA',
                                                         u'sections': {u'DESCRIPTION': u'Create and manage Google Cloud Dataproc clusters.\n\n## EXAMPLES\n\nTo create a cluster, run:\n\n  $ clusters create my_cluster\n\nTo resize a cluster, run:\n\n  $ clusters update my_cluster --num_workers 5\n\nTo delete a cluster, run:\n\n  $ clusters delete my_cluster\n\nTo view the details of a cluster, run:\n\n  $ clusters describe my_cluster\n\nTo see the list of all clusters, run:\n\n  $ clusters list'}},
                                           u'jobs': {u'capsule': u'Submit and manage Google Cloud Dataproc jobs.',
                                                     u'commands': {u'delete': {u'capsule': u'Delete the record of an inactive job.',
                                                                               u'commands': {},
                                                                               u'flags': {},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'delete',
                                                                               u'path': [u'gcloud',
                                                                                         u'dataproc',
                                                                                         u'jobs',
                                                                                         u'delete'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The ID of the job to delete.',
                                                                                                 u'name': u'id',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'JOB_ID'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Delete the record of an inactive job.\n\n## EXAMPLES\n\nTo delete the record of a job, run:\n\n  $ delete job_id'}},
                                                                   u'describe': {u'capsule': u'View the details of a job.',
                                                                                 u'commands': {},
                                                                                 u'flags': {},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'describe',
                                                                                 u'path': [u'gcloud',
                                                                                           u'dataproc',
                                                                                           u'jobs',
                                                                                           u'describe'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The ID of the job to describe.',
                                                                                                   u'name': u'id',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'JOB_ID'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'View the details of a job.\n\n## EXAMPLES\n\nTo view the details of a job, run:\n\n  $ describe job_id'}},
                                                                   u'kill': {u'capsule': u'Kill an active job.',
                                                                             u'commands': {},
                                                                             u'flags': {},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'kill',
                                                                             u'path': [u'gcloud',
                                                                                       u'dataproc',
                                                                                       u'jobs',
                                                                                       u'kill'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'The ID of the job to kill.',
                                                                                               u'name': u'id',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'value': u'JOB_ID'}],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'Kill an active job.\n\n## EXAMPLES\n\nTo cancel a job, run:\n\n  $ kill job_id'}},
                                                                   u'list': {u'capsule': u'List jobs in a project.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--cluster': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Restrict to the jobs of this Dataproc cluster.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--cluster',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'CLUSTER'},
                                                                                        u'--filter': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--filter',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'EXPRESSION'},
                                                                                        u'--limit': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--limit',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'LIMIT'},
                                                                                        u'--page-size': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': 100,
                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--page-size',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'int',
                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                        u'--sort-by': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--sort-by',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'FIELD'},
                                                                                        u'--state-filter': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [u'active',
                                                                                                                         u'inactive'],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Filter by job state. _STATE_FILTER_ must be one of: *active*, *inactive*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--state-filter',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'STATE_FILTER'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'list',
                                                                             u'path': [u'gcloud',
                                                                                       u'dataproc',
                                                                                       u'jobs',
                                                                                       u'list'],
                                                                             u'positionals': [],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u"List jobs in a project. An optional filter can be used to constrain the jobs\nreturned. Filters are case-sensitive and have the following syntax:\n\n  [field = value] AND [field [= value]] ...\n\nwhere `field` is `status.state` or `labels.[KEY]`, and `[KEY]` is a label\nkey. `value` can be ```*``` to match all values. `status.state` can be either\n`ACTIVE` or `INACTIVE`. Only the logical `AND` operator is supported;\nspace-separated items are treated as having an implicit `AND` operator.\n\n## EXAMPLES\n\nTo see the list of all jobs, run:\n\n  $ list\n\nTo see a list of all active jobs in cluster `my_cluster` with a label of\n`env=staging`, run:\n\n  $ list --filter='status.state = ACTIVE AND placement.clusterName = my_cluster AND labels.env = staging'"}},
                                                                   u'submit': {u'capsule': u'Submit Google Cloud Dataproc jobs to execute on a cluster.',
                                                                               u'commands': {u'hadoop': {u'capsule': u'Submit a Hadoop job to a cluster.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--archives': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': [],
                                                                                                                                    u'description': u'Comma separated list of archives to be provided to the job. must be one of the following file formats: .zip, .tar, .tar.gz, or .tgz.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--archives',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'ARCHIVE'},
                                                                                                                    u'--class': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The class containing the main method of the driver. Must be in a provided jar or jar that is already on the classpath',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--class',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'CLASS'},
                                                                                                                    u'--cluster': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--cluster',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'CLUSTER'},
                                                                                                                    u'--driver-log-levels': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'A list of package to log4j log level pairs to configure driver logging. For example: root=FATAL,com.example=INFO',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--driver-log-levels',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'dict',
                                                                                                                                             u'value': u'PACKAGE=LEVEL'},
                                                                                                                    u'--files': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': [],
                                                                                                                                 u'description': u'Comma separated list of files to be provided to the job.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--files',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'FILE'},
                                                                                                                    u'--jar': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The HCFS URI of jar file containing the driver jar.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--jar',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'JAR'},
                                                                                                                    u'--jars': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': [],
                                                                                                                                u'description': u'Comma separated list of jar files to be provided to the MR and driver classpaths.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--jars',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'JAR'},
                                                                                                                    u'--labels': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--labels',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'dict',
                                                                                                                                  u'value': u'KEY=VALUE'},
                                                                                                                    u'--properties': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'A list of key value pairs to configure Hadoop.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--properties',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'dict',
                                                                                                                                      u'value': u'PROPERTY=VALUE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'hadoop',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'dataproc',
                                                                                                                   u'jobs',
                                                                                                                   u'submit',
                                                                                                                   u'hadoop'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u"The arguments to pass to the driver.\n+\nThe '--' argument must be specified between gcloud specific args on the left and JOB_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                                                                                                           u'name': u'job-args',
                                                                                                                           u'nargs': u'...',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'JOB_ARGS'}],
                                                                                                         u'release': u'GA',
                                                                                                         u'sections': {u'DESCRIPTION': u'Submit a Hadoop job to a cluster.\n\n## EXAMPLES\n\nTo submit a Hadoop job that runs the main class of a jar, run:\n\n $ hadoop --cluster my_cluster --jar my_jar.jar arg1 arg2\n\nTo submit a Hadoop job that runs a specific class of a jar, run:\n\n  $ hadoop --cluster my_cluster --class org.my.main.Class --jars my_jar1.jar,my_jar2.jar arg1 arg2\n\nTo submit a Hadoop job that runs a jar that is already on the cluster, run:\n\n  $ hadoop --cluster my_cluster --jar file:///usr/lib/hadoop-op/hadoop-op-examples.jar wordcount gs://my_bucket/my_file.txt gs://my_bucket/output'}},
                                                                                             u'hive': {u'capsule': u'Submit a Hive job to a cluster.',
                                                                                                       u'commands': {},
                                                                                                       u'flags': {u'--cluster': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--cluster',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': True,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'CLUSTER'},
                                                                                                                  u'--continue-on-failure': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': False,
                                                                                                                                             u'description': u'Whether to continue if a single query fails.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--continue-on-failure',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'bool',
                                                                                                                                             u'value': u'CONTINUE_ON_FAILURE'},
                                                                                                                  u'--execute': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': [],
                                                                                                                                 u'description': u'A Hive query to execute as part of the job.',
                                                                                                                                 u'group': u'hive.1',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--execute',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'QUERY'},
                                                                                                                  u'--file': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'HCFS URI of file containing Hive script to execute as the job.',
                                                                                                                              u'group': u'hive.1',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--file',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'FILE'},
                                                                                                                  u'--jars': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': [],
                                                                                                                              u'description': u'Comma separated list of jar files to be provided to the Hive and MR. May contain UDFs.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--jars',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'list',
                                                                                                                              u'value': u'JAR'},
                                                                                                                  u'--labels': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--labels',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'dict',
                                                                                                                                u'value': u'KEY=VALUE'},
                                                                                                                  u'--no-continue-on-failure': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': True,
                                                                                                                                                u'description': u'',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': True,
                                                                                                                                                u'name': u'--no-continue-on-failure',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'bool',
                                                                                                                                                u'value': u'NO_CONTINUE_ON_FAILURE'},
                                                                                                                  u'--params': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'A list of key value pairs to set variables in the Hive queries.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--params',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'dict',
                                                                                                                                u'value': u'PARAM=VALUE'},
                                                                                                                  u'--properties': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'A list of key value pairs to configure Hive.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--properties',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'dict',
                                                                                                                                    u'value': u'PROPERTY=VALUE'}},
                                                                                                       u'group': False,
                                                                                                       u'groups': {u'hive.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                               u'is_mutex': True,
                                                                                                                               u'is_required': True}},
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'hive',
                                                                                                       u'path': [u'gcloud',
                                                                                                                 u'dataproc',
                                                                                                                 u'jobs',
                                                                                                                 u'submit',
                                                                                                                 u'hive'],
                                                                                                       u'positionals': [],
                                                                                                       u'release': u'GA',
                                                                                                       u'sections': {u'DESCRIPTION': u'Submit a Hive job to a cluster.\n\n## EXAMPLES\n\nTo submit a Hive job with a local script, run:\n\n  $ hive --cluster my_cluster --file my_queries.q\n\nTo submit a Hive job with inline queries, run:\n\n  $ hive --cluster my_cluster -e "CREATE EXTERNAL TABLE foo(bar int) LOCATION \'gs://my_bucket/\'" -e "SELECT * FROM foo WHERE bar > 2"'}},
                                                                                             u'pig': {u'capsule': u'Submit a Pig job to a cluster.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--cluster': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--cluster',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'CLUSTER'},
                                                                                                                 u'--continue-on-failure': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': False,
                                                                                                                                            u'description': u'Whether to continue if a single query fails.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--continue-on-failure',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'bool',
                                                                                                                                            u'value': u'CONTINUE_ON_FAILURE'},
                                                                                                                 u'--driver-log-levels': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'A list of package to log4j log level pairs to configure driver logging. For example: root=FATAL,com.example=INFO',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--driver-log-levels',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'dict',
                                                                                                                                          u'value': u'PACKAGE=LEVEL'},
                                                                                                                 u'--execute': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': [],
                                                                                                                                u'description': u'A Pig query to execute as part of the job.',
                                                                                                                                u'group': u'pig.1',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--execute',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'QUERY'},
                                                                                                                 u'--file': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'HCFS URI of file containing Pig script to execute as the job.',
                                                                                                                             u'group': u'pig.1',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--file',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'FILE'},
                                                                                                                 u'--jars': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': [],
                                                                                                                             u'description': u'Comma separated list of jar files to be provided to Pig and MR. May contain UDFs.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--jars',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'list',
                                                                                                                             u'value': u'JAR'},
                                                                                                                 u'--labels': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--labels',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'dict',
                                                                                                                               u'value': u'KEY=VALUE'},
                                                                                                                 u'--no-continue-on-failure': {u'attr': {},
                                                                                                                                               u'category': u'',
                                                                                                                                               u'choices': [],
                                                                                                                                               u'completer': u'',
                                                                                                                                               u'default': True,
                                                                                                                                               u'description': u'',
                                                                                                                                               u'group': u'',
                                                                                                                                               u'hidden': True,
                                                                                                                                               u'name': u'--no-continue-on-failure',
                                                                                                                                               u'nargs': u'0',
                                                                                                                                               u'required': False,
                                                                                                                                               u'type': u'bool',
                                                                                                                                               u'value': u'NO_CONTINUE_ON_FAILURE'},
                                                                                                                 u'--params': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'A list of key value pairs to set variables in the Pig queries.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--params',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'dict',
                                                                                                                               u'value': u'PARAM=VALUE'},
                                                                                                                 u'--properties': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A list of key value pairs to configure Pig.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--properties',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'dict',
                                                                                                                                   u'value': u'PROPERTY=VALUE'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {u'pig.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                             u'is_mutex': True,
                                                                                                                             u'is_required': True}},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'pig',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'dataproc',
                                                                                                                u'jobs',
                                                                                                                u'submit',
                                                                                                                u'pig'],
                                                                                                      u'positionals': [],
                                                                                                      u'release': u'GA',
                                                                                                      u'sections': {u'DESCRIPTION': u'Submit a Pig job to a cluster.\n\n## EXAMPLES\n\nTo submit a Pig job with a local script, run:\n\n  $ pig --cluster my_cluster --file my_queries.pig\n\nTo submit a Pig job with inline queries, run:\n\n  $ pig --cluster my_cluster -e "LNS = LOAD \'gs://my_bucket/my_file.txt\' AS (line)" -e "WORDS = FOREACH LNS GENERATE FLATTEN(TOKENIZE(line)) AS word" -e "GROUPS = GROUP WORDS BY word" -e "WORD_COUNTS = FOREACH GROUPS GENERATE group, COUNT(WORDS)" -e "DUMP WORD_COUNTS"',
                                                                                                                    u'EXAMPLES': u'To submit a Pig job with a local script, run:\n\n  $ pig --cluster my_cluster --file my_queries.pig\n\nTo submit a Pig job with inline queries, run:\n\n  $ pig --cluster my_cluster -e "LNS = LOAD \'gs://my_bucket/my_file.txt\' AS (line)" -e "WORDS = FOREACH LNS GENERATE FLATTEN(TOKENIZE(line)) AS word" -e "GROUPS = GROUP WORDS BY word" -e "WORD_COUNTS = FOREACH GROUPS GENERATE group, COUNT(WORDS)" -e "DUMP WORD_COUNTS"\n'}},
                                                                                             u'pyspark': {u'capsule': u'Submit a PySpark job to a cluster.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--archives': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'Comma separated list of archives to be provided to the job. must be one of the following file formats: .zip, .tar, .tar.gz, or .tgz.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--archives',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'ARCHIVE'},
                                                                                                                     u'--cluster': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--cluster',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'CLUSTER'},
                                                                                                                     u'--driver-log-levels': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': None,
                                                                                                                                              u'description': u'A list of package to log4j log level pairs to configure driver logging. For example: root=FATAL,com.example=INFO',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--driver-log-levels',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'dict',
                                                                                                                                              u'value': u'PACKAGE=LEVEL'},
                                                                                                                     u'--files': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': [],
                                                                                                                                  u'description': u'Comma separated list of files to be provided to the job.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--files',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'list',
                                                                                                                                  u'value': u'FILE'},
                                                                                                                     u'--jars': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': [],
                                                                                                                                 u'description': u'Comma separated list of jar files to be provided to the executor and driver classpaths.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--jars',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'list',
                                                                                                                                 u'value': u'JAR'},
                                                                                                                     u'--labels': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--labels',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'dict',
                                                                                                                                   u'value': u'KEY=VALUE'},
                                                                                                                     u'--properties': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'A list of key value pairs to configure PySpark.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--properties',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'dict',
                                                                                                                                       u'value': u'PROPERTY=VALUE'},
                                                                                                                     u'--py-files': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': [],
                                                                                                                                     u'description': u'Comma separated list of Python files to be provided to the job.Must be one of the following file formats" .py, ,.zip, or .egg',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--py-files',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'list',
                                                                                                                                     u'value': u'PY_FILE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'pyspark',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'dataproc',
                                                                                                                    u'jobs',
                                                                                                                    u'submit',
                                                                                                                    u'pyspark'],
                                                                                                          u'positionals': [{u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The main .py file to run as the driver.',
                                                                                                                            u'name': u'py-file',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'PY_FILE'},
                                                                                                                           {u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u"The arguments to pass to the driver.\n+\nThe '--' argument must be specified between gcloud specific args on the left and JOB_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                                                                                                            u'name': u'job-args',
                                                                                                                            u'nargs': u'...',
                                                                                                                            u'required': False,
                                                                                                                            u'value': u'JOB_ARGS'}],
                                                                                                          u'release': u'GA',
                                                                                                          u'sections': {u'DESCRIPTION': u'Submit a PySpark job to a cluster.\n\n## EXAMPLES\nTo submit a PySpark job with a local script, run:\n\n  $ pyspark --cluster my_cluster my_script.py\n\nTo submit a Spark job that runs a script that is already on the cluster, run:\n\n  $ pyspark --cluster my_cluster file:///usr/lib/spark/examples/src/main/python/pi.py 100',
                                                                                                                        u'EXAMPLES': u'To submit a PySpark job with a local script, run:\n\n  $ pyspark --cluster my_cluster my_script.py\n\nTo submit a Spark job that runs a script that is already on the   cluster, run:\n\n  $ pyspark --cluster my_cluster file:///usr/lib/spark/examples/src/main/python/pi.py 100\n'}},
                                                                                             u'spark': {u'capsule': u'Submit a Spark job to a cluster.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--archives': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': [],
                                                                                                                                   u'description': u'Comma separated list of archives to be provided to the job. must be one of the following file formats: .zip, .tar, .tar.gz, or .tgz.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--archives',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'ARCHIVE'},
                                                                                                                   u'--class': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The class containing the main method of the driver. Must be in a provided jar or jar that is already on the classpath',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--class',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'CLASS'},
                                                                                                                   u'--cluster': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--cluster',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'CLUSTER'},
                                                                                                                   u'--driver-log-levels': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'A list of package to log4j log level pairs to configure driver logging. For example: root=FATAL,com.example=INFO',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--driver-log-levels',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': False,
                                                                                                                                            u'type': u'dict',
                                                                                                                                            u'value': u'PACKAGE=LEVEL'},
                                                                                                                   u'--files': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': [],
                                                                                                                                u'description': u'Comma separated list of files to be provided to the job.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--files',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'list',
                                                                                                                                u'value': u'FILE'},
                                                                                                                   u'--jar': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The HCFS URI of jar file containing the driver jar.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--jar',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'JAR'},
                                                                                                                   u'--jars': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': [],
                                                                                                                               u'description': u'Comma separated list of jar files to be provided to the executor and driver classpaths.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--jars',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'list',
                                                                                                                               u'value': u'JAR'},
                                                                                                                   u'--labels': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--labels',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': False,
                                                                                                                                 u'type': u'dict',
                                                                                                                                 u'value': u'KEY=VALUE'},
                                                                                                                   u'--properties': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'A list of key value pairs to configure Spark.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--properties',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'dict',
                                                                                                                                     u'value': u'PROPERTY=VALUE'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'spark',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'dataproc',
                                                                                                                  u'jobs',
                                                                                                                  u'submit',
                                                                                                                  u'spark'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u"The arguments to pass to the driver.\n+\nThe '--' argument must be specified between gcloud specific args on the left and JOB_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                                                                                                          u'name': u'job-args',
                                                                                                                          u'nargs': u'...',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'JOB_ARGS'}],
                                                                                                        u'release': u'GA',
                                                                                                        u'sections': {u'DESCRIPTION': u'Submit a Spark job to a cluster.\n\n## EXAMPLES\n\nTo submit a Spark job that runs the main class of a jar, run:\n\n  $ spark --cluster my_cluster --jar my_jar.jar arg1 arg2\n\nTo submit a Spark job that runs a specific class of a jar, run:\n\n  $ spark --cluster my_cluster --class org.my.main.Class --jars my_jar1.jar,my_jar2.jar arg1 arg2\n\nTo submit a Spark job that runs a jar that is already on the cluster, run:\n\n  $ spark --cluster my_cluster --class org.apache.spark.examples.SparkPi --jars file:///usr/lib/spark/lib/spark-examples.jar 1000'}},
                                                                                             u'spark-sql': {u'capsule': u'Submit a Spark SQL job to a cluster.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--cluster': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The Dataproc cluster to submit the job to.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--cluster',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'CLUSTER'},
                                                                                                                       u'--driver-log-levels': {u'attr': {},
                                                                                                                                                u'category': u'',
                                                                                                                                                u'choices': [],
                                                                                                                                                u'completer': u'',
                                                                                                                                                u'default': None,
                                                                                                                                                u'description': u'A list of package to log4j log level pairs to configure driver logging. For example: root=FATAL,com.example=INFO',
                                                                                                                                                u'group': u'',
                                                                                                                                                u'hidden': False,
                                                                                                                                                u'name': u'--driver-log-levels',
                                                                                                                                                u'nargs': u'0',
                                                                                                                                                u'required': False,
                                                                                                                                                u'type': u'dict',
                                                                                                                                                u'value': u'PACKAGE=LEVEL'},
                                                                                                                       u'--execute': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': [],
                                                                                                                                      u'description': u'A Spark SQL query to execute as part of the job.',
                                                                                                                                      u'group': u'spark-sql.1',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--execute',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'QUERY'},
                                                                                                                       u'--file': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'HCFS URI of file containing Spark SQL script to execute as the job.',
                                                                                                                                   u'group': u'spark-sql.1',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--file',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'FILE'},
                                                                                                                       u'--jars': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': [],
                                                                                                                                   u'description': u'Comma separated list of jar files to be provided to the executor and driver classpaths. May contain UDFs.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--jars',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'list',
                                                                                                                                   u'value': u'JAR'},
                                                                                                                       u'--labels': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'A list of label KEY=VALUE pairs to add.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--labels',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'dict',
                                                                                                                                     u'value': u'KEY=VALUE'},
                                                                                                                       u'--params': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'A list of key value pairs to set variables in the Hive queries.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--params',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'dict',
                                                                                                                                     u'value': u'PARAM=VALUE'},
                                                                                                                       u'--properties': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'A list of key value pairs to configure Hive.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--properties',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'dict',
                                                                                                                                         u'value': u'PROPERTY=VALUE'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {u'spark-sql.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                                         u'is_mutex': True,
                                                                                                                                         u'is_required': True}},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'spark-sql',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'dataproc',
                                                                                                                      u'jobs',
                                                                                                                      u'submit',
                                                                                                                      u'spark-sql'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'GA',
                                                                                                            u'sections': {u'DESCRIPTION': u'Submit a Spark SQL job to a cluster.\n\n## EXAMPLES\n\nTo submit a Spark SQL job with a local script, run:\n\n  $ spark-sql --cluster my_cluster --file my_queries.ql\n\nTo submit a Spark SQL job with inline queries, run:\n\n  $ spark-sql --cluster my_cluster -e "CREATE EXTERNAL TABLE foo(bar int) LOCATION \'gs://my_bucket/\'" -e "SELECT * FROM foo WHERE bar > 2"'}}},
                                                                               u'flags': {u'--async': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u'Does not wait for the job to run.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--async',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'ASYNC'},
                                                                                          u'--bucket': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"The Cloud Storage bucket to stage files in. Defaults to the cluster's configured bucket.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--bucket',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'BUCKET'},
                                                                                          u'--id': {u'attr': {},
                                                                                                    u'category': u'',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': True,
                                                                                                    u'name': u'--id',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'ID'},
                                                                                          u'--no-async': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-async',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_ASYNC'}},
                                                                               u'group': True,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'submit',
                                                                               u'path': [u'gcloud',
                                                                                         u'dataproc',
                                                                                         u'jobs',
                                                                                         u'submit'],
                                                                               u'positionals': [],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Submit Google Cloud Dataproc jobs to execute on a cluster.\n\n## EXAMPLES\n\nTo submit a Hadoop MapReduce job, run:\n\n  $ submit hadoop --cluster my_cluster --jar my_jar.jar arg1 arg2\n\nTo submit a Spark Scala or Java job, run:\n\n  $ submit spark --cluster my_cluster --jar my_jar.jar arg1 arg2\n\nTo submit a PySpark job, run:\n\n  $ submit pyspark --cluster my_cluster my_script.py arg1 arg2\n\nTo submit a Spark SQL job, run:\n\n  $ submit spark-sql --cluster my_cluster --file my_queries.q\n\nTo submit a Pig job, run:\n\n  $ submit pig --cluster my_cluster --file my_script.pig\n\nTo submit a Hive job, run:\n\n  $ submit hive --cluster my_cluster --file my_queries.q'}},
                                                                   u'update': {u'capsule': u'Update the labels for a job.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--remove-labels': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'A list of label keys to remove. If a label does not exist it is\nsilently ignored.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--remove-labels',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'list',
                                                                                                               u'value': u'KEY'},
                                                                                          u'--update-labels': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'A list of label KEY=VALUE pairs to update. If a label exists its value\nis modified, otherwise a new label is created.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--update-labels',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'dict',
                                                                                                               u'value': u'KEY=VALUE'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'update',
                                                                               u'path': [u'gcloud',
                                                                                         u'dataproc',
                                                                                         u'jobs',
                                                                                         u'update'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The ID of the job to describe.',
                                                                                                 u'name': u'id',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'JOB_ID'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u"Update the labels for a job.\n\n## EXAMPLES\n\nTo add the label 'customer=acme' to a job , run:\n\n  $ update job_id --update-labels=customer=acme\n\nTo update the label 'customer=ackme' to 'customer=acme', run:\n\n  $ update job_id --update-labels=customer=acme\n\nTo remove the label whose key is 'customer', run:\n\n  $ update job_id --remove-labels=customer"}},
                                                                   u'wait': {u'capsule': u'View the output of a job as it runs or after it completes.',
                                                                             u'commands': {},
                                                                             u'flags': {},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'wait',
                                                                             u'path': [u'gcloud',
                                                                                       u'dataproc',
                                                                                       u'jobs',
                                                                                       u'wait'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'The ID of the job to wait.',
                                                                                               u'name': u'id',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'value': u'JOB_ID'}],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'View the output of a job as it runs or after it completes.\n\n## EXAMPLES\n\nTo view the output of a job as it runs, run:\n\n  $ wait job_id'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'jobs',
                                                     u'path': [u'gcloud',
                                                               u'dataproc',
                                                               u'jobs'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'Submit and manage Google Cloud Dataproc jobs.\n\n## EXAMPLES\n\nTo learn about the types of jobs that can be submitted, run:\n\n  $ jobs submit\n\nTo view the output of a job as it runs, run:\n\n  $ jobs wait job_id\n\nTo cancel an active job, run:\n\n  $ jobs kill job_id\n\nTo view the details of a job, run:\n\n  $ jobs describe job_id\n\nTo see the list of all jobs, run:\n\n  $ jobs list\n\nTo delete the record of an inactive job, run:\n\n  $ jobs delete job_id'}},
                                           u'operations': {u'capsule': u'View and manage Google Cloud Dataproc operations.',
                                                           u'commands': {u'cancel': {u'capsule': u'Cancel an active operation.',
                                                                                     u'commands': {},
                                                                                     u'flags': {},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'cancel',
                                                                                     u'path': [u'gcloud',
                                                                                               u'dataproc',
                                                                                               u'operations',
                                                                                               u'cancel'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The ID of the operation to cancel.',
                                                                                                       u'name': u'operation',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'OPERATION'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'Cancel an active operation.\n\n## EXAMPLES\n\nTo cancel an operation, run:\n\n  $ cancel operation_id'}},
                                                                         u'delete': {u'capsule': u'Delete the record of an inactive operation.',
                                                                                     u'commands': {},
                                                                                     u'flags': {},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'delete',
                                                                                     u'path': [u'gcloud',
                                                                                               u'dataproc',
                                                                                               u'operations',
                                                                                               u'delete'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The ID of the operation to delete.',
                                                                                                       u'name': u'operation',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'OPERATION'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'Delete the record of an inactive operation.\n\n## EXAMPLES\n\nTo delete the record of an operation, run:\n\n  $ delete operation_id'}},
                                                                         u'describe': {u'capsule': u'View the details of an operation.',
                                                                                       u'commands': {},
                                                                                       u'flags': {},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'describe',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'dataproc',
                                                                                                 u'operations',
                                                                                                 u'describe'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The ID of the operation to describe.',
                                                                                                         u'name': u'operation',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'value': u'OPERATION'}],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u'View the details of an operation.\n\n## EXAMPLES\n\nTo view the details of an operation, run:\n\n  $ describe operation_id'}},
                                                                         u'list': {u'capsule': u'View the list of all operations.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--cluster': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Restrict to the operations of this Dataproc cluster. This flag is ignored when --filter is specified. The equivalent term in a --filter expression is: `clusterName = myclustername`',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--cluster',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'CLUSTER'},
                                                                                              u'--filter': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--filter',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'EXPRESSION'},
                                                                                              u'--limit': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--limit',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'LIMIT'},
                                                                                              u'--page-size': {u'attr': {},
                                                                                                               u'category': u'LIST COMMAND',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': 100,
                                                                                                               u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--page-size',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'int',
                                                                                                               u'value': u'PAGE_SIZE'},
                                                                                              u'--sort-by': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--sort-by',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'list',
                                                                                                             u'value': u'FIELD'},
                                                                                              u'--state-filter': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [u'active',
                                                                                                                               u'inactive'],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Filter by cluster state. This flag is ignored when --filter is specified. The equivalent term in a --filter expression is: `status.state = ACTIVE`. _STATE_FILTER_ must be one of: *active*, *inactive*.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--state-filter',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'STATE_FILTER'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'list',
                                                                                   u'path': [u'gcloud',
                                                                                             u'dataproc',
                                                                                             u'operations',
                                                                                             u'list'],
                                                                                   u'positionals': [],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u"View a list of operations in a project. An optional filter can be used to\nconstrain the operations returned. Filters are case-sensitive and have the\nfollowing syntax:\n\n  field = value [AND [field = value]] ...\n\nwhere `field` is either of `status.state` or `labels.[KEY]`, where `[KEY]` is\na label key. `value` can be ```*``` to match all values. `status.state` is\none of: `PENDING`, `ACTIVE`, `DONE`. Only the logical `AND` operator is\nsupported; space-separated items are treated as having an implicit `AND`\noperator.\n\n## EXAMPLES\n\nTo see the list of all operations, run:\n\n  $ list\n\nTo see the list of all active operations in a cluster named mycluster, run:\n\n  $ list --filter='status.state = RUNNING AND clusterName = mycluster'\n\nTo see a list of all pending operations the label `env=staging` on cluster `mycluster`, run:\n\n  $ list --filter='status.state = PENDING  AND labels.env = staging AND clusterName = mycluster'"}}},
                                                           u'flags': {},
                                                           u'group': True,
                                                           u'groups': {},
                                                           u'hidden': False,
                                                           u'name': u'operations',
                                                           u'path': [u'gcloud',
                                                                     u'dataproc',
                                                                     u'operations'],
                                                           u'positionals': [],
                                                           u'release': u'GA',
                                                           u'sections': {u'DESCRIPTION': u'View and manage Google Cloud Dataproc operations.\n\n## EXAMPLES\n\nTo cancel an active operation, run:\n\n  $ operations cancel operation_id\n\nTo view the details of an operation, run:\n\n  $ operations describe operation_id\n\nTo see the list of all operations, run:\n\n  $ operations list\n\nTo delete the record of an inactive operation, run:\n\n  $ operations delete operation_id'}}},
                             u'flags': {},
                             u'group': True,
                             u'groups': {},
                             u'hidden': False,
                             u'name': u'dataproc',
                             u'path': [u'gcloud', u'dataproc'],
                             u'positionals': [],
                             u'release': u'GA',
                             u'sections': {u'DESCRIPTION': u'The gcloud dataproc command group lets you create and manage Google\nCloud Dataproc clusters and jobs.\n\nCloud Dataproc is an Apache Hadoop, Apache Spark, Apache Pig, and Apache\nHive service. It easily processes big datasets at low cost, creating\nmanaged clusters of any size that scale down once processing is\ncomplete.\n\nMore information on Cloud Dataproc can be found here:\nhttps://cloud.google.com/dataproc and detailed documentation can be\nfound here: https://cloud.google.com/dataproc/docs/\n\n## EXAMPLES\n\nTo see how to create and manage clusters, run:\n\n    $ dataproc clusters\n\nTo see how to submit and manage jobs, run:\n\n    $ dataproc jobs\n'}},
               u'datastore': {u'capsule': u'Manage your Cloud Datastore indexes.',
                              u'commands': {u'cleanup-indexes': {u'capsule': u'Remove unused datastore indexes based on your local index configuration.',
                                                                 u'commands': {},
                                                                 u'flags': {},
                                                                 u'group': False,
                                                                 u'groups': {},
                                                                 u'hidden': False,
                                                                 u'name': u'cleanup-indexes',
                                                                 u'path': [u'gcloud',
                                                                           u'datastore',
                                                                           u'cleanup-indexes'],
                                                                 u'positionals': [{u'completer': u'',
                                                                                   u'default': None,
                                                                                   u'description': u'The path to your index.yaml file.',
                                                                                   u'name': u'index-file',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'value': u'INDEX_FILE'}],
                                                                 u'release': u'GA',
                                                                 u'sections': {u'DESCRIPTION': u'\nThis command removes unused datastore indexes based on your local index\nconfiguration. Any indexes that exist that are not in the index file will be\nremoved.\n',
                                                                               u'EXAMPLES': u'To remove unused indexes based on your local configuration, run:\n\n  $ cleanup-indexes ~/myapp/index.yaml\n'}},
                                            u'create-indexes': {u'capsule': u'Create new datastore indexes based on your local index configuration.',
                                                                u'commands': {},
                                                                u'flags': {},
                                                                u'group': False,
                                                                u'groups': {},
                                                                u'hidden': False,
                                                                u'name': u'create-indexes',
                                                                u'path': [u'gcloud',
                                                                          u'datastore',
                                                                          u'create-indexes'],
                                                                u'positionals': [{u'completer': u'',
                                                                                  u'default': None,
                                                                                  u'description': u'The path to your index.yaml file.',
                                                                                  u'name': u'index-file',
                                                                                  u'nargs': u'0',
                                                                                  u'required': False,
                                                                                  u'value': u'INDEX_FILE'}],
                                                                u'release': u'GA',
                                                                u'sections': {u'DESCRIPTION': u'\nThis command creates new datastore indexes based on your local index\nconfiguration. Any indexes in your index file that do not exist will be created.\n',
                                                                              u'EXAMPLES': u'To create new indexes based on your local configuration, run:\n\n  $ create-indexes ~/myapp/index.yaml\n'}}},
                              u'flags': {},
                              u'group': True,
                              u'groups': {},
                              u'hidden': False,
                              u'name': u'datastore',
                              u'path': [u'gcloud', u'datastore'],
                              u'positionals': [],
                              u'release': u'GA',
                              u'sections': {u'DESCRIPTION': u"The gcloud datastore command group lets you create and delete Google Cloud\nDatastore indexes.\n\nCloud Datastore is a highly-scalable NoSQL database for your applications.\nCloud Datastore automatically handles sharding and replication, providing you\nwith a highly available and durable database that scales automatically to\nhandle your applications' load.\n\nMore information on Cloud Datastore can be found here:\nhttps://cloud.google.com/datastore and detailed documentation can be\nfound here: https://cloud.google.com/datastore/docs\n\n## EXAMPLES\n\nTo create new indexes from a file, run:\n\n  $ datastore create-indexes index.yaml\n\nTo clean up unused indexes from a file, run:\n\n  $ datastore cleanup-indexes index.yaml"}},
               u'debug': {u'capsule': u'Commands for interacting with the Cloud Debugger.',
                          u'commands': {u'logpoints': {u'capsule': u'Commands for interacting with Cloud Debugger logpoints.',
                                                       u'commands': {u'create': {u'capsule': u'Create debug logpoints.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--condition': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'A condition to restrict when the log output is generated. When the\nlogpoint is hit, the condition will be evaluated, and the log output\nwill be generated only if the condition is true.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--condition',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'CONDITION'},
                                                                                            u'--log-level': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [u'info',
                                                                                                                          u'warning',
                                                                                                                          u'error'],
                                                                                                             u'completer': u'',
                                                                                                             u'default': u'info',
                                                                                                             u'description': u'The logging level to use when producing the log message. _LOG_LEVEL_ must be one of: *info*, *warning*, *error*.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--log-level',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'LOG_LEVEL'},
                                                                                            u'--wait': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': 10,
                                                                                                        u'description': u'The number of seconds to wait to ensure that no error is returned\nfrom a debugger agent when creating the logpoint. When a logpoint\nis created, there will be a delay before the agents see and apply\nthe logpoint. Until at least one agent has attempted to\nenable the logpoint, it cannot be determined if the logpoint is\nvalid.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--wait',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'int',
                                                                                                        u'value': u'WAIT'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'create',
                                                                                 u'path': [u'gcloud',
                                                                                           u'debug',
                                                                                           u'logpoints',
                                                                                           u'create'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The logpoint location. Locations are of\nthe form FILE:LINE, where FILE can be simply the file name, or the\nfile name preceded by enough path components to differentiate it\nfrom other files with the same name. It is an error to provide a\nfile name that is not unique in the debug target.',
                                                                                                   u'name': u'location',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'LOCATION'},
                                                                                                  {u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'A format string which will be logged every time the logpoint\nlocation is executed. If the string contains curly braces (\'{\' and\n\'}\'), any text within the curly braces will be interpreted as a\nrun-time expression in the debug target\'s language, which will be\nevaluated when the logpoint is hit.\n+\nThe value of the expression will then replace the {} expression in\nthe resulting log output. For example, if you specify the format\nstring "a={a}, b={b}", and the logpoint is hit when local variable\na is 1 and b is 2, the resulting log output would be "a=1, b=2".',
                                                                                                   u'name': u'log-format-string',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'LOG_FORMAT_STRING'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'This command adds a debug logpoint to a debug target. Logpoints add\nlogging to your running service without changing your code or\nrestarting your application. When you create a logpoint, the message\nyou specify will be added to your logs whenever any instance of your\nservice executes the specified line of code.\n\nThe default lifetime of a logpoint is 24 hours from creation, and the\noutput will go to the standard log for the programming language of the\ntarget (java.logging for Java, logging.* for Python, etc.)\n'}},
                                                                     u'delete': {u'capsule': u'Delete debug logpoints.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--all-users': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': False,
                                                                                                             u'description': u'If set, any location regexp will match logpoints from all users,\nrather than only logpoints created by the current user. This flag is\nnot required when specifying the exact ID of a logpoint created by\nanother user.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--all-users',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'ALL_USERS'},
                                                                                            u'--include-inactive': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'If set, any location regexp will also match inactive logpoints,\nrather than only logpoints which have not expired. This flag is\nnot required when specifying the exact ID of an inactive logpoint.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--include-inactive',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'INCLUDE_INACTIVE'},
                                                                                            u'--location': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'A regular expression to match against logpoint\nlocations. All logpoints matching this value will be\ndeleted.  You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n      --location foo.py:[1-3] --location bar.py:4',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--location',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'LOCATION-REGEXP'},
                                                                                            u'--no-all-users': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--no-all-users',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_ALL_USERS'},
                                                                                            u'--no-include-inactive': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-include-inactive',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_INCLUDE_INACTIVE'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'delete',
                                                                                 u'path': [u'gcloud',
                                                                                           u'debug',
                                                                                           u'logpoints',
                                                                                           u'delete'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'Zero or more logpoint resource identifiers. The specified\nlogpoints will be deleted.',
                                                                                                   u'name': u'ids',
                                                                                                   u'nargs': u'*',
                                                                                                   u'required': False,
                                                                                                   u'value': u'ID'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'This command deletes logpoints from a Cloud Debugger debug target. It will\nask for confirmation before deleting any logpoints. To suppress confirmation,\nuse the global --quiet option.'}},
                                                                     u'list': {u'capsule': u'List debug logpoints.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--all-users': {u'attr': {u'inverted_synopsis': True},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': True,
                                                                                                           u'description': u'If false, display only logpoints created by the current user. Enabled by default, use *--no-all-users* to disable.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--all-users',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'ALL_USERS'},
                                                                                          u'--filter': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--filter',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'EXPRESSION'},
                                                                                          u'--include-inactive': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': 300,
                                                                                                                  u'description': u'Include logpoints which failed or expired in the last\nINCLUDE_INACTIVE seconds. If the value is "unlimited", all failed\nor expired logpoints will be included.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--include-inactive',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'int',
                                                                                                                  u'value': u'INCLUDE_INACTIVE'},
                                                                                          u'--limit': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--limit',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'LIMIT'},
                                                                                          u'--location': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'A regular expression to match against logpoint\nlocations. All logpoints matching this value will be\nlisted.  You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n      --location foo.py:[1-3] --location bar.py:4',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--location',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'LOCATION-REGEXP'},
                                                                                          u'--no-all-users': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': True,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-all-users',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_ALL_USERS'},
                                                                                          u'--page-size': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--page-size',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                          u'--sort-by': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--sort-by',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'list',
                                                                                                         u'value': u'FIELD'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'list',
                                                                               u'path': [u'gcloud',
                                                                                         u'debug',
                                                                                         u'logpoints',
                                                                                         u'list'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Zero or more logpoint resource identifiers. The specified\nlogpoints will be listed.',
                                                                                                 u'name': u'ids',
                                                                                                 u'nargs': u'*',
                                                                                                 u'required': False,
                                                                                                 u'value': u'ID'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'This command displays a list of the active debug logpoints for a\nCloud Debugger debug target.\n'}}},
                                                       u'flags': {u'--target': {u'attr': {},
                                                                                u'category': u'',
                                                                                u'choices': [],
                                                                                u'completer': u'',
                                                                                u'default': None,
                                                                                u'description': u"The debug target. It may be a target ID or name obtained from\n'debug targets list', or it may be a regular expression uniquely\nspecifying a debuggee based on its description or name. For App\nEngine projects, if not specified, the default target is\nthe most recent deployment of the default module and version.",
                                                                                u'group': u'',
                                                                                u'hidden': False,
                                                                                u'name': u'--target',
                                                                                u'nargs': u'0',
                                                                                u'required': False,
                                                                                u'type': u'string',
                                                                                u'value': u'(ID|DESCRIPTION_REGEXP)'}},
                                                       u'group': True,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'logpoints',
                                                       u'path': [u'gcloud',
                                                                 u'debug',
                                                                 u'logpoints'],
                                                       u'positionals': [],
                                                       u'release': u'GA',
                                                       u'sections': {u'DESCRIPTION': u"Logpoints allow you to inject logging into running services without\nrestarting or interfering with the normal function of the service. Log output\nwill be sent to the appropriate log for the target's environment.\nOn App Engine, for example, output will go to the request log.",
                                                                     u'EXAMPLES': u'\nThe following command would log the value of the "name" attribute\nof the "product" variable whenever any request executes line 123 of\nthe file product.py:\n\n    $ logpoints create product.py:123               "No description for {product.name}"\n\nThe log output will appear wherever explicit logging output from your\nprogram is normally written. For example, for an App Engine Standard\napplication, the output would appear in the request log.\n\nIf you want to log output only when certain runtime conditions are met,\nyou can add a "--condition" option:\n\n    $ logpoints create product.py:123               "Suspicious price: {product.name} costs {price}"               --condition "price < .50"\n\nLogpoints remain active for 24 hours after creation. If you want to\ndisable a logpoint, use the logpoints delete command:\n\n    $ logpoints delete product.*\n\nThe above command would delete all logpoints in any file whose name\nbegins with "product". If you want to delete only a single logpoint, you\nshould first determine the logpoint ID using the logpoints list command,\nthen delete that specific ID:\n\n    $ logpoints list\n    ID                        LOCATION    ...\n    567890abcdef1-1234-56789  product.py:123  ...\n    $ logpoints delete 567890abcdef1-1234-56789\n\nFor App Engine services, logpoint resources include the "logQuery"\nproperty, which is suitable for use with the "gcloud beta logging read"\ncommand. You can save this property\'s value and use it to read logs from\nthe command line:\n\n    $ log_query=$(logpoints create product.py:123               "No description for {product.name}" --format="value(logQuery)")\n    $ gcloud beta logging read "$log_query"\n'}},
                                        u'snapshots': {u'capsule': u'Commands for interacting with Cloud Debugger snapshots.',
                                                       u'commands': {u'create': {u'capsule': u'Create debug snapshots.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--condition': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'A condition to restrict when the snapshot is taken. When the\nsnapshot location is executed, the condition will be evaluated, and\nthe snapshot will be generated only if the condition is true.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--condition',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'CONDITION'},
                                                                                            u'--expression': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'An expression to evaluate when the snapshot is taken. You may\nspecify --expression multiple times.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--expression',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'EXPRESSION'},
                                                                                            u'--wait': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': 10,
                                                                                                        u'description': u'The number of seconds to wait to ensure that no error is returned\nfrom a debugger agent when creating the snapshot. When a snapshot\nis created, there will be a delay before the agents see and apply\nthe snapshot. Until at least one agent has attempted to\nenable the snapshot, it cannot be determined if the snapshot is\nvalid.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--wait',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'int',
                                                                                                        u'value': u'WAIT'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'create',
                                                                                 u'path': [u'gcloud',
                                                                                           u'debug',
                                                                                           u'snapshots',
                                                                                           u'create'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The location where the snapshot should be taken. Locations are of\nthe form FILE:LINE, where FILE can be simply the file name, or the\nfile name preceded by enough path components to differntiate it from\nother files with the same name. If the file name is not unique in\nthe debug target, the behavior is unspecified.',
                                                                                                   u'name': u'location',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'LOCATION'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'This command creates a debug snapshot on a Cloud Debugger debug\ntarget. Snapshots allow you to capture stack traces and local\nvariables from your running service without interfering with normal\noperations.\n\nWhen any instance of the target executes the snapshot location, the\noptional condition expression is evaluated. If the result is true\n(or if there is no condition), the instance captures the current\nthread state and reports it back to Cloud Debugger. Once any instance\ncaptures a snapshot, the snapshot is marked as completed, and it\nwill not be captured again.\n\nYou can most easily view snapshot results in the developer console. It\nis also possible to inspect snapshot results with the "snapshots\ndescribe" command.\n'}},
                                                                     u'delete': {u'capsule': u'Delete debug snapshots.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--all-users': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': False,
                                                                                                             u'description': u'If set, matching snapshots from all users will be deleted, rather\nthan only snapshots created by the current user.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--all-users',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'ALL_USERS'},
                                                                                            u'--include-inactive': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'If set, also delete snapshots which have been completed. By default,\nonly pending snapshots will be deleted.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--include-inactive',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'INCLUDE_INACTIVE'},
                                                                                            u'--location': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'A regular expression to match against snapshot\nlocations. All snapshots matching this value will be\ndeleted.  You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n      --location foo.py:[1-3] --location bar.py:4',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--location',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'LOCATION-REGEXP'},
                                                                                            u'--no-all-users': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--no-all-users',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_ALL_USERS'},
                                                                                            u'--no-include-inactive': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-include-inactive',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_INCLUDE_INACTIVE'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'delete',
                                                                                 u'path': [u'gcloud',
                                                                                           u'debug',
                                                                                           u'snapshots',
                                                                                           u'delete'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'Zero or more snapshot resource identifiers. The specified\nsnapshots will be deleted.',
                                                                                                   u'name': u'ids',
                                                                                                   u'nargs': u'*',
                                                                                                   u'required': False,
                                                                                                   u'value': u'ID'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'This command deletes snapshots from a Cloud Debugger debug target. It will\nask for confirmation before deleting any snapshots. To suppress confirmation,\nuse the global --quiet option.'}},
                                                                     u'describe': {u'capsule': u'Describe debug snapshots.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--location': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'A regular expression to match against snapshot\nlocations. All snapshots matching this value will be\ndisplayed.  You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n      --location foo.py:[1-3] --location bar.py:4',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--location',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'LOCATION-REGEXP'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'describe',
                                                                                   u'path': [u'gcloud',
                                                                                             u'debug',
                                                                                             u'snapshots',
                                                                                             u'describe'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Zero or more snapshot resource identifiers. The specified\nsnapshots will be displayed.',
                                                                                                     u'name': u'ids',
                                                                                                     u'nargs': u'*',
                                                                                                     u'required': False,
                                                                                                     u'value': u'ID'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'This command describes debug snapshots for a Cloud Debugger debug\ntarget. If the snapshot has been completed, the output will include\ndetails on the stack trace and local variables, stored in a compact\nform which is primarily intended to be machine-readable rather than\nhuman-readable.\n'}},
                                                                     u'list': {u'capsule': u'List debug snapshots.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--all-users': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'If set, display snapshots from all users, rather than only the\ncurrent user.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--all-users',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'ALL_USERS'},
                                                                                          u'--filter': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--filter',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'EXPRESSION'},
                                                                                          u'--include-inactive': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': 300,
                                                                                                                  u'description': u'Include snapshots which have completed in the last INCLUDE_INACTIVE\nseconds. If the value is "unlimited", all inactive snapshots will\nbe included.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--include-inactive',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'int',
                                                                                                                  u'value': u'INCLUDE_INACTIVE'},
                                                                                          u'--limit': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--limit',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'LIMIT'},
                                                                                          u'--location': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'A regular expression to match against snapshot\nlocations. All snapshots matching this value will be\ndisplayed.  You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n      --location foo.py:[1-3] --location bar.py:4',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--location',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'LOCATION-REGEXP'},
                                                                                          u'--no-all-users': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-all-users',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_ALL_USERS'},
                                                                                          u'--page-size': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--page-size',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                          u'--sort-by': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--sort-by',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'list',
                                                                                                         u'value': u'FIELD'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'list',
                                                                               u'path': [u'gcloud',
                                                                                         u'debug',
                                                                                         u'snapshots',
                                                                                         u'list'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Zero or more snapshot resource identifiers. The specified\nsnapshots will be displayed.',
                                                                                                 u'name': u'ids',
                                                                                                 u'nargs': u'*',
                                                                                                 u'required': False,
                                                                                                 u'value': u'ID'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'This command displays a list of the active debug snapshots for a\nCloud Debugger debug target.\n'}},
                                                                     u'wait': {u'capsule': u'Wait for debug snapshots to complete.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--all': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'If set, wait for all of the specified snapshots to complete, instead of\nwaiting for any one of them to complete.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--all',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'ALL'},
                                                                                          u'--all-users': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'If set, wait for matching snapshots from all users, rather than\nonly the current user.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--all-users',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'ALL_USERS'},
                                                                                          u'--filter': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--filter',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'EXPRESSION'},
                                                                                          u'--limit': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--limit',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'LIMIT'},
                                                                                          u'--location': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'A regular expression to match against snapshot\nlocations. The command will wait for any snapshots matching these\ncriteria to complete. You may specify --location multiple times.\n+\nEXAMPLE:\n+\n  {command} \\\n    --location foo.py:[1-3] --location bar.py:3',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--location',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'LOCATION-REGEXP'},
                                                                                          u'--no-all': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': False,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-all',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_ALL'},
                                                                                          u'--no-all-users': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-all-users',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_ALL_USERS'},
                                                                                          u'--no-uri': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-uri',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_URI'},
                                                                                          u'--page-size': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--page-size',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                          u'--sort-by': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--sort-by',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'list',
                                                                                                         u'value': u'FIELD'},
                                                                                          u'--timeout': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': u'unlimited',
                                                                                                         u'description': u'Maximum number of seconds to wait for a snapshot to complete. By\ndefault, wait indefinitely.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--timeout',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'TIMEOUT'},
                                                                                          u'--uri': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--uri',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'URI'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'wait',
                                                                               u'path': [u'gcloud',
                                                                                         u'debug',
                                                                                         u'snapshots',
                                                                                         u'wait'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Zero or more snapshot resource identifiers. The command will\nwait for any of the specified snapshots to complete.',
                                                                                                 u'name': u'ids',
                                                                                                 u'nargs': u'*',
                                                                                                 u'required': False,
                                                                                                 u'value': u'ID'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'This command waits for one or more snapshots on a Cloud Debugger debug\ntarget to become completed. A snapshot is considered completed either\nif there was an error setting the snapshot or if the snapshot was hit\non an instance of the debug target.\n'}}},
                                                       u'flags': {u'--target': {u'attr': {},
                                                                                u'category': u'',
                                                                                u'choices': [],
                                                                                u'completer': u'',
                                                                                u'default': None,
                                                                                u'description': u"The debug target. It may be a target ID or name obtained from\n'debug targets list', or it may be a regular expression uniquely\nspecifying a debuggee based on its description or name. For App\nEngine projects, if not specified, the default target is\nthe most recent deployment of the default module and version.",
                                                                                u'group': u'',
                                                                                u'hidden': False,
                                                                                u'name': u'--target',
                                                                                u'nargs': u'0',
                                                                                u'required': False,
                                                                                u'type': u'string',
                                                                                u'value': u'(ID|DESCRIPTION_REGEXP)'}},
                                                       u'group': True,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'snapshots',
                                                       u'path': [u'gcloud',
                                                                 u'debug',
                                                                 u'snapshots'],
                                                       u'positionals': [],
                                                       u'release': u'GA',
                                                       u'sections': {u'DESCRIPTION': u'Commands to interact with debug snapshots. Snapshots allow you to capture\nstack traces and local variables from running services without interfering\nwith the normal function of the service.'}},
                                        u'source': {u'capsule': u'Commands to manage source information for Stackdriver tools.',
                                                    u'commands': {u'gen-repo-info-file': {u'capsule': u'Generates repository information files for the Stackdriver Debugger.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--output-directory': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': u'.',
                                                                                                                             u'description': u'The directory in which to create the source context files.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--output-directory',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'OUTPUT_DIRECTORY'},
                                                                                                     u'--source-directory': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': u'.',
                                                                                                                             u'description': u'The directory containing the source code for the build.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--source-directory',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'SOURCE_DIRECTORY'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'gen-repo-info-file',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'debug',
                                                                                                    u'source',
                                                                                                    u'gen-repo-info-file'],
                                                                                          u'positionals': [],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'This command generates two files, source-context.json and\nsource-contexts.json, containing information on the source revision\nand remote repository associated with the given source directory.\n',
                                                                                                        u'EXAMPLES': u'To generate repository information files for your app,\nfrom your source directory run:\n\n  $ gen-repo-info-file\n'}}},
                                                    u'flags': {},
                                                    u'group': True,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'source',
                                                    u'path': [u'gcloud',
                                                              u'debug',
                                                              u'source'],
                                                    u'positionals': [],
                                                    u'release': u'GA',
                                                    u'sections': {u'DESCRIPTION': u'This set of commands allows you to provide Stackdriver tools with source\ncode version information.'}},
                                        u'targets': {u'capsule': u'Commands for interacting with Cloud Debugger debug targets.',
                                                     u'commands': {u'list': {u'capsule': u'List debug targets.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--filter',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'EXPRESSION'},
                                                                                        u'--include-inactive': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'If set, include targets which are no longer active.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--include-inactive',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'INCLUDE_INACTIVE'},
                                                                                        u'--limit': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--limit',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'LIMIT'},
                                                                                        u'--no-include-inactive': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--no-include-inactive',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'NO_INCLUDE_INACTIVE'},
                                                                                        u'--no-uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': True,
                                                                                                      u'description': u'',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': True,
                                                                                                      u'name': u'--no-uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'NO_URI'},
                                                                                        u'--page-size': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--page-size',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                        u'--sort-by': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--sort-by',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'FIELD'},
                                                                                        u'--uri': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': False,
                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--uri',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'URI'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'list',
                                                                             u'path': [u'gcloud',
                                                                                       u'debug',
                                                                                       u'targets',
                                                                                       u'list'],
                                                                             u'positionals': [],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'This command displays a list of the active debug targets registered\nwith the Cloud Debugger.'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'targets',
                                                     u'path': [u'gcloud',
                                                               u'debug',
                                                               u'targets'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'Commands to interact with debug targets. A debug target can be an App Engine\nmodule version or any other entity enabled for use with the cloud debugger.',
                                                                   u'EXAMPLES': u'To view all available debug targets, run:\n\n    $ targets list\n'}}},
                          u'flags': {},
                          u'group': True,
                          u'groups': {},
                          u'hidden': False,
                          u'name': u'debug',
                          u'path': [u'gcloud', u'debug'],
                          u'positionals': [],
                          u'release': u'GA',
                          u'sections': {u'DESCRIPTION': u'The debug command group provides interaction with Stackdriver Debugger,\nallowing you to list and manipulate debugging targets, snapshots and\nlogpoints.\n\nStackdriver Debugger is a feature of the Google Cloud Platform that lets you\ninspect the state of an application at any code location without using logging\nstatements and without stopping or slowing down your applications.\n\nMore information on Stackdriver Debugger can be found here:\nhttps://cloud.google.com/debugger and detailed documentation can be found\nhere: https://cloud.google.com/debugger/docs/\n\n## EXAMPLES\n\nTo view all available debug targets, run:\n\n  $ debug targets list\n\n  NAME           ID             DESCRIPTION\n  default-test   gcp:1234:5678  myproject-test-9876543\n  default-test2  gcp:9012:3456  myproject-test2-1234567\n\nTo create a snapshot in a for a particular target:\n\n  $ debug snapshots create --target=default-test foo.py:12\n\nNote that if there is not a target with the exact name or ID specified, the\ntarget is treated as a regular expression to match against the name or\ndescription:\n\n  $ debug snapshots create --target=test foo.py:12\n\n  ERROR: (gcloud.beta.debug.snapshots.create) Multiple possible targets found.\n  Use the --target option to select one of the following targets:\n      default-test\n      default-test2\n\n  In the above case, "test" matches both targets\' names. Specifying \'test$\'\n  would match only "default-test" (by name), while "9876" would match\n  "default-test" by description.'}},
               u'deployment-manager': {u'capsule': u'Manage deployments of cloud resources.',
                                       u'commands': {u'deployments': {u'capsule': u'Commands for Deployment Manager deployments.',
                                                                      u'commands': {u'cancel-preview': {u'capsule': u'Cancel a pending or running deployment preview.',
                                                                                                        u'commands': {},
                                                                                                        u'flags': {u'--async': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--async',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'ASYNC'},
                                                                                                                   u'--fingerprint': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'The fingerprint to use in requests to modify a deployment. If not specified, a get deployment request will be made to fetch the latest fingerprint. A fingerprint is a randomly generated value that is part of the update, stop, and cancel-preview request to perform optimistic locking. It is initially generated by Deployment Manager and changes after every request to modify data. The latest fingerprint is printed when deployment data is modified.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--fingerprint',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'FINGERPRINT'},
                                                                                                                   u'--no-async': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': False,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-async',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_ASYNC'}},
                                                                                                        u'group': False,
                                                                                                        u'groups': {},
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'cancel-preview',
                                                                                                        u'path': [u'gcloud',
                                                                                                                  u'deployment-manager',
                                                                                                                  u'deployments',
                                                                                                                  u'cancel-preview'],
                                                                                                        u'positionals': [{u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Deployment name.',
                                                                                                                          u'name': u'deployment-name',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'value': u'DEPLOYMENT_NAME'}],
                                                                                                        u'release': u'GA',
                                                                                                        u'sections': {u'DESCRIPTION': u'This command will cancel a currently running or pending preview operation on\na deployment.',
                                                                                                                      u'EXAMPLES': u'To cancel a running operation on a deployment, run:\n\n  $ cancel-preview my-deployment\n\nTo issue a cancel preview command without waiting for the operation to complete, run:\n\n  $ cancel-preview my-deployment --async\n\nTo cancel a preview command providing a fingerprint:\n\n  $ cancel-preview my-deployment --fingerprint deployment-fingerprint\n'}},
                                                                                    u'create': {u'capsule': u'Create a deployment.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--async': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--async',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'ASYNC'},
                                                                                                           u'--config': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Filename of config which specifies resources to deploy.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--config',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': True,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'CONFIG'},
                                                                                                           u'--description': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'Optional description of the deployment to insert.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--description',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'DESCRIPTION'},
                                                                                                           u'--no-async': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-async',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_ASYNC'},
                                                                                                           u'--no-preview': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-preview',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_PREVIEW'},
                                                                                                           u'--preview': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'Preview the requested create without actually instantiating the underlying resources. (default=False)',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--preview',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'PREVIEW'},
                                                                                                           u'--properties': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'A comma seperated, key=value, map to be used when deploying a template file directly.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--properties',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'dict',
                                                                                                                             u'value': u'PROPERTIES'}},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'create',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'deployment-manager',
                                                                                                          u'deployments',
                                                                                                          u'create'],
                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Deployment name.',
                                                                                                                  u'name': u'deployment-name',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'value': u'DEPLOYMENT_NAME'}],
                                                                                                u'release': u'GA',
                                                                                                u'sections': {u'DESCRIPTION': u'This command inserts (creates) a new deployment based on a provided config\nfile.',
                                                                                                              u'EXAMPLES': u'To create a new deployment, run:\n\n  $ create my-deployment --config config.yaml --description "My deployment"\n\nTo preview a deployment without actually creating resources, run:\n\n  $ create my-new-deployment --config config.yaml --preview\n\nTo instantiate a deployment that has been previewed, issue an update command for that deployment without specifying a config file.\n'}},
                                                                                    u'delete': {u'capsule': u'Delete a deployment.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--async': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--async',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'ASYNC'},
                                                                                                           u'--delete-policy': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [u'ABANDON',
                                                                                                                                             u'DELETE'],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': u'DELETE',
                                                                                                                                u'description': u'Delete policy for resources that will change as part of an update or delete. DELETE deletes the resource while ABANDON just removes the resource reference from the deployment. _DELETE_POLICY_ must be one of: *ABANDON*, *DELETE*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--delete-policy',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'DELETE_POLICY'},
                                                                                                           u'--no-async': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-async',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_ASYNC'}},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'delete',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'deployment-manager',
                                                                                                          u'deployments',
                                                                                                          u'delete'],
                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Deployment name.',
                                                                                                                  u'name': u'deployment-name',
                                                                                                                  u'nargs': u'+',
                                                                                                                  u'required': False,
                                                                                                                  u'value': u'DEPLOYMENT_NAME'}],
                                                                                                u'release': u'GA',
                                                                                                u'sections': {u'DESCRIPTION': u'This command deletes a deployment and deletes all associated resources.',
                                                                                                              u'EXAMPLES': u'To delete a deployment, run:\n\n  $ delete my-deployment\n\nTo issue a delete command without waiting for the operation to complete, run:\n\n  $ delete my-deployment --async\n\nTo delete several deployments, run:\n\n  $ delete my-deployment-one my-deployment-two my-deployment-three\n\nTo disable the confirmation prompt on delete, run:\n\n  $ delete my-deployment -q\n'}},
                                                                                    u'describe': {u'capsule': u'Provide information about a deployment.',
                                                                                                  u'commands': {},
                                                                                                  u'flags': {},
                                                                                                  u'group': False,
                                                                                                  u'groups': {},
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'describe',
                                                                                                  u'path': [u'gcloud',
                                                                                                            u'deployment-manager',
                                                                                                            u'deployments',
                                                                                                            u'describe'],
                                                                                                  u'positionals': [{u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Deployment name.',
                                                                                                                    u'name': u'deployment-name',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'value': u'DEPLOYMENT_NAME'}],
                                                                                                  u'release': u'GA',
                                                                                                  u'sections': {u'DESCRIPTION': u'This command prints out all available details about a deployment.',
                                                                                                                u'EXAMPLES': u'To display information about a deployment, run:\n\n  $ describe my-deployment\n'}},
                                                                                    u'list': {u'capsule': u'List deployments in a project.',
                                                                                              u'commands': {},
                                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--filter',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'EXPRESSION'},
                                                                                                         u'--limit': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--limit',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'LIMIT'},
                                                                                                         u'--no-uri': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': True,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-uri',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_URI'},
                                                                                                         u'--page-size': {u'attr': {},
                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--page-size',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                                         u'--simple-list': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--simple-list',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'SIMPLE_LIST'},
                                                                                                         u'--sort-by': {u'attr': {},
                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--sort-by',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'list',
                                                                                                                        u'value': u'FIELD'},
                                                                                                         u'--uri': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--uri',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'URI'}},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'list',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'deployment-manager',
                                                                                                        u'deployments',
                                                                                                        u'list'],
                                                                                              u'positionals': [],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'Prints a table with summary information on all deployments in the project.',
                                                                                                            u'EXAMPLES': u'To print out a list of deployments with some summary information about each, run:\n\n  $ list\n\nTo print only the name of each deployment, run:\n\n  $ list --simple-list\n'}},
                                                                                    u'stop': {u'capsule': u'Stop a pending or running deployment update or creation.',
                                                                                              u'commands': {},
                                                                                              u'flags': {u'--async': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': False,
                                                                                                                      u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--async',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'bool',
                                                                                                                      u'value': u'ASYNC'},
                                                                                                         u'--fingerprint': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': None,
                                                                                                                            u'description': u'The fingerprint to use in requests to modify a deployment. If not specified, a get deployment request will be made to fetch the latest fingerprint. A fingerprint is a randomly generated value that is part of the update, stop, and cancel-preview request to perform optimistic locking. It is initially generated by Deployment Manager and changes after every request to modify data. The latest fingerprint is printed when deployment data is modified.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--fingerprint',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'string',
                                                                                                                            u'value': u'FINGERPRINT'},
                                                                                                         u'--no-async': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': False,
                                                                                                                         u'description': u'',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': True,
                                                                                                                         u'name': u'--no-async',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'bool',
                                                                                                                         u'value': u'NO_ASYNC'}},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'stop',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'deployment-manager',
                                                                                                        u'deployments',
                                                                                                        u'stop'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Deployment name.',
                                                                                                                u'name': u'deployment-name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'DEPLOYMENT_NAME'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'This command will stop a currently running or pending operation on\na deployment.',
                                                                                                            u'EXAMPLES': u'To stop a running operation on a deployment, run:\n\n  $ stop my-deployment\n\nTo issue a stop command without waiting for the operation to complete, run:\n\n  $ stop my-deployment --async\n\nTo stop a running operation on a deployment providing a fingerprint, run:\n\n  $ stop my-deployment --fingerprint deployment-fingerprint\n'}},
                                                                                    u'update': {u'capsule': u'Update a deployment based on a provided config file.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--async': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'Return immediately and print information about the Operation in progress rather than waiting for the Operation to complete. (default=False)',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--async',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'ASYNC'},
                                                                                                           u'--config': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Filename of config which specifies resources to deploy. Required unless launching an already-previewed update to this deployment.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--config',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'CONFIG'},
                                                                                                           u'--create-policy': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [u'ACQUIRE',
                                                                                                                                             u'CREATE_OR_ACQUIRE'],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': u'CREATE_OR_ACQUIRE',
                                                                                                                                u'description': u'Create policy for resources that have changed in the update. _CREATE_POLICY_ must be one of: *ACQUIRE*, *CREATE_OR_ACQUIRE*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--create-policy',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'CREATE_POLICY'},
                                                                                                           u'--delete-policy': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [u'ABANDON',
                                                                                                                                             u'DELETE'],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': u'DELETE',
                                                                                                                                u'description': u'Delete policy for resources that will change as part of an update or delete. DELETE deletes the resource while ABANDON just removes the resource reference from the deployment. _DELETE_POLICY_ must be one of: *ABANDON*, *DELETE*.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--delete-policy',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'DELETE_POLICY'},
                                                                                                           u'--description': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The new description of the deployment.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--description',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'DESCRIPTION'},
                                                                                                           u'--fingerprint': {u'attr': {},
                                                                                                                              u'category': u'',
                                                                                                                              u'choices': [],
                                                                                                                              u'completer': u'',
                                                                                                                              u'default': None,
                                                                                                                              u'description': u'The fingerprint to use in requests to modify a deployment. If not specified, a get deployment request will be made to fetch the latest fingerprint. A fingerprint is a randomly generated value that is part of the update, stop, and cancel-preview request to perform optimistic locking. It is initially generated by Deployment Manager and changes after every request to modify data. The latest fingerprint is printed when deployment data is modified.',
                                                                                                                              u'group': u'',
                                                                                                                              u'hidden': False,
                                                                                                                              u'name': u'--fingerprint',
                                                                                                                              u'nargs': u'0',
                                                                                                                              u'required': False,
                                                                                                                              u'type': u'string',
                                                                                                                              u'value': u'FINGERPRINT'},
                                                                                                           u'--no-async': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-async',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_ASYNC'},
                                                                                                           u'--no-preview': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': False,
                                                                                                                             u'description': u'',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': True,
                                                                                                                             u'name': u'--no-preview',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'bool',
                                                                                                                             u'value': u'NO_PREVIEW'},
                                                                                                           u'--preview': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'Preview the requested update without making any changes to theunderlying resources. (default=False)',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--preview',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'PREVIEW'},
                                                                                                           u'--properties': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'A comma seperated, key=value, map to be used when deploying a template file directly.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--properties',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': False,
                                                                                                                             u'type': u'dict',
                                                                                                                             u'value': u'PROPERTIES'}},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'update',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'deployment-manager',
                                                                                                          u'deployments',
                                                                                                          u'update'],
                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Deployment name.',
                                                                                                                  u'name': u'deployment-name',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'value': u'DEPLOYMENT_NAME'}],
                                                                                                u'release': u'GA',
                                                                                                u'sections': {u'DESCRIPTION': u'This command will update a deployment with the new config file provided.\nDifferent policies for create, update, and delete policies can be specified.',
                                                                                                              u'EXAMPLES': u'To update an existing deployment with a new config file, run:\n\n  $ update my-deployment --config new_config.yaml\n\nTo preview an update to an existing deployment without actually modifying the resources, run:\n\n  $ update my-deployment --config new_config.yaml --preview\n\nTo apply an update that has been previewed, provide the name of the previewed deployment, and no config file:\n\n  $ update my-deployment\n\nTo specify different create, update, or delete policies, include any subset of the following flags;\n\n  $ update my-deployment --config new_config.yaml --create-policy ACQUIRE --delete-policy ABANDON\n\nTo perform an update without waiting for the operation to complete, run:\n\n  $ update my-deployment --config new_config.yaml --async\n\nTo update an existing deployment with a new config file and a fingerprint, run:\n\n  $ update my-deployment --config new_config.yaml --fingerprint deployment-fingerprint\n'}}},
                                                                      u'flags': {},
                                                                      u'group': True,
                                                                      u'groups': {},
                                                                      u'hidden': False,
                                                                      u'name': u'deployments',
                                                                      u'path': [u'gcloud',
                                                                                u'deployment-manager',
                                                                                u'deployments'],
                                                                      u'positionals': [],
                                                                      u'release': u'GA',
                                                                      u'sections': {u'DESCRIPTION': u'Commands to create, update, delete, and examine deployments of resources.',
                                                                                    u'EXAMPLES': u'To create a deployment, run:\n\n  $ deployments create my-deployment --config config.yaml\n\nTo update a deployment, run:\n\n  $ deployments update my-deployment --config new_config.yaml\n\nTo stop a deployment create or update in progress, run:\n\n  $ deployments stop my-deployment\n\nTo cancel a previewed create or update, run:\n\n  $ deployments cancel-preview my-deployment\n\nTo delete a deployment, run:\n\n  $ deployments delete my-deployment\n\nTo view the details of a deployment, run:\n\n  $ deployments describe my-deployment\n\nTo see the list of all deployments, run:\n\n  $ deployments list\n'}},
                                                     u'manifests': {u'capsule': u'Commands for Deployment Manager manifests.',
                                                                    u'commands': {u'describe': {u'capsule': u'Provide information about a manifest.',
                                                                                                u'commands': {},
                                                                                                u'flags': {u'--deployment': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Deployment name.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--deployment',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': True,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'DEPLOYMENT'}},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'describe',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'deployment-manager',
                                                                                                          u'manifests',
                                                                                                          u'describe'],
                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Manifest name.',
                                                                                                                  u'name': u'manifest',
                                                                                                                  u'nargs': u'?',
                                                                                                                  u'required': False,
                                                                                                                  u'value': u'MANIFEST'}],
                                                                                                u'release': u'GA',
                                                                                                u'sections': {u'DESCRIPTION': u'This command prints out all available details about a manifest.',
                                                                                                              u'EXAMPLES': u'To display information about a manifest, run:\n\n  $ describe --deployment my-deployment manifest-name\n\nTo display information about the latest manifest, run:\n\n  $ describe --deployment my-deployment\n'}},
                                                                                  u'list': {u'capsule': u'List manifests in a deployment.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--deployment': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Deployment name.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--deployment',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': True,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'DEPLOYMENT'},
                                                                                                       u'--filter': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--filter',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                       u'--limit': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--limit',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'LIMIT'},
                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-uri',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_URI'},
                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--page-size',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                       u'--simple-list': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--simple-list',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'SIMPLE_LIST'},
                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--sort-by',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'list',
                                                                                                                      u'value': u'FIELD'},
                                                                                                       u'--uri': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--uri',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'URI'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'list',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'deployment-manager',
                                                                                                      u'manifests',
                                                                                                      u'list'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'Prints a table with summary information on all manifests in the deployment.',
                                                                                                          u'EXAMPLES': u'To print out a list of manifests in a deployment, run:\n\n  $ list --deployment my-deployment\n\nTo print only the name of each manifest, run:\n\n  $ list --deployment my-deployment --simple-list\n'}}},
                                                                    u'flags': {},
                                                                    u'group': True,
                                                                    u'groups': {},
                                                                    u'hidden': False,
                                                                    u'name': u'manifests',
                                                                    u'path': [u'gcloud',
                                                                              u'deployment-manager',
                                                                              u'manifests'],
                                                                    u'positionals': [],
                                                                    u'release': u'GA',
                                                                    u'sections': {u'DESCRIPTION': u'Commands to list and examine manifests within a deployment.',
                                                                                  u'EXAMPLES': u'To view all details about a manifest, run:\n\n  $ manifests describe manifest-name --deployment my-deployment\n\nTo see the list of all manifests in a deployment, run:\n\n  $ manifests list --deployment my-deployment\n'}},
                                                     u'operations': {u'capsule': u'Commands for Deployment Manager operations.',
                                                                     u'commands': {u'describe': {u'capsule': u'Provide information about an operation.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'describe',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'deployment-manager',
                                                                                                           u'operations',
                                                                                                           u'describe'],
                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Operation name.',
                                                                                                                   u'name': u'operation-name',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'OPERATION_NAME'}],
                                                                                                 u'release': u'GA',
                                                                                                 u'sections': {u'DESCRIPTION': u'This command prints out all available details about an operation.',
                                                                                                               u'EXAMPLES': u'To display information about an operation, run:\n\n  $ describe operation-name\n'}},
                                                                                   u'list': {u'capsule': u'List operations in a project.',
                                                                                             u'commands': {},
                                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--filter',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'EXPRESSION'},
                                                                                                        u'--limit': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--limit',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'LIMIT'},
                                                                                                        u'--no-uri': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': True,
                                                                                                                      u'description': u'',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': True,
                                                                                                                      u'name': u'--no-uri',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'bool',
                                                                                                                      u'value': u'NO_URI'},
                                                                                                        u'--page-size': {u'attr': {},
                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': None,
                                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--page-size',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                                        u'--simple-list': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': False,
                                                                                                                           u'name': u'--simple-list',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'SIMPLE_LIST'},
                                                                                                        u'--sort-by': {u'attr': {},
                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--sort-by',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'list',
                                                                                                                       u'value': u'FIELD'},
                                                                                                        u'--uri': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--uri',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'URI'}},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'list',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'deployment-manager',
                                                                                                       u'operations',
                                                                                                       u'list'],
                                                                                             u'positionals': [],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'Prints a table with summary information on all operations in the project.',
                                                                                                           u'EXAMPLES': u'To print out a list of operations with some summary information about each, run:\n\n  $ list\n\nTo print only the name of each operation, run:\n\n  $ list --simple-list\n'}},
                                                                                   u'wait': {u'capsule': u'Wait for all operations specified to complete before returning.',
                                                                                             u'commands': {},
                                                                                             u'flags': {},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'wait',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'deployment-manager',
                                                                                                       u'operations',
                                                                                                       u'wait'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'Operation name.',
                                                                                                               u'name': u'operation-name',
                                                                                                               u'nargs': u'+',
                                                                                                               u'required': False,
                                                                                                               u'value': u'OPERATION_NAME'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'Polls until all operations have finished, then prints the resulting operations\nalong with any operation errors.',
                                                                                                           u'EXAMPLES': u'To poll until an operation has completed, run:\n\n  $ wait operation-name\n\nTo poll until several operations have all completed, run:\n\n  $ wait operation-one operation-two operation-three\n'}}},
                                                                     u'flags': {},
                                                                     u'group': True,
                                                                     u'groups': {},
                                                                     u'hidden': False,
                                                                     u'name': u'operations',
                                                                     u'path': [u'gcloud',
                                                                               u'deployment-manager',
                                                                               u'operations'],
                                                                     u'positionals': [],
                                                                     u'release': u'GA',
                                                                     u'sections': {u'DESCRIPTION': u'Commands to list, examine, and wait for long-running operations.',
                                                                                   u'EXAMPLES': u'To view the details of an operation, run:\n\n  $ operations describe operation-name\n\nTo see the list of all operations, run:\n\n  $ operations list\n\nTo wait for an operation to complete, run:\n\n  $ operations wait operation-name\n'}},
                                                     u'resources': {u'capsule': u'Commands for Deployment Manager resources.',
                                                                    u'commands': {u'describe': {u'capsule': u'Provide information about a resource.',
                                                                                                u'commands': {},
                                                                                                u'flags': {},
                                                                                                u'group': False,
                                                                                                u'groups': {},
                                                                                                u'hidden': False,
                                                                                                u'name': u'describe',
                                                                                                u'path': [u'gcloud',
                                                                                                          u'deployment-manager',
                                                                                                          u'resources',
                                                                                                          u'describe'],
                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Resource name.',
                                                                                                                  u'name': u'resource',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'value': u'RESOURCE'}],
                                                                                                u'release': u'GA',
                                                                                                u'sections': {u'DESCRIPTION': u'This command prints out all available details about a resource.',
                                                                                                              u'EXAMPLES': u'To display information about a resource, run:\n\n  $ describe --deployment my-deployment my-resource-name\n'}},
                                                                                  u'list': {u'capsule': u'List resources in a deployment.',
                                                                                            u'commands': {},
                                                                                            u'flags': {u'--filter': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--filter',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                       u'--limit': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--limit',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'LIMIT'},
                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-uri',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_URI'},
                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--page-size',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                       u'--simple-list': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'Changes the --format flag to print the resource IDs. Otherwise either the --format value or the default format is used.',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--simple-list',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'SIMPLE_LIST'},
                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--sort-by',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'list',
                                                                                                                      u'value': u'FIELD'},
                                                                                                       u'--uri': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--uri',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'URI'}},
                                                                                            u'group': False,
                                                                                            u'groups': {},
                                                                                            u'hidden': False,
                                                                                            u'name': u'list',
                                                                                            u'path': [u'gcloud',
                                                                                                      u'deployment-manager',
                                                                                                      u'resources',
                                                                                                      u'list'],
                                                                                            u'positionals': [],
                                                                                            u'release': u'GA',
                                                                                            u'sections': {u'DESCRIPTION': u'Prints a table with summary information on all resources in the deployment.',
                                                                                                          u'EXAMPLES': u'To print out a list of resources in the deployment with some summary information about each, run:\n\n  $ list --deployment my-deployment\n\nTo print only the name of each resource, run:\n\n  $ list --deployment my-deployment --simple-list\n'}}},
                                                                    u'flags': {u'--deployment': {u'attr': {},
                                                                                                 u'category': u'',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Deployment name',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'--deployment',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'type': u'string',
                                                                                                 u'value': u'DEPLOYMENT'}},
                                                                    u'group': True,
                                                                    u'groups': {},
                                                                    u'hidden': False,
                                                                    u'name': u'resources',
                                                                    u'path': [u'gcloud',
                                                                              u'deployment-manager',
                                                                              u'resources'],
                                                                    u'positionals': [],
                                                                    u'release': u'GA',
                                                                    u'sections': {u'DESCRIPTION': u'Commands to list and examine resources within a deployment.',
                                                                                  u'EXAMPLES': u'To view all details about a resource, run:\n\n  $ resources describe my-resource --deployment my-deployment\n\nTo see the list of all resources in a deployment, run:\n\n  $ resources list --deployment my-deployment\n'}},
                                                     u'types': {u'capsule': u'Commands for Deployment Manager types.',
                                                                u'commands': {u'list': {u'capsule': u'List types in a project.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--filter': {u'attr': {},
                                                                                                                 u'category': u'LIST COMMAND',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--filter',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'EXPRESSION'},
                                                                                                   u'--limit': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--limit',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'LIMIT'},
                                                                                                   u'--page-size': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--page-size',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'PAGE_SIZE'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'list',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'deployment-manager',
                                                                                                  u'types',
                                                                                                  u'list'],
                                                                                        u'positionals': [],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'Prints a list of the available resource types.',
                                                                                                      u'EXAMPLES': u'To print out a list of all available type names, run:\n\n  $ list\n'}}},
                                                                u'flags': {},
                                                                u'group': True,
                                                                u'groups': {},
                                                                u'hidden': False,
                                                                u'name': u'types',
                                                                u'path': [u'gcloud',
                                                                          u'deployment-manager',
                                                                          u'types'],
                                                                u'positionals': [],
                                                                u'release': u'GA',
                                                                u'sections': {u'DESCRIPTION': u'Commands to show available resource types.',
                                                                              u'EXAMPLES': u'To see the list of all available resource types, run:\n\n  $ types list\n'}}},
                                       u'flags': {},
                                       u'group': True,
                                       u'groups': {},
                                       u'hidden': False,
                                       u'name': u'deployment-manager',
                                       u'path': [u'gcloud',
                                                 u'deployment-manager'],
                                       u'positionals': [],
                                       u'release': u'GA',
                                       u'sections': {u'DESCRIPTION': u'The deployment-manager command group lets you manage the deployment of Google Cloud\nPlatform resources using Google Cloud Deployment Manager.\n\nGoogle Cloud Deployment Manager allows you to specify all the resources needed\nfor your application in a declarative format using YAML. You can also use\nPython or Jinja2 templates to parameterize the configuration and allow reuse\nof common deployment paradigms such as a load balanced, auto-scaled instance\ngroup.\n\nMore information on Cloud Deployment Manager can be found here:\nhttps://cloud.google.com/deployment-manager and detailed documentation can be\nfound here: https://cloud.google.com/deployment-manager/docs/'}},
               u'dns': {u'capsule': u'Manage your Cloud DNS managed-zones and record-sets.',
                        u'commands': {u'managed-zones': {u'capsule': u'Manage your Cloud DNS managed-zones.',
                                                         u'commands': {u'create': {u'capsule': u'Create a Cloud DNS managed-zone.',
                                                                                   u'commands': {},
                                                                                   u'flags': {u'--description': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Short description for the managed-zone.',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--description',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': True,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'DESCRIPTION'},
                                                                                              u'--dns-name': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u'The DNS name suffix that will be managed with the created zone.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--dns-name',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': True,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'DNS_NAME'}},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'create',
                                                                                   u'path': [u'gcloud',
                                                                                             u'dns',
                                                                                             u'managed-zones',
                                                                                             u'create'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The name of the managed-zone to be created.',
                                                                                                     u'name': u'dns-zone',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'value': u'ZONE_NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'This command creates a Cloud DNS managed-zone.\n\n## EXAMPLES\n\nTo create a managed-zone, run:\n\n  $ create my_zone --dns-name my.zone.com. --description "My zone!"'}},
                                                                       u'delete': {u'capsule': u'Delete an empty Cloud DNS managed-zone.',
                                                                                   u'commands': {},
                                                                                   u'flags': {},
                                                                                   u'group': False,
                                                                                   u'groups': {},
                                                                                   u'hidden': False,
                                                                                   u'name': u'delete',
                                                                                   u'path': [u'gcloud',
                                                                                             u'dns',
                                                                                             u'managed-zones',
                                                                                             u'delete'],
                                                                                   u'positionals': [{u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The name of the empty managed-zone to be deleted.',
                                                                                                     u'name': u'dns-zone',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'value': u'ZONE_NAME'}],
                                                                                   u'release': u'GA',
                                                                                   u'sections': {u'DESCRIPTION': u'This command deletes an empty Cloud DNS managed-zone. An empty managed-zone\nhas only SOA and NS record-sets.\n\n## EXAMPLES\n\nTo delete an empty managed-zone, run:\n\n  $ delete my_zone'}},
                                                                       u'describe': {u'capsule': u'View the details of a Cloud DNS managed-zone.',
                                                                                     u'commands': {},
                                                                                     u'flags': {},
                                                                                     u'group': False,
                                                                                     u'groups': {},
                                                                                     u'hidden': False,
                                                                                     u'name': u'describe',
                                                                                     u'path': [u'gcloud',
                                                                                               u'dns',
                                                                                               u'managed-zones',
                                                                                               u'describe'],
                                                                                     u'positionals': [{u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The name of the managed-zone to be described.',
                                                                                                       u'name': u'dns-zone',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'value': u'ZONE_NAME'}],
                                                                                     u'release': u'GA',
                                                                                     u'sections': {u'DESCRIPTION': u'This command displays the details of the specified managed-zone.\n\n## EXAMPLES\n\nTo display the details of your managed-zone, run:\n\n  $ describe my_zone'}},
                                                                       u'list': {u'capsule': u'View the list of all your managed-zones.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--filter',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'EXPRESSION'},
                                                                                            u'--limit': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--limit',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'LIMIT'},
                                                                                            u'--no-uri': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-uri',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_URI'},
                                                                                            u'--page-size': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--page-size',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                            u'--sort-by': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--sort-by',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'list',
                                                                                                           u'value': u'FIELD'},
                                                                                            u'--uri': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--uri',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'URI'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'list',
                                                                                 u'path': [u'gcloud',
                                                                                           u'dns',
                                                                                           u'managed-zones',
                                                                                           u'list'],
                                                                                 u'positionals': [],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'This command displays the list of your managed-zones.\n\n## EXAMPLES\n\nTo see the list of all managed-zones, run:\n\n  $ list\n\nTo see the list of first 10 managed-zones, run:\n\n  $ list --limit=10'}}},
                                                         u'flags': {},
                                                         u'group': True,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'managed-zones',
                                                         u'path': [u'gcloud',
                                                                   u'dns',
                                                                   u'managed-zones'],
                                                         u'positionals': [],
                                                         u'release': u'GA',
                                                         u'sections': {u'DESCRIPTION': u'Manage your Cloud DNS managed-zones.\n\n## EXAMPLES\n\nTo create a managed-zone, run:\n\n  $ managed-zones create my_zone --description="My Zone" --dns-name="my.zone.com."\n\nTo delete a managed-zone, run:\n\n  $ managed-zones delete my_zone\n\nTo view the details of a managed-zone, run:\n\n  $ managed-zones describe my_zone\n\nTo see the list of all managed-zones, run:\n\n  $ managed-zones list'}},
                                      u'project-info': {u'capsule': u'View Cloud DNS related information for a project.',
                                                        u'commands': {u'describe': {u'capsule': u'View Cloud DNS related information for a project.',
                                                                                    u'commands': {},
                                                                                    u'flags': {},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'describe',
                                                                                    u'path': [u'gcloud',
                                                                                              u'dns',
                                                                                              u'project-info',
                                                                                              u'describe'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The identifier for the project you want DNS related info for.',
                                                                                                      u'name': u'dns-project',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'value': u'PROJECT_ID'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'This command displays Cloud DNS related information for your project including\nquotas for various resources and operations.',
                                                                                                  u'EXAMPLES': u'To display Cloud DNS related information for your project, run:\n\n  $ describe my_project_id\n'}}},
                                                        u'flags': {},
                                                        u'group': True,
                                                        u'groups': {},
                                                        u'hidden': False,
                                                        u'name': u'project-info',
                                                        u'path': [u'gcloud',
                                                                  u'dns',
                                                                  u'project-info'],
                                                        u'positionals': [],
                                                        u'release': u'GA',
                                                        u'sections': {u'DESCRIPTION': u'View Cloud DNS related information for a project.',
                                                                      u'EXAMPLES': u'To display Cloud DNS related information for your project, run:\n\n  $ project-info describe\n'}},
                                      u'record-sets': {u'capsule': u'Manage the record-sets within your managed-zones.',
                                                       u'commands': {u'changes': {u'capsule': u'View details about changes to your Cloud DNS record-sets.',
                                                                                  u'commands': {u'describe': {u'capsule': u'View the details of a change.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--zone': {u'attr': {},
                                                                                                                                     u'category': u'',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--zone',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': True,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'ZONE'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'describe',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'dns',
                                                                                                                        u'record-sets',
                                                                                                                        u'changes',
                                                                                                                        u'describe'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The ID of the change you want details for.',
                                                                                                                                u'name': u'change-id',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'CHANGE_ID'}],
                                                                                                              u'release': u'GA',
                                                                                                              u'sections': {u'DESCRIPTION': u'This command displays the details of the specified change.',
                                                                                                                            u'EXAMPLES': u'To display the details of a change, run:\n\n  $ describe change_id\n'}},
                                                                                                u'list': {u'capsule': u'View the list of changes that have been made to your record-sets.',
                                                                                                          u'commands': {},
                                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--filter',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                                     u'--limit': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--limit',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'LIMIT'},
                                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': True,
                                                                                                                                   u'description': u'',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': True,
                                                                                                                                   u'name': u'--no-uri',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': False,
                                                                                                                                   u'type': u'bool',
                                                                                                                                   u'value': u'NO_URI'},
                                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--page-size',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--sort-by',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'list',
                                                                                                                                    u'value': u'FIELD'},
                                                                                                                     u'--sort-order': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [u'ascending',
                                                                                                                                                    u'descending'],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Sort order for listing. _SORT_ORDER_ must be one of: *ascending*, *descending*.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--sort-order',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'SORT_ORDER'},
                                                                                                                     u'--uri': {u'attr': {},
                                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': False,
                                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--uri',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'type': u'bool',
                                                                                                                                u'value': u'URI'},
                                                                                                                     u'--zone': {u'attr': {},
                                                                                                                                 u'category': u'',
                                                                                                                                 u'choices': [],
                                                                                                                                 u'completer': u'',
                                                                                                                                 u'default': None,
                                                                                                                                 u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                                                 u'group': u'',
                                                                                                                                 u'hidden': False,
                                                                                                                                 u'name': u'--zone',
                                                                                                                                 u'nargs': u'0',
                                                                                                                                 u'required': True,
                                                                                                                                 u'type': u'string',
                                                                                                                                 u'value': u'ZONE'}},
                                                                                                          u'group': False,
                                                                                                          u'groups': {},
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'list',
                                                                                                          u'path': [u'gcloud',
                                                                                                                    u'dns',
                                                                                                                    u'record-sets',
                                                                                                                    u'changes',
                                                                                                                    u'list'],
                                                                                                          u'positionals': [],
                                                                                                          u'release': u'GA',
                                                                                                          u'sections': {u'DESCRIPTION': u'This command displays the list of changes that have been made to your\nrecord-sets.',
                                                                                                                        u'EXAMPLES': u'To see the list of changes, run:\n\n  $ list\n\nTo see the list of first 10 changes, run:\n\n  $ list --limit=10\n'}}},
                                                                                  u'flags': {},
                                                                                  u'group': True,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'changes',
                                                                                  u'path': [u'gcloud',
                                                                                            u'dns',
                                                                                            u'record-sets',
                                                                                            u'changes'],
                                                                                  u'positionals': [],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'View details about changes to your Cloud DNS record-sets.',
                                                                                                u'EXAMPLES': u'To view the details of a particular change, run:\n\n  $ changes describe CHANGE_ID -z MANAGED_ZONE\n\nTo view the list of all changes, run:\n\n  $ changes list -z MANAGED_ZONE\n'}},
                                                                     u'export': {u'capsule': u'Export your record-sets into a file.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--no-zone-file-format': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': True,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-zone-file-format',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_ZONE_FILE_FORMAT'},
                                                                                            u'--zone': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--zone',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': True,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'ZONE'},
                                                                                            u'--zone-file-format': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'Indicates that records-file should be in the zone file format.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--zone-file-format',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'ZONE_FILE_FORMAT'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'export',
                                                                                 u'path': [u'gcloud',
                                                                                           u'dns',
                                                                                           u'record-sets',
                                                                                           u'export'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'File to which record-sets should be exported.',
                                                                                                   u'name': u'records-file',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'RECORDS_FILE'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'This command exports the record-sets contained within the specified\nmanaged-zone into a file.',
                                                                                               u'EXAMPLES': u'To export record-sets into a yaml file, run:\n\n  $ export YAML_RECORDS_FILE -z MANAGED_ZONE\n\nTo import record-sets into a zone file, run:\n\n  $ export ZONE_FILE --zone-file-format -z MANAGED_ZONE\n'}},
                                                                     u'import': {u'capsule': u'Import record-sets into your managed-zone.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--delete-all-existing': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': False,
                                                                                                                       u'description': u'Indicates that all existing record-sets should be deleted before importing the record-sets in the records-file.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--delete-all-existing',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'DELETE_ALL_EXISTING'},
                                                                                            u'--no-delete-all-existing': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': True,
                                                                                                                          u'description': u'',
                                                                                                                          u'group': u'',
                                                                                                                          u'hidden': True,
                                                                                                                          u'name': u'--no-delete-all-existing',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'NO_DELETE_ALL_EXISTING'},
                                                                                            u'--no-replace-origin-ns': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': True,
                                                                                                                        u'description': u'',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': True,
                                                                                                                        u'name': u'--no-replace-origin-ns',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'NO_REPLACE_ORIGIN_NS'},
                                                                                            u'--no-zone-file-format': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': True,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--no-zone-file-format',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'bool',
                                                                                                                       u'value': u'NO_ZONE_FILE_FORMAT'},
                                                                                            u'--replace-origin-ns': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': False,
                                                                                                                     u'description': u'Indicates that NS records for the origin of a zone should be imported if defined',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--replace-origin-ns',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'REPLACE_ORIGIN_NS'},
                                                                                            u'--zone': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--zone',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': True,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'ZONE'},
                                                                                            u'--zone-file-format': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': False,
                                                                                                                    u'description': u'Indicates that the records-file is in the zone file format.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--zone-file-format',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'ZONE_FILE_FORMAT'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'import',
                                                                                 u'path': [u'gcloud',
                                                                                           u'dns',
                                                                                           u'record-sets',
                                                                                           u'import'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'File from which record-sets should be imported.',
                                                                                                   u'name': u'records-file',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'RECORDS_FILE'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'This command imports record-sets contained within the specified record-sets\nfile into your managed-zone. Note that NS records for the origin of the zone,\nand the SOA NS field, are not imported since name-servers are managed by\nCloud DNS. By default, record-sets cannot be imported if there are any\nconflicts. A conflict exists if an existing record-set has the same name and\ntype as a record-set that is being imported. In contrast, if the\n--delete-all-existing flag is used, the imported record-sets will replace all\nthe records-sets currently in the managed-zone.',
                                                                                               u'EXAMPLES': u'To import record-sets from a yaml record-sets file, run:\n\n  $ import YAML_RECORDS_FILE -z MANAGED_ZONE\n\nTo import record-sets from a zone file, run:\n\n  $ import ZONE_FILE --zone-file-format -z MANAGED_ZONE\n\nTo replace all the record-sets in your zone with records from a yaml\nfile, run:\n\n  $ import YAML_RECORDS_FILE --delete-all-existing -z MANAGED_ZONE\n'}},
                                                                     u'list': {u'capsule': u'View the list of record-sets in a managed-zone.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--filter': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--filter',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'EXPRESSION'},
                                                                                          u'--limit': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--limit',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'LIMIT'},
                                                                                          u'--name': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Only list record-sets with this exact domain name.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--name',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'NAME'},
                                                                                          u'--no-uri': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-uri',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_URI'},
                                                                                          u'--page-size': {u'attr': {},
                                                                                                           u'category': u'LIST COMMAND',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--page-size',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'PAGE_SIZE'},
                                                                                          u'--sort-by': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--sort-by',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'list',
                                                                                                         u'value': u'FIELD'},
                                                                                          u'--type': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Only list records of this type. If present, the --name parameter must also be present.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--type',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'TYPE'},
                                                                                          u'--uri': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--uri',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'URI'},
                                                                                          u'--zone': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--zone',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': True,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'ZONE'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'list',
                                                                               u'path': [u'gcloud',
                                                                                         u'dns',
                                                                                         u'record-sets',
                                                                                         u'list'],
                                                                               u'positionals': [],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'This command displays the list of record-sets contained within the specified\nmanaged-zone.',
                                                                                             u'EXAMPLES': u'To see the list of all record-sets in my_zone, run:\n\n  $ list -z my_zone\n\nTo see the list of first 10 record-sets in my_zone, run:\n\n  $ list -z my_zone --limit=10\n\nTo see the list of \'my.zone.com.\' record-sets in my_zone, run:\n\n  $ list -z my_zone --name="my.zone.com."\n\nTo see the list of \'my.zone.com.\' CNAME record-sets in my_zone, run:\n\n  $ list -z my_zone --name="my.zone.com." --type="CNAME"\n'}},
                                                                     u'transaction': {u'capsule': u'Make scriptable and transactional changes to your record-sets.',
                                                                                      u'commands': {u'abort': {u'capsule': u'Abort transaction.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--zone': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--zone',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ZONE'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'abort',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'dns',
                                                                                                                         u'record-sets',
                                                                                                                         u'transaction',
                                                                                                                         u'abort'],
                                                                                                               u'positionals': [],
                                                                                                               u'release': u'GA',
                                                                                                               u'sections': {u'DESCRIPTION': u'This command aborts the transaction and deletes the transaction file.',
                                                                                                                             u'EXAMPLES': u'To abort the transaction, run:\n\n  $ abort -z MANAGED_ZONE\n'}},
                                                                                                    u'add': {u'capsule': u'Append a record-set addition to the transaction.',
                                                                                                             u'commands': {},
                                                                                                             u'flags': {u'--name': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'DNS name of the record-set to add.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--name',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'NAME'},
                                                                                                                        u'--ttl': {u'attr': {},
                                                                                                                                   u'category': u'',
                                                                                                                                   u'choices': [],
                                                                                                                                   u'completer': u'',
                                                                                                                                   u'default': None,
                                                                                                                                   u'description': u'TTL for the record-set to add.',
                                                                                                                                   u'group': u'',
                                                                                                                                   u'hidden': False,
                                                                                                                                   u'name': u'--ttl',
                                                                                                                                   u'nargs': u'0',
                                                                                                                                   u'required': True,
                                                                                                                                   u'type': u'string',
                                                                                                                                   u'value': u'TTL'},
                                                                                                                        u'--type': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Type of the record-set to add.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--type',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'TYPE'},
                                                                                                                        u'--zone': {u'attr': {},
                                                                                                                                    u'category': u'',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--zone',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': True,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'ZONE'}},
                                                                                                             u'group': False,
                                                                                                             u'groups': {},
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'add',
                                                                                                             u'path': [u'gcloud',
                                                                                                                       u'dns',
                                                                                                                       u'record-sets',
                                                                                                                       u'transaction',
                                                                                                                       u'add'],
                                                                                                             u'positionals': [{u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'DNS data (Address/CNAME/MX info, etc.) of the record-set to add.',
                                                                                                                               u'name': u'data',
                                                                                                                               u'nargs': u'+',
                                                                                                                               u'required': False,
                                                                                                                               u'value': u'DATA'}],
                                                                                                             u'release': u'GA',
                                                                                                             u'sections': {u'DESCRIPTION': u'This command appends a record-set addition to the transaction.',
                                                                                                                           u'EXAMPLES': u'To add an A record, run:\n\n  $ add -z MANAGED_ZONE --name my.domain. --ttl 1234 --type A "1.2.3.4"\n\nTo add a TXT record with multiple data values, run:\n\n  $ add -z MANAGED_ZONE --name my.domain. --ttl 2345 --type TXT "Hello world" "Bye world"\n'}},
                                                                                                    u'describe': {u'capsule': u'Describe the transaction.',
                                                                                                                  u'commands': {},
                                                                                                                  u'flags': {u'--zone': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--zone',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': True,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'ZONE'}},
                                                                                                                  u'group': False,
                                                                                                                  u'groups': {},
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'describe',
                                                                                                                  u'path': [u'gcloud',
                                                                                                                            u'dns',
                                                                                                                            u'record-sets',
                                                                                                                            u'transaction',
                                                                                                                            u'describe'],
                                                                                                                  u'positionals': [],
                                                                                                                  u'release': u'GA',
                                                                                                                  u'sections': {u'DESCRIPTION': u'This command displays the contents of the transaction.',
                                                                                                                                u'EXAMPLES': u'To look at the contents of the transaction, run:\n\n  $ describe -z MANAGED_ZONE\n'}},
                                                                                                    u'execute': {u'capsule': u'Execute the transaction on Cloud DNS.',
                                                                                                                 u'commands': {},
                                                                                                                 u'flags': {u'--filter': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--filter',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'EXPRESSION'},
                                                                                                                            u'--limit': {u'attr': {},
                                                                                                                                         u'category': u'LIST COMMAND',
                                                                                                                                         u'choices': [],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': None,
                                                                                                                                         u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--limit',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'LIMIT'},
                                                                                                                            u'--no-uri': {u'attr': {},
                                                                                                                                          u'category': u'LIST COMMAND',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': True,
                                                                                                                                          u'description': u'',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': True,
                                                                                                                                          u'name': u'--no-uri',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': False,
                                                                                                                                          u'type': u'bool',
                                                                                                                                          u'value': u'NO_URI'},
                                                                                                                            u'--page-size': {u'attr': {},
                                                                                                                                             u'category': u'LIST COMMAND',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--page-size',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'PAGE_SIZE'},
                                                                                                                            u'--sort-by': {u'attr': {},
                                                                                                                                           u'category': u'LIST COMMAND',
                                                                                                                                           u'choices': [],
                                                                                                                                           u'completer': u'',
                                                                                                                                           u'default': None,
                                                                                                                                           u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                           u'group': u'',
                                                                                                                                           u'hidden': False,
                                                                                                                                           u'name': u'--sort-by',
                                                                                                                                           u'nargs': u'0',
                                                                                                                                           u'required': False,
                                                                                                                                           u'type': u'list',
                                                                                                                                           u'value': u'FIELD'},
                                                                                                                            u'--uri': {u'attr': {},
                                                                                                                                       u'category': u'LIST COMMAND',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': False,
                                                                                                                                       u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--uri',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': False,
                                                                                                                                       u'type': u'bool',
                                                                                                                                       u'value': u'URI'},
                                                                                                                            u'--zone': {u'attr': {},
                                                                                                                                        u'category': u'',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--zone',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': True,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'ZONE'}},
                                                                                                                 u'group': False,
                                                                                                                 u'groups': {},
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'execute',
                                                                                                                 u'path': [u'gcloud',
                                                                                                                           u'dns',
                                                                                                                           u'record-sets',
                                                                                                                           u'transaction',
                                                                                                                           u'execute'],
                                                                                                                 u'positionals': [],
                                                                                                                 u'release': u'GA',
                                                                                                                 u'sections': {u'DESCRIPTION': u'This command executes the transaction on Cloud DNS. This will result in\nrecord-sets being changed as specified in the transaction.',
                                                                                                                               u'EXAMPLES': u'To execute the transaction, run:\n\n  $ execute -z MANAGED_ZONE\n'}},
                                                                                                    u'remove': {u'capsule': u'Append a record-set deletion to the transaction.',
                                                                                                                u'commands': {},
                                                                                                                u'flags': {u'--name': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'DNS name of the record-set to be removed.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--name',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'NAME'},
                                                                                                                           u'--ttl': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'TTL for the record-set to be removed.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--ttl',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'TTL'},
                                                                                                                           u'--type': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Type of the record-set to be removed.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--type',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'TYPE'},
                                                                                                                           u'--zone': {u'attr': {},
                                                                                                                                       u'category': u'',
                                                                                                                                       u'choices': [],
                                                                                                                                       u'completer': u'',
                                                                                                                                       u'default': None,
                                                                                                                                       u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                                                       u'group': u'',
                                                                                                                                       u'hidden': False,
                                                                                                                                       u'name': u'--zone',
                                                                                                                                       u'nargs': u'0',
                                                                                                                                       u'required': True,
                                                                                                                                       u'type': u'string',
                                                                                                                                       u'value': u'ZONE'}},
                                                                                                                u'group': False,
                                                                                                                u'groups': {},
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'remove',
                                                                                                                u'path': [u'gcloud',
                                                                                                                          u'dns',
                                                                                                                          u'record-sets',
                                                                                                                          u'transaction',
                                                                                                                          u'remove'],
                                                                                                                u'positionals': [{u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'DNS name of the record-set to be removed.',
                                                                                                                                  u'name': u'data',
                                                                                                                                  u'nargs': u'+',
                                                                                                                                  u'required': False,
                                                                                                                                  u'value': u'DATA'}],
                                                                                                                u'release': u'GA',
                                                                                                                u'sections': {u'DESCRIPTION': u'This command appends a record-set deletion to the transaction.',
                                                                                                                              u'EXAMPLES': u'To remove an A record, run:\n\n  $ remove -z MANAGED_ZONE --name my.domain. --ttl 1234 --type A "1.2.3.4"\n\nTo remove a TXT record with multiple data values, run:\n\n  $ remove -z MANAGED_ZONE --name my.domain. --ttl 2345 --type TXT "Hello world" "Bye world"\n'}},
                                                                                                    u'start': {u'capsule': u'Start a transaction.',
                                                                                                               u'commands': {},
                                                                                                               u'flags': {u'--zone': {u'attr': {},
                                                                                                                                      u'category': u'',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u'Name of the managed-zone whose record-sets you want to manage.',
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--zone',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': True,
                                                                                                                                      u'type': u'string',
                                                                                                                                      u'value': u'ZONE'}},
                                                                                                               u'group': False,
                                                                                                               u'groups': {},
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'start',
                                                                                                               u'path': [u'gcloud',
                                                                                                                         u'dns',
                                                                                                                         u'record-sets',
                                                                                                                         u'transaction',
                                                                                                                         u'start'],
                                                                                                               u'positionals': [],
                                                                                                               u'release': u'GA',
                                                                                                               u'sections': {u'DESCRIPTION': u'This command starts a transaction.',
                                                                                                                             u'EXAMPLES': u'To start a transaction, run:\n\n  $ start -z MANAGED_ZONE\n'}}},
                                                                                      u'flags': {u'--transaction-file': {u'attr': {},
                                                                                                                         u'category': u'',
                                                                                                                         u'choices': [],
                                                                                                                         u'completer': u'',
                                                                                                                         u'default': u'transaction.yaml',
                                                                                                                         u'description': u'Path of the file which contains the transaction.',
                                                                                                                         u'group': u'',
                                                                                                                         u'hidden': False,
                                                                                                                         u'name': u'--transaction-file',
                                                                                                                         u'nargs': u'0',
                                                                                                                         u'required': False,
                                                                                                                         u'type': u'string',
                                                                                                                         u'value': u'TRANSACTION_FILE'}},
                                                                                      u'group': True,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'transaction',
                                                                                      u'path': [u'gcloud',
                                                                                                u'dns',
                                                                                                u'record-sets',
                                                                                                u'transaction'],
                                                                                      u'positionals': [],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'Make scriptable and transactional changes to your record-sets.',
                                                                                                    u'EXAMPLES': u'To start a transaction, run:\n\n  $ transaction start\n\nTo append a record-set addition to the transaction, run:\n\n  $ transaction add --name RECORD_SET_NAME --ttl TTL --type TYPE DATA\n\nTo append a record-set removal to the transaction, run:\n\n  $ transaction remove --name RECORD_SET_NAME --ttl TTL --type TYPE DATA\n\nTo look at the details of the transaction, run:\n\n  $ transaction describe\n\nTo delete the transaction, run:\n\n  $ transaction abort\n\nTo execute the transaction, run:\n\n  $ transaction execute\n'}}},
                                                       u'flags': {},
                                                       u'group': True,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'record-sets',
                                                       u'path': [u'gcloud',
                                                                 u'dns',
                                                                 u'record-sets'],
                                                       u'positionals': [],
                                                       u'release': u'GA',
                                                       u'sections': {u'DESCRIPTION': u'Manage the record-sets within your managed-zones.',
                                                                     u'EXAMPLES': u'To import record-sets from a BIND zone file, run:\n\n  $ record-sets import -z MANAGED_ZONE  --zone-file-format ZONE_FILE\n\nTo export record-sets in yaml format, run:\n\n  $ record-sets export -z MANAGED_ZONE\n\nTo see how to make scriptable changes to your record-sets through transactions, run:\n\n  $ record-sets transaction -z MANAGED_ZONE\n\nTo see change details or list of all changes, run:\n\n  $ record-sets changes -z MANAGED_ZONE\n\nTo see the list of all record-sets, run:\n\n  $ record-sets list -z MANAGED_ZONE\n'}}},
                        u'flags': {u'--endpoint': {u'attr': {u'property': {u'name': u'api_endpoint_overrides/dns'}},
                                                   u'category': u'',
                                                   u'choices': [],
                                                   u'completer': u'',
                                                   u'default': None,
                                                   u'description': u'',
                                                   u'group': u'',
                                                   u'hidden': True,
                                                   u'name': u'--endpoint',
                                                   u'nargs': u'0',
                                                   u'required': False,
                                                   u'type': u'string',
                                                   u'value': u'ENDPOINT'}},
                        u'group': True,
                        u'groups': {},
                        u'hidden': False,
                        u'name': u'dns',
                        u'path': [u'gcloud', u'dns'],
                        u'positionals': [],
                        u'release': u'GA',
                        u'sections': {u'DESCRIPTION': u'The gcloud dns command group lets you create and manage DNS zones and\ntheir associated records on Google Cloud DNS.\n\nCloud DNS is a scalable, reliable and managed authoritative DNS service\nrunning on the same infrastructure as Google. It has low latency, high\navailability and is a cost-effective way to make your applications and\nservices available to your users.\n\nMore information on Cloud DNS can be found here:\nhttps://cloud.google.com/dns and detailed documentation can be found\nhere: https://cloud.google.com/dns/docs/\n\n## EXAMPLES\n\nTo see how to create and maintain managed-zones, run:\n\n  $ dns managed-zones --help\n\nTo see how to maintain the record-sets within a managed-zone, run:\n\n  $ dns record-sets --help\n\nTo display Cloud DNS related information for your project, run:\n\n  $ dns project-info describe --help'}},
               u'docker': {u'capsule': u'Provides the docker CLI access to the Google Container Registry.',
                           u'commands': {},
                           u'flags': {u'--authorize-only': {u'attr': {},
                                                            u'category': u'',
                                                            u'choices': [],
                                                            u'completer': u'',
                                                            u'default': False,
                                                            u'description': u'Configure docker authorization only, do not launch the docker command-line.',
                                                            u'group': u'',
                                                            u'hidden': False,
                                                            u'name': u'--authorize-only',
                                                            u'nargs': u'0',
                                                            u'required': False,
                                                            u'type': u'bool',
                                                            u'value': u'AUTHORIZE_ONLY'},
                                      u'--docker-host': {u'attr': {},
                                                         u'category': u'',
                                                         u'choices': [],
                                                         u'completer': u'',
                                                         u'default': None,
                                                         u'description': u'The URL to connect to Docker Daemon. Format: tcp://host:port or unix:///path/to/socket.',
                                                         u'group': u'',
                                                         u'hidden': False,
                                                         u'name': u'--docker-host',
                                                         u'nargs': u'0',
                                                         u'required': False,
                                                         u'type': u'string',
                                                         u'value': u'DOCKER_HOST'},
                                      u'--no-authorize-only': {u'attr': {},
                                                               u'category': u'',
                                                               u'choices': [],
                                                               u'completer': u'',
                                                               u'default': True,
                                                               u'description': u'',
                                                               u'group': u'',
                                                               u'hidden': True,
                                                               u'name': u'--no-authorize-only',
                                                               u'nargs': u'0',
                                                               u'required': False,
                                                               u'type': u'bool',
                                                               u'value': u'NO_AUTHORIZE_ONLY'},
                                      u'--server': {u'attr': {},
                                                    u'category': u'',
                                                    u'choices': [],
                                                    u'completer': u'',
                                                    u'default': [u'gcr.io',
                                                                 u'us.gcr.io',
                                                                 u'eu.gcr.io',
                                                                 u'asia.gcr.io',
                                                                 u'b.gcr.io',
                                                                 u'bucket.gcr.io',
                                                                 u'l.gcr.io',
                                                                 u'launcher.gcr.io',
                                                                 u'appengine.gcr.io',
                                                                 u'us-mirror.gcr.io',
                                                                 u'eu-mirror.gcr.io',
                                                                 u'asia-mirror.gcr.io',
                                                                 u'mirror.gcr.io'],
                                                    u'description': u'The address of the Google Cloud Registry.',
                                                    u'group': u'',
                                                    u'hidden': False,
                                                    u'name': u'--server',
                                                    u'nargs': u'0',
                                                    u'required': False,
                                                    u'type': u'list',
                                                    u'value': u'SERVER'}},
                           u'group': False,
                           u'groups': {},
                           u'hidden': False,
                           u'name': u'docker',
                           u'path': [u'gcloud', u'docker'],
                           u'positionals': [{u'completer': u'',
                                             u'default': [],
                                             u'description': u"Arguments to pass to docker.\n+\nThe '--' argument must be specified between gcloud specific args on the left and DOCKER_ARGS on the right. IMPORTANT: previously, commands allowed the omission of the --, and unparsed arguments were treated as implementation args. This usage is being deprecated and will be removed in March 2017.",
                                             u'name': u'docker-args',
                                             u'nargs': u'...',
                                             u'required': False,
                                             u'value': u'DOCKER_ARGS'}],
                           u'release': u'GA',
                           u'sections': {u'DESCRIPTION': u"The docker command group wraps docker commands, so that gcloud can\ninject the appropriate fresh authentication token into requests that interact\nwith the docker registry.\n\nAll docker-specific flags are passed through to the underlying docker command.\nA full reference of docker's command line options available after -- can be\nfound here: [](http://docs.docker.com/reference/commandline/cli/).\n\nMore information on Google Container Registry can be found here:\nhttps://cloud.google.com/container-registry/ and detailed documentation can be\nfound here: https://cloud.google.com/container-registry/docs/\n\n## EXAMPLES\n\nPull the image '{registry}/google-containers/pause:1.0' from the docker\nregistry:\n\n  $ docker -- pull {registry}/google-containers/pause:1.0\n\nPush the image '{registry}/example-org/example-image:latest' to our private\ndocker registry.\n\n  $ docker -- push {registry}/example-org/example-image:latest\n\nConfigure authentication, then simply use docker:\n\n  $ docker --authorize-only\n\n  $ docker push {registry}/example-org/example-image:latest"}},
               u'feedback': {u'capsule': u'Provide feedback to the Google Cloud SDK team.',
                             u'commands': {},
                             u'flags': {u'--log-file': {u'attr': {},
                                                        u'category': u'',
                                                        u'choices': [],
                                                        u'completer': u'',
                                                        u'default': None,
                                                        u'description': u'Path to the log file from a prior gcloud run.',
                                                        u'group': u'',
                                                        u'hidden': False,
                                                        u'name': u'--log-file',
                                                        u'nargs': u'0',
                                                        u'required': False,
                                                        u'type': u'string',
                                                        u'value': u'LOG_FILE'}},
                             u'group': False,
                             u'groups': {},
                             u'hidden': False,
                             u'name': u'feedback',
                             u'path': [u'gcloud', u'feedback'],
                             u'positionals': [],
                             u'release': u'GA',
                             u'sections': {u'DESCRIPTION': u'The Google Cloud SDK team offers support through a number of channels:\n\n* Google Cloud SDK Issue Tracker\n* Stack Overflow "#gcloud" tag\n* google-cloud-dev Google group\n\nThis command lists the available channels and facilitates getting help through\none of them by opening a web browser to the relevant page, possibly with\ninformation relevant to the current install and configuration pre-populated in\nform fields on that page.'}},
               u'help': {u'capsule': u'Prints detailed help messages for the specified commands.',
                         u'commands': {},
                         u'flags': {},
                         u'group': False,
                         u'groups': {},
                         u'hidden': False,
                         u'name': u'help',
                         u'path': [u'gcloud', u'help'],
                         u'positionals': [{u'completer': u'',
                                           u'default': None,
                                           u'description': u'A sequence of group and command names with no flags.',
                                           u'name': u'command',
                                           u'nargs': u'*',
                                           u'required': False,
                                           u'value': u'COMMAND'}],
                         u'release': u'GA',
                         u'sections': {u'DESCRIPTION': u"This command prints a detailed help message for the commands specified\nafter the ``help'' operand."}},
               u'iam': {u'capsule': u'Manage IAM service accounts and keys.',
                        u'commands': {u'list-grantable-roles': {u'capsule': u'List IAM grantable roles for a resource.',
                                                                u'commands': {},
                                                                u'flags': {u'--filter': {u'attr': {},
                                                                                         u'category': u'LIST COMMAND',
                                                                                         u'choices': [],
                                                                                         u'completer': u'',
                                                                                         u'default': None,
                                                                                         u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                         u'group': u'',
                                                                                         u'hidden': False,
                                                                                         u'name': u'--filter',
                                                                                         u'nargs': u'0',
                                                                                         u'required': False,
                                                                                         u'type': u'string',
                                                                                         u'value': u'EXPRESSION'}},
                                                                u'group': False,
                                                                u'groups': {},
                                                                u'hidden': False,
                                                                u'name': u'list-grantable-roles',
                                                                u'path': [u'gcloud',
                                                                          u'iam',
                                                                          u'list-grantable-roles'],
                                                                u'positionals': [{u'completer': u'',
                                                                                  u'default': None,
                                                                                  u'description': u'The full resource name to get the list of roles for.',
                                                                                  u'name': u'resource',
                                                                                  u'nargs': u'0',
                                                                                  u'required': False,
                                                                                  u'value': u'RESOURCE'}],
                                                                u'release': u'GA',
                                                                u'sections': {u'DESCRIPTION': u'This command displays the list of grantable roles for a resource.\nThe resource can be referenced either via the full resource name or via a URI.\nUser can then add IAM policy bindings to grant the roles.',
                                                                              u'EXAMPLES': u'List grantable roles for a resource identified via full resource name:\n\n  $ list-grantable-roles //compute.googleapis.com/projects/example-project/zones/us-central1-f/instances/example-instance\n\nList grantable roles for a resource identified via URI:\n\n  $ list-grantable-roles https://www.googleapis.com/compute/v1/projects/example-project/zones/us-central1-f/instances/example-instance\n'}},
                                      u'service-accounts': {u'capsule': u'Create and manipulate service accounts.',
                                                            u'commands': {u'add-iam-policy-binding': {u'capsule': u'Add IAM policy binding for a service account.',
                                                                                                      u'commands': {},
                                                                                                      u'flags': {u'--member': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': None,
                                                                                                                               u'description': u'The member to add to the binding.',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': False,
                                                                                                                               u'name': u'--member',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': True,
                                                                                                                               u'type': u'string',
                                                                                                                               u'value': u'MEMBER'},
                                                                                                                 u'--role': {u'attr': {},
                                                                                                                             u'category': u'',
                                                                                                                             u'choices': [],
                                                                                                                             u'completer': u'',
                                                                                                                             u'default': None,
                                                                                                                             u'description': u'Define the role of the member.',
                                                                                                                             u'group': u'',
                                                                                                                             u'hidden': False,
                                                                                                                             u'name': u'--role',
                                                                                                                             u'nargs': u'0',
                                                                                                                             u'required': True,
                                                                                                                             u'type': u'string',
                                                                                                                             u'value': u'ROLE'}},
                                                                                                      u'group': False,
                                                                                                      u'groups': {},
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'add-iam-policy-binding',
                                                                                                      u'path': [u'gcloud',
                                                                                                                u'iam',
                                                                                                                u'service-accounts',
                                                                                                                u'add-iam-policy-binding'],
                                                                                                      u'positionals': [{u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The service account whose policy to add bindings to.',
                                                                                                                        u'name': u'account',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'value': u'IAM-ACCOUNT'}],
                                                                                                      u'release': u'GA',
                                                                                                      u'sections': {u'DESCRIPTION': u'This command adds a policy binding to the IAM policy of a service account,\ngiven an IAM-ACCOUNT and the binding.',
                                                                                                                    u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on a service account with\nidentifier 'my-iam-account@somedomain.com'\n\n  $ add-iam-policy-binding my-iam-account@somedomain.com --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                          u'create': {u'capsule': u'Create a service account for a project.',
                                                                                      u'commands': {},
                                                                                      u'flags': {u'--display-name': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'A textual name to display for the account.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--display-name',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'DISPLAY_NAME'}},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'create',
                                                                                      u'path': [u'gcloud',
                                                                                                u'iam',
                                                                                                u'service-accounts',
                                                                                                u'create'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The internal name of the new service account. Used to generate an IAM-ACCOUNT (an IAM internal email address used as an identifier of service account), which must be passed to subsequent commands.',
                                                                                                        u'name': u'name',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'value': u'NAME'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'This command creates a service account with the provided name. For\nsubsequent commands regarding service accounts, this service account should be\nreferred to by the email account in the response.',
                                                                                                    u'EXAMPLES': u'To create a service account for your project, run:\n\n  $ create some-account-name --display-name "My Service Account"\n\nTo work with this service account in subsequent IAM commands, use the\nemail resulting from this call as the IAM-ACCOUNT argument.\n'}},
                                                                          u'delete': {u'capsule': u'Delete a service account from a project.',
                                                                                      u'commands': {},
                                                                                      u'flags': {},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'delete',
                                                                                      u'path': [u'gcloud',
                                                                                                u'iam',
                                                                                                u'service-accounts',
                                                                                                u'delete'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The service account to delete.',
                                                                                                        u'name': u'name',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'value': u'IAM-ACCOUNT'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'Delete a service account from a project.',
                                                                                                    u'EXAMPLES': u'To delete an service account from your project, run:\n\n  $ delete my-iam-account@somedomain.com\n'}},
                                                                          u'describe': {u'capsule': u'Show metadata for a service account from a project.',
                                                                                        u'commands': {},
                                                                                        u'flags': {},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'describe',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'iam',
                                                                                                  u'service-accounts',
                                                                                                  u'describe'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The service account to describe.',
                                                                                                          u'name': u'name',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'IAM-ACCOUNT'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'This command shows metadata for a service account.\n\nThis call can fail for the following reasons:\n    * The service account specified does not exist.\n    * The active user does not have permission to access the given\n      service account.\n',
                                                                                                      u'EXAMPLES': u'To print metadata for a service account from your project, run:\n\n  $ describe my-iam-account@somedomain.com\n'}},
                                                                          u'get-iam-policy': {u'capsule': u'Get the IAM policy for a service account.',
                                                                                              u'commands': {},
                                                                                              u'flags': {},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'get-iam-policy',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'iam',
                                                                                                        u'service-accounts',
                                                                                                        u'get-iam-policy'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The service account whose policy to get.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'IAM-ACCOUNT'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'This command gets the IAM policy for a service account. If formatted as\nJSON, the output can be edited and used as a policy file for\nset-iam-policy. The output includes an "etag" field identifying the version\nemitted and allowing detection of concurrent policy updates; see\n$ gcloud iam service-accounts set-iam-policy for additional details.',
                                                                                                            u'EXAMPLES': u'To print the IAM policy for a given service account, run:\n\n  $ get-iam-policy my-iam-account@somedomain.com\n'}},
                                                                          u'keys': {u'capsule': u'Manage service account keys.',
                                                                                    u'commands': {u'create': {u'capsule': u'Create a private key for a service account.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--iam-account': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The service account for which to create a key.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--iam-account',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'IAM_ACCOUNT'},
                                                                                                                         u'--key-file-type': {u'attr': {},
                                                                                                                                              u'category': u'',
                                                                                                                                              u'choices': [u'json',
                                                                                                                                                           u'p12'],
                                                                                                                                              u'completer': u'',
                                                                                                                                              u'default': u'json',
                                                                                                                                              u'description': u'The type of key to create. _KEY_FILE_TYPE_ must be one of: *json*, *p12*.',
                                                                                                                                              u'group': u'',
                                                                                                                                              u'hidden': False,
                                                                                                                                              u'name': u'--key-file-type',
                                                                                                                                              u'nargs': u'0',
                                                                                                                                              u'required': False,
                                                                                                                                              u'type': u'string',
                                                                                                                                              u'value': u'KEY_FILE_TYPE'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'create',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'iam',
                                                                                                                        u'service-accounts',
                                                                                                                        u'keys',
                                                                                                                        u'create'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The path where the resulting private key should be written.',
                                                                                                                                u'name': u'output',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'OUTPUT-FILE'}],
                                                                                                              u'release': u'GA',
                                                                                                              u'sections': {u'DESCRIPTION': u'Create a private key for a service account.',
                                                                                                                            u'EXAMPLES': u'To create a new private key for a service account, and save a copy\nof it locally, run:\n\n  $ create --iam-account my-iam-account@somedomain.com key.json\n',
                                                                                                                            u'NOTES': u"The option --key-file-type=p12 is available here only for legacy\nreasons; all new use cases are encouraged to use the default 'json'\nformat.\n"}},
                                                                                                  u'delete': {u'capsule': u'Delete a user-managed key from a service account.',
                                                                                                              u'commands': {},
                                                                                                              u'flags': {u'--iam-account': {u'attr': {},
                                                                                                                                            u'category': u'',
                                                                                                                                            u'choices': [],
                                                                                                                                            u'completer': u'',
                                                                                                                                            u'default': None,
                                                                                                                                            u'description': u'The service account whose key to delete.',
                                                                                                                                            u'group': u'',
                                                                                                                                            u'hidden': False,
                                                                                                                                            u'name': u'--iam-account',
                                                                                                                                            u'nargs': u'0',
                                                                                                                                            u'required': True,
                                                                                                                                            u'type': u'string',
                                                                                                                                            u'value': u'IAM_ACCOUNT'}},
                                                                                                              u'group': False,
                                                                                                              u'groups': {},
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'delete',
                                                                                                              u'path': [u'gcloud',
                                                                                                                        u'iam',
                                                                                                                        u'service-accounts',
                                                                                                                        u'keys',
                                                                                                                        u'delete'],
                                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The key to delete.',
                                                                                                                                u'name': u'key',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': False,
                                                                                                                                u'value': u'KEY-ID'}],
                                                                                                              u'release': u'GA',
                                                                                                              u'sections': {u'DESCRIPTION': u'Delete a user-managed key from a service account.'}},
                                                                                                  u'list': {u'capsule': u'List the keys for a service account.',
                                                                                                            u'commands': {},
                                                                                                            u'flags': {u'--created-before': {u'attr': {},
                                                                                                                                             u'category': u'',
                                                                                                                                             u'choices': [],
                                                                                                                                             u'completer': u'',
                                                                                                                                             u'default': None,
                                                                                                                                             u'description': u'Return only keys created before the specified time. Common time formats are accepted. This is equivalent to --filter="validAfterTime<DATE_TIME".',
                                                                                                                                             u'group': u'',
                                                                                                                                             u'hidden': False,
                                                                                                                                             u'name': u'--created-before',
                                                                                                                                             u'nargs': u'0',
                                                                                                                                             u'required': False,
                                                                                                                                             u'type': u'string',
                                                                                                                                             u'value': u'CREATED_BEFORE'},
                                                                                                                       u'--filter': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': None,
                                                                                                                                     u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': False,
                                                                                                                                     u'name': u'--filter',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'string',
                                                                                                                                     u'value': u'EXPRESSION'},
                                                                                                                       u'--iam-account': {u'attr': {},
                                                                                                                                          u'category': u'',
                                                                                                                                          u'choices': [],
                                                                                                                                          u'completer': u'',
                                                                                                                                          u'default': None,
                                                                                                                                          u'description': u'A textual name to display for the account.',
                                                                                                                                          u'group': u'',
                                                                                                                                          u'hidden': False,
                                                                                                                                          u'name': u'--iam-account',
                                                                                                                                          u'nargs': u'0',
                                                                                                                                          u'required': True,
                                                                                                                                          u'type': u'string',
                                                                                                                                          u'value': u'IAM_ACCOUNT'},
                                                                                                                       u'--limit': {u'attr': {},
                                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                                    u'choices': [],
                                                                                                                                    u'completer': u'',
                                                                                                                                    u'default': None,
                                                                                                                                    u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                                    u'group': u'',
                                                                                                                                    u'hidden': False,
                                                                                                                                    u'name': u'--limit',
                                                                                                                                    u'nargs': u'0',
                                                                                                                                    u'required': False,
                                                                                                                                    u'type': u'string',
                                                                                                                                    u'value': u'LIMIT'},
                                                                                                                       u'--managed-by': {u'attr': {},
                                                                                                                                         u'category': u'',
                                                                                                                                         u'choices': [u'user',
                                                                                                                                                      u'system',
                                                                                                                                                      u'any'],
                                                                                                                                         u'completer': u'',
                                                                                                                                         u'default': u'any',
                                                                                                                                         u'description': u'The types of keys to list. _MANAGED_BY_ must be one of: *user*, *system*, *any*.',
                                                                                                                                         u'group': u'',
                                                                                                                                         u'hidden': False,
                                                                                                                                         u'name': u'--managed-by',
                                                                                                                                         u'nargs': u'0',
                                                                                                                                         u'required': False,
                                                                                                                                         u'type': u'string',
                                                                                                                                         u'value': u'MANAGED_BY'},
                                                                                                                       u'--no-uri': {u'attr': {},
                                                                                                                                     u'category': u'LIST COMMAND',
                                                                                                                                     u'choices': [],
                                                                                                                                     u'completer': u'',
                                                                                                                                     u'default': True,
                                                                                                                                     u'description': u'',
                                                                                                                                     u'group': u'',
                                                                                                                                     u'hidden': True,
                                                                                                                                     u'name': u'--no-uri',
                                                                                                                                     u'nargs': u'0',
                                                                                                                                     u'required': False,
                                                                                                                                     u'type': u'bool',
                                                                                                                                     u'value': u'NO_URI'},
                                                                                                                       u'--page-size': {u'attr': {},
                                                                                                                                        u'category': u'LIST COMMAND',
                                                                                                                                        u'choices': [],
                                                                                                                                        u'completer': u'',
                                                                                                                                        u'default': None,
                                                                                                                                        u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                                        u'group': u'',
                                                                                                                                        u'hidden': False,
                                                                                                                                        u'name': u'--page-size',
                                                                                                                                        u'nargs': u'0',
                                                                                                                                        u'required': False,
                                                                                                                                        u'type': u'string',
                                                                                                                                        u'value': u'PAGE_SIZE'},
                                                                                                                       u'--sort-by': {u'attr': {},
                                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                                      u'choices': [],
                                                                                                                                      u'completer': u'',
                                                                                                                                      u'default': None,
                                                                                                                                      u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                                      u'group': u'',
                                                                                                                                      u'hidden': False,
                                                                                                                                      u'name': u'--sort-by',
                                                                                                                                      u'nargs': u'0',
                                                                                                                                      u'required': False,
                                                                                                                                      u'type': u'list',
                                                                                                                                      u'value': u'FIELD'},
                                                                                                                       u'--uri': {u'attr': {},
                                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': False,
                                                                                                                                  u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--uri',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': False,
                                                                                                                                  u'type': u'bool',
                                                                                                                                  u'value': u'URI'}},
                                                                                                            u'group': False,
                                                                                                            u'groups': {},
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'list',
                                                                                                            u'path': [u'gcloud',
                                                                                                                      u'iam',
                                                                                                                      u'service-accounts',
                                                                                                                      u'keys',
                                                                                                                      u'list'],
                                                                                                            u'positionals': [],
                                                                                                            u'release': u'GA',
                                                                                                            u'sections': {u'DESCRIPTION': u'List the keys for a service account.',
                                                                                                                          u'EXAMPLES': u'To list all user-managed keys created before noon on July 19th, 2015\n(to perform key rotation, for example), run:\n\n  $ list --iam-account my-iam-account@somedomain.com --managed-by user --created-before 2015-07-19T12:00:00Z\n'}}},
                                                                                    u'flags': {},
                                                                                    u'group': True,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'keys',
                                                                                    u'path': [u'gcloud',
                                                                                              u'iam',
                                                                                              u'service-accounts',
                                                                                              u'keys'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u'Manage service account keys.'}},
                                                                          u'list': {u'capsule': u"List all of a project's service accounts.",
                                                                                    u'commands': {},
                                                                                    u'flags': {u'--filter': {u'attr': {},
                                                                                                             u'category': u'LIST COMMAND',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--filter',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'EXPRESSION'},
                                                                                               u'--limit': {u'attr': {},
                                                                                                            u'category': u'LIST COMMAND',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--limit',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'LIMIT'},
                                                                                               u'--sort-by': {u'attr': {},
                                                                                                              u'category': u'LIST COMMAND',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': None,
                                                                                                              u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--sort-by',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'list',
                                                                                                              u'value': u'FIELD'}},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'list',
                                                                                    u'path': [u'gcloud',
                                                                                              u'iam',
                                                                                              u'service-accounts',
                                                                                              u'list'],
                                                                                    u'positionals': [],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u"List all of a project's service accounts."}},
                                                                          u'remove-iam-policy-binding': {u'capsule': u'Remove IAM policy binding for a service account.',
                                                                                                         u'commands': {},
                                                                                                         u'flags': {u'--member': {u'attr': {},
                                                                                                                                  u'category': u'',
                                                                                                                                  u'choices': [],
                                                                                                                                  u'completer': u'',
                                                                                                                                  u'default': None,
                                                                                                                                  u'description': u'The member to remove from the binding.',
                                                                                                                                  u'group': u'',
                                                                                                                                  u'hidden': False,
                                                                                                                                  u'name': u'--member',
                                                                                                                                  u'nargs': u'0',
                                                                                                                                  u'required': True,
                                                                                                                                  u'type': u'string',
                                                                                                                                  u'value': u'MEMBER'},
                                                                                                                    u'--role': {u'attr': {},
                                                                                                                                u'category': u'',
                                                                                                                                u'choices': [],
                                                                                                                                u'completer': u'',
                                                                                                                                u'default': None,
                                                                                                                                u'description': u'The role to remove the member from.',
                                                                                                                                u'group': u'',
                                                                                                                                u'hidden': False,
                                                                                                                                u'name': u'--role',
                                                                                                                                u'nargs': u'0',
                                                                                                                                u'required': True,
                                                                                                                                u'type': u'string',
                                                                                                                                u'value': u'ROLE'}},
                                                                                                         u'group': False,
                                                                                                         u'groups': {},
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'remove-iam-policy-binding',
                                                                                                         u'path': [u'gcloud',
                                                                                                                   u'iam',
                                                                                                                   u'service-accounts',
                                                                                                                   u'remove-iam-policy-binding'],
                                                                                                         u'positionals': [{u'completer': u'',
                                                                                                                           u'default': None,
                                                                                                                           u'description': u'The service account whose policy to remove the binding from.',
                                                                                                                           u'name': u'name',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'value': u'IAM-ACCOUNT'}],
                                                                                                         u'release': u'GA',
                                                                                                         u'sections': {u'DESCRIPTION': u'This command removes a policy binding to the IAM policy of a service account,\ngiven an IAM-ACCOUNT and the binding.',
                                                                                                                       u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on service account with\nidentifier 'my-iam-account@somedomain.com'\n\n  $ remove-iam-policy-binding my-iam-account@somedomain.com --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                                          u'set-iam-policy': {u'capsule': u'Set IAM policy for a service account.',
                                                                                              u'commands': {},
                                                                                              u'flags': {},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'set-iam-policy',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'iam',
                                                                                                        u'service-accounts',
                                                                                                        u'set-iam-policy'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The service account whose policy to set.',
                                                                                                                u'name': u'name',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'IAM-ACCOUNT'},
                                                                                                               {u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'Path to a local JSON or YAML formatted file containing a valid policy.',
                                                                                                                u'name': u'policy-file',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'POLICY-FILE'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'This command replaces the existing IAM policy for a service account, given\nan IAM-ACCOUNT and a file encoded in JSON or YAML that contains the IAM\npolicy. If the given policy file specifies an "etag" value, then the\nreplacement will succeed only if the policy already in place matches that\netag. (An etag obtained via $ gcloud iam service-accounts get-iam-policy will\nprevent the replacement if the policy for the service account has been\nsubsequently updated.) A policy file that does not contain an etag value will\nreplace any existing policy for the service account.',
                                                                                                            u'EXAMPLES': u"The following command will read an IAM policy defined in a JSON file\n'policy.json' and set it for a service account with identifier 'my-iam-account@somedomain.com'\n\n  $ set-iam-policy my-iam-account@somedomain.com policy.json\n\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof the policy file format and contents."}},
                                                                          u'sign-blob': {u'capsule': u'Sign a blob with a managed service account key.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--iam-account': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'The service account to sign as.',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': False,
                                                                                                                       u'name': u'--iam-account',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': True,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'IAM_ACCOUNT'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'sign-blob',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'iam',
                                                                                                   u'service-accounts',
                                                                                                   u'sign-blob'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'A path to the blob file to be signed.',
                                                                                                           u'name': u'input',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'INPUT-FILE'},
                                                                                                          {u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'A path the resulting signed blob will be written to.',
                                                                                                           u'name': u'output',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'OUTPUT-FILE'}],
                                                                                         u'release': u'GA',
                                                                                         u'sections': {u'DESCRIPTION': u'This command signs a file containing arbitrary binary data (a blob) using a\nsystem-managed service account key.',
                                                                                                       u'EXAMPLES': u'To sign a blob file with a system-managed service account key,\nrun:\n\n  $ sign-blob --iam-account my-account@somedomain.com input.bin output.bin\n',
                                                                                                       u'SEE ALSO': u'For more information on how this command ties into the wider cloud\ninfrastructure, please see\n[](https://cloud.google.com/appengine/docs/java/appidentity/)\n'}},
                                                                          u'update': {u'capsule': u'Update the metadata of an IAM service account.',
                                                                                      u'commands': {},
                                                                                      u'flags': {u'--display-name': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The new textual name to display for the account.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--display-name',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'DISPLAY_NAME'}},
                                                                                      u'group': False,
                                                                                      u'groups': {},
                                                                                      u'hidden': False,
                                                                                      u'name': u'update',
                                                                                      u'path': [u'gcloud',
                                                                                                u'iam',
                                                                                                u'service-accounts',
                                                                                                u'update'],
                                                                                      u'positionals': [{u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The IAM service account to update.',
                                                                                                        u'name': u'name',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'value': u'IAM-ACCOUNT'}],
                                                                                      u'release': u'GA',
                                                                                      u'sections': {u'DESCRIPTION': u'Update the metadata of an IAM service account.'}}},
                                                            u'flags': {},
                                                            u'group': True,
                                                            u'groups': {},
                                                            u'hidden': False,
                                                            u'name': u'service-accounts',
                                                            u'path': [u'gcloud',
                                                                      u'iam',
                                                                      u'service-accounts'],
                                                            u'positionals': [],
                                                            u'release': u'GA',
                                                            u'sections': {u'DESCRIPTION': u'Create and manipulate IAM service accounts. More information on service\naccounts can be found at:\nhttps://cloud.google.com/iam/docs/service-accounts'}}},
                        u'flags': {},
                        u'group': True,
                        u'groups': {},
                        u'hidden': False,
                        u'name': u'iam',
                        u'path': [u'gcloud', u'iam'],
                        u'positionals': [],
                        u'release': u'GA',
                        u'sections': {u'DESCRIPTION': u'The gcloud iam command group lets you manage Google Cloud Identity &\nAccess Management (IAM) service accounts and keys.\n\nCloud IAM authorizes who can take action on specific resources, giving you\nfull control and visibility to manage cloud resources centrally. For\nestablished enterprises with complex organizational structures, hundreds of\nworkgroups and potentially many more projects, Cloud IAM provides a unified\nview into security policy across your entire organization, with built-in\nauditing to ease compliance processes.\n\nMore information on Cloud IAM can be found here:\nhttps://cloud.google.com/iam and detailed documentation can be found here:\nhttps://cloud.google.com/iam/docs/'}},
               u'info': {u'capsule': u'Display information about the current gcloud environment.',
                         u'commands': {},
                         u'flags': {u'--no-run-diagnostics': {u'attr': {},
                                                              u'category': u'',
                                                              u'choices': [],
                                                              u'completer': u'',
                                                              u'default': True,
                                                              u'description': u'',
                                                              u'group': u'',
                                                              u'hidden': True,
                                                              u'name': u'--no-run-diagnostics',
                                                              u'nargs': u'0',
                                                              u'required': False,
                                                              u'type': u'bool',
                                                              u'value': u'NO_RUN_DIAGNOSTICS'},
                                    u'--no-show-log': {u'attr': {},
                                                       u'category': u'',
                                                       u'choices': [],
                                                       u'completer': u'',
                                                       u'default': True,
                                                       u'description': u'',
                                                       u'group': u'',
                                                       u'hidden': True,
                                                       u'name': u'--no-show-log',
                                                       u'nargs': u'0',
                                                       u'required': False,
                                                       u'type': u'bool',
                                                       u'value': u'NO_SHOW_LOG'},
                                    u'--run-diagnostics': {u'attr': {},
                                                           u'category': u'',
                                                           u'choices': [],
                                                           u'completer': u'',
                                                           u'default': False,
                                                           u'description': u'Run diagnostics on your installation of the Cloud SDK.',
                                                           u'group': u'',
                                                           u'hidden': False,
                                                           u'name': u'--run-diagnostics',
                                                           u'nargs': u'0',
                                                           u'required': False,
                                                           u'type': u'bool',
                                                           u'value': u'RUN_DIAGNOSTICS'},
                                    u'--show-log': {u'attr': {},
                                                    u'category': u'',
                                                    u'choices': [],
                                                    u'completer': u'',
                                                    u'default': False,
                                                    u'description': u'Print the contents of the last log file.',
                                                    u'group': u'',
                                                    u'hidden': False,
                                                    u'name': u'--show-log',
                                                    u'nargs': u'0',
                                                    u'required': False,
                                                    u'type': u'bool',
                                                    u'value': u'SHOW_LOG'}},
                         u'group': False,
                         u'groups': {},
                         u'hidden': False,
                         u'name': u'info',
                         u'path': [u'gcloud', u'info'],
                         u'positionals': [],
                         u'release': u'GA',
                         u'sections': {u'DESCRIPTION': u'info displays information about the current gcloud environment.\n\n- info will print information about the current active configuration,\n  including the Google Cloud Platform account, project and directory paths\n  for logs.\n\n- info --run-diagnostics will run a checks on network connectivity.\n\n- info --show-log prints the contents of the most recent log file.'}},
               u'init': {u'capsule': u'Initialize or reinitialize gcloud.',
                         u'commands': {},
                         u'flags': {u'--console-only': {u'attr': {},
                                                        u'category': u'',
                                                        u'choices': [],
                                                        u'completer': u'',
                                                        u'default': False,
                                                        u'description': u'Prevent the command from launching a browser for authorization.',
                                                        u'group': u'',
                                                        u'hidden': False,
                                                        u'name': u'--console-only',
                                                        u'nargs': u'0',
                                                        u'required': False,
                                                        u'type': u'bool',
                                                        u'value': u'CONSOLE_ONLY'},
                                    u'--no-console-only': {u'attr': {},
                                                           u'category': u'',
                                                           u'choices': [],
                                                           u'completer': u'',
                                                           u'default': True,
                                                           u'description': u'',
                                                           u'group': u'',
                                                           u'hidden': True,
                                                           u'name': u'--no-console-only',
                                                           u'nargs': u'0',
                                                           u'required': False,
                                                           u'type': u'bool',
                                                           u'value': u'NO_CONSOLE_ONLY'},
                                    u'--no-skip-diagnostics': {u'attr': {},
                                                               u'category': u'',
                                                               u'choices': [],
                                                               u'completer': u'',
                                                               u'default': True,
                                                               u'description': u'',
                                                               u'group': u'',
                                                               u'hidden': True,
                                                               u'name': u'--no-skip-diagnostics',
                                                               u'nargs': u'0',
                                                               u'required': False,
                                                               u'type': u'bool',
                                                               u'value': u'NO_SKIP_DIAGNOSTICS'},
                                    u'--skip-diagnostics': {u'attr': {},
                                                            u'category': u'',
                                                            u'choices': [],
                                                            u'completer': u'',
                                                            u'default': False,
                                                            u'description': u'Do not run diagnostics.',
                                                            u'group': u'',
                                                            u'hidden': False,
                                                            u'name': u'--skip-diagnostics',
                                                            u'nargs': u'0',
                                                            u'required': False,
                                                            u'type': u'bool',
                                                            u'value': u'SKIP_DIAGNOSTICS'}},
                         u'group': False,
                         u'groups': {},
                         u'hidden': False,
                         u'name': u'init',
                         u'path': [u'gcloud', u'init'],
                         u'positionals': [{u'completer': u'',
                                           u'default': None,
                                           u'description': u'',
                                           u'name': u'obsolete-project-arg',
                                           u'nargs': u'?',
                                           u'required': False,
                                           u'value': u'OBSOLETE_PROJECT_ARG'}],
                         u'release': u'GA',
                         u'sections': {u'DESCRIPTION': u'init launches an interactive Getting Started workflow for gcloud.\nIt performs the following setup steps:\n\n- Authorizes gcloud and other SDK tools to access Google Cloud Platform using\n  your user account credentials, or lets you select from accounts whose\n  credentials are already available.\n- Sets properties in a gcloud configuration, including the current project and\n  the default Google Compute Engine region and zone.\n\ninit can be used for initial setup of gcloud and to create new or\nreinitialize gcloud configurations. More information can be found by\nrunning `gcloud topic configurations`.\n\nProperties set by init are local and persistend, and are not affected by\nremote changes to the project. For example, the default Compute Engine zone in\nyour configuration remains stable, even if you or another user changes the\nproject-level default zone in the Cloud Platform Console.\n\nTo sync the configuration, re-run init'}},
               u'organizations': {u'capsule': u'Create and manage Google Cloud Platform Organizations.',
                                  u'commands': {u'add-iam-policy-binding': {u'capsule': u'Add IAM policy binding for a organization.',
                                                                            u'commands': {},
                                                                            u'flags': {u'--member': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The member to add to the binding.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--member',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': True,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'MEMBER'},
                                                                                       u'--role': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'Define the role of the member.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--role',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': True,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'ROLE'}},
                                                                            u'group': False,
                                                                            u'groups': {},
                                                                            u'hidden': False,
                                                                            u'name': u'add-iam-policy-binding',
                                                                            u'path': [u'gcloud',
                                                                                      u'organizations',
                                                                                      u'add-iam-policy-binding'],
                                                                            u'positionals': [{u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u'ID for the organization to which you want to add a binding',
                                                                                              u'name': u'id',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'value': u'ORGANIZATION_ID'}],
                                                                            u'release': u'GA',
                                                                            u'sections': {u'DESCRIPTION': u'Adds a policy binding to the IAM policy of an organization,\ngiven an organization ID and the binding.',
                                                                                          u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on a organization with\nidentifier '123456789'\n\n  $ add-iam-policy-binding 123456789 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                u'describe': {u'capsule': u'Show metadata for an organization.',
                                                              u'commands': {},
                                                              u'flags': {},
                                                              u'group': False,
                                                              u'groups': {},
                                                              u'hidden': False,
                                                              u'name': u'describe',
                                                              u'path': [u'gcloud',
                                                                        u'organizations',
                                                                        u'describe'],
                                                              u'positionals': [{u'completer': u'',
                                                                                u'default': None,
                                                                                u'description': u'ID for the organization you want to describe.',
                                                                                u'name': u'id',
                                                                                u'nargs': u'0',
                                                                                u'required': False,
                                                                                u'value': u'ORGANIZATION_ID'}],
                                                              u'release': u'GA',
                                                              u'sections': {u'DESCRIPTION': u'Shows metadata for an organization, given a valid organization ID.\n\nThis command can fail for the following reasons:\n    * The organization specified does not exist.\n    * The active account does not have permission to access the given\n      organization.',
                                                                            u'EXAMPLES': u'The following command prints metadata for an organization with the\nID `3589215982`:\n\n  $ describe 3589215982\n'}},
                                                u'get-iam-policy': {u'capsule': u'Get IAM policy for an organization.',
                                                                    u'commands': {},
                                                                    u'flags': {},
                                                                    u'group': False,
                                                                    u'groups': {},
                                                                    u'hidden': False,
                                                                    u'name': u'get-iam-policy',
                                                                    u'path': [u'gcloud',
                                                                              u'organizations',
                                                                              u'get-iam-policy'],
                                                                    u'positionals': [{u'completer': u'',
                                                                                      u'default': None,
                                                                                      u'description': u'ID for the organization whose policy you want to get.',
                                                                                      u'name': u'id',
                                                                                      u'nargs': u'0',
                                                                                      u'required': False,
                                                                                      u'value': u'ORGANIZATION_ID'}],
                                                                    u'release': u'GA',
                                                                    u'sections': {u'DESCRIPTION': u'Gets the IAM policy for an organization, given an organization ID.',
                                                                                  u'EXAMPLES': u'The following command prints the IAM policy for an organization with\nthe ID `123456789`:\n\n  $ get-iam-policy 123456789\n'}},
                                                u'list': {u'capsule': u'List organizations accessible by the active account.',
                                                          u'commands': {},
                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                   u'category': u'LIST COMMAND',
                                                                                   u'choices': [],
                                                                                   u'completer': u'',
                                                                                   u'default': None,
                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                   u'group': u'',
                                                                                   u'hidden': False,
                                                                                   u'name': u'--filter',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'type': u'string',
                                                                                   u'value': u'EXPRESSION'},
                                                                     u'--limit': {u'attr': {},
                                                                                  u'category': u'LIST COMMAND',
                                                                                  u'choices': [],
                                                                                  u'completer': u'',
                                                                                  u'default': None,
                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                  u'group': u'',
                                                                                  u'hidden': False,
                                                                                  u'name': u'--limit',
                                                                                  u'nargs': u'0',
                                                                                  u'required': False,
                                                                                  u'type': u'string',
                                                                                  u'value': u'LIMIT'},
                                                                     u'--no-uri': {u'attr': {},
                                                                                   u'category': u'LIST COMMAND',
                                                                                   u'choices': [],
                                                                                   u'completer': u'',
                                                                                   u'default': True,
                                                                                   u'description': u'',
                                                                                   u'group': u'',
                                                                                   u'hidden': True,
                                                                                   u'name': u'--no-uri',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'type': u'bool',
                                                                                   u'value': u'NO_URI'},
                                                                     u'--page-size': {u'attr': {},
                                                                                      u'category': u'LIST COMMAND',
                                                                                      u'choices': [],
                                                                                      u'completer': u'',
                                                                                      u'default': None,
                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                      u'group': u'',
                                                                                      u'hidden': False,
                                                                                      u'name': u'--page-size',
                                                                                      u'nargs': u'0',
                                                                                      u'required': False,
                                                                                      u'type': u'string',
                                                                                      u'value': u'PAGE_SIZE'},
                                                                     u'--sort-by': {u'attr': {},
                                                                                    u'category': u'LIST COMMAND',
                                                                                    u'choices': [],
                                                                                    u'completer': u'',
                                                                                    u'default': None,
                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                    u'group': u'',
                                                                                    u'hidden': False,
                                                                                    u'name': u'--sort-by',
                                                                                    u'nargs': u'0',
                                                                                    u'required': False,
                                                                                    u'type': u'list',
                                                                                    u'value': u'FIELD'},
                                                                     u'--uri': {u'attr': {},
                                                                                u'category': u'LIST COMMAND',
                                                                                u'choices': [],
                                                                                u'completer': u'',
                                                                                u'default': False,
                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                u'group': u'',
                                                                                u'hidden': False,
                                                                                u'name': u'--uri',
                                                                                u'nargs': u'0',
                                                                                u'required': False,
                                                                                u'type': u'bool',
                                                                                u'value': u'URI'}},
                                                          u'group': False,
                                                          u'groups': {},
                                                          u'hidden': False,
                                                          u'name': u'list',
                                                          u'path': [u'gcloud',
                                                                    u'organizations',
                                                                    u'list'],
                                                          u'positionals': [],
                                                          u'release': u'GA',
                                                          u'sections': {u'DESCRIPTION': u'Lists all organizations to which the user has access. Organizations are listed\nin an unspecified order.'}},
                                                u'remove-iam-policy-binding': {u'capsule': u'Remove IAM policy binding for a organization.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--member': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'The member to remove from the binding.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--member',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': True,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'MEMBER'},
                                                                                          u'--role': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The role to remove the member from.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--role',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': True,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'ROLE'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'remove-iam-policy-binding',
                                                                               u'path': [u'gcloud',
                                                                                         u'organizations',
                                                                                         u'remove-iam-policy-binding'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'ID for the organization whose IAM binding you want to remove.',
                                                                                                 u'name': u'id',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'ORGANIZATION_ID'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Removes a policy binding to the IAM policy of an organization, given an\norganization ID\nand the binding.',
                                                                                             u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on organization with\nidentifier 'example-organization-id-1'\n\n  $ remove-iam-policy-binding example-organization-id-1 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                u'set-iam-policy': {u'capsule': u'Set IAM policy for an organization.',
                                                                    u'commands': {},
                                                                    u'flags': {},
                                                                    u'group': False,
                                                                    u'groups': {},
                                                                    u'hidden': False,
                                                                    u'name': u'set-iam-policy',
                                                                    u'path': [u'gcloud',
                                                                              u'organizations',
                                                                              u'set-iam-policy'],
                                                                    u'positionals': [{u'completer': u'',
                                                                                      u'default': None,
                                                                                      u'description': u'ID for the organization whose IAM policy you want to set.',
                                                                                      u'name': u'id',
                                                                                      u'nargs': u'0',
                                                                                      u'required': False,
                                                                                      u'value': u'ORGANIZATION_ID'},
                                                                                     {u'completer': u'',
                                                                                      u'default': None,
                                                                                      u'description': u'JSON or YAML file containing the IAM policy.',
                                                                                      u'name': u'policy-file',
                                                                                      u'nargs': u'0',
                                                                                      u'required': False,
                                                                                      u'value': u'POLICY_FILE'}],
                                                                    u'release': u'GA',
                                                                    u'sections': {u'DESCRIPTION': u'Given an organization ID and a file encoded in JSON or YAML that contains the\nIAM policy, this command will set the IAM policy for that organization.',
                                                                                  u'EXAMPLES': u'The following command reads an IAM policy defined in a JSON\nfile `policy.json` and sets it for an organization with the ID\n`123456789`:\n\n  $ set-iam-policy 123456789 policy.json'}}},
                                  u'flags': {},
                                  u'group': True,
                                  u'groups': {},
                                  u'hidden': False,
                                  u'name': u'organizations',
                                  u'path': [u'gcloud', u'organizations'],
                                  u'positionals': [],
                                  u'release': u'GA',
                                  u'sections': {u'DESCRIPTION': u'The organizations group lets you create and manage Cloud Organizations.\nGoogle Cloud Platform resources form a hierarchy with Organizations at the\nroot. Organizations contain projects, and Projects contain the remaining\nGoogle Cloud Platform resources.\n\nMore information on the Cloud Platform Resource Hierarchy and the Organization\nresource can be found here:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-organization\nand detailed documentation on creating and managing organizations can be found\nhere:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-organization'}},
               u'projects': {u'capsule': u'Create and manage project access policies.',
                             u'commands': {u'add-iam-policy-binding': {u'capsule': u'Add IAM policy binding for a project.',
                                                                       u'commands': {},
                                                                       u'flags': {u'--member': {u'attr': {},
                                                                                                u'category': u'',
                                                                                                u'choices': [],
                                                                                                u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'The member to add to the binding.',
                                                                                                u'group': u'',
                                                                                                u'hidden': False,
                                                                                                u'name': u'--member',
                                                                                                u'nargs': u'0',
                                                                                                u'required': True,
                                                                                                u'type': u'string',
                                                                                                u'value': u'MEMBER'},
                                                                                  u'--role': {u'attr': {},
                                                                                              u'category': u'',
                                                                                              u'choices': [],
                                                                                              u'completer': u'',
                                                                                              u'default': None,
                                                                                              u'description': u'Define the role of the member.',
                                                                                              u'group': u'',
                                                                                              u'hidden': False,
                                                                                              u'name': u'--role',
                                                                                              u'nargs': u'0',
                                                                                              u'required': True,
                                                                                              u'type': u'string',
                                                                                              u'value': u'ROLE'}},
                                                                       u'group': False,
                                                                       u'groups': {},
                                                                       u'hidden': False,
                                                                       u'name': u'add-iam-policy-binding',
                                                                       u'path': [u'gcloud',
                                                                                 u'projects',
                                                                                 u'add-iam-policy-binding'],
                                                                       u'positionals': [{u'completer': u'',
                                                                                         u'default': None,
                                                                                         u'description': u'ID for the project you want to add IAM policy binding to.',
                                                                                         u'name': u'id',
                                                                                         u'nargs': u'0',
                                                                                         u'required': False,
                                                                                         u'value': u'PROJECT_ID'}],
                                                                       u'release': u'GA',
                                                                       u'sections': {u'DESCRIPTION': u'Adds a policy binding to the IAM policy of a project,\ngiven a project ID and the binding.',
                                                                                     u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on a project with\nidentifier 'example-project-id-1'\n\n  $ add-iam-policy-binding example-project-id-1 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                           u'delete': {u'capsule': u'Delete a project.',
                                                       u'commands': {},
                                                       u'flags': {},
                                                       u'group': False,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'delete',
                                                       u'path': [u'gcloud',
                                                                 u'projects',
                                                                 u'delete'],
                                                       u'positionals': [{u'completer': u'',
                                                                         u'default': None,
                                                                         u'description': u'ID for the project you want to delete.',
                                                                         u'name': u'id',
                                                                         u'nargs': u'0',
                                                                         u'required': False,
                                                                         u'value': u'PROJECT_ID'}],
                                                       u'release': u'GA',
                                                       u'sections': {u'DESCRIPTION': u'Deletes the project with the given project ID.\n\nThis command can fail for the following reasons:\n* The project specified does not exist.\n* The active account does not have Owner permissions for the given project.\n\n## EXAMPLES\n\nThe following command deletes the project with the ID `example-foo-bar-1`:\n\n  $ delete example-foo-bar-1'}},
                                           u'describe': {u'capsule': u'Show metadata for a project.',
                                                         u'commands': {},
                                                         u'flags': {},
                                                         u'group': False,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'describe',
                                                         u'path': [u'gcloud',
                                                                   u'projects',
                                                                   u'describe'],
                                                         u'positionals': [{u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u'ID for the project you want to describe.',
                                                                           u'name': u'id',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'value': u'PROJECT_ID'}],
                                                         u'release': u'GA',
                                                         u'sections': {u'DESCRIPTION': u'Shows metadata for a project given a valid project ID.\n\nThis command can fail for the following reasons:\n* The project specified does not exist.\n* The active account does not have permission to access the given project.\n\n## EXAMPLES\n\nThe following command prints metadata for a project with the ID\n`example-foo-bar-1`:\n\n  $ describe example-foo-bar-1'}},
                                           u'get-iam-policy': {u'capsule': u'Get IAM policy for a project.',
                                                               u'commands': {},
                                                               u'flags': {},
                                                               u'group': False,
                                                               u'groups': {},
                                                               u'hidden': False,
                                                               u'name': u'get-iam-policy',
                                                               u'path': [u'gcloud',
                                                                         u'projects',
                                                                         u'get-iam-policy'],
                                                               u'positionals': [{u'completer': u'',
                                                                                 u'default': None,
                                                                                 u'description': u'ID for the project you want to get IAM policy for.',
                                                                                 u'name': u'id',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'value': u'PROJECT_ID'}],
                                                               u'release': u'GA',
                                                               u'sections': {u'DESCRIPTION': u'Gets the IAM policy for a project, given a project ID.\n\n## EXAMPLES\n\nThe following command prints the IAM policy for a project with the ID\n`example-project-id-1`:\n\n  $ get-iam-policy example-project-id-1'}},
                                           u'list': {u'capsule': u'List projects accessible by the active account.',
                                                     u'commands': {},
                                                     u'flags': {u'--filter': {u'attr': {},
                                                                              u'category': u'LIST COMMAND',
                                                                              u'choices': [],
                                                                              u'completer': u'',
                                                                              u'default': None,
                                                                              u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                              u'group': u'',
                                                                              u'hidden': False,
                                                                              u'name': u'--filter',
                                                                              u'nargs': u'0',
                                                                              u'required': False,
                                                                              u'type': u'string',
                                                                              u'value': u'EXPRESSION'},
                                                                u'--limit': {u'attr': {},
                                                                             u'category': u'LIST COMMAND',
                                                                             u'choices': [],
                                                                             u'completer': u'',
                                                                             u'default': None,
                                                                             u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                             u'group': u'',
                                                                             u'hidden': False,
                                                                             u'name': u'--limit',
                                                                             u'nargs': u'0',
                                                                             u'required': False,
                                                                             u'type': u'string',
                                                                             u'value': u'LIMIT'},
                                                                u'--no-uri': {u'attr': {},
                                                                              u'category': u'LIST COMMAND',
                                                                              u'choices': [],
                                                                              u'completer': u'',
                                                                              u'default': True,
                                                                              u'description': u'',
                                                                              u'group': u'',
                                                                              u'hidden': True,
                                                                              u'name': u'--no-uri',
                                                                              u'nargs': u'0',
                                                                              u'required': False,
                                                                              u'type': u'bool',
                                                                              u'value': u'NO_URI'},
                                                                u'--page-size': {u'attr': {},
                                                                                 u'category': u'LIST COMMAND',
                                                                                 u'choices': [],
                                                                                 u'completer': u'',
                                                                                 u'default': None,
                                                                                 u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                 u'group': u'',
                                                                                 u'hidden': False,
                                                                                 u'name': u'--page-size',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'type': u'string',
                                                                                 u'value': u'PAGE_SIZE'},
                                                                u'--sort-by': {u'attr': {},
                                                                               u'category': u'LIST COMMAND',
                                                                               u'choices': [],
                                                                               u'completer': u'',
                                                                               u'default': None,
                                                                               u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                               u'group': u'',
                                                                               u'hidden': False,
                                                                               u'name': u'--sort-by',
                                                                               u'nargs': u'0',
                                                                               u'required': False,
                                                                               u'type': u'list',
                                                                               u'value': u'FIELD'},
                                                                u'--uri': {u'attr': {},
                                                                           u'category': u'LIST COMMAND',
                                                                           u'choices': [],
                                                                           u'completer': u'',
                                                                           u'default': False,
                                                                           u'description': u'Print a list of resource URIs instead of the default output.',
                                                                           u'group': u'',
                                                                           u'hidden': False,
                                                                           u'name': u'--uri',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'type': u'bool',
                                                                           u'value': u'URI'}},
                                                     u'group': False,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'list',
                                                     u'path': [u'gcloud',
                                                               u'projects',
                                                               u'list'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'Lists all active projects, where the active account has Owner, Editor or\nViewer permissions. Projects are listed in alphabetical order by project name.\nProjects that have been deleted or are pending deletion are not included.\n\nYou can specify the maximum number of projects to list using the `--limit`\nflag.\n\n## EXAMPLES\n\nThe following command lists a maximum of five projects sorted alphabetically\nby name:\n\n  $ list --limit=5'}},
                                           u'remove-iam-policy-binding': {u'capsule': u'Remove IAM policy binding for a project.',
                                                                          u'commands': {},
                                                                          u'flags': {u'--member': {u'attr': {},
                                                                                                   u'category': u'',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The member to remove from the binding.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--member',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': True,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'MEMBER'},
                                                                                     u'--role': {u'attr': {},
                                                                                                 u'category': u'',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The role to remove the member from.',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'--role',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': True,
                                                                                                 u'type': u'string',
                                                                                                 u'value': u'ROLE'}},
                                                                          u'group': False,
                                                                          u'groups': {},
                                                                          u'hidden': False,
                                                                          u'name': u'remove-iam-policy-binding',
                                                                          u'path': [u'gcloud',
                                                                                    u'projects',
                                                                                    u'remove-iam-policy-binding'],
                                                                          u'positionals': [{u'completer': u'',
                                                                                            u'default': None,
                                                                                            u'description': u'ID for the project you want to remove IAM policy binding from.',
                                                                                            u'name': u'id',
                                                                                            u'nargs': u'0',
                                                                                            u'required': False,
                                                                                            u'value': u'PROJECT_ID'}],
                                                                          u'release': u'GA',
                                                                          u'sections': {u'DESCRIPTION': u'Removes a policy binding to the IAM policy of a project, given a project ID\nand the binding.',
                                                                                        u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/editor' for the user 'test-user@gmail.com' on project with\nidentifier 'example-project-id-1'\n\n  $ remove-iam-policy-binding example-project-id-1 --member='user:test-user@gmail.com' --role='roles/editor'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                           u'set-iam-policy': {u'capsule': u'Set IAM policy for a project.',
                                                               u'commands': {},
                                                               u'flags': {},
                                                               u'group': False,
                                                               u'groups': {},
                                                               u'hidden': False,
                                                               u'name': u'set-iam-policy',
                                                               u'path': [u'gcloud',
                                                                         u'projects',
                                                                         u'set-iam-policy'],
                                                               u'positionals': [{u'completer': u'',
                                                                                 u'default': None,
                                                                                 u'description': u'ID for the project you want to set IAM policy for.',
                                                                                 u'name': u'id',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'value': u'PROJECT_ID'},
                                                                                {u'completer': u'',
                                                                                 u'default': None,
                                                                                 u'description': u'JSON or YAML file with the IAM policy',
                                                                                 u'name': u'policy-file',
                                                                                 u'nargs': u'0',
                                                                                 u'required': False,
                                                                                 u'value': u'POLICY_FILE'}],
                                                               u'release': u'GA',
                                                               u'sections': {u'DESCRIPTION': u'Sets the IAM policy for a project, given a project ID and a file encoded in\nJSON or YAML that contains the IAM policy.\n\n## EXAMPLES\n\nThe following command reads an IAM policy defined in a JSON file `policy.json`\nand sets it for a project with the ID `example-project-id-1`:\n\n  $ set-iam-policy example-project-id-1 policy.json'}},
                                           u'undelete': {u'capsule': u'Undelete a project.',
                                                         u'commands': {},
                                                         u'flags': {},
                                                         u'group': False,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'undelete',
                                                         u'path': [u'gcloud',
                                                                   u'projects',
                                                                   u'undelete'],
                                                         u'positionals': [{u'completer': u'',
                                                                           u'default': None,
                                                                           u'description': u'ID for the project you want to undelete.',
                                                                           u'name': u'id',
                                                                           u'nargs': u'0',
                                                                           u'required': False,
                                                                           u'value': u'PROJECT_ID'}],
                                                         u'release': u'GA',
                                                         u'sections': {u'DESCRIPTION': u'Undeletes the project with the given project ID.\n\nThis command can fail for the following reasons:\n* There is no project with the given ID.\n* The active account does not have Owner or Editor permissions for the\n  given project.\n\n## EXAMPLES\n\nThe following command undeletes the project with the ID `example-foo-bar-1`:\n\n  $ undelete example-foo-bar-1'}},
                                           u'update': {u'capsule': u'Update the name of a project.',
                                                       u'commands': {},
                                                       u'flags': {u'--name': {u'attr': {},
                                                                              u'category': u'',
                                                                              u'choices': [],
                                                                              u'completer': u'',
                                                                              u'default': None,
                                                                              u'description': u'New name for the project.',
                                                                              u'group': u'',
                                                                              u'hidden': False,
                                                                              u'name': u'--name',
                                                                              u'nargs': u'0',
                                                                              u'required': False,
                                                                              u'type': u'string',
                                                                              u'value': u'NAME'}},
                                                       u'group': False,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'update',
                                                       u'path': [u'gcloud',
                                                                 u'projects',
                                                                 u'update'],
                                                       u'positionals': [{u'completer': u'',
                                                                         u'default': None,
                                                                         u'description': u'ID for the project you want to update.',
                                                                         u'name': u'id',
                                                                         u'nargs': u'0',
                                                                         u'required': False,
                                                                         u'value': u'PROJECT_ID'}],
                                                       u'release': u'GA',
                                                       u'sections': {u'DESCRIPTION': u'Update the the name of the given project.\n\nThis command can fail for the following reasons:\n* There is no project with the given ID.\n* The active account does not have Owner or Editor permissions for the\n  given project.\n\n## EXAMPLES\n\nThe following command updates a project with the ID\n`example-foo-bar-1` to have the name "Foo Bar & Grill":\n\n  $ update example-foo-bar-1 --name="Foo Bar & Grill"'}}},
                             u'flags': {},
                             u'group': True,
                             u'groups': {},
                             u'hidden': False,
                             u'name': u'projects',
                             u'path': [u'gcloud', u'projects'],
                             u'positionals': [],
                             u'release': u'GA',
                             u'sections': {u'DESCRIPTION': u'The projects group lets you create and manage IAM policies for projects on\nthe Google Cloud Platform. Resources are organized hierarchically and assigned\nto a particular project.  A Project resource is required to use Google Cloud\nPlatform, and forms the basis for creating, enabling and using all Cloud\nPlatform services, managing APIs, enabling billing, adding and removing\ncollaborators, and managing permissions.\n\nMore information on the Cloud Platform Resource Hierarchy and the project\nresource can be found here:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-organization\nand detailed documentation on creating and managing projects can be found\nhere:\nhttps://cloud.google.com/resource-manager/docs/creating-managing-projects'}},
               u'service-management': {u'capsule': u'Create, enable and manage API services.',
                                       u'commands': {u'add-iam-policy-binding': {u'capsule': u'Add IAM policy binding for a service.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--member': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The member to add to the binding.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--member',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': True,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'MEMBER'},
                                                                                            u'--role': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Define the role of the member.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--role',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': True,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'ROLE'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'add-iam-policy-binding',
                                                                                 u'path': [u'gcloud',
                                                                                           u'service-management',
                                                                                           u'add-iam-policy-binding'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The name of the service to which the member is to be added.',
                                                                                                   u'name': u'service',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'SERVICE'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u"Adds IAM policy binding to a service's access policy.",
                                                                                               u'EXAMPLES': u"The following command will add an IAM policy binding for the role\nof 'roles/servicemanagement.serviceConsumer' for the user 'test-user@gmail.com' on a service with\nidentifier 'my-service'\n\n  $ add-iam-policy-binding my-service --member='user:test-user@gmail.com' --role='roles/servicemanagement.serviceConsumer'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                     u'check-iam-policy': {u'capsule': u"Returns information about a member's permissions on a service.",
                                                                           u'commands': {},
                                                                           u'flags': {},
                                                                           u'group': False,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'check-iam-policy',
                                                                           u'path': [u'gcloud',
                                                                                     u'service-management',
                                                                                     u'check-iam-policy'],
                                                                           u'positionals': [{u'completer': u'',
                                                                                             u'default': None,
                                                                                             u'description': u'The name of the service for which to check the IAM policy.',
                                                                                             u'name': u'service',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'value': u'SERVICE'}],
                                                                           u'release': u'GA',
                                                                           u'sections': {u'DESCRIPTION': u'This command lists the permissions that the current authenticated\ngcloud user has for a service. For example, if the authenticated user is\nable to delete the service, `servicemanagement.services.delete` will\nbe among the returned permissions.\n',
                                                                                         u'EXAMPLES': u'To check the permissions for the currently authenticated gcloud, run:\n\n  $ check-iam-policy my_produced_service_name\n'}},
                                                     u'configs': {u'capsule': u'View configurations for various services.',
                                                                  u'commands': {u'describe': {u'capsule': u'Describes the configuration for a given version of a service.',
                                                                                              u'commands': {},
                                                                                              u'flags': {u'--service': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': None,
                                                                                                                        u'description': u'The service from which to retrieve the configuration.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--service',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'string',
                                                                                                                        u'value': u'SERVICE'}},
                                                                                              u'group': False,
                                                                                              u'groups': {},
                                                                                              u'hidden': False,
                                                                                              u'name': u'describe',
                                                                                              u'path': [u'gcloud',
                                                                                                        u'service-management',
                                                                                                        u'configs',
                                                                                                        u'describe'],
                                                                                              u'positionals': [{u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The configuration ID to retrieve.',
                                                                                                                u'name': u'config-id',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'value': u'CONFIG_ID'}],
                                                                                              u'release': u'GA',
                                                                                              u'sections': {u'DESCRIPTION': u'This command prints out the configuration for the given version of a\ngiven service. You specify the name of the service and the ID of the\nconfiguration, and the command will print out the specified config.\n',
                                                                                                            u'EXAMPLES': u"To print the configuration with ID ``2017-01-01R0'' for the service\ncalled ``my-service'', run:\n\n  $ describe --service my-service 2017-01-01R0\n"}},
                                                                                u'list': {u'capsule': u'Lists the configurations for a given service.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--filter': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--filter',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'EXPRESSION'},
                                                                                                     u'--limit': {u'attr': {},
                                                                                                                  u'category': u'LIST COMMAND',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--limit',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'LIMIT'},
                                                                                                     u'--no-uri': {u'attr': {},
                                                                                                                   u'category': u'LIST COMMAND',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': True,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--no-uri',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'NO_URI'},
                                                                                                     u'--page-size': {u'attr': {},
                                                                                                                      u'category': u'LIST COMMAND',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--page-size',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'PAGE_SIZE'},
                                                                                                     u'--service': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'The name of service for which to list existing configurations.',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--service',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': True,
                                                                                                                    u'type': u'string',
                                                                                                                    u'value': u'SERVICE'},
                                                                                                     u'--sort-by': {u'attr': {},
                                                                                                                    u'category': u'LIST COMMAND',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--sort-by',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'list',
                                                                                                                    u'value': u'FIELD'},
                                                                                                     u'--uri': {u'attr': {},
                                                                                                                u'category': u'LIST COMMAND',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--uri',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'URI'}},
                                                                                          u'group': False,
                                                                                          u'groups': {},
                                                                                          u'hidden': False,
                                                                                          u'name': u'list',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'service-management',
                                                                                                    u'configs',
                                                                                                    u'list'],
                                                                                          u'positionals': [],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'This command lists all the configurations for a given service by ID.\n\nTo get more detailed information about a specific configuration, run:\n\n  $ configs describe\n',
                                                                                                        u'EXAMPLES': u'To list the configurations for a service named `my-service`, run:\n\n  $ list --service my-service\n'}}},
                                                                  u'flags': {},
                                                                  u'group': True,
                                                                  u'groups': {},
                                                                  u'hidden': False,
                                                                  u'name': u'configs',
                                                                  u'path': [u'gcloud',
                                                                            u'service-management',
                                                                            u'configs'],
                                                                  u'positionals': [],
                                                                  u'release': u'GA',
                                                                  u'sections': {u'DESCRIPTION': u'View configurations for various services.'}},
                                                     u'delete': {u'capsule': u'Deletes a service.',
                                                                 u'commands': {},
                                                                 u'flags': {u'--async': {u'attr': {},
                                                                                         u'category': u'',
                                                                                         u'choices': [],
                                                                                         u'completer': u'',
                                                                                         u'default': False,
                                                                                         u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                         u'group': u'',
                                                                                         u'hidden': False,
                                                                                         u'name': u'--async',
                                                                                         u'nargs': u'0',
                                                                                         u'required': False,
                                                                                         u'type': u'bool',
                                                                                         u'value': u'ASYNC'},
                                                                            u'--no-async': {u'attr': {},
                                                                                            u'category': u'',
                                                                                            u'choices': [],
                                                                                            u'completer': u'',
                                                                                            u'default': True,
                                                                                            u'description': u'',
                                                                                            u'group': u'',
                                                                                            u'hidden': True,
                                                                                            u'name': u'--no-async',
                                                                                            u'nargs': u'0',
                                                                                            u'required': False,
                                                                                            u'type': u'bool',
                                                                                            u'value': u'NO_ASYNC'}},
                                                                 u'group': False,
                                                                 u'groups': {},
                                                                 u'hidden': False,
                                                                 u'name': u'delete',
                                                                 u'path': [u'gcloud',
                                                                           u'service-management',
                                                                           u'delete'],
                                                                 u'positionals': [{u'completer': u'',
                                                                                   u'default': None,
                                                                                   u'description': u'The name of the service to delete.',
                                                                                   u'name': u'service',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'value': u'SERVICE'}],
                                                                 u'release': u'GA',
                                                                 u'sections': {u'DESCRIPTION': u'Deletes a service from Google Service Management.\n\nServices that are deleted will be retained in the system for 30 days.\nIf a deleted service is still within this retention window, it can be\nundeleted with the undelete command.\n',
                                                                               u'EXAMPLES': u'To delete a service named `my-service`, run:\n\n  $ delete my-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ delete my-service --async\n'}},
                                                     u'deploy': {u'capsule': u'Deploys a service configuration.',
                                                                 u'commands': {},
                                                                 u'flags': {u'--async': {u'attr': {},
                                                                                         u'category': u'',
                                                                                         u'choices': [],
                                                                                         u'completer': u'',
                                                                                         u'default': False,
                                                                                         u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                         u'group': u'',
                                                                                         u'hidden': False,
                                                                                         u'name': u'--async',
                                                                                         u'nargs': u'0',
                                                                                         u'required': False,
                                                                                         u'type': u'bool',
                                                                                         u'value': u'ASYNC'},
                                                                            u'--no-async': {u'attr': {},
                                                                                            u'category': u'',
                                                                                            u'choices': [],
                                                                                            u'completer': u'',
                                                                                            u'default': True,
                                                                                            u'description': u'',
                                                                                            u'group': u'',
                                                                                            u'hidden': True,
                                                                                            u'name': u'--no-async',
                                                                                            u'nargs': u'0',
                                                                                            u'required': False,
                                                                                            u'type': u'bool',
                                                                                            u'value': u'NO_ASYNC'}},
                                                                 u'group': False,
                                                                 u'groups': {},
                                                                 u'hidden': False,
                                                                 u'name': u'deploy',
                                                                 u'path': [u'gcloud',
                                                                           u'service-management',
                                                                           u'deploy'],
                                                                 u'positionals': [{u'completer': u'',
                                                                                   u'default': None,
                                                                                   u'description': u'The service configuration file (or files) containing the API specification to upload. Proto Descriptors, Open API (Swagger) specifications, and Google Service Configuration files in JSON and YAML formats are acceptable.',
                                                                                   u'name': u'service-config-file',
                                                                                   u'nargs': u'+',
                                                                                   u'required': False,
                                                                                   u'value': u'SERVICE_CONFIG_FILE'}],
                                                                 u'release': u'GA',
                                                                 u'sections': {u'DESCRIPTION': u'This command is used to deploy a service configuration for a service\nto Google Service Management. As input, it takes one or more paths\nto service configurations that should be uploaded. These configuration\nfiles can be Proto Descriptors, Open API (Swagger) specifications,\nor Google Service Configuration files in JSON or YAML formats.\n\nIf a service name is present in multiple configuration files (given\nin the `host` field in OpenAPI specifications or the `name` field in\nGoogle Service Configuration files), the first one will take precedence.\n\nThis command will block until deployment is complete unless the\n`--async` flag is passed.\n',
                                                                               u'EXAMPLES': u'To deploy a single Open API service configuration, run:\n\n  $ deploy ~/my_app/openapi.json\n\nTo run the deployment asynchronously (non-blocking), run:\n\n  $ deploy ~/my_app/openapi.json --async\n\nTo deploy a service config with a Proto, run:\n\n  $ deploy ~/my_app/service-config.yaml ~/my_app/service-protos.pb\n'}},
                                                     u'describe': {u'capsule': u'Describes a service given a service name.',
                                                                   u'commands': {},
                                                                   u'flags': {},
                                                                   u'group': False,
                                                                   u'groups': {},
                                                                   u'hidden': False,
                                                                   u'name': u'describe',
                                                                   u'path': [u'gcloud',
                                                                             u'service-management',
                                                                             u'describe'],
                                                                   u'positionals': [{u'completer': u'',
                                                                                     u'default': None,
                                                                                     u'description': u'The name of the service to describe.',
                                                                                     u'name': u'service',
                                                                                     u'nargs': u'0',
                                                                                     u'required': False,
                                                                                     u'value': u'SERVICE'}],
                                                                   u'release': u'GA',
                                                                   u'sections': {u'DESCRIPTION': u'Describes a service given a service name.'}},
                                                     u'disable': {u'capsule': u'Disables a service for consumption for a project.',
                                                                  u'commands': {},
                                                                  u'flags': {u'--async': {u'attr': {},
                                                                                          u'category': u'',
                                                                                          u'choices': [],
                                                                                          u'completer': u'',
                                                                                          u'default': False,
                                                                                          u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                          u'group': u'',
                                                                                          u'hidden': False,
                                                                                          u'name': u'--async',
                                                                                          u'nargs': u'0',
                                                                                          u'required': False,
                                                                                          u'type': u'bool',
                                                                                          u'value': u'ASYNC'},
                                                                             u'--no-async': {u'attr': {},
                                                                                             u'category': u'',
                                                                                             u'choices': [],
                                                                                             u'completer': u'',
                                                                                             u'default': True,
                                                                                             u'description': u'',
                                                                                             u'group': u'',
                                                                                             u'hidden': True,
                                                                                             u'name': u'--no-async',
                                                                                             u'nargs': u'0',
                                                                                             u'required': False,
                                                                                             u'type': u'bool',
                                                                                             u'value': u'NO_ASYNC'}},
                                                                  u'group': False,
                                                                  u'groups': {},
                                                                  u'hidden': False,
                                                                  u'name': u'disable',
                                                                  u'path': [u'gcloud',
                                                                            u'service-management',
                                                                            u'disable'],
                                                                  u'positionals': [{u'completer': u'',
                                                                                    u'default': None,
                                                                                    u'description': u'The name of the service to disable.',
                                                                                    u'name': u'service',
                                                                                    u'nargs': u'0',
                                                                                    u'required': False,
                                                                                    u'value': u'SERVICE'}],
                                                                  u'release': u'GA',
                                                                  u'sections': {u'DESCRIPTION': u'This command disables a previously-enabled service for consumption.\n\nTo see a list of the enabled services for a project, run:\n\n  $ service-management list --enabled\n\nMore information on listing services can be found at:\nhttps://cloud.google.com/service-management/list-services and on\ndisabling a service at:\nhttps://cloud.google.com/service-management/enable-disable#disabling_services\n',
                                                                                u'EXAMPLES': u'To disable a service called `my-consumed-service` for the active\nproject, run:\n\n  $ disable my-consumed-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ disable my-consumed-service --async\n'}},
                                                     u'enable': {u'capsule': u'Enables a service for consumption for a project.',
                                                                 u'commands': {},
                                                                 u'flags': {u'--async': {u'attr': {},
                                                                                         u'category': u'',
                                                                                         u'choices': [],
                                                                                         u'completer': u'',
                                                                                         u'default': False,
                                                                                         u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                         u'group': u'',
                                                                                         u'hidden': False,
                                                                                         u'name': u'--async',
                                                                                         u'nargs': u'0',
                                                                                         u'required': False,
                                                                                         u'type': u'bool',
                                                                                         u'value': u'ASYNC'},
                                                                            u'--no-async': {u'attr': {},
                                                                                            u'category': u'',
                                                                                            u'choices': [],
                                                                                            u'completer': u'',
                                                                                            u'default': True,
                                                                                            u'description': u'',
                                                                                            u'group': u'',
                                                                                            u'hidden': True,
                                                                                            u'name': u'--no-async',
                                                                                            u'nargs': u'0',
                                                                                            u'required': False,
                                                                                            u'type': u'bool',
                                                                                            u'value': u'NO_ASYNC'}},
                                                                 u'group': False,
                                                                 u'groups': {},
                                                                 u'hidden': False,
                                                                 u'name': u'enable',
                                                                 u'path': [u'gcloud',
                                                                           u'service-management',
                                                                           u'enable'],
                                                                 u'positionals': [{u'completer': u'',
                                                                                   u'default': None,
                                                                                   u'description': u'The name of the service to enable.',
                                                                                   u'name': u'service',
                                                                                   u'nargs': u'0',
                                                                                   u'required': False,
                                                                                   u'value': u'SERVICE'}],
                                                                 u'release': u'GA',
                                                                 u'sections': {u'DESCRIPTION': u'This command enables a service for consumption for a project.\n\nTo see a list of available services for a project, run:\n\n  $ service-management list --available\n\nMore information on listing services can be found at:\nhttps://cloud.google.com/service-management/list-services and on\nenabling a service at:\nhttps://cloud.google.com/service-management/enable-disable#enabling_services\n',
                                                                               u'EXAMPLES': u'To enable a service called `my-consumed-service` on the current\nproject, run:\n\n  $ enable my-consumed-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ enable my-consumed-service --async\n'}},
                                                     u'get-iam-policy': {u'capsule': u'Describes the IAM policy for a service.',
                                                                         u'commands': {},
                                                                         u'flags': {},
                                                                         u'group': False,
                                                                         u'groups': {},
                                                                         u'hidden': False,
                                                                         u'name': u'get-iam-policy',
                                                                         u'path': [u'gcloud',
                                                                                   u'service-management',
                                                                                   u'get-iam-policy'],
                                                                         u'positionals': [{u'completer': u'',
                                                                                           u'default': None,
                                                                                           u'description': u'The name of the service whose IAM policy is to be described.',
                                                                                           u'name': u'service',
                                                                                           u'nargs': u'0',
                                                                                           u'required': False,
                                                                                           u'value': u'SERVICE'}],
                                                                         u'release': u'GA',
                                                                         u'sections': {u'DESCRIPTION': u'Gets the IAM policy for a produced service, given the service name.\n',
                                                                                       u'EXAMPLES': u'To print the IAM policy for a service named `my-service`, run:\n\n  $ get-iam-policy my-service\n'}},
                                                     u'list': {u'capsule': u'List services for a project.',
                                                               u'commands': {},
                                                               u'flags': {u'--available': {u'attr': {},
                                                                                           u'category': u'',
                                                                                           u'choices': [],
                                                                                           u'completer': u'',
                                                                                           u'default': False,
                                                                                           u'description': u'Return the services available to the project to enable. This list will include any services that the project has already enabled. Or use one of --enabled or --produced.',
                                                                                           u'group': u'list.1',
                                                                                           u'hidden': False,
                                                                                           u'name': u'--available',
                                                                                           u'nargs': u'0',
                                                                                           u'required': False,
                                                                                           u'type': u'bool',
                                                                                           u'value': u'AVAILABLE'},
                                                                          u'--enabled': {u'attr': {},
                                                                                         u'category': u'',
                                                                                         u'choices': [],
                                                                                         u'completer': u'',
                                                                                         u'default': False,
                                                                                         u'description': u'(DEFAULT) Return the services which the project has enabled. Or use one of --produced or --available.',
                                                                                         u'group': u'list.1',
                                                                                         u'hidden': False,
                                                                                         u'name': u'--enabled',
                                                                                         u'nargs': u'0',
                                                                                         u'required': False,
                                                                                         u'type': u'bool',
                                                                                         u'value': u'ENABLED'},
                                                                          u'--filter': {u'attr': {},
                                                                                        u'category': u'LIST COMMAND',
                                                                                        u'choices': [],
                                                                                        u'completer': u'',
                                                                                        u'default': None,
                                                                                        u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                        u'group': u'',
                                                                                        u'hidden': False,
                                                                                        u'name': u'--filter',
                                                                                        u'nargs': u'0',
                                                                                        u'required': False,
                                                                                        u'type': u'string',
                                                                                        u'value': u'EXPRESSION'},
                                                                          u'--limit': {u'attr': {},
                                                                                       u'category': u'LIST COMMAND',
                                                                                       u'choices': [],
                                                                                       u'completer': u'',
                                                                                       u'default': None,
                                                                                       u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                       u'group': u'',
                                                                                       u'hidden': False,
                                                                                       u'name': u'--limit',
                                                                                       u'nargs': u'0',
                                                                                       u'required': False,
                                                                                       u'type': u'string',
                                                                                       u'value': u'LIMIT'},
                                                                          u'--page-size': {u'attr': {},
                                                                                           u'category': u'LIST COMMAND',
                                                                                           u'choices': [],
                                                                                           u'completer': u'',
                                                                                           u'default': None,
                                                                                           u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                           u'group': u'',
                                                                                           u'hidden': False,
                                                                                           u'name': u'--page-size',
                                                                                           u'nargs': u'0',
                                                                                           u'required': False,
                                                                                           u'type': u'string',
                                                                                           u'value': u'PAGE_SIZE'},
                                                                          u'--produced': {u'attr': {},
                                                                                          u'category': u'',
                                                                                          u'choices': [],
                                                                                          u'completer': u'',
                                                                                          u'default': False,
                                                                                          u'description': u'Return the services that the project has produced. Or use one of --enabled or --available.',
                                                                                          u'group': u'list.1',
                                                                                          u'hidden': False,
                                                                                          u'name': u'--produced',
                                                                                          u'nargs': u'0',
                                                                                          u'required': False,
                                                                                          u'type': u'bool',
                                                                                          u'value': u'PRODUCED'},
                                                                          u'--sort-by': {u'attr': {},
                                                                                         u'category': u'LIST COMMAND',
                                                                                         u'choices': [],
                                                                                         u'completer': u'',
                                                                                         u'default': None,
                                                                                         u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                         u'group': u'',
                                                                                         u'hidden': False,
                                                                                         u'name': u'--sort-by',
                                                                                         u'nargs': u'0',
                                                                                         u'required': False,
                                                                                         u'type': u'list',
                                                                                         u'value': u'FIELD'}},
                                                               u'group': False,
                                                               u'groups': {u'list.1': {u'description': u'At most one of these may be specified:',
                                                                                       u'is_mutex': True,
                                                                                       u'is_required': False}},
                                                               u'hidden': False,
                                                               u'name': u'list',
                                                               u'path': [u'gcloud',
                                                                         u'service-management',
                                                                         u'list'],
                                                               u'positionals': [],
                                                               u'release': u'GA',
                                                               u'sections': {u'DESCRIPTION': u'This command lists the services that are produced, enabled, or\navailable to be enabled by a project. You can choose the mode in\nwhich the command will list services by using exactly one of the\n`--produced`, `--enabled`, or `--available` flags.\n`--produced` is the default.\n',
                                                                             u'EXAMPLES': u'To list the services the current project produces, run:\n\n  $ list --produced\n\nTo list the services the current project has enabled for consumption,\nrun:\n\n  $ list --enabled\n\nTo list the services the current project can enable for consumption,\nrun:\n\n  $ list --available\n'}},
                                                     u'operations': {u'capsule': u'Manage Operation for various services.',
                                                                     u'commands': {u'describe': {u'capsule': u'Describes an operation resource for a given operation name.',
                                                                                                 u'commands': {},
                                                                                                 u'flags': {u'--full': {u'attr': {},
                                                                                                                        u'category': u'',
                                                                                                                        u'choices': [],
                                                                                                                        u'completer': u'',
                                                                                                                        u'default': False,
                                                                                                                        u'description': u'Print the entire operation resource, which could be large. By default, a summary will be printed instead.',
                                                                                                                        u'group': u'',
                                                                                                                        u'hidden': False,
                                                                                                                        u'name': u'--full',
                                                                                                                        u'nargs': u'0',
                                                                                                                        u'required': False,
                                                                                                                        u'type': u'bool',
                                                                                                                        u'value': u'FULL'},
                                                                                                            u'--no-full': {u'attr': {},
                                                                                                                           u'category': u'',
                                                                                                                           u'choices': [],
                                                                                                                           u'completer': u'',
                                                                                                                           u'default': False,
                                                                                                                           u'description': u'',
                                                                                                                           u'group': u'',
                                                                                                                           u'hidden': True,
                                                                                                                           u'name': u'--no-full',
                                                                                                                           u'nargs': u'0',
                                                                                                                           u'required': False,
                                                                                                                           u'type': u'bool',
                                                                                                                           u'value': u'NO_FULL'}},
                                                                                                 u'group': False,
                                                                                                 u'groups': {},
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'describe',
                                                                                                 u'path': [u'gcloud',
                                                                                                           u'service-management',
                                                                                                           u'operations',
                                                                                                           u'describe'],
                                                                                                 u'positionals': [{u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The name of the operation to describe.',
                                                                                                                   u'name': u'operation',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'value': u'OPERATION'}],
                                                                                                 u'release': u'GA',
                                                                                                 u'sections': {u'DESCRIPTION': u'This command will return information about an operation given the name\nof that operation.\n\nThe amount of information inside an operation can be very large, so by\ndefault, only a summary is returned. If you want the entire operation\nresource, you can include the `--full` flag.\n\nNote that the `operations/` prefix of the operation name is optional\nand may be omitted.\n',
                                                                                                               u'EXAMPLES': u'To describe an operation resource named\n`operations/serviceConfigs.my-service.1`, run:\n\n  $ describe serviceConfigs.my-service.1\n\nTo get the full operation resource, run:\n\n  $ describe serviceConfigs.my-service.1 --full\n'}},
                                                                                   u'wait': {u'capsule': u'Waits for an operation to complete.',
                                                                                             u'commands': {},
                                                                                             u'flags': {},
                                                                                             u'group': False,
                                                                                             u'groups': {},
                                                                                             u'hidden': False,
                                                                                             u'name': u'wait',
                                                                                             u'path': [u'gcloud',
                                                                                                       u'service-management',
                                                                                                       u'operations',
                                                                                                       u'wait'],
                                                                                             u'positionals': [{u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The name of the operation on which to wait.',
                                                                                                               u'name': u'operation',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'value': u'OPERATION'}],
                                                                                             u'release': u'GA',
                                                                                             u'sections': {u'DESCRIPTION': u'This command will block until an operation has been marked as complete.\n\nNote that the `operations/` prefix of the operation name is optional\nand may be omitted.\n',
                                                                                                           u'EXAMPLES': u'To wait on an operation named `operations/serviceConfigs.my-service.1`\nto complete, run:\n\n  $ wait serviceConfigs.my-service.1\n'}}},
                                                                     u'flags': {},
                                                                     u'group': True,
                                                                     u'groups': {},
                                                                     u'hidden': False,
                                                                     u'name': u'operations',
                                                                     u'path': [u'gcloud',
                                                                               u'service-management',
                                                                               u'operations'],
                                                                     u'positionals': [],
                                                                     u'release': u'GA',
                                                                     u'sections': {u'DESCRIPTION': u'Manage Operation for various services.'}},
                                                     u'remove-iam-policy-binding': {u'capsule': u'Remove IAM policy binding for a service.',
                                                                                    u'commands': {},
                                                                                    u'flags': {u'--member': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The member to remove from the binding.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--member',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': True,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'MEMBER'},
                                                                                               u'--role': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'The role to remove the member from.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--role',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': True,
                                                                                                           u'type': u'string',
                                                                                                           u'value': u'ROLE'}},
                                                                                    u'group': False,
                                                                                    u'groups': {},
                                                                                    u'hidden': False,
                                                                                    u'name': u'remove-iam-policy-binding',
                                                                                    u'path': [u'gcloud',
                                                                                              u'service-management',
                                                                                              u'remove-iam-policy-binding'],
                                                                                    u'positionals': [{u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The name of the service from which the member is to be removed.',
                                                                                                      u'name': u'service',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'value': u'SERVICE'}],
                                                                                    u'release': u'GA',
                                                                                    u'sections': {u'DESCRIPTION': u"Removes an IAM policy binding from a service's access policy.",
                                                                                                  u'EXAMPLES': u"The following command will remove a IAM policy binding for the role\nof 'roles/servicemanagement.serviceConsumer' for the user 'test-user@gmail.com' on service with\nidentifier 'my-service'\n\n  $ remove-iam-policy-binding my-service --member='user:test-user@gmail.com' --role='roles/servicemanagement.serviceConsumer'\n\nSee https://cloud.google.com/iam/docs/managing-policies for details\nof policy role and member types.\n"}},
                                                     u'undelete': {u'capsule': u'Undeletes a service given a service name.',
                                                                   u'commands': {},
                                                                   u'flags': {u'--async': {u'attr': {},
                                                                                           u'category': u'',
                                                                                           u'choices': [],
                                                                                           u'completer': u'',
                                                                                           u'default': False,
                                                                                           u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                           u'group': u'',
                                                                                           u'hidden': False,
                                                                                           u'name': u'--async',
                                                                                           u'nargs': u'0',
                                                                                           u'required': False,
                                                                                           u'type': u'bool',
                                                                                           u'value': u'ASYNC'},
                                                                              u'--no-async': {u'attr': {},
                                                                                              u'category': u'',
                                                                                              u'choices': [],
                                                                                              u'completer': u'',
                                                                                              u'default': True,
                                                                                              u'description': u'',
                                                                                              u'group': u'',
                                                                                              u'hidden': True,
                                                                                              u'name': u'--no-async',
                                                                                              u'nargs': u'0',
                                                                                              u'required': False,
                                                                                              u'type': u'bool',
                                                                                              u'value': u'NO_ASYNC'}},
                                                                   u'group': False,
                                                                   u'groups': {},
                                                                   u'hidden': False,
                                                                   u'name': u'undelete',
                                                                   u'path': [u'gcloud',
                                                                             u'service-management',
                                                                             u'undelete'],
                                                                   u'positionals': [{u'completer': u'',
                                                                                     u'default': None,
                                                                                     u'description': u'The name of the service to undelete.',
                                                                                     u'name': u'service',
                                                                                     u'nargs': u'0',
                                                                                     u'required': False,
                                                                                     u'value': u'SERVICE'}],
                                                                   u'release': u'GA',
                                                                   u'sections': {u'DESCRIPTION': u'Undeletes a service configuration that was previously deleted.\n\nServices that are deleted will be retained in the system for 30 days.\nIf a deleted service is still within this retention window, it can be\nundeleted with this command.\n\nNote that this means that this command will not be effective for\nservice configurations marked for deletion more than 30 days ago.\n',
                                                                                 u'EXAMPLES': u'To undelete a service named `my-service`, run:\n\n  $ undelete my-service\n\nTo run the same command asynchronously (non-blocking), run:\n\n  $ undelete my-service --async\n'}}},
                                       u'flags': {},
                                       u'group': True,
                                       u'groups': {},
                                       u'hidden': False,
                                       u'name': u'service-management',
                                       u'path': [u'gcloud',
                                                 u'service-management'],
                                       u'positionals': [],
                                       u'release': u'GA',
                                       u'sections': {u'DESCRIPTION': u"Google Service Management is an infrastructure service of Google Cloud\nPlatform that manages other APIs and services, including Google's own Cloud\nPlatform services and their APIs, and services created using Google Cloud\nEndpoints.\n\nMore information on Service Management can be found here:\nhttps://cloud.google.com/service-management and detailed documentation can be\nfound here: https://cloud.google.com/service-management/docs/"}},
               u'source': {u'capsule': u'Cloud git repository commands.',
                           u'commands': {u'repos': {u'capsule': u'Repos command group.',
                                                    u'commands': {u'clone': {u'capsule': u'Clone project git repository in the current directory.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--dry-run': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u'If provided, prints the command that would be run to standard out instead of executing it.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--dry-run',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'DRY_RUN'},
                                                                                        u'--no-dry-run': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-dry-run',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_DRY_RUN'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'clone',
                                                                             u'path': [u'gcloud',
                                                                                       u'source',
                                                                                       u'repos',
                                                                                       u'clone'],
                                                                             u'positionals': [{u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'Name of the repository. Note: Google Cloud Platform projects generally have (if created) a repository named "default"',
                                                                                               u'name': u'src',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'value': u'REPOSITORY_NAME'},
                                                                                              {u'completer': u'',
                                                                                               u'default': None,
                                                                                               u'description': u'Directory name for the cloned repo. Defaults to the repository name.',
                                                                                               u'name': u'dst',
                                                                                               u'nargs': u'?',
                                                                                               u'required': False,
                                                                                               u'value': u'DIRECTORY_NAME'}],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'This command clones git repository for the currently active\nGoogle Cloud Platform project into the specified folder in the\ncurrent directory.\n',
                                                                                           u'EXAMPLES': u"To use the default Google Cloud repository for development, use the\nfollowing commands. We recommend that you use your project name as\nTARGET_DIR to make it apparent which directory is used for which\nproject. We also recommend to clone the repository named 'default'\nsince it is automatically created for each project, and its\ncontents can be browsed and edited in the Developers Console.\n\n  $ gcloud init\n  $ gcloud source repos clone default TARGET_DIR\n  $ cd TARGET_DIR\n  ... create/edit files and create one or more commits ...\n  $ git push origin master\n"}}},
                                                    u'flags': {},
                                                    u'group': True,
                                                    u'groups': {},
                                                    u'hidden': False,
                                                    u'name': u'repos',
                                                    u'path': [u'gcloud',
                                                              u'source',
                                                              u'repos'],
                                                    u'positionals': [],
                                                    u'release': u'GA',
                                                    u'sections': {u'DESCRIPTION': u'Repos command group.'}}},
                           u'flags': {},
                           u'group': True,
                           u'groups': {},
                           u'hidden': False,
                           u'name': u'source',
                           u'path': [u'gcloud', u'source'],
                           u'positionals': [],
                           u'release': u'GA',
                           u'sections': {u'DESCRIPTION': u'The source group lets you manipulate git repositories within a Google\nCloud project.'}},
               u'sql': {u'capsule': u'Manage Cloud SQL databases.',
                        u'commands': {u'backups': {u'capsule': u'Provide commands for working with backups of Cloud SQL instances.',
                                                   u'commands': {u'describe': {u'capsule': u'Retrieves information about a backup.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--instance': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Cloud SQL instance ID.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--instance',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': True,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'INSTANCE'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'describe',
                                                                               u'path': [u'gcloud',
                                                                                         u'sql',
                                                                                         u'backups',
                                                                                         u'describe'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The time when this run is due to start in RFC 3339 format, for example 2012-11-15T16:19:00.094Z.',
                                                                                                 u'name': u'due-time',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'DUE_TIME'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Retrieves information about a backup.'}},
                                                                 u'list': {u'capsule': u'Lists all backups associated with a given instance.',
                                                                           u'commands': {},
                                                                           u'flags': {u'--filter': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--filter',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'string',
                                                                                                    u'value': u'EXPRESSION'},
                                                                                      u'--instance': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Cloud SQL instance ID.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--instance',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': True,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'INSTANCE'},
                                                                                      u'--limit': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--limit',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'string',
                                                                                                   u'value': u'LIMIT'},
                                                                                      u'--no-uri': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': True,
                                                                                                    u'description': u'',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': True,
                                                                                                    u'name': u'--no-uri',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'NO_URI'},
                                                                                      u'--page-size': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--page-size',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'PAGE_SIZE'},
                                                                                      u'--sort-by': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--sort-by',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'list',
                                                                                                     u'value': u'FIELD'},
                                                                                      u'--uri': {u'attr': {},
                                                                                                 u'category': u'LIST COMMAND',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': False,
                                                                                                 u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'--uri',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'type': u'bool',
                                                                                                 u'value': u'URI'}},
                                                                           u'group': False,
                                                                           u'groups': {},
                                                                           u'hidden': False,
                                                                           u'name': u'list',
                                                                           u'path': [u'gcloud',
                                                                                     u'sql',
                                                                                     u'backups',
                                                                                     u'list'],
                                                                           u'positionals': [],
                                                                           u'release': u'GA',
                                                                           u'sections': {u'DESCRIPTION': u'Lists all backups associated with a given Cloud SQL instance and\nconfiguration in the reverse chronological order of the enqueued time.'}}},
                                                   u'flags': {},
                                                   u'group': True,
                                                   u'groups': {},
                                                   u'hidden': False,
                                                   u'name': u'backups',
                                                   u'path': [u'gcloud',
                                                             u'sql',
                                                             u'backups'],
                                                   u'positionals': [],
                                                   u'release': u'GA',
                                                   u'sections': {u'DESCRIPTION': u'Provide commands for working with backups of Cloud SQL instances\nincluding listing and getting information about backups for a Cloud SQL\ninstance.'}},
                                      u'flags': {u'capsule': u'Provide a command to list flags.',
                                                 u'commands': {u'list': {u'capsule': u'List customizable flags for Google Cloud SQL instances.',
                                                                         u'commands': {},
                                                                         u'flags': {u'--filter': {u'attr': {},
                                                                                                  u'category': u'LIST COMMAND',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': False,
                                                                                                  u'name': u'--filter',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'string',
                                                                                                  u'value': u'EXPRESSION'},
                                                                                    u'--limit': {u'attr': {},
                                                                                                 u'category': u'LIST COMMAND',
                                                                                                 u'choices': [],
                                                                                                 u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                 u'group': u'',
                                                                                                 u'hidden': False,
                                                                                                 u'name': u'--limit',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'type': u'string',
                                                                                                 u'value': u'LIMIT'},
                                                                                    u'--no-uri': {u'attr': {},
                                                                                                  u'category': u'LIST COMMAND',
                                                                                                  u'choices': [],
                                                                                                  u'completer': u'',
                                                                                                  u'default': True,
                                                                                                  u'description': u'',
                                                                                                  u'group': u'',
                                                                                                  u'hidden': True,
                                                                                                  u'name': u'--no-uri',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'type': u'bool',
                                                                                                  u'value': u'NO_URI'},
                                                                                    u'--page-size': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--page-size',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'PAGE_SIZE'},
                                                                                    u'--sort-by': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--sort-by',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'list',
                                                                                                   u'value': u'FIELD'},
                                                                                    u'--uri': {u'attr': {},
                                                                                               u'category': u'LIST COMMAND',
                                                                                               u'choices': [],
                                                                                               u'completer': u'',
                                                                                               u'default': False,
                                                                                               u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                               u'group': u'',
                                                                                               u'hidden': False,
                                                                                               u'name': u'--uri',
                                                                                               u'nargs': u'0',
                                                                                               u'required': False,
                                                                                               u'type': u'bool',
                                                                                               u'value': u'URI'}},
                                                                         u'group': False,
                                                                         u'groups': {},
                                                                         u'hidden': False,
                                                                         u'name': u'list',
                                                                         u'path': [u'gcloud',
                                                                                   u'sql',
                                                                                   u'flags',
                                                                                   u'list'],
                                                                         u'positionals': [],
                                                                         u'release': u'GA',
                                                                         u'sections': {u'DESCRIPTION': u'List customizable flags for Google Cloud SQL instances.'}}},
                                                 u'flags': {},
                                                 u'group': True,
                                                 u'groups': {},
                                                 u'hidden': False,
                                                 u'name': u'flags',
                                                 u'path': [u'gcloud',
                                                           u'sql',
                                                           u'flags'],
                                                 u'positionals': [],
                                                 u'release': u'GA',
                                                 u'sections': {u'DESCRIPTION': u'Provide a command to list flags.'}},
                                      u'instances': {u'capsule': u'Provide commands for managing Cloud SQL instances.',
                                                     u'commands': {u'clone': {u'capsule': u'Clones a Cloud SQL instance.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--async': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': False,
                                                                                                      u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--async',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'ASYNC'},
                                                                                         u'--bin-log-file-name': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'Represents the name of the binary log file created by the source\ninstance if it has binary logs enabled.\nIf specified, is the point up to which the source instance is cloned.\nIt must be specified along with --bin-log-position to form a valid\nbinary log coordinates.\ne.g., mysql-bin.000001',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--bin-log-file-name',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'BIN_LOG_FILE_NAME'},
                                                                                         u'--bin-log-position': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': None,
                                                                                                                 u'description': u'Represents the position (offset) inside the binary log file created by\nthe source instance if it has binary logs enabled.\nIf specified, is the point up to which the source instance is cloned.\nIt must be specified along with --bin-log-file to form a valid binary\nlog coordinates.\ne.g., 123 (a numeric value)',
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--bin-log-position',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'string',
                                                                                                                 u'value': u'BIN_LOG_POSITION'},
                                                                                         u'--no-async': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': True,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--no-async',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'NO_ASYNC'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'clone',
                                                                              u'path': [u'gcloud',
                                                                                        u'sql',
                                                                                        u'instances',
                                                                                        u'clone'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'Cloud SQL instance ID of the source.',
                                                                                                u'name': u'source',
                                                                                                u'nargs': u'0',
                                                                                                u'required': False,
                                                                                                u'value': u'SOURCE'},
                                                                                               {u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'Cloud SQL instance ID of the clone.',
                                                                                                u'name': u'destination',
                                                                                                u'nargs': u'0',
                                                                                                u'required': False,
                                                                                                u'value': u'DESTINATION'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'*clone* creates a clone of the Cloud SQL instance. The source and the\ndestination instances must be in the same project. The clone once created\nwill be an independent Cloud SQL instance.\n\nThe binary log coordinates, if specified, act as the point up to which the\nsource instance is cloned. If not specified, the source instance is\ncloned up to the most recent binary log coordinates at the time the command is\nexecuted.\n\n## EXAMPLES\n\nTo clone a source instance to the most recent binary log coordinates:\n\n  $ clone instance-foo instance-bar\n\nor to clone at specific binary log coordinates:\n\n  $ clone instance-foo instance-bar --bin-log-file-name mysql-bin.000020 --bin-log-position 170'}},
                                                                   u'create': {u'capsule': u'Creates a new Cloud SQL instance.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--activation-policy': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [u'ALWAYS',
                                                                                                                                u'NEVER',
                                                                                                                                u'ON_DEMAND'],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The activation policy for this instance. This specifies when the instance should be activated and is applicable only when the instance state is RUNNABLE. More information on activation policies can be found here: https://cloud.google.com/sql/faq#activation_policy. _ACTIVATION_POLICY_ must be one of: *ALWAYS*, *NEVER*, *ON_DEMAND*.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--activation-policy',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'ACTIVATION_POLICY'},
                                                                                          u'--assign-ip': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': False,
                                                                                                           u'description': u'Specified if the instance must be assigned an IP address.',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': False,
                                                                                                           u'name': u'--assign-ip',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'ASSIGN_IP'},
                                                                                          u'--async': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--async',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'ASYNC'},
                                                                                          u'--authorized-gae-apps': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': [],
                                                                                                                     u'description': u'List of App Engine app IDs that can access this instance.',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--authorized-gae-apps',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'list',
                                                                                                                     u'value': u'APP'},
                                                                                          u'--authorized-networks': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': [],
                                                                                                                     u'description': u"The list of external networks that are allowed to connect to the instance. Specified in CIDR notation, also known as 'slash' notation (e.g. 192.168.100.0/24).",
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--authorized-networks',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'list',
                                                                                                                     u'value': u'NETWORK'},
                                                                                          u'--backup': {u'attr': {u'inverted_synopsis': True},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'Enables daily backup. Enabled by default, use *--no-backup* to disable.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--backup',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'BACKUP'},
                                                                                          u'--backup-start-time': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': None,
                                                                                                                   u'description': u'The start time of daily backups, specified in the 24 hour format - HH:MM, in the UTC timezone.',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': False,
                                                                                                                   u'name': u'--backup-start-time',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'string',
                                                                                                                   u'value': u'BACKUP_START_TIME'},
                                                                                          u'--database-flags': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'A comma-separated list of database flags to set on the instance. Use an equals sign to separate flag name and value. Flags without values, like skip_grant_tables, can be written out without a value after, e.g., `skip_grant_tables=`. Use on/off for booleans. View the Instance Resource API for allowed flags. (e.g., `--database-flags max_allowed_packet=55555,skip_grant_tables=,log_output=1`)',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--database-flags',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'dict',
                                                                                                                u'value': u'FLAG=VALUE'},
                                                                                          u'--database-version': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': u'MYSQL_5_6',
                                                                                                                  u'description': u'The database engine type and version. Can be MYSQL_5_5, MYSQL_5_6, or MYSQL_5_7.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--database-version',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'DATABASE_VERSION'},
                                                                                          u'--enable-bin-log': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'Specified if binary log should be enabled. If backup configuration is disabled, binary log must be disabled as well.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--enable-bin-log',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'ENABLE_BIN_LOG'},
                                                                                          u'--follow-gae-app': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': None,
                                                                                                                u'description': u'The App Engine app this instance should follow. It must be in the same region as the instance.',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--follow-gae-app',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'string',
                                                                                                                u'value': u'FOLLOW_GAE_APP'},
                                                                                          u'--gce-zone': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The preferred Compute Engine zone (e.g. us-central1-a, us-central1-b, etc.).',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--gce-zone',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'GCE_ZONE'},
                                                                                          u'--master-instance-name': {u'attr': {},
                                                                                                                      u'category': u'',
                                                                                                                      u'choices': [],
                                                                                                                      u'completer': u'',
                                                                                                                      u'default': None,
                                                                                                                      u'description': u'Name of the instance which will act as master in the replication setup. The newly created instance will be a read replica of the specified master instance.',
                                                                                                                      u'group': u'',
                                                                                                                      u'hidden': False,
                                                                                                                      u'name': u'--master-instance-name',
                                                                                                                      u'nargs': u'0',
                                                                                                                      u'required': False,
                                                                                                                      u'type': u'string',
                                                                                                                      u'value': u'MASTER_INSTANCE_NAME'},
                                                                                          u'--no-assign-ip': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [],
                                                                                                              u'completer': u'',
                                                                                                              u'default': False,
                                                                                                              u'description': u'',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': True,
                                                                                                              u'name': u'--no-assign-ip',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'bool',
                                                                                                              u'value': u'NO_ASSIGN_IP'},
                                                                                          u'--no-async': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-async',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_ASYNC'},
                                                                                          u'--no-backup': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': True,
                                                                                                           u'description': u'',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': True,
                                                                                                           u'name': u'--no-backup',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'NO_BACKUP'},
                                                                                          u'--no-enable-bin-log': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': False,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--no-enable-bin-log',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'NO_ENABLE_BIN_LOG'},
                                                                                          u'--no-require-ssl': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u'',
                                                                                                                u'group': u'',
                                                                                                                u'hidden': True,
                                                                                                                u'name': u'--no-require-ssl',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'NO_REQUIRE_SSL'},
                                                                                          u'--on-premises-host-port': {u'attr': {},
                                                                                                                       u'category': u'',
                                                                                                                       u'choices': [],
                                                                                                                       u'completer': u'',
                                                                                                                       u'default': None,
                                                                                                                       u'description': u'',
                                                                                                                       u'group': u'',
                                                                                                                       u'hidden': True,
                                                                                                                       u'name': u'--on-premises-host-port',
                                                                                                                       u'nargs': u'0',
                                                                                                                       u'required': False,
                                                                                                                       u'type': u'string',
                                                                                                                       u'value': u'ON_PREMISES_HOST_PORT'},
                                                                                          u'--pricing-plan': {u'attr': {},
                                                                                                              u'category': u'',
                                                                                                              u'choices': [u'PER_USE',
                                                                                                                           u'PACKAGE'],
                                                                                                              u'completer': u'',
                                                                                                              u'default': u'PER_USE',
                                                                                                              u'description': u'The pricing plan for this instance. _PRICING_PLAN_ must be one of: *PER_USE*, *PACKAGE*.',
                                                                                                              u'group': u'',
                                                                                                              u'hidden': False,
                                                                                                              u'name': u'--pricing-plan',
                                                                                                              u'nargs': u'0',
                                                                                                              u'required': False,
                                                                                                              u'type': u'string',
                                                                                                              u'value': u'PRICING_PLAN'},
                                                                                          u'--region': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': u'us-central',
                                                                                                        u'description': u'The regional location (e.g. asia-east1, us-east1). See the full list of regions at https://cloud.google.com/sql/docs/instance-locations.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--region',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'REGION'},
                                                                                          u'--replication': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [u'SYNCHRONOUS',
                                                                                                                          u'ASYNCHRONOUS'],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The type of replication this instance uses. _REPLICATION_ must be one of: *SYNCHRONOUS*, *ASYNCHRONOUS*.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--replication',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'REPLICATION'},
                                                                                          u'--require-ssl': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': False,
                                                                                                             u'description': u'Specified if users connecting over IP must use SSL.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--require-ssl',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'REQUIRE_SSL'},
                                                                                          u'--tier': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The tier for first generation Cloud SQL instances, for example  D0, D1, D2. A complete list of tiers is available here: https://cloud.google.com/sql/pricing#packages',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--tier',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'TIER'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'create',
                                                                               u'path': [u'gcloud',
                                                                                         u'sql',
                                                                                         u'instances',
                                                                                         u'create'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Cloud SQL instance ID.',
                                                                                                 u'name': u'instance',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'INSTANCE'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Creates a new Cloud SQL instance.'}},
                                                                   u'delete': {u'capsule': u'Deletes a Cloud SQL instance.',
                                                                               u'commands': {},
                                                                               u'flags': {},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'delete',
                                                                               u'path': [u'gcloud',
                                                                                         u'sql',
                                                                                         u'instances',
                                                                                         u'delete'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Cloud SQL instance ID.',
                                                                                                 u'name': u'instance',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'INSTANCE'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Deletes a Cloud SQL instance.'}},
                                                                   u'describe': {u'capsule': u'Displays configuration and metadata about a Cloud SQL instance.',
                                                                                 u'commands': {},
                                                                                 u'flags': {},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'describe',
                                                                                 u'path': [u'gcloud',
                                                                                           u'sql',
                                                                                           u'instances',
                                                                                           u'describe'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'Cloud SQL instance ID.',
                                                                                                   u'name': u'instance',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'INSTANCE'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'Displays configuration and metadata about a Cloud SQL instance.\n\nInformation such as instance name, IP address, region, the CA certificate\nand configuration settings will be displayed.'}},
                                                                   u'export': {u'capsule': u'Exports data from a Cloud SQL instance.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--async': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--async',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'ASYNC'},
                                                                                          u'--database': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Database (for example, guestbook) from which the export is made. If unspecified, all databases are exported.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--database',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'list',
                                                                                                          u'value': u'DATABASE'},
                                                                                          u'--no-async': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-async',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_ASYNC'},
                                                                                          u'--table': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Tables to export from the specified database. If you specify tables, specify one and only one database.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--table',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'TABLE'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'export',
                                                                               u'path': [u'gcloud',
                                                                                         u'sql',
                                                                                         u'instances',
                                                                                         u'export'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Cloud SQL instance ID.',
                                                                                                 u'name': u'instance',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'INSTANCE'},
                                                                                                {u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'The path to the file in Google Cloud Storage where the export will be stored. The URI is in the form gs://bucketName/fileName. If the file already exists, the operation fails. If the filename ends with .gz, the contents are compressed.',
                                                                                                 u'name': u'uri',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'URI'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Exports data from a Cloud SQL instance to a Google Cloud Storage\nbucket as a MySQL dump file.'}},
                                                                   u'import': {u'capsule': u'Imports data into a Cloud SQL instance from Google Cloud Storage.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--async': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--async',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'ASYNC'},
                                                                                          u'--database': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'The database (for example, guestbook) to which the import is made. If not set, it is assumed that the database is specified in the file to be imported.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--database',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'DATABASE'},
                                                                                          u'--no-async': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-async',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_ASYNC'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'import',
                                                                               u'path': [u'gcloud',
                                                                                         u'sql',
                                                                                         u'instances',
                                                                                         u'import'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Cloud SQL instance ID.',
                                                                                                 u'name': u'instance',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'INSTANCE'},
                                                                                                {u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Path to the MySQL dump file in Google Cloud Storage from which the import is made. The URI is in the form gs://bucketName/fileName. Compressed gzip files (.gz) are also supported.',
                                                                                                 u'name': u'uri',
                                                                                                 u'nargs': u'+',
                                                                                                 u'required': False,
                                                                                                 u'value': u'URI'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Imports data into a Cloud SQL instance from Google Cloud Storage.'}},
                                                                   u'list': {u'capsule': u'Lists Cloud SQL instances in a given project.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--filter',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'EXPRESSION'},
                                                                                        u'--limit': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--limit',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'LIMIT'},
                                                                                        u'--no-uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': True,
                                                                                                      u'description': u'',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': True,
                                                                                                      u'name': u'--no-uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'NO_URI'},
                                                                                        u'--page-size': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--page-size',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                        u'--sort-by': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--sort-by',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'FIELD'},
                                                                                        u'--uri': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': False,
                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--uri',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'URI'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'list',
                                                                             u'path': [u'gcloud',
                                                                                       u'sql',
                                                                                       u'instances',
                                                                                       u'list'],
                                                                             u'positionals': [],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'Lists Cloud SQL instances in a given project in the alphabetical\norder of the instance name.'}},
                                                                   u'patch': {u'capsule': u'Updates the settings of a Cloud SQL instance.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--activation-policy': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [u'ALWAYS',
                                                                                                                               u'NEVER',
                                                                                                                               u'ON_DEMAND'],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The activation policy for this instance. This specifies when the instance should be activated and is applicable only when the instance state is RUNNABLE. _ACTIVATION_POLICY_ must be one of: *ALWAYS*, *NEVER*, *ON_DEMAND*.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--activation-policy',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'ACTIVATION_POLICY'},
                                                                                         u'--assign-ip': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u'The instance must be assigned an IP address.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--assign-ip',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'ASSIGN_IP'},
                                                                                         u'--async': {u'attr': {},
                                                                                                      u'category': u'',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': False,
                                                                                                      u'description': u'Do not wait for the operation to complete.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--async',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'ASYNC'},
                                                                                         u'--authorized-gae-apps': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u'A list of App Engine app IDs that can access this instance.',
                                                                                                                    u'group': u'patch.1',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--authorized-gae-apps',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'list',
                                                                                                                    u'value': u'APP'},
                                                                                         u'--authorized-networks': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': None,
                                                                                                                    u'description': u"The list of external networks that are allowed to connect to the instance. Specified in CIDR notation, also known as 'slash' notation (e.g. 192.168.100.0/24).",
                                                                                                                    u'group': u'patch.2',
                                                                                                                    u'hidden': False,
                                                                                                                    u'name': u'--authorized-networks',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'list',
                                                                                                                    u'value': u'NETWORK'},
                                                                                         u'--backup-start-time': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The start time of daily backups, specified in the 24 hour format - HH:MM, in the UTC timezone.',
                                                                                                                  u'group': u'patch.3',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--backup-start-time',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'BACKUP_START_TIME'},
                                                                                         u'--clear-authorized-networks': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': False,
                                                                                                                          u'description': u'Clear the list of external networks that are allowed to connect to the instance.',
                                                                                                                          u'group': u'patch.2',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--clear-authorized-networks',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'bool',
                                                                                                                          u'value': u'CLEAR_AUTHORIZED_NETWORKS'},
                                                                                         u'--clear-database-flags': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': False,
                                                                                                                     u'description': u'Clear the database flags set on the instance. WARNING: Instance will be restarted.',
                                                                                                                     u'group': u'patch.4',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--clear-database-flags',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'CLEAR_DATABASE_FLAGS'},
                                                                                         u'--clear-gae-apps': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'Specified to clear the list of App Engine apps that can access this instance.',
                                                                                                               u'group': u'patch.1',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--clear-gae-apps',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'CLEAR_GAE_APPS'},
                                                                                         u'--database-flags': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'A comma-separated list of database flags to set on the instance. Use an equals sign to separate flag name and value. Flags without values, like skip_grant_tables, can be written out without a value after, e.g., `skip_grant_tables=`. Use on/off for booleans. View the Instance Resource API for allowed flags. (e.g., `--database-flags max_allowed_packet=55555,skip_grant_tables=,log_output=1`)',
                                                                                                               u'group': u'patch.4',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--database-flags',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'dict',
                                                                                                               u'value': u'FLAG=VALUE'},
                                                                                         u'--diff': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': False,
                                                                                                     u'description': u'Show what changed as a result of the update.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--diff',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'bool',
                                                                                                     u'value': u'DIFF'},
                                                                                         u'--enable-bin-log': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'Enable binary log. If backup configuration is disabled, binary log should be disabled as well.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--enable-bin-log',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'ENABLE_BIN_LOG'},
                                                                                         u'--enable-database-replication': {u'attr': {},
                                                                                                                            u'category': u'',
                                                                                                                            u'choices': [],
                                                                                                                            u'completer': u'',
                                                                                                                            u'default': False,
                                                                                                                            u'description': u'Enable database replication. Applicable only for read replica instance(s). WARNING: Instance will be restarted.',
                                                                                                                            u'group': u'',
                                                                                                                            u'hidden': False,
                                                                                                                            u'name': u'--enable-database-replication',
                                                                                                                            u'nargs': u'0',
                                                                                                                            u'required': False,
                                                                                                                            u'type': u'bool',
                                                                                                                            u'value': u'ENABLE_DATABASE_REPLICATION'},
                                                                                         u'--follow-gae-app': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': None,
                                                                                                               u'description': u'The App Engine app this instance should follow. It must be in the same region as the instance. WARNING: Instance may be restarted.',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--follow-gae-app',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'string',
                                                                                                               u'value': u'FOLLOW_GAE_APP'},
                                                                                         u'--gce-zone': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'The preferred Compute Engine zone (e.g. us-central1-a, us-central1-b, etc.). WARNING: Instance may be restarted.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--gce-zone',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'GCE_ZONE'},
                                                                                         u'--no-assign-ip': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': False,
                                                                                                             u'description': u'',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': True,
                                                                                                             u'name': u'--no-assign-ip',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'bool',
                                                                                                             u'value': u'NO_ASSIGN_IP'},
                                                                                         u'--no-async': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': True,
                                                                                                         u'description': u'',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': True,
                                                                                                         u'name': u'--no-async',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'bool',
                                                                                                         u'value': u'NO_ASYNC'},
                                                                                         u'--no-backup': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': False,
                                                                                                          u'description': u'Specified if daily backup should be disabled.',
                                                                                                          u'group': u'patch.3',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--no-backup',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_BACKUP'},
                                                                                         u'--no-diff': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': True,
                                                                                                        u'description': u'',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': True,
                                                                                                        u'name': u'--no-diff',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'NO_DIFF'},
                                                                                         u'--no-enable-bin-log': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u'',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': True,
                                                                                                                  u'name': u'--no-enable-bin-log',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'NO_ENABLE_BIN_LOG'},
                                                                                         u'--no-enable-database-replication': {u'attr': {},
                                                                                                                               u'category': u'',
                                                                                                                               u'choices': [],
                                                                                                                               u'completer': u'',
                                                                                                                               u'default': False,
                                                                                                                               u'description': u'',
                                                                                                                               u'group': u'',
                                                                                                                               u'hidden': True,
                                                                                                                               u'name': u'--no-enable-database-replication',
                                                                                                                               u'nargs': u'0',
                                                                                                                               u'required': False,
                                                                                                                               u'type': u'bool',
                                                                                                                               u'value': u'NO_ENABLE_DATABASE_REPLICATION'},
                                                                                         u'--no-require-ssl': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u'',
                                                                                                               u'group': u'',
                                                                                                               u'hidden': True,
                                                                                                               u'name': u'--no-require-ssl',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'NO_REQUIRE_SSL'},
                                                                                         u'--pricing-plan': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [u'PER_USE',
                                                                                                                          u'PACKAGE'],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'The pricing plan for this instance. _PRICING_PLAN_ must be one of: *PER_USE*, *PACKAGE*.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--pricing-plan',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': False,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'PRICING_PLAN'},
                                                                                         u'--replication': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [u'SYNCHRONOUS',
                                                                                                                         u'ASYNCHRONOUS'],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'The type of replication this instance uses. _REPLICATION_ must be one of: *SYNCHRONOUS*, *ASYNCHRONOUS*.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--replication',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'REPLICATION'},
                                                                                         u'--require-ssl': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': False,
                                                                                                            u'description': u"mysqld should default to 'REQUIRE X509' for users connecting over IP.",
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--require-ssl',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'type': u'bool',
                                                                                                            u'value': u'REQUIRE_SSL'},
                                                                                         u'--tier': {u'attr': {},
                                                                                                     u'category': u'',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The tier of service for this instance, for example D0, D1. WARNING: Instance will be restarted.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--tier',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'TIER'}},
                                                                              u'group': False,
                                                                              u'groups': {u'patch.1': {u'description': u'At most one of these may be specified:',
                                                                                                       u'is_mutex': True,
                                                                                                       u'is_required': False},
                                                                                          u'patch.2': {u'description': u'At most one of these may be specified:',
                                                                                                       u'is_mutex': True,
                                                                                                       u'is_required': False},
                                                                                          u'patch.3': {u'description': u'At most one of these may be specified:',
                                                                                                       u'is_mutex': True,
                                                                                                       u'is_required': False},
                                                                                          u'patch.4': {u'description': u'At most one of these may be specified:',
                                                                                                       u'is_mutex': True,
                                                                                                       u'is_required': False}},
                                                                              u'hidden': False,
                                                                              u'name': u'patch',
                                                                              u'path': [u'gcloud',
                                                                                        u'sql',
                                                                                        u'instances',
                                                                                        u'patch'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'Cloud SQL instance ID.',
                                                                                                u'name': u'instance',
                                                                                                u'nargs': u'0',
                                                                                                u'required': False,
                                                                                                u'value': u'INSTANCE'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'Updates the settings of a Cloud SQL instance.'}},
                                                                   u'promote-replica': {u'capsule': u'Promotes Cloud SQL read replica to a stand-alone instance.',
                                                                                        u'commands': {},
                                                                                        u'flags': {u'--async': {u'attr': {},
                                                                                                                u'category': u'',
                                                                                                                u'choices': [],
                                                                                                                u'completer': u'',
                                                                                                                u'default': False,
                                                                                                                u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                u'group': u'',
                                                                                                                u'hidden': False,
                                                                                                                u'name': u'--async',
                                                                                                                u'nargs': u'0',
                                                                                                                u'required': False,
                                                                                                                u'type': u'bool',
                                                                                                                u'value': u'ASYNC'},
                                                                                                   u'--no-async': {u'attr': {},
                                                                                                                   u'category': u'',
                                                                                                                   u'choices': [],
                                                                                                                   u'completer': u'',
                                                                                                                   u'default': True,
                                                                                                                   u'description': u'',
                                                                                                                   u'group': u'',
                                                                                                                   u'hidden': True,
                                                                                                                   u'name': u'--no-async',
                                                                                                                   u'nargs': u'0',
                                                                                                                   u'required': False,
                                                                                                                   u'type': u'bool',
                                                                                                                   u'value': u'NO_ASYNC'}},
                                                                                        u'group': False,
                                                                                        u'groups': {},
                                                                                        u'hidden': False,
                                                                                        u'name': u'promote-replica',
                                                                                        u'path': [u'gcloud',
                                                                                                  u'sql',
                                                                                                  u'instances',
                                                                                                  u'promote-replica'],
                                                                                        u'positionals': [{u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Cloud SQL read replica ID.',
                                                                                                          u'name': u'replica',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'value': u'REPLICA'}],
                                                                                        u'release': u'GA',
                                                                                        u'sections': {u'DESCRIPTION': u'Promotes Cloud SQL read replica to a stand-alone instance.'}},
                                                                   u'reset-ssl-config': {u'capsule': u'Deletes all client certificates and generates a new server certificate.',
                                                                                         u'commands': {},
                                                                                         u'flags': {u'--async': {u'attr': {},
                                                                                                                 u'category': u'',
                                                                                                                 u'choices': [],
                                                                                                                 u'completer': u'',
                                                                                                                 u'default': False,
                                                                                                                 u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                 u'group': u'',
                                                                                                                 u'hidden': False,
                                                                                                                 u'name': u'--async',
                                                                                                                 u'nargs': u'0',
                                                                                                                 u'required': False,
                                                                                                                 u'type': u'bool',
                                                                                                                 u'value': u'ASYNC'},
                                                                                                    u'--no-async': {u'attr': {},
                                                                                                                    u'category': u'',
                                                                                                                    u'choices': [],
                                                                                                                    u'completer': u'',
                                                                                                                    u'default': True,
                                                                                                                    u'description': u'',
                                                                                                                    u'group': u'',
                                                                                                                    u'hidden': True,
                                                                                                                    u'name': u'--no-async',
                                                                                                                    u'nargs': u'0',
                                                                                                                    u'required': False,
                                                                                                                    u'type': u'bool',
                                                                                                                    u'value': u'NO_ASYNC'}},
                                                                                         u'group': False,
                                                                                         u'groups': {},
                                                                                         u'hidden': False,
                                                                                         u'name': u'reset-ssl-config',
                                                                                         u'path': [u'gcloud',
                                                                                                   u'sql',
                                                                                                   u'instances',
                                                                                                   u'reset-ssl-config'],
                                                                                         u'positionals': [{u'completer': u'',
                                                                                                           u'default': None,
                                                                                                           u'description': u'Cloud SQL instance ID.',
                                                                                                           u'name': u'instance',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'value': u'INSTANCE'}],
                                                                                         u'release': u'GA',
                                                                                         u'sections': {u'DESCRIPTION': u'Deletes all client certificates and generates a new server certificate.'}},
                                                                   u'restart': {u'capsule': u'Restarts a Cloud SQL instance.',
                                                                                u'commands': {},
                                                                                u'flags': {u'--async': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': False,
                                                                                                        u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--async',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'bool',
                                                                                                        u'value': u'ASYNC'},
                                                                                           u'--no-async': {u'attr': {},
                                                                                                           u'category': u'',
                                                                                                           u'choices': [],
                                                                                                           u'completer': u'',
                                                                                                           u'default': True,
                                                                                                           u'description': u'',
                                                                                                           u'group': u'',
                                                                                                           u'hidden': True,
                                                                                                           u'name': u'--no-async',
                                                                                                           u'nargs': u'0',
                                                                                                           u'required': False,
                                                                                                           u'type': u'bool',
                                                                                                           u'value': u'NO_ASYNC'}},
                                                                                u'group': False,
                                                                                u'groups': {},
                                                                                u'hidden': False,
                                                                                u'name': u'restart',
                                                                                u'path': [u'gcloud',
                                                                                          u'sql',
                                                                                          u'instances',
                                                                                          u'restart'],
                                                                                u'positionals': [{u'completer': u'',
                                                                                                  u'default': None,
                                                                                                  u'description': u'Cloud SQL instance ID.',
                                                                                                  u'name': u'instance',
                                                                                                  u'nargs': u'0',
                                                                                                  u'required': False,
                                                                                                  u'value': u'INSTANCE'}],
                                                                                u'release': u'GA',
                                                                                u'sections': {u'DESCRIPTION': u'Restarts a Cloud SQL instance.'}},
                                                                   u'restore-backup': {u'capsule': u'Restores a backup of a Cloud SQL instance.',
                                                                                       u'commands': {},
                                                                                       u'flags': {u'--async': {u'attr': {},
                                                                                                               u'category': u'',
                                                                                                               u'choices': [],
                                                                                                               u'completer': u'',
                                                                                                               u'default': False,
                                                                                                               u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                               u'group': u'',
                                                                                                               u'hidden': False,
                                                                                                               u'name': u'--async',
                                                                                                               u'nargs': u'0',
                                                                                                               u'required': False,
                                                                                                               u'type': u'bool',
                                                                                                               u'value': u'ASYNC'},
                                                                                                  u'--due-time': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': None,
                                                                                                                  u'description': u'The time when this run was due to start in RFC 3339 format, for example 2012-11-15T16:19:00.094Z.',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--due-time',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': True,
                                                                                                                  u'type': u'string',
                                                                                                                  u'value': u'DUE_TIME'},
                                                                                                  u'--no-async': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': True,
                                                                                                                  u'description': u'',
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': True,
                                                                                                                  u'name': u'--no-async',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'NO_ASYNC'}},
                                                                                       u'group': False,
                                                                                       u'groups': {},
                                                                                       u'hidden': False,
                                                                                       u'name': u'restore-backup',
                                                                                       u'path': [u'gcloud',
                                                                                                 u'sql',
                                                                                                 u'instances',
                                                                                                 u'restore-backup'],
                                                                                       u'positionals': [{u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Cloud SQL instance ID.',
                                                                                                         u'name': u'instance',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'value': u'INSTANCE'}],
                                                                                       u'release': u'GA',
                                                                                       u'sections': {u'DESCRIPTION': u'Restores a backup of a Cloud SQL instance.'}},
                                                                   u'set-root-password': {u'capsule': u'Sets the password of the MySQL root user.',
                                                                                          u'commands': {},
                                                                                          u'flags': {u'--async': {u'attr': {},
                                                                                                                  u'category': u'',
                                                                                                                  u'choices': [],
                                                                                                                  u'completer': u'',
                                                                                                                  u'default': False,
                                                                                                                  u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                                  u'group': u'',
                                                                                                                  u'hidden': False,
                                                                                                                  u'name': u'--async',
                                                                                                                  u'nargs': u'0',
                                                                                                                  u'required': False,
                                                                                                                  u'type': u'bool',
                                                                                                                  u'value': u'ASYNC'},
                                                                                                     u'--no-async': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': True,
                                                                                                                     u'description': u'',
                                                                                                                     u'group': u'',
                                                                                                                     u'hidden': True,
                                                                                                                     u'name': u'--no-async',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'bool',
                                                                                                                     u'value': u'NO_ASYNC'},
                                                                                                     u'--password': {u'attr': {},
                                                                                                                     u'category': u'',
                                                                                                                     u'choices': [],
                                                                                                                     u'completer': u'',
                                                                                                                     u'default': None,
                                                                                                                     u'description': u'The password for the root user. WARNING: Setting password using this option can potentially expose the password to other users of this machine. Instead, you can use --password-file to get the password from a file.',
                                                                                                                     u'group': u'set-root-password.1',
                                                                                                                     u'hidden': False,
                                                                                                                     u'name': u'--password',
                                                                                                                     u'nargs': u'0',
                                                                                                                     u'required': False,
                                                                                                                     u'type': u'string',
                                                                                                                     u'value': u'PASSWORD'},
                                                                                                     u'--password-file': {u'attr': {},
                                                                                                                          u'category': u'',
                                                                                                                          u'choices': [],
                                                                                                                          u'completer': u'',
                                                                                                                          u'default': None,
                                                                                                                          u'description': u'The path to the filename which has the password to be set. The first line of the file will be interpreted as the password to be set.',
                                                                                                                          u'group': u'set-root-password.1',
                                                                                                                          u'hidden': False,
                                                                                                                          u'name': u'--password-file',
                                                                                                                          u'nargs': u'0',
                                                                                                                          u'required': False,
                                                                                                                          u'type': u'string',
                                                                                                                          u'value': u'PASSWORD_FILE'}},
                                                                                          u'group': False,
                                                                                          u'groups': {u'set-root-password.1': {u'description': u'Exactly one of these must be specified:',
                                                                                                                               u'is_mutex': True,
                                                                                                                               u'is_required': True}},
                                                                                          u'hidden': False,
                                                                                          u'name': u'set-root-password',
                                                                                          u'path': [u'gcloud',
                                                                                                    u'sql',
                                                                                                    u'instances',
                                                                                                    u'set-root-password'],
                                                                                          u'positionals': [{u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Cloud SQL instance ID.',
                                                                                                            u'name': u'instance',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': False,
                                                                                                            u'value': u'INSTANCE'}],
                                                                                          u'release': u'GA',
                                                                                          u'sections': {u'DESCRIPTION': u'Sets the password of the MySQL root user.'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'instances',
                                                     u'path': [u'gcloud',
                                                               u'sql',
                                                               u'instances'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'Provide commands for managing Cloud SQL instances including creating,\nconfiguring, restarting, and deleting instances.'}},
                                      u'operations': {u'capsule': u'Provide commands for working with Cloud SQL instance operations.',
                                                      u'commands': {u'describe': {u'capsule': u'Retrieves information about a Cloud SQL instance operation.',
                                                                                  u'commands': {},
                                                                                  u'flags': {u'--instance': {u'attr': {},
                                                                                                             u'category': u'',
                                                                                                             u'choices': [],
                                                                                                             u'completer': u'',
                                                                                                             u'default': None,
                                                                                                             u'description': u'Cloud SQL instance ID.',
                                                                                                             u'group': u'',
                                                                                                             u'hidden': False,
                                                                                                             u'name': u'--instance',
                                                                                                             u'nargs': u'0',
                                                                                                             u'required': True,
                                                                                                             u'type': u'string',
                                                                                                             u'value': u'INSTANCE'}},
                                                                                  u'group': False,
                                                                                  u'groups': {},
                                                                                  u'hidden': False,
                                                                                  u'name': u'describe',
                                                                                  u'path': [u'gcloud',
                                                                                            u'sql',
                                                                                            u'operations',
                                                                                            u'describe'],
                                                                                  u'positionals': [{u'completer': u'',
                                                                                                    u'default': None,
                                                                                                    u'description': u'Name that uniquely identifies the operation.',
                                                                                                    u'name': u'operation',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'value': u'OPERATION'}],
                                                                                  u'release': u'GA',
                                                                                  u'sections': {u'DESCRIPTION': u'Retrieves information about a Cloud SQL instance operation.'}},
                                                                    u'list': {u'capsule': u'Lists all instance operations for the given Cloud SQL instance.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--filter': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--filter',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'string',
                                                                                                       u'value': u'EXPRESSION'},
                                                                                         u'--instance': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Cloud SQL instance ID.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--instance',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': True,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'INSTANCE'},
                                                                                         u'--limit': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--limit',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'LIMIT'},
                                                                                         u'--no-uri': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': True,
                                                                                                       u'description': u'',
                                                                                                       u'group': u'',
                                                                                                       u'hidden': True,
                                                                                                       u'name': u'--no-uri',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'NO_URI'},
                                                                                         u'--page-size': {u'attr': {},
                                                                                                          u'category': u'LIST COMMAND',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--page-size',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'PAGE_SIZE'},
                                                                                         u'--sort-by': {u'attr': {},
                                                                                                        u'category': u'LIST COMMAND',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--sort-by',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': False,
                                                                                                        u'type': u'list',
                                                                                                        u'value': u'FIELD'},
                                                                                         u'--uri': {u'attr': {},
                                                                                                    u'category': u'LIST COMMAND',
                                                                                                    u'choices': [],
                                                                                                    u'completer': u'',
                                                                                                    u'default': False,
                                                                                                    u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                    u'group': u'',
                                                                                                    u'hidden': False,
                                                                                                    u'name': u'--uri',
                                                                                                    u'nargs': u'0',
                                                                                                    u'required': False,
                                                                                                    u'type': u'bool',
                                                                                                    u'value': u'URI'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'list',
                                                                              u'path': [u'gcloud',
                                                                                        u'sql',
                                                                                        u'operations',
                                                                                        u'list'],
                                                                              u'positionals': [],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'Lists all instance operations for the given Cloud SQL instance.'}},
                                                                    u'wait': {u'capsule': u'Waits for one or more operations to complete.',
                                                                              u'commands': {},
                                                                              u'flags': {u'--instance': {u'attr': {},
                                                                                                         u'category': u'',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Cloud SQL instance ID.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--instance',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': True,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'INSTANCE'}},
                                                                              u'group': False,
                                                                              u'groups': {},
                                                                              u'hidden': False,
                                                                              u'name': u'wait',
                                                                              u'path': [u'gcloud',
                                                                                        u'sql',
                                                                                        u'operations',
                                                                                        u'wait'],
                                                                              u'positionals': [{u'completer': u'',
                                                                                                u'default': None,
                                                                                                u'description': u'An identifier that uniquely identifies the operation.',
                                                                                                u'name': u'operation',
                                                                                                u'nargs': u'+',
                                                                                                u'required': False,
                                                                                                u'value': u'OPERATION'}],
                                                                              u'release': u'GA',
                                                                              u'sections': {u'DESCRIPTION': u'Waits for one or more operations to complete.'}}},
                                                      u'flags': {},
                                                      u'group': True,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'operations',
                                                      u'path': [u'gcloud',
                                                                u'sql',
                                                                u'operations'],
                                                      u'positionals': [],
                                                      u'release': u'GA',
                                                      u'sections': {u'DESCRIPTION': u'Provide commands for working with Cloud SQL instance operations, including\nlisting and getting information about instance operations of a Cloud SQL\ninstance.'}},
                                      u'ssl-certs': {u'capsule': u'Provide commands for managing SSL certificates of Cloud SQL instances.',
                                                     u'commands': {u'create': {u'capsule': u'Creates an SSL certificate for a Cloud SQL instance.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--instance': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Cloud SQL instance ID.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--instance',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': True,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'INSTANCE'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'create',
                                                                               u'path': [u'gcloud',
                                                                                         u'sql',
                                                                                         u'ssl-certs',
                                                                                         u'create'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'User supplied name. Constrained to ```[a-zA-Z.-_ ]+```.',
                                                                                                 u'name': u'common-name',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'COMMON_NAME'},
                                                                                                {u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'Location of file which the private key of the created ssl-cert will be written to.',
                                                                                                 u'name': u'cert-file',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'CERT_FILE'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Creates an SSL certificate for a Cloud SQL instance.'}},
                                                                   u'delete': {u'capsule': u'Deletes an SSL certificate for a Cloud SQL instance.',
                                                                               u'commands': {},
                                                                               u'flags': {u'--async': {u'attr': {},
                                                                                                       u'category': u'',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': False,
                                                                                                       u'description': u"Display information about the operation in progress and don't wait for\nthe operation to complete.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--async',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'bool',
                                                                                                       u'value': u'ASYNC'},
                                                                                          u'--instance': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': None,
                                                                                                          u'description': u'Cloud SQL instance ID.',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': False,
                                                                                                          u'name': u'--instance',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': True,
                                                                                                          u'type': u'string',
                                                                                                          u'value': u'INSTANCE'},
                                                                                          u'--no-async': {u'attr': {},
                                                                                                          u'category': u'',
                                                                                                          u'choices': [],
                                                                                                          u'completer': u'',
                                                                                                          u'default': True,
                                                                                                          u'description': u'',
                                                                                                          u'group': u'',
                                                                                                          u'hidden': True,
                                                                                                          u'name': u'--no-async',
                                                                                                          u'nargs': u'0',
                                                                                                          u'required': False,
                                                                                                          u'type': u'bool',
                                                                                                          u'value': u'NO_ASYNC'}},
                                                                               u'group': False,
                                                                               u'groups': {},
                                                                               u'hidden': False,
                                                                               u'name': u'delete',
                                                                               u'path': [u'gcloud',
                                                                                         u'sql',
                                                                                         u'ssl-certs',
                                                                                         u'delete'],
                                                                               u'positionals': [{u'completer': u'',
                                                                                                 u'default': None,
                                                                                                 u'description': u'User supplied name. Constrained to ```[a-zA-Z.-_ ]+```.',
                                                                                                 u'name': u'common-name',
                                                                                                 u'nargs': u'0',
                                                                                                 u'required': False,
                                                                                                 u'value': u'COMMON_NAME'}],
                                                                               u'release': u'GA',
                                                                               u'sections': {u'DESCRIPTION': u'Deletes an SSL certificate for a Cloud SQL instance.'}},
                                                                   u'describe': {u'capsule': u'Retrieves information about an SSL cert for a Cloud SQL instance.',
                                                                                 u'commands': {},
                                                                                 u'flags': {u'--instance': {u'attr': {},
                                                                                                            u'category': u'',
                                                                                                            u'choices': [],
                                                                                                            u'completer': u'',
                                                                                                            u'default': None,
                                                                                                            u'description': u'Cloud SQL instance ID.',
                                                                                                            u'group': u'',
                                                                                                            u'hidden': False,
                                                                                                            u'name': u'--instance',
                                                                                                            u'nargs': u'0',
                                                                                                            u'required': True,
                                                                                                            u'type': u'string',
                                                                                                            u'value': u'INSTANCE'}},
                                                                                 u'group': False,
                                                                                 u'groups': {},
                                                                                 u'hidden': False,
                                                                                 u'name': u'describe',
                                                                                 u'path': [u'gcloud',
                                                                                           u'sql',
                                                                                           u'ssl-certs',
                                                                                           u'describe'],
                                                                                 u'positionals': [{u'completer': u'',
                                                                                                   u'default': None,
                                                                                                   u'description': u'User supplied name. Constrained to ```[a-zA-Z.-_ ]+```.',
                                                                                                   u'name': u'common-name',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'value': u'COMMON_NAME'}],
                                                                                 u'release': u'GA',
                                                                                 u'sections': {u'DESCRIPTION': u'Retrieves information about an SSL cert for a Cloud SQL instance.'}},
                                                                   u'list': {u'capsule': u'Lists all SSL certs for a Cloud SQL instance.',
                                                                             u'commands': {},
                                                                             u'flags': {u'--filter': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': None,
                                                                                                      u'description': u'Apply a Boolean filter _EXPRESSION_ to each resource item to be listed.\nIf the expression evaluates True then that item is listed. For more\ndetails and examples of filter expressions run $ gcloud topic filters. This\nflag interacts with other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': False,
                                                                                                      u'name': u'--filter',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'string',
                                                                                                      u'value': u'EXPRESSION'},
                                                                                        u'--instance': {u'attr': {},
                                                                                                        u'category': u'',
                                                                                                        u'choices': [],
                                                                                                        u'completer': u'',
                                                                                                        u'default': None,
                                                                                                        u'description': u'Cloud SQL instance ID.',
                                                                                                        u'group': u'',
                                                                                                        u'hidden': False,
                                                                                                        u'name': u'--instance',
                                                                                                        u'nargs': u'0',
                                                                                                        u'required': True,
                                                                                                        u'type': u'string',
                                                                                                        u'value': u'INSTANCE'},
                                                                                        u'--limit': {u'attr': {},
                                                                                                     u'category': u'LIST COMMAND',
                                                                                                     u'choices': [],
                                                                                                     u'completer': u'',
                                                                                                     u'default': None,
                                                                                                     u'description': u'The maximum number of resources to list. The default is *unlimited*.\nThis flag interacts with other flags that are applied in this order:\n*--flatten*, *--sort-by*, *--filter*, *--limit*.',
                                                                                                     u'group': u'',
                                                                                                     u'hidden': False,
                                                                                                     u'name': u'--limit',
                                                                                                     u'nargs': u'0',
                                                                                                     u'required': False,
                                                                                                     u'type': u'string',
                                                                                                     u'value': u'LIMIT'},
                                                                                        u'--no-uri': {u'attr': {},
                                                                                                      u'category': u'LIST COMMAND',
                                                                                                      u'choices': [],
                                                                                                      u'completer': u'',
                                                                                                      u'default': True,
                                                                                                      u'description': u'',
                                                                                                      u'group': u'',
                                                                                                      u'hidden': True,
                                                                                                      u'name': u'--no-uri',
                                                                                                      u'nargs': u'0',
                                                                                                      u'required': False,
                                                                                                      u'type': u'bool',
                                                                                                      u'value': u'NO_URI'},
                                                                                        u'--page-size': {u'attr': {},
                                                                                                         u'category': u'LIST COMMAND',
                                                                                                         u'choices': [],
                                                                                                         u'completer': u'',
                                                                                                         u'default': None,
                                                                                                         u'description': u'Some services group resource list output into pages. This flag specifies\nthe maximum number of resources per page. The default is determined by the\nservice if it supports paging, otherwise it is *unlimited* (no paging).\nPaging may be applied before or after *--filter* and *--limit* depending\non the service.',
                                                                                                         u'group': u'',
                                                                                                         u'hidden': False,
                                                                                                         u'name': u'--page-size',
                                                                                                         u'nargs': u'0',
                                                                                                         u'required': False,
                                                                                                         u'type': u'string',
                                                                                                         u'value': u'PAGE_SIZE'},
                                                                                        u'--sort-by': {u'attr': {},
                                                                                                       u'category': u'LIST COMMAND',
                                                                                                       u'choices': [],
                                                                                                       u'completer': u'',
                                                                                                       u'default': None,
                                                                                                       u'description': u"A comma-separated list of resource field key names to sort by. The\ndefault order is ascending. Prefix a field with ``~'' for descending\norder on that field. This flag interacts with other flags that are applied\nin this order: *--flatten*, *--sort-by*, *--filter*, *--limit*.",
                                                                                                       u'group': u'',
                                                                                                       u'hidden': False,
                                                                                                       u'name': u'--sort-by',
                                                                                                       u'nargs': u'0',
                                                                                                       u'required': False,
                                                                                                       u'type': u'list',
                                                                                                       u'value': u'FIELD'},
                                                                                        u'--uri': {u'attr': {},
                                                                                                   u'category': u'LIST COMMAND',
                                                                                                   u'choices': [],
                                                                                                   u'completer': u'',
                                                                                                   u'default': False,
                                                                                                   u'description': u'Print a list of resource URIs instead of the default output.',
                                                                                                   u'group': u'',
                                                                                                   u'hidden': False,
                                                                                                   u'name': u'--uri',
                                                                                                   u'nargs': u'0',
                                                                                                   u'required': False,
                                                                                                   u'type': u'bool',
                                                                                                   u'value': u'URI'}},
                                                                             u'group': False,
                                                                             u'groups': {},
                                                                             u'hidden': False,
                                                                             u'name': u'list',
                                                                             u'path': [u'gcloud',
                                                                                       u'sql',
                                                                                       u'ssl-certs',
                                                                                       u'list'],
                                                                             u'positionals': [],
                                                                             u'release': u'GA',
                                                                             u'sections': {u'DESCRIPTION': u'Lists all SSL certs for a Cloud SQL instance.'}}},
                                                     u'flags': {},
                                                     u'group': True,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'ssl-certs',
                                                     u'path': [u'gcloud',
                                                               u'sql',
                                                               u'ssl-certs'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'Provide commands for managing SSL certificates of Cloud SQL instances,\nincluding creating, deleting, listing, and getting information about\ncertificates.'}},
                                      u'tiers': {u'capsule': u'Provide a command to list tiers.',
                                                 u'commands': {u'list': {u'capsule': u'Lists all available service tiers for Google Cloud SQL.',
                                                                         u'commands': {},
                                                                         u'flags': {},
                                                                         u'group': False,
                                                                         u'groups': {},
                                                                         u'hidden': False,
                                                                         u'name': u'list',
                                                                         u'path': [u'gcloud',
                                                                                   u'sql',
                                                                                   u'tiers',
                                                                                   u'list'],
                                                                         u'positionals': [],
                                                                         u'release': u'GA',
                                                                         u'sections': {u'DESCRIPTION': u'Lists all available service tiers for Google Cloud SQL.'}}},
                                                 u'flags': {},
                                                 u'group': True,
                                                 u'groups': {},
                                                 u'hidden': False,
                                                 u'name': u'tiers',
                                                 u'path': [u'gcloud',
                                                           u'sql',
                                                           u'tiers'],
                                                 u'positionals': [],
                                                 u'release': u'GA',
                                                 u'sections': {u'DESCRIPTION': u'Provide a command to list tiers.'}}},
                        u'flags': {u'--api-version': {u'attr': {u'property': {u'name': u'api_endpoint_overrides/sql'}},
                                                      u'category': u'',
                                                      u'choices': [u'v1beta3',
                                                                   u'v1beta4'],
                                                      u'completer': u'',
                                                      u'default': None,
                                                      u'description': u'',
                                                      u'group': u'',
                                                      u'hidden': True,
                                                      u'name': u'--api-version',
                                                      u'nargs': u'0',
                                                      u'required': False,
                                                      u'type': u'string',
                                                      u'value': u'API_VERSION'}},
                        u'group': True,
                        u'groups': {},
                        u'hidden': False,
                        u'name': u'sql',
                        u'path': [u'gcloud', u'sql'],
                        u'positionals': [],
                        u'release': u'GA',
                        u'sections': {u'DESCRIPTION': u'Manage Cloud SQL databases.'}},
               u'topic': {u'capsule': u'gcloud supplementary help.',
                          u'commands': {u'arg-files': {u'capsule': u'Supplementary help for arg-files to be used with *gcloud test*.',
                                                       u'commands': {},
                                                       u'flags': {},
                                                       u'group': False,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'arg-files',
                                                       u'path': [u'gcloud',
                                                                 u'topic',
                                                                 u'arg-files'],
                                                       u'positionals': [],
                                                       u'release': u'GA',
                                                       u'sections': {u'DESCRIPTION': u'Supplementary help for arg-files to be used with *gcloud test*.\n\nAll *gcloud test android run* arguments may be specified by flags on\nthe command line and/or via a YAML-formatted _ARG_FILE_. The optional,\npositional ARG_SPEC argument on the command line is used to specify\na single _ARG_FILE_:_ARG_GROUP_NAME_ pair, where _ARG_FILE_ is the\npath to the YAML argument file, and _ARG_GROUP_NAME_ is the name\nof the argument group to load and parse. The _ARG_FILE_ must\ncontain valid YAML syntax or gcloud will respond with an error.\n\nThe basic format of a YAML argument file is:\n\n  arg-group1:\n    arg1: value1  # a comment\n    arg2: value2\n    ...\n\n  # Another comment\n  arg-group2:\n    arg3: value3\n    ...\n\nList arguments may be specified within square brackets:\n\n  device-ids: [Nexus5, Nexus6, Nexus9]\n\nor by using the alternate YAML list notation with one dash per list\nitem:\n\n  ```\n  device-ids:\n    - Nexus5\n    - Nexus6\n    - Nexus9\n  ```\n\nIf a list argument only contains a single value, you may omit the\nsquare brackets:\n\n  device-ids: Nexus9\n\nComposition\n\nA special *include: [_ARG_GROUP1_, ...]* syntax allows merging or\ncomposition of argument groups (see *EXAMPLES* below). Included\nargument groups can *include:* other argument groups within the\nsame YAML file, with unlimited nesting.\n\nPrecedence\n\nAn argument which appears on the command line has the highest\nprecedence and will override the same argument if it is specified\nwithin an argument file.\n\nAny argument defined directly within a group will have higher\nprecedence than an identical argument which is merged into that\ngroup using the *include:* keyword.\n\n',
                                                                     u'EXAMPLES': u'\nHere are the contents of a very simple YAML argument file which\nwe\'ll assume is stored in a file named excelsior_args.yaml:\n\n  # Run a quick \'robo\' test on the \'Excelsior\' app for\n  # 90 seconds using only the default virtual device.\n  quick-robo-test:\n    app: path/to/excelsior.apk\n    type: robo\n    max-steps: 100\n    timeout: 90s\n    async: true\n\nTo invoke this test, run:\n\n  $ gcloud beta test android run excelsior_args.yaml:quick-robo-test\n\nIf your app has a login screen, or has additional UI elements which\nrequire input text, you may specify the resource names of the Android\ntarget UI elements, along with their corresponding input values, in\nthe \'robo-directives\' map argument. In the example below,\n"username_resource" is the resource name of the username field and\n"username" is the input for that field (similarly for password).\n\n  # Run a \'robo\' test on the \'Excelsior\' app with login credentials.\n  robo-test-with-login:\n    app: path/to/excelsior.apk\n    type: robo\n    robo-directives:\n      username_resource: username\n      password_resource: password\n\nAssuming the above YAML text is appended to the arg-file named\nexcelsior_args.yaml, you may invode the test by running:\n\n  $ gcloud beta test android run excelsior_args.yaml:robo-test-with-login\n\nHere is a slightly more complicated example which demonstrates\ncomposition of argument groups. Assume the following YAML text\nis appended to the arg-file shown above named excelsior_args.yaml:\n\n  # Specify some unit tests to be run against a test matrix\n  # with one device type, two Android versions, and four\n  # locales, for a total of eight test variations (1*2*4).\n  unit-tests:\n    type: instrumentation\n    app: path/to/excelsior.apk\n    test: path/to/excelsior-test.apk  # the unit tests\n    timeout: 10m\n    device-ids: Nexus6\n    include: [supported-versions, supported-locales]\n\n  supported-versions:\n    os-version-ids: [21, 22]\n\n  supported-locales:\n    locales: [en, es, fr, it]\n\nTo invoke this test matrix, run:\n\n  $ gcloud beta test android run excelsior_args.yaml:unit-tests\n\nTo run these unit tests with the same locales and os-version-ids,\nbut substituting a sampling of three physical Android devices\ninstead of the single virtual Nexus6 device, run:\n\n  $ gcloud beta test android run excelsior_args.yaml:unit-tests --device-ids shamu,htc_m8,g3\n\nIn the last example, the --device-ids argument on the\ncommand line overrides the device-ids: specification inside the\narg-file because command-line arguments have higher precedence.\n'}},
                                        u'configurations': {u'capsule': u'Supplementary help for named configurations.',
                                                            u'commands': {},
                                                            u'flags': {},
                                                            u'group': False,
                                                            u'groups': {},
                                                            u'hidden': False,
                                                            u'name': u'configurations',
                                                            u'path': [u'gcloud',
                                                                      u'topic',
                                                                      u'configurations'],
                                                            u'positionals': [],
                                                            u'release': u'GA',
                                                            u'sections': {u'DESCRIPTION': u"gcloud properties can be stored in *named configurations*, which\nare collections of key-value pairs that influence the behavior of\ngcloud.\n\nNamed configurations are intended to be an advanced feature,\nand you can probably ignore them entirely if you only work with one\nproject.\n\nProperties that are commonly stored in configurations include\ndefault Google Compute Engine zone, verbosity level, project ID, and\nactive user or service account. Configurations allow you to define\nand enable these and other settings together as a group.\n\nConfigurations are especially useful if you:\n  - Work with multiple projects. You can create a separate\n    configuration for each project.\n  - Use multiple accounts, for example, a user account and a\n    service account, etc.\n  - Perform generally orthogonal tasks (work on an appengine app in\n    project foo, administer a Google Compute Engine cluster in zone\n    user-central-1a, manage the network configurations for region\n    asia-east-1, etc.)\n\nProperty information stored in named configurations are readable by\nall gcloud commands and may be modified by `gcloud config set`\nand `gcloud config unset`.\n\n# Creating configurations\n\nNamed configurations maybe be defined by users or built into gcloud.\n\nUser defined configurations have lowercase names, such as\n'johndoe', 'default', 'jeff-staging', or 'foo2'.  These are defined\nby the following regular expression: ```^[a-z][-a-z0-9]*$```\n\nAdditionally there is a builtin configuration named NONE that has\nno properties set.\n\nThe easiest way to create a brand new configuration is by\nrunning\n\n  $ gcloud init\n\nThis will guide you through setting up your first named configuration,\ncreating a new named configuration, or reinitializing an existing\nnamed configuration. (Note: reinitializing an existing configuration\nwill remove all its existing properties!)\n\nYou can create a new empty configuration with\n\n  $ gcloud config configurations create my-config\n\n# Using configurations\n\ngcloud may have at most one *active* configuration which provides\nproperty values.  Inactive configurations have no effect on\ngcloud executions.\n\nYou can activate a configuration with\n\n  $ gcloud config configurations activate my-config\n\nYou can view and change the properties of your active configuration\nusing the following commands:\n\n  $ gcloud config list\n  $ gcloud config set\n\nAdditionally, commands under `gcloud config configurations`\nallow you to to list, activate, describe, and delete configurations\nthat may or may not be active.\n\nYou can activate a configuration for a single gcloud invocation using\nflag, `--configuration my-config`, or environment variable\n`CLOUDSDK_ACTIVE_CONFIG_NAME=my-config`.\n\n## AVAILABLE PROPERTIES\n\n{properties}"}},
                                        u'datetimes': {u'capsule': u'Date/time input format supplementary help.',
                                                       u'commands': {},
                                                       u'flags': {},
                                                       u'group': False,
                                                       u'groups': {},
                                                       u'hidden': False,
                                                       u'name': u'datetimes',
                                                       u'path': [u'gcloud',
                                                                 u'topic',
                                                                 u'datetimes'],
                                                       u'positionals': [],
                                                       u'release': u'GA',
                                                       u'sections': {u'DESCRIPTION': u'*gcloud* command line flags and filter expressions that expect date/time\nstring values support common input formats. These formats fall into two main\ncategories: absolute date/times and relative durations.\n\n### Absolute date/time formats\n\nAbsolute date/time input formats minimally support\n[ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) and\n[RFC 822](https://www.ietf.org/rfc/rfc0822.txt) date/times. When omitted the\ndate/time value defaults are:\n\n* year, month, day - current value\n* hour, minute, second, fractional second - 0\n\nThe supported absolute date/time input formats are listed here.\n\nISO 8601 / RFC 3339 zulu:\n\n    2003-09-25T10:49:41.519Z\n    2003-09-25T10:49:41Z\n\nISO 8601 numeric timezone offset:\n\n    2003-09-25T10:49:41.5-0000\n    2003-09-25T10:49:41.5-03:00\n    2003-09-25T10:49:41.5+0300\n\nISO with omitted parts:\n\n    2003-09-25T10:49:41\n    2003-09-25T10:49\n    2003-09-25T10\n    2003-09-25\n\nRFC 822:\n\n    Thu, 25 Sep 2003 10:49:41 -0300\n\nUNIX date command, explicit timezone:\n\n    Thu Sep 25 10:36:28 EDT 2003\n    2003 10:36:28 EDT 25 Sep Thu\n\nlocal timezone:\n\n    Thu Sep 25 10:36:28 2003\n\nomitted parts (date parts default to the current date, time parts default\nto 0):\n\n    Thu Sep 25 10:36:28\n    Thu Sep 10:36:28\n    Thu 10:36:28\n    Thu 10:36\n    10:36\n\nomitted parts with different order:\n\n    Thu Sep 25 2003\n    Sep 25 2003\n    Sep 2003\n    Sep\n    2003\n\nISO no separators:\n\n    20030925T104941.5-0300\n    20030925T104941-0300\n    20030925T104941\n    20030925T1049\n    20030925T10\n    20030925\n\nno T separator:\n\n    20030925104941\n    200309251049\n\nother date orderings:\n\n    2003-09-25\n    2003-Sep-25\n    25-Sep-2003\n    Sep-25-2003\n    09-25-2003\n\nother date separators:\n\n    2003.Sep.25\n    2003/09/25\n    2003 Sep 25\n    2003 09 25\n\n### Relative duration date/time formats\n\nRelative durations are based on\n[ISO 8601 durations](https://en.wikipedia.org/wiki/ISO_8601#Durations).\nRelative durations are case-insensitive and must be prefixed with +P or -P.\nThey denote offsets from the current time.\n\nA fully qualified duration string contains year, month, day, hour, minute,\nsecond, and fractional second parts. Each part is a number followed by a\nsingle character suffix:\n\n* P - period (the duration designator)\n* Y - year\n* M - minute if after T or H, month otherwise\n* D - day\n* T - separates date parts from time parts\n* H - hour\n* M - minute if after T or H, month otherwise\n* S - second (for fractional seconds, use decimal value for seconds)\n\nAt least one part must be specified. Omitted parts default to 0.\n\n  -P1Y2M3DT4H5M6.7S\n  +p1y2m3dT4h5m6.7s\n\nA relative duration may be used in any context that expects a date/time\nstring.\n\nFor example:\n\n* 1 month ago: -p1m\n* 30 minutes from now: +pt30m\n* 2 hours and 30 minutes ago: -p2h30m'}},
                                        u'escaping': {u'capsule': u'List/dictionary-type argument escaping supplementary help.',
                                                      u'commands': {},
                                                      u'flags': {},
                                                      u'group': False,
                                                      u'groups': {},
                                                      u'hidden': False,
                                                      u'name': u'escaping',
                                                      u'path': [u'gcloud',
                                                                u'topic',
                                                                u'escaping'],
                                                      u'positionals': [],
                                                      u'release': u'GA',
                                                      u'sections': {u'DESCRIPTION': u"List/dictionary-type argument escaping supplementary help.\n\n*gcloud* supports list-type and dictionary-type flags that take one\nargument which is a list of one or more comma-separated items:\n\n    --list-flag=value1,value2,value3\n\n    --dict-flag=key1=value1,key2=value2\n\nIn the case of a dict-type flag, each item is a key-value pair\nseparated by '='. If more than one '=' is present, the first is used.\n\nIn order to include commas in your arguments, specify an alternate\ndelimiter using the following syntax:\n\n    ^DELIM^flag value, with comma\n\nwhere _DELIM_ is a sequence of one or more characters that may not\nappear in any value in the list.\n\n",
                                                                    u'EXAMPLES': u'In these examples, a list-type or dictionary-type flag is given, along\nwith a shell comment explaining how it is parsed. The parsed flags are\nshown here using Python-style list or dict formats (in other\nlanguages, what Python calls "dicts" are often called "associative\narrays," "maps," or "hashes").\n\nBasic example:\n\n    --list-flag=^:^a,b:c,d # => [\'a,b\', \'c,d\']\n\nMulti-character delimiters are allowed:\n\n    --list-flag=^--^a-,b--c # => [\'a-,b\', \'c\']\n\nJust one \'^\' has no special meaning:\n\n    --list-flag=^a,b,c # => [\'^a\', \'b\', \'c\']\n\nThis is an alternative way of starting with \'^\':\n\n    --list-flag=^,^^a,b,c # => [\'^a\', \'b\', \'c\']\n\nA \'^\' anywhere but the start has no special meaning:\n\n    --list-flag=a^:^,b,c # => [\'a^:^\', \'b\', \'c\']\n\nDictionary-type arguments work exactly the same as list-type\narguments:\n\n    --dict-flag=^:^a=b,c:d=f,g # => {\'a: \'b,c\', \'d\': \'f,g\'}\n'}},
                                        u'filters': {u'capsule': u'Resource filters supplementary help.',
                                                     u'commands': {},
                                                     u'flags': {},
                                                     u'group': False,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'filters',
                                                     u'path': [u'gcloud',
                                                               u'topic',
                                                               u'filters'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'Most *gcloud* commands return a list of resources on success. By default they\nare pretty-printed on the standard output. The\n*--format=*_NAME_[_ATTRIBUTES_]*(*_PROJECTION_*)* flag changes the default\noutput:\n\n_NAME_:: The format name.\n\n_ATTRIBUTES_:: Format specific attributes. For details run $ gcloud topic formats.\n\n_PROJECTION_:: A list of resource keys that selects the data listed. For details run $ gcloud topic projections.\n\n_resource keys_:: Keys are names for resource resource items. For details run $ gcloud topic resource-keys.\n\nMost *gcloud* *list* commands have a *--filter=*_EXPRESSION_ flag that\nselects resources to be listed. Resource filters are described in detail below.\n\n\n=== Filter Expressions ===\n\nA filter expression is a Boolean function that selects resources from\na list. Expressions are composed of terms connected by logic\noperators.\n\n*LogicOperator*::\n\nExpressions containing both *AND* and *OR* must be parenthesized to\ndisambiguate precedence.\n\n*NOT* _term-1_:::\n\nTrue if _term-1_ is False, otherwise False.\n\n_term-1_ *AND* _term-2_:::\n\nTrue if both _term-1_ and _term-2_ are true.\n\n_term-1_ *OR* _term-2_:::\n\nTrue if at least one of _term-1_ or _term-2_ is true.\n\n_term-1_ _term-2_:::\n\nTrue if both _term-1_ and _term-2_ are true. Implicit conjunction has\nlower precedence than *OR*.\n\n*Terms*::\n\nA term is a _key_ _operator_ _value_ tuple, where _key_ is a dotted\nname that evaluates to the value of a resource attribute, and _value_\nmay be:\n\n*number*::: integer or floating point numeric constant\n\n*unquoted literal*::: character sequence terminated by space, ( or )\n\n*quoted literal*::: _"..."_ or _\'...\'_\n\nMost filter expressions need to be quoted in shell commands. If you\nuse _\'...\'_ shell quotes then use _"..."_ filter string literal quotes\nand vice versa.\n\n*Operator Terms*::\n\n_key_ *=* _value_:::\n\nTrue if _key_ is equal to _value_.\n\n_key_ *=(* _value_ ... *)*:::\n\nTrue if _key_ is equal to any _value_ in the\n(space, tab, newline, *,*) separated list.\n\n_key_ *!=* _value_:::\n\nTrue if _key_ is not _value_. Equivalent to\n-_key_=_value_ and NOT _key_=_value_.\n\n_key_ *<* _value_:::\n\nTrue if _key_ is less than _value_. If both _key_ and\n_value_ are numeric then numeric comparison is used, otherwise\nlexicographic string comparison is used.\n\n_key_ *<=* _value_:::\n\nTrue if _key_ is less than or equal to _value_. If both\n_key_ and _value_ are numeric then numeric comparison is used,\notherwise lexicographic string comparison is used.\n\n_key_ *>=* _value_:::\n\nTrue if _key_ is greater than or equal to _value_. If\nboth _key_ and _value_ are numeric then numeric comparison is used,\notherwise lexicographic string comparison is used.\n\n_key_ *>* _value_:::\n\nTrue if _key_ is greater than _value_. If both _key_ and\n_value_ are numeric then numeric comparison is used, otherwise\nlexicographic string comparison is used.\n\n_key_ *:* _simple-pattern_:::\n\nTrue if _key_ matches _simple-pattern_. The match is anchored (all\ncharacters must match), case insensitive, and allows one ```*```\noperator that matches any sequence of 0 or more characters. The\npattern ```abc``` matches ```abc```, the pattern ```abc*``` matches\n```abc``` and ```abcxyz```, the pattern ```*xyz``` matches ```xyz```\nand ```abcxyz```, and the pattern ```*``` matches any non-empty\nstring. Use _key_```:*``` to test if _key_ is defined and\n```-```_key_```:*``` to test if _key_ is undefined.\n\n_key_ *:(* _simple-pattern_ ... *)*:::\n\nTrue if _key_ matches any _simple-pattern_ in the\n(space, tab, newline, comma) separated list.\n\n_key_ *~* _value_:::\n\nTrue if _key_ matches the RE (regular expression) pattern _value_.\n\n_key_ *!*~ _value_:::\n\nTrue if _key_ does not match the RE (regular expression)\npattern _value_.\n\n',
                                                                   u'EXAMPLES': u"List all instances resources:\n\n  $ gcloud compute instances list\n\nList instances resources that have machineType *f1-micro*:\n\n  $ gcloud compute instances list --filter='machineType:f1-micro'\n\nList resources with zone prefix *us* and not MachineType *f1-micro*:\n\n  $ gcloud compute instances list --filter='zone ~ ^us AND -machineType:f1-micro'\n"}},
                                        u'formats': {u'capsule': u'Resource formats supplementary help.',
                                                     u'commands': {},
                                                     u'flags': {},
                                                     u'group': False,
                                                     u'groups': {},
                                                     u'hidden': False,
                                                     u'name': u'formats',
                                                     u'path': [u'gcloud',
                                                               u'topic',
                                                               u'formats'],
                                                     u'positionals': [],
                                                     u'release': u'GA',
                                                     u'sections': {u'DESCRIPTION': u'Most *gcloud* commands return a list of resources on success. By default they\nare pretty-printed on the standard output. The\n*--format=*_NAME_[_ATTRIBUTES_]*(*_PROJECTION_*)* flag changes the default\noutput:\n\n_NAME_:: The format name.\n\n_ATTRIBUTES_:: Format specific attributes. Resource formats are described in detail below.\n\n_PROJECTION_:: A list of resource keys that selects the data listed. For details run $ gcloud topic projections.\n\n_resource keys_:: Keys are names for resource resource items. For details run $ gcloud topic resource-keys.\n\nMost *gcloud* *list* commands have a *--filter=*_EXPRESSION_ flag that\nselects resources to be listed. For details run $ gcloud topic filters.\n\n\n### Formats\n\nA format expression has 3 parts:\n\n_NAME_:: _name_\n_ATTRIBUTES_:: *[* [no-]_attribute-name_[=_value_] [, ... ] *]*\n_PROJECTION_:: *(* _resource-key_ [, ...] *)*\n\n_NAME_ is required, _ATTRIBUTES_ are optional, and _PROJECTIONS_\nmay be required for some formats. Unknown attribute names are\nsilently ignored.\n\nEach *gcloud* *list* command has a default format expression. The\n*--format* flag can alter or replace the default. For example,\n\n    --format=\'[box]\'\n\nadds box decorations to a default table, and\n\n    --format=json\n\nlists the resource in *json* format.\n\nThe formats and format specific attributes are:\n\n*config*::\nA dictionary of dictionaries in config style.\n+\nThe format attributes are:\n\n*export*:::\nDisplay the dictionary as a list of system specific environment export commands.\n*unset*:::\nDisplay the dictionary as a list of system specific environment unset commands.\n\n*csv*::\n[Comma Separated Values](http://www.ietf.org/rfc/rfc4180.txt) with no keys. This format requires a projection to define the values to be printed.\n+\nThe format attributes are:\n\n*delimiter="string"*:::\nThe string printed between list value items, default ";".\n*no-heading*:::\nDisables the initial key name heading record.\n*separator="string"*:::\nThe string printed between values, default ",".\n*terminator="string"*:::\nThe string printed after each record, default "\\n" (newline).\n\n*default*::\nAn alias for the *yaml* format.\n\n*diff*::\nA unified diff of the first two projection columns.\n+\nThe format attributes are:\n\n*format*:::\nThe format of the diffed resources. Each resource is converted to this format and the diff of the converted resources is displayed. The default is \'flattened\'.\n\n*disable*::\nDisables formatted output and does not consume the resources.\n\n*flattened*::\nA flattened tree. Each output line contains one *key*:*value* pair.\n+\nThe format attributes are:\n\n*no-pad*:::\nDon\'t print space after the separator. The default adjusts the space to align the values into the same output column. Use *no-pad* for comparing resource outputs.\n*separator=_SEPARATOR_*:::\nPrint _SEPARATOR_ between the *key* and *value*. The default is ": ".\n\n*get*::\nEquivalent to the *value[no-transforms]* format. Default transforms are not applied to the displayed values.\n\n*json*::\n[JSON](http://www.json.org), JavaScript Object Notation.\n+\nThe format attributes are:\n\n*no-undefined*:::\nDoes not display resource data items with null values.\n\n*list*::\nAn ordered list of items.\n+\nThe format attributes are:\n\n*always-display-title*:::\nDisplay the title even if there are no records.\n*compact*:::\nDisplay all items in a record on one line.\n\n*multi*::\nEach projection key must have a subformat defined by the :format=FORMAT-STRING attribute. For example,\n+\n  `--format="multi(data:format=json, info:format=\'table[box](a, b, c)\')"`\n+\nformats the *data* field as JSON and the *info* field as a boxed table.\n\n*none*::\nDisables formatted output and consumes the resources.\n\n*object*::\nBypasses JSON-serialization and prints the object representation of each resource.\n+\nThe format attributes are:\n\n*separator*:::\nThe line printed between resources.\n*terminator*:::\nThe line printed after each resource.\n\n*table*::\nAligned left-adjusted columns with optional title, column headings and sorting. This format requires a projection to define the table columns. The default column headings are the disambiguated right hand components of the column keys in ANGRY_SNAKE_CASE. For example, the projection keys (first.name, last.name) produce the default column heading (\'NAME\', \'LAST_NAME\').\n+\nIf *--page-size*=_N_ is specified then output is grouped into tables with at most _N_ rows. Headings, alignment and sorting are done per-page. The title, if any, is printed before the first table.\n+\nThe format attributes are:\n\n*box*:::\nPrints a box around the entire table and each cell, including the title if any.\n*format=_FORMAT-STRING_*:::\nPrints the key data indented by 4 spaces using _FORMAT-STRING_ which can reference any of the supported formats.\n*no-heading*:::\nDisables the column headings.\n*optional*:::\nDoes not display the column if it is empty.\n*pad=N*:::\nSets the column horizontal pad to _N_ spaces. The default is 1 for box, 2 otherwise.\n*title=_TITLE_*:::\nPrints a centered _TITLE_ at the top of the table, within the table box if *box* is enabled.\n\n*text*::\nAn alias for the *flattened* format.\n\n*value*::\nCSV with no heading and <TAB> separator instead of <COMMA>. Used to retrieve individual resource values. This format requires a projection to define the value(s) to be printed.\n+\nThe format attributes are:\n\n*delimiter="string"*:::\nThe string printed between list value items, default ";".\n*quote*:::\n"..." quote values that contain delimiter, separator or terminator strings.\n*separator="string"*:::\nThe string printed between values, default "\\t" (tab).\n*terminator="string"*:::\nThe string printed after each record, default "\\n" (newline).\n\n*yaml*::\n[YAML](http://www.yaml.org), YAML ain\'t markup language.\n+\nThe format attributes are:\n\n*null=string*:::\nDisplay string instead of `null` for null/None values.\n*no-undefined*:::\nDoes not display resource data items with null values.\n\nAll formats have these attributes:\n+\n*disable*::\nDisables formatted output and does not consume the resources.\n*private*::\nDisables log file output. Use this for sensitive resource data that should not be displayed in log files. Explicit command line IO redirection overrides this attribute.\n\n\n',
                                                                   u'EXAMPLES': u"List a table of compute instance resources sorted by *name* with\nbox decorations and title *Instances*:\n\n  $ gcloud compute instances list --format='table[box,title=Instances](name:sort=1, zone:title=zone, status)'\n\nList the disk interfaces for all compute instances as a compact\ncomma separated list:\n\n  $ gcloud compute instances list --format='value(disks[].interface.list())'\n\nList the URIs for all compute instances:\n\n  $ gcloud compute instances list --format='value(uri())'\n\nList the project authenticated user email address:\n\n  $ gcloud info --format='value(config.account)'\n"}},
                                        u'projections': {u'capsule': u'Resource projections supplementary help.',
                                                         u'commands': {},
                                                         u'flags': {},
                                                         u'group': False,
                                                         u'groups': {},
                                                         u'hidden': False,
                                                         u'name': u'projections',
                                                         u'path': [u'gcloud',
                                                                   u'topic',
                                                                   u'projections'],
                                                         u'positionals': [],
                                                         u'release': u'GA',
                                                         u'sections': {u'DESCRIPTION': u'Most *gcloud* commands return a list of resources on success. By default they\nare pretty-printed on the standard output. The\n*--format=*_NAME_[_ATTRIBUTES_]*(*_PROJECTION_*)* flag changes the default\noutput:\n\n_NAME_:: The format name.\n\n_ATTRIBUTES_:: Format specific attributes. For details run $ gcloud topic formats.\n\n_PROJECTION_:: A list of resource keys that selects the data listed. Resource projections are described in detail below.\n\n_resource keys_:: Keys are names for resource resource items. For details run $ gcloud topic resource-keys.\n\nMost *gcloud* *list* commands have a *--filter=*_EXPRESSION_ flag that\nselects resources to be listed. For details run $ gcloud topic filters.\n\n\n### Projections\n\nA projection is a list of keys that selects resource data values.\nProjections are used in *--format* flag expressions. For example, the\n*table* format requires a projection that describes the table columns:\n\n  table(name, network.ip.internal, network.ip.external, uri())\n\n### Transforms\n\nA *transform* formats resource data values. Each projection key may\nhave zero or more transform calls:\n\n  _key_._transform_([arg...])...\n\nThis example applies the *foo*() and then the *bar*() transform to the\n*status.time* resource value:\n\n  (name, status.time.foo().bar())\n\n\nThe builtin transform functions are:\n\n\n*always*()::\nMarks a transform sequence to always be applied.\n+\nIn some cases transforms are disabled. Prepending always() to a transform sequence causes the sequence to always be evaluated.\n+\nFor example:\n+\n`some_field.always().foo().bar()`:::\nAlways applies foo() and then bar().\n\n\n*basename*(undefined="")::\nReturns the last path component.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource or basename is empty.\n:::\n\n\n*collection*(undefined="")::\nReturns the current resource collection.\n+\nThe arguments are:\n+\n*```undefined```*:::\nThis value is returned if r or the collection is empty.\n:::\n\n\n*color*(red, yellow, green, blue)::\nColorizes the resource string value.\n+\nThe *red*, *yellow*, *green* and *blue* args are RE patterns, matched against the resource in order. The first pattern that matches colorizes the matched substring with that color, and the other patterns are skipped.\n+\nThe arguments are:\n+\n*```red```*:::\nThe substring pattern for the color red.\n:::\n*```yellow```*:::\nThe substring pattern for the color yellow.\n:::\n*```green```*:::\nThe substring pattern for the color green.\n:::\n*```blue```*:::\nThe substring pattern for the color blue.\n:::\n+\nFor example:\n+\n`color(red=STOP,yellow=CAUTION,green=GO)`:::\nFor the resource string "CAUTION means GO FASTER" displays the substring "CAUTION" in yellow.\n\n\n*count*()::\nCounts the number of each item in the list.\n+\nA string resource is treated as a list of characters.\n+\nFor example:\n+\n`"b/a/b/c".split("/").count()`:::\nReturns {a: 1, b: 2, c: 1}.\n\n\n*date*(format="%Y-%m-%dT%H:%M:%S", unit=1, undefined="", tz, tz_default)::\nFormats the resource as a strftime() format.\n+\nThe arguments are:\n+\n*```format```*:::\nThe strftime(3) format.\n:::\n*```unit```*:::\nIf the resource is a Timestamp then divide by _unit_ to yield seconds.\n:::\n*```undefined```*:::\nReturns this value if the resource is not a valid time.\n:::\n*```tz```*:::\nReturn the time relative to the tz timezone if specified, the explicit       timezone in the resource if it has one, otherwise the local timezone.       For example, ...date(tz=EST5EDT, tz_default=UTC).\n:::\n*```tz_default```*:::\nThe default timezone if the resource does not have a timezone       suffix.\n:::\n\n\n*decode*(encoding, undefined="")::\nReturns the decoded value of the resource that was encoded by encoding.\n+\nThe arguments are:\n+\n*```encoding```*:::\nThe encoding name. *base64* and *utf-8* are supported.\n:::\n*```undefined```*:::\nReturns this value if the decoding fails.\n:::\n\n\n*duration*(start="", end="", parts=3, precision=3, calendar=true, unit=1, undefined="")::\nFormats the resource as an ISO 8601 duration string.\n+\nThe [ISO 8601 Duration](https://en.wikipedia.org/wiki/ISO_8601#Durations) format is: "[-]P[nY][nM][nD][T[nH][nM][n[.m]S]]". The 0 duration is "P0". Otherwise at least one part will always be displayed. Negative durations are prefixed by "-". "T" disambiguates months "P2M" to the left of "T" and minutes "PT5M" to the right.\n+\nIf the resource is a datetime then the duration of `resource - current_time` is returned.\n+\nThe arguments are:\n+\n*```start```*:::\nThe name of a start time attribute in the resource. The duration of       the `end - start` time attributes in resource is returned. If `end` is       not specified then the current time is used.\n:::\n*```end```*:::\nThe name of an end time attribute in the resource. Defaults to       the current time if omitted. Ignored if `start` is not specified.\n:::\n*```parts```*:::\nFormat at most this many duration parts starting with largest       non-zero part.\n:::\n*```precision```*:::\nFormat the last duration part with precision digits after the       decimal point. Trailing "0" and "." are always stripped.\n:::\n*```calendar```*:::\nAllow time units larger than hours in formated durations if true.       Durations specifying hours or smaller units are exact across daylight       savings time boundaries. On by default. Use calendar=false to disable.       For example, if `calendar=true` then at the daylight savings boundary       2016-03-13T01:00:00 + P1D => 2016-03-14T01:00:00 but 2016-03-13T01:00:00 +       PT24H => 2016-03-14T03:00:00. Similarly, a +P1Y duration will be inexact       but "calendar correct", yielding the same month and day number next year,       even in leap years.\n:::\n*```unit```*:::\nDivide the resource numeric value by _unit_ to yield seconds.\n:::\n*```undefined```*:::\nReturns this value if the resource is not a valid timestamp.\n:::\n+\nFor example:\n+\n`duration(start=createTime,end=updateTime)`:::\nThe duration from resource creation to the most recent update. \n`updateTime.duration()`:::\nThe duration since the most recent resource update.\n\n\n*encode*(encoding, undefined="")::\nReturns the encoded value of the resource using encoding.\n+\nThe arguments are:\n+\n*```encoding```*:::\nThe encoding name. *base64* and *utf-8* are supported.\n:::\n*```undefined```*:::\nReturns this value if the encoding fails.\n:::\n\n\n*enum*(enums, inverse=false, undefined="")::\nReturns the enums dictionary description for the resource.\n+\nThe arguments are:\n+\n*```enums```*:::\nThe name of a message enum dictionary.\n:::\n*```inverse```*:::\nDo inverse lookup if true.\n:::\n*```undefined```*:::\nReturns this value if there is no matching enum description.\n:::\n\n\n*error*(message)::\nRaises an Error exception that does not generate a stack trace.\n+\nThe arguments are:\n+\n*```message```*:::\nAn error message. If not specified then the resource is formatted       as the error message.\n:::\n\n\n*extract*(keys)::\nExtract an ordered list of values from the resource for the specified keys.\n+\nThe arguments are:\n+\n*```keys```*:::\nThe list of keys in the resource whose associated values will be         included in the result.\n:::\n\n\n*fatal*(message)::\nRaises an InternalError exception that generates a stack trace.\n+\nThe arguments are:\n+\n*```message```*:::\nAn error message. If not specified then the resource is formatted       as the error message.\n:::\n\n\n*firstof*(keys)::\nReturns the first non-empty attribute value for key in keys.\n+\nThe arguments are:\n+\n*```keys```*:::\nKeys to check for resource attribute values,\n:::\n+\nFor example:\n+\n`x.firstof(bar_foo, barFoo, BarFoo, BAR_FOO)`:::\nChecks x.bar_foo, x.barFoo, x.BarFoo, and x.BAR_FOO in order for the first non-empty value.\n\n\n*float*(precision=6, spec, undefined="")::\nReturns the string representation of a floating point number.\n+\nOne of these formats is used (1) ". _precision_ _spec_" if _spec_ is specified (2) ". _precision_" unless 1e-04 <= abs(number) < 1e+09 (3) ".1f" otherwise.\n+\nThe arguments are:\n+\n*```precision```*:::\nThe maximum number of digits before and after the decimal point.\n:::\n*```spec```*:::\nThe printf(3) floating point format "e", "f" or "g" spec character.\n:::\n*```undefined```*:::\nReturns this value if the resource is not a float.\n:::\n\n\n*format*(fmt, args)::\nFormats resource key values.\n+\nThe arguments are:\n+\n*```fmt```*:::\nThe format string with {0} ... {nargs-1} references to the resource       attribute name arg values.\n:::\n*```args```*:::\nThe resource attribute key expression to format. The printer       projection symbols and aliases may be used in key expressions. If no args       are specified then the resource is used as the arg list if it is a list,       otherwise the resource is used as the only arg.\n:::\n+\nFor example:\n+\n`--format=\'value(format("{0:f.1}/{1:f.1}", q.CPU.default, q.CPU.limit))\'`:::\nFormats q.CPU.default and q.CPU.limit as floating point numbers.\n\n\n*group*(keys)::\nFormats a [...] grouped list.\n+\nEach group is enclosed in [...]. The first item separator is \':\', subsequent separators are \',\'.   [item1] [item1] ...   [item1: item2] ... [item1: item2]   [item1: item2, item3] ... [item1: item2, item3]\n+\nThe arguments are:\n+\n*```keys```*:::\nOptional attribute keys to select from the list. Otherwise       the string value of each list item is selected.\n:::\n\n\n*if*(expr)::\nDisables the projection key if the flag name filter expr is false.\n+\nThe arguments are:\n+\n*```expr```*:::\nA command flag filter name expression. See `gcloud topic filters` for       details on filter expressions. The expression variables are flag names       without the leading *--* prefix and dashes replaced by underscores.\n:::\n+\nFor example:\n+\n`table(name, value.if(NOT short_format))`:::\nLists a value column if the *--short-format* command line flag is not specified.\n\n\n*iso*(undefined="T")::\nFormats the resource to numeric ISO time format.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource does not have an isoformat()       attribute.\n:::\n\n\n*join*(sep="/", undefined="")::\nJoins the elements of the resource list by the value of sep.\n+\nA string resource is treated as a list of characters.\n+\nThe arguments are:\n+\n*```sep```*:::\nThe separator value to use when joining.\n:::\n*```undefined```*:::\nReturns this value if the result after joining is empty.\n:::\n+\nFor example:\n+\n`"a/b/c/d".split("/").join("!")`:::\nReturns "a!b!c!d".\n\n\n*len*()::\nReturns the length of the resource if it is non-empty, 0 otherwise.\n\n*list*(show="", undefined="", separator=",")::\nFormats a dict or list into a compact comma separated list.\n+\nThe arguments are:\n+\n*```show```*:::\nIf show=*keys* then list dict keys; if show=*values* then list dict       values; otherwise list dict key=value pairs.\n:::\n*```undefined```*:::\nReturn this if the resource is empty.\n:::\n*```separator```*:::\nThe list item separator string.\n:::\n\n\n*map*(depth=1)::\nApplies the next transform in the sequence to each resource list item.\n+\nThe arguments are:\n+\n*```depth```*:::\nThe list nesting depth.\n:::\n+\nFor example:\n+\n`list_field.map().foo().list()`:::\nApplies foo() to each item in list_field and then list() to the resulting value to return a compact comma-separated list. \n`list_field.map().foo().map().bar()`:::\nApplies foo() to each item in list_field and then bar() to each item in the resulting list. \n`abc.xyz.map(2).foo()`:::\nApplies foo() to each item in xyz[] for all items in abc[].\n\n\n*notnull*()::\nRemove null values from the resource list.\n\n*resolution*(undefined="", transpose=false)::\nFormats a human readable XY resolution.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if a recognizable resolution was not found.\n:::\n*```transpose```*:::\nReturns the y/x resolution if true.\n:::\n\n\n*scope*(args)::\nGets the /args/ suffix from a URI.\n+\nThe arguments are:\n+\n*```args```*:::\nOptional URI segment names. If not specified then \'regions\', \'zones\'       is assumed.\n:::\n+\nFor example:\n+\n`"https://abc/foo/projects/bar/xyz".scope("projects")`:::\nReturns "bar/xyz". \n`"https://xyz/foo/regions/abc".scope()`:::\nReturns "abc".\n\n\n*segment*(index=-1, undefined="")::\nReturns the index-th URI path segment.\n+\nThe arguments are:\n+\n*```index```*:::\nThe path segment index to return counting from 0.\n:::\n*```undefined```*:::\nReturns this value if the resource or segment index is empty.\n:::\n\n\n*size*(zero="0", precision=1, units_in, units_out, min=0)::\nFormats a human readable size in bytes.\n+\nThe arguments are:\n+\n*```zero```*:::\nReturns this if size==0. Ignored if None.\n:::\n*```precision```*:::\nThe number of digits displayed after the decimal point.\n:::\n*```units_in```*:::\nA unit suffix (only the first character is checked) or unit size.       The size is multiplied by this. The default is 1.0.\n:::\n*```units_out```*:::\nA unit suffix (only the first character is checked) or unit size.       The size is divided by this. The default is 1.0.\n:::\n*```min```*:::\nSizes < _min_ will be listed as "< _min_".\n:::\n\n\n*slice*(op=":", undefined="")::\nReturns a list slice specified by op.\n+\nThe op parameter consists of up to three colon-delimeted integers: start, end, and step. The parameter supports half-open ranges: start and end values can be omitted, representing the first and last positions of the resource respectively.\n+\nThe step value represents the increment between items in the resource included in the slice. A step of 2 results in a slice that contains every other item in the resource.\n+\nNegative values for start and end indicate that the positons should start from the last position of the resource. A negative value for step indicates that the slice should contain items in reverse order.\n+\nIf op contains no colons, the slice consists of the single item at the specified position in the resource.\n+\nThe arguments are:\n+\n*```op```*:::\nThe slice operation.\n:::\n*```undefined```*:::\nReturns this value if the slice cannot be created, or the         resulting slice is empty.\n:::\n+\nFor example:\n+\n`[1,2,3].slice(1:)`:::\nReturns [2,3]. \n`[1,2,3].slice(:2)`:::\nReturns [1,2]. \n`[1,2,3].slice(-1:)`:::\nReturns [3]. \n`[1,2,3].slice(: :-1)`:::\nReturns [3,2,1]. \n`[1,2,3].slice(1)`:::\nReturns [2].\n\n\n*sort*(attr="")::\nSorts the elements of the resource list by a given attribute (or itself).\n+\nA string resource is treated as a list of characters.\n+\nThe arguments are:\n+\n*```attr```*:::\nThe optional field of an object or dict by which to sort.\n:::\n+\nFor example:\n+\n`"b/a/d/c".split("/").sort()`:::\nReturns "[a, b, c, d]".\n\n\n*split*(sep="/", undefined="")::\nSplits a string by the value of sep.\n+\nThe arguments are:\n+\n*```sep```*:::\nThe separator value to use when splitting.\n:::\n*```undefined```*:::\nReturns this value if the result after splitting is empty.\n:::\n+\nFor example:\n+\n`"a/b/c/d".split()`:::\nReturns ["a", "b", "c", "d"].\n\n\n*synthesize*(args)::\nSynthesizes a new resource from the schema arguments.\n+\nA list of tuple arguments controls the resource synthesis. Each tuple is a schema that defines the synthesis of one resource list item. Each schema item defines the synthesis of one synthesized_resource attribute from an original_resource attribute.\n+\nThere are three kinds of schema items:\n+\n*name:literal*:::\nThe value for the name attribute in the synthesized resource is the literal value. \n*name=key*:::\nThe value for the name attribute in the synthesized_resource is the value of key in the original_resource. \n*key*:::\nAll the attributes of the value of key in the original_resource are added to the attributes in the synthesized_resource. \n:::\n+\nThe arguments are:\n+\n*```args```*:::\nThe list of schema tuples.\n:::\n+\nFor example:\n+\nThis returns a list of two resource items:::\n`synthesize((name:up, upInfo), (name:down, downInfo))` \nIf upInfo and downInfo serialize to:::\n`{"foo": 1, "bar": "yes"}` \nand:::\n`{"foo": 0, "bar": "no"}` \nthen the synthesized resource list is:::\n`[{"name": "up", "foo": 1, "bar": "yes"},   {"name": "down", "foo": 0, "bar": "no"}]` \nThis could then be displayed by a nested table using:::\n`synthesize(...):format="table(name, foo, bar)"`\n\n\n*uri*(undefined=".")::\nGets the resource URI.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this if a the URI for r cannot be determined.\n:::\n\n\n*yesno*(yes, no="No")::\nReturns no if the resource is empty, yes or the resource itself otherwise.\n+\nThe arguments are:\n+\n*```yes```*:::\nIf the resource is not empty then returns _yes_ or the resource itself       if _yes_ is not defined.\n:::\n*```no```*:::\nReturns this value if the resource is empty.\n:::\n\n\nThe cloudbuild transform functions are:\n\n\n*build_images*(undefined="")::\nReturns the formatted build results images.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\n*build_source*(undefined="")::\nReturns the formatted build source.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\nThe compute transform functions are:\n\n\n*firewall_rule*(undefined="")::\nReturns a compact string describing a firewall rule.\n+\nThe compact string is a comma-separated list of PROTOCOL:PORT_RANGE items. If a particular protocol has no port ranges then only the protocol is listed.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\n*image_alias*(undefined="")::\nReturns a comma-separated list of alias names for an image.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\n*location*(undefined="")::\nReturn the region or zone name.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\n*location_scope*(undefined="")::\nReturn the location scope name, either region or zone.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\n*machine_type*()::\nReturn the formatted name for a machine type.\n\n*next_maintenance*(undefined="")::\nReturns the timestamps of the next scheduled maintenance.\n+\nAll timestamps are assumed to be ISO strings in the same timezone.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\n*operation_http_status*(undefined="")::\nReturns the HTTP response code of an operation.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if there is no response code.\n:::\n\n\n*quota*(undefined="")::\nFormats a quota as usage/limit.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\n*status*(undefined="")::\nReturns the machine status with deprecation information if applicable.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\nThe container transform functions are:\n\n\n*master_version*(undefined="")::\nReturns the formatted master version.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\nThe debug transform functions are:\n\n\n*full_status*(undefined="UNKNOWN_ERROR")::\nReturns a full description of the status of a logpoint or snapshot.\n+\nStatus will be one of ACTIVE, COMPLETED, or a verbose error description. If the status is an error, there will be additional information available in the status field of the object.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource is not a valid status.\n:::\n+\nFor example:\n+\n`--format="table(id, location, full_status())"`:::\nDisplays the full status in the third table problem.\n\n\n*short_status*(undefined="UNKNOWN_ERROR")::\nReturns a short description of the status of a logpoint or snapshot.\n+\nStatus will be one of ACTIVE, COMPLETED, or a short error description. If the status is an error, there will be additional information available in the status field of the object.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource is not a valid status.\n:::\n+\nFor example:\n+\n`--format="table(id, location, short_status())"`:::\nDisplays the short status in the third table problem.\n\n\nThe functions transform functions are:\n\n\n*trigger*(undefined="")::\nReturns textual information about functions trigger.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n\n\nThe runtimeconfig transform functions are:\n\n\n*waiter_status*(undefined="")::\nReturns a short description of the status of a waiter or waiter operation.\n+\nStatus will be one of WAITING, SUCCESS, FAILURE, or TIMEOUT.\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource status cannot be determined.\n:::\n+\nFor example:\n+\n`--format="table(name, status())"`:::\nDisplays the status in table column two.\n\n\nThe service_registry transform functions are:\n\n\n*endpoint_address*(undefined="")::\nReturns a compact representation of an endpoint address.\n+\nThe compact representation for a plain address (no port information) is just the address. The compact representation for an address with a port is of the form [HOST/IP]:PORT and addresses with more details or more ports will look like\n+\n  address=ADDRESS[;port_number=PORT[,protocol=PROTOCOL][,port_name=name]]+\n+\nThe arguments are:\n+\n*```undefined```*:::\nReturns this value if the resource cannot be formatted.\n:::\n+\nFor example:\n+\n`--format="table(name, addresses[].map().endpoint_address())"`:::\nDisplays each address as an endpoint address.\n\n\n\n### Key Attributes\n\nKey attributes control formatted output. Each projection key may have\nzero or more attributes:\n\n  _key_:_attribute_=_value_...\n\nwhere =_value_ is omitted for Boolean attributes and no-_attribute_\nsets the attribute to false. Attribute values may appear in any order,\nbut must be specified after any transform calls. The attributes are:\n\n*alias*=_ALIAS-NAME_::\nSets _ALIAS-NAME_ as an alias for the projection key.\n\n*align*=_ALIGNMENT_::\nSpecifies the output column data alignment. Used by the *table*\nformat. The alignment values are:\n\n*left*:::\nLeft (default).\n\n*center*:::\nCenter.\n\n*right*:::\nRight.\n\n*label*=_LABEL_::\nA string value used to label output. Use :label="" or :label=\'\'\nfor no label. The *table* format uses _LABEL_ values as column\nheadings. Also sets _LABEL_ as an alias for the projection key.\nThe default label is the the disambiguated right hand parts of the\ncolumn key name in ANGRY_SNAKE_CASE.\n\n[no-]*reverse*::\nSets the key sort order to descending. *no-reverse* resets to the\ndefault ascending order.\n\n*sort*=_SORT-ORDER_::\nAn integer counting from 1. Keys with lower sort-order are sorted\nfirst. Keys with same sort order are sorted left to right.\n\n*wrap*::\nEnables the column text to be wrapped if the table would otherwise\nbe too wide for the display.\n',
                                                                       u'EXAMPLES': u'List a table of instance *zone* (sorted in descending order) and\n*name* (sorted by *name* and centered with column heading *INSTANCE*)\nand *creationTimestamp* (listed using the *strftime*(3) year-month-day\nformat with column heading *START*):\n\n  $ gcloud compute instances list --format=\'table(name:sort=2:align=center:label=INSTANCE, zone:sort=1:reverse, creationTimestamp.date("%Y-%m-%d"):label=START)\'\n\nList only the *name*, *status* and *zone* instance resource keys in\nYAML format:\n\n  $ gcloud compute instances list --format=\'yaml(name, status, zone)\'\n\nList only the *config.account* key value(s) in the *info* resource:\n\n  $ gcloud info --format=\'value(config.account)\'\n'}},
                                        u'resource-keys': {u'capsule': u'Resource keys supplementary help.',
                                                           u'commands': {},
                                                           u'flags': {},
                                                           u'group': False,
                                                           u'groups': {},
                                                           u'hidden': False,
                                                           u'name': u'resource-keys',
                                                           u'path': [u'gcloud',
                                                                     u'topic',
                                                                     u'resource-keys'],
                                                           u'positionals': [],
                                                           u'release': u'GA',
                                                           u'sections': {u'DESCRIPTION': u"A *resource* is a JSON-serializable object organized as a tree.\nEach node is a scalar, indexed array, or dictionary. Structs and\nclasses are represented by dictionaries indexed by member name.\n\nEach node is reachable by a unique path of names from the root. A\nnode *key* is the path names separated by '.'. [_number_] represents\nan array index. For example:\n\n  foo\n  foo.bar\n  abc.def[3].ghi\n\nThe resource keys and data values for any _gcloud_ _list_\ncommand can be printed by running _gcloud_ ... _list_\n*--format=flattened*. See the command specific documentation for\ndetails on specific resource keys.\n",
                                                                         u'EXAMPLES': u"This command lists the keys and values for the *regions* resource:\n\n  $ gcloud compute regions list --format=flattened\n\nand here is sample output for the command:\n\n  ---\n  creationTimestamp: 2013-05-23T07:02:09.522-07:00\n  description:       us-central1\n  id:                22115839677829654\n  kind:              compute#region\n  name:              us-central1\n  quotas[0].limit:   24.0\n  quotas[0].metric:  CPUS\n  quotas[0].usage:   15.0\n  quotas[1].limit:   5120.0\n  quotas[1].metric:  DISKS_TOTAL_GB\n  quotas[1].usage:   1416.0\n  quotas[2].limit:   7.0\n  quotas[2].metric:  STATIC_ADDRESSES\n  quotas[2].usage:   1.0\n  quotas[3].limit:   23.0\n  quotas[3].metric:  IN_USE_ADDRESSES\n  quotas[3].usage:   16.0\n  quotas[4].limit:   1024.0\n  quotas[4].metric:  SSD_TOTAL_GB\n  quotas[4].usage:   0.0\n  quotas[5].limit:   1500.0\n  quotas[5].metric:  LOCAL_SSD_TOTAL_GB\n  quotas[5].usage:   750.0\n  selfLink:          https://www.googleapis.com/.../us-central1\n  status:            UP\n  zones[0]:          us-central1-a\n  zones[1]:          us-central1-b\n  zones[2]:          us-central1-f\n\nThe *list* command produces a resource list. The keys are to the\nleft of ':' and the values are to the right.\n"}}},
                          u'flags': {},
                          u'group': True,
                          u'groups': {},
                          u'hidden': False,
                          u'name': u'topic',
                          u'path': [u'gcloud', u'topic'],
                          u'positionals': [],
                          u'release': u'GA',
                          u'sections': {u'DESCRIPTION': u'The topic command group provides supplementary help for topics not\ndirectly associated with individual commands.\n\nMore information on topic can be found by running:\n\n  $ gcloud topic [TOPIC_NAME]\n\nFor a lits of available topics run:\n\n  $ gcloud topic --help'}},
               u'version': {u'capsule': u'Print version information for Cloud SDK components.',
                            u'commands': {},
                            u'flags': {},
                            u'group': False,
                            u'groups': {},
                            u'hidden': False,
                            u'name': u'version',
                            u'path': [u'gcloud', u'version'],
                            u'positionals': [],
                            u'release': u'GA',
                            u'sections': {u'DESCRIPTION': u'The version command prints version information for each installed Cloud SDK\ncomponents and prints a message if updates are available.'}}},
 u'flags': {u'--account': {u'attr': {u'property': {u'name': u'core/account'}},
                           u'category': u'COMMONLY USED',
                           u'choices': [],
                           u'completer': u'',
                           u'default': None,
                           u'description': u'Google Cloud Platform user account to use for invocation. Overrides the default *core/account* property value for this command invocation.',
                           u'group': u'',
                           u'hidden': False,
                           u'name': u'--account',
                           u'nargs': u'0',
                           u'required': False,
                           u'type': u'string',
                           u'value': u'ACCOUNT'},
            u'--authority-selector': {u'attr': {u'property': {u'name': u'auth/authority_selector'}},
                                      u'category': u'',
                                      u'choices': [],
                                      u'completer': u'',
                                      u'default': None,
                                      u'description': u'',
                                      u'group': u'',
                                      u'hidden': True,
                                      u'name': u'--authority-selector',
                                      u'nargs': u'0',
                                      u'required': False,
                                      u'type': u'string',
                                      u'value': u'AUTHORITY_SELECTOR'},
            u'--authorization-token-file': {u'attr': {u'property': {u'name': u'auth/authorization_token_file'}},
                                            u'category': u'',
                                            u'choices': [],
                                            u'completer': u'',
                                            u'default': None,
                                            u'description': u'',
                                            u'group': u'',
                                            u'hidden': True,
                                            u'name': u'--authorization-token-file',
                                            u'nargs': u'0',
                                            u'required': False,
                                            u'type': u'string',
                                            u'value': u'AUTHORIZATION_TOKEN_FILE'},
            u'--configuration': {u'attr': {},
                                 u'category': u'COMMONLY USED',
                                 u'choices': [],
                                 u'completer': u'',
                                 u'default': None,
                                 u'description': u'The configuration to use for this command invocation. For more\ninformation on how to use configurations, run:\n`gcloud topic configurations`.  You can also use the [CLOUDSDK_ACTIVE_CONFIG_NAME] environment\nvariable to set the equivalent of this flag for a terminal\nsession.',
                                 u'group': u'',
                                 u'hidden': False,
                                 u'name': u'--configuration',
                                 u'nargs': u'0',
                                 u'required': False,
                                 u'type': u'string',
                                 u'value': u'CONFIGURATION'},
            u'--credential-file-override': {u'attr': {u'property': {u'name': u'auth/credential_file_override'}},
                                            u'category': u'',
                                            u'choices': [],
                                            u'completer': u'',
                                            u'default': None,
                                            u'description': u'',
                                            u'group': u'',
                                            u'hidden': True,
                                            u'name': u'--credential-file-override',
                                            u'nargs': u'0',
                                            u'required': False,
                                            u'type': u'string',
                                            u'value': u'CREDENTIAL_FILE_OVERRIDE'},
            u'--document': {u'attr': {},
                            u'category': u'',
                            u'choices': [],
                            u'completer': u'',
                            u'default': None,
                            u'description': u'',
                            u'group': u'',
                            u'hidden': True,
                            u'name': u'--document',
                            u'nargs': u'1',
                            u'required': False,
                            u'type': u'dict',
                            u'value': u'ATTRIBUTES'},
            u'--flatten': {u'attr': {},
                           u'category': u'COMMONLY USED',
                           u'choices': [],
                           u'completer': u'',
                           u'default': None,
                           u'description': u'Flatten _name_[] output resource slices in _KEY_ into separate records\nfor each item in each slice. Multiple keys and slices may be specified.\nThis also flattens keys for *--format* and *--filter*. For example,\n*--flatten=abc.def[]* flattens *abc.def[].ghi* references to\n*abc.def.ghi*. A resource record containing *abc.def[]* with N elements\nwill expand to N records in the flattened output. This flag interacts\nwith other flags that are applied in this order: *--flatten*,\n*--sort-by*, *--filter*, *--limit*.',
                           u'group': u'',
                           u'hidden': False,
                           u'name': u'--flatten',
                           u'nargs': u'0',
                           u'required': False,
                           u'type': u'list',
                           u'value': u'KEY'},
            u'--format': {u'attr': {},
                          u'category': u'COMMONLY USED',
                          u'choices': [],
                          u'completer': u'',
                          u'default': None,
                          u'description': u'Sets the format for printing command output resources. The default is a\ncommand-specific human-friendly output format. The supported formats\nare: `config`, `csv`, `default`, `diff`, `disable`, `flattened`, `get`, `json`, `list`, `multi`, `none`, `object`, `table`, `text`, `value`, `yaml`. For more details run $ gcloud topic formats.',
                          u'group': u'',
                          u'hidden': False,
                          u'name': u'--format',
                          u'nargs': u'0',
                          u'required': False,
                          u'type': u'string',
                          u'value': u'FORMAT'},
            u'--help': {u'attr': {},
                        u'category': u'COMMONLY USED',
                        u'choices': [],
                        u'completer': u'',
                        u'default': False,
                        u'description': u'Display detailed help.',
                        u'group': u'',
                        u'hidden': False,
                        u'name': u'--help',
                        u'nargs': u'0',
                        u'required': False,
                        u'type': u'bool',
                        u'value': u'HELP'},
            u'--http-timeout': {u'attr': {u'property': {u'name': u'core/http_timeout'}},
                                u'category': u'',
                                u'choices': [],
                                u'completer': u'',
                                u'default': None,
                                u'description': u'',
                                u'group': u'',
                                u'hidden': True,
                                u'name': u'--http-timeout',
                                u'nargs': u'0',
                                u'required': False,
                                u'type': u'string',
                                u'value': u'HTTP_TIMEOUT'},
            u'--log-http': {u'attr': {u'property': {u'name': u'core/log_http'}},
                            u'category': u'',
                            u'choices': [],
                            u'completer': u'',
                            u'default': False,
                            u'description': u'Log all HTTP server requests and responses to stderr. Overrides the default *core/log_http* property value for this command invocation.',
                            u'group': u'',
                            u'hidden': False,
                            u'name': u'--log-http',
                            u'nargs': u'0',
                            u'required': False,
                            u'type': u'bool',
                            u'value': u'LOG_HTTP'},
            u'--no-log-http': {u'attr': {u'property': {u'name': u'core/log_http'}},
                               u'category': u'',
                               u'choices': [],
                               u'completer': u'',
                               u'default': False,
                               u'description': u'',
                               u'group': u'',
                               u'hidden': True,
                               u'name': u'--no-log-http',
                               u'nargs': u'0',
                               u'required': False,
                               u'type': u'bool',
                               u'value': u'NO_LOG_HTTP'},
            u'--no-user-output-enabled': {u'attr': {u'property': {u'name': u'core/user_output_enabled'}},
                                          u'category': u'',
                                          u'choices': [],
                                          u'completer': u'',
                                          u'default': False,
                                          u'description': u'',
                                          u'group': u'',
                                          u'hidden': True,
                                          u'name': u'--no-user-output-enabled',
                                          u'nargs': u'0',
                                          u'required': False,
                                          u'type': u'bool',
                                          u'value': u' '},
            u'--project': {u'attr': {u'property': {u'name': u'core/project'}},
                           u'category': u'COMMONLY USED',
                           u'choices': [],
                           u'completer': u'',
                           u'default': None,
                           u'description': u'The Google Cloud Platform project name to use for this invocation. If\nomitted then the current project is assumed. Overrides the default *core/project* property value for this command invocation.',
                           u'group': u'',
                           u'hidden': False,
                           u'name': u'--project',
                           u'nargs': u'0',
                           u'required': False,
                           u'type': u'string',
                           u'value': u'PROJECT_ID'},
            u'--quiet': {u'attr': {u'property': {u'name': u'core/disable_prompts',
                                                 u'value': True}},
                         u'category': u'COMMONLY USED',
                         u'choices': [],
                         u'completer': u'',
                         u'default': False,
                         u'description': u'Disable all interactive prompts when running gcloud commands. If input\nis required, defaults will be used, or an error will be raised. Overrides the default *core/disable_prompts* property value for this command invocation.',
                         u'group': u'',
                         u'hidden': False,
                         u'name': u'--quiet',
                         u'nargs': u'0',
                         u'required': False,
                         u'type': u'bool',
                         u'value': u'QUIET'},
            u'--trace-email': {u'attr': {u'property': {u'name': u'core/trace_email'}},
                               u'category': u'',
                               u'choices': [],
                               u'completer': u'',
                               u'default': None,
                               u'description': u'',
                               u'group': u'gcloud.1',
                               u'hidden': True,
                               u'name': u'--trace-email',
                               u'nargs': u'0',
                               u'required': False,
                               u'type': u'string',
                               u'value': u'USERNAME'},
            u'--trace-log': {u'attr': {u'property': {u'name': u'core/trace_log'}},
                             u'category': u'',
                             u'choices': [],
                             u'completer': u'',
                             u'default': False,
                             u'description': u'',
                             u'group': u'gcloud.1',
                             u'hidden': True,
                             u'name': u'--trace-log',
                             u'nargs': u'0',
                             u'required': False,
                             u'type': u'bool',
                             u'value': u'TRACE_LOG'},
            u'--trace-token': {u'attr': {u'property': {u'name': u'core/trace_token'}},
                               u'category': u'',
                               u'choices': [],
                               u'completer': u'',
                               u'default': None,
                               u'description': u'Token used to route traces of service requests for investigation of issues. Overrides the default *core/trace_token* property value for this command invocation.',
                               u'group': u'gcloud.1',
                               u'hidden': False,
                               u'name': u'--trace-token',
                               u'nargs': u'0',
                               u'required': False,
                               u'type': u'string',
                               u'value': u'TRACE_TOKEN'},
            u'--user-output-enabled': {u'attr': {u'inverted_synopsis': True,
                                                 u'property': {u'name': u'core/user_output_enabled'}},
                                       u'category': u'',
                                       u'choices': [],
                                       u'completer': u'',
                                       u'default': None,
                                       u'description': u'Print user intended output to the console. Overrides the default *core/user_output_enabled* property value for this command invocation. Use *--no-user-output-enabled* to disable.',
                                       u'group': u'',
                                       u'hidden': False,
                                       u'name': u'--user-output-enabled',
                                       u'nargs': u'?',
                                       u'required': False,
                                       u'type': u'bool',
                                       u'value': u' '},
            u'--verbosity': {u'attr': {u'property': {u'name': u'core/verbosity'}},
                             u'category': u'COMMONLY USED',
                             u'choices': [u'debug',
                                          u'info',
                                          u'warning',
                                          u'error',
                                          u'critical',
                                          u'none'],
                             u'completer': u'',
                             u'default': u'warning',
                             u'description': u'Override the default verbosity for this command. _VERBOSITY_ must be one of: *debug*, *info*, *warning*, *error*, *critical*, *none*.',
                             u'group': u'',
                             u'hidden': False,
                             u'name': u'--verbosity',
                             u'nargs': u'0',
                             u'required': False,
                             u'type': u'string',
                             u'value': u'VERBOSITY'},
            u'--version': {u'attr': {},
                           u'category': u'COMMONLY USED',
                           u'choices': [],
                           u'completer': u'',
                           u'default': False,
                           u'description': u'Print version information and exit. This flag is only available at the global level.',
                           u'group': u'',
                           u'hidden': False,
                           u'name': u'--version',
                           u'nargs': u'0',
                           u'required': False,
                           u'type': u'bool',
                           u'value': u'VERSION'}},
 u'group': True,
 u'groups': {u'gcloud.1': {u'description': u'At most one of these may be specified:',
                           u'is_mutex': True,
                           u'is_required': False}},
 u'hidden': False,
 u'name': u'gcloud',
 u'path': [u'gcloud'],
 u'positionals': [],
 u'release': u'GA',
 u'sections': {u'DESCRIPTION': u'The *gcloud* CLI manages authentication, local configuration, developer\nworkflow, and interactions with the Google Cloud Platform APIs.'}}
